import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* Amazon API Gateway Websocket and HTTP APIs
*/
export declare namespace APIGatewayV2 {
    /**
     * @stability stable
     */
    interface Apigatewayv2ApiConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#api_key_selection_expression Apigatewayv2Api#api_key_selection_expression}.
         *
         * @stability stable
         */
        readonly apiKeySelectionExpression?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#body Apigatewayv2Api#body}.
         *
         * @stability stable
         */
        readonly body?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#credentials_arn Apigatewayv2Api#credentials_arn}.
         *
         * @stability stable
         */
        readonly credentialsArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#description Apigatewayv2Api#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#disable_execute_api_endpoint Apigatewayv2Api#disable_execute_api_endpoint}.
         *
         * @stability stable
         */
        readonly disableExecuteApiEndpoint?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#fail_on_warnings Apigatewayv2Api#fail_on_warnings}.
         *
         * @stability stable
         */
        readonly failOnWarnings?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#name Apigatewayv2Api#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#protocol_type Apigatewayv2Api#protocol_type}.
         *
         * @stability stable
         */
        readonly protocolType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#route_key Apigatewayv2Api#route_key}.
         *
         * @stability stable
         */
        readonly routeKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#route_selection_expression Apigatewayv2Api#route_selection_expression}.
         *
         * @stability stable
         */
        readonly routeSelectionExpression?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#tags Apigatewayv2Api#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#tags_all Apigatewayv2Api#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#target Apigatewayv2Api#target}.
         *
         * @stability stable
         */
        readonly target?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#version Apigatewayv2Api#version}.
         *
         * @stability stable
         */
        readonly version?: string;
        /**
         * cors_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#cors_configuration Apigatewayv2Api#cors_configuration}
         *
         * @stability stable
         */
        readonly corsConfiguration?: Apigatewayv2ApiCorsConfiguration;
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2ApiCorsConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#allow_credentials Apigatewayv2Api#allow_credentials}.
         *
         * @stability stable
         */
        readonly allowCredentials?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#allow_headers Apigatewayv2Api#allow_headers}.
         *
         * @stability stable
         */
        readonly allowHeaders?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#allow_methods Apigatewayv2Api#allow_methods}.
         *
         * @stability stable
         */
        readonly allowMethods?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#allow_origins Apigatewayv2Api#allow_origins}.
         *
         * @stability stable
         */
        readonly allowOrigins?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#expose_headers Apigatewayv2Api#expose_headers}.
         *
         * @stability stable
         */
        readonly exposeHeaders?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#max_age Apigatewayv2Api#max_age}.
         *
         * @stability stable
         */
        readonly maxAge?: number;
    }
    /**
     * @stability stable
     */
    class Apigatewayv2ApiCorsConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _allowCredentials?;
        /**
         * @stability stable
         */
        get allowCredentials(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set allowCredentials(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAllowCredentials(): void;
        /**
         * @stability stable
         */
        get allowCredentialsInput(): boolean | cdktf.IResolvable | undefined;
        private _allowHeaders?;
        /**
         * @stability stable
         */
        get allowHeaders(): string[] | undefined;
        /**
         * @stability stable
         */
        set allowHeaders(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetAllowHeaders(): void;
        /**
         * @stability stable
         */
        get allowHeadersInput(): string[] | undefined;
        private _allowMethods?;
        /**
         * @stability stable
         */
        get allowMethods(): string[] | undefined;
        /**
         * @stability stable
         */
        set allowMethods(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetAllowMethods(): void;
        /**
         * @stability stable
         */
        get allowMethodsInput(): string[] | undefined;
        private _allowOrigins?;
        /**
         * @stability stable
         */
        get allowOrigins(): string[] | undefined;
        /**
         * @stability stable
         */
        set allowOrigins(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetAllowOrigins(): void;
        /**
         * @stability stable
         */
        get allowOriginsInput(): string[] | undefined;
        private _exposeHeaders?;
        /**
         * @stability stable
         */
        get exposeHeaders(): string[] | undefined;
        /**
         * @stability stable
         */
        set exposeHeaders(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetExposeHeaders(): void;
        /**
         * @stability stable
         */
        get exposeHeadersInput(): string[] | undefined;
        private _maxAge?;
        /**
         * @stability stable
         */
        get maxAge(): number | undefined;
        /**
         * @stability stable
         */
        set maxAge(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaxAge(): void;
        /**
         * @stability stable
         */
        get maxAgeInput(): number | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html aws_apigatewayv2_api}.
     *
     * @stability stable
     */
    class Apigatewayv2Api extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html aws_apigatewayv2_api} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Apigatewayv2ApiConfig);
        /**
         * @stability stable
         */
        get apiEndpoint(): string;
        private _apiKeySelectionExpression?;
        /**
         * @stability stable
         */
        get apiKeySelectionExpression(): string | undefined;
        /**
         * @stability stable
         */
        set apiKeySelectionExpression(value: string | undefined);
        /**
         * @stability stable
         */
        resetApiKeySelectionExpression(): void;
        /**
         * @stability stable
         */
        get apiKeySelectionExpressionInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _body?;
        /**
         * @stability stable
         */
        get body(): string | undefined;
        /**
         * @stability stable
         */
        set body(value: string | undefined);
        /**
         * @stability stable
         */
        resetBody(): void;
        /**
         * @stability stable
         */
        get bodyInput(): string | undefined;
        private _credentialsArn?;
        /**
         * @stability stable
         */
        get credentialsArn(): string | undefined;
        /**
         * @stability stable
         */
        set credentialsArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetCredentialsArn(): void;
        /**
         * @stability stable
         */
        get credentialsArnInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _disableExecuteApiEndpoint?;
        /**
         * @stability stable
         */
        get disableExecuteApiEndpoint(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set disableExecuteApiEndpoint(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDisableExecuteApiEndpoint(): void;
        /**
         * @stability stable
         */
        get disableExecuteApiEndpointInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get executionArn(): string;
        private _failOnWarnings?;
        /**
         * @stability stable
         */
        get failOnWarnings(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set failOnWarnings(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetFailOnWarnings(): void;
        /**
         * @stability stable
         */
        get failOnWarningsInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _protocolType?;
        /**
         * @stability stable
         */
        get protocolType(): string;
        /**
         * @stability stable
         */
        set protocolType(value: string);
        /**
         * @stability stable
         */
        get protocolTypeInput(): string | undefined;
        private _routeKey?;
        /**
         * @stability stable
         */
        get routeKey(): string | undefined;
        /**
         * @stability stable
         */
        set routeKey(value: string | undefined);
        /**
         * @stability stable
         */
        resetRouteKey(): void;
        /**
         * @stability stable
         */
        get routeKeyInput(): string | undefined;
        private _routeSelectionExpression?;
        /**
         * @stability stable
         */
        get routeSelectionExpression(): string | undefined;
        /**
         * @stability stable
         */
        set routeSelectionExpression(value: string | undefined);
        /**
         * @stability stable
         */
        resetRouteSelectionExpression(): void;
        /**
         * @stability stable
         */
        get routeSelectionExpressionInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _target?;
        /**
         * @stability stable
         */
        get target(): string | undefined;
        /**
         * @stability stable
         */
        set target(value: string | undefined);
        /**
         * @stability stable
         */
        resetTarget(): void;
        /**
         * @stability stable
         */
        get targetInput(): string | undefined;
        private _version?;
        /**
         * @stability stable
         */
        get version(): string | undefined;
        /**
         * @stability stable
         */
        set version(value: string | undefined);
        /**
         * @stability stable
         */
        resetVersion(): void;
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
        private _corsConfiguration?;
        private __corsConfigurationOutput;
        /**
         * @stability stable
         */
        get corsConfiguration(): Apigatewayv2ApiCorsConfigurationOutputReference;
        /**
         * @stability stable
         */
        putCorsConfiguration(value: Apigatewayv2ApiCorsConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetCorsConfiguration(): void;
        /**
         * @stability stable
         */
        get corsConfigurationInput(): Apigatewayv2ApiCorsConfiguration | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2ApiMappingConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api_mapping.html#api_id Apigatewayv2ApiMapping#api_id}.
         *
         * @stability stable
         */
        readonly apiId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api_mapping.html#api_mapping_key Apigatewayv2ApiMapping#api_mapping_key}.
         *
         * @stability stable
         */
        readonly apiMappingKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api_mapping.html#domain_name Apigatewayv2ApiMapping#domain_name}.
         *
         * @stability stable
         */
        readonly domainName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api_mapping.html#stage Apigatewayv2ApiMapping#stage}.
         *
         * @stability stable
         */
        readonly stage: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api_mapping.html aws_apigatewayv2_api_mapping}.
     *
     * @stability stable
     */
    class Apigatewayv2ApiMapping extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api_mapping.html aws_apigatewayv2_api_mapping} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Apigatewayv2ApiMappingConfig);
        private _apiId?;
        /**
         * @stability stable
         */
        get apiId(): string;
        /**
         * @stability stable
         */
        set apiId(value: string);
        /**
         * @stability stable
         */
        get apiIdInput(): string | undefined;
        private _apiMappingKey?;
        /**
         * @stability stable
         */
        get apiMappingKey(): string | undefined;
        /**
         * @stability stable
         */
        set apiMappingKey(value: string | undefined);
        /**
         * @stability stable
         */
        resetApiMappingKey(): void;
        /**
         * @stability stable
         */
        get apiMappingKeyInput(): string | undefined;
        private _domainName?;
        /**
         * @stability stable
         */
        get domainName(): string;
        /**
         * @stability stable
         */
        set domainName(value: string);
        /**
         * @stability stable
         */
        get domainNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _stage?;
        /**
         * @stability stable
         */
        get stage(): string;
        /**
         * @stability stable
         */
        set stage(value: string);
        /**
         * @stability stable
         */
        get stageInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2AuthorizerConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_authorizer.html#api_id Apigatewayv2Authorizer#api_id}.
         *
         * @stability stable
         */
        readonly apiId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_authorizer.html#authorizer_credentials_arn Apigatewayv2Authorizer#authorizer_credentials_arn}.
         *
         * @stability stable
         */
        readonly authorizerCredentialsArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_authorizer.html#authorizer_payload_format_version Apigatewayv2Authorizer#authorizer_payload_format_version}.
         *
         * @stability stable
         */
        readonly authorizerPayloadFormatVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_authorizer.html#authorizer_result_ttl_in_seconds Apigatewayv2Authorizer#authorizer_result_ttl_in_seconds}.
         *
         * @stability stable
         */
        readonly authorizerResultTtlInSeconds?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_authorizer.html#authorizer_type Apigatewayv2Authorizer#authorizer_type}.
         *
         * @stability stable
         */
        readonly authorizerType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_authorizer.html#authorizer_uri Apigatewayv2Authorizer#authorizer_uri}.
         *
         * @stability stable
         */
        readonly authorizerUri?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_authorizer.html#enable_simple_responses Apigatewayv2Authorizer#enable_simple_responses}.
         *
         * @stability stable
         */
        readonly enableSimpleResponses?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_authorizer.html#identity_sources Apigatewayv2Authorizer#identity_sources}.
         *
         * @stability stable
         */
        readonly identitySources?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_authorizer.html#name Apigatewayv2Authorizer#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * jwt_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_authorizer.html#jwt_configuration Apigatewayv2Authorizer#jwt_configuration}
         *
         * @stability stable
         */
        readonly jwtConfiguration?: Apigatewayv2AuthorizerJwtConfiguration;
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2AuthorizerJwtConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_authorizer.html#audience Apigatewayv2Authorizer#audience}.
         *
         * @stability stable
         */
        readonly audience?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_authorizer.html#issuer Apigatewayv2Authorizer#issuer}.
         *
         * @stability stable
         */
        readonly issuer?: string;
    }
    /**
     * @stability stable
     */
    class Apigatewayv2AuthorizerJwtConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _audience?;
        /**
         * @stability stable
         */
        get audience(): string[] | undefined;
        /**
         * @stability stable
         */
        set audience(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetAudience(): void;
        /**
         * @stability stable
         */
        get audienceInput(): string[] | undefined;
        private _issuer?;
        /**
         * @stability stable
         */
        get issuer(): string | undefined;
        /**
         * @stability stable
         */
        set issuer(value: string | undefined);
        /**
         * @stability stable
         */
        resetIssuer(): void;
        /**
         * @stability stable
         */
        get issuerInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_authorizer.html aws_apigatewayv2_authorizer}.
     *
     * @stability stable
     */
    class Apigatewayv2Authorizer extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_authorizer.html aws_apigatewayv2_authorizer} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Apigatewayv2AuthorizerConfig);
        private _apiId?;
        /**
         * @stability stable
         */
        get apiId(): string;
        /**
         * @stability stable
         */
        set apiId(value: string);
        /**
         * @stability stable
         */
        get apiIdInput(): string | undefined;
        private _authorizerCredentialsArn?;
        /**
         * @stability stable
         */
        get authorizerCredentialsArn(): string | undefined;
        /**
         * @stability stable
         */
        set authorizerCredentialsArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetAuthorizerCredentialsArn(): void;
        /**
         * @stability stable
         */
        get authorizerCredentialsArnInput(): string | undefined;
        private _authorizerPayloadFormatVersion?;
        /**
         * @stability stable
         */
        get authorizerPayloadFormatVersion(): string | undefined;
        /**
         * @stability stable
         */
        set authorizerPayloadFormatVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetAuthorizerPayloadFormatVersion(): void;
        /**
         * @stability stable
         */
        get authorizerPayloadFormatVersionInput(): string | undefined;
        private _authorizerResultTtlInSeconds?;
        /**
         * @stability stable
         */
        get authorizerResultTtlInSeconds(): number | undefined;
        /**
         * @stability stable
         */
        set authorizerResultTtlInSeconds(value: number | undefined);
        /**
         * @stability stable
         */
        resetAuthorizerResultTtlInSeconds(): void;
        /**
         * @stability stable
         */
        get authorizerResultTtlInSecondsInput(): number | undefined;
        private _authorizerType?;
        /**
         * @stability stable
         */
        get authorizerType(): string;
        /**
         * @stability stable
         */
        set authorizerType(value: string);
        /**
         * @stability stable
         */
        get authorizerTypeInput(): string | undefined;
        private _authorizerUri?;
        /**
         * @stability stable
         */
        get authorizerUri(): string | undefined;
        /**
         * @stability stable
         */
        set authorizerUri(value: string | undefined);
        /**
         * @stability stable
         */
        resetAuthorizerUri(): void;
        /**
         * @stability stable
         */
        get authorizerUriInput(): string | undefined;
        private _enableSimpleResponses?;
        /**
         * @stability stable
         */
        get enableSimpleResponses(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableSimpleResponses(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableSimpleResponses(): void;
        /**
         * @stability stable
         */
        get enableSimpleResponsesInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _identitySources?;
        /**
         * @stability stable
         */
        get identitySources(): string[] | undefined;
        /**
         * @stability stable
         */
        set identitySources(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetIdentitySources(): void;
        /**
         * @stability stable
         */
        get identitySourcesInput(): string[] | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _jwtConfiguration?;
        private __jwtConfigurationOutput;
        /**
         * @stability stable
         */
        get jwtConfiguration(): Apigatewayv2AuthorizerJwtConfigurationOutputReference;
        /**
         * @stability stable
         */
        putJwtConfiguration(value: Apigatewayv2AuthorizerJwtConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetJwtConfiguration(): void;
        /**
         * @stability stable
         */
        get jwtConfigurationInput(): Apigatewayv2AuthorizerJwtConfiguration | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2DeploymentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_deployment.html#api_id Apigatewayv2Deployment#api_id}.
         *
         * @stability stable
         */
        readonly apiId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_deployment.html#description Apigatewayv2Deployment#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_deployment.html#triggers Apigatewayv2Deployment#triggers}.
         *
         * @stability stable
         */
        readonly triggers?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_deployment.html aws_apigatewayv2_deployment}.
     *
     * @stability stable
     */
    class Apigatewayv2Deployment extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_deployment.html aws_apigatewayv2_deployment} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Apigatewayv2DeploymentConfig);
        private _apiId?;
        /**
         * @stability stable
         */
        get apiId(): string;
        /**
         * @stability stable
         */
        set apiId(value: string);
        /**
         * @stability stable
         */
        get apiIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get autoDeployed(): any;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _triggers?;
        /**
         * @stability stable
         */
        get triggers(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set triggers(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTriggers(): void;
        /**
         * @stability stable
         */
        get triggersInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2DomainNameConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#domain_name Apigatewayv2DomainName#domain_name}.
         *
         * @stability stable
         */
        readonly domainName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#tags Apigatewayv2DomainName#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#tags_all Apigatewayv2DomainName#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * domain_name_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#domain_name_configuration Apigatewayv2DomainName#domain_name_configuration}
         *
         * @stability stable
         */
        readonly domainNameConfiguration: Apigatewayv2DomainNameDomainNameConfiguration;
        /**
         * mutual_tls_authentication block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#mutual_tls_authentication Apigatewayv2DomainName#mutual_tls_authentication}
         *
         * @stability stable
         */
        readonly mutualTlsAuthentication?: Apigatewayv2DomainNameMutualTlsAuthentication;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#timeouts Apigatewayv2DomainName#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: Apigatewayv2DomainNameTimeouts;
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2DomainNameDomainNameConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#certificate_arn Apigatewayv2DomainName#certificate_arn}.
         *
         * @stability stable
         */
        readonly certificateArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#endpoint_type Apigatewayv2DomainName#endpoint_type}.
         *
         * @stability stable
         */
        readonly endpointType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#security_policy Apigatewayv2DomainName#security_policy}.
         *
         * @stability stable
         */
        readonly securityPolicy: string;
    }
    /**
     * @stability stable
     */
    class Apigatewayv2DomainNameDomainNameConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificateArn?;
        /**
         * @stability stable
         */
        get certificateArn(): string;
        /**
         * @stability stable
         */
        set certificateArn(value: string);
        /**
         * @stability stable
         */
        get certificateArnInput(): string | undefined;
        private _endpointType?;
        /**
         * @stability stable
         */
        get endpointType(): string;
        /**
         * @stability stable
         */
        set endpointType(value: string);
        /**
         * @stability stable
         */
        get endpointTypeInput(): string | undefined;
        private _securityPolicy?;
        /**
         * @stability stable
         */
        get securityPolicy(): string;
        /**
         * @stability stable
         */
        set securityPolicy(value: string);
        /**
         * @stability stable
         */
        get securityPolicyInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2DomainNameMutualTlsAuthentication {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#truststore_uri Apigatewayv2DomainName#truststore_uri}.
         *
         * @stability stable
         */
        readonly truststoreUri: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#truststore_version Apigatewayv2DomainName#truststore_version}.
         *
         * @stability stable
         */
        readonly truststoreVersion?: string;
    }
    /**
     * @stability stable
     */
    class Apigatewayv2DomainNameMutualTlsAuthenticationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _truststoreUri?;
        /**
         * @stability stable
         */
        get truststoreUri(): string;
        /**
         * @stability stable
         */
        set truststoreUri(value: string);
        /**
         * @stability stable
         */
        get truststoreUriInput(): string | undefined;
        private _truststoreVersion?;
        /**
         * @stability stable
         */
        get truststoreVersion(): string | undefined;
        /**
         * @stability stable
         */
        set truststoreVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetTruststoreVersion(): void;
        /**
         * @stability stable
         */
        get truststoreVersionInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2DomainNameTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#create Apigatewayv2DomainName#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html#update Apigatewayv2DomainName#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class Apigatewayv2DomainNameTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html aws_apigatewayv2_domain_name}.
     *
     * @stability stable
     */
    class Apigatewayv2DomainName extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name.html aws_apigatewayv2_domain_name} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Apigatewayv2DomainNameConfig);
        /**
         * @stability stable
         */
        get apiMappingSelectionExpression(): string;
        /**
         * @stability stable
         */
        get arn(): string;
        private _domainName?;
        /**
         * @stability stable
         */
        get domainName(): string;
        /**
         * @stability stable
         */
        set domainName(value: string);
        /**
         * @stability stable
         */
        get domainNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _domainNameConfiguration?;
        private __domainNameConfigurationOutput;
        /**
         * @stability stable
         */
        get domainNameConfiguration(): Apigatewayv2DomainNameDomainNameConfigurationOutputReference;
        /**
         * @stability stable
         */
        putDomainNameConfiguration(value: Apigatewayv2DomainNameDomainNameConfiguration): void;
        /**
         * @stability stable
         */
        get domainNameConfigurationInput(): Apigatewayv2DomainNameDomainNameConfiguration | undefined;
        private _mutualTlsAuthentication?;
        private __mutualTlsAuthenticationOutput;
        /**
         * @stability stable
         */
        get mutualTlsAuthentication(): Apigatewayv2DomainNameMutualTlsAuthenticationOutputReference;
        /**
         * @stability stable
         */
        putMutualTlsAuthentication(value: Apigatewayv2DomainNameMutualTlsAuthentication | undefined): void;
        /**
         * @stability stable
         */
        resetMutualTlsAuthentication(): void;
        /**
         * @stability stable
         */
        get mutualTlsAuthenticationInput(): Apigatewayv2DomainNameMutualTlsAuthentication | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): Apigatewayv2DomainNameTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: Apigatewayv2DomainNameTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): Apigatewayv2DomainNameTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2IntegrationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#api_id Apigatewayv2Integration#api_id}.
         *
         * @stability stable
         */
        readonly apiId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#connection_id Apigatewayv2Integration#connection_id}.
         *
         * @stability stable
         */
        readonly connectionId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#connection_type Apigatewayv2Integration#connection_type}.
         *
         * @stability stable
         */
        readonly connectionType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#content_handling_strategy Apigatewayv2Integration#content_handling_strategy}.
         *
         * @stability stable
         */
        readonly contentHandlingStrategy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#credentials_arn Apigatewayv2Integration#credentials_arn}.
         *
         * @stability stable
         */
        readonly credentialsArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#description Apigatewayv2Integration#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#integration_method Apigatewayv2Integration#integration_method}.
         *
         * @stability stable
         */
        readonly integrationMethod?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#integration_subtype Apigatewayv2Integration#integration_subtype}.
         *
         * @stability stable
         */
        readonly integrationSubtype?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#integration_type Apigatewayv2Integration#integration_type}.
         *
         * @stability stable
         */
        readonly integrationType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#integration_uri Apigatewayv2Integration#integration_uri}.
         *
         * @stability stable
         */
        readonly integrationUri?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#passthrough_behavior Apigatewayv2Integration#passthrough_behavior}.
         *
         * @stability stable
         */
        readonly passthroughBehavior?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#payload_format_version Apigatewayv2Integration#payload_format_version}.
         *
         * @stability stable
         */
        readonly payloadFormatVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#request_parameters Apigatewayv2Integration#request_parameters}.
         *
         * @stability stable
         */
        readonly requestParameters?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#request_templates Apigatewayv2Integration#request_templates}.
         *
         * @stability stable
         */
        readonly requestTemplates?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#template_selection_expression Apigatewayv2Integration#template_selection_expression}.
         *
         * @stability stable
         */
        readonly templateSelectionExpression?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#timeout_milliseconds Apigatewayv2Integration#timeout_milliseconds}.
         *
         * @stability stable
         */
        readonly timeoutMilliseconds?: number;
        /**
         * response_parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#response_parameters Apigatewayv2Integration#response_parameters}
         *
         * @stability stable
         */
        readonly responseParameters?: Apigatewayv2IntegrationResponseParameters[];
        /**
         * tls_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#tls_config Apigatewayv2Integration#tls_config}
         *
         * @stability stable
         */
        readonly tlsConfig?: Apigatewayv2IntegrationTlsConfig;
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2IntegrationResponseParameters {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#mappings Apigatewayv2Integration#mappings}.
         *
         * @stability stable
         */
        readonly mappings: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#status_code Apigatewayv2Integration#status_code}.
         *
         * @stability stable
         */
        readonly statusCode: string;
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2IntegrationTlsConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html#server_name_to_verify Apigatewayv2Integration#server_name_to_verify}.
         *
         * @stability stable
         */
        readonly serverNameToVerify?: string;
    }
    /**
     * @stability stable
     */
    class Apigatewayv2IntegrationTlsConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _serverNameToVerify?;
        /**
         * @stability stable
         */
        get serverNameToVerify(): string | undefined;
        /**
         * @stability stable
         */
        set serverNameToVerify(value: string | undefined);
        /**
         * @stability stable
         */
        resetServerNameToVerify(): void;
        /**
         * @stability stable
         */
        get serverNameToVerifyInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html aws_apigatewayv2_integration}.
     *
     * @stability stable
     */
    class Apigatewayv2Integration extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration.html aws_apigatewayv2_integration} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Apigatewayv2IntegrationConfig);
        private _apiId?;
        /**
         * @stability stable
         */
        get apiId(): string;
        /**
         * @stability stable
         */
        set apiId(value: string);
        /**
         * @stability stable
         */
        get apiIdInput(): string | undefined;
        private _connectionId?;
        /**
         * @stability stable
         */
        get connectionId(): string | undefined;
        /**
         * @stability stable
         */
        set connectionId(value: string | undefined);
        /**
         * @stability stable
         */
        resetConnectionId(): void;
        /**
         * @stability stable
         */
        get connectionIdInput(): string | undefined;
        private _connectionType?;
        /**
         * @stability stable
         */
        get connectionType(): string | undefined;
        /**
         * @stability stable
         */
        set connectionType(value: string | undefined);
        /**
         * @stability stable
         */
        resetConnectionType(): void;
        /**
         * @stability stable
         */
        get connectionTypeInput(): string | undefined;
        private _contentHandlingStrategy?;
        /**
         * @stability stable
         */
        get contentHandlingStrategy(): string | undefined;
        /**
         * @stability stable
         */
        set contentHandlingStrategy(value: string | undefined);
        /**
         * @stability stable
         */
        resetContentHandlingStrategy(): void;
        /**
         * @stability stable
         */
        get contentHandlingStrategyInput(): string | undefined;
        private _credentialsArn?;
        /**
         * @stability stable
         */
        get credentialsArn(): string | undefined;
        /**
         * @stability stable
         */
        set credentialsArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetCredentialsArn(): void;
        /**
         * @stability stable
         */
        get credentialsArnInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _integrationMethod?;
        /**
         * @stability stable
         */
        get integrationMethod(): string | undefined;
        /**
         * @stability stable
         */
        set integrationMethod(value: string | undefined);
        /**
         * @stability stable
         */
        resetIntegrationMethod(): void;
        /**
         * @stability stable
         */
        get integrationMethodInput(): string | undefined;
        /**
         * @stability stable
         */
        get integrationResponseSelectionExpression(): string;
        private _integrationSubtype?;
        /**
         * @stability stable
         */
        get integrationSubtype(): string | undefined;
        /**
         * @stability stable
         */
        set integrationSubtype(value: string | undefined);
        /**
         * @stability stable
         */
        resetIntegrationSubtype(): void;
        /**
         * @stability stable
         */
        get integrationSubtypeInput(): string | undefined;
        private _integrationType?;
        /**
         * @stability stable
         */
        get integrationType(): string;
        /**
         * @stability stable
         */
        set integrationType(value: string);
        /**
         * @stability stable
         */
        get integrationTypeInput(): string | undefined;
        private _integrationUri?;
        /**
         * @stability stable
         */
        get integrationUri(): string | undefined;
        /**
         * @stability stable
         */
        set integrationUri(value: string | undefined);
        /**
         * @stability stable
         */
        resetIntegrationUri(): void;
        /**
         * @stability stable
         */
        get integrationUriInput(): string | undefined;
        private _passthroughBehavior?;
        /**
         * @stability stable
         */
        get passthroughBehavior(): string | undefined;
        /**
         * @stability stable
         */
        set passthroughBehavior(value: string | undefined);
        /**
         * @stability stable
         */
        resetPassthroughBehavior(): void;
        /**
         * @stability stable
         */
        get passthroughBehaviorInput(): string | undefined;
        private _payloadFormatVersion?;
        /**
         * @stability stable
         */
        get payloadFormatVersion(): string | undefined;
        /**
         * @stability stable
         */
        set payloadFormatVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetPayloadFormatVersion(): void;
        /**
         * @stability stable
         */
        get payloadFormatVersionInput(): string | undefined;
        private _requestParameters?;
        /**
         * @stability stable
         */
        get requestParameters(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set requestParameters(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetRequestParameters(): void;
        /**
         * @stability stable
         */
        get requestParametersInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _requestTemplates?;
        /**
         * @stability stable
         */
        get requestTemplates(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set requestTemplates(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetRequestTemplates(): void;
        /**
         * @stability stable
         */
        get requestTemplatesInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _templateSelectionExpression?;
        /**
         * @stability stable
         */
        get templateSelectionExpression(): string | undefined;
        /**
         * @stability stable
         */
        set templateSelectionExpression(value: string | undefined);
        /**
         * @stability stable
         */
        resetTemplateSelectionExpression(): void;
        /**
         * @stability stable
         */
        get templateSelectionExpressionInput(): string | undefined;
        private _timeoutMilliseconds?;
        /**
         * @stability stable
         */
        get timeoutMilliseconds(): number | undefined;
        /**
         * @stability stable
         */
        set timeoutMilliseconds(value: number | undefined);
        /**
         * @stability stable
         */
        resetTimeoutMilliseconds(): void;
        /**
         * @stability stable
         */
        get timeoutMillisecondsInput(): number | undefined;
        private _responseParameters?;
        /**
         * @stability stable
         */
        get responseParameters(): Apigatewayv2IntegrationResponseParameters[] | undefined;
        /**
         * @stability stable
         */
        set responseParameters(value: Apigatewayv2IntegrationResponseParameters[] | undefined);
        /**
         * @stability stable
         */
        resetResponseParameters(): void;
        /**
         * @stability stable
         */
        get responseParametersInput(): Apigatewayv2IntegrationResponseParameters[] | undefined;
        private _tlsConfig?;
        private __tlsConfigOutput;
        /**
         * @stability stable
         */
        get tlsConfig(): Apigatewayv2IntegrationTlsConfigOutputReference;
        /**
         * @stability stable
         */
        putTlsConfig(value: Apigatewayv2IntegrationTlsConfig | undefined): void;
        /**
         * @stability stable
         */
        resetTlsConfig(): void;
        /**
         * @stability stable
         */
        get tlsConfigInput(): Apigatewayv2IntegrationTlsConfig | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2IntegrationResponseConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration_response.html#api_id Apigatewayv2IntegrationResponse#api_id}.
         *
         * @stability stable
         */
        readonly apiId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration_response.html#content_handling_strategy Apigatewayv2IntegrationResponse#content_handling_strategy}.
         *
         * @stability stable
         */
        readonly contentHandlingStrategy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration_response.html#integration_id Apigatewayv2IntegrationResponse#integration_id}.
         *
         * @stability stable
         */
        readonly integrationId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration_response.html#integration_response_key Apigatewayv2IntegrationResponse#integration_response_key}.
         *
         * @stability stable
         */
        readonly integrationResponseKey: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration_response.html#response_templates Apigatewayv2IntegrationResponse#response_templates}.
         *
         * @stability stable
         */
        readonly responseTemplates?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration_response.html#template_selection_expression Apigatewayv2IntegrationResponse#template_selection_expression}.
         *
         * @stability stable
         */
        readonly templateSelectionExpression?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration_response.html aws_apigatewayv2_integration_response}.
     *
     * @stability stable
     */
    class Apigatewayv2IntegrationResponse extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration_response.html aws_apigatewayv2_integration_response} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Apigatewayv2IntegrationResponseConfig);
        private _apiId?;
        /**
         * @stability stable
         */
        get apiId(): string;
        /**
         * @stability stable
         */
        set apiId(value: string);
        /**
         * @stability stable
         */
        get apiIdInput(): string | undefined;
        private _contentHandlingStrategy?;
        /**
         * @stability stable
         */
        get contentHandlingStrategy(): string | undefined;
        /**
         * @stability stable
         */
        set contentHandlingStrategy(value: string | undefined);
        /**
         * @stability stable
         */
        resetContentHandlingStrategy(): void;
        /**
         * @stability stable
         */
        get contentHandlingStrategyInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _integrationId?;
        /**
         * @stability stable
         */
        get integrationId(): string;
        /**
         * @stability stable
         */
        set integrationId(value: string);
        /**
         * @stability stable
         */
        get integrationIdInput(): string | undefined;
        private _integrationResponseKey?;
        /**
         * @stability stable
         */
        get integrationResponseKey(): string;
        /**
         * @stability stable
         */
        set integrationResponseKey(value: string);
        /**
         * @stability stable
         */
        get integrationResponseKeyInput(): string | undefined;
        private _responseTemplates?;
        /**
         * @stability stable
         */
        get responseTemplates(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set responseTemplates(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetResponseTemplates(): void;
        /**
         * @stability stable
         */
        get responseTemplatesInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _templateSelectionExpression?;
        /**
         * @stability stable
         */
        get templateSelectionExpression(): string | undefined;
        /**
         * @stability stable
         */
        set templateSelectionExpression(value: string | undefined);
        /**
         * @stability stable
         */
        resetTemplateSelectionExpression(): void;
        /**
         * @stability stable
         */
        get templateSelectionExpressionInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2ModelConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_model.html#api_id Apigatewayv2Model#api_id}.
         *
         * @stability stable
         */
        readonly apiId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_model.html#content_type Apigatewayv2Model#content_type}.
         *
         * @stability stable
         */
        readonly contentType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_model.html#description Apigatewayv2Model#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_model.html#name Apigatewayv2Model#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_model.html#schema Apigatewayv2Model#schema}.
         *
         * @stability stable
         */
        readonly schema: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_model.html aws_apigatewayv2_model}.
     *
     * @stability stable
     */
    class Apigatewayv2Model extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_model.html aws_apigatewayv2_model} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Apigatewayv2ModelConfig);
        private _apiId?;
        /**
         * @stability stable
         */
        get apiId(): string;
        /**
         * @stability stable
         */
        set apiId(value: string);
        /**
         * @stability stable
         */
        get apiIdInput(): string | undefined;
        private _contentType?;
        /**
         * @stability stable
         */
        get contentType(): string;
        /**
         * @stability stable
         */
        set contentType(value: string);
        /**
         * @stability stable
         */
        get contentTypeInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _schema?;
        /**
         * @stability stable
         */
        get schema(): string;
        /**
         * @stability stable
         */
        set schema(value: string);
        /**
         * @stability stable
         */
        get schemaInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2RouteConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route.html#api_id Apigatewayv2Route#api_id}.
         *
         * @stability stable
         */
        readonly apiId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route.html#api_key_required Apigatewayv2Route#api_key_required}.
         *
         * @stability stable
         */
        readonly apiKeyRequired?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route.html#authorization_scopes Apigatewayv2Route#authorization_scopes}.
         *
         * @stability stable
         */
        readonly authorizationScopes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route.html#authorization_type Apigatewayv2Route#authorization_type}.
         *
         * @stability stable
         */
        readonly authorizationType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route.html#authorizer_id Apigatewayv2Route#authorizer_id}.
         *
         * @stability stable
         */
        readonly authorizerId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route.html#model_selection_expression Apigatewayv2Route#model_selection_expression}.
         *
         * @stability stable
         */
        readonly modelSelectionExpression?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route.html#operation_name Apigatewayv2Route#operation_name}.
         *
         * @stability stable
         */
        readonly operationName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route.html#request_models Apigatewayv2Route#request_models}.
         *
         * @stability stable
         */
        readonly requestModels?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route.html#route_key Apigatewayv2Route#route_key}.
         *
         * @stability stable
         */
        readonly routeKey: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route.html#route_response_selection_expression Apigatewayv2Route#route_response_selection_expression}.
         *
         * @stability stable
         */
        readonly routeResponseSelectionExpression?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route.html#target Apigatewayv2Route#target}.
         *
         * @stability stable
         */
        readonly target?: string;
        /**
         * request_parameter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route.html#request_parameter Apigatewayv2Route#request_parameter}
         *
         * @stability stable
         */
        readonly requestParameter?: Apigatewayv2RouteRequestParameter[];
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2RouteRequestParameter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route.html#request_parameter_key Apigatewayv2Route#request_parameter_key}.
         *
         * @stability stable
         */
        readonly requestParameterKey: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route.html#required Apigatewayv2Route#required}.
         *
         * @stability stable
         */
        readonly required: boolean | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route.html aws_apigatewayv2_route}.
     *
     * @stability stable
     */
    class Apigatewayv2Route extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route.html aws_apigatewayv2_route} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Apigatewayv2RouteConfig);
        private _apiId?;
        /**
         * @stability stable
         */
        get apiId(): string;
        /**
         * @stability stable
         */
        set apiId(value: string);
        /**
         * @stability stable
         */
        get apiIdInput(): string | undefined;
        private _apiKeyRequired?;
        /**
         * @stability stable
         */
        get apiKeyRequired(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set apiKeyRequired(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetApiKeyRequired(): void;
        /**
         * @stability stable
         */
        get apiKeyRequiredInput(): boolean | cdktf.IResolvable | undefined;
        private _authorizationScopes?;
        /**
         * @stability stable
         */
        get authorizationScopes(): string[] | undefined;
        /**
         * @stability stable
         */
        set authorizationScopes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetAuthorizationScopes(): void;
        /**
         * @stability stable
         */
        get authorizationScopesInput(): string[] | undefined;
        private _authorizationType?;
        /**
         * @stability stable
         */
        get authorizationType(): string | undefined;
        /**
         * @stability stable
         */
        set authorizationType(value: string | undefined);
        /**
         * @stability stable
         */
        resetAuthorizationType(): void;
        /**
         * @stability stable
         */
        get authorizationTypeInput(): string | undefined;
        private _authorizerId?;
        /**
         * @stability stable
         */
        get authorizerId(): string | undefined;
        /**
         * @stability stable
         */
        set authorizerId(value: string | undefined);
        /**
         * @stability stable
         */
        resetAuthorizerId(): void;
        /**
         * @stability stable
         */
        get authorizerIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _modelSelectionExpression?;
        /**
         * @stability stable
         */
        get modelSelectionExpression(): string | undefined;
        /**
         * @stability stable
         */
        set modelSelectionExpression(value: string | undefined);
        /**
         * @stability stable
         */
        resetModelSelectionExpression(): void;
        /**
         * @stability stable
         */
        get modelSelectionExpressionInput(): string | undefined;
        private _operationName?;
        /**
         * @stability stable
         */
        get operationName(): string | undefined;
        /**
         * @stability stable
         */
        set operationName(value: string | undefined);
        /**
         * @stability stable
         */
        resetOperationName(): void;
        /**
         * @stability stable
         */
        get operationNameInput(): string | undefined;
        private _requestModels?;
        /**
         * @stability stable
         */
        get requestModels(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set requestModels(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetRequestModels(): void;
        /**
         * @stability stable
         */
        get requestModelsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _routeKey?;
        /**
         * @stability stable
         */
        get routeKey(): string;
        /**
         * @stability stable
         */
        set routeKey(value: string);
        /**
         * @stability stable
         */
        get routeKeyInput(): string | undefined;
        private _routeResponseSelectionExpression?;
        /**
         * @stability stable
         */
        get routeResponseSelectionExpression(): string | undefined;
        /**
         * @stability stable
         */
        set routeResponseSelectionExpression(value: string | undefined);
        /**
         * @stability stable
         */
        resetRouteResponseSelectionExpression(): void;
        /**
         * @stability stable
         */
        get routeResponseSelectionExpressionInput(): string | undefined;
        private _target?;
        /**
         * @stability stable
         */
        get target(): string | undefined;
        /**
         * @stability stable
         */
        set target(value: string | undefined);
        /**
         * @stability stable
         */
        resetTarget(): void;
        /**
         * @stability stable
         */
        get targetInput(): string | undefined;
        private _requestParameter?;
        /**
         * @stability stable
         */
        get requestParameter(): Apigatewayv2RouteRequestParameter[] | undefined;
        /**
         * @stability stable
         */
        set requestParameter(value: Apigatewayv2RouteRequestParameter[] | undefined);
        /**
         * @stability stable
         */
        resetRequestParameter(): void;
        /**
         * @stability stable
         */
        get requestParameterInput(): Apigatewayv2RouteRequestParameter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2RouteResponseConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route_response.html#api_id Apigatewayv2RouteResponse#api_id}.
         *
         * @stability stable
         */
        readonly apiId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route_response.html#model_selection_expression Apigatewayv2RouteResponse#model_selection_expression}.
         *
         * @stability stable
         */
        readonly modelSelectionExpression?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route_response.html#response_models Apigatewayv2RouteResponse#response_models}.
         *
         * @stability stable
         */
        readonly responseModels?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route_response.html#route_id Apigatewayv2RouteResponse#route_id}.
         *
         * @stability stable
         */
        readonly routeId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route_response.html#route_response_key Apigatewayv2RouteResponse#route_response_key}.
         *
         * @stability stable
         */
        readonly routeResponseKey: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route_response.html aws_apigatewayv2_route_response}.
     *
     * @stability stable
     */
    class Apigatewayv2RouteResponse extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route_response.html aws_apigatewayv2_route_response} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Apigatewayv2RouteResponseConfig);
        private _apiId?;
        /**
         * @stability stable
         */
        get apiId(): string;
        /**
         * @stability stable
         */
        set apiId(value: string);
        /**
         * @stability stable
         */
        get apiIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _modelSelectionExpression?;
        /**
         * @stability stable
         */
        get modelSelectionExpression(): string | undefined;
        /**
         * @stability stable
         */
        set modelSelectionExpression(value: string | undefined);
        /**
         * @stability stable
         */
        resetModelSelectionExpression(): void;
        /**
         * @stability stable
         */
        get modelSelectionExpressionInput(): string | undefined;
        private _responseModels?;
        /**
         * @stability stable
         */
        get responseModels(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set responseModels(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetResponseModels(): void;
        /**
         * @stability stable
         */
        get responseModelsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _routeId?;
        /**
         * @stability stable
         */
        get routeId(): string;
        /**
         * @stability stable
         */
        set routeId(value: string);
        /**
         * @stability stable
         */
        get routeIdInput(): string | undefined;
        private _routeResponseKey?;
        /**
         * @stability stable
         */
        get routeResponseKey(): string;
        /**
         * @stability stable
         */
        set routeResponseKey(value: string);
        /**
         * @stability stable
         */
        get routeResponseKeyInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2StageConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#api_id Apigatewayv2Stage#api_id}.
         *
         * @stability stable
         */
        readonly apiId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#auto_deploy Apigatewayv2Stage#auto_deploy}.
         *
         * @stability stable
         */
        readonly autoDeploy?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#client_certificate_id Apigatewayv2Stage#client_certificate_id}.
         *
         * @stability stable
         */
        readonly clientCertificateId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#deployment_id Apigatewayv2Stage#deployment_id}.
         *
         * @stability stable
         */
        readonly deploymentId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#description Apigatewayv2Stage#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#name Apigatewayv2Stage#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#stage_variables Apigatewayv2Stage#stage_variables}.
         *
         * @stability stable
         */
        readonly stageVariables?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#tags Apigatewayv2Stage#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#tags_all Apigatewayv2Stage#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * access_log_settings block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#access_log_settings Apigatewayv2Stage#access_log_settings}
         *
         * @stability stable
         */
        readonly accessLogSettings?: Apigatewayv2StageAccessLogSettings;
        /**
         * default_route_settings block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#default_route_settings Apigatewayv2Stage#default_route_settings}
         *
         * @stability stable
         */
        readonly defaultRouteSettings?: Apigatewayv2StageDefaultRouteSettings;
        /**
         * route_settings block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#route_settings Apigatewayv2Stage#route_settings}
         *
         * @stability stable
         */
        readonly routeSettings?: Apigatewayv2StageRouteSettings[];
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2StageAccessLogSettings {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#destination_arn Apigatewayv2Stage#destination_arn}.
         *
         * @stability stable
         */
        readonly destinationArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#format Apigatewayv2Stage#format}.
         *
         * @stability stable
         */
        readonly format: string;
    }
    /**
     * @stability stable
     */
    class Apigatewayv2StageAccessLogSettingsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _destinationArn?;
        /**
         * @stability stable
         */
        get destinationArn(): string;
        /**
         * @stability stable
         */
        set destinationArn(value: string);
        /**
         * @stability stable
         */
        get destinationArnInput(): string | undefined;
        private _format?;
        /**
         * @stability stable
         */
        get format(): string;
        /**
         * @stability stable
         */
        set format(value: string);
        /**
         * @stability stable
         */
        get formatInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2StageDefaultRouteSettings {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#data_trace_enabled Apigatewayv2Stage#data_trace_enabled}.
         *
         * @stability stable
         */
        readonly dataTraceEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#detailed_metrics_enabled Apigatewayv2Stage#detailed_metrics_enabled}.
         *
         * @stability stable
         */
        readonly detailedMetricsEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#logging_level Apigatewayv2Stage#logging_level}.
         *
         * @stability stable
         */
        readonly loggingLevel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#throttling_burst_limit Apigatewayv2Stage#throttling_burst_limit}.
         *
         * @stability stable
         */
        readonly throttlingBurstLimit?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#throttling_rate_limit Apigatewayv2Stage#throttling_rate_limit}.
         *
         * @stability stable
         */
        readonly throttlingRateLimit?: number;
    }
    /**
     * @stability stable
     */
    class Apigatewayv2StageDefaultRouteSettingsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _dataTraceEnabled?;
        /**
         * @stability stable
         */
        get dataTraceEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set dataTraceEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDataTraceEnabled(): void;
        /**
         * @stability stable
         */
        get dataTraceEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _detailedMetricsEnabled?;
        /**
         * @stability stable
         */
        get detailedMetricsEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set detailedMetricsEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDetailedMetricsEnabled(): void;
        /**
         * @stability stable
         */
        get detailedMetricsEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _loggingLevel?;
        /**
         * @stability stable
         */
        get loggingLevel(): string | undefined;
        /**
         * @stability stable
         */
        set loggingLevel(value: string | undefined);
        /**
         * @stability stable
         */
        resetLoggingLevel(): void;
        /**
         * @stability stable
         */
        get loggingLevelInput(): string | undefined;
        private _throttlingBurstLimit?;
        /**
         * @stability stable
         */
        get throttlingBurstLimit(): number | undefined;
        /**
         * @stability stable
         */
        set throttlingBurstLimit(value: number | undefined);
        /**
         * @stability stable
         */
        resetThrottlingBurstLimit(): void;
        /**
         * @stability stable
         */
        get throttlingBurstLimitInput(): number | undefined;
        private _throttlingRateLimit?;
        /**
         * @stability stable
         */
        get throttlingRateLimit(): number | undefined;
        /**
         * @stability stable
         */
        set throttlingRateLimit(value: number | undefined);
        /**
         * @stability stable
         */
        resetThrottlingRateLimit(): void;
        /**
         * @stability stable
         */
        get throttlingRateLimitInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2StageRouteSettings {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#data_trace_enabled Apigatewayv2Stage#data_trace_enabled}.
         *
         * @stability stable
         */
        readonly dataTraceEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#detailed_metrics_enabled Apigatewayv2Stage#detailed_metrics_enabled}.
         *
         * @stability stable
         */
        readonly detailedMetricsEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#logging_level Apigatewayv2Stage#logging_level}.
         *
         * @stability stable
         */
        readonly loggingLevel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#route_key Apigatewayv2Stage#route_key}.
         *
         * @stability stable
         */
        readonly routeKey: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#throttling_burst_limit Apigatewayv2Stage#throttling_burst_limit}.
         *
         * @stability stable
         */
        readonly throttlingBurstLimit?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html#throttling_rate_limit Apigatewayv2Stage#throttling_rate_limit}.
         *
         * @stability stable
         */
        readonly throttlingRateLimit?: number;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html aws_apigatewayv2_stage}.
     *
     * @stability stable
     */
    class Apigatewayv2Stage extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage.html aws_apigatewayv2_stage} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Apigatewayv2StageConfig);
        private _apiId?;
        /**
         * @stability stable
         */
        get apiId(): string;
        /**
         * @stability stable
         */
        set apiId(value: string);
        /**
         * @stability stable
         */
        get apiIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoDeploy?;
        /**
         * @stability stable
         */
        get autoDeploy(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoDeploy(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoDeploy(): void;
        /**
         * @stability stable
         */
        get autoDeployInput(): boolean | cdktf.IResolvable | undefined;
        private _clientCertificateId?;
        /**
         * @stability stable
         */
        get clientCertificateId(): string | undefined;
        /**
         * @stability stable
         */
        set clientCertificateId(value: string | undefined);
        /**
         * @stability stable
         */
        resetClientCertificateId(): void;
        /**
         * @stability stable
         */
        get clientCertificateIdInput(): string | undefined;
        private _deploymentId?;
        /**
         * @stability stable
         */
        get deploymentId(): string | undefined;
        /**
         * @stability stable
         */
        set deploymentId(value: string | undefined);
        /**
         * @stability stable
         */
        resetDeploymentId(): void;
        /**
         * @stability stable
         */
        get deploymentIdInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get executionArn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get invokeUrl(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _stageVariables?;
        /**
         * @stability stable
         */
        get stageVariables(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set stageVariables(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetStageVariables(): void;
        /**
         * @stability stable
         */
        get stageVariablesInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _accessLogSettings?;
        private __accessLogSettingsOutput;
        /**
         * @stability stable
         */
        get accessLogSettings(): Apigatewayv2StageAccessLogSettingsOutputReference;
        /**
         * @stability stable
         */
        putAccessLogSettings(value: Apigatewayv2StageAccessLogSettings | undefined): void;
        /**
         * @stability stable
         */
        resetAccessLogSettings(): void;
        /**
         * @stability stable
         */
        get accessLogSettingsInput(): Apigatewayv2StageAccessLogSettings | undefined;
        private _defaultRouteSettings?;
        private __defaultRouteSettingsOutput;
        /**
         * @stability stable
         */
        get defaultRouteSettings(): Apigatewayv2StageDefaultRouteSettingsOutputReference;
        /**
         * @stability stable
         */
        putDefaultRouteSettings(value: Apigatewayv2StageDefaultRouteSettings | undefined): void;
        /**
         * @stability stable
         */
        resetDefaultRouteSettings(): void;
        /**
         * @stability stable
         */
        get defaultRouteSettingsInput(): Apigatewayv2StageDefaultRouteSettings | undefined;
        private _routeSettings?;
        /**
         * @stability stable
         */
        get routeSettings(): Apigatewayv2StageRouteSettings[] | undefined;
        /**
         * @stability stable
         */
        set routeSettings(value: Apigatewayv2StageRouteSettings[] | undefined);
        /**
         * @stability stable
         */
        resetRouteSettings(): void;
        /**
         * @stability stable
         */
        get routeSettingsInput(): Apigatewayv2StageRouteSettings[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Apigatewayv2VpcLinkConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_vpc_link.html#name Apigatewayv2VpcLink#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_vpc_link.html#security_group_ids Apigatewayv2VpcLink#security_group_ids}.
         *
         * @stability stable
         */
        readonly securityGroupIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_vpc_link.html#subnet_ids Apigatewayv2VpcLink#subnet_ids}.
         *
         * @stability stable
         */
        readonly subnetIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_vpc_link.html#tags Apigatewayv2VpcLink#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_vpc_link.html#tags_all Apigatewayv2VpcLink#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_vpc_link.html aws_apigatewayv2_vpc_link}.
     *
     * @stability stable
     */
    class Apigatewayv2VpcLink extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_vpc_link.html aws_apigatewayv2_vpc_link} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Apigatewayv2VpcLinkConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _securityGroupIds?;
        /**
         * @stability stable
         */
        get securityGroupIds(): string[];
        /**
         * @stability stable
         */
        set securityGroupIds(value: string[]);
        /**
         * @stability stable
         */
        get securityGroupIdsInput(): string[] | undefined;
        private _subnetIds?;
        /**
         * @stability stable
         */
        get subnetIds(): string[];
        /**
         * @stability stable
         */
        set subnetIds(value: string[]);
        /**
         * @stability stable
         */
        get subnetIdsInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsApigatewayv2ApiConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/apigatewayv2_api.html#api_id DataAwsApigatewayv2Api#api_id}.
         *
         * @stability stable
         */
        readonly apiId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/apigatewayv2_api.html#tags DataAwsApigatewayv2Api#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class DataAwsApigatewayv2ApiCorsConfiguration extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get allowCredentials(): any;
        /**
         * @stability stable
         */
        get allowHeaders(): string[];
        /**
         * @stability stable
         */
        get allowMethods(): string[];
        /**
         * @stability stable
         */
        get allowOrigins(): string[];
        /**
         * @stability stable
         */
        get exposeHeaders(): string[];
        /**
         * @stability stable
         */
        get maxAge(): number;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/apigatewayv2_api.html aws_apigatewayv2_api}.
     *
     * @stability stable
     */
    class DataAwsApigatewayv2Api extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/apigatewayv2_api.html aws_apigatewayv2_api} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsApigatewayv2ApiConfig);
        /**
         * @stability stable
         */
        get apiEndpoint(): string;
        private _apiId?;
        /**
         * @stability stable
         */
        get apiId(): string;
        /**
         * @stability stable
         */
        set apiId(value: string);
        /**
         * @stability stable
         */
        get apiIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get apiKeySelectionExpression(): string;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        corsConfiguration(index: string): DataAwsApigatewayv2ApiCorsConfiguration;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get disableExecuteApiEndpoint(): any;
        /**
         * @stability stable
         */
        get executionArn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        get protocolType(): string;
        /**
         * @stability stable
         */
        get routeSelectionExpression(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get version(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsApigatewayv2ApisConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/apigatewayv2_apis.html#name DataAwsApigatewayv2Apis#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/apigatewayv2_apis.html#protocol_type DataAwsApigatewayv2Apis#protocol_type}.
         *
         * @stability stable
         */
        readonly protocolType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/apigatewayv2_apis.html#tags DataAwsApigatewayv2Apis#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/apigatewayv2_apis.html aws_apigatewayv2_apis}.
     *
     * @stability stable
     */
    class DataAwsApigatewayv2Apis extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/apigatewayv2_apis.html aws_apigatewayv2_apis} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsApigatewayv2ApisConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ids(): string[];
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _protocolType?;
        /**
         * @stability stable
         */
        get protocolType(): string | undefined;
        /**
         * @stability stable
         */
        set protocolType(value: string | undefined);
        /**
         * @stability stable
         */
        resetProtocolType(): void;
        /**
         * @stability stable
         */
        get protocolTypeInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
