import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Amplify
*/
export declare namespace Amplify {
    /**
     * @stability stable
     */
    interface AmplifyAppConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#access_token AmplifyApp#access_token}.
         *
         * @stability stable
         */
        readonly accessToken?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#auto_branch_creation_patterns AmplifyApp#auto_branch_creation_patterns}.
         *
         * @stability stable
         */
        readonly autoBranchCreationPatterns?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#basic_auth_credentials AmplifyApp#basic_auth_credentials}.
         *
         * @stability stable
         */
        readonly basicAuthCredentials?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#build_spec AmplifyApp#build_spec}.
         *
         * @stability stable
         */
        readonly buildSpec?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#description AmplifyApp#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#enable_auto_branch_creation AmplifyApp#enable_auto_branch_creation}.
         *
         * @stability stable
         */
        readonly enableAutoBranchCreation?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#enable_basic_auth AmplifyApp#enable_basic_auth}.
         *
         * @stability stable
         */
        readonly enableBasicAuth?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#enable_branch_auto_build AmplifyApp#enable_branch_auto_build}.
         *
         * @stability stable
         */
        readonly enableBranchAutoBuild?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#enable_branch_auto_deletion AmplifyApp#enable_branch_auto_deletion}.
         *
         * @stability stable
         */
        readonly enableBranchAutoDeletion?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#environment_variables AmplifyApp#environment_variables}.
         *
         * @stability stable
         */
        readonly environmentVariables?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#iam_service_role_arn AmplifyApp#iam_service_role_arn}.
         *
         * @stability stable
         */
        readonly iamServiceRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#name AmplifyApp#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#oauth_token AmplifyApp#oauth_token}.
         *
         * @stability stable
         */
        readonly oauthToken?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#platform AmplifyApp#platform}.
         *
         * @stability stable
         */
        readonly platform?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#repository AmplifyApp#repository}.
         *
         * @stability stable
         */
        readonly repository?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#tags AmplifyApp#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#tags_all AmplifyApp#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * auto_branch_creation_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#auto_branch_creation_config AmplifyApp#auto_branch_creation_config}
         *
         * @stability stable
         */
        readonly autoBranchCreationConfig?: AmplifyAppAutoBranchCreationConfig;
        /**
         * custom_rule block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#custom_rule AmplifyApp#custom_rule}
         *
         * @stability stable
         */
        readonly customRule?: AmplifyAppCustomRule[];
    }
    /**
     * @stability stable
     */
    class AmplifyAppProductionBranch extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get branchName(): string;
        /**
         * @stability stable
         */
        get lastDeployTime(): string;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        get thumbnailUrl(): string;
    }
    /**
     * @stability stable
     */
    interface AmplifyAppAutoBranchCreationConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#basic_auth_credentials AmplifyApp#basic_auth_credentials}.
         *
         * @stability stable
         */
        readonly basicAuthCredentials?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#build_spec AmplifyApp#build_spec}.
         *
         * @stability stable
         */
        readonly buildSpec?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#enable_auto_build AmplifyApp#enable_auto_build}.
         *
         * @stability stable
         */
        readonly enableAutoBuild?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#enable_basic_auth AmplifyApp#enable_basic_auth}.
         *
         * @stability stable
         */
        readonly enableBasicAuth?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#enable_performance_mode AmplifyApp#enable_performance_mode}.
         *
         * @stability stable
         */
        readonly enablePerformanceMode?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#enable_pull_request_preview AmplifyApp#enable_pull_request_preview}.
         *
         * @stability stable
         */
        readonly enablePullRequestPreview?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#environment_variables AmplifyApp#environment_variables}.
         *
         * @stability stable
         */
        readonly environmentVariables?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#framework AmplifyApp#framework}.
         *
         * @stability stable
         */
        readonly framework?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#pull_request_environment_name AmplifyApp#pull_request_environment_name}.
         *
         * @stability stable
         */
        readonly pullRequestEnvironmentName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#stage AmplifyApp#stage}.
         *
         * @stability stable
         */
        readonly stage?: string;
    }
    /**
     * @stability stable
     */
    class AmplifyAppAutoBranchCreationConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _basicAuthCredentials?;
        /**
         * @stability stable
         */
        get basicAuthCredentials(): string | undefined;
        /**
         * @stability stable
         */
        set basicAuthCredentials(value: string | undefined);
        /**
         * @stability stable
         */
        resetBasicAuthCredentials(): void;
        /**
         * @stability stable
         */
        get basicAuthCredentialsInput(): string | undefined;
        private _buildSpec?;
        /**
         * @stability stable
         */
        get buildSpec(): string | undefined;
        /**
         * @stability stable
         */
        set buildSpec(value: string | undefined);
        /**
         * @stability stable
         */
        resetBuildSpec(): void;
        /**
         * @stability stable
         */
        get buildSpecInput(): string | undefined;
        private _enableAutoBuild?;
        /**
         * @stability stable
         */
        get enableAutoBuild(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableAutoBuild(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableAutoBuild(): void;
        /**
         * @stability stable
         */
        get enableAutoBuildInput(): boolean | cdktf.IResolvable | undefined;
        private _enableBasicAuth?;
        /**
         * @stability stable
         */
        get enableBasicAuth(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableBasicAuth(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableBasicAuth(): void;
        /**
         * @stability stable
         */
        get enableBasicAuthInput(): boolean | cdktf.IResolvable | undefined;
        private _enablePerformanceMode?;
        /**
         * @stability stable
         */
        get enablePerformanceMode(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enablePerformanceMode(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnablePerformanceMode(): void;
        /**
         * @stability stable
         */
        get enablePerformanceModeInput(): boolean | cdktf.IResolvable | undefined;
        private _enablePullRequestPreview?;
        /**
         * @stability stable
         */
        get enablePullRequestPreview(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enablePullRequestPreview(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnablePullRequestPreview(): void;
        /**
         * @stability stable
         */
        get enablePullRequestPreviewInput(): boolean | cdktf.IResolvable | undefined;
        private _environmentVariables?;
        /**
         * @stability stable
         */
        get environmentVariables(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set environmentVariables(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnvironmentVariables(): void;
        /**
         * @stability stable
         */
        get environmentVariablesInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _framework?;
        /**
         * @stability stable
         */
        get framework(): string | undefined;
        /**
         * @stability stable
         */
        set framework(value: string | undefined);
        /**
         * @stability stable
         */
        resetFramework(): void;
        /**
         * @stability stable
         */
        get frameworkInput(): string | undefined;
        private _pullRequestEnvironmentName?;
        /**
         * @stability stable
         */
        get pullRequestEnvironmentName(): string | undefined;
        /**
         * @stability stable
         */
        set pullRequestEnvironmentName(value: string | undefined);
        /**
         * @stability stable
         */
        resetPullRequestEnvironmentName(): void;
        /**
         * @stability stable
         */
        get pullRequestEnvironmentNameInput(): string | undefined;
        private _stage?;
        /**
         * @stability stable
         */
        get stage(): string | undefined;
        /**
         * @stability stable
         */
        set stage(value: string | undefined);
        /**
         * @stability stable
         */
        resetStage(): void;
        /**
         * @stability stable
         */
        get stageInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AmplifyAppCustomRule {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#condition AmplifyApp#condition}.
         *
         * @stability stable
         */
        readonly condition?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#source AmplifyApp#source}.
         *
         * @stability stable
         */
        readonly source: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#status AmplifyApp#status}.
         *
         * @stability stable
         */
        readonly status?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#target AmplifyApp#target}.
         *
         * @stability stable
         */
        readonly target: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html aws_amplify_app}.
     *
     * @stability stable
     */
    class AmplifyApp extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html aws_amplify_app} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AmplifyAppConfig);
        private _accessToken?;
        /**
         * @stability stable
         */
        get accessToken(): string | undefined;
        /**
         * @stability stable
         */
        set accessToken(value: string | undefined);
        /**
         * @stability stable
         */
        resetAccessToken(): void;
        /**
         * @stability stable
         */
        get accessTokenInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoBranchCreationPatterns?;
        /**
         * @stability stable
         */
        get autoBranchCreationPatterns(): string[] | undefined;
        /**
         * @stability stable
         */
        set autoBranchCreationPatterns(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetAutoBranchCreationPatterns(): void;
        /**
         * @stability stable
         */
        get autoBranchCreationPatternsInput(): string[] | undefined;
        private _basicAuthCredentials?;
        /**
         * @stability stable
         */
        get basicAuthCredentials(): string | undefined;
        /**
         * @stability stable
         */
        set basicAuthCredentials(value: string | undefined);
        /**
         * @stability stable
         */
        resetBasicAuthCredentials(): void;
        /**
         * @stability stable
         */
        get basicAuthCredentialsInput(): string | undefined;
        private _buildSpec?;
        /**
         * @stability stable
         */
        get buildSpec(): string | undefined;
        /**
         * @stability stable
         */
        set buildSpec(value: string | undefined);
        /**
         * @stability stable
         */
        resetBuildSpec(): void;
        /**
         * @stability stable
         */
        get buildSpecInput(): string | undefined;
        /**
         * @stability stable
         */
        get defaultDomain(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _enableAutoBranchCreation?;
        /**
         * @stability stable
         */
        get enableAutoBranchCreation(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableAutoBranchCreation(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableAutoBranchCreation(): void;
        /**
         * @stability stable
         */
        get enableAutoBranchCreationInput(): boolean | cdktf.IResolvable | undefined;
        private _enableBasicAuth?;
        /**
         * @stability stable
         */
        get enableBasicAuth(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableBasicAuth(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableBasicAuth(): void;
        /**
         * @stability stable
         */
        get enableBasicAuthInput(): boolean | cdktf.IResolvable | undefined;
        private _enableBranchAutoBuild?;
        /**
         * @stability stable
         */
        get enableBranchAutoBuild(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableBranchAutoBuild(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableBranchAutoBuild(): void;
        /**
         * @stability stable
         */
        get enableBranchAutoBuildInput(): boolean | cdktf.IResolvable | undefined;
        private _enableBranchAutoDeletion?;
        /**
         * @stability stable
         */
        get enableBranchAutoDeletion(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableBranchAutoDeletion(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableBranchAutoDeletion(): void;
        /**
         * @stability stable
         */
        get enableBranchAutoDeletionInput(): boolean | cdktf.IResolvable | undefined;
        private _environmentVariables?;
        /**
         * @stability stable
         */
        get environmentVariables(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set environmentVariables(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnvironmentVariables(): void;
        /**
         * @stability stable
         */
        get environmentVariablesInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _iamServiceRoleArn?;
        /**
         * @stability stable
         */
        get iamServiceRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set iamServiceRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetIamServiceRoleArn(): void;
        /**
         * @stability stable
         */
        get iamServiceRoleArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _oauthToken?;
        /**
         * @stability stable
         */
        get oauthToken(): string | undefined;
        /**
         * @stability stable
         */
        set oauthToken(value: string | undefined);
        /**
         * @stability stable
         */
        resetOauthToken(): void;
        /**
         * @stability stable
         */
        get oauthTokenInput(): string | undefined;
        private _platform?;
        /**
         * @stability stable
         */
        get platform(): string | undefined;
        /**
         * @stability stable
         */
        set platform(value: string | undefined);
        /**
         * @stability stable
         */
        resetPlatform(): void;
        /**
         * @stability stable
         */
        get platformInput(): string | undefined;
        /**
         * @stability stable
         */
        productionBranch(index: string): AmplifyAppProductionBranch;
        private _repository?;
        /**
         * @stability stable
         */
        get repository(): string | undefined;
        /**
         * @stability stable
         */
        set repository(value: string | undefined);
        /**
         * @stability stable
         */
        resetRepository(): void;
        /**
         * @stability stable
         */
        get repositoryInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _autoBranchCreationConfig?;
        private __autoBranchCreationConfigOutput;
        /**
         * @stability stable
         */
        get autoBranchCreationConfig(): AmplifyAppAutoBranchCreationConfigOutputReference;
        /**
         * @stability stable
         */
        putAutoBranchCreationConfig(value: AmplifyAppAutoBranchCreationConfig | undefined): void;
        /**
         * @stability stable
         */
        resetAutoBranchCreationConfig(): void;
        /**
         * @stability stable
         */
        get autoBranchCreationConfigInput(): AmplifyAppAutoBranchCreationConfig | undefined;
        private _customRule?;
        /**
         * @stability stable
         */
        get customRule(): AmplifyAppCustomRule[] | undefined;
        /**
         * @stability stable
         */
        set customRule(value: AmplifyAppCustomRule[] | undefined);
        /**
         * @stability stable
         */
        resetCustomRule(): void;
        /**
         * @stability stable
         */
        get customRuleInput(): AmplifyAppCustomRule[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AmplifyBackendEnvironmentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_backend_environment.html#app_id AmplifyBackendEnvironment#app_id}.
         *
         * @stability stable
         */
        readonly appId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_backend_environment.html#deployment_artifacts AmplifyBackendEnvironment#deployment_artifacts}.
         *
         * @stability stable
         */
        readonly deploymentArtifacts?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_backend_environment.html#environment_name AmplifyBackendEnvironment#environment_name}.
         *
         * @stability stable
         */
        readonly environmentName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_backend_environment.html#stack_name AmplifyBackendEnvironment#stack_name}.
         *
         * @stability stable
         */
        readonly stackName?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/amplify_backend_environment.html aws_amplify_backend_environment}.
     *
     * @stability stable
     */
    class AmplifyBackendEnvironment extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/amplify_backend_environment.html aws_amplify_backend_environment} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AmplifyBackendEnvironmentConfig);
        private _appId?;
        /**
         * @stability stable
         */
        get appId(): string;
        /**
         * @stability stable
         */
        set appId(value: string);
        /**
         * @stability stable
         */
        get appIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _deploymentArtifacts?;
        /**
         * @stability stable
         */
        get deploymentArtifacts(): string | undefined;
        /**
         * @stability stable
         */
        set deploymentArtifacts(value: string | undefined);
        /**
         * @stability stable
         */
        resetDeploymentArtifacts(): void;
        /**
         * @stability stable
         */
        get deploymentArtifactsInput(): string | undefined;
        private _environmentName?;
        /**
         * @stability stable
         */
        get environmentName(): string;
        /**
         * @stability stable
         */
        set environmentName(value: string);
        /**
         * @stability stable
         */
        get environmentNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _stackName?;
        /**
         * @stability stable
         */
        get stackName(): string | undefined;
        /**
         * @stability stable
         */
        set stackName(value: string | undefined);
        /**
         * @stability stable
         */
        resetStackName(): void;
        /**
         * @stability stable
         */
        get stackNameInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AmplifyBranchConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#app_id AmplifyBranch#app_id}.
         *
         * @stability stable
         */
        readonly appId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#backend_environment_arn AmplifyBranch#backend_environment_arn}.
         *
         * @stability stable
         */
        readonly backendEnvironmentArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#basic_auth_credentials AmplifyBranch#basic_auth_credentials}.
         *
         * @stability stable
         */
        readonly basicAuthCredentials?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#branch_name AmplifyBranch#branch_name}.
         *
         * @stability stable
         */
        readonly branchName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#description AmplifyBranch#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#display_name AmplifyBranch#display_name}.
         *
         * @stability stable
         */
        readonly displayName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#enable_auto_build AmplifyBranch#enable_auto_build}.
         *
         * @stability stable
         */
        readonly enableAutoBuild?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#enable_basic_auth AmplifyBranch#enable_basic_auth}.
         *
         * @stability stable
         */
        readonly enableBasicAuth?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#enable_notification AmplifyBranch#enable_notification}.
         *
         * @stability stable
         */
        readonly enableNotification?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#enable_performance_mode AmplifyBranch#enable_performance_mode}.
         *
         * @stability stable
         */
        readonly enablePerformanceMode?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#enable_pull_request_preview AmplifyBranch#enable_pull_request_preview}.
         *
         * @stability stable
         */
        readonly enablePullRequestPreview?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#environment_variables AmplifyBranch#environment_variables}.
         *
         * @stability stable
         */
        readonly environmentVariables?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#framework AmplifyBranch#framework}.
         *
         * @stability stable
         */
        readonly framework?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#pull_request_environment_name AmplifyBranch#pull_request_environment_name}.
         *
         * @stability stable
         */
        readonly pullRequestEnvironmentName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#stage AmplifyBranch#stage}.
         *
         * @stability stable
         */
        readonly stage?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#tags AmplifyBranch#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#tags_all AmplifyBranch#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html#ttl AmplifyBranch#ttl}.
         *
         * @stability stable
         */
        readonly ttl?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html aws_amplify_branch}.
     *
     * @stability stable
     */
    class AmplifyBranch extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch.html aws_amplify_branch} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AmplifyBranchConfig);
        private _appId?;
        /**
         * @stability stable
         */
        get appId(): string;
        /**
         * @stability stable
         */
        set appId(value: string);
        /**
         * @stability stable
         */
        get appIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get associatedResources(): string[];
        private _backendEnvironmentArn?;
        /**
         * @stability stable
         */
        get backendEnvironmentArn(): string | undefined;
        /**
         * @stability stable
         */
        set backendEnvironmentArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetBackendEnvironmentArn(): void;
        /**
         * @stability stable
         */
        get backendEnvironmentArnInput(): string | undefined;
        private _basicAuthCredentials?;
        /**
         * @stability stable
         */
        get basicAuthCredentials(): string | undefined;
        /**
         * @stability stable
         */
        set basicAuthCredentials(value: string | undefined);
        /**
         * @stability stable
         */
        resetBasicAuthCredentials(): void;
        /**
         * @stability stable
         */
        get basicAuthCredentialsInput(): string | undefined;
        private _branchName?;
        /**
         * @stability stable
         */
        get branchName(): string;
        /**
         * @stability stable
         */
        set branchName(value: string);
        /**
         * @stability stable
         */
        get branchNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get customDomains(): string[];
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get destinationBranch(): string;
        private _displayName?;
        /**
         * @stability stable
         */
        get displayName(): string | undefined;
        /**
         * @stability stable
         */
        set displayName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDisplayName(): void;
        /**
         * @stability stable
         */
        get displayNameInput(): string | undefined;
        private _enableAutoBuild?;
        /**
         * @stability stable
         */
        get enableAutoBuild(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableAutoBuild(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableAutoBuild(): void;
        /**
         * @stability stable
         */
        get enableAutoBuildInput(): boolean | cdktf.IResolvable | undefined;
        private _enableBasicAuth?;
        /**
         * @stability stable
         */
        get enableBasicAuth(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableBasicAuth(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableBasicAuth(): void;
        /**
         * @stability stable
         */
        get enableBasicAuthInput(): boolean | cdktf.IResolvable | undefined;
        private _enableNotification?;
        /**
         * @stability stable
         */
        get enableNotification(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableNotification(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableNotification(): void;
        /**
         * @stability stable
         */
        get enableNotificationInput(): boolean | cdktf.IResolvable | undefined;
        private _enablePerformanceMode?;
        /**
         * @stability stable
         */
        get enablePerformanceMode(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enablePerformanceMode(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnablePerformanceMode(): void;
        /**
         * @stability stable
         */
        get enablePerformanceModeInput(): boolean | cdktf.IResolvable | undefined;
        private _enablePullRequestPreview?;
        /**
         * @stability stable
         */
        get enablePullRequestPreview(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enablePullRequestPreview(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnablePullRequestPreview(): void;
        /**
         * @stability stable
         */
        get enablePullRequestPreviewInput(): boolean | cdktf.IResolvable | undefined;
        private _environmentVariables?;
        /**
         * @stability stable
         */
        get environmentVariables(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set environmentVariables(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnvironmentVariables(): void;
        /**
         * @stability stable
         */
        get environmentVariablesInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _framework?;
        /**
         * @stability stable
         */
        get framework(): string | undefined;
        /**
         * @stability stable
         */
        set framework(value: string | undefined);
        /**
         * @stability stable
         */
        resetFramework(): void;
        /**
         * @stability stable
         */
        get frameworkInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _pullRequestEnvironmentName?;
        /**
         * @stability stable
         */
        get pullRequestEnvironmentName(): string | undefined;
        /**
         * @stability stable
         */
        set pullRequestEnvironmentName(value: string | undefined);
        /**
         * @stability stable
         */
        resetPullRequestEnvironmentName(): void;
        /**
         * @stability stable
         */
        get pullRequestEnvironmentNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get sourceBranch(): string;
        private _stage?;
        /**
         * @stability stable
         */
        get stage(): string | undefined;
        /**
         * @stability stable
         */
        set stage(value: string | undefined);
        /**
         * @stability stable
         */
        resetStage(): void;
        /**
         * @stability stable
         */
        get stageInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _ttl?;
        /**
         * @stability stable
         */
        get ttl(): string | undefined;
        /**
         * @stability stable
         */
        set ttl(value: string | undefined);
        /**
         * @stability stable
         */
        resetTtl(): void;
        /**
         * @stability stable
         */
        get ttlInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AmplifyDomainAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_domain_association.html#app_id AmplifyDomainAssociation#app_id}.
         *
         * @stability stable
         */
        readonly appId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_domain_association.html#domain_name AmplifyDomainAssociation#domain_name}.
         *
         * @stability stable
         */
        readonly domainName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_domain_association.html#wait_for_verification AmplifyDomainAssociation#wait_for_verification}.
         *
         * @stability stable
         */
        readonly waitForVerification?: boolean | cdktf.IResolvable;
        /**
         * sub_domain block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_domain_association.html#sub_domain AmplifyDomainAssociation#sub_domain}
         *
         * @stability stable
         */
        readonly subDomain: AmplifyDomainAssociationSubDomain[];
    }
    /**
     * @stability stable
     */
    interface AmplifyDomainAssociationSubDomain {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_domain_association.html#branch_name AmplifyDomainAssociation#branch_name}.
         *
         * @stability stable
         */
        readonly branchName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_domain_association.html#prefix AmplifyDomainAssociation#prefix}.
         *
         * @stability stable
         */
        readonly prefix: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/amplify_domain_association.html aws_amplify_domain_association}.
     *
     * @stability stable
     */
    class AmplifyDomainAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/amplify_domain_association.html aws_amplify_domain_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AmplifyDomainAssociationConfig);
        private _appId?;
        /**
         * @stability stable
         */
        get appId(): string;
        /**
         * @stability stable
         */
        set appId(value: string);
        /**
         * @stability stable
         */
        get appIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get certificateVerificationDnsRecord(): string;
        private _domainName?;
        /**
         * @stability stable
         */
        get domainName(): string;
        /**
         * @stability stable
         */
        set domainName(value: string);
        /**
         * @stability stable
         */
        get domainNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _waitForVerification?;
        /**
         * @stability stable
         */
        get waitForVerification(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set waitForVerification(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetWaitForVerification(): void;
        /**
         * @stability stable
         */
        get waitForVerificationInput(): boolean | cdktf.IResolvable | undefined;
        private _subDomain?;
        /**
         * @stability stable
         */
        get subDomain(): AmplifyDomainAssociationSubDomain[];
        /**
         * @stability stable
         */
        set subDomain(value: AmplifyDomainAssociationSubDomain[]);
        /**
         * @stability stable
         */
        get subDomainInput(): AmplifyDomainAssociationSubDomain[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AmplifyWebhookConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_webhook.html#app_id AmplifyWebhook#app_id}.
         *
         * @stability stable
         */
        readonly appId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_webhook.html#branch_name AmplifyWebhook#branch_name}.
         *
         * @stability stable
         */
        readonly branchName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_webhook.html#description AmplifyWebhook#description}.
         *
         * @stability stable
         */
        readonly description?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/amplify_webhook.html aws_amplify_webhook}.
     *
     * @stability stable
     */
    class AmplifyWebhook extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/amplify_webhook.html aws_amplify_webhook} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AmplifyWebhookConfig);
        private _appId?;
        /**
         * @stability stable
         */
        get appId(): string;
        /**
         * @stability stable
         */
        set appId(value: string);
        /**
         * @stability stable
         */
        get appIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _branchName?;
        /**
         * @stability stable
         */
        get branchName(): string;
        /**
         * @stability stable
         */
        set branchName(value: string);
        /**
         * @stability stable
         */
        get branchNameInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get url(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
