import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS AppAutoScaling
*/
export declare namespace AppAutoScaling {
    /**
     * @stability stable
     */
    interface AppautoscalingPolicyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#name AppautoscalingPolicy#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#policy_type AppautoscalingPolicy#policy_type}.
         *
         * @stability stable
         */
        readonly policyType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#resource_id AppautoscalingPolicy#resource_id}.
         *
         * @stability stable
         */
        readonly resourceId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#scalable_dimension AppautoscalingPolicy#scalable_dimension}.
         *
         * @stability stable
         */
        readonly scalableDimension: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#service_namespace AppautoscalingPolicy#service_namespace}.
         *
         * @stability stable
         */
        readonly serviceNamespace: string;
        /**
         * step_scaling_policy_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#step_scaling_policy_configuration AppautoscalingPolicy#step_scaling_policy_configuration}
         *
         * @stability stable
         */
        readonly stepScalingPolicyConfiguration?: AppautoscalingPolicyStepScalingPolicyConfiguration;
        /**
         * target_tracking_scaling_policy_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#target_tracking_scaling_policy_configuration AppautoscalingPolicy#target_tracking_scaling_policy_configuration}
         *
         * @stability stable
         */
        readonly targetTrackingScalingPolicyConfiguration?: AppautoscalingPolicyTargetTrackingScalingPolicyConfiguration;
    }
    /**
     * @stability stable
     */
    interface AppautoscalingPolicyStepScalingPolicyConfigurationStepAdjustment {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#metric_interval_lower_bound AppautoscalingPolicy#metric_interval_lower_bound}.
         *
         * @stability stable
         */
        readonly metricIntervalLowerBound?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#metric_interval_upper_bound AppautoscalingPolicy#metric_interval_upper_bound}.
         *
         * @stability stable
         */
        readonly metricIntervalUpperBound?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#scaling_adjustment AppautoscalingPolicy#scaling_adjustment}.
         *
         * @stability stable
         */
        readonly scalingAdjustment: number;
    }
    /**
     * @stability stable
     */
    interface AppautoscalingPolicyStepScalingPolicyConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#adjustment_type AppautoscalingPolicy#adjustment_type}.
         *
         * @stability stable
         */
        readonly adjustmentType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#cooldown AppautoscalingPolicy#cooldown}.
         *
         * @stability stable
         */
        readonly cooldown?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#metric_aggregation_type AppautoscalingPolicy#metric_aggregation_type}.
         *
         * @stability stable
         */
        readonly metricAggregationType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#min_adjustment_magnitude AppautoscalingPolicy#min_adjustment_magnitude}.
         *
         * @stability stable
         */
        readonly minAdjustmentMagnitude?: number;
        /**
         * step_adjustment block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#step_adjustment AppautoscalingPolicy#step_adjustment}
         *
         * @stability stable
         */
        readonly stepAdjustment?: AppautoscalingPolicyStepScalingPolicyConfigurationStepAdjustment[];
    }
    /**
     * @stability stable
     */
    class AppautoscalingPolicyStepScalingPolicyConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _adjustmentType?;
        /**
         * @stability stable
         */
        get adjustmentType(): string | undefined;
        /**
         * @stability stable
         */
        set adjustmentType(value: string | undefined);
        /**
         * @stability stable
         */
        resetAdjustmentType(): void;
        /**
         * @stability stable
         */
        get adjustmentTypeInput(): string | undefined;
        private _cooldown?;
        /**
         * @stability stable
         */
        get cooldown(): number | undefined;
        /**
         * @stability stable
         */
        set cooldown(value: number | undefined);
        /**
         * @stability stable
         */
        resetCooldown(): void;
        /**
         * @stability stable
         */
        get cooldownInput(): number | undefined;
        private _metricAggregationType?;
        /**
         * @stability stable
         */
        get metricAggregationType(): string | undefined;
        /**
         * @stability stable
         */
        set metricAggregationType(value: string | undefined);
        /**
         * @stability stable
         */
        resetMetricAggregationType(): void;
        /**
         * @stability stable
         */
        get metricAggregationTypeInput(): string | undefined;
        private _minAdjustmentMagnitude?;
        /**
         * @stability stable
         */
        get minAdjustmentMagnitude(): number | undefined;
        /**
         * @stability stable
         */
        set minAdjustmentMagnitude(value: number | undefined);
        /**
         * @stability stable
         */
        resetMinAdjustmentMagnitude(): void;
        /**
         * @stability stable
         */
        get minAdjustmentMagnitudeInput(): number | undefined;
        private _stepAdjustment?;
        /**
         * @stability stable
         */
        get stepAdjustment(): AppautoscalingPolicyStepScalingPolicyConfigurationStepAdjustment[] | undefined;
        /**
         * @stability stable
         */
        set stepAdjustment(value: AppautoscalingPolicyStepScalingPolicyConfigurationStepAdjustment[] | undefined);
        /**
         * @stability stable
         */
        resetStepAdjustment(): void;
        /**
         * @stability stable
         */
        get stepAdjustmentInput(): AppautoscalingPolicyStepScalingPolicyConfigurationStepAdjustment[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationCustomizedMetricSpecificationDimensions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#name AppautoscalingPolicy#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#value AppautoscalingPolicy#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * @stability stable
     */
    interface AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationCustomizedMetricSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#metric_name AppautoscalingPolicy#metric_name}.
         *
         * @stability stable
         */
        readonly metricName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#namespace AppautoscalingPolicy#namespace}.
         *
         * @stability stable
         */
        readonly namespace: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#statistic AppautoscalingPolicy#statistic}.
         *
         * @stability stable
         */
        readonly statistic: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#unit AppautoscalingPolicy#unit}.
         *
         * @stability stable
         */
        readonly unit?: string;
        /**
         * dimensions block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#dimensions AppautoscalingPolicy#dimensions}
         *
         * @stability stable
         */
        readonly dimensions?: AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationCustomizedMetricSpecificationDimensions[];
    }
    /**
     * @stability stable
     */
    class AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationCustomizedMetricSpecificationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _metricName?;
        /**
         * @stability stable
         */
        get metricName(): string;
        /**
         * @stability stable
         */
        set metricName(value: string);
        /**
         * @stability stable
         */
        get metricNameInput(): string | undefined;
        private _namespace?;
        /**
         * @stability stable
         */
        get namespace(): string;
        /**
         * @stability stable
         */
        set namespace(value: string);
        /**
         * @stability stable
         */
        get namespaceInput(): string | undefined;
        private _statistic?;
        /**
         * @stability stable
         */
        get statistic(): string;
        /**
         * @stability stable
         */
        set statistic(value: string);
        /**
         * @stability stable
         */
        get statisticInput(): string | undefined;
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string | undefined;
        /**
         * @stability stable
         */
        set unit(value: string | undefined);
        /**
         * @stability stable
         */
        resetUnit(): void;
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _dimensions?;
        /**
         * @stability stable
         */
        get dimensions(): AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationCustomizedMetricSpecificationDimensions[] | undefined;
        /**
         * @stability stable
         */
        set dimensions(value: AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationCustomizedMetricSpecificationDimensions[] | undefined);
        /**
         * @stability stable
         */
        resetDimensions(): void;
        /**
         * @stability stable
         */
        get dimensionsInput(): AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationCustomizedMetricSpecificationDimensions[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationPredefinedMetricSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#predefined_metric_type AppautoscalingPolicy#predefined_metric_type}.
         *
         * @stability stable
         */
        readonly predefinedMetricType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#resource_label AppautoscalingPolicy#resource_label}.
         *
         * @stability stable
         */
        readonly resourceLabel?: string;
    }
    /**
     * @stability stable
     */
    class AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationPredefinedMetricSpecificationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _predefinedMetricType?;
        /**
         * @stability stable
         */
        get predefinedMetricType(): string;
        /**
         * @stability stable
         */
        set predefinedMetricType(value: string);
        /**
         * @stability stable
         */
        get predefinedMetricTypeInput(): string | undefined;
        private _resourceLabel?;
        /**
         * @stability stable
         */
        get resourceLabel(): string | undefined;
        /**
         * @stability stable
         */
        set resourceLabel(value: string | undefined);
        /**
         * @stability stable
         */
        resetResourceLabel(): void;
        /**
         * @stability stable
         */
        get resourceLabelInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppautoscalingPolicyTargetTrackingScalingPolicyConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#disable_scale_in AppautoscalingPolicy#disable_scale_in}.
         *
         * @stability stable
         */
        readonly disableScaleIn?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#scale_in_cooldown AppautoscalingPolicy#scale_in_cooldown}.
         *
         * @stability stable
         */
        readonly scaleInCooldown?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#scale_out_cooldown AppautoscalingPolicy#scale_out_cooldown}.
         *
         * @stability stable
         */
        readonly scaleOutCooldown?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#target_value AppautoscalingPolicy#target_value}.
         *
         * @stability stable
         */
        readonly targetValue: number;
        /**
         * customized_metric_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#customized_metric_specification AppautoscalingPolicy#customized_metric_specification}
         *
         * @stability stable
         */
        readonly customizedMetricSpecification?: AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationCustomizedMetricSpecification;
        /**
         * predefined_metric_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html#predefined_metric_specification AppautoscalingPolicy#predefined_metric_specification}
         *
         * @stability stable
         */
        readonly predefinedMetricSpecification?: AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationPredefinedMetricSpecification;
    }
    /**
     * @stability stable
     */
    class AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _disableScaleIn?;
        /**
         * @stability stable
         */
        get disableScaleIn(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set disableScaleIn(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDisableScaleIn(): void;
        /**
         * @stability stable
         */
        get disableScaleInInput(): boolean | cdktf.IResolvable | undefined;
        private _scaleInCooldown?;
        /**
         * @stability stable
         */
        get scaleInCooldown(): number | undefined;
        /**
         * @stability stable
         */
        set scaleInCooldown(value: number | undefined);
        /**
         * @stability stable
         */
        resetScaleInCooldown(): void;
        /**
         * @stability stable
         */
        get scaleInCooldownInput(): number | undefined;
        private _scaleOutCooldown?;
        /**
         * @stability stable
         */
        get scaleOutCooldown(): number | undefined;
        /**
         * @stability stable
         */
        set scaleOutCooldown(value: number | undefined);
        /**
         * @stability stable
         */
        resetScaleOutCooldown(): void;
        /**
         * @stability stable
         */
        get scaleOutCooldownInput(): number | undefined;
        private _targetValue?;
        /**
         * @stability stable
         */
        get targetValue(): number;
        /**
         * @stability stable
         */
        set targetValue(value: number);
        /**
         * @stability stable
         */
        get targetValueInput(): number | undefined;
        private _customizedMetricSpecification?;
        private __customizedMetricSpecificationOutput;
        /**
         * @stability stable
         */
        get customizedMetricSpecification(): AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationCustomizedMetricSpecificationOutputReference;
        /**
         * @stability stable
         */
        putCustomizedMetricSpecification(value: AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationCustomizedMetricSpecification | undefined): void;
        /**
         * @stability stable
         */
        resetCustomizedMetricSpecification(): void;
        /**
         * @stability stable
         */
        get customizedMetricSpecificationInput(): AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationCustomizedMetricSpecification | undefined;
        private _predefinedMetricSpecification?;
        private __predefinedMetricSpecificationOutput;
        /**
         * @stability stable
         */
        get predefinedMetricSpecification(): AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationPredefinedMetricSpecificationOutputReference;
        /**
         * @stability stable
         */
        putPredefinedMetricSpecification(value: AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationPredefinedMetricSpecification | undefined): void;
        /**
         * @stability stable
         */
        resetPredefinedMetricSpecification(): void;
        /**
         * @stability stable
         */
        get predefinedMetricSpecificationInput(): AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationPredefinedMetricSpecification | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html aws_appautoscaling_policy}.
     *
     * @stability stable
     */
    class AppautoscalingPolicy extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_policy.html aws_appautoscaling_policy} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AppautoscalingPolicyConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _policyType?;
        /**
         * @stability stable
         */
        get policyType(): string | undefined;
        /**
         * @stability stable
         */
        set policyType(value: string | undefined);
        /**
         * @stability stable
         */
        resetPolicyType(): void;
        /**
         * @stability stable
         */
        get policyTypeInput(): string | undefined;
        private _resourceId?;
        /**
         * @stability stable
         */
        get resourceId(): string;
        /**
         * @stability stable
         */
        set resourceId(value: string);
        /**
         * @stability stable
         */
        get resourceIdInput(): string | undefined;
        private _scalableDimension?;
        /**
         * @stability stable
         */
        get scalableDimension(): string;
        /**
         * @stability stable
         */
        set scalableDimension(value: string);
        /**
         * @stability stable
         */
        get scalableDimensionInput(): string | undefined;
        private _serviceNamespace?;
        /**
         * @stability stable
         */
        get serviceNamespace(): string;
        /**
         * @stability stable
         */
        set serviceNamespace(value: string);
        /**
         * @stability stable
         */
        get serviceNamespaceInput(): string | undefined;
        private _stepScalingPolicyConfiguration?;
        private __stepScalingPolicyConfigurationOutput;
        /**
         * @stability stable
         */
        get stepScalingPolicyConfiguration(): AppautoscalingPolicyStepScalingPolicyConfigurationOutputReference;
        /**
         * @stability stable
         */
        putStepScalingPolicyConfiguration(value: AppautoscalingPolicyStepScalingPolicyConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetStepScalingPolicyConfiguration(): void;
        /**
         * @stability stable
         */
        get stepScalingPolicyConfigurationInput(): AppautoscalingPolicyStepScalingPolicyConfiguration | undefined;
        private _targetTrackingScalingPolicyConfiguration?;
        private __targetTrackingScalingPolicyConfigurationOutput;
        /**
         * @stability stable
         */
        get targetTrackingScalingPolicyConfiguration(): AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationOutputReference;
        /**
         * @stability stable
         */
        putTargetTrackingScalingPolicyConfiguration(value: AppautoscalingPolicyTargetTrackingScalingPolicyConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetTargetTrackingScalingPolicyConfiguration(): void;
        /**
         * @stability stable
         */
        get targetTrackingScalingPolicyConfigurationInput(): AppautoscalingPolicyTargetTrackingScalingPolicyConfiguration | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AppautoscalingScheduledActionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_scheduled_action.html#end_time AppautoscalingScheduledAction#end_time}.
         *
         * @stability stable
         */
        readonly endTime?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_scheduled_action.html#name AppautoscalingScheduledAction#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_scheduled_action.html#resource_id AppautoscalingScheduledAction#resource_id}.
         *
         * @stability stable
         */
        readonly resourceId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_scheduled_action.html#scalable_dimension AppautoscalingScheduledAction#scalable_dimension}.
         *
         * @stability stable
         */
        readonly scalableDimension: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_scheduled_action.html#schedule AppautoscalingScheduledAction#schedule}.
         *
         * @stability stable
         */
        readonly schedule: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_scheduled_action.html#service_namespace AppautoscalingScheduledAction#service_namespace}.
         *
         * @stability stable
         */
        readonly serviceNamespace: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_scheduled_action.html#start_time AppautoscalingScheduledAction#start_time}.
         *
         * @stability stable
         */
        readonly startTime?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_scheduled_action.html#timezone AppautoscalingScheduledAction#timezone}.
         *
         * @stability stable
         */
        readonly timezone?: string;
        /**
         * scalable_target_action block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_scheduled_action.html#scalable_target_action AppautoscalingScheduledAction#scalable_target_action}
         *
         * @stability stable
         */
        readonly scalableTargetAction: AppautoscalingScheduledActionScalableTargetAction;
    }
    /**
     * @stability stable
     */
    interface AppautoscalingScheduledActionScalableTargetAction {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_scheduled_action.html#max_capacity AppautoscalingScheduledAction#max_capacity}.
         *
         * @stability stable
         */
        readonly maxCapacity?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_scheduled_action.html#min_capacity AppautoscalingScheduledAction#min_capacity}.
         *
         * @stability stable
         */
        readonly minCapacity?: string;
    }
    /**
     * @stability stable
     */
    class AppautoscalingScheduledActionScalableTargetActionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _maxCapacity?;
        /**
         * @stability stable
         */
        get maxCapacity(): string | undefined;
        /**
         * @stability stable
         */
        set maxCapacity(value: string | undefined);
        /**
         * @stability stable
         */
        resetMaxCapacity(): void;
        /**
         * @stability stable
         */
        get maxCapacityInput(): string | undefined;
        private _minCapacity?;
        /**
         * @stability stable
         */
        get minCapacity(): string | undefined;
        /**
         * @stability stable
         */
        set minCapacity(value: string | undefined);
        /**
         * @stability stable
         */
        resetMinCapacity(): void;
        /**
         * @stability stable
         */
        get minCapacityInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_scheduled_action.html aws_appautoscaling_scheduled_action}.
     *
     * @stability stable
     */
    class AppautoscalingScheduledAction extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_scheduled_action.html aws_appautoscaling_scheduled_action} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AppautoscalingScheduledActionConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _endTime?;
        /**
         * @stability stable
         */
        get endTime(): string | undefined;
        /**
         * @stability stable
         */
        set endTime(value: string | undefined);
        /**
         * @stability stable
         */
        resetEndTime(): void;
        /**
         * @stability stable
         */
        get endTimeInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _resourceId?;
        /**
         * @stability stable
         */
        get resourceId(): string;
        /**
         * @stability stable
         */
        set resourceId(value: string);
        /**
         * @stability stable
         */
        get resourceIdInput(): string | undefined;
        private _scalableDimension?;
        /**
         * @stability stable
         */
        get scalableDimension(): string;
        /**
         * @stability stable
         */
        set scalableDimension(value: string);
        /**
         * @stability stable
         */
        get scalableDimensionInput(): string | undefined;
        private _schedule?;
        /**
         * @stability stable
         */
        get schedule(): string;
        /**
         * @stability stable
         */
        set schedule(value: string);
        /**
         * @stability stable
         */
        get scheduleInput(): string | undefined;
        private _serviceNamespace?;
        /**
         * @stability stable
         */
        get serviceNamespace(): string;
        /**
         * @stability stable
         */
        set serviceNamespace(value: string);
        /**
         * @stability stable
         */
        get serviceNamespaceInput(): string | undefined;
        private _startTime?;
        /**
         * @stability stable
         */
        get startTime(): string | undefined;
        /**
         * @stability stable
         */
        set startTime(value: string | undefined);
        /**
         * @stability stable
         */
        resetStartTime(): void;
        /**
         * @stability stable
         */
        get startTimeInput(): string | undefined;
        private _timezone?;
        /**
         * @stability stable
         */
        get timezone(): string | undefined;
        /**
         * @stability stable
         */
        set timezone(value: string | undefined);
        /**
         * @stability stable
         */
        resetTimezone(): void;
        /**
         * @stability stable
         */
        get timezoneInput(): string | undefined;
        private _scalableTargetAction?;
        private __scalableTargetActionOutput;
        /**
         * @stability stable
         */
        get scalableTargetAction(): AppautoscalingScheduledActionScalableTargetActionOutputReference;
        /**
         * @stability stable
         */
        putScalableTargetAction(value: AppautoscalingScheduledActionScalableTargetAction): void;
        /**
         * @stability stable
         */
        get scalableTargetActionInput(): AppautoscalingScheduledActionScalableTargetAction | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AppautoscalingTargetConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_target.html#max_capacity AppautoscalingTarget#max_capacity}.
         *
         * @stability stable
         */
        readonly maxCapacity: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_target.html#min_capacity AppautoscalingTarget#min_capacity}.
         *
         * @stability stable
         */
        readonly minCapacity: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_target.html#resource_id AppautoscalingTarget#resource_id}.
         *
         * @stability stable
         */
        readonly resourceId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_target.html#role_arn AppautoscalingTarget#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_target.html#scalable_dimension AppautoscalingTarget#scalable_dimension}.
         *
         * @stability stable
         */
        readonly scalableDimension: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_target.html#service_namespace AppautoscalingTarget#service_namespace}.
         *
         * @stability stable
         */
        readonly serviceNamespace: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_target.html aws_appautoscaling_target}.
     *
     * @stability stable
     */
    class AppautoscalingTarget extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appautoscaling_target.html aws_appautoscaling_target} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AppautoscalingTargetConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _maxCapacity?;
        /**
         * @stability stable
         */
        get maxCapacity(): number;
        /**
         * @stability stable
         */
        set maxCapacity(value: number);
        /**
         * @stability stable
         */
        get maxCapacityInput(): number | undefined;
        private _minCapacity?;
        /**
         * @stability stable
         */
        get minCapacity(): number;
        /**
         * @stability stable
         */
        set minCapacity(value: number);
        /**
         * @stability stable
         */
        get minCapacityInput(): number | undefined;
        private _resourceId?;
        /**
         * @stability stable
         */
        get resourceId(): string;
        /**
         * @stability stable
         */
        set resourceId(value: string);
        /**
         * @stability stable
         */
        get resourceIdInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string | undefined;
        /**
         * @stability stable
         */
        set roleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetRoleArn(): void;
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        private _scalableDimension?;
        /**
         * @stability stable
         */
        get scalableDimension(): string;
        /**
         * @stability stable
         */
        set scalableDimension(value: string);
        /**
         * @stability stable
         */
        get scalableDimensionInput(): string | undefined;
        private _serviceNamespace?;
        /**
         * @stability stable
         */
        get serviceNamespace(): string;
        /**
         * @stability stable
         */
        set serviceNamespace(value: string);
        /**
         * @stability stable
         */
        get serviceNamespaceInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
