import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* App Runner
*/
export declare namespace AppRunner {
    /**
     * @stability stable
     */
    interface ApprunnerAutoScalingConfigurationVersionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_auto_scaling_configuration_version.html#auto_scaling_configuration_name ApprunnerAutoScalingConfigurationVersion#auto_scaling_configuration_name}.
         *
         * @stability stable
         */
        readonly autoScalingConfigurationName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_auto_scaling_configuration_version.html#max_concurrency ApprunnerAutoScalingConfigurationVersion#max_concurrency}.
         *
         * @stability stable
         */
        readonly maxConcurrency?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_auto_scaling_configuration_version.html#max_size ApprunnerAutoScalingConfigurationVersion#max_size}.
         *
         * @stability stable
         */
        readonly maxSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_auto_scaling_configuration_version.html#min_size ApprunnerAutoScalingConfigurationVersion#min_size}.
         *
         * @stability stable
         */
        readonly minSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_auto_scaling_configuration_version.html#tags ApprunnerAutoScalingConfigurationVersion#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_auto_scaling_configuration_version.html#tags_all ApprunnerAutoScalingConfigurationVersion#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apprunner_auto_scaling_configuration_version.html aws_apprunner_auto_scaling_configuration_version}.
     *
     * @stability stable
     */
    class ApprunnerAutoScalingConfigurationVersion extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apprunner_auto_scaling_configuration_version.html aws_apprunner_auto_scaling_configuration_version} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ApprunnerAutoScalingConfigurationVersionConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoScalingConfigurationName?;
        /**
         * @stability stable
         */
        get autoScalingConfigurationName(): string;
        /**
         * @stability stable
         */
        set autoScalingConfigurationName(value: string);
        /**
         * @stability stable
         */
        get autoScalingConfigurationNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get autoScalingConfigurationRevision(): number;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get latest(): any;
        private _maxConcurrency?;
        /**
         * @stability stable
         */
        get maxConcurrency(): number | undefined;
        /**
         * @stability stable
         */
        set maxConcurrency(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaxConcurrency(): void;
        /**
         * @stability stable
         */
        get maxConcurrencyInput(): number | undefined;
        private _maxSize?;
        /**
         * @stability stable
         */
        get maxSize(): number | undefined;
        /**
         * @stability stable
         */
        set maxSize(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaxSize(): void;
        /**
         * @stability stable
         */
        get maxSizeInput(): number | undefined;
        private _minSize?;
        /**
         * @stability stable
         */
        get minSize(): number | undefined;
        /**
         * @stability stable
         */
        set minSize(value: number | undefined);
        /**
         * @stability stable
         */
        resetMinSize(): void;
        /**
         * @stability stable
         */
        get minSizeInput(): number | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ApprunnerConnectionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_connection.html#connection_name ApprunnerConnection#connection_name}.
         *
         * @stability stable
         */
        readonly connectionName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_connection.html#provider_type ApprunnerConnection#provider_type}.
         *
         * @stability stable
         */
        readonly providerType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_connection.html#tags ApprunnerConnection#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_connection.html#tags_all ApprunnerConnection#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apprunner_connection.html aws_apprunner_connection}.
     *
     * @stability stable
     */
    class ApprunnerConnection extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apprunner_connection.html aws_apprunner_connection} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ApprunnerConnectionConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _connectionName?;
        /**
         * @stability stable
         */
        get connectionName(): string;
        /**
         * @stability stable
         */
        set connectionName(value: string);
        /**
         * @stability stable
         */
        get connectionNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _providerType?;
        /**
         * @stability stable
         */
        get providerType(): string;
        /**
         * @stability stable
         */
        set providerType(value: string);
        /**
         * @stability stable
         */
        get providerTypeInput(): string | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ApprunnerCustomDomainAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_custom_domain_association.html#domain_name ApprunnerCustomDomainAssociation#domain_name}.
         *
         * @stability stable
         */
        readonly domainName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_custom_domain_association.html#enable_www_subdomain ApprunnerCustomDomainAssociation#enable_www_subdomain}.
         *
         * @stability stable
         */
        readonly enableWwwSubdomain?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_custom_domain_association.html#service_arn ApprunnerCustomDomainAssociation#service_arn}.
         *
         * @stability stable
         */
        readonly serviceArn: string;
    }
    /**
     * @stability stable
     */
    class ApprunnerCustomDomainAssociationCertificateValidationRecords extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        get value(): string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apprunner_custom_domain_association.html aws_apprunner_custom_domain_association}.
     *
     * @stability stable
     */
    class ApprunnerCustomDomainAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apprunner_custom_domain_association.html aws_apprunner_custom_domain_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ApprunnerCustomDomainAssociationConfig);
        /**
         * @stability stable
         */
        certificateValidationRecords(index: string): ApprunnerCustomDomainAssociationCertificateValidationRecords;
        /**
         * @stability stable
         */
        get dnsTarget(): string;
        private _domainName?;
        /**
         * @stability stable
         */
        get domainName(): string;
        /**
         * @stability stable
         */
        set domainName(value: string);
        /**
         * @stability stable
         */
        get domainNameInput(): string | undefined;
        private _enableWwwSubdomain?;
        /**
         * @stability stable
         */
        get enableWwwSubdomain(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableWwwSubdomain(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableWwwSubdomain(): void;
        /**
         * @stability stable
         */
        get enableWwwSubdomainInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _serviceArn?;
        /**
         * @stability stable
         */
        get serviceArn(): string;
        /**
         * @stability stable
         */
        set serviceArn(value: string);
        /**
         * @stability stable
         */
        get serviceArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ApprunnerServiceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#auto_scaling_configuration_arn ApprunnerService#auto_scaling_configuration_arn}.
         *
         * @stability stable
         */
        readonly autoScalingConfigurationArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#service_name ApprunnerService#service_name}.
         *
         * @stability stable
         */
        readonly serviceName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#tags ApprunnerService#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#tags_all ApprunnerService#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * encryption_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#encryption_configuration ApprunnerService#encryption_configuration}
         *
         * @stability stable
         */
        readonly encryptionConfiguration?: ApprunnerServiceEncryptionConfiguration;
        /**
         * health_check_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#health_check_configuration ApprunnerService#health_check_configuration}
         *
         * @stability stable
         */
        readonly healthCheckConfiguration?: ApprunnerServiceHealthCheckConfiguration;
        /**
         * instance_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#instance_configuration ApprunnerService#instance_configuration}
         *
         * @stability stable
         */
        readonly instanceConfiguration?: ApprunnerServiceInstanceConfiguration;
        /**
         * source_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#source_configuration ApprunnerService#source_configuration}
         *
         * @stability stable
         */
        readonly sourceConfiguration: ApprunnerServiceSourceConfiguration;
    }
    /**
     * @stability stable
     */
    interface ApprunnerServiceEncryptionConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#kms_key ApprunnerService#kms_key}.
         *
         * @stability stable
         */
        readonly kmsKey: string;
    }
    /**
     * @stability stable
     */
    class ApprunnerServiceEncryptionConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _kmsKey?;
        /**
         * @stability stable
         */
        get kmsKey(): string;
        /**
         * @stability stable
         */
        set kmsKey(value: string);
        /**
         * @stability stable
         */
        get kmsKeyInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface ApprunnerServiceHealthCheckConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#healthy_threshold ApprunnerService#healthy_threshold}.
         *
         * @stability stable
         */
        readonly healthyThreshold?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#interval ApprunnerService#interval}.
         *
         * @stability stable
         */
        readonly interval?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#path ApprunnerService#path}.
         *
         * @stability stable
         */
        readonly path?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#protocol ApprunnerService#protocol}.
         *
         * @stability stable
         */
        readonly protocol?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#timeout ApprunnerService#timeout}.
         *
         * @stability stable
         */
        readonly timeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#unhealthy_threshold ApprunnerService#unhealthy_threshold}.
         *
         * @stability stable
         */
        readonly unhealthyThreshold?: number;
    }
    /**
     * @stability stable
     */
    class ApprunnerServiceHealthCheckConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _healthyThreshold?;
        /**
         * @stability stable
         */
        get healthyThreshold(): number | undefined;
        /**
         * @stability stable
         */
        set healthyThreshold(value: number | undefined);
        /**
         * @stability stable
         */
        resetHealthyThreshold(): void;
        /**
         * @stability stable
         */
        get healthyThresholdInput(): number | undefined;
        private _interval?;
        /**
         * @stability stable
         */
        get interval(): number | undefined;
        /**
         * @stability stable
         */
        set interval(value: number | undefined);
        /**
         * @stability stable
         */
        resetInterval(): void;
        /**
         * @stability stable
         */
        get intervalInput(): number | undefined;
        private _path?;
        /**
         * @stability stable
         */
        get path(): string | undefined;
        /**
         * @stability stable
         */
        set path(value: string | undefined);
        /**
         * @stability stable
         */
        resetPath(): void;
        /**
         * @stability stable
         */
        get pathInput(): string | undefined;
        private _protocol?;
        /**
         * @stability stable
         */
        get protocol(): string | undefined;
        /**
         * @stability stable
         */
        set protocol(value: string | undefined);
        /**
         * @stability stable
         */
        resetProtocol(): void;
        /**
         * @stability stable
         */
        get protocolInput(): string | undefined;
        private _timeout?;
        /**
         * @stability stable
         */
        get timeout(): number | undefined;
        /**
         * @stability stable
         */
        set timeout(value: number | undefined);
        /**
         * @stability stable
         */
        resetTimeout(): void;
        /**
         * @stability stable
         */
        get timeoutInput(): number | undefined;
        private _unhealthyThreshold?;
        /**
         * @stability stable
         */
        get unhealthyThreshold(): number | undefined;
        /**
         * @stability stable
         */
        set unhealthyThreshold(value: number | undefined);
        /**
         * @stability stable
         */
        resetUnhealthyThreshold(): void;
        /**
         * @stability stable
         */
        get unhealthyThresholdInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface ApprunnerServiceInstanceConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#cpu ApprunnerService#cpu}.
         *
         * @stability stable
         */
        readonly cpu?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#instance_role_arn ApprunnerService#instance_role_arn}.
         *
         * @stability stable
         */
        readonly instanceRoleArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#memory ApprunnerService#memory}.
         *
         * @stability stable
         */
        readonly memory?: string;
    }
    /**
     * @stability stable
     */
    class ApprunnerServiceInstanceConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _cpu?;
        /**
         * @stability stable
         */
        get cpu(): string | undefined;
        /**
         * @stability stable
         */
        set cpu(value: string | undefined);
        /**
         * @stability stable
         */
        resetCpu(): void;
        /**
         * @stability stable
         */
        get cpuInput(): string | undefined;
        private _instanceRoleArn?;
        /**
         * @stability stable
         */
        get instanceRoleArn(): string;
        /**
         * @stability stable
         */
        set instanceRoleArn(value: string);
        /**
         * @stability stable
         */
        get instanceRoleArnInput(): string | undefined;
        private _memory?;
        /**
         * @stability stable
         */
        get memory(): string | undefined;
        /**
         * @stability stable
         */
        set memory(value: string | undefined);
        /**
         * @stability stable
         */
        resetMemory(): void;
        /**
         * @stability stable
         */
        get memoryInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface ApprunnerServiceSourceConfigurationAuthenticationConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#access_role_arn ApprunnerService#access_role_arn}.
         *
         * @stability stable
         */
        readonly accessRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#connection_arn ApprunnerService#connection_arn}.
         *
         * @stability stable
         */
        readonly connectionArn?: string;
    }
    /**
     * @stability stable
     */
    class ApprunnerServiceSourceConfigurationAuthenticationConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _accessRoleArn?;
        /**
         * @stability stable
         */
        get accessRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set accessRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetAccessRoleArn(): void;
        /**
         * @stability stable
         */
        get accessRoleArnInput(): string | undefined;
        private _connectionArn?;
        /**
         * @stability stable
         */
        get connectionArn(): string | undefined;
        /**
         * @stability stable
         */
        set connectionArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetConnectionArn(): void;
        /**
         * @stability stable
         */
        get connectionArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface ApprunnerServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValues {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#build_command ApprunnerService#build_command}.
         *
         * @stability stable
         */
        readonly buildCommand?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#port ApprunnerService#port}.
         *
         * @stability stable
         */
        readonly port?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#runtime ApprunnerService#runtime}.
         *
         * @stability stable
         */
        readonly runtime: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#runtime_environment_variables ApprunnerService#runtime_environment_variables}.
         *
         * @stability stable
         */
        readonly runtimeEnvironmentVariables?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#start_command ApprunnerService#start_command}.
         *
         * @stability stable
         */
        readonly startCommand?: string;
    }
    /**
     * @stability stable
     */
    class ApprunnerServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValuesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _buildCommand?;
        /**
         * @stability stable
         */
        get buildCommand(): string | undefined;
        /**
         * @stability stable
         */
        set buildCommand(value: string | undefined);
        /**
         * @stability stable
         */
        resetBuildCommand(): void;
        /**
         * @stability stable
         */
        get buildCommandInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): string | undefined;
        /**
         * @stability stable
         */
        set port(value: string | undefined);
        /**
         * @stability stable
         */
        resetPort(): void;
        /**
         * @stability stable
         */
        get portInput(): string | undefined;
        private _runtime?;
        /**
         * @stability stable
         */
        get runtime(): string;
        /**
         * @stability stable
         */
        set runtime(value: string);
        /**
         * @stability stable
         */
        get runtimeInput(): string | undefined;
        private _runtimeEnvironmentVariables?;
        /**
         * @stability stable
         */
        get runtimeEnvironmentVariables(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set runtimeEnvironmentVariables(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetRuntimeEnvironmentVariables(): void;
        /**
         * @stability stable
         */
        get runtimeEnvironmentVariablesInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _startCommand?;
        /**
         * @stability stable
         */
        get startCommand(): string | undefined;
        /**
         * @stability stable
         */
        set startCommand(value: string | undefined);
        /**
         * @stability stable
         */
        resetStartCommand(): void;
        /**
         * @stability stable
         */
        get startCommandInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface ApprunnerServiceSourceConfigurationCodeRepositoryCodeConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#configuration_source ApprunnerService#configuration_source}.
         *
         * @stability stable
         */
        readonly configurationSource: string;
        /**
         * code_configuration_values block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#code_configuration_values ApprunnerService#code_configuration_values}
         *
         * @stability stable
         */
        readonly codeConfigurationValues?: ApprunnerServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValues;
    }
    /**
     * @stability stable
     */
    class ApprunnerServiceSourceConfigurationCodeRepositoryCodeConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _configurationSource?;
        /**
         * @stability stable
         */
        get configurationSource(): string;
        /**
         * @stability stable
         */
        set configurationSource(value: string);
        /**
         * @stability stable
         */
        get configurationSourceInput(): string | undefined;
        private _codeConfigurationValues?;
        private __codeConfigurationValuesOutput;
        /**
         * @stability stable
         */
        get codeConfigurationValues(): ApprunnerServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValuesOutputReference;
        /**
         * @stability stable
         */
        putCodeConfigurationValues(value: ApprunnerServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValues | undefined): void;
        /**
         * @stability stable
         */
        resetCodeConfigurationValues(): void;
        /**
         * @stability stable
         */
        get codeConfigurationValuesInput(): ApprunnerServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValues | undefined;
    }
    /**
     * @stability stable
     */
    interface ApprunnerServiceSourceConfigurationCodeRepositorySourceCodeVersion {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#type ApprunnerService#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#value ApprunnerService#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * @stability stable
     */
    class ApprunnerServiceSourceConfigurationCodeRepositorySourceCodeVersionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): string;
        /**
         * @stability stable
         */
        set value(value: string);
        /**
         * @stability stable
         */
        get valueInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface ApprunnerServiceSourceConfigurationCodeRepository {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#repository_url ApprunnerService#repository_url}.
         *
         * @stability stable
         */
        readonly repositoryUrl: string;
        /**
         * code_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#code_configuration ApprunnerService#code_configuration}
         *
         * @stability stable
         */
        readonly codeConfiguration?: ApprunnerServiceSourceConfigurationCodeRepositoryCodeConfiguration;
        /**
         * source_code_version block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#source_code_version ApprunnerService#source_code_version}
         *
         * @stability stable
         */
        readonly sourceCodeVersion: ApprunnerServiceSourceConfigurationCodeRepositorySourceCodeVersion;
    }
    /**
     * @stability stable
     */
    class ApprunnerServiceSourceConfigurationCodeRepositoryOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _repositoryUrl?;
        /**
         * @stability stable
         */
        get repositoryUrl(): string;
        /**
         * @stability stable
         */
        set repositoryUrl(value: string);
        /**
         * @stability stable
         */
        get repositoryUrlInput(): string | undefined;
        private _codeConfiguration?;
        private __codeConfigurationOutput;
        /**
         * @stability stable
         */
        get codeConfiguration(): ApprunnerServiceSourceConfigurationCodeRepositoryCodeConfigurationOutputReference;
        /**
         * @stability stable
         */
        putCodeConfiguration(value: ApprunnerServiceSourceConfigurationCodeRepositoryCodeConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetCodeConfiguration(): void;
        /**
         * @stability stable
         */
        get codeConfigurationInput(): ApprunnerServiceSourceConfigurationCodeRepositoryCodeConfiguration | undefined;
        private _sourceCodeVersion?;
        private __sourceCodeVersionOutput;
        /**
         * @stability stable
         */
        get sourceCodeVersion(): ApprunnerServiceSourceConfigurationCodeRepositorySourceCodeVersionOutputReference;
        /**
         * @stability stable
         */
        putSourceCodeVersion(value: ApprunnerServiceSourceConfigurationCodeRepositorySourceCodeVersion): void;
        /**
         * @stability stable
         */
        get sourceCodeVersionInput(): ApprunnerServiceSourceConfigurationCodeRepositorySourceCodeVersion | undefined;
    }
    /**
     * @stability stable
     */
    interface ApprunnerServiceSourceConfigurationImageRepositoryImageConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#port ApprunnerService#port}.
         *
         * @stability stable
         */
        readonly port?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#runtime_environment_variables ApprunnerService#runtime_environment_variables}.
         *
         * @stability stable
         */
        readonly runtimeEnvironmentVariables?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#start_command ApprunnerService#start_command}.
         *
         * @stability stable
         */
        readonly startCommand?: string;
    }
    /**
     * @stability stable
     */
    class ApprunnerServiceSourceConfigurationImageRepositoryImageConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _port?;
        /**
         * @stability stable
         */
        get port(): string | undefined;
        /**
         * @stability stable
         */
        set port(value: string | undefined);
        /**
         * @stability stable
         */
        resetPort(): void;
        /**
         * @stability stable
         */
        get portInput(): string | undefined;
        private _runtimeEnvironmentVariables?;
        /**
         * @stability stable
         */
        get runtimeEnvironmentVariables(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set runtimeEnvironmentVariables(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetRuntimeEnvironmentVariables(): void;
        /**
         * @stability stable
         */
        get runtimeEnvironmentVariablesInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _startCommand?;
        /**
         * @stability stable
         */
        get startCommand(): string | undefined;
        /**
         * @stability stable
         */
        set startCommand(value: string | undefined);
        /**
         * @stability stable
         */
        resetStartCommand(): void;
        /**
         * @stability stable
         */
        get startCommandInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface ApprunnerServiceSourceConfigurationImageRepository {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#image_identifier ApprunnerService#image_identifier}.
         *
         * @stability stable
         */
        readonly imageIdentifier: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#image_repository_type ApprunnerService#image_repository_type}.
         *
         * @stability stable
         */
        readonly imageRepositoryType: string;
        /**
         * image_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#image_configuration ApprunnerService#image_configuration}
         *
         * @stability stable
         */
        readonly imageConfiguration?: ApprunnerServiceSourceConfigurationImageRepositoryImageConfiguration;
    }
    /**
     * @stability stable
     */
    class ApprunnerServiceSourceConfigurationImageRepositoryOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _imageIdentifier?;
        /**
         * @stability stable
         */
        get imageIdentifier(): string;
        /**
         * @stability stable
         */
        set imageIdentifier(value: string);
        /**
         * @stability stable
         */
        get imageIdentifierInput(): string | undefined;
        private _imageRepositoryType?;
        /**
         * @stability stable
         */
        get imageRepositoryType(): string;
        /**
         * @stability stable
         */
        set imageRepositoryType(value: string);
        /**
         * @stability stable
         */
        get imageRepositoryTypeInput(): string | undefined;
        private _imageConfiguration?;
        private __imageConfigurationOutput;
        /**
         * @stability stable
         */
        get imageConfiguration(): ApprunnerServiceSourceConfigurationImageRepositoryImageConfigurationOutputReference;
        /**
         * @stability stable
         */
        putImageConfiguration(value: ApprunnerServiceSourceConfigurationImageRepositoryImageConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetImageConfiguration(): void;
        /**
         * @stability stable
         */
        get imageConfigurationInput(): ApprunnerServiceSourceConfigurationImageRepositoryImageConfiguration | undefined;
    }
    /**
     * @stability stable
     */
    interface ApprunnerServiceSourceConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#auto_deployments_enabled ApprunnerService#auto_deployments_enabled}.
         *
         * @stability stable
         */
        readonly autoDeploymentsEnabled?: boolean | cdktf.IResolvable;
        /**
         * authentication_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#authentication_configuration ApprunnerService#authentication_configuration}
         *
         * @stability stable
         */
        readonly authenticationConfiguration?: ApprunnerServiceSourceConfigurationAuthenticationConfiguration;
        /**
         * code_repository block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#code_repository ApprunnerService#code_repository}
         *
         * @stability stable
         */
        readonly codeRepository?: ApprunnerServiceSourceConfigurationCodeRepository;
        /**
         * image_repository block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#image_repository ApprunnerService#image_repository}
         *
         * @stability stable
         */
        readonly imageRepository?: ApprunnerServiceSourceConfigurationImageRepository;
    }
    /**
     * @stability stable
     */
    class ApprunnerServiceSourceConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _autoDeploymentsEnabled?;
        /**
         * @stability stable
         */
        get autoDeploymentsEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoDeploymentsEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoDeploymentsEnabled(): void;
        /**
         * @stability stable
         */
        get autoDeploymentsEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _authenticationConfiguration?;
        private __authenticationConfigurationOutput;
        /**
         * @stability stable
         */
        get authenticationConfiguration(): ApprunnerServiceSourceConfigurationAuthenticationConfigurationOutputReference;
        /**
         * @stability stable
         */
        putAuthenticationConfiguration(value: ApprunnerServiceSourceConfigurationAuthenticationConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetAuthenticationConfiguration(): void;
        /**
         * @stability stable
         */
        get authenticationConfigurationInput(): ApprunnerServiceSourceConfigurationAuthenticationConfiguration | undefined;
        private _codeRepository?;
        private __codeRepositoryOutput;
        /**
         * @stability stable
         */
        get codeRepository(): ApprunnerServiceSourceConfigurationCodeRepositoryOutputReference;
        /**
         * @stability stable
         */
        putCodeRepository(value: ApprunnerServiceSourceConfigurationCodeRepository | undefined): void;
        /**
         * @stability stable
         */
        resetCodeRepository(): void;
        /**
         * @stability stable
         */
        get codeRepositoryInput(): ApprunnerServiceSourceConfigurationCodeRepository | undefined;
        private _imageRepository?;
        private __imageRepositoryOutput;
        /**
         * @stability stable
         */
        get imageRepository(): ApprunnerServiceSourceConfigurationImageRepositoryOutputReference;
        /**
         * @stability stable
         */
        putImageRepository(value: ApprunnerServiceSourceConfigurationImageRepository | undefined): void;
        /**
         * @stability stable
         */
        resetImageRepository(): void;
        /**
         * @stability stable
         */
        get imageRepositoryInput(): ApprunnerServiceSourceConfigurationImageRepository | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html aws_apprunner_service}.
     *
     * @stability stable
     */
    class ApprunnerService extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html aws_apprunner_service} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ApprunnerServiceConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoScalingConfigurationArn?;
        /**
         * @stability stable
         */
        get autoScalingConfigurationArn(): string | undefined;
        /**
         * @stability stable
         */
        set autoScalingConfigurationArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetAutoScalingConfigurationArn(): void;
        /**
         * @stability stable
         */
        get autoScalingConfigurationArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get serviceId(): string;
        private _serviceName?;
        /**
         * @stability stable
         */
        get serviceName(): string;
        /**
         * @stability stable
         */
        set serviceName(value: string);
        /**
         * @stability stable
         */
        get serviceNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get serviceUrl(): string;
        /**
         * @stability stable
         */
        get status(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _encryptionConfiguration?;
        private __encryptionConfigurationOutput;
        /**
         * @stability stable
         */
        get encryptionConfiguration(): ApprunnerServiceEncryptionConfigurationOutputReference;
        /**
         * @stability stable
         */
        putEncryptionConfiguration(value: ApprunnerServiceEncryptionConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetEncryptionConfiguration(): void;
        /**
         * @stability stable
         */
        get encryptionConfigurationInput(): ApprunnerServiceEncryptionConfiguration | undefined;
        private _healthCheckConfiguration?;
        private __healthCheckConfigurationOutput;
        /**
         * @stability stable
         */
        get healthCheckConfiguration(): ApprunnerServiceHealthCheckConfigurationOutputReference;
        /**
         * @stability stable
         */
        putHealthCheckConfiguration(value: ApprunnerServiceHealthCheckConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetHealthCheckConfiguration(): void;
        /**
         * @stability stable
         */
        get healthCheckConfigurationInput(): ApprunnerServiceHealthCheckConfiguration | undefined;
        private _instanceConfiguration?;
        private __instanceConfigurationOutput;
        /**
         * @stability stable
         */
        get instanceConfiguration(): ApprunnerServiceInstanceConfigurationOutputReference;
        /**
         * @stability stable
         */
        putInstanceConfiguration(value: ApprunnerServiceInstanceConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetInstanceConfiguration(): void;
        /**
         * @stability stable
         */
        get instanceConfigurationInput(): ApprunnerServiceInstanceConfiguration | undefined;
        private _sourceConfiguration?;
        private __sourceConfigurationOutput;
        /**
         * @stability stable
         */
        get sourceConfiguration(): ApprunnerServiceSourceConfigurationOutputReference;
        /**
         * @stability stable
         */
        putSourceConfiguration(value: ApprunnerServiceSourceConfiguration): void;
        /**
         * @stability stable
         */
        get sourceConfigurationInput(): ApprunnerServiceSourceConfiguration | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
