import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AppStream
*/
export declare namespace AppStream {
    /**
     * @stability stable
     */
    interface AppstreamFleetConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#description AppstreamFleet#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#disconnect_timeout_in_seconds AppstreamFleet#disconnect_timeout_in_seconds}.
         *
         * @stability stable
         */
        readonly disconnectTimeoutInSeconds?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#display_name AppstreamFleet#display_name}.
         *
         * @stability stable
         */
        readonly displayName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#enable_default_internet_access AppstreamFleet#enable_default_internet_access}.
         *
         * @stability stable
         */
        readonly enableDefaultInternetAccess?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#fleet_type AppstreamFleet#fleet_type}.
         *
         * @stability stable
         */
        readonly fleetType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#iam_role_arn AppstreamFleet#iam_role_arn}.
         *
         * @stability stable
         */
        readonly iamRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#idle_disconnect_timeout_in_seconds AppstreamFleet#idle_disconnect_timeout_in_seconds}.
         *
         * @stability stable
         */
        readonly idleDisconnectTimeoutInSeconds?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#image_arn AppstreamFleet#image_arn}.
         *
         * @stability stable
         */
        readonly imageArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#image_name AppstreamFleet#image_name}.
         *
         * @stability stable
         */
        readonly imageName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#instance_type AppstreamFleet#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#max_user_duration_in_seconds AppstreamFleet#max_user_duration_in_seconds}.
         *
         * @stability stable
         */
        readonly maxUserDurationInSeconds?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#name AppstreamFleet#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#stream_view AppstreamFleet#stream_view}.
         *
         * @stability stable
         */
        readonly streamView?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#tags AppstreamFleet#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#tags_all AppstreamFleet#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * compute_capacity block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#compute_capacity AppstreamFleet#compute_capacity}
         *
         * @stability stable
         */
        readonly computeCapacity: AppstreamFleetComputeCapacity;
        /**
         * domain_join_info block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#domain_join_info AppstreamFleet#domain_join_info}
         *
         * @stability stable
         */
        readonly domainJoinInfo?: AppstreamFleetDomainJoinInfo;
        /**
         * vpc_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#vpc_config AppstreamFleet#vpc_config}
         *
         * @stability stable
         */
        readonly vpcConfig?: AppstreamFleetVpcConfig;
    }
    /**
     * @stability stable
     */
    interface AppstreamFleetComputeCapacity {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#desired_instances AppstreamFleet#desired_instances}.
         *
         * @stability stable
         */
        readonly desiredInstances: number;
    }
    /**
     * @stability stable
     */
    class AppstreamFleetComputeCapacityOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _desiredInstances?;
        /**
         * @stability stable
         */
        get desiredInstances(): number;
        /**
         * @stability stable
         */
        set desiredInstances(value: number);
        /**
         * @stability stable
         */
        get desiredInstancesInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppstreamFleetDomainJoinInfo {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#directory_name AppstreamFleet#directory_name}.
         *
         * @stability stable
         */
        readonly directoryName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#organizational_unit_distinguished_name AppstreamFleet#organizational_unit_distinguished_name}.
         *
         * @stability stable
         */
        readonly organizationalUnitDistinguishedName?: string;
    }
    /**
     * @stability stable
     */
    class AppstreamFleetDomainJoinInfoOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _directoryName?;
        /**
         * @stability stable
         */
        get directoryName(): string | undefined;
        /**
         * @stability stable
         */
        set directoryName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDirectoryName(): void;
        /**
         * @stability stable
         */
        get directoryNameInput(): string | undefined;
        private _organizationalUnitDistinguishedName?;
        /**
         * @stability stable
         */
        get organizationalUnitDistinguishedName(): string | undefined;
        /**
         * @stability stable
         */
        set organizationalUnitDistinguishedName(value: string | undefined);
        /**
         * @stability stable
         */
        resetOrganizationalUnitDistinguishedName(): void;
        /**
         * @stability stable
         */
        get organizationalUnitDistinguishedNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppstreamFleetVpcConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#security_group_ids AppstreamFleet#security_group_ids}.
         *
         * @stability stable
         */
        readonly securityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html#subnet_ids AppstreamFleet#subnet_ids}.
         *
         * @stability stable
         */
        readonly subnetIds?: string[];
    }
    /**
     * @stability stable
     */
    class AppstreamFleetVpcConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _securityGroupIds?;
        /**
         * @stability stable
         */
        get securityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set securityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get securityGroupIdsInput(): string[] | undefined;
        private _subnetIds?;
        /**
         * @stability stable
         */
        get subnetIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set subnetIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSubnetIds(): void;
        /**
         * @stability stable
         */
        get subnetIdsInput(): string[] | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html aws_appstream_fleet}.
     *
     * @stability stable
     */
    class AppstreamFleet extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet.html aws_appstream_fleet} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AppstreamFleetConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdTime(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _disconnectTimeoutInSeconds?;
        /**
         * @stability stable
         */
        get disconnectTimeoutInSeconds(): number | undefined;
        /**
         * @stability stable
         */
        set disconnectTimeoutInSeconds(value: number | undefined);
        /**
         * @stability stable
         */
        resetDisconnectTimeoutInSeconds(): void;
        /**
         * @stability stable
         */
        get disconnectTimeoutInSecondsInput(): number | undefined;
        private _displayName?;
        /**
         * @stability stable
         */
        get displayName(): string | undefined;
        /**
         * @stability stable
         */
        set displayName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDisplayName(): void;
        /**
         * @stability stable
         */
        get displayNameInput(): string | undefined;
        private _enableDefaultInternetAccess?;
        /**
         * @stability stable
         */
        get enableDefaultInternetAccess(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableDefaultInternetAccess(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableDefaultInternetAccess(): void;
        /**
         * @stability stable
         */
        get enableDefaultInternetAccessInput(): boolean | cdktf.IResolvable | undefined;
        private _fleetType?;
        /**
         * @stability stable
         */
        get fleetType(): string | undefined;
        /**
         * @stability stable
         */
        set fleetType(value: string | undefined);
        /**
         * @stability stable
         */
        resetFleetType(): void;
        /**
         * @stability stable
         */
        get fleetTypeInput(): string | undefined;
        private _iamRoleArn?;
        /**
         * @stability stable
         */
        get iamRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set iamRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetIamRoleArn(): void;
        /**
         * @stability stable
         */
        get iamRoleArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _idleDisconnectTimeoutInSeconds?;
        /**
         * @stability stable
         */
        get idleDisconnectTimeoutInSeconds(): number | undefined;
        /**
         * @stability stable
         */
        set idleDisconnectTimeoutInSeconds(value: number | undefined);
        /**
         * @stability stable
         */
        resetIdleDisconnectTimeoutInSeconds(): void;
        /**
         * @stability stable
         */
        get idleDisconnectTimeoutInSecondsInput(): number | undefined;
        private _imageArn?;
        /**
         * @stability stable
         */
        get imageArn(): string | undefined;
        /**
         * @stability stable
         */
        set imageArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetImageArn(): void;
        /**
         * @stability stable
         */
        get imageArnInput(): string | undefined;
        private _imageName?;
        /**
         * @stability stable
         */
        get imageName(): string | undefined;
        /**
         * @stability stable
         */
        set imageName(value: string | undefined);
        /**
         * @stability stable
         */
        resetImageName(): void;
        /**
         * @stability stable
         */
        get imageNameInput(): string | undefined;
        private _instanceType?;
        /**
         * @stability stable
         */
        get instanceType(): string;
        /**
         * @stability stable
         */
        set instanceType(value: string);
        /**
         * @stability stable
         */
        get instanceTypeInput(): string | undefined;
        private _maxUserDurationInSeconds?;
        /**
         * @stability stable
         */
        get maxUserDurationInSeconds(): number | undefined;
        /**
         * @stability stable
         */
        set maxUserDurationInSeconds(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaxUserDurationInSeconds(): void;
        /**
         * @stability stable
         */
        get maxUserDurationInSecondsInput(): number | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get state(): string;
        private _streamView?;
        /**
         * @stability stable
         */
        get streamView(): string | undefined;
        /**
         * @stability stable
         */
        set streamView(value: string | undefined);
        /**
         * @stability stable
         */
        resetStreamView(): void;
        /**
         * @stability stable
         */
        get streamViewInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _computeCapacity?;
        private __computeCapacityOutput;
        /**
         * @stability stable
         */
        get computeCapacity(): AppstreamFleetComputeCapacityOutputReference;
        /**
         * @stability stable
         */
        putComputeCapacity(value: AppstreamFleetComputeCapacity): void;
        /**
         * @stability stable
         */
        get computeCapacityInput(): AppstreamFleetComputeCapacity | undefined;
        private _domainJoinInfo?;
        private __domainJoinInfoOutput;
        /**
         * @stability stable
         */
        get domainJoinInfo(): AppstreamFleetDomainJoinInfoOutputReference;
        /**
         * @stability stable
         */
        putDomainJoinInfo(value: AppstreamFleetDomainJoinInfo | undefined): void;
        /**
         * @stability stable
         */
        resetDomainJoinInfo(): void;
        /**
         * @stability stable
         */
        get domainJoinInfoInput(): AppstreamFleetDomainJoinInfo | undefined;
        private _vpcConfig?;
        private __vpcConfigOutput;
        /**
         * @stability stable
         */
        get vpcConfig(): AppstreamFleetVpcConfigOutputReference;
        /**
         * @stability stable
         */
        putVpcConfig(value: AppstreamFleetVpcConfig | undefined): void;
        /**
         * @stability stable
         */
        resetVpcConfig(): void;
        /**
         * @stability stable
         */
        get vpcConfigInput(): AppstreamFleetVpcConfig | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AppstreamImageBuilderConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#appstream_agent_version AppstreamImageBuilder#appstream_agent_version}.
         *
         * @stability stable
         */
        readonly appstreamAgentVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#description AppstreamImageBuilder#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#display_name AppstreamImageBuilder#display_name}.
         *
         * @stability stable
         */
        readonly displayName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#enable_default_internet_access AppstreamImageBuilder#enable_default_internet_access}.
         *
         * @stability stable
         */
        readonly enableDefaultInternetAccess?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#iam_role_arn AppstreamImageBuilder#iam_role_arn}.
         *
         * @stability stable
         */
        readonly iamRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#image_arn AppstreamImageBuilder#image_arn}.
         *
         * @stability stable
         */
        readonly imageArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#image_name AppstreamImageBuilder#image_name}.
         *
         * @stability stable
         */
        readonly imageName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#instance_type AppstreamImageBuilder#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#name AppstreamImageBuilder#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#tags AppstreamImageBuilder#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#tags_all AppstreamImageBuilder#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * access_endpoint block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#access_endpoint AppstreamImageBuilder#access_endpoint}
         *
         * @stability stable
         */
        readonly accessEndpoint?: AppstreamImageBuilderAccessEndpoint[];
        /**
         * domain_join_info block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#domain_join_info AppstreamImageBuilder#domain_join_info}
         *
         * @stability stable
         */
        readonly domainJoinInfo?: AppstreamImageBuilderDomainJoinInfo;
        /**
         * vpc_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#vpc_config AppstreamImageBuilder#vpc_config}
         *
         * @stability stable
         */
        readonly vpcConfig?: AppstreamImageBuilderVpcConfig;
    }
    /**
     * @stability stable
     */
    interface AppstreamImageBuilderAccessEndpoint {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#endpoint_type AppstreamImageBuilder#endpoint_type}.
         *
         * @stability stable
         */
        readonly endpointType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#vpce_id AppstreamImageBuilder#vpce_id}.
         *
         * @stability stable
         */
        readonly vpceId?: string;
    }
    /**
     * @stability stable
     */
    interface AppstreamImageBuilderDomainJoinInfo {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#directory_name AppstreamImageBuilder#directory_name}.
         *
         * @stability stable
         */
        readonly directoryName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#organizational_unit_distinguished_name AppstreamImageBuilder#organizational_unit_distinguished_name}.
         *
         * @stability stable
         */
        readonly organizationalUnitDistinguishedName?: string;
    }
    /**
     * @stability stable
     */
    class AppstreamImageBuilderDomainJoinInfoOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _directoryName?;
        /**
         * @stability stable
         */
        get directoryName(): string | undefined;
        /**
         * @stability stable
         */
        set directoryName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDirectoryName(): void;
        /**
         * @stability stable
         */
        get directoryNameInput(): string | undefined;
        private _organizationalUnitDistinguishedName?;
        /**
         * @stability stable
         */
        get organizationalUnitDistinguishedName(): string | undefined;
        /**
         * @stability stable
         */
        set organizationalUnitDistinguishedName(value: string | undefined);
        /**
         * @stability stable
         */
        resetOrganizationalUnitDistinguishedName(): void;
        /**
         * @stability stable
         */
        get organizationalUnitDistinguishedNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppstreamImageBuilderVpcConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#security_group_ids AppstreamImageBuilder#security_group_ids}.
         *
         * @stability stable
         */
        readonly securityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html#subnet_ids AppstreamImageBuilder#subnet_ids}.
         *
         * @stability stable
         */
        readonly subnetIds?: string[];
    }
    /**
     * @stability stable
     */
    class AppstreamImageBuilderVpcConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _securityGroupIds?;
        /**
         * @stability stable
         */
        get securityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set securityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get securityGroupIdsInput(): string[] | undefined;
        private _subnetIds?;
        /**
         * @stability stable
         */
        get subnetIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set subnetIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSubnetIds(): void;
        /**
         * @stability stable
         */
        get subnetIdsInput(): string[] | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html aws_appstream_image_builder}.
     *
     * @stability stable
     */
    class AppstreamImageBuilder extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder.html aws_appstream_image_builder} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AppstreamImageBuilderConfig);
        private _appstreamAgentVersion?;
        /**
         * @stability stable
         */
        get appstreamAgentVersion(): string | undefined;
        /**
         * @stability stable
         */
        set appstreamAgentVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetAppstreamAgentVersion(): void;
        /**
         * @stability stable
         */
        get appstreamAgentVersionInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdTime(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _displayName?;
        /**
         * @stability stable
         */
        get displayName(): string | undefined;
        /**
         * @stability stable
         */
        set displayName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDisplayName(): void;
        /**
         * @stability stable
         */
        get displayNameInput(): string | undefined;
        private _enableDefaultInternetAccess?;
        /**
         * @stability stable
         */
        get enableDefaultInternetAccess(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableDefaultInternetAccess(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableDefaultInternetAccess(): void;
        /**
         * @stability stable
         */
        get enableDefaultInternetAccessInput(): boolean | cdktf.IResolvable | undefined;
        private _iamRoleArn?;
        /**
         * @stability stable
         */
        get iamRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set iamRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetIamRoleArn(): void;
        /**
         * @stability stable
         */
        get iamRoleArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _imageArn?;
        /**
         * @stability stable
         */
        get imageArn(): string | undefined;
        /**
         * @stability stable
         */
        set imageArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetImageArn(): void;
        /**
         * @stability stable
         */
        get imageArnInput(): string | undefined;
        private _imageName?;
        /**
         * @stability stable
         */
        get imageName(): string | undefined;
        /**
         * @stability stable
         */
        set imageName(value: string | undefined);
        /**
         * @stability stable
         */
        resetImageName(): void;
        /**
         * @stability stable
         */
        get imageNameInput(): string | undefined;
        private _instanceType?;
        /**
         * @stability stable
         */
        get instanceType(): string;
        /**
         * @stability stable
         */
        set instanceType(value: string);
        /**
         * @stability stable
         */
        get instanceTypeInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get state(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _accessEndpoint?;
        /**
         * @stability stable
         */
        get accessEndpoint(): AppstreamImageBuilderAccessEndpoint[] | undefined;
        /**
         * @stability stable
         */
        set accessEndpoint(value: AppstreamImageBuilderAccessEndpoint[] | undefined);
        /**
         * @stability stable
         */
        resetAccessEndpoint(): void;
        /**
         * @stability stable
         */
        get accessEndpointInput(): AppstreamImageBuilderAccessEndpoint[] | undefined;
        private _domainJoinInfo?;
        private __domainJoinInfoOutput;
        /**
         * @stability stable
         */
        get domainJoinInfo(): AppstreamImageBuilderDomainJoinInfoOutputReference;
        /**
         * @stability stable
         */
        putDomainJoinInfo(value: AppstreamImageBuilderDomainJoinInfo | undefined): void;
        /**
         * @stability stable
         */
        resetDomainJoinInfo(): void;
        /**
         * @stability stable
         */
        get domainJoinInfoInput(): AppstreamImageBuilderDomainJoinInfo | undefined;
        private _vpcConfig?;
        private __vpcConfigOutput;
        /**
         * @stability stable
         */
        get vpcConfig(): AppstreamImageBuilderVpcConfigOutputReference;
        /**
         * @stability stable
         */
        putVpcConfig(value: AppstreamImageBuilderVpcConfig | undefined): void;
        /**
         * @stability stable
         */
        resetVpcConfig(): void;
        /**
         * @stability stable
         */
        get vpcConfigInput(): AppstreamImageBuilderVpcConfig | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AppstreamStackConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#description AppstreamStack#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#display_name AppstreamStack#display_name}.
         *
         * @stability stable
         */
        readonly displayName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#embed_host_domains AppstreamStack#embed_host_domains}.
         *
         * @stability stable
         */
        readonly embedHostDomains?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#feedback_url AppstreamStack#feedback_url}.
         *
         * @stability stable
         */
        readonly feedbackUrl?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#name AppstreamStack#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#redirect_url AppstreamStack#redirect_url}.
         *
         * @stability stable
         */
        readonly redirectUrl?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#tags AppstreamStack#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#tags_all AppstreamStack#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * access_endpoints block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#access_endpoints AppstreamStack#access_endpoints}
         *
         * @stability stable
         */
        readonly accessEndpoints?: AppstreamStackAccessEndpoints[];
        /**
         * application_settings block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#application_settings AppstreamStack#application_settings}
         *
         * @stability stable
         */
        readonly applicationSettings?: AppstreamStackApplicationSettings;
        /**
         * storage_connectors block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#storage_connectors AppstreamStack#storage_connectors}
         *
         * @stability stable
         */
        readonly storageConnectors?: AppstreamStackStorageConnectors[];
        /**
         * user_settings block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#user_settings AppstreamStack#user_settings}
         *
         * @stability stable
         */
        readonly userSettings?: AppstreamStackUserSettings[];
    }
    /**
     * @stability stable
     */
    interface AppstreamStackAccessEndpoints {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#endpoint_type AppstreamStack#endpoint_type}.
         *
         * @stability stable
         */
        readonly endpointType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#vpce_id AppstreamStack#vpce_id}.
         *
         * @stability stable
         */
        readonly vpceId?: string;
    }
    /**
     * @stability stable
     */
    interface AppstreamStackApplicationSettings {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#enabled AppstreamStack#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#settings_group AppstreamStack#settings_group}.
         *
         * @stability stable
         */
        readonly settingsGroup?: string;
    }
    /**
     * @stability stable
     */
    class AppstreamStackApplicationSettingsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _settingsGroup?;
        /**
         * @stability stable
         */
        get settingsGroup(): string | undefined;
        /**
         * @stability stable
         */
        set settingsGroup(value: string | undefined);
        /**
         * @stability stable
         */
        resetSettingsGroup(): void;
        /**
         * @stability stable
         */
        get settingsGroupInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppstreamStackStorageConnectors {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#connector_type AppstreamStack#connector_type}.
         *
         * @stability stable
         */
        readonly connectorType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#domains AppstreamStack#domains}.
         *
         * @stability stable
         */
        readonly domains?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#resource_identifier AppstreamStack#resource_identifier}.
         *
         * @stability stable
         */
        readonly resourceIdentifier?: string;
    }
    /**
     * @stability stable
     */
    interface AppstreamStackUserSettings {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#action AppstreamStack#action}.
         *
         * @stability stable
         */
        readonly action: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html#permission AppstreamStack#permission}.
         *
         * @stability stable
         */
        readonly permission: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html aws_appstream_stack}.
     *
     * @stability stable
     */
    class AppstreamStack extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack.html aws_appstream_stack} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AppstreamStackConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdTime(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _displayName?;
        /**
         * @stability stable
         */
        get displayName(): string | undefined;
        /**
         * @stability stable
         */
        set displayName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDisplayName(): void;
        /**
         * @stability stable
         */
        get displayNameInput(): string | undefined;
        private _embedHostDomains?;
        /**
         * @stability stable
         */
        get embedHostDomains(): string[] | undefined;
        /**
         * @stability stable
         */
        set embedHostDomains(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetEmbedHostDomains(): void;
        /**
         * @stability stable
         */
        get embedHostDomainsInput(): string[] | undefined;
        private _feedbackUrl?;
        /**
         * @stability stable
         */
        get feedbackUrl(): string | undefined;
        /**
         * @stability stable
         */
        set feedbackUrl(value: string | undefined);
        /**
         * @stability stable
         */
        resetFeedbackUrl(): void;
        /**
         * @stability stable
         */
        get feedbackUrlInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _redirectUrl?;
        /**
         * @stability stable
         */
        get redirectUrl(): string | undefined;
        /**
         * @stability stable
         */
        set redirectUrl(value: string | undefined);
        /**
         * @stability stable
         */
        resetRedirectUrl(): void;
        /**
         * @stability stable
         */
        get redirectUrlInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _accessEndpoints?;
        /**
         * @stability stable
         */
        get accessEndpoints(): AppstreamStackAccessEndpoints[] | undefined;
        /**
         * @stability stable
         */
        set accessEndpoints(value: AppstreamStackAccessEndpoints[] | undefined);
        /**
         * @stability stable
         */
        resetAccessEndpoints(): void;
        /**
         * @stability stable
         */
        get accessEndpointsInput(): AppstreamStackAccessEndpoints[] | undefined;
        private _applicationSettings?;
        private __applicationSettingsOutput;
        /**
         * @stability stable
         */
        get applicationSettings(): AppstreamStackApplicationSettingsOutputReference;
        /**
         * @stability stable
         */
        putApplicationSettings(value: AppstreamStackApplicationSettings | undefined): void;
        /**
         * @stability stable
         */
        resetApplicationSettings(): void;
        /**
         * @stability stable
         */
        get applicationSettingsInput(): AppstreamStackApplicationSettings | undefined;
        private _storageConnectors?;
        /**
         * @stability stable
         */
        get storageConnectors(): AppstreamStackStorageConnectors[] | undefined;
        /**
         * @stability stable
         */
        set storageConnectors(value: AppstreamStackStorageConnectors[] | undefined);
        /**
         * @stability stable
         */
        resetStorageConnectors(): void;
        /**
         * @stability stable
         */
        get storageConnectorsInput(): AppstreamStackStorageConnectors[] | undefined;
        private _userSettings?;
        /**
         * @stability stable
         */
        get userSettings(): AppstreamStackUserSettings[] | undefined;
        /**
         * @stability stable
         */
        set userSettings(value: AppstreamStackUserSettings[] | undefined);
        /**
         * @stability stable
         */
        resetUserSettings(): void;
        /**
         * @stability stable
         */
        get userSettingsInput(): AppstreamStackUserSettings[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
