import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Auto Scaling Plans
*/
export declare namespace AutoScalingPlans {
    /**
     * @stability stable
     */
    interface AutoscalingplansScalingPlanConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#name AutoscalingplansScalingPlan#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * application_source block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#application_source AutoscalingplansScalingPlan#application_source}
         *
         * @stability stable
         */
        readonly applicationSource: AutoscalingplansScalingPlanApplicationSource;
        /**
         * scaling_instruction block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#scaling_instruction AutoscalingplansScalingPlan#scaling_instruction}
         *
         * @stability stable
         */
        readonly scalingInstruction: AutoscalingplansScalingPlanScalingInstruction[];
    }
    /**
     * @stability stable
     */
    interface AutoscalingplansScalingPlanApplicationSourceTagFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#key AutoscalingplansScalingPlan#key}.
         *
         * @stability stable
         */
        readonly key: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#values AutoscalingplansScalingPlan#values}.
         *
         * @stability stable
         */
        readonly values?: string[];
    }
    /**
     * @stability stable
     */
    interface AutoscalingplansScalingPlanApplicationSource {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#cloudformation_stack_arn AutoscalingplansScalingPlan#cloudformation_stack_arn}.
         *
         * @stability stable
         */
        readonly cloudformationStackArn?: string;
        /**
         * tag_filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#tag_filter AutoscalingplansScalingPlan#tag_filter}
         *
         * @stability stable
         */
        readonly tagFilter?: AutoscalingplansScalingPlanApplicationSourceTagFilter[];
    }
    /**
     * @stability stable
     */
    class AutoscalingplansScalingPlanApplicationSourceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _cloudformationStackArn?;
        /**
         * @stability stable
         */
        get cloudformationStackArn(): string | undefined;
        /**
         * @stability stable
         */
        set cloudformationStackArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetCloudformationStackArn(): void;
        /**
         * @stability stable
         */
        get cloudformationStackArnInput(): string | undefined;
        private _tagFilter?;
        /**
         * @stability stable
         */
        get tagFilter(): AutoscalingplansScalingPlanApplicationSourceTagFilter[] | undefined;
        /**
         * @stability stable
         */
        set tagFilter(value: AutoscalingplansScalingPlanApplicationSourceTagFilter[] | undefined);
        /**
         * @stability stable
         */
        resetTagFilter(): void;
        /**
         * @stability stable
         */
        get tagFilterInput(): AutoscalingplansScalingPlanApplicationSourceTagFilter[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AutoscalingplansScalingPlanScalingInstructionCustomizedLoadMetricSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#dimensions AutoscalingplansScalingPlan#dimensions}.
         *
         * @stability stable
         */
        readonly dimensions?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#metric_name AutoscalingplansScalingPlan#metric_name}.
         *
         * @stability stable
         */
        readonly metricName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#namespace AutoscalingplansScalingPlan#namespace}.
         *
         * @stability stable
         */
        readonly namespace: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#statistic AutoscalingplansScalingPlan#statistic}.
         *
         * @stability stable
         */
        readonly statistic: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#unit AutoscalingplansScalingPlan#unit}.
         *
         * @stability stable
         */
        readonly unit?: string;
    }
    /**
     * @stability stable
     */
    class AutoscalingplansScalingPlanScalingInstructionCustomizedLoadMetricSpecificationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _dimensions?;
        /**
         * @stability stable
         */
        get dimensions(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set dimensions(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDimensions(): void;
        /**
         * @stability stable
         */
        get dimensionsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _metricName?;
        /**
         * @stability stable
         */
        get metricName(): string;
        /**
         * @stability stable
         */
        set metricName(value: string);
        /**
         * @stability stable
         */
        get metricNameInput(): string | undefined;
        private _namespace?;
        /**
         * @stability stable
         */
        get namespace(): string;
        /**
         * @stability stable
         */
        set namespace(value: string);
        /**
         * @stability stable
         */
        get namespaceInput(): string | undefined;
        private _statistic?;
        /**
         * @stability stable
         */
        get statistic(): string;
        /**
         * @stability stable
         */
        set statistic(value: string);
        /**
         * @stability stable
         */
        get statisticInput(): string | undefined;
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string | undefined;
        /**
         * @stability stable
         */
        set unit(value: string | undefined);
        /**
         * @stability stable
         */
        resetUnit(): void;
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AutoscalingplansScalingPlanScalingInstructionPredefinedLoadMetricSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#predefined_load_metric_type AutoscalingplansScalingPlan#predefined_load_metric_type}.
         *
         * @stability stable
         */
        readonly predefinedLoadMetricType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#resource_label AutoscalingplansScalingPlan#resource_label}.
         *
         * @stability stable
         */
        readonly resourceLabel?: string;
    }
    /**
     * @stability stable
     */
    class AutoscalingplansScalingPlanScalingInstructionPredefinedLoadMetricSpecificationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _predefinedLoadMetricType?;
        /**
         * @stability stable
         */
        get predefinedLoadMetricType(): string;
        /**
         * @stability stable
         */
        set predefinedLoadMetricType(value: string);
        /**
         * @stability stable
         */
        get predefinedLoadMetricTypeInput(): string | undefined;
        private _resourceLabel?;
        /**
         * @stability stable
         */
        get resourceLabel(): string | undefined;
        /**
         * @stability stable
         */
        set resourceLabel(value: string | undefined);
        /**
         * @stability stable
         */
        resetResourceLabel(): void;
        /**
         * @stability stable
         */
        get resourceLabelInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AutoscalingplansScalingPlanScalingInstructionTargetTrackingConfigurationCustomizedScalingMetricSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#dimensions AutoscalingplansScalingPlan#dimensions}.
         *
         * @stability stable
         */
        readonly dimensions?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#metric_name AutoscalingplansScalingPlan#metric_name}.
         *
         * @stability stable
         */
        readonly metricName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#namespace AutoscalingplansScalingPlan#namespace}.
         *
         * @stability stable
         */
        readonly namespace: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#statistic AutoscalingplansScalingPlan#statistic}.
         *
         * @stability stable
         */
        readonly statistic: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#unit AutoscalingplansScalingPlan#unit}.
         *
         * @stability stable
         */
        readonly unit?: string;
    }
    /**
     * @stability stable
     */
    class AutoscalingplansScalingPlanScalingInstructionTargetTrackingConfigurationCustomizedScalingMetricSpecificationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _dimensions?;
        /**
         * @stability stable
         */
        get dimensions(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set dimensions(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDimensions(): void;
        /**
         * @stability stable
         */
        get dimensionsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _metricName?;
        /**
         * @stability stable
         */
        get metricName(): string;
        /**
         * @stability stable
         */
        set metricName(value: string);
        /**
         * @stability stable
         */
        get metricNameInput(): string | undefined;
        private _namespace?;
        /**
         * @stability stable
         */
        get namespace(): string;
        /**
         * @stability stable
         */
        set namespace(value: string);
        /**
         * @stability stable
         */
        get namespaceInput(): string | undefined;
        private _statistic?;
        /**
         * @stability stable
         */
        get statistic(): string;
        /**
         * @stability stable
         */
        set statistic(value: string);
        /**
         * @stability stable
         */
        get statisticInput(): string | undefined;
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string | undefined;
        /**
         * @stability stable
         */
        set unit(value: string | undefined);
        /**
         * @stability stable
         */
        resetUnit(): void;
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AutoscalingplansScalingPlanScalingInstructionTargetTrackingConfigurationPredefinedScalingMetricSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#predefined_scaling_metric_type AutoscalingplansScalingPlan#predefined_scaling_metric_type}.
         *
         * @stability stable
         */
        readonly predefinedScalingMetricType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#resource_label AutoscalingplansScalingPlan#resource_label}.
         *
         * @stability stable
         */
        readonly resourceLabel?: string;
    }
    /**
     * @stability stable
     */
    class AutoscalingplansScalingPlanScalingInstructionTargetTrackingConfigurationPredefinedScalingMetricSpecificationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _predefinedScalingMetricType?;
        /**
         * @stability stable
         */
        get predefinedScalingMetricType(): string;
        /**
         * @stability stable
         */
        set predefinedScalingMetricType(value: string);
        /**
         * @stability stable
         */
        get predefinedScalingMetricTypeInput(): string | undefined;
        private _resourceLabel?;
        /**
         * @stability stable
         */
        get resourceLabel(): string | undefined;
        /**
         * @stability stable
         */
        set resourceLabel(value: string | undefined);
        /**
         * @stability stable
         */
        resetResourceLabel(): void;
        /**
         * @stability stable
         */
        get resourceLabelInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AutoscalingplansScalingPlanScalingInstructionTargetTrackingConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#disable_scale_in AutoscalingplansScalingPlan#disable_scale_in}.
         *
         * @stability stable
         */
        readonly disableScaleIn?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#estimated_instance_warmup AutoscalingplansScalingPlan#estimated_instance_warmup}.
         *
         * @stability stable
         */
        readonly estimatedInstanceWarmup?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#scale_in_cooldown AutoscalingplansScalingPlan#scale_in_cooldown}.
         *
         * @stability stable
         */
        readonly scaleInCooldown?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#scale_out_cooldown AutoscalingplansScalingPlan#scale_out_cooldown}.
         *
         * @stability stable
         */
        readonly scaleOutCooldown?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#target_value AutoscalingplansScalingPlan#target_value}.
         *
         * @stability stable
         */
        readonly targetValue: number;
        /**
         * customized_scaling_metric_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#customized_scaling_metric_specification AutoscalingplansScalingPlan#customized_scaling_metric_specification}
         *
         * @stability stable
         */
        readonly customizedScalingMetricSpecification?: AutoscalingplansScalingPlanScalingInstructionTargetTrackingConfigurationCustomizedScalingMetricSpecification;
        /**
         * predefined_scaling_metric_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#predefined_scaling_metric_specification AutoscalingplansScalingPlan#predefined_scaling_metric_specification}
         *
         * @stability stable
         */
        readonly predefinedScalingMetricSpecification?: AutoscalingplansScalingPlanScalingInstructionTargetTrackingConfigurationPredefinedScalingMetricSpecification;
    }
    /**
     * @stability stable
     */
    interface AutoscalingplansScalingPlanScalingInstruction {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#disable_dynamic_scaling AutoscalingplansScalingPlan#disable_dynamic_scaling}.
         *
         * @stability stable
         */
        readonly disableDynamicScaling?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#max_capacity AutoscalingplansScalingPlan#max_capacity}.
         *
         * @stability stable
         */
        readonly maxCapacity: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#min_capacity AutoscalingplansScalingPlan#min_capacity}.
         *
         * @stability stable
         */
        readonly minCapacity: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#predictive_scaling_max_capacity_behavior AutoscalingplansScalingPlan#predictive_scaling_max_capacity_behavior}.
         *
         * @stability stable
         */
        readonly predictiveScalingMaxCapacityBehavior?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#predictive_scaling_max_capacity_buffer AutoscalingplansScalingPlan#predictive_scaling_max_capacity_buffer}.
         *
         * @stability stable
         */
        readonly predictiveScalingMaxCapacityBuffer?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#predictive_scaling_mode AutoscalingplansScalingPlan#predictive_scaling_mode}.
         *
         * @stability stable
         */
        readonly predictiveScalingMode?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#resource_id AutoscalingplansScalingPlan#resource_id}.
         *
         * @stability stable
         */
        readonly resourceId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#scalable_dimension AutoscalingplansScalingPlan#scalable_dimension}.
         *
         * @stability stable
         */
        readonly scalableDimension: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#scaling_policy_update_behavior AutoscalingplansScalingPlan#scaling_policy_update_behavior}.
         *
         * @stability stable
         */
        readonly scalingPolicyUpdateBehavior?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#scheduled_action_buffer_time AutoscalingplansScalingPlan#scheduled_action_buffer_time}.
         *
         * @stability stable
         */
        readonly scheduledActionBufferTime?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#service_namespace AutoscalingplansScalingPlan#service_namespace}.
         *
         * @stability stable
         */
        readonly serviceNamespace: string;
        /**
         * customized_load_metric_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#customized_load_metric_specification AutoscalingplansScalingPlan#customized_load_metric_specification}
         *
         * @stability stable
         */
        readonly customizedLoadMetricSpecification?: AutoscalingplansScalingPlanScalingInstructionCustomizedLoadMetricSpecification;
        /**
         * predefined_load_metric_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#predefined_load_metric_specification AutoscalingplansScalingPlan#predefined_load_metric_specification}
         *
         * @stability stable
         */
        readonly predefinedLoadMetricSpecification?: AutoscalingplansScalingPlanScalingInstructionPredefinedLoadMetricSpecification;
        /**
         * target_tracking_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html#target_tracking_configuration AutoscalingplansScalingPlan#target_tracking_configuration}
         *
         * @stability stable
         */
        readonly targetTrackingConfiguration: AutoscalingplansScalingPlanScalingInstructionTargetTrackingConfiguration[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html aws_autoscalingplans_scaling_plan}.
     *
     * @stability stable
     */
    class AutoscalingplansScalingPlan extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/autoscalingplans_scaling_plan.html aws_autoscalingplans_scaling_plan} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AutoscalingplansScalingPlanConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get scalingPlanVersion(): number;
        private _applicationSource?;
        private __applicationSourceOutput;
        /**
         * @stability stable
         */
        get applicationSource(): AutoscalingplansScalingPlanApplicationSourceOutputReference;
        /**
         * @stability stable
         */
        putApplicationSource(value: AutoscalingplansScalingPlanApplicationSource): void;
        /**
         * @stability stable
         */
        get applicationSourceInput(): AutoscalingplansScalingPlanApplicationSource | undefined;
        private _scalingInstruction?;
        /**
         * @stability stable
         */
        get scalingInstruction(): AutoscalingplansScalingPlanScalingInstruction[];
        /**
         * @stability stable
         */
        set scalingInstruction(value: AutoscalingplansScalingPlanScalingInstruction[]);
        /**
         * @stability stable
         */
        get scalingInstructionInput(): AutoscalingplansScalingPlanScalingInstruction[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
