import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Batch
*/
export declare namespace Batch {
    /**
     * @stability stable
     */
    interface BatchComputeEnvironmentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#compute_environment_name BatchComputeEnvironment#compute_environment_name}.
         *
         * @stability stable
         */
        readonly computeEnvironmentName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#compute_environment_name_prefix BatchComputeEnvironment#compute_environment_name_prefix}.
         *
         * @stability stable
         */
        readonly computeEnvironmentNamePrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#service_role BatchComputeEnvironment#service_role}.
         *
         * @stability stable
         */
        readonly serviceRole?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#state BatchComputeEnvironment#state}.
         *
         * @stability stable
         */
        readonly state?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#tags BatchComputeEnvironment#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#tags_all BatchComputeEnvironment#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#type BatchComputeEnvironment#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * compute_resources block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#compute_resources BatchComputeEnvironment#compute_resources}
         *
         * @stability stable
         */
        readonly computeResources?: BatchComputeEnvironmentComputeResources;
    }
    /**
     * @stability stable
     */
    interface BatchComputeEnvironmentComputeResourcesLaunchTemplate {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#launch_template_id BatchComputeEnvironment#launch_template_id}.
         *
         * @stability stable
         */
        readonly launchTemplateId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#launch_template_name BatchComputeEnvironment#launch_template_name}.
         *
         * @stability stable
         */
        readonly launchTemplateName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#version BatchComputeEnvironment#version}.
         *
         * @stability stable
         */
        readonly version?: string;
    }
    /**
     * @stability stable
     */
    class BatchComputeEnvironmentComputeResourcesLaunchTemplateOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _launchTemplateId?;
        /**
         * @stability stable
         */
        get launchTemplateId(): string | undefined;
        /**
         * @stability stable
         */
        set launchTemplateId(value: string | undefined);
        /**
         * @stability stable
         */
        resetLaunchTemplateId(): void;
        /**
         * @stability stable
         */
        get launchTemplateIdInput(): string | undefined;
        private _launchTemplateName?;
        /**
         * @stability stable
         */
        get launchTemplateName(): string | undefined;
        /**
         * @stability stable
         */
        set launchTemplateName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLaunchTemplateName(): void;
        /**
         * @stability stable
         */
        get launchTemplateNameInput(): string | undefined;
        private _version?;
        /**
         * @stability stable
         */
        get version(): string | undefined;
        /**
         * @stability stable
         */
        set version(value: string | undefined);
        /**
         * @stability stable
         */
        resetVersion(): void;
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface BatchComputeEnvironmentComputeResources {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#allocation_strategy BatchComputeEnvironment#allocation_strategy}.
         *
         * @stability stable
         */
        readonly allocationStrategy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#bid_percentage BatchComputeEnvironment#bid_percentage}.
         *
         * @stability stable
         */
        readonly bidPercentage?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#desired_vcpus BatchComputeEnvironment#desired_vcpus}.
         *
         * @stability stable
         */
        readonly desiredVcpus?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#ec2_key_pair BatchComputeEnvironment#ec2_key_pair}.
         *
         * @stability stable
         */
        readonly ec2KeyPair?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#image_id BatchComputeEnvironment#image_id}.
         *
         * @stability stable
         */
        readonly imageId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#instance_role BatchComputeEnvironment#instance_role}.
         *
         * @stability stable
         */
        readonly instanceRole?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#instance_type BatchComputeEnvironment#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#max_vcpus BatchComputeEnvironment#max_vcpus}.
         *
         * @stability stable
         */
        readonly maxVcpus: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#min_vcpus BatchComputeEnvironment#min_vcpus}.
         *
         * @stability stable
         */
        readonly minVcpus?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#security_group_ids BatchComputeEnvironment#security_group_ids}.
         *
         * @stability stable
         */
        readonly securityGroupIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#spot_iam_fleet_role BatchComputeEnvironment#spot_iam_fleet_role}.
         *
         * @stability stable
         */
        readonly spotIamFleetRole?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#subnets BatchComputeEnvironment#subnets}.
         *
         * @stability stable
         */
        readonly subnets: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#tags BatchComputeEnvironment#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#type BatchComputeEnvironment#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * launch_template block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html#launch_template BatchComputeEnvironment#launch_template}
         *
         * @stability stable
         */
        readonly launchTemplate?: BatchComputeEnvironmentComputeResourcesLaunchTemplate;
    }
    /**
     * @stability stable
     */
    class BatchComputeEnvironmentComputeResourcesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _allocationStrategy?;
        /**
         * @stability stable
         */
        get allocationStrategy(): string | undefined;
        /**
         * @stability stable
         */
        set allocationStrategy(value: string | undefined);
        /**
         * @stability stable
         */
        resetAllocationStrategy(): void;
        /**
         * @stability stable
         */
        get allocationStrategyInput(): string | undefined;
        private _bidPercentage?;
        /**
         * @stability stable
         */
        get bidPercentage(): number | undefined;
        /**
         * @stability stable
         */
        set bidPercentage(value: number | undefined);
        /**
         * @stability stable
         */
        resetBidPercentage(): void;
        /**
         * @stability stable
         */
        get bidPercentageInput(): number | undefined;
        private _desiredVcpus?;
        /**
         * @stability stable
         */
        get desiredVcpus(): number | undefined;
        /**
         * @stability stable
         */
        set desiredVcpus(value: number | undefined);
        /**
         * @stability stable
         */
        resetDesiredVcpus(): void;
        /**
         * @stability stable
         */
        get desiredVcpusInput(): number | undefined;
        private _ec2KeyPair?;
        /**
         * @stability stable
         */
        get ec2KeyPair(): string | undefined;
        /**
         * @stability stable
         */
        set ec2KeyPair(value: string | undefined);
        /**
         * @stability stable
         */
        resetEc2KeyPair(): void;
        /**
         * @stability stable
         */
        get ec2KeyPairInput(): string | undefined;
        private _imageId?;
        /**
         * @stability stable
         */
        get imageId(): string | undefined;
        /**
         * @stability stable
         */
        set imageId(value: string | undefined);
        /**
         * @stability stable
         */
        resetImageId(): void;
        /**
         * @stability stable
         */
        get imageIdInput(): string | undefined;
        private _instanceRole?;
        /**
         * @stability stable
         */
        get instanceRole(): string | undefined;
        /**
         * @stability stable
         */
        set instanceRole(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceRole(): void;
        /**
         * @stability stable
         */
        get instanceRoleInput(): string | undefined;
        private _instanceType?;
        /**
         * @stability stable
         */
        get instanceType(): string[] | undefined;
        /**
         * @stability stable
         */
        set instanceType(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetInstanceType(): void;
        /**
         * @stability stable
         */
        get instanceTypeInput(): string[] | undefined;
        private _maxVcpus?;
        /**
         * @stability stable
         */
        get maxVcpus(): number;
        /**
         * @stability stable
         */
        set maxVcpus(value: number);
        /**
         * @stability stable
         */
        get maxVcpusInput(): number | undefined;
        private _minVcpus?;
        /**
         * @stability stable
         */
        get minVcpus(): number | undefined;
        /**
         * @stability stable
         */
        set minVcpus(value: number | undefined);
        /**
         * @stability stable
         */
        resetMinVcpus(): void;
        /**
         * @stability stable
         */
        get minVcpusInput(): number | undefined;
        private _securityGroupIds?;
        /**
         * @stability stable
         */
        get securityGroupIds(): string[];
        /**
         * @stability stable
         */
        set securityGroupIds(value: string[]);
        /**
         * @stability stable
         */
        get securityGroupIdsInput(): string[] | undefined;
        private _spotIamFleetRole?;
        /**
         * @stability stable
         */
        get spotIamFleetRole(): string | undefined;
        /**
         * @stability stable
         */
        set spotIamFleetRole(value: string | undefined);
        /**
         * @stability stable
         */
        resetSpotIamFleetRole(): void;
        /**
         * @stability stable
         */
        get spotIamFleetRoleInput(): string | undefined;
        private _subnets?;
        /**
         * @stability stable
         */
        get subnets(): string[];
        /**
         * @stability stable
         */
        set subnets(value: string[]);
        /**
         * @stability stable
         */
        get subnetsInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _launchTemplate?;
        private __launchTemplateOutput;
        /**
         * @stability stable
         */
        get launchTemplate(): BatchComputeEnvironmentComputeResourcesLaunchTemplateOutputReference;
        /**
         * @stability stable
         */
        putLaunchTemplate(value: BatchComputeEnvironmentComputeResourcesLaunchTemplate | undefined): void;
        /**
         * @stability stable
         */
        resetLaunchTemplate(): void;
        /**
         * @stability stable
         */
        get launchTemplateInput(): BatchComputeEnvironmentComputeResourcesLaunchTemplate | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html aws_batch_compute_environment}.
     *
     * @stability stable
     */
    class BatchComputeEnvironment extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment.html aws_batch_compute_environment} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: BatchComputeEnvironmentConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _computeEnvironmentName?;
        /**
         * @stability stable
         */
        get computeEnvironmentName(): string | undefined;
        /**
         * @stability stable
         */
        set computeEnvironmentName(value: string | undefined);
        /**
         * @stability stable
         */
        resetComputeEnvironmentName(): void;
        /**
         * @stability stable
         */
        get computeEnvironmentNameInput(): string | undefined;
        private _computeEnvironmentNamePrefix?;
        /**
         * @stability stable
         */
        get computeEnvironmentNamePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set computeEnvironmentNamePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetComputeEnvironmentNamePrefix(): void;
        /**
         * @stability stable
         */
        get computeEnvironmentNamePrefixInput(): string | undefined;
        /**
         * @stability stable
         */
        get ecsClusterArn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _serviceRole?;
        /**
         * @stability stable
         */
        get serviceRole(): string | undefined;
        /**
         * @stability stable
         */
        set serviceRole(value: string | undefined);
        /**
         * @stability stable
         */
        resetServiceRole(): void;
        /**
         * @stability stable
         */
        get serviceRoleInput(): string | undefined;
        private _state?;
        /**
         * @stability stable
         */
        get state(): string | undefined;
        /**
         * @stability stable
         */
        set state(value: string | undefined);
        /**
         * @stability stable
         */
        resetState(): void;
        /**
         * @stability stable
         */
        get stateInput(): string | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        get statusReason(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _computeResources?;
        private __computeResourcesOutput;
        /**
         * @stability stable
         */
        get computeResources(): BatchComputeEnvironmentComputeResourcesOutputReference;
        /**
         * @stability stable
         */
        putComputeResources(value: BatchComputeEnvironmentComputeResources | undefined): void;
        /**
         * @stability stable
         */
        resetComputeResources(): void;
        /**
         * @stability stable
         */
        get computeResourcesInput(): BatchComputeEnvironmentComputeResources | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface BatchJobDefinitionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#container_properties BatchJobDefinition#container_properties}.
         *
         * @stability stable
         */
        readonly containerProperties?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#name BatchJobDefinition#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#parameters BatchJobDefinition#parameters}.
         *
         * @stability stable
         */
        readonly parameters?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#platform_capabilities BatchJobDefinition#platform_capabilities}.
         *
         * @stability stable
         */
        readonly platformCapabilities?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#propagate_tags BatchJobDefinition#propagate_tags}.
         *
         * @stability stable
         */
        readonly propagateTags?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#tags BatchJobDefinition#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#tags_all BatchJobDefinition#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#type BatchJobDefinition#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * retry_strategy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#retry_strategy BatchJobDefinition#retry_strategy}
         *
         * @stability stable
         */
        readonly retryStrategy?: BatchJobDefinitionRetryStrategy;
        /**
         * timeout block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#timeout BatchJobDefinition#timeout}
         *
         * @stability stable
         */
        readonly timeout?: BatchJobDefinitionTimeout;
    }
    /**
     * @stability stable
     */
    interface BatchJobDefinitionRetryStrategyEvaluateOnExit {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#action BatchJobDefinition#action}.
         *
         * @stability stable
         */
        readonly action: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#on_exit_code BatchJobDefinition#on_exit_code}.
         *
         * @stability stable
         */
        readonly onExitCode?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#on_reason BatchJobDefinition#on_reason}.
         *
         * @stability stable
         */
        readonly onReason?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#on_status_reason BatchJobDefinition#on_status_reason}.
         *
         * @stability stable
         */
        readonly onStatusReason?: string;
    }
    /**
     * @stability stable
     */
    interface BatchJobDefinitionRetryStrategy {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#attempts BatchJobDefinition#attempts}.
         *
         * @stability stable
         */
        readonly attempts?: number;
        /**
         * evaluate_on_exit block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#evaluate_on_exit BatchJobDefinition#evaluate_on_exit}
         *
         * @stability stable
         */
        readonly evaluateOnExit?: BatchJobDefinitionRetryStrategyEvaluateOnExit[];
    }
    /**
     * @stability stable
     */
    class BatchJobDefinitionRetryStrategyOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _attempts?;
        /**
         * @stability stable
         */
        get attempts(): number | undefined;
        /**
         * @stability stable
         */
        set attempts(value: number | undefined);
        /**
         * @stability stable
         */
        resetAttempts(): void;
        /**
         * @stability stable
         */
        get attemptsInput(): number | undefined;
        private _evaluateOnExit?;
        /**
         * @stability stable
         */
        get evaluateOnExit(): BatchJobDefinitionRetryStrategyEvaluateOnExit[] | undefined;
        /**
         * @stability stable
         */
        set evaluateOnExit(value: BatchJobDefinitionRetryStrategyEvaluateOnExit[] | undefined);
        /**
         * @stability stable
         */
        resetEvaluateOnExit(): void;
        /**
         * @stability stable
         */
        get evaluateOnExitInput(): BatchJobDefinitionRetryStrategyEvaluateOnExit[] | undefined;
    }
    /**
     * @stability stable
     */
    interface BatchJobDefinitionTimeout {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html#attempt_duration_seconds BatchJobDefinition#attempt_duration_seconds}.
         *
         * @stability stable
         */
        readonly attemptDurationSeconds?: number;
    }
    /**
     * @stability stable
     */
    class BatchJobDefinitionTimeoutOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _attemptDurationSeconds?;
        /**
         * @stability stable
         */
        get attemptDurationSeconds(): number | undefined;
        /**
         * @stability stable
         */
        set attemptDurationSeconds(value: number | undefined);
        /**
         * @stability stable
         */
        resetAttemptDurationSeconds(): void;
        /**
         * @stability stable
         */
        get attemptDurationSecondsInput(): number | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html aws_batch_job_definition}.
     *
     * @stability stable
     */
    class BatchJobDefinition extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/batch_job_definition.html aws_batch_job_definition} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: BatchJobDefinitionConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _containerProperties?;
        /**
         * @stability stable
         */
        get containerProperties(): string | undefined;
        /**
         * @stability stable
         */
        set containerProperties(value: string | undefined);
        /**
         * @stability stable
         */
        resetContainerProperties(): void;
        /**
         * @stability stable
         */
        get containerPropertiesInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _parameters?;
        /**
         * @stability stable
         */
        get parameters(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set parameters(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetParameters(): void;
        /**
         * @stability stable
         */
        get parametersInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _platformCapabilities?;
        /**
         * @stability stable
         */
        get platformCapabilities(): string[] | undefined;
        /**
         * @stability stable
         */
        set platformCapabilities(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetPlatformCapabilities(): void;
        /**
         * @stability stable
         */
        get platformCapabilitiesInput(): string[] | undefined;
        private _propagateTags?;
        /**
         * @stability stable
         */
        get propagateTags(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set propagateTags(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetPropagateTags(): void;
        /**
         * @stability stable
         */
        get propagateTagsInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get revision(): number;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _retryStrategy?;
        private __retryStrategyOutput;
        /**
         * @stability stable
         */
        get retryStrategy(): BatchJobDefinitionRetryStrategyOutputReference;
        /**
         * @stability stable
         */
        putRetryStrategy(value: BatchJobDefinitionRetryStrategy | undefined): void;
        /**
         * @stability stable
         */
        resetRetryStrategy(): void;
        /**
         * @stability stable
         */
        get retryStrategyInput(): BatchJobDefinitionRetryStrategy | undefined;
        private _timeout?;
        private __timeoutOutput;
        /**
         * @stability stable
         */
        get timeout(): BatchJobDefinitionTimeoutOutputReference;
        /**
         * @stability stable
         */
        putTimeout(value: BatchJobDefinitionTimeout | undefined): void;
        /**
         * @stability stable
         */
        resetTimeout(): void;
        /**
         * @stability stable
         */
        get timeoutInput(): BatchJobDefinitionTimeout | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface BatchJobQueueConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_queue.html#compute_environments BatchJobQueue#compute_environments}.
         *
         * @stability stable
         */
        readonly computeEnvironments: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_queue.html#name BatchJobQueue#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_queue.html#priority BatchJobQueue#priority}.
         *
         * @stability stable
         */
        readonly priority: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_queue.html#state BatchJobQueue#state}.
         *
         * @stability stable
         */
        readonly state: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_queue.html#tags BatchJobQueue#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_job_queue.html#tags_all BatchJobQueue#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/batch_job_queue.html aws_batch_job_queue}.
     *
     * @stability stable
     */
    class BatchJobQueue extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/batch_job_queue.html aws_batch_job_queue} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: BatchJobQueueConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _computeEnvironments?;
        /**
         * @stability stable
         */
        get computeEnvironments(): string[];
        /**
         * @stability stable
         */
        set computeEnvironments(value: string[]);
        /**
         * @stability stable
         */
        get computeEnvironmentsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _priority?;
        /**
         * @stability stable
         */
        get priority(): number;
        /**
         * @stability stable
         */
        set priority(value: number);
        /**
         * @stability stable
         */
        get priorityInput(): number | undefined;
        private _state?;
        /**
         * @stability stable
         */
        get state(): string;
        /**
         * @stability stable
         */
        set state(value: string);
        /**
         * @stability stable
         */
        get stateInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsBatchComputeEnvironmentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/batch_compute_environment.html#compute_environment_name DataAwsBatchComputeEnvironment#compute_environment_name}.
         *
         * @stability stable
         */
        readonly computeEnvironmentName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/batch_compute_environment.html#tags DataAwsBatchComputeEnvironment#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/batch_compute_environment.html aws_batch_compute_environment}.
     *
     * @stability stable
     */
    class DataAwsBatchComputeEnvironment extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/batch_compute_environment.html aws_batch_compute_environment} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsBatchComputeEnvironmentConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _computeEnvironmentName?;
        /**
         * @stability stable
         */
        get computeEnvironmentName(): string;
        /**
         * @stability stable
         */
        set computeEnvironmentName(value: string);
        /**
         * @stability stable
         */
        get computeEnvironmentNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get ecsClusterArn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get serviceRole(): string;
        /**
         * @stability stable
         */
        get state(): string;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        get statusReason(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsBatchJobQueueConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/batch_job_queue.html#name DataAwsBatchJobQueue#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/batch_job_queue.html#tags DataAwsBatchJobQueue#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class DataAwsBatchJobQueueComputeEnvironmentOrder extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get computeEnvironment(): string;
        /**
         * @stability stable
         */
        get order(): number;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/batch_job_queue.html aws_batch_job_queue}.
     *
     * @stability stable
     */
    class DataAwsBatchJobQueue extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/batch_job_queue.html aws_batch_job_queue} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsBatchJobQueueConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        computeEnvironmentOrder(index: string): DataAwsBatchJobQueueComputeEnvironmentOrder;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get priority(): number;
        /**
         * @stability stable
         */
        get state(): string;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        get statusReason(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
