import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Budgets
*/
export declare namespace Budgets {
    /**
     * @stability stable
     */
    interface BudgetsBudgetConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#account_id BudgetsBudget#account_id}.
         *
         * @stability stable
         */
        readonly accountId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#budget_type BudgetsBudget#budget_type}.
         *
         * @stability stable
         */
        readonly budgetType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#cost_filters BudgetsBudget#cost_filters}.
         *
         * @stability stable
         */
        readonly costFilters?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#limit_amount BudgetsBudget#limit_amount}.
         *
         * @stability stable
         */
        readonly limitAmount: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#limit_unit BudgetsBudget#limit_unit}.
         *
         * @stability stable
         */
        readonly limitUnit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#name BudgetsBudget#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#name_prefix BudgetsBudget#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#time_period_end BudgetsBudget#time_period_end}.
         *
         * @stability stable
         */
        readonly timePeriodEnd?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#time_period_start BudgetsBudget#time_period_start}.
         *
         * @stability stable
         */
        readonly timePeriodStart?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#time_unit BudgetsBudget#time_unit}.
         *
         * @stability stable
         */
        readonly timeUnit: string;
        /**
         * cost_filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#cost_filter BudgetsBudget#cost_filter}
         *
         * @stability stable
         */
        readonly costFilter?: BudgetsBudgetCostFilter[];
        /**
         * cost_types block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#cost_types BudgetsBudget#cost_types}
         *
         * @stability stable
         */
        readonly costTypes?: BudgetsBudgetCostTypes;
        /**
         * notification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#notification BudgetsBudget#notification}
         *
         * @stability stable
         */
        readonly notification?: BudgetsBudgetNotification[];
    }
    /**
     * @stability stable
     */
    interface BudgetsBudgetCostFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#name BudgetsBudget#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#values BudgetsBudget#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * @stability stable
     */
    interface BudgetsBudgetCostTypes {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_credit BudgetsBudget#include_credit}.
         *
         * @stability stable
         */
        readonly includeCredit?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_discount BudgetsBudget#include_discount}.
         *
         * @stability stable
         */
        readonly includeDiscount?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_other_subscription BudgetsBudget#include_other_subscription}.
         *
         * @stability stable
         */
        readonly includeOtherSubscription?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_recurring BudgetsBudget#include_recurring}.
         *
         * @stability stable
         */
        readonly includeRecurring?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_refund BudgetsBudget#include_refund}.
         *
         * @stability stable
         */
        readonly includeRefund?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_subscription BudgetsBudget#include_subscription}.
         *
         * @stability stable
         */
        readonly includeSubscription?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_support BudgetsBudget#include_support}.
         *
         * @stability stable
         */
        readonly includeSupport?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_tax BudgetsBudget#include_tax}.
         *
         * @stability stable
         */
        readonly includeTax?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#include_upfront BudgetsBudget#include_upfront}.
         *
         * @stability stable
         */
        readonly includeUpfront?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#use_amortized BudgetsBudget#use_amortized}.
         *
         * @stability stable
         */
        readonly useAmortized?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#use_blended BudgetsBudget#use_blended}.
         *
         * @stability stable
         */
        readonly useBlended?: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class BudgetsBudgetCostTypesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _includeCredit?;
        /**
         * @stability stable
         */
        get includeCredit(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set includeCredit(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIncludeCredit(): void;
        /**
         * @stability stable
         */
        get includeCreditInput(): boolean | cdktf.IResolvable | undefined;
        private _includeDiscount?;
        /**
         * @stability stable
         */
        get includeDiscount(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set includeDiscount(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIncludeDiscount(): void;
        /**
         * @stability stable
         */
        get includeDiscountInput(): boolean | cdktf.IResolvable | undefined;
        private _includeOtherSubscription?;
        /**
         * @stability stable
         */
        get includeOtherSubscription(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set includeOtherSubscription(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIncludeOtherSubscription(): void;
        /**
         * @stability stable
         */
        get includeOtherSubscriptionInput(): boolean | cdktf.IResolvable | undefined;
        private _includeRecurring?;
        /**
         * @stability stable
         */
        get includeRecurring(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set includeRecurring(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIncludeRecurring(): void;
        /**
         * @stability stable
         */
        get includeRecurringInput(): boolean | cdktf.IResolvable | undefined;
        private _includeRefund?;
        /**
         * @stability stable
         */
        get includeRefund(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set includeRefund(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIncludeRefund(): void;
        /**
         * @stability stable
         */
        get includeRefundInput(): boolean | cdktf.IResolvable | undefined;
        private _includeSubscription?;
        /**
         * @stability stable
         */
        get includeSubscription(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set includeSubscription(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIncludeSubscription(): void;
        /**
         * @stability stable
         */
        get includeSubscriptionInput(): boolean | cdktf.IResolvable | undefined;
        private _includeSupport?;
        /**
         * @stability stable
         */
        get includeSupport(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set includeSupport(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIncludeSupport(): void;
        /**
         * @stability stable
         */
        get includeSupportInput(): boolean | cdktf.IResolvable | undefined;
        private _includeTax?;
        /**
         * @stability stable
         */
        get includeTax(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set includeTax(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIncludeTax(): void;
        /**
         * @stability stable
         */
        get includeTaxInput(): boolean | cdktf.IResolvable | undefined;
        private _includeUpfront?;
        /**
         * @stability stable
         */
        get includeUpfront(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set includeUpfront(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIncludeUpfront(): void;
        /**
         * @stability stable
         */
        get includeUpfrontInput(): boolean | cdktf.IResolvable | undefined;
        private _useAmortized?;
        /**
         * @stability stable
         */
        get useAmortized(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set useAmortized(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUseAmortized(): void;
        /**
         * @stability stable
         */
        get useAmortizedInput(): boolean | cdktf.IResolvable | undefined;
        private _useBlended?;
        /**
         * @stability stable
         */
        get useBlended(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set useBlended(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUseBlended(): void;
        /**
         * @stability stable
         */
        get useBlendedInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * @stability stable
     */
    interface BudgetsBudgetNotification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#comparison_operator BudgetsBudget#comparison_operator}.
         *
         * @stability stable
         */
        readonly comparisonOperator: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#notification_type BudgetsBudget#notification_type}.
         *
         * @stability stable
         */
        readonly notificationType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#subscriber_email_addresses BudgetsBudget#subscriber_email_addresses}.
         *
         * @stability stable
         */
        readonly subscriberEmailAddresses?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#subscriber_sns_topic_arns BudgetsBudget#subscriber_sns_topic_arns}.
         *
         * @stability stable
         */
        readonly subscriberSnsTopicArns?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#threshold BudgetsBudget#threshold}.
         *
         * @stability stable
         */
        readonly threshold: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html#threshold_type BudgetsBudget#threshold_type}.
         *
         * @stability stable
         */
        readonly thresholdType: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html aws_budgets_budget}.
     *
     * @stability stable
     */
    class BudgetsBudget extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget.html aws_budgets_budget} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: BudgetsBudgetConfig);
        private _accountId?;
        /**
         * @stability stable
         */
        get accountId(): string | undefined;
        /**
         * @stability stable
         */
        set accountId(value: string | undefined);
        /**
         * @stability stable
         */
        resetAccountId(): void;
        /**
         * @stability stable
         */
        get accountIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _budgetType?;
        /**
         * @stability stable
         */
        get budgetType(): string;
        /**
         * @stability stable
         */
        set budgetType(value: string);
        /**
         * @stability stable
         */
        get budgetTypeInput(): string | undefined;
        private _costFilters?;
        /**
         * @stability stable
         */
        get costFilters(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set costFilters(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetCostFilters(): void;
        /**
         * @stability stable
         */
        get costFiltersInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _limitAmount?;
        /**
         * @stability stable
         */
        get limitAmount(): string;
        /**
         * @stability stable
         */
        set limitAmount(value: string);
        /**
         * @stability stable
         */
        get limitAmountInput(): string | undefined;
        private _limitUnit?;
        /**
         * @stability stable
         */
        get limitUnit(): string;
        /**
         * @stability stable
         */
        set limitUnit(value: string);
        /**
         * @stability stable
         */
        get limitUnitInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set namePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamePrefix(): void;
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        private _timePeriodEnd?;
        /**
         * @stability stable
         */
        get timePeriodEnd(): string | undefined;
        /**
         * @stability stable
         */
        set timePeriodEnd(value: string | undefined);
        /**
         * @stability stable
         */
        resetTimePeriodEnd(): void;
        /**
         * @stability stable
         */
        get timePeriodEndInput(): string | undefined;
        private _timePeriodStart?;
        /**
         * @stability stable
         */
        get timePeriodStart(): string | undefined;
        /**
         * @stability stable
         */
        set timePeriodStart(value: string | undefined);
        /**
         * @stability stable
         */
        resetTimePeriodStart(): void;
        /**
         * @stability stable
         */
        get timePeriodStartInput(): string | undefined;
        private _timeUnit?;
        /**
         * @stability stable
         */
        get timeUnit(): string;
        /**
         * @stability stable
         */
        set timeUnit(value: string);
        /**
         * @stability stable
         */
        get timeUnitInput(): string | undefined;
        private _costFilter?;
        /**
         * @stability stable
         */
        get costFilter(): BudgetsBudgetCostFilter[] | undefined;
        /**
         * @stability stable
         */
        set costFilter(value: BudgetsBudgetCostFilter[] | undefined);
        /**
         * @stability stable
         */
        resetCostFilter(): void;
        /**
         * @stability stable
         */
        get costFilterInput(): BudgetsBudgetCostFilter[] | undefined;
        private _costTypes?;
        private __costTypesOutput;
        /**
         * @stability stable
         */
        get costTypes(): BudgetsBudgetCostTypesOutputReference;
        /**
         * @stability stable
         */
        putCostTypes(value: BudgetsBudgetCostTypes | undefined): void;
        /**
         * @stability stable
         */
        resetCostTypes(): void;
        /**
         * @stability stable
         */
        get costTypesInput(): BudgetsBudgetCostTypes | undefined;
        private _notification?;
        /**
         * @stability stable
         */
        get notification(): BudgetsBudgetNotification[] | undefined;
        /**
         * @stability stable
         */
        set notification(value: BudgetsBudgetNotification[] | undefined);
        /**
         * @stability stable
         */
        resetNotification(): void;
        /**
         * @stability stable
         */
        get notificationInput(): BudgetsBudgetNotification[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface BudgetsBudgetActionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#account_id BudgetsBudgetAction#account_id}.
         *
         * @stability stable
         */
        readonly accountId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#action_type BudgetsBudgetAction#action_type}.
         *
         * @stability stable
         */
        readonly actionType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#approval_model BudgetsBudgetAction#approval_model}.
         *
         * @stability stable
         */
        readonly approvalModel: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#budget_name BudgetsBudgetAction#budget_name}.
         *
         * @stability stable
         */
        readonly budgetName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#execution_role_arn BudgetsBudgetAction#execution_role_arn}.
         *
         * @stability stable
         */
        readonly executionRoleArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#notification_type BudgetsBudgetAction#notification_type}.
         *
         * @stability stable
         */
        readonly notificationType: string;
        /**
         * action_threshold block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#action_threshold BudgetsBudgetAction#action_threshold}
         *
         * @stability stable
         */
        readonly actionThreshold: BudgetsBudgetActionActionThreshold;
        /**
         * definition block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#definition BudgetsBudgetAction#definition}
         *
         * @stability stable
         */
        readonly definition: BudgetsBudgetActionDefinition;
        /**
         * subscriber block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#subscriber BudgetsBudgetAction#subscriber}
         *
         * @stability stable
         */
        readonly subscriber: BudgetsBudgetActionSubscriber[];
    }
    /**
     * @stability stable
     */
    interface BudgetsBudgetActionActionThreshold {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#action_threshold_type BudgetsBudgetAction#action_threshold_type}.
         *
         * @stability stable
         */
        readonly actionThresholdType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#action_threshold_value BudgetsBudgetAction#action_threshold_value}.
         *
         * @stability stable
         */
        readonly actionThresholdValue: number;
    }
    /**
     * @stability stable
     */
    class BudgetsBudgetActionActionThresholdOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _actionThresholdType?;
        /**
         * @stability stable
         */
        get actionThresholdType(): string;
        /**
         * @stability stable
         */
        set actionThresholdType(value: string);
        /**
         * @stability stable
         */
        get actionThresholdTypeInput(): string | undefined;
        private _actionThresholdValue?;
        /**
         * @stability stable
         */
        get actionThresholdValue(): number;
        /**
         * @stability stable
         */
        set actionThresholdValue(value: number);
        /**
         * @stability stable
         */
        get actionThresholdValueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface BudgetsBudgetActionDefinitionIamActionDefinition {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#groups BudgetsBudgetAction#groups}.
         *
         * @stability stable
         */
        readonly groups?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#policy_arn BudgetsBudgetAction#policy_arn}.
         *
         * @stability stable
         */
        readonly policyArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#roles BudgetsBudgetAction#roles}.
         *
         * @stability stable
         */
        readonly roles?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#users BudgetsBudgetAction#users}.
         *
         * @stability stable
         */
        readonly users?: string[];
    }
    /**
     * @stability stable
     */
    class BudgetsBudgetActionDefinitionIamActionDefinitionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _groups?;
        /**
         * @stability stable
         */
        get groups(): string[] | undefined;
        /**
         * @stability stable
         */
        set groups(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetGroups(): void;
        /**
         * @stability stable
         */
        get groupsInput(): string[] | undefined;
        private _policyArn?;
        /**
         * @stability stable
         */
        get policyArn(): string;
        /**
         * @stability stable
         */
        set policyArn(value: string);
        /**
         * @stability stable
         */
        get policyArnInput(): string | undefined;
        private _roles?;
        /**
         * @stability stable
         */
        get roles(): string[] | undefined;
        /**
         * @stability stable
         */
        set roles(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetRoles(): void;
        /**
         * @stability stable
         */
        get rolesInput(): string[] | undefined;
        private _users?;
        /**
         * @stability stable
         */
        get users(): string[] | undefined;
        /**
         * @stability stable
         */
        set users(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetUsers(): void;
        /**
         * @stability stable
         */
        get usersInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface BudgetsBudgetActionDefinitionScpActionDefinition {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#policy_id BudgetsBudgetAction#policy_id}.
         *
         * @stability stable
         */
        readonly policyId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#target_ids BudgetsBudgetAction#target_ids}.
         *
         * @stability stable
         */
        readonly targetIds: string[];
    }
    /**
     * @stability stable
     */
    class BudgetsBudgetActionDefinitionScpActionDefinitionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _policyId?;
        /**
         * @stability stable
         */
        get policyId(): string;
        /**
         * @stability stable
         */
        set policyId(value: string);
        /**
         * @stability stable
         */
        get policyIdInput(): string | undefined;
        private _targetIds?;
        /**
         * @stability stable
         */
        get targetIds(): string[];
        /**
         * @stability stable
         */
        set targetIds(value: string[]);
        /**
         * @stability stable
         */
        get targetIdsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface BudgetsBudgetActionDefinitionSsmActionDefinition {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#action_sub_type BudgetsBudgetAction#action_sub_type}.
         *
         * @stability stable
         */
        readonly actionSubType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#instance_ids BudgetsBudgetAction#instance_ids}.
         *
         * @stability stable
         */
        readonly instanceIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#region BudgetsBudgetAction#region}.
         *
         * @stability stable
         */
        readonly region: string;
    }
    /**
     * @stability stable
     */
    class BudgetsBudgetActionDefinitionSsmActionDefinitionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _actionSubType?;
        /**
         * @stability stable
         */
        get actionSubType(): string;
        /**
         * @stability stable
         */
        set actionSubType(value: string);
        /**
         * @stability stable
         */
        get actionSubTypeInput(): string | undefined;
        private _instanceIds?;
        /**
         * @stability stable
         */
        get instanceIds(): string[];
        /**
         * @stability stable
         */
        set instanceIds(value: string[]);
        /**
         * @stability stable
         */
        get instanceIdsInput(): string[] | undefined;
        private _region?;
        /**
         * @stability stable
         */
        get region(): string;
        /**
         * @stability stable
         */
        set region(value: string);
        /**
         * @stability stable
         */
        get regionInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface BudgetsBudgetActionDefinition {
        /**
         * iam_action_definition block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#iam_action_definition BudgetsBudgetAction#iam_action_definition}
         *
         * @stability stable
         */
        readonly iamActionDefinition?: BudgetsBudgetActionDefinitionIamActionDefinition;
        /**
         * scp_action_definition block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#scp_action_definition BudgetsBudgetAction#scp_action_definition}
         *
         * @stability stable
         */
        readonly scpActionDefinition?: BudgetsBudgetActionDefinitionScpActionDefinition;
        /**
         * ssm_action_definition block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#ssm_action_definition BudgetsBudgetAction#ssm_action_definition}
         *
         * @stability stable
         */
        readonly ssmActionDefinition?: BudgetsBudgetActionDefinitionSsmActionDefinition;
    }
    /**
     * @stability stable
     */
    class BudgetsBudgetActionDefinitionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _iamActionDefinition?;
        private __iamActionDefinitionOutput;
        /**
         * @stability stable
         */
        get iamActionDefinition(): BudgetsBudgetActionDefinitionIamActionDefinitionOutputReference;
        /**
         * @stability stable
         */
        putIamActionDefinition(value: BudgetsBudgetActionDefinitionIamActionDefinition | undefined): void;
        /**
         * @stability stable
         */
        resetIamActionDefinition(): void;
        /**
         * @stability stable
         */
        get iamActionDefinitionInput(): BudgetsBudgetActionDefinitionIamActionDefinition | undefined;
        private _scpActionDefinition?;
        private __scpActionDefinitionOutput;
        /**
         * @stability stable
         */
        get scpActionDefinition(): BudgetsBudgetActionDefinitionScpActionDefinitionOutputReference;
        /**
         * @stability stable
         */
        putScpActionDefinition(value: BudgetsBudgetActionDefinitionScpActionDefinition | undefined): void;
        /**
         * @stability stable
         */
        resetScpActionDefinition(): void;
        /**
         * @stability stable
         */
        get scpActionDefinitionInput(): BudgetsBudgetActionDefinitionScpActionDefinition | undefined;
        private _ssmActionDefinition?;
        private __ssmActionDefinitionOutput;
        /**
         * @stability stable
         */
        get ssmActionDefinition(): BudgetsBudgetActionDefinitionSsmActionDefinitionOutputReference;
        /**
         * @stability stable
         */
        putSsmActionDefinition(value: BudgetsBudgetActionDefinitionSsmActionDefinition | undefined): void;
        /**
         * @stability stable
         */
        resetSsmActionDefinition(): void;
        /**
         * @stability stable
         */
        get ssmActionDefinitionInput(): BudgetsBudgetActionDefinitionSsmActionDefinition | undefined;
    }
    /**
     * @stability stable
     */
    interface BudgetsBudgetActionSubscriber {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#address BudgetsBudgetAction#address}.
         *
         * @stability stable
         */
        readonly address: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html#subscription_type BudgetsBudgetAction#subscription_type}.
         *
         * @stability stable
         */
        readonly subscriptionType: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html aws_budgets_budget_action}.
     *
     * @stability stable
     */
    class BudgetsBudgetAction extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action.html aws_budgets_budget_action} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: BudgetsBudgetActionConfig);
        private _accountId?;
        /**
         * @stability stable
         */
        get accountId(): string | undefined;
        /**
         * @stability stable
         */
        set accountId(value: string | undefined);
        /**
         * @stability stable
         */
        resetAccountId(): void;
        /**
         * @stability stable
         */
        get accountIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get actionId(): string;
        private _actionType?;
        /**
         * @stability stable
         */
        get actionType(): string;
        /**
         * @stability stable
         */
        set actionType(value: string);
        /**
         * @stability stable
         */
        get actionTypeInput(): string | undefined;
        private _approvalModel?;
        /**
         * @stability stable
         */
        get approvalModel(): string;
        /**
         * @stability stable
         */
        set approvalModel(value: string);
        /**
         * @stability stable
         */
        get approvalModelInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _budgetName?;
        /**
         * @stability stable
         */
        get budgetName(): string;
        /**
         * @stability stable
         */
        set budgetName(value: string);
        /**
         * @stability stable
         */
        get budgetNameInput(): string | undefined;
        private _executionRoleArn?;
        /**
         * @stability stable
         */
        get executionRoleArn(): string;
        /**
         * @stability stable
         */
        set executionRoleArn(value: string);
        /**
         * @stability stable
         */
        get executionRoleArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _notificationType?;
        /**
         * @stability stable
         */
        get notificationType(): string;
        /**
         * @stability stable
         */
        set notificationType(value: string);
        /**
         * @stability stable
         */
        get notificationTypeInput(): string | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        private _actionThreshold?;
        private __actionThresholdOutput;
        /**
         * @stability stable
         */
        get actionThreshold(): BudgetsBudgetActionActionThresholdOutputReference;
        /**
         * @stability stable
         */
        putActionThreshold(value: BudgetsBudgetActionActionThreshold): void;
        /**
         * @stability stable
         */
        get actionThresholdInput(): BudgetsBudgetActionActionThreshold | undefined;
        private _definition?;
        private __definitionOutput;
        /**
         * @stability stable
         */
        get definition(): BudgetsBudgetActionDefinitionOutputReference;
        /**
         * @stability stable
         */
        putDefinition(value: BudgetsBudgetActionDefinition): void;
        /**
         * @stability stable
         */
        get definitionInput(): BudgetsBudgetActionDefinition | undefined;
        private _subscriber?;
        /**
         * @stability stable
         */
        get subscriber(): BudgetsBudgetActionSubscriber[];
        /**
         * @stability stable
         */
        set subscriber(value: BudgetsBudgetActionSubscriber[]);
        /**
         * @stability stable
         */
        get subscriberInput(): BudgetsBudgetActionSubscriber[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
