import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* Amazon Chime
*/
export declare namespace Chime {
    /**
     * @stability stable
     */
    interface ChimeVoiceConnectorConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector.html#aws_region ChimeVoiceConnector#aws_region}.
         *
         * @stability stable
         */
        readonly awsRegion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector.html#name ChimeVoiceConnector#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector.html#require_encryption ChimeVoiceConnector#require_encryption}.
         *
         * @stability stable
         */
        readonly requireEncryption: boolean | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector.html aws_chime_voice_connector}.
     *
     * @stability stable
     */
    class ChimeVoiceConnector extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector.html aws_chime_voice_connector} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ChimeVoiceConnectorConfig);
        private _awsRegion?;
        /**
         * @stability stable
         */
        get awsRegion(): string | undefined;
        /**
         * @stability stable
         */
        set awsRegion(value: string | undefined);
        /**
         * @stability stable
         */
        resetAwsRegion(): void;
        /**
         * @stability stable
         */
        get awsRegionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get outboundHostName(): string;
        private _requireEncryption?;
        /**
         * @stability stable
         */
        get requireEncryption(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set requireEncryption(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get requireEncryptionInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ChimeVoiceConnectorGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_group.html#name ChimeVoiceConnectorGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * connector block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_group.html#connector ChimeVoiceConnectorGroup#connector}
         *
         * @stability stable
         */
        readonly connector?: ChimeVoiceConnectorGroupConnector[];
    }
    /**
     * @stability stable
     */
    interface ChimeVoiceConnectorGroupConnector {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_group.html#priority ChimeVoiceConnectorGroup#priority}.
         *
         * @stability stable
         */
        readonly priority: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_group.html#voice_connector_id ChimeVoiceConnectorGroup#voice_connector_id}.
         *
         * @stability stable
         */
        readonly voiceConnectorId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_group.html aws_chime_voice_connector_group}.
     *
     * @stability stable
     */
    class ChimeVoiceConnectorGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_group.html aws_chime_voice_connector_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ChimeVoiceConnectorGroupConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _connector?;
        /**
         * @stability stable
         */
        get connector(): ChimeVoiceConnectorGroupConnector[] | undefined;
        /**
         * @stability stable
         */
        set connector(value: ChimeVoiceConnectorGroupConnector[] | undefined);
        /**
         * @stability stable
         */
        resetConnector(): void;
        /**
         * @stability stable
         */
        get connectorInput(): ChimeVoiceConnectorGroupConnector[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ChimeVoiceConnectorLoggingConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_logging.html#enable_sip_logs ChimeVoiceConnectorLogging#enable_sip_logs}.
         *
         * @stability stable
         */
        readonly enableSipLogs?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_logging.html#voice_connector_id ChimeVoiceConnectorLogging#voice_connector_id}.
         *
         * @stability stable
         */
        readonly voiceConnectorId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_logging.html aws_chime_voice_connector_logging}.
     *
     * @stability stable
     */
    class ChimeVoiceConnectorLogging extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_logging.html aws_chime_voice_connector_logging} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ChimeVoiceConnectorLoggingConfig);
        private _enableSipLogs?;
        /**
         * @stability stable
         */
        get enableSipLogs(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableSipLogs(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableSipLogs(): void;
        /**
         * @stability stable
         */
        get enableSipLogsInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _voiceConnectorId?;
        /**
         * @stability stable
         */
        get voiceConnectorId(): string;
        /**
         * @stability stable
         */
        set voiceConnectorId(value: string);
        /**
         * @stability stable
         */
        get voiceConnectorIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ChimeVoiceConnectorOriginationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_origination.html#disabled ChimeVoiceConnectorOrigination#disabled}.
         *
         * @stability stable
         */
        readonly disabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_origination.html#voice_connector_id ChimeVoiceConnectorOrigination#voice_connector_id}.
         *
         * @stability stable
         */
        readonly voiceConnectorId: string;
        /**
         * route block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_origination.html#route ChimeVoiceConnectorOrigination#route}
         *
         * @stability stable
         */
        readonly route: ChimeVoiceConnectorOriginationRoute[];
    }
    /**
     * @stability stable
     */
    interface ChimeVoiceConnectorOriginationRoute {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_origination.html#host ChimeVoiceConnectorOrigination#host}.
         *
         * @stability stable
         */
        readonly host: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_origination.html#port ChimeVoiceConnectorOrigination#port}.
         *
         * @stability stable
         */
        readonly port?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_origination.html#priority ChimeVoiceConnectorOrigination#priority}.
         *
         * @stability stable
         */
        readonly priority: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_origination.html#protocol ChimeVoiceConnectorOrigination#protocol}.
         *
         * @stability stable
         */
        readonly protocol: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_origination.html#weight ChimeVoiceConnectorOrigination#weight}.
         *
         * @stability stable
         */
        readonly weight: number;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_origination.html aws_chime_voice_connector_origination}.
     *
     * @stability stable
     */
    class ChimeVoiceConnectorOrigination extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_origination.html aws_chime_voice_connector_origination} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ChimeVoiceConnectorOriginationConfig);
        private _disabled?;
        /**
         * @stability stable
         */
        get disabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set disabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDisabled(): void;
        /**
         * @stability stable
         */
        get disabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _voiceConnectorId?;
        /**
         * @stability stable
         */
        get voiceConnectorId(): string;
        /**
         * @stability stable
         */
        set voiceConnectorId(value: string);
        /**
         * @stability stable
         */
        get voiceConnectorIdInput(): string | undefined;
        private _route?;
        /**
         * @stability stable
         */
        get route(): ChimeVoiceConnectorOriginationRoute[];
        /**
         * @stability stable
         */
        set route(value: ChimeVoiceConnectorOriginationRoute[]);
        /**
         * @stability stable
         */
        get routeInput(): ChimeVoiceConnectorOriginationRoute[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ChimeVoiceConnectorStreamingConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_streaming.html#data_retention ChimeVoiceConnectorStreaming#data_retention}.
         *
         * @stability stable
         */
        readonly dataRetention: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_streaming.html#disabled ChimeVoiceConnectorStreaming#disabled}.
         *
         * @stability stable
         */
        readonly disabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_streaming.html#streaming_notification_targets ChimeVoiceConnectorStreaming#streaming_notification_targets}.
         *
         * @stability stable
         */
        readonly streamingNotificationTargets?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_streaming.html#voice_connector_id ChimeVoiceConnectorStreaming#voice_connector_id}.
         *
         * @stability stable
         */
        readonly voiceConnectorId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_streaming.html aws_chime_voice_connector_streaming}.
     *
     * @stability stable
     */
    class ChimeVoiceConnectorStreaming extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_streaming.html aws_chime_voice_connector_streaming} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ChimeVoiceConnectorStreamingConfig);
        private _dataRetention?;
        /**
         * @stability stable
         */
        get dataRetention(): number;
        /**
         * @stability stable
         */
        set dataRetention(value: number);
        /**
         * @stability stable
         */
        get dataRetentionInput(): number | undefined;
        private _disabled?;
        /**
         * @stability stable
         */
        get disabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set disabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDisabled(): void;
        /**
         * @stability stable
         */
        get disabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _streamingNotificationTargets?;
        /**
         * @stability stable
         */
        get streamingNotificationTargets(): string[] | undefined;
        /**
         * @stability stable
         */
        set streamingNotificationTargets(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetStreamingNotificationTargets(): void;
        /**
         * @stability stable
         */
        get streamingNotificationTargetsInput(): string[] | undefined;
        private _voiceConnectorId?;
        /**
         * @stability stable
         */
        get voiceConnectorId(): string;
        /**
         * @stability stable
         */
        set voiceConnectorId(value: string);
        /**
         * @stability stable
         */
        get voiceConnectorIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ChimeVoiceConnectorTerminationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination.html#calling_regions ChimeVoiceConnectorTermination#calling_regions}.
         *
         * @stability stable
         */
        readonly callingRegions: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination.html#cidr_allow_list ChimeVoiceConnectorTermination#cidr_allow_list}.
         *
         * @stability stable
         */
        readonly cidrAllowList: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination.html#cps_limit ChimeVoiceConnectorTermination#cps_limit}.
         *
         * @stability stable
         */
        readonly cpsLimit?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination.html#default_phone_number ChimeVoiceConnectorTermination#default_phone_number}.
         *
         * @stability stable
         */
        readonly defaultPhoneNumber?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination.html#disabled ChimeVoiceConnectorTermination#disabled}.
         *
         * @stability stable
         */
        readonly disabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination.html#voice_connector_id ChimeVoiceConnectorTermination#voice_connector_id}.
         *
         * @stability stable
         */
        readonly voiceConnectorId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination.html aws_chime_voice_connector_termination}.
     *
     * @stability stable
     */
    class ChimeVoiceConnectorTermination extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination.html aws_chime_voice_connector_termination} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ChimeVoiceConnectorTerminationConfig);
        private _callingRegions?;
        /**
         * @stability stable
         */
        get callingRegions(): string[];
        /**
         * @stability stable
         */
        set callingRegions(value: string[]);
        /**
         * @stability stable
         */
        get callingRegionsInput(): string[] | undefined;
        private _cidrAllowList?;
        /**
         * @stability stable
         */
        get cidrAllowList(): string[];
        /**
         * @stability stable
         */
        set cidrAllowList(value: string[]);
        /**
         * @stability stable
         */
        get cidrAllowListInput(): string[] | undefined;
        private _cpsLimit?;
        /**
         * @stability stable
         */
        get cpsLimit(): number | undefined;
        /**
         * @stability stable
         */
        set cpsLimit(value: number | undefined);
        /**
         * @stability stable
         */
        resetCpsLimit(): void;
        /**
         * @stability stable
         */
        get cpsLimitInput(): number | undefined;
        private _defaultPhoneNumber?;
        /**
         * @stability stable
         */
        get defaultPhoneNumber(): string | undefined;
        /**
         * @stability stable
         */
        set defaultPhoneNumber(value: string | undefined);
        /**
         * @stability stable
         */
        resetDefaultPhoneNumber(): void;
        /**
         * @stability stable
         */
        get defaultPhoneNumberInput(): string | undefined;
        private _disabled?;
        /**
         * @stability stable
         */
        get disabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set disabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDisabled(): void;
        /**
         * @stability stable
         */
        get disabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _voiceConnectorId?;
        /**
         * @stability stable
         */
        get voiceConnectorId(): string;
        /**
         * @stability stable
         */
        set voiceConnectorId(value: string);
        /**
         * @stability stable
         */
        get voiceConnectorIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ChimeVoiceConnectorTerminationCredentialsConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination_credentials.html#voice_connector_id ChimeVoiceConnectorTerminationCredentials#voice_connector_id}.
         *
         * @stability stable
         */
        readonly voiceConnectorId: string;
        /**
         * credentials block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination_credentials.html#credentials ChimeVoiceConnectorTerminationCredentials#credentials}
         *
         * @stability stable
         */
        readonly credentials: ChimeVoiceConnectorTerminationCredentialsCredentials[];
    }
    /**
     * @stability stable
     */
    interface ChimeVoiceConnectorTerminationCredentialsCredentials {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination_credentials.html#password ChimeVoiceConnectorTerminationCredentials#password}.
         *
         * @stability stable
         */
        readonly password: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination_credentials.html#username ChimeVoiceConnectorTerminationCredentials#username}.
         *
         * @stability stable
         */
        readonly username: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination_credentials.html aws_chime_voice_connector_termination_credentials}.
     *
     * @stability stable
     */
    class ChimeVoiceConnectorTerminationCredentials extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_termination_credentials.html aws_chime_voice_connector_termination_credentials} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ChimeVoiceConnectorTerminationCredentialsConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _voiceConnectorId?;
        /**
         * @stability stable
         */
        get voiceConnectorId(): string;
        /**
         * @stability stable
         */
        set voiceConnectorId(value: string);
        /**
         * @stability stable
         */
        get voiceConnectorIdInput(): string | undefined;
        private _credentials?;
        /**
         * @stability stable
         */
        get credentials(): ChimeVoiceConnectorTerminationCredentialsCredentials[];
        /**
         * @stability stable
         */
        set credentials(value: ChimeVoiceConnectorTerminationCredentialsCredentials[]);
        /**
         * @stability stable
         */
        get credentialsInput(): ChimeVoiceConnectorTerminationCredentialsCredentials[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
