import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS CloudFront
*/
export declare namespace CloudFront {
    /**
     * @stability stable
     */
    interface CloudfrontCachePolicyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#comment CloudfrontCachePolicy#comment}.
         *
         * @stability stable
         */
        readonly comment?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#default_ttl CloudfrontCachePolicy#default_ttl}.
         *
         * @stability stable
         */
        readonly defaultTtl?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#etag CloudfrontCachePolicy#etag}.
         *
         * @stability stable
         */
        readonly etag?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#max_ttl CloudfrontCachePolicy#max_ttl}.
         *
         * @stability stable
         */
        readonly maxTtl?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#min_ttl CloudfrontCachePolicy#min_ttl}.
         *
         * @stability stable
         */
        readonly minTtl?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#name CloudfrontCachePolicy#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * parameters_in_cache_key_and_forwarded_to_origin block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#parameters_in_cache_key_and_forwarded_to_origin CloudfrontCachePolicy#parameters_in_cache_key_and_forwarded_to_origin}
         *
         * @stability stable
         */
        readonly parametersInCacheKeyAndForwardedToOrigin?: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOrigin;
    }
    /**
     * @stability stable
     */
    interface CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfigCookies {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#items CloudfrontCachePolicy#items}.
         *
         * @stability stable
         */
        readonly items?: string[];
    }
    /**
     * @stability stable
     */
    class CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfigCookiesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _items?;
        /**
         * @stability stable
         */
        get items(): string[] | undefined;
        /**
         * @stability stable
         */
        set items(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetItems(): void;
        /**
         * @stability stable
         */
        get itemsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#cookie_behavior CloudfrontCachePolicy#cookie_behavior}.
         *
         * @stability stable
         */
        readonly cookieBehavior: string;
        /**
         * cookies block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#cookies CloudfrontCachePolicy#cookies}
         *
         * @stability stable
         */
        readonly cookies?: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfigCookies;
    }
    /**
     * @stability stable
     */
    class CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _cookieBehavior?;
        /**
         * @stability stable
         */
        get cookieBehavior(): string;
        /**
         * @stability stable
         */
        set cookieBehavior(value: string);
        /**
         * @stability stable
         */
        get cookieBehaviorInput(): string | undefined;
        private _cookies?;
        private __cookiesOutput;
        /**
         * @stability stable
         */
        get cookies(): CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfigCookiesOutputReference;
        /**
         * @stability stable
         */
        putCookies(value: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfigCookies | undefined): void;
        /**
         * @stability stable
         */
        resetCookies(): void;
        /**
         * @stability stable
         */
        get cookiesInput(): CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfigCookies | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfigHeaders {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#items CloudfrontCachePolicy#items}.
         *
         * @stability stable
         */
        readonly items?: string[];
    }
    /**
     * @stability stable
     */
    class CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfigHeadersOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _items?;
        /**
         * @stability stable
         */
        get items(): string[] | undefined;
        /**
         * @stability stable
         */
        set items(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetItems(): void;
        /**
         * @stability stable
         */
        get itemsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#header_behavior CloudfrontCachePolicy#header_behavior}.
         *
         * @stability stable
         */
        readonly headerBehavior?: string;
        /**
         * headers block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#headers CloudfrontCachePolicy#headers}
         *
         * @stability stable
         */
        readonly headers?: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfigHeaders;
    }
    /**
     * @stability stable
     */
    class CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _headerBehavior?;
        /**
         * @stability stable
         */
        get headerBehavior(): string | undefined;
        /**
         * @stability stable
         */
        set headerBehavior(value: string | undefined);
        /**
         * @stability stable
         */
        resetHeaderBehavior(): void;
        /**
         * @stability stable
         */
        get headerBehaviorInput(): string | undefined;
        private _headers?;
        private __headersOutput;
        /**
         * @stability stable
         */
        get headers(): CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfigHeadersOutputReference;
        /**
         * @stability stable
         */
        putHeaders(value: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfigHeaders | undefined): void;
        /**
         * @stability stable
         */
        resetHeaders(): void;
        /**
         * @stability stable
         */
        get headersInput(): CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfigHeaders | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfigQueryStrings {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#items CloudfrontCachePolicy#items}.
         *
         * @stability stable
         */
        readonly items?: string[];
    }
    /**
     * @stability stable
     */
    class CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfigQueryStringsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _items?;
        /**
         * @stability stable
         */
        get items(): string[] | undefined;
        /**
         * @stability stable
         */
        set items(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetItems(): void;
        /**
         * @stability stable
         */
        get itemsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#query_string_behavior CloudfrontCachePolicy#query_string_behavior}.
         *
         * @stability stable
         */
        readonly queryStringBehavior: string;
        /**
         * query_strings block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#query_strings CloudfrontCachePolicy#query_strings}
         *
         * @stability stable
         */
        readonly queryStrings?: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfigQueryStrings;
    }
    /**
     * @stability stable
     */
    class CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _queryStringBehavior?;
        /**
         * @stability stable
         */
        get queryStringBehavior(): string;
        /**
         * @stability stable
         */
        set queryStringBehavior(value: string);
        /**
         * @stability stable
         */
        get queryStringBehaviorInput(): string | undefined;
        private _queryStrings?;
        private __queryStringsOutput;
        /**
         * @stability stable
         */
        get queryStrings(): CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfigQueryStringsOutputReference;
        /**
         * @stability stable
         */
        putQueryStrings(value: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfigQueryStrings | undefined): void;
        /**
         * @stability stable
         */
        resetQueryStrings(): void;
        /**
         * @stability stable
         */
        get queryStringsInput(): CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfigQueryStrings | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOrigin {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#enable_accept_encoding_brotli CloudfrontCachePolicy#enable_accept_encoding_brotli}.
         *
         * @stability stable
         */
        readonly enableAcceptEncodingBrotli?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#enable_accept_encoding_gzip CloudfrontCachePolicy#enable_accept_encoding_gzip}.
         *
         * @stability stable
         */
        readonly enableAcceptEncodingGzip?: boolean | cdktf.IResolvable;
        /**
         * cookies_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#cookies_config CloudfrontCachePolicy#cookies_config}
         *
         * @stability stable
         */
        readonly cookiesConfig: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfig;
        /**
         * headers_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#headers_config CloudfrontCachePolicy#headers_config}
         *
         * @stability stable
         */
        readonly headersConfig: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfig;
        /**
         * query_strings_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html#query_strings_config CloudfrontCachePolicy#query_strings_config}
         *
         * @stability stable
         */
        readonly queryStringsConfig: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfig;
    }
    /**
     * @stability stable
     */
    class CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enableAcceptEncodingBrotli?;
        /**
         * @stability stable
         */
        get enableAcceptEncodingBrotli(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableAcceptEncodingBrotli(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableAcceptEncodingBrotli(): void;
        /**
         * @stability stable
         */
        get enableAcceptEncodingBrotliInput(): boolean | cdktf.IResolvable | undefined;
        private _enableAcceptEncodingGzip?;
        /**
         * @stability stable
         */
        get enableAcceptEncodingGzip(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableAcceptEncodingGzip(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableAcceptEncodingGzip(): void;
        /**
         * @stability stable
         */
        get enableAcceptEncodingGzipInput(): boolean | cdktf.IResolvable | undefined;
        private _cookiesConfig?;
        private __cookiesConfigOutput;
        /**
         * @stability stable
         */
        get cookiesConfig(): CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfigOutputReference;
        /**
         * @stability stable
         */
        putCookiesConfig(value: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfig): void;
        /**
         * @stability stable
         */
        get cookiesConfigInput(): CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfig | undefined;
        private _headersConfig?;
        private __headersConfigOutput;
        /**
         * @stability stable
         */
        get headersConfig(): CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfigOutputReference;
        /**
         * @stability stable
         */
        putHeadersConfig(value: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfig): void;
        /**
         * @stability stable
         */
        get headersConfigInput(): CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfig | undefined;
        private _queryStringsConfig?;
        private __queryStringsConfigOutput;
        /**
         * @stability stable
         */
        get queryStringsConfig(): CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfigOutputReference;
        /**
         * @stability stable
         */
        putQueryStringsConfig(value: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfig): void;
        /**
         * @stability stable
         */
        get queryStringsConfigInput(): CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfig | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html aws_cloudfront_cache_policy}.
     *
     * @stability stable
     */
    class CloudfrontCachePolicy extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_cache_policy.html aws_cloudfront_cache_policy} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudfrontCachePolicyConfig);
        private _comment?;
        /**
         * @stability stable
         */
        get comment(): string | undefined;
        /**
         * @stability stable
         */
        set comment(value: string | undefined);
        /**
         * @stability stable
         */
        resetComment(): void;
        /**
         * @stability stable
         */
        get commentInput(): string | undefined;
        private _defaultTtl?;
        /**
         * @stability stable
         */
        get defaultTtl(): number | undefined;
        /**
         * @stability stable
         */
        set defaultTtl(value: number | undefined);
        /**
         * @stability stable
         */
        resetDefaultTtl(): void;
        /**
         * @stability stable
         */
        get defaultTtlInput(): number | undefined;
        private _etag?;
        /**
         * @stability stable
         */
        get etag(): string | undefined;
        /**
         * @stability stable
         */
        set etag(value: string | undefined);
        /**
         * @stability stable
         */
        resetEtag(): void;
        /**
         * @stability stable
         */
        get etagInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _maxTtl?;
        /**
         * @stability stable
         */
        get maxTtl(): number | undefined;
        /**
         * @stability stable
         */
        set maxTtl(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaxTtl(): void;
        /**
         * @stability stable
         */
        get maxTtlInput(): number | undefined;
        private _minTtl?;
        /**
         * @stability stable
         */
        get minTtl(): number | undefined;
        /**
         * @stability stable
         */
        set minTtl(value: number | undefined);
        /**
         * @stability stable
         */
        resetMinTtl(): void;
        /**
         * @stability stable
         */
        get minTtlInput(): number | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _parametersInCacheKeyAndForwardedToOrigin?;
        private __parametersInCacheKeyAndForwardedToOriginOutput;
        /**
         * @stability stable
         */
        get parametersInCacheKeyAndForwardedToOrigin(): CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginOutputReference;
        /**
         * @stability stable
         */
        putParametersInCacheKeyAndForwardedToOrigin(value: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOrigin | undefined): void;
        /**
         * @stability stable
         */
        resetParametersInCacheKeyAndForwardedToOrigin(): void;
        /**
         * @stability stable
         */
        get parametersInCacheKeyAndForwardedToOriginInput(): CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOrigin | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#aliases CloudfrontDistribution#aliases}.
         *
         * @stability stable
         */
        readonly aliases?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#comment CloudfrontDistribution#comment}.
         *
         * @stability stable
         */
        readonly comment?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#default_root_object CloudfrontDistribution#default_root_object}.
         *
         * @stability stable
         */
        readonly defaultRootObject?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#enabled CloudfrontDistribution#enabled}.
         *
         * @stability stable
         */
        readonly enabled: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#http_version CloudfrontDistribution#http_version}.
         *
         * @stability stable
         */
        readonly httpVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#is_ipv6_enabled CloudfrontDistribution#is_ipv6_enabled}.
         *
         * @stability stable
         */
        readonly isIpv6Enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#price_class CloudfrontDistribution#price_class}.
         *
         * @stability stable
         */
        readonly priceClass?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#retain_on_delete CloudfrontDistribution#retain_on_delete}.
         *
         * @stability stable
         */
        readonly retainOnDelete?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#tags CloudfrontDistribution#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#tags_all CloudfrontDistribution#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#wait_for_deployment CloudfrontDistribution#wait_for_deployment}.
         *
         * @stability stable
         */
        readonly waitForDeployment?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#web_acl_id CloudfrontDistribution#web_acl_id}.
         *
         * @stability stable
         */
        readonly webAclId?: string;
        /**
         * custom_error_response block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#custom_error_response CloudfrontDistribution#custom_error_response}
         *
         * @stability stable
         */
        readonly customErrorResponse?: CloudfrontDistributionCustomErrorResponse[];
        /**
         * default_cache_behavior block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#default_cache_behavior CloudfrontDistribution#default_cache_behavior}
         *
         * @stability stable
         */
        readonly defaultCacheBehavior: CloudfrontDistributionDefaultCacheBehavior;
        /**
         * logging_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#logging_config CloudfrontDistribution#logging_config}
         *
         * @stability stable
         */
        readonly loggingConfig?: CloudfrontDistributionLoggingConfig;
        /**
         * ordered_cache_behavior block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#ordered_cache_behavior CloudfrontDistribution#ordered_cache_behavior}
         *
         * @stability stable
         */
        readonly orderedCacheBehavior?: CloudfrontDistributionOrderedCacheBehavior[];
        /**
         * origin block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin CloudfrontDistribution#origin}
         *
         * @stability stable
         */
        readonly origin: CloudfrontDistributionOrigin[];
        /**
         * origin_group block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_group CloudfrontDistribution#origin_group}
         *
         * @stability stable
         */
        readonly originGroup?: CloudfrontDistributionOriginGroup[];
        /**
         * restrictions block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#restrictions CloudfrontDistribution#restrictions}
         *
         * @stability stable
         */
        readonly restrictions: CloudfrontDistributionRestrictions;
        /**
         * viewer_certificate block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#viewer_certificate CloudfrontDistribution#viewer_certificate}
         *
         * @stability stable
         */
        readonly viewerCertificate: CloudfrontDistributionViewerCertificate;
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionTrustedKeyGroupsItems extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get keyGroupId(): string;
        /**
         * @stability stable
         */
        get keyPairIds(): string[];
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionTrustedKeyGroups extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get enabled(): any;
        /**
         * @stability stable
         */
        get items(): any;
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionTrustedSignersItems extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get awsAccountNumber(): string;
        /**
         * @stability stable
         */
        get keyPairIds(): string[];
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionTrustedSigners extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get enabled(): any;
        /**
         * @stability stable
         */
        get items(): any;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionCustomErrorResponse {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#error_caching_min_ttl CloudfrontDistribution#error_caching_min_ttl}.
         *
         * @stability stable
         */
        readonly errorCachingMinTtl?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#error_code CloudfrontDistribution#error_code}.
         *
         * @stability stable
         */
        readonly errorCode: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#response_code CloudfrontDistribution#response_code}.
         *
         * @stability stable
         */
        readonly responseCode?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#response_page_path CloudfrontDistribution#response_page_path}.
         *
         * @stability stable
         */
        readonly responsePagePath?: string;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionDefaultCacheBehaviorForwardedValuesCookies {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#forward CloudfrontDistribution#forward}.
         *
         * @stability stable
         */
        readonly forward: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#whitelisted_names CloudfrontDistribution#whitelisted_names}.
         *
         * @stability stable
         */
        readonly whitelistedNames?: string[];
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionDefaultCacheBehaviorForwardedValuesCookiesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _forward?;
        /**
         * @stability stable
         */
        get forward(): string;
        /**
         * @stability stable
         */
        set forward(value: string);
        /**
         * @stability stable
         */
        get forwardInput(): string | undefined;
        private _whitelistedNames?;
        /**
         * @stability stable
         */
        get whitelistedNames(): string[] | undefined;
        /**
         * @stability stable
         */
        set whitelistedNames(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetWhitelistedNames(): void;
        /**
         * @stability stable
         */
        get whitelistedNamesInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionDefaultCacheBehaviorForwardedValues {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#headers CloudfrontDistribution#headers}.
         *
         * @stability stable
         */
        readonly headers?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#query_string CloudfrontDistribution#query_string}.
         *
         * @stability stable
         */
        readonly queryString: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#query_string_cache_keys CloudfrontDistribution#query_string_cache_keys}.
         *
         * @stability stable
         */
        readonly queryStringCacheKeys?: string[];
        /**
         * cookies block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#cookies CloudfrontDistribution#cookies}
         *
         * @stability stable
         */
        readonly cookies: CloudfrontDistributionDefaultCacheBehaviorForwardedValuesCookies;
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionDefaultCacheBehaviorForwardedValuesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _headers?;
        /**
         * @stability stable
         */
        get headers(): string[] | undefined;
        /**
         * @stability stable
         */
        set headers(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetHeaders(): void;
        /**
         * @stability stable
         */
        get headersInput(): string[] | undefined;
        private _queryString?;
        /**
         * @stability stable
         */
        get queryString(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set queryString(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get queryStringInput(): boolean | cdktf.IResolvable | undefined;
        private _queryStringCacheKeys?;
        /**
         * @stability stable
         */
        get queryStringCacheKeys(): string[] | undefined;
        /**
         * @stability stable
         */
        set queryStringCacheKeys(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetQueryStringCacheKeys(): void;
        /**
         * @stability stable
         */
        get queryStringCacheKeysInput(): string[] | undefined;
        private _cookies?;
        private __cookiesOutput;
        /**
         * @stability stable
         */
        get cookies(): CloudfrontDistributionDefaultCacheBehaviorForwardedValuesCookiesOutputReference;
        /**
         * @stability stable
         */
        putCookies(value: CloudfrontDistributionDefaultCacheBehaviorForwardedValuesCookies): void;
        /**
         * @stability stable
         */
        get cookiesInput(): CloudfrontDistributionDefaultCacheBehaviorForwardedValuesCookies | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionDefaultCacheBehaviorFunctionAssociation {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#event_type CloudfrontDistribution#event_type}.
         *
         * @stability stable
         */
        readonly eventType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#function_arn CloudfrontDistribution#function_arn}.
         *
         * @stability stable
         */
        readonly functionArn: string;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionDefaultCacheBehaviorLambdaFunctionAssociation {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#event_type CloudfrontDistribution#event_type}.
         *
         * @stability stable
         */
        readonly eventType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#include_body CloudfrontDistribution#include_body}.
         *
         * @stability stable
         */
        readonly includeBody?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#lambda_arn CloudfrontDistribution#lambda_arn}.
         *
         * @stability stable
         */
        readonly lambdaArn: string;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionDefaultCacheBehavior {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#allowed_methods CloudfrontDistribution#allowed_methods}.
         *
         * @stability stable
         */
        readonly allowedMethods: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#cache_policy_id CloudfrontDistribution#cache_policy_id}.
         *
         * @stability stable
         */
        readonly cachePolicyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#cached_methods CloudfrontDistribution#cached_methods}.
         *
         * @stability stable
         */
        readonly cachedMethods: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#compress CloudfrontDistribution#compress}.
         *
         * @stability stable
         */
        readonly compress?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#default_ttl CloudfrontDistribution#default_ttl}.
         *
         * @stability stable
         */
        readonly defaultTtl?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#field_level_encryption_id CloudfrontDistribution#field_level_encryption_id}.
         *
         * @stability stable
         */
        readonly fieldLevelEncryptionId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#max_ttl CloudfrontDistribution#max_ttl}.
         *
         * @stability stable
         */
        readonly maxTtl?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#min_ttl CloudfrontDistribution#min_ttl}.
         *
         * @stability stable
         */
        readonly minTtl?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_request_policy_id CloudfrontDistribution#origin_request_policy_id}.
         *
         * @stability stable
         */
        readonly originRequestPolicyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#realtime_log_config_arn CloudfrontDistribution#realtime_log_config_arn}.
         *
         * @stability stable
         */
        readonly realtimeLogConfigArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#smooth_streaming CloudfrontDistribution#smooth_streaming}.
         *
         * @stability stable
         */
        readonly smoothStreaming?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#target_origin_id CloudfrontDistribution#target_origin_id}.
         *
         * @stability stable
         */
        readonly targetOriginId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#trusted_key_groups CloudfrontDistribution#trusted_key_groups}.
         *
         * @stability stable
         */
        readonly trustedKeyGroups?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#trusted_signers CloudfrontDistribution#trusted_signers}.
         *
         * @stability stable
         */
        readonly trustedSigners?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#viewer_protocol_policy CloudfrontDistribution#viewer_protocol_policy}.
         *
         * @stability stable
         */
        readonly viewerProtocolPolicy: string;
        /**
         * forwarded_values block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#forwarded_values CloudfrontDistribution#forwarded_values}
         *
         * @stability stable
         */
        readonly forwardedValues?: CloudfrontDistributionDefaultCacheBehaviorForwardedValues;
        /**
         * function_association block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#function_association CloudfrontDistribution#function_association}
         *
         * @stability stable
         */
        readonly functionAssociation?: CloudfrontDistributionDefaultCacheBehaviorFunctionAssociation[];
        /**
         * lambda_function_association block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#lambda_function_association CloudfrontDistribution#lambda_function_association}
         *
         * @stability stable
         */
        readonly lambdaFunctionAssociation?: CloudfrontDistributionDefaultCacheBehaviorLambdaFunctionAssociation[];
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionDefaultCacheBehaviorOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _allowedMethods?;
        /**
         * @stability stable
         */
        get allowedMethods(): string[];
        /**
         * @stability stable
         */
        set allowedMethods(value: string[]);
        /**
         * @stability stable
         */
        get allowedMethodsInput(): string[] | undefined;
        private _cachePolicyId?;
        /**
         * @stability stable
         */
        get cachePolicyId(): string | undefined;
        /**
         * @stability stable
         */
        set cachePolicyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetCachePolicyId(): void;
        /**
         * @stability stable
         */
        get cachePolicyIdInput(): string | undefined;
        private _cachedMethods?;
        /**
         * @stability stable
         */
        get cachedMethods(): string[];
        /**
         * @stability stable
         */
        set cachedMethods(value: string[]);
        /**
         * @stability stable
         */
        get cachedMethodsInput(): string[] | undefined;
        private _compress?;
        /**
         * @stability stable
         */
        get compress(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set compress(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetCompress(): void;
        /**
         * @stability stable
         */
        get compressInput(): boolean | cdktf.IResolvable | undefined;
        private _defaultTtl?;
        /**
         * @stability stable
         */
        get defaultTtl(): number | undefined;
        /**
         * @stability stable
         */
        set defaultTtl(value: number | undefined);
        /**
         * @stability stable
         */
        resetDefaultTtl(): void;
        /**
         * @stability stable
         */
        get defaultTtlInput(): number | undefined;
        private _fieldLevelEncryptionId?;
        /**
         * @stability stable
         */
        get fieldLevelEncryptionId(): string | undefined;
        /**
         * @stability stable
         */
        set fieldLevelEncryptionId(value: string | undefined);
        /**
         * @stability stable
         */
        resetFieldLevelEncryptionId(): void;
        /**
         * @stability stable
         */
        get fieldLevelEncryptionIdInput(): string | undefined;
        private _maxTtl?;
        /**
         * @stability stable
         */
        get maxTtl(): number | undefined;
        /**
         * @stability stable
         */
        set maxTtl(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaxTtl(): void;
        /**
         * @stability stable
         */
        get maxTtlInput(): number | undefined;
        private _minTtl?;
        /**
         * @stability stable
         */
        get minTtl(): number | undefined;
        /**
         * @stability stable
         */
        set minTtl(value: number | undefined);
        /**
         * @stability stable
         */
        resetMinTtl(): void;
        /**
         * @stability stable
         */
        get minTtlInput(): number | undefined;
        private _originRequestPolicyId?;
        /**
         * @stability stable
         */
        get originRequestPolicyId(): string | undefined;
        /**
         * @stability stable
         */
        set originRequestPolicyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetOriginRequestPolicyId(): void;
        /**
         * @stability stable
         */
        get originRequestPolicyIdInput(): string | undefined;
        private _realtimeLogConfigArn?;
        /**
         * @stability stable
         */
        get realtimeLogConfigArn(): string | undefined;
        /**
         * @stability stable
         */
        set realtimeLogConfigArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetRealtimeLogConfigArn(): void;
        /**
         * @stability stable
         */
        get realtimeLogConfigArnInput(): string | undefined;
        private _smoothStreaming?;
        /**
         * @stability stable
         */
        get smoothStreaming(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set smoothStreaming(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetSmoothStreaming(): void;
        /**
         * @stability stable
         */
        get smoothStreamingInput(): boolean | cdktf.IResolvable | undefined;
        private _targetOriginId?;
        /**
         * @stability stable
         */
        get targetOriginId(): string;
        /**
         * @stability stable
         */
        set targetOriginId(value: string);
        /**
         * @stability stable
         */
        get targetOriginIdInput(): string | undefined;
        private _trustedKeyGroups?;
        /**
         * @stability stable
         */
        get trustedKeyGroups(): string[] | undefined;
        /**
         * @stability stable
         */
        set trustedKeyGroups(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetTrustedKeyGroups(): void;
        /**
         * @stability stable
         */
        get trustedKeyGroupsInput(): string[] | undefined;
        private _trustedSigners?;
        /**
         * @stability stable
         */
        get trustedSigners(): string[] | undefined;
        /**
         * @stability stable
         */
        set trustedSigners(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetTrustedSigners(): void;
        /**
         * @stability stable
         */
        get trustedSignersInput(): string[] | undefined;
        private _viewerProtocolPolicy?;
        /**
         * @stability stable
         */
        get viewerProtocolPolicy(): string;
        /**
         * @stability stable
         */
        set viewerProtocolPolicy(value: string);
        /**
         * @stability stable
         */
        get viewerProtocolPolicyInput(): string | undefined;
        private _forwardedValues?;
        private __forwardedValuesOutput;
        /**
         * @stability stable
         */
        get forwardedValues(): CloudfrontDistributionDefaultCacheBehaviorForwardedValuesOutputReference;
        /**
         * @stability stable
         */
        putForwardedValues(value: CloudfrontDistributionDefaultCacheBehaviorForwardedValues | undefined): void;
        /**
         * @stability stable
         */
        resetForwardedValues(): void;
        /**
         * @stability stable
         */
        get forwardedValuesInput(): CloudfrontDistributionDefaultCacheBehaviorForwardedValues | undefined;
        private _functionAssociation?;
        /**
         * @stability stable
         */
        get functionAssociation(): CloudfrontDistributionDefaultCacheBehaviorFunctionAssociation[] | undefined;
        /**
         * @stability stable
         */
        set functionAssociation(value: CloudfrontDistributionDefaultCacheBehaviorFunctionAssociation[] | undefined);
        /**
         * @stability stable
         */
        resetFunctionAssociation(): void;
        /**
         * @stability stable
         */
        get functionAssociationInput(): CloudfrontDistributionDefaultCacheBehaviorFunctionAssociation[] | undefined;
        private _lambdaFunctionAssociation?;
        /**
         * @stability stable
         */
        get lambdaFunctionAssociation(): CloudfrontDistributionDefaultCacheBehaviorLambdaFunctionAssociation[] | undefined;
        /**
         * @stability stable
         */
        set lambdaFunctionAssociation(value: CloudfrontDistributionDefaultCacheBehaviorLambdaFunctionAssociation[] | undefined);
        /**
         * @stability stable
         */
        resetLambdaFunctionAssociation(): void;
        /**
         * @stability stable
         */
        get lambdaFunctionAssociationInput(): CloudfrontDistributionDefaultCacheBehaviorLambdaFunctionAssociation[] | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionLoggingConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#bucket CloudfrontDistribution#bucket}.
         *
         * @stability stable
         */
        readonly bucket: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#include_cookies CloudfrontDistribution#include_cookies}.
         *
         * @stability stable
         */
        readonly includeCookies?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#prefix CloudfrontDistribution#prefix}.
         *
         * @stability stable
         */
        readonly prefix?: string;
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionLoggingConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bucket?;
        /**
         * @stability stable
         */
        get bucket(): string;
        /**
         * @stability stable
         */
        set bucket(value: string);
        /**
         * @stability stable
         */
        get bucketInput(): string | undefined;
        private _includeCookies?;
        /**
         * @stability stable
         */
        get includeCookies(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set includeCookies(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIncludeCookies(): void;
        /**
         * @stability stable
         */
        get includeCookiesInput(): boolean | cdktf.IResolvable | undefined;
        private _prefix?;
        /**
         * @stability stable
         */
        get prefix(): string | undefined;
        /**
         * @stability stable
         */
        set prefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrefix(): void;
        /**
         * @stability stable
         */
        get prefixInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionOrderedCacheBehaviorForwardedValuesCookies {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#forward CloudfrontDistribution#forward}.
         *
         * @stability stable
         */
        readonly forward: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#whitelisted_names CloudfrontDistribution#whitelisted_names}.
         *
         * @stability stable
         */
        readonly whitelistedNames?: string[];
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionOrderedCacheBehaviorForwardedValuesCookiesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _forward?;
        /**
         * @stability stable
         */
        get forward(): string;
        /**
         * @stability stable
         */
        set forward(value: string);
        /**
         * @stability stable
         */
        get forwardInput(): string | undefined;
        private _whitelistedNames?;
        /**
         * @stability stable
         */
        get whitelistedNames(): string[] | undefined;
        /**
         * @stability stable
         */
        set whitelistedNames(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetWhitelistedNames(): void;
        /**
         * @stability stable
         */
        get whitelistedNamesInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionOrderedCacheBehaviorForwardedValues {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#headers CloudfrontDistribution#headers}.
         *
         * @stability stable
         */
        readonly headers?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#query_string CloudfrontDistribution#query_string}.
         *
         * @stability stable
         */
        readonly queryString: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#query_string_cache_keys CloudfrontDistribution#query_string_cache_keys}.
         *
         * @stability stable
         */
        readonly queryStringCacheKeys?: string[];
        /**
         * cookies block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#cookies CloudfrontDistribution#cookies}
         *
         * @stability stable
         */
        readonly cookies: CloudfrontDistributionOrderedCacheBehaviorForwardedValuesCookies;
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionOrderedCacheBehaviorForwardedValuesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _headers?;
        /**
         * @stability stable
         */
        get headers(): string[] | undefined;
        /**
         * @stability stable
         */
        set headers(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetHeaders(): void;
        /**
         * @stability stable
         */
        get headersInput(): string[] | undefined;
        private _queryString?;
        /**
         * @stability stable
         */
        get queryString(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set queryString(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get queryStringInput(): boolean | cdktf.IResolvable | undefined;
        private _queryStringCacheKeys?;
        /**
         * @stability stable
         */
        get queryStringCacheKeys(): string[] | undefined;
        /**
         * @stability stable
         */
        set queryStringCacheKeys(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetQueryStringCacheKeys(): void;
        /**
         * @stability stable
         */
        get queryStringCacheKeysInput(): string[] | undefined;
        private _cookies?;
        private __cookiesOutput;
        /**
         * @stability stable
         */
        get cookies(): CloudfrontDistributionOrderedCacheBehaviorForwardedValuesCookiesOutputReference;
        /**
         * @stability stable
         */
        putCookies(value: CloudfrontDistributionOrderedCacheBehaviorForwardedValuesCookies): void;
        /**
         * @stability stable
         */
        get cookiesInput(): CloudfrontDistributionOrderedCacheBehaviorForwardedValuesCookies | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionOrderedCacheBehaviorFunctionAssociation {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#event_type CloudfrontDistribution#event_type}.
         *
         * @stability stable
         */
        readonly eventType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#function_arn CloudfrontDistribution#function_arn}.
         *
         * @stability stable
         */
        readonly functionArn: string;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionOrderedCacheBehaviorLambdaFunctionAssociation {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#event_type CloudfrontDistribution#event_type}.
         *
         * @stability stable
         */
        readonly eventType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#include_body CloudfrontDistribution#include_body}.
         *
         * @stability stable
         */
        readonly includeBody?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#lambda_arn CloudfrontDistribution#lambda_arn}.
         *
         * @stability stable
         */
        readonly lambdaArn: string;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionOrderedCacheBehavior {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#allowed_methods CloudfrontDistribution#allowed_methods}.
         *
         * @stability stable
         */
        readonly allowedMethods: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#cache_policy_id CloudfrontDistribution#cache_policy_id}.
         *
         * @stability stable
         */
        readonly cachePolicyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#cached_methods CloudfrontDistribution#cached_methods}.
         *
         * @stability stable
         */
        readonly cachedMethods: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#compress CloudfrontDistribution#compress}.
         *
         * @stability stable
         */
        readonly compress?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#default_ttl CloudfrontDistribution#default_ttl}.
         *
         * @stability stable
         */
        readonly defaultTtl?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#field_level_encryption_id CloudfrontDistribution#field_level_encryption_id}.
         *
         * @stability stable
         */
        readonly fieldLevelEncryptionId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#max_ttl CloudfrontDistribution#max_ttl}.
         *
         * @stability stable
         */
        readonly maxTtl?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#min_ttl CloudfrontDistribution#min_ttl}.
         *
         * @stability stable
         */
        readonly minTtl?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_request_policy_id CloudfrontDistribution#origin_request_policy_id}.
         *
         * @stability stable
         */
        readonly originRequestPolicyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#path_pattern CloudfrontDistribution#path_pattern}.
         *
         * @stability stable
         */
        readonly pathPattern: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#realtime_log_config_arn CloudfrontDistribution#realtime_log_config_arn}.
         *
         * @stability stable
         */
        readonly realtimeLogConfigArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#smooth_streaming CloudfrontDistribution#smooth_streaming}.
         *
         * @stability stable
         */
        readonly smoothStreaming?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#target_origin_id CloudfrontDistribution#target_origin_id}.
         *
         * @stability stable
         */
        readonly targetOriginId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#trusted_key_groups CloudfrontDistribution#trusted_key_groups}.
         *
         * @stability stable
         */
        readonly trustedKeyGroups?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#trusted_signers CloudfrontDistribution#trusted_signers}.
         *
         * @stability stable
         */
        readonly trustedSigners?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#viewer_protocol_policy CloudfrontDistribution#viewer_protocol_policy}.
         *
         * @stability stable
         */
        readonly viewerProtocolPolicy: string;
        /**
         * forwarded_values block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#forwarded_values CloudfrontDistribution#forwarded_values}
         *
         * @stability stable
         */
        readonly forwardedValues?: CloudfrontDistributionOrderedCacheBehaviorForwardedValues;
        /**
         * function_association block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#function_association CloudfrontDistribution#function_association}
         *
         * @stability stable
         */
        readonly functionAssociation?: CloudfrontDistributionOrderedCacheBehaviorFunctionAssociation[];
        /**
         * lambda_function_association block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#lambda_function_association CloudfrontDistribution#lambda_function_association}
         *
         * @stability stable
         */
        readonly lambdaFunctionAssociation?: CloudfrontDistributionOrderedCacheBehaviorLambdaFunctionAssociation[];
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionOriginCustomHeader {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#name CloudfrontDistribution#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#value CloudfrontDistribution#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionOriginCustomOriginConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#http_port CloudfrontDistribution#http_port}.
         *
         * @stability stable
         */
        readonly httpPort: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#https_port CloudfrontDistribution#https_port}.
         *
         * @stability stable
         */
        readonly httpsPort: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_keepalive_timeout CloudfrontDistribution#origin_keepalive_timeout}.
         *
         * @stability stable
         */
        readonly originKeepaliveTimeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_protocol_policy CloudfrontDistribution#origin_protocol_policy}.
         *
         * @stability stable
         */
        readonly originProtocolPolicy: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_read_timeout CloudfrontDistribution#origin_read_timeout}.
         *
         * @stability stable
         */
        readonly originReadTimeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_ssl_protocols CloudfrontDistribution#origin_ssl_protocols}.
         *
         * @stability stable
         */
        readonly originSslProtocols: string[];
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionOriginCustomOriginConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _httpPort?;
        /**
         * @stability stable
         */
        get httpPort(): number;
        /**
         * @stability stable
         */
        set httpPort(value: number);
        /**
         * @stability stable
         */
        get httpPortInput(): number | undefined;
        private _httpsPort?;
        /**
         * @stability stable
         */
        get httpsPort(): number;
        /**
         * @stability stable
         */
        set httpsPort(value: number);
        /**
         * @stability stable
         */
        get httpsPortInput(): number | undefined;
        private _originKeepaliveTimeout?;
        /**
         * @stability stable
         */
        get originKeepaliveTimeout(): number | undefined;
        /**
         * @stability stable
         */
        set originKeepaliveTimeout(value: number | undefined);
        /**
         * @stability stable
         */
        resetOriginKeepaliveTimeout(): void;
        /**
         * @stability stable
         */
        get originKeepaliveTimeoutInput(): number | undefined;
        private _originProtocolPolicy?;
        /**
         * @stability stable
         */
        get originProtocolPolicy(): string;
        /**
         * @stability stable
         */
        set originProtocolPolicy(value: string);
        /**
         * @stability stable
         */
        get originProtocolPolicyInput(): string | undefined;
        private _originReadTimeout?;
        /**
         * @stability stable
         */
        get originReadTimeout(): number | undefined;
        /**
         * @stability stable
         */
        set originReadTimeout(value: number | undefined);
        /**
         * @stability stable
         */
        resetOriginReadTimeout(): void;
        /**
         * @stability stable
         */
        get originReadTimeoutInput(): number | undefined;
        private _originSslProtocols?;
        /**
         * @stability stable
         */
        get originSslProtocols(): string[];
        /**
         * @stability stable
         */
        set originSslProtocols(value: string[]);
        /**
         * @stability stable
         */
        get originSslProtocolsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionOriginOriginShield {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#enabled CloudfrontDistribution#enabled}.
         *
         * @stability stable
         */
        readonly enabled: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_shield_region CloudfrontDistribution#origin_shield_region}.
         *
         * @stability stable
         */
        readonly originShieldRegion: string;
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionOriginOriginShieldOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _originShieldRegion?;
        /**
         * @stability stable
         */
        get originShieldRegion(): string;
        /**
         * @stability stable
         */
        set originShieldRegion(value: string);
        /**
         * @stability stable
         */
        get originShieldRegionInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionOriginS3OriginConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_access_identity CloudfrontDistribution#origin_access_identity}.
         *
         * @stability stable
         */
        readonly originAccessIdentity: string;
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionOriginS3OriginConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _originAccessIdentity?;
        /**
         * @stability stable
         */
        get originAccessIdentity(): string;
        /**
         * @stability stable
         */
        set originAccessIdentity(value: string);
        /**
         * @stability stable
         */
        get originAccessIdentityInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionOrigin {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#connection_attempts CloudfrontDistribution#connection_attempts}.
         *
         * @stability stable
         */
        readonly connectionAttempts?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#connection_timeout CloudfrontDistribution#connection_timeout}.
         *
         * @stability stable
         */
        readonly connectionTimeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#domain_name CloudfrontDistribution#domain_name}.
         *
         * @stability stable
         */
        readonly domainName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_id CloudfrontDistribution#origin_id}.
         *
         * @stability stable
         */
        readonly originId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_path CloudfrontDistribution#origin_path}.
         *
         * @stability stable
         */
        readonly originPath?: string;
        /**
         * custom_header block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#custom_header CloudfrontDistribution#custom_header}
         *
         * @stability stable
         */
        readonly customHeader?: CloudfrontDistributionOriginCustomHeader[];
        /**
         * custom_origin_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#custom_origin_config CloudfrontDistribution#custom_origin_config}
         *
         * @stability stable
         */
        readonly customOriginConfig?: CloudfrontDistributionOriginCustomOriginConfig;
        /**
         * origin_shield block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_shield CloudfrontDistribution#origin_shield}
         *
         * @stability stable
         */
        readonly originShield?: CloudfrontDistributionOriginOriginShield;
        /**
         * s3_origin_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#s3_origin_config CloudfrontDistribution#s3_origin_config}
         *
         * @stability stable
         */
        readonly s3OriginConfig?: CloudfrontDistributionOriginS3OriginConfig;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionOriginGroupFailoverCriteria {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#status_codes CloudfrontDistribution#status_codes}.
         *
         * @stability stable
         */
        readonly statusCodes: number[];
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionOriginGroupFailoverCriteriaOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _statusCodes?;
        /**
         * @stability stable
         */
        get statusCodes(): number[];
        /**
         * @stability stable
         */
        set statusCodes(value: number[]);
        /**
         * @stability stable
         */
        get statusCodesInput(): number[] | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionOriginGroupMember {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_id CloudfrontDistribution#origin_id}.
         *
         * @stability stable
         */
        readonly originId: string;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionOriginGroup {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#origin_id CloudfrontDistribution#origin_id}.
         *
         * @stability stable
         */
        readonly originId: string;
        /**
         * failover_criteria block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#failover_criteria CloudfrontDistribution#failover_criteria}
         *
         * @stability stable
         */
        readonly failoverCriteria: CloudfrontDistributionOriginGroupFailoverCriteria;
        /**
         * member block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#member CloudfrontDistribution#member}
         *
         * @stability stable
         */
        readonly member: CloudfrontDistributionOriginGroupMember[];
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionRestrictionsGeoRestriction {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#locations CloudfrontDistribution#locations}.
         *
         * @stability stable
         */
        readonly locations?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#restriction_type CloudfrontDistribution#restriction_type}.
         *
         * @stability stable
         */
        readonly restrictionType: string;
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionRestrictionsGeoRestrictionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _locations?;
        /**
         * @stability stable
         */
        get locations(): string[] | undefined;
        /**
         * @stability stable
         */
        set locations(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetLocations(): void;
        /**
         * @stability stable
         */
        get locationsInput(): string[] | undefined;
        private _restrictionType?;
        /**
         * @stability stable
         */
        get restrictionType(): string;
        /**
         * @stability stable
         */
        set restrictionType(value: string);
        /**
         * @stability stable
         */
        get restrictionTypeInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionRestrictions {
        /**
         * geo_restriction block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#geo_restriction CloudfrontDistribution#geo_restriction}
         *
         * @stability stable
         */
        readonly geoRestriction: CloudfrontDistributionRestrictionsGeoRestriction;
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionRestrictionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _geoRestriction?;
        private __geoRestrictionOutput;
        /**
         * @stability stable
         */
        get geoRestriction(): CloudfrontDistributionRestrictionsGeoRestrictionOutputReference;
        /**
         * @stability stable
         */
        putGeoRestriction(value: CloudfrontDistributionRestrictionsGeoRestriction): void;
        /**
         * @stability stable
         */
        get geoRestrictionInput(): CloudfrontDistributionRestrictionsGeoRestriction | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontDistributionViewerCertificate {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#acm_certificate_arn CloudfrontDistribution#acm_certificate_arn}.
         *
         * @stability stable
         */
        readonly acmCertificateArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#cloudfront_default_certificate CloudfrontDistribution#cloudfront_default_certificate}.
         *
         * @stability stable
         */
        readonly cloudfrontDefaultCertificate?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#iam_certificate_id CloudfrontDistribution#iam_certificate_id}.
         *
         * @stability stable
         */
        readonly iamCertificateId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#minimum_protocol_version CloudfrontDistribution#minimum_protocol_version}.
         *
         * @stability stable
         */
        readonly minimumProtocolVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html#ssl_support_method CloudfrontDistribution#ssl_support_method}.
         *
         * @stability stable
         */
        readonly sslSupportMethod?: string;
    }
    /**
     * @stability stable
     */
    class CloudfrontDistributionViewerCertificateOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _acmCertificateArn?;
        /**
         * @stability stable
         */
        get acmCertificateArn(): string | undefined;
        /**
         * @stability stable
         */
        set acmCertificateArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetAcmCertificateArn(): void;
        /**
         * @stability stable
         */
        get acmCertificateArnInput(): string | undefined;
        private _cloudfrontDefaultCertificate?;
        /**
         * @stability stable
         */
        get cloudfrontDefaultCertificate(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set cloudfrontDefaultCertificate(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetCloudfrontDefaultCertificate(): void;
        /**
         * @stability stable
         */
        get cloudfrontDefaultCertificateInput(): boolean | cdktf.IResolvable | undefined;
        private _iamCertificateId?;
        /**
         * @stability stable
         */
        get iamCertificateId(): string | undefined;
        /**
         * @stability stable
         */
        set iamCertificateId(value: string | undefined);
        /**
         * @stability stable
         */
        resetIamCertificateId(): void;
        /**
         * @stability stable
         */
        get iamCertificateIdInput(): string | undefined;
        private _minimumProtocolVersion?;
        /**
         * @stability stable
         */
        get minimumProtocolVersion(): string | undefined;
        /**
         * @stability stable
         */
        set minimumProtocolVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetMinimumProtocolVersion(): void;
        /**
         * @stability stable
         */
        get minimumProtocolVersionInput(): string | undefined;
        private _sslSupportMethod?;
        /**
         * @stability stable
         */
        get sslSupportMethod(): string | undefined;
        /**
         * @stability stable
         */
        set sslSupportMethod(value: string | undefined);
        /**
         * @stability stable
         */
        resetSslSupportMethod(): void;
        /**
         * @stability stable
         */
        get sslSupportMethodInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html aws_cloudfront_distribution}.
     *
     * @stability stable
     */
    class CloudfrontDistribution extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_distribution.html aws_cloudfront_distribution} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudfrontDistributionConfig);
        private _aliases?;
        /**
         * @stability stable
         */
        get aliases(): string[] | undefined;
        /**
         * @stability stable
         */
        set aliases(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetAliases(): void;
        /**
         * @stability stable
         */
        get aliasesInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get callerReference(): string;
        private _comment?;
        /**
         * @stability stable
         */
        get comment(): string | undefined;
        /**
         * @stability stable
         */
        set comment(value: string | undefined);
        /**
         * @stability stable
         */
        resetComment(): void;
        /**
         * @stability stable
         */
        get commentInput(): string | undefined;
        private _defaultRootObject?;
        /**
         * @stability stable
         */
        get defaultRootObject(): string | undefined;
        /**
         * @stability stable
         */
        set defaultRootObject(value: string | undefined);
        /**
         * @stability stable
         */
        resetDefaultRootObject(): void;
        /**
         * @stability stable
         */
        get defaultRootObjectInput(): string | undefined;
        /**
         * @stability stable
         */
        get domainName(): string;
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get etag(): string;
        /**
         * @stability stable
         */
        get hostedZoneId(): string;
        private _httpVersion?;
        /**
         * @stability stable
         */
        get httpVersion(): string | undefined;
        /**
         * @stability stable
         */
        set httpVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetHttpVersion(): void;
        /**
         * @stability stable
         */
        get httpVersionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get inProgressValidationBatches(): number;
        private _isIpv6Enabled?;
        /**
         * @stability stable
         */
        get isIpv6Enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set isIpv6Enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIsIpv6Enabled(): void;
        /**
         * @stability stable
         */
        get isIpv6EnabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get lastModifiedTime(): string;
        private _priceClass?;
        /**
         * @stability stable
         */
        get priceClass(): string | undefined;
        /**
         * @stability stable
         */
        set priceClass(value: string | undefined);
        /**
         * @stability stable
         */
        resetPriceClass(): void;
        /**
         * @stability stable
         */
        get priceClassInput(): string | undefined;
        private _retainOnDelete?;
        /**
         * @stability stable
         */
        get retainOnDelete(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set retainOnDelete(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetRetainOnDelete(): void;
        /**
         * @stability stable
         */
        get retainOnDeleteInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        trustedKeyGroups(index: string): CloudfrontDistributionTrustedKeyGroups;
        /**
         * @stability stable
         */
        trustedSigners(index: string): CloudfrontDistributionTrustedSigners;
        private _waitForDeployment?;
        /**
         * @stability stable
         */
        get waitForDeployment(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set waitForDeployment(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetWaitForDeployment(): void;
        /**
         * @stability stable
         */
        get waitForDeploymentInput(): boolean | cdktf.IResolvable | undefined;
        private _webAclId?;
        /**
         * @stability stable
         */
        get webAclId(): string | undefined;
        /**
         * @stability stable
         */
        set webAclId(value: string | undefined);
        /**
         * @stability stable
         */
        resetWebAclId(): void;
        /**
         * @stability stable
         */
        get webAclIdInput(): string | undefined;
        private _customErrorResponse?;
        /**
         * @stability stable
         */
        get customErrorResponse(): CloudfrontDistributionCustomErrorResponse[] | undefined;
        /**
         * @stability stable
         */
        set customErrorResponse(value: CloudfrontDistributionCustomErrorResponse[] | undefined);
        /**
         * @stability stable
         */
        resetCustomErrorResponse(): void;
        /**
         * @stability stable
         */
        get customErrorResponseInput(): CloudfrontDistributionCustomErrorResponse[] | undefined;
        private _defaultCacheBehavior?;
        private __defaultCacheBehaviorOutput;
        /**
         * @stability stable
         */
        get defaultCacheBehavior(): CloudfrontDistributionDefaultCacheBehaviorOutputReference;
        /**
         * @stability stable
         */
        putDefaultCacheBehavior(value: CloudfrontDistributionDefaultCacheBehavior): void;
        /**
         * @stability stable
         */
        get defaultCacheBehaviorInput(): CloudfrontDistributionDefaultCacheBehavior | undefined;
        private _loggingConfig?;
        private __loggingConfigOutput;
        /**
         * @stability stable
         */
        get loggingConfig(): CloudfrontDistributionLoggingConfigOutputReference;
        /**
         * @stability stable
         */
        putLoggingConfig(value: CloudfrontDistributionLoggingConfig | undefined): void;
        /**
         * @stability stable
         */
        resetLoggingConfig(): void;
        /**
         * @stability stable
         */
        get loggingConfigInput(): CloudfrontDistributionLoggingConfig | undefined;
        private _orderedCacheBehavior?;
        /**
         * @stability stable
         */
        get orderedCacheBehavior(): CloudfrontDistributionOrderedCacheBehavior[] | undefined;
        /**
         * @stability stable
         */
        set orderedCacheBehavior(value: CloudfrontDistributionOrderedCacheBehavior[] | undefined);
        /**
         * @stability stable
         */
        resetOrderedCacheBehavior(): void;
        /**
         * @stability stable
         */
        get orderedCacheBehaviorInput(): CloudfrontDistributionOrderedCacheBehavior[] | undefined;
        private _origin?;
        /**
         * @stability stable
         */
        get origin(): CloudfrontDistributionOrigin[];
        /**
         * @stability stable
         */
        set origin(value: CloudfrontDistributionOrigin[]);
        /**
         * @stability stable
         */
        get originInput(): CloudfrontDistributionOrigin[] | undefined;
        private _originGroup?;
        /**
         * @stability stable
         */
        get originGroup(): CloudfrontDistributionOriginGroup[] | undefined;
        /**
         * @stability stable
         */
        set originGroup(value: CloudfrontDistributionOriginGroup[] | undefined);
        /**
         * @stability stable
         */
        resetOriginGroup(): void;
        /**
         * @stability stable
         */
        get originGroupInput(): CloudfrontDistributionOriginGroup[] | undefined;
        private _restrictions?;
        private __restrictionsOutput;
        /**
         * @stability stable
         */
        get restrictions(): CloudfrontDistributionRestrictionsOutputReference;
        /**
         * @stability stable
         */
        putRestrictions(value: CloudfrontDistributionRestrictions): void;
        /**
         * @stability stable
         */
        get restrictionsInput(): CloudfrontDistributionRestrictions | undefined;
        private _viewerCertificate?;
        private __viewerCertificateOutput;
        /**
         * @stability stable
         */
        get viewerCertificate(): CloudfrontDistributionViewerCertificateOutputReference;
        /**
         * @stability stable
         */
        putViewerCertificate(value: CloudfrontDistributionViewerCertificate): void;
        /**
         * @stability stable
         */
        get viewerCertificateInput(): CloudfrontDistributionViewerCertificate | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudfrontFunctionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_function.html#code CloudfrontFunction#code}.
         *
         * @stability stable
         */
        readonly code: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_function.html#comment CloudfrontFunction#comment}.
         *
         * @stability stable
         */
        readonly comment?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_function.html#name CloudfrontFunction#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_function.html#publish CloudfrontFunction#publish}.
         *
         * @stability stable
         */
        readonly publish?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_function.html#runtime CloudfrontFunction#runtime}.
         *
         * @stability stable
         */
        readonly runtime: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_function.html aws_cloudfront_function}.
     *
     * @stability stable
     */
    class CloudfrontFunction extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_function.html aws_cloudfront_function} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudfrontFunctionConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _code?;
        /**
         * @stability stable
         */
        get code(): string;
        /**
         * @stability stable
         */
        set code(value: string);
        /**
         * @stability stable
         */
        get codeInput(): string | undefined;
        private _comment?;
        /**
         * @stability stable
         */
        get comment(): string | undefined;
        /**
         * @stability stable
         */
        set comment(value: string | undefined);
        /**
         * @stability stable
         */
        resetComment(): void;
        /**
         * @stability stable
         */
        get commentInput(): string | undefined;
        /**
         * @stability stable
         */
        get etag(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _publish?;
        /**
         * @stability stable
         */
        get publish(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set publish(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetPublish(): void;
        /**
         * @stability stable
         */
        get publishInput(): boolean | cdktf.IResolvable | undefined;
        private _runtime?;
        /**
         * @stability stable
         */
        get runtime(): string;
        /**
         * @stability stable
         */
        set runtime(value: string);
        /**
         * @stability stable
         */
        get runtimeInput(): string | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudfrontKeyGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_key_group.html#comment CloudfrontKeyGroup#comment}.
         *
         * @stability stable
         */
        readonly comment?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_key_group.html#items CloudfrontKeyGroup#items}.
         *
         * @stability stable
         */
        readonly items: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_key_group.html#name CloudfrontKeyGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_key_group.html aws_cloudfront_key_group}.
     *
     * @stability stable
     */
    class CloudfrontKeyGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_key_group.html aws_cloudfront_key_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudfrontKeyGroupConfig);
        private _comment?;
        /**
         * @stability stable
         */
        get comment(): string | undefined;
        /**
         * @stability stable
         */
        set comment(value: string | undefined);
        /**
         * @stability stable
         */
        resetComment(): void;
        /**
         * @stability stable
         */
        get commentInput(): string | undefined;
        /**
         * @stability stable
         */
        get etag(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _items?;
        /**
         * @stability stable
         */
        get items(): string[];
        /**
         * @stability stable
         */
        set items(value: string[]);
        /**
         * @stability stable
         */
        get itemsInput(): string[] | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudfrontMonitoringSubscriptionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_monitoring_subscription.html#distribution_id CloudfrontMonitoringSubscription#distribution_id}.
         *
         * @stability stable
         */
        readonly distributionId: string;
        /**
         * monitoring_subscription block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_monitoring_subscription.html#monitoring_subscription CloudfrontMonitoringSubscription#monitoring_subscription}
         *
         * @stability stable
         */
        readonly monitoringSubscription: CloudfrontMonitoringSubscriptionMonitoringSubscription;
    }
    /**
     * @stability stable
     */
    interface CloudfrontMonitoringSubscriptionMonitoringSubscriptionRealtimeMetricsSubscriptionConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_monitoring_subscription.html#realtime_metrics_subscription_status CloudfrontMonitoringSubscription#realtime_metrics_subscription_status}.
         *
         * @stability stable
         */
        readonly realtimeMetricsSubscriptionStatus: string;
    }
    /**
     * @stability stable
     */
    class CloudfrontMonitoringSubscriptionMonitoringSubscriptionRealtimeMetricsSubscriptionConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _realtimeMetricsSubscriptionStatus?;
        /**
         * @stability stable
         */
        get realtimeMetricsSubscriptionStatus(): string;
        /**
         * @stability stable
         */
        set realtimeMetricsSubscriptionStatus(value: string);
        /**
         * @stability stable
         */
        get realtimeMetricsSubscriptionStatusInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontMonitoringSubscriptionMonitoringSubscription {
        /**
         * realtime_metrics_subscription_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_monitoring_subscription.html#realtime_metrics_subscription_config CloudfrontMonitoringSubscription#realtime_metrics_subscription_config}
         *
         * @stability stable
         */
        readonly realtimeMetricsSubscriptionConfig: CloudfrontMonitoringSubscriptionMonitoringSubscriptionRealtimeMetricsSubscriptionConfig;
    }
    /**
     * @stability stable
     */
    class CloudfrontMonitoringSubscriptionMonitoringSubscriptionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _realtimeMetricsSubscriptionConfig?;
        private __realtimeMetricsSubscriptionConfigOutput;
        /**
         * @stability stable
         */
        get realtimeMetricsSubscriptionConfig(): CloudfrontMonitoringSubscriptionMonitoringSubscriptionRealtimeMetricsSubscriptionConfigOutputReference;
        /**
         * @stability stable
         */
        putRealtimeMetricsSubscriptionConfig(value: CloudfrontMonitoringSubscriptionMonitoringSubscriptionRealtimeMetricsSubscriptionConfig): void;
        /**
         * @stability stable
         */
        get realtimeMetricsSubscriptionConfigInput(): CloudfrontMonitoringSubscriptionMonitoringSubscriptionRealtimeMetricsSubscriptionConfig | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_monitoring_subscription.html aws_cloudfront_monitoring_subscription}.
     *
     * @stability stable
     */
    class CloudfrontMonitoringSubscription extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_monitoring_subscription.html aws_cloudfront_monitoring_subscription} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudfrontMonitoringSubscriptionConfig);
        private _distributionId?;
        /**
         * @stability stable
         */
        get distributionId(): string;
        /**
         * @stability stable
         */
        set distributionId(value: string);
        /**
         * @stability stable
         */
        get distributionIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _monitoringSubscription?;
        private __monitoringSubscriptionOutput;
        /**
         * @stability stable
         */
        get monitoringSubscription(): CloudfrontMonitoringSubscriptionMonitoringSubscriptionOutputReference;
        /**
         * @stability stable
         */
        putMonitoringSubscription(value: CloudfrontMonitoringSubscriptionMonitoringSubscription): void;
        /**
         * @stability stable
         */
        get monitoringSubscriptionInput(): CloudfrontMonitoringSubscriptionMonitoringSubscription | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudfrontOriginAccessIdentityConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_access_identity.html#comment CloudfrontOriginAccessIdentity#comment}.
         *
         * @stability stable
         */
        readonly comment?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_access_identity.html aws_cloudfront_origin_access_identity}.
     *
     * @stability stable
     */
    class CloudfrontOriginAccessIdentity extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_access_identity.html aws_cloudfront_origin_access_identity} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: CloudfrontOriginAccessIdentityConfig);
        /**
         * @stability stable
         */
        get callerReference(): string;
        /**
         * @stability stable
         */
        get cloudfrontAccessIdentityPath(): string;
        private _comment?;
        /**
         * @stability stable
         */
        get comment(): string | undefined;
        /**
         * @stability stable
         */
        set comment(value: string | undefined);
        /**
         * @stability stable
         */
        resetComment(): void;
        /**
         * @stability stable
         */
        get commentInput(): string | undefined;
        /**
         * @stability stable
         */
        get etag(): string;
        /**
         * @stability stable
         */
        get iamArn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get s3CanonicalUserId(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudfrontOriginRequestPolicyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#comment CloudfrontOriginRequestPolicy#comment}.
         *
         * @stability stable
         */
        readonly comment?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#etag CloudfrontOriginRequestPolicy#etag}.
         *
         * @stability stable
         */
        readonly etag?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#name CloudfrontOriginRequestPolicy#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * cookies_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#cookies_config CloudfrontOriginRequestPolicy#cookies_config}
         *
         * @stability stable
         */
        readonly cookiesConfig: CloudfrontOriginRequestPolicyCookiesConfig;
        /**
         * headers_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#headers_config CloudfrontOriginRequestPolicy#headers_config}
         *
         * @stability stable
         */
        readonly headersConfig: CloudfrontOriginRequestPolicyHeadersConfig;
        /**
         * query_strings_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#query_strings_config CloudfrontOriginRequestPolicy#query_strings_config}
         *
         * @stability stable
         */
        readonly queryStringsConfig: CloudfrontOriginRequestPolicyQueryStringsConfig;
    }
    /**
     * @stability stable
     */
    interface CloudfrontOriginRequestPolicyCookiesConfigCookies {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#items CloudfrontOriginRequestPolicy#items}.
         *
         * @stability stable
         */
        readonly items?: string[];
    }
    /**
     * @stability stable
     */
    class CloudfrontOriginRequestPolicyCookiesConfigCookiesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _items?;
        /**
         * @stability stable
         */
        get items(): string[] | undefined;
        /**
         * @stability stable
         */
        set items(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetItems(): void;
        /**
         * @stability stable
         */
        get itemsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontOriginRequestPolicyCookiesConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#cookie_behavior CloudfrontOriginRequestPolicy#cookie_behavior}.
         *
         * @stability stable
         */
        readonly cookieBehavior: string;
        /**
         * cookies block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#cookies CloudfrontOriginRequestPolicy#cookies}
         *
         * @stability stable
         */
        readonly cookies?: CloudfrontOriginRequestPolicyCookiesConfigCookies;
    }
    /**
     * @stability stable
     */
    class CloudfrontOriginRequestPolicyCookiesConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _cookieBehavior?;
        /**
         * @stability stable
         */
        get cookieBehavior(): string;
        /**
         * @stability stable
         */
        set cookieBehavior(value: string);
        /**
         * @stability stable
         */
        get cookieBehaviorInput(): string | undefined;
        private _cookies?;
        private __cookiesOutput;
        /**
         * @stability stable
         */
        get cookies(): CloudfrontOriginRequestPolicyCookiesConfigCookiesOutputReference;
        /**
         * @stability stable
         */
        putCookies(value: CloudfrontOriginRequestPolicyCookiesConfigCookies | undefined): void;
        /**
         * @stability stable
         */
        resetCookies(): void;
        /**
         * @stability stable
         */
        get cookiesInput(): CloudfrontOriginRequestPolicyCookiesConfigCookies | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontOriginRequestPolicyHeadersConfigHeaders {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#items CloudfrontOriginRequestPolicy#items}.
         *
         * @stability stable
         */
        readonly items?: string[];
    }
    /**
     * @stability stable
     */
    class CloudfrontOriginRequestPolicyHeadersConfigHeadersOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _items?;
        /**
         * @stability stable
         */
        get items(): string[] | undefined;
        /**
         * @stability stable
         */
        set items(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetItems(): void;
        /**
         * @stability stable
         */
        get itemsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontOriginRequestPolicyHeadersConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#header_behavior CloudfrontOriginRequestPolicy#header_behavior}.
         *
         * @stability stable
         */
        readonly headerBehavior?: string;
        /**
         * headers block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#headers CloudfrontOriginRequestPolicy#headers}
         *
         * @stability stable
         */
        readonly headers?: CloudfrontOriginRequestPolicyHeadersConfigHeaders;
    }
    /**
     * @stability stable
     */
    class CloudfrontOriginRequestPolicyHeadersConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _headerBehavior?;
        /**
         * @stability stable
         */
        get headerBehavior(): string | undefined;
        /**
         * @stability stable
         */
        set headerBehavior(value: string | undefined);
        /**
         * @stability stable
         */
        resetHeaderBehavior(): void;
        /**
         * @stability stable
         */
        get headerBehaviorInput(): string | undefined;
        private _headers?;
        private __headersOutput;
        /**
         * @stability stable
         */
        get headers(): CloudfrontOriginRequestPolicyHeadersConfigHeadersOutputReference;
        /**
         * @stability stable
         */
        putHeaders(value: CloudfrontOriginRequestPolicyHeadersConfigHeaders | undefined): void;
        /**
         * @stability stable
         */
        resetHeaders(): void;
        /**
         * @stability stable
         */
        get headersInput(): CloudfrontOriginRequestPolicyHeadersConfigHeaders | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#items CloudfrontOriginRequestPolicy#items}.
         *
         * @stability stable
         */
        readonly items?: string[];
    }
    /**
     * @stability stable
     */
    class CloudfrontOriginRequestPolicyQueryStringsConfigQueryStringsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _items?;
        /**
         * @stability stable
         */
        get items(): string[] | undefined;
        /**
         * @stability stable
         */
        set items(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetItems(): void;
        /**
         * @stability stable
         */
        get itemsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontOriginRequestPolicyQueryStringsConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#query_string_behavior CloudfrontOriginRequestPolicy#query_string_behavior}.
         *
         * @stability stable
         */
        readonly queryStringBehavior: string;
        /**
         * query_strings block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html#query_strings CloudfrontOriginRequestPolicy#query_strings}
         *
         * @stability stable
         */
        readonly queryStrings?: CloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings;
    }
    /**
     * @stability stable
     */
    class CloudfrontOriginRequestPolicyQueryStringsConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _queryStringBehavior?;
        /**
         * @stability stable
         */
        get queryStringBehavior(): string;
        /**
         * @stability stable
         */
        set queryStringBehavior(value: string);
        /**
         * @stability stable
         */
        get queryStringBehaviorInput(): string | undefined;
        private _queryStrings?;
        private __queryStringsOutput;
        /**
         * @stability stable
         */
        get queryStrings(): CloudfrontOriginRequestPolicyQueryStringsConfigQueryStringsOutputReference;
        /**
         * @stability stable
         */
        putQueryStrings(value: CloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings | undefined): void;
        /**
         * @stability stable
         */
        resetQueryStrings(): void;
        /**
         * @stability stable
         */
        get queryStringsInput(): CloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html aws_cloudfront_origin_request_policy}.
     *
     * @stability stable
     */
    class CloudfrontOriginRequestPolicy extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy.html aws_cloudfront_origin_request_policy} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudfrontOriginRequestPolicyConfig);
        private _comment?;
        /**
         * @stability stable
         */
        get comment(): string | undefined;
        /**
         * @stability stable
         */
        set comment(value: string | undefined);
        /**
         * @stability stable
         */
        resetComment(): void;
        /**
         * @stability stable
         */
        get commentInput(): string | undefined;
        private _etag?;
        /**
         * @stability stable
         */
        get etag(): string | undefined;
        /**
         * @stability stable
         */
        set etag(value: string | undefined);
        /**
         * @stability stable
         */
        resetEtag(): void;
        /**
         * @stability stable
         */
        get etagInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _cookiesConfig?;
        private __cookiesConfigOutput;
        /**
         * @stability stable
         */
        get cookiesConfig(): CloudfrontOriginRequestPolicyCookiesConfigOutputReference;
        /**
         * @stability stable
         */
        putCookiesConfig(value: CloudfrontOriginRequestPolicyCookiesConfig): void;
        /**
         * @stability stable
         */
        get cookiesConfigInput(): CloudfrontOriginRequestPolicyCookiesConfig | undefined;
        private _headersConfig?;
        private __headersConfigOutput;
        /**
         * @stability stable
         */
        get headersConfig(): CloudfrontOriginRequestPolicyHeadersConfigOutputReference;
        /**
         * @stability stable
         */
        putHeadersConfig(value: CloudfrontOriginRequestPolicyHeadersConfig): void;
        /**
         * @stability stable
         */
        get headersConfigInput(): CloudfrontOriginRequestPolicyHeadersConfig | undefined;
        private _queryStringsConfig?;
        private __queryStringsConfigOutput;
        /**
         * @stability stable
         */
        get queryStringsConfig(): CloudfrontOriginRequestPolicyQueryStringsConfigOutputReference;
        /**
         * @stability stable
         */
        putQueryStringsConfig(value: CloudfrontOriginRequestPolicyQueryStringsConfig): void;
        /**
         * @stability stable
         */
        get queryStringsConfigInput(): CloudfrontOriginRequestPolicyQueryStringsConfig | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudfrontPublicKeyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_public_key.html#comment CloudfrontPublicKey#comment}.
         *
         * @stability stable
         */
        readonly comment?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_public_key.html#encoded_key CloudfrontPublicKey#encoded_key}.
         *
         * @stability stable
         */
        readonly encodedKey: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_public_key.html#name CloudfrontPublicKey#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_public_key.html#name_prefix CloudfrontPublicKey#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_public_key.html aws_cloudfront_public_key}.
     *
     * @stability stable
     */
    class CloudfrontPublicKey extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_public_key.html aws_cloudfront_public_key} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudfrontPublicKeyConfig);
        /**
         * @stability stable
         */
        get callerReference(): string;
        private _comment?;
        /**
         * @stability stable
         */
        get comment(): string | undefined;
        /**
         * @stability stable
         */
        set comment(value: string | undefined);
        /**
         * @stability stable
         */
        resetComment(): void;
        /**
         * @stability stable
         */
        get commentInput(): string | undefined;
        private _encodedKey?;
        /**
         * @stability stable
         */
        get encodedKey(): string;
        /**
         * @stability stable
         */
        set encodedKey(value: string);
        /**
         * @stability stable
         */
        get encodedKeyInput(): string | undefined;
        /**
         * @stability stable
         */
        get etag(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set namePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamePrefix(): void;
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudfrontRealtimeLogConfigConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html#fields CloudfrontRealtimeLogConfig#fields}.
         *
         * @stability stable
         */
        readonly fields: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html#name CloudfrontRealtimeLogConfig#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html#sampling_rate CloudfrontRealtimeLogConfig#sampling_rate}.
         *
         * @stability stable
         */
        readonly samplingRate: number;
        /**
         * endpoint block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html#endpoint CloudfrontRealtimeLogConfig#endpoint}
         *
         * @stability stable
         */
        readonly endpoint: CloudfrontRealtimeLogConfigEndpoint;
    }
    /**
     * @stability stable
     */
    interface CloudfrontRealtimeLogConfigEndpointKinesisStreamConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html#role_arn CloudfrontRealtimeLogConfig#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html#stream_arn CloudfrontRealtimeLogConfig#stream_arn}.
         *
         * @stability stable
         */
        readonly streamArn: string;
    }
    /**
     * @stability stable
     */
    class CloudfrontRealtimeLogConfigEndpointKinesisStreamConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        private _streamArn?;
        /**
         * @stability stable
         */
        get streamArn(): string;
        /**
         * @stability stable
         */
        set streamArn(value: string);
        /**
         * @stability stable
         */
        get streamArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudfrontRealtimeLogConfigEndpoint {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html#stream_type CloudfrontRealtimeLogConfig#stream_type}.
         *
         * @stability stable
         */
        readonly streamType: string;
        /**
         * kinesis_stream_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html#kinesis_stream_config CloudfrontRealtimeLogConfig#kinesis_stream_config}
         *
         * @stability stable
         */
        readonly kinesisStreamConfig: CloudfrontRealtimeLogConfigEndpointKinesisStreamConfig;
    }
    /**
     * @stability stable
     */
    class CloudfrontRealtimeLogConfigEndpointOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _streamType?;
        /**
         * @stability stable
         */
        get streamType(): string;
        /**
         * @stability stable
         */
        set streamType(value: string);
        /**
         * @stability stable
         */
        get streamTypeInput(): string | undefined;
        private _kinesisStreamConfig?;
        private __kinesisStreamConfigOutput;
        /**
         * @stability stable
         */
        get kinesisStreamConfig(): CloudfrontRealtimeLogConfigEndpointKinesisStreamConfigOutputReference;
        /**
         * @stability stable
         */
        putKinesisStreamConfig(value: CloudfrontRealtimeLogConfigEndpointKinesisStreamConfig): void;
        /**
         * @stability stable
         */
        get kinesisStreamConfigInput(): CloudfrontRealtimeLogConfigEndpointKinesisStreamConfig | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html aws_cloudfront_realtime_log_config}.
     *
     * @stability stable
     */
    class CloudfrontRealtimeLogConfig extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config.html aws_cloudfront_realtime_log_config} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudfrontRealtimeLogConfigConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _fields?;
        /**
         * @stability stable
         */
        get fields(): string[];
        /**
         * @stability stable
         */
        set fields(value: string[]);
        /**
         * @stability stable
         */
        get fieldsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _samplingRate?;
        /**
         * @stability stable
         */
        get samplingRate(): number;
        /**
         * @stability stable
         */
        set samplingRate(value: number);
        /**
         * @stability stable
         */
        get samplingRateInput(): number | undefined;
        private _endpoint?;
        private __endpointOutput;
        /**
         * @stability stable
         */
        get endpoint(): CloudfrontRealtimeLogConfigEndpointOutputReference;
        /**
         * @stability stable
         */
        putEndpoint(value: CloudfrontRealtimeLogConfigEndpoint): void;
        /**
         * @stability stable
         */
        get endpointInput(): CloudfrontRealtimeLogConfigEndpoint | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsCloudfrontCachePolicyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_cache_policy.html#id DataAwsCloudfrontCachePolicy#id}.
         *
         * @stability stable
         */
        readonly id?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_cache_policy.html#name DataAwsCloudfrontCachePolicy#name}.
         *
         * @stability stable
         */
        readonly name?: string;
    }
    /**
     * @stability stable
     */
    class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfigCookies extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get items(): string[];
    }
    /**
     * @stability stable
     */
    class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfig extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get cookieBehavior(): string;
        /**
         * @stability stable
         */
        get cookies(): any;
    }
    /**
     * @stability stable
     */
    class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfigHeaders extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get items(): string[];
    }
    /**
     * @stability stable
     */
    class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfig extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get headerBehavior(): string;
        /**
         * @stability stable
         */
        get headers(): any;
    }
    /**
     * @stability stable
     */
    class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfigQueryStrings extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get items(): string[];
    }
    /**
     * @stability stable
     */
    class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfig extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get queryStringBehavior(): string;
        /**
         * @stability stable
         */
        get queryStrings(): any;
    }
    /**
     * @stability stable
     */
    class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOrigin extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get cookiesConfig(): any;
        /**
         * @stability stable
         */
        get enableAcceptEncodingBrotli(): any;
        /**
         * @stability stable
         */
        get enableAcceptEncodingGzip(): any;
        /**
         * @stability stable
         */
        get headersConfig(): any;
        /**
         * @stability stable
         */
        get queryStringsConfig(): any;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_cache_policy.html aws_cloudfront_cache_policy}.
     *
     * @stability stable
     */
    class DataAwsCloudfrontCachePolicy extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_cache_policy.html aws_cloudfront_cache_policy} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsCloudfrontCachePolicyConfig);
        /**
         * @stability stable
         */
        get comment(): string;
        /**
         * @stability stable
         */
        get defaultTtl(): number;
        /**
         * @stability stable
         */
        get etag(): string;
        private _id?;
        /**
         * @stability stable
         */
        get id(): string | undefined;
        /**
         * @stability stable
         */
        set id(value: string | undefined);
        /**
         * @stability stable
         */
        resetId(): void;
        /**
         * @stability stable
         */
        get idInput(): string | undefined;
        /**
         * @stability stable
         */
        get maxTtl(): number;
        /**
         * @stability stable
         */
        get minTtl(): number;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        parametersInCacheKeyAndForwardedToOrigin(index: string): DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOrigin;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsCloudfrontDistributionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_distribution.html#id DataAwsCloudfrontDistribution#id}.
         *
         * @stability stable
         */
        readonly id: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_distribution.html#tags DataAwsCloudfrontDistribution#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_distribution.html aws_cloudfront_distribution}.
     *
     * @stability stable
     */
    class DataAwsCloudfrontDistribution extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_distribution.html aws_cloudfront_distribution} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsCloudfrontDistributionConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get domainName(): string;
        /**
         * @stability stable
         */
        get enabled(): any;
        /**
         * @stability stable
         */
        get etag(): string;
        /**
         * @stability stable
         */
        get hostedZoneId(): string;
        private _id?;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        set id(value: string);
        /**
         * @stability stable
         */
        get idInput(): string | undefined;
        /**
         * @stability stable
         */
        get inProgressValidationBatches(): number;
        /**
         * @stability stable
         */
        get lastModifiedTime(): string;
        /**
         * @stability stable
         */
        get status(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsCloudfrontFunctionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_function.html#name DataAwsCloudfrontFunction#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_function.html#stage DataAwsCloudfrontFunction#stage}.
         *
         * @stability stable
         */
        readonly stage: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_function.html aws_cloudfront_function}.
     *
     * @stability stable
     */
    class DataAwsCloudfrontFunction extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_function.html aws_cloudfront_function} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsCloudfrontFunctionConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get code(): string;
        /**
         * @stability stable
         */
        get comment(): string;
        /**
         * @stability stable
         */
        get etag(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastModifiedTime(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get runtime(): string;
        private _stage?;
        /**
         * @stability stable
         */
        get stage(): string;
        /**
         * @stability stable
         */
        set stage(value: string);
        /**
         * @stability stable
         */
        get stageInput(): string | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsCloudfrontLogDeliveryCanonicalUserIdConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_log_delivery_canonical_user_id.html#region DataAwsCloudfrontLogDeliveryCanonicalUserId#region}.
         *
         * @stability stable
         */
        readonly region?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_log_delivery_canonical_user_id.html aws_cloudfront_log_delivery_canonical_user_id}.
     *
     * @stability stable
     */
    class DataAwsCloudfrontLogDeliveryCanonicalUserId extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_log_delivery_canonical_user_id.html aws_cloudfront_log_delivery_canonical_user_id} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsCloudfrontLogDeliveryCanonicalUserIdConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _region?;
        /**
         * @stability stable
         */
        get region(): string | undefined;
        /**
         * @stability stable
         */
        set region(value: string | undefined);
        /**
         * @stability stable
         */
        resetRegion(): void;
        /**
         * @stability stable
         */
        get regionInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsCloudfrontOriginRequestPolicyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_origin_request_policy.html#id DataAwsCloudfrontOriginRequestPolicy#id}.
         *
         * @stability stable
         */
        readonly id?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_origin_request_policy.html#name DataAwsCloudfrontOriginRequestPolicy#name}.
         *
         * @stability stable
         */
        readonly name?: string;
    }
    /**
     * @stability stable
     */
    class DataAwsCloudfrontOriginRequestPolicyCookiesConfigCookies extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get items(): string[];
    }
    /**
     * @stability stable
     */
    class DataAwsCloudfrontOriginRequestPolicyCookiesConfig extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get cookieBehavior(): string;
        /**
         * @stability stable
         */
        get cookies(): any;
    }
    /**
     * @stability stable
     */
    class DataAwsCloudfrontOriginRequestPolicyHeadersConfigHeaders extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get items(): string[];
    }
    /**
     * @stability stable
     */
    class DataAwsCloudfrontOriginRequestPolicyHeadersConfig extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get headerBehavior(): string;
        /**
         * @stability stable
         */
        get headers(): any;
    }
    /**
     * @stability stable
     */
    class DataAwsCloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get items(): string[];
    }
    /**
     * @stability stable
     */
    class DataAwsCloudfrontOriginRequestPolicyQueryStringsConfig extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get queryStringBehavior(): string;
        /**
         * @stability stable
         */
        get queryStrings(): any;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_origin_request_policy.html aws_cloudfront_origin_request_policy}.
     *
     * @stability stable
     */
    class DataAwsCloudfrontOriginRequestPolicy extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_origin_request_policy.html aws_cloudfront_origin_request_policy} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsCloudfrontOriginRequestPolicyConfig);
        /**
         * @stability stable
         */
        get comment(): string;
        /**
         * @stability stable
         */
        cookiesConfig(index: string): DataAwsCloudfrontOriginRequestPolicyCookiesConfig;
        /**
         * @stability stable
         */
        get etag(): string;
        /**
         * @stability stable
         */
        headersConfig(index: string): DataAwsCloudfrontOriginRequestPolicyHeadersConfig;
        private _id?;
        /**
         * @stability stable
         */
        get id(): string | undefined;
        /**
         * @stability stable
         */
        set id(value: string | undefined);
        /**
         * @stability stable
         */
        resetId(): void;
        /**
         * @stability stable
         */
        get idInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        queryStringsConfig(index: string): DataAwsCloudfrontOriginRequestPolicyQueryStringsConfig;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
