import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS CloudWatch
*/
export declare namespace CloudWatch {
    /**
     * @stability stable
     */
    interface CloudwatchCompositeAlarmConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_composite_alarm.html#actions_enabled CloudwatchCompositeAlarm#actions_enabled}.
         *
         * @stability stable
         */
        readonly actionsEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_composite_alarm.html#alarm_actions CloudwatchCompositeAlarm#alarm_actions}.
         *
         * @stability stable
         */
        readonly alarmActions?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_composite_alarm.html#alarm_description CloudwatchCompositeAlarm#alarm_description}.
         *
         * @stability stable
         */
        readonly alarmDescription?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_composite_alarm.html#alarm_name CloudwatchCompositeAlarm#alarm_name}.
         *
         * @stability stable
         */
        readonly alarmName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_composite_alarm.html#alarm_rule CloudwatchCompositeAlarm#alarm_rule}.
         *
         * @stability stable
         */
        readonly alarmRule: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_composite_alarm.html#insufficient_data_actions CloudwatchCompositeAlarm#insufficient_data_actions}.
         *
         * @stability stable
         */
        readonly insufficientDataActions?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_composite_alarm.html#ok_actions CloudwatchCompositeAlarm#ok_actions}.
         *
         * @stability stable
         */
        readonly okActions?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_composite_alarm.html#tags CloudwatchCompositeAlarm#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_composite_alarm.html#tags_all CloudwatchCompositeAlarm#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_composite_alarm.html aws_cloudwatch_composite_alarm}.
     *
     * @stability stable
     */
    class CloudwatchCompositeAlarm extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_composite_alarm.html aws_cloudwatch_composite_alarm} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchCompositeAlarmConfig);
        private _actionsEnabled?;
        /**
         * @stability stable
         */
        get actionsEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set actionsEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetActionsEnabled(): void;
        /**
         * @stability stable
         */
        get actionsEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _alarmActions?;
        /**
         * @stability stable
         */
        get alarmActions(): string[] | undefined;
        /**
         * @stability stable
         */
        set alarmActions(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetAlarmActions(): void;
        /**
         * @stability stable
         */
        get alarmActionsInput(): string[] | undefined;
        private _alarmDescription?;
        /**
         * @stability stable
         */
        get alarmDescription(): string | undefined;
        /**
         * @stability stable
         */
        set alarmDescription(value: string | undefined);
        /**
         * @stability stable
         */
        resetAlarmDescription(): void;
        /**
         * @stability stable
         */
        get alarmDescriptionInput(): string | undefined;
        private _alarmName?;
        /**
         * @stability stable
         */
        get alarmName(): string;
        /**
         * @stability stable
         */
        set alarmName(value: string);
        /**
         * @stability stable
         */
        get alarmNameInput(): string | undefined;
        private _alarmRule?;
        /**
         * @stability stable
         */
        get alarmRule(): string;
        /**
         * @stability stable
         */
        set alarmRule(value: string);
        /**
         * @stability stable
         */
        get alarmRuleInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _insufficientDataActions?;
        /**
         * @stability stable
         */
        get insufficientDataActions(): string[] | undefined;
        /**
         * @stability stable
         */
        set insufficientDataActions(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetInsufficientDataActions(): void;
        /**
         * @stability stable
         */
        get insufficientDataActionsInput(): string[] | undefined;
        private _okActions?;
        /**
         * @stability stable
         */
        get okActions(): string[] | undefined;
        /**
         * @stability stable
         */
        set okActions(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetOkActions(): void;
        /**
         * @stability stable
         */
        get okActionsInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchDashboardConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_dashboard.html#dashboard_body CloudwatchDashboard#dashboard_body}.
         *
         * @stability stable
         */
        readonly dashboardBody: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_dashboard.html#dashboard_name CloudwatchDashboard#dashboard_name}.
         *
         * @stability stable
         */
        readonly dashboardName: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_dashboard.html aws_cloudwatch_dashboard}.
     *
     * @stability stable
     */
    class CloudwatchDashboard extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_dashboard.html aws_cloudwatch_dashboard} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchDashboardConfig);
        /**
         * @stability stable
         */
        get dashboardArn(): string;
        private _dashboardBody?;
        /**
         * @stability stable
         */
        get dashboardBody(): string;
        /**
         * @stability stable
         */
        set dashboardBody(value: string);
        /**
         * @stability stable
         */
        get dashboardBodyInput(): string | undefined;
        private _dashboardName?;
        /**
         * @stability stable
         */
        get dashboardName(): string;
        /**
         * @stability stable
         */
        set dashboardName(value: string);
        /**
         * @stability stable
         */
        get dashboardNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchLogDestinationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_destination.html#name CloudwatchLogDestination#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_destination.html#role_arn CloudwatchLogDestination#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_destination.html#target_arn CloudwatchLogDestination#target_arn}.
         *
         * @stability stable
         */
        readonly targetArn: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_destination.html aws_cloudwatch_log_destination}.
     *
     * @stability stable
     */
    class CloudwatchLogDestination extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_destination.html aws_cloudwatch_log_destination} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchLogDestinationConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        private _targetArn?;
        /**
         * @stability stable
         */
        get targetArn(): string;
        /**
         * @stability stable
         */
        set targetArn(value: string);
        /**
         * @stability stable
         */
        get targetArnInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchLogDestinationPolicyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_destination_policy.html#access_policy CloudwatchLogDestinationPolicy#access_policy}.
         *
         * @stability stable
         */
        readonly accessPolicy: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_destination_policy.html#destination_name CloudwatchLogDestinationPolicy#destination_name}.
         *
         * @stability stable
         */
        readonly destinationName: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_destination_policy.html aws_cloudwatch_log_destination_policy}.
     *
     * @stability stable
     */
    class CloudwatchLogDestinationPolicy extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_destination_policy.html aws_cloudwatch_log_destination_policy} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchLogDestinationPolicyConfig);
        private _accessPolicy?;
        /**
         * @stability stable
         */
        get accessPolicy(): string;
        /**
         * @stability stable
         */
        set accessPolicy(value: string);
        /**
         * @stability stable
         */
        get accessPolicyInput(): string | undefined;
        private _destinationName?;
        /**
         * @stability stable
         */
        get destinationName(): string;
        /**
         * @stability stable
         */
        set destinationName(value: string);
        /**
         * @stability stable
         */
        get destinationNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchLogGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_group.html#kms_key_id CloudwatchLogGroup#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_group.html#name CloudwatchLogGroup#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_group.html#name_prefix CloudwatchLogGroup#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_group.html#retention_in_days CloudwatchLogGroup#retention_in_days}.
         *
         * @stability stable
         */
        readonly retentionInDays?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_group.html#tags CloudwatchLogGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_group.html#tags_all CloudwatchLogGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_group.html aws_cloudwatch_log_group}.
     *
     * @stability stable
     */
    class CloudwatchLogGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_group.html aws_cloudwatch_log_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: CloudwatchLogGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set namePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamePrefix(): void;
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        private _retentionInDays?;
        /**
         * @stability stable
         */
        get retentionInDays(): number | undefined;
        /**
         * @stability stable
         */
        set retentionInDays(value: number | undefined);
        /**
         * @stability stable
         */
        resetRetentionInDays(): void;
        /**
         * @stability stable
         */
        get retentionInDaysInput(): number | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchLogMetricFilterConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_metric_filter.html#log_group_name CloudwatchLogMetricFilter#log_group_name}.
         *
         * @stability stable
         */
        readonly logGroupName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_metric_filter.html#name CloudwatchLogMetricFilter#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_metric_filter.html#pattern CloudwatchLogMetricFilter#pattern}.
         *
         * @stability stable
         */
        readonly pattern: string;
        /**
         * metric_transformation block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_metric_filter.html#metric_transformation CloudwatchLogMetricFilter#metric_transformation}
         *
         * @stability stable
         */
        readonly metricTransformation: CloudwatchLogMetricFilterMetricTransformation;
    }
    /**
     * @stability stable
     */
    interface CloudwatchLogMetricFilterMetricTransformation {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_metric_filter.html#default_value CloudwatchLogMetricFilter#default_value}.
         *
         * @stability stable
         */
        readonly defaultValue?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_metric_filter.html#dimensions CloudwatchLogMetricFilter#dimensions}.
         *
         * @stability stable
         */
        readonly dimensions?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_metric_filter.html#name CloudwatchLogMetricFilter#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_metric_filter.html#namespace CloudwatchLogMetricFilter#namespace}.
         *
         * @stability stable
         */
        readonly namespace: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_metric_filter.html#unit CloudwatchLogMetricFilter#unit}.
         *
         * @stability stable
         */
        readonly unit?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_metric_filter.html#value CloudwatchLogMetricFilter#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * @stability stable
     */
    class CloudwatchLogMetricFilterMetricTransformationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _defaultValue?;
        /**
         * @stability stable
         */
        get defaultValue(): string | undefined;
        /**
         * @stability stable
         */
        set defaultValue(value: string | undefined);
        /**
         * @stability stable
         */
        resetDefaultValue(): void;
        /**
         * @stability stable
         */
        get defaultValueInput(): string | undefined;
        private _dimensions?;
        /**
         * @stability stable
         */
        get dimensions(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set dimensions(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDimensions(): void;
        /**
         * @stability stable
         */
        get dimensionsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namespace?;
        /**
         * @stability stable
         */
        get namespace(): string;
        /**
         * @stability stable
         */
        set namespace(value: string);
        /**
         * @stability stable
         */
        get namespaceInput(): string | undefined;
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string | undefined;
        /**
         * @stability stable
         */
        set unit(value: string | undefined);
        /**
         * @stability stable
         */
        resetUnit(): void;
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): string;
        /**
         * @stability stable
         */
        set value(value: string);
        /**
         * @stability stable
         */
        get valueInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_metric_filter.html aws_cloudwatch_log_metric_filter}.
     *
     * @stability stable
     */
    class CloudwatchLogMetricFilter extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_metric_filter.html aws_cloudwatch_log_metric_filter} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchLogMetricFilterConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _logGroupName?;
        /**
         * @stability stable
         */
        get logGroupName(): string;
        /**
         * @stability stable
         */
        set logGroupName(value: string);
        /**
         * @stability stable
         */
        get logGroupNameInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _pattern?;
        /**
         * @stability stable
         */
        get pattern(): string;
        /**
         * @stability stable
         */
        set pattern(value: string);
        /**
         * @stability stable
         */
        get patternInput(): string | undefined;
        private _metricTransformation?;
        private __metricTransformationOutput;
        /**
         * @stability stable
         */
        get metricTransformation(): CloudwatchLogMetricFilterMetricTransformationOutputReference;
        /**
         * @stability stable
         */
        putMetricTransformation(value: CloudwatchLogMetricFilterMetricTransformation): void;
        /**
         * @stability stable
         */
        get metricTransformationInput(): CloudwatchLogMetricFilterMetricTransformation | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchLogResourcePolicyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_resource_policy.html#policy_document CloudwatchLogResourcePolicy#policy_document}.
         *
         * @stability stable
         */
        readonly policyDocument: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_resource_policy.html#policy_name CloudwatchLogResourcePolicy#policy_name}.
         *
         * @stability stable
         */
        readonly policyName: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_resource_policy.html aws_cloudwatch_log_resource_policy}.
     *
     * @stability stable
     */
    class CloudwatchLogResourcePolicy extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_resource_policy.html aws_cloudwatch_log_resource_policy} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchLogResourcePolicyConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _policyDocument?;
        /**
         * @stability stable
         */
        get policyDocument(): string;
        /**
         * @stability stable
         */
        set policyDocument(value: string);
        /**
         * @stability stable
         */
        get policyDocumentInput(): string | undefined;
        private _policyName?;
        /**
         * @stability stable
         */
        get policyName(): string;
        /**
         * @stability stable
         */
        set policyName(value: string);
        /**
         * @stability stable
         */
        get policyNameInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchLogStreamConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_stream.html#log_group_name CloudwatchLogStream#log_group_name}.
         *
         * @stability stable
         */
        readonly logGroupName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_stream.html#name CloudwatchLogStream#name}.
         *
         * @stability stable
         */
        readonly name: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_stream.html aws_cloudwatch_log_stream}.
     *
     * @stability stable
     */
    class CloudwatchLogStream extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_stream.html aws_cloudwatch_log_stream} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchLogStreamConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _logGroupName?;
        /**
         * @stability stable
         */
        get logGroupName(): string;
        /**
         * @stability stable
         */
        set logGroupName(value: string);
        /**
         * @stability stable
         */
        get logGroupNameInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchLogSubscriptionFilterConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_subscription_filter.html#destination_arn CloudwatchLogSubscriptionFilter#destination_arn}.
         *
         * @stability stable
         */
        readonly destinationArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_subscription_filter.html#distribution CloudwatchLogSubscriptionFilter#distribution}.
         *
         * @stability stable
         */
        readonly distribution?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_subscription_filter.html#filter_pattern CloudwatchLogSubscriptionFilter#filter_pattern}.
         *
         * @stability stable
         */
        readonly filterPattern: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_subscription_filter.html#log_group_name CloudwatchLogSubscriptionFilter#log_group_name}.
         *
         * @stability stable
         */
        readonly logGroupName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_subscription_filter.html#name CloudwatchLogSubscriptionFilter#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_subscription_filter.html#role_arn CloudwatchLogSubscriptionFilter#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_subscription_filter.html aws_cloudwatch_log_subscription_filter}.
     *
     * @stability stable
     */
    class CloudwatchLogSubscriptionFilter extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_subscription_filter.html aws_cloudwatch_log_subscription_filter} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchLogSubscriptionFilterConfig);
        private _destinationArn?;
        /**
         * @stability stable
         */
        get destinationArn(): string;
        /**
         * @stability stable
         */
        set destinationArn(value: string);
        /**
         * @stability stable
         */
        get destinationArnInput(): string | undefined;
        private _distribution?;
        /**
         * @stability stable
         */
        get distribution(): string | undefined;
        /**
         * @stability stable
         */
        set distribution(value: string | undefined);
        /**
         * @stability stable
         */
        resetDistribution(): void;
        /**
         * @stability stable
         */
        get distributionInput(): string | undefined;
        private _filterPattern?;
        /**
         * @stability stable
         */
        get filterPattern(): string;
        /**
         * @stability stable
         */
        set filterPattern(value: string);
        /**
         * @stability stable
         */
        get filterPatternInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _logGroupName?;
        /**
         * @stability stable
         */
        get logGroupName(): string;
        /**
         * @stability stable
         */
        set logGroupName(value: string);
        /**
         * @stability stable
         */
        get logGroupNameInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string | undefined;
        /**
         * @stability stable
         */
        set roleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetRoleArn(): void;
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchMetricAlarmConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#actions_enabled CloudwatchMetricAlarm#actions_enabled}.
         *
         * @stability stable
         */
        readonly actionsEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#alarm_actions CloudwatchMetricAlarm#alarm_actions}.
         *
         * @stability stable
         */
        readonly alarmActions?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#alarm_description CloudwatchMetricAlarm#alarm_description}.
         *
         * @stability stable
         */
        readonly alarmDescription?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#alarm_name CloudwatchMetricAlarm#alarm_name}.
         *
         * @stability stable
         */
        readonly alarmName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#comparison_operator CloudwatchMetricAlarm#comparison_operator}.
         *
         * @stability stable
         */
        readonly comparisonOperator: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#datapoints_to_alarm CloudwatchMetricAlarm#datapoints_to_alarm}.
         *
         * @stability stable
         */
        readonly datapointsToAlarm?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#dimensions CloudwatchMetricAlarm#dimensions}.
         *
         * @stability stable
         */
        readonly dimensions?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#evaluate_low_sample_count_percentiles CloudwatchMetricAlarm#evaluate_low_sample_count_percentiles}.
         *
         * @stability stable
         */
        readonly evaluateLowSampleCountPercentiles?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#evaluation_periods CloudwatchMetricAlarm#evaluation_periods}.
         *
         * @stability stable
         */
        readonly evaluationPeriods: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#extended_statistic CloudwatchMetricAlarm#extended_statistic}.
         *
         * @stability stable
         */
        readonly extendedStatistic?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#insufficient_data_actions CloudwatchMetricAlarm#insufficient_data_actions}.
         *
         * @stability stable
         */
        readonly insufficientDataActions?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#metric_name CloudwatchMetricAlarm#metric_name}.
         *
         * @stability stable
         */
        readonly metricName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#namespace CloudwatchMetricAlarm#namespace}.
         *
         * @stability stable
         */
        readonly namespace?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#ok_actions CloudwatchMetricAlarm#ok_actions}.
         *
         * @stability stable
         */
        readonly okActions?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#period CloudwatchMetricAlarm#period}.
         *
         * @stability stable
         */
        readonly period?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#statistic CloudwatchMetricAlarm#statistic}.
         *
         * @stability stable
         */
        readonly statistic?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#tags CloudwatchMetricAlarm#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#tags_all CloudwatchMetricAlarm#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#threshold CloudwatchMetricAlarm#threshold}.
         *
         * @stability stable
         */
        readonly threshold?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#threshold_metric_id CloudwatchMetricAlarm#threshold_metric_id}.
         *
         * @stability stable
         */
        readonly thresholdMetricId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#treat_missing_data CloudwatchMetricAlarm#treat_missing_data}.
         *
         * @stability stable
         */
        readonly treatMissingData?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#unit CloudwatchMetricAlarm#unit}.
         *
         * @stability stable
         */
        readonly unit?: string;
        /**
         * metric_query block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#metric_query CloudwatchMetricAlarm#metric_query}
         *
         * @stability stable
         */
        readonly metricQuery?: CloudwatchMetricAlarmMetricQuery[];
    }
    /**
     * @stability stable
     */
    interface CloudwatchMetricAlarmMetricQueryMetric {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#dimensions CloudwatchMetricAlarm#dimensions}.
         *
         * @stability stable
         */
        readonly dimensions?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#metric_name CloudwatchMetricAlarm#metric_name}.
         *
         * @stability stable
         */
        readonly metricName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#namespace CloudwatchMetricAlarm#namespace}.
         *
         * @stability stable
         */
        readonly namespace?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#period CloudwatchMetricAlarm#period}.
         *
         * @stability stable
         */
        readonly period: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#stat CloudwatchMetricAlarm#stat}.
         *
         * @stability stable
         */
        readonly stat: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#unit CloudwatchMetricAlarm#unit}.
         *
         * @stability stable
         */
        readonly unit?: string;
    }
    /**
     * @stability stable
     */
    class CloudwatchMetricAlarmMetricQueryMetricOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _dimensions?;
        /**
         * @stability stable
         */
        get dimensions(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set dimensions(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDimensions(): void;
        /**
         * @stability stable
         */
        get dimensionsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _metricName?;
        /**
         * @stability stable
         */
        get metricName(): string;
        /**
         * @stability stable
         */
        set metricName(value: string);
        /**
         * @stability stable
         */
        get metricNameInput(): string | undefined;
        private _namespace?;
        /**
         * @stability stable
         */
        get namespace(): string | undefined;
        /**
         * @stability stable
         */
        set namespace(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamespace(): void;
        /**
         * @stability stable
         */
        get namespaceInput(): string | undefined;
        private _period?;
        /**
         * @stability stable
         */
        get period(): number;
        /**
         * @stability stable
         */
        set period(value: number);
        /**
         * @stability stable
         */
        get periodInput(): number | undefined;
        private _stat?;
        /**
         * @stability stable
         */
        get stat(): string;
        /**
         * @stability stable
         */
        set stat(value: string);
        /**
         * @stability stable
         */
        get statInput(): string | undefined;
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string | undefined;
        /**
         * @stability stable
         */
        set unit(value: string | undefined);
        /**
         * @stability stable
         */
        resetUnit(): void;
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudwatchMetricAlarmMetricQuery {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#account_id CloudwatchMetricAlarm#account_id}.
         *
         * @stability stable
         */
        readonly accountId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#expression CloudwatchMetricAlarm#expression}.
         *
         * @stability stable
         */
        readonly expression?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#id CloudwatchMetricAlarm#id}.
         *
         * @stability stable
         */
        readonly id: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#label CloudwatchMetricAlarm#label}.
         *
         * @stability stable
         */
        readonly label?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#return_data CloudwatchMetricAlarm#return_data}.
         *
         * @stability stable
         */
        readonly returnData?: boolean | cdktf.IResolvable;
        /**
         * metric block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html#metric CloudwatchMetricAlarm#metric}
         *
         * @stability stable
         */
        readonly metric?: CloudwatchMetricAlarmMetricQueryMetric;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html aws_cloudwatch_metric_alarm}.
     *
     * @stability stable
     */
    class CloudwatchMetricAlarm extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_alarm.html aws_cloudwatch_metric_alarm} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchMetricAlarmConfig);
        private _actionsEnabled?;
        /**
         * @stability stable
         */
        get actionsEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set actionsEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetActionsEnabled(): void;
        /**
         * @stability stable
         */
        get actionsEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _alarmActions?;
        /**
         * @stability stable
         */
        get alarmActions(): string[] | undefined;
        /**
         * @stability stable
         */
        set alarmActions(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetAlarmActions(): void;
        /**
         * @stability stable
         */
        get alarmActionsInput(): string[] | undefined;
        private _alarmDescription?;
        /**
         * @stability stable
         */
        get alarmDescription(): string | undefined;
        /**
         * @stability stable
         */
        set alarmDescription(value: string | undefined);
        /**
         * @stability stable
         */
        resetAlarmDescription(): void;
        /**
         * @stability stable
         */
        get alarmDescriptionInput(): string | undefined;
        private _alarmName?;
        /**
         * @stability stable
         */
        get alarmName(): string;
        /**
         * @stability stable
         */
        set alarmName(value: string);
        /**
         * @stability stable
         */
        get alarmNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _comparisonOperator?;
        /**
         * @stability stable
         */
        get comparisonOperator(): string;
        /**
         * @stability stable
         */
        set comparisonOperator(value: string);
        /**
         * @stability stable
         */
        get comparisonOperatorInput(): string | undefined;
        private _datapointsToAlarm?;
        /**
         * @stability stable
         */
        get datapointsToAlarm(): number | undefined;
        /**
         * @stability stable
         */
        set datapointsToAlarm(value: number | undefined);
        /**
         * @stability stable
         */
        resetDatapointsToAlarm(): void;
        /**
         * @stability stable
         */
        get datapointsToAlarmInput(): number | undefined;
        private _dimensions?;
        /**
         * @stability stable
         */
        get dimensions(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set dimensions(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDimensions(): void;
        /**
         * @stability stable
         */
        get dimensionsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _evaluateLowSampleCountPercentiles?;
        /**
         * @stability stable
         */
        get evaluateLowSampleCountPercentiles(): string | undefined;
        /**
         * @stability stable
         */
        set evaluateLowSampleCountPercentiles(value: string | undefined);
        /**
         * @stability stable
         */
        resetEvaluateLowSampleCountPercentiles(): void;
        /**
         * @stability stable
         */
        get evaluateLowSampleCountPercentilesInput(): string | undefined;
        private _evaluationPeriods?;
        /**
         * @stability stable
         */
        get evaluationPeriods(): number;
        /**
         * @stability stable
         */
        set evaluationPeriods(value: number);
        /**
         * @stability stable
         */
        get evaluationPeriodsInput(): number | undefined;
        private _extendedStatistic?;
        /**
         * @stability stable
         */
        get extendedStatistic(): string | undefined;
        /**
         * @stability stable
         */
        set extendedStatistic(value: string | undefined);
        /**
         * @stability stable
         */
        resetExtendedStatistic(): void;
        /**
         * @stability stable
         */
        get extendedStatisticInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _insufficientDataActions?;
        /**
         * @stability stable
         */
        get insufficientDataActions(): string[] | undefined;
        /**
         * @stability stable
         */
        set insufficientDataActions(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetInsufficientDataActions(): void;
        /**
         * @stability stable
         */
        get insufficientDataActionsInput(): string[] | undefined;
        private _metricName?;
        /**
         * @stability stable
         */
        get metricName(): string | undefined;
        /**
         * @stability stable
         */
        set metricName(value: string | undefined);
        /**
         * @stability stable
         */
        resetMetricName(): void;
        /**
         * @stability stable
         */
        get metricNameInput(): string | undefined;
        private _namespace?;
        /**
         * @stability stable
         */
        get namespace(): string | undefined;
        /**
         * @stability stable
         */
        set namespace(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamespace(): void;
        /**
         * @stability stable
         */
        get namespaceInput(): string | undefined;
        private _okActions?;
        /**
         * @stability stable
         */
        get okActions(): string[] | undefined;
        /**
         * @stability stable
         */
        set okActions(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetOkActions(): void;
        /**
         * @stability stable
         */
        get okActionsInput(): string[] | undefined;
        private _period?;
        /**
         * @stability stable
         */
        get period(): number | undefined;
        /**
         * @stability stable
         */
        set period(value: number | undefined);
        /**
         * @stability stable
         */
        resetPeriod(): void;
        /**
         * @stability stable
         */
        get periodInput(): number | undefined;
        private _statistic?;
        /**
         * @stability stable
         */
        get statistic(): string | undefined;
        /**
         * @stability stable
         */
        set statistic(value: string | undefined);
        /**
         * @stability stable
         */
        resetStatistic(): void;
        /**
         * @stability stable
         */
        get statisticInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _threshold?;
        /**
         * @stability stable
         */
        get threshold(): number | undefined;
        /**
         * @stability stable
         */
        set threshold(value: number | undefined);
        /**
         * @stability stable
         */
        resetThreshold(): void;
        /**
         * @stability stable
         */
        get thresholdInput(): number | undefined;
        private _thresholdMetricId?;
        /**
         * @stability stable
         */
        get thresholdMetricId(): string | undefined;
        /**
         * @stability stable
         */
        set thresholdMetricId(value: string | undefined);
        /**
         * @stability stable
         */
        resetThresholdMetricId(): void;
        /**
         * @stability stable
         */
        get thresholdMetricIdInput(): string | undefined;
        private _treatMissingData?;
        /**
         * @stability stable
         */
        get treatMissingData(): string | undefined;
        /**
         * @stability stable
         */
        set treatMissingData(value: string | undefined);
        /**
         * @stability stable
         */
        resetTreatMissingData(): void;
        /**
         * @stability stable
         */
        get treatMissingDataInput(): string | undefined;
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string | undefined;
        /**
         * @stability stable
         */
        set unit(value: string | undefined);
        /**
         * @stability stable
         */
        resetUnit(): void;
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _metricQuery?;
        /**
         * @stability stable
         */
        get metricQuery(): CloudwatchMetricAlarmMetricQuery[] | undefined;
        /**
         * @stability stable
         */
        set metricQuery(value: CloudwatchMetricAlarmMetricQuery[] | undefined);
        /**
         * @stability stable
         */
        resetMetricQuery(): void;
        /**
         * @stability stable
         */
        get metricQueryInput(): CloudwatchMetricAlarmMetricQuery[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchMetricStreamConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_stream.html#firehose_arn CloudwatchMetricStream#firehose_arn}.
         *
         * @stability stable
         */
        readonly firehoseArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_stream.html#name CloudwatchMetricStream#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_stream.html#name_prefix CloudwatchMetricStream#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_stream.html#output_format CloudwatchMetricStream#output_format}.
         *
         * @stability stable
         */
        readonly outputFormat: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_stream.html#role_arn CloudwatchMetricStream#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_stream.html#tags CloudwatchMetricStream#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_stream.html#tags_all CloudwatchMetricStream#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * exclude_filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_stream.html#exclude_filter CloudwatchMetricStream#exclude_filter}
         *
         * @stability stable
         */
        readonly excludeFilter?: CloudwatchMetricStreamExcludeFilter[];
        /**
         * include_filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_stream.html#include_filter CloudwatchMetricStream#include_filter}
         *
         * @stability stable
         */
        readonly includeFilter?: CloudwatchMetricStreamIncludeFilter[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_stream.html#timeouts CloudwatchMetricStream#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: CloudwatchMetricStreamTimeouts;
    }
    /**
     * @stability stable
     */
    interface CloudwatchMetricStreamExcludeFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_stream.html#namespace CloudwatchMetricStream#namespace}.
         *
         * @stability stable
         */
        readonly namespace: string;
    }
    /**
     * @stability stable
     */
    interface CloudwatchMetricStreamIncludeFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_stream.html#namespace CloudwatchMetricStream#namespace}.
         *
         * @stability stable
         */
        readonly namespace: string;
    }
    /**
     * @stability stable
     */
    interface CloudwatchMetricStreamTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_stream.html#create CloudwatchMetricStream#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_stream.html#delete CloudwatchMetricStream#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
    }
    /**
     * @stability stable
     */
    class CloudwatchMetricStreamTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_stream.html aws_cloudwatch_metric_stream}.
     *
     * @stability stable
     */
    class CloudwatchMetricStream extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_metric_stream.html aws_cloudwatch_metric_stream} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchMetricStreamConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get creationDate(): string;
        private _firehoseArn?;
        /**
         * @stability stable
         */
        get firehoseArn(): string;
        /**
         * @stability stable
         */
        set firehoseArn(value: string);
        /**
         * @stability stable
         */
        get firehoseArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdateDate(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set namePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamePrefix(): void;
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        private _outputFormat?;
        /**
         * @stability stable
         */
        get outputFormat(): string;
        /**
         * @stability stable
         */
        set outputFormat(value: string);
        /**
         * @stability stable
         */
        get outputFormatInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get state(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _excludeFilter?;
        /**
         * @stability stable
         */
        get excludeFilter(): CloudwatchMetricStreamExcludeFilter[] | undefined;
        /**
         * @stability stable
         */
        set excludeFilter(value: CloudwatchMetricStreamExcludeFilter[] | undefined);
        /**
         * @stability stable
         */
        resetExcludeFilter(): void;
        /**
         * @stability stable
         */
        get excludeFilterInput(): CloudwatchMetricStreamExcludeFilter[] | undefined;
        private _includeFilter?;
        /**
         * @stability stable
         */
        get includeFilter(): CloudwatchMetricStreamIncludeFilter[] | undefined;
        /**
         * @stability stable
         */
        set includeFilter(value: CloudwatchMetricStreamIncludeFilter[] | undefined);
        /**
         * @stability stable
         */
        resetIncludeFilter(): void;
        /**
         * @stability stable
         */
        get includeFilterInput(): CloudwatchMetricStreamIncludeFilter[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): CloudwatchMetricStreamTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: CloudwatchMetricStreamTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): CloudwatchMetricStreamTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchQueryDefinitionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_query_definition.html#log_group_names CloudwatchQueryDefinition#log_group_names}.
         *
         * @stability stable
         */
        readonly logGroupNames?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_query_definition.html#name CloudwatchQueryDefinition#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_query_definition.html#query_string CloudwatchQueryDefinition#query_string}.
         *
         * @stability stable
         */
        readonly queryString: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_query_definition.html aws_cloudwatch_query_definition}.
     *
     * @stability stable
     */
    class CloudwatchQueryDefinition extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_query_definition.html aws_cloudwatch_query_definition} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchQueryDefinitionConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _logGroupNames?;
        /**
         * @stability stable
         */
        get logGroupNames(): string[] | undefined;
        /**
         * @stability stable
         */
        set logGroupNames(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetLogGroupNames(): void;
        /**
         * @stability stable
         */
        get logGroupNamesInput(): string[] | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get queryDefinitionId(): string;
        private _queryString?;
        /**
         * @stability stable
         */
        get queryString(): string;
        /**
         * @stability stable
         */
        set queryString(value: string);
        /**
         * @stability stable
         */
        get queryStringInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsCloudwatchLogGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudwatch_log_group.html#name DataAwsCloudwatchLogGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudwatch_log_group.html#tags DataAwsCloudwatchLogGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/cloudwatch_log_group.html aws_cloudwatch_log_group}.
     *
     * @stability stable
     */
    class DataAwsCloudwatchLogGroup extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cloudwatch_log_group.html aws_cloudwatch_log_group} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsCloudwatchLogGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get creationTime(): number;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get kmsKeyId(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get retentionInDays(): number;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsCloudwatchLogGroupsConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudwatch_log_groups.html#log_group_name_prefix DataAwsCloudwatchLogGroups#log_group_name_prefix}.
         *
         * @stability stable
         */
        readonly logGroupNamePrefix: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/cloudwatch_log_groups.html aws_cloudwatch_log_groups}.
     *
     * @stability stable
     */
    class DataAwsCloudwatchLogGroups extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cloudwatch_log_groups.html aws_cloudwatch_log_groups} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsCloudwatchLogGroupsConfig);
        /**
         * @stability stable
         */
        get arns(): string[];
        /**
         * @stability stable
         */
        get id(): string;
        private _logGroupNamePrefix?;
        /**
         * @stability stable
         */
        get logGroupNamePrefix(): string;
        /**
         * @stability stable
         */
        set logGroupNamePrefix(value: string);
        /**
         * @stability stable
         */
        get logGroupNamePrefixInput(): string | undefined;
        /**
         * @stability stable
         */
        get logGroupNames(): string[];
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
