import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS CloudWatch Event Bridge
*/
export declare namespace CloudWatchEventBridge {
    /**
     * @stability stable
     */
    interface CloudwatchEventApiDestinationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_api_destination.html#connection_arn CloudwatchEventApiDestination#connection_arn}.
         *
         * @stability stable
         */
        readonly connectionArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_api_destination.html#description CloudwatchEventApiDestination#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_api_destination.html#http_method CloudwatchEventApiDestination#http_method}.
         *
         * @stability stable
         */
        readonly httpMethod: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_api_destination.html#invocation_endpoint CloudwatchEventApiDestination#invocation_endpoint}.
         *
         * @stability stable
         */
        readonly invocationEndpoint: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_api_destination.html#invocation_rate_limit_per_second CloudwatchEventApiDestination#invocation_rate_limit_per_second}.
         *
         * @stability stable
         */
        readonly invocationRateLimitPerSecond?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_api_destination.html#name CloudwatchEventApiDestination#name}.
         *
         * @stability stable
         */
        readonly name: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_api_destination.html aws_cloudwatch_event_api_destination}.
     *
     * @stability stable
     */
    class CloudwatchEventApiDestination extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_api_destination.html aws_cloudwatch_event_api_destination} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchEventApiDestinationConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _connectionArn?;
        /**
         * @stability stable
         */
        get connectionArn(): string;
        /**
         * @stability stable
         */
        set connectionArn(value: string);
        /**
         * @stability stable
         */
        get connectionArnInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _httpMethod?;
        /**
         * @stability stable
         */
        get httpMethod(): string;
        /**
         * @stability stable
         */
        set httpMethod(value: string);
        /**
         * @stability stable
         */
        get httpMethodInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _invocationEndpoint?;
        /**
         * @stability stable
         */
        get invocationEndpoint(): string;
        /**
         * @stability stable
         */
        set invocationEndpoint(value: string);
        /**
         * @stability stable
         */
        get invocationEndpointInput(): string | undefined;
        private _invocationRateLimitPerSecond?;
        /**
         * @stability stable
         */
        get invocationRateLimitPerSecond(): number | undefined;
        /**
         * @stability stable
         */
        set invocationRateLimitPerSecond(value: number | undefined);
        /**
         * @stability stable
         */
        resetInvocationRateLimitPerSecond(): void;
        /**
         * @stability stable
         */
        get invocationRateLimitPerSecondInput(): number | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventArchiveConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_archive.html#description CloudwatchEventArchive#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_archive.html#event_pattern CloudwatchEventArchive#event_pattern}.
         *
         * @stability stable
         */
        readonly eventPattern?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_archive.html#event_source_arn CloudwatchEventArchive#event_source_arn}.
         *
         * @stability stable
         */
        readonly eventSourceArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_archive.html#name CloudwatchEventArchive#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_archive.html#retention_days CloudwatchEventArchive#retention_days}.
         *
         * @stability stable
         */
        readonly retentionDays?: number;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_archive.html aws_cloudwatch_event_archive}.
     *
     * @stability stable
     */
    class CloudwatchEventArchive extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_archive.html aws_cloudwatch_event_archive} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchEventArchiveConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _eventPattern?;
        /**
         * @stability stable
         */
        get eventPattern(): string | undefined;
        /**
         * @stability stable
         */
        set eventPattern(value: string | undefined);
        /**
         * @stability stable
         */
        resetEventPattern(): void;
        /**
         * @stability stable
         */
        get eventPatternInput(): string | undefined;
        private _eventSourceArn?;
        /**
         * @stability stable
         */
        get eventSourceArn(): string;
        /**
         * @stability stable
         */
        set eventSourceArn(value: string);
        /**
         * @stability stable
         */
        get eventSourceArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _retentionDays?;
        /**
         * @stability stable
         */
        get retentionDays(): number | undefined;
        /**
         * @stability stable
         */
        set retentionDays(value: number | undefined);
        /**
         * @stability stable
         */
        resetRetentionDays(): void;
        /**
         * @stability stable
         */
        get retentionDaysInput(): number | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventBusConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_bus.html#event_source_name CloudwatchEventBus#event_source_name}.
         *
         * @stability stable
         */
        readonly eventSourceName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_bus.html#name CloudwatchEventBus#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_bus.html#tags CloudwatchEventBus#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_bus.html#tags_all CloudwatchEventBus#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_bus.html aws_cloudwatch_event_bus}.
     *
     * @stability stable
     */
    class CloudwatchEventBus extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_bus.html aws_cloudwatch_event_bus} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchEventBusConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _eventSourceName?;
        /**
         * @stability stable
         */
        get eventSourceName(): string | undefined;
        /**
         * @stability stable
         */
        set eventSourceName(value: string | undefined);
        /**
         * @stability stable
         */
        resetEventSourceName(): void;
        /**
         * @stability stable
         */
        get eventSourceNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventBusPolicyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_bus_policy.html#event_bus_name CloudwatchEventBusPolicy#event_bus_name}.
         *
         * @stability stable
         */
        readonly eventBusName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_bus_policy.html#policy CloudwatchEventBusPolicy#policy}.
         *
         * @stability stable
         */
        readonly policy: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_bus_policy.html aws_cloudwatch_event_bus_policy}.
     *
     * @stability stable
     */
    class CloudwatchEventBusPolicy extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_bus_policy.html aws_cloudwatch_event_bus_policy} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchEventBusPolicyConfig);
        private _eventBusName?;
        /**
         * @stability stable
         */
        get eventBusName(): string | undefined;
        /**
         * @stability stable
         */
        set eventBusName(value: string | undefined);
        /**
         * @stability stable
         */
        resetEventBusName(): void;
        /**
         * @stability stable
         */
        get eventBusNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _policy?;
        /**
         * @stability stable
         */
        get policy(): string;
        /**
         * @stability stable
         */
        set policy(value: string);
        /**
         * @stability stable
         */
        get policyInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventConnectionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#authorization_type CloudwatchEventConnection#authorization_type}.
         *
         * @stability stable
         */
        readonly authorizationType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#description CloudwatchEventConnection#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#name CloudwatchEventConnection#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * auth_parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#auth_parameters CloudwatchEventConnection#auth_parameters}
         *
         * @stability stable
         */
        readonly authParameters: CloudwatchEventConnectionAuthParameters;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventConnectionAuthParametersApiKey {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#key CloudwatchEventConnection#key}.
         *
         * @stability stable
         */
        readonly key: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#value CloudwatchEventConnection#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * @stability stable
     */
    class CloudwatchEventConnectionAuthParametersApiKeyOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _key?;
        /**
         * @stability stable
         */
        get key(): string;
        /**
         * @stability stable
         */
        set key(value: string);
        /**
         * @stability stable
         */
        get keyInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): string;
        /**
         * @stability stable
         */
        set value(value: string);
        /**
         * @stability stable
         */
        get valueInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventConnectionAuthParametersBasic {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#password CloudwatchEventConnection#password}.
         *
         * @stability stable
         */
        readonly password: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#username CloudwatchEventConnection#username}.
         *
         * @stability stable
         */
        readonly username: string;
    }
    /**
     * @stability stable
     */
    class CloudwatchEventConnectionAuthParametersBasicOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _password?;
        /**
         * @stability stable
         */
        get password(): string;
        /**
         * @stability stable
         */
        set password(value: string);
        /**
         * @stability stable
         */
        get passwordInput(): string | undefined;
        private _username?;
        /**
         * @stability stable
         */
        get username(): string;
        /**
         * @stability stable
         */
        set username(value: string);
        /**
         * @stability stable
         */
        get usernameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventConnectionAuthParametersInvocationHttpParametersBody {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#is_value_secret CloudwatchEventConnection#is_value_secret}.
         *
         * @stability stable
         */
        readonly isValueSecret?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#key CloudwatchEventConnection#key}.
         *
         * @stability stable
         */
        readonly key?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#value CloudwatchEventConnection#value}.
         *
         * @stability stable
         */
        readonly value?: string;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventConnectionAuthParametersInvocationHttpParametersHeader {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#is_value_secret CloudwatchEventConnection#is_value_secret}.
         *
         * @stability stable
         */
        readonly isValueSecret?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#key CloudwatchEventConnection#key}.
         *
         * @stability stable
         */
        readonly key?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#value CloudwatchEventConnection#value}.
         *
         * @stability stable
         */
        readonly value?: string;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventConnectionAuthParametersInvocationHttpParametersQueryString {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#is_value_secret CloudwatchEventConnection#is_value_secret}.
         *
         * @stability stable
         */
        readonly isValueSecret?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#key CloudwatchEventConnection#key}.
         *
         * @stability stable
         */
        readonly key?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#value CloudwatchEventConnection#value}.
         *
         * @stability stable
         */
        readonly value?: string;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventConnectionAuthParametersInvocationHttpParameters {
        /**
         * body block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#body CloudwatchEventConnection#body}
         *
         * @stability stable
         */
        readonly body?: CloudwatchEventConnectionAuthParametersInvocationHttpParametersBody[];
        /**
         * header block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#header CloudwatchEventConnection#header}
         *
         * @stability stable
         */
        readonly header?: CloudwatchEventConnectionAuthParametersInvocationHttpParametersHeader[];
        /**
         * query_string block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#query_string CloudwatchEventConnection#query_string}
         *
         * @stability stable
         */
        readonly queryString?: CloudwatchEventConnectionAuthParametersInvocationHttpParametersQueryString[];
    }
    /**
     * @stability stable
     */
    class CloudwatchEventConnectionAuthParametersInvocationHttpParametersOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _body?;
        /**
         * @stability stable
         */
        get body(): CloudwatchEventConnectionAuthParametersInvocationHttpParametersBody[] | undefined;
        /**
         * @stability stable
         */
        set body(value: CloudwatchEventConnectionAuthParametersInvocationHttpParametersBody[] | undefined);
        /**
         * @stability stable
         */
        resetBody(): void;
        /**
         * @stability stable
         */
        get bodyInput(): CloudwatchEventConnectionAuthParametersInvocationHttpParametersBody[] | undefined;
        private _header?;
        /**
         * @stability stable
         */
        get header(): CloudwatchEventConnectionAuthParametersInvocationHttpParametersHeader[] | undefined;
        /**
         * @stability stable
         */
        set header(value: CloudwatchEventConnectionAuthParametersInvocationHttpParametersHeader[] | undefined);
        /**
         * @stability stable
         */
        resetHeader(): void;
        /**
         * @stability stable
         */
        get headerInput(): CloudwatchEventConnectionAuthParametersInvocationHttpParametersHeader[] | undefined;
        private _queryString?;
        /**
         * @stability stable
         */
        get queryString(): CloudwatchEventConnectionAuthParametersInvocationHttpParametersQueryString[] | undefined;
        /**
         * @stability stable
         */
        set queryString(value: CloudwatchEventConnectionAuthParametersInvocationHttpParametersQueryString[] | undefined);
        /**
         * @stability stable
         */
        resetQueryString(): void;
        /**
         * @stability stable
         */
        get queryStringInput(): CloudwatchEventConnectionAuthParametersInvocationHttpParametersQueryString[] | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventConnectionAuthParametersOauthClientParameters {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#client_id CloudwatchEventConnection#client_id}.
         *
         * @stability stable
         */
        readonly clientId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#client_secret CloudwatchEventConnection#client_secret}.
         *
         * @stability stable
         */
        readonly clientSecret: string;
    }
    /**
     * @stability stable
     */
    class CloudwatchEventConnectionAuthParametersOauthClientParametersOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _clientId?;
        /**
         * @stability stable
         */
        get clientId(): string;
        /**
         * @stability stable
         */
        set clientId(value: string);
        /**
         * @stability stable
         */
        get clientIdInput(): string | undefined;
        private _clientSecret?;
        /**
         * @stability stable
         */
        get clientSecret(): string;
        /**
         * @stability stable
         */
        set clientSecret(value: string);
        /**
         * @stability stable
         */
        get clientSecretInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersBody {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#is_value_secret CloudwatchEventConnection#is_value_secret}.
         *
         * @stability stable
         */
        readonly isValueSecret?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#key CloudwatchEventConnection#key}.
         *
         * @stability stable
         */
        readonly key?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#value CloudwatchEventConnection#value}.
         *
         * @stability stable
         */
        readonly value?: string;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersHeader {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#is_value_secret CloudwatchEventConnection#is_value_secret}.
         *
         * @stability stable
         */
        readonly isValueSecret?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#key CloudwatchEventConnection#key}.
         *
         * @stability stable
         */
        readonly key?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#value CloudwatchEventConnection#value}.
         *
         * @stability stable
         */
        readonly value?: string;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersQueryString {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#is_value_secret CloudwatchEventConnection#is_value_secret}.
         *
         * @stability stable
         */
        readonly isValueSecret?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#key CloudwatchEventConnection#key}.
         *
         * @stability stable
         */
        readonly key?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#value CloudwatchEventConnection#value}.
         *
         * @stability stable
         */
        readonly value?: string;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventConnectionAuthParametersOauthOauthHttpParameters {
        /**
         * body block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#body CloudwatchEventConnection#body}
         *
         * @stability stable
         */
        readonly body?: CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersBody[];
        /**
         * header block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#header CloudwatchEventConnection#header}
         *
         * @stability stable
         */
        readonly header?: CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersHeader[];
        /**
         * query_string block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#query_string CloudwatchEventConnection#query_string}
         *
         * @stability stable
         */
        readonly queryString?: CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersQueryString[];
    }
    /**
     * @stability stable
     */
    class CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _body?;
        /**
         * @stability stable
         */
        get body(): CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersBody[] | undefined;
        /**
         * @stability stable
         */
        set body(value: CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersBody[] | undefined);
        /**
         * @stability stable
         */
        resetBody(): void;
        /**
         * @stability stable
         */
        get bodyInput(): CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersBody[] | undefined;
        private _header?;
        /**
         * @stability stable
         */
        get header(): CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersHeader[] | undefined;
        /**
         * @stability stable
         */
        set header(value: CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersHeader[] | undefined);
        /**
         * @stability stable
         */
        resetHeader(): void;
        /**
         * @stability stable
         */
        get headerInput(): CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersHeader[] | undefined;
        private _queryString?;
        /**
         * @stability stable
         */
        get queryString(): CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersQueryString[] | undefined;
        /**
         * @stability stable
         */
        set queryString(value: CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersQueryString[] | undefined);
        /**
         * @stability stable
         */
        resetQueryString(): void;
        /**
         * @stability stable
         */
        get queryStringInput(): CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersQueryString[] | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventConnectionAuthParametersOauth {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#authorization_endpoint CloudwatchEventConnection#authorization_endpoint}.
         *
         * @stability stable
         */
        readonly authorizationEndpoint: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#http_method CloudwatchEventConnection#http_method}.
         *
         * @stability stable
         */
        readonly httpMethod: string;
        /**
         * client_parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#client_parameters CloudwatchEventConnection#client_parameters}
         *
         * @stability stable
         */
        readonly clientParameters?: CloudwatchEventConnectionAuthParametersOauthClientParameters;
        /**
         * oauth_http_parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#oauth_http_parameters CloudwatchEventConnection#oauth_http_parameters}
         *
         * @stability stable
         */
        readonly oauthHttpParameters: CloudwatchEventConnectionAuthParametersOauthOauthHttpParameters;
    }
    /**
     * @stability stable
     */
    class CloudwatchEventConnectionAuthParametersOauthOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _authorizationEndpoint?;
        /**
         * @stability stable
         */
        get authorizationEndpoint(): string;
        /**
         * @stability stable
         */
        set authorizationEndpoint(value: string);
        /**
         * @stability stable
         */
        get authorizationEndpointInput(): string | undefined;
        private _httpMethod?;
        /**
         * @stability stable
         */
        get httpMethod(): string;
        /**
         * @stability stable
         */
        set httpMethod(value: string);
        /**
         * @stability stable
         */
        get httpMethodInput(): string | undefined;
        private _clientParameters?;
        private __clientParametersOutput;
        /**
         * @stability stable
         */
        get clientParameters(): CloudwatchEventConnectionAuthParametersOauthClientParametersOutputReference;
        /**
         * @stability stable
         */
        putClientParameters(value: CloudwatchEventConnectionAuthParametersOauthClientParameters | undefined): void;
        /**
         * @stability stable
         */
        resetClientParameters(): void;
        /**
         * @stability stable
         */
        get clientParametersInput(): CloudwatchEventConnectionAuthParametersOauthClientParameters | undefined;
        private _oauthHttpParameters?;
        private __oauthHttpParametersOutput;
        /**
         * @stability stable
         */
        get oauthHttpParameters(): CloudwatchEventConnectionAuthParametersOauthOauthHttpParametersOutputReference;
        /**
         * @stability stable
         */
        putOauthHttpParameters(value: CloudwatchEventConnectionAuthParametersOauthOauthHttpParameters): void;
        /**
         * @stability stable
         */
        get oauthHttpParametersInput(): CloudwatchEventConnectionAuthParametersOauthOauthHttpParameters | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventConnectionAuthParameters {
        /**
         * api_key block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#api_key CloudwatchEventConnection#api_key}
         *
         * @stability stable
         */
        readonly apiKey?: CloudwatchEventConnectionAuthParametersApiKey;
        /**
         * basic block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#basic CloudwatchEventConnection#basic}
         *
         * @stability stable
         */
        readonly basic?: CloudwatchEventConnectionAuthParametersBasic;
        /**
         * invocation_http_parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#invocation_http_parameters CloudwatchEventConnection#invocation_http_parameters}
         *
         * @stability stable
         */
        readonly invocationHttpParameters?: CloudwatchEventConnectionAuthParametersInvocationHttpParameters;
        /**
         * oauth block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html#oauth CloudwatchEventConnection#oauth}
         *
         * @stability stable
         */
        readonly oauth?: CloudwatchEventConnectionAuthParametersOauth;
    }
    /**
     * @stability stable
     */
    class CloudwatchEventConnectionAuthParametersOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _apiKey?;
        private __apiKeyOutput;
        /**
         * @stability stable
         */
        get apiKey(): CloudwatchEventConnectionAuthParametersApiKeyOutputReference;
        /**
         * @stability stable
         */
        putApiKey(value: CloudwatchEventConnectionAuthParametersApiKey | undefined): void;
        /**
         * @stability stable
         */
        resetApiKey(): void;
        /**
         * @stability stable
         */
        get apiKeyInput(): CloudwatchEventConnectionAuthParametersApiKey | undefined;
        private _basic?;
        private __basicOutput;
        /**
         * @stability stable
         */
        get basic(): CloudwatchEventConnectionAuthParametersBasicOutputReference;
        /**
         * @stability stable
         */
        putBasic(value: CloudwatchEventConnectionAuthParametersBasic | undefined): void;
        /**
         * @stability stable
         */
        resetBasic(): void;
        /**
         * @stability stable
         */
        get basicInput(): CloudwatchEventConnectionAuthParametersBasic | undefined;
        private _invocationHttpParameters?;
        private __invocationHttpParametersOutput;
        /**
         * @stability stable
         */
        get invocationHttpParameters(): CloudwatchEventConnectionAuthParametersInvocationHttpParametersOutputReference;
        /**
         * @stability stable
         */
        putInvocationHttpParameters(value: CloudwatchEventConnectionAuthParametersInvocationHttpParameters | undefined): void;
        /**
         * @stability stable
         */
        resetInvocationHttpParameters(): void;
        /**
         * @stability stable
         */
        get invocationHttpParametersInput(): CloudwatchEventConnectionAuthParametersInvocationHttpParameters | undefined;
        private _oauth?;
        private __oauthOutput;
        /**
         * @stability stable
         */
        get oauth(): CloudwatchEventConnectionAuthParametersOauthOutputReference;
        /**
         * @stability stable
         */
        putOauth(value: CloudwatchEventConnectionAuthParametersOauth | undefined): void;
        /**
         * @stability stable
         */
        resetOauth(): void;
        /**
         * @stability stable
         */
        get oauthInput(): CloudwatchEventConnectionAuthParametersOauth | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html aws_cloudwatch_event_connection}.
     *
     * @stability stable
     */
    class CloudwatchEventConnection extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_connection.html aws_cloudwatch_event_connection} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchEventConnectionConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _authorizationType?;
        /**
         * @stability stable
         */
        get authorizationType(): string;
        /**
         * @stability stable
         */
        set authorizationType(value: string);
        /**
         * @stability stable
         */
        get authorizationTypeInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get secretArn(): string;
        private _authParameters?;
        private __authParametersOutput;
        /**
         * @stability stable
         */
        get authParameters(): CloudwatchEventConnectionAuthParametersOutputReference;
        /**
         * @stability stable
         */
        putAuthParameters(value: CloudwatchEventConnectionAuthParameters): void;
        /**
         * @stability stable
         */
        get authParametersInput(): CloudwatchEventConnectionAuthParameters | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventPermissionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_permission.html#action CloudwatchEventPermission#action}.
         *
         * @stability stable
         */
        readonly action?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_permission.html#event_bus_name CloudwatchEventPermission#event_bus_name}.
         *
         * @stability stable
         */
        readonly eventBusName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_permission.html#principal CloudwatchEventPermission#principal}.
         *
         * @stability stable
         */
        readonly principal: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_permission.html#statement_id CloudwatchEventPermission#statement_id}.
         *
         * @stability stable
         */
        readonly statementId: string;
        /**
         * condition block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_permission.html#condition CloudwatchEventPermission#condition}
         *
         * @stability stable
         */
        readonly condition?: CloudwatchEventPermissionCondition;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventPermissionCondition {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_permission.html#key CloudwatchEventPermission#key}.
         *
         * @stability stable
         */
        readonly key: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_permission.html#type CloudwatchEventPermission#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_permission.html#value CloudwatchEventPermission#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * @stability stable
     */
    class CloudwatchEventPermissionConditionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _key?;
        /**
         * @stability stable
         */
        get key(): string;
        /**
         * @stability stable
         */
        set key(value: string);
        /**
         * @stability stable
         */
        get keyInput(): string | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): string;
        /**
         * @stability stable
         */
        set value(value: string);
        /**
         * @stability stable
         */
        get valueInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_permission.html aws_cloudwatch_event_permission}.
     *
     * @stability stable
     */
    class CloudwatchEventPermission extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_permission.html aws_cloudwatch_event_permission} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchEventPermissionConfig);
        private _action?;
        /**
         * @stability stable
         */
        get action(): string | undefined;
        /**
         * @stability stable
         */
        set action(value: string | undefined);
        /**
         * @stability stable
         */
        resetAction(): void;
        /**
         * @stability stable
         */
        get actionInput(): string | undefined;
        private _eventBusName?;
        /**
         * @stability stable
         */
        get eventBusName(): string | undefined;
        /**
         * @stability stable
         */
        set eventBusName(value: string | undefined);
        /**
         * @stability stable
         */
        resetEventBusName(): void;
        /**
         * @stability stable
         */
        get eventBusNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _principal?;
        /**
         * @stability stable
         */
        get principal(): string;
        /**
         * @stability stable
         */
        set principal(value: string);
        /**
         * @stability stable
         */
        get principalInput(): string | undefined;
        private _statementId?;
        /**
         * @stability stable
         */
        get statementId(): string;
        /**
         * @stability stable
         */
        set statementId(value: string);
        /**
         * @stability stable
         */
        get statementIdInput(): string | undefined;
        private _condition?;
        private __conditionOutput;
        /**
         * @stability stable
         */
        get condition(): CloudwatchEventPermissionConditionOutputReference;
        /**
         * @stability stable
         */
        putCondition(value: CloudwatchEventPermissionCondition | undefined): void;
        /**
         * @stability stable
         */
        resetCondition(): void;
        /**
         * @stability stable
         */
        get conditionInput(): CloudwatchEventPermissionCondition | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventRuleConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_rule.html#description CloudwatchEventRule#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_rule.html#event_bus_name CloudwatchEventRule#event_bus_name}.
         *
         * @stability stable
         */
        readonly eventBusName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_rule.html#event_pattern CloudwatchEventRule#event_pattern}.
         *
         * @stability stable
         */
        readonly eventPattern?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_rule.html#is_enabled CloudwatchEventRule#is_enabled}.
         *
         * @stability stable
         */
        readonly isEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_rule.html#name CloudwatchEventRule#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_rule.html#name_prefix CloudwatchEventRule#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_rule.html#role_arn CloudwatchEventRule#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_rule.html#schedule_expression CloudwatchEventRule#schedule_expression}.
         *
         * @stability stable
         */
        readonly scheduleExpression?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_rule.html#tags CloudwatchEventRule#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_rule.html#tags_all CloudwatchEventRule#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_rule.html aws_cloudwatch_event_rule}.
     *
     * @stability stable
     */
    class CloudwatchEventRule extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_rule.html aws_cloudwatch_event_rule} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: CloudwatchEventRuleConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _eventBusName?;
        /**
         * @stability stable
         */
        get eventBusName(): string | undefined;
        /**
         * @stability stable
         */
        set eventBusName(value: string | undefined);
        /**
         * @stability stable
         */
        resetEventBusName(): void;
        /**
         * @stability stable
         */
        get eventBusNameInput(): string | undefined;
        private _eventPattern?;
        /**
         * @stability stable
         */
        get eventPattern(): string | undefined;
        /**
         * @stability stable
         */
        set eventPattern(value: string | undefined);
        /**
         * @stability stable
         */
        resetEventPattern(): void;
        /**
         * @stability stable
         */
        get eventPatternInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _isEnabled?;
        /**
         * @stability stable
         */
        get isEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set isEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIsEnabled(): void;
        /**
         * @stability stable
         */
        get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set namePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamePrefix(): void;
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string | undefined;
        /**
         * @stability stable
         */
        set roleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetRoleArn(): void;
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        private _scheduleExpression?;
        /**
         * @stability stable
         */
        get scheduleExpression(): string | undefined;
        /**
         * @stability stable
         */
        set scheduleExpression(value: string | undefined);
        /**
         * @stability stable
         */
        resetScheduleExpression(): void;
        /**
         * @stability stable
         */
        get scheduleExpressionInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventTargetConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#arn CloudwatchEventTarget#arn}.
         *
         * @stability stable
         */
        readonly arn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#event_bus_name CloudwatchEventTarget#event_bus_name}.
         *
         * @stability stable
         */
        readonly eventBusName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#input CloudwatchEventTarget#input}.
         *
         * @stability stable
         */
        readonly input?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#input_path CloudwatchEventTarget#input_path}.
         *
         * @stability stable
         */
        readonly inputPath?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#role_arn CloudwatchEventTarget#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#rule CloudwatchEventTarget#rule}.
         *
         * @stability stable
         */
        readonly rule: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#target_id CloudwatchEventTarget#target_id}.
         *
         * @stability stable
         */
        readonly targetId?: string;
        /**
         * batch_target block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#batch_target CloudwatchEventTarget#batch_target}
         *
         * @stability stable
         */
        readonly batchTarget?: CloudwatchEventTargetBatchTarget;
        /**
         * dead_letter_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#dead_letter_config CloudwatchEventTarget#dead_letter_config}
         *
         * @stability stable
         */
        readonly deadLetterConfig?: CloudwatchEventTargetDeadLetterConfig;
        /**
         * ecs_target block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#ecs_target CloudwatchEventTarget#ecs_target}
         *
         * @stability stable
         */
        readonly ecsTarget?: CloudwatchEventTargetEcsTarget;
        /**
         * http_target block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#http_target CloudwatchEventTarget#http_target}
         *
         * @stability stable
         */
        readonly httpTarget?: CloudwatchEventTargetHttpTarget;
        /**
         * input_transformer block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#input_transformer CloudwatchEventTarget#input_transformer}
         *
         * @stability stable
         */
        readonly inputTransformer?: CloudwatchEventTargetInputTransformer;
        /**
         * kinesis_target block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#kinesis_target CloudwatchEventTarget#kinesis_target}
         *
         * @stability stable
         */
        readonly kinesisTarget?: CloudwatchEventTargetKinesisTarget;
        /**
         * redshift_target block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#redshift_target CloudwatchEventTarget#redshift_target}
         *
         * @stability stable
         */
        readonly redshiftTarget?: CloudwatchEventTargetRedshiftTarget;
        /**
         * retry_policy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#retry_policy CloudwatchEventTarget#retry_policy}
         *
         * @stability stable
         */
        readonly retryPolicy?: CloudwatchEventTargetRetryPolicy;
        /**
         * run_command_targets block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#run_command_targets CloudwatchEventTarget#run_command_targets}
         *
         * @stability stable
         */
        readonly runCommandTargets?: CloudwatchEventTargetRunCommandTargets[];
        /**
         * sqs_target block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#sqs_target CloudwatchEventTarget#sqs_target}
         *
         * @stability stable
         */
        readonly sqsTarget?: CloudwatchEventTargetSqsTarget;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventTargetBatchTarget {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#array_size CloudwatchEventTarget#array_size}.
         *
         * @stability stable
         */
        readonly arraySize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#job_attempts CloudwatchEventTarget#job_attempts}.
         *
         * @stability stable
         */
        readonly jobAttempts?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#job_definition CloudwatchEventTarget#job_definition}.
         *
         * @stability stable
         */
        readonly jobDefinition: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#job_name CloudwatchEventTarget#job_name}.
         *
         * @stability stable
         */
        readonly jobName: string;
    }
    /**
     * @stability stable
     */
    class CloudwatchEventTargetBatchTargetOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _arraySize?;
        /**
         * @stability stable
         */
        get arraySize(): number | undefined;
        /**
         * @stability stable
         */
        set arraySize(value: number | undefined);
        /**
         * @stability stable
         */
        resetArraySize(): void;
        /**
         * @stability stable
         */
        get arraySizeInput(): number | undefined;
        private _jobAttempts?;
        /**
         * @stability stable
         */
        get jobAttempts(): number | undefined;
        /**
         * @stability stable
         */
        set jobAttempts(value: number | undefined);
        /**
         * @stability stable
         */
        resetJobAttempts(): void;
        /**
         * @stability stable
         */
        get jobAttemptsInput(): number | undefined;
        private _jobDefinition?;
        /**
         * @stability stable
         */
        get jobDefinition(): string;
        /**
         * @stability stable
         */
        set jobDefinition(value: string);
        /**
         * @stability stable
         */
        get jobDefinitionInput(): string | undefined;
        private _jobName?;
        /**
         * @stability stable
         */
        get jobName(): string;
        /**
         * @stability stable
         */
        set jobName(value: string);
        /**
         * @stability stable
         */
        get jobNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventTargetDeadLetterConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#arn CloudwatchEventTarget#arn}.
         *
         * @stability stable
         */
        readonly arn?: string;
    }
    /**
     * @stability stable
     */
    class CloudwatchEventTargetDeadLetterConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _arn?;
        /**
         * @stability stable
         */
        get arn(): string | undefined;
        /**
         * @stability stable
         */
        set arn(value: string | undefined);
        /**
         * @stability stable
         */
        resetArn(): void;
        /**
         * @stability stable
         */
        get arnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventTargetEcsTargetNetworkConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#assign_public_ip CloudwatchEventTarget#assign_public_ip}.
         *
         * @stability stable
         */
        readonly assignPublicIp?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#security_groups CloudwatchEventTarget#security_groups}.
         *
         * @stability stable
         */
        readonly securityGroups?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#subnets CloudwatchEventTarget#subnets}.
         *
         * @stability stable
         */
        readonly subnets: string[];
    }
    /**
     * @stability stable
     */
    class CloudwatchEventTargetEcsTargetNetworkConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _assignPublicIp?;
        /**
         * @stability stable
         */
        get assignPublicIp(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set assignPublicIp(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAssignPublicIp(): void;
        /**
         * @stability stable
         */
        get assignPublicIpInput(): boolean | cdktf.IResolvable | undefined;
        private _securityGroups?;
        /**
         * @stability stable
         */
        get securityGroups(): string[] | undefined;
        /**
         * @stability stable
         */
        set securityGroups(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecurityGroups(): void;
        /**
         * @stability stable
         */
        get securityGroupsInput(): string[] | undefined;
        private _subnets?;
        /**
         * @stability stable
         */
        get subnets(): string[];
        /**
         * @stability stable
         */
        set subnets(value: string[]);
        /**
         * @stability stable
         */
        get subnetsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventTargetEcsTargetPlacementConstraint {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#expression CloudwatchEventTarget#expression}.
         *
         * @stability stable
         */
        readonly expression?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#type CloudwatchEventTarget#type}.
         *
         * @stability stable
         */
        readonly type: string;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventTargetEcsTarget {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#enable_ecs_managed_tags CloudwatchEventTarget#enable_ecs_managed_tags}.
         *
         * @stability stable
         */
        readonly enableEcsManagedTags?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#enable_execute_command CloudwatchEventTarget#enable_execute_command}.
         *
         * @stability stable
         */
        readonly enableExecuteCommand?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#group CloudwatchEventTarget#group}.
         *
         * @stability stable
         */
        readonly group?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#launch_type CloudwatchEventTarget#launch_type}.
         *
         * @stability stable
         */
        readonly launchType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#platform_version CloudwatchEventTarget#platform_version}.
         *
         * @stability stable
         */
        readonly platformVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#propagate_tags CloudwatchEventTarget#propagate_tags}.
         *
         * @stability stable
         */
        readonly propagateTags?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#tags CloudwatchEventTarget#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#task_count CloudwatchEventTarget#task_count}.
         *
         * @stability stable
         */
        readonly taskCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#task_definition_arn CloudwatchEventTarget#task_definition_arn}.
         *
         * @stability stable
         */
        readonly taskDefinitionArn: string;
        /**
         * network_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#network_configuration CloudwatchEventTarget#network_configuration}
         *
         * @stability stable
         */
        readonly networkConfiguration?: CloudwatchEventTargetEcsTargetNetworkConfiguration;
        /**
         * placement_constraint block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#placement_constraint CloudwatchEventTarget#placement_constraint}
         *
         * @stability stable
         */
        readonly placementConstraint?: CloudwatchEventTargetEcsTargetPlacementConstraint[];
    }
    /**
     * @stability stable
     */
    class CloudwatchEventTargetEcsTargetOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enableEcsManagedTags?;
        /**
         * @stability stable
         */
        get enableEcsManagedTags(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableEcsManagedTags(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableEcsManagedTags(): void;
        /**
         * @stability stable
         */
        get enableEcsManagedTagsInput(): boolean | cdktf.IResolvable | undefined;
        private _enableExecuteCommand?;
        /**
         * @stability stable
         */
        get enableExecuteCommand(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableExecuteCommand(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableExecuteCommand(): void;
        /**
         * @stability stable
         */
        get enableExecuteCommandInput(): boolean | cdktf.IResolvable | undefined;
        private _group?;
        /**
         * @stability stable
         */
        get group(): string | undefined;
        /**
         * @stability stable
         */
        set group(value: string | undefined);
        /**
         * @stability stable
         */
        resetGroup(): void;
        /**
         * @stability stable
         */
        get groupInput(): string | undefined;
        private _launchType?;
        /**
         * @stability stable
         */
        get launchType(): string | undefined;
        /**
         * @stability stable
         */
        set launchType(value: string | undefined);
        /**
         * @stability stable
         */
        resetLaunchType(): void;
        /**
         * @stability stable
         */
        get launchTypeInput(): string | undefined;
        private _platformVersion?;
        /**
         * @stability stable
         */
        get platformVersion(): string | undefined;
        /**
         * @stability stable
         */
        set platformVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetPlatformVersion(): void;
        /**
         * @stability stable
         */
        get platformVersionInput(): string | undefined;
        private _propagateTags?;
        /**
         * @stability stable
         */
        get propagateTags(): string | undefined;
        /**
         * @stability stable
         */
        set propagateTags(value: string | undefined);
        /**
         * @stability stable
         */
        resetPropagateTags(): void;
        /**
         * @stability stable
         */
        get propagateTagsInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _taskCount?;
        /**
         * @stability stable
         */
        get taskCount(): number | undefined;
        /**
         * @stability stable
         */
        set taskCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetTaskCount(): void;
        /**
         * @stability stable
         */
        get taskCountInput(): number | undefined;
        private _taskDefinitionArn?;
        /**
         * @stability stable
         */
        get taskDefinitionArn(): string;
        /**
         * @stability stable
         */
        set taskDefinitionArn(value: string);
        /**
         * @stability stable
         */
        get taskDefinitionArnInput(): string | undefined;
        private _networkConfiguration?;
        private __networkConfigurationOutput;
        /**
         * @stability stable
         */
        get networkConfiguration(): CloudwatchEventTargetEcsTargetNetworkConfigurationOutputReference;
        /**
         * @stability stable
         */
        putNetworkConfiguration(value: CloudwatchEventTargetEcsTargetNetworkConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetNetworkConfiguration(): void;
        /**
         * @stability stable
         */
        get networkConfigurationInput(): CloudwatchEventTargetEcsTargetNetworkConfiguration | undefined;
        private _placementConstraint?;
        /**
         * @stability stable
         */
        get placementConstraint(): CloudwatchEventTargetEcsTargetPlacementConstraint[] | undefined;
        /**
         * @stability stable
         */
        set placementConstraint(value: CloudwatchEventTargetEcsTargetPlacementConstraint[] | undefined);
        /**
         * @stability stable
         */
        resetPlacementConstraint(): void;
        /**
         * @stability stable
         */
        get placementConstraintInput(): CloudwatchEventTargetEcsTargetPlacementConstraint[] | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventTargetHttpTarget {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#header_parameters CloudwatchEventTarget#header_parameters}.
         *
         * @stability stable
         */
        readonly headerParameters?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#path_parameter_values CloudwatchEventTarget#path_parameter_values}.
         *
         * @stability stable
         */
        readonly pathParameterValues?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#query_string_parameters CloudwatchEventTarget#query_string_parameters}.
         *
         * @stability stable
         */
        readonly queryStringParameters?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class CloudwatchEventTargetHttpTargetOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _headerParameters?;
        /**
         * @stability stable
         */
        get headerParameters(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set headerParameters(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetHeaderParameters(): void;
        /**
         * @stability stable
         */
        get headerParametersInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _pathParameterValues?;
        /**
         * @stability stable
         */
        get pathParameterValues(): string[] | undefined;
        /**
         * @stability stable
         */
        set pathParameterValues(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetPathParameterValues(): void;
        /**
         * @stability stable
         */
        get pathParameterValuesInput(): string[] | undefined;
        private _queryStringParameters?;
        /**
         * @stability stable
         */
        get queryStringParameters(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set queryStringParameters(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetQueryStringParameters(): void;
        /**
         * @stability stable
         */
        get queryStringParametersInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventTargetInputTransformer {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#input_paths CloudwatchEventTarget#input_paths}.
         *
         * @stability stable
         */
        readonly inputPaths?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#input_template CloudwatchEventTarget#input_template}.
         *
         * @stability stable
         */
        readonly inputTemplate: string;
    }
    /**
     * @stability stable
     */
    class CloudwatchEventTargetInputTransformerOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _inputPaths?;
        /**
         * @stability stable
         */
        get inputPaths(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set inputPaths(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetInputPaths(): void;
        /**
         * @stability stable
         */
        get inputPathsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _inputTemplate?;
        /**
         * @stability stable
         */
        get inputTemplate(): string;
        /**
         * @stability stable
         */
        set inputTemplate(value: string);
        /**
         * @stability stable
         */
        get inputTemplateInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventTargetKinesisTarget {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#partition_key_path CloudwatchEventTarget#partition_key_path}.
         *
         * @stability stable
         */
        readonly partitionKeyPath?: string;
    }
    /**
     * @stability stable
     */
    class CloudwatchEventTargetKinesisTargetOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _partitionKeyPath?;
        /**
         * @stability stable
         */
        get partitionKeyPath(): string | undefined;
        /**
         * @stability stable
         */
        set partitionKeyPath(value: string | undefined);
        /**
         * @stability stable
         */
        resetPartitionKeyPath(): void;
        /**
         * @stability stable
         */
        get partitionKeyPathInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventTargetRedshiftTarget {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#database CloudwatchEventTarget#database}.
         *
         * @stability stable
         */
        readonly database: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#db_user CloudwatchEventTarget#db_user}.
         *
         * @stability stable
         */
        readonly dbUser?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#secrets_manager_arn CloudwatchEventTarget#secrets_manager_arn}.
         *
         * @stability stable
         */
        readonly secretsManagerArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#sql CloudwatchEventTarget#sql}.
         *
         * @stability stable
         */
        readonly sql?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#statement_name CloudwatchEventTarget#statement_name}.
         *
         * @stability stable
         */
        readonly statementName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#with_event CloudwatchEventTarget#with_event}.
         *
         * @stability stable
         */
        readonly withEvent?: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class CloudwatchEventTargetRedshiftTargetOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _database?;
        /**
         * @stability stable
         */
        get database(): string;
        /**
         * @stability stable
         */
        set database(value: string);
        /**
         * @stability stable
         */
        get databaseInput(): string | undefined;
        private _dbUser?;
        /**
         * @stability stable
         */
        get dbUser(): string | undefined;
        /**
         * @stability stable
         */
        set dbUser(value: string | undefined);
        /**
         * @stability stable
         */
        resetDbUser(): void;
        /**
         * @stability stable
         */
        get dbUserInput(): string | undefined;
        private _secretsManagerArn?;
        /**
         * @stability stable
         */
        get secretsManagerArn(): string | undefined;
        /**
         * @stability stable
         */
        set secretsManagerArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetSecretsManagerArn(): void;
        /**
         * @stability stable
         */
        get secretsManagerArnInput(): string | undefined;
        private _sql?;
        /**
         * @stability stable
         */
        get sql(): string | undefined;
        /**
         * @stability stable
         */
        set sql(value: string | undefined);
        /**
         * @stability stable
         */
        resetSql(): void;
        /**
         * @stability stable
         */
        get sqlInput(): string | undefined;
        private _statementName?;
        /**
         * @stability stable
         */
        get statementName(): string | undefined;
        /**
         * @stability stable
         */
        set statementName(value: string | undefined);
        /**
         * @stability stable
         */
        resetStatementName(): void;
        /**
         * @stability stable
         */
        get statementNameInput(): string | undefined;
        private _withEvent?;
        /**
         * @stability stable
         */
        get withEvent(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set withEvent(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetWithEvent(): void;
        /**
         * @stability stable
         */
        get withEventInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventTargetRetryPolicy {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#maximum_event_age_in_seconds CloudwatchEventTarget#maximum_event_age_in_seconds}.
         *
         * @stability stable
         */
        readonly maximumEventAgeInSeconds?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#maximum_retry_attempts CloudwatchEventTarget#maximum_retry_attempts}.
         *
         * @stability stable
         */
        readonly maximumRetryAttempts?: number;
    }
    /**
     * @stability stable
     */
    class CloudwatchEventTargetRetryPolicyOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _maximumEventAgeInSeconds?;
        /**
         * @stability stable
         */
        get maximumEventAgeInSeconds(): number | undefined;
        /**
         * @stability stable
         */
        set maximumEventAgeInSeconds(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaximumEventAgeInSeconds(): void;
        /**
         * @stability stable
         */
        get maximumEventAgeInSecondsInput(): number | undefined;
        private _maximumRetryAttempts?;
        /**
         * @stability stable
         */
        get maximumRetryAttempts(): number | undefined;
        /**
         * @stability stable
         */
        set maximumRetryAttempts(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaximumRetryAttempts(): void;
        /**
         * @stability stable
         */
        get maximumRetryAttemptsInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventTargetRunCommandTargets {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#key CloudwatchEventTarget#key}.
         *
         * @stability stable
         */
        readonly key: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#values CloudwatchEventTarget#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * @stability stable
     */
    interface CloudwatchEventTargetSqsTarget {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#message_group_id CloudwatchEventTarget#message_group_id}.
         *
         * @stability stable
         */
        readonly messageGroupId?: string;
    }
    /**
     * @stability stable
     */
    class CloudwatchEventTargetSqsTargetOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _messageGroupId?;
        /**
         * @stability stable
         */
        get messageGroupId(): string | undefined;
        /**
         * @stability stable
         */
        set messageGroupId(value: string | undefined);
        /**
         * @stability stable
         */
        resetMessageGroupId(): void;
        /**
         * @stability stable
         */
        get messageGroupIdInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html aws_cloudwatch_event_target}.
     *
     * @stability stable
     */
    class CloudwatchEventTarget extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html aws_cloudwatch_event_target} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CloudwatchEventTargetConfig);
        private _arn?;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        set arn(value: string);
        /**
         * @stability stable
         */
        get arnInput(): string | undefined;
        private _eventBusName?;
        /**
         * @stability stable
         */
        get eventBusName(): string | undefined;
        /**
         * @stability stable
         */
        set eventBusName(value: string | undefined);
        /**
         * @stability stable
         */
        resetEventBusName(): void;
        /**
         * @stability stable
         */
        get eventBusNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _input?;
        /**
         * @stability stable
         */
        get input(): string | undefined;
        /**
         * @stability stable
         */
        set input(value: string | undefined);
        /**
         * @stability stable
         */
        resetInput(): void;
        /**
         * @stability stable
         */
        get inputInput(): string | undefined;
        private _inputPath?;
        /**
         * @stability stable
         */
        get inputPath(): string | undefined;
        /**
         * @stability stable
         */
        set inputPath(value: string | undefined);
        /**
         * @stability stable
         */
        resetInputPath(): void;
        /**
         * @stability stable
         */
        get inputPathInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string | undefined;
        /**
         * @stability stable
         */
        set roleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetRoleArn(): void;
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        private _rule?;
        /**
         * @stability stable
         */
        get rule(): string;
        /**
         * @stability stable
         */
        set rule(value: string);
        /**
         * @stability stable
         */
        get ruleInput(): string | undefined;
        private _targetId?;
        /**
         * @stability stable
         */
        get targetId(): string | undefined;
        /**
         * @stability stable
         */
        set targetId(value: string | undefined);
        /**
         * @stability stable
         */
        resetTargetId(): void;
        /**
         * @stability stable
         */
        get targetIdInput(): string | undefined;
        private _batchTarget?;
        private __batchTargetOutput;
        /**
         * @stability stable
         */
        get batchTarget(): CloudwatchEventTargetBatchTargetOutputReference;
        /**
         * @stability stable
         */
        putBatchTarget(value: CloudwatchEventTargetBatchTarget | undefined): void;
        /**
         * @stability stable
         */
        resetBatchTarget(): void;
        /**
         * @stability stable
         */
        get batchTargetInput(): CloudwatchEventTargetBatchTarget | undefined;
        private _deadLetterConfig?;
        private __deadLetterConfigOutput;
        /**
         * @stability stable
         */
        get deadLetterConfig(): CloudwatchEventTargetDeadLetterConfigOutputReference;
        /**
         * @stability stable
         */
        putDeadLetterConfig(value: CloudwatchEventTargetDeadLetterConfig | undefined): void;
        /**
         * @stability stable
         */
        resetDeadLetterConfig(): void;
        /**
         * @stability stable
         */
        get deadLetterConfigInput(): CloudwatchEventTargetDeadLetterConfig | undefined;
        private _ecsTarget?;
        private __ecsTargetOutput;
        /**
         * @stability stable
         */
        get ecsTarget(): CloudwatchEventTargetEcsTargetOutputReference;
        /**
         * @stability stable
         */
        putEcsTarget(value: CloudwatchEventTargetEcsTarget | undefined): void;
        /**
         * @stability stable
         */
        resetEcsTarget(): void;
        /**
         * @stability stable
         */
        get ecsTargetInput(): CloudwatchEventTargetEcsTarget | undefined;
        private _httpTarget?;
        private __httpTargetOutput;
        /**
         * @stability stable
         */
        get httpTarget(): CloudwatchEventTargetHttpTargetOutputReference;
        /**
         * @stability stable
         */
        putHttpTarget(value: CloudwatchEventTargetHttpTarget | undefined): void;
        /**
         * @stability stable
         */
        resetHttpTarget(): void;
        /**
         * @stability stable
         */
        get httpTargetInput(): CloudwatchEventTargetHttpTarget | undefined;
        private _inputTransformer?;
        private __inputTransformerOutput;
        /**
         * @stability stable
         */
        get inputTransformer(): CloudwatchEventTargetInputTransformerOutputReference;
        /**
         * @stability stable
         */
        putInputTransformer(value: CloudwatchEventTargetInputTransformer | undefined): void;
        /**
         * @stability stable
         */
        resetInputTransformer(): void;
        /**
         * @stability stable
         */
        get inputTransformerInput(): CloudwatchEventTargetInputTransformer | undefined;
        private _kinesisTarget?;
        private __kinesisTargetOutput;
        /**
         * @stability stable
         */
        get kinesisTarget(): CloudwatchEventTargetKinesisTargetOutputReference;
        /**
         * @stability stable
         */
        putKinesisTarget(value: CloudwatchEventTargetKinesisTarget | undefined): void;
        /**
         * @stability stable
         */
        resetKinesisTarget(): void;
        /**
         * @stability stable
         */
        get kinesisTargetInput(): CloudwatchEventTargetKinesisTarget | undefined;
        private _redshiftTarget?;
        private __redshiftTargetOutput;
        /**
         * @stability stable
         */
        get redshiftTarget(): CloudwatchEventTargetRedshiftTargetOutputReference;
        /**
         * @stability stable
         */
        putRedshiftTarget(value: CloudwatchEventTargetRedshiftTarget | undefined): void;
        /**
         * @stability stable
         */
        resetRedshiftTarget(): void;
        /**
         * @stability stable
         */
        get redshiftTargetInput(): CloudwatchEventTargetRedshiftTarget | undefined;
        private _retryPolicy?;
        private __retryPolicyOutput;
        /**
         * @stability stable
         */
        get retryPolicy(): CloudwatchEventTargetRetryPolicyOutputReference;
        /**
         * @stability stable
         */
        putRetryPolicy(value: CloudwatchEventTargetRetryPolicy | undefined): void;
        /**
         * @stability stable
         */
        resetRetryPolicy(): void;
        /**
         * @stability stable
         */
        get retryPolicyInput(): CloudwatchEventTargetRetryPolicy | undefined;
        private _runCommandTargets?;
        /**
         * @stability stable
         */
        get runCommandTargets(): CloudwatchEventTargetRunCommandTargets[] | undefined;
        /**
         * @stability stable
         */
        set runCommandTargets(value: CloudwatchEventTargetRunCommandTargets[] | undefined);
        /**
         * @stability stable
         */
        resetRunCommandTargets(): void;
        /**
         * @stability stable
         */
        get runCommandTargetsInput(): CloudwatchEventTargetRunCommandTargets[] | undefined;
        private _sqsTarget?;
        private __sqsTargetOutput;
        /**
         * @stability stable
         */
        get sqsTarget(): CloudwatchEventTargetSqsTargetOutputReference;
        /**
         * @stability stable
         */
        putSqsTarget(value: CloudwatchEventTargetSqsTarget | undefined): void;
        /**
         * @stability stable
         */
        resetSqsTarget(): void;
        /**
         * @stability stable
         */
        get sqsTargetInput(): CloudwatchEventTargetSqsTarget | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsCloudwatchEventConnectionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudwatch_event_connection.html#name DataAwsCloudwatchEventConnection#name}.
         *
         * @stability stable
         */
        readonly name: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/cloudwatch_event_connection.html aws_cloudwatch_event_connection}.
     *
     * @stability stable
     */
    class DataAwsCloudwatchEventConnection extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cloudwatch_event_connection.html aws_cloudwatch_event_connection} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsCloudwatchEventConnectionConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get authorizationType(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get secretArn(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsCloudwatchEventSourceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudwatch_event_source.html#name_prefix DataAwsCloudwatchEventSource#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/cloudwatch_event_source.html aws_cloudwatch_event_source}.
     *
     * @stability stable
     */
    class DataAwsCloudwatchEventSource extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cloudwatch_event_source.html aws_cloudwatch_event_source} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsCloudwatchEventSourceConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdBy(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get name(): string;
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set namePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamePrefix(): void;
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        /**
         * @stability stable
         */
        get state(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
