import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS CodeBuild
*/
export declare namespace CodeBuild {
    /**
     * @stability stable
     */
    interface CodebuildProjectConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#badge_enabled CodebuildProject#badge_enabled}.
         *
         * @stability stable
         */
        readonly badgeEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#build_timeout CodebuildProject#build_timeout}.
         *
         * @stability stable
         */
        readonly buildTimeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#concurrent_build_limit CodebuildProject#concurrent_build_limit}.
         *
         * @stability stable
         */
        readonly concurrentBuildLimit?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#description CodebuildProject#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#encryption_key CodebuildProject#encryption_key}.
         *
         * @stability stable
         */
        readonly encryptionKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#name CodebuildProject#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#queued_timeout CodebuildProject#queued_timeout}.
         *
         * @stability stable
         */
        readonly queuedTimeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#service_role CodebuildProject#service_role}.
         *
         * @stability stable
         */
        readonly serviceRole: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#source_version CodebuildProject#source_version}.
         *
         * @stability stable
         */
        readonly sourceVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#tags CodebuildProject#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#tags_all CodebuildProject#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * artifacts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#artifacts CodebuildProject#artifacts}
         *
         * @stability stable
         */
        readonly artifacts: CodebuildProjectArtifacts;
        /**
         * build_batch_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#build_batch_config CodebuildProject#build_batch_config}
         *
         * @stability stable
         */
        readonly buildBatchConfig?: CodebuildProjectBuildBatchConfig;
        /**
         * cache block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#cache CodebuildProject#cache}
         *
         * @stability stable
         */
        readonly cache?: CodebuildProjectCache;
        /**
         * environment block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#environment CodebuildProject#environment}
         *
         * @stability stable
         */
        readonly environment: CodebuildProjectEnvironment;
        /**
         * file_system_locations block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#file_system_locations CodebuildProject#file_system_locations}
         *
         * @stability stable
         */
        readonly fileSystemLocations?: CodebuildProjectFileSystemLocations[];
        /**
         * logs_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#logs_config CodebuildProject#logs_config}
         *
         * @stability stable
         */
        readonly logsConfig?: CodebuildProjectLogsConfig;
        /**
         * secondary_artifacts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#secondary_artifacts CodebuildProject#secondary_artifacts}
         *
         * @stability stable
         */
        readonly secondaryArtifacts?: CodebuildProjectSecondaryArtifacts[];
        /**
         * secondary_sources block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#secondary_sources CodebuildProject#secondary_sources}
         *
         * @stability stable
         */
        readonly secondarySources?: CodebuildProjectSecondarySources[];
        /**
         * source block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#source CodebuildProject#source}
         *
         * @stability stable
         */
        readonly source: CodebuildProjectSource;
        /**
         * vpc_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#vpc_config CodebuildProject#vpc_config}
         *
         * @stability stable
         */
        readonly vpcConfig?: CodebuildProjectVpcConfig;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectArtifacts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#artifact_identifier CodebuildProject#artifact_identifier}.
         *
         * @stability stable
         */
        readonly artifactIdentifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#encryption_disabled CodebuildProject#encryption_disabled}.
         *
         * @stability stable
         */
        readonly encryptionDisabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#location CodebuildProject#location}.
         *
         * @stability stable
         */
        readonly location?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#name CodebuildProject#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#namespace_type CodebuildProject#namespace_type}.
         *
         * @stability stable
         */
        readonly namespaceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#override_artifact_name CodebuildProject#override_artifact_name}.
         *
         * @stability stable
         */
        readonly overrideArtifactName?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#packaging CodebuildProject#packaging}.
         *
         * @stability stable
         */
        readonly packaging?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#path CodebuildProject#path}.
         *
         * @stability stable
         */
        readonly path?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
         *
         * @stability stable
         */
        readonly type: string;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectArtifactsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _artifactIdentifier?;
        /**
         * @stability stable
         */
        get artifactIdentifier(): string | undefined;
        /**
         * @stability stable
         */
        set artifactIdentifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetArtifactIdentifier(): void;
        /**
         * @stability stable
         */
        get artifactIdentifierInput(): string | undefined;
        private _encryptionDisabled?;
        /**
         * @stability stable
         */
        get encryptionDisabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set encryptionDisabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEncryptionDisabled(): void;
        /**
         * @stability stable
         */
        get encryptionDisabledInput(): boolean | cdktf.IResolvable | undefined;
        private _location?;
        /**
         * @stability stable
         */
        get location(): string | undefined;
        /**
         * @stability stable
         */
        set location(value: string | undefined);
        /**
         * @stability stable
         */
        resetLocation(): void;
        /**
         * @stability stable
         */
        get locationInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namespaceType?;
        /**
         * @stability stable
         */
        get namespaceType(): string | undefined;
        /**
         * @stability stable
         */
        set namespaceType(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamespaceType(): void;
        /**
         * @stability stable
         */
        get namespaceTypeInput(): string | undefined;
        private _overrideArtifactName?;
        /**
         * @stability stable
         */
        get overrideArtifactName(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set overrideArtifactName(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetOverrideArtifactName(): void;
        /**
         * @stability stable
         */
        get overrideArtifactNameInput(): boolean | cdktf.IResolvable | undefined;
        private _packaging?;
        /**
         * @stability stable
         */
        get packaging(): string | undefined;
        /**
         * @stability stable
         */
        set packaging(value: string | undefined);
        /**
         * @stability stable
         */
        resetPackaging(): void;
        /**
         * @stability stable
         */
        get packagingInput(): string | undefined;
        private _path?;
        /**
         * @stability stable
         */
        get path(): string | undefined;
        /**
         * @stability stable
         */
        set path(value: string | undefined);
        /**
         * @stability stable
         */
        resetPath(): void;
        /**
         * @stability stable
         */
        get pathInput(): string | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectBuildBatchConfigRestrictions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#compute_types_allowed CodebuildProject#compute_types_allowed}.
         *
         * @stability stable
         */
        readonly computeTypesAllowed?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#maximum_builds_allowed CodebuildProject#maximum_builds_allowed}.
         *
         * @stability stable
         */
        readonly maximumBuildsAllowed?: number;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectBuildBatchConfigRestrictionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _computeTypesAllowed?;
        /**
         * @stability stable
         */
        get computeTypesAllowed(): string[] | undefined;
        /**
         * @stability stable
         */
        set computeTypesAllowed(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetComputeTypesAllowed(): void;
        /**
         * @stability stable
         */
        get computeTypesAllowedInput(): string[] | undefined;
        private _maximumBuildsAllowed?;
        /**
         * @stability stable
         */
        get maximumBuildsAllowed(): number | undefined;
        /**
         * @stability stable
         */
        set maximumBuildsAllowed(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaximumBuildsAllowed(): void;
        /**
         * @stability stable
         */
        get maximumBuildsAllowedInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectBuildBatchConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#combine_artifacts CodebuildProject#combine_artifacts}.
         *
         * @stability stable
         */
        readonly combineArtifacts?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#service_role CodebuildProject#service_role}.
         *
         * @stability stable
         */
        readonly serviceRole: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#timeout_in_mins CodebuildProject#timeout_in_mins}.
         *
         * @stability stable
         */
        readonly timeoutInMins?: number;
        /**
         * restrictions block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#restrictions CodebuildProject#restrictions}
         *
         * @stability stable
         */
        readonly restrictions?: CodebuildProjectBuildBatchConfigRestrictions;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectBuildBatchConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _combineArtifacts?;
        /**
         * @stability stable
         */
        get combineArtifacts(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set combineArtifacts(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetCombineArtifacts(): void;
        /**
         * @stability stable
         */
        get combineArtifactsInput(): boolean | cdktf.IResolvable | undefined;
        private _serviceRole?;
        /**
         * @stability stable
         */
        get serviceRole(): string;
        /**
         * @stability stable
         */
        set serviceRole(value: string);
        /**
         * @stability stable
         */
        get serviceRoleInput(): string | undefined;
        private _timeoutInMins?;
        /**
         * @stability stable
         */
        get timeoutInMins(): number | undefined;
        /**
         * @stability stable
         */
        set timeoutInMins(value: number | undefined);
        /**
         * @stability stable
         */
        resetTimeoutInMins(): void;
        /**
         * @stability stable
         */
        get timeoutInMinsInput(): number | undefined;
        private _restrictions?;
        private __restrictionsOutput;
        /**
         * @stability stable
         */
        get restrictions(): CodebuildProjectBuildBatchConfigRestrictionsOutputReference;
        /**
         * @stability stable
         */
        putRestrictions(value: CodebuildProjectBuildBatchConfigRestrictions | undefined): void;
        /**
         * @stability stable
         */
        resetRestrictions(): void;
        /**
         * @stability stable
         */
        get restrictionsInput(): CodebuildProjectBuildBatchConfigRestrictions | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectCache {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#location CodebuildProject#location}.
         *
         * @stability stable
         */
        readonly location?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#modes CodebuildProject#modes}.
         *
         * @stability stable
         */
        readonly modes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectCacheOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _location?;
        /**
         * @stability stable
         */
        get location(): string | undefined;
        /**
         * @stability stable
         */
        set location(value: string | undefined);
        /**
         * @stability stable
         */
        resetLocation(): void;
        /**
         * @stability stable
         */
        get locationInput(): string | undefined;
        private _modes?;
        /**
         * @stability stable
         */
        get modes(): string[] | undefined;
        /**
         * @stability stable
         */
        set modes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetModes(): void;
        /**
         * @stability stable
         */
        get modesInput(): string[] | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string | undefined;
        /**
         * @stability stable
         */
        set type(value: string | undefined);
        /**
         * @stability stable
         */
        resetType(): void;
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectEnvironmentEnvironmentVariable {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#name CodebuildProject#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
         *
         * @stability stable
         */
        readonly type?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#value CodebuildProject#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectEnvironmentRegistryCredential {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#credential CodebuildProject#credential}.
         *
         * @stability stable
         */
        readonly credential: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#credential_provider CodebuildProject#credential_provider}.
         *
         * @stability stable
         */
        readonly credentialProvider: string;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectEnvironmentRegistryCredentialOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _credential?;
        /**
         * @stability stable
         */
        get credential(): string;
        /**
         * @stability stable
         */
        set credential(value: string);
        /**
         * @stability stable
         */
        get credentialInput(): string | undefined;
        private _credentialProvider?;
        /**
         * @stability stable
         */
        get credentialProvider(): string;
        /**
         * @stability stable
         */
        set credentialProvider(value: string);
        /**
         * @stability stable
         */
        get credentialProviderInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectEnvironment {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#certificate CodebuildProject#certificate}.
         *
         * @stability stable
         */
        readonly certificate?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#compute_type CodebuildProject#compute_type}.
         *
         * @stability stable
         */
        readonly computeType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#image CodebuildProject#image}.
         *
         * @stability stable
         */
        readonly image: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#image_pull_credentials_type CodebuildProject#image_pull_credentials_type}.
         *
         * @stability stable
         */
        readonly imagePullCredentialsType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#privileged_mode CodebuildProject#privileged_mode}.
         *
         * @stability stable
         */
        readonly privilegedMode?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * environment_variable block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#environment_variable CodebuildProject#environment_variable}
         *
         * @stability stable
         */
        readonly environmentVariable?: CodebuildProjectEnvironmentEnvironmentVariable[];
        /**
         * registry_credential block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#registry_credential CodebuildProject#registry_credential}
         *
         * @stability stable
         */
        readonly registryCredential?: CodebuildProjectEnvironmentRegistryCredential;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectEnvironmentOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificate?;
        /**
         * @stability stable
         */
        get certificate(): string | undefined;
        /**
         * @stability stable
         */
        set certificate(value: string | undefined);
        /**
         * @stability stable
         */
        resetCertificate(): void;
        /**
         * @stability stable
         */
        get certificateInput(): string | undefined;
        private _computeType?;
        /**
         * @stability stable
         */
        get computeType(): string;
        /**
         * @stability stable
         */
        set computeType(value: string);
        /**
         * @stability stable
         */
        get computeTypeInput(): string | undefined;
        private _image?;
        /**
         * @stability stable
         */
        get image(): string;
        /**
         * @stability stable
         */
        set image(value: string);
        /**
         * @stability stable
         */
        get imageInput(): string | undefined;
        private _imagePullCredentialsType?;
        /**
         * @stability stable
         */
        get imagePullCredentialsType(): string | undefined;
        /**
         * @stability stable
         */
        set imagePullCredentialsType(value: string | undefined);
        /**
         * @stability stable
         */
        resetImagePullCredentialsType(): void;
        /**
         * @stability stable
         */
        get imagePullCredentialsTypeInput(): string | undefined;
        private _privilegedMode?;
        /**
         * @stability stable
         */
        get privilegedMode(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set privilegedMode(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetPrivilegedMode(): void;
        /**
         * @stability stable
         */
        get privilegedModeInput(): boolean | cdktf.IResolvable | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _environmentVariable?;
        /**
         * @stability stable
         */
        get environmentVariable(): CodebuildProjectEnvironmentEnvironmentVariable[] | undefined;
        /**
         * @stability stable
         */
        set environmentVariable(value: CodebuildProjectEnvironmentEnvironmentVariable[] | undefined);
        /**
         * @stability stable
         */
        resetEnvironmentVariable(): void;
        /**
         * @stability stable
         */
        get environmentVariableInput(): CodebuildProjectEnvironmentEnvironmentVariable[] | undefined;
        private _registryCredential?;
        private __registryCredentialOutput;
        /**
         * @stability stable
         */
        get registryCredential(): CodebuildProjectEnvironmentRegistryCredentialOutputReference;
        /**
         * @stability stable
         */
        putRegistryCredential(value: CodebuildProjectEnvironmentRegistryCredential | undefined): void;
        /**
         * @stability stable
         */
        resetRegistryCredential(): void;
        /**
         * @stability stable
         */
        get registryCredentialInput(): CodebuildProjectEnvironmentRegistryCredential | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectFileSystemLocations {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#identifier CodebuildProject#identifier}.
         *
         * @stability stable
         */
        readonly identifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#location CodebuildProject#location}.
         *
         * @stability stable
         */
        readonly location?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#mount_options CodebuildProject#mount_options}.
         *
         * @stability stable
         */
        readonly mountOptions?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#mount_point CodebuildProject#mount_point}.
         *
         * @stability stable
         */
        readonly mountPoint?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectLogsConfigCloudwatchLogs {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#group_name CodebuildProject#group_name}.
         *
         * @stability stable
         */
        readonly groupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#status CodebuildProject#status}.
         *
         * @stability stable
         */
        readonly status?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#stream_name CodebuildProject#stream_name}.
         *
         * @stability stable
         */
        readonly streamName?: string;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectLogsConfigCloudwatchLogsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _groupName?;
        /**
         * @stability stable
         */
        get groupName(): string | undefined;
        /**
         * @stability stable
         */
        set groupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetGroupName(): void;
        /**
         * @stability stable
         */
        get groupNameInput(): string | undefined;
        private _status?;
        /**
         * @stability stable
         */
        get status(): string | undefined;
        /**
         * @stability stable
         */
        set status(value: string | undefined);
        /**
         * @stability stable
         */
        resetStatus(): void;
        /**
         * @stability stable
         */
        get statusInput(): string | undefined;
        private _streamName?;
        /**
         * @stability stable
         */
        get streamName(): string | undefined;
        /**
         * @stability stable
         */
        set streamName(value: string | undefined);
        /**
         * @stability stable
         */
        resetStreamName(): void;
        /**
         * @stability stable
         */
        get streamNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectLogsConfigS3Logs {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#encryption_disabled CodebuildProject#encryption_disabled}.
         *
         * @stability stable
         */
        readonly encryptionDisabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#location CodebuildProject#location}.
         *
         * @stability stable
         */
        readonly location?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#status CodebuildProject#status}.
         *
         * @stability stable
         */
        readonly status?: string;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectLogsConfigS3LogsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _encryptionDisabled?;
        /**
         * @stability stable
         */
        get encryptionDisabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set encryptionDisabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEncryptionDisabled(): void;
        /**
         * @stability stable
         */
        get encryptionDisabledInput(): boolean | cdktf.IResolvable | undefined;
        private _location?;
        /**
         * @stability stable
         */
        get location(): string | undefined;
        /**
         * @stability stable
         */
        set location(value: string | undefined);
        /**
         * @stability stable
         */
        resetLocation(): void;
        /**
         * @stability stable
         */
        get locationInput(): string | undefined;
        private _status?;
        /**
         * @stability stable
         */
        get status(): string | undefined;
        /**
         * @stability stable
         */
        set status(value: string | undefined);
        /**
         * @stability stable
         */
        resetStatus(): void;
        /**
         * @stability stable
         */
        get statusInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectLogsConfig {
        /**
         * cloudwatch_logs block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#cloudwatch_logs CodebuildProject#cloudwatch_logs}
         *
         * @stability stable
         */
        readonly cloudwatchLogs?: CodebuildProjectLogsConfigCloudwatchLogs;
        /**
         * s3_logs block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#s3_logs CodebuildProject#s3_logs}
         *
         * @stability stable
         */
        readonly s3Logs?: CodebuildProjectLogsConfigS3Logs;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectLogsConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _cloudwatchLogs?;
        private __cloudwatchLogsOutput;
        /**
         * @stability stable
         */
        get cloudwatchLogs(): CodebuildProjectLogsConfigCloudwatchLogsOutputReference;
        /**
         * @stability stable
         */
        putCloudwatchLogs(value: CodebuildProjectLogsConfigCloudwatchLogs | undefined): void;
        /**
         * @stability stable
         */
        resetCloudwatchLogs(): void;
        /**
         * @stability stable
         */
        get cloudwatchLogsInput(): CodebuildProjectLogsConfigCloudwatchLogs | undefined;
        private _s3Logs?;
        private __s3LogsOutput;
        /**
         * @stability stable
         */
        get s3Logs(): CodebuildProjectLogsConfigS3LogsOutputReference;
        /**
         * @stability stable
         */
        putS3Logs(value: CodebuildProjectLogsConfigS3Logs | undefined): void;
        /**
         * @stability stable
         */
        resetS3Logs(): void;
        /**
         * @stability stable
         */
        get s3LogsInput(): CodebuildProjectLogsConfigS3Logs | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectSecondaryArtifacts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#artifact_identifier CodebuildProject#artifact_identifier}.
         *
         * @stability stable
         */
        readonly artifactIdentifier: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#encryption_disabled CodebuildProject#encryption_disabled}.
         *
         * @stability stable
         */
        readonly encryptionDisabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#location CodebuildProject#location}.
         *
         * @stability stable
         */
        readonly location?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#name CodebuildProject#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#namespace_type CodebuildProject#namespace_type}.
         *
         * @stability stable
         */
        readonly namespaceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#override_artifact_name CodebuildProject#override_artifact_name}.
         *
         * @stability stable
         */
        readonly overrideArtifactName?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#packaging CodebuildProject#packaging}.
         *
         * @stability stable
         */
        readonly packaging?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#path CodebuildProject#path}.
         *
         * @stability stable
         */
        readonly path?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
         *
         * @stability stable
         */
        readonly type: string;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectSecondarySourcesAuth {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#resource CodebuildProject#resource}.
         *
         * @stability stable
         */
        readonly resource?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
         *
         * @stability stable
         */
        readonly type: string;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectSecondarySourcesAuthOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _resource?;
        /**
         * @stability stable
         */
        get resource(): string | undefined;
        /**
         * @stability stable
         */
        set resource(value: string | undefined);
        /**
         * @stability stable
         */
        resetResource(): void;
        /**
         * @stability stable
         */
        get resourceInput(): string | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectSecondarySourcesBuildStatusConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#context CodebuildProject#context}.
         *
         * @stability stable
         */
        readonly context?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#target_url CodebuildProject#target_url}.
         *
         * @stability stable
         */
        readonly targetUrl?: string;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectSecondarySourcesBuildStatusConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _context?;
        /**
         * @stability stable
         */
        get context(): string | undefined;
        /**
         * @stability stable
         */
        set context(value: string | undefined);
        /**
         * @stability stable
         */
        resetContext(): void;
        /**
         * @stability stable
         */
        get contextInput(): string | undefined;
        private _targetUrl?;
        /**
         * @stability stable
         */
        get targetUrl(): string | undefined;
        /**
         * @stability stable
         */
        set targetUrl(value: string | undefined);
        /**
         * @stability stable
         */
        resetTargetUrl(): void;
        /**
         * @stability stable
         */
        get targetUrlInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectSecondarySourcesGitSubmodulesConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#fetch_submodules CodebuildProject#fetch_submodules}.
         *
         * @stability stable
         */
        readonly fetchSubmodules: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectSecondarySourcesGitSubmodulesConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _fetchSubmodules?;
        /**
         * @stability stable
         */
        get fetchSubmodules(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set fetchSubmodules(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get fetchSubmodulesInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectSecondarySources {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#buildspec CodebuildProject#buildspec}.
         *
         * @stability stable
         */
        readonly buildspec?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#git_clone_depth CodebuildProject#git_clone_depth}.
         *
         * @stability stable
         */
        readonly gitCloneDepth?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#insecure_ssl CodebuildProject#insecure_ssl}.
         *
         * @stability stable
         */
        readonly insecureSsl?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#location CodebuildProject#location}.
         *
         * @stability stable
         */
        readonly location?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#report_build_status CodebuildProject#report_build_status}.
         *
         * @stability stable
         */
        readonly reportBuildStatus?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#source_identifier CodebuildProject#source_identifier}.
         *
         * @stability stable
         */
        readonly sourceIdentifier: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * auth block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#auth CodebuildProject#auth}
         *
         * @stability stable
         */
        readonly auth?: CodebuildProjectSecondarySourcesAuth;
        /**
         * build_status_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#build_status_config CodebuildProject#build_status_config}
         *
         * @stability stable
         */
        readonly buildStatusConfig?: CodebuildProjectSecondarySourcesBuildStatusConfig;
        /**
         * git_submodules_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#git_submodules_config CodebuildProject#git_submodules_config}
         *
         * @stability stable
         */
        readonly gitSubmodulesConfig?: CodebuildProjectSecondarySourcesGitSubmodulesConfig;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectSourceAuth {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#resource CodebuildProject#resource}.
         *
         * @stability stable
         */
        readonly resource?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
         *
         * @stability stable
         */
        readonly type: string;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectSourceAuthOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _resource?;
        /**
         * @stability stable
         */
        get resource(): string | undefined;
        /**
         * @stability stable
         */
        set resource(value: string | undefined);
        /**
         * @stability stable
         */
        resetResource(): void;
        /**
         * @stability stable
         */
        get resourceInput(): string | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectSourceBuildStatusConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#context CodebuildProject#context}.
         *
         * @stability stable
         */
        readonly context?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#target_url CodebuildProject#target_url}.
         *
         * @stability stable
         */
        readonly targetUrl?: string;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectSourceBuildStatusConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _context?;
        /**
         * @stability stable
         */
        get context(): string | undefined;
        /**
         * @stability stable
         */
        set context(value: string | undefined);
        /**
         * @stability stable
         */
        resetContext(): void;
        /**
         * @stability stable
         */
        get contextInput(): string | undefined;
        private _targetUrl?;
        /**
         * @stability stable
         */
        get targetUrl(): string | undefined;
        /**
         * @stability stable
         */
        set targetUrl(value: string | undefined);
        /**
         * @stability stable
         */
        resetTargetUrl(): void;
        /**
         * @stability stable
         */
        get targetUrlInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectSourceGitSubmodulesConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#fetch_submodules CodebuildProject#fetch_submodules}.
         *
         * @stability stable
         */
        readonly fetchSubmodules: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectSourceGitSubmodulesConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _fetchSubmodules?;
        /**
         * @stability stable
         */
        get fetchSubmodules(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set fetchSubmodules(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get fetchSubmodulesInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectSource {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#buildspec CodebuildProject#buildspec}.
         *
         * @stability stable
         */
        readonly buildspec?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#git_clone_depth CodebuildProject#git_clone_depth}.
         *
         * @stability stable
         */
        readonly gitCloneDepth?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#insecure_ssl CodebuildProject#insecure_ssl}.
         *
         * @stability stable
         */
        readonly insecureSsl?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#location CodebuildProject#location}.
         *
         * @stability stable
         */
        readonly location?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#report_build_status CodebuildProject#report_build_status}.
         *
         * @stability stable
         */
        readonly reportBuildStatus?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#type CodebuildProject#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * auth block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#auth CodebuildProject#auth}
         *
         * @stability stable
         */
        readonly auth?: CodebuildProjectSourceAuth;
        /**
         * build_status_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#build_status_config CodebuildProject#build_status_config}
         *
         * @stability stable
         */
        readonly buildStatusConfig?: CodebuildProjectSourceBuildStatusConfig;
        /**
         * git_submodules_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#git_submodules_config CodebuildProject#git_submodules_config}
         *
         * @stability stable
         */
        readonly gitSubmodulesConfig?: CodebuildProjectSourceGitSubmodulesConfig;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectSourceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _buildspec?;
        /**
         * @stability stable
         */
        get buildspec(): string | undefined;
        /**
         * @stability stable
         */
        set buildspec(value: string | undefined);
        /**
         * @stability stable
         */
        resetBuildspec(): void;
        /**
         * @stability stable
         */
        get buildspecInput(): string | undefined;
        private _gitCloneDepth?;
        /**
         * @stability stable
         */
        get gitCloneDepth(): number | undefined;
        /**
         * @stability stable
         */
        set gitCloneDepth(value: number | undefined);
        /**
         * @stability stable
         */
        resetGitCloneDepth(): void;
        /**
         * @stability stable
         */
        get gitCloneDepthInput(): number | undefined;
        private _insecureSsl?;
        /**
         * @stability stable
         */
        get insecureSsl(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set insecureSsl(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetInsecureSsl(): void;
        /**
         * @stability stable
         */
        get insecureSslInput(): boolean | cdktf.IResolvable | undefined;
        private _location?;
        /**
         * @stability stable
         */
        get location(): string | undefined;
        /**
         * @stability stable
         */
        set location(value: string | undefined);
        /**
         * @stability stable
         */
        resetLocation(): void;
        /**
         * @stability stable
         */
        get locationInput(): string | undefined;
        private _reportBuildStatus?;
        /**
         * @stability stable
         */
        get reportBuildStatus(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set reportBuildStatus(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetReportBuildStatus(): void;
        /**
         * @stability stable
         */
        get reportBuildStatusInput(): boolean | cdktf.IResolvable | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _auth?;
        private __authOutput;
        /**
         * @stability stable
         */
        get auth(): CodebuildProjectSourceAuthOutputReference;
        /**
         * @stability stable
         */
        putAuth(value: CodebuildProjectSourceAuth | undefined): void;
        /**
         * @stability stable
         */
        resetAuth(): void;
        /**
         * @stability stable
         */
        get authInput(): CodebuildProjectSourceAuth | undefined;
        private _buildStatusConfig?;
        private __buildStatusConfigOutput;
        /**
         * @stability stable
         */
        get buildStatusConfig(): CodebuildProjectSourceBuildStatusConfigOutputReference;
        /**
         * @stability stable
         */
        putBuildStatusConfig(value: CodebuildProjectSourceBuildStatusConfig | undefined): void;
        /**
         * @stability stable
         */
        resetBuildStatusConfig(): void;
        /**
         * @stability stable
         */
        get buildStatusConfigInput(): CodebuildProjectSourceBuildStatusConfig | undefined;
        private _gitSubmodulesConfig?;
        private __gitSubmodulesConfigOutput;
        /**
         * @stability stable
         */
        get gitSubmodulesConfig(): CodebuildProjectSourceGitSubmodulesConfigOutputReference;
        /**
         * @stability stable
         */
        putGitSubmodulesConfig(value: CodebuildProjectSourceGitSubmodulesConfig | undefined): void;
        /**
         * @stability stable
         */
        resetGitSubmodulesConfig(): void;
        /**
         * @stability stable
         */
        get gitSubmodulesConfigInput(): CodebuildProjectSourceGitSubmodulesConfig | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildProjectVpcConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#security_group_ids CodebuildProject#security_group_ids}.
         *
         * @stability stable
         */
        readonly securityGroupIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#subnets CodebuildProject#subnets}.
         *
         * @stability stable
         */
        readonly subnets: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html#vpc_id CodebuildProject#vpc_id}.
         *
         * @stability stable
         */
        readonly vpcId: string;
    }
    /**
     * @stability stable
     */
    class CodebuildProjectVpcConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _securityGroupIds?;
        /**
         * @stability stable
         */
        get securityGroupIds(): string[];
        /**
         * @stability stable
         */
        set securityGroupIds(value: string[]);
        /**
         * @stability stable
         */
        get securityGroupIdsInput(): string[] | undefined;
        private _subnets?;
        /**
         * @stability stable
         */
        get subnets(): string[];
        /**
         * @stability stable
         */
        set subnets(value: string[]);
        /**
         * @stability stable
         */
        get subnetsInput(): string[] | undefined;
        private _vpcId?;
        /**
         * @stability stable
         */
        get vpcId(): string;
        /**
         * @stability stable
         */
        set vpcId(value: string);
        /**
         * @stability stable
         */
        get vpcIdInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html aws_codebuild_project}.
     *
     * @stability stable
     */
    class CodebuildProject extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project.html aws_codebuild_project} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CodebuildProjectConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _badgeEnabled?;
        /**
         * @stability stable
         */
        get badgeEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set badgeEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetBadgeEnabled(): void;
        /**
         * @stability stable
         */
        get badgeEnabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get badgeUrl(): string;
        private _buildTimeout?;
        /**
         * @stability stable
         */
        get buildTimeout(): number | undefined;
        /**
         * @stability stable
         */
        set buildTimeout(value: number | undefined);
        /**
         * @stability stable
         */
        resetBuildTimeout(): void;
        /**
         * @stability stable
         */
        get buildTimeoutInput(): number | undefined;
        private _concurrentBuildLimit?;
        /**
         * @stability stable
         */
        get concurrentBuildLimit(): number | undefined;
        /**
         * @stability stable
         */
        set concurrentBuildLimit(value: number | undefined);
        /**
         * @stability stable
         */
        resetConcurrentBuildLimit(): void;
        /**
         * @stability stable
         */
        get concurrentBuildLimitInput(): number | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _encryptionKey?;
        /**
         * @stability stable
         */
        get encryptionKey(): string | undefined;
        /**
         * @stability stable
         */
        set encryptionKey(value: string | undefined);
        /**
         * @stability stable
         */
        resetEncryptionKey(): void;
        /**
         * @stability stable
         */
        get encryptionKeyInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _queuedTimeout?;
        /**
         * @stability stable
         */
        get queuedTimeout(): number | undefined;
        /**
         * @stability stable
         */
        set queuedTimeout(value: number | undefined);
        /**
         * @stability stable
         */
        resetQueuedTimeout(): void;
        /**
         * @stability stable
         */
        get queuedTimeoutInput(): number | undefined;
        private _serviceRole?;
        /**
         * @stability stable
         */
        get serviceRole(): string;
        /**
         * @stability stable
         */
        set serviceRole(value: string);
        /**
         * @stability stable
         */
        get serviceRoleInput(): string | undefined;
        private _sourceVersion?;
        /**
         * @stability stable
         */
        get sourceVersion(): string | undefined;
        /**
         * @stability stable
         */
        set sourceVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetSourceVersion(): void;
        /**
         * @stability stable
         */
        get sourceVersionInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _artifacts?;
        private __artifactsOutput;
        /**
         * @stability stable
         */
        get artifacts(): CodebuildProjectArtifactsOutputReference;
        /**
         * @stability stable
         */
        putArtifacts(value: CodebuildProjectArtifacts): void;
        /**
         * @stability stable
         */
        get artifactsInput(): CodebuildProjectArtifacts | undefined;
        private _buildBatchConfig?;
        private __buildBatchConfigOutput;
        /**
         * @stability stable
         */
        get buildBatchConfig(): CodebuildProjectBuildBatchConfigOutputReference;
        /**
         * @stability stable
         */
        putBuildBatchConfig(value: CodebuildProjectBuildBatchConfig | undefined): void;
        /**
         * @stability stable
         */
        resetBuildBatchConfig(): void;
        /**
         * @stability stable
         */
        get buildBatchConfigInput(): CodebuildProjectBuildBatchConfig | undefined;
        private _cache?;
        private __cacheOutput;
        /**
         * @stability stable
         */
        get cache(): CodebuildProjectCacheOutputReference;
        /**
         * @stability stable
         */
        putCache(value: CodebuildProjectCache | undefined): void;
        /**
         * @stability stable
         */
        resetCache(): void;
        /**
         * @stability stable
         */
        get cacheInput(): CodebuildProjectCache | undefined;
        private _environment?;
        private __environmentOutput;
        /**
         * @stability stable
         */
        get environment(): CodebuildProjectEnvironmentOutputReference;
        /**
         * @stability stable
         */
        putEnvironment(value: CodebuildProjectEnvironment): void;
        /**
         * @stability stable
         */
        get environmentInput(): CodebuildProjectEnvironment | undefined;
        private _fileSystemLocations?;
        /**
         * @stability stable
         */
        get fileSystemLocations(): CodebuildProjectFileSystemLocations[] | undefined;
        /**
         * @stability stable
         */
        set fileSystemLocations(value: CodebuildProjectFileSystemLocations[] | undefined);
        /**
         * @stability stable
         */
        resetFileSystemLocations(): void;
        /**
         * @stability stable
         */
        get fileSystemLocationsInput(): CodebuildProjectFileSystemLocations[] | undefined;
        private _logsConfig?;
        private __logsConfigOutput;
        /**
         * @stability stable
         */
        get logsConfig(): CodebuildProjectLogsConfigOutputReference;
        /**
         * @stability stable
         */
        putLogsConfig(value: CodebuildProjectLogsConfig | undefined): void;
        /**
         * @stability stable
         */
        resetLogsConfig(): void;
        /**
         * @stability stable
         */
        get logsConfigInput(): CodebuildProjectLogsConfig | undefined;
        private _secondaryArtifacts?;
        /**
         * @stability stable
         */
        get secondaryArtifacts(): CodebuildProjectSecondaryArtifacts[] | undefined;
        /**
         * @stability stable
         */
        set secondaryArtifacts(value: CodebuildProjectSecondaryArtifacts[] | undefined);
        /**
         * @stability stable
         */
        resetSecondaryArtifacts(): void;
        /**
         * @stability stable
         */
        get secondaryArtifactsInput(): CodebuildProjectSecondaryArtifacts[] | undefined;
        private _secondarySources?;
        /**
         * @stability stable
         */
        get secondarySources(): CodebuildProjectSecondarySources[] | undefined;
        /**
         * @stability stable
         */
        set secondarySources(value: CodebuildProjectSecondarySources[] | undefined);
        /**
         * @stability stable
         */
        resetSecondarySources(): void;
        /**
         * @stability stable
         */
        get secondarySourcesInput(): CodebuildProjectSecondarySources[] | undefined;
        private _source?;
        private __sourceOutput;
        /**
         * @stability stable
         */
        get source(): CodebuildProjectSourceOutputReference;
        /**
         * @stability stable
         */
        putSource(value: CodebuildProjectSource): void;
        /**
         * @stability stable
         */
        get sourceInput(): CodebuildProjectSource | undefined;
        private _vpcConfig?;
        private __vpcConfigOutput;
        /**
         * @stability stable
         */
        get vpcConfig(): CodebuildProjectVpcConfigOutputReference;
        /**
         * @stability stable
         */
        putVpcConfig(value: CodebuildProjectVpcConfig | undefined): void;
        /**
         * @stability stable
         */
        resetVpcConfig(): void;
        /**
         * @stability stable
         */
        get vpcConfigInput(): CodebuildProjectVpcConfig | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CodebuildReportGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group.html#delete_reports CodebuildReportGroup#delete_reports}.
         *
         * @stability stable
         */
        readonly deleteReports?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group.html#name CodebuildReportGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group.html#tags CodebuildReportGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group.html#tags_all CodebuildReportGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group.html#type CodebuildReportGroup#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * export_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group.html#export_config CodebuildReportGroup#export_config}
         *
         * @stability stable
         */
        readonly exportConfig: CodebuildReportGroupExportConfig;
    }
    /**
     * @stability stable
     */
    interface CodebuildReportGroupExportConfigS3Destination {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group.html#bucket CodebuildReportGroup#bucket}.
         *
         * @stability stable
         */
        readonly bucket: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group.html#encryption_disabled CodebuildReportGroup#encryption_disabled}.
         *
         * @stability stable
         */
        readonly encryptionDisabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group.html#encryption_key CodebuildReportGroup#encryption_key}.
         *
         * @stability stable
         */
        readonly encryptionKey: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group.html#packaging CodebuildReportGroup#packaging}.
         *
         * @stability stable
         */
        readonly packaging?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group.html#path CodebuildReportGroup#path}.
         *
         * @stability stable
         */
        readonly path?: string;
    }
    /**
     * @stability stable
     */
    class CodebuildReportGroupExportConfigS3DestinationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bucket?;
        /**
         * @stability stable
         */
        get bucket(): string;
        /**
         * @stability stable
         */
        set bucket(value: string);
        /**
         * @stability stable
         */
        get bucketInput(): string | undefined;
        private _encryptionDisabled?;
        /**
         * @stability stable
         */
        get encryptionDisabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set encryptionDisabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEncryptionDisabled(): void;
        /**
         * @stability stable
         */
        get encryptionDisabledInput(): boolean | cdktf.IResolvable | undefined;
        private _encryptionKey?;
        /**
         * @stability stable
         */
        get encryptionKey(): string;
        /**
         * @stability stable
         */
        set encryptionKey(value: string);
        /**
         * @stability stable
         */
        get encryptionKeyInput(): string | undefined;
        private _packaging?;
        /**
         * @stability stable
         */
        get packaging(): string | undefined;
        /**
         * @stability stable
         */
        set packaging(value: string | undefined);
        /**
         * @stability stable
         */
        resetPackaging(): void;
        /**
         * @stability stable
         */
        get packagingInput(): string | undefined;
        private _path?;
        /**
         * @stability stable
         */
        get path(): string | undefined;
        /**
         * @stability stable
         */
        set path(value: string | undefined);
        /**
         * @stability stable
         */
        resetPath(): void;
        /**
         * @stability stable
         */
        get pathInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface CodebuildReportGroupExportConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group.html#type CodebuildReportGroup#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * s3_destination block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group.html#s3_destination CodebuildReportGroup#s3_destination}
         *
         * @stability stable
         */
        readonly s3Destination?: CodebuildReportGroupExportConfigS3Destination;
    }
    /**
     * @stability stable
     */
    class CodebuildReportGroupExportConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _s3Destination?;
        private __s3DestinationOutput;
        /**
         * @stability stable
         */
        get s3Destination(): CodebuildReportGroupExportConfigS3DestinationOutputReference;
        /**
         * @stability stable
         */
        putS3Destination(value: CodebuildReportGroupExportConfigS3Destination | undefined): void;
        /**
         * @stability stable
         */
        resetS3Destination(): void;
        /**
         * @stability stable
         */
        get s3DestinationInput(): CodebuildReportGroupExportConfigS3Destination | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group.html aws_codebuild_report_group}.
     *
     * @stability stable
     */
    class CodebuildReportGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group.html aws_codebuild_report_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CodebuildReportGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get created(): string;
        private _deleteReports?;
        /**
         * @stability stable
         */
        get deleteReports(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set deleteReports(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDeleteReports(): void;
        /**
         * @stability stable
         */
        get deleteReportsInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _exportConfig?;
        private __exportConfigOutput;
        /**
         * @stability stable
         */
        get exportConfig(): CodebuildReportGroupExportConfigOutputReference;
        /**
         * @stability stable
         */
        putExportConfig(value: CodebuildReportGroupExportConfig): void;
        /**
         * @stability stable
         */
        get exportConfigInput(): CodebuildReportGroupExportConfig | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CodebuildSourceCredentialConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_source_credential.html#auth_type CodebuildSourceCredential#auth_type}.
         *
         * @stability stable
         */
        readonly authType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_source_credential.html#server_type CodebuildSourceCredential#server_type}.
         *
         * @stability stable
         */
        readonly serverType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_source_credential.html#token CodebuildSourceCredential#token}.
         *
         * @stability stable
         */
        readonly token: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_source_credential.html#user_name CodebuildSourceCredential#user_name}.
         *
         * @stability stable
         */
        readonly userName?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/codebuild_source_credential.html aws_codebuild_source_credential}.
     *
     * @stability stable
     */
    class CodebuildSourceCredential extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/codebuild_source_credential.html aws_codebuild_source_credential} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CodebuildSourceCredentialConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _authType?;
        /**
         * @stability stable
         */
        get authType(): string;
        /**
         * @stability stable
         */
        set authType(value: string);
        /**
         * @stability stable
         */
        get authTypeInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _serverType?;
        /**
         * @stability stable
         */
        get serverType(): string;
        /**
         * @stability stable
         */
        set serverType(value: string);
        /**
         * @stability stable
         */
        get serverTypeInput(): string | undefined;
        private _token?;
        /**
         * @stability stable
         */
        get token(): string;
        /**
         * @stability stable
         */
        set token(value: string);
        /**
         * @stability stable
         */
        get tokenInput(): string | undefined;
        private _userName?;
        /**
         * @stability stable
         */
        get userName(): string | undefined;
        /**
         * @stability stable
         */
        set userName(value: string | undefined);
        /**
         * @stability stable
         */
        resetUserName(): void;
        /**
         * @stability stable
         */
        get userNameInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface CodebuildWebhookConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html#branch_filter CodebuildWebhook#branch_filter}.
         *
         * @stability stable
         */
        readonly branchFilter?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html#build_type CodebuildWebhook#build_type}.
         *
         * @stability stable
         */
        readonly buildType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html#project_name CodebuildWebhook#project_name}.
         *
         * @stability stable
         */
        readonly projectName: string;
        /**
         * filter_group block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html#filter_group CodebuildWebhook#filter_group}
         *
         * @stability stable
         */
        readonly filterGroup?: CodebuildWebhookFilterGroup[];
    }
    /**
     * @stability stable
     */
    interface CodebuildWebhookFilterGroupFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html#exclude_matched_pattern CodebuildWebhook#exclude_matched_pattern}.
         *
         * @stability stable
         */
        readonly excludeMatchedPattern?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html#pattern CodebuildWebhook#pattern}.
         *
         * @stability stable
         */
        readonly pattern: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html#type CodebuildWebhook#type}.
         *
         * @stability stable
         */
        readonly type: string;
    }
    /**
     * @stability stable
     */
    interface CodebuildWebhookFilterGroup {
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html#filter CodebuildWebhook#filter}
         *
         * @stability stable
         */
        readonly filter?: CodebuildWebhookFilterGroupFilter[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html aws_codebuild_webhook}.
     *
     * @stability stable
     */
    class CodebuildWebhook extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/codebuild_webhook.html aws_codebuild_webhook} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: CodebuildWebhookConfig);
        private _branchFilter?;
        /**
         * @stability stable
         */
        get branchFilter(): string | undefined;
        /**
         * @stability stable
         */
        set branchFilter(value: string | undefined);
        /**
         * @stability stable
         */
        resetBranchFilter(): void;
        /**
         * @stability stable
         */
        get branchFilterInput(): string | undefined;
        private _buildType?;
        /**
         * @stability stable
         */
        get buildType(): string | undefined;
        /**
         * @stability stable
         */
        set buildType(value: string | undefined);
        /**
         * @stability stable
         */
        resetBuildType(): void;
        /**
         * @stability stable
         */
        get buildTypeInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get payloadUrl(): string;
        private _projectName?;
        /**
         * @stability stable
         */
        get projectName(): string;
        /**
         * @stability stable
         */
        set projectName(value: string);
        /**
         * @stability stable
         */
        get projectNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get secret(): string;
        /**
         * @stability stable
         */
        get url(): string;
        private _filterGroup?;
        /**
         * @stability stable
         */
        get filterGroup(): CodebuildWebhookFilterGroup[] | undefined;
        /**
         * @stability stable
         */
        set filterGroup(value: CodebuildWebhookFilterGroup[] | undefined);
        /**
         * @stability stable
         */
        resetFilterGroup(): void;
        /**
         * @stability stable
         */
        get filterGroupInput(): CodebuildWebhookFilterGroup[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
