import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Config
*/
export declare namespace Config {
    /**
     * @stability stable
     */
    interface ConfigAggregateAuthorizationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_aggregate_authorization.html#account_id ConfigAggregateAuthorization#account_id}.
         *
         * @stability stable
         */
        readonly accountId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_aggregate_authorization.html#region ConfigAggregateAuthorization#region}.
         *
         * @stability stable
         */
        readonly region: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_aggregate_authorization.html#tags ConfigAggregateAuthorization#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_aggregate_authorization.html#tags_all ConfigAggregateAuthorization#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_aggregate_authorization.html aws_config_aggregate_authorization}.
     *
     * @stability stable
     */
    class ConfigAggregateAuthorization extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_aggregate_authorization.html aws_config_aggregate_authorization} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ConfigAggregateAuthorizationConfig);
        private _accountId?;
        /**
         * @stability stable
         */
        get accountId(): string;
        /**
         * @stability stable
         */
        set accountId(value: string);
        /**
         * @stability stable
         */
        get accountIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _region?;
        /**
         * @stability stable
         */
        get region(): string;
        /**
         * @stability stable
         */
        set region(value: string);
        /**
         * @stability stable
         */
        get regionInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ConfigConfigRuleConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#description ConfigConfigRule#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#input_parameters ConfigConfigRule#input_parameters}.
         *
         * @stability stable
         */
        readonly inputParameters?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#maximum_execution_frequency ConfigConfigRule#maximum_execution_frequency}.
         *
         * @stability stable
         */
        readonly maximumExecutionFrequency?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#name ConfigConfigRule#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#tags ConfigConfigRule#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#tags_all ConfigConfigRule#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * scope block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#scope ConfigConfigRule#scope}
         *
         * @stability stable
         */
        readonly scope?: ConfigConfigRuleScope;
        /**
         * source block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#source ConfigConfigRule#source}
         *
         * @stability stable
         */
        readonly source: ConfigConfigRuleSource;
    }
    /**
     * @stability stable
     */
    interface ConfigConfigRuleScope {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#compliance_resource_id ConfigConfigRule#compliance_resource_id}.
         *
         * @stability stable
         */
        readonly complianceResourceId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#compliance_resource_types ConfigConfigRule#compliance_resource_types}.
         *
         * @stability stable
         */
        readonly complianceResourceTypes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#tag_key ConfigConfigRule#tag_key}.
         *
         * @stability stable
         */
        readonly tagKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#tag_value ConfigConfigRule#tag_value}.
         *
         * @stability stable
         */
        readonly tagValue?: string;
    }
    /**
     * @stability stable
     */
    class ConfigConfigRuleScopeOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _complianceResourceId?;
        /**
         * @stability stable
         */
        get complianceResourceId(): string | undefined;
        /**
         * @stability stable
         */
        set complianceResourceId(value: string | undefined);
        /**
         * @stability stable
         */
        resetComplianceResourceId(): void;
        /**
         * @stability stable
         */
        get complianceResourceIdInput(): string | undefined;
        private _complianceResourceTypes?;
        /**
         * @stability stable
         */
        get complianceResourceTypes(): string[] | undefined;
        /**
         * @stability stable
         */
        set complianceResourceTypes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetComplianceResourceTypes(): void;
        /**
         * @stability stable
         */
        get complianceResourceTypesInput(): string[] | undefined;
        private _tagKey?;
        /**
         * @stability stable
         */
        get tagKey(): string | undefined;
        /**
         * @stability stable
         */
        set tagKey(value: string | undefined);
        /**
         * @stability stable
         */
        resetTagKey(): void;
        /**
         * @stability stable
         */
        get tagKeyInput(): string | undefined;
        private _tagValue?;
        /**
         * @stability stable
         */
        get tagValue(): string | undefined;
        /**
         * @stability stable
         */
        set tagValue(value: string | undefined);
        /**
         * @stability stable
         */
        resetTagValue(): void;
        /**
         * @stability stable
         */
        get tagValueInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface ConfigConfigRuleSourceSourceDetail {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#event_source ConfigConfigRule#event_source}.
         *
         * @stability stable
         */
        readonly eventSource?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#maximum_execution_frequency ConfigConfigRule#maximum_execution_frequency}.
         *
         * @stability stable
         */
        readonly maximumExecutionFrequency?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#message_type ConfigConfigRule#message_type}.
         *
         * @stability stable
         */
        readonly messageType?: string;
    }
    /**
     * @stability stable
     */
    interface ConfigConfigRuleSource {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#owner ConfigConfigRule#owner}.
         *
         * @stability stable
         */
        readonly owner: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#source_identifier ConfigConfigRule#source_identifier}.
         *
         * @stability stable
         */
        readonly sourceIdentifier: string;
        /**
         * source_detail block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html#source_detail ConfigConfigRule#source_detail}
         *
         * @stability stable
         */
        readonly sourceDetail?: ConfigConfigRuleSourceSourceDetail[];
    }
    /**
     * @stability stable
     */
    class ConfigConfigRuleSourceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _owner?;
        /**
         * @stability stable
         */
        get owner(): string;
        /**
         * @stability stable
         */
        set owner(value: string);
        /**
         * @stability stable
         */
        get ownerInput(): string | undefined;
        private _sourceIdentifier?;
        /**
         * @stability stable
         */
        get sourceIdentifier(): string;
        /**
         * @stability stable
         */
        set sourceIdentifier(value: string);
        /**
         * @stability stable
         */
        get sourceIdentifierInput(): string | undefined;
        private _sourceDetail?;
        /**
         * @stability stable
         */
        get sourceDetail(): ConfigConfigRuleSourceSourceDetail[] | undefined;
        /**
         * @stability stable
         */
        set sourceDetail(value: ConfigConfigRuleSourceSourceDetail[] | undefined);
        /**
         * @stability stable
         */
        resetSourceDetail(): void;
        /**
         * @stability stable
         */
        get sourceDetailInput(): ConfigConfigRuleSourceSourceDetail[] | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html aws_config_config_rule}.
     *
     * @stability stable
     */
    class ConfigConfigRule extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule.html aws_config_config_rule} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ConfigConfigRuleConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _inputParameters?;
        /**
         * @stability stable
         */
        get inputParameters(): string | undefined;
        /**
         * @stability stable
         */
        set inputParameters(value: string | undefined);
        /**
         * @stability stable
         */
        resetInputParameters(): void;
        /**
         * @stability stable
         */
        get inputParametersInput(): string | undefined;
        private _maximumExecutionFrequency?;
        /**
         * @stability stable
         */
        get maximumExecutionFrequency(): string | undefined;
        /**
         * @stability stable
         */
        set maximumExecutionFrequency(value: string | undefined);
        /**
         * @stability stable
         */
        resetMaximumExecutionFrequency(): void;
        /**
         * @stability stable
         */
        get maximumExecutionFrequencyInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get ruleId(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _scope?;
        private __scopeOutput;
        /**
         * @stability stable
         */
        get scope(): ConfigConfigRuleScopeOutputReference;
        /**
         * @stability stable
         */
        putScope(value: ConfigConfigRuleScope | undefined): void;
        /**
         * @stability stable
         */
        resetScope(): void;
        /**
         * @stability stable
         */
        get scopeInput(): ConfigConfigRuleScope | undefined;
        private _source?;
        private __sourceOutput;
        /**
         * @stability stable
         */
        get source(): ConfigConfigRuleSourceOutputReference;
        /**
         * @stability stable
         */
        putSource(value: ConfigConfigRuleSource): void;
        /**
         * @stability stable
         */
        get sourceInput(): ConfigConfigRuleSource | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ConfigConfigurationAggregatorConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_aggregator.html#name ConfigConfigurationAggregator#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_aggregator.html#tags ConfigConfigurationAggregator#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_aggregator.html#tags_all ConfigConfigurationAggregator#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * account_aggregation_source block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_aggregator.html#account_aggregation_source ConfigConfigurationAggregator#account_aggregation_source}
         *
         * @stability stable
         */
        readonly accountAggregationSource?: ConfigConfigurationAggregatorAccountAggregationSource;
        /**
         * organization_aggregation_source block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_aggregator.html#organization_aggregation_source ConfigConfigurationAggregator#organization_aggregation_source}
         *
         * @stability stable
         */
        readonly organizationAggregationSource?: ConfigConfigurationAggregatorOrganizationAggregationSource;
    }
    /**
     * @stability stable
     */
    interface ConfigConfigurationAggregatorAccountAggregationSource {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_aggregator.html#account_ids ConfigConfigurationAggregator#account_ids}.
         *
         * @stability stable
         */
        readonly accountIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_aggregator.html#all_regions ConfigConfigurationAggregator#all_regions}.
         *
         * @stability stable
         */
        readonly allRegions?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_aggregator.html#regions ConfigConfigurationAggregator#regions}.
         *
         * @stability stable
         */
        readonly regions?: string[];
    }
    /**
     * @stability stable
     */
    class ConfigConfigurationAggregatorAccountAggregationSourceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _accountIds?;
        /**
         * @stability stable
         */
        get accountIds(): string[];
        /**
         * @stability stable
         */
        set accountIds(value: string[]);
        /**
         * @stability stable
         */
        get accountIdsInput(): string[] | undefined;
        private _allRegions?;
        /**
         * @stability stable
         */
        get allRegions(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set allRegions(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAllRegions(): void;
        /**
         * @stability stable
         */
        get allRegionsInput(): boolean | cdktf.IResolvable | undefined;
        private _regions?;
        /**
         * @stability stable
         */
        get regions(): string[] | undefined;
        /**
         * @stability stable
         */
        set regions(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetRegions(): void;
        /**
         * @stability stable
         */
        get regionsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface ConfigConfigurationAggregatorOrganizationAggregationSource {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_aggregator.html#all_regions ConfigConfigurationAggregator#all_regions}.
         *
         * @stability stable
         */
        readonly allRegions?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_aggregator.html#regions ConfigConfigurationAggregator#regions}.
         *
         * @stability stable
         */
        readonly regions?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_aggregator.html#role_arn ConfigConfigurationAggregator#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
    }
    /**
     * @stability stable
     */
    class ConfigConfigurationAggregatorOrganizationAggregationSourceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _allRegions?;
        /**
         * @stability stable
         */
        get allRegions(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set allRegions(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAllRegions(): void;
        /**
         * @stability stable
         */
        get allRegionsInput(): boolean | cdktf.IResolvable | undefined;
        private _regions?;
        /**
         * @stability stable
         */
        get regions(): string[] | undefined;
        /**
         * @stability stable
         */
        set regions(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetRegions(): void;
        /**
         * @stability stable
         */
        get regionsInput(): string[] | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_aggregator.html aws_config_configuration_aggregator}.
     *
     * @stability stable
     */
    class ConfigConfigurationAggregator extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_aggregator.html aws_config_configuration_aggregator} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ConfigConfigurationAggregatorConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _accountAggregationSource?;
        private __accountAggregationSourceOutput;
        /**
         * @stability stable
         */
        get accountAggregationSource(): ConfigConfigurationAggregatorAccountAggregationSourceOutputReference;
        /**
         * @stability stable
         */
        putAccountAggregationSource(value: ConfigConfigurationAggregatorAccountAggregationSource | undefined): void;
        /**
         * @stability stable
         */
        resetAccountAggregationSource(): void;
        /**
         * @stability stable
         */
        get accountAggregationSourceInput(): ConfigConfigurationAggregatorAccountAggregationSource | undefined;
        private _organizationAggregationSource?;
        private __organizationAggregationSourceOutput;
        /**
         * @stability stable
         */
        get organizationAggregationSource(): ConfigConfigurationAggregatorOrganizationAggregationSourceOutputReference;
        /**
         * @stability stable
         */
        putOrganizationAggregationSource(value: ConfigConfigurationAggregatorOrganizationAggregationSource | undefined): void;
        /**
         * @stability stable
         */
        resetOrganizationAggregationSource(): void;
        /**
         * @stability stable
         */
        get organizationAggregationSourceInput(): ConfigConfigurationAggregatorOrganizationAggregationSource | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ConfigConfigurationRecorderConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_recorder.html#name ConfigConfigurationRecorder#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_recorder.html#role_arn ConfigConfigurationRecorder#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
        /**
         * recording_group block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_recorder.html#recording_group ConfigConfigurationRecorder#recording_group}
         *
         * @stability stable
         */
        readonly recordingGroup?: ConfigConfigurationRecorderRecordingGroup;
    }
    /**
     * @stability stable
     */
    interface ConfigConfigurationRecorderRecordingGroup {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_recorder.html#all_supported ConfigConfigurationRecorder#all_supported}.
         *
         * @stability stable
         */
        readonly allSupported?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_recorder.html#include_global_resource_types ConfigConfigurationRecorder#include_global_resource_types}.
         *
         * @stability stable
         */
        readonly includeGlobalResourceTypes?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_recorder.html#resource_types ConfigConfigurationRecorder#resource_types}.
         *
         * @stability stable
         */
        readonly resourceTypes?: string[];
    }
    /**
     * @stability stable
     */
    class ConfigConfigurationRecorderRecordingGroupOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _allSupported?;
        /**
         * @stability stable
         */
        get allSupported(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set allSupported(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAllSupported(): void;
        /**
         * @stability stable
         */
        get allSupportedInput(): boolean | cdktf.IResolvable | undefined;
        private _includeGlobalResourceTypes?;
        /**
         * @stability stable
         */
        get includeGlobalResourceTypes(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set includeGlobalResourceTypes(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIncludeGlobalResourceTypes(): void;
        /**
         * @stability stable
         */
        get includeGlobalResourceTypesInput(): boolean | cdktf.IResolvable | undefined;
        private _resourceTypes?;
        /**
         * @stability stable
         */
        get resourceTypes(): string[] | undefined;
        /**
         * @stability stable
         */
        set resourceTypes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetResourceTypes(): void;
        /**
         * @stability stable
         */
        get resourceTypesInput(): string[] | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_recorder.html aws_config_configuration_recorder}.
     *
     * @stability stable
     */
    class ConfigConfigurationRecorder extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_recorder.html aws_config_configuration_recorder} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ConfigConfigurationRecorderConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        private _recordingGroup?;
        private __recordingGroupOutput;
        /**
         * @stability stable
         */
        get recordingGroup(): ConfigConfigurationRecorderRecordingGroupOutputReference;
        /**
         * @stability stable
         */
        putRecordingGroup(value: ConfigConfigurationRecorderRecordingGroup | undefined): void;
        /**
         * @stability stable
         */
        resetRecordingGroup(): void;
        /**
         * @stability stable
         */
        get recordingGroupInput(): ConfigConfigurationRecorderRecordingGroup | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ConfigConfigurationRecorderStatusConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_recorder_status.html#is_enabled ConfigConfigurationRecorderStatus#is_enabled}.
         *
         * @stability stable
         */
        readonly isEnabled: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_recorder_status.html#name ConfigConfigurationRecorderStatus#name}.
         *
         * @stability stable
         */
        readonly name: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_recorder_status.html aws_config_configuration_recorder_status}.
     *
     * @stability stable
     */
    class ConfigConfigurationRecorderStatus extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_configuration_recorder_status.html aws_config_configuration_recorder_status} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ConfigConfigurationRecorderStatusConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _isEnabled?;
        /**
         * @stability stable
         */
        get isEnabled(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set isEnabled(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ConfigConformancePackConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack.html#delivery_s3_bucket ConfigConformancePack#delivery_s3_bucket}.
         *
         * @stability stable
         */
        readonly deliveryS3Bucket?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack.html#delivery_s3_key_prefix ConfigConformancePack#delivery_s3_key_prefix}.
         *
         * @stability stable
         */
        readonly deliveryS3KeyPrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack.html#name ConfigConformancePack#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack.html#template_body ConfigConformancePack#template_body}.
         *
         * @stability stable
         */
        readonly templateBody?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack.html#template_s3_uri ConfigConformancePack#template_s3_uri}.
         *
         * @stability stable
         */
        readonly templateS3Uri?: string;
        /**
         * input_parameter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack.html#input_parameter ConfigConformancePack#input_parameter}
         *
         * @stability stable
         */
        readonly inputParameter?: ConfigConformancePackInputParameter[];
    }
    /**
     * @stability stable
     */
    interface ConfigConformancePackInputParameter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack.html#parameter_name ConfigConformancePack#parameter_name}.
         *
         * @stability stable
         */
        readonly parameterName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack.html#parameter_value ConfigConformancePack#parameter_value}.
         *
         * @stability stable
         */
        readonly parameterValue: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack.html aws_config_conformance_pack}.
     *
     * @stability stable
     */
    class ConfigConformancePack extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack.html aws_config_conformance_pack} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ConfigConformancePackConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _deliveryS3Bucket?;
        /**
         * @stability stable
         */
        get deliveryS3Bucket(): string | undefined;
        /**
         * @stability stable
         */
        set deliveryS3Bucket(value: string | undefined);
        /**
         * @stability stable
         */
        resetDeliveryS3Bucket(): void;
        /**
         * @stability stable
         */
        get deliveryS3BucketInput(): string | undefined;
        private _deliveryS3KeyPrefix?;
        /**
         * @stability stable
         */
        get deliveryS3KeyPrefix(): string | undefined;
        /**
         * @stability stable
         */
        set deliveryS3KeyPrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetDeliveryS3KeyPrefix(): void;
        /**
         * @stability stable
         */
        get deliveryS3KeyPrefixInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _templateBody?;
        /**
         * @stability stable
         */
        get templateBody(): string | undefined;
        /**
         * @stability stable
         */
        set templateBody(value: string | undefined);
        /**
         * @stability stable
         */
        resetTemplateBody(): void;
        /**
         * @stability stable
         */
        get templateBodyInput(): string | undefined;
        private _templateS3Uri?;
        /**
         * @stability stable
         */
        get templateS3Uri(): string | undefined;
        /**
         * @stability stable
         */
        set templateS3Uri(value: string | undefined);
        /**
         * @stability stable
         */
        resetTemplateS3Uri(): void;
        /**
         * @stability stable
         */
        get templateS3UriInput(): string | undefined;
        private _inputParameter?;
        /**
         * @stability stable
         */
        get inputParameter(): ConfigConformancePackInputParameter[] | undefined;
        /**
         * @stability stable
         */
        set inputParameter(value: ConfigConformancePackInputParameter[] | undefined);
        /**
         * @stability stable
         */
        resetInputParameter(): void;
        /**
         * @stability stable
         */
        get inputParameterInput(): ConfigConformancePackInputParameter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ConfigDeliveryChannelConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_delivery_channel.html#name ConfigDeliveryChannel#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_delivery_channel.html#s3_bucket_name ConfigDeliveryChannel#s3_bucket_name}.
         *
         * @stability stable
         */
        readonly s3BucketName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_delivery_channel.html#s3_key_prefix ConfigDeliveryChannel#s3_key_prefix}.
         *
         * @stability stable
         */
        readonly s3KeyPrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_delivery_channel.html#s3_kms_key_arn ConfigDeliveryChannel#s3_kms_key_arn}.
         *
         * @stability stable
         */
        readonly s3KmsKeyArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_delivery_channel.html#sns_topic_arn ConfigDeliveryChannel#sns_topic_arn}.
         *
         * @stability stable
         */
        readonly snsTopicArn?: string;
        /**
         * snapshot_delivery_properties block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_delivery_channel.html#snapshot_delivery_properties ConfigDeliveryChannel#snapshot_delivery_properties}
         *
         * @stability stable
         */
        readonly snapshotDeliveryProperties?: ConfigDeliveryChannelSnapshotDeliveryProperties;
    }
    /**
     * @stability stable
     */
    interface ConfigDeliveryChannelSnapshotDeliveryProperties {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_delivery_channel.html#delivery_frequency ConfigDeliveryChannel#delivery_frequency}.
         *
         * @stability stable
         */
        readonly deliveryFrequency?: string;
    }
    /**
     * @stability stable
     */
    class ConfigDeliveryChannelSnapshotDeliveryPropertiesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _deliveryFrequency?;
        /**
         * @stability stable
         */
        get deliveryFrequency(): string | undefined;
        /**
         * @stability stable
         */
        set deliveryFrequency(value: string | undefined);
        /**
         * @stability stable
         */
        resetDeliveryFrequency(): void;
        /**
         * @stability stable
         */
        get deliveryFrequencyInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_delivery_channel.html aws_config_delivery_channel}.
     *
     * @stability stable
     */
    class ConfigDeliveryChannel extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_delivery_channel.html aws_config_delivery_channel} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ConfigDeliveryChannelConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _s3BucketName?;
        /**
         * @stability stable
         */
        get s3BucketName(): string;
        /**
         * @stability stable
         */
        set s3BucketName(value: string);
        /**
         * @stability stable
         */
        get s3BucketNameInput(): string | undefined;
        private _s3KeyPrefix?;
        /**
         * @stability stable
         */
        get s3KeyPrefix(): string | undefined;
        /**
         * @stability stable
         */
        set s3KeyPrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetS3KeyPrefix(): void;
        /**
         * @stability stable
         */
        get s3KeyPrefixInput(): string | undefined;
        private _s3KmsKeyArn?;
        /**
         * @stability stable
         */
        get s3KmsKeyArn(): string | undefined;
        /**
         * @stability stable
         */
        set s3KmsKeyArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetS3KmsKeyArn(): void;
        /**
         * @stability stable
         */
        get s3KmsKeyArnInput(): string | undefined;
        private _snsTopicArn?;
        /**
         * @stability stable
         */
        get snsTopicArn(): string | undefined;
        /**
         * @stability stable
         */
        set snsTopicArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetSnsTopicArn(): void;
        /**
         * @stability stable
         */
        get snsTopicArnInput(): string | undefined;
        private _snapshotDeliveryProperties?;
        private __snapshotDeliveryPropertiesOutput;
        /**
         * @stability stable
         */
        get snapshotDeliveryProperties(): ConfigDeliveryChannelSnapshotDeliveryPropertiesOutputReference;
        /**
         * @stability stable
         */
        putSnapshotDeliveryProperties(value: ConfigDeliveryChannelSnapshotDeliveryProperties | undefined): void;
        /**
         * @stability stable
         */
        resetSnapshotDeliveryProperties(): void;
        /**
         * @stability stable
         */
        get snapshotDeliveryPropertiesInput(): ConfigDeliveryChannelSnapshotDeliveryProperties | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ConfigOrganizationConformancePackConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_conformance_pack.html#delivery_s3_bucket ConfigOrganizationConformancePack#delivery_s3_bucket}.
         *
         * @stability stable
         */
        readonly deliveryS3Bucket?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_conformance_pack.html#delivery_s3_key_prefix ConfigOrganizationConformancePack#delivery_s3_key_prefix}.
         *
         * @stability stable
         */
        readonly deliveryS3KeyPrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_conformance_pack.html#excluded_accounts ConfigOrganizationConformancePack#excluded_accounts}.
         *
         * @stability stable
         */
        readonly excludedAccounts?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_conformance_pack.html#name ConfigOrganizationConformancePack#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_conformance_pack.html#template_body ConfigOrganizationConformancePack#template_body}.
         *
         * @stability stable
         */
        readonly templateBody?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_conformance_pack.html#template_s3_uri ConfigOrganizationConformancePack#template_s3_uri}.
         *
         * @stability stable
         */
        readonly templateS3Uri?: string;
        /**
         * input_parameter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_conformance_pack.html#input_parameter ConfigOrganizationConformancePack#input_parameter}
         *
         * @stability stable
         */
        readonly inputParameter?: ConfigOrganizationConformancePackInputParameter[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_conformance_pack.html#timeouts ConfigOrganizationConformancePack#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: ConfigOrganizationConformancePackTimeouts;
    }
    /**
     * @stability stable
     */
    interface ConfigOrganizationConformancePackInputParameter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_conformance_pack.html#parameter_name ConfigOrganizationConformancePack#parameter_name}.
         *
         * @stability stable
         */
        readonly parameterName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_conformance_pack.html#parameter_value ConfigOrganizationConformancePack#parameter_value}.
         *
         * @stability stable
         */
        readonly parameterValue: string;
    }
    /**
     * @stability stable
     */
    interface ConfigOrganizationConformancePackTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_conformance_pack.html#create ConfigOrganizationConformancePack#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_conformance_pack.html#delete ConfigOrganizationConformancePack#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_conformance_pack.html#update ConfigOrganizationConformancePack#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class ConfigOrganizationConformancePackTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_organization_conformance_pack.html aws_config_organization_conformance_pack}.
     *
     * @stability stable
     */
    class ConfigOrganizationConformancePack extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_organization_conformance_pack.html aws_config_organization_conformance_pack} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ConfigOrganizationConformancePackConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _deliveryS3Bucket?;
        /**
         * @stability stable
         */
        get deliveryS3Bucket(): string | undefined;
        /**
         * @stability stable
         */
        set deliveryS3Bucket(value: string | undefined);
        /**
         * @stability stable
         */
        resetDeliveryS3Bucket(): void;
        /**
         * @stability stable
         */
        get deliveryS3BucketInput(): string | undefined;
        private _deliveryS3KeyPrefix?;
        /**
         * @stability stable
         */
        get deliveryS3KeyPrefix(): string | undefined;
        /**
         * @stability stable
         */
        set deliveryS3KeyPrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetDeliveryS3KeyPrefix(): void;
        /**
         * @stability stable
         */
        get deliveryS3KeyPrefixInput(): string | undefined;
        private _excludedAccounts?;
        /**
         * @stability stable
         */
        get excludedAccounts(): string[] | undefined;
        /**
         * @stability stable
         */
        set excludedAccounts(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetExcludedAccounts(): void;
        /**
         * @stability stable
         */
        get excludedAccountsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _templateBody?;
        /**
         * @stability stable
         */
        get templateBody(): string | undefined;
        /**
         * @stability stable
         */
        set templateBody(value: string | undefined);
        /**
         * @stability stable
         */
        resetTemplateBody(): void;
        /**
         * @stability stable
         */
        get templateBodyInput(): string | undefined;
        private _templateS3Uri?;
        /**
         * @stability stable
         */
        get templateS3Uri(): string | undefined;
        /**
         * @stability stable
         */
        set templateS3Uri(value: string | undefined);
        /**
         * @stability stable
         */
        resetTemplateS3Uri(): void;
        /**
         * @stability stable
         */
        get templateS3UriInput(): string | undefined;
        private _inputParameter?;
        /**
         * @stability stable
         */
        get inputParameter(): ConfigOrganizationConformancePackInputParameter[] | undefined;
        /**
         * @stability stable
         */
        set inputParameter(value: ConfigOrganizationConformancePackInputParameter[] | undefined);
        /**
         * @stability stable
         */
        resetInputParameter(): void;
        /**
         * @stability stable
         */
        get inputParameterInput(): ConfigOrganizationConformancePackInputParameter[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): ConfigOrganizationConformancePackTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: ConfigOrganizationConformancePackTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): ConfigOrganizationConformancePackTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ConfigOrganizationCustomRuleConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#description ConfigOrganizationCustomRule#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#excluded_accounts ConfigOrganizationCustomRule#excluded_accounts}.
         *
         * @stability stable
         */
        readonly excludedAccounts?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#input_parameters ConfigOrganizationCustomRule#input_parameters}.
         *
         * @stability stable
         */
        readonly inputParameters?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#lambda_function_arn ConfigOrganizationCustomRule#lambda_function_arn}.
         *
         * @stability stable
         */
        readonly lambdaFunctionArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#maximum_execution_frequency ConfigOrganizationCustomRule#maximum_execution_frequency}.
         *
         * @stability stable
         */
        readonly maximumExecutionFrequency?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#name ConfigOrganizationCustomRule#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#resource_id_scope ConfigOrganizationCustomRule#resource_id_scope}.
         *
         * @stability stable
         */
        readonly resourceIdScope?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#resource_types_scope ConfigOrganizationCustomRule#resource_types_scope}.
         *
         * @stability stable
         */
        readonly resourceTypesScope?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#tag_key_scope ConfigOrganizationCustomRule#tag_key_scope}.
         *
         * @stability stable
         */
        readonly tagKeyScope?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#tag_value_scope ConfigOrganizationCustomRule#tag_value_scope}.
         *
         * @stability stable
         */
        readonly tagValueScope?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#trigger_types ConfigOrganizationCustomRule#trigger_types}.
         *
         * @stability stable
         */
        readonly triggerTypes: string[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#timeouts ConfigOrganizationCustomRule#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: ConfigOrganizationCustomRuleTimeouts;
    }
    /**
     * @stability stable
     */
    interface ConfigOrganizationCustomRuleTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#create ConfigOrganizationCustomRule#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#delete ConfigOrganizationCustomRule#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html#update ConfigOrganizationCustomRule#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class ConfigOrganizationCustomRuleTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html aws_config_organization_custom_rule}.
     *
     * @stability stable
     */
    class ConfigOrganizationCustomRule extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule.html aws_config_organization_custom_rule} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ConfigOrganizationCustomRuleConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _excludedAccounts?;
        /**
         * @stability stable
         */
        get excludedAccounts(): string[] | undefined;
        /**
         * @stability stable
         */
        set excludedAccounts(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetExcludedAccounts(): void;
        /**
         * @stability stable
         */
        get excludedAccountsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _inputParameters?;
        /**
         * @stability stable
         */
        get inputParameters(): string | undefined;
        /**
         * @stability stable
         */
        set inputParameters(value: string | undefined);
        /**
         * @stability stable
         */
        resetInputParameters(): void;
        /**
         * @stability stable
         */
        get inputParametersInput(): string | undefined;
        private _lambdaFunctionArn?;
        /**
         * @stability stable
         */
        get lambdaFunctionArn(): string;
        /**
         * @stability stable
         */
        set lambdaFunctionArn(value: string);
        /**
         * @stability stable
         */
        get lambdaFunctionArnInput(): string | undefined;
        private _maximumExecutionFrequency?;
        /**
         * @stability stable
         */
        get maximumExecutionFrequency(): string | undefined;
        /**
         * @stability stable
         */
        set maximumExecutionFrequency(value: string | undefined);
        /**
         * @stability stable
         */
        resetMaximumExecutionFrequency(): void;
        /**
         * @stability stable
         */
        get maximumExecutionFrequencyInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _resourceIdScope?;
        /**
         * @stability stable
         */
        get resourceIdScope(): string | undefined;
        /**
         * @stability stable
         */
        set resourceIdScope(value: string | undefined);
        /**
         * @stability stable
         */
        resetResourceIdScope(): void;
        /**
         * @stability stable
         */
        get resourceIdScopeInput(): string | undefined;
        private _resourceTypesScope?;
        /**
         * @stability stable
         */
        get resourceTypesScope(): string[] | undefined;
        /**
         * @stability stable
         */
        set resourceTypesScope(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetResourceTypesScope(): void;
        /**
         * @stability stable
         */
        get resourceTypesScopeInput(): string[] | undefined;
        private _tagKeyScope?;
        /**
         * @stability stable
         */
        get tagKeyScope(): string | undefined;
        /**
         * @stability stable
         */
        set tagKeyScope(value: string | undefined);
        /**
         * @stability stable
         */
        resetTagKeyScope(): void;
        /**
         * @stability stable
         */
        get tagKeyScopeInput(): string | undefined;
        private _tagValueScope?;
        /**
         * @stability stable
         */
        get tagValueScope(): string | undefined;
        /**
         * @stability stable
         */
        set tagValueScope(value: string | undefined);
        /**
         * @stability stable
         */
        resetTagValueScope(): void;
        /**
         * @stability stable
         */
        get tagValueScopeInput(): string | undefined;
        private _triggerTypes?;
        /**
         * @stability stable
         */
        get triggerTypes(): string[];
        /**
         * @stability stable
         */
        set triggerTypes(value: string[]);
        /**
         * @stability stable
         */
        get triggerTypesInput(): string[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): ConfigOrganizationCustomRuleTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: ConfigOrganizationCustomRuleTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): ConfigOrganizationCustomRuleTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ConfigOrganizationManagedRuleConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule.html#description ConfigOrganizationManagedRule#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule.html#excluded_accounts ConfigOrganizationManagedRule#excluded_accounts}.
         *
         * @stability stable
         */
        readonly excludedAccounts?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule.html#input_parameters ConfigOrganizationManagedRule#input_parameters}.
         *
         * @stability stable
         */
        readonly inputParameters?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule.html#maximum_execution_frequency ConfigOrganizationManagedRule#maximum_execution_frequency}.
         *
         * @stability stable
         */
        readonly maximumExecutionFrequency?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule.html#name ConfigOrganizationManagedRule#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule.html#resource_id_scope ConfigOrganizationManagedRule#resource_id_scope}.
         *
         * @stability stable
         */
        readonly resourceIdScope?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule.html#resource_types_scope ConfigOrganizationManagedRule#resource_types_scope}.
         *
         * @stability stable
         */
        readonly resourceTypesScope?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule.html#rule_identifier ConfigOrganizationManagedRule#rule_identifier}.
         *
         * @stability stable
         */
        readonly ruleIdentifier: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule.html#tag_key_scope ConfigOrganizationManagedRule#tag_key_scope}.
         *
         * @stability stable
         */
        readonly tagKeyScope?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule.html#tag_value_scope ConfigOrganizationManagedRule#tag_value_scope}.
         *
         * @stability stable
         */
        readonly tagValueScope?: string;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule.html#timeouts ConfigOrganizationManagedRule#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: ConfigOrganizationManagedRuleTimeouts;
    }
    /**
     * @stability stable
     */
    interface ConfigOrganizationManagedRuleTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule.html#create ConfigOrganizationManagedRule#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule.html#delete ConfigOrganizationManagedRule#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule.html#update ConfigOrganizationManagedRule#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class ConfigOrganizationManagedRuleTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule.html aws_config_organization_managed_rule}.
     *
     * @stability stable
     */
    class ConfigOrganizationManagedRule extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule.html aws_config_organization_managed_rule} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ConfigOrganizationManagedRuleConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _excludedAccounts?;
        /**
         * @stability stable
         */
        get excludedAccounts(): string[] | undefined;
        /**
         * @stability stable
         */
        set excludedAccounts(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetExcludedAccounts(): void;
        /**
         * @stability stable
         */
        get excludedAccountsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _inputParameters?;
        /**
         * @stability stable
         */
        get inputParameters(): string | undefined;
        /**
         * @stability stable
         */
        set inputParameters(value: string | undefined);
        /**
         * @stability stable
         */
        resetInputParameters(): void;
        /**
         * @stability stable
         */
        get inputParametersInput(): string | undefined;
        private _maximumExecutionFrequency?;
        /**
         * @stability stable
         */
        get maximumExecutionFrequency(): string | undefined;
        /**
         * @stability stable
         */
        set maximumExecutionFrequency(value: string | undefined);
        /**
         * @stability stable
         */
        resetMaximumExecutionFrequency(): void;
        /**
         * @stability stable
         */
        get maximumExecutionFrequencyInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _resourceIdScope?;
        /**
         * @stability stable
         */
        get resourceIdScope(): string | undefined;
        /**
         * @stability stable
         */
        set resourceIdScope(value: string | undefined);
        /**
         * @stability stable
         */
        resetResourceIdScope(): void;
        /**
         * @stability stable
         */
        get resourceIdScopeInput(): string | undefined;
        private _resourceTypesScope?;
        /**
         * @stability stable
         */
        get resourceTypesScope(): string[] | undefined;
        /**
         * @stability stable
         */
        set resourceTypesScope(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetResourceTypesScope(): void;
        /**
         * @stability stable
         */
        get resourceTypesScopeInput(): string[] | undefined;
        private _ruleIdentifier?;
        /**
         * @stability stable
         */
        get ruleIdentifier(): string;
        /**
         * @stability stable
         */
        set ruleIdentifier(value: string);
        /**
         * @stability stable
         */
        get ruleIdentifierInput(): string | undefined;
        private _tagKeyScope?;
        /**
         * @stability stable
         */
        get tagKeyScope(): string | undefined;
        /**
         * @stability stable
         */
        set tagKeyScope(value: string | undefined);
        /**
         * @stability stable
         */
        resetTagKeyScope(): void;
        /**
         * @stability stable
         */
        get tagKeyScopeInput(): string | undefined;
        private _tagValueScope?;
        /**
         * @stability stable
         */
        get tagValueScope(): string | undefined;
        /**
         * @stability stable
         */
        set tagValueScope(value: string | undefined);
        /**
         * @stability stable
         */
        resetTagValueScope(): void;
        /**
         * @stability stable
         */
        get tagValueScopeInput(): string | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): ConfigOrganizationManagedRuleTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: ConfigOrganizationManagedRuleTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): ConfigOrganizationManagedRuleTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ConfigRemediationConfigurationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration.html#config_rule_name ConfigRemediationConfiguration#config_rule_name}.
         *
         * @stability stable
         */
        readonly configRuleName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration.html#resource_type ConfigRemediationConfiguration#resource_type}.
         *
         * @stability stable
         */
        readonly resourceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration.html#target_id ConfigRemediationConfiguration#target_id}.
         *
         * @stability stable
         */
        readonly targetId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration.html#target_type ConfigRemediationConfiguration#target_type}.
         *
         * @stability stable
         */
        readonly targetType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration.html#target_version ConfigRemediationConfiguration#target_version}.
         *
         * @stability stable
         */
        readonly targetVersion?: string;
        /**
         * parameter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration.html#parameter ConfigRemediationConfiguration#parameter}
         *
         * @stability stable
         */
        readonly parameter?: ConfigRemediationConfigurationParameter[];
    }
    /**
     * @stability stable
     */
    interface ConfigRemediationConfigurationParameter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration.html#name ConfigRemediationConfiguration#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration.html#resource_value ConfigRemediationConfiguration#resource_value}.
         *
         * @stability stable
         */
        readonly resourceValue?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration.html#static_value ConfigRemediationConfiguration#static_value}.
         *
         * @stability stable
         */
        readonly staticValue?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration.html aws_config_remediation_configuration}.
     *
     * @stability stable
     */
    class ConfigRemediationConfiguration extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration.html aws_config_remediation_configuration} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ConfigRemediationConfigurationConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _configRuleName?;
        /**
         * @stability stable
         */
        get configRuleName(): string;
        /**
         * @stability stable
         */
        set configRuleName(value: string);
        /**
         * @stability stable
         */
        get configRuleNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _resourceType?;
        /**
         * @stability stable
         */
        get resourceType(): string | undefined;
        /**
         * @stability stable
         */
        set resourceType(value: string | undefined);
        /**
         * @stability stable
         */
        resetResourceType(): void;
        /**
         * @stability stable
         */
        get resourceTypeInput(): string | undefined;
        private _targetId?;
        /**
         * @stability stable
         */
        get targetId(): string;
        /**
         * @stability stable
         */
        set targetId(value: string);
        /**
         * @stability stable
         */
        get targetIdInput(): string | undefined;
        private _targetType?;
        /**
         * @stability stable
         */
        get targetType(): string;
        /**
         * @stability stable
         */
        set targetType(value: string);
        /**
         * @stability stable
         */
        get targetTypeInput(): string | undefined;
        private _targetVersion?;
        /**
         * @stability stable
         */
        get targetVersion(): string | undefined;
        /**
         * @stability stable
         */
        set targetVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetTargetVersion(): void;
        /**
         * @stability stable
         */
        get targetVersionInput(): string | undefined;
        private _parameter?;
        /**
         * @stability stable
         */
        get parameter(): ConfigRemediationConfigurationParameter[] | undefined;
        /**
         * @stability stable
         */
        set parameter(value: ConfigRemediationConfigurationParameter[] | undefined);
        /**
         * @stability stable
         */
        resetParameter(): void;
        /**
         * @stability stable
         */
        get parameterInput(): ConfigRemediationConfigurationParameter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
