import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Connect
*/
export declare namespace Connect {
    /**
     * @stability stable
     */
    interface ConnectContactFlowConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_contact_flow.html#content ConnectContactFlow#content}.
         *
         * @stability stable
         */
        readonly content?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_contact_flow.html#content_hash ConnectContactFlow#content_hash}.
         *
         * @stability stable
         */
        readonly contentHash?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_contact_flow.html#description ConnectContactFlow#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_contact_flow.html#filename ConnectContactFlow#filename}.
         *
         * @stability stable
         */
        readonly filename?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_contact_flow.html#instance_id ConnectContactFlow#instance_id}.
         *
         * @stability stable
         */
        readonly instanceId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_contact_flow.html#name ConnectContactFlow#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_contact_flow.html#tags ConnectContactFlow#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_contact_flow.html#tags_all ConnectContactFlow#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_contact_flow.html#type ConnectContactFlow#type}.
         *
         * @stability stable
         */
        readonly type?: string;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_contact_flow.html#timeouts ConnectContactFlow#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: ConnectContactFlowTimeouts;
    }
    /**
     * @stability stable
     */
    interface ConnectContactFlowTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_contact_flow.html#create ConnectContactFlow#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_contact_flow.html#update ConnectContactFlow#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class ConnectContactFlowTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/connect_contact_flow.html aws_connect_contact_flow}.
     *
     * @stability stable
     */
    class ConnectContactFlow extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/connect_contact_flow.html aws_connect_contact_flow} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ConnectContactFlowConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get contactFlowId(): string;
        private _content?;
        /**
         * @stability stable
         */
        get content(): string | undefined;
        /**
         * @stability stable
         */
        set content(value: string | undefined);
        /**
         * @stability stable
         */
        resetContent(): void;
        /**
         * @stability stable
         */
        get contentInput(): string | undefined;
        private _contentHash?;
        /**
         * @stability stable
         */
        get contentHash(): string | undefined;
        /**
         * @stability stable
         */
        set contentHash(value: string | undefined);
        /**
         * @stability stable
         */
        resetContentHash(): void;
        /**
         * @stability stable
         */
        get contentHashInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _filename?;
        /**
         * @stability stable
         */
        get filename(): string | undefined;
        /**
         * @stability stable
         */
        set filename(value: string | undefined);
        /**
         * @stability stable
         */
        resetFilename(): void;
        /**
         * @stability stable
         */
        get filenameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceId?;
        /**
         * @stability stable
         */
        get instanceId(): string;
        /**
         * @stability stable
         */
        set instanceId(value: string);
        /**
         * @stability stable
         */
        get instanceIdInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string | undefined;
        /**
         * @stability stable
         */
        set type(value: string | undefined);
        /**
         * @stability stable
         */
        resetType(): void;
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): ConnectContactFlowTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: ConnectContactFlowTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): ConnectContactFlowTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ConnectInstanceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_instance.html#auto_resolve_best_voices_enabled ConnectInstance#auto_resolve_best_voices_enabled}.
         *
         * @stability stable
         */
        readonly autoResolveBestVoicesEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_instance.html#contact_flow_logs_enabled ConnectInstance#contact_flow_logs_enabled}.
         *
         * @stability stable
         */
        readonly contactFlowLogsEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_instance.html#contact_lens_enabled ConnectInstance#contact_lens_enabled}.
         *
         * @stability stable
         */
        readonly contactLensEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_instance.html#directory_id ConnectInstance#directory_id}.
         *
         * @stability stable
         */
        readonly directoryId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_instance.html#early_media_enabled ConnectInstance#early_media_enabled}.
         *
         * @stability stable
         */
        readonly earlyMediaEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_instance.html#identity_management_type ConnectInstance#identity_management_type}.
         *
         * @stability stable
         */
        readonly identityManagementType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_instance.html#inbound_calls_enabled ConnectInstance#inbound_calls_enabled}.
         *
         * @stability stable
         */
        readonly inboundCallsEnabled: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_instance.html#instance_alias ConnectInstance#instance_alias}.
         *
         * @stability stable
         */
        readonly instanceAlias?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_instance.html#outbound_calls_enabled ConnectInstance#outbound_calls_enabled}.
         *
         * @stability stable
         */
        readonly outboundCallsEnabled: boolean | cdktf.IResolvable;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_instance.html#timeouts ConnectInstance#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: ConnectInstanceTimeouts;
    }
    /**
     * @stability stable
     */
    interface ConnectInstanceTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_instance.html#create ConnectInstance#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_instance.html#delete ConnectInstance#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
    }
    /**
     * @stability stable
     */
    class ConnectInstanceTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/connect_instance.html aws_connect_instance}.
     *
     * @stability stable
     */
    class ConnectInstance extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/connect_instance.html aws_connect_instance} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ConnectInstanceConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoResolveBestVoicesEnabled?;
        /**
         * @stability stable
         */
        get autoResolveBestVoicesEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoResolveBestVoicesEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoResolveBestVoicesEnabled(): void;
        /**
         * @stability stable
         */
        get autoResolveBestVoicesEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _contactFlowLogsEnabled?;
        /**
         * @stability stable
         */
        get contactFlowLogsEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set contactFlowLogsEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetContactFlowLogsEnabled(): void;
        /**
         * @stability stable
         */
        get contactFlowLogsEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _contactLensEnabled?;
        /**
         * @stability stable
         */
        get contactLensEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set contactLensEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetContactLensEnabled(): void;
        /**
         * @stability stable
         */
        get contactLensEnabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get createdTime(): string;
        private _directoryId?;
        /**
         * @stability stable
         */
        get directoryId(): string | undefined;
        /**
         * @stability stable
         */
        set directoryId(value: string | undefined);
        /**
         * @stability stable
         */
        resetDirectoryId(): void;
        /**
         * @stability stable
         */
        get directoryIdInput(): string | undefined;
        private _earlyMediaEnabled?;
        /**
         * @stability stable
         */
        get earlyMediaEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set earlyMediaEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEarlyMediaEnabled(): void;
        /**
         * @stability stable
         */
        get earlyMediaEnabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _identityManagementType?;
        /**
         * @stability stable
         */
        get identityManagementType(): string;
        /**
         * @stability stable
         */
        set identityManagementType(value: string);
        /**
         * @stability stable
         */
        get identityManagementTypeInput(): string | undefined;
        private _inboundCallsEnabled?;
        /**
         * @stability stable
         */
        get inboundCallsEnabled(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set inboundCallsEnabled(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get inboundCallsEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _instanceAlias?;
        /**
         * @stability stable
         */
        get instanceAlias(): string | undefined;
        /**
         * @stability stable
         */
        set instanceAlias(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceAlias(): void;
        /**
         * @stability stable
         */
        get instanceAliasInput(): string | undefined;
        private _outboundCallsEnabled?;
        /**
         * @stability stable
         */
        get outboundCallsEnabled(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set outboundCallsEnabled(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get outboundCallsEnabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get serviceRole(): string;
        /**
         * @stability stable
         */
        get status(): string;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): ConnectInstanceTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: ConnectInstanceTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): ConnectInstanceTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsConnectContactFlowConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_contact_flow.html#contact_flow_id DataAwsConnectContactFlow#contact_flow_id}.
         *
         * @stability stable
         */
        readonly contactFlowId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_contact_flow.html#instance_id DataAwsConnectContactFlow#instance_id}.
         *
         * @stability stable
         */
        readonly instanceId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_contact_flow.html#name DataAwsConnectContactFlow#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_contact_flow.html#tags DataAwsConnectContactFlow#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_contact_flow.html#type DataAwsConnectContactFlow#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/connect_contact_flow.html aws_connect_contact_flow}.
     *
     * @stability stable
     */
    class DataAwsConnectContactFlow extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/connect_contact_flow.html aws_connect_contact_flow} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsConnectContactFlowConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _contactFlowId?;
        /**
         * @stability stable
         */
        get contactFlowId(): string | undefined;
        /**
         * @stability stable
         */
        set contactFlowId(value: string | undefined);
        /**
         * @stability stable
         */
        resetContactFlowId(): void;
        /**
         * @stability stable
         */
        get contactFlowIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get content(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceId?;
        /**
         * @stability stable
         */
        get instanceId(): string;
        /**
         * @stability stable
         */
        set instanceId(value: string);
        /**
         * @stability stable
         */
        get instanceIdInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string | undefined;
        /**
         * @stability stable
         */
        set type(value: string | undefined);
        /**
         * @stability stable
         */
        resetType(): void;
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsConnectInstanceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_instance.html#instance_alias DataAwsConnectInstance#instance_alias}.
         *
         * @stability stable
         */
        readonly instanceAlias?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_instance.html#instance_id DataAwsConnectInstance#instance_id}.
         *
         * @stability stable
         */
        readonly instanceId?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/connect_instance.html aws_connect_instance}.
     *
     * @stability stable
     */
    class DataAwsConnectInstance extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/connect_instance.html aws_connect_instance} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsConnectInstanceConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get autoResolveBestVoicesEnabled(): any;
        /**
         * @stability stable
         */
        get contactFlowLogsEnabled(): any;
        /**
         * @stability stable
         */
        get contactLensEnabled(): any;
        /**
         * @stability stable
         */
        get createdTime(): string;
        /**
         * @stability stable
         */
        get earlyMediaEnabled(): any;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get identityManagementType(): string;
        /**
         * @stability stable
         */
        get inboundCallsEnabled(): any;
        private _instanceAlias?;
        /**
         * @stability stable
         */
        get instanceAlias(): string | undefined;
        /**
         * @stability stable
         */
        set instanceAlias(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceAlias(): void;
        /**
         * @stability stable
         */
        get instanceAliasInput(): string | undefined;
        private _instanceId?;
        /**
         * @stability stable
         */
        get instanceId(): string | undefined;
        /**
         * @stability stable
         */
        set instanceId(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceId(): void;
        /**
         * @stability stable
         */
        get instanceIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get outboundCallsEnabled(): any;
        /**
         * @stability stable
         */
        get serviceRole(): string;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
