import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Data Lifecycle Manager
*/
export declare namespace DLM {
    /**
     * @stability stable
     */
    interface DlmLifecyclePolicyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#description DlmLifecyclePolicy#description}.
         *
         * @stability stable
         */
        readonly description: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#execution_role_arn DlmLifecyclePolicy#execution_role_arn}.
         *
         * @stability stable
         */
        readonly executionRoleArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#state DlmLifecyclePolicy#state}.
         *
         * @stability stable
         */
        readonly state?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#tags DlmLifecyclePolicy#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#tags_all DlmLifecyclePolicy#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * policy_details block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#policy_details DlmLifecyclePolicy#policy_details}
         *
         * @stability stable
         */
        readonly policyDetails: DlmLifecyclePolicyPolicyDetails;
    }
    /**
     * @stability stable
     */
    interface DlmLifecyclePolicyPolicyDetailsScheduleCreateRule {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#interval DlmLifecyclePolicy#interval}.
         *
         * @stability stable
         */
        readonly interval: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#interval_unit DlmLifecyclePolicy#interval_unit}.
         *
         * @stability stable
         */
        readonly intervalUnit?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#times DlmLifecyclePolicy#times}.
         *
         * @stability stable
         */
        readonly times?: string[];
    }
    /**
     * @stability stable
     */
    class DlmLifecyclePolicyPolicyDetailsScheduleCreateRuleOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _interval?;
        /**
         * @stability stable
         */
        get interval(): number;
        /**
         * @stability stable
         */
        set interval(value: number);
        /**
         * @stability stable
         */
        get intervalInput(): number | undefined;
        private _intervalUnit?;
        /**
         * @stability stable
         */
        get intervalUnit(): string | undefined;
        /**
         * @stability stable
         */
        set intervalUnit(value: string | undefined);
        /**
         * @stability stable
         */
        resetIntervalUnit(): void;
        /**
         * @stability stable
         */
        get intervalUnitInput(): string | undefined;
        private _times?;
        /**
         * @stability stable
         */
        get times(): string[] | undefined;
        /**
         * @stability stable
         */
        set times(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetTimes(): void;
        /**
         * @stability stable
         */
        get timesInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface DlmLifecyclePolicyPolicyDetailsScheduleRetainRule {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#count DlmLifecyclePolicy#count}.
         *
         * @stability stable
         */
        readonly count: number;
    }
    /**
     * @stability stable
     */
    class DlmLifecyclePolicyPolicyDetailsScheduleRetainRuleOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _count?;
        /**
         * @stability stable
         */
        get count(): number;
        /**
         * @stability stable
         */
        set count(value: number);
        /**
         * @stability stable
         */
        get countInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface DlmLifecyclePolicyPolicyDetailsSchedule {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#copy_tags DlmLifecyclePolicy#copy_tags}.
         *
         * @stability stable
         */
        readonly copyTags?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#name DlmLifecyclePolicy#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#tags_to_add DlmLifecyclePolicy#tags_to_add}.
         *
         * @stability stable
         */
        readonly tagsToAdd?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * create_rule block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#create_rule DlmLifecyclePolicy#create_rule}
         *
         * @stability stable
         */
        readonly createRule: DlmLifecyclePolicyPolicyDetailsScheduleCreateRule;
        /**
         * retain_rule block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#retain_rule DlmLifecyclePolicy#retain_rule}
         *
         * @stability stable
         */
        readonly retainRule: DlmLifecyclePolicyPolicyDetailsScheduleRetainRule;
    }
    /**
     * @stability stable
     */
    interface DlmLifecyclePolicyPolicyDetails {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#resource_types DlmLifecyclePolicy#resource_types}.
         *
         * @stability stable
         */
        readonly resourceTypes: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#target_tags DlmLifecyclePolicy#target_tags}.
         *
         * @stability stable
         */
        readonly targetTags: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * schedule block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html#schedule DlmLifecyclePolicy#schedule}
         *
         * @stability stable
         */
        readonly schedule: DlmLifecyclePolicyPolicyDetailsSchedule[];
    }
    /**
     * @stability stable
     */
    class DlmLifecyclePolicyPolicyDetailsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _resourceTypes?;
        /**
         * @stability stable
         */
        get resourceTypes(): string[];
        /**
         * @stability stable
         */
        set resourceTypes(value: string[]);
        /**
         * @stability stable
         */
        get resourceTypesInput(): string[] | undefined;
        private _targetTags?;
        /**
         * @stability stable
         */
        get targetTags(): {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set targetTags(value: {
            [key: string]: string;
        } | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get targetTagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _schedule?;
        /**
         * @stability stable
         */
        get schedule(): DlmLifecyclePolicyPolicyDetailsSchedule[];
        /**
         * @stability stable
         */
        set schedule(value: DlmLifecyclePolicyPolicyDetailsSchedule[]);
        /**
         * @stability stable
         */
        get scheduleInput(): DlmLifecyclePolicyPolicyDetailsSchedule[] | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html aws_dlm_lifecycle_policy}.
     *
     * @stability stable
     */
    class DlmLifecyclePolicy extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/dlm_lifecycle_policy.html aws_dlm_lifecycle_policy} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DlmLifecyclePolicyConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        set description(value: string);
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _executionRoleArn?;
        /**
         * @stability stable
         */
        get executionRoleArn(): string;
        /**
         * @stability stable
         */
        set executionRoleArn(value: string);
        /**
         * @stability stable
         */
        get executionRoleArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _state?;
        /**
         * @stability stable
         */
        get state(): string | undefined;
        /**
         * @stability stable
         */
        set state(value: string | undefined);
        /**
         * @stability stable
         */
        resetState(): void;
        /**
         * @stability stable
         */
        get stateInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _policyDetails?;
        private __policyDetailsOutput;
        /**
         * @stability stable
         */
        get policyDetails(): DlmLifecyclePolicyPolicyDetailsOutputReference;
        /**
         * @stability stable
         */
        putPolicyDetails(value: DlmLifecyclePolicyPolicyDetails): void;
        /**
         * @stability stable
         */
        get policyDetailsInput(): DlmLifecyclePolicyPolicyDetails | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
