import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS DataSync
*/
export declare namespace DataSync {
    /**
     * @stability stable
     */
    interface DatasyncAgentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_agent.html#activation_key DatasyncAgent#activation_key}.
         *
         * @stability stable
         */
        readonly activationKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_agent.html#ip_address DatasyncAgent#ip_address}.
         *
         * @stability stable
         */
        readonly ipAddress?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_agent.html#name DatasyncAgent#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_agent.html#private_link_endpoint DatasyncAgent#private_link_endpoint}.
         *
         * @stability stable
         */
        readonly privateLinkEndpoint?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_agent.html#security_group_arns DatasyncAgent#security_group_arns}.
         *
         * @stability stable
         */
        readonly securityGroupArns?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_agent.html#subnet_arns DatasyncAgent#subnet_arns}.
         *
         * @stability stable
         */
        readonly subnetArns?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_agent.html#tags DatasyncAgent#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_agent.html#tags_all DatasyncAgent#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_agent.html#vpc_endpoint_id DatasyncAgent#vpc_endpoint_id}.
         *
         * @stability stable
         */
        readonly vpcEndpointId?: string;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_agent.html#timeouts DatasyncAgent#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: DatasyncAgentTimeouts;
    }
    /**
     * @stability stable
     */
    interface DatasyncAgentTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_agent.html#create DatasyncAgent#create}.
         *
         * @stability stable
         */
        readonly create?: string;
    }
    /**
     * @stability stable
     */
    class DatasyncAgentTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/datasync_agent.html aws_datasync_agent}.
     *
     * @stability stable
     */
    class DatasyncAgent extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/datasync_agent.html aws_datasync_agent} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DatasyncAgentConfig);
        private _activationKey?;
        /**
         * @stability stable
         */
        get activationKey(): string | undefined;
        /**
         * @stability stable
         */
        set activationKey(value: string | undefined);
        /**
         * @stability stable
         */
        resetActivationKey(): void;
        /**
         * @stability stable
         */
        get activationKeyInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _ipAddress?;
        /**
         * @stability stable
         */
        get ipAddress(): string | undefined;
        /**
         * @stability stable
         */
        set ipAddress(value: string | undefined);
        /**
         * @stability stable
         */
        resetIpAddress(): void;
        /**
         * @stability stable
         */
        get ipAddressInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _privateLinkEndpoint?;
        /**
         * @stability stable
         */
        get privateLinkEndpoint(): string | undefined;
        /**
         * @stability stable
         */
        set privateLinkEndpoint(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrivateLinkEndpoint(): void;
        /**
         * @stability stable
         */
        get privateLinkEndpointInput(): string | undefined;
        private _securityGroupArns?;
        /**
         * @stability stable
         */
        get securityGroupArns(): string[] | undefined;
        /**
         * @stability stable
         */
        set securityGroupArns(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecurityGroupArns(): void;
        /**
         * @stability stable
         */
        get securityGroupArnsInput(): string[] | undefined;
        private _subnetArns?;
        /**
         * @stability stable
         */
        get subnetArns(): string[] | undefined;
        /**
         * @stability stable
         */
        set subnetArns(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSubnetArns(): void;
        /**
         * @stability stable
         */
        get subnetArnsInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _vpcEndpointId?;
        /**
         * @stability stable
         */
        get vpcEndpointId(): string | undefined;
        /**
         * @stability stable
         */
        set vpcEndpointId(value: string | undefined);
        /**
         * @stability stable
         */
        resetVpcEndpointId(): void;
        /**
         * @stability stable
         */
        get vpcEndpointIdInput(): string | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): DatasyncAgentTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: DatasyncAgentTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): DatasyncAgentTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DatasyncLocationEfsConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_efs.html#efs_file_system_arn DatasyncLocationEfs#efs_file_system_arn}.
         *
         * @stability stable
         */
        readonly efsFileSystemArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_efs.html#subdirectory DatasyncLocationEfs#subdirectory}.
         *
         * @stability stable
         */
        readonly subdirectory?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_efs.html#tags DatasyncLocationEfs#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_efs.html#tags_all DatasyncLocationEfs#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * ec2_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_efs.html#ec2_config DatasyncLocationEfs#ec2_config}
         *
         * @stability stable
         */
        readonly ec2Config: DatasyncLocationEfsEc2Config;
    }
    /**
     * @stability stable
     */
    interface DatasyncLocationEfsEc2Config {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_efs.html#security_group_arns DatasyncLocationEfs#security_group_arns}.
         *
         * @stability stable
         */
        readonly securityGroupArns: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_efs.html#subnet_arn DatasyncLocationEfs#subnet_arn}.
         *
         * @stability stable
         */
        readonly subnetArn: string;
    }
    /**
     * @stability stable
     */
    class DatasyncLocationEfsEc2ConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _securityGroupArns?;
        /**
         * @stability stable
         */
        get securityGroupArns(): string[];
        /**
         * @stability stable
         */
        set securityGroupArns(value: string[]);
        /**
         * @stability stable
         */
        get securityGroupArnsInput(): string[] | undefined;
        private _subnetArn?;
        /**
         * @stability stable
         */
        get subnetArn(): string;
        /**
         * @stability stable
         */
        set subnetArn(value: string);
        /**
         * @stability stable
         */
        get subnetArnInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_efs.html aws_datasync_location_efs}.
     *
     * @stability stable
     */
    class DatasyncLocationEfs extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_efs.html aws_datasync_location_efs} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DatasyncLocationEfsConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _efsFileSystemArn?;
        /**
         * @stability stable
         */
        get efsFileSystemArn(): string;
        /**
         * @stability stable
         */
        set efsFileSystemArn(value: string);
        /**
         * @stability stable
         */
        get efsFileSystemArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _subdirectory?;
        /**
         * @stability stable
         */
        get subdirectory(): string | undefined;
        /**
         * @stability stable
         */
        set subdirectory(value: string | undefined);
        /**
         * @stability stable
         */
        resetSubdirectory(): void;
        /**
         * @stability stable
         */
        get subdirectoryInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get uri(): string;
        private _ec2Config?;
        private __ec2ConfigOutput;
        /**
         * @stability stable
         */
        get ec2Config(): DatasyncLocationEfsEc2ConfigOutputReference;
        /**
         * @stability stable
         */
        putEc2Config(value: DatasyncLocationEfsEc2Config): void;
        /**
         * @stability stable
         */
        get ec2ConfigInput(): DatasyncLocationEfsEc2Config | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DatasyncLocationFsxWindowsFileSystemConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_fsx_windows_file_system.html#domain DatasyncLocationFsxWindowsFileSystem#domain}.
         *
         * @stability stable
         */
        readonly domain?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_fsx_windows_file_system.html#fsx_filesystem_arn DatasyncLocationFsxWindowsFileSystem#fsx_filesystem_arn}.
         *
         * @stability stable
         */
        readonly fsxFilesystemArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_fsx_windows_file_system.html#password DatasyncLocationFsxWindowsFileSystem#password}.
         *
         * @stability stable
         */
        readonly password: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_fsx_windows_file_system.html#security_group_arns DatasyncLocationFsxWindowsFileSystem#security_group_arns}.
         *
         * @stability stable
         */
        readonly securityGroupArns: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_fsx_windows_file_system.html#subdirectory DatasyncLocationFsxWindowsFileSystem#subdirectory}.
         *
         * @stability stable
         */
        readonly subdirectory?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_fsx_windows_file_system.html#tags DatasyncLocationFsxWindowsFileSystem#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_fsx_windows_file_system.html#tags_all DatasyncLocationFsxWindowsFileSystem#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_fsx_windows_file_system.html#user DatasyncLocationFsxWindowsFileSystem#user}.
         *
         * @stability stable
         */
        readonly user: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_fsx_windows_file_system.html aws_datasync_location_fsx_windows_file_system}.
     *
     * @stability stable
     */
    class DatasyncLocationFsxWindowsFileSystem extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_fsx_windows_file_system.html aws_datasync_location_fsx_windows_file_system} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DatasyncLocationFsxWindowsFileSystemConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get creationTime(): string;
        private _domain?;
        /**
         * @stability stable
         */
        get domain(): string | undefined;
        /**
         * @stability stable
         */
        set domain(value: string | undefined);
        /**
         * @stability stable
         */
        resetDomain(): void;
        /**
         * @stability stable
         */
        get domainInput(): string | undefined;
        private _fsxFilesystemArn?;
        /**
         * @stability stable
         */
        get fsxFilesystemArn(): string;
        /**
         * @stability stable
         */
        set fsxFilesystemArn(value: string);
        /**
         * @stability stable
         */
        get fsxFilesystemArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _password?;
        /**
         * @stability stable
         */
        get password(): string;
        /**
         * @stability stable
         */
        set password(value: string);
        /**
         * @stability stable
         */
        get passwordInput(): string | undefined;
        private _securityGroupArns?;
        /**
         * @stability stable
         */
        get securityGroupArns(): string[];
        /**
         * @stability stable
         */
        set securityGroupArns(value: string[]);
        /**
         * @stability stable
         */
        get securityGroupArnsInput(): string[] | undefined;
        private _subdirectory?;
        /**
         * @stability stable
         */
        get subdirectory(): string | undefined;
        /**
         * @stability stable
         */
        set subdirectory(value: string | undefined);
        /**
         * @stability stable
         */
        resetSubdirectory(): void;
        /**
         * @stability stable
         */
        get subdirectoryInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get uri(): string;
        private _user?;
        /**
         * @stability stable
         */
        get user(): string;
        /**
         * @stability stable
         */
        set user(value: string);
        /**
         * @stability stable
         */
        get userInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DatasyncLocationNfsConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_nfs.html#server_hostname DatasyncLocationNfs#server_hostname}.
         *
         * @stability stable
         */
        readonly serverHostname: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_nfs.html#subdirectory DatasyncLocationNfs#subdirectory}.
         *
         * @stability stable
         */
        readonly subdirectory: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_nfs.html#tags DatasyncLocationNfs#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_nfs.html#tags_all DatasyncLocationNfs#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * mount_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_nfs.html#mount_options DatasyncLocationNfs#mount_options}
         *
         * @stability stable
         */
        readonly mountOptions?: DatasyncLocationNfsMountOptions;
        /**
         * on_prem_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_nfs.html#on_prem_config DatasyncLocationNfs#on_prem_config}
         *
         * @stability stable
         */
        readonly onPremConfig: DatasyncLocationNfsOnPremConfig;
    }
    /**
     * @stability stable
     */
    interface DatasyncLocationNfsMountOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_nfs.html#version DatasyncLocationNfs#version}.
         *
         * @stability stable
         */
        readonly version?: string;
    }
    /**
     * @stability stable
     */
    class DatasyncLocationNfsMountOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _version?;
        /**
         * @stability stable
         */
        get version(): string | undefined;
        /**
         * @stability stable
         */
        set version(value: string | undefined);
        /**
         * @stability stable
         */
        resetVersion(): void;
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface DatasyncLocationNfsOnPremConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_nfs.html#agent_arns DatasyncLocationNfs#agent_arns}.
         *
         * @stability stable
         */
        readonly agentArns: string[];
    }
    /**
     * @stability stable
     */
    class DatasyncLocationNfsOnPremConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _agentArns?;
        /**
         * @stability stable
         */
        get agentArns(): string[];
        /**
         * @stability stable
         */
        set agentArns(value: string[]);
        /**
         * @stability stable
         */
        get agentArnsInput(): string[] | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_nfs.html aws_datasync_location_nfs}.
     *
     * @stability stable
     */
    class DatasyncLocationNfs extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_nfs.html aws_datasync_location_nfs} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DatasyncLocationNfsConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _serverHostname?;
        /**
         * @stability stable
         */
        get serverHostname(): string;
        /**
         * @stability stable
         */
        set serverHostname(value: string);
        /**
         * @stability stable
         */
        get serverHostnameInput(): string | undefined;
        private _subdirectory?;
        /**
         * @stability stable
         */
        get subdirectory(): string;
        /**
         * @stability stable
         */
        set subdirectory(value: string);
        /**
         * @stability stable
         */
        get subdirectoryInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get uri(): string;
        private _mountOptions?;
        private __mountOptionsOutput;
        /**
         * @stability stable
         */
        get mountOptions(): DatasyncLocationNfsMountOptionsOutputReference;
        /**
         * @stability stable
         */
        putMountOptions(value: DatasyncLocationNfsMountOptions | undefined): void;
        /**
         * @stability stable
         */
        resetMountOptions(): void;
        /**
         * @stability stable
         */
        get mountOptionsInput(): DatasyncLocationNfsMountOptions | undefined;
        private _onPremConfig?;
        private __onPremConfigOutput;
        /**
         * @stability stable
         */
        get onPremConfig(): DatasyncLocationNfsOnPremConfigOutputReference;
        /**
         * @stability stable
         */
        putOnPremConfig(value: DatasyncLocationNfsOnPremConfig): void;
        /**
         * @stability stable
         */
        get onPremConfigInput(): DatasyncLocationNfsOnPremConfig | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DatasyncLocationS3Config extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_s3.html#agent_arns DatasyncLocationS3#agent_arns}.
         *
         * @stability stable
         */
        readonly agentArns?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_s3.html#s3_bucket_arn DatasyncLocationS3#s3_bucket_arn}.
         *
         * @stability stable
         */
        readonly s3BucketArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_s3.html#s3_storage_class DatasyncLocationS3#s3_storage_class}.
         *
         * @stability stable
         */
        readonly s3StorageClass?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_s3.html#subdirectory DatasyncLocationS3#subdirectory}.
         *
         * @stability stable
         */
        readonly subdirectory: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_s3.html#tags DatasyncLocationS3#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_s3.html#tags_all DatasyncLocationS3#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * s3_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_s3.html#s3_config DatasyncLocationS3#s3_config}
         *
         * @stability stable
         */
        readonly s3Config: DatasyncLocationS3S3Config;
    }
    /**
     * @stability stable
     */
    interface DatasyncLocationS3S3Config {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_s3.html#bucket_access_role_arn DatasyncLocationS3#bucket_access_role_arn}.
         *
         * @stability stable
         */
        readonly bucketAccessRoleArn: string;
    }
    /**
     * @stability stable
     */
    class DatasyncLocationS3S3ConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bucketAccessRoleArn?;
        /**
         * @stability stable
         */
        get bucketAccessRoleArn(): string;
        /**
         * @stability stable
         */
        set bucketAccessRoleArn(value: string);
        /**
         * @stability stable
         */
        get bucketAccessRoleArnInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_s3.html aws_datasync_location_s3}.
     *
     * @stability stable
     */
    class DatasyncLocationS3 extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_s3.html aws_datasync_location_s3} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DatasyncLocationS3Config);
        private _agentArns?;
        /**
         * @stability stable
         */
        get agentArns(): string[] | undefined;
        /**
         * @stability stable
         */
        set agentArns(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetAgentArns(): void;
        /**
         * @stability stable
         */
        get agentArnsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _s3BucketArn?;
        /**
         * @stability stable
         */
        get s3BucketArn(): string;
        /**
         * @stability stable
         */
        set s3BucketArn(value: string);
        /**
         * @stability stable
         */
        get s3BucketArnInput(): string | undefined;
        private _s3StorageClass?;
        /**
         * @stability stable
         */
        get s3StorageClass(): string | undefined;
        /**
         * @stability stable
         */
        set s3StorageClass(value: string | undefined);
        /**
         * @stability stable
         */
        resetS3StorageClass(): void;
        /**
         * @stability stable
         */
        get s3StorageClassInput(): string | undefined;
        private _subdirectory?;
        /**
         * @stability stable
         */
        get subdirectory(): string;
        /**
         * @stability stable
         */
        set subdirectory(value: string);
        /**
         * @stability stable
         */
        get subdirectoryInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get uri(): string;
        private _s3Config?;
        private __s3ConfigOutput;
        /**
         * @stability stable
         */
        get s3Config(): DatasyncLocationS3S3ConfigOutputReference;
        /**
         * @stability stable
         */
        putS3Config(value: DatasyncLocationS3S3Config): void;
        /**
         * @stability stable
         */
        get s3ConfigInput(): DatasyncLocationS3S3Config | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DatasyncLocationSmbConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_smb.html#agent_arns DatasyncLocationSmb#agent_arns}.
         *
         * @stability stable
         */
        readonly agentArns: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_smb.html#domain DatasyncLocationSmb#domain}.
         *
         * @stability stable
         */
        readonly domain?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_smb.html#password DatasyncLocationSmb#password}.
         *
         * @stability stable
         */
        readonly password: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_smb.html#server_hostname DatasyncLocationSmb#server_hostname}.
         *
         * @stability stable
         */
        readonly serverHostname: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_smb.html#subdirectory DatasyncLocationSmb#subdirectory}.
         *
         * @stability stable
         */
        readonly subdirectory: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_smb.html#tags DatasyncLocationSmb#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_smb.html#tags_all DatasyncLocationSmb#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_smb.html#user DatasyncLocationSmb#user}.
         *
         * @stability stable
         */
        readonly user: string;
        /**
         * mount_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_smb.html#mount_options DatasyncLocationSmb#mount_options}
         *
         * @stability stable
         */
        readonly mountOptions?: DatasyncLocationSmbMountOptions;
    }
    /**
     * @stability stable
     */
    interface DatasyncLocationSmbMountOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_smb.html#version DatasyncLocationSmb#version}.
         *
         * @stability stable
         */
        readonly version?: string;
    }
    /**
     * @stability stable
     */
    class DatasyncLocationSmbMountOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _version?;
        /**
         * @stability stable
         */
        get version(): string | undefined;
        /**
         * @stability stable
         */
        set version(value: string | undefined);
        /**
         * @stability stable
         */
        resetVersion(): void;
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_smb.html aws_datasync_location_smb}.
     *
     * @stability stable
     */
    class DatasyncLocationSmb extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/datasync_location_smb.html aws_datasync_location_smb} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DatasyncLocationSmbConfig);
        private _agentArns?;
        /**
         * @stability stable
         */
        get agentArns(): string[];
        /**
         * @stability stable
         */
        set agentArns(value: string[]);
        /**
         * @stability stable
         */
        get agentArnsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _domain?;
        /**
         * @stability stable
         */
        get domain(): string | undefined;
        /**
         * @stability stable
         */
        set domain(value: string | undefined);
        /**
         * @stability stable
         */
        resetDomain(): void;
        /**
         * @stability stable
         */
        get domainInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _password?;
        /**
         * @stability stable
         */
        get password(): string;
        /**
         * @stability stable
         */
        set password(value: string);
        /**
         * @stability stable
         */
        get passwordInput(): string | undefined;
        private _serverHostname?;
        /**
         * @stability stable
         */
        get serverHostname(): string;
        /**
         * @stability stable
         */
        set serverHostname(value: string);
        /**
         * @stability stable
         */
        get serverHostnameInput(): string | undefined;
        private _subdirectory?;
        /**
         * @stability stable
         */
        get subdirectory(): string;
        /**
         * @stability stable
         */
        set subdirectory(value: string);
        /**
         * @stability stable
         */
        get subdirectoryInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get uri(): string;
        private _user?;
        /**
         * @stability stable
         */
        get user(): string;
        /**
         * @stability stable
         */
        set user(value: string);
        /**
         * @stability stable
         */
        get userInput(): string | undefined;
        private _mountOptions?;
        private __mountOptionsOutput;
        /**
         * @stability stable
         */
        get mountOptions(): DatasyncLocationSmbMountOptionsOutputReference;
        /**
         * @stability stable
         */
        putMountOptions(value: DatasyncLocationSmbMountOptions | undefined): void;
        /**
         * @stability stable
         */
        resetMountOptions(): void;
        /**
         * @stability stable
         */
        get mountOptionsInput(): DatasyncLocationSmbMountOptions | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DatasyncTaskConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#cloudwatch_log_group_arn DatasyncTask#cloudwatch_log_group_arn}.
         *
         * @stability stable
         */
        readonly cloudwatchLogGroupArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#destination_location_arn DatasyncTask#destination_location_arn}.
         *
         * @stability stable
         */
        readonly destinationLocationArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#name DatasyncTask#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#source_location_arn DatasyncTask#source_location_arn}.
         *
         * @stability stable
         */
        readonly sourceLocationArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#tags DatasyncTask#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#tags_all DatasyncTask#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * excludes block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#excludes DatasyncTask#excludes}
         *
         * @stability stable
         */
        readonly excludes?: DatasyncTaskExcludes;
        /**
         * options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#options DatasyncTask#options}
         *
         * @stability stable
         */
        readonly options?: DatasyncTaskOptions;
        /**
         * schedule block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#schedule DatasyncTask#schedule}
         *
         * @stability stable
         */
        readonly schedule?: DatasyncTaskSchedule;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#timeouts DatasyncTask#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: DatasyncTaskTimeouts;
    }
    /**
     * @stability stable
     */
    interface DatasyncTaskExcludes {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#filter_type DatasyncTask#filter_type}.
         *
         * @stability stable
         */
        readonly filterType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#value DatasyncTask#value}.
         *
         * @stability stable
         */
        readonly value?: string;
    }
    /**
     * @stability stable
     */
    class DatasyncTaskExcludesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _filterType?;
        /**
         * @stability stable
         */
        get filterType(): string | undefined;
        /**
         * @stability stable
         */
        set filterType(value: string | undefined);
        /**
         * @stability stable
         */
        resetFilterType(): void;
        /**
         * @stability stable
         */
        get filterTypeInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): string | undefined;
        /**
         * @stability stable
         */
        set value(value: string | undefined);
        /**
         * @stability stable
         */
        resetValue(): void;
        /**
         * @stability stable
         */
        get valueInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface DatasyncTaskOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#atime DatasyncTask#atime}.
         *
         * @stability stable
         */
        readonly atime?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#bytes_per_second DatasyncTask#bytes_per_second}.
         *
         * @stability stable
         */
        readonly bytesPerSecond?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#gid DatasyncTask#gid}.
         *
         * @stability stable
         */
        readonly gid?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#log_level DatasyncTask#log_level}.
         *
         * @stability stable
         */
        readonly logLevel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#mtime DatasyncTask#mtime}.
         *
         * @stability stable
         */
        readonly mtime?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#overwrite_mode DatasyncTask#overwrite_mode}.
         *
         * @stability stable
         */
        readonly overwriteMode?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#posix_permissions DatasyncTask#posix_permissions}.
         *
         * @stability stable
         */
        readonly posixPermissions?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#preserve_deleted_files DatasyncTask#preserve_deleted_files}.
         *
         * @stability stable
         */
        readonly preserveDeletedFiles?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#preserve_devices DatasyncTask#preserve_devices}.
         *
         * @stability stable
         */
        readonly preserveDevices?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#task_queueing DatasyncTask#task_queueing}.
         *
         * @stability stable
         */
        readonly taskQueueing?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#transfer_mode DatasyncTask#transfer_mode}.
         *
         * @stability stable
         */
        readonly transferMode?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#uid DatasyncTask#uid}.
         *
         * @stability stable
         */
        readonly uid?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#verify_mode DatasyncTask#verify_mode}.
         *
         * @stability stable
         */
        readonly verifyMode?: string;
    }
    /**
     * @stability stable
     */
    class DatasyncTaskOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _atime?;
        /**
         * @stability stable
         */
        get atime(): string | undefined;
        /**
         * @stability stable
         */
        set atime(value: string | undefined);
        /**
         * @stability stable
         */
        resetAtime(): void;
        /**
         * @stability stable
         */
        get atimeInput(): string | undefined;
        private _bytesPerSecond?;
        /**
         * @stability stable
         */
        get bytesPerSecond(): number | undefined;
        /**
         * @stability stable
         */
        set bytesPerSecond(value: number | undefined);
        /**
         * @stability stable
         */
        resetBytesPerSecond(): void;
        /**
         * @stability stable
         */
        get bytesPerSecondInput(): number | undefined;
        private _gid?;
        /**
         * @stability stable
         */
        get gid(): string | undefined;
        /**
         * @stability stable
         */
        set gid(value: string | undefined);
        /**
         * @stability stable
         */
        resetGid(): void;
        /**
         * @stability stable
         */
        get gidInput(): string | undefined;
        private _logLevel?;
        /**
         * @stability stable
         */
        get logLevel(): string | undefined;
        /**
         * @stability stable
         */
        set logLevel(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogLevel(): void;
        /**
         * @stability stable
         */
        get logLevelInput(): string | undefined;
        private _mtime?;
        /**
         * @stability stable
         */
        get mtime(): string | undefined;
        /**
         * @stability stable
         */
        set mtime(value: string | undefined);
        /**
         * @stability stable
         */
        resetMtime(): void;
        /**
         * @stability stable
         */
        get mtimeInput(): string | undefined;
        private _overwriteMode?;
        /**
         * @stability stable
         */
        get overwriteMode(): string | undefined;
        /**
         * @stability stable
         */
        set overwriteMode(value: string | undefined);
        /**
         * @stability stable
         */
        resetOverwriteMode(): void;
        /**
         * @stability stable
         */
        get overwriteModeInput(): string | undefined;
        private _posixPermissions?;
        /**
         * @stability stable
         */
        get posixPermissions(): string | undefined;
        /**
         * @stability stable
         */
        set posixPermissions(value: string | undefined);
        /**
         * @stability stable
         */
        resetPosixPermissions(): void;
        /**
         * @stability stable
         */
        get posixPermissionsInput(): string | undefined;
        private _preserveDeletedFiles?;
        /**
         * @stability stable
         */
        get preserveDeletedFiles(): string | undefined;
        /**
         * @stability stable
         */
        set preserveDeletedFiles(value: string | undefined);
        /**
         * @stability stable
         */
        resetPreserveDeletedFiles(): void;
        /**
         * @stability stable
         */
        get preserveDeletedFilesInput(): string | undefined;
        private _preserveDevices?;
        /**
         * @stability stable
         */
        get preserveDevices(): string | undefined;
        /**
         * @stability stable
         */
        set preserveDevices(value: string | undefined);
        /**
         * @stability stable
         */
        resetPreserveDevices(): void;
        /**
         * @stability stable
         */
        get preserveDevicesInput(): string | undefined;
        private _taskQueueing?;
        /**
         * @stability stable
         */
        get taskQueueing(): string | undefined;
        /**
         * @stability stable
         */
        set taskQueueing(value: string | undefined);
        /**
         * @stability stable
         */
        resetTaskQueueing(): void;
        /**
         * @stability stable
         */
        get taskQueueingInput(): string | undefined;
        private _transferMode?;
        /**
         * @stability stable
         */
        get transferMode(): string | undefined;
        /**
         * @stability stable
         */
        set transferMode(value: string | undefined);
        /**
         * @stability stable
         */
        resetTransferMode(): void;
        /**
         * @stability stable
         */
        get transferModeInput(): string | undefined;
        private _uid?;
        /**
         * @stability stable
         */
        get uid(): string | undefined;
        /**
         * @stability stable
         */
        set uid(value: string | undefined);
        /**
         * @stability stable
         */
        resetUid(): void;
        /**
         * @stability stable
         */
        get uidInput(): string | undefined;
        private _verifyMode?;
        /**
         * @stability stable
         */
        get verifyMode(): string | undefined;
        /**
         * @stability stable
         */
        set verifyMode(value: string | undefined);
        /**
         * @stability stable
         */
        resetVerifyMode(): void;
        /**
         * @stability stable
         */
        get verifyModeInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface DatasyncTaskSchedule {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#schedule_expression DatasyncTask#schedule_expression}.
         *
         * @stability stable
         */
        readonly scheduleExpression: string;
    }
    /**
     * @stability stable
     */
    class DatasyncTaskScheduleOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _scheduleExpression?;
        /**
         * @stability stable
         */
        get scheduleExpression(): string;
        /**
         * @stability stable
         */
        set scheduleExpression(value: string);
        /**
         * @stability stable
         */
        get scheduleExpressionInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface DatasyncTaskTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html#create DatasyncTask#create}.
         *
         * @stability stable
         */
        readonly create?: string;
    }
    /**
     * @stability stable
     */
    class DatasyncTaskTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html aws_datasync_task}.
     *
     * @stability stable
     */
    class DatasyncTask extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/datasync_task.html aws_datasync_task} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DatasyncTaskConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _cloudwatchLogGroupArn?;
        /**
         * @stability stable
         */
        get cloudwatchLogGroupArn(): string | undefined;
        /**
         * @stability stable
         */
        set cloudwatchLogGroupArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetCloudwatchLogGroupArn(): void;
        /**
         * @stability stable
         */
        get cloudwatchLogGroupArnInput(): string | undefined;
        private _destinationLocationArn?;
        /**
         * @stability stable
         */
        get destinationLocationArn(): string;
        /**
         * @stability stable
         */
        set destinationLocationArn(value: string);
        /**
         * @stability stable
         */
        get destinationLocationArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _sourceLocationArn?;
        /**
         * @stability stable
         */
        get sourceLocationArn(): string;
        /**
         * @stability stable
         */
        set sourceLocationArn(value: string);
        /**
         * @stability stable
         */
        get sourceLocationArnInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _excludes?;
        private __excludesOutput;
        /**
         * @stability stable
         */
        get excludes(): DatasyncTaskExcludesOutputReference;
        /**
         * @stability stable
         */
        putExcludes(value: DatasyncTaskExcludes | undefined): void;
        /**
         * @stability stable
         */
        resetExcludes(): void;
        /**
         * @stability stable
         */
        get excludesInput(): DatasyncTaskExcludes | undefined;
        private _options?;
        private __optionsOutput;
        /**
         * @stability stable
         */
        get options(): DatasyncTaskOptionsOutputReference;
        /**
         * @stability stable
         */
        putOptions(value: DatasyncTaskOptions | undefined): void;
        /**
         * @stability stable
         */
        resetOptions(): void;
        /**
         * @stability stable
         */
        get optionsInput(): DatasyncTaskOptions | undefined;
        private _schedule?;
        private __scheduleOutput;
        /**
         * @stability stable
         */
        get schedule(): DatasyncTaskScheduleOutputReference;
        /**
         * @stability stable
         */
        putSchedule(value: DatasyncTaskSchedule | undefined): void;
        /**
         * @stability stable
         */
        resetSchedule(): void;
        /**
         * @stability stable
         */
        get scheduleInput(): DatasyncTaskSchedule | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): DatasyncTaskTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: DatasyncTaskTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): DatasyncTaskTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
