import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS DocumentDB
*/
export declare namespace DocumentDB {
    /**
     * @stability stable
     */
    interface DocdbClusterConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#apply_immediately DocdbCluster#apply_immediately}.
         *
         * @stability stable
         */
        readonly applyImmediately?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#availability_zones DocdbCluster#availability_zones}.
         *
         * @stability stable
         */
        readonly availabilityZones?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#backup_retention_period DocdbCluster#backup_retention_period}.
         *
         * @stability stable
         */
        readonly backupRetentionPeriod?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#cluster_identifier DocdbCluster#cluster_identifier}.
         *
         * @stability stable
         */
        readonly clusterIdentifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#cluster_identifier_prefix DocdbCluster#cluster_identifier_prefix}.
         *
         * @stability stable
         */
        readonly clusterIdentifierPrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#cluster_members DocdbCluster#cluster_members}.
         *
         * @stability stable
         */
        readonly clusterMembers?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#db_cluster_parameter_group_name DocdbCluster#db_cluster_parameter_group_name}.
         *
         * @stability stable
         */
        readonly dbClusterParameterGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#db_subnet_group_name DocdbCluster#db_subnet_group_name}.
         *
         * @stability stable
         */
        readonly dbSubnetGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#deletion_protection DocdbCluster#deletion_protection}.
         *
         * @stability stable
         */
        readonly deletionProtection?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#enabled_cloudwatch_logs_exports DocdbCluster#enabled_cloudwatch_logs_exports}.
         *
         * @stability stable
         */
        readonly enabledCloudwatchLogsExports?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#engine DocdbCluster#engine}.
         *
         * @stability stable
         */
        readonly engine?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#engine_version DocdbCluster#engine_version}.
         *
         * @stability stable
         */
        readonly engineVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#final_snapshot_identifier DocdbCluster#final_snapshot_identifier}.
         *
         * @stability stable
         */
        readonly finalSnapshotIdentifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#kms_key_id DocdbCluster#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#master_password DocdbCluster#master_password}.
         *
         * @stability stable
         */
        readonly masterPassword?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#master_username DocdbCluster#master_username}.
         *
         * @stability stable
         */
        readonly masterUsername?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#port DocdbCluster#port}.
         *
         * @stability stable
         */
        readonly port?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#preferred_backup_window DocdbCluster#preferred_backup_window}.
         *
         * @stability stable
         */
        readonly preferredBackupWindow?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#preferred_maintenance_window DocdbCluster#preferred_maintenance_window}.
         *
         * @stability stable
         */
        readonly preferredMaintenanceWindow?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#skip_final_snapshot DocdbCluster#skip_final_snapshot}.
         *
         * @stability stable
         */
        readonly skipFinalSnapshot?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#snapshot_identifier DocdbCluster#snapshot_identifier}.
         *
         * @stability stable
         */
        readonly snapshotIdentifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#storage_encrypted DocdbCluster#storage_encrypted}.
         *
         * @stability stable
         */
        readonly storageEncrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#tags DocdbCluster#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#tags_all DocdbCluster#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#vpc_security_group_ids DocdbCluster#vpc_security_group_ids}.
         *
         * @stability stable
         */
        readonly vpcSecurityGroupIds?: string[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#timeouts DocdbCluster#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: DocdbClusterTimeouts;
    }
    /**
     * @stability stable
     */
    interface DocdbClusterTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#create DocdbCluster#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#delete DocdbCluster#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html#update DocdbCluster#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class DocdbClusterTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html aws_docdb_cluster}.
     *
     * @stability stable
     */
    class DocdbCluster extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster.html aws_docdb_cluster} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DocdbClusterConfig);
        private _applyImmediately?;
        /**
         * @stability stable
         */
        get applyImmediately(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set applyImmediately(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetApplyImmediately(): void;
        /**
         * @stability stable
         */
        get applyImmediatelyInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _availabilityZones?;
        /**
         * @stability stable
         */
        get availabilityZones(): string[] | undefined;
        /**
         * @stability stable
         */
        set availabilityZones(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetAvailabilityZones(): void;
        /**
         * @stability stable
         */
        get availabilityZonesInput(): string[] | undefined;
        private _backupRetentionPeriod?;
        /**
         * @stability stable
         */
        get backupRetentionPeriod(): number | undefined;
        /**
         * @stability stable
         */
        set backupRetentionPeriod(value: number | undefined);
        /**
         * @stability stable
         */
        resetBackupRetentionPeriod(): void;
        /**
         * @stability stable
         */
        get backupRetentionPeriodInput(): number | undefined;
        private _clusterIdentifier?;
        /**
         * @stability stable
         */
        get clusterIdentifier(): string | undefined;
        /**
         * @stability stable
         */
        set clusterIdentifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetClusterIdentifier(): void;
        /**
         * @stability stable
         */
        get clusterIdentifierInput(): string | undefined;
        private _clusterIdentifierPrefix?;
        /**
         * @stability stable
         */
        get clusterIdentifierPrefix(): string | undefined;
        /**
         * @stability stable
         */
        set clusterIdentifierPrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetClusterIdentifierPrefix(): void;
        /**
         * @stability stable
         */
        get clusterIdentifierPrefixInput(): string | undefined;
        private _clusterMembers?;
        /**
         * @stability stable
         */
        get clusterMembers(): string[] | undefined;
        /**
         * @stability stable
         */
        set clusterMembers(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetClusterMembers(): void;
        /**
         * @stability stable
         */
        get clusterMembersInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get clusterResourceId(): string;
        private _dbClusterParameterGroupName?;
        /**
         * @stability stable
         */
        get dbClusterParameterGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set dbClusterParameterGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDbClusterParameterGroupName(): void;
        /**
         * @stability stable
         */
        get dbClusterParameterGroupNameInput(): string | undefined;
        private _dbSubnetGroupName?;
        /**
         * @stability stable
         */
        get dbSubnetGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set dbSubnetGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDbSubnetGroupName(): void;
        /**
         * @stability stable
         */
        get dbSubnetGroupNameInput(): string | undefined;
        private _deletionProtection?;
        /**
         * @stability stable
         */
        get deletionProtection(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set deletionProtection(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDeletionProtection(): void;
        /**
         * @stability stable
         */
        get deletionProtectionInput(): boolean | cdktf.IResolvable | undefined;
        private _enabledCloudwatchLogsExports?;
        /**
         * @stability stable
         */
        get enabledCloudwatchLogsExports(): string[] | undefined;
        /**
         * @stability stable
         */
        set enabledCloudwatchLogsExports(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetEnabledCloudwatchLogsExports(): void;
        /**
         * @stability stable
         */
        get enabledCloudwatchLogsExportsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get endpoint(): string;
        private _engine?;
        /**
         * @stability stable
         */
        get engine(): string | undefined;
        /**
         * @stability stable
         */
        set engine(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngine(): void;
        /**
         * @stability stable
         */
        get engineInput(): string | undefined;
        private _engineVersion?;
        /**
         * @stability stable
         */
        get engineVersion(): string | undefined;
        /**
         * @stability stable
         */
        set engineVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngineVersion(): void;
        /**
         * @stability stable
         */
        get engineVersionInput(): string | undefined;
        private _finalSnapshotIdentifier?;
        /**
         * @stability stable
         */
        get finalSnapshotIdentifier(): string | undefined;
        /**
         * @stability stable
         */
        set finalSnapshotIdentifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetFinalSnapshotIdentifier(): void;
        /**
         * @stability stable
         */
        get finalSnapshotIdentifierInput(): string | undefined;
        /**
         * @stability stable
         */
        get hostedZoneId(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        private _masterPassword?;
        /**
         * @stability stable
         */
        get masterPassword(): string | undefined;
        /**
         * @stability stable
         */
        set masterPassword(value: string | undefined);
        /**
         * @stability stable
         */
        resetMasterPassword(): void;
        /**
         * @stability stable
         */
        get masterPasswordInput(): string | undefined;
        private _masterUsername?;
        /**
         * @stability stable
         */
        get masterUsername(): string | undefined;
        /**
         * @stability stable
         */
        set masterUsername(value: string | undefined);
        /**
         * @stability stable
         */
        resetMasterUsername(): void;
        /**
         * @stability stable
         */
        get masterUsernameInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number | undefined;
        /**
         * @stability stable
         */
        set port(value: number | undefined);
        /**
         * @stability stable
         */
        resetPort(): void;
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
        private _preferredBackupWindow?;
        /**
         * @stability stable
         */
        get preferredBackupWindow(): string | undefined;
        /**
         * @stability stable
         */
        set preferredBackupWindow(value: string | undefined);
        /**
         * @stability stable
         */
        resetPreferredBackupWindow(): void;
        /**
         * @stability stable
         */
        get preferredBackupWindowInput(): string | undefined;
        private _preferredMaintenanceWindow?;
        /**
         * @stability stable
         */
        get preferredMaintenanceWindow(): string | undefined;
        /**
         * @stability stable
         */
        set preferredMaintenanceWindow(value: string | undefined);
        /**
         * @stability stable
         */
        resetPreferredMaintenanceWindow(): void;
        /**
         * @stability stable
         */
        get preferredMaintenanceWindowInput(): string | undefined;
        /**
         * @stability stable
         */
        get readerEndpoint(): string;
        private _skipFinalSnapshot?;
        /**
         * @stability stable
         */
        get skipFinalSnapshot(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set skipFinalSnapshot(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetSkipFinalSnapshot(): void;
        /**
         * @stability stable
         */
        get skipFinalSnapshotInput(): boolean | cdktf.IResolvable | undefined;
        private _snapshotIdentifier?;
        /**
         * @stability stable
         */
        get snapshotIdentifier(): string | undefined;
        /**
         * @stability stable
         */
        set snapshotIdentifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetSnapshotIdentifier(): void;
        /**
         * @stability stable
         */
        get snapshotIdentifierInput(): string | undefined;
        private _storageEncrypted?;
        /**
         * @stability stable
         */
        get storageEncrypted(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set storageEncrypted(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetStorageEncrypted(): void;
        /**
         * @stability stable
         */
        get storageEncryptedInput(): boolean | cdktf.IResolvable | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _vpcSecurityGroupIds?;
        /**
         * @stability stable
         */
        get vpcSecurityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set vpcSecurityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetVpcSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get vpcSecurityGroupIdsInput(): string[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): DocdbClusterTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: DocdbClusterTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): DocdbClusterTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DocdbClusterInstanceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#apply_immediately DocdbClusterInstance#apply_immediately}.
         *
         * @stability stable
         */
        readonly applyImmediately?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#auto_minor_version_upgrade DocdbClusterInstance#auto_minor_version_upgrade}.
         *
         * @stability stable
         */
        readonly autoMinorVersionUpgrade?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#availability_zone DocdbClusterInstance#availability_zone}.
         *
         * @stability stable
         */
        readonly availabilityZone?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#ca_cert_identifier DocdbClusterInstance#ca_cert_identifier}.
         *
         * @stability stable
         */
        readonly caCertIdentifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#cluster_identifier DocdbClusterInstance#cluster_identifier}.
         *
         * @stability stable
         */
        readonly clusterIdentifier: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#engine DocdbClusterInstance#engine}.
         *
         * @stability stable
         */
        readonly engine?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#identifier DocdbClusterInstance#identifier}.
         *
         * @stability stable
         */
        readonly identifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#identifier_prefix DocdbClusterInstance#identifier_prefix}.
         *
         * @stability stable
         */
        readonly identifierPrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#instance_class DocdbClusterInstance#instance_class}.
         *
         * @stability stable
         */
        readonly instanceClass: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#preferred_maintenance_window DocdbClusterInstance#preferred_maintenance_window}.
         *
         * @stability stable
         */
        readonly preferredMaintenanceWindow?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#promotion_tier DocdbClusterInstance#promotion_tier}.
         *
         * @stability stable
         */
        readonly promotionTier?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#tags DocdbClusterInstance#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#tags_all DocdbClusterInstance#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#timeouts DocdbClusterInstance#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: DocdbClusterInstanceTimeouts;
    }
    /**
     * @stability stable
     */
    interface DocdbClusterInstanceTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#create DocdbClusterInstance#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#delete DocdbClusterInstance#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html#update DocdbClusterInstance#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class DocdbClusterInstanceTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html aws_docdb_cluster_instance}.
     *
     * @stability stable
     */
    class DocdbClusterInstance extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_instance.html aws_docdb_cluster_instance} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DocdbClusterInstanceConfig);
        private _applyImmediately?;
        /**
         * @stability stable
         */
        get applyImmediately(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set applyImmediately(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetApplyImmediately(): void;
        /**
         * @stability stable
         */
        get applyImmediatelyInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoMinorVersionUpgrade?;
        /**
         * @stability stable
         */
        get autoMinorVersionUpgrade(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoMinorVersionUpgrade(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoMinorVersionUpgrade(): void;
        /**
         * @stability stable
         */
        get autoMinorVersionUpgradeInput(): boolean | cdktf.IResolvable | undefined;
        private _availabilityZone?;
        /**
         * @stability stable
         */
        get availabilityZone(): string | undefined;
        /**
         * @stability stable
         */
        set availabilityZone(value: string | undefined);
        /**
         * @stability stable
         */
        resetAvailabilityZone(): void;
        /**
         * @stability stable
         */
        get availabilityZoneInput(): string | undefined;
        private _caCertIdentifier?;
        /**
         * @stability stable
         */
        get caCertIdentifier(): string | undefined;
        /**
         * @stability stable
         */
        set caCertIdentifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetCaCertIdentifier(): void;
        /**
         * @stability stable
         */
        get caCertIdentifierInput(): string | undefined;
        private _clusterIdentifier?;
        /**
         * @stability stable
         */
        get clusterIdentifier(): string;
        /**
         * @stability stable
         */
        set clusterIdentifier(value: string);
        /**
         * @stability stable
         */
        get clusterIdentifierInput(): string | undefined;
        /**
         * @stability stable
         */
        get dbSubnetGroupName(): string;
        /**
         * @stability stable
         */
        get dbiResourceId(): string;
        /**
         * @stability stable
         */
        get endpoint(): string;
        private _engine?;
        /**
         * @stability stable
         */
        get engine(): string | undefined;
        /**
         * @stability stable
         */
        set engine(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngine(): void;
        /**
         * @stability stable
         */
        get engineInput(): string | undefined;
        /**
         * @stability stable
         */
        get engineVersion(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _identifier?;
        /**
         * @stability stable
         */
        get identifier(): string | undefined;
        /**
         * @stability stable
         */
        set identifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetIdentifier(): void;
        /**
         * @stability stable
         */
        get identifierInput(): string | undefined;
        private _identifierPrefix?;
        /**
         * @stability stable
         */
        get identifierPrefix(): string | undefined;
        /**
         * @stability stable
         */
        set identifierPrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetIdentifierPrefix(): void;
        /**
         * @stability stable
         */
        get identifierPrefixInput(): string | undefined;
        private _instanceClass?;
        /**
         * @stability stable
         */
        get instanceClass(): string;
        /**
         * @stability stable
         */
        set instanceClass(value: string);
        /**
         * @stability stable
         */
        get instanceClassInput(): string | undefined;
        /**
         * @stability stable
         */
        get kmsKeyId(): string;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        get preferredBackupWindow(): string;
        private _preferredMaintenanceWindow?;
        /**
         * @stability stable
         */
        get preferredMaintenanceWindow(): string | undefined;
        /**
         * @stability stable
         */
        set preferredMaintenanceWindow(value: string | undefined);
        /**
         * @stability stable
         */
        resetPreferredMaintenanceWindow(): void;
        /**
         * @stability stable
         */
        get preferredMaintenanceWindowInput(): string | undefined;
        private _promotionTier?;
        /**
         * @stability stable
         */
        get promotionTier(): number | undefined;
        /**
         * @stability stable
         */
        set promotionTier(value: number | undefined);
        /**
         * @stability stable
         */
        resetPromotionTier(): void;
        /**
         * @stability stable
         */
        get promotionTierInput(): number | undefined;
        /**
         * @stability stable
         */
        get publiclyAccessible(): any;
        /**
         * @stability stable
         */
        get storageEncrypted(): any;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get writer(): any;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): DocdbClusterInstanceTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: DocdbClusterInstanceTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): DocdbClusterInstanceTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DocdbClusterParameterGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_parameter_group.html#description DocdbClusterParameterGroup#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_parameter_group.html#family DocdbClusterParameterGroup#family}.
         *
         * @stability stable
         */
        readonly family: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_parameter_group.html#name DocdbClusterParameterGroup#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_parameter_group.html#name_prefix DocdbClusterParameterGroup#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_parameter_group.html#tags DocdbClusterParameterGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_parameter_group.html#tags_all DocdbClusterParameterGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * parameter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_parameter_group.html#parameter DocdbClusterParameterGroup#parameter}
         *
         * @stability stable
         */
        readonly parameter?: DocdbClusterParameterGroupParameter[];
    }
    /**
     * @stability stable
     */
    interface DocdbClusterParameterGroupParameter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_parameter_group.html#apply_method DocdbClusterParameterGroup#apply_method}.
         *
         * @stability stable
         */
        readonly applyMethod?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_parameter_group.html#name DocdbClusterParameterGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_parameter_group.html#value DocdbClusterParameterGroup#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_parameter_group.html aws_docdb_cluster_parameter_group}.
     *
     * @stability stable
     */
    class DocdbClusterParameterGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_parameter_group.html aws_docdb_cluster_parameter_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DocdbClusterParameterGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _family?;
        /**
         * @stability stable
         */
        get family(): string;
        /**
         * @stability stable
         */
        set family(value: string);
        /**
         * @stability stable
         */
        get familyInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set namePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamePrefix(): void;
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _parameter?;
        /**
         * @stability stable
         */
        get parameter(): DocdbClusterParameterGroupParameter[] | undefined;
        /**
         * @stability stable
         */
        set parameter(value: DocdbClusterParameterGroupParameter[] | undefined);
        /**
         * @stability stable
         */
        resetParameter(): void;
        /**
         * @stability stable
         */
        get parameterInput(): DocdbClusterParameterGroupParameter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DocdbClusterSnapshotConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_snapshot.html#db_cluster_identifier DocdbClusterSnapshot#db_cluster_identifier}.
         *
         * @stability stable
         */
        readonly dbClusterIdentifier: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_snapshot.html#db_cluster_snapshot_identifier DocdbClusterSnapshot#db_cluster_snapshot_identifier}.
         *
         * @stability stable
         */
        readonly dbClusterSnapshotIdentifier: string;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_snapshot.html#timeouts DocdbClusterSnapshot#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: DocdbClusterSnapshotTimeouts;
    }
    /**
     * @stability stable
     */
    interface DocdbClusterSnapshotTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_snapshot.html#create DocdbClusterSnapshot#create}.
         *
         * @stability stable
         */
        readonly create?: string;
    }
    /**
     * @stability stable
     */
    class DocdbClusterSnapshotTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_snapshot.html aws_docdb_cluster_snapshot}.
     *
     * @stability stable
     */
    class DocdbClusterSnapshot extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/docdb_cluster_snapshot.html aws_docdb_cluster_snapshot} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DocdbClusterSnapshotConfig);
        /**
         * @stability stable
         */
        get availabilityZones(): string[];
        private _dbClusterIdentifier?;
        /**
         * @stability stable
         */
        get dbClusterIdentifier(): string;
        /**
         * @stability stable
         */
        set dbClusterIdentifier(value: string);
        /**
         * @stability stable
         */
        get dbClusterIdentifierInput(): string | undefined;
        /**
         * @stability stable
         */
        get dbClusterSnapshotArn(): string;
        private _dbClusterSnapshotIdentifier?;
        /**
         * @stability stable
         */
        get dbClusterSnapshotIdentifier(): string;
        /**
         * @stability stable
         */
        set dbClusterSnapshotIdentifier(value: string);
        /**
         * @stability stable
         */
        get dbClusterSnapshotIdentifierInput(): string | undefined;
        /**
         * @stability stable
         */
        get engine(): string;
        /**
         * @stability stable
         */
        get engineVersion(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get kmsKeyId(): string;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        get snapshotType(): string;
        /**
         * @stability stable
         */
        get sourceDbClusterSnapshotArn(): string;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        get storageEncrypted(): any;
        /**
         * @stability stable
         */
        get vpcId(): string;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): DocdbClusterSnapshotTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: DocdbClusterSnapshotTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): DocdbClusterSnapshotTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DocdbSubnetGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_subnet_group.html#description DocdbSubnetGroup#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_subnet_group.html#name DocdbSubnetGroup#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_subnet_group.html#name_prefix DocdbSubnetGroup#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_subnet_group.html#subnet_ids DocdbSubnetGroup#subnet_ids}.
         *
         * @stability stable
         */
        readonly subnetIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_subnet_group.html#tags DocdbSubnetGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/docdb_subnet_group.html#tags_all DocdbSubnetGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/docdb_subnet_group.html aws_docdb_subnet_group}.
     *
     * @stability stable
     */
    class DocdbSubnetGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/docdb_subnet_group.html aws_docdb_subnet_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DocdbSubnetGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set namePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamePrefix(): void;
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        private _subnetIds?;
        /**
         * @stability stable
         */
        get subnetIds(): string[];
        /**
         * @stability stable
         */
        set subnetIds(value: string[]);
        /**
         * @stability stable
         */
        get subnetIdsInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsDocdbEngineVersionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/docdb_engine_version.html#engine DataAwsDocdbEngineVersion#engine}.
         *
         * @stability stable
         */
        readonly engine?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/docdb_engine_version.html#parameter_group_family DataAwsDocdbEngineVersion#parameter_group_family}.
         *
         * @stability stable
         */
        readonly parameterGroupFamily?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/docdb_engine_version.html#preferred_versions DataAwsDocdbEngineVersion#preferred_versions}.
         *
         * @stability stable
         */
        readonly preferredVersions?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/docdb_engine_version.html#version DataAwsDocdbEngineVersion#version}.
         *
         * @stability stable
         */
        readonly version?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/docdb_engine_version.html aws_docdb_engine_version}.
     *
     * @stability stable
     */
    class DataAwsDocdbEngineVersion extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/docdb_engine_version.html aws_docdb_engine_version} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsDocdbEngineVersionConfig);
        private _engine?;
        /**
         * @stability stable
         */
        get engine(): string | undefined;
        /**
         * @stability stable
         */
        set engine(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngine(): void;
        /**
         * @stability stable
         */
        get engineInput(): string | undefined;
        /**
         * @stability stable
         */
        get engineDescription(): string;
        /**
         * @stability stable
         */
        get exportableLogTypes(): string[];
        /**
         * @stability stable
         */
        get id(): string;
        private _parameterGroupFamily?;
        /**
         * @stability stable
         */
        get parameterGroupFamily(): string | undefined;
        /**
         * @stability stable
         */
        set parameterGroupFamily(value: string | undefined);
        /**
         * @stability stable
         */
        resetParameterGroupFamily(): void;
        /**
         * @stability stable
         */
        get parameterGroupFamilyInput(): string | undefined;
        private _preferredVersions?;
        /**
         * @stability stable
         */
        get preferredVersions(): string[] | undefined;
        /**
         * @stability stable
         */
        set preferredVersions(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetPreferredVersions(): void;
        /**
         * @stability stable
         */
        get preferredVersionsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get supportsLogExportsToCloudwatch(): any;
        /**
         * @stability stable
         */
        get validUpgradeTargets(): string[];
        private _version?;
        /**
         * @stability stable
         */
        get version(): string | undefined;
        /**
         * @stability stable
         */
        set version(value: string | undefined);
        /**
         * @stability stable
         */
        resetVersion(): void;
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
        /**
         * @stability stable
         */
        get versionDescription(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsDocdbOrderableDbInstanceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/docdb_orderable_db_instance.html#engine DataAwsDocdbOrderableDbInstance#engine}.
         *
         * @stability stable
         */
        readonly engine?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/docdb_orderable_db_instance.html#engine_version DataAwsDocdbOrderableDbInstance#engine_version}.
         *
         * @stability stable
         */
        readonly engineVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/docdb_orderable_db_instance.html#instance_class DataAwsDocdbOrderableDbInstance#instance_class}.
         *
         * @stability stable
         */
        readonly instanceClass?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/docdb_orderable_db_instance.html#license_model DataAwsDocdbOrderableDbInstance#license_model}.
         *
         * @stability stable
         */
        readonly licenseModel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/docdb_orderable_db_instance.html#preferred_instance_classes DataAwsDocdbOrderableDbInstance#preferred_instance_classes}.
         *
         * @stability stable
         */
        readonly preferredInstanceClasses?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/docdb_orderable_db_instance.html#vpc DataAwsDocdbOrderableDbInstance#vpc}.
         *
         * @stability stable
         */
        readonly vpc?: boolean | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/docdb_orderable_db_instance.html aws_docdb_orderable_db_instance}.
     *
     * @stability stable
     */
    class DataAwsDocdbOrderableDbInstance extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/docdb_orderable_db_instance.html aws_docdb_orderable_db_instance} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsDocdbOrderableDbInstanceConfig);
        /**
         * @stability stable
         */
        get availabilityZones(): string[];
        private _engine?;
        /**
         * @stability stable
         */
        get engine(): string | undefined;
        /**
         * @stability stable
         */
        set engine(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngine(): void;
        /**
         * @stability stable
         */
        get engineInput(): string | undefined;
        private _engineVersion?;
        /**
         * @stability stable
         */
        get engineVersion(): string | undefined;
        /**
         * @stability stable
         */
        set engineVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngineVersion(): void;
        /**
         * @stability stable
         */
        get engineVersionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceClass?;
        /**
         * @stability stable
         */
        get instanceClass(): string | undefined;
        /**
         * @stability stable
         */
        set instanceClass(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceClass(): void;
        /**
         * @stability stable
         */
        get instanceClassInput(): string | undefined;
        private _licenseModel?;
        /**
         * @stability stable
         */
        get licenseModel(): string | undefined;
        /**
         * @stability stable
         */
        set licenseModel(value: string | undefined);
        /**
         * @stability stable
         */
        resetLicenseModel(): void;
        /**
         * @stability stable
         */
        get licenseModelInput(): string | undefined;
        private _preferredInstanceClasses?;
        /**
         * @stability stable
         */
        get preferredInstanceClasses(): string[] | undefined;
        /**
         * @stability stable
         */
        set preferredInstanceClasses(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetPreferredInstanceClasses(): void;
        /**
         * @stability stable
         */
        get preferredInstanceClassesInput(): string[] | undefined;
        private _vpc?;
        /**
         * @stability stable
         */
        get vpc(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set vpc(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetVpc(): void;
        /**
         * @stability stable
         */
        get vpcInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
