import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Elastic MapReduce
*/
export declare namespace EMR {
    /**
     * @stability stable
     */
    interface EmrClusterConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#additional_info EmrCluster#additional_info}.
         *
         * @stability stable
         */
        readonly additionalInfo?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#applications EmrCluster#applications}.
         *
         * @stability stable
         */
        readonly applications?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#autoscaling_role EmrCluster#autoscaling_role}.
         *
         * @stability stable
         */
        readonly autoscalingRole?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#configurations EmrCluster#configurations}.
         *
         * @stability stable
         */
        readonly configurations?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#configurations_json EmrCluster#configurations_json}.
         *
         * @stability stable
         */
        readonly configurationsJson?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#custom_ami_id EmrCluster#custom_ami_id}.
         *
         * @stability stable
         */
        readonly customAmiId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#ebs_root_volume_size EmrCluster#ebs_root_volume_size}.
         *
         * @stability stable
         */
        readonly ebsRootVolumeSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#keep_job_flow_alive_when_no_steps EmrCluster#keep_job_flow_alive_when_no_steps}.
         *
         * @stability stable
         */
        readonly keepJobFlowAliveWhenNoSteps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#log_encryption_kms_key_id EmrCluster#log_encryption_kms_key_id}.
         *
         * @stability stable
         */
        readonly logEncryptionKmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#log_uri EmrCluster#log_uri}.
         *
         * @stability stable
         */
        readonly logUri?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#name EmrCluster#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#release_label EmrCluster#release_label}.
         *
         * @stability stable
         */
        readonly releaseLabel: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#scale_down_behavior EmrCluster#scale_down_behavior}.
         *
         * @stability stable
         */
        readonly scaleDownBehavior?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#security_configuration EmrCluster#security_configuration}.
         *
         * @stability stable
         */
        readonly securityConfiguration?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#service_role EmrCluster#service_role}.
         *
         * @stability stable
         */
        readonly serviceRole: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#step EmrCluster#step}.
         *
         * @stability stable
         */
        readonly step?: EmrClusterStep[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#step_concurrency_level EmrCluster#step_concurrency_level}.
         *
         * @stability stable
         */
        readonly stepConcurrencyLevel?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#tags EmrCluster#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#tags_all EmrCluster#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#termination_protection EmrCluster#termination_protection}.
         *
         * @stability stable
         */
        readonly terminationProtection?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#visible_to_all_users EmrCluster#visible_to_all_users}.
         *
         * @stability stable
         */
        readonly visibleToAllUsers?: boolean | cdktf.IResolvable;
        /**
         * bootstrap_action block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#bootstrap_action EmrCluster#bootstrap_action}
         *
         * @stability stable
         */
        readonly bootstrapAction?: EmrClusterBootstrapAction[];
        /**
         * core_instance_fleet block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#core_instance_fleet EmrCluster#core_instance_fleet}
         *
         * @stability stable
         */
        readonly coreInstanceFleet?: EmrClusterCoreInstanceFleet;
        /**
         * core_instance_group block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#core_instance_group EmrCluster#core_instance_group}
         *
         * @stability stable
         */
        readonly coreInstanceGroup?: EmrClusterCoreInstanceGroup;
        /**
         * ec2_attributes block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#ec2_attributes EmrCluster#ec2_attributes}
         *
         * @stability stable
         */
        readonly ec2Attributes?: EmrClusterEc2Attributes;
        /**
         * kerberos_attributes block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#kerberos_attributes EmrCluster#kerberos_attributes}
         *
         * @stability stable
         */
        readonly kerberosAttributes?: EmrClusterKerberosAttributes;
        /**
         * master_instance_fleet block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#master_instance_fleet EmrCluster#master_instance_fleet}
         *
         * @stability stable
         */
        readonly masterInstanceFleet?: EmrClusterMasterInstanceFleet;
        /**
         * master_instance_group block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#master_instance_group EmrCluster#master_instance_group}
         *
         * @stability stable
         */
        readonly masterInstanceGroup?: EmrClusterMasterInstanceGroup;
    }
    /**
     * @stability stable
     */
    interface EmrClusterStepHadoopJarStep {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#args EmrCluster#args}.
         *
         * @stability stable
         */
        readonly args?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#jar EmrCluster#jar}.
         *
         * @stability stable
         */
        readonly jar?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#main_class EmrCluster#main_class}.
         *
         * @stability stable
         */
        readonly mainClass?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#properties EmrCluster#properties}.
         *
         * @stability stable
         */
        readonly properties?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    interface EmrClusterStep {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#action_on_failure EmrCluster#action_on_failure}.
         *
         * @stability stable
         */
        readonly actionOnFailure?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#hadoop_jar_step EmrCluster#hadoop_jar_step}.
         *
         * @stability stable
         */
        readonly hadoopJarStep?: EmrClusterStepHadoopJarStep[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#name EmrCluster#name}.
         *
         * @stability stable
         */
        readonly name?: string;
    }
    /**
     * @stability stable
     */
    interface EmrClusterBootstrapAction {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#args EmrCluster#args}.
         *
         * @stability stable
         */
        readonly args?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#name EmrCluster#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#path EmrCluster#path}.
         *
         * @stability stable
         */
        readonly path: string;
    }
    /**
     * @stability stable
     */
    interface EmrClusterCoreInstanceFleetInstanceTypeConfigsConfigurations {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#classification EmrCluster#classification}.
         *
         * @stability stable
         */
        readonly classification?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#properties EmrCluster#properties}.
         *
         * @stability stable
         */
        readonly properties?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    interface EmrClusterCoreInstanceFleetInstanceTypeConfigsEbsConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#iops EmrCluster#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#size EmrCluster#size}.
         *
         * @stability stable
         */
        readonly size: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#type EmrCluster#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#volumes_per_instance EmrCluster#volumes_per_instance}.
         *
         * @stability stable
         */
        readonly volumesPerInstance?: number;
    }
    /**
     * @stability stable
     */
    interface EmrClusterCoreInstanceFleetInstanceTypeConfigs {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#bid_price EmrCluster#bid_price}.
         *
         * @stability stable
         */
        readonly bidPrice?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#bid_price_as_percentage_of_on_demand_price EmrCluster#bid_price_as_percentage_of_on_demand_price}.
         *
         * @stability stable
         */
        readonly bidPriceAsPercentageOfOnDemandPrice?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_type EmrCluster#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#weighted_capacity EmrCluster#weighted_capacity}.
         *
         * @stability stable
         */
        readonly weightedCapacity?: number;
        /**
         * configurations block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#configurations EmrCluster#configurations}
         *
         * @stability stable
         */
        readonly configurations?: EmrClusterCoreInstanceFleetInstanceTypeConfigsConfigurations[];
        /**
         * ebs_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#ebs_config EmrCluster#ebs_config}
         *
         * @stability stable
         */
        readonly ebsConfig?: EmrClusterCoreInstanceFleetInstanceTypeConfigsEbsConfig[];
    }
    /**
     * @stability stable
     */
    interface EmrClusterCoreInstanceFleetLaunchSpecificationsOnDemandSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#allocation_strategy EmrCluster#allocation_strategy}.
         *
         * @stability stable
         */
        readonly allocationStrategy: string;
    }
    /**
     * @stability stable
     */
    interface EmrClusterCoreInstanceFleetLaunchSpecificationsSpotSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#allocation_strategy EmrCluster#allocation_strategy}.
         *
         * @stability stable
         */
        readonly allocationStrategy: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#block_duration_minutes EmrCluster#block_duration_minutes}.
         *
         * @stability stable
         */
        readonly blockDurationMinutes?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#timeout_action EmrCluster#timeout_action}.
         *
         * @stability stable
         */
        readonly timeoutAction: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#timeout_duration_minutes EmrCluster#timeout_duration_minutes}.
         *
         * @stability stable
         */
        readonly timeoutDurationMinutes: number;
    }
    /**
     * @stability stable
     */
    interface EmrClusterCoreInstanceFleetLaunchSpecifications {
        /**
         * on_demand_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#on_demand_specification EmrCluster#on_demand_specification}
         *
         * @stability stable
         */
        readonly onDemandSpecification?: EmrClusterCoreInstanceFleetLaunchSpecificationsOnDemandSpecification[];
        /**
         * spot_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#spot_specification EmrCluster#spot_specification}
         *
         * @stability stable
         */
        readonly spotSpecification?: EmrClusterCoreInstanceFleetLaunchSpecificationsSpotSpecification[];
    }
    /**
     * @stability stable
     */
    class EmrClusterCoreInstanceFleetLaunchSpecificationsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _onDemandSpecification?;
        /**
         * @stability stable
         */
        get onDemandSpecification(): EmrClusterCoreInstanceFleetLaunchSpecificationsOnDemandSpecification[] | undefined;
        /**
         * @stability stable
         */
        set onDemandSpecification(value: EmrClusterCoreInstanceFleetLaunchSpecificationsOnDemandSpecification[] | undefined);
        /**
         * @stability stable
         */
        resetOnDemandSpecification(): void;
        /**
         * @stability stable
         */
        get onDemandSpecificationInput(): EmrClusterCoreInstanceFleetLaunchSpecificationsOnDemandSpecification[] | undefined;
        private _spotSpecification?;
        /**
         * @stability stable
         */
        get spotSpecification(): EmrClusterCoreInstanceFleetLaunchSpecificationsSpotSpecification[] | undefined;
        /**
         * @stability stable
         */
        set spotSpecification(value: EmrClusterCoreInstanceFleetLaunchSpecificationsSpotSpecification[] | undefined);
        /**
         * @stability stable
         */
        resetSpotSpecification(): void;
        /**
         * @stability stable
         */
        get spotSpecificationInput(): EmrClusterCoreInstanceFleetLaunchSpecificationsSpotSpecification[] | undefined;
    }
    /**
     * @stability stable
     */
    interface EmrClusterCoreInstanceFleet {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#name EmrCluster#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#target_on_demand_capacity EmrCluster#target_on_demand_capacity}.
         *
         * @stability stable
         */
        readonly targetOnDemandCapacity?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#target_spot_capacity EmrCluster#target_spot_capacity}.
         *
         * @stability stable
         */
        readonly targetSpotCapacity?: number;
        /**
         * instance_type_configs block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_type_configs EmrCluster#instance_type_configs}
         *
         * @stability stable
         */
        readonly instanceTypeConfigs?: EmrClusterCoreInstanceFleetInstanceTypeConfigs[];
        /**
         * launch_specifications block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#launch_specifications EmrCluster#launch_specifications}
         *
         * @stability stable
         */
        readonly launchSpecifications?: EmrClusterCoreInstanceFleetLaunchSpecifications;
    }
    /**
     * @stability stable
     */
    class EmrClusterCoreInstanceFleetOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _targetOnDemandCapacity?;
        /**
         * @stability stable
         */
        get targetOnDemandCapacity(): number | undefined;
        /**
         * @stability stable
         */
        set targetOnDemandCapacity(value: number | undefined);
        /**
         * @stability stable
         */
        resetTargetOnDemandCapacity(): void;
        /**
         * @stability stable
         */
        get targetOnDemandCapacityInput(): number | undefined;
        private _targetSpotCapacity?;
        /**
         * @stability stable
         */
        get targetSpotCapacity(): number | undefined;
        /**
         * @stability stable
         */
        set targetSpotCapacity(value: number | undefined);
        /**
         * @stability stable
         */
        resetTargetSpotCapacity(): void;
        /**
         * @stability stable
         */
        get targetSpotCapacityInput(): number | undefined;
        private _instanceTypeConfigs?;
        /**
         * @stability stable
         */
        get instanceTypeConfigs(): EmrClusterCoreInstanceFleetInstanceTypeConfigs[] | undefined;
        /**
         * @stability stable
         */
        set instanceTypeConfigs(value: EmrClusterCoreInstanceFleetInstanceTypeConfigs[] | undefined);
        /**
         * @stability stable
         */
        resetInstanceTypeConfigs(): void;
        /**
         * @stability stable
         */
        get instanceTypeConfigsInput(): EmrClusterCoreInstanceFleetInstanceTypeConfigs[] | undefined;
        private _launchSpecifications?;
        private __launchSpecificationsOutput;
        /**
         * @stability stable
         */
        get launchSpecifications(): EmrClusterCoreInstanceFleetLaunchSpecificationsOutputReference;
        /**
         * @stability stable
         */
        putLaunchSpecifications(value: EmrClusterCoreInstanceFleetLaunchSpecifications | undefined): void;
        /**
         * @stability stable
         */
        resetLaunchSpecifications(): void;
        /**
         * @stability stable
         */
        get launchSpecificationsInput(): EmrClusterCoreInstanceFleetLaunchSpecifications | undefined;
    }
    /**
     * @stability stable
     */
    interface EmrClusterCoreInstanceGroupEbsConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#iops EmrCluster#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#size EmrCluster#size}.
         *
         * @stability stable
         */
        readonly size: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#type EmrCluster#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#volumes_per_instance EmrCluster#volumes_per_instance}.
         *
         * @stability stable
         */
        readonly volumesPerInstance?: number;
    }
    /**
     * @stability stable
     */
    interface EmrClusterCoreInstanceGroup {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#autoscaling_policy EmrCluster#autoscaling_policy}.
         *
         * @stability stable
         */
        readonly autoscalingPolicy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#bid_price EmrCluster#bid_price}.
         *
         * @stability stable
         */
        readonly bidPrice?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_count EmrCluster#instance_count}.
         *
         * @stability stable
         */
        readonly instanceCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_type EmrCluster#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#name EmrCluster#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * ebs_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#ebs_config EmrCluster#ebs_config}
         *
         * @stability stable
         */
        readonly ebsConfig?: EmrClusterCoreInstanceGroupEbsConfig[];
    }
    /**
     * @stability stable
     */
    class EmrClusterCoreInstanceGroupOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _autoscalingPolicy?;
        /**
         * @stability stable
         */
        get autoscalingPolicy(): string | undefined;
        /**
         * @stability stable
         */
        set autoscalingPolicy(value: string | undefined);
        /**
         * @stability stable
         */
        resetAutoscalingPolicy(): void;
        /**
         * @stability stable
         */
        get autoscalingPolicyInput(): string | undefined;
        private _bidPrice?;
        /**
         * @stability stable
         */
        get bidPrice(): string | undefined;
        /**
         * @stability stable
         */
        set bidPrice(value: string | undefined);
        /**
         * @stability stable
         */
        resetBidPrice(): void;
        /**
         * @stability stable
         */
        get bidPriceInput(): string | undefined;
        private _instanceCount?;
        /**
         * @stability stable
         */
        get instanceCount(): number | undefined;
        /**
         * @stability stable
         */
        set instanceCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetInstanceCount(): void;
        /**
         * @stability stable
         */
        get instanceCountInput(): number | undefined;
        private _instanceType?;
        /**
         * @stability stable
         */
        get instanceType(): string;
        /**
         * @stability stable
         */
        set instanceType(value: string);
        /**
         * @stability stable
         */
        get instanceTypeInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _ebsConfig?;
        /**
         * @stability stable
         */
        get ebsConfig(): EmrClusterCoreInstanceGroupEbsConfig[] | undefined;
        /**
         * @stability stable
         */
        set ebsConfig(value: EmrClusterCoreInstanceGroupEbsConfig[] | undefined);
        /**
         * @stability stable
         */
        resetEbsConfig(): void;
        /**
         * @stability stable
         */
        get ebsConfigInput(): EmrClusterCoreInstanceGroupEbsConfig[] | undefined;
    }
    /**
     * @stability stable
     */
    interface EmrClusterEc2Attributes {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#additional_master_security_groups EmrCluster#additional_master_security_groups}.
         *
         * @stability stable
         */
        readonly additionalMasterSecurityGroups?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#additional_slave_security_groups EmrCluster#additional_slave_security_groups}.
         *
         * @stability stable
         */
        readonly additionalSlaveSecurityGroups?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#emr_managed_master_security_group EmrCluster#emr_managed_master_security_group}.
         *
         * @stability stable
         */
        readonly emrManagedMasterSecurityGroup?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#emr_managed_slave_security_group EmrCluster#emr_managed_slave_security_group}.
         *
         * @stability stable
         */
        readonly emrManagedSlaveSecurityGroup?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_profile EmrCluster#instance_profile}.
         *
         * @stability stable
         */
        readonly instanceProfile: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#key_name EmrCluster#key_name}.
         *
         * @stability stable
         */
        readonly keyName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#service_access_security_group EmrCluster#service_access_security_group}.
         *
         * @stability stable
         */
        readonly serviceAccessSecurityGroup?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#subnet_id EmrCluster#subnet_id}.
         *
         * @stability stable
         */
        readonly subnetId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#subnet_ids EmrCluster#subnet_ids}.
         *
         * @stability stable
         */
        readonly subnetIds?: string[];
    }
    /**
     * @stability stable
     */
    class EmrClusterEc2AttributesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _additionalMasterSecurityGroups?;
        /**
         * @stability stable
         */
        get additionalMasterSecurityGroups(): string | undefined;
        /**
         * @stability stable
         */
        set additionalMasterSecurityGroups(value: string | undefined);
        /**
         * @stability stable
         */
        resetAdditionalMasterSecurityGroups(): void;
        /**
         * @stability stable
         */
        get additionalMasterSecurityGroupsInput(): string | undefined;
        private _additionalSlaveSecurityGroups?;
        /**
         * @stability stable
         */
        get additionalSlaveSecurityGroups(): string | undefined;
        /**
         * @stability stable
         */
        set additionalSlaveSecurityGroups(value: string | undefined);
        /**
         * @stability stable
         */
        resetAdditionalSlaveSecurityGroups(): void;
        /**
         * @stability stable
         */
        get additionalSlaveSecurityGroupsInput(): string | undefined;
        private _emrManagedMasterSecurityGroup?;
        /**
         * @stability stable
         */
        get emrManagedMasterSecurityGroup(): string | undefined;
        /**
         * @stability stable
         */
        set emrManagedMasterSecurityGroup(value: string | undefined);
        /**
         * @stability stable
         */
        resetEmrManagedMasterSecurityGroup(): void;
        /**
         * @stability stable
         */
        get emrManagedMasterSecurityGroupInput(): string | undefined;
        private _emrManagedSlaveSecurityGroup?;
        /**
         * @stability stable
         */
        get emrManagedSlaveSecurityGroup(): string | undefined;
        /**
         * @stability stable
         */
        set emrManagedSlaveSecurityGroup(value: string | undefined);
        /**
         * @stability stable
         */
        resetEmrManagedSlaveSecurityGroup(): void;
        /**
         * @stability stable
         */
        get emrManagedSlaveSecurityGroupInput(): string | undefined;
        private _instanceProfile?;
        /**
         * @stability stable
         */
        get instanceProfile(): string;
        /**
         * @stability stable
         */
        set instanceProfile(value: string);
        /**
         * @stability stable
         */
        get instanceProfileInput(): string | undefined;
        private _keyName?;
        /**
         * @stability stable
         */
        get keyName(): string | undefined;
        /**
         * @stability stable
         */
        set keyName(value: string | undefined);
        /**
         * @stability stable
         */
        resetKeyName(): void;
        /**
         * @stability stable
         */
        get keyNameInput(): string | undefined;
        private _serviceAccessSecurityGroup?;
        /**
         * @stability stable
         */
        get serviceAccessSecurityGroup(): string | undefined;
        /**
         * @stability stable
         */
        set serviceAccessSecurityGroup(value: string | undefined);
        /**
         * @stability stable
         */
        resetServiceAccessSecurityGroup(): void;
        /**
         * @stability stable
         */
        get serviceAccessSecurityGroupInput(): string | undefined;
        private _subnetId?;
        /**
         * @stability stable
         */
        get subnetId(): string | undefined;
        /**
         * @stability stable
         */
        set subnetId(value: string | undefined);
        /**
         * @stability stable
         */
        resetSubnetId(): void;
        /**
         * @stability stable
         */
        get subnetIdInput(): string | undefined;
        private _subnetIds?;
        /**
         * @stability stable
         */
        get subnetIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set subnetIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSubnetIds(): void;
        /**
         * @stability stable
         */
        get subnetIdsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface EmrClusterKerberosAttributes {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#ad_domain_join_password EmrCluster#ad_domain_join_password}.
         *
         * @stability stable
         */
        readonly adDomainJoinPassword?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#ad_domain_join_user EmrCluster#ad_domain_join_user}.
         *
         * @stability stable
         */
        readonly adDomainJoinUser?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#cross_realm_trust_principal_password EmrCluster#cross_realm_trust_principal_password}.
         *
         * @stability stable
         */
        readonly crossRealmTrustPrincipalPassword?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#kdc_admin_password EmrCluster#kdc_admin_password}.
         *
         * @stability stable
         */
        readonly kdcAdminPassword: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#realm EmrCluster#realm}.
         *
         * @stability stable
         */
        readonly realm: string;
    }
    /**
     * @stability stable
     */
    class EmrClusterKerberosAttributesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _adDomainJoinPassword?;
        /**
         * @stability stable
         */
        get adDomainJoinPassword(): string | undefined;
        /**
         * @stability stable
         */
        set adDomainJoinPassword(value: string | undefined);
        /**
         * @stability stable
         */
        resetAdDomainJoinPassword(): void;
        /**
         * @stability stable
         */
        get adDomainJoinPasswordInput(): string | undefined;
        private _adDomainJoinUser?;
        /**
         * @stability stable
         */
        get adDomainJoinUser(): string | undefined;
        /**
         * @stability stable
         */
        set adDomainJoinUser(value: string | undefined);
        /**
         * @stability stable
         */
        resetAdDomainJoinUser(): void;
        /**
         * @stability stable
         */
        get adDomainJoinUserInput(): string | undefined;
        private _crossRealmTrustPrincipalPassword?;
        /**
         * @stability stable
         */
        get crossRealmTrustPrincipalPassword(): string | undefined;
        /**
         * @stability stable
         */
        set crossRealmTrustPrincipalPassword(value: string | undefined);
        /**
         * @stability stable
         */
        resetCrossRealmTrustPrincipalPassword(): void;
        /**
         * @stability stable
         */
        get crossRealmTrustPrincipalPasswordInput(): string | undefined;
        private _kdcAdminPassword?;
        /**
         * @stability stable
         */
        get kdcAdminPassword(): string;
        /**
         * @stability stable
         */
        set kdcAdminPassword(value: string);
        /**
         * @stability stable
         */
        get kdcAdminPasswordInput(): string | undefined;
        private _realm?;
        /**
         * @stability stable
         */
        get realm(): string;
        /**
         * @stability stable
         */
        set realm(value: string);
        /**
         * @stability stable
         */
        get realmInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface EmrClusterMasterInstanceFleetInstanceTypeConfigsConfigurations {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#classification EmrCluster#classification}.
         *
         * @stability stable
         */
        readonly classification?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#properties EmrCluster#properties}.
         *
         * @stability stable
         */
        readonly properties?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    interface EmrClusterMasterInstanceFleetInstanceTypeConfigsEbsConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#iops EmrCluster#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#size EmrCluster#size}.
         *
         * @stability stable
         */
        readonly size: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#type EmrCluster#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#volumes_per_instance EmrCluster#volumes_per_instance}.
         *
         * @stability stable
         */
        readonly volumesPerInstance?: number;
    }
    /**
     * @stability stable
     */
    interface EmrClusterMasterInstanceFleetInstanceTypeConfigs {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#bid_price EmrCluster#bid_price}.
         *
         * @stability stable
         */
        readonly bidPrice?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#bid_price_as_percentage_of_on_demand_price EmrCluster#bid_price_as_percentage_of_on_demand_price}.
         *
         * @stability stable
         */
        readonly bidPriceAsPercentageOfOnDemandPrice?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_type EmrCluster#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#weighted_capacity EmrCluster#weighted_capacity}.
         *
         * @stability stable
         */
        readonly weightedCapacity?: number;
        /**
         * configurations block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#configurations EmrCluster#configurations}
         *
         * @stability stable
         */
        readonly configurations?: EmrClusterMasterInstanceFleetInstanceTypeConfigsConfigurations[];
        /**
         * ebs_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#ebs_config EmrCluster#ebs_config}
         *
         * @stability stable
         */
        readonly ebsConfig?: EmrClusterMasterInstanceFleetInstanceTypeConfigsEbsConfig[];
    }
    /**
     * @stability stable
     */
    interface EmrClusterMasterInstanceFleetLaunchSpecificationsOnDemandSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#allocation_strategy EmrCluster#allocation_strategy}.
         *
         * @stability stable
         */
        readonly allocationStrategy: string;
    }
    /**
     * @stability stable
     */
    interface EmrClusterMasterInstanceFleetLaunchSpecificationsSpotSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#allocation_strategy EmrCluster#allocation_strategy}.
         *
         * @stability stable
         */
        readonly allocationStrategy: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#block_duration_minutes EmrCluster#block_duration_minutes}.
         *
         * @stability stable
         */
        readonly blockDurationMinutes?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#timeout_action EmrCluster#timeout_action}.
         *
         * @stability stable
         */
        readonly timeoutAction: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#timeout_duration_minutes EmrCluster#timeout_duration_minutes}.
         *
         * @stability stable
         */
        readonly timeoutDurationMinutes: number;
    }
    /**
     * @stability stable
     */
    interface EmrClusterMasterInstanceFleetLaunchSpecifications {
        /**
         * on_demand_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#on_demand_specification EmrCluster#on_demand_specification}
         *
         * @stability stable
         */
        readonly onDemandSpecification?: EmrClusterMasterInstanceFleetLaunchSpecificationsOnDemandSpecification[];
        /**
         * spot_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#spot_specification EmrCluster#spot_specification}
         *
         * @stability stable
         */
        readonly spotSpecification?: EmrClusterMasterInstanceFleetLaunchSpecificationsSpotSpecification[];
    }
    /**
     * @stability stable
     */
    class EmrClusterMasterInstanceFleetLaunchSpecificationsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _onDemandSpecification?;
        /**
         * @stability stable
         */
        get onDemandSpecification(): EmrClusterMasterInstanceFleetLaunchSpecificationsOnDemandSpecification[] | undefined;
        /**
         * @stability stable
         */
        set onDemandSpecification(value: EmrClusterMasterInstanceFleetLaunchSpecificationsOnDemandSpecification[] | undefined);
        /**
         * @stability stable
         */
        resetOnDemandSpecification(): void;
        /**
         * @stability stable
         */
        get onDemandSpecificationInput(): EmrClusterMasterInstanceFleetLaunchSpecificationsOnDemandSpecification[] | undefined;
        private _spotSpecification?;
        /**
         * @stability stable
         */
        get spotSpecification(): EmrClusterMasterInstanceFleetLaunchSpecificationsSpotSpecification[] | undefined;
        /**
         * @stability stable
         */
        set spotSpecification(value: EmrClusterMasterInstanceFleetLaunchSpecificationsSpotSpecification[] | undefined);
        /**
         * @stability stable
         */
        resetSpotSpecification(): void;
        /**
         * @stability stable
         */
        get spotSpecificationInput(): EmrClusterMasterInstanceFleetLaunchSpecificationsSpotSpecification[] | undefined;
    }
    /**
     * @stability stable
     */
    interface EmrClusterMasterInstanceFleet {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#name EmrCluster#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#target_on_demand_capacity EmrCluster#target_on_demand_capacity}.
         *
         * @stability stable
         */
        readonly targetOnDemandCapacity?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#target_spot_capacity EmrCluster#target_spot_capacity}.
         *
         * @stability stable
         */
        readonly targetSpotCapacity?: number;
        /**
         * instance_type_configs block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_type_configs EmrCluster#instance_type_configs}
         *
         * @stability stable
         */
        readonly instanceTypeConfigs?: EmrClusterMasterInstanceFleetInstanceTypeConfigs[];
        /**
         * launch_specifications block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#launch_specifications EmrCluster#launch_specifications}
         *
         * @stability stable
         */
        readonly launchSpecifications?: EmrClusterMasterInstanceFleetLaunchSpecifications;
    }
    /**
     * @stability stable
     */
    class EmrClusterMasterInstanceFleetOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _targetOnDemandCapacity?;
        /**
         * @stability stable
         */
        get targetOnDemandCapacity(): number | undefined;
        /**
         * @stability stable
         */
        set targetOnDemandCapacity(value: number | undefined);
        /**
         * @stability stable
         */
        resetTargetOnDemandCapacity(): void;
        /**
         * @stability stable
         */
        get targetOnDemandCapacityInput(): number | undefined;
        private _targetSpotCapacity?;
        /**
         * @stability stable
         */
        get targetSpotCapacity(): number | undefined;
        /**
         * @stability stable
         */
        set targetSpotCapacity(value: number | undefined);
        /**
         * @stability stable
         */
        resetTargetSpotCapacity(): void;
        /**
         * @stability stable
         */
        get targetSpotCapacityInput(): number | undefined;
        private _instanceTypeConfigs?;
        /**
         * @stability stable
         */
        get instanceTypeConfigs(): EmrClusterMasterInstanceFleetInstanceTypeConfigs[] | undefined;
        /**
         * @stability stable
         */
        set instanceTypeConfigs(value: EmrClusterMasterInstanceFleetInstanceTypeConfigs[] | undefined);
        /**
         * @stability stable
         */
        resetInstanceTypeConfigs(): void;
        /**
         * @stability stable
         */
        get instanceTypeConfigsInput(): EmrClusterMasterInstanceFleetInstanceTypeConfigs[] | undefined;
        private _launchSpecifications?;
        private __launchSpecificationsOutput;
        /**
         * @stability stable
         */
        get launchSpecifications(): EmrClusterMasterInstanceFleetLaunchSpecificationsOutputReference;
        /**
         * @stability stable
         */
        putLaunchSpecifications(value: EmrClusterMasterInstanceFleetLaunchSpecifications | undefined): void;
        /**
         * @stability stable
         */
        resetLaunchSpecifications(): void;
        /**
         * @stability stable
         */
        get launchSpecificationsInput(): EmrClusterMasterInstanceFleetLaunchSpecifications | undefined;
    }
    /**
     * @stability stable
     */
    interface EmrClusterMasterInstanceGroupEbsConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#iops EmrCluster#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#size EmrCluster#size}.
         *
         * @stability stable
         */
        readonly size: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#type EmrCluster#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#volumes_per_instance EmrCluster#volumes_per_instance}.
         *
         * @stability stable
         */
        readonly volumesPerInstance?: number;
    }
    /**
     * @stability stable
     */
    interface EmrClusterMasterInstanceGroup {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#bid_price EmrCluster#bid_price}.
         *
         * @stability stable
         */
        readonly bidPrice?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_count EmrCluster#instance_count}.
         *
         * @stability stable
         */
        readonly instanceCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#instance_type EmrCluster#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#name EmrCluster#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * ebs_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html#ebs_config EmrCluster#ebs_config}
         *
         * @stability stable
         */
        readonly ebsConfig?: EmrClusterMasterInstanceGroupEbsConfig[];
    }
    /**
     * @stability stable
     */
    class EmrClusterMasterInstanceGroupOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bidPrice?;
        /**
         * @stability stable
         */
        get bidPrice(): string | undefined;
        /**
         * @stability stable
         */
        set bidPrice(value: string | undefined);
        /**
         * @stability stable
         */
        resetBidPrice(): void;
        /**
         * @stability stable
         */
        get bidPriceInput(): string | undefined;
        private _instanceCount?;
        /**
         * @stability stable
         */
        get instanceCount(): number | undefined;
        /**
         * @stability stable
         */
        set instanceCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetInstanceCount(): void;
        /**
         * @stability stable
         */
        get instanceCountInput(): number | undefined;
        private _instanceType?;
        /**
         * @stability stable
         */
        get instanceType(): string;
        /**
         * @stability stable
         */
        set instanceType(value: string);
        /**
         * @stability stable
         */
        get instanceTypeInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _ebsConfig?;
        /**
         * @stability stable
         */
        get ebsConfig(): EmrClusterMasterInstanceGroupEbsConfig[] | undefined;
        /**
         * @stability stable
         */
        set ebsConfig(value: EmrClusterMasterInstanceGroupEbsConfig[] | undefined);
        /**
         * @stability stable
         */
        resetEbsConfig(): void;
        /**
         * @stability stable
         */
        get ebsConfigInput(): EmrClusterMasterInstanceGroupEbsConfig[] | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html aws_emr_cluster}.
     *
     * @stability stable
     */
    class EmrCluster extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster.html aws_emr_cluster} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: EmrClusterConfig);
        private _additionalInfo?;
        /**
         * @stability stable
         */
        get additionalInfo(): string | undefined;
        /**
         * @stability stable
         */
        set additionalInfo(value: string | undefined);
        /**
         * @stability stable
         */
        resetAdditionalInfo(): void;
        /**
         * @stability stable
         */
        get additionalInfoInput(): string | undefined;
        private _applications?;
        /**
         * @stability stable
         */
        get applications(): string[] | undefined;
        /**
         * @stability stable
         */
        set applications(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetApplications(): void;
        /**
         * @stability stable
         */
        get applicationsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoscalingRole?;
        /**
         * @stability stable
         */
        get autoscalingRole(): string | undefined;
        /**
         * @stability stable
         */
        set autoscalingRole(value: string | undefined);
        /**
         * @stability stable
         */
        resetAutoscalingRole(): void;
        /**
         * @stability stable
         */
        get autoscalingRoleInput(): string | undefined;
        /**
         * @stability stable
         */
        get clusterState(): string;
        private _configurations?;
        /**
         * @stability stable
         */
        get configurations(): string | undefined;
        /**
         * @stability stable
         */
        set configurations(value: string | undefined);
        /**
         * @stability stable
         */
        resetConfigurations(): void;
        /**
         * @stability stable
         */
        get configurationsInput(): string | undefined;
        private _configurationsJson?;
        /**
         * @stability stable
         */
        get configurationsJson(): string | undefined;
        /**
         * @stability stable
         */
        set configurationsJson(value: string | undefined);
        /**
         * @stability stable
         */
        resetConfigurationsJson(): void;
        /**
         * @stability stable
         */
        get configurationsJsonInput(): string | undefined;
        private _customAmiId?;
        /**
         * @stability stable
         */
        get customAmiId(): string | undefined;
        /**
         * @stability stable
         */
        set customAmiId(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomAmiId(): void;
        /**
         * @stability stable
         */
        get customAmiIdInput(): string | undefined;
        private _ebsRootVolumeSize?;
        /**
         * @stability stable
         */
        get ebsRootVolumeSize(): number | undefined;
        /**
         * @stability stable
         */
        set ebsRootVolumeSize(value: number | undefined);
        /**
         * @stability stable
         */
        resetEbsRootVolumeSize(): void;
        /**
         * @stability stable
         */
        get ebsRootVolumeSizeInput(): number | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _keepJobFlowAliveWhenNoSteps?;
        /**
         * @stability stable
         */
        get keepJobFlowAliveWhenNoSteps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set keepJobFlowAliveWhenNoSteps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetKeepJobFlowAliveWhenNoSteps(): void;
        /**
         * @stability stable
         */
        get keepJobFlowAliveWhenNoStepsInput(): boolean | cdktf.IResolvable | undefined;
        private _logEncryptionKmsKeyId?;
        /**
         * @stability stable
         */
        get logEncryptionKmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set logEncryptionKmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogEncryptionKmsKeyId(): void;
        /**
         * @stability stable
         */
        get logEncryptionKmsKeyIdInput(): string | undefined;
        private _logUri?;
        /**
         * @stability stable
         */
        get logUri(): string | undefined;
        /**
         * @stability stable
         */
        set logUri(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogUri(): void;
        /**
         * @stability stable
         */
        get logUriInput(): string | undefined;
        /**
         * @stability stable
         */
        get masterPublicDns(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _releaseLabel?;
        /**
         * @stability stable
         */
        get releaseLabel(): string;
        /**
         * @stability stable
         */
        set releaseLabel(value: string);
        /**
         * @stability stable
         */
        get releaseLabelInput(): string | undefined;
        private _scaleDownBehavior?;
        /**
         * @stability stable
         */
        get scaleDownBehavior(): string | undefined;
        /**
         * @stability stable
         */
        set scaleDownBehavior(value: string | undefined);
        /**
         * @stability stable
         */
        resetScaleDownBehavior(): void;
        /**
         * @stability stable
         */
        get scaleDownBehaviorInput(): string | undefined;
        private _securityConfiguration?;
        /**
         * @stability stable
         */
        get securityConfiguration(): string | undefined;
        /**
         * @stability stable
         */
        set securityConfiguration(value: string | undefined);
        /**
         * @stability stable
         */
        resetSecurityConfiguration(): void;
        /**
         * @stability stable
         */
        get securityConfigurationInput(): string | undefined;
        private _serviceRole?;
        /**
         * @stability stable
         */
        get serviceRole(): string;
        /**
         * @stability stable
         */
        set serviceRole(value: string);
        /**
         * @stability stable
         */
        get serviceRoleInput(): string | undefined;
        private _step?;
        /**
         * @stability stable
         */
        get step(): EmrClusterStep[] | undefined;
        /**
         * @stability stable
         */
        set step(value: EmrClusterStep[] | undefined);
        /**
         * @stability stable
         */
        resetStep(): void;
        /**
         * @stability stable
         */
        get stepInput(): EmrClusterStep[] | undefined;
        private _stepConcurrencyLevel?;
        /**
         * @stability stable
         */
        get stepConcurrencyLevel(): number | undefined;
        /**
         * @stability stable
         */
        set stepConcurrencyLevel(value: number | undefined);
        /**
         * @stability stable
         */
        resetStepConcurrencyLevel(): void;
        /**
         * @stability stable
         */
        get stepConcurrencyLevelInput(): number | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _terminationProtection?;
        /**
         * @stability stable
         */
        get terminationProtection(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set terminationProtection(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTerminationProtection(): void;
        /**
         * @stability stable
         */
        get terminationProtectionInput(): boolean | cdktf.IResolvable | undefined;
        private _visibleToAllUsers?;
        /**
         * @stability stable
         */
        get visibleToAllUsers(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set visibleToAllUsers(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetVisibleToAllUsers(): void;
        /**
         * @stability stable
         */
        get visibleToAllUsersInput(): boolean | cdktf.IResolvable | undefined;
        private _bootstrapAction?;
        /**
         * @stability stable
         */
        get bootstrapAction(): EmrClusterBootstrapAction[] | undefined;
        /**
         * @stability stable
         */
        set bootstrapAction(value: EmrClusterBootstrapAction[] | undefined);
        /**
         * @stability stable
         */
        resetBootstrapAction(): void;
        /**
         * @stability stable
         */
        get bootstrapActionInput(): EmrClusterBootstrapAction[] | undefined;
        private _coreInstanceFleet?;
        private __coreInstanceFleetOutput;
        /**
         * @stability stable
         */
        get coreInstanceFleet(): EmrClusterCoreInstanceFleetOutputReference;
        /**
         * @stability stable
         */
        putCoreInstanceFleet(value: EmrClusterCoreInstanceFleet | undefined): void;
        /**
         * @stability stable
         */
        resetCoreInstanceFleet(): void;
        /**
         * @stability stable
         */
        get coreInstanceFleetInput(): EmrClusterCoreInstanceFleet | undefined;
        private _coreInstanceGroup?;
        private __coreInstanceGroupOutput;
        /**
         * @stability stable
         */
        get coreInstanceGroup(): EmrClusterCoreInstanceGroupOutputReference;
        /**
         * @stability stable
         */
        putCoreInstanceGroup(value: EmrClusterCoreInstanceGroup | undefined): void;
        /**
         * @stability stable
         */
        resetCoreInstanceGroup(): void;
        /**
         * @stability stable
         */
        get coreInstanceGroupInput(): EmrClusterCoreInstanceGroup | undefined;
        private _ec2Attributes?;
        private __ec2AttributesOutput;
        /**
         * @stability stable
         */
        get ec2Attributes(): EmrClusterEc2AttributesOutputReference;
        /**
         * @stability stable
         */
        putEc2Attributes(value: EmrClusterEc2Attributes | undefined): void;
        /**
         * @stability stable
         */
        resetEc2Attributes(): void;
        /**
         * @stability stable
         */
        get ec2AttributesInput(): EmrClusterEc2Attributes | undefined;
        private _kerberosAttributes?;
        private __kerberosAttributesOutput;
        /**
         * @stability stable
         */
        get kerberosAttributes(): EmrClusterKerberosAttributesOutputReference;
        /**
         * @stability stable
         */
        putKerberosAttributes(value: EmrClusterKerberosAttributes | undefined): void;
        /**
         * @stability stable
         */
        resetKerberosAttributes(): void;
        /**
         * @stability stable
         */
        get kerberosAttributesInput(): EmrClusterKerberosAttributes | undefined;
        private _masterInstanceFleet?;
        private __masterInstanceFleetOutput;
        /**
         * @stability stable
         */
        get masterInstanceFleet(): EmrClusterMasterInstanceFleetOutputReference;
        /**
         * @stability stable
         */
        putMasterInstanceFleet(value: EmrClusterMasterInstanceFleet | undefined): void;
        /**
         * @stability stable
         */
        resetMasterInstanceFleet(): void;
        /**
         * @stability stable
         */
        get masterInstanceFleetInput(): EmrClusterMasterInstanceFleet | undefined;
        private _masterInstanceGroup?;
        private __masterInstanceGroupOutput;
        /**
         * @stability stable
         */
        get masterInstanceGroup(): EmrClusterMasterInstanceGroupOutputReference;
        /**
         * @stability stable
         */
        putMasterInstanceGroup(value: EmrClusterMasterInstanceGroup | undefined): void;
        /**
         * @stability stable
         */
        resetMasterInstanceGroup(): void;
        /**
         * @stability stable
         */
        get masterInstanceGroupInput(): EmrClusterMasterInstanceGroup | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface EmrInstanceFleetConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#cluster_id EmrInstanceFleet#cluster_id}.
         *
         * @stability stable
         */
        readonly clusterId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#name EmrInstanceFleet#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#target_on_demand_capacity EmrInstanceFleet#target_on_demand_capacity}.
         *
         * @stability stable
         */
        readonly targetOnDemandCapacity?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#target_spot_capacity EmrInstanceFleet#target_spot_capacity}.
         *
         * @stability stable
         */
        readonly targetSpotCapacity?: number;
        /**
         * instance_type_configs block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#instance_type_configs EmrInstanceFleet#instance_type_configs}
         *
         * @stability stable
         */
        readonly instanceTypeConfigs?: EmrInstanceFleetInstanceTypeConfigs[];
        /**
         * launch_specifications block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#launch_specifications EmrInstanceFleet#launch_specifications}
         *
         * @stability stable
         */
        readonly launchSpecifications?: EmrInstanceFleetLaunchSpecifications;
    }
    /**
     * @stability stable
     */
    interface EmrInstanceFleetInstanceTypeConfigsConfigurations {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#classification EmrInstanceFleet#classification}.
         *
         * @stability stable
         */
        readonly classification?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#properties EmrInstanceFleet#properties}.
         *
         * @stability stable
         */
        readonly properties?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    interface EmrInstanceFleetInstanceTypeConfigsEbsConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#iops EmrInstanceFleet#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#size EmrInstanceFleet#size}.
         *
         * @stability stable
         */
        readonly size: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#type EmrInstanceFleet#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#volumes_per_instance EmrInstanceFleet#volumes_per_instance}.
         *
         * @stability stable
         */
        readonly volumesPerInstance?: number;
    }
    /**
     * @stability stable
     */
    interface EmrInstanceFleetInstanceTypeConfigs {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#bid_price EmrInstanceFleet#bid_price}.
         *
         * @stability stable
         */
        readonly bidPrice?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#bid_price_as_percentage_of_on_demand_price EmrInstanceFleet#bid_price_as_percentage_of_on_demand_price}.
         *
         * @stability stable
         */
        readonly bidPriceAsPercentageOfOnDemandPrice?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#instance_type EmrInstanceFleet#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#weighted_capacity EmrInstanceFleet#weighted_capacity}.
         *
         * @stability stable
         */
        readonly weightedCapacity?: number;
        /**
         * configurations block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#configurations EmrInstanceFleet#configurations}
         *
         * @stability stable
         */
        readonly configurations?: EmrInstanceFleetInstanceTypeConfigsConfigurations[];
        /**
         * ebs_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#ebs_config EmrInstanceFleet#ebs_config}
         *
         * @stability stable
         */
        readonly ebsConfig?: EmrInstanceFleetInstanceTypeConfigsEbsConfig[];
    }
    /**
     * @stability stable
     */
    interface EmrInstanceFleetLaunchSpecificationsOnDemandSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#allocation_strategy EmrInstanceFleet#allocation_strategy}.
         *
         * @stability stable
         */
        readonly allocationStrategy: string;
    }
    /**
     * @stability stable
     */
    interface EmrInstanceFleetLaunchSpecificationsSpotSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#allocation_strategy EmrInstanceFleet#allocation_strategy}.
         *
         * @stability stable
         */
        readonly allocationStrategy: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#block_duration_minutes EmrInstanceFleet#block_duration_minutes}.
         *
         * @stability stable
         */
        readonly blockDurationMinutes?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#timeout_action EmrInstanceFleet#timeout_action}.
         *
         * @stability stable
         */
        readonly timeoutAction: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#timeout_duration_minutes EmrInstanceFleet#timeout_duration_minutes}.
         *
         * @stability stable
         */
        readonly timeoutDurationMinutes: number;
    }
    /**
     * @stability stable
     */
    interface EmrInstanceFleetLaunchSpecifications {
        /**
         * on_demand_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#on_demand_specification EmrInstanceFleet#on_demand_specification}
         *
         * @stability stable
         */
        readonly onDemandSpecification?: EmrInstanceFleetLaunchSpecificationsOnDemandSpecification[];
        /**
         * spot_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html#spot_specification EmrInstanceFleet#spot_specification}
         *
         * @stability stable
         */
        readonly spotSpecification?: EmrInstanceFleetLaunchSpecificationsSpotSpecification[];
    }
    /**
     * @stability stable
     */
    class EmrInstanceFleetLaunchSpecificationsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _onDemandSpecification?;
        /**
         * @stability stable
         */
        get onDemandSpecification(): EmrInstanceFleetLaunchSpecificationsOnDemandSpecification[] | undefined;
        /**
         * @stability stable
         */
        set onDemandSpecification(value: EmrInstanceFleetLaunchSpecificationsOnDemandSpecification[] | undefined);
        /**
         * @stability stable
         */
        resetOnDemandSpecification(): void;
        /**
         * @stability stable
         */
        get onDemandSpecificationInput(): EmrInstanceFleetLaunchSpecificationsOnDemandSpecification[] | undefined;
        private _spotSpecification?;
        /**
         * @stability stable
         */
        get spotSpecification(): EmrInstanceFleetLaunchSpecificationsSpotSpecification[] | undefined;
        /**
         * @stability stable
         */
        set spotSpecification(value: EmrInstanceFleetLaunchSpecificationsSpotSpecification[] | undefined);
        /**
         * @stability stable
         */
        resetSpotSpecification(): void;
        /**
         * @stability stable
         */
        get spotSpecificationInput(): EmrInstanceFleetLaunchSpecificationsSpotSpecification[] | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html aws_emr_instance_fleet}.
     *
     * @stability stable
     */
    class EmrInstanceFleet extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet.html aws_emr_instance_fleet} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: EmrInstanceFleetConfig);
        private _clusterId?;
        /**
         * @stability stable
         */
        get clusterId(): string;
        /**
         * @stability stable
         */
        set clusterId(value: string);
        /**
         * @stability stable
         */
        get clusterIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get provisionedOnDemandCapacity(): number;
        /**
         * @stability stable
         */
        get provisionedSpotCapacity(): number;
        private _targetOnDemandCapacity?;
        /**
         * @stability stable
         */
        get targetOnDemandCapacity(): number | undefined;
        /**
         * @stability stable
         */
        set targetOnDemandCapacity(value: number | undefined);
        /**
         * @stability stable
         */
        resetTargetOnDemandCapacity(): void;
        /**
         * @stability stable
         */
        get targetOnDemandCapacityInput(): number | undefined;
        private _targetSpotCapacity?;
        /**
         * @stability stable
         */
        get targetSpotCapacity(): number | undefined;
        /**
         * @stability stable
         */
        set targetSpotCapacity(value: number | undefined);
        /**
         * @stability stable
         */
        resetTargetSpotCapacity(): void;
        /**
         * @stability stable
         */
        get targetSpotCapacityInput(): number | undefined;
        private _instanceTypeConfigs?;
        /**
         * @stability stable
         */
        get instanceTypeConfigs(): EmrInstanceFleetInstanceTypeConfigs[] | undefined;
        /**
         * @stability stable
         */
        set instanceTypeConfigs(value: EmrInstanceFleetInstanceTypeConfigs[] | undefined);
        /**
         * @stability stable
         */
        resetInstanceTypeConfigs(): void;
        /**
         * @stability stable
         */
        get instanceTypeConfigsInput(): EmrInstanceFleetInstanceTypeConfigs[] | undefined;
        private _launchSpecifications?;
        private __launchSpecificationsOutput;
        /**
         * @stability stable
         */
        get launchSpecifications(): EmrInstanceFleetLaunchSpecificationsOutputReference;
        /**
         * @stability stable
         */
        putLaunchSpecifications(value: EmrInstanceFleetLaunchSpecifications | undefined): void;
        /**
         * @stability stable
         */
        resetLaunchSpecifications(): void;
        /**
         * @stability stable
         */
        get launchSpecificationsInput(): EmrInstanceFleetLaunchSpecifications | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface EmrInstanceGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_group.html#autoscaling_policy EmrInstanceGroup#autoscaling_policy}.
         *
         * @stability stable
         */
        readonly autoscalingPolicy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_group.html#bid_price EmrInstanceGroup#bid_price}.
         *
         * @stability stable
         */
        readonly bidPrice?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_group.html#cluster_id EmrInstanceGroup#cluster_id}.
         *
         * @stability stable
         */
        readonly clusterId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_group.html#configurations_json EmrInstanceGroup#configurations_json}.
         *
         * @stability stable
         */
        readonly configurationsJson?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_group.html#ebs_optimized EmrInstanceGroup#ebs_optimized}.
         *
         * @stability stable
         */
        readonly ebsOptimized?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_group.html#instance_count EmrInstanceGroup#instance_count}.
         *
         * @stability stable
         */
        readonly instanceCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_group.html#instance_type EmrInstanceGroup#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_group.html#name EmrInstanceGroup#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * ebs_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_group.html#ebs_config EmrInstanceGroup#ebs_config}
         *
         * @stability stable
         */
        readonly ebsConfig?: EmrInstanceGroupEbsConfig[];
    }
    /**
     * @stability stable
     */
    interface EmrInstanceGroupEbsConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_group.html#iops EmrInstanceGroup#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_group.html#size EmrInstanceGroup#size}.
         *
         * @stability stable
         */
        readonly size: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_group.html#type EmrInstanceGroup#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_group.html#volumes_per_instance EmrInstanceGroup#volumes_per_instance}.
         *
         * @stability stable
         */
        readonly volumesPerInstance?: number;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_group.html aws_emr_instance_group}.
     *
     * @stability stable
     */
    class EmrInstanceGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_group.html aws_emr_instance_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: EmrInstanceGroupConfig);
        private _autoscalingPolicy?;
        /**
         * @stability stable
         */
        get autoscalingPolicy(): string | undefined;
        /**
         * @stability stable
         */
        set autoscalingPolicy(value: string | undefined);
        /**
         * @stability stable
         */
        resetAutoscalingPolicy(): void;
        /**
         * @stability stable
         */
        get autoscalingPolicyInput(): string | undefined;
        private _bidPrice?;
        /**
         * @stability stable
         */
        get bidPrice(): string | undefined;
        /**
         * @stability stable
         */
        set bidPrice(value: string | undefined);
        /**
         * @stability stable
         */
        resetBidPrice(): void;
        /**
         * @stability stable
         */
        get bidPriceInput(): string | undefined;
        private _clusterId?;
        /**
         * @stability stable
         */
        get clusterId(): string;
        /**
         * @stability stable
         */
        set clusterId(value: string);
        /**
         * @stability stable
         */
        get clusterIdInput(): string | undefined;
        private _configurationsJson?;
        /**
         * @stability stable
         */
        get configurationsJson(): string | undefined;
        /**
         * @stability stable
         */
        set configurationsJson(value: string | undefined);
        /**
         * @stability stable
         */
        resetConfigurationsJson(): void;
        /**
         * @stability stable
         */
        get configurationsJsonInput(): string | undefined;
        private _ebsOptimized?;
        /**
         * @stability stable
         */
        get ebsOptimized(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set ebsOptimized(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEbsOptimized(): void;
        /**
         * @stability stable
         */
        get ebsOptimizedInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceCount?;
        /**
         * @stability stable
         */
        get instanceCount(): number | undefined;
        /**
         * @stability stable
         */
        set instanceCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetInstanceCount(): void;
        /**
         * @stability stable
         */
        get instanceCountInput(): number | undefined;
        private _instanceType?;
        /**
         * @stability stable
         */
        get instanceType(): string;
        /**
         * @stability stable
         */
        set instanceType(value: string);
        /**
         * @stability stable
         */
        get instanceTypeInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get runningInstanceCount(): number;
        /**
         * @stability stable
         */
        get status(): string;
        private _ebsConfig?;
        /**
         * @stability stable
         */
        get ebsConfig(): EmrInstanceGroupEbsConfig[] | undefined;
        /**
         * @stability stable
         */
        set ebsConfig(value: EmrInstanceGroupEbsConfig[] | undefined);
        /**
         * @stability stable
         */
        resetEbsConfig(): void;
        /**
         * @stability stable
         */
        get ebsConfigInput(): EmrInstanceGroupEbsConfig[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface EmrManagedScalingPolicyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_managed_scaling_policy.html#cluster_id EmrManagedScalingPolicy#cluster_id}.
         *
         * @stability stable
         */
        readonly clusterId: string;
        /**
         * compute_limits block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_managed_scaling_policy.html#compute_limits EmrManagedScalingPolicy#compute_limits}
         *
         * @stability stable
         */
        readonly computeLimits: EmrManagedScalingPolicyComputeLimits[];
    }
    /**
     * @stability stable
     */
    interface EmrManagedScalingPolicyComputeLimits {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_managed_scaling_policy.html#maximum_capacity_units EmrManagedScalingPolicy#maximum_capacity_units}.
         *
         * @stability stable
         */
        readonly maximumCapacityUnits: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_managed_scaling_policy.html#maximum_core_capacity_units EmrManagedScalingPolicy#maximum_core_capacity_units}.
         *
         * @stability stable
         */
        readonly maximumCoreCapacityUnits?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_managed_scaling_policy.html#maximum_ondemand_capacity_units EmrManagedScalingPolicy#maximum_ondemand_capacity_units}.
         *
         * @stability stable
         */
        readonly maximumOndemandCapacityUnits?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_managed_scaling_policy.html#minimum_capacity_units EmrManagedScalingPolicy#minimum_capacity_units}.
         *
         * @stability stable
         */
        readonly minimumCapacityUnits: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_managed_scaling_policy.html#unit_type EmrManagedScalingPolicy#unit_type}.
         *
         * @stability stable
         */
        readonly unitType: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/emr_managed_scaling_policy.html aws_emr_managed_scaling_policy}.
     *
     * @stability stable
     */
    class EmrManagedScalingPolicy extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/emr_managed_scaling_policy.html aws_emr_managed_scaling_policy} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: EmrManagedScalingPolicyConfig);
        private _clusterId?;
        /**
         * @stability stable
         */
        get clusterId(): string;
        /**
         * @stability stable
         */
        set clusterId(value: string);
        /**
         * @stability stable
         */
        get clusterIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _computeLimits?;
        /**
         * @stability stable
         */
        get computeLimits(): EmrManagedScalingPolicyComputeLimits[];
        /**
         * @stability stable
         */
        set computeLimits(value: EmrManagedScalingPolicyComputeLimits[]);
        /**
         * @stability stable
         */
        get computeLimitsInput(): EmrManagedScalingPolicyComputeLimits[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface EmrSecurityConfigurationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_security_configuration.html#configuration EmrSecurityConfiguration#configuration}.
         *
         * @stability stable
         */
        readonly configuration: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_security_configuration.html#name EmrSecurityConfiguration#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_security_configuration.html#name_prefix EmrSecurityConfiguration#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/emr_security_configuration.html aws_emr_security_configuration}.
     *
     * @stability stable
     */
    class EmrSecurityConfiguration extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/emr_security_configuration.html aws_emr_security_configuration} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: EmrSecurityConfigurationConfig);
        private _configuration?;
        /**
         * @stability stable
         */
        get configuration(): string;
        /**
         * @stability stable
         */
        set configuration(value: string);
        /**
         * @stability stable
         */
        get configurationInput(): string | undefined;
        /**
         * @stability stable
         */
        get creationDate(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set namePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamePrefix(): void;
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
