import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS ElastiCache
*/
export declare namespace ElastiCache {
    /**
     * @stability stable
     */
    interface ElasticacheClusterConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#apply_immediately ElasticacheCluster#apply_immediately}.
         *
         * @stability stable
         */
        readonly applyImmediately?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#availability_zone ElasticacheCluster#availability_zone}.
         *
         * @stability stable
         */
        readonly availabilityZone?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#az_mode ElasticacheCluster#az_mode}.
         *
         * @stability stable
         */
        readonly azMode?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#cluster_id ElasticacheCluster#cluster_id}.
         *
         * @stability stable
         */
        readonly clusterId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#engine ElasticacheCluster#engine}.
         *
         * @stability stable
         */
        readonly engine?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#engine_version ElasticacheCluster#engine_version}.
         *
         * @stability stable
         */
        readonly engineVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#final_snapshot_identifier ElasticacheCluster#final_snapshot_identifier}.
         *
         * @stability stable
         */
        readonly finalSnapshotIdentifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#maintenance_window ElasticacheCluster#maintenance_window}.
         *
         * @stability stable
         */
        readonly maintenanceWindow?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#node_type ElasticacheCluster#node_type}.
         *
         * @stability stable
         */
        readonly nodeType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#notification_topic_arn ElasticacheCluster#notification_topic_arn}.
         *
         * @stability stable
         */
        readonly notificationTopicArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#num_cache_nodes ElasticacheCluster#num_cache_nodes}.
         *
         * @stability stable
         */
        readonly numCacheNodes?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#parameter_group_name ElasticacheCluster#parameter_group_name}.
         *
         * @stability stable
         */
        readonly parameterGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#port ElasticacheCluster#port}.
         *
         * @stability stable
         */
        readonly port?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#preferred_availability_zones ElasticacheCluster#preferred_availability_zones}.
         *
         * @stability stable
         */
        readonly preferredAvailabilityZones?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#replication_group_id ElasticacheCluster#replication_group_id}.
         *
         * @stability stable
         */
        readonly replicationGroupId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#security_group_ids ElasticacheCluster#security_group_ids}.
         *
         * @stability stable
         */
        readonly securityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#security_group_names ElasticacheCluster#security_group_names}.
         *
         * @stability stable
         */
        readonly securityGroupNames?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#snapshot_arns ElasticacheCluster#snapshot_arns}.
         *
         * @stability stable
         */
        readonly snapshotArns?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#snapshot_name ElasticacheCluster#snapshot_name}.
         *
         * @stability stable
         */
        readonly snapshotName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#snapshot_retention_limit ElasticacheCluster#snapshot_retention_limit}.
         *
         * @stability stable
         */
        readonly snapshotRetentionLimit?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#snapshot_window ElasticacheCluster#snapshot_window}.
         *
         * @stability stable
         */
        readonly snapshotWindow?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#subnet_group_name ElasticacheCluster#subnet_group_name}.
         *
         * @stability stable
         */
        readonly subnetGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#tags ElasticacheCluster#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html#tags_all ElasticacheCluster#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class ElasticacheClusterCacheNodes extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get address(): string;
        /**
         * @stability stable
         */
        get availabilityZone(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get port(): number;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html aws_elasticache_cluster}.
     *
     * @stability stable
     */
    class ElasticacheCluster extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elasticache_cluster.html aws_elasticache_cluster} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ElasticacheClusterConfig);
        private _applyImmediately?;
        /**
         * @stability stable
         */
        get applyImmediately(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set applyImmediately(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetApplyImmediately(): void;
        /**
         * @stability stable
         */
        get applyImmediatelyInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _availabilityZone?;
        /**
         * @stability stable
         */
        get availabilityZone(): string | undefined;
        /**
         * @stability stable
         */
        set availabilityZone(value: string | undefined);
        /**
         * @stability stable
         */
        resetAvailabilityZone(): void;
        /**
         * @stability stable
         */
        get availabilityZoneInput(): string | undefined;
        private _azMode?;
        /**
         * @stability stable
         */
        get azMode(): string | undefined;
        /**
         * @stability stable
         */
        set azMode(value: string | undefined);
        /**
         * @stability stable
         */
        resetAzMode(): void;
        /**
         * @stability stable
         */
        get azModeInput(): string | undefined;
        /**
         * @stability stable
         */
        cacheNodes(index: string): ElasticacheClusterCacheNodes;
        /**
         * @stability stable
         */
        get clusterAddress(): string;
        private _clusterId?;
        /**
         * @stability stable
         */
        get clusterId(): string;
        /**
         * @stability stable
         */
        set clusterId(value: string);
        /**
         * @stability stable
         */
        get clusterIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get configurationEndpoint(): string;
        private _engine?;
        /**
         * @stability stable
         */
        get engine(): string | undefined;
        /**
         * @stability stable
         */
        set engine(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngine(): void;
        /**
         * @stability stable
         */
        get engineInput(): string | undefined;
        private _engineVersion?;
        /**
         * @stability stable
         */
        get engineVersion(): string | undefined;
        /**
         * @stability stable
         */
        set engineVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngineVersion(): void;
        /**
         * @stability stable
         */
        get engineVersionInput(): string | undefined;
        /**
         * @stability stable
         */
        get engineVersionActual(): string;
        private _finalSnapshotIdentifier?;
        /**
         * @stability stable
         */
        get finalSnapshotIdentifier(): string | undefined;
        /**
         * @stability stable
         */
        set finalSnapshotIdentifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetFinalSnapshotIdentifier(): void;
        /**
         * @stability stable
         */
        get finalSnapshotIdentifierInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _maintenanceWindow?;
        /**
         * @stability stable
         */
        get maintenanceWindow(): string | undefined;
        /**
         * @stability stable
         */
        set maintenanceWindow(value: string | undefined);
        /**
         * @stability stable
         */
        resetMaintenanceWindow(): void;
        /**
         * @stability stable
         */
        get maintenanceWindowInput(): string | undefined;
        private _nodeType?;
        /**
         * @stability stable
         */
        get nodeType(): string | undefined;
        /**
         * @stability stable
         */
        set nodeType(value: string | undefined);
        /**
         * @stability stable
         */
        resetNodeType(): void;
        /**
         * @stability stable
         */
        get nodeTypeInput(): string | undefined;
        private _notificationTopicArn?;
        /**
         * @stability stable
         */
        get notificationTopicArn(): string | undefined;
        /**
         * @stability stable
         */
        set notificationTopicArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetNotificationTopicArn(): void;
        /**
         * @stability stable
         */
        get notificationTopicArnInput(): string | undefined;
        private _numCacheNodes?;
        /**
         * @stability stable
         */
        get numCacheNodes(): number | undefined;
        /**
         * @stability stable
         */
        set numCacheNodes(value: number | undefined);
        /**
         * @stability stable
         */
        resetNumCacheNodes(): void;
        /**
         * @stability stable
         */
        get numCacheNodesInput(): number | undefined;
        private _parameterGroupName?;
        /**
         * @stability stable
         */
        get parameterGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set parameterGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetParameterGroupName(): void;
        /**
         * @stability stable
         */
        get parameterGroupNameInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number | undefined;
        /**
         * @stability stable
         */
        set port(value: number | undefined);
        /**
         * @stability stable
         */
        resetPort(): void;
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
        private _preferredAvailabilityZones?;
        /**
         * @stability stable
         */
        get preferredAvailabilityZones(): string[] | undefined;
        /**
         * @stability stable
         */
        set preferredAvailabilityZones(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetPreferredAvailabilityZones(): void;
        /**
         * @stability stable
         */
        get preferredAvailabilityZonesInput(): string[] | undefined;
        private _replicationGroupId?;
        /**
         * @stability stable
         */
        get replicationGroupId(): string | undefined;
        /**
         * @stability stable
         */
        set replicationGroupId(value: string | undefined);
        /**
         * @stability stable
         */
        resetReplicationGroupId(): void;
        /**
         * @stability stable
         */
        get replicationGroupIdInput(): string | undefined;
        private _securityGroupIds?;
        /**
         * @stability stable
         */
        get securityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set securityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get securityGroupIdsInput(): string[] | undefined;
        private _securityGroupNames?;
        /**
         * @stability stable
         */
        get securityGroupNames(): string[] | undefined;
        /**
         * @stability stable
         */
        set securityGroupNames(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecurityGroupNames(): void;
        /**
         * @stability stable
         */
        get securityGroupNamesInput(): string[] | undefined;
        private _snapshotArns?;
        /**
         * @stability stable
         */
        get snapshotArns(): string[] | undefined;
        /**
         * @stability stable
         */
        set snapshotArns(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSnapshotArns(): void;
        /**
         * @stability stable
         */
        get snapshotArnsInput(): string[] | undefined;
        private _snapshotName?;
        /**
         * @stability stable
         */
        get snapshotName(): string | undefined;
        /**
         * @stability stable
         */
        set snapshotName(value: string | undefined);
        /**
         * @stability stable
         */
        resetSnapshotName(): void;
        /**
         * @stability stable
         */
        get snapshotNameInput(): string | undefined;
        private _snapshotRetentionLimit?;
        /**
         * @stability stable
         */
        get snapshotRetentionLimit(): number | undefined;
        /**
         * @stability stable
         */
        set snapshotRetentionLimit(value: number | undefined);
        /**
         * @stability stable
         */
        resetSnapshotRetentionLimit(): void;
        /**
         * @stability stable
         */
        get snapshotRetentionLimitInput(): number | undefined;
        private _snapshotWindow?;
        /**
         * @stability stable
         */
        get snapshotWindow(): string | undefined;
        /**
         * @stability stable
         */
        set snapshotWindow(value: string | undefined);
        /**
         * @stability stable
         */
        resetSnapshotWindow(): void;
        /**
         * @stability stable
         */
        get snapshotWindowInput(): string | undefined;
        private _subnetGroupName?;
        /**
         * @stability stable
         */
        get subnetGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set subnetGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetSubnetGroupName(): void;
        /**
         * @stability stable
         */
        get subnetGroupNameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ElasticacheGlobalReplicationGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_global_replication_group.html#global_replication_group_description ElasticacheGlobalReplicationGroup#global_replication_group_description}.
         *
         * @stability stable
         */
        readonly globalReplicationGroupDescription?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_global_replication_group.html#global_replication_group_id_suffix ElasticacheGlobalReplicationGroup#global_replication_group_id_suffix}.
         *
         * @stability stable
         */
        readonly globalReplicationGroupIdSuffix: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_global_replication_group.html#primary_replication_group_id ElasticacheGlobalReplicationGroup#primary_replication_group_id}.
         *
         * @stability stable
         */
        readonly primaryReplicationGroupId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elasticache_global_replication_group.html aws_elasticache_global_replication_group}.
     *
     * @stability stable
     */
    class ElasticacheGlobalReplicationGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elasticache_global_replication_group.html aws_elasticache_global_replication_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ElasticacheGlobalReplicationGroupConfig);
        /**
         * @stability stable
         */
        get actualEngineVersion(): string;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get atRestEncryptionEnabled(): any;
        /**
         * @stability stable
         */
        get authTokenEnabled(): any;
        /**
         * @stability stable
         */
        get cacheNodeType(): string;
        /**
         * @stability stable
         */
        get clusterEnabled(): any;
        /**
         * @stability stable
         */
        get engine(): string;
        /**
         * @stability stable
         */
        get engineVersionActual(): string;
        private _globalReplicationGroupDescription?;
        /**
         * @stability stable
         */
        get globalReplicationGroupDescription(): string | undefined;
        /**
         * @stability stable
         */
        set globalReplicationGroupDescription(value: string | undefined);
        /**
         * @stability stable
         */
        resetGlobalReplicationGroupDescription(): void;
        /**
         * @stability stable
         */
        get globalReplicationGroupDescriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get globalReplicationGroupId(): string;
        private _globalReplicationGroupIdSuffix?;
        /**
         * @stability stable
         */
        get globalReplicationGroupIdSuffix(): string;
        /**
         * @stability stable
         */
        set globalReplicationGroupIdSuffix(value: string);
        /**
         * @stability stable
         */
        get globalReplicationGroupIdSuffixInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _primaryReplicationGroupId?;
        /**
         * @stability stable
         */
        get primaryReplicationGroupId(): string;
        /**
         * @stability stable
         */
        set primaryReplicationGroupId(value: string);
        /**
         * @stability stable
         */
        get primaryReplicationGroupIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get transitEncryptionEnabled(): any;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ElasticacheParameterGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_parameter_group.html#description ElasticacheParameterGroup#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_parameter_group.html#family ElasticacheParameterGroup#family}.
         *
         * @stability stable
         */
        readonly family: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_parameter_group.html#name ElasticacheParameterGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_parameter_group.html#tags ElasticacheParameterGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_parameter_group.html#tags_all ElasticacheParameterGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * parameter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_parameter_group.html#parameter ElasticacheParameterGroup#parameter}
         *
         * @stability stable
         */
        readonly parameter?: ElasticacheParameterGroupParameter[];
    }
    /**
     * @stability stable
     */
    interface ElasticacheParameterGroupParameter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_parameter_group.html#name ElasticacheParameterGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_parameter_group.html#value ElasticacheParameterGroup#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elasticache_parameter_group.html aws_elasticache_parameter_group}.
     *
     * @stability stable
     */
    class ElasticacheParameterGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elasticache_parameter_group.html aws_elasticache_parameter_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ElasticacheParameterGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _family?;
        /**
         * @stability stable
         */
        get family(): string;
        /**
         * @stability stable
         */
        set family(value: string);
        /**
         * @stability stable
         */
        get familyInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _parameter?;
        /**
         * @stability stable
         */
        get parameter(): ElasticacheParameterGroupParameter[] | undefined;
        /**
         * @stability stable
         */
        set parameter(value: ElasticacheParameterGroupParameter[] | undefined);
        /**
         * @stability stable
         */
        resetParameter(): void;
        /**
         * @stability stable
         */
        get parameterInput(): ElasticacheParameterGroupParameter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ElasticacheReplicationGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#apply_immediately ElasticacheReplicationGroup#apply_immediately}.
         *
         * @stability stable
         */
        readonly applyImmediately?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#at_rest_encryption_enabled ElasticacheReplicationGroup#at_rest_encryption_enabled}.
         *
         * @stability stable
         */
        readonly atRestEncryptionEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#auth_token ElasticacheReplicationGroup#auth_token}.
         *
         * @stability stable
         */
        readonly authToken?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#auto_minor_version_upgrade ElasticacheReplicationGroup#auto_minor_version_upgrade}.
         *
         * @stability stable
         */
        readonly autoMinorVersionUpgrade?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#automatic_failover_enabled ElasticacheReplicationGroup#automatic_failover_enabled}.
         *
         * @stability stable
         */
        readonly automaticFailoverEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#availability_zones ElasticacheReplicationGroup#availability_zones}.
         *
         * @stability stable
         */
        readonly availabilityZones?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#engine ElasticacheReplicationGroup#engine}.
         *
         * @stability stable
         */
        readonly engine?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#engine_version ElasticacheReplicationGroup#engine_version}.
         *
         * @stability stable
         */
        readonly engineVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#final_snapshot_identifier ElasticacheReplicationGroup#final_snapshot_identifier}.
         *
         * @stability stable
         */
        readonly finalSnapshotIdentifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#global_replication_group_id ElasticacheReplicationGroup#global_replication_group_id}.
         *
         * @stability stable
         */
        readonly globalReplicationGroupId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#kms_key_id ElasticacheReplicationGroup#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#maintenance_window ElasticacheReplicationGroup#maintenance_window}.
         *
         * @stability stable
         */
        readonly maintenanceWindow?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#multi_az_enabled ElasticacheReplicationGroup#multi_az_enabled}.
         *
         * @stability stable
         */
        readonly multiAzEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#node_type ElasticacheReplicationGroup#node_type}.
         *
         * @stability stable
         */
        readonly nodeType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#notification_topic_arn ElasticacheReplicationGroup#notification_topic_arn}.
         *
         * @stability stable
         */
        readonly notificationTopicArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#number_cache_clusters ElasticacheReplicationGroup#number_cache_clusters}.
         *
         * @stability stable
         */
        readonly numberCacheClusters?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#parameter_group_name ElasticacheReplicationGroup#parameter_group_name}.
         *
         * @stability stable
         */
        readonly parameterGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#port ElasticacheReplicationGroup#port}.
         *
         * @stability stable
         */
        readonly port?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#replication_group_description ElasticacheReplicationGroup#replication_group_description}.
         *
         * @stability stable
         */
        readonly replicationGroupDescription: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#replication_group_id ElasticacheReplicationGroup#replication_group_id}.
         *
         * @stability stable
         */
        readonly replicationGroupId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#security_group_ids ElasticacheReplicationGroup#security_group_ids}.
         *
         * @stability stable
         */
        readonly securityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#security_group_names ElasticacheReplicationGroup#security_group_names}.
         *
         * @stability stable
         */
        readonly securityGroupNames?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#snapshot_arns ElasticacheReplicationGroup#snapshot_arns}.
         *
         * @stability stable
         */
        readonly snapshotArns?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#snapshot_name ElasticacheReplicationGroup#snapshot_name}.
         *
         * @stability stable
         */
        readonly snapshotName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#snapshot_retention_limit ElasticacheReplicationGroup#snapshot_retention_limit}.
         *
         * @stability stable
         */
        readonly snapshotRetentionLimit?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#snapshot_window ElasticacheReplicationGroup#snapshot_window}.
         *
         * @stability stable
         */
        readonly snapshotWindow?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#subnet_group_name ElasticacheReplicationGroup#subnet_group_name}.
         *
         * @stability stable
         */
        readonly subnetGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#tags ElasticacheReplicationGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#tags_all ElasticacheReplicationGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#transit_encryption_enabled ElasticacheReplicationGroup#transit_encryption_enabled}.
         *
         * @stability stable
         */
        readonly transitEncryptionEnabled?: boolean | cdktf.IResolvable;
        /**
         * cluster_mode block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#cluster_mode ElasticacheReplicationGroup#cluster_mode}
         *
         * @stability stable
         */
        readonly clusterMode?: ElasticacheReplicationGroupClusterMode;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#timeouts ElasticacheReplicationGroup#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: ElasticacheReplicationGroupTimeouts;
    }
    /**
     * @stability stable
     */
    interface ElasticacheReplicationGroupClusterMode {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#num_node_groups ElasticacheReplicationGroup#num_node_groups}.
         *
         * @stability stable
         */
        readonly numNodeGroups?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#replicas_per_node_group ElasticacheReplicationGroup#replicas_per_node_group}.
         *
         * @stability stable
         */
        readonly replicasPerNodeGroup: number;
    }
    /**
     * @stability stable
     */
    class ElasticacheReplicationGroupClusterModeOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _numNodeGroups?;
        /**
         * @stability stable
         */
        get numNodeGroups(): number | undefined;
        /**
         * @stability stable
         */
        set numNodeGroups(value: number | undefined);
        /**
         * @stability stable
         */
        resetNumNodeGroups(): void;
        /**
         * @stability stable
         */
        get numNodeGroupsInput(): number | undefined;
        private _replicasPerNodeGroup?;
        /**
         * @stability stable
         */
        get replicasPerNodeGroup(): number;
        /**
         * @stability stable
         */
        set replicasPerNodeGroup(value: number);
        /**
         * @stability stable
         */
        get replicasPerNodeGroupInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface ElasticacheReplicationGroupTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#create ElasticacheReplicationGroup#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#delete ElasticacheReplicationGroup#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html#update ElasticacheReplicationGroup#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class ElasticacheReplicationGroupTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html aws_elasticache_replication_group}.
     *
     * @stability stable
     */
    class ElasticacheReplicationGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group.html aws_elasticache_replication_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ElasticacheReplicationGroupConfig);
        private _applyImmediately?;
        /**
         * @stability stable
         */
        get applyImmediately(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set applyImmediately(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetApplyImmediately(): void;
        /**
         * @stability stable
         */
        get applyImmediatelyInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _atRestEncryptionEnabled?;
        /**
         * @stability stable
         */
        get atRestEncryptionEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set atRestEncryptionEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAtRestEncryptionEnabled(): void;
        /**
         * @stability stable
         */
        get atRestEncryptionEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _authToken?;
        /**
         * @stability stable
         */
        get authToken(): string | undefined;
        /**
         * @stability stable
         */
        set authToken(value: string | undefined);
        /**
         * @stability stable
         */
        resetAuthToken(): void;
        /**
         * @stability stable
         */
        get authTokenInput(): string | undefined;
        private _autoMinorVersionUpgrade?;
        /**
         * @stability stable
         */
        get autoMinorVersionUpgrade(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoMinorVersionUpgrade(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoMinorVersionUpgrade(): void;
        /**
         * @stability stable
         */
        get autoMinorVersionUpgradeInput(): boolean | cdktf.IResolvable | undefined;
        private _automaticFailoverEnabled?;
        /**
         * @stability stable
         */
        get automaticFailoverEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set automaticFailoverEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutomaticFailoverEnabled(): void;
        /**
         * @stability stable
         */
        get automaticFailoverEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _availabilityZones?;
        /**
         * @stability stable
         */
        get availabilityZones(): string[] | undefined;
        /**
         * @stability stable
         */
        set availabilityZones(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetAvailabilityZones(): void;
        /**
         * @stability stable
         */
        get availabilityZonesInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get clusterEnabled(): any;
        /**
         * @stability stable
         */
        get configurationEndpointAddress(): string;
        private _engine?;
        /**
         * @stability stable
         */
        get engine(): string | undefined;
        /**
         * @stability stable
         */
        set engine(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngine(): void;
        /**
         * @stability stable
         */
        get engineInput(): string | undefined;
        private _engineVersion?;
        /**
         * @stability stable
         */
        get engineVersion(): string | undefined;
        /**
         * @stability stable
         */
        set engineVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngineVersion(): void;
        /**
         * @stability stable
         */
        get engineVersionInput(): string | undefined;
        /**
         * @stability stable
         */
        get engineVersionActual(): string;
        private _finalSnapshotIdentifier?;
        /**
         * @stability stable
         */
        get finalSnapshotIdentifier(): string | undefined;
        /**
         * @stability stable
         */
        set finalSnapshotIdentifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetFinalSnapshotIdentifier(): void;
        /**
         * @stability stable
         */
        get finalSnapshotIdentifierInput(): string | undefined;
        private _globalReplicationGroupId?;
        /**
         * @stability stable
         */
        get globalReplicationGroupId(): string | undefined;
        /**
         * @stability stable
         */
        set globalReplicationGroupId(value: string | undefined);
        /**
         * @stability stable
         */
        resetGlobalReplicationGroupId(): void;
        /**
         * @stability stable
         */
        get globalReplicationGroupIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        private _maintenanceWindow?;
        /**
         * @stability stable
         */
        get maintenanceWindow(): string | undefined;
        /**
         * @stability stable
         */
        set maintenanceWindow(value: string | undefined);
        /**
         * @stability stable
         */
        resetMaintenanceWindow(): void;
        /**
         * @stability stable
         */
        get maintenanceWindowInput(): string | undefined;
        /**
         * @stability stable
         */
        get memberClusters(): string[];
        private _multiAzEnabled?;
        /**
         * @stability stable
         */
        get multiAzEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set multiAzEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetMultiAzEnabled(): void;
        /**
         * @stability stable
         */
        get multiAzEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _nodeType?;
        /**
         * @stability stable
         */
        get nodeType(): string | undefined;
        /**
         * @stability stable
         */
        set nodeType(value: string | undefined);
        /**
         * @stability stable
         */
        resetNodeType(): void;
        /**
         * @stability stable
         */
        get nodeTypeInput(): string | undefined;
        private _notificationTopicArn?;
        /**
         * @stability stable
         */
        get notificationTopicArn(): string | undefined;
        /**
         * @stability stable
         */
        set notificationTopicArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetNotificationTopicArn(): void;
        /**
         * @stability stable
         */
        get notificationTopicArnInput(): string | undefined;
        private _numberCacheClusters?;
        /**
         * @stability stable
         */
        get numberCacheClusters(): number | undefined;
        /**
         * @stability stable
         */
        set numberCacheClusters(value: number | undefined);
        /**
         * @stability stable
         */
        resetNumberCacheClusters(): void;
        /**
         * @stability stable
         */
        get numberCacheClustersInput(): number | undefined;
        private _parameterGroupName?;
        /**
         * @stability stable
         */
        get parameterGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set parameterGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetParameterGroupName(): void;
        /**
         * @stability stable
         */
        get parameterGroupNameInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number | undefined;
        /**
         * @stability stable
         */
        set port(value: number | undefined);
        /**
         * @stability stable
         */
        resetPort(): void;
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
        /**
         * @stability stable
         */
        get primaryEndpointAddress(): string;
        /**
         * @stability stable
         */
        get readerEndpointAddress(): string;
        private _replicationGroupDescription?;
        /**
         * @stability stable
         */
        get replicationGroupDescription(): string;
        /**
         * @stability stable
         */
        set replicationGroupDescription(value: string);
        /**
         * @stability stable
         */
        get replicationGroupDescriptionInput(): string | undefined;
        private _replicationGroupId?;
        /**
         * @stability stable
         */
        get replicationGroupId(): string;
        /**
         * @stability stable
         */
        set replicationGroupId(value: string);
        /**
         * @stability stable
         */
        get replicationGroupIdInput(): string | undefined;
        private _securityGroupIds?;
        /**
         * @stability stable
         */
        get securityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set securityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get securityGroupIdsInput(): string[] | undefined;
        private _securityGroupNames?;
        /**
         * @stability stable
         */
        get securityGroupNames(): string[] | undefined;
        /**
         * @stability stable
         */
        set securityGroupNames(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecurityGroupNames(): void;
        /**
         * @stability stable
         */
        get securityGroupNamesInput(): string[] | undefined;
        private _snapshotArns?;
        /**
         * @stability stable
         */
        get snapshotArns(): string[] | undefined;
        /**
         * @stability stable
         */
        set snapshotArns(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSnapshotArns(): void;
        /**
         * @stability stable
         */
        get snapshotArnsInput(): string[] | undefined;
        private _snapshotName?;
        /**
         * @stability stable
         */
        get snapshotName(): string | undefined;
        /**
         * @stability stable
         */
        set snapshotName(value: string | undefined);
        /**
         * @stability stable
         */
        resetSnapshotName(): void;
        /**
         * @stability stable
         */
        get snapshotNameInput(): string | undefined;
        private _snapshotRetentionLimit?;
        /**
         * @stability stable
         */
        get snapshotRetentionLimit(): number | undefined;
        /**
         * @stability stable
         */
        set snapshotRetentionLimit(value: number | undefined);
        /**
         * @stability stable
         */
        resetSnapshotRetentionLimit(): void;
        /**
         * @stability stable
         */
        get snapshotRetentionLimitInput(): number | undefined;
        private _snapshotWindow?;
        /**
         * @stability stable
         */
        get snapshotWindow(): string | undefined;
        /**
         * @stability stable
         */
        set snapshotWindow(value: string | undefined);
        /**
         * @stability stable
         */
        resetSnapshotWindow(): void;
        /**
         * @stability stable
         */
        get snapshotWindowInput(): string | undefined;
        private _subnetGroupName?;
        /**
         * @stability stable
         */
        get subnetGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set subnetGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetSubnetGroupName(): void;
        /**
         * @stability stable
         */
        get subnetGroupNameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _transitEncryptionEnabled?;
        /**
         * @stability stable
         */
        get transitEncryptionEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set transitEncryptionEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTransitEncryptionEnabled(): void;
        /**
         * @stability stable
         */
        get transitEncryptionEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _clusterMode?;
        private __clusterModeOutput;
        /**
         * @stability stable
         */
        get clusterMode(): ElasticacheReplicationGroupClusterModeOutputReference;
        /**
         * @stability stable
         */
        putClusterMode(value: ElasticacheReplicationGroupClusterMode | undefined): void;
        /**
         * @stability stable
         */
        resetClusterMode(): void;
        /**
         * @stability stable
         */
        get clusterModeInput(): ElasticacheReplicationGroupClusterMode | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): ElasticacheReplicationGroupTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: ElasticacheReplicationGroupTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): ElasticacheReplicationGroupTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ElasticacheSecurityGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_security_group.html#description ElasticacheSecurityGroup#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_security_group.html#name ElasticacheSecurityGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_security_group.html#security_group_names ElasticacheSecurityGroup#security_group_names}.
         *
         * @stability stable
         */
        readonly securityGroupNames: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elasticache_security_group.html aws_elasticache_security_group}.
     *
     * @stability stable
     */
    class ElasticacheSecurityGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elasticache_security_group.html aws_elasticache_security_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ElasticacheSecurityGroupConfig);
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _securityGroupNames?;
        /**
         * @stability stable
         */
        get securityGroupNames(): string[];
        /**
         * @stability stable
         */
        set securityGroupNames(value: string[]);
        /**
         * @stability stable
         */
        get securityGroupNamesInput(): string[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ElasticacheSubnetGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_subnet_group.html#description ElasticacheSubnetGroup#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_subnet_group.html#name ElasticacheSubnetGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_subnet_group.html#subnet_ids ElasticacheSubnetGroup#subnet_ids}.
         *
         * @stability stable
         */
        readonly subnetIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_subnet_group.html#tags ElasticacheSubnetGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_subnet_group.html#tags_all ElasticacheSubnetGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elasticache_subnet_group.html aws_elasticache_subnet_group}.
     *
     * @stability stable
     */
    class ElasticacheSubnetGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elasticache_subnet_group.html aws_elasticache_subnet_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ElasticacheSubnetGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _subnetIds?;
        /**
         * @stability stable
         */
        get subnetIds(): string[];
        /**
         * @stability stable
         */
        set subnetIds(value: string[]);
        /**
         * @stability stable
         */
        get subnetIdsInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ElasticacheUserConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user.html#access_string ElasticacheUser#access_string}.
         *
         * @stability stable
         */
        readonly accessString: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user.html#engine ElasticacheUser#engine}.
         *
         * @stability stable
         */
        readonly engine: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user.html#no_password_required ElasticacheUser#no_password_required}.
         *
         * @stability stable
         */
        readonly noPasswordRequired?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user.html#passwords ElasticacheUser#passwords}.
         *
         * @stability stable
         */
        readonly passwords?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user.html#tags ElasticacheUser#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user.html#tags_all ElasticacheUser#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user.html#user_id ElasticacheUser#user_id}.
         *
         * @stability stable
         */
        readonly userId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user.html#user_name ElasticacheUser#user_name}.
         *
         * @stability stable
         */
        readonly userName: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user.html aws_elasticache_user}.
     *
     * @stability stable
     */
    class ElasticacheUser extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user.html aws_elasticache_user} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ElasticacheUserConfig);
        private _accessString?;
        /**
         * @stability stable
         */
        get accessString(): string;
        /**
         * @stability stable
         */
        set accessString(value: string);
        /**
         * @stability stable
         */
        get accessStringInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _engine?;
        /**
         * @stability stable
         */
        get engine(): string;
        /**
         * @stability stable
         */
        set engine(value: string);
        /**
         * @stability stable
         */
        get engineInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _noPasswordRequired?;
        /**
         * @stability stable
         */
        get noPasswordRequired(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set noPasswordRequired(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetNoPasswordRequired(): void;
        /**
         * @stability stable
         */
        get noPasswordRequiredInput(): boolean | cdktf.IResolvable | undefined;
        private _passwords?;
        /**
         * @stability stable
         */
        get passwords(): string[] | undefined;
        /**
         * @stability stable
         */
        set passwords(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetPasswords(): void;
        /**
         * @stability stable
         */
        get passwordsInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _userId?;
        /**
         * @stability stable
         */
        get userId(): string;
        /**
         * @stability stable
         */
        set userId(value: string);
        /**
         * @stability stable
         */
        get userIdInput(): string | undefined;
        private _userName?;
        /**
         * @stability stable
         */
        get userName(): string;
        /**
         * @stability stable
         */
        set userName(value: string);
        /**
         * @stability stable
         */
        get userNameInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ElasticacheUserGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user_group.html#engine ElasticacheUserGroup#engine}.
         *
         * @stability stable
         */
        readonly engine: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user_group.html#tags ElasticacheUserGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user_group.html#tags_all ElasticacheUserGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user_group.html#user_group_id ElasticacheUserGroup#user_group_id}.
         *
         * @stability stable
         */
        readonly userGroupId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user_group.html#user_ids ElasticacheUserGroup#user_ids}.
         *
         * @stability stable
         */
        readonly userIds?: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user_group.html aws_elasticache_user_group}.
     *
     * @stability stable
     */
    class ElasticacheUserGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elasticache_user_group.html aws_elasticache_user_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ElasticacheUserGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _engine?;
        /**
         * @stability stable
         */
        get engine(): string;
        /**
         * @stability stable
         */
        set engine(value: string);
        /**
         * @stability stable
         */
        get engineInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _userGroupId?;
        /**
         * @stability stable
         */
        get userGroupId(): string;
        /**
         * @stability stable
         */
        set userGroupId(value: string);
        /**
         * @stability stable
         */
        get userGroupIdInput(): string | undefined;
        private _userIds?;
        /**
         * @stability stable
         */
        get userIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set userIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetUserIds(): void;
        /**
         * @stability stable
         */
        get userIdsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsElasticacheClusterConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/elasticache_cluster.html#cluster_id DataAwsElasticacheCluster#cluster_id}.
         *
         * @stability stable
         */
        readonly clusterId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/elasticache_cluster.html#tags DataAwsElasticacheCluster#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class DataAwsElasticacheClusterCacheNodes extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get address(): string;
        /**
         * @stability stable
         */
        get availabilityZone(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get port(): number;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/elasticache_cluster.html aws_elasticache_cluster}.
     *
     * @stability stable
     */
    class DataAwsElasticacheCluster extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/elasticache_cluster.html aws_elasticache_cluster} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsElasticacheClusterConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get availabilityZone(): string;
        /**
         * @stability stable
         */
        cacheNodes(index: string): DataAwsElasticacheClusterCacheNodes;
        /**
         * @stability stable
         */
        get clusterAddress(): string;
        private _clusterId?;
        /**
         * @stability stable
         */
        get clusterId(): string;
        /**
         * @stability stable
         */
        set clusterId(value: string);
        /**
         * @stability stable
         */
        get clusterIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get configurationEndpoint(): string;
        /**
         * @stability stable
         */
        get engine(): string;
        /**
         * @stability stable
         */
        get engineVersion(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get maintenanceWindow(): string;
        /**
         * @stability stable
         */
        get nodeType(): string;
        /**
         * @stability stable
         */
        get notificationTopicArn(): string;
        /**
         * @stability stable
         */
        get numCacheNodes(): number;
        /**
         * @stability stable
         */
        get parameterGroupName(): string;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        get replicationGroupId(): string;
        /**
         * @stability stable
         */
        get securityGroupIds(): string[];
        /**
         * @stability stable
         */
        get securityGroupNames(): string[];
        /**
         * @stability stable
         */
        get snapshotRetentionLimit(): number;
        /**
         * @stability stable
         */
        get snapshotWindow(): string;
        /**
         * @stability stable
         */
        get subnetGroupName(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsElasticacheReplicationGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/elasticache_replication_group.html#replication_group_id DataAwsElasticacheReplicationGroup#replication_group_id}.
         *
         * @stability stable
         */
        readonly replicationGroupId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/elasticache_replication_group.html aws_elasticache_replication_group}.
     *
     * @stability stable
     */
    class DataAwsElasticacheReplicationGroup extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/elasticache_replication_group.html aws_elasticache_replication_group} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsElasticacheReplicationGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get authTokenEnabled(): any;
        /**
         * @stability stable
         */
        get automaticFailoverEnabled(): any;
        /**
         * @stability stable
         */
        get configurationEndpointAddress(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get memberClusters(): string[];
        /**
         * @stability stable
         */
        get multiAzEnabled(): any;
        /**
         * @stability stable
         */
        get nodeType(): string;
        /**
         * @stability stable
         */
        get numberCacheClusters(): number;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        get primaryEndpointAddress(): string;
        /**
         * @stability stable
         */
        get readerEndpointAddress(): string;
        /**
         * @stability stable
         */
        get replicationGroupDescription(): string;
        private _replicationGroupId?;
        /**
         * @stability stable
         */
        get replicationGroupId(): string;
        /**
         * @stability stable
         */
        set replicationGroupId(value: string);
        /**
         * @stability stable
         */
        get replicationGroupIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get snapshotRetentionLimit(): number;
        /**
         * @stability stable
         */
        get snapshotWindow(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsElasticacheUserConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/elasticache_user.html#access_string DataAwsElasticacheUser#access_string}.
         *
         * @stability stable
         */
        readonly accessString?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/elasticache_user.html#engine DataAwsElasticacheUser#engine}.
         *
         * @stability stable
         */
        readonly engine?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/elasticache_user.html#no_password_required DataAwsElasticacheUser#no_password_required}.
         *
         * @stability stable
         */
        readonly noPasswordRequired?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/elasticache_user.html#passwords DataAwsElasticacheUser#passwords}.
         *
         * @stability stable
         */
        readonly passwords?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/elasticache_user.html#user_id DataAwsElasticacheUser#user_id}.
         *
         * @stability stable
         */
        readonly userId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/elasticache_user.html#user_name DataAwsElasticacheUser#user_name}.
         *
         * @stability stable
         */
        readonly userName?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/elasticache_user.html aws_elasticache_user}.
     *
     * @stability stable
     */
    class DataAwsElasticacheUser extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/elasticache_user.html aws_elasticache_user} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsElasticacheUserConfig);
        private _accessString?;
        /**
         * @stability stable
         */
        get accessString(): string | undefined;
        /**
         * @stability stable
         */
        set accessString(value: string | undefined);
        /**
         * @stability stable
         */
        resetAccessString(): void;
        /**
         * @stability stable
         */
        get accessStringInput(): string | undefined;
        private _engine?;
        /**
         * @stability stable
         */
        get engine(): string | undefined;
        /**
         * @stability stable
         */
        set engine(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngine(): void;
        /**
         * @stability stable
         */
        get engineInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _noPasswordRequired?;
        /**
         * @stability stable
         */
        get noPasswordRequired(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set noPasswordRequired(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetNoPasswordRequired(): void;
        /**
         * @stability stable
         */
        get noPasswordRequiredInput(): boolean | cdktf.IResolvable | undefined;
        private _passwords?;
        /**
         * @stability stable
         */
        get passwords(): string[] | undefined;
        /**
         * @stability stable
         */
        set passwords(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetPasswords(): void;
        /**
         * @stability stable
         */
        get passwordsInput(): string[] | undefined;
        private _userId?;
        /**
         * @stability stable
         */
        get userId(): string;
        /**
         * @stability stable
         */
        set userId(value: string);
        /**
         * @stability stable
         */
        get userIdInput(): string | undefined;
        private _userName?;
        /**
         * @stability stable
         */
        get userName(): string | undefined;
        /**
         * @stability stable
         */
        set userName(value: string | undefined);
        /**
         * @stability stable
         */
        resetUserName(): void;
        /**
         * @stability stable
         */
        get userNameInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
