import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Elastic Beanstalk
*/
export declare namespace ElasticBeanstalk {
    /**
     * @stability stable
     */
    interface ElasticBeanstalkApplicationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application.html#description ElasticBeanstalkApplication#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application.html#name ElasticBeanstalkApplication#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application.html#tags ElasticBeanstalkApplication#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application.html#tags_all ElasticBeanstalkApplication#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * appversion_lifecycle block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application.html#appversion_lifecycle ElasticBeanstalkApplication#appversion_lifecycle}
         *
         * @stability stable
         */
        readonly appversionLifecycle?: ElasticBeanstalkApplicationAppversionLifecycle;
    }
    /**
     * @stability stable
     */
    interface ElasticBeanstalkApplicationAppversionLifecycle {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application.html#delete_source_from_s3 ElasticBeanstalkApplication#delete_source_from_s3}.
         *
         * @stability stable
         */
        readonly deleteSourceFromS3?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application.html#max_age_in_days ElasticBeanstalkApplication#max_age_in_days}.
         *
         * @stability stable
         */
        readonly maxAgeInDays?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application.html#max_count ElasticBeanstalkApplication#max_count}.
         *
         * @stability stable
         */
        readonly maxCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application.html#service_role ElasticBeanstalkApplication#service_role}.
         *
         * @stability stable
         */
        readonly serviceRole: string;
    }
    /**
     * @stability stable
     */
    class ElasticBeanstalkApplicationAppversionLifecycleOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _deleteSourceFromS3?;
        /**
         * @stability stable
         */
        get deleteSourceFromS3(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set deleteSourceFromS3(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDeleteSourceFromS3(): void;
        /**
         * @stability stable
         */
        get deleteSourceFromS3Input(): boolean | cdktf.IResolvable | undefined;
        private _maxAgeInDays?;
        /**
         * @stability stable
         */
        get maxAgeInDays(): number | undefined;
        /**
         * @stability stable
         */
        set maxAgeInDays(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaxAgeInDays(): void;
        /**
         * @stability stable
         */
        get maxAgeInDaysInput(): number | undefined;
        private _maxCount?;
        /**
         * @stability stable
         */
        get maxCount(): number | undefined;
        /**
         * @stability stable
         */
        set maxCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaxCount(): void;
        /**
         * @stability stable
         */
        get maxCountInput(): number | undefined;
        private _serviceRole?;
        /**
         * @stability stable
         */
        get serviceRole(): string;
        /**
         * @stability stable
         */
        set serviceRole(value: string);
        /**
         * @stability stable
         */
        get serviceRoleInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application.html aws_elastic_beanstalk_application}.
     *
     * @stability stable
     */
    class ElasticBeanstalkApplication extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application.html aws_elastic_beanstalk_application} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ElasticBeanstalkApplicationConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _appversionLifecycle?;
        private __appversionLifecycleOutput;
        /**
         * @stability stable
         */
        get appversionLifecycle(): ElasticBeanstalkApplicationAppversionLifecycleOutputReference;
        /**
         * @stability stable
         */
        putAppversionLifecycle(value: ElasticBeanstalkApplicationAppversionLifecycle | undefined): void;
        /**
         * @stability stable
         */
        resetAppversionLifecycle(): void;
        /**
         * @stability stable
         */
        get appversionLifecycleInput(): ElasticBeanstalkApplicationAppversionLifecycle | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ElasticBeanstalkApplicationVersionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application_version.html#application ElasticBeanstalkApplicationVersion#application}.
         *
         * @stability stable
         */
        readonly application: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application_version.html#bucket ElasticBeanstalkApplicationVersion#bucket}.
         *
         * @stability stable
         */
        readonly bucket: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application_version.html#description ElasticBeanstalkApplicationVersion#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application_version.html#force_delete ElasticBeanstalkApplicationVersion#force_delete}.
         *
         * @stability stable
         */
        readonly forceDelete?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application_version.html#key ElasticBeanstalkApplicationVersion#key}.
         *
         * @stability stable
         */
        readonly key: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application_version.html#name ElasticBeanstalkApplicationVersion#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application_version.html#tags ElasticBeanstalkApplicationVersion#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application_version.html#tags_all ElasticBeanstalkApplicationVersion#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application_version.html aws_elastic_beanstalk_application_version}.
     *
     * @stability stable
     */
    class ElasticBeanstalkApplicationVersion extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_application_version.html aws_elastic_beanstalk_application_version} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ElasticBeanstalkApplicationVersionConfig);
        private _application?;
        /**
         * @stability stable
         */
        get application(): string;
        /**
         * @stability stable
         */
        set application(value: string);
        /**
         * @stability stable
         */
        get applicationInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _bucket?;
        /**
         * @stability stable
         */
        get bucket(): string;
        /**
         * @stability stable
         */
        set bucket(value: string);
        /**
         * @stability stable
         */
        get bucketInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _forceDelete?;
        /**
         * @stability stable
         */
        get forceDelete(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set forceDelete(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetForceDelete(): void;
        /**
         * @stability stable
         */
        get forceDeleteInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _key?;
        /**
         * @stability stable
         */
        get key(): string;
        /**
         * @stability stable
         */
        set key(value: string);
        /**
         * @stability stable
         */
        get keyInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ElasticBeanstalkConfigurationTemplateConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_configuration_template.html#application ElasticBeanstalkConfigurationTemplate#application}.
         *
         * @stability stable
         */
        readonly application: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_configuration_template.html#description ElasticBeanstalkConfigurationTemplate#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_configuration_template.html#environment_id ElasticBeanstalkConfigurationTemplate#environment_id}.
         *
         * @stability stable
         */
        readonly environmentId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_configuration_template.html#name ElasticBeanstalkConfigurationTemplate#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_configuration_template.html#solution_stack_name ElasticBeanstalkConfigurationTemplate#solution_stack_name}.
         *
         * @stability stable
         */
        readonly solutionStackName?: string;
        /**
         * setting block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_configuration_template.html#setting ElasticBeanstalkConfigurationTemplate#setting}
         *
         * @stability stable
         */
        readonly setting?: ElasticBeanstalkConfigurationTemplateSetting[];
    }
    /**
     * @stability stable
     */
    interface ElasticBeanstalkConfigurationTemplateSetting {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_configuration_template.html#name ElasticBeanstalkConfigurationTemplate#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_configuration_template.html#namespace ElasticBeanstalkConfigurationTemplate#namespace}.
         *
         * @stability stable
         */
        readonly namespace: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_configuration_template.html#resource ElasticBeanstalkConfigurationTemplate#resource}.
         *
         * @stability stable
         */
        readonly resource?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_configuration_template.html#value ElasticBeanstalkConfigurationTemplate#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_configuration_template.html aws_elastic_beanstalk_configuration_template}.
     *
     * @stability stable
     */
    class ElasticBeanstalkConfigurationTemplate extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_configuration_template.html aws_elastic_beanstalk_configuration_template} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ElasticBeanstalkConfigurationTemplateConfig);
        private _application?;
        /**
         * @stability stable
         */
        get application(): string;
        /**
         * @stability stable
         */
        set application(value: string);
        /**
         * @stability stable
         */
        get applicationInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _environmentId?;
        /**
         * @stability stable
         */
        get environmentId(): string | undefined;
        /**
         * @stability stable
         */
        set environmentId(value: string | undefined);
        /**
         * @stability stable
         */
        resetEnvironmentId(): void;
        /**
         * @stability stable
         */
        get environmentIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _solutionStackName?;
        /**
         * @stability stable
         */
        get solutionStackName(): string | undefined;
        /**
         * @stability stable
         */
        set solutionStackName(value: string | undefined);
        /**
         * @stability stable
         */
        resetSolutionStackName(): void;
        /**
         * @stability stable
         */
        get solutionStackNameInput(): string | undefined;
        private _setting?;
        /**
         * @stability stable
         */
        get setting(): ElasticBeanstalkConfigurationTemplateSetting[] | undefined;
        /**
         * @stability stable
         */
        set setting(value: ElasticBeanstalkConfigurationTemplateSetting[] | undefined);
        /**
         * @stability stable
         */
        resetSetting(): void;
        /**
         * @stability stable
         */
        get settingInput(): ElasticBeanstalkConfigurationTemplateSetting[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ElasticBeanstalkEnvironmentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#application ElasticBeanstalkEnvironment#application}.
         *
         * @stability stable
         */
        readonly application: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#cname_prefix ElasticBeanstalkEnvironment#cname_prefix}.
         *
         * @stability stable
         */
        readonly cnamePrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#description ElasticBeanstalkEnvironment#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#name ElasticBeanstalkEnvironment#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#platform_arn ElasticBeanstalkEnvironment#platform_arn}.
         *
         * @stability stable
         */
        readonly platformArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#poll_interval ElasticBeanstalkEnvironment#poll_interval}.
         *
         * @stability stable
         */
        readonly pollInterval?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#solution_stack_name ElasticBeanstalkEnvironment#solution_stack_name}.
         *
         * @stability stable
         */
        readonly solutionStackName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#tags ElasticBeanstalkEnvironment#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#tags_all ElasticBeanstalkEnvironment#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#template_name ElasticBeanstalkEnvironment#template_name}.
         *
         * @stability stable
         */
        readonly templateName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#tier ElasticBeanstalkEnvironment#tier}.
         *
         * @stability stable
         */
        readonly tier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#version_label ElasticBeanstalkEnvironment#version_label}.
         *
         * @stability stable
         */
        readonly versionLabel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#wait_for_ready_timeout ElasticBeanstalkEnvironment#wait_for_ready_timeout}.
         *
         * @stability stable
         */
        readonly waitForReadyTimeout?: string;
        /**
         * setting block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#setting ElasticBeanstalkEnvironment#setting}
         *
         * @stability stable
         */
        readonly setting?: ElasticBeanstalkEnvironmentSetting[];
    }
    /**
     * @stability stable
     */
    class ElasticBeanstalkEnvironmentAllSettings extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        get namespace(): string;
        /**
         * @stability stable
         */
        get resource(): string;
        /**
         * @stability stable
         */
        get value(): string;
    }
    /**
     * @stability stable
     */
    interface ElasticBeanstalkEnvironmentSetting {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#name ElasticBeanstalkEnvironment#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#namespace ElasticBeanstalkEnvironment#namespace}.
         *
         * @stability stable
         */
        readonly namespace: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#resource ElasticBeanstalkEnvironment#resource}.
         *
         * @stability stable
         */
        readonly resource?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html#value ElasticBeanstalkEnvironment#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html aws_elastic_beanstalk_environment}.
     *
     * @stability stable
     */
    class ElasticBeanstalkEnvironment extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment.html aws_elastic_beanstalk_environment} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ElasticBeanstalkEnvironmentConfig);
        /**
         * @stability stable
         */
        allSettings(index: string): ElasticBeanstalkEnvironmentAllSettings;
        private _application?;
        /**
         * @stability stable
         */
        get application(): string;
        /**
         * @stability stable
         */
        set application(value: string);
        /**
         * @stability stable
         */
        get applicationInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get autoscalingGroups(): string[];
        /**
         * @stability stable
         */
        get cname(): string;
        private _cnamePrefix?;
        /**
         * @stability stable
         */
        get cnamePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set cnamePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetCnamePrefix(): void;
        /**
         * @stability stable
         */
        get cnamePrefixInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get endpointUrl(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get instances(): string[];
        /**
         * @stability stable
         */
        get launchConfigurations(): string[];
        /**
         * @stability stable
         */
        get loadBalancers(): string[];
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _platformArn?;
        /**
         * @stability stable
         */
        get platformArn(): string | undefined;
        /**
         * @stability stable
         */
        set platformArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetPlatformArn(): void;
        /**
         * @stability stable
         */
        get platformArnInput(): string | undefined;
        private _pollInterval?;
        /**
         * @stability stable
         */
        get pollInterval(): string | undefined;
        /**
         * @stability stable
         */
        set pollInterval(value: string | undefined);
        /**
         * @stability stable
         */
        resetPollInterval(): void;
        /**
         * @stability stable
         */
        get pollIntervalInput(): string | undefined;
        /**
         * @stability stable
         */
        get queues(): string[];
        private _solutionStackName?;
        /**
         * @stability stable
         */
        get solutionStackName(): string | undefined;
        /**
         * @stability stable
         */
        set solutionStackName(value: string | undefined);
        /**
         * @stability stable
         */
        resetSolutionStackName(): void;
        /**
         * @stability stable
         */
        get solutionStackNameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _templateName?;
        /**
         * @stability stable
         */
        get templateName(): string | undefined;
        /**
         * @stability stable
         */
        set templateName(value: string | undefined);
        /**
         * @stability stable
         */
        resetTemplateName(): void;
        /**
         * @stability stable
         */
        get templateNameInput(): string | undefined;
        private _tier?;
        /**
         * @stability stable
         */
        get tier(): string | undefined;
        /**
         * @stability stable
         */
        set tier(value: string | undefined);
        /**
         * @stability stable
         */
        resetTier(): void;
        /**
         * @stability stable
         */
        get tierInput(): string | undefined;
        /**
         * @stability stable
         */
        get triggers(): string[];
        private _versionLabel?;
        /**
         * @stability stable
         */
        get versionLabel(): string | undefined;
        /**
         * @stability stable
         */
        set versionLabel(value: string | undefined);
        /**
         * @stability stable
         */
        resetVersionLabel(): void;
        /**
         * @stability stable
         */
        get versionLabelInput(): string | undefined;
        private _waitForReadyTimeout?;
        /**
         * @stability stable
         */
        get waitForReadyTimeout(): string | undefined;
        /**
         * @stability stable
         */
        set waitForReadyTimeout(value: string | undefined);
        /**
         * @stability stable
         */
        resetWaitForReadyTimeout(): void;
        /**
         * @stability stable
         */
        get waitForReadyTimeoutInput(): string | undefined;
        private _setting?;
        /**
         * @stability stable
         */
        get setting(): ElasticBeanstalkEnvironmentSetting[] | undefined;
        /**
         * @stability stable
         */
        set setting(value: ElasticBeanstalkEnvironmentSetting[] | undefined);
        /**
         * @stability stable
         */
        resetSetting(): void;
        /**
         * @stability stable
         */
        get settingInput(): ElasticBeanstalkEnvironmentSetting[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsElasticBeanstalkApplicationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/elastic_beanstalk_application.html#name DataAwsElasticBeanstalkApplication#name}.
         *
         * @stability stable
         */
        readonly name: string;
    }
    /**
     * @stability stable
     */
    class DataAwsElasticBeanstalkApplicationAppversionLifecycle extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get deleteSourceFromS3(): any;
        /**
         * @stability stable
         */
        get maxAgeInDays(): number;
        /**
         * @stability stable
         */
        get maxCount(): number;
        /**
         * @stability stable
         */
        get serviceRole(): string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/elastic_beanstalk_application.html aws_elastic_beanstalk_application}.
     *
     * @stability stable
     */
    class DataAwsElasticBeanstalkApplication extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/elastic_beanstalk_application.html aws_elastic_beanstalk_application} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsElasticBeanstalkApplicationConfig);
        /**
         * @stability stable
         */
        appversionLifecycle(index: string): DataAwsElasticBeanstalkApplicationAppversionLifecycle;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsElasticBeanstalkHostedZoneConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/elastic_beanstalk_hosted_zone.html#region DataAwsElasticBeanstalkHostedZone#region}.
         *
         * @stability stable
         */
        readonly region?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/elastic_beanstalk_hosted_zone.html aws_elastic_beanstalk_hosted_zone}.
     *
     * @stability stable
     */
    class DataAwsElasticBeanstalkHostedZone extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/elastic_beanstalk_hosted_zone.html aws_elastic_beanstalk_hosted_zone} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsElasticBeanstalkHostedZoneConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _region?;
        /**
         * @stability stable
         */
        get region(): string | undefined;
        /**
         * @stability stable
         */
        set region(value: string | undefined);
        /**
         * @stability stable
         */
        resetRegion(): void;
        /**
         * @stability stable
         */
        get regionInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsElasticBeanstalkSolutionStackConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/elastic_beanstalk_solution_stack.html#most_recent DataAwsElasticBeanstalkSolutionStack#most_recent}.
         *
         * @stability stable
         */
        readonly mostRecent?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/elastic_beanstalk_solution_stack.html#name_regex DataAwsElasticBeanstalkSolutionStack#name_regex}.
         *
         * @stability stable
         */
        readonly nameRegex: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/elastic_beanstalk_solution_stack.html aws_elastic_beanstalk_solution_stack}.
     *
     * @stability stable
     */
    class DataAwsElasticBeanstalkSolutionStack extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/elastic_beanstalk_solution_stack.html aws_elastic_beanstalk_solution_stack} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsElasticBeanstalkSolutionStackConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _mostRecent?;
        /**
         * @stability stable
         */
        get mostRecent(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set mostRecent(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetMostRecent(): void;
        /**
         * @stability stable
         */
        get mostRecentInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get name(): string;
        private _nameRegex?;
        /**
         * @stability stable
         */
        get nameRegex(): string;
        /**
         * @stability stable
         */
        set nameRegex(value: string);
        /**
         * @stability stable
         */
        get nameRegexInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
