import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS GameLift
*/
export declare namespace GameLift {
    /**
     * @stability stable
     */
    interface GameliftAliasConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_alias.html#description GameliftAlias#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_alias.html#name GameliftAlias#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_alias.html#tags GameliftAlias#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_alias.html#tags_all GameliftAlias#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * routing_strategy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_alias.html#routing_strategy GameliftAlias#routing_strategy}
         *
         * @stability stable
         */
        readonly routingStrategy: GameliftAliasRoutingStrategy;
    }
    /**
     * @stability stable
     */
    interface GameliftAliasRoutingStrategy {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_alias.html#fleet_id GameliftAlias#fleet_id}.
         *
         * @stability stable
         */
        readonly fleetId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_alias.html#message GameliftAlias#message}.
         *
         * @stability stable
         */
        readonly message?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_alias.html#type GameliftAlias#type}.
         *
         * @stability stable
         */
        readonly type: string;
    }
    /**
     * @stability stable
     */
    class GameliftAliasRoutingStrategyOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _fleetId?;
        /**
         * @stability stable
         */
        get fleetId(): string | undefined;
        /**
         * @stability stable
         */
        set fleetId(value: string | undefined);
        /**
         * @stability stable
         */
        resetFleetId(): void;
        /**
         * @stability stable
         */
        get fleetIdInput(): string | undefined;
        private _message?;
        /**
         * @stability stable
         */
        get message(): string | undefined;
        /**
         * @stability stable
         */
        set message(value: string | undefined);
        /**
         * @stability stable
         */
        resetMessage(): void;
        /**
         * @stability stable
         */
        get messageInput(): string | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/gamelift_alias.html aws_gamelift_alias}.
     *
     * @stability stable
     */
    class GameliftAlias extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/gamelift_alias.html aws_gamelift_alias} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: GameliftAliasConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _routingStrategy?;
        private __routingStrategyOutput;
        /**
         * @stability stable
         */
        get routingStrategy(): GameliftAliasRoutingStrategyOutputReference;
        /**
         * @stability stable
         */
        putRoutingStrategy(value: GameliftAliasRoutingStrategy): void;
        /**
         * @stability stable
         */
        get routingStrategyInput(): GameliftAliasRoutingStrategy | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface GameliftBuildConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_build.html#name GameliftBuild#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_build.html#operating_system GameliftBuild#operating_system}.
         *
         * @stability stable
         */
        readonly operatingSystem: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_build.html#tags GameliftBuild#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_build.html#tags_all GameliftBuild#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_build.html#version GameliftBuild#version}.
         *
         * @stability stable
         */
        readonly version?: string;
        /**
         * storage_location block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_build.html#storage_location GameliftBuild#storage_location}
         *
         * @stability stable
         */
        readonly storageLocation: GameliftBuildStorageLocation;
    }
    /**
     * @stability stable
     */
    interface GameliftBuildStorageLocation {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_build.html#bucket GameliftBuild#bucket}.
         *
         * @stability stable
         */
        readonly bucket: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_build.html#key GameliftBuild#key}.
         *
         * @stability stable
         */
        readonly key: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_build.html#role_arn GameliftBuild#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
    }
    /**
     * @stability stable
     */
    class GameliftBuildStorageLocationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bucket?;
        /**
         * @stability stable
         */
        get bucket(): string;
        /**
         * @stability stable
         */
        set bucket(value: string);
        /**
         * @stability stable
         */
        get bucketInput(): string | undefined;
        private _key?;
        /**
         * @stability stable
         */
        get key(): string;
        /**
         * @stability stable
         */
        set key(value: string);
        /**
         * @stability stable
         */
        get keyInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/gamelift_build.html aws_gamelift_build}.
     *
     * @stability stable
     */
    class GameliftBuild extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/gamelift_build.html aws_gamelift_build} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: GameliftBuildConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _operatingSystem?;
        /**
         * @stability stable
         */
        get operatingSystem(): string;
        /**
         * @stability stable
         */
        set operatingSystem(value: string);
        /**
         * @stability stable
         */
        get operatingSystemInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _version?;
        /**
         * @stability stable
         */
        get version(): string | undefined;
        /**
         * @stability stable
         */
        set version(value: string | undefined);
        /**
         * @stability stable
         */
        resetVersion(): void;
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
        private _storageLocation?;
        private __storageLocationOutput;
        /**
         * @stability stable
         */
        get storageLocation(): GameliftBuildStorageLocationOutputReference;
        /**
         * @stability stable
         */
        putStorageLocation(value: GameliftBuildStorageLocation): void;
        /**
         * @stability stable
         */
        get storageLocationInput(): GameliftBuildStorageLocation | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface GameliftFleetConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#build_id GameliftFleet#build_id}.
         *
         * @stability stable
         */
        readonly buildId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#description GameliftFleet#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#ec2_instance_type GameliftFleet#ec2_instance_type}.
         *
         * @stability stable
         */
        readonly ec2InstanceType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#fleet_type GameliftFleet#fleet_type}.
         *
         * @stability stable
         */
        readonly fleetType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#instance_role_arn GameliftFleet#instance_role_arn}.
         *
         * @stability stable
         */
        readonly instanceRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#metric_groups GameliftFleet#metric_groups}.
         *
         * @stability stable
         */
        readonly metricGroups?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#name GameliftFleet#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#new_game_session_protection_policy GameliftFleet#new_game_session_protection_policy}.
         *
         * @stability stable
         */
        readonly newGameSessionProtectionPolicy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#tags GameliftFleet#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#tags_all GameliftFleet#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * ec2_inbound_permission block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#ec2_inbound_permission GameliftFleet#ec2_inbound_permission}
         *
         * @stability stable
         */
        readonly ec2InboundPermission?: GameliftFleetEc2InboundPermission[];
        /**
         * resource_creation_limit_policy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#resource_creation_limit_policy GameliftFleet#resource_creation_limit_policy}
         *
         * @stability stable
         */
        readonly resourceCreationLimitPolicy?: GameliftFleetResourceCreationLimitPolicy;
        /**
         * runtime_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#runtime_configuration GameliftFleet#runtime_configuration}
         *
         * @stability stable
         */
        readonly runtimeConfiguration?: GameliftFleetRuntimeConfiguration;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#timeouts GameliftFleet#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: GameliftFleetTimeouts;
    }
    /**
     * @stability stable
     */
    interface GameliftFleetEc2InboundPermission {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#from_port GameliftFleet#from_port}.
         *
         * @stability stable
         */
        readonly fromPort: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#ip_range GameliftFleet#ip_range}.
         *
         * @stability stable
         */
        readonly ipRange: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#protocol GameliftFleet#protocol}.
         *
         * @stability stable
         */
        readonly protocol: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#to_port GameliftFleet#to_port}.
         *
         * @stability stable
         */
        readonly toPort: number;
    }
    /**
     * @stability stable
     */
    interface GameliftFleetResourceCreationLimitPolicy {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#new_game_sessions_per_creator GameliftFleet#new_game_sessions_per_creator}.
         *
         * @stability stable
         */
        readonly newGameSessionsPerCreator?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#policy_period_in_minutes GameliftFleet#policy_period_in_minutes}.
         *
         * @stability stable
         */
        readonly policyPeriodInMinutes?: number;
    }
    /**
     * @stability stable
     */
    class GameliftFleetResourceCreationLimitPolicyOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _newGameSessionsPerCreator?;
        /**
         * @stability stable
         */
        get newGameSessionsPerCreator(): number | undefined;
        /**
         * @stability stable
         */
        set newGameSessionsPerCreator(value: number | undefined);
        /**
         * @stability stable
         */
        resetNewGameSessionsPerCreator(): void;
        /**
         * @stability stable
         */
        get newGameSessionsPerCreatorInput(): number | undefined;
        private _policyPeriodInMinutes?;
        /**
         * @stability stable
         */
        get policyPeriodInMinutes(): number | undefined;
        /**
         * @stability stable
         */
        set policyPeriodInMinutes(value: number | undefined);
        /**
         * @stability stable
         */
        resetPolicyPeriodInMinutes(): void;
        /**
         * @stability stable
         */
        get policyPeriodInMinutesInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface GameliftFleetRuntimeConfigurationServerProcess {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#concurrent_executions GameliftFleet#concurrent_executions}.
         *
         * @stability stable
         */
        readonly concurrentExecutions: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#launch_path GameliftFleet#launch_path}.
         *
         * @stability stable
         */
        readonly launchPath: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#parameters GameliftFleet#parameters}.
         *
         * @stability stable
         */
        readonly parameters?: string;
    }
    /**
     * @stability stable
     */
    interface GameliftFleetRuntimeConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#game_session_activation_timeout_seconds GameliftFleet#game_session_activation_timeout_seconds}.
         *
         * @stability stable
         */
        readonly gameSessionActivationTimeoutSeconds?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#max_concurrent_game_session_activations GameliftFleet#max_concurrent_game_session_activations}.
         *
         * @stability stable
         */
        readonly maxConcurrentGameSessionActivations?: number;
        /**
         * server_process block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#server_process GameliftFleet#server_process}
         *
         * @stability stable
         */
        readonly serverProcess?: GameliftFleetRuntimeConfigurationServerProcess[];
    }
    /**
     * @stability stable
     */
    class GameliftFleetRuntimeConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _gameSessionActivationTimeoutSeconds?;
        /**
         * @stability stable
         */
        get gameSessionActivationTimeoutSeconds(): number | undefined;
        /**
         * @stability stable
         */
        set gameSessionActivationTimeoutSeconds(value: number | undefined);
        /**
         * @stability stable
         */
        resetGameSessionActivationTimeoutSeconds(): void;
        /**
         * @stability stable
         */
        get gameSessionActivationTimeoutSecondsInput(): number | undefined;
        private _maxConcurrentGameSessionActivations?;
        /**
         * @stability stable
         */
        get maxConcurrentGameSessionActivations(): number | undefined;
        /**
         * @stability stable
         */
        set maxConcurrentGameSessionActivations(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaxConcurrentGameSessionActivations(): void;
        /**
         * @stability stable
         */
        get maxConcurrentGameSessionActivationsInput(): number | undefined;
        private _serverProcess?;
        /**
         * @stability stable
         */
        get serverProcess(): GameliftFleetRuntimeConfigurationServerProcess[] | undefined;
        /**
         * @stability stable
         */
        set serverProcess(value: GameliftFleetRuntimeConfigurationServerProcess[] | undefined);
        /**
         * @stability stable
         */
        resetServerProcess(): void;
        /**
         * @stability stable
         */
        get serverProcessInput(): GameliftFleetRuntimeConfigurationServerProcess[] | undefined;
    }
    /**
     * @stability stable
     */
    interface GameliftFleetTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#create GameliftFleet#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html#delete GameliftFleet#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
    }
    /**
     * @stability stable
     */
    class GameliftFleetTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html aws_gamelift_fleet}.
     *
     * @stability stable
     */
    class GameliftFleet extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet.html aws_gamelift_fleet} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: GameliftFleetConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _buildId?;
        /**
         * @stability stable
         */
        get buildId(): string;
        /**
         * @stability stable
         */
        set buildId(value: string);
        /**
         * @stability stable
         */
        get buildIdInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _ec2InstanceType?;
        /**
         * @stability stable
         */
        get ec2InstanceType(): string;
        /**
         * @stability stable
         */
        set ec2InstanceType(value: string);
        /**
         * @stability stable
         */
        get ec2InstanceTypeInput(): string | undefined;
        private _fleetType?;
        /**
         * @stability stable
         */
        get fleetType(): string | undefined;
        /**
         * @stability stable
         */
        set fleetType(value: string | undefined);
        /**
         * @stability stable
         */
        resetFleetType(): void;
        /**
         * @stability stable
         */
        get fleetTypeInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceRoleArn?;
        /**
         * @stability stable
         */
        get instanceRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set instanceRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceRoleArn(): void;
        /**
         * @stability stable
         */
        get instanceRoleArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get logPaths(): string[];
        private _metricGroups?;
        /**
         * @stability stable
         */
        get metricGroups(): string[] | undefined;
        /**
         * @stability stable
         */
        set metricGroups(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetMetricGroups(): void;
        /**
         * @stability stable
         */
        get metricGroupsInput(): string[] | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _newGameSessionProtectionPolicy?;
        /**
         * @stability stable
         */
        get newGameSessionProtectionPolicy(): string | undefined;
        /**
         * @stability stable
         */
        set newGameSessionProtectionPolicy(value: string | undefined);
        /**
         * @stability stable
         */
        resetNewGameSessionProtectionPolicy(): void;
        /**
         * @stability stable
         */
        get newGameSessionProtectionPolicyInput(): string | undefined;
        /**
         * @stability stable
         */
        get operatingSystem(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _ec2InboundPermission?;
        /**
         * @stability stable
         */
        get ec2InboundPermission(): GameliftFleetEc2InboundPermission[] | undefined;
        /**
         * @stability stable
         */
        set ec2InboundPermission(value: GameliftFleetEc2InboundPermission[] | undefined);
        /**
         * @stability stable
         */
        resetEc2InboundPermission(): void;
        /**
         * @stability stable
         */
        get ec2InboundPermissionInput(): GameliftFleetEc2InboundPermission[] | undefined;
        private _resourceCreationLimitPolicy?;
        private __resourceCreationLimitPolicyOutput;
        /**
         * @stability stable
         */
        get resourceCreationLimitPolicy(): GameliftFleetResourceCreationLimitPolicyOutputReference;
        /**
         * @stability stable
         */
        putResourceCreationLimitPolicy(value: GameliftFleetResourceCreationLimitPolicy | undefined): void;
        /**
         * @stability stable
         */
        resetResourceCreationLimitPolicy(): void;
        /**
         * @stability stable
         */
        get resourceCreationLimitPolicyInput(): GameliftFleetResourceCreationLimitPolicy | undefined;
        private _runtimeConfiguration?;
        private __runtimeConfigurationOutput;
        /**
         * @stability stable
         */
        get runtimeConfiguration(): GameliftFleetRuntimeConfigurationOutputReference;
        /**
         * @stability stable
         */
        putRuntimeConfiguration(value: GameliftFleetRuntimeConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetRuntimeConfiguration(): void;
        /**
         * @stability stable
         */
        get runtimeConfigurationInput(): GameliftFleetRuntimeConfiguration | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): GameliftFleetTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: GameliftFleetTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): GameliftFleetTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface GameliftGameSessionQueueConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_game_session_queue.html#destinations GameliftGameSessionQueue#destinations}.
         *
         * @stability stable
         */
        readonly destinations?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_game_session_queue.html#name GameliftGameSessionQueue#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_game_session_queue.html#tags GameliftGameSessionQueue#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_game_session_queue.html#tags_all GameliftGameSessionQueue#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_game_session_queue.html#timeout_in_seconds GameliftGameSessionQueue#timeout_in_seconds}.
         *
         * @stability stable
         */
        readonly timeoutInSeconds?: number;
        /**
         * player_latency_policy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_game_session_queue.html#player_latency_policy GameliftGameSessionQueue#player_latency_policy}
         *
         * @stability stable
         */
        readonly playerLatencyPolicy?: GameliftGameSessionQueuePlayerLatencyPolicy[];
    }
    /**
     * @stability stable
     */
    interface GameliftGameSessionQueuePlayerLatencyPolicy {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_game_session_queue.html#maximum_individual_player_latency_milliseconds GameliftGameSessionQueue#maximum_individual_player_latency_milliseconds}.
         *
         * @stability stable
         */
        readonly maximumIndividualPlayerLatencyMilliseconds: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_game_session_queue.html#policy_duration_seconds GameliftGameSessionQueue#policy_duration_seconds}.
         *
         * @stability stable
         */
        readonly policyDurationSeconds?: number;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/gamelift_game_session_queue.html aws_gamelift_game_session_queue}.
     *
     * @stability stable
     */
    class GameliftGameSessionQueue extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/gamelift_game_session_queue.html aws_gamelift_game_session_queue} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: GameliftGameSessionQueueConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _destinations?;
        /**
         * @stability stable
         */
        get destinations(): string[] | undefined;
        /**
         * @stability stable
         */
        set destinations(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetDestinations(): void;
        /**
         * @stability stable
         */
        get destinationsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _timeoutInSeconds?;
        /**
         * @stability stable
         */
        get timeoutInSeconds(): number | undefined;
        /**
         * @stability stable
         */
        set timeoutInSeconds(value: number | undefined);
        /**
         * @stability stable
         */
        resetTimeoutInSeconds(): void;
        /**
         * @stability stable
         */
        get timeoutInSecondsInput(): number | undefined;
        private _playerLatencyPolicy?;
        /**
         * @stability stable
         */
        get playerLatencyPolicy(): GameliftGameSessionQueuePlayerLatencyPolicy[] | undefined;
        /**
         * @stability stable
         */
        set playerLatencyPolicy(value: GameliftGameSessionQueuePlayerLatencyPolicy[] | undefined);
        /**
         * @stability stable
         */
        resetPlayerLatencyPolicy(): void;
        /**
         * @stability stable
         */
        get playerLatencyPolicyInput(): GameliftGameSessionQueuePlayerLatencyPolicy[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
