import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Global Accelerator
*/
export declare namespace GlobalAccelerator {
    /**
     * @stability stable
     */
    interface GlobalacceleratorAcceleratorConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator.html#enabled GlobalacceleratorAccelerator#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator.html#ip_address_type GlobalacceleratorAccelerator#ip_address_type}.
         *
         * @stability stable
         */
        readonly ipAddressType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator.html#name GlobalacceleratorAccelerator#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator.html#tags GlobalacceleratorAccelerator#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator.html#tags_all GlobalacceleratorAccelerator#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * attributes block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator.html#attributes GlobalacceleratorAccelerator#attributes}
         *
         * @stability stable
         */
        readonly attributes?: GlobalacceleratorAcceleratorAttributes;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator.html#timeouts GlobalacceleratorAccelerator#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: GlobalacceleratorAcceleratorTimeouts;
    }
    /**
     * @stability stable
     */
    class GlobalacceleratorAcceleratorIpSets extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get ipAddresses(): string[];
        /**
         * @stability stable
         */
        get ipFamily(): string;
    }
    /**
     * @stability stable
     */
    interface GlobalacceleratorAcceleratorAttributes {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator.html#flow_logs_enabled GlobalacceleratorAccelerator#flow_logs_enabled}.
         *
         * @stability stable
         */
        readonly flowLogsEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator.html#flow_logs_s3_bucket GlobalacceleratorAccelerator#flow_logs_s3_bucket}.
         *
         * @stability stable
         */
        readonly flowLogsS3Bucket?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator.html#flow_logs_s3_prefix GlobalacceleratorAccelerator#flow_logs_s3_prefix}.
         *
         * @stability stable
         */
        readonly flowLogsS3Prefix?: string;
    }
    /**
     * @stability stable
     */
    class GlobalacceleratorAcceleratorAttributesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _flowLogsEnabled?;
        /**
         * @stability stable
         */
        get flowLogsEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set flowLogsEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetFlowLogsEnabled(): void;
        /**
         * @stability stable
         */
        get flowLogsEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _flowLogsS3Bucket?;
        /**
         * @stability stable
         */
        get flowLogsS3Bucket(): string | undefined;
        /**
         * @stability stable
         */
        set flowLogsS3Bucket(value: string | undefined);
        /**
         * @stability stable
         */
        resetFlowLogsS3Bucket(): void;
        /**
         * @stability stable
         */
        get flowLogsS3BucketInput(): string | undefined;
        private _flowLogsS3Prefix?;
        /**
         * @stability stable
         */
        get flowLogsS3Prefix(): string | undefined;
        /**
         * @stability stable
         */
        set flowLogsS3Prefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetFlowLogsS3Prefix(): void;
        /**
         * @stability stable
         */
        get flowLogsS3PrefixInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface GlobalacceleratorAcceleratorTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator.html#create GlobalacceleratorAccelerator#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator.html#update GlobalacceleratorAccelerator#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class GlobalacceleratorAcceleratorTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator.html aws_globalaccelerator_accelerator}.
     *
     * @stability stable
     */
    class GlobalacceleratorAccelerator extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator.html aws_globalaccelerator_accelerator} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: GlobalacceleratorAcceleratorConfig);
        /**
         * @stability stable
         */
        get dnsName(): string;
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get hostedZoneId(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _ipAddressType?;
        /**
         * @stability stable
         */
        get ipAddressType(): string | undefined;
        /**
         * @stability stable
         */
        set ipAddressType(value: string | undefined);
        /**
         * @stability stable
         */
        resetIpAddressType(): void;
        /**
         * @stability stable
         */
        get ipAddressTypeInput(): string | undefined;
        /**
         * @stability stable
         */
        ipSets(index: string): GlobalacceleratorAcceleratorIpSets;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _attributes?;
        private __attributesOutput;
        /**
         * @stability stable
         */
        get attributes(): GlobalacceleratorAcceleratorAttributesOutputReference;
        /**
         * @stability stable
         */
        putAttributes(value: GlobalacceleratorAcceleratorAttributes | undefined): void;
        /**
         * @stability stable
         */
        resetAttributes(): void;
        /**
         * @stability stable
         */
        get attributesInput(): GlobalacceleratorAcceleratorAttributes | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): GlobalacceleratorAcceleratorTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: GlobalacceleratorAcceleratorTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): GlobalacceleratorAcceleratorTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface GlobalacceleratorEndpointGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#endpoint_group_region GlobalacceleratorEndpointGroup#endpoint_group_region}.
         *
         * @stability stable
         */
        readonly endpointGroupRegion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#health_check_interval_seconds GlobalacceleratorEndpointGroup#health_check_interval_seconds}.
         *
         * @stability stable
         */
        readonly healthCheckIntervalSeconds?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#health_check_path GlobalacceleratorEndpointGroup#health_check_path}.
         *
         * @stability stable
         */
        readonly healthCheckPath?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#health_check_port GlobalacceleratorEndpointGroup#health_check_port}.
         *
         * @stability stable
         */
        readonly healthCheckPort?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#health_check_protocol GlobalacceleratorEndpointGroup#health_check_protocol}.
         *
         * @stability stable
         */
        readonly healthCheckProtocol?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#listener_arn GlobalacceleratorEndpointGroup#listener_arn}.
         *
         * @stability stable
         */
        readonly listenerArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#threshold_count GlobalacceleratorEndpointGroup#threshold_count}.
         *
         * @stability stable
         */
        readonly thresholdCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#traffic_dial_percentage GlobalacceleratorEndpointGroup#traffic_dial_percentage}.
         *
         * @stability stable
         */
        readonly trafficDialPercentage?: number;
        /**
         * endpoint_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#endpoint_configuration GlobalacceleratorEndpointGroup#endpoint_configuration}
         *
         * @stability stable
         */
        readonly endpointConfiguration?: GlobalacceleratorEndpointGroupEndpointConfiguration[];
        /**
         * port_override block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#port_override GlobalacceleratorEndpointGroup#port_override}
         *
         * @stability stable
         */
        readonly portOverride?: GlobalacceleratorEndpointGroupPortOverride[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#timeouts GlobalacceleratorEndpointGroup#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: GlobalacceleratorEndpointGroupTimeouts;
    }
    /**
     * @stability stable
     */
    interface GlobalacceleratorEndpointGroupEndpointConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#client_ip_preservation_enabled GlobalacceleratorEndpointGroup#client_ip_preservation_enabled}.
         *
         * @stability stable
         */
        readonly clientIpPreservationEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#endpoint_id GlobalacceleratorEndpointGroup#endpoint_id}.
         *
         * @stability stable
         */
        readonly endpointId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#weight GlobalacceleratorEndpointGroup#weight}.
         *
         * @stability stable
         */
        readonly weight?: number;
    }
    /**
     * @stability stable
     */
    interface GlobalacceleratorEndpointGroupPortOverride {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#endpoint_port GlobalacceleratorEndpointGroup#endpoint_port}.
         *
         * @stability stable
         */
        readonly endpointPort: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#listener_port GlobalacceleratorEndpointGroup#listener_port}.
         *
         * @stability stable
         */
        readonly listenerPort: number;
    }
    /**
     * @stability stable
     */
    interface GlobalacceleratorEndpointGroupTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#create GlobalacceleratorEndpointGroup#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#delete GlobalacceleratorEndpointGroup#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html#update GlobalacceleratorEndpointGroup#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class GlobalacceleratorEndpointGroupTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html aws_globalaccelerator_endpoint_group}.
     *
     * @stability stable
     */
    class GlobalacceleratorEndpointGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group.html aws_globalaccelerator_endpoint_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: GlobalacceleratorEndpointGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _endpointGroupRegion?;
        /**
         * @stability stable
         */
        get endpointGroupRegion(): string | undefined;
        /**
         * @stability stable
         */
        set endpointGroupRegion(value: string | undefined);
        /**
         * @stability stable
         */
        resetEndpointGroupRegion(): void;
        /**
         * @stability stable
         */
        get endpointGroupRegionInput(): string | undefined;
        private _healthCheckIntervalSeconds?;
        /**
         * @stability stable
         */
        get healthCheckIntervalSeconds(): number | undefined;
        /**
         * @stability stable
         */
        set healthCheckIntervalSeconds(value: number | undefined);
        /**
         * @stability stable
         */
        resetHealthCheckIntervalSeconds(): void;
        /**
         * @stability stable
         */
        get healthCheckIntervalSecondsInput(): number | undefined;
        private _healthCheckPath?;
        /**
         * @stability stable
         */
        get healthCheckPath(): string | undefined;
        /**
         * @stability stable
         */
        set healthCheckPath(value: string | undefined);
        /**
         * @stability stable
         */
        resetHealthCheckPath(): void;
        /**
         * @stability stable
         */
        get healthCheckPathInput(): string | undefined;
        private _healthCheckPort?;
        /**
         * @stability stable
         */
        get healthCheckPort(): number | undefined;
        /**
         * @stability stable
         */
        set healthCheckPort(value: number | undefined);
        /**
         * @stability stable
         */
        resetHealthCheckPort(): void;
        /**
         * @stability stable
         */
        get healthCheckPortInput(): number | undefined;
        private _healthCheckProtocol?;
        /**
         * @stability stable
         */
        get healthCheckProtocol(): string | undefined;
        /**
         * @stability stable
         */
        set healthCheckProtocol(value: string | undefined);
        /**
         * @stability stable
         */
        resetHealthCheckProtocol(): void;
        /**
         * @stability stable
         */
        get healthCheckProtocolInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _listenerArn?;
        /**
         * @stability stable
         */
        get listenerArn(): string;
        /**
         * @stability stable
         */
        set listenerArn(value: string);
        /**
         * @stability stable
         */
        get listenerArnInput(): string | undefined;
        private _thresholdCount?;
        /**
         * @stability stable
         */
        get thresholdCount(): number | undefined;
        /**
         * @stability stable
         */
        set thresholdCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetThresholdCount(): void;
        /**
         * @stability stable
         */
        get thresholdCountInput(): number | undefined;
        private _trafficDialPercentage?;
        /**
         * @stability stable
         */
        get trafficDialPercentage(): number | undefined;
        /**
         * @stability stable
         */
        set trafficDialPercentage(value: number | undefined);
        /**
         * @stability stable
         */
        resetTrafficDialPercentage(): void;
        /**
         * @stability stable
         */
        get trafficDialPercentageInput(): number | undefined;
        private _endpointConfiguration?;
        /**
         * @stability stable
         */
        get endpointConfiguration(): GlobalacceleratorEndpointGroupEndpointConfiguration[] | undefined;
        /**
         * @stability stable
         */
        set endpointConfiguration(value: GlobalacceleratorEndpointGroupEndpointConfiguration[] | undefined);
        /**
         * @stability stable
         */
        resetEndpointConfiguration(): void;
        /**
         * @stability stable
         */
        get endpointConfigurationInput(): GlobalacceleratorEndpointGroupEndpointConfiguration[] | undefined;
        private _portOverride?;
        /**
         * @stability stable
         */
        get portOverride(): GlobalacceleratorEndpointGroupPortOverride[] | undefined;
        /**
         * @stability stable
         */
        set portOverride(value: GlobalacceleratorEndpointGroupPortOverride[] | undefined);
        /**
         * @stability stable
         */
        resetPortOverride(): void;
        /**
         * @stability stable
         */
        get portOverrideInput(): GlobalacceleratorEndpointGroupPortOverride[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): GlobalacceleratorEndpointGroupTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: GlobalacceleratorEndpointGroupTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): GlobalacceleratorEndpointGroupTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface GlobalacceleratorListenerConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#accelerator_arn GlobalacceleratorListener#accelerator_arn}.
         *
         * @stability stable
         */
        readonly acceleratorArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#client_affinity GlobalacceleratorListener#client_affinity}.
         *
         * @stability stable
         */
        readonly clientAffinity?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#protocol GlobalacceleratorListener#protocol}.
         *
         * @stability stable
         */
        readonly protocol: string;
        /**
         * port_range block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#port_range GlobalacceleratorListener#port_range}
         *
         * @stability stable
         */
        readonly portRange: GlobalacceleratorListenerPortRange[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#timeouts GlobalacceleratorListener#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: GlobalacceleratorListenerTimeouts;
    }
    /**
     * @stability stable
     */
    interface GlobalacceleratorListenerPortRange {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#from_port GlobalacceleratorListener#from_port}.
         *
         * @stability stable
         */
        readonly fromPort?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#to_port GlobalacceleratorListener#to_port}.
         *
         * @stability stable
         */
        readonly toPort?: number;
    }
    /**
     * @stability stable
     */
    interface GlobalacceleratorListenerTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#create GlobalacceleratorListener#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#delete GlobalacceleratorListener#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html#update GlobalacceleratorListener#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class GlobalacceleratorListenerTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html aws_globalaccelerator_listener}.
     *
     * @stability stable
     */
    class GlobalacceleratorListener extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener.html aws_globalaccelerator_listener} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: GlobalacceleratorListenerConfig);
        private _acceleratorArn?;
        /**
         * @stability stable
         */
        get acceleratorArn(): string;
        /**
         * @stability stable
         */
        set acceleratorArn(value: string);
        /**
         * @stability stable
         */
        get acceleratorArnInput(): string | undefined;
        private _clientAffinity?;
        /**
         * @stability stable
         */
        get clientAffinity(): string | undefined;
        /**
         * @stability stable
         */
        set clientAffinity(value: string | undefined);
        /**
         * @stability stable
         */
        resetClientAffinity(): void;
        /**
         * @stability stable
         */
        get clientAffinityInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _protocol?;
        /**
         * @stability stable
         */
        get protocol(): string;
        /**
         * @stability stable
         */
        set protocol(value: string);
        /**
         * @stability stable
         */
        get protocolInput(): string | undefined;
        private _portRange?;
        /**
         * @stability stable
         */
        get portRange(): GlobalacceleratorListenerPortRange[];
        /**
         * @stability stable
         */
        set portRange(value: GlobalacceleratorListenerPortRange[]);
        /**
         * @stability stable
         */
        get portRangeInput(): GlobalacceleratorListenerPortRange[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): GlobalacceleratorListenerTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: GlobalacceleratorListenerTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): GlobalacceleratorListenerTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsGlobalacceleratorAcceleratorConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/globalaccelerator_accelerator.html#name DataAwsGlobalacceleratorAccelerator#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/globalaccelerator_accelerator.html#tags DataAwsGlobalacceleratorAccelerator#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class DataAwsGlobalacceleratorAcceleratorAttributes extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get flowLogsEnabled(): any;
        /**
         * @stability stable
         */
        get flowLogsS3Bucket(): string;
        /**
         * @stability stable
         */
        get flowLogsS3Prefix(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsGlobalacceleratorAcceleratorIpSets extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get ipAddresses(): string[];
        /**
         * @stability stable
         */
        get ipFamily(): string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/globalaccelerator_accelerator.html aws_globalaccelerator_accelerator}.
     *
     * @stability stable
     */
    class DataAwsGlobalacceleratorAccelerator extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/globalaccelerator_accelerator.html aws_globalaccelerator_accelerator} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsGlobalacceleratorAcceleratorConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        attributes(index: string): DataAwsGlobalacceleratorAcceleratorAttributes;
        /**
         * @stability stable
         */
        get dnsName(): string;
        /**
         * @stability stable
         */
        get enabled(): any;
        /**
         * @stability stable
         */
        get hostedZoneId(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ipAddressType(): string;
        /**
         * @stability stable
         */
        ipSets(index: string): DataAwsGlobalacceleratorAcceleratorIpSets;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
