import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Image Builder
*/
export declare namespace ImageBuilder {
    /**
     * @stability stable
     */
    interface ImagebuilderComponentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_component.html#change_description ImagebuilderComponent#change_description}.
         *
         * @stability stable
         */
        readonly changeDescription?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_component.html#data ImagebuilderComponent#data}.
         *
         * @stability stable
         */
        readonly data?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_component.html#description ImagebuilderComponent#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_component.html#kms_key_id ImagebuilderComponent#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_component.html#name ImagebuilderComponent#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_component.html#platform ImagebuilderComponent#platform}.
         *
         * @stability stable
         */
        readonly platform: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_component.html#supported_os_versions ImagebuilderComponent#supported_os_versions}.
         *
         * @stability stable
         */
        readonly supportedOsVersions?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_component.html#tags ImagebuilderComponent#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_component.html#tags_all ImagebuilderComponent#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_component.html#uri ImagebuilderComponent#uri}.
         *
         * @stability stable
         */
        readonly uri?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_component.html#version ImagebuilderComponent#version}.
         *
         * @stability stable
         */
        readonly version: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_component.html aws_imagebuilder_component}.
     *
     * @stability stable
     */
    class ImagebuilderComponent extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_component.html aws_imagebuilder_component} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ImagebuilderComponentConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _changeDescription?;
        /**
         * @stability stable
         */
        get changeDescription(): string | undefined;
        /**
         * @stability stable
         */
        set changeDescription(value: string | undefined);
        /**
         * @stability stable
         */
        resetChangeDescription(): void;
        /**
         * @stability stable
         */
        get changeDescriptionInput(): string | undefined;
        private _data?;
        /**
         * @stability stable
         */
        get data(): string | undefined;
        /**
         * @stability stable
         */
        set data(value: string | undefined);
        /**
         * @stability stable
         */
        resetData(): void;
        /**
         * @stability stable
         */
        get dataInput(): string | undefined;
        /**
         * @stability stable
         */
        get dateCreated(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get encrypted(): any;
        /**
         * @stability stable
         */
        get id(): string;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get owner(): string;
        private _platform?;
        /**
         * @stability stable
         */
        get platform(): string;
        /**
         * @stability stable
         */
        set platform(value: string);
        /**
         * @stability stable
         */
        get platformInput(): string | undefined;
        private _supportedOsVersions?;
        /**
         * @stability stable
         */
        get supportedOsVersions(): string[] | undefined;
        /**
         * @stability stable
         */
        set supportedOsVersions(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSupportedOsVersions(): void;
        /**
         * @stability stable
         */
        get supportedOsVersionsInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get type(): string;
        private _uri?;
        /**
         * @stability stable
         */
        get uri(): string | undefined;
        /**
         * @stability stable
         */
        set uri(value: string | undefined);
        /**
         * @stability stable
         */
        resetUri(): void;
        /**
         * @stability stable
         */
        get uriInput(): string | undefined;
        private _version?;
        /**
         * @stability stable
         */
        get version(): string;
        /**
         * @stability stable
         */
        set version(value: string);
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ImagebuilderDistributionConfigurationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html#description ImagebuilderDistributionConfiguration#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html#name ImagebuilderDistributionConfiguration#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html#tags ImagebuilderDistributionConfiguration#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html#tags_all ImagebuilderDistributionConfiguration#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * distribution block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html#distribution ImagebuilderDistributionConfiguration#distribution}
         *
         * @stability stable
         */
        readonly distribution: ImagebuilderDistributionConfigurationDistribution[];
    }
    /**
     * @stability stable
     */
    interface ImagebuilderDistributionConfigurationDistributionAmiDistributionConfigurationLaunchPermission {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html#user_groups ImagebuilderDistributionConfiguration#user_groups}.
         *
         * @stability stable
         */
        readonly userGroups?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html#user_ids ImagebuilderDistributionConfiguration#user_ids}.
         *
         * @stability stable
         */
        readonly userIds?: string[];
    }
    /**
     * @stability stable
     */
    class ImagebuilderDistributionConfigurationDistributionAmiDistributionConfigurationLaunchPermissionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _userGroups?;
        /**
         * @stability stable
         */
        get userGroups(): string[] | undefined;
        /**
         * @stability stable
         */
        set userGroups(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetUserGroups(): void;
        /**
         * @stability stable
         */
        get userGroupsInput(): string[] | undefined;
        private _userIds?;
        /**
         * @stability stable
         */
        get userIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set userIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetUserIds(): void;
        /**
         * @stability stable
         */
        get userIdsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface ImagebuilderDistributionConfigurationDistributionAmiDistributionConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html#ami_tags ImagebuilderDistributionConfiguration#ami_tags}.
         *
         * @stability stable
         */
        readonly amiTags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html#description ImagebuilderDistributionConfiguration#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html#kms_key_id ImagebuilderDistributionConfiguration#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html#name ImagebuilderDistributionConfiguration#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html#target_account_ids ImagebuilderDistributionConfiguration#target_account_ids}.
         *
         * @stability stable
         */
        readonly targetAccountIds?: string[];
        /**
         * launch_permission block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html#launch_permission ImagebuilderDistributionConfiguration#launch_permission}
         *
         * @stability stable
         */
        readonly launchPermission?: ImagebuilderDistributionConfigurationDistributionAmiDistributionConfigurationLaunchPermission;
    }
    /**
     * @stability stable
     */
    class ImagebuilderDistributionConfigurationDistributionAmiDistributionConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _amiTags?;
        /**
         * @stability stable
         */
        get amiTags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set amiTags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAmiTags(): void;
        /**
         * @stability stable
         */
        get amiTagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _targetAccountIds?;
        /**
         * @stability stable
         */
        get targetAccountIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set targetAccountIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetTargetAccountIds(): void;
        /**
         * @stability stable
         */
        get targetAccountIdsInput(): string[] | undefined;
        private _launchPermission?;
        private __launchPermissionOutput;
        /**
         * @stability stable
         */
        get launchPermission(): ImagebuilderDistributionConfigurationDistributionAmiDistributionConfigurationLaunchPermissionOutputReference;
        /**
         * @stability stable
         */
        putLaunchPermission(value: ImagebuilderDistributionConfigurationDistributionAmiDistributionConfigurationLaunchPermission | undefined): void;
        /**
         * @stability stable
         */
        resetLaunchPermission(): void;
        /**
         * @stability stable
         */
        get launchPermissionInput(): ImagebuilderDistributionConfigurationDistributionAmiDistributionConfigurationLaunchPermission | undefined;
    }
    /**
     * @stability stable
     */
    interface ImagebuilderDistributionConfigurationDistribution {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html#license_configuration_arns ImagebuilderDistributionConfiguration#license_configuration_arns}.
         *
         * @stability stable
         */
        readonly licenseConfigurationArns?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html#region ImagebuilderDistributionConfiguration#region}.
         *
         * @stability stable
         */
        readonly region: string;
        /**
         * ami_distribution_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html#ami_distribution_configuration ImagebuilderDistributionConfiguration#ami_distribution_configuration}
         *
         * @stability stable
         */
        readonly amiDistributionConfiguration?: ImagebuilderDistributionConfigurationDistributionAmiDistributionConfiguration;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html aws_imagebuilder_distribution_configuration}.
     *
     * @stability stable
     */
    class ImagebuilderDistributionConfiguration extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_distribution_configuration.html aws_imagebuilder_distribution_configuration} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ImagebuilderDistributionConfigurationConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get dateCreated(): string;
        /**
         * @stability stable
         */
        get dateUpdated(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _distribution?;
        /**
         * @stability stable
         */
        get distribution(): ImagebuilderDistributionConfigurationDistribution[];
        /**
         * @stability stable
         */
        set distribution(value: ImagebuilderDistributionConfigurationDistribution[]);
        /**
         * @stability stable
         */
        get distributionInput(): ImagebuilderDistributionConfigurationDistribution[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ImagebuilderImageConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image.html#distribution_configuration_arn ImagebuilderImage#distribution_configuration_arn}.
         *
         * @stability stable
         */
        readonly distributionConfigurationArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image.html#enhanced_image_metadata_enabled ImagebuilderImage#enhanced_image_metadata_enabled}.
         *
         * @stability stable
         */
        readonly enhancedImageMetadataEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image.html#image_recipe_arn ImagebuilderImage#image_recipe_arn}.
         *
         * @stability stable
         */
        readonly imageRecipeArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image.html#infrastructure_configuration_arn ImagebuilderImage#infrastructure_configuration_arn}.
         *
         * @stability stable
         */
        readonly infrastructureConfigurationArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image.html#tags ImagebuilderImage#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image.html#tags_all ImagebuilderImage#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * image_tests_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image.html#image_tests_configuration ImagebuilderImage#image_tests_configuration}
         *
         * @stability stable
         */
        readonly imageTestsConfiguration?: ImagebuilderImageImageTestsConfiguration;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image.html#timeouts ImagebuilderImage#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: ImagebuilderImageTimeouts;
    }
    /**
     * @stability stable
     */
    class ImagebuilderImageOutputResourcesAmis extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get accountId(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get image(): string;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        get region(): string;
    }
    /**
     * @stability stable
     */
    class ImagebuilderImageOutputResources extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get amis(): any;
    }
    /**
     * @stability stable
     */
    interface ImagebuilderImageImageTestsConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image.html#image_tests_enabled ImagebuilderImage#image_tests_enabled}.
         *
         * @stability stable
         */
        readonly imageTestsEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image.html#timeout_minutes ImagebuilderImage#timeout_minutes}.
         *
         * @stability stable
         */
        readonly timeoutMinutes?: number;
    }
    /**
     * @stability stable
     */
    class ImagebuilderImageImageTestsConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _imageTestsEnabled?;
        /**
         * @stability stable
         */
        get imageTestsEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set imageTestsEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetImageTestsEnabled(): void;
        /**
         * @stability stable
         */
        get imageTestsEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _timeoutMinutes?;
        /**
         * @stability stable
         */
        get timeoutMinutes(): number | undefined;
        /**
         * @stability stable
         */
        set timeoutMinutes(value: number | undefined);
        /**
         * @stability stable
         */
        resetTimeoutMinutes(): void;
        /**
         * @stability stable
         */
        get timeoutMinutesInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface ImagebuilderImageTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image.html#create ImagebuilderImage#create}.
         *
         * @stability stable
         */
        readonly create?: string;
    }
    /**
     * @stability stable
     */
    class ImagebuilderImageTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image.html aws_imagebuilder_image}.
     *
     * @stability stable
     */
    class ImagebuilderImage extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image.html aws_imagebuilder_image} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ImagebuilderImageConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get dateCreated(): string;
        private _distributionConfigurationArn?;
        /**
         * @stability stable
         */
        get distributionConfigurationArn(): string | undefined;
        /**
         * @stability stable
         */
        set distributionConfigurationArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetDistributionConfigurationArn(): void;
        /**
         * @stability stable
         */
        get distributionConfigurationArnInput(): string | undefined;
        private _enhancedImageMetadataEnabled?;
        /**
         * @stability stable
         */
        get enhancedImageMetadataEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enhancedImageMetadataEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnhancedImageMetadataEnabled(): void;
        /**
         * @stability stable
         */
        get enhancedImageMetadataEnabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _imageRecipeArn?;
        /**
         * @stability stable
         */
        get imageRecipeArn(): string;
        /**
         * @stability stable
         */
        set imageRecipeArn(value: string);
        /**
         * @stability stable
         */
        get imageRecipeArnInput(): string | undefined;
        private _infrastructureConfigurationArn?;
        /**
         * @stability stable
         */
        get infrastructureConfigurationArn(): string;
        /**
         * @stability stable
         */
        set infrastructureConfigurationArn(value: string);
        /**
         * @stability stable
         */
        get infrastructureConfigurationArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        get osVersion(): string;
        /**
         * @stability stable
         */
        outputResources(index: string): ImagebuilderImageOutputResources;
        /**
         * @stability stable
         */
        get platform(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get version(): string;
        private _imageTestsConfiguration?;
        private __imageTestsConfigurationOutput;
        /**
         * @stability stable
         */
        get imageTestsConfiguration(): ImagebuilderImageImageTestsConfigurationOutputReference;
        /**
         * @stability stable
         */
        putImageTestsConfiguration(value: ImagebuilderImageImageTestsConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetImageTestsConfiguration(): void;
        /**
         * @stability stable
         */
        get imageTestsConfigurationInput(): ImagebuilderImageImageTestsConfiguration | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): ImagebuilderImageTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: ImagebuilderImageTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): ImagebuilderImageTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ImagebuilderImagePipelineConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#description ImagebuilderImagePipeline#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#distribution_configuration_arn ImagebuilderImagePipeline#distribution_configuration_arn}.
         *
         * @stability stable
         */
        readonly distributionConfigurationArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#enhanced_image_metadata_enabled ImagebuilderImagePipeline#enhanced_image_metadata_enabled}.
         *
         * @stability stable
         */
        readonly enhancedImageMetadataEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#image_recipe_arn ImagebuilderImagePipeline#image_recipe_arn}.
         *
         * @stability stable
         */
        readonly imageRecipeArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#infrastructure_configuration_arn ImagebuilderImagePipeline#infrastructure_configuration_arn}.
         *
         * @stability stable
         */
        readonly infrastructureConfigurationArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#name ImagebuilderImagePipeline#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#status ImagebuilderImagePipeline#status}.
         *
         * @stability stable
         */
        readonly status?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#tags ImagebuilderImagePipeline#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#tags_all ImagebuilderImagePipeline#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * image_tests_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#image_tests_configuration ImagebuilderImagePipeline#image_tests_configuration}
         *
         * @stability stable
         */
        readonly imageTestsConfiguration?: ImagebuilderImagePipelineImageTestsConfiguration;
        /**
         * schedule block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#schedule ImagebuilderImagePipeline#schedule}
         *
         * @stability stable
         */
        readonly schedule?: ImagebuilderImagePipelineSchedule;
    }
    /**
     * @stability stable
     */
    interface ImagebuilderImagePipelineImageTestsConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#image_tests_enabled ImagebuilderImagePipeline#image_tests_enabled}.
         *
         * @stability stable
         */
        readonly imageTestsEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#timeout_minutes ImagebuilderImagePipeline#timeout_minutes}.
         *
         * @stability stable
         */
        readonly timeoutMinutes?: number;
    }
    /**
     * @stability stable
     */
    class ImagebuilderImagePipelineImageTestsConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _imageTestsEnabled?;
        /**
         * @stability stable
         */
        get imageTestsEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set imageTestsEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetImageTestsEnabled(): void;
        /**
         * @stability stable
         */
        get imageTestsEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _timeoutMinutes?;
        /**
         * @stability stable
         */
        get timeoutMinutes(): number | undefined;
        /**
         * @stability stable
         */
        set timeoutMinutes(value: number | undefined);
        /**
         * @stability stable
         */
        resetTimeoutMinutes(): void;
        /**
         * @stability stable
         */
        get timeoutMinutesInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface ImagebuilderImagePipelineSchedule {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#pipeline_execution_start_condition ImagebuilderImagePipeline#pipeline_execution_start_condition}.
         *
         * @stability stable
         */
        readonly pipelineExecutionStartCondition?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html#schedule_expression ImagebuilderImagePipeline#schedule_expression}.
         *
         * @stability stable
         */
        readonly scheduleExpression: string;
    }
    /**
     * @stability stable
     */
    class ImagebuilderImagePipelineScheduleOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _pipelineExecutionStartCondition?;
        /**
         * @stability stable
         */
        get pipelineExecutionStartCondition(): string | undefined;
        /**
         * @stability stable
         */
        set pipelineExecutionStartCondition(value: string | undefined);
        /**
         * @stability stable
         */
        resetPipelineExecutionStartCondition(): void;
        /**
         * @stability stable
         */
        get pipelineExecutionStartConditionInput(): string | undefined;
        private _scheduleExpression?;
        /**
         * @stability stable
         */
        get scheduleExpression(): string;
        /**
         * @stability stable
         */
        set scheduleExpression(value: string);
        /**
         * @stability stable
         */
        get scheduleExpressionInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html aws_imagebuilder_image_pipeline}.
     *
     * @stability stable
     */
    class ImagebuilderImagePipeline extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_pipeline.html aws_imagebuilder_image_pipeline} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ImagebuilderImagePipelineConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get dateCreated(): string;
        /**
         * @stability stable
         */
        get dateLastRun(): string;
        /**
         * @stability stable
         */
        get dateNextRun(): string;
        /**
         * @stability stable
         */
        get dateUpdated(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _distributionConfigurationArn?;
        /**
         * @stability stable
         */
        get distributionConfigurationArn(): string | undefined;
        /**
         * @stability stable
         */
        set distributionConfigurationArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetDistributionConfigurationArn(): void;
        /**
         * @stability stable
         */
        get distributionConfigurationArnInput(): string | undefined;
        private _enhancedImageMetadataEnabled?;
        /**
         * @stability stable
         */
        get enhancedImageMetadataEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enhancedImageMetadataEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnhancedImageMetadataEnabled(): void;
        /**
         * @stability stable
         */
        get enhancedImageMetadataEnabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _imageRecipeArn?;
        /**
         * @stability stable
         */
        get imageRecipeArn(): string;
        /**
         * @stability stable
         */
        set imageRecipeArn(value: string);
        /**
         * @stability stable
         */
        get imageRecipeArnInput(): string | undefined;
        private _infrastructureConfigurationArn?;
        /**
         * @stability stable
         */
        get infrastructureConfigurationArn(): string;
        /**
         * @stability stable
         */
        set infrastructureConfigurationArn(value: string);
        /**
         * @stability stable
         */
        get infrastructureConfigurationArnInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get platform(): string;
        private _status?;
        /**
         * @stability stable
         */
        get status(): string | undefined;
        /**
         * @stability stable
         */
        set status(value: string | undefined);
        /**
         * @stability stable
         */
        resetStatus(): void;
        /**
         * @stability stable
         */
        get statusInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _imageTestsConfiguration?;
        private __imageTestsConfigurationOutput;
        /**
         * @stability stable
         */
        get imageTestsConfiguration(): ImagebuilderImagePipelineImageTestsConfigurationOutputReference;
        /**
         * @stability stable
         */
        putImageTestsConfiguration(value: ImagebuilderImagePipelineImageTestsConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetImageTestsConfiguration(): void;
        /**
         * @stability stable
         */
        get imageTestsConfigurationInput(): ImagebuilderImagePipelineImageTestsConfiguration | undefined;
        private _schedule?;
        private __scheduleOutput;
        /**
         * @stability stable
         */
        get schedule(): ImagebuilderImagePipelineScheduleOutputReference;
        /**
         * @stability stable
         */
        putSchedule(value: ImagebuilderImagePipelineSchedule | undefined): void;
        /**
         * @stability stable
         */
        resetSchedule(): void;
        /**
         * @stability stable
         */
        get scheduleInput(): ImagebuilderImagePipelineSchedule | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ImagebuilderImageRecipeConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#description ImagebuilderImageRecipe#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#name ImagebuilderImageRecipe#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#parent_image ImagebuilderImageRecipe#parent_image}.
         *
         * @stability stable
         */
        readonly parentImage: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#tags ImagebuilderImageRecipe#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#tags_all ImagebuilderImageRecipe#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#version ImagebuilderImageRecipe#version}.
         *
         * @stability stable
         */
        readonly version: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#working_directory ImagebuilderImageRecipe#working_directory}.
         *
         * @stability stable
         */
        readonly workingDirectory?: string;
        /**
         * block_device_mapping block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#block_device_mapping ImagebuilderImageRecipe#block_device_mapping}
         *
         * @stability stable
         */
        readonly blockDeviceMapping?: ImagebuilderImageRecipeBlockDeviceMapping[];
        /**
         * component block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#component ImagebuilderImageRecipe#component}
         *
         * @stability stable
         */
        readonly component: ImagebuilderImageRecipeComponent[];
    }
    /**
     * @stability stable
     */
    interface ImagebuilderImageRecipeBlockDeviceMappingEbs {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#delete_on_termination ImagebuilderImageRecipe#delete_on_termination}.
         *
         * @stability stable
         */
        readonly deleteOnTermination?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#encrypted ImagebuilderImageRecipe#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#iops ImagebuilderImageRecipe#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#kms_key_id ImagebuilderImageRecipe#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#snapshot_id ImagebuilderImageRecipe#snapshot_id}.
         *
         * @stability stable
         */
        readonly snapshotId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#volume_size ImagebuilderImageRecipe#volume_size}.
         *
         * @stability stable
         */
        readonly volumeSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#volume_type ImagebuilderImageRecipe#volume_type}.
         *
         * @stability stable
         */
        readonly volumeType?: string;
    }
    /**
     * @stability stable
     */
    class ImagebuilderImageRecipeBlockDeviceMappingEbsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _deleteOnTermination?;
        /**
         * @stability stable
         */
        get deleteOnTermination(): string | undefined;
        /**
         * @stability stable
         */
        set deleteOnTermination(value: string | undefined);
        /**
         * @stability stable
         */
        resetDeleteOnTermination(): void;
        /**
         * @stability stable
         */
        get deleteOnTerminationInput(): string | undefined;
        private _encrypted?;
        /**
         * @stability stable
         */
        get encrypted(): string | undefined;
        /**
         * @stability stable
         */
        set encrypted(value: string | undefined);
        /**
         * @stability stable
         */
        resetEncrypted(): void;
        /**
         * @stability stable
         */
        get encryptedInput(): string | undefined;
        private _iops?;
        /**
         * @stability stable
         */
        get iops(): number | undefined;
        /**
         * @stability stable
         */
        set iops(value: number | undefined);
        /**
         * @stability stable
         */
        resetIops(): void;
        /**
         * @stability stable
         */
        get iopsInput(): number | undefined;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        private _snapshotId?;
        /**
         * @stability stable
         */
        get snapshotId(): string | undefined;
        /**
         * @stability stable
         */
        set snapshotId(value: string | undefined);
        /**
         * @stability stable
         */
        resetSnapshotId(): void;
        /**
         * @stability stable
         */
        get snapshotIdInput(): string | undefined;
        private _volumeSize?;
        /**
         * @stability stable
         */
        get volumeSize(): number | undefined;
        /**
         * @stability stable
         */
        set volumeSize(value: number | undefined);
        /**
         * @stability stable
         */
        resetVolumeSize(): void;
        /**
         * @stability stable
         */
        get volumeSizeInput(): number | undefined;
        private _volumeType?;
        /**
         * @stability stable
         */
        get volumeType(): string | undefined;
        /**
         * @stability stable
         */
        set volumeType(value: string | undefined);
        /**
         * @stability stable
         */
        resetVolumeType(): void;
        /**
         * @stability stable
         */
        get volumeTypeInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface ImagebuilderImageRecipeBlockDeviceMapping {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#device_name ImagebuilderImageRecipe#device_name}.
         *
         * @stability stable
         */
        readonly deviceName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#no_device ImagebuilderImageRecipe#no_device}.
         *
         * @stability stable
         */
        readonly noDevice?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#virtual_name ImagebuilderImageRecipe#virtual_name}.
         *
         * @stability stable
         */
        readonly virtualName?: string;
        /**
         * ebs block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#ebs ImagebuilderImageRecipe#ebs}
         *
         * @stability stable
         */
        readonly ebs?: ImagebuilderImageRecipeBlockDeviceMappingEbs;
    }
    /**
     * @stability stable
     */
    interface ImagebuilderImageRecipeComponent {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html#component_arn ImagebuilderImageRecipe#component_arn}.
         *
         * @stability stable
         */
        readonly componentArn: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html aws_imagebuilder_image_recipe}.
     *
     * @stability stable
     */
    class ImagebuilderImageRecipe extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_image_recipe.html aws_imagebuilder_image_recipe} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ImagebuilderImageRecipeConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get dateCreated(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get owner(): string;
        private _parentImage?;
        /**
         * @stability stable
         */
        get parentImage(): string;
        /**
         * @stability stable
         */
        set parentImage(value: string);
        /**
         * @stability stable
         */
        get parentImageInput(): string | undefined;
        /**
         * @stability stable
         */
        get platform(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _version?;
        /**
         * @stability stable
         */
        get version(): string;
        /**
         * @stability stable
         */
        set version(value: string);
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
        private _workingDirectory?;
        /**
         * @stability stable
         */
        get workingDirectory(): string | undefined;
        /**
         * @stability stable
         */
        set workingDirectory(value: string | undefined);
        /**
         * @stability stable
         */
        resetWorkingDirectory(): void;
        /**
         * @stability stable
         */
        get workingDirectoryInput(): string | undefined;
        private _blockDeviceMapping?;
        /**
         * @stability stable
         */
        get blockDeviceMapping(): ImagebuilderImageRecipeBlockDeviceMapping[] | undefined;
        /**
         * @stability stable
         */
        set blockDeviceMapping(value: ImagebuilderImageRecipeBlockDeviceMapping[] | undefined);
        /**
         * @stability stable
         */
        resetBlockDeviceMapping(): void;
        /**
         * @stability stable
         */
        get blockDeviceMappingInput(): ImagebuilderImageRecipeBlockDeviceMapping[] | undefined;
        private _component?;
        /**
         * @stability stable
         */
        get component(): ImagebuilderImageRecipeComponent[];
        /**
         * @stability stable
         */
        set component(value: ImagebuilderImageRecipeComponent[]);
        /**
         * @stability stable
         */
        get componentInput(): ImagebuilderImageRecipeComponent[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ImagebuilderInfrastructureConfigurationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html#description ImagebuilderInfrastructureConfiguration#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html#instance_profile_name ImagebuilderInfrastructureConfiguration#instance_profile_name}.
         *
         * @stability stable
         */
        readonly instanceProfileName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html#instance_types ImagebuilderInfrastructureConfiguration#instance_types}.
         *
         * @stability stable
         */
        readonly instanceTypes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html#key_pair ImagebuilderInfrastructureConfiguration#key_pair}.
         *
         * @stability stable
         */
        readonly keyPair?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html#name ImagebuilderInfrastructureConfiguration#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html#resource_tags ImagebuilderInfrastructureConfiguration#resource_tags}.
         *
         * @stability stable
         */
        readonly resourceTags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html#security_group_ids ImagebuilderInfrastructureConfiguration#security_group_ids}.
         *
         * @stability stable
         */
        readonly securityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html#sns_topic_arn ImagebuilderInfrastructureConfiguration#sns_topic_arn}.
         *
         * @stability stable
         */
        readonly snsTopicArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html#subnet_id ImagebuilderInfrastructureConfiguration#subnet_id}.
         *
         * @stability stable
         */
        readonly subnetId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html#tags ImagebuilderInfrastructureConfiguration#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html#tags_all ImagebuilderInfrastructureConfiguration#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html#terminate_instance_on_failure ImagebuilderInfrastructureConfiguration#terminate_instance_on_failure}.
         *
         * @stability stable
         */
        readonly terminateInstanceOnFailure?: boolean | cdktf.IResolvable;
        /**
         * logging block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html#logging ImagebuilderInfrastructureConfiguration#logging}
         *
         * @stability stable
         */
        readonly logging?: ImagebuilderInfrastructureConfigurationLogging;
    }
    /**
     * @stability stable
     */
    interface ImagebuilderInfrastructureConfigurationLoggingS3Logs {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html#s3_bucket_name ImagebuilderInfrastructureConfiguration#s3_bucket_name}.
         *
         * @stability stable
         */
        readonly s3BucketName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html#s3_key_prefix ImagebuilderInfrastructureConfiguration#s3_key_prefix}.
         *
         * @stability stable
         */
        readonly s3KeyPrefix?: string;
    }
    /**
     * @stability stable
     */
    class ImagebuilderInfrastructureConfigurationLoggingS3LogsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _s3BucketName?;
        /**
         * @stability stable
         */
        get s3BucketName(): string;
        /**
         * @stability stable
         */
        set s3BucketName(value: string);
        /**
         * @stability stable
         */
        get s3BucketNameInput(): string | undefined;
        private _s3KeyPrefix?;
        /**
         * @stability stable
         */
        get s3KeyPrefix(): string | undefined;
        /**
         * @stability stable
         */
        set s3KeyPrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetS3KeyPrefix(): void;
        /**
         * @stability stable
         */
        get s3KeyPrefixInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface ImagebuilderInfrastructureConfigurationLogging {
        /**
         * s3_logs block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html#s3_logs ImagebuilderInfrastructureConfiguration#s3_logs}
         *
         * @stability stable
         */
        readonly s3Logs: ImagebuilderInfrastructureConfigurationLoggingS3Logs;
    }
    /**
     * @stability stable
     */
    class ImagebuilderInfrastructureConfigurationLoggingOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _s3Logs?;
        private __s3LogsOutput;
        /**
         * @stability stable
         */
        get s3Logs(): ImagebuilderInfrastructureConfigurationLoggingS3LogsOutputReference;
        /**
         * @stability stable
         */
        putS3Logs(value: ImagebuilderInfrastructureConfigurationLoggingS3Logs): void;
        /**
         * @stability stable
         */
        get s3LogsInput(): ImagebuilderInfrastructureConfigurationLoggingS3Logs | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html aws_imagebuilder_infrastructure_configuration}.
     *
     * @stability stable
     */
    class ImagebuilderInfrastructureConfiguration extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/imagebuilder_infrastructure_configuration.html aws_imagebuilder_infrastructure_configuration} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ImagebuilderInfrastructureConfigurationConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get dateCreated(): string;
        /**
         * @stability stable
         */
        get dateUpdated(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceProfileName?;
        /**
         * @stability stable
         */
        get instanceProfileName(): string;
        /**
         * @stability stable
         */
        set instanceProfileName(value: string);
        /**
         * @stability stable
         */
        get instanceProfileNameInput(): string | undefined;
        private _instanceTypes?;
        /**
         * @stability stable
         */
        get instanceTypes(): string[] | undefined;
        /**
         * @stability stable
         */
        set instanceTypes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetInstanceTypes(): void;
        /**
         * @stability stable
         */
        get instanceTypesInput(): string[] | undefined;
        private _keyPair?;
        /**
         * @stability stable
         */
        get keyPair(): string | undefined;
        /**
         * @stability stable
         */
        set keyPair(value: string | undefined);
        /**
         * @stability stable
         */
        resetKeyPair(): void;
        /**
         * @stability stable
         */
        get keyPairInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _resourceTags?;
        /**
         * @stability stable
         */
        get resourceTags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set resourceTags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetResourceTags(): void;
        /**
         * @stability stable
         */
        get resourceTagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _securityGroupIds?;
        /**
         * @stability stable
         */
        get securityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set securityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get securityGroupIdsInput(): string[] | undefined;
        private _snsTopicArn?;
        /**
         * @stability stable
         */
        get snsTopicArn(): string | undefined;
        /**
         * @stability stable
         */
        set snsTopicArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetSnsTopicArn(): void;
        /**
         * @stability stable
         */
        get snsTopicArnInput(): string | undefined;
        private _subnetId?;
        /**
         * @stability stable
         */
        get subnetId(): string | undefined;
        /**
         * @stability stable
         */
        set subnetId(value: string | undefined);
        /**
         * @stability stable
         */
        resetSubnetId(): void;
        /**
         * @stability stable
         */
        get subnetIdInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _terminateInstanceOnFailure?;
        /**
         * @stability stable
         */
        get terminateInstanceOnFailure(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set terminateInstanceOnFailure(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTerminateInstanceOnFailure(): void;
        /**
         * @stability stable
         */
        get terminateInstanceOnFailureInput(): boolean | cdktf.IResolvable | undefined;
        private _logging?;
        private __loggingOutput;
        /**
         * @stability stable
         */
        get logging(): ImagebuilderInfrastructureConfigurationLoggingOutputReference;
        /**
         * @stability stable
         */
        putLogging(value: ImagebuilderInfrastructureConfigurationLogging | undefined): void;
        /**
         * @stability stable
         */
        resetLogging(): void;
        /**
         * @stability stable
         */
        get loggingInput(): ImagebuilderInfrastructureConfigurationLogging | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsImagebuilderComponentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_component.html#arn DataAwsImagebuilderComponent#arn}.
         *
         * @stability stable
         */
        readonly arn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_component.html#tags DataAwsImagebuilderComponent#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_component.html aws_imagebuilder_component}.
     *
     * @stability stable
     */
    class DataAwsImagebuilderComponent extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_component.html aws_imagebuilder_component} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsImagebuilderComponentConfig);
        private _arn?;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        set arn(value: string);
        /**
         * @stability stable
         */
        get arnInput(): string | undefined;
        /**
         * @stability stable
         */
        get changeDescription(): string;
        /**
         * @stability stable
         */
        get data(): string;
        /**
         * @stability stable
         */
        get dateCreated(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get encrypted(): any;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get kmsKeyId(): string;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        get owner(): string;
        /**
         * @stability stable
         */
        get platform(): string;
        /**
         * @stability stable
         */
        get supportedOsVersions(): string[];
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        get version(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsImagebuilderDistributionConfigurationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_distribution_configuration.html#arn DataAwsImagebuilderDistributionConfiguration#arn}.
         *
         * @stability stable
         */
        readonly arn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_distribution_configuration.html#tags DataAwsImagebuilderDistributionConfiguration#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class DataAwsImagebuilderDistributionConfigurationDistributionAmiDistributionConfigurationLaunchPermission extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get userGroups(): string[];
        /**
         * @stability stable
         */
        get userIds(): string[];
    }
    /**
     * @stability stable
     */
    class DataAwsImagebuilderDistributionConfigurationDistributionAmiDistributionConfiguration extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get amiTags(): any;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get kmsKeyId(): string;
        /**
         * @stability stable
         */
        get launchPermission(): any;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        get targetAccountIds(): string[];
    }
    /**
     * @stability stable
     */
    class DataAwsImagebuilderDistributionConfigurationDistribution extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get amiDistributionConfiguration(): any;
        /**
         * @stability stable
         */
        get licenseConfigurationArns(): string[];
        /**
         * @stability stable
         */
        get region(): string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_distribution_configuration.html aws_imagebuilder_distribution_configuration}.
     *
     * @stability stable
     */
    class DataAwsImagebuilderDistributionConfiguration extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_distribution_configuration.html aws_imagebuilder_distribution_configuration} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsImagebuilderDistributionConfigurationConfig);
        private _arn?;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        set arn(value: string);
        /**
         * @stability stable
         */
        get arnInput(): string | undefined;
        /**
         * @stability stable
         */
        get dateCreated(): string;
        /**
         * @stability stable
         */
        get dateUpdated(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        distribution(index: string): DataAwsImagebuilderDistributionConfigurationDistribution;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get name(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsImagebuilderImageConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_image.html#arn DataAwsImagebuilderImage#arn}.
         *
         * @stability stable
         */
        readonly arn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_image.html#tags DataAwsImagebuilderImage#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class DataAwsImagebuilderImageImageTestsConfiguration extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get imageTestsEnabled(): any;
        /**
         * @stability stable
         */
        get timeoutMinutes(): number;
    }
    /**
     * @stability stable
     */
    class DataAwsImagebuilderImageOutputResourcesAmis extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get accountId(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get image(): string;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        get region(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsImagebuilderImageOutputResources extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get amis(): any;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_image.html aws_imagebuilder_image}.
     *
     * @stability stable
     */
    class DataAwsImagebuilderImage extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_image.html aws_imagebuilder_image} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsImagebuilderImageConfig);
        private _arn?;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        set arn(value: string);
        /**
         * @stability stable
         */
        get arnInput(): string | undefined;
        /**
         * @stability stable
         */
        get buildVersionArn(): string;
        /**
         * @stability stable
         */
        get dateCreated(): string;
        /**
         * @stability stable
         */
        get distributionConfigurationArn(): string;
        /**
         * @stability stable
         */
        get enhancedImageMetadataEnabled(): any;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get imageRecipeArn(): string;
        /**
         * @stability stable
         */
        imageTestsConfiguration(index: string): DataAwsImagebuilderImageImageTestsConfiguration;
        /**
         * @stability stable
         */
        get infrastructureConfigurationArn(): string;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        get osVersion(): string;
        /**
         * @stability stable
         */
        outputResources(index: string): DataAwsImagebuilderImageOutputResources;
        /**
         * @stability stable
         */
        get platform(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get version(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsImagebuilderImagePipelineConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_image_pipeline.html#arn DataAwsImagebuilderImagePipeline#arn}.
         *
         * @stability stable
         */
        readonly arn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_image_pipeline.html#tags DataAwsImagebuilderImagePipeline#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class DataAwsImagebuilderImagePipelineImageTestsConfiguration extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get imageTestsEnabled(): any;
        /**
         * @stability stable
         */
        get timeoutMinutes(): number;
    }
    /**
     * @stability stable
     */
    class DataAwsImagebuilderImagePipelineSchedule extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get pipelineExecutionStartCondition(): string;
        /**
         * @stability stable
         */
        get scheduleExpression(): string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_image_pipeline.html aws_imagebuilder_image_pipeline}.
     *
     * @stability stable
     */
    class DataAwsImagebuilderImagePipeline extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_image_pipeline.html aws_imagebuilder_image_pipeline} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsImagebuilderImagePipelineConfig);
        private _arn?;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        set arn(value: string);
        /**
         * @stability stable
         */
        get arnInput(): string | undefined;
        /**
         * @stability stable
         */
        get dateCreated(): string;
        /**
         * @stability stable
         */
        get dateLastRun(): string;
        /**
         * @stability stable
         */
        get dateNextRun(): string;
        /**
         * @stability stable
         */
        get dateUpdated(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get distributionConfigurationArn(): string;
        /**
         * @stability stable
         */
        get enhancedImageMetadataEnabled(): any;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get imageRecipeArn(): string;
        /**
         * @stability stable
         */
        imageTestsConfiguration(index: string): DataAwsImagebuilderImagePipelineImageTestsConfiguration;
        /**
         * @stability stable
         */
        get infrastructureConfigurationArn(): string;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        get platform(): string;
        /**
         * @stability stable
         */
        schedule(index: string): DataAwsImagebuilderImagePipelineSchedule;
        /**
         * @stability stable
         */
        get status(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsImagebuilderImageRecipeConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_image_recipe.html#arn DataAwsImagebuilderImageRecipe#arn}.
         *
         * @stability stable
         */
        readonly arn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_image_recipe.html#tags DataAwsImagebuilderImageRecipe#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class DataAwsImagebuilderImageRecipeBlockDeviceMappingEbs extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get deleteOnTermination(): any;
        /**
         * @stability stable
         */
        get encrypted(): any;
        /**
         * @stability stable
         */
        get iops(): number;
        /**
         * @stability stable
         */
        get kmsKeyId(): string;
        /**
         * @stability stable
         */
        get snapshotId(): string;
        /**
         * @stability stable
         */
        get volumeSize(): number;
        /**
         * @stability stable
         */
        get volumeType(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsImagebuilderImageRecipeBlockDeviceMapping extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get deviceName(): string;
        /**
         * @stability stable
         */
        get ebs(): any;
        /**
         * @stability stable
         */
        get noDevice(): string;
        /**
         * @stability stable
         */
        get virtualName(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsImagebuilderImageRecipeComponent extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get componentArn(): string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_image_recipe.html aws_imagebuilder_image_recipe}.
     *
     * @stability stable
     */
    class DataAwsImagebuilderImageRecipe extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_image_recipe.html aws_imagebuilder_image_recipe} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsImagebuilderImageRecipeConfig);
        private _arn?;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        set arn(value: string);
        /**
         * @stability stable
         */
        get arnInput(): string | undefined;
        /**
         * @stability stable
         */
        blockDeviceMapping(index: string): DataAwsImagebuilderImageRecipeBlockDeviceMapping;
        /**
         * @stability stable
         */
        component(index: string): DataAwsImagebuilderImageRecipeComponent;
        /**
         * @stability stable
         */
        get dateCreated(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        get owner(): string;
        /**
         * @stability stable
         */
        get parentImage(): string;
        /**
         * @stability stable
         */
        get platform(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get version(): string;
        /**
         * @stability stable
         */
        get workingDirectory(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsImagebuilderInfrastructureConfigurationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_infrastructure_configuration.html#arn DataAwsImagebuilderInfrastructureConfiguration#arn}.
         *
         * @stability stable
         */
        readonly arn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_infrastructure_configuration.html#resource_tags DataAwsImagebuilderInfrastructureConfiguration#resource_tags}.
         *
         * @stability stable
         */
        readonly resourceTags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_infrastructure_configuration.html#tags DataAwsImagebuilderInfrastructureConfiguration#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class DataAwsImagebuilderInfrastructureConfigurationLoggingS3Logs extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get s3BucketName(): string;
        /**
         * @stability stable
         */
        get s3KeyPrefix(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsImagebuilderInfrastructureConfigurationLogging extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get s3Logs(): any;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_infrastructure_configuration.html aws_imagebuilder_infrastructure_configuration}.
     *
     * @stability stable
     */
    class DataAwsImagebuilderInfrastructureConfiguration extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_infrastructure_configuration.html aws_imagebuilder_infrastructure_configuration} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsImagebuilderInfrastructureConfigurationConfig);
        private _arn?;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        set arn(value: string);
        /**
         * @stability stable
         */
        get arnInput(): string | undefined;
        /**
         * @stability stable
         */
        get dateCreated(): string;
        /**
         * @stability stable
         */
        get dateUpdated(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get instanceProfileName(): string;
        /**
         * @stability stable
         */
        get instanceTypes(): string[];
        /**
         * @stability stable
         */
        get keyPair(): string;
        /**
         * @stability stable
         */
        logging(index: string): DataAwsImagebuilderInfrastructureConfigurationLogging;
        /**
         * @stability stable
         */
        get name(): string;
        private _resourceTags?;
        /**
         * @stability stable
         */
        get resourceTags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set resourceTags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetResourceTags(): void;
        /**
         * @stability stable
         */
        get resourceTagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get securityGroupIds(): string[];
        /**
         * @stability stable
         */
        get snsTopicArn(): string;
        /**
         * @stability stable
         */
        get subnetId(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get terminateInstanceOnFailure(): any;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
