import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Lex
*/
export declare namespace Lex {
    /**
     * @stability stable
     */
    interface LexBotConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#child_directed LexBot#child_directed}.
         *
         * @stability stable
         */
        readonly childDirected: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#create_version LexBot#create_version}.
         *
         * @stability stable
         */
        readonly createVersion?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#description LexBot#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#detect_sentiment LexBot#detect_sentiment}.
         *
         * @stability stable
         */
        readonly detectSentiment?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#enable_model_improvements LexBot#enable_model_improvements}.
         *
         * @stability stable
         */
        readonly enableModelImprovements?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#idle_session_ttl_in_seconds LexBot#idle_session_ttl_in_seconds}.
         *
         * @stability stable
         */
        readonly idleSessionTtlInSeconds?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#locale LexBot#locale}.
         *
         * @stability stable
         */
        readonly locale?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#name LexBot#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#nlu_intent_confidence_threshold LexBot#nlu_intent_confidence_threshold}.
         *
         * @stability stable
         */
        readonly nluIntentConfidenceThreshold?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#process_behavior LexBot#process_behavior}.
         *
         * @stability stable
         */
        readonly processBehavior?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#voice_id LexBot#voice_id}.
         *
         * @stability stable
         */
        readonly voiceId?: string;
        /**
         * abort_statement block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#abort_statement LexBot#abort_statement}
         *
         * @stability stable
         */
        readonly abortStatement: LexBotAbortStatement;
        /**
         * clarification_prompt block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#clarification_prompt LexBot#clarification_prompt}
         *
         * @stability stable
         */
        readonly clarificationPrompt?: LexBotClarificationPrompt;
        /**
         * intent block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#intent LexBot#intent}
         *
         * @stability stable
         */
        readonly intent: LexBotIntent[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#timeouts LexBot#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: LexBotTimeouts;
    }
    /**
     * @stability stable
     */
    interface LexBotAbortStatementMessage {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#content LexBot#content}.
         *
         * @stability stable
         */
        readonly content: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#content_type LexBot#content_type}.
         *
         * @stability stable
         */
        readonly contentType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#group_number LexBot#group_number}.
         *
         * @stability stable
         */
        readonly groupNumber?: number;
    }
    /**
     * @stability stable
     */
    interface LexBotAbortStatement {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#response_card LexBot#response_card}.
         *
         * @stability stable
         */
        readonly responseCard?: string;
        /**
         * message block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#message LexBot#message}
         *
         * @stability stable
         */
        readonly message: LexBotAbortStatementMessage[];
    }
    /**
     * @stability stable
     */
    class LexBotAbortStatementOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _responseCard?;
        /**
         * @stability stable
         */
        get responseCard(): string | undefined;
        /**
         * @stability stable
         */
        set responseCard(value: string | undefined);
        /**
         * @stability stable
         */
        resetResponseCard(): void;
        /**
         * @stability stable
         */
        get responseCardInput(): string | undefined;
        private _message?;
        /**
         * @stability stable
         */
        get message(): LexBotAbortStatementMessage[];
        /**
         * @stability stable
         */
        set message(value: LexBotAbortStatementMessage[]);
        /**
         * @stability stable
         */
        get messageInput(): LexBotAbortStatementMessage[] | undefined;
    }
    /**
     * @stability stable
     */
    interface LexBotClarificationPromptMessage {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#content LexBot#content}.
         *
         * @stability stable
         */
        readonly content: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#content_type LexBot#content_type}.
         *
         * @stability stable
         */
        readonly contentType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#group_number LexBot#group_number}.
         *
         * @stability stable
         */
        readonly groupNumber?: number;
    }
    /**
     * @stability stable
     */
    interface LexBotClarificationPrompt {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#max_attempts LexBot#max_attempts}.
         *
         * @stability stable
         */
        readonly maxAttempts: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#response_card LexBot#response_card}.
         *
         * @stability stable
         */
        readonly responseCard?: string;
        /**
         * message block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#message LexBot#message}
         *
         * @stability stable
         */
        readonly message: LexBotClarificationPromptMessage[];
    }
    /**
     * @stability stable
     */
    class LexBotClarificationPromptOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _maxAttempts?;
        /**
         * @stability stable
         */
        get maxAttempts(): number;
        /**
         * @stability stable
         */
        set maxAttempts(value: number);
        /**
         * @stability stable
         */
        get maxAttemptsInput(): number | undefined;
        private _responseCard?;
        /**
         * @stability stable
         */
        get responseCard(): string | undefined;
        /**
         * @stability stable
         */
        set responseCard(value: string | undefined);
        /**
         * @stability stable
         */
        resetResponseCard(): void;
        /**
         * @stability stable
         */
        get responseCardInput(): string | undefined;
        private _message?;
        /**
         * @stability stable
         */
        get message(): LexBotClarificationPromptMessage[];
        /**
         * @stability stable
         */
        set message(value: LexBotClarificationPromptMessage[]);
        /**
         * @stability stable
         */
        get messageInput(): LexBotClarificationPromptMessage[] | undefined;
    }
    /**
     * @stability stable
     */
    interface LexBotIntent {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#intent_name LexBot#intent_name}.
         *
         * @stability stable
         */
        readonly intentName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#intent_version LexBot#intent_version}.
         *
         * @stability stable
         */
        readonly intentVersion: string;
    }
    /**
     * @stability stable
     */
    interface LexBotTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#create LexBot#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#delete LexBot#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html#update LexBot#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class LexBotTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html aws_lex_bot}.
     *
     * @stability stable
     */
    class LexBot extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lex_bot.html aws_lex_bot} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: LexBotConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get checksum(): string;
        private _childDirected?;
        /**
         * @stability stable
         */
        get childDirected(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set childDirected(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get childDirectedInput(): boolean | cdktf.IResolvable | undefined;
        private _createVersion?;
        /**
         * @stability stable
         */
        get createVersion(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set createVersion(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetCreateVersion(): void;
        /**
         * @stability stable
         */
        get createVersionInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get createdDate(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _detectSentiment?;
        /**
         * @stability stable
         */
        get detectSentiment(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set detectSentiment(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDetectSentiment(): void;
        /**
         * @stability stable
         */
        get detectSentimentInput(): boolean | cdktf.IResolvable | undefined;
        private _enableModelImprovements?;
        /**
         * @stability stable
         */
        get enableModelImprovements(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableModelImprovements(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableModelImprovements(): void;
        /**
         * @stability stable
         */
        get enableModelImprovementsInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get failureReason(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _idleSessionTtlInSeconds?;
        /**
         * @stability stable
         */
        get idleSessionTtlInSeconds(): number | undefined;
        /**
         * @stability stable
         */
        set idleSessionTtlInSeconds(value: number | undefined);
        /**
         * @stability stable
         */
        resetIdleSessionTtlInSeconds(): void;
        /**
         * @stability stable
         */
        get idleSessionTtlInSecondsInput(): number | undefined;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        private _locale?;
        /**
         * @stability stable
         */
        get locale(): string | undefined;
        /**
         * @stability stable
         */
        set locale(value: string | undefined);
        /**
         * @stability stable
         */
        resetLocale(): void;
        /**
         * @stability stable
         */
        get localeInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _nluIntentConfidenceThreshold?;
        /**
         * @stability stable
         */
        get nluIntentConfidenceThreshold(): number | undefined;
        /**
         * @stability stable
         */
        set nluIntentConfidenceThreshold(value: number | undefined);
        /**
         * @stability stable
         */
        resetNluIntentConfidenceThreshold(): void;
        /**
         * @stability stable
         */
        get nluIntentConfidenceThresholdInput(): number | undefined;
        private _processBehavior?;
        /**
         * @stability stable
         */
        get processBehavior(): string | undefined;
        /**
         * @stability stable
         */
        set processBehavior(value: string | undefined);
        /**
         * @stability stable
         */
        resetProcessBehavior(): void;
        /**
         * @stability stable
         */
        get processBehaviorInput(): string | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        get version(): string;
        private _voiceId?;
        /**
         * @stability stable
         */
        get voiceId(): string | undefined;
        /**
         * @stability stable
         */
        set voiceId(value: string | undefined);
        /**
         * @stability stable
         */
        resetVoiceId(): void;
        /**
         * @stability stable
         */
        get voiceIdInput(): string | undefined;
        private _abortStatement?;
        private __abortStatementOutput;
        /**
         * @stability stable
         */
        get abortStatement(): LexBotAbortStatementOutputReference;
        /**
         * @stability stable
         */
        putAbortStatement(value: LexBotAbortStatement): void;
        /**
         * @stability stable
         */
        get abortStatementInput(): LexBotAbortStatement | undefined;
        private _clarificationPrompt?;
        private __clarificationPromptOutput;
        /**
         * @stability stable
         */
        get clarificationPrompt(): LexBotClarificationPromptOutputReference;
        /**
         * @stability stable
         */
        putClarificationPrompt(value: LexBotClarificationPrompt | undefined): void;
        /**
         * @stability stable
         */
        resetClarificationPrompt(): void;
        /**
         * @stability stable
         */
        get clarificationPromptInput(): LexBotClarificationPrompt | undefined;
        private _intent?;
        /**
         * @stability stable
         */
        get intent(): LexBotIntent[];
        /**
         * @stability stable
         */
        set intent(value: LexBotIntent[]);
        /**
         * @stability stable
         */
        get intentInput(): LexBotIntent[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): LexBotTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: LexBotTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): LexBotTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface LexBotAliasConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html#bot_name LexBotAlias#bot_name}.
         *
         * @stability stable
         */
        readonly botName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html#bot_version LexBotAlias#bot_version}.
         *
         * @stability stable
         */
        readonly botVersion: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html#description LexBotAlias#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html#name LexBotAlias#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * conversation_logs block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html#conversation_logs LexBotAlias#conversation_logs}
         *
         * @stability stable
         */
        readonly conversationLogs?: LexBotAliasConversationLogs;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html#timeouts LexBotAlias#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: LexBotAliasTimeouts;
    }
    /**
     * @stability stable
     */
    interface LexBotAliasConversationLogsLogSettings {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html#destination LexBotAlias#destination}.
         *
         * @stability stable
         */
        readonly destination: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html#kms_key_arn LexBotAlias#kms_key_arn}.
         *
         * @stability stable
         */
        readonly kmsKeyArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html#log_type LexBotAlias#log_type}.
         *
         * @stability stable
         */
        readonly logType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html#resource_arn LexBotAlias#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
    }
    /**
     * @stability stable
     */
    interface LexBotAliasConversationLogs {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html#iam_role_arn LexBotAlias#iam_role_arn}.
         *
         * @stability stable
         */
        readonly iamRoleArn: string;
        /**
         * log_settings block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html#log_settings LexBotAlias#log_settings}
         *
         * @stability stable
         */
        readonly logSettings?: LexBotAliasConversationLogsLogSettings[];
    }
    /**
     * @stability stable
     */
    class LexBotAliasConversationLogsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _iamRoleArn?;
        /**
         * @stability stable
         */
        get iamRoleArn(): string;
        /**
         * @stability stable
         */
        set iamRoleArn(value: string);
        /**
         * @stability stable
         */
        get iamRoleArnInput(): string | undefined;
        private _logSettings?;
        /**
         * @stability stable
         */
        get logSettings(): LexBotAliasConversationLogsLogSettings[] | undefined;
        /**
         * @stability stable
         */
        set logSettings(value: LexBotAliasConversationLogsLogSettings[] | undefined);
        /**
         * @stability stable
         */
        resetLogSettings(): void;
        /**
         * @stability stable
         */
        get logSettingsInput(): LexBotAliasConversationLogsLogSettings[] | undefined;
    }
    /**
     * @stability stable
     */
    interface LexBotAliasTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html#create LexBotAlias#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html#delete LexBotAlias#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html#update LexBotAlias#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class LexBotAliasTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html aws_lex_bot_alias}.
     *
     * @stability stable
     */
    class LexBotAlias extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lex_bot_alias.html aws_lex_bot_alias} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: LexBotAliasConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _botName?;
        /**
         * @stability stable
         */
        get botName(): string;
        /**
         * @stability stable
         */
        set botName(value: string);
        /**
         * @stability stable
         */
        get botNameInput(): string | undefined;
        private _botVersion?;
        /**
         * @stability stable
         */
        get botVersion(): string;
        /**
         * @stability stable
         */
        set botVersion(value: string);
        /**
         * @stability stable
         */
        get botVersionInput(): string | undefined;
        /**
         * @stability stable
         */
        get checksum(): string;
        /**
         * @stability stable
         */
        get createdDate(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _conversationLogs?;
        private __conversationLogsOutput;
        /**
         * @stability stable
         */
        get conversationLogs(): LexBotAliasConversationLogsOutputReference;
        /**
         * @stability stable
         */
        putConversationLogs(value: LexBotAliasConversationLogs | undefined): void;
        /**
         * @stability stable
         */
        resetConversationLogs(): void;
        /**
         * @stability stable
         */
        get conversationLogsInput(): LexBotAliasConversationLogs | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): LexBotAliasTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: LexBotAliasTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): LexBotAliasTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface LexIntentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#create_version LexIntent#create_version}.
         *
         * @stability stable
         */
        readonly createVersion?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#description LexIntent#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#name LexIntent#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#parent_intent_signature LexIntent#parent_intent_signature}.
         *
         * @stability stable
         */
        readonly parentIntentSignature?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#sample_utterances LexIntent#sample_utterances}.
         *
         * @stability stable
         */
        readonly sampleUtterances?: string[];
        /**
         * conclusion_statement block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#conclusion_statement LexIntent#conclusion_statement}
         *
         * @stability stable
         */
        readonly conclusionStatement?: LexIntentConclusionStatement;
        /**
         * confirmation_prompt block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#confirmation_prompt LexIntent#confirmation_prompt}
         *
         * @stability stable
         */
        readonly confirmationPrompt?: LexIntentConfirmationPrompt;
        /**
         * dialog_code_hook block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#dialog_code_hook LexIntent#dialog_code_hook}
         *
         * @stability stable
         */
        readonly dialogCodeHook?: LexIntentDialogCodeHook;
        /**
         * follow_up_prompt block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#follow_up_prompt LexIntent#follow_up_prompt}
         *
         * @stability stable
         */
        readonly followUpPrompt?: LexIntentFollowUpPrompt;
        /**
         * fulfillment_activity block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#fulfillment_activity LexIntent#fulfillment_activity}
         *
         * @stability stable
         */
        readonly fulfillmentActivity: LexIntentFulfillmentActivity;
        /**
         * rejection_statement block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#rejection_statement LexIntent#rejection_statement}
         *
         * @stability stable
         */
        readonly rejectionStatement?: LexIntentRejectionStatement;
        /**
         * slot block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#slot LexIntent#slot}
         *
         * @stability stable
         */
        readonly slot?: LexIntentSlot[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#timeouts LexIntent#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: LexIntentTimeouts;
    }
    /**
     * @stability stable
     */
    interface LexIntentConclusionStatementMessage {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content LexIntent#content}.
         *
         * @stability stable
         */
        readonly content: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content_type LexIntent#content_type}.
         *
         * @stability stable
         */
        readonly contentType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#group_number LexIntent#group_number}.
         *
         * @stability stable
         */
        readonly groupNumber?: number;
    }
    /**
     * @stability stable
     */
    interface LexIntentConclusionStatement {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#response_card LexIntent#response_card}.
         *
         * @stability stable
         */
        readonly responseCard?: string;
        /**
         * message block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#message LexIntent#message}
         *
         * @stability stable
         */
        readonly message: LexIntentConclusionStatementMessage[];
    }
    /**
     * @stability stable
     */
    class LexIntentConclusionStatementOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _responseCard?;
        /**
         * @stability stable
         */
        get responseCard(): string | undefined;
        /**
         * @stability stable
         */
        set responseCard(value: string | undefined);
        /**
         * @stability stable
         */
        resetResponseCard(): void;
        /**
         * @stability stable
         */
        get responseCardInput(): string | undefined;
        private _message?;
        /**
         * @stability stable
         */
        get message(): LexIntentConclusionStatementMessage[];
        /**
         * @stability stable
         */
        set message(value: LexIntentConclusionStatementMessage[]);
        /**
         * @stability stable
         */
        get messageInput(): LexIntentConclusionStatementMessage[] | undefined;
    }
    /**
     * @stability stable
     */
    interface LexIntentConfirmationPromptMessage {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content LexIntent#content}.
         *
         * @stability stable
         */
        readonly content: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content_type LexIntent#content_type}.
         *
         * @stability stable
         */
        readonly contentType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#group_number LexIntent#group_number}.
         *
         * @stability stable
         */
        readonly groupNumber?: number;
    }
    /**
     * @stability stable
     */
    interface LexIntentConfirmationPrompt {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#max_attempts LexIntent#max_attempts}.
         *
         * @stability stable
         */
        readonly maxAttempts: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#response_card LexIntent#response_card}.
         *
         * @stability stable
         */
        readonly responseCard?: string;
        /**
         * message block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#message LexIntent#message}
         *
         * @stability stable
         */
        readonly message: LexIntentConfirmationPromptMessage[];
    }
    /**
     * @stability stable
     */
    class LexIntentConfirmationPromptOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _maxAttempts?;
        /**
         * @stability stable
         */
        get maxAttempts(): number;
        /**
         * @stability stable
         */
        set maxAttempts(value: number);
        /**
         * @stability stable
         */
        get maxAttemptsInput(): number | undefined;
        private _responseCard?;
        /**
         * @stability stable
         */
        get responseCard(): string | undefined;
        /**
         * @stability stable
         */
        set responseCard(value: string | undefined);
        /**
         * @stability stable
         */
        resetResponseCard(): void;
        /**
         * @stability stable
         */
        get responseCardInput(): string | undefined;
        private _message?;
        /**
         * @stability stable
         */
        get message(): LexIntentConfirmationPromptMessage[];
        /**
         * @stability stable
         */
        set message(value: LexIntentConfirmationPromptMessage[]);
        /**
         * @stability stable
         */
        get messageInput(): LexIntentConfirmationPromptMessage[] | undefined;
    }
    /**
     * @stability stable
     */
    interface LexIntentDialogCodeHook {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#message_version LexIntent#message_version}.
         *
         * @stability stable
         */
        readonly messageVersion: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#uri LexIntent#uri}.
         *
         * @stability stable
         */
        readonly uri: string;
    }
    /**
     * @stability stable
     */
    class LexIntentDialogCodeHookOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _messageVersion?;
        /**
         * @stability stable
         */
        get messageVersion(): string;
        /**
         * @stability stable
         */
        set messageVersion(value: string);
        /**
         * @stability stable
         */
        get messageVersionInput(): string | undefined;
        private _uri?;
        /**
         * @stability stable
         */
        get uri(): string;
        /**
         * @stability stable
         */
        set uri(value: string);
        /**
         * @stability stable
         */
        get uriInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface LexIntentFollowUpPromptPromptMessage {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content LexIntent#content}.
         *
         * @stability stable
         */
        readonly content: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content_type LexIntent#content_type}.
         *
         * @stability stable
         */
        readonly contentType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#group_number LexIntent#group_number}.
         *
         * @stability stable
         */
        readonly groupNumber?: number;
    }
    /**
     * @stability stable
     */
    interface LexIntentFollowUpPromptPrompt {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#max_attempts LexIntent#max_attempts}.
         *
         * @stability stable
         */
        readonly maxAttempts: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#response_card LexIntent#response_card}.
         *
         * @stability stable
         */
        readonly responseCard?: string;
        /**
         * message block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#message LexIntent#message}
         *
         * @stability stable
         */
        readonly message: LexIntentFollowUpPromptPromptMessage[];
    }
    /**
     * @stability stable
     */
    class LexIntentFollowUpPromptPromptOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _maxAttempts?;
        /**
         * @stability stable
         */
        get maxAttempts(): number;
        /**
         * @stability stable
         */
        set maxAttempts(value: number);
        /**
         * @stability stable
         */
        get maxAttemptsInput(): number | undefined;
        private _responseCard?;
        /**
         * @stability stable
         */
        get responseCard(): string | undefined;
        /**
         * @stability stable
         */
        set responseCard(value: string | undefined);
        /**
         * @stability stable
         */
        resetResponseCard(): void;
        /**
         * @stability stable
         */
        get responseCardInput(): string | undefined;
        private _message?;
        /**
         * @stability stable
         */
        get message(): LexIntentFollowUpPromptPromptMessage[];
        /**
         * @stability stable
         */
        set message(value: LexIntentFollowUpPromptPromptMessage[]);
        /**
         * @stability stable
         */
        get messageInput(): LexIntentFollowUpPromptPromptMessage[] | undefined;
    }
    /**
     * @stability stable
     */
    interface LexIntentFollowUpPromptRejectionStatementMessage {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content LexIntent#content}.
         *
         * @stability stable
         */
        readonly content: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content_type LexIntent#content_type}.
         *
         * @stability stable
         */
        readonly contentType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#group_number LexIntent#group_number}.
         *
         * @stability stable
         */
        readonly groupNumber?: number;
    }
    /**
     * @stability stable
     */
    interface LexIntentFollowUpPromptRejectionStatement {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#response_card LexIntent#response_card}.
         *
         * @stability stable
         */
        readonly responseCard?: string;
        /**
         * message block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#message LexIntent#message}
         *
         * @stability stable
         */
        readonly message: LexIntentFollowUpPromptRejectionStatementMessage[];
    }
    /**
     * @stability stable
     */
    class LexIntentFollowUpPromptRejectionStatementOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _responseCard?;
        /**
         * @stability stable
         */
        get responseCard(): string | undefined;
        /**
         * @stability stable
         */
        set responseCard(value: string | undefined);
        /**
         * @stability stable
         */
        resetResponseCard(): void;
        /**
         * @stability stable
         */
        get responseCardInput(): string | undefined;
        private _message?;
        /**
         * @stability stable
         */
        get message(): LexIntentFollowUpPromptRejectionStatementMessage[];
        /**
         * @stability stable
         */
        set message(value: LexIntentFollowUpPromptRejectionStatementMessage[]);
        /**
         * @stability stable
         */
        get messageInput(): LexIntentFollowUpPromptRejectionStatementMessage[] | undefined;
    }
    /**
     * @stability stable
     */
    interface LexIntentFollowUpPrompt {
        /**
         * prompt block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#prompt LexIntent#prompt}
         *
         * @stability stable
         */
        readonly prompt: LexIntentFollowUpPromptPrompt;
        /**
         * rejection_statement block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#rejection_statement LexIntent#rejection_statement}
         *
         * @stability stable
         */
        readonly rejectionStatement: LexIntentFollowUpPromptRejectionStatement;
    }
    /**
     * @stability stable
     */
    class LexIntentFollowUpPromptOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _prompt?;
        private __promptOutput;
        /**
         * @stability stable
         */
        get prompt(): LexIntentFollowUpPromptPromptOutputReference;
        /**
         * @stability stable
         */
        putPrompt(value: LexIntentFollowUpPromptPrompt): void;
        /**
         * @stability stable
         */
        get promptInput(): LexIntentFollowUpPromptPrompt | undefined;
        private _rejectionStatement?;
        private __rejectionStatementOutput;
        /**
         * @stability stable
         */
        get rejectionStatement(): LexIntentFollowUpPromptRejectionStatementOutputReference;
        /**
         * @stability stable
         */
        putRejectionStatement(value: LexIntentFollowUpPromptRejectionStatement): void;
        /**
         * @stability stable
         */
        get rejectionStatementInput(): LexIntentFollowUpPromptRejectionStatement | undefined;
    }
    /**
     * @stability stable
     */
    interface LexIntentFulfillmentActivityCodeHook {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#message_version LexIntent#message_version}.
         *
         * @stability stable
         */
        readonly messageVersion: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#uri LexIntent#uri}.
         *
         * @stability stable
         */
        readonly uri: string;
    }
    /**
     * @stability stable
     */
    class LexIntentFulfillmentActivityCodeHookOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _messageVersion?;
        /**
         * @stability stable
         */
        get messageVersion(): string;
        /**
         * @stability stable
         */
        set messageVersion(value: string);
        /**
         * @stability stable
         */
        get messageVersionInput(): string | undefined;
        private _uri?;
        /**
         * @stability stable
         */
        get uri(): string;
        /**
         * @stability stable
         */
        set uri(value: string);
        /**
         * @stability stable
         */
        get uriInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface LexIntentFulfillmentActivity {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#type LexIntent#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * code_hook block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#code_hook LexIntent#code_hook}
         *
         * @stability stable
         */
        readonly codeHook?: LexIntentFulfillmentActivityCodeHook;
    }
    /**
     * @stability stable
     */
    class LexIntentFulfillmentActivityOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _codeHook?;
        private __codeHookOutput;
        /**
         * @stability stable
         */
        get codeHook(): LexIntentFulfillmentActivityCodeHookOutputReference;
        /**
         * @stability stable
         */
        putCodeHook(value: LexIntentFulfillmentActivityCodeHook | undefined): void;
        /**
         * @stability stable
         */
        resetCodeHook(): void;
        /**
         * @stability stable
         */
        get codeHookInput(): LexIntentFulfillmentActivityCodeHook | undefined;
    }
    /**
     * @stability stable
     */
    interface LexIntentRejectionStatementMessage {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content LexIntent#content}.
         *
         * @stability stable
         */
        readonly content: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content_type LexIntent#content_type}.
         *
         * @stability stable
         */
        readonly contentType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#group_number LexIntent#group_number}.
         *
         * @stability stable
         */
        readonly groupNumber?: number;
    }
    /**
     * @stability stable
     */
    interface LexIntentRejectionStatement {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#response_card LexIntent#response_card}.
         *
         * @stability stable
         */
        readonly responseCard?: string;
        /**
         * message block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#message LexIntent#message}
         *
         * @stability stable
         */
        readonly message: LexIntentRejectionStatementMessage[];
    }
    /**
     * @stability stable
     */
    class LexIntentRejectionStatementOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _responseCard?;
        /**
         * @stability stable
         */
        get responseCard(): string | undefined;
        /**
         * @stability stable
         */
        set responseCard(value: string | undefined);
        /**
         * @stability stable
         */
        resetResponseCard(): void;
        /**
         * @stability stable
         */
        get responseCardInput(): string | undefined;
        private _message?;
        /**
         * @stability stable
         */
        get message(): LexIntentRejectionStatementMessage[];
        /**
         * @stability stable
         */
        set message(value: LexIntentRejectionStatementMessage[]);
        /**
         * @stability stable
         */
        get messageInput(): LexIntentRejectionStatementMessage[] | undefined;
    }
    /**
     * @stability stable
     */
    interface LexIntentSlotValueElicitationPromptMessage {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content LexIntent#content}.
         *
         * @stability stable
         */
        readonly content: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#content_type LexIntent#content_type}.
         *
         * @stability stable
         */
        readonly contentType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#group_number LexIntent#group_number}.
         *
         * @stability stable
         */
        readonly groupNumber?: number;
    }
    /**
     * @stability stable
     */
    interface LexIntentSlotValueElicitationPrompt {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#max_attempts LexIntent#max_attempts}.
         *
         * @stability stable
         */
        readonly maxAttempts: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#response_card LexIntent#response_card}.
         *
         * @stability stable
         */
        readonly responseCard?: string;
        /**
         * message block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#message LexIntent#message}
         *
         * @stability stable
         */
        readonly message: LexIntentSlotValueElicitationPromptMessage[];
    }
    /**
     * @stability stable
     */
    class LexIntentSlotValueElicitationPromptOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _maxAttempts?;
        /**
         * @stability stable
         */
        get maxAttempts(): number;
        /**
         * @stability stable
         */
        set maxAttempts(value: number);
        /**
         * @stability stable
         */
        get maxAttemptsInput(): number | undefined;
        private _responseCard?;
        /**
         * @stability stable
         */
        get responseCard(): string | undefined;
        /**
         * @stability stable
         */
        set responseCard(value: string | undefined);
        /**
         * @stability stable
         */
        resetResponseCard(): void;
        /**
         * @stability stable
         */
        get responseCardInput(): string | undefined;
        private _message?;
        /**
         * @stability stable
         */
        get message(): LexIntentSlotValueElicitationPromptMessage[];
        /**
         * @stability stable
         */
        set message(value: LexIntentSlotValueElicitationPromptMessage[]);
        /**
         * @stability stable
         */
        get messageInput(): LexIntentSlotValueElicitationPromptMessage[] | undefined;
    }
    /**
     * @stability stable
     */
    interface LexIntentSlot {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#description LexIntent#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#name LexIntent#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#priority LexIntent#priority}.
         *
         * @stability stable
         */
        readonly priority?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#response_card LexIntent#response_card}.
         *
         * @stability stable
         */
        readonly responseCard?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#sample_utterances LexIntent#sample_utterances}.
         *
         * @stability stable
         */
        readonly sampleUtterances?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#slot_constraint LexIntent#slot_constraint}.
         *
         * @stability stable
         */
        readonly slotConstraint: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#slot_type LexIntent#slot_type}.
         *
         * @stability stable
         */
        readonly slotType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#slot_type_version LexIntent#slot_type_version}.
         *
         * @stability stable
         */
        readonly slotTypeVersion?: string;
        /**
         * value_elicitation_prompt block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#value_elicitation_prompt LexIntent#value_elicitation_prompt}
         *
         * @stability stable
         */
        readonly valueElicitationPrompt?: LexIntentSlotValueElicitationPrompt;
    }
    /**
     * @stability stable
     */
    interface LexIntentTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#create LexIntent#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#delete LexIntent#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html#update LexIntent#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class LexIntentTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html aws_lex_intent}.
     *
     * @stability stable
     */
    class LexIntent extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lex_intent.html aws_lex_intent} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: LexIntentConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get checksum(): string;
        private _createVersion?;
        /**
         * @stability stable
         */
        get createVersion(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set createVersion(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetCreateVersion(): void;
        /**
         * @stability stable
         */
        get createVersionInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get createdDate(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _parentIntentSignature?;
        /**
         * @stability stable
         */
        get parentIntentSignature(): string | undefined;
        /**
         * @stability stable
         */
        set parentIntentSignature(value: string | undefined);
        /**
         * @stability stable
         */
        resetParentIntentSignature(): void;
        /**
         * @stability stable
         */
        get parentIntentSignatureInput(): string | undefined;
        private _sampleUtterances?;
        /**
         * @stability stable
         */
        get sampleUtterances(): string[] | undefined;
        /**
         * @stability stable
         */
        set sampleUtterances(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSampleUtterances(): void;
        /**
         * @stability stable
         */
        get sampleUtterancesInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get version(): string;
        private _conclusionStatement?;
        private __conclusionStatementOutput;
        /**
         * @stability stable
         */
        get conclusionStatement(): LexIntentConclusionStatementOutputReference;
        /**
         * @stability stable
         */
        putConclusionStatement(value: LexIntentConclusionStatement | undefined): void;
        /**
         * @stability stable
         */
        resetConclusionStatement(): void;
        /**
         * @stability stable
         */
        get conclusionStatementInput(): LexIntentConclusionStatement | undefined;
        private _confirmationPrompt?;
        private __confirmationPromptOutput;
        /**
         * @stability stable
         */
        get confirmationPrompt(): LexIntentConfirmationPromptOutputReference;
        /**
         * @stability stable
         */
        putConfirmationPrompt(value: LexIntentConfirmationPrompt | undefined): void;
        /**
         * @stability stable
         */
        resetConfirmationPrompt(): void;
        /**
         * @stability stable
         */
        get confirmationPromptInput(): LexIntentConfirmationPrompt | undefined;
        private _dialogCodeHook?;
        private __dialogCodeHookOutput;
        /**
         * @stability stable
         */
        get dialogCodeHook(): LexIntentDialogCodeHookOutputReference;
        /**
         * @stability stable
         */
        putDialogCodeHook(value: LexIntentDialogCodeHook | undefined): void;
        /**
         * @stability stable
         */
        resetDialogCodeHook(): void;
        /**
         * @stability stable
         */
        get dialogCodeHookInput(): LexIntentDialogCodeHook | undefined;
        private _followUpPrompt?;
        private __followUpPromptOutput;
        /**
         * @stability stable
         */
        get followUpPrompt(): LexIntentFollowUpPromptOutputReference;
        /**
         * @stability stable
         */
        putFollowUpPrompt(value: LexIntentFollowUpPrompt | undefined): void;
        /**
         * @stability stable
         */
        resetFollowUpPrompt(): void;
        /**
         * @stability stable
         */
        get followUpPromptInput(): LexIntentFollowUpPrompt | undefined;
        private _fulfillmentActivity?;
        private __fulfillmentActivityOutput;
        /**
         * @stability stable
         */
        get fulfillmentActivity(): LexIntentFulfillmentActivityOutputReference;
        /**
         * @stability stable
         */
        putFulfillmentActivity(value: LexIntentFulfillmentActivity): void;
        /**
         * @stability stable
         */
        get fulfillmentActivityInput(): LexIntentFulfillmentActivity | undefined;
        private _rejectionStatement?;
        private __rejectionStatementOutput;
        /**
         * @stability stable
         */
        get rejectionStatement(): LexIntentRejectionStatementOutputReference;
        /**
         * @stability stable
         */
        putRejectionStatement(value: LexIntentRejectionStatement | undefined): void;
        /**
         * @stability stable
         */
        resetRejectionStatement(): void;
        /**
         * @stability stable
         */
        get rejectionStatementInput(): LexIntentRejectionStatement | undefined;
        private _slot?;
        /**
         * @stability stable
         */
        get slot(): LexIntentSlot[] | undefined;
        /**
         * @stability stable
         */
        set slot(value: LexIntentSlot[] | undefined);
        /**
         * @stability stable
         */
        resetSlot(): void;
        /**
         * @stability stable
         */
        get slotInput(): LexIntentSlot[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): LexIntentTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: LexIntentTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): LexIntentTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface LexSlotTypeConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#create_version LexSlotType#create_version}.
         *
         * @stability stable
         */
        readonly createVersion?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#description LexSlotType#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#name LexSlotType#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#value_selection_strategy LexSlotType#value_selection_strategy}.
         *
         * @stability stable
         */
        readonly valueSelectionStrategy?: string;
        /**
         * enumeration_value block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#enumeration_value LexSlotType#enumeration_value}
         *
         * @stability stable
         */
        readonly enumerationValue: LexSlotTypeEnumerationValue[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#timeouts LexSlotType#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: LexSlotTypeTimeouts;
    }
    /**
     * @stability stable
     */
    interface LexSlotTypeEnumerationValue {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#synonyms LexSlotType#synonyms}.
         *
         * @stability stable
         */
        readonly synonyms?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#value LexSlotType#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * @stability stable
     */
    interface LexSlotTypeTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#create LexSlotType#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#delete LexSlotType#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html#update LexSlotType#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class LexSlotTypeTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html aws_lex_slot_type}.
     *
     * @stability stable
     */
    class LexSlotType extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type.html aws_lex_slot_type} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: LexSlotTypeConfig);
        /**
         * @stability stable
         */
        get checksum(): string;
        private _createVersion?;
        /**
         * @stability stable
         */
        get createVersion(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set createVersion(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetCreateVersion(): void;
        /**
         * @stability stable
         */
        get createVersionInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get createdDate(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _valueSelectionStrategy?;
        /**
         * @stability stable
         */
        get valueSelectionStrategy(): string | undefined;
        /**
         * @stability stable
         */
        set valueSelectionStrategy(value: string | undefined);
        /**
         * @stability stable
         */
        resetValueSelectionStrategy(): void;
        /**
         * @stability stable
         */
        get valueSelectionStrategyInput(): string | undefined;
        /**
         * @stability stable
         */
        get version(): string;
        private _enumerationValue?;
        /**
         * @stability stable
         */
        get enumerationValue(): LexSlotTypeEnumerationValue[];
        /**
         * @stability stable
         */
        set enumerationValue(value: LexSlotTypeEnumerationValue[]);
        /**
         * @stability stable
         */
        get enumerationValueInput(): LexSlotTypeEnumerationValue[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): LexSlotTypeTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: LexSlotTypeTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): LexSlotTypeTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsLexBotConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lex_bot.html#name DataAwsLexBot#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lex_bot.html#version DataAwsLexBot#version}.
         *
         * @stability stable
         */
        readonly version?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/lex_bot.html aws_lex_bot}.
     *
     * @stability stable
     */
    class DataAwsLexBot extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/lex_bot.html aws_lex_bot} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsLexBotConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get checksum(): string;
        /**
         * @stability stable
         */
        get childDirected(): any;
        /**
         * @stability stable
         */
        get createdDate(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get detectSentiment(): any;
        /**
         * @stability stable
         */
        get enableModelImprovements(): any;
        /**
         * @stability stable
         */
        get failureReason(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get idleSessionTtlInSeconds(): number;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        /**
         * @stability stable
         */
        get locale(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get nluIntentConfidenceThreshold(): number;
        /**
         * @stability stable
         */
        get status(): string;
        private _version?;
        /**
         * @stability stable
         */
        get version(): string | undefined;
        /**
         * @stability stable
         */
        set version(value: string | undefined);
        /**
         * @stability stable
         */
        resetVersion(): void;
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
        /**
         * @stability stable
         */
        get voiceId(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsLexBotAliasConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lex_bot_alias.html#bot_name DataAwsLexBotAlias#bot_name}.
         *
         * @stability stable
         */
        readonly botName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lex_bot_alias.html#name DataAwsLexBotAlias#name}.
         *
         * @stability stable
         */
        readonly name: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/lex_bot_alias.html aws_lex_bot_alias}.
     *
     * @stability stable
     */
    class DataAwsLexBotAlias extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/lex_bot_alias.html aws_lex_bot_alias} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsLexBotAliasConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _botName?;
        /**
         * @stability stable
         */
        get botName(): string;
        /**
         * @stability stable
         */
        set botName(value: string);
        /**
         * @stability stable
         */
        get botNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get botVersion(): string;
        /**
         * @stability stable
         */
        get checksum(): string;
        /**
         * @stability stable
         */
        get createdDate(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsLexIntentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lex_intent.html#name DataAwsLexIntent#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lex_intent.html#version DataAwsLexIntent#version}.
         *
         * @stability stable
         */
        readonly version?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/lex_intent.html aws_lex_intent}.
     *
     * @stability stable
     */
    class DataAwsLexIntent extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/lex_intent.html aws_lex_intent} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsLexIntentConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get checksum(): string;
        /**
         * @stability stable
         */
        get createdDate(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get parentIntentSignature(): string;
        private _version?;
        /**
         * @stability stable
         */
        get version(): string | undefined;
        /**
         * @stability stable
         */
        set version(value: string | undefined);
        /**
         * @stability stable
         */
        resetVersion(): void;
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsLexSlotTypeConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lex_slot_type.html#name DataAwsLexSlotType#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lex_slot_type.html#version DataAwsLexSlotType#version}.
         *
         * @stability stable
         */
        readonly version?: string;
    }
    /**
     * @stability stable
     */
    class DataAwsLexSlotTypeEnumerationValue extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get synonyms(): string[];
        /**
         * @stability stable
         */
        get value(): string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/lex_slot_type.html aws_lex_slot_type}.
     *
     * @stability stable
     */
    class DataAwsLexSlotType extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/lex_slot_type.html aws_lex_slot_type} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsLexSlotTypeConfig);
        /**
         * @stability stable
         */
        get checksum(): string;
        /**
         * @stability stable
         */
        get createdDate(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        enumerationValue(index: string): DataAwsLexSlotTypeEnumerationValue;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get valueSelectionStrategy(): string;
        private _version?;
        /**
         * @stability stable
         */
        get version(): string | undefined;
        /**
         * @stability stable
         */
        set version(value: string | undefined);
        /**
         * @stability stable
         */
        resetVersion(): void;
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
