import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Managed Message Queue
*/
export declare namespace MQ {
    /**
     * @stability stable
     */
    interface MqBrokerConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#apply_immediately MqBroker#apply_immediately}.
         *
         * @stability stable
         */
        readonly applyImmediately?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#authentication_strategy MqBroker#authentication_strategy}.
         *
         * @stability stable
         */
        readonly authenticationStrategy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#auto_minor_version_upgrade MqBroker#auto_minor_version_upgrade}.
         *
         * @stability stable
         */
        readonly autoMinorVersionUpgrade?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#broker_name MqBroker#broker_name}.
         *
         * @stability stable
         */
        readonly brokerName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#deployment_mode MqBroker#deployment_mode}.
         *
         * @stability stable
         */
        readonly deploymentMode?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#engine_type MqBroker#engine_type}.
         *
         * @stability stable
         */
        readonly engineType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#engine_version MqBroker#engine_version}.
         *
         * @stability stable
         */
        readonly engineVersion: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#host_instance_type MqBroker#host_instance_type}.
         *
         * @stability stable
         */
        readonly hostInstanceType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#publicly_accessible MqBroker#publicly_accessible}.
         *
         * @stability stable
         */
        readonly publiclyAccessible?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#security_groups MqBroker#security_groups}.
         *
         * @stability stable
         */
        readonly securityGroups?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#storage_type MqBroker#storage_type}.
         *
         * @stability stable
         */
        readonly storageType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#subnet_ids MqBroker#subnet_ids}.
         *
         * @stability stable
         */
        readonly subnetIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#tags MqBroker#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#tags_all MqBroker#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#configuration MqBroker#configuration}
         *
         * @stability stable
         */
        readonly configuration?: MqBrokerConfiguration;
        /**
         * encryption_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#encryption_options MqBroker#encryption_options}
         *
         * @stability stable
         */
        readonly encryptionOptions?: MqBrokerEncryptionOptions;
        /**
         * ldap_server_metadata block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#ldap_server_metadata MqBroker#ldap_server_metadata}
         *
         * @stability stable
         */
        readonly ldapServerMetadata?: MqBrokerLdapServerMetadata;
        /**
         * logs block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#logs MqBroker#logs}
         *
         * @stability stable
         */
        readonly logs?: MqBrokerLogs;
        /**
         * maintenance_window_start_time block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#maintenance_window_start_time MqBroker#maintenance_window_start_time}
         *
         * @stability stable
         */
        readonly maintenanceWindowStartTime?: MqBrokerMaintenanceWindowStartTime;
        /**
         * user block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#user MqBroker#user}
         *
         * @stability stable
         */
        readonly user: MqBrokerUser[];
    }
    /**
     * @stability stable
     */
    class MqBrokerInstances extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get consoleUrl(): string;
        /**
         * @stability stable
         */
        get endpoints(): string[];
        /**
         * @stability stable
         */
        get ipAddress(): string;
    }
    /**
     * @stability stable
     */
    interface MqBrokerConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#id MqBroker#id}.
         *
         * @stability stable
         */
        readonly id?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#revision MqBroker#revision}.
         *
         * @stability stable
         */
        readonly revision?: number;
    }
    /**
     * @stability stable
     */
    class MqBrokerConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        /**
         * @stability stable
         */
        get id(): string;
        private _revision?;
        /**
         * @stability stable
         */
        get revision(): number | undefined;
        /**
         * @stability stable
         */
        set revision(value: number | undefined);
        /**
         * @stability stable
         */
        resetRevision(): void;
        /**
         * @stability stable
         */
        get revisionInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface MqBrokerEncryptionOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#kms_key_id MqBroker#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#use_aws_owned_key MqBroker#use_aws_owned_key}.
         *
         * @stability stable
         */
        readonly useAwsOwnedKey?: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class MqBrokerEncryptionOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        private _useAwsOwnedKey?;
        /**
         * @stability stable
         */
        get useAwsOwnedKey(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set useAwsOwnedKey(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUseAwsOwnedKey(): void;
        /**
         * @stability stable
         */
        get useAwsOwnedKeyInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * @stability stable
     */
    interface MqBrokerLdapServerMetadata {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#hosts MqBroker#hosts}.
         *
         * @stability stable
         */
        readonly hosts?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#role_base MqBroker#role_base}.
         *
         * @stability stable
         */
        readonly roleBase?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#role_name MqBroker#role_name}.
         *
         * @stability stable
         */
        readonly roleName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#role_search_matching MqBroker#role_search_matching}.
         *
         * @stability stable
         */
        readonly roleSearchMatching?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#role_search_subtree MqBroker#role_search_subtree}.
         *
         * @stability stable
         */
        readonly roleSearchSubtree?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#service_account_password MqBroker#service_account_password}.
         *
         * @stability stable
         */
        readonly serviceAccountPassword?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#service_account_username MqBroker#service_account_username}.
         *
         * @stability stable
         */
        readonly serviceAccountUsername?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#user_base MqBroker#user_base}.
         *
         * @stability stable
         */
        readonly userBase?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#user_role_name MqBroker#user_role_name}.
         *
         * @stability stable
         */
        readonly userRoleName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#user_search_matching MqBroker#user_search_matching}.
         *
         * @stability stable
         */
        readonly userSearchMatching?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#user_search_subtree MqBroker#user_search_subtree}.
         *
         * @stability stable
         */
        readonly userSearchSubtree?: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class MqBrokerLdapServerMetadataOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _hosts?;
        /**
         * @stability stable
         */
        get hosts(): string[] | undefined;
        /**
         * @stability stable
         */
        set hosts(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetHosts(): void;
        /**
         * @stability stable
         */
        get hostsInput(): string[] | undefined;
        private _roleBase?;
        /**
         * @stability stable
         */
        get roleBase(): string | undefined;
        /**
         * @stability stable
         */
        set roleBase(value: string | undefined);
        /**
         * @stability stable
         */
        resetRoleBase(): void;
        /**
         * @stability stable
         */
        get roleBaseInput(): string | undefined;
        private _roleName?;
        /**
         * @stability stable
         */
        get roleName(): string | undefined;
        /**
         * @stability stable
         */
        set roleName(value: string | undefined);
        /**
         * @stability stable
         */
        resetRoleName(): void;
        /**
         * @stability stable
         */
        get roleNameInput(): string | undefined;
        private _roleSearchMatching?;
        /**
         * @stability stable
         */
        get roleSearchMatching(): string | undefined;
        /**
         * @stability stable
         */
        set roleSearchMatching(value: string | undefined);
        /**
         * @stability stable
         */
        resetRoleSearchMatching(): void;
        /**
         * @stability stable
         */
        get roleSearchMatchingInput(): string | undefined;
        private _roleSearchSubtree?;
        /**
         * @stability stable
         */
        get roleSearchSubtree(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set roleSearchSubtree(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetRoleSearchSubtree(): void;
        /**
         * @stability stable
         */
        get roleSearchSubtreeInput(): boolean | cdktf.IResolvable | undefined;
        private _serviceAccountPassword?;
        /**
         * @stability stable
         */
        get serviceAccountPassword(): string | undefined;
        /**
         * @stability stable
         */
        set serviceAccountPassword(value: string | undefined);
        /**
         * @stability stable
         */
        resetServiceAccountPassword(): void;
        /**
         * @stability stable
         */
        get serviceAccountPasswordInput(): string | undefined;
        private _serviceAccountUsername?;
        /**
         * @stability stable
         */
        get serviceAccountUsername(): string | undefined;
        /**
         * @stability stable
         */
        set serviceAccountUsername(value: string | undefined);
        /**
         * @stability stable
         */
        resetServiceAccountUsername(): void;
        /**
         * @stability stable
         */
        get serviceAccountUsernameInput(): string | undefined;
        private _userBase?;
        /**
         * @stability stable
         */
        get userBase(): string | undefined;
        /**
         * @stability stable
         */
        set userBase(value: string | undefined);
        /**
         * @stability stable
         */
        resetUserBase(): void;
        /**
         * @stability stable
         */
        get userBaseInput(): string | undefined;
        private _userRoleName?;
        /**
         * @stability stable
         */
        get userRoleName(): string | undefined;
        /**
         * @stability stable
         */
        set userRoleName(value: string | undefined);
        /**
         * @stability stable
         */
        resetUserRoleName(): void;
        /**
         * @stability stable
         */
        get userRoleNameInput(): string | undefined;
        private _userSearchMatching?;
        /**
         * @stability stable
         */
        get userSearchMatching(): string | undefined;
        /**
         * @stability stable
         */
        set userSearchMatching(value: string | undefined);
        /**
         * @stability stable
         */
        resetUserSearchMatching(): void;
        /**
         * @stability stable
         */
        get userSearchMatchingInput(): string | undefined;
        private _userSearchSubtree?;
        /**
         * @stability stable
         */
        get userSearchSubtree(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set userSearchSubtree(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUserSearchSubtree(): void;
        /**
         * @stability stable
         */
        get userSearchSubtreeInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * @stability stable
     */
    interface MqBrokerLogs {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#audit MqBroker#audit}.
         *
         * @stability stable
         */
        readonly audit?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#general MqBroker#general}.
         *
         * @stability stable
         */
        readonly general?: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class MqBrokerLogsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _audit?;
        /**
         * @stability stable
         */
        get audit(): string | undefined;
        /**
         * @stability stable
         */
        set audit(value: string | undefined);
        /**
         * @stability stable
         */
        resetAudit(): void;
        /**
         * @stability stable
         */
        get auditInput(): string | undefined;
        private _general?;
        /**
         * @stability stable
         */
        get general(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set general(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetGeneral(): void;
        /**
         * @stability stable
         */
        get generalInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * @stability stable
     */
    interface MqBrokerMaintenanceWindowStartTime {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#day_of_week MqBroker#day_of_week}.
         *
         * @stability stable
         */
        readonly dayOfWeek: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#time_of_day MqBroker#time_of_day}.
         *
         * @stability stable
         */
        readonly timeOfDay: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#time_zone MqBroker#time_zone}.
         *
         * @stability stable
         */
        readonly timeZone: string;
    }
    /**
     * @stability stable
     */
    class MqBrokerMaintenanceWindowStartTimeOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _dayOfWeek?;
        /**
         * @stability stable
         */
        get dayOfWeek(): string;
        /**
         * @stability stable
         */
        set dayOfWeek(value: string);
        /**
         * @stability stable
         */
        get dayOfWeekInput(): string | undefined;
        private _timeOfDay?;
        /**
         * @stability stable
         */
        get timeOfDay(): string;
        /**
         * @stability stable
         */
        set timeOfDay(value: string);
        /**
         * @stability stable
         */
        get timeOfDayInput(): string | undefined;
        private _timeZone?;
        /**
         * @stability stable
         */
        get timeZone(): string;
        /**
         * @stability stable
         */
        set timeZone(value: string);
        /**
         * @stability stable
         */
        get timeZoneInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface MqBrokerUser {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#console_access MqBroker#console_access}.
         *
         * @stability stable
         */
        readonly consoleAccess?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#groups MqBroker#groups}.
         *
         * @stability stable
         */
        readonly groups?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#password MqBroker#password}.
         *
         * @stability stable
         */
        readonly password: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html#username MqBroker#username}.
         *
         * @stability stable
         */
        readonly username: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html aws_mq_broker}.
     *
     * @stability stable
     */
    class MqBroker extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/mq_broker.html aws_mq_broker} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: MqBrokerConfig);
        private _applyImmediately?;
        /**
         * @stability stable
         */
        get applyImmediately(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set applyImmediately(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetApplyImmediately(): void;
        /**
         * @stability stable
         */
        get applyImmediatelyInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _authenticationStrategy?;
        /**
         * @stability stable
         */
        get authenticationStrategy(): string | undefined;
        /**
         * @stability stable
         */
        set authenticationStrategy(value: string | undefined);
        /**
         * @stability stable
         */
        resetAuthenticationStrategy(): void;
        /**
         * @stability stable
         */
        get authenticationStrategyInput(): string | undefined;
        private _autoMinorVersionUpgrade?;
        /**
         * @stability stable
         */
        get autoMinorVersionUpgrade(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoMinorVersionUpgrade(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoMinorVersionUpgrade(): void;
        /**
         * @stability stable
         */
        get autoMinorVersionUpgradeInput(): boolean | cdktf.IResolvable | undefined;
        private _brokerName?;
        /**
         * @stability stable
         */
        get brokerName(): string;
        /**
         * @stability stable
         */
        set brokerName(value: string);
        /**
         * @stability stable
         */
        get brokerNameInput(): string | undefined;
        private _deploymentMode?;
        /**
         * @stability stable
         */
        get deploymentMode(): string | undefined;
        /**
         * @stability stable
         */
        set deploymentMode(value: string | undefined);
        /**
         * @stability stable
         */
        resetDeploymentMode(): void;
        /**
         * @stability stable
         */
        get deploymentModeInput(): string | undefined;
        private _engineType?;
        /**
         * @stability stable
         */
        get engineType(): string;
        /**
         * @stability stable
         */
        set engineType(value: string);
        /**
         * @stability stable
         */
        get engineTypeInput(): string | undefined;
        private _engineVersion?;
        /**
         * @stability stable
         */
        get engineVersion(): string;
        /**
         * @stability stable
         */
        set engineVersion(value: string);
        /**
         * @stability stable
         */
        get engineVersionInput(): string | undefined;
        private _hostInstanceType?;
        /**
         * @stability stable
         */
        get hostInstanceType(): string;
        /**
         * @stability stable
         */
        set hostInstanceType(value: string);
        /**
         * @stability stable
         */
        get hostInstanceTypeInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        instances(index: string): MqBrokerInstances;
        private _publiclyAccessible?;
        /**
         * @stability stable
         */
        get publiclyAccessible(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set publiclyAccessible(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetPubliclyAccessible(): void;
        /**
         * @stability stable
         */
        get publiclyAccessibleInput(): boolean | cdktf.IResolvable | undefined;
        private _securityGroups?;
        /**
         * @stability stable
         */
        get securityGroups(): string[] | undefined;
        /**
         * @stability stable
         */
        set securityGroups(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecurityGroups(): void;
        /**
         * @stability stable
         */
        get securityGroupsInput(): string[] | undefined;
        private _storageType?;
        /**
         * @stability stable
         */
        get storageType(): string | undefined;
        /**
         * @stability stable
         */
        set storageType(value: string | undefined);
        /**
         * @stability stable
         */
        resetStorageType(): void;
        /**
         * @stability stable
         */
        get storageTypeInput(): string | undefined;
        private _subnetIds?;
        /**
         * @stability stable
         */
        get subnetIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set subnetIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSubnetIds(): void;
        /**
         * @stability stable
         */
        get subnetIdsInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _configuration?;
        private __configurationOutput;
        /**
         * @stability stable
         */
        get configuration(): MqBrokerConfigurationOutputReference;
        /**
         * @stability stable
         */
        putConfiguration(value: MqBrokerConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetConfiguration(): void;
        /**
         * @stability stable
         */
        get configurationInput(): MqBrokerConfiguration | undefined;
        private _encryptionOptions?;
        private __encryptionOptionsOutput;
        /**
         * @stability stable
         */
        get encryptionOptions(): MqBrokerEncryptionOptionsOutputReference;
        /**
         * @stability stable
         */
        putEncryptionOptions(value: MqBrokerEncryptionOptions | undefined): void;
        /**
         * @stability stable
         */
        resetEncryptionOptions(): void;
        /**
         * @stability stable
         */
        get encryptionOptionsInput(): MqBrokerEncryptionOptions | undefined;
        private _ldapServerMetadata?;
        private __ldapServerMetadataOutput;
        /**
         * @stability stable
         */
        get ldapServerMetadata(): MqBrokerLdapServerMetadataOutputReference;
        /**
         * @stability stable
         */
        putLdapServerMetadata(value: MqBrokerLdapServerMetadata | undefined): void;
        /**
         * @stability stable
         */
        resetLdapServerMetadata(): void;
        /**
         * @stability stable
         */
        get ldapServerMetadataInput(): MqBrokerLdapServerMetadata | undefined;
        private _logs?;
        private __logsOutput;
        /**
         * @stability stable
         */
        get logs(): MqBrokerLogsOutputReference;
        /**
         * @stability stable
         */
        putLogs(value: MqBrokerLogs | undefined): void;
        /**
         * @stability stable
         */
        resetLogs(): void;
        /**
         * @stability stable
         */
        get logsInput(): MqBrokerLogs | undefined;
        private _maintenanceWindowStartTime?;
        private __maintenanceWindowStartTimeOutput;
        /**
         * @stability stable
         */
        get maintenanceWindowStartTime(): MqBrokerMaintenanceWindowStartTimeOutputReference;
        /**
         * @stability stable
         */
        putMaintenanceWindowStartTime(value: MqBrokerMaintenanceWindowStartTime | undefined): void;
        /**
         * @stability stable
         */
        resetMaintenanceWindowStartTime(): void;
        /**
         * @stability stable
         */
        get maintenanceWindowStartTimeInput(): MqBrokerMaintenanceWindowStartTime | undefined;
        private _user?;
        /**
         * @stability stable
         */
        get user(): MqBrokerUser[];
        /**
         * @stability stable
         */
        set user(value: MqBrokerUser[]);
        /**
         * @stability stable
         */
        get userInput(): MqBrokerUser[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface MqConfigurationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_configuration.html#authentication_strategy MqConfiguration#authentication_strategy}.
         *
         * @stability stable
         */
        readonly authenticationStrategy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_configuration.html#data MqConfiguration#data}.
         *
         * @stability stable
         */
        readonly data: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_configuration.html#description MqConfiguration#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_configuration.html#engine_type MqConfiguration#engine_type}.
         *
         * @stability stable
         */
        readonly engineType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_configuration.html#engine_version MqConfiguration#engine_version}.
         *
         * @stability stable
         */
        readonly engineVersion: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_configuration.html#name MqConfiguration#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_configuration.html#tags MqConfiguration#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mq_configuration.html#tags_all MqConfiguration#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/mq_configuration.html aws_mq_configuration}.
     *
     * @stability stable
     */
    class MqConfiguration extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/mq_configuration.html aws_mq_configuration} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: MqConfigurationConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _authenticationStrategy?;
        /**
         * @stability stable
         */
        get authenticationStrategy(): string | undefined;
        /**
         * @stability stable
         */
        set authenticationStrategy(value: string | undefined);
        /**
         * @stability stable
         */
        resetAuthenticationStrategy(): void;
        /**
         * @stability stable
         */
        get authenticationStrategyInput(): string | undefined;
        private _data?;
        /**
         * @stability stable
         */
        get data(): string;
        /**
         * @stability stable
         */
        set data(value: string);
        /**
         * @stability stable
         */
        get dataInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _engineType?;
        /**
         * @stability stable
         */
        get engineType(): string;
        /**
         * @stability stable
         */
        set engineType(value: string);
        /**
         * @stability stable
         */
        get engineTypeInput(): string | undefined;
        private _engineVersion?;
        /**
         * @stability stable
         */
        get engineVersion(): string;
        /**
         * @stability stable
         */
        set engineVersion(value: string);
        /**
         * @stability stable
         */
        get engineVersionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get latestRevision(): number;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsMqBrokerConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/mq_broker.html#broker_id DataAwsMqBroker#broker_id}.
         *
         * @stability stable
         */
        readonly brokerId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/mq_broker.html#broker_name DataAwsMqBroker#broker_name}.
         *
         * @stability stable
         */
        readonly brokerName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/mq_broker.html#tags DataAwsMqBroker#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class DataAwsMqBrokerConfiguration extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get revision(): number;
    }
    /**
     * @stability stable
     */
    class DataAwsMqBrokerEncryptionOptions extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get kmsKeyId(): string;
        /**
         * @stability stable
         */
        get useAwsOwnedKey(): any;
    }
    /**
     * @stability stable
     */
    class DataAwsMqBrokerInstances extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get consoleUrl(): string;
        /**
         * @stability stable
         */
        get endpoints(): string[];
        /**
         * @stability stable
         */
        get ipAddress(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsMqBrokerLdapServerMetadata extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get hosts(): string[];
        /**
         * @stability stable
         */
        get roleBase(): string;
        /**
         * @stability stable
         */
        get roleName(): string;
        /**
         * @stability stable
         */
        get roleSearchMatching(): string;
        /**
         * @stability stable
         */
        get roleSearchSubtree(): any;
        /**
         * @stability stable
         */
        get serviceAccountPassword(): string;
        /**
         * @stability stable
         */
        get serviceAccountUsername(): string;
        /**
         * @stability stable
         */
        get userBase(): string;
        /**
         * @stability stable
         */
        get userRoleName(): string;
        /**
         * @stability stable
         */
        get userSearchMatching(): string;
        /**
         * @stability stable
         */
        get userSearchSubtree(): any;
    }
    /**
     * @stability stable
     */
    class DataAwsMqBrokerLogs extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get audit(): string;
        /**
         * @stability stable
         */
        get general(): any;
    }
    /**
     * @stability stable
     */
    class DataAwsMqBrokerMaintenanceWindowStartTime extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get dayOfWeek(): string;
        /**
         * @stability stable
         */
        get timeOfDay(): string;
        /**
         * @stability stable
         */
        get timeZone(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsMqBrokerUser extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get consoleAccess(): any;
        /**
         * @stability stable
         */
        get groups(): string[];
        /**
         * @stability stable
         */
        get username(): string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/mq_broker.html aws_mq_broker}.
     *
     * @stability stable
     */
    class DataAwsMqBroker extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/mq_broker.html aws_mq_broker} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsMqBrokerConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get authenticationStrategy(): string;
        /**
         * @stability stable
         */
        get autoMinorVersionUpgrade(): any;
        private _brokerId?;
        /**
         * @stability stable
         */
        get brokerId(): string | undefined;
        /**
         * @stability stable
         */
        set brokerId(value: string | undefined);
        /**
         * @stability stable
         */
        resetBrokerId(): void;
        /**
         * @stability stable
         */
        get brokerIdInput(): string | undefined;
        private _brokerName?;
        /**
         * @stability stable
         */
        get brokerName(): string | undefined;
        /**
         * @stability stable
         */
        set brokerName(value: string | undefined);
        /**
         * @stability stable
         */
        resetBrokerName(): void;
        /**
         * @stability stable
         */
        get brokerNameInput(): string | undefined;
        /**
         * @stability stable
         */
        configuration(index: string): DataAwsMqBrokerConfiguration;
        /**
         * @stability stable
         */
        get deploymentMode(): string;
        /**
         * @stability stable
         */
        encryptionOptions(index: string): DataAwsMqBrokerEncryptionOptions;
        /**
         * @stability stable
         */
        get engineType(): string;
        /**
         * @stability stable
         */
        get engineVersion(): string;
        /**
         * @stability stable
         */
        get hostInstanceType(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        instances(index: string): DataAwsMqBrokerInstances;
        /**
         * @stability stable
         */
        ldapServerMetadata(index: string): DataAwsMqBrokerLdapServerMetadata;
        /**
         * @stability stable
         */
        logs(index: string): DataAwsMqBrokerLogs;
        /**
         * @stability stable
         */
        maintenanceWindowStartTime(index: string): DataAwsMqBrokerMaintenanceWindowStartTime;
        /**
         * @stability stable
         */
        get publiclyAccessible(): any;
        /**
         * @stability stable
         */
        get securityGroups(): string[];
        /**
         * @stability stable
         */
        get storageType(): string;
        /**
         * @stability stable
         */
        get subnetIds(): string[];
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        user(index: string): DataAwsMqBrokerUser;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
