import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Macie
*/
export declare namespace Macie {
    /**
     * @stability stable
     */
    interface MacieMemberAccountAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie_member_account_association.html#member_account_id MacieMemberAccountAssociation#member_account_id}.
         *
         * @stability stable
         */
        readonly memberAccountId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/macie_member_account_association.html aws_macie_member_account_association}.
     *
     * @stability stable
     */
    class MacieMemberAccountAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/macie_member_account_association.html aws_macie_member_account_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: MacieMemberAccountAssociationConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _memberAccountId?;
        /**
         * @stability stable
         */
        get memberAccountId(): string;
        /**
         * @stability stable
         */
        set memberAccountId(value: string);
        /**
         * @stability stable
         */
        get memberAccountIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface MacieS3BucketAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie_s3_bucket_association.html#bucket_name MacieS3BucketAssociation#bucket_name}.
         *
         * @stability stable
         */
        readonly bucketName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie_s3_bucket_association.html#member_account_id MacieS3BucketAssociation#member_account_id}.
         *
         * @stability stable
         */
        readonly memberAccountId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie_s3_bucket_association.html#prefix MacieS3BucketAssociation#prefix}.
         *
         * @stability stable
         */
        readonly prefix?: string;
        /**
         * classification_type block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie_s3_bucket_association.html#classification_type MacieS3BucketAssociation#classification_type}
         *
         * @stability stable
         */
        readonly classificationType?: MacieS3BucketAssociationClassificationType;
    }
    /**
     * @stability stable
     */
    interface MacieS3BucketAssociationClassificationType {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie_s3_bucket_association.html#continuous MacieS3BucketAssociation#continuous}.
         *
         * @stability stable
         */
        readonly continuous?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie_s3_bucket_association.html#one_time MacieS3BucketAssociation#one_time}.
         *
         * @stability stable
         */
        readonly oneTime?: string;
    }
    /**
     * @stability stable
     */
    class MacieS3BucketAssociationClassificationTypeOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _continuous?;
        /**
         * @stability stable
         */
        get continuous(): string | undefined;
        /**
         * @stability stable
         */
        set continuous(value: string | undefined);
        /**
         * @stability stable
         */
        resetContinuous(): void;
        /**
         * @stability stable
         */
        get continuousInput(): string | undefined;
        private _oneTime?;
        /**
         * @stability stable
         */
        get oneTime(): string | undefined;
        /**
         * @stability stable
         */
        set oneTime(value: string | undefined);
        /**
         * @stability stable
         */
        resetOneTime(): void;
        /**
         * @stability stable
         */
        get oneTimeInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/macie_s3_bucket_association.html aws_macie_s3_bucket_association}.
     *
     * @stability stable
     */
    class MacieS3BucketAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/macie_s3_bucket_association.html aws_macie_s3_bucket_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: MacieS3BucketAssociationConfig);
        private _bucketName?;
        /**
         * @stability stable
         */
        get bucketName(): string;
        /**
         * @stability stable
         */
        set bucketName(value: string);
        /**
         * @stability stable
         */
        get bucketNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _memberAccountId?;
        /**
         * @stability stable
         */
        get memberAccountId(): string | undefined;
        /**
         * @stability stable
         */
        set memberAccountId(value: string | undefined);
        /**
         * @stability stable
         */
        resetMemberAccountId(): void;
        /**
         * @stability stable
         */
        get memberAccountIdInput(): string | undefined;
        private _prefix?;
        /**
         * @stability stable
         */
        get prefix(): string | undefined;
        /**
         * @stability stable
         */
        set prefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrefix(): void;
        /**
         * @stability stable
         */
        get prefixInput(): string | undefined;
        private _classificationType?;
        private __classificationTypeOutput;
        /**
         * @stability stable
         */
        get classificationType(): MacieS3BucketAssociationClassificationTypeOutputReference;
        /**
         * @stability stable
         */
        putClassificationType(value: MacieS3BucketAssociationClassificationType | undefined): void;
        /**
         * @stability stable
         */
        resetClassificationType(): void;
        /**
         * @stability stable
         */
        get classificationTypeInput(): MacieS3BucketAssociationClassificationType | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
