import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS MediaConvert
*/
export declare namespace MediaConvert {
    /**
     * @stability stable
     */
    interface MediaConvertQueueConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/media_convert_queue.html#description MediaConvertQueue#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/media_convert_queue.html#name MediaConvertQueue#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/media_convert_queue.html#pricing_plan MediaConvertQueue#pricing_plan}.
         *
         * @stability stable
         */
        readonly pricingPlan?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/media_convert_queue.html#status MediaConvertQueue#status}.
         *
         * @stability stable
         */
        readonly status?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/media_convert_queue.html#tags MediaConvertQueue#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/media_convert_queue.html#tags_all MediaConvertQueue#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * reservation_plan_settings block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/media_convert_queue.html#reservation_plan_settings MediaConvertQueue#reservation_plan_settings}
         *
         * @stability stable
         */
        readonly reservationPlanSettings?: MediaConvertQueueReservationPlanSettings;
    }
    /**
     * @stability stable
     */
    interface MediaConvertQueueReservationPlanSettings {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/media_convert_queue.html#commitment MediaConvertQueue#commitment}.
         *
         * @stability stable
         */
        readonly commitment: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/media_convert_queue.html#renewal_type MediaConvertQueue#renewal_type}.
         *
         * @stability stable
         */
        readonly renewalType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/media_convert_queue.html#reserved_slots MediaConvertQueue#reserved_slots}.
         *
         * @stability stable
         */
        readonly reservedSlots: number;
    }
    /**
     * @stability stable
     */
    class MediaConvertQueueReservationPlanSettingsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _commitment?;
        /**
         * @stability stable
         */
        get commitment(): string;
        /**
         * @stability stable
         */
        set commitment(value: string);
        /**
         * @stability stable
         */
        get commitmentInput(): string | undefined;
        private _renewalType?;
        /**
         * @stability stable
         */
        get renewalType(): string;
        /**
         * @stability stable
         */
        set renewalType(value: string);
        /**
         * @stability stable
         */
        get renewalTypeInput(): string | undefined;
        private _reservedSlots?;
        /**
         * @stability stable
         */
        get reservedSlots(): number;
        /**
         * @stability stable
         */
        set reservedSlots(value: number);
        /**
         * @stability stable
         */
        get reservedSlotsInput(): number | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/media_convert_queue.html aws_media_convert_queue}.
     *
     * @stability stable
     */
    class MediaConvertQueue extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/media_convert_queue.html aws_media_convert_queue} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: MediaConvertQueueConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _pricingPlan?;
        /**
         * @stability stable
         */
        get pricingPlan(): string | undefined;
        /**
         * @stability stable
         */
        set pricingPlan(value: string | undefined);
        /**
         * @stability stable
         */
        resetPricingPlan(): void;
        /**
         * @stability stable
         */
        get pricingPlanInput(): string | undefined;
        private _status?;
        /**
         * @stability stable
         */
        get status(): string | undefined;
        /**
         * @stability stable
         */
        set status(value: string | undefined);
        /**
         * @stability stable
         */
        resetStatus(): void;
        /**
         * @stability stable
         */
        get statusInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _reservationPlanSettings?;
        private __reservationPlanSettingsOutput;
        /**
         * @stability stable
         */
        get reservationPlanSettings(): MediaConvertQueueReservationPlanSettingsOutputReference;
        /**
         * @stability stable
         */
        putReservationPlanSettings(value: MediaConvertQueueReservationPlanSettings | undefined): void;
        /**
         * @stability stable
         */
        resetReservationPlanSettings(): void;
        /**
         * @stability stable
         */
        get reservationPlanSettingsInput(): MediaConvertQueueReservationPlanSettings | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
