import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Neptune
*/
export declare namespace Neptune {
    /**
     * @stability stable
     */
    interface NeptuneClusterConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#apply_immediately NeptuneCluster#apply_immediately}.
         *
         * @stability stable
         */
        readonly applyImmediately?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#availability_zones NeptuneCluster#availability_zones}.
         *
         * @stability stable
         */
        readonly availabilityZones?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#backup_retention_period NeptuneCluster#backup_retention_period}.
         *
         * @stability stable
         */
        readonly backupRetentionPeriod?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#cluster_identifier NeptuneCluster#cluster_identifier}.
         *
         * @stability stable
         */
        readonly clusterIdentifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#cluster_identifier_prefix NeptuneCluster#cluster_identifier_prefix}.
         *
         * @stability stable
         */
        readonly clusterIdentifierPrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#copy_tags_to_snapshot NeptuneCluster#copy_tags_to_snapshot}.
         *
         * @stability stable
         */
        readonly copyTagsToSnapshot?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#deletion_protection NeptuneCluster#deletion_protection}.
         *
         * @stability stable
         */
        readonly deletionProtection?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#enable_cloudwatch_logs_exports NeptuneCluster#enable_cloudwatch_logs_exports}.
         *
         * @stability stable
         */
        readonly enableCloudwatchLogsExports?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#engine NeptuneCluster#engine}.
         *
         * @stability stable
         */
        readonly engine?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#engine_version NeptuneCluster#engine_version}.
         *
         * @stability stable
         */
        readonly engineVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#final_snapshot_identifier NeptuneCluster#final_snapshot_identifier}.
         *
         * @stability stable
         */
        readonly finalSnapshotIdentifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#iam_database_authentication_enabled NeptuneCluster#iam_database_authentication_enabled}.
         *
         * @stability stable
         */
        readonly iamDatabaseAuthenticationEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#iam_roles NeptuneCluster#iam_roles}.
         *
         * @stability stable
         */
        readonly iamRoles?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#kms_key_arn NeptuneCluster#kms_key_arn}.
         *
         * @stability stable
         */
        readonly kmsKeyArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#neptune_cluster_parameter_group_name NeptuneCluster#neptune_cluster_parameter_group_name}.
         *
         * @stability stable
         */
        readonly neptuneClusterParameterGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#neptune_subnet_group_name NeptuneCluster#neptune_subnet_group_name}.
         *
         * @stability stable
         */
        readonly neptuneSubnetGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#port NeptuneCluster#port}.
         *
         * @stability stable
         */
        readonly port?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#preferred_backup_window NeptuneCluster#preferred_backup_window}.
         *
         * @stability stable
         */
        readonly preferredBackupWindow?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#preferred_maintenance_window NeptuneCluster#preferred_maintenance_window}.
         *
         * @stability stable
         */
        readonly preferredMaintenanceWindow?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#replication_source_identifier NeptuneCluster#replication_source_identifier}.
         *
         * @stability stable
         */
        readonly replicationSourceIdentifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#skip_final_snapshot NeptuneCluster#skip_final_snapshot}.
         *
         * @stability stable
         */
        readonly skipFinalSnapshot?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#snapshot_identifier NeptuneCluster#snapshot_identifier}.
         *
         * @stability stable
         */
        readonly snapshotIdentifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#storage_encrypted NeptuneCluster#storage_encrypted}.
         *
         * @stability stable
         */
        readonly storageEncrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#tags NeptuneCluster#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#tags_all NeptuneCluster#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#vpc_security_group_ids NeptuneCluster#vpc_security_group_ids}.
         *
         * @stability stable
         */
        readonly vpcSecurityGroupIds?: string[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#timeouts NeptuneCluster#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: NeptuneClusterTimeouts;
    }
    /**
     * @stability stable
     */
    interface NeptuneClusterTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#create NeptuneCluster#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#delete NeptuneCluster#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html#update NeptuneCluster#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class NeptuneClusterTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html aws_neptune_cluster}.
     *
     * @stability stable
     */
    class NeptuneCluster extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster.html aws_neptune_cluster} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: NeptuneClusterConfig);
        private _applyImmediately?;
        /**
         * @stability stable
         */
        get applyImmediately(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set applyImmediately(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetApplyImmediately(): void;
        /**
         * @stability stable
         */
        get applyImmediatelyInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _availabilityZones?;
        /**
         * @stability stable
         */
        get availabilityZones(): string[] | undefined;
        /**
         * @stability stable
         */
        set availabilityZones(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetAvailabilityZones(): void;
        /**
         * @stability stable
         */
        get availabilityZonesInput(): string[] | undefined;
        private _backupRetentionPeriod?;
        /**
         * @stability stable
         */
        get backupRetentionPeriod(): number | undefined;
        /**
         * @stability stable
         */
        set backupRetentionPeriod(value: number | undefined);
        /**
         * @stability stable
         */
        resetBackupRetentionPeriod(): void;
        /**
         * @stability stable
         */
        get backupRetentionPeriodInput(): number | undefined;
        private _clusterIdentifier?;
        /**
         * @stability stable
         */
        get clusterIdentifier(): string | undefined;
        /**
         * @stability stable
         */
        set clusterIdentifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetClusterIdentifier(): void;
        /**
         * @stability stable
         */
        get clusterIdentifierInput(): string | undefined;
        private _clusterIdentifierPrefix?;
        /**
         * @stability stable
         */
        get clusterIdentifierPrefix(): string | undefined;
        /**
         * @stability stable
         */
        set clusterIdentifierPrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetClusterIdentifierPrefix(): void;
        /**
         * @stability stable
         */
        get clusterIdentifierPrefixInput(): string | undefined;
        /**
         * @stability stable
         */
        get clusterMembers(): string[];
        /**
         * @stability stable
         */
        get clusterResourceId(): string;
        private _copyTagsToSnapshot?;
        /**
         * @stability stable
         */
        get copyTagsToSnapshot(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set copyTagsToSnapshot(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetCopyTagsToSnapshot(): void;
        /**
         * @stability stable
         */
        get copyTagsToSnapshotInput(): boolean | cdktf.IResolvable | undefined;
        private _deletionProtection?;
        /**
         * @stability stable
         */
        get deletionProtection(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set deletionProtection(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDeletionProtection(): void;
        /**
         * @stability stable
         */
        get deletionProtectionInput(): boolean | cdktf.IResolvable | undefined;
        private _enableCloudwatchLogsExports?;
        /**
         * @stability stable
         */
        get enableCloudwatchLogsExports(): string[] | undefined;
        /**
         * @stability stable
         */
        set enableCloudwatchLogsExports(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetEnableCloudwatchLogsExports(): void;
        /**
         * @stability stable
         */
        get enableCloudwatchLogsExportsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get endpoint(): string;
        private _engine?;
        /**
         * @stability stable
         */
        get engine(): string | undefined;
        /**
         * @stability stable
         */
        set engine(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngine(): void;
        /**
         * @stability stable
         */
        get engineInput(): string | undefined;
        private _engineVersion?;
        /**
         * @stability stable
         */
        get engineVersion(): string | undefined;
        /**
         * @stability stable
         */
        set engineVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngineVersion(): void;
        /**
         * @stability stable
         */
        get engineVersionInput(): string | undefined;
        private _finalSnapshotIdentifier?;
        /**
         * @stability stable
         */
        get finalSnapshotIdentifier(): string | undefined;
        /**
         * @stability stable
         */
        set finalSnapshotIdentifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetFinalSnapshotIdentifier(): void;
        /**
         * @stability stable
         */
        get finalSnapshotIdentifierInput(): string | undefined;
        /**
         * @stability stable
         */
        get hostedZoneId(): string;
        private _iamDatabaseAuthenticationEnabled?;
        /**
         * @stability stable
         */
        get iamDatabaseAuthenticationEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set iamDatabaseAuthenticationEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIamDatabaseAuthenticationEnabled(): void;
        /**
         * @stability stable
         */
        get iamDatabaseAuthenticationEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _iamRoles?;
        /**
         * @stability stable
         */
        get iamRoles(): string[] | undefined;
        /**
         * @stability stable
         */
        set iamRoles(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetIamRoles(): void;
        /**
         * @stability stable
         */
        get iamRolesInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _kmsKeyArn?;
        /**
         * @stability stable
         */
        get kmsKeyArn(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyArn(): void;
        /**
         * @stability stable
         */
        get kmsKeyArnInput(): string | undefined;
        private _neptuneClusterParameterGroupName?;
        /**
         * @stability stable
         */
        get neptuneClusterParameterGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set neptuneClusterParameterGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetNeptuneClusterParameterGroupName(): void;
        /**
         * @stability stable
         */
        get neptuneClusterParameterGroupNameInput(): string | undefined;
        private _neptuneSubnetGroupName?;
        /**
         * @stability stable
         */
        get neptuneSubnetGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set neptuneSubnetGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetNeptuneSubnetGroupName(): void;
        /**
         * @stability stable
         */
        get neptuneSubnetGroupNameInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number | undefined;
        /**
         * @stability stable
         */
        set port(value: number | undefined);
        /**
         * @stability stable
         */
        resetPort(): void;
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
        private _preferredBackupWindow?;
        /**
         * @stability stable
         */
        get preferredBackupWindow(): string | undefined;
        /**
         * @stability stable
         */
        set preferredBackupWindow(value: string | undefined);
        /**
         * @stability stable
         */
        resetPreferredBackupWindow(): void;
        /**
         * @stability stable
         */
        get preferredBackupWindowInput(): string | undefined;
        private _preferredMaintenanceWindow?;
        /**
         * @stability stable
         */
        get preferredMaintenanceWindow(): string | undefined;
        /**
         * @stability stable
         */
        set preferredMaintenanceWindow(value: string | undefined);
        /**
         * @stability stable
         */
        resetPreferredMaintenanceWindow(): void;
        /**
         * @stability stable
         */
        get preferredMaintenanceWindowInput(): string | undefined;
        /**
         * @stability stable
         */
        get readerEndpoint(): string;
        private _replicationSourceIdentifier?;
        /**
         * @stability stable
         */
        get replicationSourceIdentifier(): string | undefined;
        /**
         * @stability stable
         */
        set replicationSourceIdentifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetReplicationSourceIdentifier(): void;
        /**
         * @stability stable
         */
        get replicationSourceIdentifierInput(): string | undefined;
        private _skipFinalSnapshot?;
        /**
         * @stability stable
         */
        get skipFinalSnapshot(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set skipFinalSnapshot(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetSkipFinalSnapshot(): void;
        /**
         * @stability stable
         */
        get skipFinalSnapshotInput(): boolean | cdktf.IResolvable | undefined;
        private _snapshotIdentifier?;
        /**
         * @stability stable
         */
        get snapshotIdentifier(): string | undefined;
        /**
         * @stability stable
         */
        set snapshotIdentifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetSnapshotIdentifier(): void;
        /**
         * @stability stable
         */
        get snapshotIdentifierInput(): string | undefined;
        private _storageEncrypted?;
        /**
         * @stability stable
         */
        get storageEncrypted(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set storageEncrypted(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetStorageEncrypted(): void;
        /**
         * @stability stable
         */
        get storageEncryptedInput(): boolean | cdktf.IResolvable | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _vpcSecurityGroupIds?;
        /**
         * @stability stable
         */
        get vpcSecurityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set vpcSecurityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetVpcSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get vpcSecurityGroupIdsInput(): string[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): NeptuneClusterTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: NeptuneClusterTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): NeptuneClusterTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface NeptuneClusterEndpointConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_endpoint.html#cluster_endpoint_identifier NeptuneClusterEndpoint#cluster_endpoint_identifier}.
         *
         * @stability stable
         */
        readonly clusterEndpointIdentifier: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_endpoint.html#cluster_identifier NeptuneClusterEndpoint#cluster_identifier}.
         *
         * @stability stable
         */
        readonly clusterIdentifier: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_endpoint.html#endpoint_type NeptuneClusterEndpoint#endpoint_type}.
         *
         * @stability stable
         */
        readonly endpointType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_endpoint.html#excluded_members NeptuneClusterEndpoint#excluded_members}.
         *
         * @stability stable
         */
        readonly excludedMembers?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_endpoint.html#static_members NeptuneClusterEndpoint#static_members}.
         *
         * @stability stable
         */
        readonly staticMembers?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_endpoint.html#tags NeptuneClusterEndpoint#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_endpoint.html#tags_all NeptuneClusterEndpoint#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_endpoint.html aws_neptune_cluster_endpoint}.
     *
     * @stability stable
     */
    class NeptuneClusterEndpoint extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_endpoint.html aws_neptune_cluster_endpoint} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: NeptuneClusterEndpointConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _clusterEndpointIdentifier?;
        /**
         * @stability stable
         */
        get clusterEndpointIdentifier(): string;
        /**
         * @stability stable
         */
        set clusterEndpointIdentifier(value: string);
        /**
         * @stability stable
         */
        get clusterEndpointIdentifierInput(): string | undefined;
        private _clusterIdentifier?;
        /**
         * @stability stable
         */
        get clusterIdentifier(): string;
        /**
         * @stability stable
         */
        set clusterIdentifier(value: string);
        /**
         * @stability stable
         */
        get clusterIdentifierInput(): string | undefined;
        /**
         * @stability stable
         */
        get endpoint(): string;
        private _endpointType?;
        /**
         * @stability stable
         */
        get endpointType(): string;
        /**
         * @stability stable
         */
        set endpointType(value: string);
        /**
         * @stability stable
         */
        get endpointTypeInput(): string | undefined;
        private _excludedMembers?;
        /**
         * @stability stable
         */
        get excludedMembers(): string[] | undefined;
        /**
         * @stability stable
         */
        set excludedMembers(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetExcludedMembers(): void;
        /**
         * @stability stable
         */
        get excludedMembersInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _staticMembers?;
        /**
         * @stability stable
         */
        get staticMembers(): string[] | undefined;
        /**
         * @stability stable
         */
        set staticMembers(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetStaticMembers(): void;
        /**
         * @stability stable
         */
        get staticMembersInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface NeptuneClusterInstanceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#apply_immediately NeptuneClusterInstance#apply_immediately}.
         *
         * @stability stable
         */
        readonly applyImmediately?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#auto_minor_version_upgrade NeptuneClusterInstance#auto_minor_version_upgrade}.
         *
         * @stability stable
         */
        readonly autoMinorVersionUpgrade?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#availability_zone NeptuneClusterInstance#availability_zone}.
         *
         * @stability stable
         */
        readonly availabilityZone?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#cluster_identifier NeptuneClusterInstance#cluster_identifier}.
         *
         * @stability stable
         */
        readonly clusterIdentifier: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#engine NeptuneClusterInstance#engine}.
         *
         * @stability stable
         */
        readonly engine?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#engine_version NeptuneClusterInstance#engine_version}.
         *
         * @stability stable
         */
        readonly engineVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#identifier NeptuneClusterInstance#identifier}.
         *
         * @stability stable
         */
        readonly identifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#identifier_prefix NeptuneClusterInstance#identifier_prefix}.
         *
         * @stability stable
         */
        readonly identifierPrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#instance_class NeptuneClusterInstance#instance_class}.
         *
         * @stability stable
         */
        readonly instanceClass: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#neptune_parameter_group_name NeptuneClusterInstance#neptune_parameter_group_name}.
         *
         * @stability stable
         */
        readonly neptuneParameterGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#neptune_subnet_group_name NeptuneClusterInstance#neptune_subnet_group_name}.
         *
         * @stability stable
         */
        readonly neptuneSubnetGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#port NeptuneClusterInstance#port}.
         *
         * @stability stable
         */
        readonly port?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#preferred_backup_window NeptuneClusterInstance#preferred_backup_window}.
         *
         * @stability stable
         */
        readonly preferredBackupWindow?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#preferred_maintenance_window NeptuneClusterInstance#preferred_maintenance_window}.
         *
         * @stability stable
         */
        readonly preferredMaintenanceWindow?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#promotion_tier NeptuneClusterInstance#promotion_tier}.
         *
         * @stability stable
         */
        readonly promotionTier?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#publicly_accessible NeptuneClusterInstance#publicly_accessible}.
         *
         * @stability stable
         */
        readonly publiclyAccessible?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#tags NeptuneClusterInstance#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#tags_all NeptuneClusterInstance#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#timeouts NeptuneClusterInstance#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: NeptuneClusterInstanceTimeouts;
    }
    /**
     * @stability stable
     */
    interface NeptuneClusterInstanceTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#create NeptuneClusterInstance#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#delete NeptuneClusterInstance#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html#update NeptuneClusterInstance#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class NeptuneClusterInstanceTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html aws_neptune_cluster_instance}.
     *
     * @stability stable
     */
    class NeptuneClusterInstance extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_instance.html aws_neptune_cluster_instance} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: NeptuneClusterInstanceConfig);
        /**
         * @stability stable
         */
        get address(): string;
        private _applyImmediately?;
        /**
         * @stability stable
         */
        get applyImmediately(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set applyImmediately(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetApplyImmediately(): void;
        /**
         * @stability stable
         */
        get applyImmediatelyInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoMinorVersionUpgrade?;
        /**
         * @stability stable
         */
        get autoMinorVersionUpgrade(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoMinorVersionUpgrade(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoMinorVersionUpgrade(): void;
        /**
         * @stability stable
         */
        get autoMinorVersionUpgradeInput(): boolean | cdktf.IResolvable | undefined;
        private _availabilityZone?;
        /**
         * @stability stable
         */
        get availabilityZone(): string | undefined;
        /**
         * @stability stable
         */
        set availabilityZone(value: string | undefined);
        /**
         * @stability stable
         */
        resetAvailabilityZone(): void;
        /**
         * @stability stable
         */
        get availabilityZoneInput(): string | undefined;
        private _clusterIdentifier?;
        /**
         * @stability stable
         */
        get clusterIdentifier(): string;
        /**
         * @stability stable
         */
        set clusterIdentifier(value: string);
        /**
         * @stability stable
         */
        get clusterIdentifierInput(): string | undefined;
        /**
         * @stability stable
         */
        get dbiResourceId(): string;
        /**
         * @stability stable
         */
        get endpoint(): string;
        private _engine?;
        /**
         * @stability stable
         */
        get engine(): string | undefined;
        /**
         * @stability stable
         */
        set engine(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngine(): void;
        /**
         * @stability stable
         */
        get engineInput(): string | undefined;
        private _engineVersion?;
        /**
         * @stability stable
         */
        get engineVersion(): string | undefined;
        /**
         * @stability stable
         */
        set engineVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngineVersion(): void;
        /**
         * @stability stable
         */
        get engineVersionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _identifier?;
        /**
         * @stability stable
         */
        get identifier(): string | undefined;
        /**
         * @stability stable
         */
        set identifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetIdentifier(): void;
        /**
         * @stability stable
         */
        get identifierInput(): string | undefined;
        private _identifierPrefix?;
        /**
         * @stability stable
         */
        get identifierPrefix(): string | undefined;
        /**
         * @stability stable
         */
        set identifierPrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetIdentifierPrefix(): void;
        /**
         * @stability stable
         */
        get identifierPrefixInput(): string | undefined;
        private _instanceClass?;
        /**
         * @stability stable
         */
        get instanceClass(): string;
        /**
         * @stability stable
         */
        set instanceClass(value: string);
        /**
         * @stability stable
         */
        get instanceClassInput(): string | undefined;
        /**
         * @stability stable
         */
        get kmsKeyArn(): string;
        private _neptuneParameterGroupName?;
        /**
         * @stability stable
         */
        get neptuneParameterGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set neptuneParameterGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetNeptuneParameterGroupName(): void;
        /**
         * @stability stable
         */
        get neptuneParameterGroupNameInput(): string | undefined;
        private _neptuneSubnetGroupName?;
        /**
         * @stability stable
         */
        get neptuneSubnetGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set neptuneSubnetGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetNeptuneSubnetGroupName(): void;
        /**
         * @stability stable
         */
        get neptuneSubnetGroupNameInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number | undefined;
        /**
         * @stability stable
         */
        set port(value: number | undefined);
        /**
         * @stability stable
         */
        resetPort(): void;
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
        private _preferredBackupWindow?;
        /**
         * @stability stable
         */
        get preferredBackupWindow(): string | undefined;
        /**
         * @stability stable
         */
        set preferredBackupWindow(value: string | undefined);
        /**
         * @stability stable
         */
        resetPreferredBackupWindow(): void;
        /**
         * @stability stable
         */
        get preferredBackupWindowInput(): string | undefined;
        private _preferredMaintenanceWindow?;
        /**
         * @stability stable
         */
        get preferredMaintenanceWindow(): string | undefined;
        /**
         * @stability stable
         */
        set preferredMaintenanceWindow(value: string | undefined);
        /**
         * @stability stable
         */
        resetPreferredMaintenanceWindow(): void;
        /**
         * @stability stable
         */
        get preferredMaintenanceWindowInput(): string | undefined;
        private _promotionTier?;
        /**
         * @stability stable
         */
        get promotionTier(): number | undefined;
        /**
         * @stability stable
         */
        set promotionTier(value: number | undefined);
        /**
         * @stability stable
         */
        resetPromotionTier(): void;
        /**
         * @stability stable
         */
        get promotionTierInput(): number | undefined;
        private _publiclyAccessible?;
        /**
         * @stability stable
         */
        get publiclyAccessible(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set publiclyAccessible(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetPubliclyAccessible(): void;
        /**
         * @stability stable
         */
        get publiclyAccessibleInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get storageEncrypted(): any;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get writer(): any;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): NeptuneClusterInstanceTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: NeptuneClusterInstanceTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): NeptuneClusterInstanceTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface NeptuneClusterParameterGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_parameter_group.html#description NeptuneClusterParameterGroup#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_parameter_group.html#family NeptuneClusterParameterGroup#family}.
         *
         * @stability stable
         */
        readonly family: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_parameter_group.html#name NeptuneClusterParameterGroup#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_parameter_group.html#name_prefix NeptuneClusterParameterGroup#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_parameter_group.html#tags NeptuneClusterParameterGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_parameter_group.html#tags_all NeptuneClusterParameterGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * parameter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_parameter_group.html#parameter NeptuneClusterParameterGroup#parameter}
         *
         * @stability stable
         */
        readonly parameter?: NeptuneClusterParameterGroupParameter[];
    }
    /**
     * @stability stable
     */
    interface NeptuneClusterParameterGroupParameter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_parameter_group.html#apply_method NeptuneClusterParameterGroup#apply_method}.
         *
         * @stability stable
         */
        readonly applyMethod?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_parameter_group.html#name NeptuneClusterParameterGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_parameter_group.html#value NeptuneClusterParameterGroup#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_parameter_group.html aws_neptune_cluster_parameter_group}.
     *
     * @stability stable
     */
    class NeptuneClusterParameterGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_parameter_group.html aws_neptune_cluster_parameter_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: NeptuneClusterParameterGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _family?;
        /**
         * @stability stable
         */
        get family(): string;
        /**
         * @stability stable
         */
        set family(value: string);
        /**
         * @stability stable
         */
        get familyInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set namePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamePrefix(): void;
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _parameter?;
        /**
         * @stability stable
         */
        get parameter(): NeptuneClusterParameterGroupParameter[] | undefined;
        /**
         * @stability stable
         */
        set parameter(value: NeptuneClusterParameterGroupParameter[] | undefined);
        /**
         * @stability stable
         */
        resetParameter(): void;
        /**
         * @stability stable
         */
        get parameterInput(): NeptuneClusterParameterGroupParameter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface NeptuneClusterSnapshotConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_snapshot.html#db_cluster_identifier NeptuneClusterSnapshot#db_cluster_identifier}.
         *
         * @stability stable
         */
        readonly dbClusterIdentifier: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_snapshot.html#db_cluster_snapshot_identifier NeptuneClusterSnapshot#db_cluster_snapshot_identifier}.
         *
         * @stability stable
         */
        readonly dbClusterSnapshotIdentifier: string;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_snapshot.html#timeouts NeptuneClusterSnapshot#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: NeptuneClusterSnapshotTimeouts;
    }
    /**
     * @stability stable
     */
    interface NeptuneClusterSnapshotTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_snapshot.html#create NeptuneClusterSnapshot#create}.
         *
         * @stability stable
         */
        readonly create?: string;
    }
    /**
     * @stability stable
     */
    class NeptuneClusterSnapshotTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_snapshot.html aws_neptune_cluster_snapshot}.
     *
     * @stability stable
     */
    class NeptuneClusterSnapshot extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/neptune_cluster_snapshot.html aws_neptune_cluster_snapshot} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: NeptuneClusterSnapshotConfig);
        /**
         * @stability stable
         */
        get allocatedStorage(): number;
        /**
         * @stability stable
         */
        get availabilityZones(): string[];
        private _dbClusterIdentifier?;
        /**
         * @stability stable
         */
        get dbClusterIdentifier(): string;
        /**
         * @stability stable
         */
        set dbClusterIdentifier(value: string);
        /**
         * @stability stable
         */
        get dbClusterIdentifierInput(): string | undefined;
        /**
         * @stability stable
         */
        get dbClusterSnapshotArn(): string;
        private _dbClusterSnapshotIdentifier?;
        /**
         * @stability stable
         */
        get dbClusterSnapshotIdentifier(): string;
        /**
         * @stability stable
         */
        set dbClusterSnapshotIdentifier(value: string);
        /**
         * @stability stable
         */
        get dbClusterSnapshotIdentifierInput(): string | undefined;
        /**
         * @stability stable
         */
        get engine(): string;
        /**
         * @stability stable
         */
        get engineVersion(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get kmsKeyId(): string;
        /**
         * @stability stable
         */
        get licenseModel(): string;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        get snapshotType(): string;
        /**
         * @stability stable
         */
        get sourceDbClusterSnapshotArn(): string;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        get storageEncrypted(): any;
        /**
         * @stability stable
         */
        get vpcId(): string;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): NeptuneClusterSnapshotTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: NeptuneClusterSnapshotTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): NeptuneClusterSnapshotTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface NeptuneEventSubscriptionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_event_subscription.html#enabled NeptuneEventSubscription#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_event_subscription.html#event_categories NeptuneEventSubscription#event_categories}.
         *
         * @stability stable
         */
        readonly eventCategories?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_event_subscription.html#name NeptuneEventSubscription#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_event_subscription.html#name_prefix NeptuneEventSubscription#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_event_subscription.html#sns_topic_arn NeptuneEventSubscription#sns_topic_arn}.
         *
         * @stability stable
         */
        readonly snsTopicArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_event_subscription.html#source_ids NeptuneEventSubscription#source_ids}.
         *
         * @stability stable
         */
        readonly sourceIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_event_subscription.html#source_type NeptuneEventSubscription#source_type}.
         *
         * @stability stable
         */
        readonly sourceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_event_subscription.html#tags NeptuneEventSubscription#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_event_subscription.html#tags_all NeptuneEventSubscription#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_event_subscription.html#timeouts NeptuneEventSubscription#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: NeptuneEventSubscriptionTimeouts;
    }
    /**
     * @stability stable
     */
    interface NeptuneEventSubscriptionTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_event_subscription.html#create NeptuneEventSubscription#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_event_subscription.html#delete NeptuneEventSubscription#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_event_subscription.html#update NeptuneEventSubscription#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class NeptuneEventSubscriptionTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/neptune_event_subscription.html aws_neptune_event_subscription}.
     *
     * @stability stable
     */
    class NeptuneEventSubscription extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/neptune_event_subscription.html aws_neptune_event_subscription} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: NeptuneEventSubscriptionConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get customerAwsId(): string;
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _eventCategories?;
        /**
         * @stability stable
         */
        get eventCategories(): string[] | undefined;
        /**
         * @stability stable
         */
        set eventCategories(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetEventCategories(): void;
        /**
         * @stability stable
         */
        get eventCategoriesInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set namePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamePrefix(): void;
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        private _snsTopicArn?;
        /**
         * @stability stable
         */
        get snsTopicArn(): string;
        /**
         * @stability stable
         */
        set snsTopicArn(value: string);
        /**
         * @stability stable
         */
        get snsTopicArnInput(): string | undefined;
        private _sourceIds?;
        /**
         * @stability stable
         */
        get sourceIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set sourceIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSourceIds(): void;
        /**
         * @stability stable
         */
        get sourceIdsInput(): string[] | undefined;
        private _sourceType?;
        /**
         * @stability stable
         */
        get sourceType(): string | undefined;
        /**
         * @stability stable
         */
        set sourceType(value: string | undefined);
        /**
         * @stability stable
         */
        resetSourceType(): void;
        /**
         * @stability stable
         */
        get sourceTypeInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): NeptuneEventSubscriptionTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: NeptuneEventSubscriptionTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): NeptuneEventSubscriptionTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface NeptuneParameterGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_parameter_group.html#description NeptuneParameterGroup#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_parameter_group.html#family NeptuneParameterGroup#family}.
         *
         * @stability stable
         */
        readonly family: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_parameter_group.html#name NeptuneParameterGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_parameter_group.html#tags NeptuneParameterGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_parameter_group.html#tags_all NeptuneParameterGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * parameter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_parameter_group.html#parameter NeptuneParameterGroup#parameter}
         *
         * @stability stable
         */
        readonly parameter?: NeptuneParameterGroupParameter[];
    }
    /**
     * @stability stable
     */
    interface NeptuneParameterGroupParameter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_parameter_group.html#apply_method NeptuneParameterGroup#apply_method}.
         *
         * @stability stable
         */
        readonly applyMethod?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_parameter_group.html#name NeptuneParameterGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_parameter_group.html#value NeptuneParameterGroup#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/neptune_parameter_group.html aws_neptune_parameter_group}.
     *
     * @stability stable
     */
    class NeptuneParameterGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/neptune_parameter_group.html aws_neptune_parameter_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: NeptuneParameterGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _family?;
        /**
         * @stability stable
         */
        get family(): string;
        /**
         * @stability stable
         */
        set family(value: string);
        /**
         * @stability stable
         */
        get familyInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _parameter?;
        /**
         * @stability stable
         */
        get parameter(): NeptuneParameterGroupParameter[] | undefined;
        /**
         * @stability stable
         */
        set parameter(value: NeptuneParameterGroupParameter[] | undefined);
        /**
         * @stability stable
         */
        resetParameter(): void;
        /**
         * @stability stable
         */
        get parameterInput(): NeptuneParameterGroupParameter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface NeptuneSubnetGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_subnet_group.html#description NeptuneSubnetGroup#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_subnet_group.html#name NeptuneSubnetGroup#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_subnet_group.html#name_prefix NeptuneSubnetGroup#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_subnet_group.html#subnet_ids NeptuneSubnetGroup#subnet_ids}.
         *
         * @stability stable
         */
        readonly subnetIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_subnet_group.html#tags NeptuneSubnetGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/neptune_subnet_group.html#tags_all NeptuneSubnetGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/neptune_subnet_group.html aws_neptune_subnet_group}.
     *
     * @stability stable
     */
    class NeptuneSubnetGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/neptune_subnet_group.html aws_neptune_subnet_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: NeptuneSubnetGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set namePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamePrefix(): void;
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        private _subnetIds?;
        /**
         * @stability stable
         */
        get subnetIds(): string[];
        /**
         * @stability stable
         */
        set subnetIds(value: string[]);
        /**
         * @stability stable
         */
        get subnetIdsInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsNeptuneEngineVersionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_engine_version.html#engine DataAwsNeptuneEngineVersion#engine}.
         *
         * @stability stable
         */
        readonly engine?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_engine_version.html#parameter_group_family DataAwsNeptuneEngineVersion#parameter_group_family}.
         *
         * @stability stable
         */
        readonly parameterGroupFamily?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_engine_version.html#preferred_versions DataAwsNeptuneEngineVersion#preferred_versions}.
         *
         * @stability stable
         */
        readonly preferredVersions?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_engine_version.html#version DataAwsNeptuneEngineVersion#version}.
         *
         * @stability stable
         */
        readonly version?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/neptune_engine_version.html aws_neptune_engine_version}.
     *
     * @stability stable
     */
    class DataAwsNeptuneEngineVersion extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/neptune_engine_version.html aws_neptune_engine_version} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsNeptuneEngineVersionConfig);
        private _engine?;
        /**
         * @stability stable
         */
        get engine(): string | undefined;
        /**
         * @stability stable
         */
        set engine(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngine(): void;
        /**
         * @stability stable
         */
        get engineInput(): string | undefined;
        /**
         * @stability stable
         */
        get engineDescription(): string;
        /**
         * @stability stable
         */
        get exportableLogTypes(): string[];
        /**
         * @stability stable
         */
        get id(): string;
        private _parameterGroupFamily?;
        /**
         * @stability stable
         */
        get parameterGroupFamily(): string | undefined;
        /**
         * @stability stable
         */
        set parameterGroupFamily(value: string | undefined);
        /**
         * @stability stable
         */
        resetParameterGroupFamily(): void;
        /**
         * @stability stable
         */
        get parameterGroupFamilyInput(): string | undefined;
        private _preferredVersions?;
        /**
         * @stability stable
         */
        get preferredVersions(): string[] | undefined;
        /**
         * @stability stable
         */
        set preferredVersions(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetPreferredVersions(): void;
        /**
         * @stability stable
         */
        get preferredVersionsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get supportedTimezones(): string[];
        /**
         * @stability stable
         */
        get supportsLogExportsToCloudwatch(): any;
        /**
         * @stability stable
         */
        get supportsReadReplica(): any;
        /**
         * @stability stable
         */
        get validUpgradeTargets(): string[];
        private _version?;
        /**
         * @stability stable
         */
        get version(): string | undefined;
        /**
         * @stability stable
         */
        set version(value: string | undefined);
        /**
         * @stability stable
         */
        resetVersion(): void;
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
        /**
         * @stability stable
         */
        get versionDescription(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsNeptuneOrderableDbInstanceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_orderable_db_instance.html#engine DataAwsNeptuneOrderableDbInstance#engine}.
         *
         * @stability stable
         */
        readonly engine?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_orderable_db_instance.html#engine_version DataAwsNeptuneOrderableDbInstance#engine_version}.
         *
         * @stability stable
         */
        readonly engineVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_orderable_db_instance.html#instance_class DataAwsNeptuneOrderableDbInstance#instance_class}.
         *
         * @stability stable
         */
        readonly instanceClass?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_orderable_db_instance.html#license_model DataAwsNeptuneOrderableDbInstance#license_model}.
         *
         * @stability stable
         */
        readonly licenseModel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_orderable_db_instance.html#preferred_instance_classes DataAwsNeptuneOrderableDbInstance#preferred_instance_classes}.
         *
         * @stability stable
         */
        readonly preferredInstanceClasses?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_orderable_db_instance.html#vpc DataAwsNeptuneOrderableDbInstance#vpc}.
         *
         * @stability stable
         */
        readonly vpc?: boolean | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/neptune_orderable_db_instance.html aws_neptune_orderable_db_instance}.
     *
     * @stability stable
     */
    class DataAwsNeptuneOrderableDbInstance extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/neptune_orderable_db_instance.html aws_neptune_orderable_db_instance} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsNeptuneOrderableDbInstanceConfig);
        /**
         * @stability stable
         */
        get availabilityZones(): string[];
        private _engine?;
        /**
         * @stability stable
         */
        get engine(): string | undefined;
        /**
         * @stability stable
         */
        set engine(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngine(): void;
        /**
         * @stability stable
         */
        get engineInput(): string | undefined;
        private _engineVersion?;
        /**
         * @stability stable
         */
        get engineVersion(): string | undefined;
        /**
         * @stability stable
         */
        set engineVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetEngineVersion(): void;
        /**
         * @stability stable
         */
        get engineVersionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceClass?;
        /**
         * @stability stable
         */
        get instanceClass(): string | undefined;
        /**
         * @stability stable
         */
        set instanceClass(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceClass(): void;
        /**
         * @stability stable
         */
        get instanceClassInput(): string | undefined;
        private _licenseModel?;
        /**
         * @stability stable
         */
        get licenseModel(): string | undefined;
        /**
         * @stability stable
         */
        set licenseModel(value: string | undefined);
        /**
         * @stability stable
         */
        resetLicenseModel(): void;
        /**
         * @stability stable
         */
        get licenseModelInput(): string | undefined;
        /**
         * @stability stable
         */
        get maxIopsPerDbInstance(): number;
        /**
         * @stability stable
         */
        get maxIopsPerGib(): number;
        /**
         * @stability stable
         */
        get maxStorageSize(): number;
        /**
         * @stability stable
         */
        get minIopsPerDbInstance(): number;
        /**
         * @stability stable
         */
        get minIopsPerGib(): number;
        /**
         * @stability stable
         */
        get minStorageSize(): number;
        /**
         * @stability stable
         */
        get multiAzCapable(): any;
        private _preferredInstanceClasses?;
        /**
         * @stability stable
         */
        get preferredInstanceClasses(): string[] | undefined;
        /**
         * @stability stable
         */
        set preferredInstanceClasses(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetPreferredInstanceClasses(): void;
        /**
         * @stability stable
         */
        get preferredInstanceClassesInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get readReplicaCapable(): any;
        /**
         * @stability stable
         */
        get storageType(): string;
        /**
         * @stability stable
         */
        get supportsEnhancedMonitoring(): any;
        /**
         * @stability stable
         */
        get supportsIamDatabaseAuthentication(): any;
        /**
         * @stability stable
         */
        get supportsIops(): any;
        /**
         * @stability stable
         */
        get supportsPerformanceInsights(): any;
        /**
         * @stability stable
         */
        get supportsStorageEncryption(): any;
        private _vpc?;
        /**
         * @stability stable
         */
        get vpc(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set vpc(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetVpc(): void;
        /**
         * @stability stable
         */
        get vpcInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
