import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Network Firewall
*/
export declare namespace NetworkFirewall {
    /**
     * @stability stable
     */
    interface NetworkfirewallFirewallConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall.html#delete_protection NetworkfirewallFirewall#delete_protection}.
         *
         * @stability stable
         */
        readonly deleteProtection?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall.html#description NetworkfirewallFirewall#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall.html#firewall_policy_arn NetworkfirewallFirewall#firewall_policy_arn}.
         *
         * @stability stable
         */
        readonly firewallPolicyArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall.html#firewall_policy_change_protection NetworkfirewallFirewall#firewall_policy_change_protection}.
         *
         * @stability stable
         */
        readonly firewallPolicyChangeProtection?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall.html#name NetworkfirewallFirewall#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall.html#subnet_change_protection NetworkfirewallFirewall#subnet_change_protection}.
         *
         * @stability stable
         */
        readonly subnetChangeProtection?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall.html#tags NetworkfirewallFirewall#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall.html#tags_all NetworkfirewallFirewall#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall.html#vpc_id NetworkfirewallFirewall#vpc_id}.
         *
         * @stability stable
         */
        readonly vpcId: string;
        /**
         * subnet_mapping block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall.html#subnet_mapping NetworkfirewallFirewall#subnet_mapping}
         *
         * @stability stable
         */
        readonly subnetMapping: NetworkfirewallFirewallSubnetMapping[];
    }
    /**
     * @stability stable
     */
    class NetworkfirewallFirewallFirewallStatusSyncStatesAttachment extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get endpointId(): string;
        /**
         * @stability stable
         */
        get subnetId(): string;
    }
    /**
     * @stability stable
     */
    class NetworkfirewallFirewallFirewallStatusSyncStates extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get attachment(): any;
        /**
         * @stability stable
         */
        get availabilityZone(): string;
    }
    /**
     * @stability stable
     */
    class NetworkfirewallFirewallFirewallStatus extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get syncStates(): any;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallFirewallSubnetMapping {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall.html#subnet_id NetworkfirewallFirewall#subnet_id}.
         *
         * @stability stable
         */
        readonly subnetId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall.html aws_networkfirewall_firewall}.
     *
     * @stability stable
     */
    class NetworkfirewallFirewall extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall.html aws_networkfirewall_firewall} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: NetworkfirewallFirewallConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _deleteProtection?;
        /**
         * @stability stable
         */
        get deleteProtection(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set deleteProtection(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDeleteProtection(): void;
        /**
         * @stability stable
         */
        get deleteProtectionInput(): boolean | cdktf.IResolvable | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _firewallPolicyArn?;
        /**
         * @stability stable
         */
        get firewallPolicyArn(): string;
        /**
         * @stability stable
         */
        set firewallPolicyArn(value: string);
        /**
         * @stability stable
         */
        get firewallPolicyArnInput(): string | undefined;
        private _firewallPolicyChangeProtection?;
        /**
         * @stability stable
         */
        get firewallPolicyChangeProtection(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set firewallPolicyChangeProtection(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetFirewallPolicyChangeProtection(): void;
        /**
         * @stability stable
         */
        get firewallPolicyChangeProtectionInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        firewallStatus(index: string): NetworkfirewallFirewallFirewallStatus;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _subnetChangeProtection?;
        /**
         * @stability stable
         */
        get subnetChangeProtection(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set subnetChangeProtection(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetSubnetChangeProtection(): void;
        /**
         * @stability stable
         */
        get subnetChangeProtectionInput(): boolean | cdktf.IResolvable | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get updateToken(): string;
        private _vpcId?;
        /**
         * @stability stable
         */
        get vpcId(): string;
        /**
         * @stability stable
         */
        set vpcId(value: string);
        /**
         * @stability stable
         */
        get vpcIdInput(): string | undefined;
        private _subnetMapping?;
        /**
         * @stability stable
         */
        get subnetMapping(): NetworkfirewallFirewallSubnetMapping[];
        /**
         * @stability stable
         */
        set subnetMapping(value: NetworkfirewallFirewallSubnetMapping[]);
        /**
         * @stability stable
         */
        get subnetMappingInput(): NetworkfirewallFirewallSubnetMapping[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallFirewallPolicyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#description NetworkfirewallFirewallPolicy#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#name NetworkfirewallFirewallPolicy#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#tags NetworkfirewallFirewallPolicy#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#tags_all NetworkfirewallFirewallPolicy#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * firewall_policy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#firewall_policy NetworkfirewallFirewallPolicy#firewall_policy}
         *
         * @stability stable
         */
        readonly firewallPolicy: NetworkfirewallFirewallPolicyFirewallPolicy;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallFirewallPolicyFirewallPolicyStatefulRuleGroupReference {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#resource_arn NetworkfirewallFirewallPolicy#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinitionPublishMetricActionDimension {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#value NetworkfirewallFirewallPolicy#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinitionPublishMetricAction {
        /**
         * dimension block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#dimension NetworkfirewallFirewallPolicy#dimension}
         *
         * @stability stable
         */
        readonly dimension: NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinitionPublishMetricActionDimension[];
    }
    /**
     * @stability stable
     */
    class NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinitionPublishMetricActionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _dimension?;
        /**
         * @stability stable
         */
        get dimension(): NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinitionPublishMetricActionDimension[];
        /**
         * @stability stable
         */
        set dimension(value: NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinitionPublishMetricActionDimension[]);
        /**
         * @stability stable
         */
        get dimensionInput(): NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinitionPublishMetricActionDimension[] | undefined;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinition {
        /**
         * publish_metric_action block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#publish_metric_action NetworkfirewallFirewallPolicy#publish_metric_action}
         *
         * @stability stable
         */
        readonly publishMetricAction: NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinitionPublishMetricAction;
    }
    /**
     * @stability stable
     */
    class NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinitionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _publishMetricAction?;
        private __publishMetricActionOutput;
        /**
         * @stability stable
         */
        get publishMetricAction(): NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinitionPublishMetricActionOutputReference;
        /**
         * @stability stable
         */
        putPublishMetricAction(value: NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinitionPublishMetricAction): void;
        /**
         * @stability stable
         */
        get publishMetricActionInput(): NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinitionPublishMetricAction | undefined;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomAction {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#action_name NetworkfirewallFirewallPolicy#action_name}.
         *
         * @stability stable
         */
        readonly actionName: string;
        /**
         * action_definition block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#action_definition NetworkfirewallFirewallPolicy#action_definition}
         *
         * @stability stable
         */
        readonly actionDefinition: NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinition;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallFirewallPolicyFirewallPolicyStatelessRuleGroupReference {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#priority NetworkfirewallFirewallPolicy#priority}.
         *
         * @stability stable
         */
        readonly priority: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#resource_arn NetworkfirewallFirewallPolicy#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallFirewallPolicyFirewallPolicy {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#stateless_default_actions NetworkfirewallFirewallPolicy#stateless_default_actions}.
         *
         * @stability stable
         */
        readonly statelessDefaultActions: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#stateless_fragment_default_actions NetworkfirewallFirewallPolicy#stateless_fragment_default_actions}.
         *
         * @stability stable
         */
        readonly statelessFragmentDefaultActions: string[];
        /**
         * stateful_rule_group_reference block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#stateful_rule_group_reference NetworkfirewallFirewallPolicy#stateful_rule_group_reference}
         *
         * @stability stable
         */
        readonly statefulRuleGroupReference?: NetworkfirewallFirewallPolicyFirewallPolicyStatefulRuleGroupReference[];
        /**
         * stateless_custom_action block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#stateless_custom_action NetworkfirewallFirewallPolicy#stateless_custom_action}
         *
         * @stability stable
         */
        readonly statelessCustomAction?: NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomAction[];
        /**
         * stateless_rule_group_reference block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html#stateless_rule_group_reference NetworkfirewallFirewallPolicy#stateless_rule_group_reference}
         *
         * @stability stable
         */
        readonly statelessRuleGroupReference?: NetworkfirewallFirewallPolicyFirewallPolicyStatelessRuleGroupReference[];
    }
    /**
     * @stability stable
     */
    class NetworkfirewallFirewallPolicyFirewallPolicyOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _statelessDefaultActions?;
        /**
         * @stability stable
         */
        get statelessDefaultActions(): string[];
        /**
         * @stability stable
         */
        set statelessDefaultActions(value: string[]);
        /**
         * @stability stable
         */
        get statelessDefaultActionsInput(): string[] | undefined;
        private _statelessFragmentDefaultActions?;
        /**
         * @stability stable
         */
        get statelessFragmentDefaultActions(): string[];
        /**
         * @stability stable
         */
        set statelessFragmentDefaultActions(value: string[]);
        /**
         * @stability stable
         */
        get statelessFragmentDefaultActionsInput(): string[] | undefined;
        private _statefulRuleGroupReference?;
        /**
         * @stability stable
         */
        get statefulRuleGroupReference(): NetworkfirewallFirewallPolicyFirewallPolicyStatefulRuleGroupReference[] | undefined;
        /**
         * @stability stable
         */
        set statefulRuleGroupReference(value: NetworkfirewallFirewallPolicyFirewallPolicyStatefulRuleGroupReference[] | undefined);
        /**
         * @stability stable
         */
        resetStatefulRuleGroupReference(): void;
        /**
         * @stability stable
         */
        get statefulRuleGroupReferenceInput(): NetworkfirewallFirewallPolicyFirewallPolicyStatefulRuleGroupReference[] | undefined;
        private _statelessCustomAction?;
        /**
         * @stability stable
         */
        get statelessCustomAction(): NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomAction[] | undefined;
        /**
         * @stability stable
         */
        set statelessCustomAction(value: NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomAction[] | undefined);
        /**
         * @stability stable
         */
        resetStatelessCustomAction(): void;
        /**
         * @stability stable
         */
        get statelessCustomActionInput(): NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomAction[] | undefined;
        private _statelessRuleGroupReference?;
        /**
         * @stability stable
         */
        get statelessRuleGroupReference(): NetworkfirewallFirewallPolicyFirewallPolicyStatelessRuleGroupReference[] | undefined;
        /**
         * @stability stable
         */
        set statelessRuleGroupReference(value: NetworkfirewallFirewallPolicyFirewallPolicyStatelessRuleGroupReference[] | undefined);
        /**
         * @stability stable
         */
        resetStatelessRuleGroupReference(): void;
        /**
         * @stability stable
         */
        get statelessRuleGroupReferenceInput(): NetworkfirewallFirewallPolicyFirewallPolicyStatelessRuleGroupReference[] | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html aws_networkfirewall_firewall_policy}.
     *
     * @stability stable
     */
    class NetworkfirewallFirewallPolicy extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall_policy.html aws_networkfirewall_firewall_policy} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: NetworkfirewallFirewallPolicyConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get updateToken(): string;
        private _firewallPolicy?;
        private __firewallPolicyOutput;
        /**
         * @stability stable
         */
        get firewallPolicy(): NetworkfirewallFirewallPolicyFirewallPolicyOutputReference;
        /**
         * @stability stable
         */
        putFirewallPolicy(value: NetworkfirewallFirewallPolicyFirewallPolicy): void;
        /**
         * @stability stable
         */
        get firewallPolicyInput(): NetworkfirewallFirewallPolicyFirewallPolicy | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallLoggingConfigurationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration.html#firewall_arn NetworkfirewallLoggingConfiguration#firewall_arn}.
         *
         * @stability stable
         */
        readonly firewallArn: string;
        /**
         * logging_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration.html#logging_configuration NetworkfirewallLoggingConfiguration#logging_configuration}
         *
         * @stability stable
         */
        readonly loggingConfiguration: NetworkfirewallLoggingConfigurationLoggingConfiguration;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallLoggingConfigurationLoggingConfigurationLogDestinationConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration.html#log_destination NetworkfirewallLoggingConfiguration#log_destination}.
         *
         * @stability stable
         */
        readonly logDestination: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration.html#log_destination_type NetworkfirewallLoggingConfiguration#log_destination_type}.
         *
         * @stability stable
         */
        readonly logDestinationType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration.html#log_type NetworkfirewallLoggingConfiguration#log_type}.
         *
         * @stability stable
         */
        readonly logType: string;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallLoggingConfigurationLoggingConfiguration {
        /**
         * log_destination_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration.html#log_destination_config NetworkfirewallLoggingConfiguration#log_destination_config}
         *
         * @stability stable
         */
        readonly logDestinationConfig: NetworkfirewallLoggingConfigurationLoggingConfigurationLogDestinationConfig[];
    }
    /**
     * @stability stable
     */
    class NetworkfirewallLoggingConfigurationLoggingConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _logDestinationConfig?;
        /**
         * @stability stable
         */
        get logDestinationConfig(): NetworkfirewallLoggingConfigurationLoggingConfigurationLogDestinationConfig[];
        /**
         * @stability stable
         */
        set logDestinationConfig(value: NetworkfirewallLoggingConfigurationLoggingConfigurationLogDestinationConfig[]);
        /**
         * @stability stable
         */
        get logDestinationConfigInput(): NetworkfirewallLoggingConfigurationLoggingConfigurationLogDestinationConfig[] | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration.html aws_networkfirewall_logging_configuration}.
     *
     * @stability stable
     */
    class NetworkfirewallLoggingConfiguration extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration.html aws_networkfirewall_logging_configuration} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: NetworkfirewallLoggingConfigurationConfig);
        private _firewallArn?;
        /**
         * @stability stable
         */
        get firewallArn(): string;
        /**
         * @stability stable
         */
        set firewallArn(value: string);
        /**
         * @stability stable
         */
        get firewallArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _loggingConfiguration?;
        private __loggingConfigurationOutput;
        /**
         * @stability stable
         */
        get loggingConfiguration(): NetworkfirewallLoggingConfigurationLoggingConfigurationOutputReference;
        /**
         * @stability stable
         */
        putLoggingConfiguration(value: NetworkfirewallLoggingConfigurationLoggingConfiguration): void;
        /**
         * @stability stable
         */
        get loggingConfigurationInput(): NetworkfirewallLoggingConfigurationLoggingConfiguration | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallResourcePolicyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_resource_policy.html#policy NetworkfirewallResourcePolicy#policy}.
         *
         * @stability stable
         */
        readonly policy: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_resource_policy.html#resource_arn NetworkfirewallResourcePolicy#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_resource_policy.html aws_networkfirewall_resource_policy}.
     *
     * @stability stable
     */
    class NetworkfirewallResourcePolicy extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_resource_policy.html aws_networkfirewall_resource_policy} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: NetworkfirewallResourcePolicyConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _policy?;
        /**
         * @stability stable
         */
        get policy(): string;
        /**
         * @stability stable
         */
        set policy(value: string);
        /**
         * @stability stable
         */
        get policyInput(): string | undefined;
        private _resourceArn?;
        /**
         * @stability stable
         */
        get resourceArn(): string;
        /**
         * @stability stable
         */
        set resourceArn(value: string);
        /**
         * @stability stable
         */
        get resourceArnInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#capacity NetworkfirewallRuleGroup#capacity}.
         *
         * @stability stable
         */
        readonly capacity: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#description NetworkfirewallRuleGroup#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#name NetworkfirewallRuleGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#rules NetworkfirewallRuleGroup#rules}.
         *
         * @stability stable
         */
        readonly rules?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#tags NetworkfirewallRuleGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#tags_all NetworkfirewallRuleGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#type NetworkfirewallRuleGroup#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * rule_group block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#rule_group NetworkfirewallRuleGroup#rule_group}
         *
         * @stability stable
         */
        readonly ruleGroup?: NetworkfirewallRuleGroupRuleGroup;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRuleVariablesIpSetsIpSet {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#definition NetworkfirewallRuleGroup#definition}.
         *
         * @stability stable
         */
        readonly definition: string[];
    }
    /**
     * @stability stable
     */
    class NetworkfirewallRuleGroupRuleGroupRuleVariablesIpSetsIpSetOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _definition?;
        /**
         * @stability stable
         */
        get definition(): string[];
        /**
         * @stability stable
         */
        set definition(value: string[]);
        /**
         * @stability stable
         */
        get definitionInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRuleVariablesIpSets {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#key NetworkfirewallRuleGroup#key}.
         *
         * @stability stable
         */
        readonly key: string;
        /**
         * ip_set block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#ip_set NetworkfirewallRuleGroup#ip_set}
         *
         * @stability stable
         */
        readonly ipSet: NetworkfirewallRuleGroupRuleGroupRuleVariablesIpSetsIpSet;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRuleVariablesPortSetsPortSet {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#definition NetworkfirewallRuleGroup#definition}.
         *
         * @stability stable
         */
        readonly definition: string[];
    }
    /**
     * @stability stable
     */
    class NetworkfirewallRuleGroupRuleGroupRuleVariablesPortSetsPortSetOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _definition?;
        /**
         * @stability stable
         */
        get definition(): string[];
        /**
         * @stability stable
         */
        set definition(value: string[]);
        /**
         * @stability stable
         */
        get definitionInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRuleVariablesPortSets {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#key NetworkfirewallRuleGroup#key}.
         *
         * @stability stable
         */
        readonly key: string;
        /**
         * port_set block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#port_set NetworkfirewallRuleGroup#port_set}
         *
         * @stability stable
         */
        readonly portSet: NetworkfirewallRuleGroupRuleGroupRuleVariablesPortSetsPortSet;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRuleVariables {
        /**
         * ip_sets block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#ip_sets NetworkfirewallRuleGroup#ip_sets}
         *
         * @stability stable
         */
        readonly ipSets?: NetworkfirewallRuleGroupRuleGroupRuleVariablesIpSets[];
        /**
         * port_sets block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#port_sets NetworkfirewallRuleGroup#port_sets}
         *
         * @stability stable
         */
        readonly portSets?: NetworkfirewallRuleGroupRuleGroupRuleVariablesPortSets[];
    }
    /**
     * @stability stable
     */
    class NetworkfirewallRuleGroupRuleGroupRuleVariablesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _ipSets?;
        /**
         * @stability stable
         */
        get ipSets(): NetworkfirewallRuleGroupRuleGroupRuleVariablesIpSets[] | undefined;
        /**
         * @stability stable
         */
        set ipSets(value: NetworkfirewallRuleGroupRuleGroupRuleVariablesIpSets[] | undefined);
        /**
         * @stability stable
         */
        resetIpSets(): void;
        /**
         * @stability stable
         */
        get ipSetsInput(): NetworkfirewallRuleGroupRuleGroupRuleVariablesIpSets[] | undefined;
        private _portSets?;
        /**
         * @stability stable
         */
        get portSets(): NetworkfirewallRuleGroupRuleGroupRuleVariablesPortSets[] | undefined;
        /**
         * @stability stable
         */
        set portSets(value: NetworkfirewallRuleGroupRuleGroupRuleVariablesPortSets[] | undefined);
        /**
         * @stability stable
         */
        resetPortSets(): void;
        /**
         * @stability stable
         */
        get portSetsInput(): NetworkfirewallRuleGroupRuleGroupRuleVariablesPortSets[] | undefined;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceRulesSourceList {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#generated_rules_type NetworkfirewallRuleGroup#generated_rules_type}.
         *
         * @stability stable
         */
        readonly generatedRulesType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#target_types NetworkfirewallRuleGroup#target_types}.
         *
         * @stability stable
         */
        readonly targetTypes: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#targets NetworkfirewallRuleGroup#targets}.
         *
         * @stability stable
         */
        readonly targets: string[];
    }
    /**
     * @stability stable
     */
    class NetworkfirewallRuleGroupRuleGroupRulesSourceRulesSourceListOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _generatedRulesType?;
        /**
         * @stability stable
         */
        get generatedRulesType(): string;
        /**
         * @stability stable
         */
        set generatedRulesType(value: string);
        /**
         * @stability stable
         */
        get generatedRulesTypeInput(): string | undefined;
        private _targetTypes?;
        /**
         * @stability stable
         */
        get targetTypes(): string[];
        /**
         * @stability stable
         */
        set targetTypes(value: string[]);
        /**
         * @stability stable
         */
        get targetTypesInput(): string[] | undefined;
        private _targets?;
        /**
         * @stability stable
         */
        get targets(): string[];
        /**
         * @stability stable
         */
        set targets(value: string[]);
        /**
         * @stability stable
         */
        get targetsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatefulRuleHeader {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#destination NetworkfirewallRuleGroup#destination}.
         *
         * @stability stable
         */
        readonly destination: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#destination_port NetworkfirewallRuleGroup#destination_port}.
         *
         * @stability stable
         */
        readonly destinationPort: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#direction NetworkfirewallRuleGroup#direction}.
         *
         * @stability stable
         */
        readonly direction: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#protocol NetworkfirewallRuleGroup#protocol}.
         *
         * @stability stable
         */
        readonly protocol: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#source NetworkfirewallRuleGroup#source}.
         *
         * @stability stable
         */
        readonly source: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#source_port NetworkfirewallRuleGroup#source_port}.
         *
         * @stability stable
         */
        readonly sourcePort: string;
    }
    /**
     * @stability stable
     */
    class NetworkfirewallRuleGroupRuleGroupRulesSourceStatefulRuleHeaderOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _destination?;
        /**
         * @stability stable
         */
        get destination(): string;
        /**
         * @stability stable
         */
        set destination(value: string);
        /**
         * @stability stable
         */
        get destinationInput(): string | undefined;
        private _destinationPort?;
        /**
         * @stability stable
         */
        get destinationPort(): string;
        /**
         * @stability stable
         */
        set destinationPort(value: string);
        /**
         * @stability stable
         */
        get destinationPortInput(): string | undefined;
        private _direction?;
        /**
         * @stability stable
         */
        get direction(): string;
        /**
         * @stability stable
         */
        set direction(value: string);
        /**
         * @stability stable
         */
        get directionInput(): string | undefined;
        private _protocol?;
        /**
         * @stability stable
         */
        get protocol(): string;
        /**
         * @stability stable
         */
        set protocol(value: string);
        /**
         * @stability stable
         */
        get protocolInput(): string | undefined;
        private _source?;
        /**
         * @stability stable
         */
        get source(): string;
        /**
         * @stability stable
         */
        set source(value: string);
        /**
         * @stability stable
         */
        get sourceInput(): string | undefined;
        private _sourcePort?;
        /**
         * @stability stable
         */
        get sourcePort(): string;
        /**
         * @stability stable
         */
        set sourcePort(value: string);
        /**
         * @stability stable
         */
        get sourcePortInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatefulRuleRuleOption {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#keyword NetworkfirewallRuleGroup#keyword}.
         *
         * @stability stable
         */
        readonly keyword: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#settings NetworkfirewallRuleGroup#settings}.
         *
         * @stability stable
         */
        readonly settings?: string[];
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatefulRule {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#action NetworkfirewallRuleGroup#action}.
         *
         * @stability stable
         */
        readonly action: string;
        /**
         * header block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#header NetworkfirewallRuleGroup#header}
         *
         * @stability stable
         */
        readonly header: NetworkfirewallRuleGroupRuleGroupRulesSourceStatefulRuleHeader;
        /**
         * rule_option block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#rule_option NetworkfirewallRuleGroup#rule_option}
         *
         * @stability stable
         */
        readonly ruleOption: NetworkfirewallRuleGroupRuleGroupRulesSourceStatefulRuleRuleOption[];
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinitionPublishMetricActionDimension {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#value NetworkfirewallRuleGroup#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinitionPublishMetricAction {
        /**
         * dimension block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#dimension NetworkfirewallRuleGroup#dimension}
         *
         * @stability stable
         */
        readonly dimension: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinitionPublishMetricActionDimension[];
    }
    /**
     * @stability stable
     */
    class NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinitionPublishMetricActionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _dimension?;
        /**
         * @stability stable
         */
        get dimension(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinitionPublishMetricActionDimension[];
        /**
         * @stability stable
         */
        set dimension(value: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinitionPublishMetricActionDimension[]);
        /**
         * @stability stable
         */
        get dimensionInput(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinitionPublishMetricActionDimension[] | undefined;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinition {
        /**
         * publish_metric_action block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#publish_metric_action NetworkfirewallRuleGroup#publish_metric_action}
         *
         * @stability stable
         */
        readonly publishMetricAction: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinitionPublishMetricAction;
    }
    /**
     * @stability stable
     */
    class NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinitionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _publishMetricAction?;
        private __publishMetricActionOutput;
        /**
         * @stability stable
         */
        get publishMetricAction(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinitionPublishMetricActionOutputReference;
        /**
         * @stability stable
         */
        putPublishMetricAction(value: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinitionPublishMetricAction): void;
        /**
         * @stability stable
         */
        get publishMetricActionInput(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinitionPublishMetricAction | undefined;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomAction {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#action_name NetworkfirewallRuleGroup#action_name}.
         *
         * @stability stable
         */
        readonly actionName: string;
        /**
         * action_definition block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#action_definition NetworkfirewallRuleGroup#action_definition}
         *
         * @stability stable
         */
        readonly actionDefinition: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinition;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesDestination {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#address_definition NetworkfirewallRuleGroup#address_definition}.
         *
         * @stability stable
         */
        readonly addressDefinition: string;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesDestinationPort {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#from_port NetworkfirewallRuleGroup#from_port}.
         *
         * @stability stable
         */
        readonly fromPort: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#to_port NetworkfirewallRuleGroup#to_port}.
         *
         * @stability stable
         */
        readonly toPort?: number;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesSource {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#address_definition NetworkfirewallRuleGroup#address_definition}.
         *
         * @stability stable
         */
        readonly addressDefinition: string;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesSourcePort {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#from_port NetworkfirewallRuleGroup#from_port}.
         *
         * @stability stable
         */
        readonly fromPort: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#to_port NetworkfirewallRuleGroup#to_port}.
         *
         * @stability stable
         */
        readonly toPort?: number;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesTcpFlag {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#flags NetworkfirewallRuleGroup#flags}.
         *
         * @stability stable
         */
        readonly flags: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#masks NetworkfirewallRuleGroup#masks}.
         *
         * @stability stable
         */
        readonly masks?: string[];
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributes {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#protocols NetworkfirewallRuleGroup#protocols}.
         *
         * @stability stable
         */
        readonly protocols?: number[];
        /**
         * destination block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#destination NetworkfirewallRuleGroup#destination}
         *
         * @stability stable
         */
        readonly destination?: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesDestination[];
        /**
         * destination_port block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#destination_port NetworkfirewallRuleGroup#destination_port}
         *
         * @stability stable
         */
        readonly destinationPort?: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesDestinationPort[];
        /**
         * source block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#source NetworkfirewallRuleGroup#source}
         *
         * @stability stable
         */
        readonly source?: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesSource[];
        /**
         * source_port block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#source_port NetworkfirewallRuleGroup#source_port}
         *
         * @stability stable
         */
        readonly sourcePort?: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesSourcePort[];
        /**
         * tcp_flag block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#tcp_flag NetworkfirewallRuleGroup#tcp_flag}
         *
         * @stability stable
         */
        readonly tcpFlag?: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesTcpFlag[];
    }
    /**
     * @stability stable
     */
    class NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _protocols?;
        /**
         * @stability stable
         */
        get protocols(): number[] | undefined;
        /**
         * @stability stable
         */
        set protocols(value: number[] | undefined);
        /**
         * @stability stable
         */
        resetProtocols(): void;
        /**
         * @stability stable
         */
        get protocolsInput(): number[] | undefined;
        private _destination?;
        /**
         * @stability stable
         */
        get destination(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesDestination[] | undefined;
        /**
         * @stability stable
         */
        set destination(value: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesDestination[] | undefined);
        /**
         * @stability stable
         */
        resetDestination(): void;
        /**
         * @stability stable
         */
        get destinationInput(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesDestination[] | undefined;
        private _destinationPort?;
        /**
         * @stability stable
         */
        get destinationPort(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesDestinationPort[] | undefined;
        /**
         * @stability stable
         */
        set destinationPort(value: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesDestinationPort[] | undefined);
        /**
         * @stability stable
         */
        resetDestinationPort(): void;
        /**
         * @stability stable
         */
        get destinationPortInput(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesDestinationPort[] | undefined;
        private _source?;
        /**
         * @stability stable
         */
        get source(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesSource[] | undefined;
        /**
         * @stability stable
         */
        set source(value: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesSource[] | undefined);
        /**
         * @stability stable
         */
        resetSource(): void;
        /**
         * @stability stable
         */
        get sourceInput(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesSource[] | undefined;
        private _sourcePort?;
        /**
         * @stability stable
         */
        get sourcePort(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesSourcePort[] | undefined;
        /**
         * @stability stable
         */
        set sourcePort(value: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesSourcePort[] | undefined);
        /**
         * @stability stable
         */
        resetSourcePort(): void;
        /**
         * @stability stable
         */
        get sourcePortInput(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesSourcePort[] | undefined;
        private _tcpFlag?;
        /**
         * @stability stable
         */
        get tcpFlag(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesTcpFlag[] | undefined;
        /**
         * @stability stable
         */
        set tcpFlag(value: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesTcpFlag[] | undefined);
        /**
         * @stability stable
         */
        resetTcpFlag(): void;
        /**
         * @stability stable
         */
        get tcpFlagInput(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesTcpFlag[] | undefined;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinition {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#actions NetworkfirewallRuleGroup#actions}.
         *
         * @stability stable
         */
        readonly actions: string[];
        /**
         * match_attributes block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#match_attributes NetworkfirewallRuleGroup#match_attributes}
         *
         * @stability stable
         */
        readonly matchAttributes: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributes;
    }
    /**
     * @stability stable
     */
    class NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _actions?;
        /**
         * @stability stable
         */
        get actions(): string[];
        /**
         * @stability stable
         */
        set actions(value: string[]);
        /**
         * @stability stable
         */
        get actionsInput(): string[] | undefined;
        private _matchAttributes?;
        private __matchAttributesOutput;
        /**
         * @stability stable
         */
        get matchAttributes(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesOutputReference;
        /**
         * @stability stable
         */
        putMatchAttributes(value: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributes): void;
        /**
         * @stability stable
         */
        get matchAttributesInput(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributes | undefined;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRule {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#priority NetworkfirewallRuleGroup#priority}.
         *
         * @stability stable
         */
        readonly priority: number;
        /**
         * rule_definition block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#rule_definition NetworkfirewallRuleGroup#rule_definition}
         *
         * @stability stable
         */
        readonly ruleDefinition: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinition;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActions {
        /**
         * custom_action block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#custom_action NetworkfirewallRuleGroup#custom_action}
         *
         * @stability stable
         */
        readonly customAction?: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomAction[];
        /**
         * stateless_rule block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#stateless_rule NetworkfirewallRuleGroup#stateless_rule}
         *
         * @stability stable
         */
        readonly statelessRule: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRule[];
    }
    /**
     * @stability stable
     */
    class NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _customAction?;
        /**
         * @stability stable
         */
        get customAction(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomAction[] | undefined;
        /**
         * @stability stable
         */
        set customAction(value: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomAction[] | undefined);
        /**
         * @stability stable
         */
        resetCustomAction(): void;
        /**
         * @stability stable
         */
        get customActionInput(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomAction[] | undefined;
        private _statelessRule?;
        /**
         * @stability stable
         */
        get statelessRule(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRule[];
        /**
         * @stability stable
         */
        set statelessRule(value: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRule[]);
        /**
         * @stability stable
         */
        get statelessRuleInput(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRule[] | undefined;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroupRulesSource {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#rules_string NetworkfirewallRuleGroup#rules_string}.
         *
         * @stability stable
         */
        readonly rulesString?: string;
        /**
         * rules_source_list block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#rules_source_list NetworkfirewallRuleGroup#rules_source_list}
         *
         * @stability stable
         */
        readonly rulesSourceList?: NetworkfirewallRuleGroupRuleGroupRulesSourceRulesSourceList;
        /**
         * stateful_rule block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#stateful_rule NetworkfirewallRuleGroup#stateful_rule}
         *
         * @stability stable
         */
        readonly statefulRule?: NetworkfirewallRuleGroupRuleGroupRulesSourceStatefulRule[];
        /**
         * stateless_rules_and_custom_actions block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#stateless_rules_and_custom_actions NetworkfirewallRuleGroup#stateless_rules_and_custom_actions}
         *
         * @stability stable
         */
        readonly statelessRulesAndCustomActions?: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActions;
    }
    /**
     * @stability stable
     */
    class NetworkfirewallRuleGroupRuleGroupRulesSourceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _rulesString?;
        /**
         * @stability stable
         */
        get rulesString(): string | undefined;
        /**
         * @stability stable
         */
        set rulesString(value: string | undefined);
        /**
         * @stability stable
         */
        resetRulesString(): void;
        /**
         * @stability stable
         */
        get rulesStringInput(): string | undefined;
        private _rulesSourceList?;
        private __rulesSourceListOutput;
        /**
         * @stability stable
         */
        get rulesSourceList(): NetworkfirewallRuleGroupRuleGroupRulesSourceRulesSourceListOutputReference;
        /**
         * @stability stable
         */
        putRulesSourceList(value: NetworkfirewallRuleGroupRuleGroupRulesSourceRulesSourceList | undefined): void;
        /**
         * @stability stable
         */
        resetRulesSourceList(): void;
        /**
         * @stability stable
         */
        get rulesSourceListInput(): NetworkfirewallRuleGroupRuleGroupRulesSourceRulesSourceList | undefined;
        private _statefulRule?;
        /**
         * @stability stable
         */
        get statefulRule(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatefulRule[] | undefined;
        /**
         * @stability stable
         */
        set statefulRule(value: NetworkfirewallRuleGroupRuleGroupRulesSourceStatefulRule[] | undefined);
        /**
         * @stability stable
         */
        resetStatefulRule(): void;
        /**
         * @stability stable
         */
        get statefulRuleInput(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatefulRule[] | undefined;
        private _statelessRulesAndCustomActions?;
        private __statelessRulesAndCustomActionsOutput;
        /**
         * @stability stable
         */
        get statelessRulesAndCustomActions(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsOutputReference;
        /**
         * @stability stable
         */
        putStatelessRulesAndCustomActions(value: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActions | undefined): void;
        /**
         * @stability stable
         */
        resetStatelessRulesAndCustomActions(): void;
        /**
         * @stability stable
         */
        get statelessRulesAndCustomActionsInput(): NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActions | undefined;
    }
    /**
     * @stability stable
     */
    interface NetworkfirewallRuleGroupRuleGroup {
        /**
         * rule_variables block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#rule_variables NetworkfirewallRuleGroup#rule_variables}
         *
         * @stability stable
         */
        readonly ruleVariables?: NetworkfirewallRuleGroupRuleGroupRuleVariables;
        /**
         * rules_source block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html#rules_source NetworkfirewallRuleGroup#rules_source}
         *
         * @stability stable
         */
        readonly rulesSource: NetworkfirewallRuleGroupRuleGroupRulesSource;
    }
    /**
     * @stability stable
     */
    class NetworkfirewallRuleGroupRuleGroupOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _ruleVariables?;
        private __ruleVariablesOutput;
        /**
         * @stability stable
         */
        get ruleVariables(): NetworkfirewallRuleGroupRuleGroupRuleVariablesOutputReference;
        /**
         * @stability stable
         */
        putRuleVariables(value: NetworkfirewallRuleGroupRuleGroupRuleVariables | undefined): void;
        /**
         * @stability stable
         */
        resetRuleVariables(): void;
        /**
         * @stability stable
         */
        get ruleVariablesInput(): NetworkfirewallRuleGroupRuleGroupRuleVariables | undefined;
        private _rulesSource?;
        private __rulesSourceOutput;
        /**
         * @stability stable
         */
        get rulesSource(): NetworkfirewallRuleGroupRuleGroupRulesSourceOutputReference;
        /**
         * @stability stable
         */
        putRulesSource(value: NetworkfirewallRuleGroupRuleGroupRulesSource): void;
        /**
         * @stability stable
         */
        get rulesSourceInput(): NetworkfirewallRuleGroupRuleGroupRulesSource | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html aws_networkfirewall_rule_group}.
     *
     * @stability stable
     */
    class NetworkfirewallRuleGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_rule_group.html aws_networkfirewall_rule_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: NetworkfirewallRuleGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _capacity?;
        /**
         * @stability stable
         */
        get capacity(): number;
        /**
         * @stability stable
         */
        set capacity(value: number);
        /**
         * @stability stable
         */
        get capacityInput(): number | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _rules?;
        /**
         * @stability stable
         */
        get rules(): string | undefined;
        /**
         * @stability stable
         */
        set rules(value: string | undefined);
        /**
         * @stability stable
         */
        resetRules(): void;
        /**
         * @stability stable
         */
        get rulesInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        /**
         * @stability stable
         */
        get updateToken(): string;
        private _ruleGroup?;
        private __ruleGroupOutput;
        /**
         * @stability stable
         */
        get ruleGroup(): NetworkfirewallRuleGroupRuleGroupOutputReference;
        /**
         * @stability stable
         */
        putRuleGroup(value: NetworkfirewallRuleGroupRuleGroup | undefined): void;
        /**
         * @stability stable
         */
        resetRuleGroup(): void;
        /**
         * @stability stable
         */
        get ruleGroupInput(): NetworkfirewallRuleGroupRuleGroup | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
