import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Pinpoint
*/
export declare namespace Pinpoint {
    /**
     * @stability stable
     */
    interface PinpointAdmChannelConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_adm_channel.html#application_id PinpointAdmChannel#application_id}.
         *
         * @stability stable
         */
        readonly applicationId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_adm_channel.html#client_id PinpointAdmChannel#client_id}.
         *
         * @stability stable
         */
        readonly clientId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_adm_channel.html#client_secret PinpointAdmChannel#client_secret}.
         *
         * @stability stable
         */
        readonly clientSecret: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_adm_channel.html#enabled PinpointAdmChannel#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_adm_channel.html aws_pinpoint_adm_channel}.
     *
     * @stability stable
     */
    class PinpointAdmChannel extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_adm_channel.html aws_pinpoint_adm_channel} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: PinpointAdmChannelConfig);
        private _applicationId?;
        /**
         * @stability stable
         */
        get applicationId(): string;
        /**
         * @stability stable
         */
        set applicationId(value: string);
        /**
         * @stability stable
         */
        get applicationIdInput(): string | undefined;
        private _clientId?;
        /**
         * @stability stable
         */
        get clientId(): string;
        /**
         * @stability stable
         */
        set clientId(value: string);
        /**
         * @stability stable
         */
        get clientIdInput(): string | undefined;
        private _clientSecret?;
        /**
         * @stability stable
         */
        get clientSecret(): string;
        /**
         * @stability stable
         */
        set clientSecret(value: string);
        /**
         * @stability stable
         */
        get clientSecretInput(): string | undefined;
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface PinpointApnsChannelConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_channel.html#application_id PinpointApnsChannel#application_id}.
         *
         * @stability stable
         */
        readonly applicationId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_channel.html#bundle_id PinpointApnsChannel#bundle_id}.
         *
         * @stability stable
         */
        readonly bundleId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_channel.html#certificate PinpointApnsChannel#certificate}.
         *
         * @stability stable
         */
        readonly certificate?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_channel.html#default_authentication_method PinpointApnsChannel#default_authentication_method}.
         *
         * @stability stable
         */
        readonly defaultAuthenticationMethod?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_channel.html#enabled PinpointApnsChannel#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_channel.html#private_key PinpointApnsChannel#private_key}.
         *
         * @stability stable
         */
        readonly privateKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_channel.html#team_id PinpointApnsChannel#team_id}.
         *
         * @stability stable
         */
        readonly teamId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_channel.html#token_key PinpointApnsChannel#token_key}.
         *
         * @stability stable
         */
        readonly tokenKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_channel.html#token_key_id PinpointApnsChannel#token_key_id}.
         *
         * @stability stable
         */
        readonly tokenKeyId?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_channel.html aws_pinpoint_apns_channel}.
     *
     * @stability stable
     */
    class PinpointApnsChannel extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_channel.html aws_pinpoint_apns_channel} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: PinpointApnsChannelConfig);
        private _applicationId?;
        /**
         * @stability stable
         */
        get applicationId(): string;
        /**
         * @stability stable
         */
        set applicationId(value: string);
        /**
         * @stability stable
         */
        get applicationIdInput(): string | undefined;
        private _bundleId?;
        /**
         * @stability stable
         */
        get bundleId(): string | undefined;
        /**
         * @stability stable
         */
        set bundleId(value: string | undefined);
        /**
         * @stability stable
         */
        resetBundleId(): void;
        /**
         * @stability stable
         */
        get bundleIdInput(): string | undefined;
        private _certificate?;
        /**
         * @stability stable
         */
        get certificate(): string | undefined;
        /**
         * @stability stable
         */
        set certificate(value: string | undefined);
        /**
         * @stability stable
         */
        resetCertificate(): void;
        /**
         * @stability stable
         */
        get certificateInput(): string | undefined;
        private _defaultAuthenticationMethod?;
        /**
         * @stability stable
         */
        get defaultAuthenticationMethod(): string | undefined;
        /**
         * @stability stable
         */
        set defaultAuthenticationMethod(value: string | undefined);
        /**
         * @stability stable
         */
        resetDefaultAuthenticationMethod(): void;
        /**
         * @stability stable
         */
        get defaultAuthenticationMethodInput(): string | undefined;
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _privateKey?;
        /**
         * @stability stable
         */
        get privateKey(): string | undefined;
        /**
         * @stability stable
         */
        set privateKey(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrivateKey(): void;
        /**
         * @stability stable
         */
        get privateKeyInput(): string | undefined;
        private _teamId?;
        /**
         * @stability stable
         */
        get teamId(): string | undefined;
        /**
         * @stability stable
         */
        set teamId(value: string | undefined);
        /**
         * @stability stable
         */
        resetTeamId(): void;
        /**
         * @stability stable
         */
        get teamIdInput(): string | undefined;
        private _tokenKey?;
        /**
         * @stability stable
         */
        get tokenKey(): string | undefined;
        /**
         * @stability stable
         */
        set tokenKey(value: string | undefined);
        /**
         * @stability stable
         */
        resetTokenKey(): void;
        /**
         * @stability stable
         */
        get tokenKeyInput(): string | undefined;
        private _tokenKeyId?;
        /**
         * @stability stable
         */
        get tokenKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set tokenKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetTokenKeyId(): void;
        /**
         * @stability stable
         */
        get tokenKeyIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface PinpointApnsSandboxChannelConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_sandbox_channel.html#application_id PinpointApnsSandboxChannel#application_id}.
         *
         * @stability stable
         */
        readonly applicationId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_sandbox_channel.html#bundle_id PinpointApnsSandboxChannel#bundle_id}.
         *
         * @stability stable
         */
        readonly bundleId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_sandbox_channel.html#certificate PinpointApnsSandboxChannel#certificate}.
         *
         * @stability stable
         */
        readonly certificate?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_sandbox_channel.html#default_authentication_method PinpointApnsSandboxChannel#default_authentication_method}.
         *
         * @stability stable
         */
        readonly defaultAuthenticationMethod?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_sandbox_channel.html#enabled PinpointApnsSandboxChannel#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_sandbox_channel.html#private_key PinpointApnsSandboxChannel#private_key}.
         *
         * @stability stable
         */
        readonly privateKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_sandbox_channel.html#team_id PinpointApnsSandboxChannel#team_id}.
         *
         * @stability stable
         */
        readonly teamId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_sandbox_channel.html#token_key PinpointApnsSandboxChannel#token_key}.
         *
         * @stability stable
         */
        readonly tokenKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_sandbox_channel.html#token_key_id PinpointApnsSandboxChannel#token_key_id}.
         *
         * @stability stable
         */
        readonly tokenKeyId?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_sandbox_channel.html aws_pinpoint_apns_sandbox_channel}.
     *
     * @stability stable
     */
    class PinpointApnsSandboxChannel extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_sandbox_channel.html aws_pinpoint_apns_sandbox_channel} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: PinpointApnsSandboxChannelConfig);
        private _applicationId?;
        /**
         * @stability stable
         */
        get applicationId(): string;
        /**
         * @stability stable
         */
        set applicationId(value: string);
        /**
         * @stability stable
         */
        get applicationIdInput(): string | undefined;
        private _bundleId?;
        /**
         * @stability stable
         */
        get bundleId(): string | undefined;
        /**
         * @stability stable
         */
        set bundleId(value: string | undefined);
        /**
         * @stability stable
         */
        resetBundleId(): void;
        /**
         * @stability stable
         */
        get bundleIdInput(): string | undefined;
        private _certificate?;
        /**
         * @stability stable
         */
        get certificate(): string | undefined;
        /**
         * @stability stable
         */
        set certificate(value: string | undefined);
        /**
         * @stability stable
         */
        resetCertificate(): void;
        /**
         * @stability stable
         */
        get certificateInput(): string | undefined;
        private _defaultAuthenticationMethod?;
        /**
         * @stability stable
         */
        get defaultAuthenticationMethod(): string | undefined;
        /**
         * @stability stable
         */
        set defaultAuthenticationMethod(value: string | undefined);
        /**
         * @stability stable
         */
        resetDefaultAuthenticationMethod(): void;
        /**
         * @stability stable
         */
        get defaultAuthenticationMethodInput(): string | undefined;
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _privateKey?;
        /**
         * @stability stable
         */
        get privateKey(): string | undefined;
        /**
         * @stability stable
         */
        set privateKey(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrivateKey(): void;
        /**
         * @stability stable
         */
        get privateKeyInput(): string | undefined;
        private _teamId?;
        /**
         * @stability stable
         */
        get teamId(): string | undefined;
        /**
         * @stability stable
         */
        set teamId(value: string | undefined);
        /**
         * @stability stable
         */
        resetTeamId(): void;
        /**
         * @stability stable
         */
        get teamIdInput(): string | undefined;
        private _tokenKey?;
        /**
         * @stability stable
         */
        get tokenKey(): string | undefined;
        /**
         * @stability stable
         */
        set tokenKey(value: string | undefined);
        /**
         * @stability stable
         */
        resetTokenKey(): void;
        /**
         * @stability stable
         */
        get tokenKeyInput(): string | undefined;
        private _tokenKeyId?;
        /**
         * @stability stable
         */
        get tokenKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set tokenKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetTokenKeyId(): void;
        /**
         * @stability stable
         */
        get tokenKeyIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface PinpointApnsVoipChannelConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_channel.html#application_id PinpointApnsVoipChannel#application_id}.
         *
         * @stability stable
         */
        readonly applicationId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_channel.html#bundle_id PinpointApnsVoipChannel#bundle_id}.
         *
         * @stability stable
         */
        readonly bundleId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_channel.html#certificate PinpointApnsVoipChannel#certificate}.
         *
         * @stability stable
         */
        readonly certificate?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_channel.html#default_authentication_method PinpointApnsVoipChannel#default_authentication_method}.
         *
         * @stability stable
         */
        readonly defaultAuthenticationMethod?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_channel.html#enabled PinpointApnsVoipChannel#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_channel.html#private_key PinpointApnsVoipChannel#private_key}.
         *
         * @stability stable
         */
        readonly privateKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_channel.html#team_id PinpointApnsVoipChannel#team_id}.
         *
         * @stability stable
         */
        readonly teamId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_channel.html#token_key PinpointApnsVoipChannel#token_key}.
         *
         * @stability stable
         */
        readonly tokenKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_channel.html#token_key_id PinpointApnsVoipChannel#token_key_id}.
         *
         * @stability stable
         */
        readonly tokenKeyId?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_channel.html aws_pinpoint_apns_voip_channel}.
     *
     * @stability stable
     */
    class PinpointApnsVoipChannel extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_channel.html aws_pinpoint_apns_voip_channel} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: PinpointApnsVoipChannelConfig);
        private _applicationId?;
        /**
         * @stability stable
         */
        get applicationId(): string;
        /**
         * @stability stable
         */
        set applicationId(value: string);
        /**
         * @stability stable
         */
        get applicationIdInput(): string | undefined;
        private _bundleId?;
        /**
         * @stability stable
         */
        get bundleId(): string | undefined;
        /**
         * @stability stable
         */
        set bundleId(value: string | undefined);
        /**
         * @stability stable
         */
        resetBundleId(): void;
        /**
         * @stability stable
         */
        get bundleIdInput(): string | undefined;
        private _certificate?;
        /**
         * @stability stable
         */
        get certificate(): string | undefined;
        /**
         * @stability stable
         */
        set certificate(value: string | undefined);
        /**
         * @stability stable
         */
        resetCertificate(): void;
        /**
         * @stability stable
         */
        get certificateInput(): string | undefined;
        private _defaultAuthenticationMethod?;
        /**
         * @stability stable
         */
        get defaultAuthenticationMethod(): string | undefined;
        /**
         * @stability stable
         */
        set defaultAuthenticationMethod(value: string | undefined);
        /**
         * @stability stable
         */
        resetDefaultAuthenticationMethod(): void;
        /**
         * @stability stable
         */
        get defaultAuthenticationMethodInput(): string | undefined;
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _privateKey?;
        /**
         * @stability stable
         */
        get privateKey(): string | undefined;
        /**
         * @stability stable
         */
        set privateKey(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrivateKey(): void;
        /**
         * @stability stable
         */
        get privateKeyInput(): string | undefined;
        private _teamId?;
        /**
         * @stability stable
         */
        get teamId(): string | undefined;
        /**
         * @stability stable
         */
        set teamId(value: string | undefined);
        /**
         * @stability stable
         */
        resetTeamId(): void;
        /**
         * @stability stable
         */
        get teamIdInput(): string | undefined;
        private _tokenKey?;
        /**
         * @stability stable
         */
        get tokenKey(): string | undefined;
        /**
         * @stability stable
         */
        set tokenKey(value: string | undefined);
        /**
         * @stability stable
         */
        resetTokenKey(): void;
        /**
         * @stability stable
         */
        get tokenKeyInput(): string | undefined;
        private _tokenKeyId?;
        /**
         * @stability stable
         */
        get tokenKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set tokenKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetTokenKeyId(): void;
        /**
         * @stability stable
         */
        get tokenKeyIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface PinpointApnsVoipSandboxChannelConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_sandbox_channel.html#application_id PinpointApnsVoipSandboxChannel#application_id}.
         *
         * @stability stable
         */
        readonly applicationId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_sandbox_channel.html#bundle_id PinpointApnsVoipSandboxChannel#bundle_id}.
         *
         * @stability stable
         */
        readonly bundleId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_sandbox_channel.html#certificate PinpointApnsVoipSandboxChannel#certificate}.
         *
         * @stability stable
         */
        readonly certificate?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_sandbox_channel.html#default_authentication_method PinpointApnsVoipSandboxChannel#default_authentication_method}.
         *
         * @stability stable
         */
        readonly defaultAuthenticationMethod?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_sandbox_channel.html#enabled PinpointApnsVoipSandboxChannel#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_sandbox_channel.html#private_key PinpointApnsVoipSandboxChannel#private_key}.
         *
         * @stability stable
         */
        readonly privateKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_sandbox_channel.html#team_id PinpointApnsVoipSandboxChannel#team_id}.
         *
         * @stability stable
         */
        readonly teamId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_sandbox_channel.html#token_key PinpointApnsVoipSandboxChannel#token_key}.
         *
         * @stability stable
         */
        readonly tokenKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_sandbox_channel.html#token_key_id PinpointApnsVoipSandboxChannel#token_key_id}.
         *
         * @stability stable
         */
        readonly tokenKeyId?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_sandbox_channel.html aws_pinpoint_apns_voip_sandbox_channel}.
     *
     * @stability stable
     */
    class PinpointApnsVoipSandboxChannel extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_apns_voip_sandbox_channel.html aws_pinpoint_apns_voip_sandbox_channel} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: PinpointApnsVoipSandboxChannelConfig);
        private _applicationId?;
        /**
         * @stability stable
         */
        get applicationId(): string;
        /**
         * @stability stable
         */
        set applicationId(value: string);
        /**
         * @stability stable
         */
        get applicationIdInput(): string | undefined;
        private _bundleId?;
        /**
         * @stability stable
         */
        get bundleId(): string | undefined;
        /**
         * @stability stable
         */
        set bundleId(value: string | undefined);
        /**
         * @stability stable
         */
        resetBundleId(): void;
        /**
         * @stability stable
         */
        get bundleIdInput(): string | undefined;
        private _certificate?;
        /**
         * @stability stable
         */
        get certificate(): string | undefined;
        /**
         * @stability stable
         */
        set certificate(value: string | undefined);
        /**
         * @stability stable
         */
        resetCertificate(): void;
        /**
         * @stability stable
         */
        get certificateInput(): string | undefined;
        private _defaultAuthenticationMethod?;
        /**
         * @stability stable
         */
        get defaultAuthenticationMethod(): string | undefined;
        /**
         * @stability stable
         */
        set defaultAuthenticationMethod(value: string | undefined);
        /**
         * @stability stable
         */
        resetDefaultAuthenticationMethod(): void;
        /**
         * @stability stable
         */
        get defaultAuthenticationMethodInput(): string | undefined;
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _privateKey?;
        /**
         * @stability stable
         */
        get privateKey(): string | undefined;
        /**
         * @stability stable
         */
        set privateKey(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrivateKey(): void;
        /**
         * @stability stable
         */
        get privateKeyInput(): string | undefined;
        private _teamId?;
        /**
         * @stability stable
         */
        get teamId(): string | undefined;
        /**
         * @stability stable
         */
        set teamId(value: string | undefined);
        /**
         * @stability stable
         */
        resetTeamId(): void;
        /**
         * @stability stable
         */
        get teamIdInput(): string | undefined;
        private _tokenKey?;
        /**
         * @stability stable
         */
        get tokenKey(): string | undefined;
        /**
         * @stability stable
         */
        set tokenKey(value: string | undefined);
        /**
         * @stability stable
         */
        resetTokenKey(): void;
        /**
         * @stability stable
         */
        get tokenKeyInput(): string | undefined;
        private _tokenKeyId?;
        /**
         * @stability stable
         */
        get tokenKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set tokenKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetTokenKeyId(): void;
        /**
         * @stability stable
         */
        get tokenKeyIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface PinpointAppConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html#name PinpointApp#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html#name_prefix PinpointApp#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html#tags PinpointApp#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html#tags_all PinpointApp#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * campaign_hook block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html#campaign_hook PinpointApp#campaign_hook}
         *
         * @stability stable
         */
        readonly campaignHook?: PinpointAppCampaignHook;
        /**
         * limits block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html#limits PinpointApp#limits}
         *
         * @stability stable
         */
        readonly limits?: PinpointAppLimits;
        /**
         * quiet_time block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html#quiet_time PinpointApp#quiet_time}
         *
         * @stability stable
         */
        readonly quietTime?: PinpointAppQuietTime;
    }
    /**
     * @stability stable
     */
    interface PinpointAppCampaignHook {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html#lambda_function_name PinpointApp#lambda_function_name}.
         *
         * @stability stable
         */
        readonly lambdaFunctionName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html#mode PinpointApp#mode}.
         *
         * @stability stable
         */
        readonly mode?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html#web_url PinpointApp#web_url}.
         *
         * @stability stable
         */
        readonly webUrl?: string;
    }
    /**
     * @stability stable
     */
    class PinpointAppCampaignHookOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _lambdaFunctionName?;
        /**
         * @stability stable
         */
        get lambdaFunctionName(): string | undefined;
        /**
         * @stability stable
         */
        set lambdaFunctionName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLambdaFunctionName(): void;
        /**
         * @stability stable
         */
        get lambdaFunctionNameInput(): string | undefined;
        private _mode?;
        /**
         * @stability stable
         */
        get mode(): string | undefined;
        /**
         * @stability stable
         */
        set mode(value: string | undefined);
        /**
         * @stability stable
         */
        resetMode(): void;
        /**
         * @stability stable
         */
        get modeInput(): string | undefined;
        private _webUrl?;
        /**
         * @stability stable
         */
        get webUrl(): string | undefined;
        /**
         * @stability stable
         */
        set webUrl(value: string | undefined);
        /**
         * @stability stable
         */
        resetWebUrl(): void;
        /**
         * @stability stable
         */
        get webUrlInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface PinpointAppLimits {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html#daily PinpointApp#daily}.
         *
         * @stability stable
         */
        readonly daily?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html#maximum_duration PinpointApp#maximum_duration}.
         *
         * @stability stable
         */
        readonly maximumDuration?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html#messages_per_second PinpointApp#messages_per_second}.
         *
         * @stability stable
         */
        readonly messagesPerSecond?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html#total PinpointApp#total}.
         *
         * @stability stable
         */
        readonly total?: number;
    }
    /**
     * @stability stable
     */
    class PinpointAppLimitsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _daily?;
        /**
         * @stability stable
         */
        get daily(): number | undefined;
        /**
         * @stability stable
         */
        set daily(value: number | undefined);
        /**
         * @stability stable
         */
        resetDaily(): void;
        /**
         * @stability stable
         */
        get dailyInput(): number | undefined;
        private _maximumDuration?;
        /**
         * @stability stable
         */
        get maximumDuration(): number | undefined;
        /**
         * @stability stable
         */
        set maximumDuration(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaximumDuration(): void;
        /**
         * @stability stable
         */
        get maximumDurationInput(): number | undefined;
        private _messagesPerSecond?;
        /**
         * @stability stable
         */
        get messagesPerSecond(): number | undefined;
        /**
         * @stability stable
         */
        set messagesPerSecond(value: number | undefined);
        /**
         * @stability stable
         */
        resetMessagesPerSecond(): void;
        /**
         * @stability stable
         */
        get messagesPerSecondInput(): number | undefined;
        private _total?;
        /**
         * @stability stable
         */
        get total(): number | undefined;
        /**
         * @stability stable
         */
        set total(value: number | undefined);
        /**
         * @stability stable
         */
        resetTotal(): void;
        /**
         * @stability stable
         */
        get totalInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface PinpointAppQuietTime {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html#end PinpointApp#end}.
         *
         * @stability stable
         */
        readonly end?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html#start PinpointApp#start}.
         *
         * @stability stable
         */
        readonly start?: string;
    }
    /**
     * @stability stable
     */
    class PinpointAppQuietTimeOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _end?;
        /**
         * @stability stable
         */
        get end(): string | undefined;
        /**
         * @stability stable
         */
        set end(value: string | undefined);
        /**
         * @stability stable
         */
        resetEnd(): void;
        /**
         * @stability stable
         */
        get endInput(): string | undefined;
        private _start?;
        /**
         * @stability stable
         */
        get start(): string | undefined;
        /**
         * @stability stable
         */
        set start(value: string | undefined);
        /**
         * @stability stable
         */
        resetStart(): void;
        /**
         * @stability stable
         */
        get startInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html aws_pinpoint_app}.
     *
     * @stability stable
     */
    class PinpointApp extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app.html aws_pinpoint_app} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: PinpointAppConfig);
        /**
         * @stability stable
         */
        get applicationId(): string;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set namePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamePrefix(): void;
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _campaignHook?;
        private __campaignHookOutput;
        /**
         * @stability stable
         */
        get campaignHook(): PinpointAppCampaignHookOutputReference;
        /**
         * @stability stable
         */
        putCampaignHook(value: PinpointAppCampaignHook | undefined): void;
        /**
         * @stability stable
         */
        resetCampaignHook(): void;
        /**
         * @stability stable
         */
        get campaignHookInput(): PinpointAppCampaignHook | undefined;
        private _limits?;
        private __limitsOutput;
        /**
         * @stability stable
         */
        get limits(): PinpointAppLimitsOutputReference;
        /**
         * @stability stable
         */
        putLimits(value: PinpointAppLimits | undefined): void;
        /**
         * @stability stable
         */
        resetLimits(): void;
        /**
         * @stability stable
         */
        get limitsInput(): PinpointAppLimits | undefined;
        private _quietTime?;
        private __quietTimeOutput;
        /**
         * @stability stable
         */
        get quietTime(): PinpointAppQuietTimeOutputReference;
        /**
         * @stability stable
         */
        putQuietTime(value: PinpointAppQuietTime | undefined): void;
        /**
         * @stability stable
         */
        resetQuietTime(): void;
        /**
         * @stability stable
         */
        get quietTimeInput(): PinpointAppQuietTime | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface PinpointBaiduChannelConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_baidu_channel.html#api_key PinpointBaiduChannel#api_key}.
         *
         * @stability stable
         */
        readonly apiKey: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_baidu_channel.html#application_id PinpointBaiduChannel#application_id}.
         *
         * @stability stable
         */
        readonly applicationId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_baidu_channel.html#enabled PinpointBaiduChannel#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_baidu_channel.html#secret_key PinpointBaiduChannel#secret_key}.
         *
         * @stability stable
         */
        readonly secretKey: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_baidu_channel.html aws_pinpoint_baidu_channel}.
     *
     * @stability stable
     */
    class PinpointBaiduChannel extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_baidu_channel.html aws_pinpoint_baidu_channel} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: PinpointBaiduChannelConfig);
        private _apiKey?;
        /**
         * @stability stable
         */
        get apiKey(): string;
        /**
         * @stability stable
         */
        set apiKey(value: string);
        /**
         * @stability stable
         */
        get apiKeyInput(): string | undefined;
        private _applicationId?;
        /**
         * @stability stable
         */
        get applicationId(): string;
        /**
         * @stability stable
         */
        set applicationId(value: string);
        /**
         * @stability stable
         */
        get applicationIdInput(): string | undefined;
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _secretKey?;
        /**
         * @stability stable
         */
        get secretKey(): string;
        /**
         * @stability stable
         */
        set secretKey(value: string);
        /**
         * @stability stable
         */
        get secretKeyInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface PinpointEmailChannelConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_email_channel.html#application_id PinpointEmailChannel#application_id}.
         *
         * @stability stable
         */
        readonly applicationId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_email_channel.html#configuration_set PinpointEmailChannel#configuration_set}.
         *
         * @stability stable
         */
        readonly configurationSet?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_email_channel.html#enabled PinpointEmailChannel#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_email_channel.html#from_address PinpointEmailChannel#from_address}.
         *
         * @stability stable
         */
        readonly fromAddress: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_email_channel.html#identity PinpointEmailChannel#identity}.
         *
         * @stability stable
         */
        readonly identity: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_email_channel.html#role_arn PinpointEmailChannel#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_email_channel.html aws_pinpoint_email_channel}.
     *
     * @stability stable
     */
    class PinpointEmailChannel extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_email_channel.html aws_pinpoint_email_channel} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: PinpointEmailChannelConfig);
        private _applicationId?;
        /**
         * @stability stable
         */
        get applicationId(): string;
        /**
         * @stability stable
         */
        set applicationId(value: string);
        /**
         * @stability stable
         */
        get applicationIdInput(): string | undefined;
        private _configurationSet?;
        /**
         * @stability stable
         */
        get configurationSet(): string | undefined;
        /**
         * @stability stable
         */
        set configurationSet(value: string | undefined);
        /**
         * @stability stable
         */
        resetConfigurationSet(): void;
        /**
         * @stability stable
         */
        get configurationSetInput(): string | undefined;
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _fromAddress?;
        /**
         * @stability stable
         */
        get fromAddress(): string;
        /**
         * @stability stable
         */
        set fromAddress(value: string);
        /**
         * @stability stable
         */
        get fromAddressInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _identity?;
        /**
         * @stability stable
         */
        get identity(): string;
        /**
         * @stability stable
         */
        set identity(value: string);
        /**
         * @stability stable
         */
        get identityInput(): string | undefined;
        /**
         * @stability stable
         */
        get messagesPerSecond(): number;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string | undefined;
        /**
         * @stability stable
         */
        set roleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetRoleArn(): void;
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface PinpointEventStreamConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_event_stream.html#application_id PinpointEventStream#application_id}.
         *
         * @stability stable
         */
        readonly applicationId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_event_stream.html#destination_stream_arn PinpointEventStream#destination_stream_arn}.
         *
         * @stability stable
         */
        readonly destinationStreamArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_event_stream.html#role_arn PinpointEventStream#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_event_stream.html aws_pinpoint_event_stream}.
     *
     * @stability stable
     */
    class PinpointEventStream extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_event_stream.html aws_pinpoint_event_stream} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: PinpointEventStreamConfig);
        private _applicationId?;
        /**
         * @stability stable
         */
        get applicationId(): string;
        /**
         * @stability stable
         */
        set applicationId(value: string);
        /**
         * @stability stable
         */
        get applicationIdInput(): string | undefined;
        private _destinationStreamArn?;
        /**
         * @stability stable
         */
        get destinationStreamArn(): string;
        /**
         * @stability stable
         */
        set destinationStreamArn(value: string);
        /**
         * @stability stable
         */
        get destinationStreamArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface PinpointGcmChannelConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_gcm_channel.html#api_key PinpointGcmChannel#api_key}.
         *
         * @stability stable
         */
        readonly apiKey: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_gcm_channel.html#application_id PinpointGcmChannel#application_id}.
         *
         * @stability stable
         */
        readonly applicationId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_gcm_channel.html#enabled PinpointGcmChannel#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_gcm_channel.html aws_pinpoint_gcm_channel}.
     *
     * @stability stable
     */
    class PinpointGcmChannel extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_gcm_channel.html aws_pinpoint_gcm_channel} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: PinpointGcmChannelConfig);
        private _apiKey?;
        /**
         * @stability stable
         */
        get apiKey(): string;
        /**
         * @stability stable
         */
        set apiKey(value: string);
        /**
         * @stability stable
         */
        get apiKeyInput(): string | undefined;
        private _applicationId?;
        /**
         * @stability stable
         */
        get applicationId(): string;
        /**
         * @stability stable
         */
        set applicationId(value: string);
        /**
         * @stability stable
         */
        get applicationIdInput(): string | undefined;
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface PinpointSmsChannelConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_sms_channel.html#application_id PinpointSmsChannel#application_id}.
         *
         * @stability stable
         */
        readonly applicationId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_sms_channel.html#enabled PinpointSmsChannel#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_sms_channel.html#sender_id PinpointSmsChannel#sender_id}.
         *
         * @stability stable
         */
        readonly senderId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_sms_channel.html#short_code PinpointSmsChannel#short_code}.
         *
         * @stability stable
         */
        readonly shortCode?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_sms_channel.html aws_pinpoint_sms_channel}.
     *
     * @stability stable
     */
    class PinpointSmsChannel extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_sms_channel.html aws_pinpoint_sms_channel} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: PinpointSmsChannelConfig);
        private _applicationId?;
        /**
         * @stability stable
         */
        get applicationId(): string;
        /**
         * @stability stable
         */
        set applicationId(value: string);
        /**
         * @stability stable
         */
        get applicationIdInput(): string | undefined;
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get promotionalMessagesPerSecond(): number;
        private _senderId?;
        /**
         * @stability stable
         */
        get senderId(): string | undefined;
        /**
         * @stability stable
         */
        set senderId(value: string | undefined);
        /**
         * @stability stable
         */
        resetSenderId(): void;
        /**
         * @stability stable
         */
        get senderIdInput(): string | undefined;
        private _shortCode?;
        /**
         * @stability stable
         */
        get shortCode(): string | undefined;
        /**
         * @stability stable
         */
        set shortCode(value: string | undefined);
        /**
         * @stability stable
         */
        resetShortCode(): void;
        /**
         * @stability stable
         */
        get shortCodeInput(): string | undefined;
        /**
         * @stability stable
         */
        get transactionalMessagesPerSecond(): number;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
