import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* Prometheus
*/
export declare namespace Prometheus {
    /**
     * @stability stable
     */
    interface PrometheusWorkspaceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/prometheus_workspace.html#alias PrometheusWorkspace#alias}.
         *
         * @stability stable
         */
        readonly alias?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/prometheus_workspace.html aws_prometheus_workspace}.
     *
     * @stability stable
     */
    class PrometheusWorkspace extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/prometheus_workspace.html aws_prometheus_workspace} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: PrometheusWorkspaceConfig);
        private _alias?;
        /**
         * @stability stable
         */
        get alias(): string | undefined;
        /**
         * @stability stable
         */
        set alias(value: string | undefined);
        /**
         * @stability stable
         */
        resetAlias(): void;
        /**
         * @stability stable
         */
        get aliasInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get prometheusEndpoint(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
