import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS QuickSight
*/
export declare namespace QuickSight {
    /**
     * @stability stable
     */
    interface QuicksightDataSourceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#aws_account_id QuicksightDataSource#aws_account_id}.
         *
         * @stability stable
         */
        readonly awsAccountId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#data_source_id QuicksightDataSource#data_source_id}.
         *
         * @stability stable
         */
        readonly dataSourceId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#name QuicksightDataSource#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#tags QuicksightDataSource#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#tags_all QuicksightDataSource#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#type QuicksightDataSource#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * credentials block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#credentials QuicksightDataSource#credentials}
         *
         * @stability stable
         */
        readonly credentials?: QuicksightDataSourceCredentials;
        /**
         * parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#parameters QuicksightDataSource#parameters}
         *
         * @stability stable
         */
        readonly parameters: QuicksightDataSourceParameters;
        /**
         * permission block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#permission QuicksightDataSource#permission}
         *
         * @stability stable
         */
        readonly permission?: QuicksightDataSourcePermission[];
        /**
         * ssl_properties block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#ssl_properties QuicksightDataSource#ssl_properties}
         *
         * @stability stable
         */
        readonly sslProperties?: QuicksightDataSourceSslProperties;
        /**
         * vpc_connection_properties block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#vpc_connection_properties QuicksightDataSource#vpc_connection_properties}
         *
         * @stability stable
         */
        readonly vpcConnectionProperties?: QuicksightDataSourceVpcConnectionProperties;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceCredentialsCredentialPair {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#password QuicksightDataSource#password}.
         *
         * @stability stable
         */
        readonly password: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#username QuicksightDataSource#username}.
         *
         * @stability stable
         */
        readonly username: string;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceCredentialsCredentialPairOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _password?;
        /**
         * @stability stable
         */
        get password(): string;
        /**
         * @stability stable
         */
        set password(value: string);
        /**
         * @stability stable
         */
        get passwordInput(): string | undefined;
        private _username?;
        /**
         * @stability stable
         */
        get username(): string;
        /**
         * @stability stable
         */
        set username(value: string);
        /**
         * @stability stable
         */
        get usernameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceCredentials {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#copy_source_arn QuicksightDataSource#copy_source_arn}.
         *
         * @stability stable
         */
        readonly copySourceArn?: string;
        /**
         * credential_pair block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#credential_pair QuicksightDataSource#credential_pair}
         *
         * @stability stable
         */
        readonly credentialPair?: QuicksightDataSourceCredentialsCredentialPair;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceCredentialsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _copySourceArn?;
        /**
         * @stability stable
         */
        get copySourceArn(): string | undefined;
        /**
         * @stability stable
         */
        set copySourceArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetCopySourceArn(): void;
        /**
         * @stability stable
         */
        get copySourceArnInput(): string | undefined;
        private _credentialPair?;
        private __credentialPairOutput;
        /**
         * @stability stable
         */
        get credentialPair(): QuicksightDataSourceCredentialsCredentialPairOutputReference;
        /**
         * @stability stable
         */
        putCredentialPair(value: QuicksightDataSourceCredentialsCredentialPair | undefined): void;
        /**
         * @stability stable
         */
        resetCredentialPair(): void;
        /**
         * @stability stable
         */
        get credentialPairInput(): QuicksightDataSourceCredentialsCredentialPair | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersAmazonElasticsearch {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#domain QuicksightDataSource#domain}.
         *
         * @stability stable
         */
        readonly domain: string;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersAmazonElasticsearchOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _domain?;
        /**
         * @stability stable
         */
        get domain(): string;
        /**
         * @stability stable
         */
        set domain(value: string);
        /**
         * @stability stable
         */
        get domainInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersAthena {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#work_group QuicksightDataSource#work_group}.
         *
         * @stability stable
         */
        readonly workGroup?: string;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersAthenaOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _workGroup?;
        /**
         * @stability stable
         */
        get workGroup(): string | undefined;
        /**
         * @stability stable
         */
        set workGroup(value: string | undefined);
        /**
         * @stability stable
         */
        resetWorkGroup(): void;
        /**
         * @stability stable
         */
        get workGroupInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersAurora {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
         *
         * @stability stable
         */
        readonly database: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
         *
         * @stability stable
         */
        readonly host: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
         *
         * @stability stable
         */
        readonly port: number;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersAuroraOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _database?;
        /**
         * @stability stable
         */
        get database(): string;
        /**
         * @stability stable
         */
        set database(value: string);
        /**
         * @stability stable
         */
        get databaseInput(): string | undefined;
        private _host?;
        /**
         * @stability stable
         */
        get host(): string;
        /**
         * @stability stable
         */
        set host(value: string);
        /**
         * @stability stable
         */
        get hostInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        set port(value: number);
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersAuroraPostgresql {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
         *
         * @stability stable
         */
        readonly database: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
         *
         * @stability stable
         */
        readonly host: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
         *
         * @stability stable
         */
        readonly port: number;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersAuroraPostgresqlOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _database?;
        /**
         * @stability stable
         */
        get database(): string;
        /**
         * @stability stable
         */
        set database(value: string);
        /**
         * @stability stable
         */
        get databaseInput(): string | undefined;
        private _host?;
        /**
         * @stability stable
         */
        get host(): string;
        /**
         * @stability stable
         */
        set host(value: string);
        /**
         * @stability stable
         */
        get hostInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        set port(value: number);
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersAwsIotAnalytics {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#data_set_name QuicksightDataSource#data_set_name}.
         *
         * @stability stable
         */
        readonly dataSetName: string;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersAwsIotAnalyticsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _dataSetName?;
        /**
         * @stability stable
         */
        get dataSetName(): string;
        /**
         * @stability stable
         */
        set dataSetName(value: string);
        /**
         * @stability stable
         */
        get dataSetNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersJira {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#site_base_url QuicksightDataSource#site_base_url}.
         *
         * @stability stable
         */
        readonly siteBaseUrl: string;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersJiraOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _siteBaseUrl?;
        /**
         * @stability stable
         */
        get siteBaseUrl(): string;
        /**
         * @stability stable
         */
        set siteBaseUrl(value: string);
        /**
         * @stability stable
         */
        get siteBaseUrlInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersMariaDb {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
         *
         * @stability stable
         */
        readonly database: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
         *
         * @stability stable
         */
        readonly host: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
         *
         * @stability stable
         */
        readonly port: number;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersMariaDbOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _database?;
        /**
         * @stability stable
         */
        get database(): string;
        /**
         * @stability stable
         */
        set database(value: string);
        /**
         * @stability stable
         */
        get databaseInput(): string | undefined;
        private _host?;
        /**
         * @stability stable
         */
        get host(): string;
        /**
         * @stability stable
         */
        set host(value: string);
        /**
         * @stability stable
         */
        get hostInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        set port(value: number);
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersMysql {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
         *
         * @stability stable
         */
        readonly database: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
         *
         * @stability stable
         */
        readonly host: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
         *
         * @stability stable
         */
        readonly port: number;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersMysqlOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _database?;
        /**
         * @stability stable
         */
        get database(): string;
        /**
         * @stability stable
         */
        set database(value: string);
        /**
         * @stability stable
         */
        get databaseInput(): string | undefined;
        private _host?;
        /**
         * @stability stable
         */
        get host(): string;
        /**
         * @stability stable
         */
        set host(value: string);
        /**
         * @stability stable
         */
        get hostInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        set port(value: number);
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersOracle {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
         *
         * @stability stable
         */
        readonly database: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
         *
         * @stability stable
         */
        readonly host: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
         *
         * @stability stable
         */
        readonly port: number;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersOracleOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _database?;
        /**
         * @stability stable
         */
        get database(): string;
        /**
         * @stability stable
         */
        set database(value: string);
        /**
         * @stability stable
         */
        get databaseInput(): string | undefined;
        private _host?;
        /**
         * @stability stable
         */
        get host(): string;
        /**
         * @stability stable
         */
        set host(value: string);
        /**
         * @stability stable
         */
        get hostInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        set port(value: number);
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersPostgresql {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
         *
         * @stability stable
         */
        readonly database: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
         *
         * @stability stable
         */
        readonly host: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
         *
         * @stability stable
         */
        readonly port: number;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersPostgresqlOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _database?;
        /**
         * @stability stable
         */
        get database(): string;
        /**
         * @stability stable
         */
        set database(value: string);
        /**
         * @stability stable
         */
        get databaseInput(): string | undefined;
        private _host?;
        /**
         * @stability stable
         */
        get host(): string;
        /**
         * @stability stable
         */
        set host(value: string);
        /**
         * @stability stable
         */
        get hostInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        set port(value: number);
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersPresto {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#catalog QuicksightDataSource#catalog}.
         *
         * @stability stable
         */
        readonly catalog: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
         *
         * @stability stable
         */
        readonly host: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
         *
         * @stability stable
         */
        readonly port: number;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersPrestoOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _catalog?;
        /**
         * @stability stable
         */
        get catalog(): string;
        /**
         * @stability stable
         */
        set catalog(value: string);
        /**
         * @stability stable
         */
        get catalogInput(): string | undefined;
        private _host?;
        /**
         * @stability stable
         */
        get host(): string;
        /**
         * @stability stable
         */
        set host(value: string);
        /**
         * @stability stable
         */
        get hostInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        set port(value: number);
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersRds {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
         *
         * @stability stable
         */
        readonly database: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#instance_id QuicksightDataSource#instance_id}.
         *
         * @stability stable
         */
        readonly instanceId: string;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersRdsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _database?;
        /**
         * @stability stable
         */
        get database(): string;
        /**
         * @stability stable
         */
        set database(value: string);
        /**
         * @stability stable
         */
        get databaseInput(): string | undefined;
        private _instanceId?;
        /**
         * @stability stable
         */
        get instanceId(): string;
        /**
         * @stability stable
         */
        set instanceId(value: string);
        /**
         * @stability stable
         */
        get instanceIdInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersRedshift {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#cluster_id QuicksightDataSource#cluster_id}.
         *
         * @stability stable
         */
        readonly clusterId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
         *
         * @stability stable
         */
        readonly database: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
         *
         * @stability stable
         */
        readonly host?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
         *
         * @stability stable
         */
        readonly port?: number;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersRedshiftOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _clusterId?;
        /**
         * @stability stable
         */
        get clusterId(): string | undefined;
        /**
         * @stability stable
         */
        set clusterId(value: string | undefined);
        /**
         * @stability stable
         */
        resetClusterId(): void;
        /**
         * @stability stable
         */
        get clusterIdInput(): string | undefined;
        private _database?;
        /**
         * @stability stable
         */
        get database(): string;
        /**
         * @stability stable
         */
        set database(value: string);
        /**
         * @stability stable
         */
        get databaseInput(): string | undefined;
        private _host?;
        /**
         * @stability stable
         */
        get host(): string | undefined;
        /**
         * @stability stable
         */
        set host(value: string | undefined);
        /**
         * @stability stable
         */
        resetHost(): void;
        /**
         * @stability stable
         */
        get hostInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number | undefined;
        /**
         * @stability stable
         */
        set port(value: number | undefined);
        /**
         * @stability stable
         */
        resetPort(): void;
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersS3ManifestFileLocation {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#bucket QuicksightDataSource#bucket}.
         *
         * @stability stable
         */
        readonly bucket: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#key QuicksightDataSource#key}.
         *
         * @stability stable
         */
        readonly key: string;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersS3ManifestFileLocationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bucket?;
        /**
         * @stability stable
         */
        get bucket(): string;
        /**
         * @stability stable
         */
        set bucket(value: string);
        /**
         * @stability stable
         */
        get bucketInput(): string | undefined;
        private _key?;
        /**
         * @stability stable
         */
        get key(): string;
        /**
         * @stability stable
         */
        set key(value: string);
        /**
         * @stability stable
         */
        get keyInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersS3 {
        /**
         * manifest_file_location block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#manifest_file_location QuicksightDataSource#manifest_file_location}
         *
         * @stability stable
         */
        readonly manifestFileLocation: QuicksightDataSourceParametersS3ManifestFileLocation;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersS3OutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _manifestFileLocation?;
        private __manifestFileLocationOutput;
        /**
         * @stability stable
         */
        get manifestFileLocation(): QuicksightDataSourceParametersS3ManifestFileLocationOutputReference;
        /**
         * @stability stable
         */
        putManifestFileLocation(value: QuicksightDataSourceParametersS3ManifestFileLocation): void;
        /**
         * @stability stable
         */
        get manifestFileLocationInput(): QuicksightDataSourceParametersS3ManifestFileLocation | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersServiceNow {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#site_base_url QuicksightDataSource#site_base_url}.
         *
         * @stability stable
         */
        readonly siteBaseUrl: string;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersServiceNowOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _siteBaseUrl?;
        /**
         * @stability stable
         */
        get siteBaseUrl(): string;
        /**
         * @stability stable
         */
        set siteBaseUrl(value: string);
        /**
         * @stability stable
         */
        get siteBaseUrlInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersSnowflake {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
         *
         * @stability stable
         */
        readonly database: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
         *
         * @stability stable
         */
        readonly host: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#warehouse QuicksightDataSource#warehouse}.
         *
         * @stability stable
         */
        readonly warehouse: string;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersSnowflakeOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _database?;
        /**
         * @stability stable
         */
        get database(): string;
        /**
         * @stability stable
         */
        set database(value: string);
        /**
         * @stability stable
         */
        get databaseInput(): string | undefined;
        private _host?;
        /**
         * @stability stable
         */
        get host(): string;
        /**
         * @stability stable
         */
        set host(value: string);
        /**
         * @stability stable
         */
        get hostInput(): string | undefined;
        private _warehouse?;
        /**
         * @stability stable
         */
        get warehouse(): string;
        /**
         * @stability stable
         */
        set warehouse(value: string);
        /**
         * @stability stable
         */
        get warehouseInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersSpark {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
         *
         * @stability stable
         */
        readonly host: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
         *
         * @stability stable
         */
        readonly port: number;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersSparkOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _host?;
        /**
         * @stability stable
         */
        get host(): string;
        /**
         * @stability stable
         */
        set host(value: string);
        /**
         * @stability stable
         */
        get hostInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        set port(value: number);
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersSqlServer {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
         *
         * @stability stable
         */
        readonly database: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
         *
         * @stability stable
         */
        readonly host: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
         *
         * @stability stable
         */
        readonly port: number;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersSqlServerOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _database?;
        /**
         * @stability stable
         */
        get database(): string;
        /**
         * @stability stable
         */
        set database(value: string);
        /**
         * @stability stable
         */
        get databaseInput(): string | undefined;
        private _host?;
        /**
         * @stability stable
         */
        get host(): string;
        /**
         * @stability stable
         */
        set host(value: string);
        /**
         * @stability stable
         */
        get hostInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        set port(value: number);
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersTeradata {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#database QuicksightDataSource#database}.
         *
         * @stability stable
         */
        readonly database: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#host QuicksightDataSource#host}.
         *
         * @stability stable
         */
        readonly host: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#port QuicksightDataSource#port}.
         *
         * @stability stable
         */
        readonly port: number;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersTeradataOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _database?;
        /**
         * @stability stable
         */
        get database(): string;
        /**
         * @stability stable
         */
        set database(value: string);
        /**
         * @stability stable
         */
        get databaseInput(): string | undefined;
        private _host?;
        /**
         * @stability stable
         */
        get host(): string;
        /**
         * @stability stable
         */
        set host(value: string);
        /**
         * @stability stable
         */
        get hostInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        set port(value: number);
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParametersTwitter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#max_rows QuicksightDataSource#max_rows}.
         *
         * @stability stable
         */
        readonly maxRows: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#query QuicksightDataSource#query}.
         *
         * @stability stable
         */
        readonly query: string;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersTwitterOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _maxRows?;
        /**
         * @stability stable
         */
        get maxRows(): number;
        /**
         * @stability stable
         */
        set maxRows(value: number);
        /**
         * @stability stable
         */
        get maxRowsInput(): number | undefined;
        private _query?;
        /**
         * @stability stable
         */
        get query(): string;
        /**
         * @stability stable
         */
        set query(value: string);
        /**
         * @stability stable
         */
        get queryInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceParameters {
        /**
         * amazon_elasticsearch block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#amazon_elasticsearch QuicksightDataSource#amazon_elasticsearch}
         *
         * @stability stable
         */
        readonly amazonElasticsearch?: QuicksightDataSourceParametersAmazonElasticsearch;
        /**
         * athena block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#athena QuicksightDataSource#athena}
         *
         * @stability stable
         */
        readonly athena?: QuicksightDataSourceParametersAthena;
        /**
         * aurora block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#aurora QuicksightDataSource#aurora}
         *
         * @stability stable
         */
        readonly aurora?: QuicksightDataSourceParametersAurora;
        /**
         * aurora_postgresql block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#aurora_postgresql QuicksightDataSource#aurora_postgresql}
         *
         * @stability stable
         */
        readonly auroraPostgresql?: QuicksightDataSourceParametersAuroraPostgresql;
        /**
         * aws_iot_analytics block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#aws_iot_analytics QuicksightDataSource#aws_iot_analytics}
         *
         * @stability stable
         */
        readonly awsIotAnalytics?: QuicksightDataSourceParametersAwsIotAnalytics;
        /**
         * jira block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#jira QuicksightDataSource#jira}
         *
         * @stability stable
         */
        readonly jira?: QuicksightDataSourceParametersJira;
        /**
         * maria_db block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#maria_db QuicksightDataSource#maria_db}
         *
         * @stability stable
         */
        readonly mariaDb?: QuicksightDataSourceParametersMariaDb;
        /**
         * mysql block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#mysql QuicksightDataSource#mysql}
         *
         * @stability stable
         */
        readonly mysql?: QuicksightDataSourceParametersMysql;
        /**
         * oracle block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#oracle QuicksightDataSource#oracle}
         *
         * @stability stable
         */
        readonly oracle?: QuicksightDataSourceParametersOracle;
        /**
         * postgresql block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#postgresql QuicksightDataSource#postgresql}
         *
         * @stability stable
         */
        readonly postgresql?: QuicksightDataSourceParametersPostgresql;
        /**
         * presto block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#presto QuicksightDataSource#presto}
         *
         * @stability stable
         */
        readonly presto?: QuicksightDataSourceParametersPresto;
        /**
         * rds block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#rds QuicksightDataSource#rds}
         *
         * @stability stable
         */
        readonly rds?: QuicksightDataSourceParametersRds;
        /**
         * redshift block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#redshift QuicksightDataSource#redshift}
         *
         * @stability stable
         */
        readonly redshift?: QuicksightDataSourceParametersRedshift;
        /**
         * s3 block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#s3 QuicksightDataSource#s3}
         *
         * @stability stable
         */
        readonly s3?: QuicksightDataSourceParametersS3;
        /**
         * service_now block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#service_now QuicksightDataSource#service_now}
         *
         * @stability stable
         */
        readonly serviceNow?: QuicksightDataSourceParametersServiceNow;
        /**
         * snowflake block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#snowflake QuicksightDataSource#snowflake}
         *
         * @stability stable
         */
        readonly snowflake?: QuicksightDataSourceParametersSnowflake;
        /**
         * spark block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#spark QuicksightDataSource#spark}
         *
         * @stability stable
         */
        readonly spark?: QuicksightDataSourceParametersSpark;
        /**
         * sql_server block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#sql_server QuicksightDataSource#sql_server}
         *
         * @stability stable
         */
        readonly sqlServer?: QuicksightDataSourceParametersSqlServer;
        /**
         * teradata block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#teradata QuicksightDataSource#teradata}
         *
         * @stability stable
         */
        readonly teradata?: QuicksightDataSourceParametersTeradata;
        /**
         * twitter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#twitter QuicksightDataSource#twitter}
         *
         * @stability stable
         */
        readonly twitter?: QuicksightDataSourceParametersTwitter;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceParametersOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _amazonElasticsearch?;
        private __amazonElasticsearchOutput;
        /**
         * @stability stable
         */
        get amazonElasticsearch(): QuicksightDataSourceParametersAmazonElasticsearchOutputReference;
        /**
         * @stability stable
         */
        putAmazonElasticsearch(value: QuicksightDataSourceParametersAmazonElasticsearch | undefined): void;
        /**
         * @stability stable
         */
        resetAmazonElasticsearch(): void;
        /**
         * @stability stable
         */
        get amazonElasticsearchInput(): QuicksightDataSourceParametersAmazonElasticsearch | undefined;
        private _athena?;
        private __athenaOutput;
        /**
         * @stability stable
         */
        get athena(): QuicksightDataSourceParametersAthenaOutputReference;
        /**
         * @stability stable
         */
        putAthena(value: QuicksightDataSourceParametersAthena | undefined): void;
        /**
         * @stability stable
         */
        resetAthena(): void;
        /**
         * @stability stable
         */
        get athenaInput(): QuicksightDataSourceParametersAthena | undefined;
        private _aurora?;
        private __auroraOutput;
        /**
         * @stability stable
         */
        get aurora(): QuicksightDataSourceParametersAuroraOutputReference;
        /**
         * @stability stable
         */
        putAurora(value: QuicksightDataSourceParametersAurora | undefined): void;
        /**
         * @stability stable
         */
        resetAurora(): void;
        /**
         * @stability stable
         */
        get auroraInput(): QuicksightDataSourceParametersAurora | undefined;
        private _auroraPostgresql?;
        private __auroraPostgresqlOutput;
        /**
         * @stability stable
         */
        get auroraPostgresql(): QuicksightDataSourceParametersAuroraPostgresqlOutputReference;
        /**
         * @stability stable
         */
        putAuroraPostgresql(value: QuicksightDataSourceParametersAuroraPostgresql | undefined): void;
        /**
         * @stability stable
         */
        resetAuroraPostgresql(): void;
        /**
         * @stability stable
         */
        get auroraPostgresqlInput(): QuicksightDataSourceParametersAuroraPostgresql | undefined;
        private _awsIotAnalytics?;
        private __awsIotAnalyticsOutput;
        /**
         * @stability stable
         */
        get awsIotAnalytics(): QuicksightDataSourceParametersAwsIotAnalyticsOutputReference;
        /**
         * @stability stable
         */
        putAwsIotAnalytics(value: QuicksightDataSourceParametersAwsIotAnalytics | undefined): void;
        /**
         * @stability stable
         */
        resetAwsIotAnalytics(): void;
        /**
         * @stability stable
         */
        get awsIotAnalyticsInput(): QuicksightDataSourceParametersAwsIotAnalytics | undefined;
        private _jira?;
        private __jiraOutput;
        /**
         * @stability stable
         */
        get jira(): QuicksightDataSourceParametersJiraOutputReference;
        /**
         * @stability stable
         */
        putJira(value: QuicksightDataSourceParametersJira | undefined): void;
        /**
         * @stability stable
         */
        resetJira(): void;
        /**
         * @stability stable
         */
        get jiraInput(): QuicksightDataSourceParametersJira | undefined;
        private _mariaDb?;
        private __mariaDbOutput;
        /**
         * @stability stable
         */
        get mariaDb(): QuicksightDataSourceParametersMariaDbOutputReference;
        /**
         * @stability stable
         */
        putMariaDb(value: QuicksightDataSourceParametersMariaDb | undefined): void;
        /**
         * @stability stable
         */
        resetMariaDb(): void;
        /**
         * @stability stable
         */
        get mariaDbInput(): QuicksightDataSourceParametersMariaDb | undefined;
        private _mysql?;
        private __mysqlOutput;
        /**
         * @stability stable
         */
        get mysql(): QuicksightDataSourceParametersMysqlOutputReference;
        /**
         * @stability stable
         */
        putMysql(value: QuicksightDataSourceParametersMysql | undefined): void;
        /**
         * @stability stable
         */
        resetMysql(): void;
        /**
         * @stability stable
         */
        get mysqlInput(): QuicksightDataSourceParametersMysql | undefined;
        private _oracle?;
        private __oracleOutput;
        /**
         * @stability stable
         */
        get oracle(): QuicksightDataSourceParametersOracleOutputReference;
        /**
         * @stability stable
         */
        putOracle(value: QuicksightDataSourceParametersOracle | undefined): void;
        /**
         * @stability stable
         */
        resetOracle(): void;
        /**
         * @stability stable
         */
        get oracleInput(): QuicksightDataSourceParametersOracle | undefined;
        private _postgresql?;
        private __postgresqlOutput;
        /**
         * @stability stable
         */
        get postgresql(): QuicksightDataSourceParametersPostgresqlOutputReference;
        /**
         * @stability stable
         */
        putPostgresql(value: QuicksightDataSourceParametersPostgresql | undefined): void;
        /**
         * @stability stable
         */
        resetPostgresql(): void;
        /**
         * @stability stable
         */
        get postgresqlInput(): QuicksightDataSourceParametersPostgresql | undefined;
        private _presto?;
        private __prestoOutput;
        /**
         * @stability stable
         */
        get presto(): QuicksightDataSourceParametersPrestoOutputReference;
        /**
         * @stability stable
         */
        putPresto(value: QuicksightDataSourceParametersPresto | undefined): void;
        /**
         * @stability stable
         */
        resetPresto(): void;
        /**
         * @stability stable
         */
        get prestoInput(): QuicksightDataSourceParametersPresto | undefined;
        private _rds?;
        private __rdsOutput;
        /**
         * @stability stable
         */
        get rds(): QuicksightDataSourceParametersRdsOutputReference;
        /**
         * @stability stable
         */
        putRds(value: QuicksightDataSourceParametersRds | undefined): void;
        /**
         * @stability stable
         */
        resetRds(): void;
        /**
         * @stability stable
         */
        get rdsInput(): QuicksightDataSourceParametersRds | undefined;
        private _redshift?;
        private __redshiftOutput;
        /**
         * @stability stable
         */
        get redshift(): QuicksightDataSourceParametersRedshiftOutputReference;
        /**
         * @stability stable
         */
        putRedshift(value: QuicksightDataSourceParametersRedshift | undefined): void;
        /**
         * @stability stable
         */
        resetRedshift(): void;
        /**
         * @stability stable
         */
        get redshiftInput(): QuicksightDataSourceParametersRedshift | undefined;
        private _s3?;
        private __s3Output;
        /**
         * @stability stable
         */
        get s3(): QuicksightDataSourceParametersS3OutputReference;
        /**
         * @stability stable
         */
        putS3(value: QuicksightDataSourceParametersS3 | undefined): void;
        /**
         * @stability stable
         */
        resetS3(): void;
        /**
         * @stability stable
         */
        get s3Input(): QuicksightDataSourceParametersS3 | undefined;
        private _serviceNow?;
        private __serviceNowOutput;
        /**
         * @stability stable
         */
        get serviceNow(): QuicksightDataSourceParametersServiceNowOutputReference;
        /**
         * @stability stable
         */
        putServiceNow(value: QuicksightDataSourceParametersServiceNow | undefined): void;
        /**
         * @stability stable
         */
        resetServiceNow(): void;
        /**
         * @stability stable
         */
        get serviceNowInput(): QuicksightDataSourceParametersServiceNow | undefined;
        private _snowflake?;
        private __snowflakeOutput;
        /**
         * @stability stable
         */
        get snowflake(): QuicksightDataSourceParametersSnowflakeOutputReference;
        /**
         * @stability stable
         */
        putSnowflake(value: QuicksightDataSourceParametersSnowflake | undefined): void;
        /**
         * @stability stable
         */
        resetSnowflake(): void;
        /**
         * @stability stable
         */
        get snowflakeInput(): QuicksightDataSourceParametersSnowflake | undefined;
        private _spark?;
        private __sparkOutput;
        /**
         * @stability stable
         */
        get spark(): QuicksightDataSourceParametersSparkOutputReference;
        /**
         * @stability stable
         */
        putSpark(value: QuicksightDataSourceParametersSpark | undefined): void;
        /**
         * @stability stable
         */
        resetSpark(): void;
        /**
         * @stability stable
         */
        get sparkInput(): QuicksightDataSourceParametersSpark | undefined;
        private _sqlServer?;
        private __sqlServerOutput;
        /**
         * @stability stable
         */
        get sqlServer(): QuicksightDataSourceParametersSqlServerOutputReference;
        /**
         * @stability stable
         */
        putSqlServer(value: QuicksightDataSourceParametersSqlServer | undefined): void;
        /**
         * @stability stable
         */
        resetSqlServer(): void;
        /**
         * @stability stable
         */
        get sqlServerInput(): QuicksightDataSourceParametersSqlServer | undefined;
        private _teradata?;
        private __teradataOutput;
        /**
         * @stability stable
         */
        get teradata(): QuicksightDataSourceParametersTeradataOutputReference;
        /**
         * @stability stable
         */
        putTeradata(value: QuicksightDataSourceParametersTeradata | undefined): void;
        /**
         * @stability stable
         */
        resetTeradata(): void;
        /**
         * @stability stable
         */
        get teradataInput(): QuicksightDataSourceParametersTeradata | undefined;
        private _twitter?;
        private __twitterOutput;
        /**
         * @stability stable
         */
        get twitter(): QuicksightDataSourceParametersTwitterOutputReference;
        /**
         * @stability stable
         */
        putTwitter(value: QuicksightDataSourceParametersTwitter | undefined): void;
        /**
         * @stability stable
         */
        resetTwitter(): void;
        /**
         * @stability stable
         */
        get twitterInput(): QuicksightDataSourceParametersTwitter | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourcePermission {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#actions QuicksightDataSource#actions}.
         *
         * @stability stable
         */
        readonly actions: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#principal QuicksightDataSource#principal}.
         *
         * @stability stable
         */
        readonly principal: string;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceSslProperties {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#disable_ssl QuicksightDataSource#disable_ssl}.
         *
         * @stability stable
         */
        readonly disableSsl: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceSslPropertiesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _disableSsl?;
        /**
         * @stability stable
         */
        get disableSsl(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set disableSsl(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get disableSslInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * @stability stable
     */
    interface QuicksightDataSourceVpcConnectionProperties {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html#vpc_connection_arn QuicksightDataSource#vpc_connection_arn}.
         *
         * @stability stable
         */
        readonly vpcConnectionArn: string;
    }
    /**
     * @stability stable
     */
    class QuicksightDataSourceVpcConnectionPropertiesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _vpcConnectionArn?;
        /**
         * @stability stable
         */
        get vpcConnectionArn(): string;
        /**
         * @stability stable
         */
        set vpcConnectionArn(value: string);
        /**
         * @stability stable
         */
        get vpcConnectionArnInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html aws_quicksight_data_source}.
     *
     * @stability stable
     */
    class QuicksightDataSource extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/quicksight_data_source.html aws_quicksight_data_source} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: QuicksightDataSourceConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _awsAccountId?;
        /**
         * @stability stable
         */
        get awsAccountId(): string | undefined;
        /**
         * @stability stable
         */
        set awsAccountId(value: string | undefined);
        /**
         * @stability stable
         */
        resetAwsAccountId(): void;
        /**
         * @stability stable
         */
        get awsAccountIdInput(): string | undefined;
        private _dataSourceId?;
        /**
         * @stability stable
         */
        get dataSourceId(): string;
        /**
         * @stability stable
         */
        set dataSourceId(value: string);
        /**
         * @stability stable
         */
        get dataSourceIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _credentials?;
        private __credentialsOutput;
        /**
         * @stability stable
         */
        get credentials(): QuicksightDataSourceCredentialsOutputReference;
        /**
         * @stability stable
         */
        putCredentials(value: QuicksightDataSourceCredentials | undefined): void;
        /**
         * @stability stable
         */
        resetCredentials(): void;
        /**
         * @stability stable
         */
        get credentialsInput(): QuicksightDataSourceCredentials | undefined;
        private _parameters?;
        private __parametersOutput;
        /**
         * @stability stable
         */
        get parameters(): QuicksightDataSourceParametersOutputReference;
        /**
         * @stability stable
         */
        putParameters(value: QuicksightDataSourceParameters): void;
        /**
         * @stability stable
         */
        get parametersInput(): QuicksightDataSourceParameters | undefined;
        private _permission?;
        /**
         * @stability stable
         */
        get permission(): QuicksightDataSourcePermission[] | undefined;
        /**
         * @stability stable
         */
        set permission(value: QuicksightDataSourcePermission[] | undefined);
        /**
         * @stability stable
         */
        resetPermission(): void;
        /**
         * @stability stable
         */
        get permissionInput(): QuicksightDataSourcePermission[] | undefined;
        private _sslProperties?;
        private __sslPropertiesOutput;
        /**
         * @stability stable
         */
        get sslProperties(): QuicksightDataSourceSslPropertiesOutputReference;
        /**
         * @stability stable
         */
        putSslProperties(value: QuicksightDataSourceSslProperties | undefined): void;
        /**
         * @stability stable
         */
        resetSslProperties(): void;
        /**
         * @stability stable
         */
        get sslPropertiesInput(): QuicksightDataSourceSslProperties | undefined;
        private _vpcConnectionProperties?;
        private __vpcConnectionPropertiesOutput;
        /**
         * @stability stable
         */
        get vpcConnectionProperties(): QuicksightDataSourceVpcConnectionPropertiesOutputReference;
        /**
         * @stability stable
         */
        putVpcConnectionProperties(value: QuicksightDataSourceVpcConnectionProperties | undefined): void;
        /**
         * @stability stable
         */
        resetVpcConnectionProperties(): void;
        /**
         * @stability stable
         */
        get vpcConnectionPropertiesInput(): QuicksightDataSourceVpcConnectionProperties | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface QuicksightGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_group.html#aws_account_id QuicksightGroup#aws_account_id}.
         *
         * @stability stable
         */
        readonly awsAccountId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_group.html#description QuicksightGroup#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_group.html#group_name QuicksightGroup#group_name}.
         *
         * @stability stable
         */
        readonly groupName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_group.html#namespace QuicksightGroup#namespace}.
         *
         * @stability stable
         */
        readonly namespace?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/quicksight_group.html aws_quicksight_group}.
     *
     * @stability stable
     */
    class QuicksightGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/quicksight_group.html aws_quicksight_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: QuicksightGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _awsAccountId?;
        /**
         * @stability stable
         */
        get awsAccountId(): string | undefined;
        /**
         * @stability stable
         */
        set awsAccountId(value: string | undefined);
        /**
         * @stability stable
         */
        resetAwsAccountId(): void;
        /**
         * @stability stable
         */
        get awsAccountIdInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _groupName?;
        /**
         * @stability stable
         */
        get groupName(): string;
        /**
         * @stability stable
         */
        set groupName(value: string);
        /**
         * @stability stable
         */
        get groupNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _namespace?;
        /**
         * @stability stable
         */
        get namespace(): string | undefined;
        /**
         * @stability stable
         */
        set namespace(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamespace(): void;
        /**
         * @stability stable
         */
        get namespaceInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface QuicksightGroupMembershipConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_group_membership.html#aws_account_id QuicksightGroupMembership#aws_account_id}.
         *
         * @stability stable
         */
        readonly awsAccountId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_group_membership.html#group_name QuicksightGroupMembership#group_name}.
         *
         * @stability stable
         */
        readonly groupName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_group_membership.html#member_name QuicksightGroupMembership#member_name}.
         *
         * @stability stable
         */
        readonly memberName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_group_membership.html#namespace QuicksightGroupMembership#namespace}.
         *
         * @stability stable
         */
        readonly namespace?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/quicksight_group_membership.html aws_quicksight_group_membership}.
     *
     * @stability stable
     */
    class QuicksightGroupMembership extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/quicksight_group_membership.html aws_quicksight_group_membership} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: QuicksightGroupMembershipConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _awsAccountId?;
        /**
         * @stability stable
         */
        get awsAccountId(): string | undefined;
        /**
         * @stability stable
         */
        set awsAccountId(value: string | undefined);
        /**
         * @stability stable
         */
        resetAwsAccountId(): void;
        /**
         * @stability stable
         */
        get awsAccountIdInput(): string | undefined;
        private _groupName?;
        /**
         * @stability stable
         */
        get groupName(): string;
        /**
         * @stability stable
         */
        set groupName(value: string);
        /**
         * @stability stable
         */
        get groupNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _memberName?;
        /**
         * @stability stable
         */
        get memberName(): string;
        /**
         * @stability stable
         */
        set memberName(value: string);
        /**
         * @stability stable
         */
        get memberNameInput(): string | undefined;
        private _namespace?;
        /**
         * @stability stable
         */
        get namespace(): string | undefined;
        /**
         * @stability stable
         */
        set namespace(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamespace(): void;
        /**
         * @stability stable
         */
        get namespaceInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface QuicksightUserConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html#aws_account_id QuicksightUser#aws_account_id}.
         *
         * @stability stable
         */
        readonly awsAccountId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html#email QuicksightUser#email}.
         *
         * @stability stable
         */
        readonly email: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html#iam_arn QuicksightUser#iam_arn}.
         *
         * @stability stable
         */
        readonly iamArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html#identity_type QuicksightUser#identity_type}.
         *
         * @stability stable
         */
        readonly identityType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html#namespace QuicksightUser#namespace}.
         *
         * @stability stable
         */
        readonly namespace?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html#session_name QuicksightUser#session_name}.
         *
         * @stability stable
         */
        readonly sessionName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html#user_name QuicksightUser#user_name}.
         *
         * @stability stable
         */
        readonly userName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html#user_role QuicksightUser#user_role}.
         *
         * @stability stable
         */
        readonly userRole: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html aws_quicksight_user}.
     *
     * @stability stable
     */
    class QuicksightUser extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/quicksight_user.html aws_quicksight_user} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: QuicksightUserConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _awsAccountId?;
        /**
         * @stability stable
         */
        get awsAccountId(): string | undefined;
        /**
         * @stability stable
         */
        set awsAccountId(value: string | undefined);
        /**
         * @stability stable
         */
        resetAwsAccountId(): void;
        /**
         * @stability stable
         */
        get awsAccountIdInput(): string | undefined;
        private _email?;
        /**
         * @stability stable
         */
        get email(): string;
        /**
         * @stability stable
         */
        set email(value: string);
        /**
         * @stability stable
         */
        get emailInput(): string | undefined;
        private _iamArn?;
        /**
         * @stability stable
         */
        get iamArn(): string | undefined;
        /**
         * @stability stable
         */
        set iamArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetIamArn(): void;
        /**
         * @stability stable
         */
        get iamArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _identityType?;
        /**
         * @stability stable
         */
        get identityType(): string;
        /**
         * @stability stable
         */
        set identityType(value: string);
        /**
         * @stability stable
         */
        get identityTypeInput(): string | undefined;
        private _namespace?;
        /**
         * @stability stable
         */
        get namespace(): string | undefined;
        /**
         * @stability stable
         */
        set namespace(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamespace(): void;
        /**
         * @stability stable
         */
        get namespaceInput(): string | undefined;
        private _sessionName?;
        /**
         * @stability stable
         */
        get sessionName(): string | undefined;
        /**
         * @stability stable
         */
        set sessionName(value: string | undefined);
        /**
         * @stability stable
         */
        resetSessionName(): void;
        /**
         * @stability stable
         */
        get sessionNameInput(): string | undefined;
        private _userName?;
        /**
         * @stability stable
         */
        get userName(): string | undefined;
        /**
         * @stability stable
         */
        set userName(value: string | undefined);
        /**
         * @stability stable
         */
        resetUserName(): void;
        /**
         * @stability stable
         */
        get userNameInput(): string | undefined;
        private _userRole?;
        /**
         * @stability stable
         */
        get userRole(): string;
        /**
         * @stability stable
         */
        set userRole(value: string);
        /**
         * @stability stable
         */
        get userRoleInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
