import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Redshift
*/
export declare namespace Redshift {
    /**
     * @stability stable
     */
    interface RedshiftClusterConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#allow_version_upgrade RedshiftCluster#allow_version_upgrade}.
         *
         * @stability stable
         */
        readonly allowVersionUpgrade?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#automated_snapshot_retention_period RedshiftCluster#automated_snapshot_retention_period}.
         *
         * @stability stable
         */
        readonly automatedSnapshotRetentionPeriod?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#availability_zone RedshiftCluster#availability_zone}.
         *
         * @stability stable
         */
        readonly availabilityZone?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#cluster_identifier RedshiftCluster#cluster_identifier}.
         *
         * @stability stable
         */
        readonly clusterIdentifier: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#cluster_parameter_group_name RedshiftCluster#cluster_parameter_group_name}.
         *
         * @stability stable
         */
        readonly clusterParameterGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#cluster_public_key RedshiftCluster#cluster_public_key}.
         *
         * @stability stable
         */
        readonly clusterPublicKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#cluster_revision_number RedshiftCluster#cluster_revision_number}.
         *
         * @stability stable
         */
        readonly clusterRevisionNumber?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#cluster_security_groups RedshiftCluster#cluster_security_groups}.
         *
         * @stability stable
         */
        readonly clusterSecurityGroups?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#cluster_subnet_group_name RedshiftCluster#cluster_subnet_group_name}.
         *
         * @stability stable
         */
        readonly clusterSubnetGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#cluster_type RedshiftCluster#cluster_type}.
         *
         * @stability stable
         */
        readonly clusterType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#cluster_version RedshiftCluster#cluster_version}.
         *
         * @stability stable
         */
        readonly clusterVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#database_name RedshiftCluster#database_name}.
         *
         * @stability stable
         */
        readonly databaseName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#elastic_ip RedshiftCluster#elastic_ip}.
         *
         * @stability stable
         */
        readonly elasticIp?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#encrypted RedshiftCluster#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#endpoint RedshiftCluster#endpoint}.
         *
         * @stability stable
         */
        readonly endpoint?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#enhanced_vpc_routing RedshiftCluster#enhanced_vpc_routing}.
         *
         * @stability stable
         */
        readonly enhancedVpcRouting?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#final_snapshot_identifier RedshiftCluster#final_snapshot_identifier}.
         *
         * @stability stable
         */
        readonly finalSnapshotIdentifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#iam_roles RedshiftCluster#iam_roles}.
         *
         * @stability stable
         */
        readonly iamRoles?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#kms_key_id RedshiftCluster#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#master_password RedshiftCluster#master_password}.
         *
         * @stability stable
         */
        readonly masterPassword?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#master_username RedshiftCluster#master_username}.
         *
         * @stability stable
         */
        readonly masterUsername?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#node_type RedshiftCluster#node_type}.
         *
         * @stability stable
         */
        readonly nodeType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#number_of_nodes RedshiftCluster#number_of_nodes}.
         *
         * @stability stable
         */
        readonly numberOfNodes?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#owner_account RedshiftCluster#owner_account}.
         *
         * @stability stable
         */
        readonly ownerAccount?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#port RedshiftCluster#port}.
         *
         * @stability stable
         */
        readonly port?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#preferred_maintenance_window RedshiftCluster#preferred_maintenance_window}.
         *
         * @stability stable
         */
        readonly preferredMaintenanceWindow?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#publicly_accessible RedshiftCluster#publicly_accessible}.
         *
         * @stability stable
         */
        readonly publiclyAccessible?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#skip_final_snapshot RedshiftCluster#skip_final_snapshot}.
         *
         * @stability stable
         */
        readonly skipFinalSnapshot?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#snapshot_cluster_identifier RedshiftCluster#snapshot_cluster_identifier}.
         *
         * @stability stable
         */
        readonly snapshotClusterIdentifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#snapshot_identifier RedshiftCluster#snapshot_identifier}.
         *
         * @stability stable
         */
        readonly snapshotIdentifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#tags RedshiftCluster#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#tags_all RedshiftCluster#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#vpc_security_group_ids RedshiftCluster#vpc_security_group_ids}.
         *
         * @stability stable
         */
        readonly vpcSecurityGroupIds?: string[];
        /**
         * logging block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#logging RedshiftCluster#logging}
         *
         * @stability stable
         */
        readonly logging?: RedshiftClusterLogging;
        /**
         * snapshot_copy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#snapshot_copy RedshiftCluster#snapshot_copy}
         *
         * @stability stable
         */
        readonly snapshotCopy?: RedshiftClusterSnapshotCopy;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#timeouts RedshiftCluster#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: RedshiftClusterTimeouts;
    }
    /**
     * @stability stable
     */
    class RedshiftClusterClusterNodes extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get nodeRole(): string;
        /**
         * @stability stable
         */
        get privateIpAddress(): string;
        /**
         * @stability stable
         */
        get publicIpAddress(): string;
    }
    /**
     * @stability stable
     */
    interface RedshiftClusterLogging {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#bucket_name RedshiftCluster#bucket_name}.
         *
         * @stability stable
         */
        readonly bucketName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#enable RedshiftCluster#enable}.
         *
         * @stability stable
         */
        readonly enable: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#s3_key_prefix RedshiftCluster#s3_key_prefix}.
         *
         * @stability stable
         */
        readonly s3KeyPrefix?: string;
    }
    /**
     * @stability stable
     */
    class RedshiftClusterLoggingOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bucketName?;
        /**
         * @stability stable
         */
        get bucketName(): string | undefined;
        /**
         * @stability stable
         */
        set bucketName(value: string | undefined);
        /**
         * @stability stable
         */
        resetBucketName(): void;
        /**
         * @stability stable
         */
        get bucketNameInput(): string | undefined;
        private _enable?;
        /**
         * @stability stable
         */
        get enable(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set enable(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get enableInput(): boolean | cdktf.IResolvable | undefined;
        private _s3KeyPrefix?;
        /**
         * @stability stable
         */
        get s3KeyPrefix(): string | undefined;
        /**
         * @stability stable
         */
        set s3KeyPrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetS3KeyPrefix(): void;
        /**
         * @stability stable
         */
        get s3KeyPrefixInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface RedshiftClusterSnapshotCopy {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#destination_region RedshiftCluster#destination_region}.
         *
         * @stability stable
         */
        readonly destinationRegion: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#grant_name RedshiftCluster#grant_name}.
         *
         * @stability stable
         */
        readonly grantName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#retention_period RedshiftCluster#retention_period}.
         *
         * @stability stable
         */
        readonly retentionPeriod?: number;
    }
    /**
     * @stability stable
     */
    class RedshiftClusterSnapshotCopyOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _destinationRegion?;
        /**
         * @stability stable
         */
        get destinationRegion(): string;
        /**
         * @stability stable
         */
        set destinationRegion(value: string);
        /**
         * @stability stable
         */
        get destinationRegionInput(): string | undefined;
        private _grantName?;
        /**
         * @stability stable
         */
        get grantName(): string | undefined;
        /**
         * @stability stable
         */
        set grantName(value: string | undefined);
        /**
         * @stability stable
         */
        resetGrantName(): void;
        /**
         * @stability stable
         */
        get grantNameInput(): string | undefined;
        private _retentionPeriod?;
        /**
         * @stability stable
         */
        get retentionPeriod(): number | undefined;
        /**
         * @stability stable
         */
        set retentionPeriod(value: number | undefined);
        /**
         * @stability stable
         */
        resetRetentionPeriod(): void;
        /**
         * @stability stable
         */
        get retentionPeriodInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface RedshiftClusterTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#create RedshiftCluster#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#delete RedshiftCluster#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html#update RedshiftCluster#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class RedshiftClusterTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html aws_redshift_cluster}.
     *
     * @stability stable
     */
    class RedshiftCluster extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/redshift_cluster.html aws_redshift_cluster} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: RedshiftClusterConfig);
        private _allowVersionUpgrade?;
        /**
         * @stability stable
         */
        get allowVersionUpgrade(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set allowVersionUpgrade(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAllowVersionUpgrade(): void;
        /**
         * @stability stable
         */
        get allowVersionUpgradeInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _automatedSnapshotRetentionPeriod?;
        /**
         * @stability stable
         */
        get automatedSnapshotRetentionPeriod(): number | undefined;
        /**
         * @stability stable
         */
        set automatedSnapshotRetentionPeriod(value: number | undefined);
        /**
         * @stability stable
         */
        resetAutomatedSnapshotRetentionPeriod(): void;
        /**
         * @stability stable
         */
        get automatedSnapshotRetentionPeriodInput(): number | undefined;
        private _availabilityZone?;
        /**
         * @stability stable
         */
        get availabilityZone(): string | undefined;
        /**
         * @stability stable
         */
        set availabilityZone(value: string | undefined);
        /**
         * @stability stable
         */
        resetAvailabilityZone(): void;
        /**
         * @stability stable
         */
        get availabilityZoneInput(): string | undefined;
        private _clusterIdentifier?;
        /**
         * @stability stable
         */
        get clusterIdentifier(): string;
        /**
         * @stability stable
         */
        set clusterIdentifier(value: string);
        /**
         * @stability stable
         */
        get clusterIdentifierInput(): string | undefined;
        /**
         * @stability stable
         */
        clusterNodes(index: string): RedshiftClusterClusterNodes;
        private _clusterParameterGroupName?;
        /**
         * @stability stable
         */
        get clusterParameterGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set clusterParameterGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetClusterParameterGroupName(): void;
        /**
         * @stability stable
         */
        get clusterParameterGroupNameInput(): string | undefined;
        private _clusterPublicKey?;
        /**
         * @stability stable
         */
        get clusterPublicKey(): string | undefined;
        /**
         * @stability stable
         */
        set clusterPublicKey(value: string | undefined);
        /**
         * @stability stable
         */
        resetClusterPublicKey(): void;
        /**
         * @stability stable
         */
        get clusterPublicKeyInput(): string | undefined;
        private _clusterRevisionNumber?;
        /**
         * @stability stable
         */
        get clusterRevisionNumber(): string | undefined;
        /**
         * @stability stable
         */
        set clusterRevisionNumber(value: string | undefined);
        /**
         * @stability stable
         */
        resetClusterRevisionNumber(): void;
        /**
         * @stability stable
         */
        get clusterRevisionNumberInput(): string | undefined;
        private _clusterSecurityGroups?;
        /**
         * @stability stable
         */
        get clusterSecurityGroups(): string[] | undefined;
        /**
         * @stability stable
         */
        set clusterSecurityGroups(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetClusterSecurityGroups(): void;
        /**
         * @stability stable
         */
        get clusterSecurityGroupsInput(): string[] | undefined;
        private _clusterSubnetGroupName?;
        /**
         * @stability stable
         */
        get clusterSubnetGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set clusterSubnetGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetClusterSubnetGroupName(): void;
        /**
         * @stability stable
         */
        get clusterSubnetGroupNameInput(): string | undefined;
        private _clusterType?;
        /**
         * @stability stable
         */
        get clusterType(): string | undefined;
        /**
         * @stability stable
         */
        set clusterType(value: string | undefined);
        /**
         * @stability stable
         */
        resetClusterType(): void;
        /**
         * @stability stable
         */
        get clusterTypeInput(): string | undefined;
        private _clusterVersion?;
        /**
         * @stability stable
         */
        get clusterVersion(): string | undefined;
        /**
         * @stability stable
         */
        set clusterVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetClusterVersion(): void;
        /**
         * @stability stable
         */
        get clusterVersionInput(): string | undefined;
        private _databaseName?;
        /**
         * @stability stable
         */
        get databaseName(): string | undefined;
        /**
         * @stability stable
         */
        set databaseName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDatabaseName(): void;
        /**
         * @stability stable
         */
        get databaseNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get dnsName(): string;
        private _elasticIp?;
        /**
         * @stability stable
         */
        get elasticIp(): string | undefined;
        /**
         * @stability stable
         */
        set elasticIp(value: string | undefined);
        /**
         * @stability stable
         */
        resetElasticIp(): void;
        /**
         * @stability stable
         */
        get elasticIpInput(): string | undefined;
        private _encrypted?;
        /**
         * @stability stable
         */
        get encrypted(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set encrypted(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEncrypted(): void;
        /**
         * @stability stable
         */
        get encryptedInput(): boolean | cdktf.IResolvable | undefined;
        private _endpoint?;
        /**
         * @stability stable
         */
        get endpoint(): string | undefined;
        /**
         * @stability stable
         */
        set endpoint(value: string | undefined);
        /**
         * @stability stable
         */
        resetEndpoint(): void;
        /**
         * @stability stable
         */
        get endpointInput(): string | undefined;
        private _enhancedVpcRouting?;
        /**
         * @stability stable
         */
        get enhancedVpcRouting(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enhancedVpcRouting(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnhancedVpcRouting(): void;
        /**
         * @stability stable
         */
        get enhancedVpcRoutingInput(): boolean | cdktf.IResolvable | undefined;
        private _finalSnapshotIdentifier?;
        /**
         * @stability stable
         */
        get finalSnapshotIdentifier(): string | undefined;
        /**
         * @stability stable
         */
        set finalSnapshotIdentifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetFinalSnapshotIdentifier(): void;
        /**
         * @stability stable
         */
        get finalSnapshotIdentifierInput(): string | undefined;
        private _iamRoles?;
        /**
         * @stability stable
         */
        get iamRoles(): string[] | undefined;
        /**
         * @stability stable
         */
        set iamRoles(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetIamRoles(): void;
        /**
         * @stability stable
         */
        get iamRolesInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        private _masterPassword?;
        /**
         * @stability stable
         */
        get masterPassword(): string | undefined;
        /**
         * @stability stable
         */
        set masterPassword(value: string | undefined);
        /**
         * @stability stable
         */
        resetMasterPassword(): void;
        /**
         * @stability stable
         */
        get masterPasswordInput(): string | undefined;
        private _masterUsername?;
        /**
         * @stability stable
         */
        get masterUsername(): string | undefined;
        /**
         * @stability stable
         */
        set masterUsername(value: string | undefined);
        /**
         * @stability stable
         */
        resetMasterUsername(): void;
        /**
         * @stability stable
         */
        get masterUsernameInput(): string | undefined;
        private _nodeType?;
        /**
         * @stability stable
         */
        get nodeType(): string;
        /**
         * @stability stable
         */
        set nodeType(value: string);
        /**
         * @stability stable
         */
        get nodeTypeInput(): string | undefined;
        private _numberOfNodes?;
        /**
         * @stability stable
         */
        get numberOfNodes(): number | undefined;
        /**
         * @stability stable
         */
        set numberOfNodes(value: number | undefined);
        /**
         * @stability stable
         */
        resetNumberOfNodes(): void;
        /**
         * @stability stable
         */
        get numberOfNodesInput(): number | undefined;
        private _ownerAccount?;
        /**
         * @stability stable
         */
        get ownerAccount(): string | undefined;
        /**
         * @stability stable
         */
        set ownerAccount(value: string | undefined);
        /**
         * @stability stable
         */
        resetOwnerAccount(): void;
        /**
         * @stability stable
         */
        get ownerAccountInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number | undefined;
        /**
         * @stability stable
         */
        set port(value: number | undefined);
        /**
         * @stability stable
         */
        resetPort(): void;
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
        private _preferredMaintenanceWindow?;
        /**
         * @stability stable
         */
        get preferredMaintenanceWindow(): string | undefined;
        /**
         * @stability stable
         */
        set preferredMaintenanceWindow(value: string | undefined);
        /**
         * @stability stable
         */
        resetPreferredMaintenanceWindow(): void;
        /**
         * @stability stable
         */
        get preferredMaintenanceWindowInput(): string | undefined;
        private _publiclyAccessible?;
        /**
         * @stability stable
         */
        get publiclyAccessible(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set publiclyAccessible(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetPubliclyAccessible(): void;
        /**
         * @stability stable
         */
        get publiclyAccessibleInput(): boolean | cdktf.IResolvable | undefined;
        private _skipFinalSnapshot?;
        /**
         * @stability stable
         */
        get skipFinalSnapshot(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set skipFinalSnapshot(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetSkipFinalSnapshot(): void;
        /**
         * @stability stable
         */
        get skipFinalSnapshotInput(): boolean | cdktf.IResolvable | undefined;
        private _snapshotClusterIdentifier?;
        /**
         * @stability stable
         */
        get snapshotClusterIdentifier(): string | undefined;
        /**
         * @stability stable
         */
        set snapshotClusterIdentifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetSnapshotClusterIdentifier(): void;
        /**
         * @stability stable
         */
        get snapshotClusterIdentifierInput(): string | undefined;
        private _snapshotIdentifier?;
        /**
         * @stability stable
         */
        get snapshotIdentifier(): string | undefined;
        /**
         * @stability stable
         */
        set snapshotIdentifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetSnapshotIdentifier(): void;
        /**
         * @stability stable
         */
        get snapshotIdentifierInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _vpcSecurityGroupIds?;
        /**
         * @stability stable
         */
        get vpcSecurityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set vpcSecurityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetVpcSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get vpcSecurityGroupIdsInput(): string[] | undefined;
        private _logging?;
        private __loggingOutput;
        /**
         * @stability stable
         */
        get logging(): RedshiftClusterLoggingOutputReference;
        /**
         * @stability stable
         */
        putLogging(value: RedshiftClusterLogging | undefined): void;
        /**
         * @stability stable
         */
        resetLogging(): void;
        /**
         * @stability stable
         */
        get loggingInput(): RedshiftClusterLogging | undefined;
        private _snapshotCopy?;
        private __snapshotCopyOutput;
        /**
         * @stability stable
         */
        get snapshotCopy(): RedshiftClusterSnapshotCopyOutputReference;
        /**
         * @stability stable
         */
        putSnapshotCopy(value: RedshiftClusterSnapshotCopy | undefined): void;
        /**
         * @stability stable
         */
        resetSnapshotCopy(): void;
        /**
         * @stability stable
         */
        get snapshotCopyInput(): RedshiftClusterSnapshotCopy | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): RedshiftClusterTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: RedshiftClusterTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): RedshiftClusterTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface RedshiftEventSubscriptionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_event_subscription.html#enabled RedshiftEventSubscription#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_event_subscription.html#event_categories RedshiftEventSubscription#event_categories}.
         *
         * @stability stable
         */
        readonly eventCategories?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_event_subscription.html#name RedshiftEventSubscription#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_event_subscription.html#severity RedshiftEventSubscription#severity}.
         *
         * @stability stable
         */
        readonly severity?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_event_subscription.html#sns_topic_arn RedshiftEventSubscription#sns_topic_arn}.
         *
         * @stability stable
         */
        readonly snsTopicArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_event_subscription.html#source_ids RedshiftEventSubscription#source_ids}.
         *
         * @stability stable
         */
        readonly sourceIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_event_subscription.html#source_type RedshiftEventSubscription#source_type}.
         *
         * @stability stable
         */
        readonly sourceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_event_subscription.html#tags RedshiftEventSubscription#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_event_subscription.html#tags_all RedshiftEventSubscription#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_event_subscription.html#timeouts RedshiftEventSubscription#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: RedshiftEventSubscriptionTimeouts;
    }
    /**
     * @stability stable
     */
    interface RedshiftEventSubscriptionTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_event_subscription.html#create RedshiftEventSubscription#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_event_subscription.html#delete RedshiftEventSubscription#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_event_subscription.html#update RedshiftEventSubscription#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class RedshiftEventSubscriptionTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/redshift_event_subscription.html aws_redshift_event_subscription}.
     *
     * @stability stable
     */
    class RedshiftEventSubscription extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/redshift_event_subscription.html aws_redshift_event_subscription} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: RedshiftEventSubscriptionConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get customerAwsId(): string;
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _eventCategories?;
        /**
         * @stability stable
         */
        get eventCategories(): string[] | undefined;
        /**
         * @stability stable
         */
        set eventCategories(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetEventCategories(): void;
        /**
         * @stability stable
         */
        get eventCategoriesInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _severity?;
        /**
         * @stability stable
         */
        get severity(): string | undefined;
        /**
         * @stability stable
         */
        set severity(value: string | undefined);
        /**
         * @stability stable
         */
        resetSeverity(): void;
        /**
         * @stability stable
         */
        get severityInput(): string | undefined;
        private _snsTopicArn?;
        /**
         * @stability stable
         */
        get snsTopicArn(): string;
        /**
         * @stability stable
         */
        set snsTopicArn(value: string);
        /**
         * @stability stable
         */
        get snsTopicArnInput(): string | undefined;
        private _sourceIds?;
        /**
         * @stability stable
         */
        get sourceIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set sourceIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSourceIds(): void;
        /**
         * @stability stable
         */
        get sourceIdsInput(): string[] | undefined;
        private _sourceType?;
        /**
         * @stability stable
         */
        get sourceType(): string | undefined;
        /**
         * @stability stable
         */
        set sourceType(value: string | undefined);
        /**
         * @stability stable
         */
        resetSourceType(): void;
        /**
         * @stability stable
         */
        get sourceTypeInput(): string | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): RedshiftEventSubscriptionTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: RedshiftEventSubscriptionTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): RedshiftEventSubscriptionTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface RedshiftParameterGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_parameter_group.html#description RedshiftParameterGroup#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_parameter_group.html#family RedshiftParameterGroup#family}.
         *
         * @stability stable
         */
        readonly family: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_parameter_group.html#name RedshiftParameterGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_parameter_group.html#tags RedshiftParameterGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_parameter_group.html#tags_all RedshiftParameterGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * parameter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_parameter_group.html#parameter RedshiftParameterGroup#parameter}
         *
         * @stability stable
         */
        readonly parameter?: RedshiftParameterGroupParameter[];
    }
    /**
     * @stability stable
     */
    interface RedshiftParameterGroupParameter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_parameter_group.html#name RedshiftParameterGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_parameter_group.html#value RedshiftParameterGroup#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/redshift_parameter_group.html aws_redshift_parameter_group}.
     *
     * @stability stable
     */
    class RedshiftParameterGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/redshift_parameter_group.html aws_redshift_parameter_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: RedshiftParameterGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _family?;
        /**
         * @stability stable
         */
        get family(): string;
        /**
         * @stability stable
         */
        set family(value: string);
        /**
         * @stability stable
         */
        get familyInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _parameter?;
        /**
         * @stability stable
         */
        get parameter(): RedshiftParameterGroupParameter[] | undefined;
        /**
         * @stability stable
         */
        set parameter(value: RedshiftParameterGroupParameter[] | undefined);
        /**
         * @stability stable
         */
        resetParameter(): void;
        /**
         * @stability stable
         */
        get parameterInput(): RedshiftParameterGroupParameter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface RedshiftScheduledActionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#description RedshiftScheduledAction#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#enable RedshiftScheduledAction#enable}.
         *
         * @stability stable
         */
        readonly enable?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#end_time RedshiftScheduledAction#end_time}.
         *
         * @stability stable
         */
        readonly endTime?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#iam_role RedshiftScheduledAction#iam_role}.
         *
         * @stability stable
         */
        readonly iamRole: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#name RedshiftScheduledAction#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#schedule RedshiftScheduledAction#schedule}.
         *
         * @stability stable
         */
        readonly schedule: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#start_time RedshiftScheduledAction#start_time}.
         *
         * @stability stable
         */
        readonly startTime?: string;
        /**
         * target_action block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#target_action RedshiftScheduledAction#target_action}
         *
         * @stability stable
         */
        readonly targetAction: RedshiftScheduledActionTargetAction;
    }
    /**
     * @stability stable
     */
    interface RedshiftScheduledActionTargetActionPauseCluster {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#cluster_identifier RedshiftScheduledAction#cluster_identifier}.
         *
         * @stability stable
         */
        readonly clusterIdentifier: string;
    }
    /**
     * @stability stable
     */
    class RedshiftScheduledActionTargetActionPauseClusterOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _clusterIdentifier?;
        /**
         * @stability stable
         */
        get clusterIdentifier(): string;
        /**
         * @stability stable
         */
        set clusterIdentifier(value: string);
        /**
         * @stability stable
         */
        get clusterIdentifierInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface RedshiftScheduledActionTargetActionResizeCluster {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#classic RedshiftScheduledAction#classic}.
         *
         * @stability stable
         */
        readonly classic?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#cluster_identifier RedshiftScheduledAction#cluster_identifier}.
         *
         * @stability stable
         */
        readonly clusterIdentifier: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#cluster_type RedshiftScheduledAction#cluster_type}.
         *
         * @stability stable
         */
        readonly clusterType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#node_type RedshiftScheduledAction#node_type}.
         *
         * @stability stable
         */
        readonly nodeType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#number_of_nodes RedshiftScheduledAction#number_of_nodes}.
         *
         * @stability stable
         */
        readonly numberOfNodes?: number;
    }
    /**
     * @stability stable
     */
    class RedshiftScheduledActionTargetActionResizeClusterOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _classic?;
        /**
         * @stability stable
         */
        get classic(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set classic(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetClassic(): void;
        /**
         * @stability stable
         */
        get classicInput(): boolean | cdktf.IResolvable | undefined;
        private _clusterIdentifier?;
        /**
         * @stability stable
         */
        get clusterIdentifier(): string;
        /**
         * @stability stable
         */
        set clusterIdentifier(value: string);
        /**
         * @stability stable
         */
        get clusterIdentifierInput(): string | undefined;
        private _clusterType?;
        /**
         * @stability stable
         */
        get clusterType(): string | undefined;
        /**
         * @stability stable
         */
        set clusterType(value: string | undefined);
        /**
         * @stability stable
         */
        resetClusterType(): void;
        /**
         * @stability stable
         */
        get clusterTypeInput(): string | undefined;
        private _nodeType?;
        /**
         * @stability stable
         */
        get nodeType(): string | undefined;
        /**
         * @stability stable
         */
        set nodeType(value: string | undefined);
        /**
         * @stability stable
         */
        resetNodeType(): void;
        /**
         * @stability stable
         */
        get nodeTypeInput(): string | undefined;
        private _numberOfNodes?;
        /**
         * @stability stable
         */
        get numberOfNodes(): number | undefined;
        /**
         * @stability stable
         */
        set numberOfNodes(value: number | undefined);
        /**
         * @stability stable
         */
        resetNumberOfNodes(): void;
        /**
         * @stability stable
         */
        get numberOfNodesInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface RedshiftScheduledActionTargetActionResumeCluster {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#cluster_identifier RedshiftScheduledAction#cluster_identifier}.
         *
         * @stability stable
         */
        readonly clusterIdentifier: string;
    }
    /**
     * @stability stable
     */
    class RedshiftScheduledActionTargetActionResumeClusterOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _clusterIdentifier?;
        /**
         * @stability stable
         */
        get clusterIdentifier(): string;
        /**
         * @stability stable
         */
        set clusterIdentifier(value: string);
        /**
         * @stability stable
         */
        get clusterIdentifierInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface RedshiftScheduledActionTargetAction {
        /**
         * pause_cluster block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#pause_cluster RedshiftScheduledAction#pause_cluster}
         *
         * @stability stable
         */
        readonly pauseCluster?: RedshiftScheduledActionTargetActionPauseCluster;
        /**
         * resize_cluster block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#resize_cluster RedshiftScheduledAction#resize_cluster}
         *
         * @stability stable
         */
        readonly resizeCluster?: RedshiftScheduledActionTargetActionResizeCluster;
        /**
         * resume_cluster block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html#resume_cluster RedshiftScheduledAction#resume_cluster}
         *
         * @stability stable
         */
        readonly resumeCluster?: RedshiftScheduledActionTargetActionResumeCluster;
    }
    /**
     * @stability stable
     */
    class RedshiftScheduledActionTargetActionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _pauseCluster?;
        private __pauseClusterOutput;
        /**
         * @stability stable
         */
        get pauseCluster(): RedshiftScheduledActionTargetActionPauseClusterOutputReference;
        /**
         * @stability stable
         */
        putPauseCluster(value: RedshiftScheduledActionTargetActionPauseCluster | undefined): void;
        /**
         * @stability stable
         */
        resetPauseCluster(): void;
        /**
         * @stability stable
         */
        get pauseClusterInput(): RedshiftScheduledActionTargetActionPauseCluster | undefined;
        private _resizeCluster?;
        private __resizeClusterOutput;
        /**
         * @stability stable
         */
        get resizeCluster(): RedshiftScheduledActionTargetActionResizeClusterOutputReference;
        /**
         * @stability stable
         */
        putResizeCluster(value: RedshiftScheduledActionTargetActionResizeCluster | undefined): void;
        /**
         * @stability stable
         */
        resetResizeCluster(): void;
        /**
         * @stability stable
         */
        get resizeClusterInput(): RedshiftScheduledActionTargetActionResizeCluster | undefined;
        private _resumeCluster?;
        private __resumeClusterOutput;
        /**
         * @stability stable
         */
        get resumeCluster(): RedshiftScheduledActionTargetActionResumeClusterOutputReference;
        /**
         * @stability stable
         */
        putResumeCluster(value: RedshiftScheduledActionTargetActionResumeCluster | undefined): void;
        /**
         * @stability stable
         */
        resetResumeCluster(): void;
        /**
         * @stability stable
         */
        get resumeClusterInput(): RedshiftScheduledActionTargetActionResumeCluster | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html aws_redshift_scheduled_action}.
     *
     * @stability stable
     */
    class RedshiftScheduledAction extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/redshift_scheduled_action.html aws_redshift_scheduled_action} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: RedshiftScheduledActionConfig);
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _enable?;
        /**
         * @stability stable
         */
        get enable(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enable(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnable(): void;
        /**
         * @stability stable
         */
        get enableInput(): boolean | cdktf.IResolvable | undefined;
        private _endTime?;
        /**
         * @stability stable
         */
        get endTime(): string | undefined;
        /**
         * @stability stable
         */
        set endTime(value: string | undefined);
        /**
         * @stability stable
         */
        resetEndTime(): void;
        /**
         * @stability stable
         */
        get endTimeInput(): string | undefined;
        private _iamRole?;
        /**
         * @stability stable
         */
        get iamRole(): string;
        /**
         * @stability stable
         */
        set iamRole(value: string);
        /**
         * @stability stable
         */
        get iamRoleInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _schedule?;
        /**
         * @stability stable
         */
        get schedule(): string;
        /**
         * @stability stable
         */
        set schedule(value: string);
        /**
         * @stability stable
         */
        get scheduleInput(): string | undefined;
        private _startTime?;
        /**
         * @stability stable
         */
        get startTime(): string | undefined;
        /**
         * @stability stable
         */
        set startTime(value: string | undefined);
        /**
         * @stability stable
         */
        resetStartTime(): void;
        /**
         * @stability stable
         */
        get startTimeInput(): string | undefined;
        private _targetAction?;
        private __targetActionOutput;
        /**
         * @stability stable
         */
        get targetAction(): RedshiftScheduledActionTargetActionOutputReference;
        /**
         * @stability stable
         */
        putTargetAction(value: RedshiftScheduledActionTargetAction): void;
        /**
         * @stability stable
         */
        get targetActionInput(): RedshiftScheduledActionTargetAction | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface RedshiftSecurityGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_security_group.html#description RedshiftSecurityGroup#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_security_group.html#name RedshiftSecurityGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * ingress block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_security_group.html#ingress RedshiftSecurityGroup#ingress}
         *
         * @stability stable
         */
        readonly ingress: RedshiftSecurityGroupIngress[];
    }
    /**
     * @stability stable
     */
    interface RedshiftSecurityGroupIngress {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_security_group.html#cidr RedshiftSecurityGroup#cidr}.
         *
         * @stability stable
         */
        readonly cidr?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_security_group.html#security_group_name RedshiftSecurityGroup#security_group_name}.
         *
         * @stability stable
         */
        readonly securityGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_security_group.html#security_group_owner_id RedshiftSecurityGroup#security_group_owner_id}.
         *
         * @stability stable
         */
        readonly securityGroupOwnerId?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/redshift_security_group.html aws_redshift_security_group}.
     *
     * @stability stable
     */
    class RedshiftSecurityGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/redshift_security_group.html aws_redshift_security_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: RedshiftSecurityGroupConfig);
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _ingress?;
        /**
         * @stability stable
         */
        get ingress(): RedshiftSecurityGroupIngress[];
        /**
         * @stability stable
         */
        set ingress(value: RedshiftSecurityGroupIngress[]);
        /**
         * @stability stable
         */
        get ingressInput(): RedshiftSecurityGroupIngress[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface RedshiftSnapshotCopyGrantConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_copy_grant.html#kms_key_id RedshiftSnapshotCopyGrant#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_copy_grant.html#snapshot_copy_grant_name RedshiftSnapshotCopyGrant#snapshot_copy_grant_name}.
         *
         * @stability stable
         */
        readonly snapshotCopyGrantName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_copy_grant.html#tags RedshiftSnapshotCopyGrant#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_copy_grant.html#tags_all RedshiftSnapshotCopyGrant#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_copy_grant.html aws_redshift_snapshot_copy_grant}.
     *
     * @stability stable
     */
    class RedshiftSnapshotCopyGrant extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_copy_grant.html aws_redshift_snapshot_copy_grant} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: RedshiftSnapshotCopyGrantConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        private _snapshotCopyGrantName?;
        /**
         * @stability stable
         */
        get snapshotCopyGrantName(): string;
        /**
         * @stability stable
         */
        set snapshotCopyGrantName(value: string);
        /**
         * @stability stable
         */
        get snapshotCopyGrantNameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface RedshiftSnapshotScheduleConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_schedule.html#definitions RedshiftSnapshotSchedule#definitions}.
         *
         * @stability stable
         */
        readonly definitions: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_schedule.html#description RedshiftSnapshotSchedule#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_schedule.html#force_destroy RedshiftSnapshotSchedule#force_destroy}.
         *
         * @stability stable
         */
        readonly forceDestroy?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_schedule.html#identifier RedshiftSnapshotSchedule#identifier}.
         *
         * @stability stable
         */
        readonly identifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_schedule.html#identifier_prefix RedshiftSnapshotSchedule#identifier_prefix}.
         *
         * @stability stable
         */
        readonly identifierPrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_schedule.html#tags RedshiftSnapshotSchedule#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_schedule.html#tags_all RedshiftSnapshotSchedule#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_schedule.html aws_redshift_snapshot_schedule}.
     *
     * @stability stable
     */
    class RedshiftSnapshotSchedule extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_schedule.html aws_redshift_snapshot_schedule} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: RedshiftSnapshotScheduleConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _definitions?;
        /**
         * @stability stable
         */
        get definitions(): string[];
        /**
         * @stability stable
         */
        set definitions(value: string[]);
        /**
         * @stability stable
         */
        get definitionsInput(): string[] | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _forceDestroy?;
        /**
         * @stability stable
         */
        get forceDestroy(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set forceDestroy(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetForceDestroy(): void;
        /**
         * @stability stable
         */
        get forceDestroyInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _identifier?;
        /**
         * @stability stable
         */
        get identifier(): string | undefined;
        /**
         * @stability stable
         */
        set identifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetIdentifier(): void;
        /**
         * @stability stable
         */
        get identifierInput(): string | undefined;
        private _identifierPrefix?;
        /**
         * @stability stable
         */
        get identifierPrefix(): string | undefined;
        /**
         * @stability stable
         */
        set identifierPrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetIdentifierPrefix(): void;
        /**
         * @stability stable
         */
        get identifierPrefixInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface RedshiftSnapshotScheduleAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_schedule_association.html#cluster_identifier RedshiftSnapshotScheduleAssociation#cluster_identifier}.
         *
         * @stability stable
         */
        readonly clusterIdentifier: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_schedule_association.html#schedule_identifier RedshiftSnapshotScheduleAssociation#schedule_identifier}.
         *
         * @stability stable
         */
        readonly scheduleIdentifier: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_schedule_association.html aws_redshift_snapshot_schedule_association}.
     *
     * @stability stable
     */
    class RedshiftSnapshotScheduleAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/redshift_snapshot_schedule_association.html aws_redshift_snapshot_schedule_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: RedshiftSnapshotScheduleAssociationConfig);
        private _clusterIdentifier?;
        /**
         * @stability stable
         */
        get clusterIdentifier(): string;
        /**
         * @stability stable
         */
        set clusterIdentifier(value: string);
        /**
         * @stability stable
         */
        get clusterIdentifierInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _scheduleIdentifier?;
        /**
         * @stability stable
         */
        get scheduleIdentifier(): string;
        /**
         * @stability stable
         */
        set scheduleIdentifier(value: string);
        /**
         * @stability stable
         */
        get scheduleIdentifierInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface RedshiftSubnetGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_subnet_group.html#description RedshiftSubnetGroup#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_subnet_group.html#name RedshiftSubnetGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_subnet_group.html#subnet_ids RedshiftSubnetGroup#subnet_ids}.
         *
         * @stability stable
         */
        readonly subnetIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_subnet_group.html#tags RedshiftSubnetGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/redshift_subnet_group.html#tags_all RedshiftSubnetGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/redshift_subnet_group.html aws_redshift_subnet_group}.
     *
     * @stability stable
     */
    class RedshiftSubnetGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/redshift_subnet_group.html aws_redshift_subnet_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: RedshiftSubnetGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _subnetIds?;
        /**
         * @stability stable
         */
        get subnetIds(): string[];
        /**
         * @stability stable
         */
        set subnetIds(value: string[]);
        /**
         * @stability stable
         */
        get subnetIdsInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsRedshiftClusterConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/redshift_cluster.html#cluster_identifier DataAwsRedshiftCluster#cluster_identifier}.
         *
         * @stability stable
         */
        readonly clusterIdentifier: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/redshift_cluster.html#tags DataAwsRedshiftCluster#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/redshift_cluster.html aws_redshift_cluster}.
     *
     * @stability stable
     */
    class DataAwsRedshiftCluster extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/redshift_cluster.html aws_redshift_cluster} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsRedshiftClusterConfig);
        /**
         * @stability stable
         */
        get allowVersionUpgrade(): any;
        /**
         * @stability stable
         */
        get automatedSnapshotRetentionPeriod(): number;
        /**
         * @stability stable
         */
        get availabilityZone(): string;
        /**
         * @stability stable
         */
        get bucketName(): string;
        private _clusterIdentifier?;
        /**
         * @stability stable
         */
        get clusterIdentifier(): string;
        /**
         * @stability stable
         */
        set clusterIdentifier(value: string);
        /**
         * @stability stable
         */
        get clusterIdentifierInput(): string | undefined;
        /**
         * @stability stable
         */
        get clusterParameterGroupName(): string;
        /**
         * @stability stable
         */
        get clusterPublicKey(): string;
        /**
         * @stability stable
         */
        get clusterRevisionNumber(): string;
        /**
         * @stability stable
         */
        get clusterSecurityGroups(): string[];
        /**
         * @stability stable
         */
        get clusterSubnetGroupName(): string;
        /**
         * @stability stable
         */
        get clusterType(): string;
        /**
         * @stability stable
         */
        get clusterVersion(): string;
        /**
         * @stability stable
         */
        get databaseName(): string;
        /**
         * @stability stable
         */
        get elasticIp(): string;
        /**
         * @stability stable
         */
        get enableLogging(): any;
        /**
         * @stability stable
         */
        get encrypted(): any;
        /**
         * @stability stable
         */
        get endpoint(): string;
        /**
         * @stability stable
         */
        get enhancedVpcRouting(): any;
        /**
         * @stability stable
         */
        get iamRoles(): string[];
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get kmsKeyId(): string;
        /**
         * @stability stable
         */
        get masterUsername(): string;
        /**
         * @stability stable
         */
        get nodeType(): string;
        /**
         * @stability stable
         */
        get numberOfNodes(): number;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        get preferredMaintenanceWindow(): string;
        /**
         * @stability stable
         */
        get publiclyAccessible(): any;
        /**
         * @stability stable
         */
        get s3KeyPrefix(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get vpcId(): string;
        /**
         * @stability stable
         */
        get vpcSecurityGroupIds(): string[];
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsRedshiftOrderableClusterConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/redshift_orderable_cluster.html#cluster_type DataAwsRedshiftOrderableCluster#cluster_type}.
         *
         * @stability stable
         */
        readonly clusterType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/redshift_orderable_cluster.html#cluster_version DataAwsRedshiftOrderableCluster#cluster_version}.
         *
         * @stability stable
         */
        readonly clusterVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/redshift_orderable_cluster.html#node_type DataAwsRedshiftOrderableCluster#node_type}.
         *
         * @stability stable
         */
        readonly nodeType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/redshift_orderable_cluster.html#preferred_node_types DataAwsRedshiftOrderableCluster#preferred_node_types}.
         *
         * @stability stable
         */
        readonly preferredNodeTypes?: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/redshift_orderable_cluster.html aws_redshift_orderable_cluster}.
     *
     * @stability stable
     */
    class DataAwsRedshiftOrderableCluster extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/redshift_orderable_cluster.html aws_redshift_orderable_cluster} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsRedshiftOrderableClusterConfig);
        /**
         * @stability stable
         */
        get availabilityZones(): string[];
        private _clusterType?;
        /**
         * @stability stable
         */
        get clusterType(): string | undefined;
        /**
         * @stability stable
         */
        set clusterType(value: string | undefined);
        /**
         * @stability stable
         */
        resetClusterType(): void;
        /**
         * @stability stable
         */
        get clusterTypeInput(): string | undefined;
        private _clusterVersion?;
        /**
         * @stability stable
         */
        get clusterVersion(): string | undefined;
        /**
         * @stability stable
         */
        set clusterVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetClusterVersion(): void;
        /**
         * @stability stable
         */
        get clusterVersionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _nodeType?;
        /**
         * @stability stable
         */
        get nodeType(): string | undefined;
        /**
         * @stability stable
         */
        set nodeType(value: string | undefined);
        /**
         * @stability stable
         */
        resetNodeType(): void;
        /**
         * @stability stable
         */
        get nodeTypeInput(): string | undefined;
        private _preferredNodeTypes?;
        /**
         * @stability stable
         */
        get preferredNodeTypes(): string[] | undefined;
        /**
         * @stability stable
         */
        set preferredNodeTypes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetPreferredNodeTypes(): void;
        /**
         * @stability stable
         */
        get preferredNodeTypesInput(): string[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsRedshiftServiceAccountConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/redshift_service_account.html#region DataAwsRedshiftServiceAccount#region}.
         *
         * @stability stable
         */
        readonly region?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/redshift_service_account.html aws_redshift_service_account}.
     *
     * @stability stable
     */
    class DataAwsRedshiftServiceAccount extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/redshift_service_account.html aws_redshift_service_account} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsRedshiftServiceAccountConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _region?;
        /**
         * @stability stable
         */
        get region(): string | undefined;
        /**
         * @stability stable
         */
        set region(value: string | undefined);
        /**
         * @stability stable
         */
        resetRegion(): void;
        /**
         * @stability stable
         */
        get regionInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
