import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Resource Groups
*/
export declare namespace ResourceGroups {
    /**
     * @stability stable
     */
    interface ResourcegroupsGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/resourcegroups_group.html#description ResourcegroupsGroup#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/resourcegroups_group.html#name ResourcegroupsGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/resourcegroups_group.html#tags ResourcegroupsGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/resourcegroups_group.html#tags_all ResourcegroupsGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * resource_query block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/resourcegroups_group.html#resource_query ResourcegroupsGroup#resource_query}
         *
         * @stability stable
         */
        readonly resourceQuery: ResourcegroupsGroupResourceQuery;
    }
    /**
     * @stability stable
     */
    interface ResourcegroupsGroupResourceQuery {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/resourcegroups_group.html#query ResourcegroupsGroup#query}.
         *
         * @stability stable
         */
        readonly query: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/resourcegroups_group.html#type ResourcegroupsGroup#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * @stability stable
     */
    class ResourcegroupsGroupResourceQueryOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _query?;
        /**
         * @stability stable
         */
        get query(): string;
        /**
         * @stability stable
         */
        set query(value: string);
        /**
         * @stability stable
         */
        get queryInput(): string | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string | undefined;
        /**
         * @stability stable
         */
        set type(value: string | undefined);
        /**
         * @stability stable
         */
        resetType(): void;
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/resourcegroups_group.html aws_resourcegroups_group}.
     *
     * @stability stable
     */
    class ResourcegroupsGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/resourcegroups_group.html aws_resourcegroups_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ResourcegroupsGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _resourceQuery?;
        private __resourceQueryOutput;
        /**
         * @stability stable
         */
        get resourceQuery(): ResourcegroupsGroupResourceQueryOutputReference;
        /**
         * @stability stable
         */
        putResourceQuery(value: ResourcegroupsGroupResourceQuery): void;
        /**
         * @stability stable
         */
        get resourceQueryInput(): ResourcegroupsGroupResourceQuery | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsResourcegroupstaggingapiResourcesConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html#exclude_compliant_resources DataAwsResourcegroupstaggingapiResources#exclude_compliant_resources}.
         *
         * @stability stable
         */
        readonly excludeCompliantResources?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html#include_compliance_details DataAwsResourcegroupstaggingapiResources#include_compliance_details}.
         *
         * @stability stable
         */
        readonly includeComplianceDetails?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html#resource_arn_list DataAwsResourcegroupstaggingapiResources#resource_arn_list}.
         *
         * @stability stable
         */
        readonly resourceArnList?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html#resource_type_filters DataAwsResourcegroupstaggingapiResources#resource_type_filters}.
         *
         * @stability stable
         */
        readonly resourceTypeFilters?: string[];
        /**
         * tag_filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html#tag_filter DataAwsResourcegroupstaggingapiResources#tag_filter}
         *
         * @stability stable
         */
        readonly tagFilter?: DataAwsResourcegroupstaggingapiResourcesTagFilter[];
    }
    /**
     * @stability stable
     */
    class DataAwsResourcegroupstaggingapiResourcesResourceTagMappingListComplianceDetails extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get complianceStatus(): any;
        /**
         * @stability stable
         */
        get keysWithNoncompliantValues(): string[];
        /**
         * @stability stable
         */
        get nonCompliantKeys(): string[];
    }
    /**
     * @stability stable
     */
    class DataAwsResourcegroupstaggingapiResourcesResourceTagMappingList extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get complianceDetails(): any;
        /**
         * @stability stable
         */
        get resourceArn(): string;
        /**
         * @stability stable
         */
        get tags(): any;
    }
    /**
     * @stability stable
     */
    interface DataAwsResourcegroupstaggingapiResourcesTagFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html#key DataAwsResourcegroupstaggingapiResources#key}.
         *
         * @stability stable
         */
        readonly key: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html#values DataAwsResourcegroupstaggingapiResources#values}.
         *
         * @stability stable
         */
        readonly values?: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html aws_resourcegroupstaggingapi_resources}.
     *
     * @stability stable
     */
    class DataAwsResourcegroupstaggingapiResources extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/resourcegroupstaggingapi_resources.html aws_resourcegroupstaggingapi_resources} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsResourcegroupstaggingapiResourcesConfig);
        private _excludeCompliantResources?;
        /**
         * @stability stable
         */
        get excludeCompliantResources(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set excludeCompliantResources(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetExcludeCompliantResources(): void;
        /**
         * @stability stable
         */
        get excludeCompliantResourcesInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _includeComplianceDetails?;
        /**
         * @stability stable
         */
        get includeComplianceDetails(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set includeComplianceDetails(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIncludeComplianceDetails(): void;
        /**
         * @stability stable
         */
        get includeComplianceDetailsInput(): boolean | cdktf.IResolvable | undefined;
        private _resourceArnList?;
        /**
         * @stability stable
         */
        get resourceArnList(): string[] | undefined;
        /**
         * @stability stable
         */
        set resourceArnList(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetResourceArnList(): void;
        /**
         * @stability stable
         */
        get resourceArnListInput(): string[] | undefined;
        /**
         * @stability stable
         */
        resourceTagMappingList(index: string): DataAwsResourcegroupstaggingapiResourcesResourceTagMappingList;
        private _resourceTypeFilters?;
        /**
         * @stability stable
         */
        get resourceTypeFilters(): string[] | undefined;
        /**
         * @stability stable
         */
        set resourceTypeFilters(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetResourceTypeFilters(): void;
        /**
         * @stability stable
         */
        get resourceTypeFiltersInput(): string[] | undefined;
        private _tagFilter?;
        /**
         * @stability stable
         */
        get tagFilter(): DataAwsResourcegroupstaggingapiResourcesTagFilter[] | undefined;
        /**
         * @stability stable
         */
        set tagFilter(value: DataAwsResourcegroupstaggingapiResourcesTagFilter[] | undefined);
        /**
         * @stability stable
         */
        resetTagFilter(): void;
        /**
         * @stability stable
         */
        get tagFilterInput(): DataAwsResourcegroupstaggingapiResourcesTagFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
