import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Route 53
*/
export declare namespace Route53 {
    /**
     * @stability stable
     */
    interface Route53DelegationSetConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_delegation_set.html#reference_name Route53DelegationSet#reference_name}.
         *
         * @stability stable
         */
        readonly referenceName?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_delegation_set.html aws_route53_delegation_set}.
     *
     * @stability stable
     */
    class Route53DelegationSet extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_delegation_set.html aws_route53_delegation_set} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: Route53DelegationSetConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get nameServers(): string[];
        private _referenceName?;
        /**
         * @stability stable
         */
        get referenceName(): string | undefined;
        /**
         * @stability stable
         */
        set referenceName(value: string | undefined);
        /**
         * @stability stable
         */
        resetReferenceName(): void;
        /**
         * @stability stable
         */
        get referenceNameInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53HealthCheckConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#child_health_threshold Route53HealthCheck#child_health_threshold}.
         *
         * @stability stable
         */
        readonly childHealthThreshold?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#child_healthchecks Route53HealthCheck#child_healthchecks}.
         *
         * @stability stable
         */
        readonly childHealthchecks?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#cloudwatch_alarm_name Route53HealthCheck#cloudwatch_alarm_name}.
         *
         * @stability stable
         */
        readonly cloudwatchAlarmName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#cloudwatch_alarm_region Route53HealthCheck#cloudwatch_alarm_region}.
         *
         * @stability stable
         */
        readonly cloudwatchAlarmRegion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#disabled Route53HealthCheck#disabled}.
         *
         * @stability stable
         */
        readonly disabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#enable_sni Route53HealthCheck#enable_sni}.
         *
         * @stability stable
         */
        readonly enableSni?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#failure_threshold Route53HealthCheck#failure_threshold}.
         *
         * @stability stable
         */
        readonly failureThreshold?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#fqdn Route53HealthCheck#fqdn}.
         *
         * @stability stable
         */
        readonly fqdn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#insufficient_data_health_status Route53HealthCheck#insufficient_data_health_status}.
         *
         * @stability stable
         */
        readonly insufficientDataHealthStatus?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#invert_healthcheck Route53HealthCheck#invert_healthcheck}.
         *
         * @stability stable
         */
        readonly invertHealthcheck?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#ip_address Route53HealthCheck#ip_address}.
         *
         * @stability stable
         */
        readonly ipAddress?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#measure_latency Route53HealthCheck#measure_latency}.
         *
         * @stability stable
         */
        readonly measureLatency?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#port Route53HealthCheck#port}.
         *
         * @stability stable
         */
        readonly port?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#reference_name Route53HealthCheck#reference_name}.
         *
         * @stability stable
         */
        readonly referenceName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#regions Route53HealthCheck#regions}.
         *
         * @stability stable
         */
        readonly regions?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#request_interval Route53HealthCheck#request_interval}.
         *
         * @stability stable
         */
        readonly requestInterval?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#resource_path Route53HealthCheck#resource_path}.
         *
         * @stability stable
         */
        readonly resourcePath?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#routing_control_arn Route53HealthCheck#routing_control_arn}.
         *
         * @stability stable
         */
        readonly routingControlArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#search_string Route53HealthCheck#search_string}.
         *
         * @stability stable
         */
        readonly searchString?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#tags Route53HealthCheck#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#tags_all Route53HealthCheck#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#type Route53HealthCheck#type}.
         *
         * @stability stable
         */
        readonly type: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html aws_route53_health_check}.
     *
     * @stability stable
     */
    class Route53HealthCheck extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html aws_route53_health_check} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53HealthCheckConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _childHealthThreshold?;
        /**
         * @stability stable
         */
        get childHealthThreshold(): number | undefined;
        /**
         * @stability stable
         */
        set childHealthThreshold(value: number | undefined);
        /**
         * @stability stable
         */
        resetChildHealthThreshold(): void;
        /**
         * @stability stable
         */
        get childHealthThresholdInput(): number | undefined;
        private _childHealthchecks?;
        /**
         * @stability stable
         */
        get childHealthchecks(): string[] | undefined;
        /**
         * @stability stable
         */
        set childHealthchecks(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetChildHealthchecks(): void;
        /**
         * @stability stable
         */
        get childHealthchecksInput(): string[] | undefined;
        private _cloudwatchAlarmName?;
        /**
         * @stability stable
         */
        get cloudwatchAlarmName(): string | undefined;
        /**
         * @stability stable
         */
        set cloudwatchAlarmName(value: string | undefined);
        /**
         * @stability stable
         */
        resetCloudwatchAlarmName(): void;
        /**
         * @stability stable
         */
        get cloudwatchAlarmNameInput(): string | undefined;
        private _cloudwatchAlarmRegion?;
        /**
         * @stability stable
         */
        get cloudwatchAlarmRegion(): string | undefined;
        /**
         * @stability stable
         */
        set cloudwatchAlarmRegion(value: string | undefined);
        /**
         * @stability stable
         */
        resetCloudwatchAlarmRegion(): void;
        /**
         * @stability stable
         */
        get cloudwatchAlarmRegionInput(): string | undefined;
        private _disabled?;
        /**
         * @stability stable
         */
        get disabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set disabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDisabled(): void;
        /**
         * @stability stable
         */
        get disabledInput(): boolean | cdktf.IResolvable | undefined;
        private _enableSni?;
        /**
         * @stability stable
         */
        get enableSni(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableSni(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableSni(): void;
        /**
         * @stability stable
         */
        get enableSniInput(): boolean | cdktf.IResolvable | undefined;
        private _failureThreshold?;
        /**
         * @stability stable
         */
        get failureThreshold(): number | undefined;
        /**
         * @stability stable
         */
        set failureThreshold(value: number | undefined);
        /**
         * @stability stable
         */
        resetFailureThreshold(): void;
        /**
         * @stability stable
         */
        get failureThresholdInput(): number | undefined;
        private _fqdn?;
        /**
         * @stability stable
         */
        get fqdn(): string | undefined;
        /**
         * @stability stable
         */
        set fqdn(value: string | undefined);
        /**
         * @stability stable
         */
        resetFqdn(): void;
        /**
         * @stability stable
         */
        get fqdnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _insufficientDataHealthStatus?;
        /**
         * @stability stable
         */
        get insufficientDataHealthStatus(): string | undefined;
        /**
         * @stability stable
         */
        set insufficientDataHealthStatus(value: string | undefined);
        /**
         * @stability stable
         */
        resetInsufficientDataHealthStatus(): void;
        /**
         * @stability stable
         */
        get insufficientDataHealthStatusInput(): string | undefined;
        private _invertHealthcheck?;
        /**
         * @stability stable
         */
        get invertHealthcheck(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set invertHealthcheck(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetInvertHealthcheck(): void;
        /**
         * @stability stable
         */
        get invertHealthcheckInput(): boolean | cdktf.IResolvable | undefined;
        private _ipAddress?;
        /**
         * @stability stable
         */
        get ipAddress(): string | undefined;
        /**
         * @stability stable
         */
        set ipAddress(value: string | undefined);
        /**
         * @stability stable
         */
        resetIpAddress(): void;
        /**
         * @stability stable
         */
        get ipAddressInput(): string | undefined;
        private _measureLatency?;
        /**
         * @stability stable
         */
        get measureLatency(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set measureLatency(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetMeasureLatency(): void;
        /**
         * @stability stable
         */
        get measureLatencyInput(): boolean | cdktf.IResolvable | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number | undefined;
        /**
         * @stability stable
         */
        set port(value: number | undefined);
        /**
         * @stability stable
         */
        resetPort(): void;
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
        private _referenceName?;
        /**
         * @stability stable
         */
        get referenceName(): string | undefined;
        /**
         * @stability stable
         */
        set referenceName(value: string | undefined);
        /**
         * @stability stable
         */
        resetReferenceName(): void;
        /**
         * @stability stable
         */
        get referenceNameInput(): string | undefined;
        private _regions?;
        /**
         * @stability stable
         */
        get regions(): string[] | undefined;
        /**
         * @stability stable
         */
        set regions(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetRegions(): void;
        /**
         * @stability stable
         */
        get regionsInput(): string[] | undefined;
        private _requestInterval?;
        /**
         * @stability stable
         */
        get requestInterval(): number | undefined;
        /**
         * @stability stable
         */
        set requestInterval(value: number | undefined);
        /**
         * @stability stable
         */
        resetRequestInterval(): void;
        /**
         * @stability stable
         */
        get requestIntervalInput(): number | undefined;
        private _resourcePath?;
        /**
         * @stability stable
         */
        get resourcePath(): string | undefined;
        /**
         * @stability stable
         */
        set resourcePath(value: string | undefined);
        /**
         * @stability stable
         */
        resetResourcePath(): void;
        /**
         * @stability stable
         */
        get resourcePathInput(): string | undefined;
        private _routingControlArn?;
        /**
         * @stability stable
         */
        get routingControlArn(): string | undefined;
        /**
         * @stability stable
         */
        set routingControlArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetRoutingControlArn(): void;
        /**
         * @stability stable
         */
        get routingControlArnInput(): string | undefined;
        private _searchString?;
        /**
         * @stability stable
         */
        get searchString(): string | undefined;
        /**
         * @stability stable
         */
        set searchString(value: string | undefined);
        /**
         * @stability stable
         */
        resetSearchString(): void;
        /**
         * @stability stable
         */
        get searchStringInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53HostedZoneDnssecConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_hosted_zone_dnssec.html#hosted_zone_id Route53HostedZoneDnssec#hosted_zone_id}.
         *
         * @stability stable
         */
        readonly hostedZoneId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_hosted_zone_dnssec.html#signing_status Route53HostedZoneDnssec#signing_status}.
         *
         * @stability stable
         */
        readonly signingStatus?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_hosted_zone_dnssec.html aws_route53_hosted_zone_dnssec}.
     *
     * @stability stable
     */
    class Route53HostedZoneDnssec extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_hosted_zone_dnssec.html aws_route53_hosted_zone_dnssec} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53HostedZoneDnssecConfig);
        private _hostedZoneId?;
        /**
         * @stability stable
         */
        get hostedZoneId(): string;
        /**
         * @stability stable
         */
        set hostedZoneId(value: string);
        /**
         * @stability stable
         */
        get hostedZoneIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _signingStatus?;
        /**
         * @stability stable
         */
        get signingStatus(): string | undefined;
        /**
         * @stability stable
         */
        set signingStatus(value: string | undefined);
        /**
         * @stability stable
         */
        resetSigningStatus(): void;
        /**
         * @stability stable
         */
        get signingStatusInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53KeySigningKeyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_key_signing_key.html#hosted_zone_id Route53KeySigningKey#hosted_zone_id}.
         *
         * @stability stable
         */
        readonly hostedZoneId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_key_signing_key.html#key_management_service_arn Route53KeySigningKey#key_management_service_arn}.
         *
         * @stability stable
         */
        readonly keyManagementServiceArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_key_signing_key.html#name Route53KeySigningKey#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_key_signing_key.html#status Route53KeySigningKey#status}.
         *
         * @stability stable
         */
        readonly status?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_key_signing_key.html aws_route53_key_signing_key}.
     *
     * @stability stable
     */
    class Route53KeySigningKey extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_key_signing_key.html aws_route53_key_signing_key} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53KeySigningKeyConfig);
        /**
         * @stability stable
         */
        get digestAlgorithmMnemonic(): string;
        /**
         * @stability stable
         */
        get digestAlgorithmType(): number;
        /**
         * @stability stable
         */
        get digestValue(): string;
        /**
         * @stability stable
         */
        get dnskeyRecord(): string;
        /**
         * @stability stable
         */
        get dsRecord(): string;
        /**
         * @stability stable
         */
        get flag(): number;
        private _hostedZoneId?;
        /**
         * @stability stable
         */
        get hostedZoneId(): string;
        /**
         * @stability stable
         */
        set hostedZoneId(value: string);
        /**
         * @stability stable
         */
        get hostedZoneIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _keyManagementServiceArn?;
        /**
         * @stability stable
         */
        get keyManagementServiceArn(): string;
        /**
         * @stability stable
         */
        set keyManagementServiceArn(value: string);
        /**
         * @stability stable
         */
        get keyManagementServiceArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get keyTag(): number;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get publicKey(): string;
        /**
         * @stability stable
         */
        get signingAlgorithmMnemonic(): string;
        /**
         * @stability stable
         */
        get signingAlgorithmType(): number;
        private _status?;
        /**
         * @stability stable
         */
        get status(): string | undefined;
        /**
         * @stability stable
         */
        set status(value: string | undefined);
        /**
         * @stability stable
         */
        resetStatus(): void;
        /**
         * @stability stable
         */
        get statusInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53QueryLogConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_query_log.html#cloudwatch_log_group_arn Route53QueryLog#cloudwatch_log_group_arn}.
         *
         * @stability stable
         */
        readonly cloudwatchLogGroupArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_query_log.html#zone_id Route53QueryLog#zone_id}.
         *
         * @stability stable
         */
        readonly zoneId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_query_log.html aws_route53_query_log}.
     *
     * @stability stable
     */
    class Route53QueryLog extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_query_log.html aws_route53_query_log} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53QueryLogConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _cloudwatchLogGroupArn?;
        /**
         * @stability stable
         */
        get cloudwatchLogGroupArn(): string;
        /**
         * @stability stable
         */
        set cloudwatchLogGroupArn(value: string);
        /**
         * @stability stable
         */
        get cloudwatchLogGroupArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _zoneId?;
        /**
         * @stability stable
         */
        get zoneId(): string;
        /**
         * @stability stable
         */
        set zoneId(value: string);
        /**
         * @stability stable
         */
        get zoneIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53RecordConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#allow_overwrite Route53Record#allow_overwrite}.
         *
         * @stability stable
         */
        readonly allowOverwrite?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#health_check_id Route53Record#health_check_id}.
         *
         * @stability stable
         */
        readonly healthCheckId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#multivalue_answer_routing_policy Route53Record#multivalue_answer_routing_policy}.
         *
         * @stability stable
         */
        readonly multivalueAnswerRoutingPolicy?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#name Route53Record#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#records Route53Record#records}.
         *
         * @stability stable
         */
        readonly records?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#set_identifier Route53Record#set_identifier}.
         *
         * @stability stable
         */
        readonly setIdentifier?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#ttl Route53Record#ttl}.
         *
         * @stability stable
         */
        readonly ttl?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#type Route53Record#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#zone_id Route53Record#zone_id}.
         *
         * @stability stable
         */
        readonly zoneId: string;
        /**
         * alias block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#alias Route53Record#alias}
         *
         * @stability stable
         */
        readonly alias?: Route53RecordAlias[];
        /**
         * failover_routing_policy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#failover_routing_policy Route53Record#failover_routing_policy}
         *
         * @stability stable
         */
        readonly failoverRoutingPolicy?: Route53RecordFailoverRoutingPolicy[];
        /**
         * geolocation_routing_policy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#geolocation_routing_policy Route53Record#geolocation_routing_policy}
         *
         * @stability stable
         */
        readonly geolocationRoutingPolicy?: Route53RecordGeolocationRoutingPolicy[];
        /**
         * latency_routing_policy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#latency_routing_policy Route53Record#latency_routing_policy}
         *
         * @stability stable
         */
        readonly latencyRoutingPolicy?: Route53RecordLatencyRoutingPolicy[];
        /**
         * weighted_routing_policy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#weighted_routing_policy Route53Record#weighted_routing_policy}
         *
         * @stability stable
         */
        readonly weightedRoutingPolicy?: Route53RecordWeightedRoutingPolicy[];
    }
    /**
     * @stability stable
     */
    interface Route53RecordAlias {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#evaluate_target_health Route53Record#evaluate_target_health}.
         *
         * @stability stable
         */
        readonly evaluateTargetHealth: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#name Route53Record#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#zone_id Route53Record#zone_id}.
         *
         * @stability stable
         */
        readonly zoneId: string;
    }
    /**
     * @stability stable
     */
    interface Route53RecordFailoverRoutingPolicy {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#type Route53Record#type}.
         *
         * @stability stable
         */
        readonly type: string;
    }
    /**
     * @stability stable
     */
    interface Route53RecordGeolocationRoutingPolicy {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#continent Route53Record#continent}.
         *
         * @stability stable
         */
        readonly continent?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#country Route53Record#country}.
         *
         * @stability stable
         */
        readonly country?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#subdivision Route53Record#subdivision}.
         *
         * @stability stable
         */
        readonly subdivision?: string;
    }
    /**
     * @stability stable
     */
    interface Route53RecordLatencyRoutingPolicy {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#region Route53Record#region}.
         *
         * @stability stable
         */
        readonly region: string;
    }
    /**
     * @stability stable
     */
    interface Route53RecordWeightedRoutingPolicy {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html#weight Route53Record#weight}.
         *
         * @stability stable
         */
        readonly weight: number;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html aws_route53_record}.
     *
     * @stability stable
     */
    class Route53Record extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_record.html aws_route53_record} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53RecordConfig);
        private _allowOverwrite?;
        /**
         * @stability stable
         */
        get allowOverwrite(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set allowOverwrite(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAllowOverwrite(): void;
        /**
         * @stability stable
         */
        get allowOverwriteInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get fqdn(): string;
        private _healthCheckId?;
        /**
         * @stability stable
         */
        get healthCheckId(): string | undefined;
        /**
         * @stability stable
         */
        set healthCheckId(value: string | undefined);
        /**
         * @stability stable
         */
        resetHealthCheckId(): void;
        /**
         * @stability stable
         */
        get healthCheckIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _multivalueAnswerRoutingPolicy?;
        /**
         * @stability stable
         */
        get multivalueAnswerRoutingPolicy(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set multivalueAnswerRoutingPolicy(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetMultivalueAnswerRoutingPolicy(): void;
        /**
         * @stability stable
         */
        get multivalueAnswerRoutingPolicyInput(): boolean | cdktf.IResolvable | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _records?;
        /**
         * @stability stable
         */
        get records(): string[] | undefined;
        /**
         * @stability stable
         */
        set records(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetRecords(): void;
        /**
         * @stability stable
         */
        get recordsInput(): string[] | undefined;
        private _setIdentifier?;
        /**
         * @stability stable
         */
        get setIdentifier(): string | undefined;
        /**
         * @stability stable
         */
        set setIdentifier(value: string | undefined);
        /**
         * @stability stable
         */
        resetSetIdentifier(): void;
        /**
         * @stability stable
         */
        get setIdentifierInput(): string | undefined;
        private _ttl?;
        /**
         * @stability stable
         */
        get ttl(): number | undefined;
        /**
         * @stability stable
         */
        set ttl(value: number | undefined);
        /**
         * @stability stable
         */
        resetTtl(): void;
        /**
         * @stability stable
         */
        get ttlInput(): number | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _zoneId?;
        /**
         * @stability stable
         */
        get zoneId(): string;
        /**
         * @stability stable
         */
        set zoneId(value: string);
        /**
         * @stability stable
         */
        get zoneIdInput(): string | undefined;
        private _alias?;
        /**
         * @stability stable
         */
        get alias(): Route53RecordAlias[] | undefined;
        /**
         * @stability stable
         */
        set alias(value: Route53RecordAlias[] | undefined);
        /**
         * @stability stable
         */
        resetAlias(): void;
        /**
         * @stability stable
         */
        get aliasInput(): Route53RecordAlias[] | undefined;
        private _failoverRoutingPolicy?;
        /**
         * @stability stable
         */
        get failoverRoutingPolicy(): Route53RecordFailoverRoutingPolicy[] | undefined;
        /**
         * @stability stable
         */
        set failoverRoutingPolicy(value: Route53RecordFailoverRoutingPolicy[] | undefined);
        /**
         * @stability stable
         */
        resetFailoverRoutingPolicy(): void;
        /**
         * @stability stable
         */
        get failoverRoutingPolicyInput(): Route53RecordFailoverRoutingPolicy[] | undefined;
        private _geolocationRoutingPolicy?;
        /**
         * @stability stable
         */
        get geolocationRoutingPolicy(): Route53RecordGeolocationRoutingPolicy[] | undefined;
        /**
         * @stability stable
         */
        set geolocationRoutingPolicy(value: Route53RecordGeolocationRoutingPolicy[] | undefined);
        /**
         * @stability stable
         */
        resetGeolocationRoutingPolicy(): void;
        /**
         * @stability stable
         */
        get geolocationRoutingPolicyInput(): Route53RecordGeolocationRoutingPolicy[] | undefined;
        private _latencyRoutingPolicy?;
        /**
         * @stability stable
         */
        get latencyRoutingPolicy(): Route53RecordLatencyRoutingPolicy[] | undefined;
        /**
         * @stability stable
         */
        set latencyRoutingPolicy(value: Route53RecordLatencyRoutingPolicy[] | undefined);
        /**
         * @stability stable
         */
        resetLatencyRoutingPolicy(): void;
        /**
         * @stability stable
         */
        get latencyRoutingPolicyInput(): Route53RecordLatencyRoutingPolicy[] | undefined;
        private _weightedRoutingPolicy?;
        /**
         * @stability stable
         */
        get weightedRoutingPolicy(): Route53RecordWeightedRoutingPolicy[] | undefined;
        /**
         * @stability stable
         */
        set weightedRoutingPolicy(value: Route53RecordWeightedRoutingPolicy[] | undefined);
        /**
         * @stability stable
         */
        resetWeightedRoutingPolicy(): void;
        /**
         * @stability stable
         */
        get weightedRoutingPolicyInput(): Route53RecordWeightedRoutingPolicy[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53ResolverDnssecConfigConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_dnssec_config.html#resource_id Route53ResolverDnssecConfig#resource_id}.
         *
         * @stability stable
         */
        readonly resourceId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_dnssec_config.html aws_route53_resolver_dnssec_config}.
     *
     * @stability stable
     */
    class Route53ResolverDnssecConfig extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_dnssec_config.html aws_route53_resolver_dnssec_config} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53ResolverDnssecConfigConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _resourceId?;
        /**
         * @stability stable
         */
        get resourceId(): string;
        /**
         * @stability stable
         */
        set resourceId(value: string);
        /**
         * @stability stable
         */
        get resourceIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get validationStatus(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53ResolverEndpointConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_endpoint.html#direction Route53ResolverEndpoint#direction}.
         *
         * @stability stable
         */
        readonly direction: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_endpoint.html#name Route53ResolverEndpoint#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_endpoint.html#security_group_ids Route53ResolverEndpoint#security_group_ids}.
         *
         * @stability stable
         */
        readonly securityGroupIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_endpoint.html#tags Route53ResolverEndpoint#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_endpoint.html#tags_all Route53ResolverEndpoint#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * ip_address block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_endpoint.html#ip_address Route53ResolverEndpoint#ip_address}
         *
         * @stability stable
         */
        readonly ipAddress: Route53ResolverEndpointIpAddress[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_endpoint.html#timeouts Route53ResolverEndpoint#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: Route53ResolverEndpointTimeouts;
    }
    /**
     * @stability stable
     */
    interface Route53ResolverEndpointIpAddress {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_endpoint.html#ip Route53ResolverEndpoint#ip}.
         *
         * @stability stable
         */
        readonly ip?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_endpoint.html#subnet_id Route53ResolverEndpoint#subnet_id}.
         *
         * @stability stable
         */
        readonly subnetId: string;
    }
    /**
     * @stability stable
     */
    interface Route53ResolverEndpointTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_endpoint.html#create Route53ResolverEndpoint#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_endpoint.html#delete Route53ResolverEndpoint#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_endpoint.html#update Route53ResolverEndpoint#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class Route53ResolverEndpointTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_endpoint.html aws_route53_resolver_endpoint}.
     *
     * @stability stable
     */
    class Route53ResolverEndpoint extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_endpoint.html aws_route53_resolver_endpoint} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53ResolverEndpointConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _direction?;
        /**
         * @stability stable
         */
        get direction(): string;
        /**
         * @stability stable
         */
        set direction(value: string);
        /**
         * @stability stable
         */
        get directionInput(): string | undefined;
        /**
         * @stability stable
         */
        get hostVpcId(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _securityGroupIds?;
        /**
         * @stability stable
         */
        get securityGroupIds(): string[];
        /**
         * @stability stable
         */
        set securityGroupIds(value: string[]);
        /**
         * @stability stable
         */
        get securityGroupIdsInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _ipAddress?;
        /**
         * @stability stable
         */
        get ipAddress(): Route53ResolverEndpointIpAddress[];
        /**
         * @stability stable
         */
        set ipAddress(value: Route53ResolverEndpointIpAddress[]);
        /**
         * @stability stable
         */
        get ipAddressInput(): Route53ResolverEndpointIpAddress[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): Route53ResolverEndpointTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: Route53ResolverEndpointTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): Route53ResolverEndpointTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53ResolverFirewallConfigConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_config.html#firewall_fail_open Route53ResolverFirewallConfig#firewall_fail_open}.
         *
         * @stability stable
         */
        readonly firewallFailOpen?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_config.html#resource_id Route53ResolverFirewallConfig#resource_id}.
         *
         * @stability stable
         */
        readonly resourceId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_config.html aws_route53_resolver_firewall_config}.
     *
     * @stability stable
     */
    class Route53ResolverFirewallConfig extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_config.html aws_route53_resolver_firewall_config} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53ResolverFirewallConfigConfig);
        private _firewallFailOpen?;
        /**
         * @stability stable
         */
        get firewallFailOpen(): string | undefined;
        /**
         * @stability stable
         */
        set firewallFailOpen(value: string | undefined);
        /**
         * @stability stable
         */
        resetFirewallFailOpen(): void;
        /**
         * @stability stable
         */
        get firewallFailOpenInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _resourceId?;
        /**
         * @stability stable
         */
        get resourceId(): string;
        /**
         * @stability stable
         */
        set resourceId(value: string);
        /**
         * @stability stable
         */
        get resourceIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53ResolverFirewallDomainListConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_domain_list.html#domains Route53ResolverFirewallDomainList#domains}.
         *
         * @stability stable
         */
        readonly domains?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_domain_list.html#name Route53ResolverFirewallDomainList#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_domain_list.html#tags Route53ResolverFirewallDomainList#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_domain_list.html#tags_all Route53ResolverFirewallDomainList#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_domain_list.html aws_route53_resolver_firewall_domain_list}.
     *
     * @stability stable
     */
    class Route53ResolverFirewallDomainList extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_domain_list.html aws_route53_resolver_firewall_domain_list} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53ResolverFirewallDomainListConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _domains?;
        /**
         * @stability stable
         */
        get domains(): string[] | undefined;
        /**
         * @stability stable
         */
        set domains(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetDomains(): void;
        /**
         * @stability stable
         */
        get domainsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53ResolverFirewallRuleConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#action Route53ResolverFirewallRule#action}.
         *
         * @stability stable
         */
        readonly action: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#block_override_dns_type Route53ResolverFirewallRule#block_override_dns_type}.
         *
         * @stability stable
         */
        readonly blockOverrideDnsType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#block_override_domain Route53ResolverFirewallRule#block_override_domain}.
         *
         * @stability stable
         */
        readonly blockOverrideDomain?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#block_override_ttl Route53ResolverFirewallRule#block_override_ttl}.
         *
         * @stability stable
         */
        readonly blockOverrideTtl?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#block_response Route53ResolverFirewallRule#block_response}.
         *
         * @stability stable
         */
        readonly blockResponse?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#firewall_domain_list_id Route53ResolverFirewallRule#firewall_domain_list_id}.
         *
         * @stability stable
         */
        readonly firewallDomainListId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#firewall_rule_group_id Route53ResolverFirewallRule#firewall_rule_group_id}.
         *
         * @stability stable
         */
        readonly firewallRuleGroupId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#name Route53ResolverFirewallRule#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html#priority Route53ResolverFirewallRule#priority}.
         *
         * @stability stable
         */
        readonly priority: number;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html aws_route53_resolver_firewall_rule}.
     *
     * @stability stable
     */
    class Route53ResolverFirewallRule extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule.html aws_route53_resolver_firewall_rule} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53ResolverFirewallRuleConfig);
        private _action?;
        /**
         * @stability stable
         */
        get action(): string;
        /**
         * @stability stable
         */
        set action(value: string);
        /**
         * @stability stable
         */
        get actionInput(): string | undefined;
        private _blockOverrideDnsType?;
        /**
         * @stability stable
         */
        get blockOverrideDnsType(): string | undefined;
        /**
         * @stability stable
         */
        set blockOverrideDnsType(value: string | undefined);
        /**
         * @stability stable
         */
        resetBlockOverrideDnsType(): void;
        /**
         * @stability stable
         */
        get blockOverrideDnsTypeInput(): string | undefined;
        private _blockOverrideDomain?;
        /**
         * @stability stable
         */
        get blockOverrideDomain(): string | undefined;
        /**
         * @stability stable
         */
        set blockOverrideDomain(value: string | undefined);
        /**
         * @stability stable
         */
        resetBlockOverrideDomain(): void;
        /**
         * @stability stable
         */
        get blockOverrideDomainInput(): string | undefined;
        private _blockOverrideTtl?;
        /**
         * @stability stable
         */
        get blockOverrideTtl(): number | undefined;
        /**
         * @stability stable
         */
        set blockOverrideTtl(value: number | undefined);
        /**
         * @stability stable
         */
        resetBlockOverrideTtl(): void;
        /**
         * @stability stable
         */
        get blockOverrideTtlInput(): number | undefined;
        private _blockResponse?;
        /**
         * @stability stable
         */
        get blockResponse(): string | undefined;
        /**
         * @stability stable
         */
        set blockResponse(value: string | undefined);
        /**
         * @stability stable
         */
        resetBlockResponse(): void;
        /**
         * @stability stable
         */
        get blockResponseInput(): string | undefined;
        private _firewallDomainListId?;
        /**
         * @stability stable
         */
        get firewallDomainListId(): string;
        /**
         * @stability stable
         */
        set firewallDomainListId(value: string);
        /**
         * @stability stable
         */
        get firewallDomainListIdInput(): string | undefined;
        private _firewallRuleGroupId?;
        /**
         * @stability stable
         */
        get firewallRuleGroupId(): string;
        /**
         * @stability stable
         */
        set firewallRuleGroupId(value: string);
        /**
         * @stability stable
         */
        get firewallRuleGroupIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _priority?;
        /**
         * @stability stable
         */
        get priority(): number;
        /**
         * @stability stable
         */
        set priority(value: number);
        /**
         * @stability stable
         */
        get priorityInput(): number | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53ResolverFirewallRuleGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule_group.html#name Route53ResolverFirewallRuleGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule_group.html#tags Route53ResolverFirewallRuleGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule_group.html#tags_all Route53ResolverFirewallRuleGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule_group.html aws_route53_resolver_firewall_rule_group}.
     *
     * @stability stable
     */
    class Route53ResolverFirewallRuleGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule_group.html aws_route53_resolver_firewall_rule_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53ResolverFirewallRuleGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get ownerId(): string;
        /**
         * @stability stable
         */
        get shareStatus(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53ResolverFirewallRuleGroupAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule_group_association.html#firewall_rule_group_id Route53ResolverFirewallRuleGroupAssociation#firewall_rule_group_id}.
         *
         * @stability stable
         */
        readonly firewallRuleGroupId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule_group_association.html#mutation_protection Route53ResolverFirewallRuleGroupAssociation#mutation_protection}.
         *
         * @stability stable
         */
        readonly mutationProtection?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule_group_association.html#name Route53ResolverFirewallRuleGroupAssociation#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule_group_association.html#priority Route53ResolverFirewallRuleGroupAssociation#priority}.
         *
         * @stability stable
         */
        readonly priority: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule_group_association.html#tags Route53ResolverFirewallRuleGroupAssociation#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule_group_association.html#tags_all Route53ResolverFirewallRuleGroupAssociation#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule_group_association.html#vpc_id Route53ResolverFirewallRuleGroupAssociation#vpc_id}.
         *
         * @stability stable
         */
        readonly vpcId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule_group_association.html aws_route53_resolver_firewall_rule_group_association}.
     *
     * @stability stable
     */
    class Route53ResolverFirewallRuleGroupAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_firewall_rule_group_association.html aws_route53_resolver_firewall_rule_group_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53ResolverFirewallRuleGroupAssociationConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _firewallRuleGroupId?;
        /**
         * @stability stable
         */
        get firewallRuleGroupId(): string;
        /**
         * @stability stable
         */
        set firewallRuleGroupId(value: string);
        /**
         * @stability stable
         */
        get firewallRuleGroupIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _mutationProtection?;
        /**
         * @stability stable
         */
        get mutationProtection(): string | undefined;
        /**
         * @stability stable
         */
        set mutationProtection(value: string | undefined);
        /**
         * @stability stable
         */
        resetMutationProtection(): void;
        /**
         * @stability stable
         */
        get mutationProtectionInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _priority?;
        /**
         * @stability stable
         */
        get priority(): number;
        /**
         * @stability stable
         */
        set priority(value: number);
        /**
         * @stability stable
         */
        get priorityInput(): number | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _vpcId?;
        /**
         * @stability stable
         */
        get vpcId(): string;
        /**
         * @stability stable
         */
        set vpcId(value: string);
        /**
         * @stability stable
         */
        get vpcIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53ResolverQueryLogConfigConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_query_log_config.html#destination_arn Route53ResolverQueryLogConfig#destination_arn}.
         *
         * @stability stable
         */
        readonly destinationArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_query_log_config.html#name Route53ResolverQueryLogConfig#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_query_log_config.html#tags Route53ResolverQueryLogConfig#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_query_log_config.html#tags_all Route53ResolverQueryLogConfig#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_query_log_config.html aws_route53_resolver_query_log_config}.
     *
     * @stability stable
     */
    class Route53ResolverQueryLogConfig extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_query_log_config.html aws_route53_resolver_query_log_config} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53ResolverQueryLogConfigConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _destinationArn?;
        /**
         * @stability stable
         */
        get destinationArn(): string;
        /**
         * @stability stable
         */
        set destinationArn(value: string);
        /**
         * @stability stable
         */
        get destinationArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get ownerId(): string;
        /**
         * @stability stable
         */
        get shareStatus(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53ResolverQueryLogConfigAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_query_log_config_association.html#resolver_query_log_config_id Route53ResolverQueryLogConfigAssociation#resolver_query_log_config_id}.
         *
         * @stability stable
         */
        readonly resolverQueryLogConfigId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_query_log_config_association.html#resource_id Route53ResolverQueryLogConfigAssociation#resource_id}.
         *
         * @stability stable
         */
        readonly resourceId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_query_log_config_association.html aws_route53_resolver_query_log_config_association}.
     *
     * @stability stable
     */
    class Route53ResolverQueryLogConfigAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_query_log_config_association.html aws_route53_resolver_query_log_config_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53ResolverQueryLogConfigAssociationConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _resolverQueryLogConfigId?;
        /**
         * @stability stable
         */
        get resolverQueryLogConfigId(): string;
        /**
         * @stability stable
         */
        set resolverQueryLogConfigId(value: string);
        /**
         * @stability stable
         */
        get resolverQueryLogConfigIdInput(): string | undefined;
        private _resourceId?;
        /**
         * @stability stable
         */
        get resourceId(): string;
        /**
         * @stability stable
         */
        set resourceId(value: string);
        /**
         * @stability stable
         */
        get resourceIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53ResolverRuleConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule.html#domain_name Route53ResolverRule#domain_name}.
         *
         * @stability stable
         */
        readonly domainName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule.html#name Route53ResolverRule#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule.html#resolver_endpoint_id Route53ResolverRule#resolver_endpoint_id}.
         *
         * @stability stable
         */
        readonly resolverEndpointId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule.html#rule_type Route53ResolverRule#rule_type}.
         *
         * @stability stable
         */
        readonly ruleType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule.html#tags Route53ResolverRule#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule.html#tags_all Route53ResolverRule#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * target_ip block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule.html#target_ip Route53ResolverRule#target_ip}
         *
         * @stability stable
         */
        readonly targetIp?: Route53ResolverRuleTargetIp[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule.html#timeouts Route53ResolverRule#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: Route53ResolverRuleTimeouts;
    }
    /**
     * @stability stable
     */
    interface Route53ResolverRuleTargetIp {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule.html#ip Route53ResolverRule#ip}.
         *
         * @stability stable
         */
        readonly ip: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule.html#port Route53ResolverRule#port}.
         *
         * @stability stable
         */
        readonly port?: number;
    }
    /**
     * @stability stable
     */
    interface Route53ResolverRuleTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule.html#create Route53ResolverRule#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule.html#delete Route53ResolverRule#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule.html#update Route53ResolverRule#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class Route53ResolverRuleTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule.html aws_route53_resolver_rule}.
     *
     * @stability stable
     */
    class Route53ResolverRule extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule.html aws_route53_resolver_rule} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53ResolverRuleConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _domainName?;
        /**
         * @stability stable
         */
        get domainName(): string;
        /**
         * @stability stable
         */
        set domainName(value: string);
        /**
         * @stability stable
         */
        get domainNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _resolverEndpointId?;
        /**
         * @stability stable
         */
        get resolverEndpointId(): string | undefined;
        /**
         * @stability stable
         */
        set resolverEndpointId(value: string | undefined);
        /**
         * @stability stable
         */
        resetResolverEndpointId(): void;
        /**
         * @stability stable
         */
        get resolverEndpointIdInput(): string | undefined;
        private _ruleType?;
        /**
         * @stability stable
         */
        get ruleType(): string;
        /**
         * @stability stable
         */
        set ruleType(value: string);
        /**
         * @stability stable
         */
        get ruleTypeInput(): string | undefined;
        /**
         * @stability stable
         */
        get shareStatus(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _targetIp?;
        /**
         * @stability stable
         */
        get targetIp(): Route53ResolverRuleTargetIp[] | undefined;
        /**
         * @stability stable
         */
        set targetIp(value: Route53ResolverRuleTargetIp[] | undefined);
        /**
         * @stability stable
         */
        resetTargetIp(): void;
        /**
         * @stability stable
         */
        get targetIpInput(): Route53ResolverRuleTargetIp[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): Route53ResolverRuleTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: Route53ResolverRuleTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): Route53ResolverRuleTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53ResolverRuleAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule_association.html#name Route53ResolverRuleAssociation#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule_association.html#resolver_rule_id Route53ResolverRuleAssociation#resolver_rule_id}.
         *
         * @stability stable
         */
        readonly resolverRuleId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule_association.html#vpc_id Route53ResolverRuleAssociation#vpc_id}.
         *
         * @stability stable
         */
        readonly vpcId: string;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule_association.html#timeouts Route53ResolverRuleAssociation#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: Route53ResolverRuleAssociationTimeouts;
    }
    /**
     * @stability stable
     */
    interface Route53ResolverRuleAssociationTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule_association.html#create Route53ResolverRuleAssociation#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule_association.html#delete Route53ResolverRuleAssociation#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
    }
    /**
     * @stability stable
     */
    class Route53ResolverRuleAssociationTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule_association.html aws_route53_resolver_rule_association}.
     *
     * @stability stable
     */
    class Route53ResolverRuleAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_resolver_rule_association.html aws_route53_resolver_rule_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53ResolverRuleAssociationConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _resolverRuleId?;
        /**
         * @stability stable
         */
        get resolverRuleId(): string;
        /**
         * @stability stable
         */
        set resolverRuleId(value: string);
        /**
         * @stability stable
         */
        get resolverRuleIdInput(): string | undefined;
        private _vpcId?;
        /**
         * @stability stable
         */
        get vpcId(): string;
        /**
         * @stability stable
         */
        set vpcId(value: string);
        /**
         * @stability stable
         */
        get vpcIdInput(): string | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): Route53ResolverRuleAssociationTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: Route53ResolverRuleAssociationTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): Route53ResolverRuleAssociationTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53VpcAssociationAuthorizationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_vpc_association_authorization.html#vpc_id Route53VpcAssociationAuthorization#vpc_id}.
         *
         * @stability stable
         */
        readonly vpcId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_vpc_association_authorization.html#vpc_region Route53VpcAssociationAuthorization#vpc_region}.
         *
         * @stability stable
         */
        readonly vpcRegion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_vpc_association_authorization.html#zone_id Route53VpcAssociationAuthorization#zone_id}.
         *
         * @stability stable
         */
        readonly zoneId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_vpc_association_authorization.html aws_route53_vpc_association_authorization}.
     *
     * @stability stable
     */
    class Route53VpcAssociationAuthorization extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_vpc_association_authorization.html aws_route53_vpc_association_authorization} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53VpcAssociationAuthorizationConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _vpcId?;
        /**
         * @stability stable
         */
        get vpcId(): string;
        /**
         * @stability stable
         */
        set vpcId(value: string);
        /**
         * @stability stable
         */
        get vpcIdInput(): string | undefined;
        private _vpcRegion?;
        /**
         * @stability stable
         */
        get vpcRegion(): string | undefined;
        /**
         * @stability stable
         */
        set vpcRegion(value: string | undefined);
        /**
         * @stability stable
         */
        resetVpcRegion(): void;
        /**
         * @stability stable
         */
        get vpcRegionInput(): string | undefined;
        private _zoneId?;
        /**
         * @stability stable
         */
        get zoneId(): string;
        /**
         * @stability stable
         */
        set zoneId(value: string);
        /**
         * @stability stable
         */
        get zoneIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53ZoneConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_zone.html#comment Route53Zone#comment}.
         *
         * @stability stable
         */
        readonly comment?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_zone.html#delegation_set_id Route53Zone#delegation_set_id}.
         *
         * @stability stable
         */
        readonly delegationSetId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_zone.html#force_destroy Route53Zone#force_destroy}.
         *
         * @stability stable
         */
        readonly forceDestroy?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_zone.html#name Route53Zone#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_zone.html#tags Route53Zone#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_zone.html#tags_all Route53Zone#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * vpc block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_zone.html#vpc Route53Zone#vpc}
         *
         * @stability stable
         */
        readonly vpc?: Route53ZoneVpc[];
    }
    /**
     * @stability stable
     */
    interface Route53ZoneVpc {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_zone.html#vpc_id Route53Zone#vpc_id}.
         *
         * @stability stable
         */
        readonly vpcId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_zone.html#vpc_region Route53Zone#vpc_region}.
         *
         * @stability stable
         */
        readonly vpcRegion?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_zone.html aws_route53_zone}.
     *
     * @stability stable
     */
    class Route53Zone extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_zone.html aws_route53_zone} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53ZoneConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _comment?;
        /**
         * @stability stable
         */
        get comment(): string | undefined;
        /**
         * @stability stable
         */
        set comment(value: string | undefined);
        /**
         * @stability stable
         */
        resetComment(): void;
        /**
         * @stability stable
         */
        get commentInput(): string | undefined;
        private _delegationSetId?;
        /**
         * @stability stable
         */
        get delegationSetId(): string | undefined;
        /**
         * @stability stable
         */
        set delegationSetId(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelegationSetId(): void;
        /**
         * @stability stable
         */
        get delegationSetIdInput(): string | undefined;
        private _forceDestroy?;
        /**
         * @stability stable
         */
        get forceDestroy(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set forceDestroy(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetForceDestroy(): void;
        /**
         * @stability stable
         */
        get forceDestroyInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get nameServers(): string[];
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get zoneId(): string;
        private _vpc?;
        /**
         * @stability stable
         */
        get vpc(): Route53ZoneVpc[] | undefined;
        /**
         * @stability stable
         */
        set vpc(value: Route53ZoneVpc[] | undefined);
        /**
         * @stability stable
         */
        resetVpc(): void;
        /**
         * @stability stable
         */
        get vpcInput(): Route53ZoneVpc[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53ZoneAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_zone_association.html#vpc_id Route53ZoneAssociation#vpc_id}.
         *
         * @stability stable
         */
        readonly vpcId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_zone_association.html#vpc_region Route53ZoneAssociation#vpc_region}.
         *
         * @stability stable
         */
        readonly vpcRegion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_zone_association.html#zone_id Route53ZoneAssociation#zone_id}.
         *
         * @stability stable
         */
        readonly zoneId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_zone_association.html aws_route53_zone_association}.
     *
     * @stability stable
     */
    class Route53ZoneAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_zone_association.html aws_route53_zone_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53ZoneAssociationConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get owningAccount(): string;
        private _vpcId?;
        /**
         * @stability stable
         */
        get vpcId(): string;
        /**
         * @stability stable
         */
        set vpcId(value: string);
        /**
         * @stability stable
         */
        get vpcIdInput(): string | undefined;
        private _vpcRegion?;
        /**
         * @stability stable
         */
        get vpcRegion(): string | undefined;
        /**
         * @stability stable
         */
        set vpcRegion(value: string | undefined);
        /**
         * @stability stable
         */
        resetVpcRegion(): void;
        /**
         * @stability stable
         */
        get vpcRegionInput(): string | undefined;
        private _zoneId?;
        /**
         * @stability stable
         */
        get zoneId(): string;
        /**
         * @stability stable
         */
        set zoneId(value: string);
        /**
         * @stability stable
         */
        get zoneIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53RecoverycontrolconfigClusterConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_cluster.html#name Route53RecoverycontrolconfigCluster#name}.
         *
         * @stability stable
         */
        readonly name: string;
    }
    /**
     * @stability stable
     */
    class Route53RecoverycontrolconfigClusterClusterEndpoints extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get endpoint(): string;
        /**
         * @stability stable
         */
        get region(): string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_cluster.html aws_route53recoverycontrolconfig_cluster}.
     *
     * @stability stable
     */
    class Route53RecoverycontrolconfigCluster extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_cluster.html aws_route53recoverycontrolconfig_cluster} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53RecoverycontrolconfigClusterConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        clusterEndpoints(index: string): Route53RecoverycontrolconfigClusterClusterEndpoints;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53RecoverycontrolconfigControlPanelConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_control_panel.html#cluster_arn Route53RecoverycontrolconfigControlPanel#cluster_arn}.
         *
         * @stability stable
         */
        readonly clusterArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_control_panel.html#name Route53RecoverycontrolconfigControlPanel#name}.
         *
         * @stability stable
         */
        readonly name: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_control_panel.html aws_route53recoverycontrolconfig_control_panel}.
     *
     * @stability stable
     */
    class Route53RecoverycontrolconfigControlPanel extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_control_panel.html aws_route53recoverycontrolconfig_control_panel} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53RecoverycontrolconfigControlPanelConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _clusterArn?;
        /**
         * @stability stable
         */
        get clusterArn(): string;
        /**
         * @stability stable
         */
        set clusterArn(value: string);
        /**
         * @stability stable
         */
        get clusterArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get defaultControlPanel(): any;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get routingControlCount(): number;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53RecoverycontrolconfigRoutingControlConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_routing_control.html#cluster_arn Route53RecoverycontrolconfigRoutingControl#cluster_arn}.
         *
         * @stability stable
         */
        readonly clusterArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_routing_control.html#control_panel_arn Route53RecoverycontrolconfigRoutingControl#control_panel_arn}.
         *
         * @stability stable
         */
        readonly controlPanelArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_routing_control.html#name Route53RecoverycontrolconfigRoutingControl#name}.
         *
         * @stability stable
         */
        readonly name: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_routing_control.html aws_route53recoverycontrolconfig_routing_control}.
     *
     * @stability stable
     */
    class Route53RecoverycontrolconfigRoutingControl extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_routing_control.html aws_route53recoverycontrolconfig_routing_control} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53RecoverycontrolconfigRoutingControlConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _clusterArn?;
        /**
         * @stability stable
         */
        get clusterArn(): string;
        /**
         * @stability stable
         */
        set clusterArn(value: string);
        /**
         * @stability stable
         */
        get clusterArnInput(): string | undefined;
        private _controlPanelArn?;
        /**
         * @stability stable
         */
        get controlPanelArn(): string | undefined;
        /**
         * @stability stable
         */
        set controlPanelArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetControlPanelArn(): void;
        /**
         * @stability stable
         */
        get controlPanelArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53RecoverycontrolconfigSafetyRuleConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#asserted_controls Route53RecoverycontrolconfigSafetyRule#asserted_controls}.
         *
         * @stability stable
         */
        readonly assertedControls?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#control_panel_arn Route53RecoverycontrolconfigSafetyRule#control_panel_arn}.
         *
         * @stability stable
         */
        readonly controlPanelArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#gating_controls Route53RecoverycontrolconfigSafetyRule#gating_controls}.
         *
         * @stability stable
         */
        readonly gatingControls?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#name Route53RecoverycontrolconfigSafetyRule#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#target_controls Route53RecoverycontrolconfigSafetyRule#target_controls}.
         *
         * @stability stable
         */
        readonly targetControls?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#wait_period_ms Route53RecoverycontrolconfigSafetyRule#wait_period_ms}.
         *
         * @stability stable
         */
        readonly waitPeriodMs: number;
        /**
         * rule_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#rule_config Route53RecoverycontrolconfigSafetyRule#rule_config}
         *
         * @stability stable
         */
        readonly ruleConfig: Route53RecoverycontrolconfigSafetyRuleRuleConfig;
    }
    /**
     * @stability stable
     */
    interface Route53RecoverycontrolconfigSafetyRuleRuleConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#inverted Route53RecoverycontrolconfigSafetyRule#inverted}.
         *
         * @stability stable
         */
        readonly inverted: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#threshold Route53RecoverycontrolconfigSafetyRule#threshold}.
         *
         * @stability stable
         */
        readonly threshold: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html#type Route53RecoverycontrolconfigSafetyRule#type}.
         *
         * @stability stable
         */
        readonly type: string;
    }
    /**
     * @stability stable
     */
    class Route53RecoverycontrolconfigSafetyRuleRuleConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _inverted?;
        /**
         * @stability stable
         */
        get inverted(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set inverted(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get invertedInput(): boolean | cdktf.IResolvable | undefined;
        private _threshold?;
        /**
         * @stability stable
         */
        get threshold(): number;
        /**
         * @stability stable
         */
        set threshold(value: number);
        /**
         * @stability stable
         */
        get thresholdInput(): number | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html aws_route53recoverycontrolconfig_safety_rule}.
     *
     * @stability stable
     */
    class Route53RecoverycontrolconfigSafetyRule extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule.html aws_route53recoverycontrolconfig_safety_rule} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53RecoverycontrolconfigSafetyRuleConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _assertedControls?;
        /**
         * @stability stable
         */
        get assertedControls(): string[] | undefined;
        /**
         * @stability stable
         */
        set assertedControls(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetAssertedControls(): void;
        /**
         * @stability stable
         */
        get assertedControlsInput(): string[] | undefined;
        private _controlPanelArn?;
        /**
         * @stability stable
         */
        get controlPanelArn(): string;
        /**
         * @stability stable
         */
        set controlPanelArn(value: string);
        /**
         * @stability stable
         */
        get controlPanelArnInput(): string | undefined;
        private _gatingControls?;
        /**
         * @stability stable
         */
        get gatingControls(): string[] | undefined;
        /**
         * @stability stable
         */
        set gatingControls(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetGatingControls(): void;
        /**
         * @stability stable
         */
        get gatingControlsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        private _targetControls?;
        /**
         * @stability stable
         */
        get targetControls(): string[] | undefined;
        /**
         * @stability stable
         */
        set targetControls(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetTargetControls(): void;
        /**
         * @stability stable
         */
        get targetControlsInput(): string[] | undefined;
        private _waitPeriodMs?;
        /**
         * @stability stable
         */
        get waitPeriodMs(): number;
        /**
         * @stability stable
         */
        set waitPeriodMs(value: number);
        /**
         * @stability stable
         */
        get waitPeriodMsInput(): number | undefined;
        private _ruleConfig?;
        private __ruleConfigOutput;
        /**
         * @stability stable
         */
        get ruleConfig(): Route53RecoverycontrolconfigSafetyRuleRuleConfigOutputReference;
        /**
         * @stability stable
         */
        putRuleConfig(value: Route53RecoverycontrolconfigSafetyRuleRuleConfig): void;
        /**
         * @stability stable
         */
        get ruleConfigInput(): Route53RecoverycontrolconfigSafetyRuleRuleConfig | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53RecoveryreadinessCellConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_cell.html#cell_name Route53RecoveryreadinessCell#cell_name}.
         *
         * @stability stable
         */
        readonly cellName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_cell.html#cells Route53RecoveryreadinessCell#cells}.
         *
         * @stability stable
         */
        readonly cells?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_cell.html#tags Route53RecoveryreadinessCell#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_cell.html#tags_all Route53RecoveryreadinessCell#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_cell.html#timeouts Route53RecoveryreadinessCell#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: Route53RecoveryreadinessCellTimeouts;
    }
    /**
     * @stability stable
     */
    interface Route53RecoveryreadinessCellTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_cell.html#delete Route53RecoveryreadinessCell#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
    }
    /**
     * @stability stable
     */
    class Route53RecoveryreadinessCellTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_cell.html aws_route53recoveryreadiness_cell}.
     *
     * @stability stable
     */
    class Route53RecoveryreadinessCell extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_cell.html aws_route53recoveryreadiness_cell} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53RecoveryreadinessCellConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _cellName?;
        /**
         * @stability stable
         */
        get cellName(): string;
        /**
         * @stability stable
         */
        set cellName(value: string);
        /**
         * @stability stable
         */
        get cellNameInput(): string | undefined;
        private _cells?;
        /**
         * @stability stable
         */
        get cells(): string[] | undefined;
        /**
         * @stability stable
         */
        set cells(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCells(): void;
        /**
         * @stability stable
         */
        get cellsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get parentReadinessScopes(): string[];
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): Route53RecoveryreadinessCellTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: Route53RecoveryreadinessCellTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): Route53RecoveryreadinessCellTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53RecoveryreadinessReadinessCheckConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_readiness_check.html#readiness_check_name Route53RecoveryreadinessReadinessCheck#readiness_check_name}.
         *
         * @stability stable
         */
        readonly readinessCheckName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_readiness_check.html#resource_set_name Route53RecoveryreadinessReadinessCheck#resource_set_name}.
         *
         * @stability stable
         */
        readonly resourceSetName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_readiness_check.html#tags Route53RecoveryreadinessReadinessCheck#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_readiness_check.html#tags_all Route53RecoveryreadinessReadinessCheck#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_readiness_check.html#timeouts Route53RecoveryreadinessReadinessCheck#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: Route53RecoveryreadinessReadinessCheckTimeouts;
    }
    /**
     * @stability stable
     */
    interface Route53RecoveryreadinessReadinessCheckTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_readiness_check.html#delete Route53RecoveryreadinessReadinessCheck#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
    }
    /**
     * @stability stable
     */
    class Route53RecoveryreadinessReadinessCheckTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_readiness_check.html aws_route53recoveryreadiness_readiness_check}.
     *
     * @stability stable
     */
    class Route53RecoveryreadinessReadinessCheck extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_readiness_check.html aws_route53recoveryreadiness_readiness_check} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53RecoveryreadinessReadinessCheckConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _readinessCheckName?;
        /**
         * @stability stable
         */
        get readinessCheckName(): string;
        /**
         * @stability stable
         */
        set readinessCheckName(value: string);
        /**
         * @stability stable
         */
        get readinessCheckNameInput(): string | undefined;
        private _resourceSetName?;
        /**
         * @stability stable
         */
        get resourceSetName(): string;
        /**
         * @stability stable
         */
        set resourceSetName(value: string);
        /**
         * @stability stable
         */
        get resourceSetNameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): Route53RecoveryreadinessReadinessCheckTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: Route53RecoveryreadinessReadinessCheckTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): Route53RecoveryreadinessReadinessCheckTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53RecoveryreadinessRecoveryGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_recovery_group.html#cells Route53RecoveryreadinessRecoveryGroup#cells}.
         *
         * @stability stable
         */
        readonly cells?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_recovery_group.html#recovery_group_name Route53RecoveryreadinessRecoveryGroup#recovery_group_name}.
         *
         * @stability stable
         */
        readonly recoveryGroupName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_recovery_group.html#tags Route53RecoveryreadinessRecoveryGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_recovery_group.html#tags_all Route53RecoveryreadinessRecoveryGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_recovery_group.html#timeouts Route53RecoveryreadinessRecoveryGroup#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: Route53RecoveryreadinessRecoveryGroupTimeouts;
    }
    /**
     * @stability stable
     */
    interface Route53RecoveryreadinessRecoveryGroupTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_recovery_group.html#delete Route53RecoveryreadinessRecoveryGroup#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
    }
    /**
     * @stability stable
     */
    class Route53RecoveryreadinessRecoveryGroupTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_recovery_group.html aws_route53recoveryreadiness_recovery_group}.
     *
     * @stability stable
     */
    class Route53RecoveryreadinessRecoveryGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_recovery_group.html aws_route53recoveryreadiness_recovery_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53RecoveryreadinessRecoveryGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _cells?;
        /**
         * @stability stable
         */
        get cells(): string[] | undefined;
        /**
         * @stability stable
         */
        set cells(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCells(): void;
        /**
         * @stability stable
         */
        get cellsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _recoveryGroupName?;
        /**
         * @stability stable
         */
        get recoveryGroupName(): string;
        /**
         * @stability stable
         */
        set recoveryGroupName(value: string);
        /**
         * @stability stable
         */
        get recoveryGroupNameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): Route53RecoveryreadinessRecoveryGroupTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: Route53RecoveryreadinessRecoveryGroupTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): Route53RecoveryreadinessRecoveryGroupTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Route53RecoveryreadinessResourceSetConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#resource_set_name Route53RecoveryreadinessResourceSet#resource_set_name}.
         *
         * @stability stable
         */
        readonly resourceSetName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#resource_set_type Route53RecoveryreadinessResourceSet#resource_set_type}.
         *
         * @stability stable
         */
        readonly resourceSetType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#tags Route53RecoveryreadinessResourceSet#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#tags_all Route53RecoveryreadinessResourceSet#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * resources block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#resources Route53RecoveryreadinessResourceSet#resources}
         *
         * @stability stable
         */
        readonly resources: Route53RecoveryreadinessResourceSetResources[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#timeouts Route53RecoveryreadinessResourceSet#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: Route53RecoveryreadinessResourceSetTimeouts;
    }
    /**
     * @stability stable
     */
    interface Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResource {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#arn Route53RecoveryreadinessResourceSet#arn}.
         *
         * @stability stable
         */
        readonly arn?: string;
    }
    /**
     * @stability stable
     */
    class Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResourceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _arn?;
        /**
         * @stability stable
         */
        get arn(): string | undefined;
        /**
         * @stability stable
         */
        set arn(value: string | undefined);
        /**
         * @stability stable
         */
        resetArn(): void;
        /**
         * @stability stable
         */
        get arnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53Resource {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#domain_name Route53RecoveryreadinessResourceSet#domain_name}.
         *
         * @stability stable
         */
        readonly domainName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#record_set_id Route53RecoveryreadinessResourceSet#record_set_id}.
         *
         * @stability stable
         */
        readonly recordSetId?: string;
    }
    /**
     * @stability stable
     */
    class Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53ResourceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _domainName?;
        /**
         * @stability stable
         */
        get domainName(): string | undefined;
        /**
         * @stability stable
         */
        set domainName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDomainName(): void;
        /**
         * @stability stable
         */
        get domainNameInput(): string | undefined;
        private _recordSetId?;
        /**
         * @stability stable
         */
        get recordSetId(): string | undefined;
        /**
         * @stability stable
         */
        set recordSetId(value: string | undefined);
        /**
         * @stability stable
         */
        resetRecordSetId(): void;
        /**
         * @stability stable
         */
        get recordSetIdInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResource {
        /**
         * nlb_resource block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#nlb_resource Route53RecoveryreadinessResourceSet#nlb_resource}
         *
         * @stability stable
         */
        readonly nlbResource?: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResource;
        /**
         * r53_resource block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#r53_resource Route53RecoveryreadinessResourceSet#r53_resource}
         *
         * @stability stable
         */
        readonly r53Resource?: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53Resource;
    }
    /**
     * @stability stable
     */
    class Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _nlbResource?;
        private __nlbResourceOutput;
        /**
         * @stability stable
         */
        get nlbResource(): Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResourceOutputReference;
        /**
         * @stability stable
         */
        putNlbResource(value: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResource | undefined): void;
        /**
         * @stability stable
         */
        resetNlbResource(): void;
        /**
         * @stability stable
         */
        get nlbResourceInput(): Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResource | undefined;
        private _r53Resource?;
        private __r53ResourceOutput;
        /**
         * @stability stable
         */
        get r53Resource(): Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53ResourceOutputReference;
        /**
         * @stability stable
         */
        putR53Resource(value: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53Resource | undefined): void;
        /**
         * @stability stable
         */
        resetR53Resource(): void;
        /**
         * @stability stable
         */
        get r53ResourceInput(): Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53Resource | undefined;
    }
    /**
     * @stability stable
     */
    interface Route53RecoveryreadinessResourceSetResourcesDnsTargetResource {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#domain_name Route53RecoveryreadinessResourceSet#domain_name}.
         *
         * @stability stable
         */
        readonly domainName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#hosted_zone_arn Route53RecoveryreadinessResourceSet#hosted_zone_arn}.
         *
         * @stability stable
         */
        readonly hostedZoneArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#record_set_id Route53RecoveryreadinessResourceSet#record_set_id}.
         *
         * @stability stable
         */
        readonly recordSetId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#record_type Route53RecoveryreadinessResourceSet#record_type}.
         *
         * @stability stable
         */
        readonly recordType?: string;
        /**
         * target_resource block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#target_resource Route53RecoveryreadinessResourceSet#target_resource}
         *
         * @stability stable
         */
        readonly targetResource?: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResource;
    }
    /**
     * @stability stable
     */
    class Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _domainName?;
        /**
         * @stability stable
         */
        get domainName(): string;
        /**
         * @stability stable
         */
        set domainName(value: string);
        /**
         * @stability stable
         */
        get domainNameInput(): string | undefined;
        private _hostedZoneArn?;
        /**
         * @stability stable
         */
        get hostedZoneArn(): string | undefined;
        /**
         * @stability stable
         */
        set hostedZoneArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetHostedZoneArn(): void;
        /**
         * @stability stable
         */
        get hostedZoneArnInput(): string | undefined;
        private _recordSetId?;
        /**
         * @stability stable
         */
        get recordSetId(): string | undefined;
        /**
         * @stability stable
         */
        set recordSetId(value: string | undefined);
        /**
         * @stability stable
         */
        resetRecordSetId(): void;
        /**
         * @stability stable
         */
        get recordSetIdInput(): string | undefined;
        private _recordType?;
        /**
         * @stability stable
         */
        get recordType(): string | undefined;
        /**
         * @stability stable
         */
        set recordType(value: string | undefined);
        /**
         * @stability stable
         */
        resetRecordType(): void;
        /**
         * @stability stable
         */
        get recordTypeInput(): string | undefined;
        private _targetResource?;
        private __targetResourceOutput;
        /**
         * @stability stable
         */
        get targetResource(): Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceOutputReference;
        /**
         * @stability stable
         */
        putTargetResource(value: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResource | undefined): void;
        /**
         * @stability stable
         */
        resetTargetResource(): void;
        /**
         * @stability stable
         */
        get targetResourceInput(): Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResource | undefined;
    }
    /**
     * @stability stable
     */
    interface Route53RecoveryreadinessResourceSetResources {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#readiness_scopes Route53RecoveryreadinessResourceSet#readiness_scopes}.
         *
         * @stability stable
         */
        readonly readinessScopes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#resource_arn Route53RecoveryreadinessResourceSet#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn?: string;
        /**
         * dns_target_resource block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#dns_target_resource Route53RecoveryreadinessResourceSet#dns_target_resource}
         *
         * @stability stable
         */
        readonly dnsTargetResource?: Route53RecoveryreadinessResourceSetResourcesDnsTargetResource;
    }
    /**
     * @stability stable
     */
    interface Route53RecoveryreadinessResourceSetTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html#delete Route53RecoveryreadinessResourceSet#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
    }
    /**
     * @stability stable
     */
    class Route53RecoveryreadinessResourceSetTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html aws_route53recoveryreadiness_resource_set}.
     *
     * @stability stable
     */
    class Route53RecoveryreadinessResourceSet extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set.html aws_route53recoveryreadiness_resource_set} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Route53RecoveryreadinessResourceSetConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _resourceSetName?;
        /**
         * @stability stable
         */
        get resourceSetName(): string;
        /**
         * @stability stable
         */
        set resourceSetName(value: string);
        /**
         * @stability stable
         */
        get resourceSetNameInput(): string | undefined;
        private _resourceSetType?;
        /**
         * @stability stable
         */
        get resourceSetType(): string;
        /**
         * @stability stable
         */
        set resourceSetType(value: string);
        /**
         * @stability stable
         */
        get resourceSetTypeInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _resources?;
        /**
         * @stability stable
         */
        get resources(): Route53RecoveryreadinessResourceSetResources[];
        /**
         * @stability stable
         */
        set resources(value: Route53RecoveryreadinessResourceSetResources[]);
        /**
         * @stability stable
         */
        get resourcesInput(): Route53RecoveryreadinessResourceSetResources[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): Route53RecoveryreadinessResourceSetTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: Route53RecoveryreadinessResourceSetTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): Route53RecoveryreadinessResourceSetTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsRoute53DelegationSetConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_delegation_set.html#id DataAwsRoute53DelegationSet#id}.
         *
         * @stability stable
         */
        readonly id: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/route53_delegation_set.html aws_route53_delegation_set}.
     *
     * @stability stable
     */
    class DataAwsRoute53DelegationSet extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/route53_delegation_set.html aws_route53_delegation_set} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsRoute53DelegationSetConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get callerReference(): string;
        private _id?;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        set id(value: string);
        /**
         * @stability stable
         */
        get idInput(): string | undefined;
        /**
         * @stability stable
         */
        get nameServers(): string[];
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsRoute53ResolverEndpointConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_endpoint.html#resolver_endpoint_id DataAwsRoute53ResolverEndpoint#resolver_endpoint_id}.
         *
         * @stability stable
         */
        readonly resolverEndpointId?: string;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_endpoint.html#filter DataAwsRoute53ResolverEndpoint#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsRoute53ResolverEndpointFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsRoute53ResolverEndpointFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_endpoint.html#name DataAwsRoute53ResolverEndpoint#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_endpoint.html#values DataAwsRoute53ResolverEndpoint#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_endpoint.html aws_route53_resolver_endpoint}.
     *
     * @stability stable
     */
    class DataAwsRoute53ResolverEndpoint extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_endpoint.html aws_route53_resolver_endpoint} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsRoute53ResolverEndpointConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get direction(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ipAddresses(): string[];
        /**
         * @stability stable
         */
        get name(): string;
        private _resolverEndpointId?;
        /**
         * @stability stable
         */
        get resolverEndpointId(): string | undefined;
        /**
         * @stability stable
         */
        set resolverEndpointId(value: string | undefined);
        /**
         * @stability stable
         */
        resetResolverEndpointId(): void;
        /**
         * @stability stable
         */
        get resolverEndpointIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        get vpcId(): string;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsRoute53ResolverEndpointFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsRoute53ResolverEndpointFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsRoute53ResolverEndpointFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsRoute53ResolverRuleConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_rule.html#domain_name DataAwsRoute53ResolverRule#domain_name}.
         *
         * @stability stable
         */
        readonly domainName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_rule.html#name DataAwsRoute53ResolverRule#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_rule.html#resolver_endpoint_id DataAwsRoute53ResolverRule#resolver_endpoint_id}.
         *
         * @stability stable
         */
        readonly resolverEndpointId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_rule.html#resolver_rule_id DataAwsRoute53ResolverRule#resolver_rule_id}.
         *
         * @stability stable
         */
        readonly resolverRuleId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_rule.html#rule_type DataAwsRoute53ResolverRule#rule_type}.
         *
         * @stability stable
         */
        readonly ruleType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_rule.html#tags DataAwsRoute53ResolverRule#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_rule.html aws_route53_resolver_rule}.
     *
     * @stability stable
     */
    class DataAwsRoute53ResolverRule extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_rule.html aws_route53_resolver_rule} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsRoute53ResolverRuleConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _domainName?;
        /**
         * @stability stable
         */
        get domainName(): string | undefined;
        /**
         * @stability stable
         */
        set domainName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDomainName(): void;
        /**
         * @stability stable
         */
        get domainNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _resolverEndpointId?;
        /**
         * @stability stable
         */
        get resolverEndpointId(): string | undefined;
        /**
         * @stability stable
         */
        set resolverEndpointId(value: string | undefined);
        /**
         * @stability stable
         */
        resetResolverEndpointId(): void;
        /**
         * @stability stable
         */
        get resolverEndpointIdInput(): string | undefined;
        private _resolverRuleId?;
        /**
         * @stability stable
         */
        get resolverRuleId(): string | undefined;
        /**
         * @stability stable
         */
        set resolverRuleId(value: string | undefined);
        /**
         * @stability stable
         */
        resetResolverRuleId(): void;
        /**
         * @stability stable
         */
        get resolverRuleIdInput(): string | undefined;
        private _ruleType?;
        /**
         * @stability stable
         */
        get ruleType(): string | undefined;
        /**
         * @stability stable
         */
        set ruleType(value: string | undefined);
        /**
         * @stability stable
         */
        resetRuleType(): void;
        /**
         * @stability stable
         */
        get ruleTypeInput(): string | undefined;
        /**
         * @stability stable
         */
        get shareStatus(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsRoute53ResolverRulesConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_rules.html#owner_id DataAwsRoute53ResolverRules#owner_id}.
         *
         * @stability stable
         */
        readonly ownerId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_rules.html#resolver_endpoint_id DataAwsRoute53ResolverRules#resolver_endpoint_id}.
         *
         * @stability stable
         */
        readonly resolverEndpointId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_rules.html#rule_type DataAwsRoute53ResolverRules#rule_type}.
         *
         * @stability stable
         */
        readonly ruleType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_rules.html#share_status DataAwsRoute53ResolverRules#share_status}.
         *
         * @stability stable
         */
        readonly shareStatus?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_rules.html aws_route53_resolver_rules}.
     *
     * @stability stable
     */
    class DataAwsRoute53ResolverRules extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/route53_resolver_rules.html aws_route53_resolver_rules} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsRoute53ResolverRulesConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _ownerId?;
        /**
         * @stability stable
         */
        get ownerId(): string | undefined;
        /**
         * @stability stable
         */
        set ownerId(value: string | undefined);
        /**
         * @stability stable
         */
        resetOwnerId(): void;
        /**
         * @stability stable
         */
        get ownerIdInput(): string | undefined;
        private _resolverEndpointId?;
        /**
         * @stability stable
         */
        get resolverEndpointId(): string | undefined;
        /**
         * @stability stable
         */
        set resolverEndpointId(value: string | undefined);
        /**
         * @stability stable
         */
        resetResolverEndpointId(): void;
        /**
         * @stability stable
         */
        get resolverEndpointIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get resolverRuleIds(): string[];
        private _ruleType?;
        /**
         * @stability stable
         */
        get ruleType(): string | undefined;
        /**
         * @stability stable
         */
        set ruleType(value: string | undefined);
        /**
         * @stability stable
         */
        resetRuleType(): void;
        /**
         * @stability stable
         */
        get ruleTypeInput(): string | undefined;
        private _shareStatus?;
        /**
         * @stability stable
         */
        get shareStatus(): string | undefined;
        /**
         * @stability stable
         */
        set shareStatus(value: string | undefined);
        /**
         * @stability stable
         */
        resetShareStatus(): void;
        /**
         * @stability stable
         */
        get shareStatusInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsRoute53ZoneConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_zone.html#name DataAwsRoute53Zone#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_zone.html#private_zone DataAwsRoute53Zone#private_zone}.
         *
         * @stability stable
         */
        readonly privateZone?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_zone.html#resource_record_set_count DataAwsRoute53Zone#resource_record_set_count}.
         *
         * @stability stable
         */
        readonly resourceRecordSetCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_zone.html#tags DataAwsRoute53Zone#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_zone.html#vpc_id DataAwsRoute53Zone#vpc_id}.
         *
         * @stability stable
         */
        readonly vpcId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/route53_zone.html#zone_id DataAwsRoute53Zone#zone_id}.
         *
         * @stability stable
         */
        readonly zoneId?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/route53_zone.html aws_route53_zone}.
     *
     * @stability stable
     */
    class DataAwsRoute53Zone extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/route53_zone.html aws_route53_zone} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsRoute53ZoneConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get callerReference(): string;
        /**
         * @stability stable
         */
        get comment(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get linkedServiceDescription(): string;
        /**
         * @stability stable
         */
        get linkedServicePrincipal(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get nameServers(): string[];
        private _privateZone?;
        /**
         * @stability stable
         */
        get privateZone(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set privateZone(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetPrivateZone(): void;
        /**
         * @stability stable
         */
        get privateZoneInput(): boolean | cdktf.IResolvable | undefined;
        private _resourceRecordSetCount?;
        /**
         * @stability stable
         */
        get resourceRecordSetCount(): number | undefined;
        /**
         * @stability stable
         */
        set resourceRecordSetCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetResourceRecordSetCount(): void;
        /**
         * @stability stable
         */
        get resourceRecordSetCountInput(): number | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _vpcId?;
        /**
         * @stability stable
         */
        get vpcId(): string | undefined;
        /**
         * @stability stable
         */
        set vpcId(value: string | undefined);
        /**
         * @stability stable
         */
        resetVpcId(): void;
        /**
         * @stability stable
         */
        get vpcIdInput(): string | undefined;
        private _zoneId?;
        /**
         * @stability stable
         */
        get zoneId(): string | undefined;
        /**
         * @stability stable
         */
        set zoneId(value: string | undefined);
        /**
         * @stability stable
         */
        resetZoneId(): void;
        /**
         * @stability stable
         */
        get zoneIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
