import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Simple Notification Service
*/
export declare namespace SNS {
    /**
     * @stability stable
     */
    interface SnsPlatformApplicationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#event_delivery_failure_topic_arn SnsPlatformApplication#event_delivery_failure_topic_arn}.
         *
         * @stability stable
         */
        readonly eventDeliveryFailureTopicArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#event_endpoint_created_topic_arn SnsPlatformApplication#event_endpoint_created_topic_arn}.
         *
         * @stability stable
         */
        readonly eventEndpointCreatedTopicArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#event_endpoint_deleted_topic_arn SnsPlatformApplication#event_endpoint_deleted_topic_arn}.
         *
         * @stability stable
         */
        readonly eventEndpointDeletedTopicArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#event_endpoint_updated_topic_arn SnsPlatformApplication#event_endpoint_updated_topic_arn}.
         *
         * @stability stable
         */
        readonly eventEndpointUpdatedTopicArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#failure_feedback_role_arn SnsPlatformApplication#failure_feedback_role_arn}.
         *
         * @stability stable
         */
        readonly failureFeedbackRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#name SnsPlatformApplication#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#platform SnsPlatformApplication#platform}.
         *
         * @stability stable
         */
        readonly platform: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#platform_credential SnsPlatformApplication#platform_credential}.
         *
         * @stability stable
         */
        readonly platformCredential: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#platform_principal SnsPlatformApplication#platform_principal}.
         *
         * @stability stable
         */
        readonly platformPrincipal?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#success_feedback_role_arn SnsPlatformApplication#success_feedback_role_arn}.
         *
         * @stability stable
         */
        readonly successFeedbackRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#success_feedback_sample_rate SnsPlatformApplication#success_feedback_sample_rate}.
         *
         * @stability stable
         */
        readonly successFeedbackSampleRate?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html aws_sns_platform_application}.
     *
     * @stability stable
     */
    class SnsPlatformApplication extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html aws_sns_platform_application} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: SnsPlatformApplicationConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _eventDeliveryFailureTopicArn?;
        /**
         * @stability stable
         */
        get eventDeliveryFailureTopicArn(): string | undefined;
        /**
         * @stability stable
         */
        set eventDeliveryFailureTopicArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetEventDeliveryFailureTopicArn(): void;
        /**
         * @stability stable
         */
        get eventDeliveryFailureTopicArnInput(): string | undefined;
        private _eventEndpointCreatedTopicArn?;
        /**
         * @stability stable
         */
        get eventEndpointCreatedTopicArn(): string | undefined;
        /**
         * @stability stable
         */
        set eventEndpointCreatedTopicArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetEventEndpointCreatedTopicArn(): void;
        /**
         * @stability stable
         */
        get eventEndpointCreatedTopicArnInput(): string | undefined;
        private _eventEndpointDeletedTopicArn?;
        /**
         * @stability stable
         */
        get eventEndpointDeletedTopicArn(): string | undefined;
        /**
         * @stability stable
         */
        set eventEndpointDeletedTopicArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetEventEndpointDeletedTopicArn(): void;
        /**
         * @stability stable
         */
        get eventEndpointDeletedTopicArnInput(): string | undefined;
        private _eventEndpointUpdatedTopicArn?;
        /**
         * @stability stable
         */
        get eventEndpointUpdatedTopicArn(): string | undefined;
        /**
         * @stability stable
         */
        set eventEndpointUpdatedTopicArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetEventEndpointUpdatedTopicArn(): void;
        /**
         * @stability stable
         */
        get eventEndpointUpdatedTopicArnInput(): string | undefined;
        private _failureFeedbackRoleArn?;
        /**
         * @stability stable
         */
        get failureFeedbackRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set failureFeedbackRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetFailureFeedbackRoleArn(): void;
        /**
         * @stability stable
         */
        get failureFeedbackRoleArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _platform?;
        /**
         * @stability stable
         */
        get platform(): string;
        /**
         * @stability stable
         */
        set platform(value: string);
        /**
         * @stability stable
         */
        get platformInput(): string | undefined;
        private _platformCredential?;
        /**
         * @stability stable
         */
        get platformCredential(): string;
        /**
         * @stability stable
         */
        set platformCredential(value: string);
        /**
         * @stability stable
         */
        get platformCredentialInput(): string | undefined;
        private _platformPrincipal?;
        /**
         * @stability stable
         */
        get platformPrincipal(): string | undefined;
        /**
         * @stability stable
         */
        set platformPrincipal(value: string | undefined);
        /**
         * @stability stable
         */
        resetPlatformPrincipal(): void;
        /**
         * @stability stable
         */
        get platformPrincipalInput(): string | undefined;
        private _successFeedbackRoleArn?;
        /**
         * @stability stable
         */
        get successFeedbackRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set successFeedbackRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetSuccessFeedbackRoleArn(): void;
        /**
         * @stability stable
         */
        get successFeedbackRoleArnInput(): string | undefined;
        private _successFeedbackSampleRate?;
        /**
         * @stability stable
         */
        get successFeedbackSampleRate(): string | undefined;
        /**
         * @stability stable
         */
        set successFeedbackSampleRate(value: string | undefined);
        /**
         * @stability stable
         */
        resetSuccessFeedbackSampleRate(): void;
        /**
         * @stability stable
         */
        get successFeedbackSampleRateInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface SnsSmsPreferencesConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_sms_preferences.html#default_sender_id SnsSmsPreferences#default_sender_id}.
         *
         * @stability stable
         */
        readonly defaultSenderId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_sms_preferences.html#default_sms_type SnsSmsPreferences#default_sms_type}.
         *
         * @stability stable
         */
        readonly defaultSmsType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_sms_preferences.html#delivery_status_iam_role_arn SnsSmsPreferences#delivery_status_iam_role_arn}.
         *
         * @stability stable
         */
        readonly deliveryStatusIamRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_sms_preferences.html#delivery_status_success_sampling_rate SnsSmsPreferences#delivery_status_success_sampling_rate}.
         *
         * @stability stable
         */
        readonly deliveryStatusSuccessSamplingRate?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_sms_preferences.html#monthly_spend_limit SnsSmsPreferences#monthly_spend_limit}.
         *
         * @stability stable
         */
        readonly monthlySpendLimit?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_sms_preferences.html#usage_report_s3_bucket SnsSmsPreferences#usage_report_s3_bucket}.
         *
         * @stability stable
         */
        readonly usageReportS3Bucket?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sns_sms_preferences.html aws_sns_sms_preferences}.
     *
     * @stability stable
     */
    class SnsSmsPreferences extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sns_sms_preferences.html aws_sns_sms_preferences} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: SnsSmsPreferencesConfig);
        private _defaultSenderId?;
        /**
         * @stability stable
         */
        get defaultSenderId(): string | undefined;
        /**
         * @stability stable
         */
        set defaultSenderId(value: string | undefined);
        /**
         * @stability stable
         */
        resetDefaultSenderId(): void;
        /**
         * @stability stable
         */
        get defaultSenderIdInput(): string | undefined;
        private _defaultSmsType?;
        /**
         * @stability stable
         */
        get defaultSmsType(): string | undefined;
        /**
         * @stability stable
         */
        set defaultSmsType(value: string | undefined);
        /**
         * @stability stable
         */
        resetDefaultSmsType(): void;
        /**
         * @stability stable
         */
        get defaultSmsTypeInput(): string | undefined;
        private _deliveryStatusIamRoleArn?;
        /**
         * @stability stable
         */
        get deliveryStatusIamRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set deliveryStatusIamRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetDeliveryStatusIamRoleArn(): void;
        /**
         * @stability stable
         */
        get deliveryStatusIamRoleArnInput(): string | undefined;
        private _deliveryStatusSuccessSamplingRate?;
        /**
         * @stability stable
         */
        get deliveryStatusSuccessSamplingRate(): string | undefined;
        /**
         * @stability stable
         */
        set deliveryStatusSuccessSamplingRate(value: string | undefined);
        /**
         * @stability stable
         */
        resetDeliveryStatusSuccessSamplingRate(): void;
        /**
         * @stability stable
         */
        get deliveryStatusSuccessSamplingRateInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _monthlySpendLimit?;
        /**
         * @stability stable
         */
        get monthlySpendLimit(): string | undefined;
        /**
         * @stability stable
         */
        set monthlySpendLimit(value: string | undefined);
        /**
         * @stability stable
         */
        resetMonthlySpendLimit(): void;
        /**
         * @stability stable
         */
        get monthlySpendLimitInput(): string | undefined;
        private _usageReportS3Bucket?;
        /**
         * @stability stable
         */
        get usageReportS3Bucket(): string | undefined;
        /**
         * @stability stable
         */
        set usageReportS3Bucket(value: string | undefined);
        /**
         * @stability stable
         */
        resetUsageReportS3Bucket(): void;
        /**
         * @stability stable
         */
        get usageReportS3BucketInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface SnsTopicConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#application_failure_feedback_role_arn SnsTopic#application_failure_feedback_role_arn}.
         *
         * @stability stable
         */
        readonly applicationFailureFeedbackRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#application_success_feedback_role_arn SnsTopic#application_success_feedback_role_arn}.
         *
         * @stability stable
         */
        readonly applicationSuccessFeedbackRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#application_success_feedback_sample_rate SnsTopic#application_success_feedback_sample_rate}.
         *
         * @stability stable
         */
        readonly applicationSuccessFeedbackSampleRate?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#content_based_deduplication SnsTopic#content_based_deduplication}.
         *
         * @stability stable
         */
        readonly contentBasedDeduplication?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#delivery_policy SnsTopic#delivery_policy}.
         *
         * @stability stable
         */
        readonly deliveryPolicy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#display_name SnsTopic#display_name}.
         *
         * @stability stable
         */
        readonly displayName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#fifo_topic SnsTopic#fifo_topic}.
         *
         * @stability stable
         */
        readonly fifoTopic?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#firehose_failure_feedback_role_arn SnsTopic#firehose_failure_feedback_role_arn}.
         *
         * @stability stable
         */
        readonly firehoseFailureFeedbackRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#firehose_success_feedback_role_arn SnsTopic#firehose_success_feedback_role_arn}.
         *
         * @stability stable
         */
        readonly firehoseSuccessFeedbackRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#firehose_success_feedback_sample_rate SnsTopic#firehose_success_feedback_sample_rate}.
         *
         * @stability stable
         */
        readonly firehoseSuccessFeedbackSampleRate?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#http_failure_feedback_role_arn SnsTopic#http_failure_feedback_role_arn}.
         *
         * @stability stable
         */
        readonly httpFailureFeedbackRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#http_success_feedback_role_arn SnsTopic#http_success_feedback_role_arn}.
         *
         * @stability stable
         */
        readonly httpSuccessFeedbackRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#http_success_feedback_sample_rate SnsTopic#http_success_feedback_sample_rate}.
         *
         * @stability stable
         */
        readonly httpSuccessFeedbackSampleRate?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#kms_master_key_id SnsTopic#kms_master_key_id}.
         *
         * @stability stable
         */
        readonly kmsMasterKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#lambda_failure_feedback_role_arn SnsTopic#lambda_failure_feedback_role_arn}.
         *
         * @stability stable
         */
        readonly lambdaFailureFeedbackRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#lambda_success_feedback_role_arn SnsTopic#lambda_success_feedback_role_arn}.
         *
         * @stability stable
         */
        readonly lambdaSuccessFeedbackRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#lambda_success_feedback_sample_rate SnsTopic#lambda_success_feedback_sample_rate}.
         *
         * @stability stable
         */
        readonly lambdaSuccessFeedbackSampleRate?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#name SnsTopic#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#name_prefix SnsTopic#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#policy SnsTopic#policy}.
         *
         * @stability stable
         */
        readonly policy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#sqs_failure_feedback_role_arn SnsTopic#sqs_failure_feedback_role_arn}.
         *
         * @stability stable
         */
        readonly sqsFailureFeedbackRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#sqs_success_feedback_role_arn SnsTopic#sqs_success_feedback_role_arn}.
         *
         * @stability stable
         */
        readonly sqsSuccessFeedbackRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#sqs_success_feedback_sample_rate SnsTopic#sqs_success_feedback_sample_rate}.
         *
         * @stability stable
         */
        readonly sqsSuccessFeedbackSampleRate?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#tags SnsTopic#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html#tags_all SnsTopic#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html aws_sns_topic}.
     *
     * @stability stable
     */
    class SnsTopic extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sns_topic.html aws_sns_topic} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: SnsTopicConfig);
        private _applicationFailureFeedbackRoleArn?;
        /**
         * @stability stable
         */
        get applicationFailureFeedbackRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set applicationFailureFeedbackRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetApplicationFailureFeedbackRoleArn(): void;
        /**
         * @stability stable
         */
        get applicationFailureFeedbackRoleArnInput(): string | undefined;
        private _applicationSuccessFeedbackRoleArn?;
        /**
         * @stability stable
         */
        get applicationSuccessFeedbackRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set applicationSuccessFeedbackRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetApplicationSuccessFeedbackRoleArn(): void;
        /**
         * @stability stable
         */
        get applicationSuccessFeedbackRoleArnInput(): string | undefined;
        private _applicationSuccessFeedbackSampleRate?;
        /**
         * @stability stable
         */
        get applicationSuccessFeedbackSampleRate(): number | undefined;
        /**
         * @stability stable
         */
        set applicationSuccessFeedbackSampleRate(value: number | undefined);
        /**
         * @stability stable
         */
        resetApplicationSuccessFeedbackSampleRate(): void;
        /**
         * @stability stable
         */
        get applicationSuccessFeedbackSampleRateInput(): number | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _contentBasedDeduplication?;
        /**
         * @stability stable
         */
        get contentBasedDeduplication(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set contentBasedDeduplication(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetContentBasedDeduplication(): void;
        /**
         * @stability stable
         */
        get contentBasedDeduplicationInput(): boolean | cdktf.IResolvable | undefined;
        private _deliveryPolicy?;
        /**
         * @stability stable
         */
        get deliveryPolicy(): string | undefined;
        /**
         * @stability stable
         */
        set deliveryPolicy(value: string | undefined);
        /**
         * @stability stable
         */
        resetDeliveryPolicy(): void;
        /**
         * @stability stable
         */
        get deliveryPolicyInput(): string | undefined;
        private _displayName?;
        /**
         * @stability stable
         */
        get displayName(): string | undefined;
        /**
         * @stability stable
         */
        set displayName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDisplayName(): void;
        /**
         * @stability stable
         */
        get displayNameInput(): string | undefined;
        private _fifoTopic?;
        /**
         * @stability stable
         */
        get fifoTopic(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set fifoTopic(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetFifoTopic(): void;
        /**
         * @stability stable
         */
        get fifoTopicInput(): boolean | cdktf.IResolvable | undefined;
        private _firehoseFailureFeedbackRoleArn?;
        /**
         * @stability stable
         */
        get firehoseFailureFeedbackRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set firehoseFailureFeedbackRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetFirehoseFailureFeedbackRoleArn(): void;
        /**
         * @stability stable
         */
        get firehoseFailureFeedbackRoleArnInput(): string | undefined;
        private _firehoseSuccessFeedbackRoleArn?;
        /**
         * @stability stable
         */
        get firehoseSuccessFeedbackRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set firehoseSuccessFeedbackRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetFirehoseSuccessFeedbackRoleArn(): void;
        /**
         * @stability stable
         */
        get firehoseSuccessFeedbackRoleArnInput(): string | undefined;
        private _firehoseSuccessFeedbackSampleRate?;
        /**
         * @stability stable
         */
        get firehoseSuccessFeedbackSampleRate(): number | undefined;
        /**
         * @stability stable
         */
        set firehoseSuccessFeedbackSampleRate(value: number | undefined);
        /**
         * @stability stable
         */
        resetFirehoseSuccessFeedbackSampleRate(): void;
        /**
         * @stability stable
         */
        get firehoseSuccessFeedbackSampleRateInput(): number | undefined;
        private _httpFailureFeedbackRoleArn?;
        /**
         * @stability stable
         */
        get httpFailureFeedbackRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set httpFailureFeedbackRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetHttpFailureFeedbackRoleArn(): void;
        /**
         * @stability stable
         */
        get httpFailureFeedbackRoleArnInput(): string | undefined;
        private _httpSuccessFeedbackRoleArn?;
        /**
         * @stability stable
         */
        get httpSuccessFeedbackRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set httpSuccessFeedbackRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetHttpSuccessFeedbackRoleArn(): void;
        /**
         * @stability stable
         */
        get httpSuccessFeedbackRoleArnInput(): string | undefined;
        private _httpSuccessFeedbackSampleRate?;
        /**
         * @stability stable
         */
        get httpSuccessFeedbackSampleRate(): number | undefined;
        /**
         * @stability stable
         */
        set httpSuccessFeedbackSampleRate(value: number | undefined);
        /**
         * @stability stable
         */
        resetHttpSuccessFeedbackSampleRate(): void;
        /**
         * @stability stable
         */
        get httpSuccessFeedbackSampleRateInput(): number | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _kmsMasterKeyId?;
        /**
         * @stability stable
         */
        get kmsMasterKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsMasterKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsMasterKeyId(): void;
        /**
         * @stability stable
         */
        get kmsMasterKeyIdInput(): string | undefined;
        private _lambdaFailureFeedbackRoleArn?;
        /**
         * @stability stable
         */
        get lambdaFailureFeedbackRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set lambdaFailureFeedbackRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetLambdaFailureFeedbackRoleArn(): void;
        /**
         * @stability stable
         */
        get lambdaFailureFeedbackRoleArnInput(): string | undefined;
        private _lambdaSuccessFeedbackRoleArn?;
        /**
         * @stability stable
         */
        get lambdaSuccessFeedbackRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set lambdaSuccessFeedbackRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetLambdaSuccessFeedbackRoleArn(): void;
        /**
         * @stability stable
         */
        get lambdaSuccessFeedbackRoleArnInput(): string | undefined;
        private _lambdaSuccessFeedbackSampleRate?;
        /**
         * @stability stable
         */
        get lambdaSuccessFeedbackSampleRate(): number | undefined;
        /**
         * @stability stable
         */
        set lambdaSuccessFeedbackSampleRate(value: number | undefined);
        /**
         * @stability stable
         */
        resetLambdaSuccessFeedbackSampleRate(): void;
        /**
         * @stability stable
         */
        get lambdaSuccessFeedbackSampleRateInput(): number | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set namePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamePrefix(): void;
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        /**
         * @stability stable
         */
        get owner(): string;
        private _policy?;
        /**
         * @stability stable
         */
        get policy(): string | undefined;
        /**
         * @stability stable
         */
        set policy(value: string | undefined);
        /**
         * @stability stable
         */
        resetPolicy(): void;
        /**
         * @stability stable
         */
        get policyInput(): string | undefined;
        private _sqsFailureFeedbackRoleArn?;
        /**
         * @stability stable
         */
        get sqsFailureFeedbackRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set sqsFailureFeedbackRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetSqsFailureFeedbackRoleArn(): void;
        /**
         * @stability stable
         */
        get sqsFailureFeedbackRoleArnInput(): string | undefined;
        private _sqsSuccessFeedbackRoleArn?;
        /**
         * @stability stable
         */
        get sqsSuccessFeedbackRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set sqsSuccessFeedbackRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetSqsSuccessFeedbackRoleArn(): void;
        /**
         * @stability stable
         */
        get sqsSuccessFeedbackRoleArnInput(): string | undefined;
        private _sqsSuccessFeedbackSampleRate?;
        /**
         * @stability stable
         */
        get sqsSuccessFeedbackSampleRate(): number | undefined;
        /**
         * @stability stable
         */
        set sqsSuccessFeedbackSampleRate(value: number | undefined);
        /**
         * @stability stable
         */
        resetSqsSuccessFeedbackSampleRate(): void;
        /**
         * @stability stable
         */
        get sqsSuccessFeedbackSampleRateInput(): number | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface SnsTopicPolicyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_policy.html#arn SnsTopicPolicy#arn}.
         *
         * @stability stable
         */
        readonly arn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_policy.html#policy SnsTopicPolicy#policy}.
         *
         * @stability stable
         */
        readonly policy: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_policy.html aws_sns_topic_policy}.
     *
     * @stability stable
     */
    class SnsTopicPolicy extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_policy.html aws_sns_topic_policy} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: SnsTopicPolicyConfig);
        private _arn?;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        set arn(value: string);
        /**
         * @stability stable
         */
        get arnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get owner(): string;
        private _policy?;
        /**
         * @stability stable
         */
        get policy(): string;
        /**
         * @stability stable
         */
        set policy(value: string);
        /**
         * @stability stable
         */
        get policyInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface SnsTopicSubscriptionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#confirmation_timeout_in_minutes SnsTopicSubscription#confirmation_timeout_in_minutes}.
         *
         * @stability stable
         */
        readonly confirmationTimeoutInMinutes?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#delivery_policy SnsTopicSubscription#delivery_policy}.
         *
         * @stability stable
         */
        readonly deliveryPolicy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#endpoint SnsTopicSubscription#endpoint}.
         *
         * @stability stable
         */
        readonly endpoint: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#endpoint_auto_confirms SnsTopicSubscription#endpoint_auto_confirms}.
         *
         * @stability stable
         */
        readonly endpointAutoConfirms?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#filter_policy SnsTopicSubscription#filter_policy}.
         *
         * @stability stable
         */
        readonly filterPolicy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#protocol SnsTopicSubscription#protocol}.
         *
         * @stability stable
         */
        readonly protocol: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#raw_message_delivery SnsTopicSubscription#raw_message_delivery}.
         *
         * @stability stable
         */
        readonly rawMessageDelivery?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#redrive_policy SnsTopicSubscription#redrive_policy}.
         *
         * @stability stable
         */
        readonly redrivePolicy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#subscription_role_arn SnsTopicSubscription#subscription_role_arn}.
         *
         * @stability stable
         */
        readonly subscriptionRoleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html#topic_arn SnsTopicSubscription#topic_arn}.
         *
         * @stability stable
         */
        readonly topicArn: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html aws_sns_topic_subscription}.
     *
     * @stability stable
     */
    class SnsTopicSubscription extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sns_topic_subscription.html aws_sns_topic_subscription} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: SnsTopicSubscriptionConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _confirmationTimeoutInMinutes?;
        /**
         * @stability stable
         */
        get confirmationTimeoutInMinutes(): number | undefined;
        /**
         * @stability stable
         */
        set confirmationTimeoutInMinutes(value: number | undefined);
        /**
         * @stability stable
         */
        resetConfirmationTimeoutInMinutes(): void;
        /**
         * @stability stable
         */
        get confirmationTimeoutInMinutesInput(): number | undefined;
        /**
         * @stability stable
         */
        get confirmationWasAuthenticated(): any;
        private _deliveryPolicy?;
        /**
         * @stability stable
         */
        get deliveryPolicy(): string | undefined;
        /**
         * @stability stable
         */
        set deliveryPolicy(value: string | undefined);
        /**
         * @stability stable
         */
        resetDeliveryPolicy(): void;
        /**
         * @stability stable
         */
        get deliveryPolicyInput(): string | undefined;
        private _endpoint?;
        /**
         * @stability stable
         */
        get endpoint(): string;
        /**
         * @stability stable
         */
        set endpoint(value: string);
        /**
         * @stability stable
         */
        get endpointInput(): string | undefined;
        private _endpointAutoConfirms?;
        /**
         * @stability stable
         */
        get endpointAutoConfirms(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set endpointAutoConfirms(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEndpointAutoConfirms(): void;
        /**
         * @stability stable
         */
        get endpointAutoConfirmsInput(): boolean | cdktf.IResolvable | undefined;
        private _filterPolicy?;
        /**
         * @stability stable
         */
        get filterPolicy(): string | undefined;
        /**
         * @stability stable
         */
        set filterPolicy(value: string | undefined);
        /**
         * @stability stable
         */
        resetFilterPolicy(): void;
        /**
         * @stability stable
         */
        get filterPolicyInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ownerId(): string;
        /**
         * @stability stable
         */
        get pendingConfirmation(): any;
        private _protocol?;
        /**
         * @stability stable
         */
        get protocol(): string;
        /**
         * @stability stable
         */
        set protocol(value: string);
        /**
         * @stability stable
         */
        get protocolInput(): string | undefined;
        private _rawMessageDelivery?;
        /**
         * @stability stable
         */
        get rawMessageDelivery(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set rawMessageDelivery(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetRawMessageDelivery(): void;
        /**
         * @stability stable
         */
        get rawMessageDeliveryInput(): boolean | cdktf.IResolvable | undefined;
        private _redrivePolicy?;
        /**
         * @stability stable
         */
        get redrivePolicy(): string | undefined;
        /**
         * @stability stable
         */
        set redrivePolicy(value: string | undefined);
        /**
         * @stability stable
         */
        resetRedrivePolicy(): void;
        /**
         * @stability stable
         */
        get redrivePolicyInput(): string | undefined;
        private _subscriptionRoleArn?;
        /**
         * @stability stable
         */
        get subscriptionRoleArn(): string | undefined;
        /**
         * @stability stable
         */
        set subscriptionRoleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetSubscriptionRoleArn(): void;
        /**
         * @stability stable
         */
        get subscriptionRoleArnInput(): string | undefined;
        private _topicArn?;
        /**
         * @stability stable
         */
        get topicArn(): string;
        /**
         * @stability stable
         */
        set topicArn(value: string);
        /**
         * @stability stable
         */
        get topicArnInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsSnsTopicConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/sns_topic.html#name DataAwsSnsTopic#name}.
         *
         * @stability stable
         */
        readonly name: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/sns_topic.html aws_sns_topic}.
     *
     * @stability stable
     */
    class DataAwsSnsTopic extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/sns_topic.html aws_sns_topic} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsSnsTopicConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
