import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS SSO Admin
*/
export declare namespace SSOAdmin {
    /**
     * @stability stable
     */
    interface SsoadminAccountAssignmentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_account_assignment.html#instance_arn SsoadminAccountAssignment#instance_arn}.
         *
         * @stability stable
         */
        readonly instanceArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_account_assignment.html#permission_set_arn SsoadminAccountAssignment#permission_set_arn}.
         *
         * @stability stable
         */
        readonly permissionSetArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_account_assignment.html#principal_id SsoadminAccountAssignment#principal_id}.
         *
         * @stability stable
         */
        readonly principalId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_account_assignment.html#principal_type SsoadminAccountAssignment#principal_type}.
         *
         * @stability stable
         */
        readonly principalType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_account_assignment.html#target_id SsoadminAccountAssignment#target_id}.
         *
         * @stability stable
         */
        readonly targetId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_account_assignment.html#target_type SsoadminAccountAssignment#target_type}.
         *
         * @stability stable
         */
        readonly targetType?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_account_assignment.html aws_ssoadmin_account_assignment}.
     *
     * @stability stable
     */
    class SsoadminAccountAssignment extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_account_assignment.html aws_ssoadmin_account_assignment} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: SsoadminAccountAssignmentConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceArn?;
        /**
         * @stability stable
         */
        get instanceArn(): string;
        /**
         * @stability stable
         */
        set instanceArn(value: string);
        /**
         * @stability stable
         */
        get instanceArnInput(): string | undefined;
        private _permissionSetArn?;
        /**
         * @stability stable
         */
        get permissionSetArn(): string;
        /**
         * @stability stable
         */
        set permissionSetArn(value: string);
        /**
         * @stability stable
         */
        get permissionSetArnInput(): string | undefined;
        private _principalId?;
        /**
         * @stability stable
         */
        get principalId(): string;
        /**
         * @stability stable
         */
        set principalId(value: string);
        /**
         * @stability stable
         */
        get principalIdInput(): string | undefined;
        private _principalType?;
        /**
         * @stability stable
         */
        get principalType(): string;
        /**
         * @stability stable
         */
        set principalType(value: string);
        /**
         * @stability stable
         */
        get principalTypeInput(): string | undefined;
        private _targetId?;
        /**
         * @stability stable
         */
        get targetId(): string;
        /**
         * @stability stable
         */
        set targetId(value: string);
        /**
         * @stability stable
         */
        get targetIdInput(): string | undefined;
        private _targetType?;
        /**
         * @stability stable
         */
        get targetType(): string | undefined;
        /**
         * @stability stable
         */
        set targetType(value: string | undefined);
        /**
         * @stability stable
         */
        resetTargetType(): void;
        /**
         * @stability stable
         */
        get targetTypeInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface SsoadminManagedPolicyAttachmentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_managed_policy_attachment.html#instance_arn SsoadminManagedPolicyAttachment#instance_arn}.
         *
         * @stability stable
         */
        readonly instanceArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_managed_policy_attachment.html#managed_policy_arn SsoadminManagedPolicyAttachment#managed_policy_arn}.
         *
         * @stability stable
         */
        readonly managedPolicyArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_managed_policy_attachment.html#permission_set_arn SsoadminManagedPolicyAttachment#permission_set_arn}.
         *
         * @stability stable
         */
        readonly permissionSetArn: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_managed_policy_attachment.html aws_ssoadmin_managed_policy_attachment}.
     *
     * @stability stable
     */
    class SsoadminManagedPolicyAttachment extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_managed_policy_attachment.html aws_ssoadmin_managed_policy_attachment} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: SsoadminManagedPolicyAttachmentConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceArn?;
        /**
         * @stability stable
         */
        get instanceArn(): string;
        /**
         * @stability stable
         */
        set instanceArn(value: string);
        /**
         * @stability stable
         */
        get instanceArnInput(): string | undefined;
        private _managedPolicyArn?;
        /**
         * @stability stable
         */
        get managedPolicyArn(): string;
        /**
         * @stability stable
         */
        set managedPolicyArn(value: string);
        /**
         * @stability stable
         */
        get managedPolicyArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get managedPolicyName(): string;
        private _permissionSetArn?;
        /**
         * @stability stable
         */
        get permissionSetArn(): string;
        /**
         * @stability stable
         */
        set permissionSetArn(value: string);
        /**
         * @stability stable
         */
        get permissionSetArnInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface SsoadminPermissionSetConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set.html#description SsoadminPermissionSet#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set.html#instance_arn SsoadminPermissionSet#instance_arn}.
         *
         * @stability stable
         */
        readonly instanceArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set.html#name SsoadminPermissionSet#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set.html#relay_state SsoadminPermissionSet#relay_state}.
         *
         * @stability stable
         */
        readonly relayState?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set.html#session_duration SsoadminPermissionSet#session_duration}.
         *
         * @stability stable
         */
        readonly sessionDuration?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set.html#tags SsoadminPermissionSet#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set.html#tags_all SsoadminPermissionSet#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set.html aws_ssoadmin_permission_set}.
     *
     * @stability stable
     */
    class SsoadminPermissionSet extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set.html aws_ssoadmin_permission_set} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: SsoadminPermissionSetConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdDate(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceArn?;
        /**
         * @stability stable
         */
        get instanceArn(): string;
        /**
         * @stability stable
         */
        set instanceArn(value: string);
        /**
         * @stability stable
         */
        get instanceArnInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _relayState?;
        /**
         * @stability stable
         */
        get relayState(): string | undefined;
        /**
         * @stability stable
         */
        set relayState(value: string | undefined);
        /**
         * @stability stable
         */
        resetRelayState(): void;
        /**
         * @stability stable
         */
        get relayStateInput(): string | undefined;
        private _sessionDuration?;
        /**
         * @stability stable
         */
        get sessionDuration(): string | undefined;
        /**
         * @stability stable
         */
        set sessionDuration(value: string | undefined);
        /**
         * @stability stable
         */
        resetSessionDuration(): void;
        /**
         * @stability stable
         */
        get sessionDurationInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface SsoadminPermissionSetInlinePolicyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set_inline_policy.html#inline_policy SsoadminPermissionSetInlinePolicy#inline_policy}.
         *
         * @stability stable
         */
        readonly inlinePolicy: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set_inline_policy.html#instance_arn SsoadminPermissionSetInlinePolicy#instance_arn}.
         *
         * @stability stable
         */
        readonly instanceArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set_inline_policy.html#permission_set_arn SsoadminPermissionSetInlinePolicy#permission_set_arn}.
         *
         * @stability stable
         */
        readonly permissionSetArn: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set_inline_policy.html aws_ssoadmin_permission_set_inline_policy}.
     *
     * @stability stable
     */
    class SsoadminPermissionSetInlinePolicy extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set_inline_policy.html aws_ssoadmin_permission_set_inline_policy} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: SsoadminPermissionSetInlinePolicyConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _inlinePolicy?;
        /**
         * @stability stable
         */
        get inlinePolicy(): string;
        /**
         * @stability stable
         */
        set inlinePolicy(value: string);
        /**
         * @stability stable
         */
        get inlinePolicyInput(): string | undefined;
        private _instanceArn?;
        /**
         * @stability stable
         */
        get instanceArn(): string;
        /**
         * @stability stable
         */
        set instanceArn(value: string);
        /**
         * @stability stable
         */
        get instanceArnInput(): string | undefined;
        private _permissionSetArn?;
        /**
         * @stability stable
         */
        get permissionSetArn(): string;
        /**
         * @stability stable
         */
        set permissionSetArn(value: string);
        /**
         * @stability stable
         */
        get permissionSetArnInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsSsoadminInstancesConfig extends cdktf.TerraformMetaArguments {
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ssoadmin_instances.html aws_ssoadmin_instances}.
     *
     * @stability stable
     */
    class DataAwsSsoadminInstances extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ssoadmin_instances.html aws_ssoadmin_instances} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsSsoadminInstancesConfig);
        /**
         * @stability stable
         */
        get arns(): string[];
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get identityStoreIds(): string[];
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsSsoadminPermissionSetConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ssoadmin_permission_set.html#instance_arn DataAwsSsoadminPermissionSet#instance_arn}.
         *
         * @stability stable
         */
        readonly instanceArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ssoadmin_permission_set.html#name DataAwsSsoadminPermissionSet#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ssoadmin_permission_set.html#tags DataAwsSsoadminPermissionSet#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ssoadmin_permission_set.html aws_ssoadmin_permission_set}.
     *
     * @stability stable
     */
    class DataAwsSsoadminPermissionSet extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ssoadmin_permission_set.html aws_ssoadmin_permission_set} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsSsoadminPermissionSetConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdDate(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceArn?;
        /**
         * @stability stable
         */
        get instanceArn(): string;
        /**
         * @stability stable
         */
        set instanceArn(value: string);
        /**
         * @stability stable
         */
        get instanceArnInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get relayState(): string;
        /**
         * @stability stable
         */
        get sessionDuration(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
