import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Service Catalog
*/
export declare namespace ServiceCatalog {
    /**
     * @stability stable
     */
    interface ServicecatalogBudgetResourceAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_budget_resource_association.html#budget_name ServicecatalogBudgetResourceAssociation#budget_name}.
         *
         * @stability stable
         */
        readonly budgetName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_budget_resource_association.html#resource_id ServicecatalogBudgetResourceAssociation#resource_id}.
         *
         * @stability stable
         */
        readonly resourceId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_budget_resource_association.html aws_servicecatalog_budget_resource_association}.
     *
     * @stability stable
     */
    class ServicecatalogBudgetResourceAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_budget_resource_association.html aws_servicecatalog_budget_resource_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ServicecatalogBudgetResourceAssociationConfig);
        private _budgetName?;
        /**
         * @stability stable
         */
        get budgetName(): string;
        /**
         * @stability stable
         */
        set budgetName(value: string);
        /**
         * @stability stable
         */
        get budgetNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _resourceId?;
        /**
         * @stability stable
         */
        get resourceId(): string;
        /**
         * @stability stable
         */
        set resourceId(value: string);
        /**
         * @stability stable
         */
        get resourceIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ServicecatalogConstraintConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_constraint.html#accept_language ServicecatalogConstraint#accept_language}.
         *
         * @stability stable
         */
        readonly acceptLanguage?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_constraint.html#description ServicecatalogConstraint#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_constraint.html#parameters ServicecatalogConstraint#parameters}.
         *
         * @stability stable
         */
        readonly parameters: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_constraint.html#portfolio_id ServicecatalogConstraint#portfolio_id}.
         *
         * @stability stable
         */
        readonly portfolioId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_constraint.html#product_id ServicecatalogConstraint#product_id}.
         *
         * @stability stable
         */
        readonly productId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_constraint.html#type ServicecatalogConstraint#type}.
         *
         * @stability stable
         */
        readonly type: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_constraint.html aws_servicecatalog_constraint}.
     *
     * @stability stable
     */
    class ServicecatalogConstraint extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_constraint.html aws_servicecatalog_constraint} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ServicecatalogConstraintConfig);
        private _acceptLanguage?;
        /**
         * @stability stable
         */
        get acceptLanguage(): string | undefined;
        /**
         * @stability stable
         */
        set acceptLanguage(value: string | undefined);
        /**
         * @stability stable
         */
        resetAcceptLanguage(): void;
        /**
         * @stability stable
         */
        get acceptLanguageInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get owner(): string;
        private _parameters?;
        /**
         * @stability stable
         */
        get parameters(): string;
        /**
         * @stability stable
         */
        set parameters(value: string);
        /**
         * @stability stable
         */
        get parametersInput(): string | undefined;
        private _portfolioId?;
        /**
         * @stability stable
         */
        get portfolioId(): string;
        /**
         * @stability stable
         */
        set portfolioId(value: string);
        /**
         * @stability stable
         */
        get portfolioIdInput(): string | undefined;
        private _productId?;
        /**
         * @stability stable
         */
        get productId(): string;
        /**
         * @stability stable
         */
        set productId(value: string);
        /**
         * @stability stable
         */
        get productIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ServicecatalogOrganizationsAccessConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_organizations_access.html#enabled ServicecatalogOrganizationsAccess#enabled}.
         *
         * @stability stable
         */
        readonly enabled: boolean | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_organizations_access.html aws_servicecatalog_organizations_access}.
     *
     * @stability stable
     */
    class ServicecatalogOrganizationsAccess extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_organizations_access.html aws_servicecatalog_organizations_access} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ServicecatalogOrganizationsAccessConfig);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ServicecatalogPortfolioConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio.html#description ServicecatalogPortfolio#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio.html#name ServicecatalogPortfolio#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio.html#provider_name ServicecatalogPortfolio#provider_name}.
         *
         * @stability stable
         */
        readonly providerName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio.html#tags ServicecatalogPortfolio#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio.html#tags_all ServicecatalogPortfolio#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio.html#timeouts ServicecatalogPortfolio#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: ServicecatalogPortfolioTimeouts;
    }
    /**
     * @stability stable
     */
    interface ServicecatalogPortfolioTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio.html#create ServicecatalogPortfolio#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio.html#delete ServicecatalogPortfolio#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio.html#update ServicecatalogPortfolio#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class ServicecatalogPortfolioTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio.html aws_servicecatalog_portfolio}.
     *
     * @stability stable
     */
    class ServicecatalogPortfolio extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio.html aws_servicecatalog_portfolio} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ServicecatalogPortfolioConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdTime(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _providerName?;
        /**
         * @stability stable
         */
        get providerName(): string;
        /**
         * @stability stable
         */
        set providerName(value: string);
        /**
         * @stability stable
         */
        get providerNameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): ServicecatalogPortfolioTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: ServicecatalogPortfolioTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): ServicecatalogPortfolioTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ServicecatalogPortfolioShareConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio_share.html#accept_language ServicecatalogPortfolioShare#accept_language}.
         *
         * @stability stable
         */
        readonly acceptLanguage?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio_share.html#portfolio_id ServicecatalogPortfolioShare#portfolio_id}.
         *
         * @stability stable
         */
        readonly portfolioId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio_share.html#principal_id ServicecatalogPortfolioShare#principal_id}.
         *
         * @stability stable
         */
        readonly principalId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio_share.html#share_tag_options ServicecatalogPortfolioShare#share_tag_options}.
         *
         * @stability stable
         */
        readonly shareTagOptions?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio_share.html#type ServicecatalogPortfolioShare#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio_share.html#wait_for_acceptance ServicecatalogPortfolioShare#wait_for_acceptance}.
         *
         * @stability stable
         */
        readonly waitForAcceptance?: boolean | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio_share.html aws_servicecatalog_portfolio_share}.
     *
     * @stability stable
     */
    class ServicecatalogPortfolioShare extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_portfolio_share.html aws_servicecatalog_portfolio_share} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ServicecatalogPortfolioShareConfig);
        private _acceptLanguage?;
        /**
         * @stability stable
         */
        get acceptLanguage(): string | undefined;
        /**
         * @stability stable
         */
        set acceptLanguage(value: string | undefined);
        /**
         * @stability stable
         */
        resetAcceptLanguage(): void;
        /**
         * @stability stable
         */
        get acceptLanguageInput(): string | undefined;
        /**
         * @stability stable
         */
        get accepted(): any;
        /**
         * @stability stable
         */
        get id(): string;
        private _portfolioId?;
        /**
         * @stability stable
         */
        get portfolioId(): string;
        /**
         * @stability stable
         */
        set portfolioId(value: string);
        /**
         * @stability stable
         */
        get portfolioIdInput(): string | undefined;
        private _principalId?;
        /**
         * @stability stable
         */
        get principalId(): string;
        /**
         * @stability stable
         */
        set principalId(value: string);
        /**
         * @stability stable
         */
        get principalIdInput(): string | undefined;
        private _shareTagOptions?;
        /**
         * @stability stable
         */
        get shareTagOptions(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set shareTagOptions(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetShareTagOptions(): void;
        /**
         * @stability stable
         */
        get shareTagOptionsInput(): boolean | cdktf.IResolvable | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _waitForAcceptance?;
        /**
         * @stability stable
         */
        get waitForAcceptance(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set waitForAcceptance(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetWaitForAcceptance(): void;
        /**
         * @stability stable
         */
        get waitForAcceptanceInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ServicecatalogPrincipalPortfolioAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_principal_portfolio_association.html#accept_language ServicecatalogPrincipalPortfolioAssociation#accept_language}.
         *
         * @stability stable
         */
        readonly acceptLanguage?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_principal_portfolio_association.html#portfolio_id ServicecatalogPrincipalPortfolioAssociation#portfolio_id}.
         *
         * @stability stable
         */
        readonly portfolioId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_principal_portfolio_association.html#principal_arn ServicecatalogPrincipalPortfolioAssociation#principal_arn}.
         *
         * @stability stable
         */
        readonly principalArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_principal_portfolio_association.html#principal_type ServicecatalogPrincipalPortfolioAssociation#principal_type}.
         *
         * @stability stable
         */
        readonly principalType?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_principal_portfolio_association.html aws_servicecatalog_principal_portfolio_association}.
     *
     * @stability stable
     */
    class ServicecatalogPrincipalPortfolioAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_principal_portfolio_association.html aws_servicecatalog_principal_portfolio_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ServicecatalogPrincipalPortfolioAssociationConfig);
        private _acceptLanguage?;
        /**
         * @stability stable
         */
        get acceptLanguage(): string | undefined;
        /**
         * @stability stable
         */
        set acceptLanguage(value: string | undefined);
        /**
         * @stability stable
         */
        resetAcceptLanguage(): void;
        /**
         * @stability stable
         */
        get acceptLanguageInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _portfolioId?;
        /**
         * @stability stable
         */
        get portfolioId(): string;
        /**
         * @stability stable
         */
        set portfolioId(value: string);
        /**
         * @stability stable
         */
        get portfolioIdInput(): string | undefined;
        private _principalArn?;
        /**
         * @stability stable
         */
        get principalArn(): string;
        /**
         * @stability stable
         */
        set principalArn(value: string);
        /**
         * @stability stable
         */
        get principalArnInput(): string | undefined;
        private _principalType?;
        /**
         * @stability stable
         */
        get principalType(): string | undefined;
        /**
         * @stability stable
         */
        set principalType(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrincipalType(): void;
        /**
         * @stability stable
         */
        get principalTypeInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ServicecatalogProductConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#accept_language ServicecatalogProduct#accept_language}.
         *
         * @stability stable
         */
        readonly acceptLanguage?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#description ServicecatalogProduct#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#distributor ServicecatalogProduct#distributor}.
         *
         * @stability stable
         */
        readonly distributor?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#name ServicecatalogProduct#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#owner ServicecatalogProduct#owner}.
         *
         * @stability stable
         */
        readonly owner: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#support_description ServicecatalogProduct#support_description}.
         *
         * @stability stable
         */
        readonly supportDescription?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#support_email ServicecatalogProduct#support_email}.
         *
         * @stability stable
         */
        readonly supportEmail?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#support_url ServicecatalogProduct#support_url}.
         *
         * @stability stable
         */
        readonly supportUrl?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#tags ServicecatalogProduct#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#tags_all ServicecatalogProduct#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#type ServicecatalogProduct#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * provisioning_artifact_parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#provisioning_artifact_parameters ServicecatalogProduct#provisioning_artifact_parameters}
         *
         * @stability stable
         */
        readonly provisioningArtifactParameters: ServicecatalogProductProvisioningArtifactParameters;
    }
    /**
     * @stability stable
     */
    interface ServicecatalogProductProvisioningArtifactParameters {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#description ServicecatalogProduct#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#disable_template_validation ServicecatalogProduct#disable_template_validation}.
         *
         * @stability stable
         */
        readonly disableTemplateValidation?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#name ServicecatalogProduct#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#template_physical_id ServicecatalogProduct#template_physical_id}.
         *
         * @stability stable
         */
        readonly templatePhysicalId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#template_url ServicecatalogProduct#template_url}.
         *
         * @stability stable
         */
        readonly templateUrl?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html#type ServicecatalogProduct#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * @stability stable
     */
    class ServicecatalogProductProvisioningArtifactParametersOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _disableTemplateValidation?;
        /**
         * @stability stable
         */
        get disableTemplateValidation(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set disableTemplateValidation(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDisableTemplateValidation(): void;
        /**
         * @stability stable
         */
        get disableTemplateValidationInput(): boolean | cdktf.IResolvable | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _templatePhysicalId?;
        /**
         * @stability stable
         */
        get templatePhysicalId(): string | undefined;
        /**
         * @stability stable
         */
        set templatePhysicalId(value: string | undefined);
        /**
         * @stability stable
         */
        resetTemplatePhysicalId(): void;
        /**
         * @stability stable
         */
        get templatePhysicalIdInput(): string | undefined;
        private _templateUrl?;
        /**
         * @stability stable
         */
        get templateUrl(): string | undefined;
        /**
         * @stability stable
         */
        set templateUrl(value: string | undefined);
        /**
         * @stability stable
         */
        resetTemplateUrl(): void;
        /**
         * @stability stable
         */
        get templateUrlInput(): string | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string | undefined;
        /**
         * @stability stable
         */
        set type(value: string | undefined);
        /**
         * @stability stable
         */
        resetType(): void;
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html aws_servicecatalog_product}.
     *
     * @stability stable
     */
    class ServicecatalogProduct extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product.html aws_servicecatalog_product} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ServicecatalogProductConfig);
        private _acceptLanguage?;
        /**
         * @stability stable
         */
        get acceptLanguage(): string | undefined;
        /**
         * @stability stable
         */
        set acceptLanguage(value: string | undefined);
        /**
         * @stability stable
         */
        resetAcceptLanguage(): void;
        /**
         * @stability stable
         */
        get acceptLanguageInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdTime(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _distributor?;
        /**
         * @stability stable
         */
        get distributor(): string | undefined;
        /**
         * @stability stable
         */
        set distributor(value: string | undefined);
        /**
         * @stability stable
         */
        resetDistributor(): void;
        /**
         * @stability stable
         */
        get distributorInput(): string | undefined;
        /**
         * @stability stable
         */
        get hasDefaultPath(): any;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _owner?;
        /**
         * @stability stable
         */
        get owner(): string;
        /**
         * @stability stable
         */
        set owner(value: string);
        /**
         * @stability stable
         */
        get ownerInput(): string | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        private _supportDescription?;
        /**
         * @stability stable
         */
        get supportDescription(): string | undefined;
        /**
         * @stability stable
         */
        set supportDescription(value: string | undefined);
        /**
         * @stability stable
         */
        resetSupportDescription(): void;
        /**
         * @stability stable
         */
        get supportDescriptionInput(): string | undefined;
        private _supportEmail?;
        /**
         * @stability stable
         */
        get supportEmail(): string | undefined;
        /**
         * @stability stable
         */
        set supportEmail(value: string | undefined);
        /**
         * @stability stable
         */
        resetSupportEmail(): void;
        /**
         * @stability stable
         */
        get supportEmailInput(): string | undefined;
        private _supportUrl?;
        /**
         * @stability stable
         */
        get supportUrl(): string | undefined;
        /**
         * @stability stable
         */
        set supportUrl(value: string | undefined);
        /**
         * @stability stable
         */
        resetSupportUrl(): void;
        /**
         * @stability stable
         */
        get supportUrlInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _provisioningArtifactParameters?;
        private __provisioningArtifactParametersOutput;
        /**
         * @stability stable
         */
        get provisioningArtifactParameters(): ServicecatalogProductProvisioningArtifactParametersOutputReference;
        /**
         * @stability stable
         */
        putProvisioningArtifactParameters(value: ServicecatalogProductProvisioningArtifactParameters): void;
        /**
         * @stability stable
         */
        get provisioningArtifactParametersInput(): ServicecatalogProductProvisioningArtifactParameters | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ServicecatalogProductPortfolioAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product_portfolio_association.html#accept_language ServicecatalogProductPortfolioAssociation#accept_language}.
         *
         * @stability stable
         */
        readonly acceptLanguage?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product_portfolio_association.html#portfolio_id ServicecatalogProductPortfolioAssociation#portfolio_id}.
         *
         * @stability stable
         */
        readonly portfolioId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product_portfolio_association.html#product_id ServicecatalogProductPortfolioAssociation#product_id}.
         *
         * @stability stable
         */
        readonly productId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product_portfolio_association.html#source_portfolio_id ServicecatalogProductPortfolioAssociation#source_portfolio_id}.
         *
         * @stability stable
         */
        readonly sourcePortfolioId?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product_portfolio_association.html aws_servicecatalog_product_portfolio_association}.
     *
     * @stability stable
     */
    class ServicecatalogProductPortfolioAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_product_portfolio_association.html aws_servicecatalog_product_portfolio_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ServicecatalogProductPortfolioAssociationConfig);
        private _acceptLanguage?;
        /**
         * @stability stable
         */
        get acceptLanguage(): string | undefined;
        /**
         * @stability stable
         */
        set acceptLanguage(value: string | undefined);
        /**
         * @stability stable
         */
        resetAcceptLanguage(): void;
        /**
         * @stability stable
         */
        get acceptLanguageInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _portfolioId?;
        /**
         * @stability stable
         */
        get portfolioId(): string;
        /**
         * @stability stable
         */
        set portfolioId(value: string);
        /**
         * @stability stable
         */
        get portfolioIdInput(): string | undefined;
        private _productId?;
        /**
         * @stability stable
         */
        get productId(): string;
        /**
         * @stability stable
         */
        set productId(value: string);
        /**
         * @stability stable
         */
        get productIdInput(): string | undefined;
        private _sourcePortfolioId?;
        /**
         * @stability stable
         */
        get sourcePortfolioId(): string | undefined;
        /**
         * @stability stable
         */
        set sourcePortfolioId(value: string | undefined);
        /**
         * @stability stable
         */
        resetSourcePortfolioId(): void;
        /**
         * @stability stable
         */
        get sourcePortfolioIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ServicecatalogProvisionedProductConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#accept_language ServicecatalogProvisionedProduct#accept_language}.
         *
         * @stability stable
         */
        readonly acceptLanguage?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#ignore_errors ServicecatalogProvisionedProduct#ignore_errors}.
         *
         * @stability stable
         */
        readonly ignoreErrors?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#name ServicecatalogProvisionedProduct#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#notification_arns ServicecatalogProvisionedProduct#notification_arns}.
         *
         * @stability stable
         */
        readonly notificationArns?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#path_id ServicecatalogProvisionedProduct#path_id}.
         *
         * @stability stable
         */
        readonly pathId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#path_name ServicecatalogProvisionedProduct#path_name}.
         *
         * @stability stable
         */
        readonly pathName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#product_id ServicecatalogProvisionedProduct#product_id}.
         *
         * @stability stable
         */
        readonly productId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#product_name ServicecatalogProvisionedProduct#product_name}.
         *
         * @stability stable
         */
        readonly productName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#provisioning_artifact_id ServicecatalogProvisionedProduct#provisioning_artifact_id}.
         *
         * @stability stable
         */
        readonly provisioningArtifactId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#provisioning_artifact_name ServicecatalogProvisionedProduct#provisioning_artifact_name}.
         *
         * @stability stable
         */
        readonly provisioningArtifactName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#retain_physical_resources ServicecatalogProvisionedProduct#retain_physical_resources}.
         *
         * @stability stable
         */
        readonly retainPhysicalResources?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#tags ServicecatalogProvisionedProduct#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#tags_all ServicecatalogProvisionedProduct#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * provisioning_parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#provisioning_parameters ServicecatalogProvisionedProduct#provisioning_parameters}
         *
         * @stability stable
         */
        readonly provisioningParameters?: ServicecatalogProvisionedProductProvisioningParameters[];
        /**
         * stack_set_provisioning_preferences block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#stack_set_provisioning_preferences ServicecatalogProvisionedProduct#stack_set_provisioning_preferences}
         *
         * @stability stable
         */
        readonly stackSetProvisioningPreferences?: ServicecatalogProvisionedProductStackSetProvisioningPreferences;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#timeouts ServicecatalogProvisionedProduct#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: ServicecatalogProvisionedProductTimeouts;
    }
    /**
     * @stability stable
     */
    interface ServicecatalogProvisionedProductProvisioningParameters {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#key ServicecatalogProvisionedProduct#key}.
         *
         * @stability stable
         */
        readonly key: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#use_previous_value ServicecatalogProvisionedProduct#use_previous_value}.
         *
         * @stability stable
         */
        readonly usePreviousValue?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#value ServicecatalogProvisionedProduct#value}.
         *
         * @stability stable
         */
        readonly value?: string;
    }
    /**
     * @stability stable
     */
    interface ServicecatalogProvisionedProductStackSetProvisioningPreferences {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#accounts ServicecatalogProvisionedProduct#accounts}.
         *
         * @stability stable
         */
        readonly accounts?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#failure_tolerance_count ServicecatalogProvisionedProduct#failure_tolerance_count}.
         *
         * @stability stable
         */
        readonly failureToleranceCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#failure_tolerance_percentage ServicecatalogProvisionedProduct#failure_tolerance_percentage}.
         *
         * @stability stable
         */
        readonly failureTolerancePercentage?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#max_concurrency_count ServicecatalogProvisionedProduct#max_concurrency_count}.
         *
         * @stability stable
         */
        readonly maxConcurrencyCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#max_concurrency_percentage ServicecatalogProvisionedProduct#max_concurrency_percentage}.
         *
         * @stability stable
         */
        readonly maxConcurrencyPercentage?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#regions ServicecatalogProvisionedProduct#regions}.
         *
         * @stability stable
         */
        readonly regions?: string[];
    }
    /**
     * @stability stable
     */
    class ServicecatalogProvisionedProductStackSetProvisioningPreferencesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _accounts?;
        /**
         * @stability stable
         */
        get accounts(): string[] | undefined;
        /**
         * @stability stable
         */
        set accounts(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetAccounts(): void;
        /**
         * @stability stable
         */
        get accountsInput(): string[] | undefined;
        private _failureToleranceCount?;
        /**
         * @stability stable
         */
        get failureToleranceCount(): number | undefined;
        /**
         * @stability stable
         */
        set failureToleranceCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetFailureToleranceCount(): void;
        /**
         * @stability stable
         */
        get failureToleranceCountInput(): number | undefined;
        private _failureTolerancePercentage?;
        /**
         * @stability stable
         */
        get failureTolerancePercentage(): number | undefined;
        /**
         * @stability stable
         */
        set failureTolerancePercentage(value: number | undefined);
        /**
         * @stability stable
         */
        resetFailureTolerancePercentage(): void;
        /**
         * @stability stable
         */
        get failureTolerancePercentageInput(): number | undefined;
        private _maxConcurrencyCount?;
        /**
         * @stability stable
         */
        get maxConcurrencyCount(): number | undefined;
        /**
         * @stability stable
         */
        set maxConcurrencyCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaxConcurrencyCount(): void;
        /**
         * @stability stable
         */
        get maxConcurrencyCountInput(): number | undefined;
        private _maxConcurrencyPercentage?;
        /**
         * @stability stable
         */
        get maxConcurrencyPercentage(): number | undefined;
        /**
         * @stability stable
         */
        set maxConcurrencyPercentage(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaxConcurrencyPercentage(): void;
        /**
         * @stability stable
         */
        get maxConcurrencyPercentageInput(): number | undefined;
        private _regions?;
        /**
         * @stability stable
         */
        get regions(): string[] | undefined;
        /**
         * @stability stable
         */
        set regions(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetRegions(): void;
        /**
         * @stability stable
         */
        get regionsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface ServicecatalogProvisionedProductTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#create ServicecatalogProvisionedProduct#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#delete ServicecatalogProvisionedProduct#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html#update ServicecatalogProvisionedProduct#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class ServicecatalogProvisionedProductTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html aws_servicecatalog_provisioned_product}.
     *
     * @stability stable
     */
    class ServicecatalogProvisionedProduct extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product.html aws_servicecatalog_provisioned_product} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ServicecatalogProvisionedProductConfig);
        private _acceptLanguage?;
        /**
         * @stability stable
         */
        get acceptLanguage(): string | undefined;
        /**
         * @stability stable
         */
        set acceptLanguage(value: string | undefined);
        /**
         * @stability stable
         */
        resetAcceptLanguage(): void;
        /**
         * @stability stable
         */
        get acceptLanguageInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get cloudwatchDashboardNames(): string[];
        /**
         * @stability stable
         */
        get createdTime(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _ignoreErrors?;
        /**
         * @stability stable
         */
        get ignoreErrors(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set ignoreErrors(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIgnoreErrors(): void;
        /**
         * @stability stable
         */
        get ignoreErrorsInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get lastProvisioningRecordId(): string;
        /**
         * @stability stable
         */
        get lastRecordId(): string;
        /**
         * @stability stable
         */
        get lastSuccessfulProvisioningRecordId(): string;
        /**
         * @stability stable
         */
        get launchRoleArn(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _notificationArns?;
        /**
         * @stability stable
         */
        get notificationArns(): string[] | undefined;
        /**
         * @stability stable
         */
        set notificationArns(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetNotificationArns(): void;
        /**
         * @stability stable
         */
        get notificationArnsInput(): string[] | undefined;
        private _pathId?;
        /**
         * @stability stable
         */
        get pathId(): string | undefined;
        /**
         * @stability stable
         */
        set pathId(value: string | undefined);
        /**
         * @stability stable
         */
        resetPathId(): void;
        /**
         * @stability stable
         */
        get pathIdInput(): string | undefined;
        private _pathName?;
        /**
         * @stability stable
         */
        get pathName(): string | undefined;
        /**
         * @stability stable
         */
        set pathName(value: string | undefined);
        /**
         * @stability stable
         */
        resetPathName(): void;
        /**
         * @stability stable
         */
        get pathNameInput(): string | undefined;
        private _productId?;
        /**
         * @stability stable
         */
        get productId(): string | undefined;
        /**
         * @stability stable
         */
        set productId(value: string | undefined);
        /**
         * @stability stable
         */
        resetProductId(): void;
        /**
         * @stability stable
         */
        get productIdInput(): string | undefined;
        private _productName?;
        /**
         * @stability stable
         */
        get productName(): string | undefined;
        /**
         * @stability stable
         */
        set productName(value: string | undefined);
        /**
         * @stability stable
         */
        resetProductName(): void;
        /**
         * @stability stable
         */
        get productNameInput(): string | undefined;
        private _provisioningArtifactId?;
        /**
         * @stability stable
         */
        get provisioningArtifactId(): string | undefined;
        /**
         * @stability stable
         */
        set provisioningArtifactId(value: string | undefined);
        /**
         * @stability stable
         */
        resetProvisioningArtifactId(): void;
        /**
         * @stability stable
         */
        get provisioningArtifactIdInput(): string | undefined;
        private _provisioningArtifactName?;
        /**
         * @stability stable
         */
        get provisioningArtifactName(): string | undefined;
        /**
         * @stability stable
         */
        set provisioningArtifactName(value: string | undefined);
        /**
         * @stability stable
         */
        resetProvisioningArtifactName(): void;
        /**
         * @stability stable
         */
        get provisioningArtifactNameInput(): string | undefined;
        private _retainPhysicalResources?;
        /**
         * @stability stable
         */
        get retainPhysicalResources(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set retainPhysicalResources(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetRetainPhysicalResources(): void;
        /**
         * @stability stable
         */
        get retainPhysicalResourcesInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        get statusMessage(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get type(): string;
        private _provisioningParameters?;
        /**
         * @stability stable
         */
        get provisioningParameters(): ServicecatalogProvisionedProductProvisioningParameters[] | undefined;
        /**
         * @stability stable
         */
        set provisioningParameters(value: ServicecatalogProvisionedProductProvisioningParameters[] | undefined);
        /**
         * @stability stable
         */
        resetProvisioningParameters(): void;
        /**
         * @stability stable
         */
        get provisioningParametersInput(): ServicecatalogProvisionedProductProvisioningParameters[] | undefined;
        private _stackSetProvisioningPreferences?;
        private __stackSetProvisioningPreferencesOutput;
        /**
         * @stability stable
         */
        get stackSetProvisioningPreferences(): ServicecatalogProvisionedProductStackSetProvisioningPreferencesOutputReference;
        /**
         * @stability stable
         */
        putStackSetProvisioningPreferences(value: ServicecatalogProvisionedProductStackSetProvisioningPreferences | undefined): void;
        /**
         * @stability stable
         */
        resetStackSetProvisioningPreferences(): void;
        /**
         * @stability stable
         */
        get stackSetProvisioningPreferencesInput(): ServicecatalogProvisionedProductStackSetProvisioningPreferences | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): ServicecatalogProvisionedProductTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: ServicecatalogProvisionedProductTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): ServicecatalogProvisionedProductTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ServicecatalogProvisioningArtifactConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioning_artifact.html#accept_language ServicecatalogProvisioningArtifact#accept_language}.
         *
         * @stability stable
         */
        readonly acceptLanguage?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioning_artifact.html#active ServicecatalogProvisioningArtifact#active}.
         *
         * @stability stable
         */
        readonly active?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioning_artifact.html#description ServicecatalogProvisioningArtifact#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioning_artifact.html#disable_template_validation ServicecatalogProvisioningArtifact#disable_template_validation}.
         *
         * @stability stable
         */
        readonly disableTemplateValidation?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioning_artifact.html#guidance ServicecatalogProvisioningArtifact#guidance}.
         *
         * @stability stable
         */
        readonly guidance?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioning_artifact.html#name ServicecatalogProvisioningArtifact#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioning_artifact.html#product_id ServicecatalogProvisioningArtifact#product_id}.
         *
         * @stability stable
         */
        readonly productId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioning_artifact.html#template_physical_id ServicecatalogProvisioningArtifact#template_physical_id}.
         *
         * @stability stable
         */
        readonly templatePhysicalId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioning_artifact.html#template_url ServicecatalogProvisioningArtifact#template_url}.
         *
         * @stability stable
         */
        readonly templateUrl?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioning_artifact.html#type ServicecatalogProvisioningArtifact#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioning_artifact.html aws_servicecatalog_provisioning_artifact}.
     *
     * @stability stable
     */
    class ServicecatalogProvisioningArtifact extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioning_artifact.html aws_servicecatalog_provisioning_artifact} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ServicecatalogProvisioningArtifactConfig);
        private _acceptLanguage?;
        /**
         * @stability stable
         */
        get acceptLanguage(): string | undefined;
        /**
         * @stability stable
         */
        set acceptLanguage(value: string | undefined);
        /**
         * @stability stable
         */
        resetAcceptLanguage(): void;
        /**
         * @stability stable
         */
        get acceptLanguageInput(): string | undefined;
        private _active?;
        /**
         * @stability stable
         */
        get active(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set active(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetActive(): void;
        /**
         * @stability stable
         */
        get activeInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get createdTime(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _disableTemplateValidation?;
        /**
         * @stability stable
         */
        get disableTemplateValidation(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set disableTemplateValidation(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDisableTemplateValidation(): void;
        /**
         * @stability stable
         */
        get disableTemplateValidationInput(): boolean | cdktf.IResolvable | undefined;
        private _guidance?;
        /**
         * @stability stable
         */
        get guidance(): string | undefined;
        /**
         * @stability stable
         */
        set guidance(value: string | undefined);
        /**
         * @stability stable
         */
        resetGuidance(): void;
        /**
         * @stability stable
         */
        get guidanceInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _productId?;
        /**
         * @stability stable
         */
        get productId(): string;
        /**
         * @stability stable
         */
        set productId(value: string);
        /**
         * @stability stable
         */
        get productIdInput(): string | undefined;
        private _templatePhysicalId?;
        /**
         * @stability stable
         */
        get templatePhysicalId(): string | undefined;
        /**
         * @stability stable
         */
        set templatePhysicalId(value: string | undefined);
        /**
         * @stability stable
         */
        resetTemplatePhysicalId(): void;
        /**
         * @stability stable
         */
        get templatePhysicalIdInput(): string | undefined;
        private _templateUrl?;
        /**
         * @stability stable
         */
        get templateUrl(): string | undefined;
        /**
         * @stability stable
         */
        set templateUrl(value: string | undefined);
        /**
         * @stability stable
         */
        resetTemplateUrl(): void;
        /**
         * @stability stable
         */
        get templateUrlInput(): string | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string | undefined;
        /**
         * @stability stable
         */
        set type(value: string | undefined);
        /**
         * @stability stable
         */
        resetType(): void;
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ServicecatalogServiceActionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_service_action.html#accept_language ServicecatalogServiceAction#accept_language}.
         *
         * @stability stable
         */
        readonly acceptLanguage?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_service_action.html#description ServicecatalogServiceAction#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_service_action.html#name ServicecatalogServiceAction#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * definition block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_service_action.html#definition ServicecatalogServiceAction#definition}
         *
         * @stability stable
         */
        readonly definition: ServicecatalogServiceActionDefinition;
    }
    /**
     * @stability stable
     */
    interface ServicecatalogServiceActionDefinition {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_service_action.html#assume_role ServicecatalogServiceAction#assume_role}.
         *
         * @stability stable
         */
        readonly assumeRole?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_service_action.html#name ServicecatalogServiceAction#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_service_action.html#parameters ServicecatalogServiceAction#parameters}.
         *
         * @stability stable
         */
        readonly parameters?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_service_action.html#type ServicecatalogServiceAction#type}.
         *
         * @stability stable
         */
        readonly type?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_service_action.html#version ServicecatalogServiceAction#version}.
         *
         * @stability stable
         */
        readonly version: string;
    }
    /**
     * @stability stable
     */
    class ServicecatalogServiceActionDefinitionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _assumeRole?;
        /**
         * @stability stable
         */
        get assumeRole(): string | undefined;
        /**
         * @stability stable
         */
        set assumeRole(value: string | undefined);
        /**
         * @stability stable
         */
        resetAssumeRole(): void;
        /**
         * @stability stable
         */
        get assumeRoleInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _parameters?;
        /**
         * @stability stable
         */
        get parameters(): string | undefined;
        /**
         * @stability stable
         */
        set parameters(value: string | undefined);
        /**
         * @stability stable
         */
        resetParameters(): void;
        /**
         * @stability stable
         */
        get parametersInput(): string | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string | undefined;
        /**
         * @stability stable
         */
        set type(value: string | undefined);
        /**
         * @stability stable
         */
        resetType(): void;
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _version?;
        /**
         * @stability stable
         */
        get version(): string;
        /**
         * @stability stable
         */
        set version(value: string);
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_service_action.html aws_servicecatalog_service_action}.
     *
     * @stability stable
     */
    class ServicecatalogServiceAction extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_service_action.html aws_servicecatalog_service_action} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ServicecatalogServiceActionConfig);
        private _acceptLanguage?;
        /**
         * @stability stable
         */
        get acceptLanguage(): string | undefined;
        /**
         * @stability stable
         */
        set acceptLanguage(value: string | undefined);
        /**
         * @stability stable
         */
        resetAcceptLanguage(): void;
        /**
         * @stability stable
         */
        get acceptLanguageInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _definition?;
        private __definitionOutput;
        /**
         * @stability stable
         */
        get definition(): ServicecatalogServiceActionDefinitionOutputReference;
        /**
         * @stability stable
         */
        putDefinition(value: ServicecatalogServiceActionDefinition): void;
        /**
         * @stability stable
         */
        get definitionInput(): ServicecatalogServiceActionDefinition | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ServicecatalogTagOptionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_tag_option.html#active ServicecatalogTagOption#active}.
         *
         * @stability stable
         */
        readonly active?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_tag_option.html#key ServicecatalogTagOption#key}.
         *
         * @stability stable
         */
        readonly key: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_tag_option.html#value ServicecatalogTagOption#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_tag_option.html aws_servicecatalog_tag_option}.
     *
     * @stability stable
     */
    class ServicecatalogTagOption extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_tag_option.html aws_servicecatalog_tag_option} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ServicecatalogTagOptionConfig);
        private _active?;
        /**
         * @stability stable
         */
        get active(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set active(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetActive(): void;
        /**
         * @stability stable
         */
        get activeInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _key?;
        /**
         * @stability stable
         */
        get key(): string;
        /**
         * @stability stable
         */
        set key(value: string);
        /**
         * @stability stable
         */
        get keyInput(): string | undefined;
        /**
         * @stability stable
         */
        get owner(): string;
        private _value?;
        /**
         * @stability stable
         */
        get value(): string;
        /**
         * @stability stable
         */
        set value(value: string);
        /**
         * @stability stable
         */
        get valueInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface ServicecatalogTagOptionResourceAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_tag_option_resource_association.html#resource_id ServicecatalogTagOptionResourceAssociation#resource_id}.
         *
         * @stability stable
         */
        readonly resourceId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_tag_option_resource_association.html#tag_option_id ServicecatalogTagOptionResourceAssociation#tag_option_id}.
         *
         * @stability stable
         */
        readonly tagOptionId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_tag_option_resource_association.html aws_servicecatalog_tag_option_resource_association}.
     *
     * @stability stable
     */
    class ServicecatalogTagOptionResourceAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_tag_option_resource_association.html aws_servicecatalog_tag_option_resource_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ServicecatalogTagOptionResourceAssociationConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get resourceArn(): string;
        /**
         * @stability stable
         */
        get resourceCreatedTime(): string;
        /**
         * @stability stable
         */
        get resourceDescription(): string;
        private _resourceId?;
        /**
         * @stability stable
         */
        get resourceId(): string;
        /**
         * @stability stable
         */
        set resourceId(value: string);
        /**
         * @stability stable
         */
        get resourceIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get resourceName(): string;
        private _tagOptionId?;
        /**
         * @stability stable
         */
        get tagOptionId(): string;
        /**
         * @stability stable
         */
        set tagOptionId(value: string);
        /**
         * @stability stable
         */
        get tagOptionIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsServicecatalogConstraintConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_constraint.html#accept_language DataAwsServicecatalogConstraint#accept_language}.
         *
         * @stability stable
         */
        readonly acceptLanguage?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_constraint.html#description DataAwsServicecatalogConstraint#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_constraint.html#id DataAwsServicecatalogConstraint#id}.
         *
         * @stability stable
         */
        readonly id: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_constraint.html aws_servicecatalog_constraint}.
     *
     * @stability stable
     */
    class DataAwsServicecatalogConstraint extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_constraint.html aws_servicecatalog_constraint} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsServicecatalogConstraintConfig);
        private _acceptLanguage?;
        /**
         * @stability stable
         */
        get acceptLanguage(): string | undefined;
        /**
         * @stability stable
         */
        set acceptLanguage(value: string | undefined);
        /**
         * @stability stable
         */
        resetAcceptLanguage(): void;
        /**
         * @stability stable
         */
        get acceptLanguageInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _id?;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        set id(value: string);
        /**
         * @stability stable
         */
        get idInput(): string | undefined;
        /**
         * @stability stable
         */
        get owner(): string;
        /**
         * @stability stable
         */
        get parameters(): string;
        /**
         * @stability stable
         */
        get portfolioId(): string;
        /**
         * @stability stable
         */
        get productId(): string;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsServicecatalogLaunchPathsConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_launch_paths.html#accept_language DataAwsServicecatalogLaunchPaths#accept_language}.
         *
         * @stability stable
         */
        readonly acceptLanguage?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_launch_paths.html#product_id DataAwsServicecatalogLaunchPaths#product_id}.
         *
         * @stability stable
         */
        readonly productId: string;
    }
    /**
     * @stability stable
     */
    class DataAwsServicecatalogLaunchPathsSummariesConstraintSummaries extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get type(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsServicecatalogLaunchPathsSummaries extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get constraintSummaries(): any;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        get pathId(): string;
        /**
         * @stability stable
         */
        get tags(): any;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_launch_paths.html aws_servicecatalog_launch_paths}.
     *
     * @stability stable
     */
    class DataAwsServicecatalogLaunchPaths extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_launch_paths.html aws_servicecatalog_launch_paths} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsServicecatalogLaunchPathsConfig);
        private _acceptLanguage?;
        /**
         * @stability stable
         */
        get acceptLanguage(): string | undefined;
        /**
         * @stability stable
         */
        set acceptLanguage(value: string | undefined);
        /**
         * @stability stable
         */
        resetAcceptLanguage(): void;
        /**
         * @stability stable
         */
        get acceptLanguageInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _productId?;
        /**
         * @stability stable
         */
        get productId(): string;
        /**
         * @stability stable
         */
        set productId(value: string);
        /**
         * @stability stable
         */
        get productIdInput(): string | undefined;
        /**
         * @stability stable
         */
        summaries(index: string): DataAwsServicecatalogLaunchPathsSummaries;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsServicecatalogPortfolioConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_portfolio.html#accept_language DataAwsServicecatalogPortfolio#accept_language}.
         *
         * @stability stable
         */
        readonly acceptLanguage?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_portfolio.html#id DataAwsServicecatalogPortfolio#id}.
         *
         * @stability stable
         */
        readonly id: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_portfolio.html#tags DataAwsServicecatalogPortfolio#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_portfolio.html aws_servicecatalog_portfolio}.
     *
     * @stability stable
     */
    class DataAwsServicecatalogPortfolio extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_portfolio.html aws_servicecatalog_portfolio} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsServicecatalogPortfolioConfig);
        private _acceptLanguage?;
        /**
         * @stability stable
         */
        get acceptLanguage(): string | undefined;
        /**
         * @stability stable
         */
        set acceptLanguage(value: string | undefined);
        /**
         * @stability stable
         */
        resetAcceptLanguage(): void;
        /**
         * @stability stable
         */
        get acceptLanguageInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdTime(): string;
        /**
         * @stability stable
         */
        get description(): string;
        private _id?;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        set id(value: string);
        /**
         * @stability stable
         */
        get idInput(): string | undefined;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        get providerName(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsServicecatalogPortfolioConstraintsConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_portfolio_constraints.html#accept_language DataAwsServicecatalogPortfolioConstraints#accept_language}.
         *
         * @stability stable
         */
        readonly acceptLanguage?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_portfolio_constraints.html#portfolio_id DataAwsServicecatalogPortfolioConstraints#portfolio_id}.
         *
         * @stability stable
         */
        readonly portfolioId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_portfolio_constraints.html#product_id DataAwsServicecatalogPortfolioConstraints#product_id}.
         *
         * @stability stable
         */
        readonly productId?: string;
    }
    /**
     * @stability stable
     */
    class DataAwsServicecatalogPortfolioConstraintsDetails extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get constraintId(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get owner(): string;
        /**
         * @stability stable
         */
        get portfolioId(): string;
        /**
         * @stability stable
         */
        get productId(): string;
        /**
         * @stability stable
         */
        get type(): string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_portfolio_constraints.html aws_servicecatalog_portfolio_constraints}.
     *
     * @stability stable
     */
    class DataAwsServicecatalogPortfolioConstraints extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_portfolio_constraints.html aws_servicecatalog_portfolio_constraints} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsServicecatalogPortfolioConstraintsConfig);
        private _acceptLanguage?;
        /**
         * @stability stable
         */
        get acceptLanguage(): string | undefined;
        /**
         * @stability stable
         */
        set acceptLanguage(value: string | undefined);
        /**
         * @stability stable
         */
        resetAcceptLanguage(): void;
        /**
         * @stability stable
         */
        get acceptLanguageInput(): string | undefined;
        /**
         * @stability stable
         */
        details(index: string): DataAwsServicecatalogPortfolioConstraintsDetails;
        /**
         * @stability stable
         */
        get id(): string;
        private _portfolioId?;
        /**
         * @stability stable
         */
        get portfolioId(): string;
        /**
         * @stability stable
         */
        set portfolioId(value: string);
        /**
         * @stability stable
         */
        get portfolioIdInput(): string | undefined;
        private _productId?;
        /**
         * @stability stable
         */
        get productId(): string | undefined;
        /**
         * @stability stable
         */
        set productId(value: string | undefined);
        /**
         * @stability stable
         */
        resetProductId(): void;
        /**
         * @stability stable
         */
        get productIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsServicecatalogProductConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_product.html#accept_language DataAwsServicecatalogProduct#accept_language}.
         *
         * @stability stable
         */
        readonly acceptLanguage?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_product.html#id DataAwsServicecatalogProduct#id}.
         *
         * @stability stable
         */
        readonly id: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_product.html#tags DataAwsServicecatalogProduct#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_product.html aws_servicecatalog_product}.
     *
     * @stability stable
     */
    class DataAwsServicecatalogProduct extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/servicecatalog_product.html aws_servicecatalog_product} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsServicecatalogProductConfig);
        private _acceptLanguage?;
        /**
         * @stability stable
         */
        get acceptLanguage(): string | undefined;
        /**
         * @stability stable
         */
        set acceptLanguage(value: string | undefined);
        /**
         * @stability stable
         */
        resetAcceptLanguage(): void;
        /**
         * @stability stable
         */
        get acceptLanguageInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdTime(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get distributor(): string;
        /**
         * @stability stable
         */
        get hasDefaultPath(): any;
        private _id?;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        set id(value: string);
        /**
         * @stability stable
         */
        get idInput(): string | undefined;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        get owner(): string;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        get supportDescription(): string;
        /**
         * @stability stable
         */
        get supportEmail(): string;
        /**
         * @stability stable
         */
        get supportUrl(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
