import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Service Quotas
*/
export declare namespace ServiceQuotas {
    /**
     * @stability stable
     */
    interface ServicequotasServiceQuotaConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicequotas_service_quota.html#quota_code ServicequotasServiceQuota#quota_code}.
         *
         * @stability stable
         */
        readonly quotaCode: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicequotas_service_quota.html#service_code ServicequotasServiceQuota#service_code}.
         *
         * @stability stable
         */
        readonly serviceCode: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicequotas_service_quota.html#value ServicequotasServiceQuota#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicequotas_service_quota.html aws_servicequotas_service_quota}.
     *
     * @stability stable
     */
    class ServicequotasServiceQuota extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicequotas_service_quota.html aws_servicequotas_service_quota} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: ServicequotasServiceQuotaConfig);
        /**
         * @stability stable
         */
        get adjustable(): any;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get defaultValue(): number;
        /**
         * @stability stable
         */
        get id(): string;
        private _quotaCode?;
        /**
         * @stability stable
         */
        get quotaCode(): string;
        /**
         * @stability stable
         */
        set quotaCode(value: string);
        /**
         * @stability stable
         */
        get quotaCodeInput(): string | undefined;
        /**
         * @stability stable
         */
        get quotaName(): string;
        /**
         * @stability stable
         */
        get requestId(): string;
        /**
         * @stability stable
         */
        get requestStatus(): string;
        private _serviceCode?;
        /**
         * @stability stable
         */
        get serviceCode(): string;
        /**
         * @stability stable
         */
        set serviceCode(value: string);
        /**
         * @stability stable
         */
        get serviceCodeInput(): string | undefined;
        /**
         * @stability stable
         */
        get serviceName(): string;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsServicequotasServiceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicequotas_service.html#service_name DataAwsServicequotasService#service_name}.
         *
         * @stability stable
         */
        readonly serviceName: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/servicequotas_service.html aws_servicequotas_service}.
     *
     * @stability stable
     */
    class DataAwsServicequotasService extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/servicequotas_service.html aws_servicequotas_service} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsServicequotasServiceConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get serviceCode(): string;
        private _serviceName?;
        /**
         * @stability stable
         */
        get serviceName(): string;
        /**
         * @stability stable
         */
        set serviceName(value: string);
        /**
         * @stability stable
         */
        get serviceNameInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsServicequotasServiceQuotaConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicequotas_service_quota.html#quota_code DataAwsServicequotasServiceQuota#quota_code}.
         *
         * @stability stable
         */
        readonly quotaCode?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicequotas_service_quota.html#quota_name DataAwsServicequotasServiceQuota#quota_name}.
         *
         * @stability stable
         */
        readonly quotaName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicequotas_service_quota.html#service_code DataAwsServicequotasServiceQuota#service_code}.
         *
         * @stability stable
         */
        readonly serviceCode: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/servicequotas_service_quota.html aws_servicequotas_service_quota}.
     *
     * @stability stable
     */
    class DataAwsServicequotasServiceQuota extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/servicequotas_service_quota.html aws_servicequotas_service_quota} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsServicequotasServiceQuotaConfig);
        /**
         * @stability stable
         */
        get adjustable(): any;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get defaultValue(): number;
        /**
         * @stability stable
         */
        get globalQuota(): any;
        /**
         * @stability stable
         */
        get id(): string;
        private _quotaCode?;
        /**
         * @stability stable
         */
        get quotaCode(): string | undefined;
        /**
         * @stability stable
         */
        set quotaCode(value: string | undefined);
        /**
         * @stability stable
         */
        resetQuotaCode(): void;
        /**
         * @stability stable
         */
        get quotaCodeInput(): string | undefined;
        private _quotaName?;
        /**
         * @stability stable
         */
        get quotaName(): string | undefined;
        /**
         * @stability stable
         */
        set quotaName(value: string | undefined);
        /**
         * @stability stable
         */
        resetQuotaName(): void;
        /**
         * @stability stable
         */
        get quotaNameInput(): string | undefined;
        private _serviceCode?;
        /**
         * @stability stable
         */
        get serviceCode(): string;
        /**
         * @stability stable
         */
        set serviceCode(value: string);
        /**
         * @stability stable
         */
        get serviceCodeInput(): string | undefined;
        /**
         * @stability stable
         */
        get serviceName(): string;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
