import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Signer
*/
export declare namespace Signer {
    /**
     * @stability stable
     */
    interface SignerSigningJobConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_job.html#ignore_signing_job_failure SignerSigningJob#ignore_signing_job_failure}.
         *
         * @stability stable
         */
        readonly ignoreSigningJobFailure?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_job.html#profile_name SignerSigningJob#profile_name}.
         *
         * @stability stable
         */
        readonly profileName: string;
        /**
         * destination block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_job.html#destination SignerSigningJob#destination}
         *
         * @stability stable
         */
        readonly destination: SignerSigningJobDestination;
        /**
         * source block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_job.html#source SignerSigningJob#source}
         *
         * @stability stable
         */
        readonly source: SignerSigningJobSource;
    }
    /**
     * @stability stable
     */
    class SignerSigningJobRevocationRecord extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get reason(): string;
        /**
         * @stability stable
         */
        get revokedAt(): string;
        /**
         * @stability stable
         */
        get revokedBy(): string;
    }
    /**
     * @stability stable
     */
    class SignerSigningJobSignedObjectS3 extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get bucket(): string;
        /**
         * @stability stable
         */
        get key(): string;
    }
    /**
     * @stability stable
     */
    class SignerSigningJobSignedObject extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get s3(): any;
    }
    /**
     * @stability stable
     */
    interface SignerSigningJobDestinationS3 {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_job.html#bucket SignerSigningJob#bucket}.
         *
         * @stability stable
         */
        readonly bucket: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_job.html#prefix SignerSigningJob#prefix}.
         *
         * @stability stable
         */
        readonly prefix?: string;
    }
    /**
     * @stability stable
     */
    class SignerSigningJobDestinationS3OutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bucket?;
        /**
         * @stability stable
         */
        get bucket(): string;
        /**
         * @stability stable
         */
        set bucket(value: string);
        /**
         * @stability stable
         */
        get bucketInput(): string | undefined;
        private _prefix?;
        /**
         * @stability stable
         */
        get prefix(): string | undefined;
        /**
         * @stability stable
         */
        set prefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrefix(): void;
        /**
         * @stability stable
         */
        get prefixInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface SignerSigningJobDestination {
        /**
         * s3 block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_job.html#s3 SignerSigningJob#s3}
         *
         * @stability stable
         */
        readonly s3: SignerSigningJobDestinationS3;
    }
    /**
     * @stability stable
     */
    class SignerSigningJobDestinationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _s3?;
        private __s3Output;
        /**
         * @stability stable
         */
        get s3(): SignerSigningJobDestinationS3OutputReference;
        /**
         * @stability stable
         */
        putS3(value: SignerSigningJobDestinationS3): void;
        /**
         * @stability stable
         */
        get s3Input(): SignerSigningJobDestinationS3 | undefined;
    }
    /**
     * @stability stable
     */
    interface SignerSigningJobSourceS3 {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_job.html#bucket SignerSigningJob#bucket}.
         *
         * @stability stable
         */
        readonly bucket: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_job.html#key SignerSigningJob#key}.
         *
         * @stability stable
         */
        readonly key: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_job.html#version SignerSigningJob#version}.
         *
         * @stability stable
         */
        readonly version: string;
    }
    /**
     * @stability stable
     */
    class SignerSigningJobSourceS3OutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bucket?;
        /**
         * @stability stable
         */
        get bucket(): string;
        /**
         * @stability stable
         */
        set bucket(value: string);
        /**
         * @stability stable
         */
        get bucketInput(): string | undefined;
        private _key?;
        /**
         * @stability stable
         */
        get key(): string;
        /**
         * @stability stable
         */
        set key(value: string);
        /**
         * @stability stable
         */
        get keyInput(): string | undefined;
        private _version?;
        /**
         * @stability stable
         */
        get version(): string;
        /**
         * @stability stable
         */
        set version(value: string);
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface SignerSigningJobSource {
        /**
         * s3 block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_job.html#s3 SignerSigningJob#s3}
         *
         * @stability stable
         */
        readonly s3: SignerSigningJobSourceS3;
    }
    /**
     * @stability stable
     */
    class SignerSigningJobSourceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _s3?;
        private __s3Output;
        /**
         * @stability stable
         */
        get s3(): SignerSigningJobSourceS3OutputReference;
        /**
         * @stability stable
         */
        putS3(value: SignerSigningJobSourceS3): void;
        /**
         * @stability stable
         */
        get s3Input(): SignerSigningJobSourceS3 | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_job.html aws_signer_signing_job}.
     *
     * @stability stable
     */
    class SignerSigningJob extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_job.html aws_signer_signing_job} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: SignerSigningJobConfig);
        /**
         * @stability stable
         */
        get completedAt(): string;
        /**
         * @stability stable
         */
        get createdAt(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _ignoreSigningJobFailure?;
        /**
         * @stability stable
         */
        get ignoreSigningJobFailure(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set ignoreSigningJobFailure(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetIgnoreSigningJobFailure(): void;
        /**
         * @stability stable
         */
        get ignoreSigningJobFailureInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get jobId(): string;
        /**
         * @stability stable
         */
        get jobInvoker(): string;
        /**
         * @stability stable
         */
        get jobOwner(): string;
        /**
         * @stability stable
         */
        get platformDisplayName(): string;
        /**
         * @stability stable
         */
        get platformId(): string;
        private _profileName?;
        /**
         * @stability stable
         */
        get profileName(): string;
        /**
         * @stability stable
         */
        set profileName(value: string);
        /**
         * @stability stable
         */
        get profileNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get profileVersion(): string;
        /**
         * @stability stable
         */
        get requestedBy(): string;
        /**
         * @stability stable
         */
        revocationRecord(index: string): SignerSigningJobRevocationRecord;
        /**
         * @stability stable
         */
        get signatureExpiresAt(): string;
        /**
         * @stability stable
         */
        signedObject(index: string): SignerSigningJobSignedObject;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        get statusReason(): string;
        private _destination?;
        private __destinationOutput;
        /**
         * @stability stable
         */
        get destination(): SignerSigningJobDestinationOutputReference;
        /**
         * @stability stable
         */
        putDestination(value: SignerSigningJobDestination): void;
        /**
         * @stability stable
         */
        get destinationInput(): SignerSigningJobDestination | undefined;
        private _source?;
        private __sourceOutput;
        /**
         * @stability stable
         */
        get source(): SignerSigningJobSourceOutputReference;
        /**
         * @stability stable
         */
        putSource(value: SignerSigningJobSource): void;
        /**
         * @stability stable
         */
        get sourceInput(): SignerSigningJobSource | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface SignerSigningProfileConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile.html#name SignerSigningProfile#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile.html#name_prefix SignerSigningProfile#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile.html#platform_id SignerSigningProfile#platform_id}.
         *
         * @stability stable
         */
        readonly platformId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile.html#tags SignerSigningProfile#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile.html#tags_all SignerSigningProfile#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * signature_validity_period block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile.html#signature_validity_period SignerSigningProfile#signature_validity_period}
         *
         * @stability stable
         */
        readonly signatureValidityPeriod?: SignerSigningProfileSignatureValidityPeriod;
    }
    /**
     * @stability stable
     */
    class SignerSigningProfileRevocationRecord extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get revocationEffectiveFrom(): string;
        /**
         * @stability stable
         */
        get revokedAt(): string;
        /**
         * @stability stable
         */
        get revokedBy(): string;
    }
    /**
     * @stability stable
     */
    interface SignerSigningProfileSignatureValidityPeriod {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile.html#type SignerSigningProfile#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile.html#value SignerSigningProfile#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class SignerSigningProfileSignatureValidityPeriodOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile.html aws_signer_signing_profile}.
     *
     * @stability stable
     */
    class SignerSigningProfile extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile.html aws_signer_signing_profile} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: SignerSigningProfileConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set namePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamePrefix(): void;
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        /**
         * @stability stable
         */
        get platformDisplayName(): string;
        private _platformId?;
        /**
         * @stability stable
         */
        get platformId(): string;
        /**
         * @stability stable
         */
        set platformId(value: string);
        /**
         * @stability stable
         */
        get platformIdInput(): string | undefined;
        /**
         * @stability stable
         */
        revocationRecord(index: string): SignerSigningProfileRevocationRecord;
        /**
         * @stability stable
         */
        get status(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get version(): string;
        /**
         * @stability stable
         */
        get versionArn(): string;
        private _signatureValidityPeriod?;
        private __signatureValidityPeriodOutput;
        /**
         * @stability stable
         */
        get signatureValidityPeriod(): SignerSigningProfileSignatureValidityPeriodOutputReference;
        /**
         * @stability stable
         */
        putSignatureValidityPeriod(value: SignerSigningProfileSignatureValidityPeriod | undefined): void;
        /**
         * @stability stable
         */
        resetSignatureValidityPeriod(): void;
        /**
         * @stability stable
         */
        get signatureValidityPeriodInput(): SignerSigningProfileSignatureValidityPeriod | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface SignerSigningProfilePermissionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile_permission.html#action SignerSigningProfilePermission#action}.
         *
         * @stability stable
         */
        readonly action: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile_permission.html#principal SignerSigningProfilePermission#principal}.
         *
         * @stability stable
         */
        readonly principal: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile_permission.html#profile_name SignerSigningProfilePermission#profile_name}.
         *
         * @stability stable
         */
        readonly profileName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile_permission.html#profile_version SignerSigningProfilePermission#profile_version}.
         *
         * @stability stable
         */
        readonly profileVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile_permission.html#statement_id SignerSigningProfilePermission#statement_id}.
         *
         * @stability stable
         */
        readonly statementId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile_permission.html#statement_id_prefix SignerSigningProfilePermission#statement_id_prefix}.
         *
         * @stability stable
         */
        readonly statementIdPrefix?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile_permission.html aws_signer_signing_profile_permission}.
     *
     * @stability stable
     */
    class SignerSigningProfilePermission extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/signer_signing_profile_permission.html aws_signer_signing_profile_permission} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: SignerSigningProfilePermissionConfig);
        private _action?;
        /**
         * @stability stable
         */
        get action(): string;
        /**
         * @stability stable
         */
        set action(value: string);
        /**
         * @stability stable
         */
        get actionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _principal?;
        /**
         * @stability stable
         */
        get principal(): string;
        /**
         * @stability stable
         */
        set principal(value: string);
        /**
         * @stability stable
         */
        get principalInput(): string | undefined;
        private _profileName?;
        /**
         * @stability stable
         */
        get profileName(): string;
        /**
         * @stability stable
         */
        set profileName(value: string);
        /**
         * @stability stable
         */
        get profileNameInput(): string | undefined;
        private _profileVersion?;
        /**
         * @stability stable
         */
        get profileVersion(): string | undefined;
        /**
         * @stability stable
         */
        set profileVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetProfileVersion(): void;
        /**
         * @stability stable
         */
        get profileVersionInput(): string | undefined;
        private _statementId?;
        /**
         * @stability stable
         */
        get statementId(): string | undefined;
        /**
         * @stability stable
         */
        set statementId(value: string | undefined);
        /**
         * @stability stable
         */
        resetStatementId(): void;
        /**
         * @stability stable
         */
        get statementIdInput(): string | undefined;
        private _statementIdPrefix?;
        /**
         * @stability stable
         */
        get statementIdPrefix(): string | undefined;
        /**
         * @stability stable
         */
        set statementIdPrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetStatementIdPrefix(): void;
        /**
         * @stability stable
         */
        get statementIdPrefixInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsSignerSigningJobConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/signer_signing_job.html#job_id DataAwsSignerSigningJob#job_id}.
         *
         * @stability stable
         */
        readonly jobId: string;
    }
    /**
     * @stability stable
     */
    class DataAwsSignerSigningJobRevocationRecord extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get reason(): string;
        /**
         * @stability stable
         */
        get revokedAt(): string;
        /**
         * @stability stable
         */
        get revokedBy(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsSignerSigningJobSignedObjectS3 extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get bucket(): string;
        /**
         * @stability stable
         */
        get key(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsSignerSigningJobSignedObject extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get s3(): any;
    }
    /**
     * @stability stable
     */
    class DataAwsSignerSigningJobSourceS3 extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get bucket(): string;
        /**
         * @stability stable
         */
        get key(): string;
        /**
         * @stability stable
         */
        get version(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsSignerSigningJobSource extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get s3(): any;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/signer_signing_job.html aws_signer_signing_job}.
     *
     * @stability stable
     */
    class DataAwsSignerSigningJob extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/signer_signing_job.html aws_signer_signing_job} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsSignerSigningJobConfig);
        /**
         * @stability stable
         */
        get completedAt(): string;
        /**
         * @stability stable
         */
        get createdAt(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _jobId?;
        /**
         * @stability stable
         */
        get jobId(): string;
        /**
         * @stability stable
         */
        set jobId(value: string);
        /**
         * @stability stable
         */
        get jobIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get jobInvoker(): string;
        /**
         * @stability stable
         */
        get jobOwner(): string;
        /**
         * @stability stable
         */
        get platformDisplayName(): string;
        /**
         * @stability stable
         */
        get platformId(): string;
        /**
         * @stability stable
         */
        get profileName(): string;
        /**
         * @stability stable
         */
        get profileVersion(): string;
        /**
         * @stability stable
         */
        get requestedBy(): string;
        /**
         * @stability stable
         */
        revocationRecord(index: string): DataAwsSignerSigningJobRevocationRecord;
        /**
         * @stability stable
         */
        get signatureExpiresAt(): string;
        /**
         * @stability stable
         */
        signedObject(index: string): DataAwsSignerSigningJobSignedObject;
        /**
         * @stability stable
         */
        source(index: string): DataAwsSignerSigningJobSource;
        /**
         * @stability stable
         */
        get status(): string;
        /**
         * @stability stable
         */
        get statusReason(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsSignerSigningProfileConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/signer_signing_profile.html#name DataAwsSignerSigningProfile#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/signer_signing_profile.html#tags DataAwsSignerSigningProfile#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class DataAwsSignerSigningProfileRevocationRecord extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get revocationEffectiveFrom(): string;
        /**
         * @stability stable
         */
        get revokedAt(): string;
        /**
         * @stability stable
         */
        get revokedBy(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsSignerSigningProfileSignatureValidityPeriod extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        get value(): number;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/signer_signing_profile.html aws_signer_signing_profile}.
     *
     * @stability stable
     */
    class DataAwsSignerSigningProfile extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/signer_signing_profile.html aws_signer_signing_profile} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsSignerSigningProfileConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get platformDisplayName(): string;
        /**
         * @stability stable
         */
        get platformId(): string;
        /**
         * @stability stable
         */
        revocationRecord(index: string): DataAwsSignerSigningProfileRevocationRecord;
        /**
         * @stability stable
         */
        signatureValidityPeriod(index: string): DataAwsSignerSigningProfileSignatureValidityPeriod;
        /**
         * @stability stable
         */
        get status(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get version(): string;
        /**
         * @stability stable
         */
        get versionArn(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
