import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS WorkLink
*/
export declare namespace WorkLink {
    /**
     * @stability stable
     */
    interface WorklinkFleetConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#audit_stream_arn WorklinkFleet#audit_stream_arn}.
         *
         * @stability stable
         */
        readonly auditStreamArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#device_ca_certificate WorklinkFleet#device_ca_certificate}.
         *
         * @stability stable
         */
        readonly deviceCaCertificate?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#display_name WorklinkFleet#display_name}.
         *
         * @stability stable
         */
        readonly displayName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#name WorklinkFleet#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#optimize_for_end_user_location WorklinkFleet#optimize_for_end_user_location}.
         *
         * @stability stable
         */
        readonly optimizeForEndUserLocation?: boolean | cdktf.IResolvable;
        /**
         * identity_provider block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#identity_provider WorklinkFleet#identity_provider}
         *
         * @stability stable
         */
        readonly identityProvider?: WorklinkFleetIdentityProvider;
        /**
         * network block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#network WorklinkFleet#network}
         *
         * @stability stable
         */
        readonly network?: WorklinkFleetNetwork;
    }
    /**
     * @stability stable
     */
    interface WorklinkFleetIdentityProvider {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#saml_metadata WorklinkFleet#saml_metadata}.
         *
         * @stability stable
         */
        readonly samlMetadata: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#type WorklinkFleet#type}.
         *
         * @stability stable
         */
        readonly type: string;
    }
    /**
     * @stability stable
     */
    class WorklinkFleetIdentityProviderOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _samlMetadata?;
        /**
         * @stability stable
         */
        get samlMetadata(): string;
        /**
         * @stability stable
         */
        set samlMetadata(value: string);
        /**
         * @stability stable
         */
        get samlMetadataInput(): string | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface WorklinkFleetNetwork {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#security_group_ids WorklinkFleet#security_group_ids}.
         *
         * @stability stable
         */
        readonly securityGroupIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#subnet_ids WorklinkFleet#subnet_ids}.
         *
         * @stability stable
         */
        readonly subnetIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#vpc_id WorklinkFleet#vpc_id}.
         *
         * @stability stable
         */
        readonly vpcId: string;
    }
    /**
     * @stability stable
     */
    class WorklinkFleetNetworkOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _securityGroupIds?;
        /**
         * @stability stable
         */
        get securityGroupIds(): string[];
        /**
         * @stability stable
         */
        set securityGroupIds(value: string[]);
        /**
         * @stability stable
         */
        get securityGroupIdsInput(): string[] | undefined;
        private _subnetIds?;
        /**
         * @stability stable
         */
        get subnetIds(): string[];
        /**
         * @stability stable
         */
        set subnetIds(value: string[]);
        /**
         * @stability stable
         */
        get subnetIdsInput(): string[] | undefined;
        private _vpcId?;
        /**
         * @stability stable
         */
        get vpcId(): string;
        /**
         * @stability stable
         */
        set vpcId(value: string);
        /**
         * @stability stable
         */
        get vpcIdInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html aws_worklink_fleet}.
     *
     * @stability stable
     */
    class WorklinkFleet extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html aws_worklink_fleet} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: WorklinkFleetConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _auditStreamArn?;
        /**
         * @stability stable
         */
        get auditStreamArn(): string | undefined;
        /**
         * @stability stable
         */
        set auditStreamArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetAuditStreamArn(): void;
        /**
         * @stability stable
         */
        get auditStreamArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get companyCode(): string;
        /**
         * @stability stable
         */
        get createdTime(): string;
        private _deviceCaCertificate?;
        /**
         * @stability stable
         */
        get deviceCaCertificate(): string | undefined;
        /**
         * @stability stable
         */
        set deviceCaCertificate(value: string | undefined);
        /**
         * @stability stable
         */
        resetDeviceCaCertificate(): void;
        /**
         * @stability stable
         */
        get deviceCaCertificateInput(): string | undefined;
        private _displayName?;
        /**
         * @stability stable
         */
        get displayName(): string | undefined;
        /**
         * @stability stable
         */
        set displayName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDisplayName(): void;
        /**
         * @stability stable
         */
        get displayNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdatedTime(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _optimizeForEndUserLocation?;
        /**
         * @stability stable
         */
        get optimizeForEndUserLocation(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set optimizeForEndUserLocation(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetOptimizeForEndUserLocation(): void;
        /**
         * @stability stable
         */
        get optimizeForEndUserLocationInput(): boolean | cdktf.IResolvable | undefined;
        private _identityProvider?;
        private __identityProviderOutput;
        /**
         * @stability stable
         */
        get identityProvider(): WorklinkFleetIdentityProviderOutputReference;
        /**
         * @stability stable
         */
        putIdentityProvider(value: WorklinkFleetIdentityProvider | undefined): void;
        /**
         * @stability stable
         */
        resetIdentityProvider(): void;
        /**
         * @stability stable
         */
        get identityProviderInput(): WorklinkFleetIdentityProvider | undefined;
        private _network?;
        private __networkOutput;
        /**
         * @stability stable
         */
        get network(): WorklinkFleetNetworkOutputReference;
        /**
         * @stability stable
         */
        putNetwork(value: WorklinkFleetNetwork | undefined): void;
        /**
         * @stability stable
         */
        resetNetwork(): void;
        /**
         * @stability stable
         */
        get networkInput(): WorklinkFleetNetwork | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface WorklinkWebsiteCertificateAuthorityAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_website_certificate_authority_association.html#certificate WorklinkWebsiteCertificateAuthorityAssociation#certificate}.
         *
         * @stability stable
         */
        readonly certificate: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_website_certificate_authority_association.html#display_name WorklinkWebsiteCertificateAuthorityAssociation#display_name}.
         *
         * @stability stable
         */
        readonly displayName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_website_certificate_authority_association.html#fleet_arn WorklinkWebsiteCertificateAuthorityAssociation#fleet_arn}.
         *
         * @stability stable
         */
        readonly fleetArn: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/worklink_website_certificate_authority_association.html aws_worklink_website_certificate_authority_association}.
     *
     * @stability stable
     */
    class WorklinkWebsiteCertificateAuthorityAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/worklink_website_certificate_authority_association.html aws_worklink_website_certificate_authority_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: WorklinkWebsiteCertificateAuthorityAssociationConfig);
        private _certificate?;
        /**
         * @stability stable
         */
        get certificate(): string;
        /**
         * @stability stable
         */
        set certificate(value: string);
        /**
         * @stability stable
         */
        get certificateInput(): string | undefined;
        private _displayName?;
        /**
         * @stability stable
         */
        get displayName(): string | undefined;
        /**
         * @stability stable
         */
        set displayName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDisplayName(): void;
        /**
         * @stability stable
         */
        get displayNameInput(): string | undefined;
        private _fleetArn?;
        /**
         * @stability stable
         */
        get fleetArn(): string;
        /**
         * @stability stable
         */
        set fleetArn(value: string);
        /**
         * @stability stable
         */
        get fleetArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get websiteCaId(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
