import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS X-Ray
*/
export declare namespace XRay {
    /**
     * @stability stable
     */
    interface XrayEncryptionConfigConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_encryption_config.html#key_id XrayEncryptionConfig#key_id}.
         *
         * @stability stable
         */
        readonly keyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_encryption_config.html#type XrayEncryptionConfig#type}.
         *
         * @stability stable
         */
        readonly type: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/xray_encryption_config.html aws_xray_encryption_config}.
     *
     * @stability stable
     */
    class XrayEncryptionConfig extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/xray_encryption_config.html aws_xray_encryption_config} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: XrayEncryptionConfigConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _keyId?;
        /**
         * @stability stable
         */
        get keyId(): string | undefined;
        /**
         * @stability stable
         */
        set keyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKeyId(): void;
        /**
         * @stability stable
         */
        get keyIdInput(): string | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface XrayGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_group.html#filter_expression XrayGroup#filter_expression}.
         *
         * @stability stable
         */
        readonly filterExpression: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_group.html#group_name XrayGroup#group_name}.
         *
         * @stability stable
         */
        readonly groupName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_group.html#tags XrayGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_group.html#tags_all XrayGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/xray_group.html aws_xray_group}.
     *
     * @stability stable
     */
    class XrayGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/xray_group.html aws_xray_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: XrayGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _filterExpression?;
        /**
         * @stability stable
         */
        get filterExpression(): string;
        /**
         * @stability stable
         */
        set filterExpression(value: string);
        /**
         * @stability stable
         */
        get filterExpressionInput(): string | undefined;
        private _groupName?;
        /**
         * @stability stable
         */
        get groupName(): string;
        /**
         * @stability stable
         */
        set groupName(value: string);
        /**
         * @stability stable
         */
        get groupNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface XraySamplingRuleConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_sampling_rule.html#attributes XraySamplingRule#attributes}.
         *
         * @stability stable
         */
        readonly attributes?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_sampling_rule.html#fixed_rate XraySamplingRule#fixed_rate}.
         *
         * @stability stable
         */
        readonly fixedRate: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_sampling_rule.html#host XraySamplingRule#host}.
         *
         * @stability stable
         */
        readonly host: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_sampling_rule.html#http_method XraySamplingRule#http_method}.
         *
         * @stability stable
         */
        readonly httpMethod: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_sampling_rule.html#priority XraySamplingRule#priority}.
         *
         * @stability stable
         */
        readonly priority: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_sampling_rule.html#reservoir_size XraySamplingRule#reservoir_size}.
         *
         * @stability stable
         */
        readonly reservoirSize: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_sampling_rule.html#resource_arn XraySamplingRule#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_sampling_rule.html#rule_name XraySamplingRule#rule_name}.
         *
         * @stability stable
         */
        readonly ruleName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_sampling_rule.html#service_name XraySamplingRule#service_name}.
         *
         * @stability stable
         */
        readonly serviceName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_sampling_rule.html#service_type XraySamplingRule#service_type}.
         *
         * @stability stable
         */
        readonly serviceType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_sampling_rule.html#tags XraySamplingRule#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_sampling_rule.html#tags_all XraySamplingRule#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_sampling_rule.html#url_path XraySamplingRule#url_path}.
         *
         * @stability stable
         */
        readonly urlPath: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/xray_sampling_rule.html#version XraySamplingRule#version}.
         *
         * @stability stable
         */
        readonly version: number;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/xray_sampling_rule.html aws_xray_sampling_rule}.
     *
     * @stability stable
     */
    class XraySamplingRule extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/xray_sampling_rule.html aws_xray_sampling_rule} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: XraySamplingRuleConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _attributes?;
        /**
         * @stability stable
         */
        get attributes(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set attributes(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAttributes(): void;
        /**
         * @stability stable
         */
        get attributesInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _fixedRate?;
        /**
         * @stability stable
         */
        get fixedRate(): number;
        /**
         * @stability stable
         */
        set fixedRate(value: number);
        /**
         * @stability stable
         */
        get fixedRateInput(): number | undefined;
        private _host?;
        /**
         * @stability stable
         */
        get host(): string;
        /**
         * @stability stable
         */
        set host(value: string);
        /**
         * @stability stable
         */
        get hostInput(): string | undefined;
        private _httpMethod?;
        /**
         * @stability stable
         */
        get httpMethod(): string;
        /**
         * @stability stable
         */
        set httpMethod(value: string);
        /**
         * @stability stable
         */
        get httpMethodInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _priority?;
        /**
         * @stability stable
         */
        get priority(): number;
        /**
         * @stability stable
         */
        set priority(value: number);
        /**
         * @stability stable
         */
        get priorityInput(): number | undefined;
        private _reservoirSize?;
        /**
         * @stability stable
         */
        get reservoirSize(): number;
        /**
         * @stability stable
         */
        set reservoirSize(value: number);
        /**
         * @stability stable
         */
        get reservoirSizeInput(): number | undefined;
        private _resourceArn?;
        /**
         * @stability stable
         */
        get resourceArn(): string;
        /**
         * @stability stable
         */
        set resourceArn(value: string);
        /**
         * @stability stable
         */
        get resourceArnInput(): string | undefined;
        private _ruleName?;
        /**
         * @stability stable
         */
        get ruleName(): string | undefined;
        /**
         * @stability stable
         */
        set ruleName(value: string | undefined);
        /**
         * @stability stable
         */
        resetRuleName(): void;
        /**
         * @stability stable
         */
        get ruleNameInput(): string | undefined;
        private _serviceName?;
        /**
         * @stability stable
         */
        get serviceName(): string;
        /**
         * @stability stable
         */
        set serviceName(value: string);
        /**
         * @stability stable
         */
        get serviceNameInput(): string | undefined;
        private _serviceType?;
        /**
         * @stability stable
         */
        get serviceType(): string;
        /**
         * @stability stable
         */
        set serviceType(value: string);
        /**
         * @stability stable
         */
        get serviceTypeInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _urlPath?;
        /**
         * @stability stable
         */
        get urlPath(): string;
        /**
         * @stability stable
         */
        set urlPath(value: string);
        /**
         * @stability stable
         */
        get urlPathInput(): string | undefined;
        private _version?;
        /**
         * @stability stable
         */
        get version(): number;
        /**
         * @stability stable
         */
        set version(value: number);
        /**
         * @stability stable
         */
        get versionInput(): number | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
