import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* App Mesh
*/
export declare namespace AppMesh {
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#mesh_name AppmeshGatewayRoute#mesh_name}.
         *
         * @stability stable
         */
        readonly meshName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#mesh_owner AppmeshGatewayRoute#mesh_owner}.
         *
         * @stability stable
         */
        readonly meshOwner?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#name AppmeshGatewayRoute#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#tags AppmeshGatewayRoute#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#tags_all AppmeshGatewayRoute#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#virtual_gateway_name AppmeshGatewayRoute#virtual_gateway_name}.
         *
         * @stability stable
         */
        readonly virtualGatewayName: string;
        /**
         * spec block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#spec AppmeshGatewayRoute#spec}
         *
         * @stability stable
         */
        readonly spec: AppmeshGatewayRouteSpec;
    }
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteSpecGrpcRouteActionTargetVirtualService {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#virtual_service_name AppmeshGatewayRoute#virtual_service_name}.
         *
         * @stability stable
         */
        readonly virtualServiceName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshGatewayRouteSpecGrpcRouteActionTargetVirtualServiceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _virtualServiceName?;
        /**
         * @stability stable
         */
        get virtualServiceName(): string;
        /**
         * @stability stable
         */
        set virtualServiceName(value: string);
        /**
         * @stability stable
         */
        get virtualServiceNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteSpecGrpcRouteActionTarget {
        /**
         * virtual_service block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#virtual_service AppmeshGatewayRoute#virtual_service}
         *
         * @stability stable
         */
        readonly virtualService: AppmeshGatewayRouteSpecGrpcRouteActionTargetVirtualService;
    }
    /**
     * @stability stable
     */
    class AppmeshGatewayRouteSpecGrpcRouteActionTargetOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _virtualService?;
        private __virtualServiceOutput;
        /**
         * @stability stable
         */
        get virtualService(): AppmeshGatewayRouteSpecGrpcRouteActionTargetVirtualServiceOutputReference;
        /**
         * @stability stable
         */
        putVirtualService(value: AppmeshGatewayRouteSpecGrpcRouteActionTargetVirtualService): void;
        /**
         * @stability stable
         */
        get virtualServiceInput(): AppmeshGatewayRouteSpecGrpcRouteActionTargetVirtualService | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteSpecGrpcRouteAction {
        /**
         * target block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#target AppmeshGatewayRoute#target}
         *
         * @stability stable
         */
        readonly target: AppmeshGatewayRouteSpecGrpcRouteActionTarget;
    }
    /**
     * @stability stable
     */
    class AppmeshGatewayRouteSpecGrpcRouteActionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _target?;
        private __targetOutput;
        /**
         * @stability stable
         */
        get target(): AppmeshGatewayRouteSpecGrpcRouteActionTargetOutputReference;
        /**
         * @stability stable
         */
        putTarget(value: AppmeshGatewayRouteSpecGrpcRouteActionTarget): void;
        /**
         * @stability stable
         */
        get targetInput(): AppmeshGatewayRouteSpecGrpcRouteActionTarget | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteSpecGrpcRouteMatch {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#service_name AppmeshGatewayRoute#service_name}.
         *
         * @stability stable
         */
        readonly serviceName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshGatewayRouteSpecGrpcRouteMatchOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _serviceName?;
        /**
         * @stability stable
         */
        get serviceName(): string;
        /**
         * @stability stable
         */
        set serviceName(value: string);
        /**
         * @stability stable
         */
        get serviceNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteSpecGrpcRoute {
        /**
         * action block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#action AppmeshGatewayRoute#action}
         *
         * @stability stable
         */
        readonly action: AppmeshGatewayRouteSpecGrpcRouteAction;
        /**
         * match block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#match AppmeshGatewayRoute#match}
         *
         * @stability stable
         */
        readonly match: AppmeshGatewayRouteSpecGrpcRouteMatch;
    }
    /**
     * @stability stable
     */
    class AppmeshGatewayRouteSpecGrpcRouteOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _action?;
        private __actionOutput;
        /**
         * @stability stable
         */
        get action(): AppmeshGatewayRouteSpecGrpcRouteActionOutputReference;
        /**
         * @stability stable
         */
        putAction(value: AppmeshGatewayRouteSpecGrpcRouteAction): void;
        /**
         * @stability stable
         */
        get actionInput(): AppmeshGatewayRouteSpecGrpcRouteAction | undefined;
        private _match?;
        private __matchOutput;
        /**
         * @stability stable
         */
        get match(): AppmeshGatewayRouteSpecGrpcRouteMatchOutputReference;
        /**
         * @stability stable
         */
        putMatch(value: AppmeshGatewayRouteSpecGrpcRouteMatch): void;
        /**
         * @stability stable
         */
        get matchInput(): AppmeshGatewayRouteSpecGrpcRouteMatch | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteSpecHttp2RouteActionTargetVirtualService {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#virtual_service_name AppmeshGatewayRoute#virtual_service_name}.
         *
         * @stability stable
         */
        readonly virtualServiceName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshGatewayRouteSpecHttp2RouteActionTargetVirtualServiceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _virtualServiceName?;
        /**
         * @stability stable
         */
        get virtualServiceName(): string;
        /**
         * @stability stable
         */
        set virtualServiceName(value: string);
        /**
         * @stability stable
         */
        get virtualServiceNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteSpecHttp2RouteActionTarget {
        /**
         * virtual_service block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#virtual_service AppmeshGatewayRoute#virtual_service}
         *
         * @stability stable
         */
        readonly virtualService: AppmeshGatewayRouteSpecHttp2RouteActionTargetVirtualService;
    }
    /**
     * @stability stable
     */
    class AppmeshGatewayRouteSpecHttp2RouteActionTargetOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _virtualService?;
        private __virtualServiceOutput;
        /**
         * @stability stable
         */
        get virtualService(): AppmeshGatewayRouteSpecHttp2RouteActionTargetVirtualServiceOutputReference;
        /**
         * @stability stable
         */
        putVirtualService(value: AppmeshGatewayRouteSpecHttp2RouteActionTargetVirtualService): void;
        /**
         * @stability stable
         */
        get virtualServiceInput(): AppmeshGatewayRouteSpecHttp2RouteActionTargetVirtualService | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteSpecHttp2RouteAction {
        /**
         * target block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#target AppmeshGatewayRoute#target}
         *
         * @stability stable
         */
        readonly target: AppmeshGatewayRouteSpecHttp2RouteActionTarget;
    }
    /**
     * @stability stable
     */
    class AppmeshGatewayRouteSpecHttp2RouteActionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _target?;
        private __targetOutput;
        /**
         * @stability stable
         */
        get target(): AppmeshGatewayRouteSpecHttp2RouteActionTargetOutputReference;
        /**
         * @stability stable
         */
        putTarget(value: AppmeshGatewayRouteSpecHttp2RouteActionTarget): void;
        /**
         * @stability stable
         */
        get targetInput(): AppmeshGatewayRouteSpecHttp2RouteActionTarget | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteSpecHttp2RouteMatch {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#prefix AppmeshGatewayRoute#prefix}.
         *
         * @stability stable
         */
        readonly prefix: string;
    }
    /**
     * @stability stable
     */
    class AppmeshGatewayRouteSpecHttp2RouteMatchOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _prefix?;
        /**
         * @stability stable
         */
        get prefix(): string;
        /**
         * @stability stable
         */
        set prefix(value: string);
        /**
         * @stability stable
         */
        get prefixInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteSpecHttp2Route {
        /**
         * action block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#action AppmeshGatewayRoute#action}
         *
         * @stability stable
         */
        readonly action: AppmeshGatewayRouteSpecHttp2RouteAction;
        /**
         * match block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#match AppmeshGatewayRoute#match}
         *
         * @stability stable
         */
        readonly match: AppmeshGatewayRouteSpecHttp2RouteMatch;
    }
    /**
     * @stability stable
     */
    class AppmeshGatewayRouteSpecHttp2RouteOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _action?;
        private __actionOutput;
        /**
         * @stability stable
         */
        get action(): AppmeshGatewayRouteSpecHttp2RouteActionOutputReference;
        /**
         * @stability stable
         */
        putAction(value: AppmeshGatewayRouteSpecHttp2RouteAction): void;
        /**
         * @stability stable
         */
        get actionInput(): AppmeshGatewayRouteSpecHttp2RouteAction | undefined;
        private _match?;
        private __matchOutput;
        /**
         * @stability stable
         */
        get match(): AppmeshGatewayRouteSpecHttp2RouteMatchOutputReference;
        /**
         * @stability stable
         */
        putMatch(value: AppmeshGatewayRouteSpecHttp2RouteMatch): void;
        /**
         * @stability stable
         */
        get matchInput(): AppmeshGatewayRouteSpecHttp2RouteMatch | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteSpecHttpRouteActionTargetVirtualService {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#virtual_service_name AppmeshGatewayRoute#virtual_service_name}.
         *
         * @stability stable
         */
        readonly virtualServiceName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshGatewayRouteSpecHttpRouteActionTargetVirtualServiceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _virtualServiceName?;
        /**
         * @stability stable
         */
        get virtualServiceName(): string;
        /**
         * @stability stable
         */
        set virtualServiceName(value: string);
        /**
         * @stability stable
         */
        get virtualServiceNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteSpecHttpRouteActionTarget {
        /**
         * virtual_service block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#virtual_service AppmeshGatewayRoute#virtual_service}
         *
         * @stability stable
         */
        readonly virtualService: AppmeshGatewayRouteSpecHttpRouteActionTargetVirtualService;
    }
    /**
     * @stability stable
     */
    class AppmeshGatewayRouteSpecHttpRouteActionTargetOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _virtualService?;
        private __virtualServiceOutput;
        /**
         * @stability stable
         */
        get virtualService(): AppmeshGatewayRouteSpecHttpRouteActionTargetVirtualServiceOutputReference;
        /**
         * @stability stable
         */
        putVirtualService(value: AppmeshGatewayRouteSpecHttpRouteActionTargetVirtualService): void;
        /**
         * @stability stable
         */
        get virtualServiceInput(): AppmeshGatewayRouteSpecHttpRouteActionTargetVirtualService | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteSpecHttpRouteAction {
        /**
         * target block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#target AppmeshGatewayRoute#target}
         *
         * @stability stable
         */
        readonly target: AppmeshGatewayRouteSpecHttpRouteActionTarget;
    }
    /**
     * @stability stable
     */
    class AppmeshGatewayRouteSpecHttpRouteActionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _target?;
        private __targetOutput;
        /**
         * @stability stable
         */
        get target(): AppmeshGatewayRouteSpecHttpRouteActionTargetOutputReference;
        /**
         * @stability stable
         */
        putTarget(value: AppmeshGatewayRouteSpecHttpRouteActionTarget): void;
        /**
         * @stability stable
         */
        get targetInput(): AppmeshGatewayRouteSpecHttpRouteActionTarget | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteSpecHttpRouteMatch {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#prefix AppmeshGatewayRoute#prefix}.
         *
         * @stability stable
         */
        readonly prefix: string;
    }
    /**
     * @stability stable
     */
    class AppmeshGatewayRouteSpecHttpRouteMatchOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _prefix?;
        /**
         * @stability stable
         */
        get prefix(): string;
        /**
         * @stability stable
         */
        set prefix(value: string);
        /**
         * @stability stable
         */
        get prefixInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteSpecHttpRoute {
        /**
         * action block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#action AppmeshGatewayRoute#action}
         *
         * @stability stable
         */
        readonly action: AppmeshGatewayRouteSpecHttpRouteAction;
        /**
         * match block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#match AppmeshGatewayRoute#match}
         *
         * @stability stable
         */
        readonly match: AppmeshGatewayRouteSpecHttpRouteMatch;
    }
    /**
     * @stability stable
     */
    class AppmeshGatewayRouteSpecHttpRouteOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _action?;
        private __actionOutput;
        /**
         * @stability stable
         */
        get action(): AppmeshGatewayRouteSpecHttpRouteActionOutputReference;
        /**
         * @stability stable
         */
        putAction(value: AppmeshGatewayRouteSpecHttpRouteAction): void;
        /**
         * @stability stable
         */
        get actionInput(): AppmeshGatewayRouteSpecHttpRouteAction | undefined;
        private _match?;
        private __matchOutput;
        /**
         * @stability stable
         */
        get match(): AppmeshGatewayRouteSpecHttpRouteMatchOutputReference;
        /**
         * @stability stable
         */
        putMatch(value: AppmeshGatewayRouteSpecHttpRouteMatch): void;
        /**
         * @stability stable
         */
        get matchInput(): AppmeshGatewayRouteSpecHttpRouteMatch | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshGatewayRouteSpec {
        /**
         * grpc_route block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#grpc_route AppmeshGatewayRoute#grpc_route}
         *
         * @stability stable
         */
        readonly grpcRoute?: AppmeshGatewayRouteSpecGrpcRoute;
        /**
         * http2_route block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#http2_route AppmeshGatewayRoute#http2_route}
         *
         * @stability stable
         */
        readonly http2Route?: AppmeshGatewayRouteSpecHttp2Route;
        /**
         * http_route block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html#http_route AppmeshGatewayRoute#http_route}
         *
         * @stability stable
         */
        readonly httpRoute?: AppmeshGatewayRouteSpecHttpRoute;
    }
    /**
     * @stability stable
     */
    class AppmeshGatewayRouteSpecOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _grpcRoute?;
        private __grpcRouteOutput;
        /**
         * @stability stable
         */
        get grpcRoute(): AppmeshGatewayRouteSpecGrpcRouteOutputReference;
        /**
         * @stability stable
         */
        putGrpcRoute(value: AppmeshGatewayRouteSpecGrpcRoute | undefined): void;
        /**
         * @stability stable
         */
        resetGrpcRoute(): void;
        /**
         * @stability stable
         */
        get grpcRouteInput(): AppmeshGatewayRouteSpecGrpcRoute | undefined;
        private _http2Route?;
        private __http2RouteOutput;
        /**
         * @stability stable
         */
        get http2Route(): AppmeshGatewayRouteSpecHttp2RouteOutputReference;
        /**
         * @stability stable
         */
        putHttp2Route(value: AppmeshGatewayRouteSpecHttp2Route | undefined): void;
        /**
         * @stability stable
         */
        resetHttp2Route(): void;
        /**
         * @stability stable
         */
        get http2RouteInput(): AppmeshGatewayRouteSpecHttp2Route | undefined;
        private _httpRoute?;
        private __httpRouteOutput;
        /**
         * @stability stable
         */
        get httpRoute(): AppmeshGatewayRouteSpecHttpRouteOutputReference;
        /**
         * @stability stable
         */
        putHttpRoute(value: AppmeshGatewayRouteSpecHttpRoute | undefined): void;
        /**
         * @stability stable
         */
        resetHttpRoute(): void;
        /**
         * @stability stable
         */
        get httpRouteInput(): AppmeshGatewayRouteSpecHttpRoute | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html aws_appmesh_gateway_route}.
     *
     * @stability stable
     */
    class AppmeshGatewayRoute extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appmesh_gateway_route.html aws_appmesh_gateway_route} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AppmeshGatewayRouteConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdDate(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        private _meshName?;
        /**
         * @stability stable
         */
        get meshName(): string;
        /**
         * @stability stable
         */
        set meshName(value: string);
        /**
         * @stability stable
         */
        get meshNameInput(): string | undefined;
        private _meshOwner?;
        /**
         * @stability stable
         */
        get meshOwner(): string | undefined;
        /**
         * @stability stable
         */
        set meshOwner(value: string | undefined);
        /**
         * @stability stable
         */
        resetMeshOwner(): void;
        /**
         * @stability stable
         */
        get meshOwnerInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get resourceOwner(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _virtualGatewayName?;
        /**
         * @stability stable
         */
        get virtualGatewayName(): string;
        /**
         * @stability stable
         */
        set virtualGatewayName(value: string);
        /**
         * @stability stable
         */
        get virtualGatewayNameInput(): string | undefined;
        private _spec?;
        private __specOutput;
        /**
         * @stability stable
         */
        get spec(): AppmeshGatewayRouteSpecOutputReference;
        /**
         * @stability stable
         */
        putSpec(value: AppmeshGatewayRouteSpec): void;
        /**
         * @stability stable
         */
        get specInput(): AppmeshGatewayRouteSpec | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AppmeshMeshConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_mesh.html#name AppmeshMesh#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_mesh.html#tags AppmeshMesh#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_mesh.html#tags_all AppmeshMesh#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * spec block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_mesh.html#spec AppmeshMesh#spec}
         *
         * @stability stable
         */
        readonly spec?: AppmeshMeshSpec;
    }
    /**
     * @stability stable
     */
    interface AppmeshMeshSpecEgressFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_mesh.html#type AppmeshMesh#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * @stability stable
     */
    class AppmeshMeshSpecEgressFilterOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _type?;
        /**
         * @stability stable
         */
        get type(): string | undefined;
        /**
         * @stability stable
         */
        set type(value: string | undefined);
        /**
         * @stability stable
         */
        resetType(): void;
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshMeshSpec {
        /**
         * egress_filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_mesh.html#egress_filter AppmeshMesh#egress_filter}
         *
         * @stability stable
         */
        readonly egressFilter?: AppmeshMeshSpecEgressFilter;
    }
    /**
     * @stability stable
     */
    class AppmeshMeshSpecOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _egressFilter?;
        private __egressFilterOutput;
        /**
         * @stability stable
         */
        get egressFilter(): AppmeshMeshSpecEgressFilterOutputReference;
        /**
         * @stability stable
         */
        putEgressFilter(value: AppmeshMeshSpecEgressFilter | undefined): void;
        /**
         * @stability stable
         */
        resetEgressFilter(): void;
        /**
         * @stability stable
         */
        get egressFilterInput(): AppmeshMeshSpecEgressFilter | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appmesh_mesh.html aws_appmesh_mesh}.
     *
     * @stability stable
     */
    class AppmeshMesh extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appmesh_mesh.html aws_appmesh_mesh} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AppmeshMeshConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdDate(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        /**
         * @stability stable
         */
        get meshOwner(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get resourceOwner(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _spec?;
        private __specOutput;
        /**
         * @stability stable
         */
        get spec(): AppmeshMeshSpecOutputReference;
        /**
         * @stability stable
         */
        putSpec(value: AppmeshMeshSpec | undefined): void;
        /**
         * @stability stable
         */
        resetSpec(): void;
        /**
         * @stability stable
         */
        get specInput(): AppmeshMeshSpec | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#mesh_name AppmeshRoute#mesh_name}.
         *
         * @stability stable
         */
        readonly meshName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#mesh_owner AppmeshRoute#mesh_owner}.
         *
         * @stability stable
         */
        readonly meshOwner?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#name AppmeshRoute#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#tags AppmeshRoute#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#tags_all AppmeshRoute#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#virtual_router_name AppmeshRoute#virtual_router_name}.
         *
         * @stability stable
         */
        readonly virtualRouterName: string;
        /**
         * spec block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#spec AppmeshRoute#spec}
         *
         * @stability stable
         */
        readonly spec: AppmeshRouteSpec;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecGrpcRouteActionWeightedTarget {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#virtual_node AppmeshRoute#virtual_node}.
         *
         * @stability stable
         */
        readonly virtualNode: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#weight AppmeshRoute#weight}.
         *
         * @stability stable
         */
        readonly weight: number;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecGrpcRouteAction {
        /**
         * weighted_target block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#weighted_target AppmeshRoute#weighted_target}
         *
         * @stability stable
         */
        readonly weightedTarget: AppmeshRouteSpecGrpcRouteActionWeightedTarget[];
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecGrpcRouteActionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _weightedTarget?;
        /**
         * @stability stable
         */
        get weightedTarget(): AppmeshRouteSpecGrpcRouteActionWeightedTarget[];
        /**
         * @stability stable
         */
        set weightedTarget(value: AppmeshRouteSpecGrpcRouteActionWeightedTarget[]);
        /**
         * @stability stable
         */
        get weightedTargetInput(): AppmeshRouteSpecGrpcRouteActionWeightedTarget[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecGrpcRouteMatchMetadataMatchRange {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#end AppmeshRoute#end}.
         *
         * @stability stable
         */
        readonly end: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#start AppmeshRoute#start}.
         *
         * @stability stable
         */
        readonly start: number;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecGrpcRouteMatchMetadataMatchRangeOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _end?;
        /**
         * @stability stable
         */
        get end(): number;
        /**
         * @stability stable
         */
        set end(value: number);
        /**
         * @stability stable
         */
        get endInput(): number | undefined;
        private _start?;
        /**
         * @stability stable
         */
        get start(): number;
        /**
         * @stability stable
         */
        set start(value: number);
        /**
         * @stability stable
         */
        get startInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecGrpcRouteMatchMetadataMatch {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#exact AppmeshRoute#exact}.
         *
         * @stability stable
         */
        readonly exact?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#prefix AppmeshRoute#prefix}.
         *
         * @stability stable
         */
        readonly prefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#regex AppmeshRoute#regex}.
         *
         * @stability stable
         */
        readonly regex?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#suffix AppmeshRoute#suffix}.
         *
         * @stability stable
         */
        readonly suffix?: string;
        /**
         * range block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#range AppmeshRoute#range}
         *
         * @stability stable
         */
        readonly range?: AppmeshRouteSpecGrpcRouteMatchMetadataMatchRange;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecGrpcRouteMatchMetadataMatchOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _exact?;
        /**
         * @stability stable
         */
        get exact(): string | undefined;
        /**
         * @stability stable
         */
        set exact(value: string | undefined);
        /**
         * @stability stable
         */
        resetExact(): void;
        /**
         * @stability stable
         */
        get exactInput(): string | undefined;
        private _prefix?;
        /**
         * @stability stable
         */
        get prefix(): string | undefined;
        /**
         * @stability stable
         */
        set prefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrefix(): void;
        /**
         * @stability stable
         */
        get prefixInput(): string | undefined;
        private _regex?;
        /**
         * @stability stable
         */
        get regex(): string | undefined;
        /**
         * @stability stable
         */
        set regex(value: string | undefined);
        /**
         * @stability stable
         */
        resetRegex(): void;
        /**
         * @stability stable
         */
        get regexInput(): string | undefined;
        private _suffix?;
        /**
         * @stability stable
         */
        get suffix(): string | undefined;
        /**
         * @stability stable
         */
        set suffix(value: string | undefined);
        /**
         * @stability stable
         */
        resetSuffix(): void;
        /**
         * @stability stable
         */
        get suffixInput(): string | undefined;
        private _range?;
        private __rangeOutput;
        /**
         * @stability stable
         */
        get range(): AppmeshRouteSpecGrpcRouteMatchMetadataMatchRangeOutputReference;
        /**
         * @stability stable
         */
        putRange(value: AppmeshRouteSpecGrpcRouteMatchMetadataMatchRange | undefined): void;
        /**
         * @stability stable
         */
        resetRange(): void;
        /**
         * @stability stable
         */
        get rangeInput(): AppmeshRouteSpecGrpcRouteMatchMetadataMatchRange | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecGrpcRouteMatchMetadata {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#invert AppmeshRoute#invert}.
         *
         * @stability stable
         */
        readonly invert?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#name AppmeshRoute#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * match block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#match AppmeshRoute#match}
         *
         * @stability stable
         */
        readonly match?: AppmeshRouteSpecGrpcRouteMatchMetadataMatch;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecGrpcRouteMatch {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#method_name AppmeshRoute#method_name}.
         *
         * @stability stable
         */
        readonly methodName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#prefix AppmeshRoute#prefix}.
         *
         * @stability stable
         */
        readonly prefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#service_name AppmeshRoute#service_name}.
         *
         * @stability stable
         */
        readonly serviceName?: string;
        /**
         * metadata block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#metadata AppmeshRoute#metadata}
         *
         * @stability stable
         */
        readonly metadata?: AppmeshRouteSpecGrpcRouteMatchMetadata[];
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecGrpcRouteMatchOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _methodName?;
        /**
         * @stability stable
         */
        get methodName(): string | undefined;
        /**
         * @stability stable
         */
        set methodName(value: string | undefined);
        /**
         * @stability stable
         */
        resetMethodName(): void;
        /**
         * @stability stable
         */
        get methodNameInput(): string | undefined;
        private _prefix?;
        /**
         * @stability stable
         */
        get prefix(): string | undefined;
        /**
         * @stability stable
         */
        set prefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrefix(): void;
        /**
         * @stability stable
         */
        get prefixInput(): string | undefined;
        private _serviceName?;
        /**
         * @stability stable
         */
        get serviceName(): string | undefined;
        /**
         * @stability stable
         */
        set serviceName(value: string | undefined);
        /**
         * @stability stable
         */
        resetServiceName(): void;
        /**
         * @stability stable
         */
        get serviceNameInput(): string | undefined;
        private _metadata?;
        /**
         * @stability stable
         */
        get metadata(): AppmeshRouteSpecGrpcRouteMatchMetadata[] | undefined;
        /**
         * @stability stable
         */
        set metadata(value: AppmeshRouteSpecGrpcRouteMatchMetadata[] | undefined);
        /**
         * @stability stable
         */
        resetMetadata(): void;
        /**
         * @stability stable
         */
        get metadataInput(): AppmeshRouteSpecGrpcRouteMatchMetadata[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeout {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeoutOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecGrpcRouteRetryPolicy {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#grpc_retry_events AppmeshRoute#grpc_retry_events}.
         *
         * @stability stable
         */
        readonly grpcRetryEvents?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#http_retry_events AppmeshRoute#http_retry_events}.
         *
         * @stability stable
         */
        readonly httpRetryEvents?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#max_retries AppmeshRoute#max_retries}.
         *
         * @stability stable
         */
        readonly maxRetries: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#tcp_retry_events AppmeshRoute#tcp_retry_events}.
         *
         * @stability stable
         */
        readonly tcpRetryEvents?: string[];
        /**
         * per_retry_timeout block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#per_retry_timeout AppmeshRoute#per_retry_timeout}
         *
         * @stability stable
         */
        readonly perRetryTimeout: AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeout;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecGrpcRouteRetryPolicyOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _grpcRetryEvents?;
        /**
         * @stability stable
         */
        get grpcRetryEvents(): string[] | undefined;
        /**
         * @stability stable
         */
        set grpcRetryEvents(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetGrpcRetryEvents(): void;
        /**
         * @stability stable
         */
        get grpcRetryEventsInput(): string[] | undefined;
        private _httpRetryEvents?;
        /**
         * @stability stable
         */
        get httpRetryEvents(): string[] | undefined;
        /**
         * @stability stable
         */
        set httpRetryEvents(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetHttpRetryEvents(): void;
        /**
         * @stability stable
         */
        get httpRetryEventsInput(): string[] | undefined;
        private _maxRetries?;
        /**
         * @stability stable
         */
        get maxRetries(): number;
        /**
         * @stability stable
         */
        set maxRetries(value: number);
        /**
         * @stability stable
         */
        get maxRetriesInput(): number | undefined;
        private _tcpRetryEvents?;
        /**
         * @stability stable
         */
        get tcpRetryEvents(): string[] | undefined;
        /**
         * @stability stable
         */
        set tcpRetryEvents(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetTcpRetryEvents(): void;
        /**
         * @stability stable
         */
        get tcpRetryEventsInput(): string[] | undefined;
        private _perRetryTimeout?;
        private __perRetryTimeoutOutput;
        /**
         * @stability stable
         */
        get perRetryTimeout(): AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeoutOutputReference;
        /**
         * @stability stable
         */
        putPerRetryTimeout(value: AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeout): void;
        /**
         * @stability stable
         */
        get perRetryTimeoutInput(): AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeout | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecGrpcRouteTimeoutIdle {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecGrpcRouteTimeoutIdleOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecGrpcRouteTimeoutPerRequest {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecGrpcRouteTimeoutPerRequestOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecGrpcRouteTimeout {
        /**
         * idle block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#idle AppmeshRoute#idle}
         *
         * @stability stable
         */
        readonly idle?: AppmeshRouteSpecGrpcRouteTimeoutIdle;
        /**
         * per_request block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#per_request AppmeshRoute#per_request}
         *
         * @stability stable
         */
        readonly perRequest?: AppmeshRouteSpecGrpcRouteTimeoutPerRequest;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecGrpcRouteTimeoutOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _idle?;
        private __idleOutput;
        /**
         * @stability stable
         */
        get idle(): AppmeshRouteSpecGrpcRouteTimeoutIdleOutputReference;
        /**
         * @stability stable
         */
        putIdle(value: AppmeshRouteSpecGrpcRouteTimeoutIdle | undefined): void;
        /**
         * @stability stable
         */
        resetIdle(): void;
        /**
         * @stability stable
         */
        get idleInput(): AppmeshRouteSpecGrpcRouteTimeoutIdle | undefined;
        private _perRequest?;
        private __perRequestOutput;
        /**
         * @stability stable
         */
        get perRequest(): AppmeshRouteSpecGrpcRouteTimeoutPerRequestOutputReference;
        /**
         * @stability stable
         */
        putPerRequest(value: AppmeshRouteSpecGrpcRouteTimeoutPerRequest | undefined): void;
        /**
         * @stability stable
         */
        resetPerRequest(): void;
        /**
         * @stability stable
         */
        get perRequestInput(): AppmeshRouteSpecGrpcRouteTimeoutPerRequest | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecGrpcRoute {
        /**
         * action block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#action AppmeshRoute#action}
         *
         * @stability stable
         */
        readonly action: AppmeshRouteSpecGrpcRouteAction;
        /**
         * match block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#match AppmeshRoute#match}
         *
         * @stability stable
         */
        readonly match?: AppmeshRouteSpecGrpcRouteMatch;
        /**
         * retry_policy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#retry_policy AppmeshRoute#retry_policy}
         *
         * @stability stable
         */
        readonly retryPolicy?: AppmeshRouteSpecGrpcRouteRetryPolicy;
        /**
         * timeout block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#timeout AppmeshRoute#timeout}
         *
         * @stability stable
         */
        readonly timeout?: AppmeshRouteSpecGrpcRouteTimeout;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecGrpcRouteOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _action?;
        private __actionOutput;
        /**
         * @stability stable
         */
        get action(): AppmeshRouteSpecGrpcRouteActionOutputReference;
        /**
         * @stability stable
         */
        putAction(value: AppmeshRouteSpecGrpcRouteAction): void;
        /**
         * @stability stable
         */
        get actionInput(): AppmeshRouteSpecGrpcRouteAction | undefined;
        private _match?;
        private __matchOutput;
        /**
         * @stability stable
         */
        get match(): AppmeshRouteSpecGrpcRouteMatchOutputReference;
        /**
         * @stability stable
         */
        putMatch(value: AppmeshRouteSpecGrpcRouteMatch | undefined): void;
        /**
         * @stability stable
         */
        resetMatch(): void;
        /**
         * @stability stable
         */
        get matchInput(): AppmeshRouteSpecGrpcRouteMatch | undefined;
        private _retryPolicy?;
        private __retryPolicyOutput;
        /**
         * @stability stable
         */
        get retryPolicy(): AppmeshRouteSpecGrpcRouteRetryPolicyOutputReference;
        /**
         * @stability stable
         */
        putRetryPolicy(value: AppmeshRouteSpecGrpcRouteRetryPolicy | undefined): void;
        /**
         * @stability stable
         */
        resetRetryPolicy(): void;
        /**
         * @stability stable
         */
        get retryPolicyInput(): AppmeshRouteSpecGrpcRouteRetryPolicy | undefined;
        private _timeout?;
        private __timeoutOutput;
        /**
         * @stability stable
         */
        get timeout(): AppmeshRouteSpecGrpcRouteTimeoutOutputReference;
        /**
         * @stability stable
         */
        putTimeout(value: AppmeshRouteSpecGrpcRouteTimeout | undefined): void;
        /**
         * @stability stable
         */
        resetTimeout(): void;
        /**
         * @stability stable
         */
        get timeoutInput(): AppmeshRouteSpecGrpcRouteTimeout | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttp2RouteActionWeightedTarget {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#virtual_node AppmeshRoute#virtual_node}.
         *
         * @stability stable
         */
        readonly virtualNode: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#weight AppmeshRoute#weight}.
         *
         * @stability stable
         */
        readonly weight: number;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttp2RouteAction {
        /**
         * weighted_target block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#weighted_target AppmeshRoute#weighted_target}
         *
         * @stability stable
         */
        readonly weightedTarget: AppmeshRouteSpecHttp2RouteActionWeightedTarget[];
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttp2RouteActionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _weightedTarget?;
        /**
         * @stability stable
         */
        get weightedTarget(): AppmeshRouteSpecHttp2RouteActionWeightedTarget[];
        /**
         * @stability stable
         */
        set weightedTarget(value: AppmeshRouteSpecHttp2RouteActionWeightedTarget[]);
        /**
         * @stability stable
         */
        get weightedTargetInput(): AppmeshRouteSpecHttp2RouteActionWeightedTarget[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttp2RouteMatchHeaderMatchRange {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#end AppmeshRoute#end}.
         *
         * @stability stable
         */
        readonly end: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#start AppmeshRoute#start}.
         *
         * @stability stable
         */
        readonly start: number;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttp2RouteMatchHeaderMatchRangeOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _end?;
        /**
         * @stability stable
         */
        get end(): number;
        /**
         * @stability stable
         */
        set end(value: number);
        /**
         * @stability stable
         */
        get endInput(): number | undefined;
        private _start?;
        /**
         * @stability stable
         */
        get start(): number;
        /**
         * @stability stable
         */
        set start(value: number);
        /**
         * @stability stable
         */
        get startInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttp2RouteMatchHeaderMatch {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#exact AppmeshRoute#exact}.
         *
         * @stability stable
         */
        readonly exact?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#prefix AppmeshRoute#prefix}.
         *
         * @stability stable
         */
        readonly prefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#regex AppmeshRoute#regex}.
         *
         * @stability stable
         */
        readonly regex?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#suffix AppmeshRoute#suffix}.
         *
         * @stability stable
         */
        readonly suffix?: string;
        /**
         * range block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#range AppmeshRoute#range}
         *
         * @stability stable
         */
        readonly range?: AppmeshRouteSpecHttp2RouteMatchHeaderMatchRange;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttp2RouteMatchHeaderMatchOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _exact?;
        /**
         * @stability stable
         */
        get exact(): string | undefined;
        /**
         * @stability stable
         */
        set exact(value: string | undefined);
        /**
         * @stability stable
         */
        resetExact(): void;
        /**
         * @stability stable
         */
        get exactInput(): string | undefined;
        private _prefix?;
        /**
         * @stability stable
         */
        get prefix(): string | undefined;
        /**
         * @stability stable
         */
        set prefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrefix(): void;
        /**
         * @stability stable
         */
        get prefixInput(): string | undefined;
        private _regex?;
        /**
         * @stability stable
         */
        get regex(): string | undefined;
        /**
         * @stability stable
         */
        set regex(value: string | undefined);
        /**
         * @stability stable
         */
        resetRegex(): void;
        /**
         * @stability stable
         */
        get regexInput(): string | undefined;
        private _suffix?;
        /**
         * @stability stable
         */
        get suffix(): string | undefined;
        /**
         * @stability stable
         */
        set suffix(value: string | undefined);
        /**
         * @stability stable
         */
        resetSuffix(): void;
        /**
         * @stability stable
         */
        get suffixInput(): string | undefined;
        private _range?;
        private __rangeOutput;
        /**
         * @stability stable
         */
        get range(): AppmeshRouteSpecHttp2RouteMatchHeaderMatchRangeOutputReference;
        /**
         * @stability stable
         */
        putRange(value: AppmeshRouteSpecHttp2RouteMatchHeaderMatchRange | undefined): void;
        /**
         * @stability stable
         */
        resetRange(): void;
        /**
         * @stability stable
         */
        get rangeInput(): AppmeshRouteSpecHttp2RouteMatchHeaderMatchRange | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttp2RouteMatchHeader {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#invert AppmeshRoute#invert}.
         *
         * @stability stable
         */
        readonly invert?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#name AppmeshRoute#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * match block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#match AppmeshRoute#match}
         *
         * @stability stable
         */
        readonly match?: AppmeshRouteSpecHttp2RouteMatchHeaderMatch;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttp2RouteMatch {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#method AppmeshRoute#method}.
         *
         * @stability stable
         */
        readonly method?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#prefix AppmeshRoute#prefix}.
         *
         * @stability stable
         */
        readonly prefix: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#scheme AppmeshRoute#scheme}.
         *
         * @stability stable
         */
        readonly scheme?: string;
        /**
         * header block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#header AppmeshRoute#header}
         *
         * @stability stable
         */
        readonly header?: AppmeshRouteSpecHttp2RouteMatchHeader[];
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttp2RouteMatchOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _method?;
        /**
         * @stability stable
         */
        get method(): string | undefined;
        /**
         * @stability stable
         */
        set method(value: string | undefined);
        /**
         * @stability stable
         */
        resetMethod(): void;
        /**
         * @stability stable
         */
        get methodInput(): string | undefined;
        private _prefix?;
        /**
         * @stability stable
         */
        get prefix(): string;
        /**
         * @stability stable
         */
        set prefix(value: string);
        /**
         * @stability stable
         */
        get prefixInput(): string | undefined;
        private _scheme?;
        /**
         * @stability stable
         */
        get scheme(): string | undefined;
        /**
         * @stability stable
         */
        set scheme(value: string | undefined);
        /**
         * @stability stable
         */
        resetScheme(): void;
        /**
         * @stability stable
         */
        get schemeInput(): string | undefined;
        private _header?;
        /**
         * @stability stable
         */
        get header(): AppmeshRouteSpecHttp2RouteMatchHeader[] | undefined;
        /**
         * @stability stable
         */
        set header(value: AppmeshRouteSpecHttp2RouteMatchHeader[] | undefined);
        /**
         * @stability stable
         */
        resetHeader(): void;
        /**
         * @stability stable
         */
        get headerInput(): AppmeshRouteSpecHttp2RouteMatchHeader[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeout {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeoutOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttp2RouteRetryPolicy {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#http_retry_events AppmeshRoute#http_retry_events}.
         *
         * @stability stable
         */
        readonly httpRetryEvents?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#max_retries AppmeshRoute#max_retries}.
         *
         * @stability stable
         */
        readonly maxRetries: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#tcp_retry_events AppmeshRoute#tcp_retry_events}.
         *
         * @stability stable
         */
        readonly tcpRetryEvents?: string[];
        /**
         * per_retry_timeout block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#per_retry_timeout AppmeshRoute#per_retry_timeout}
         *
         * @stability stable
         */
        readonly perRetryTimeout: AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeout;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttp2RouteRetryPolicyOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _httpRetryEvents?;
        /**
         * @stability stable
         */
        get httpRetryEvents(): string[] | undefined;
        /**
         * @stability stable
         */
        set httpRetryEvents(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetHttpRetryEvents(): void;
        /**
         * @stability stable
         */
        get httpRetryEventsInput(): string[] | undefined;
        private _maxRetries?;
        /**
         * @stability stable
         */
        get maxRetries(): number;
        /**
         * @stability stable
         */
        set maxRetries(value: number);
        /**
         * @stability stable
         */
        get maxRetriesInput(): number | undefined;
        private _tcpRetryEvents?;
        /**
         * @stability stable
         */
        get tcpRetryEvents(): string[] | undefined;
        /**
         * @stability stable
         */
        set tcpRetryEvents(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetTcpRetryEvents(): void;
        /**
         * @stability stable
         */
        get tcpRetryEventsInput(): string[] | undefined;
        private _perRetryTimeout?;
        private __perRetryTimeoutOutput;
        /**
         * @stability stable
         */
        get perRetryTimeout(): AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeoutOutputReference;
        /**
         * @stability stable
         */
        putPerRetryTimeout(value: AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeout): void;
        /**
         * @stability stable
         */
        get perRetryTimeoutInput(): AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeout | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttp2RouteTimeoutIdle {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttp2RouteTimeoutIdleOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttp2RouteTimeoutPerRequest {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttp2RouteTimeoutPerRequestOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttp2RouteTimeout {
        /**
         * idle block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#idle AppmeshRoute#idle}
         *
         * @stability stable
         */
        readonly idle?: AppmeshRouteSpecHttp2RouteTimeoutIdle;
        /**
         * per_request block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#per_request AppmeshRoute#per_request}
         *
         * @stability stable
         */
        readonly perRequest?: AppmeshRouteSpecHttp2RouteTimeoutPerRequest;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttp2RouteTimeoutOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _idle?;
        private __idleOutput;
        /**
         * @stability stable
         */
        get idle(): AppmeshRouteSpecHttp2RouteTimeoutIdleOutputReference;
        /**
         * @stability stable
         */
        putIdle(value: AppmeshRouteSpecHttp2RouteTimeoutIdle | undefined): void;
        /**
         * @stability stable
         */
        resetIdle(): void;
        /**
         * @stability stable
         */
        get idleInput(): AppmeshRouteSpecHttp2RouteTimeoutIdle | undefined;
        private _perRequest?;
        private __perRequestOutput;
        /**
         * @stability stable
         */
        get perRequest(): AppmeshRouteSpecHttp2RouteTimeoutPerRequestOutputReference;
        /**
         * @stability stable
         */
        putPerRequest(value: AppmeshRouteSpecHttp2RouteTimeoutPerRequest | undefined): void;
        /**
         * @stability stable
         */
        resetPerRequest(): void;
        /**
         * @stability stable
         */
        get perRequestInput(): AppmeshRouteSpecHttp2RouteTimeoutPerRequest | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttp2Route {
        /**
         * action block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#action AppmeshRoute#action}
         *
         * @stability stable
         */
        readonly action: AppmeshRouteSpecHttp2RouteAction;
        /**
         * match block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#match AppmeshRoute#match}
         *
         * @stability stable
         */
        readonly match: AppmeshRouteSpecHttp2RouteMatch;
        /**
         * retry_policy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#retry_policy AppmeshRoute#retry_policy}
         *
         * @stability stable
         */
        readonly retryPolicy?: AppmeshRouteSpecHttp2RouteRetryPolicy;
        /**
         * timeout block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#timeout AppmeshRoute#timeout}
         *
         * @stability stable
         */
        readonly timeout?: AppmeshRouteSpecHttp2RouteTimeout;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttp2RouteOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _action?;
        private __actionOutput;
        /**
         * @stability stable
         */
        get action(): AppmeshRouteSpecHttp2RouteActionOutputReference;
        /**
         * @stability stable
         */
        putAction(value: AppmeshRouteSpecHttp2RouteAction): void;
        /**
         * @stability stable
         */
        get actionInput(): AppmeshRouteSpecHttp2RouteAction | undefined;
        private _match?;
        private __matchOutput;
        /**
         * @stability stable
         */
        get match(): AppmeshRouteSpecHttp2RouteMatchOutputReference;
        /**
         * @stability stable
         */
        putMatch(value: AppmeshRouteSpecHttp2RouteMatch): void;
        /**
         * @stability stable
         */
        get matchInput(): AppmeshRouteSpecHttp2RouteMatch | undefined;
        private _retryPolicy?;
        private __retryPolicyOutput;
        /**
         * @stability stable
         */
        get retryPolicy(): AppmeshRouteSpecHttp2RouteRetryPolicyOutputReference;
        /**
         * @stability stable
         */
        putRetryPolicy(value: AppmeshRouteSpecHttp2RouteRetryPolicy | undefined): void;
        /**
         * @stability stable
         */
        resetRetryPolicy(): void;
        /**
         * @stability stable
         */
        get retryPolicyInput(): AppmeshRouteSpecHttp2RouteRetryPolicy | undefined;
        private _timeout?;
        private __timeoutOutput;
        /**
         * @stability stable
         */
        get timeout(): AppmeshRouteSpecHttp2RouteTimeoutOutputReference;
        /**
         * @stability stable
         */
        putTimeout(value: AppmeshRouteSpecHttp2RouteTimeout | undefined): void;
        /**
         * @stability stable
         */
        resetTimeout(): void;
        /**
         * @stability stable
         */
        get timeoutInput(): AppmeshRouteSpecHttp2RouteTimeout | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttpRouteActionWeightedTarget {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#virtual_node AppmeshRoute#virtual_node}.
         *
         * @stability stable
         */
        readonly virtualNode: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#weight AppmeshRoute#weight}.
         *
         * @stability stable
         */
        readonly weight: number;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttpRouteAction {
        /**
         * weighted_target block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#weighted_target AppmeshRoute#weighted_target}
         *
         * @stability stable
         */
        readonly weightedTarget: AppmeshRouteSpecHttpRouteActionWeightedTarget[];
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttpRouteActionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _weightedTarget?;
        /**
         * @stability stable
         */
        get weightedTarget(): AppmeshRouteSpecHttpRouteActionWeightedTarget[];
        /**
         * @stability stable
         */
        set weightedTarget(value: AppmeshRouteSpecHttpRouteActionWeightedTarget[]);
        /**
         * @stability stable
         */
        get weightedTargetInput(): AppmeshRouteSpecHttpRouteActionWeightedTarget[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttpRouteMatchHeaderMatchRange {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#end AppmeshRoute#end}.
         *
         * @stability stable
         */
        readonly end: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#start AppmeshRoute#start}.
         *
         * @stability stable
         */
        readonly start: number;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttpRouteMatchHeaderMatchRangeOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _end?;
        /**
         * @stability stable
         */
        get end(): number;
        /**
         * @stability stable
         */
        set end(value: number);
        /**
         * @stability stable
         */
        get endInput(): number | undefined;
        private _start?;
        /**
         * @stability stable
         */
        get start(): number;
        /**
         * @stability stable
         */
        set start(value: number);
        /**
         * @stability stable
         */
        get startInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttpRouteMatchHeaderMatch {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#exact AppmeshRoute#exact}.
         *
         * @stability stable
         */
        readonly exact?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#prefix AppmeshRoute#prefix}.
         *
         * @stability stable
         */
        readonly prefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#regex AppmeshRoute#regex}.
         *
         * @stability stable
         */
        readonly regex?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#suffix AppmeshRoute#suffix}.
         *
         * @stability stable
         */
        readonly suffix?: string;
        /**
         * range block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#range AppmeshRoute#range}
         *
         * @stability stable
         */
        readonly range?: AppmeshRouteSpecHttpRouteMatchHeaderMatchRange;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttpRouteMatchHeaderMatchOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _exact?;
        /**
         * @stability stable
         */
        get exact(): string | undefined;
        /**
         * @stability stable
         */
        set exact(value: string | undefined);
        /**
         * @stability stable
         */
        resetExact(): void;
        /**
         * @stability stable
         */
        get exactInput(): string | undefined;
        private _prefix?;
        /**
         * @stability stable
         */
        get prefix(): string | undefined;
        /**
         * @stability stable
         */
        set prefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrefix(): void;
        /**
         * @stability stable
         */
        get prefixInput(): string | undefined;
        private _regex?;
        /**
         * @stability stable
         */
        get regex(): string | undefined;
        /**
         * @stability stable
         */
        set regex(value: string | undefined);
        /**
         * @stability stable
         */
        resetRegex(): void;
        /**
         * @stability stable
         */
        get regexInput(): string | undefined;
        private _suffix?;
        /**
         * @stability stable
         */
        get suffix(): string | undefined;
        /**
         * @stability stable
         */
        set suffix(value: string | undefined);
        /**
         * @stability stable
         */
        resetSuffix(): void;
        /**
         * @stability stable
         */
        get suffixInput(): string | undefined;
        private _range?;
        private __rangeOutput;
        /**
         * @stability stable
         */
        get range(): AppmeshRouteSpecHttpRouteMatchHeaderMatchRangeOutputReference;
        /**
         * @stability stable
         */
        putRange(value: AppmeshRouteSpecHttpRouteMatchHeaderMatchRange | undefined): void;
        /**
         * @stability stable
         */
        resetRange(): void;
        /**
         * @stability stable
         */
        get rangeInput(): AppmeshRouteSpecHttpRouteMatchHeaderMatchRange | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttpRouteMatchHeader {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#invert AppmeshRoute#invert}.
         *
         * @stability stable
         */
        readonly invert?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#name AppmeshRoute#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * match block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#match AppmeshRoute#match}
         *
         * @stability stable
         */
        readonly match?: AppmeshRouteSpecHttpRouteMatchHeaderMatch;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttpRouteMatch {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#method AppmeshRoute#method}.
         *
         * @stability stable
         */
        readonly method?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#prefix AppmeshRoute#prefix}.
         *
         * @stability stable
         */
        readonly prefix: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#scheme AppmeshRoute#scheme}.
         *
         * @stability stable
         */
        readonly scheme?: string;
        /**
         * header block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#header AppmeshRoute#header}
         *
         * @stability stable
         */
        readonly header?: AppmeshRouteSpecHttpRouteMatchHeader[];
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttpRouteMatchOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _method?;
        /**
         * @stability stable
         */
        get method(): string | undefined;
        /**
         * @stability stable
         */
        set method(value: string | undefined);
        /**
         * @stability stable
         */
        resetMethod(): void;
        /**
         * @stability stable
         */
        get methodInput(): string | undefined;
        private _prefix?;
        /**
         * @stability stable
         */
        get prefix(): string;
        /**
         * @stability stable
         */
        set prefix(value: string);
        /**
         * @stability stable
         */
        get prefixInput(): string | undefined;
        private _scheme?;
        /**
         * @stability stable
         */
        get scheme(): string | undefined;
        /**
         * @stability stable
         */
        set scheme(value: string | undefined);
        /**
         * @stability stable
         */
        resetScheme(): void;
        /**
         * @stability stable
         */
        get schemeInput(): string | undefined;
        private _header?;
        /**
         * @stability stable
         */
        get header(): AppmeshRouteSpecHttpRouteMatchHeader[] | undefined;
        /**
         * @stability stable
         */
        set header(value: AppmeshRouteSpecHttpRouteMatchHeader[] | undefined);
        /**
         * @stability stable
         */
        resetHeader(): void;
        /**
         * @stability stable
         */
        get headerInput(): AppmeshRouteSpecHttpRouteMatchHeader[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeout {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeoutOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttpRouteRetryPolicy {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#http_retry_events AppmeshRoute#http_retry_events}.
         *
         * @stability stable
         */
        readonly httpRetryEvents?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#max_retries AppmeshRoute#max_retries}.
         *
         * @stability stable
         */
        readonly maxRetries: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#tcp_retry_events AppmeshRoute#tcp_retry_events}.
         *
         * @stability stable
         */
        readonly tcpRetryEvents?: string[];
        /**
         * per_retry_timeout block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#per_retry_timeout AppmeshRoute#per_retry_timeout}
         *
         * @stability stable
         */
        readonly perRetryTimeout: AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeout;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttpRouteRetryPolicyOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _httpRetryEvents?;
        /**
         * @stability stable
         */
        get httpRetryEvents(): string[] | undefined;
        /**
         * @stability stable
         */
        set httpRetryEvents(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetHttpRetryEvents(): void;
        /**
         * @stability stable
         */
        get httpRetryEventsInput(): string[] | undefined;
        private _maxRetries?;
        /**
         * @stability stable
         */
        get maxRetries(): number;
        /**
         * @stability stable
         */
        set maxRetries(value: number);
        /**
         * @stability stable
         */
        get maxRetriesInput(): number | undefined;
        private _tcpRetryEvents?;
        /**
         * @stability stable
         */
        get tcpRetryEvents(): string[] | undefined;
        /**
         * @stability stable
         */
        set tcpRetryEvents(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetTcpRetryEvents(): void;
        /**
         * @stability stable
         */
        get tcpRetryEventsInput(): string[] | undefined;
        private _perRetryTimeout?;
        private __perRetryTimeoutOutput;
        /**
         * @stability stable
         */
        get perRetryTimeout(): AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeoutOutputReference;
        /**
         * @stability stable
         */
        putPerRetryTimeout(value: AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeout): void;
        /**
         * @stability stable
         */
        get perRetryTimeoutInput(): AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeout | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttpRouteTimeoutIdle {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttpRouteTimeoutIdleOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttpRouteTimeoutPerRequest {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttpRouteTimeoutPerRequestOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttpRouteTimeout {
        /**
         * idle block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#idle AppmeshRoute#idle}
         *
         * @stability stable
         */
        readonly idle?: AppmeshRouteSpecHttpRouteTimeoutIdle;
        /**
         * per_request block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#per_request AppmeshRoute#per_request}
         *
         * @stability stable
         */
        readonly perRequest?: AppmeshRouteSpecHttpRouteTimeoutPerRequest;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttpRouteTimeoutOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _idle?;
        private __idleOutput;
        /**
         * @stability stable
         */
        get idle(): AppmeshRouteSpecHttpRouteTimeoutIdleOutputReference;
        /**
         * @stability stable
         */
        putIdle(value: AppmeshRouteSpecHttpRouteTimeoutIdle | undefined): void;
        /**
         * @stability stable
         */
        resetIdle(): void;
        /**
         * @stability stable
         */
        get idleInput(): AppmeshRouteSpecHttpRouteTimeoutIdle | undefined;
        private _perRequest?;
        private __perRequestOutput;
        /**
         * @stability stable
         */
        get perRequest(): AppmeshRouteSpecHttpRouteTimeoutPerRequestOutputReference;
        /**
         * @stability stable
         */
        putPerRequest(value: AppmeshRouteSpecHttpRouteTimeoutPerRequest | undefined): void;
        /**
         * @stability stable
         */
        resetPerRequest(): void;
        /**
         * @stability stable
         */
        get perRequestInput(): AppmeshRouteSpecHttpRouteTimeoutPerRequest | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecHttpRoute {
        /**
         * action block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#action AppmeshRoute#action}
         *
         * @stability stable
         */
        readonly action: AppmeshRouteSpecHttpRouteAction;
        /**
         * match block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#match AppmeshRoute#match}
         *
         * @stability stable
         */
        readonly match: AppmeshRouteSpecHttpRouteMatch;
        /**
         * retry_policy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#retry_policy AppmeshRoute#retry_policy}
         *
         * @stability stable
         */
        readonly retryPolicy?: AppmeshRouteSpecHttpRouteRetryPolicy;
        /**
         * timeout block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#timeout AppmeshRoute#timeout}
         *
         * @stability stable
         */
        readonly timeout?: AppmeshRouteSpecHttpRouteTimeout;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecHttpRouteOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _action?;
        private __actionOutput;
        /**
         * @stability stable
         */
        get action(): AppmeshRouteSpecHttpRouteActionOutputReference;
        /**
         * @stability stable
         */
        putAction(value: AppmeshRouteSpecHttpRouteAction): void;
        /**
         * @stability stable
         */
        get actionInput(): AppmeshRouteSpecHttpRouteAction | undefined;
        private _match?;
        private __matchOutput;
        /**
         * @stability stable
         */
        get match(): AppmeshRouteSpecHttpRouteMatchOutputReference;
        /**
         * @stability stable
         */
        putMatch(value: AppmeshRouteSpecHttpRouteMatch): void;
        /**
         * @stability stable
         */
        get matchInput(): AppmeshRouteSpecHttpRouteMatch | undefined;
        private _retryPolicy?;
        private __retryPolicyOutput;
        /**
         * @stability stable
         */
        get retryPolicy(): AppmeshRouteSpecHttpRouteRetryPolicyOutputReference;
        /**
         * @stability stable
         */
        putRetryPolicy(value: AppmeshRouteSpecHttpRouteRetryPolicy | undefined): void;
        /**
         * @stability stable
         */
        resetRetryPolicy(): void;
        /**
         * @stability stable
         */
        get retryPolicyInput(): AppmeshRouteSpecHttpRouteRetryPolicy | undefined;
        private _timeout?;
        private __timeoutOutput;
        /**
         * @stability stable
         */
        get timeout(): AppmeshRouteSpecHttpRouteTimeoutOutputReference;
        /**
         * @stability stable
         */
        putTimeout(value: AppmeshRouteSpecHttpRouteTimeout | undefined): void;
        /**
         * @stability stable
         */
        resetTimeout(): void;
        /**
         * @stability stable
         */
        get timeoutInput(): AppmeshRouteSpecHttpRouteTimeout | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecTcpRouteActionWeightedTarget {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#virtual_node AppmeshRoute#virtual_node}.
         *
         * @stability stable
         */
        readonly virtualNode: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#weight AppmeshRoute#weight}.
         *
         * @stability stable
         */
        readonly weight: number;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecTcpRouteAction {
        /**
         * weighted_target block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#weighted_target AppmeshRoute#weighted_target}
         *
         * @stability stable
         */
        readonly weightedTarget: AppmeshRouteSpecTcpRouteActionWeightedTarget[];
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecTcpRouteActionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _weightedTarget?;
        /**
         * @stability stable
         */
        get weightedTarget(): AppmeshRouteSpecTcpRouteActionWeightedTarget[];
        /**
         * @stability stable
         */
        set weightedTarget(value: AppmeshRouteSpecTcpRouteActionWeightedTarget[]);
        /**
         * @stability stable
         */
        get weightedTargetInput(): AppmeshRouteSpecTcpRouteActionWeightedTarget[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecTcpRouteTimeoutIdle {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#unit AppmeshRoute#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#value AppmeshRoute#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecTcpRouteTimeoutIdleOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecTcpRouteTimeout {
        /**
         * idle block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#idle AppmeshRoute#idle}
         *
         * @stability stable
         */
        readonly idle?: AppmeshRouteSpecTcpRouteTimeoutIdle;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecTcpRouteTimeoutOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _idle?;
        private __idleOutput;
        /**
         * @stability stable
         */
        get idle(): AppmeshRouteSpecTcpRouteTimeoutIdleOutputReference;
        /**
         * @stability stable
         */
        putIdle(value: AppmeshRouteSpecTcpRouteTimeoutIdle | undefined): void;
        /**
         * @stability stable
         */
        resetIdle(): void;
        /**
         * @stability stable
         */
        get idleInput(): AppmeshRouteSpecTcpRouteTimeoutIdle | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpecTcpRoute {
        /**
         * action block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#action AppmeshRoute#action}
         *
         * @stability stable
         */
        readonly action: AppmeshRouteSpecTcpRouteAction;
        /**
         * timeout block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#timeout AppmeshRoute#timeout}
         *
         * @stability stable
         */
        readonly timeout?: AppmeshRouteSpecTcpRouteTimeout;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecTcpRouteOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _action?;
        private __actionOutput;
        /**
         * @stability stable
         */
        get action(): AppmeshRouteSpecTcpRouteActionOutputReference;
        /**
         * @stability stable
         */
        putAction(value: AppmeshRouteSpecTcpRouteAction): void;
        /**
         * @stability stable
         */
        get actionInput(): AppmeshRouteSpecTcpRouteAction | undefined;
        private _timeout?;
        private __timeoutOutput;
        /**
         * @stability stable
         */
        get timeout(): AppmeshRouteSpecTcpRouteTimeoutOutputReference;
        /**
         * @stability stable
         */
        putTimeout(value: AppmeshRouteSpecTcpRouteTimeout | undefined): void;
        /**
         * @stability stable
         */
        resetTimeout(): void;
        /**
         * @stability stable
         */
        get timeoutInput(): AppmeshRouteSpecTcpRouteTimeout | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshRouteSpec {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#priority AppmeshRoute#priority}.
         *
         * @stability stable
         */
        readonly priority?: number;
        /**
         * grpc_route block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#grpc_route AppmeshRoute#grpc_route}
         *
         * @stability stable
         */
        readonly grpcRoute?: AppmeshRouteSpecGrpcRoute;
        /**
         * http2_route block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#http2_route AppmeshRoute#http2_route}
         *
         * @stability stable
         */
        readonly http2Route?: AppmeshRouteSpecHttp2Route;
        /**
         * http_route block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#http_route AppmeshRoute#http_route}
         *
         * @stability stable
         */
        readonly httpRoute?: AppmeshRouteSpecHttpRoute;
        /**
         * tcp_route block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html#tcp_route AppmeshRoute#tcp_route}
         *
         * @stability stable
         */
        readonly tcpRoute?: AppmeshRouteSpecTcpRoute;
    }
    /**
     * @stability stable
     */
    class AppmeshRouteSpecOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _priority?;
        /**
         * @stability stable
         */
        get priority(): number | undefined;
        /**
         * @stability stable
         */
        set priority(value: number | undefined);
        /**
         * @stability stable
         */
        resetPriority(): void;
        /**
         * @stability stable
         */
        get priorityInput(): number | undefined;
        private _grpcRoute?;
        private __grpcRouteOutput;
        /**
         * @stability stable
         */
        get grpcRoute(): AppmeshRouteSpecGrpcRouteOutputReference;
        /**
         * @stability stable
         */
        putGrpcRoute(value: AppmeshRouteSpecGrpcRoute | undefined): void;
        /**
         * @stability stable
         */
        resetGrpcRoute(): void;
        /**
         * @stability stable
         */
        get grpcRouteInput(): AppmeshRouteSpecGrpcRoute | undefined;
        private _http2Route?;
        private __http2RouteOutput;
        /**
         * @stability stable
         */
        get http2Route(): AppmeshRouteSpecHttp2RouteOutputReference;
        /**
         * @stability stable
         */
        putHttp2Route(value: AppmeshRouteSpecHttp2Route | undefined): void;
        /**
         * @stability stable
         */
        resetHttp2Route(): void;
        /**
         * @stability stable
         */
        get http2RouteInput(): AppmeshRouteSpecHttp2Route | undefined;
        private _httpRoute?;
        private __httpRouteOutput;
        /**
         * @stability stable
         */
        get httpRoute(): AppmeshRouteSpecHttpRouteOutputReference;
        /**
         * @stability stable
         */
        putHttpRoute(value: AppmeshRouteSpecHttpRoute | undefined): void;
        /**
         * @stability stable
         */
        resetHttpRoute(): void;
        /**
         * @stability stable
         */
        get httpRouteInput(): AppmeshRouteSpecHttpRoute | undefined;
        private _tcpRoute?;
        private __tcpRouteOutput;
        /**
         * @stability stable
         */
        get tcpRoute(): AppmeshRouteSpecTcpRouteOutputReference;
        /**
         * @stability stable
         */
        putTcpRoute(value: AppmeshRouteSpecTcpRoute | undefined): void;
        /**
         * @stability stable
         */
        resetTcpRoute(): void;
        /**
         * @stability stable
         */
        get tcpRouteInput(): AppmeshRouteSpecTcpRoute | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html aws_appmesh_route}.
     *
     * @stability stable
     */
    class AppmeshRoute extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route.html aws_appmesh_route} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AppmeshRouteConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdDate(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        private _meshName?;
        /**
         * @stability stable
         */
        get meshName(): string;
        /**
         * @stability stable
         */
        set meshName(value: string);
        /**
         * @stability stable
         */
        get meshNameInput(): string | undefined;
        private _meshOwner?;
        /**
         * @stability stable
         */
        get meshOwner(): string | undefined;
        /**
         * @stability stable
         */
        set meshOwner(value: string | undefined);
        /**
         * @stability stable
         */
        resetMeshOwner(): void;
        /**
         * @stability stable
         */
        get meshOwnerInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get resourceOwner(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _virtualRouterName?;
        /**
         * @stability stable
         */
        get virtualRouterName(): string;
        /**
         * @stability stable
         */
        set virtualRouterName(value: string);
        /**
         * @stability stable
         */
        get virtualRouterNameInput(): string | undefined;
        private _spec?;
        private __specOutput;
        /**
         * @stability stable
         */
        get spec(): AppmeshRouteSpecOutputReference;
        /**
         * @stability stable
         */
        putSpec(value: AppmeshRouteSpec): void;
        /**
         * @stability stable
         */
        get specInput(): AppmeshRouteSpec | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewayConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#mesh_name AppmeshVirtualGateway#mesh_name}.
         *
         * @stability stable
         */
        readonly meshName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#mesh_owner AppmeshVirtualGateway#mesh_owner}.
         *
         * @stability stable
         */
        readonly meshOwner?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#name AppmeshVirtualGateway#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#tags AppmeshVirtualGateway#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#tags_all AppmeshVirtualGateway#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * spec block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#spec AppmeshVirtualGateway#spec}
         *
         * @stability stable
         */
        readonly spec: AppmeshVirtualGatewaySpec;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateFile {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#certificate_chain AppmeshVirtualGateway#certificate_chain}.
         *
         * @stability stable
         */
        readonly certificateChain: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#private_key AppmeshVirtualGateway#private_key}.
         *
         * @stability stable
         */
        readonly privateKey: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateFileOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificateChain?;
        /**
         * @stability stable
         */
        get certificateChain(): string;
        /**
         * @stability stable
         */
        set certificateChain(value: string);
        /**
         * @stability stable
         */
        get certificateChainInput(): string | undefined;
        private _privateKey?;
        /**
         * @stability stable
         */
        get privateKey(): string;
        /**
         * @stability stable
         */
        set privateKey(value: string);
        /**
         * @stability stable
         */
        get privateKeyInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateSds {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#secret_name AppmeshVirtualGateway#secret_name}.
         *
         * @stability stable
         */
        readonly secretName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateSdsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _secretName?;
        /**
         * @stability stable
         */
        get secretName(): string;
        /**
         * @stability stable
         */
        set secretName(value: string);
        /**
         * @stability stable
         */
        get secretNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificate {
        /**
         * file block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#file AppmeshVirtualGateway#file}
         *
         * @stability stable
         */
        readonly file?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateFile;
        /**
         * sds block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#sds AppmeshVirtualGateway#sds}
         *
         * @stability stable
         */
        readonly sds?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateSds;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _file?;
        private __fileOutput;
        /**
         * @stability stable
         */
        get file(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateFileOutputReference;
        /**
         * @stability stable
         */
        putFile(value: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateFile | undefined): void;
        /**
         * @stability stable
         */
        resetFile(): void;
        /**
         * @stability stable
         */
        get fileInput(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateFile | undefined;
        private _sds?;
        private __sdsOutput;
        /**
         * @stability stable
         */
        get sds(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateSdsOutputReference;
        /**
         * @stability stable
         */
        putSds(value: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateSds | undefined): void;
        /**
         * @stability stable
         */
        resetSds(): void;
        /**
         * @stability stable
         */
        get sdsInput(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateSds | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#exact AppmeshVirtualGateway#exact}.
         *
         * @stability stable
         */
        readonly exact: string[];
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatchOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _exact?;
        /**
         * @stability stable
         */
        get exact(): string[];
        /**
         * @stability stable
         */
        set exact(value: string[]);
        /**
         * @stability stable
         */
        get exactInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames {
        /**
         * match block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#match AppmeshVirtualGateway#match}
         *
         * @stability stable
         */
        readonly match: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _match?;
        private __matchOutput;
        /**
         * @stability stable
         */
        get match(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatchOutputReference;
        /**
         * @stability stable
         */
        putMatch(value: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch): void;
        /**
         * @stability stable
         */
        get matchInput(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustAcm {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#certificate_authority_arns AppmeshVirtualGateway#certificate_authority_arns}.
         *
         * @stability stable
         */
        readonly certificateAuthorityArns: string[];
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustAcmOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificateAuthorityArns?;
        /**
         * @stability stable
         */
        get certificateAuthorityArns(): string[];
        /**
         * @stability stable
         */
        set certificateAuthorityArns(value: string[]);
        /**
         * @stability stable
         */
        get certificateAuthorityArnsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustFile {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#certificate_chain AppmeshVirtualGateway#certificate_chain}.
         *
         * @stability stable
         */
        readonly certificateChain: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustFileOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificateChain?;
        /**
         * @stability stable
         */
        get certificateChain(): string;
        /**
         * @stability stable
         */
        set certificateChain(value: string);
        /**
         * @stability stable
         */
        get certificateChainInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustSds {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#secret_name AppmeshVirtualGateway#secret_name}.
         *
         * @stability stable
         */
        readonly secretName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustSdsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _secretName?;
        /**
         * @stability stable
         */
        get secretName(): string;
        /**
         * @stability stable
         */
        set secretName(value: string);
        /**
         * @stability stable
         */
        get secretNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrust {
        /**
         * acm block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#acm AppmeshVirtualGateway#acm}
         *
         * @stability stable
         */
        readonly acm?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustAcm;
        /**
         * file block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#file AppmeshVirtualGateway#file}
         *
         * @stability stable
         */
        readonly file?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustFile;
        /**
         * sds block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#sds AppmeshVirtualGateway#sds}
         *
         * @stability stable
         */
        readonly sds?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustSds;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _acm?;
        private __acmOutput;
        /**
         * @stability stable
         */
        get acm(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustAcmOutputReference;
        /**
         * @stability stable
         */
        putAcm(value: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustAcm | undefined): void;
        /**
         * @stability stable
         */
        resetAcm(): void;
        /**
         * @stability stable
         */
        get acmInput(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustAcm | undefined;
        private _file?;
        private __fileOutput;
        /**
         * @stability stable
         */
        get file(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustFileOutputReference;
        /**
         * @stability stable
         */
        putFile(value: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustFile | undefined): void;
        /**
         * @stability stable
         */
        resetFile(): void;
        /**
         * @stability stable
         */
        get fileInput(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustFile | undefined;
        private _sds?;
        private __sdsOutput;
        /**
         * @stability stable
         */
        get sds(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustSdsOutputReference;
        /**
         * @stability stable
         */
        putSds(value: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustSds | undefined): void;
        /**
         * @stability stable
         */
        resetSds(): void;
        /**
         * @stability stable
         */
        get sdsInput(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustSds | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidation {
        /**
         * subject_alternative_names block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#subject_alternative_names AppmeshVirtualGateway#subject_alternative_names}
         *
         * @stability stable
         */
        readonly subjectAlternativeNames?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames;
        /**
         * trust block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#trust AppmeshVirtualGateway#trust}
         *
         * @stability stable
         */
        readonly trust: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrust;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _subjectAlternativeNames?;
        private __subjectAlternativeNamesOutput;
        /**
         * @stability stable
         */
        get subjectAlternativeNames(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesOutputReference;
        /**
         * @stability stable
         */
        putSubjectAlternativeNames(value: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames | undefined): void;
        /**
         * @stability stable
         */
        resetSubjectAlternativeNames(): void;
        /**
         * @stability stable
         */
        get subjectAlternativeNamesInput(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames | undefined;
        private _trust?;
        private __trustOutput;
        /**
         * @stability stable
         */
        get trust(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustOutputReference;
        /**
         * @stability stable
         */
        putTrust(value: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrust): void;
        /**
         * @stability stable
         */
        get trustInput(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrust | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTls {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#enforce AppmeshVirtualGateway#enforce}.
         *
         * @stability stable
         */
        readonly enforce?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#ports AppmeshVirtualGateway#ports}.
         *
         * @stability stable
         */
        readonly ports?: number[];
        /**
         * certificate block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#certificate AppmeshVirtualGateway#certificate}
         *
         * @stability stable
         */
        readonly certificate?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificate;
        /**
         * validation block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#validation AppmeshVirtualGateway#validation}
         *
         * @stability stable
         */
        readonly validation: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidation;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enforce?;
        /**
         * @stability stable
         */
        get enforce(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enforce(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnforce(): void;
        /**
         * @stability stable
         */
        get enforceInput(): boolean | cdktf.IResolvable | undefined;
        private _ports?;
        /**
         * @stability stable
         */
        get ports(): number[] | undefined;
        /**
         * @stability stable
         */
        set ports(value: number[] | undefined);
        /**
         * @stability stable
         */
        resetPorts(): void;
        /**
         * @stability stable
         */
        get portsInput(): number[] | undefined;
        private _certificate?;
        private __certificateOutput;
        /**
         * @stability stable
         */
        get certificate(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificateOutputReference;
        /**
         * @stability stable
         */
        putCertificate(value: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificate | undefined): void;
        /**
         * @stability stable
         */
        resetCertificate(): void;
        /**
         * @stability stable
         */
        get certificateInput(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsCertificate | undefined;
        private _validation?;
        private __validationOutput;
        /**
         * @stability stable
         */
        get validation(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationOutputReference;
        /**
         * @stability stable
         */
        putValidation(value: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidation): void;
        /**
         * @stability stable
         */
        get validationInput(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidation | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicy {
        /**
         * tls block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#tls AppmeshVirtualGateway#tls}
         *
         * @stability stable
         */
        readonly tls?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTls;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _tls?;
        private __tlsOutput;
        /**
         * @stability stable
         */
        get tls(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsOutputReference;
        /**
         * @stability stable
         */
        putTls(value: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTls | undefined): void;
        /**
         * @stability stable
         */
        resetTls(): void;
        /**
         * @stability stable
         */
        get tlsInput(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTls | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecBackendDefaults {
        /**
         * client_policy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#client_policy AppmeshVirtualGateway#client_policy}
         *
         * @stability stable
         */
        readonly clientPolicy?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicy;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecBackendDefaultsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _clientPolicy?;
        private __clientPolicyOutput;
        /**
         * @stability stable
         */
        get clientPolicy(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyOutputReference;
        /**
         * @stability stable
         */
        putClientPolicy(value: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicy | undefined): void;
        /**
         * @stability stable
         */
        resetClientPolicy(): void;
        /**
         * @stability stable
         */
        get clientPolicyInput(): AppmeshVirtualGatewaySpecBackendDefaultsClientPolicy | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerConnectionPoolGrpc {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#max_requests AppmeshVirtualGateway#max_requests}.
         *
         * @stability stable
         */
        readonly maxRequests: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerConnectionPoolGrpcOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _maxRequests?;
        /**
         * @stability stable
         */
        get maxRequests(): number;
        /**
         * @stability stable
         */
        set maxRequests(value: number);
        /**
         * @stability stable
         */
        get maxRequestsInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerConnectionPoolHttp {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#max_connections AppmeshVirtualGateway#max_connections}.
         *
         * @stability stable
         */
        readonly maxConnections: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#max_pending_requests AppmeshVirtualGateway#max_pending_requests}.
         *
         * @stability stable
         */
        readonly maxPendingRequests?: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerConnectionPoolHttpOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _maxConnections?;
        /**
         * @stability stable
         */
        get maxConnections(): number;
        /**
         * @stability stable
         */
        set maxConnections(value: number);
        /**
         * @stability stable
         */
        get maxConnectionsInput(): number | undefined;
        private _maxPendingRequests?;
        /**
         * @stability stable
         */
        get maxPendingRequests(): number | undefined;
        /**
         * @stability stable
         */
        set maxPendingRequests(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaxPendingRequests(): void;
        /**
         * @stability stable
         */
        get maxPendingRequestsInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerConnectionPoolHttp2 {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#max_requests AppmeshVirtualGateway#max_requests}.
         *
         * @stability stable
         */
        readonly maxRequests: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerConnectionPoolHttp2OutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _maxRequests?;
        /**
         * @stability stable
         */
        get maxRequests(): number;
        /**
         * @stability stable
         */
        set maxRequests(value: number);
        /**
         * @stability stable
         */
        get maxRequestsInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerConnectionPool {
        /**
         * grpc block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#grpc AppmeshVirtualGateway#grpc}
         *
         * @stability stable
         */
        readonly grpc?: AppmeshVirtualGatewaySpecListenerConnectionPoolGrpc;
        /**
         * http block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#http AppmeshVirtualGateway#http}
         *
         * @stability stable
         */
        readonly http?: AppmeshVirtualGatewaySpecListenerConnectionPoolHttp;
        /**
         * http2 block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#http2 AppmeshVirtualGateway#http2}
         *
         * @stability stable
         */
        readonly http2?: AppmeshVirtualGatewaySpecListenerConnectionPoolHttp2;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerConnectionPoolOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _grpc?;
        private __grpcOutput;
        /**
         * @stability stable
         */
        get grpc(): AppmeshVirtualGatewaySpecListenerConnectionPoolGrpcOutputReference;
        /**
         * @stability stable
         */
        putGrpc(value: AppmeshVirtualGatewaySpecListenerConnectionPoolGrpc | undefined): void;
        /**
         * @stability stable
         */
        resetGrpc(): void;
        /**
         * @stability stable
         */
        get grpcInput(): AppmeshVirtualGatewaySpecListenerConnectionPoolGrpc | undefined;
        private _http?;
        private __httpOutput;
        /**
         * @stability stable
         */
        get http(): AppmeshVirtualGatewaySpecListenerConnectionPoolHttpOutputReference;
        /**
         * @stability stable
         */
        putHttp(value: AppmeshVirtualGatewaySpecListenerConnectionPoolHttp | undefined): void;
        /**
         * @stability stable
         */
        resetHttp(): void;
        /**
         * @stability stable
         */
        get httpInput(): AppmeshVirtualGatewaySpecListenerConnectionPoolHttp | undefined;
        private _http2?;
        private __http2Output;
        /**
         * @stability stable
         */
        get http2(): AppmeshVirtualGatewaySpecListenerConnectionPoolHttp2OutputReference;
        /**
         * @stability stable
         */
        putHttp2(value: AppmeshVirtualGatewaySpecListenerConnectionPoolHttp2 | undefined): void;
        /**
         * @stability stable
         */
        resetHttp2(): void;
        /**
         * @stability stable
         */
        get http2Input(): AppmeshVirtualGatewaySpecListenerConnectionPoolHttp2 | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerHealthCheck {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#healthy_threshold AppmeshVirtualGateway#healthy_threshold}.
         *
         * @stability stable
         */
        readonly healthyThreshold: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#interval_millis AppmeshVirtualGateway#interval_millis}.
         *
         * @stability stable
         */
        readonly intervalMillis: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#path AppmeshVirtualGateway#path}.
         *
         * @stability stable
         */
        readonly path?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#port AppmeshVirtualGateway#port}.
         *
         * @stability stable
         */
        readonly port?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#protocol AppmeshVirtualGateway#protocol}.
         *
         * @stability stable
         */
        readonly protocol: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#timeout_millis AppmeshVirtualGateway#timeout_millis}.
         *
         * @stability stable
         */
        readonly timeoutMillis: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#unhealthy_threshold AppmeshVirtualGateway#unhealthy_threshold}.
         *
         * @stability stable
         */
        readonly unhealthyThreshold: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerHealthCheckOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _healthyThreshold?;
        /**
         * @stability stable
         */
        get healthyThreshold(): number;
        /**
         * @stability stable
         */
        set healthyThreshold(value: number);
        /**
         * @stability stable
         */
        get healthyThresholdInput(): number | undefined;
        private _intervalMillis?;
        /**
         * @stability stable
         */
        get intervalMillis(): number;
        /**
         * @stability stable
         */
        set intervalMillis(value: number);
        /**
         * @stability stable
         */
        get intervalMillisInput(): number | undefined;
        private _path?;
        /**
         * @stability stable
         */
        get path(): string | undefined;
        /**
         * @stability stable
         */
        set path(value: string | undefined);
        /**
         * @stability stable
         */
        resetPath(): void;
        /**
         * @stability stable
         */
        get pathInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number | undefined;
        /**
         * @stability stable
         */
        set port(value: number | undefined);
        /**
         * @stability stable
         */
        resetPort(): void;
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
        private _protocol?;
        /**
         * @stability stable
         */
        get protocol(): string;
        /**
         * @stability stable
         */
        set protocol(value: string);
        /**
         * @stability stable
         */
        get protocolInput(): string | undefined;
        private _timeoutMillis?;
        /**
         * @stability stable
         */
        get timeoutMillis(): number;
        /**
         * @stability stable
         */
        set timeoutMillis(value: number);
        /**
         * @stability stable
         */
        get timeoutMillisInput(): number | undefined;
        private _unhealthyThreshold?;
        /**
         * @stability stable
         */
        get unhealthyThreshold(): number;
        /**
         * @stability stable
         */
        set unhealthyThreshold(value: number);
        /**
         * @stability stable
         */
        get unhealthyThresholdInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerPortMapping {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#port AppmeshVirtualGateway#port}.
         *
         * @stability stable
         */
        readonly port: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#protocol AppmeshVirtualGateway#protocol}.
         *
         * @stability stable
         */
        readonly protocol: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerPortMappingOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _port?;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        set port(value: number);
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
        private _protocol?;
        /**
         * @stability stable
         */
        get protocol(): string;
        /**
         * @stability stable
         */
        set protocol(value: string);
        /**
         * @stability stable
         */
        get protocolInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerTlsCertificateAcm {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#certificate_arn AppmeshVirtualGateway#certificate_arn}.
         *
         * @stability stable
         */
        readonly certificateArn: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerTlsCertificateAcmOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificateArn?;
        /**
         * @stability stable
         */
        get certificateArn(): string;
        /**
         * @stability stable
         */
        set certificateArn(value: string);
        /**
         * @stability stable
         */
        get certificateArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerTlsCertificateFile {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#certificate_chain AppmeshVirtualGateway#certificate_chain}.
         *
         * @stability stable
         */
        readonly certificateChain: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#private_key AppmeshVirtualGateway#private_key}.
         *
         * @stability stable
         */
        readonly privateKey: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerTlsCertificateFileOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificateChain?;
        /**
         * @stability stable
         */
        get certificateChain(): string;
        /**
         * @stability stable
         */
        set certificateChain(value: string);
        /**
         * @stability stable
         */
        get certificateChainInput(): string | undefined;
        private _privateKey?;
        /**
         * @stability stable
         */
        get privateKey(): string;
        /**
         * @stability stable
         */
        set privateKey(value: string);
        /**
         * @stability stable
         */
        get privateKeyInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerTlsCertificateSds {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#secret_name AppmeshVirtualGateway#secret_name}.
         *
         * @stability stable
         */
        readonly secretName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerTlsCertificateSdsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _secretName?;
        /**
         * @stability stable
         */
        get secretName(): string;
        /**
         * @stability stable
         */
        set secretName(value: string);
        /**
         * @stability stable
         */
        get secretNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerTlsCertificate {
        /**
         * acm block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#acm AppmeshVirtualGateway#acm}
         *
         * @stability stable
         */
        readonly acm?: AppmeshVirtualGatewaySpecListenerTlsCertificateAcm;
        /**
         * file block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#file AppmeshVirtualGateway#file}
         *
         * @stability stable
         */
        readonly file?: AppmeshVirtualGatewaySpecListenerTlsCertificateFile;
        /**
         * sds block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#sds AppmeshVirtualGateway#sds}
         *
         * @stability stable
         */
        readonly sds?: AppmeshVirtualGatewaySpecListenerTlsCertificateSds;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerTlsCertificateOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _acm?;
        private __acmOutput;
        /**
         * @stability stable
         */
        get acm(): AppmeshVirtualGatewaySpecListenerTlsCertificateAcmOutputReference;
        /**
         * @stability stable
         */
        putAcm(value: AppmeshVirtualGatewaySpecListenerTlsCertificateAcm | undefined): void;
        /**
         * @stability stable
         */
        resetAcm(): void;
        /**
         * @stability stable
         */
        get acmInput(): AppmeshVirtualGatewaySpecListenerTlsCertificateAcm | undefined;
        private _file?;
        private __fileOutput;
        /**
         * @stability stable
         */
        get file(): AppmeshVirtualGatewaySpecListenerTlsCertificateFileOutputReference;
        /**
         * @stability stable
         */
        putFile(value: AppmeshVirtualGatewaySpecListenerTlsCertificateFile | undefined): void;
        /**
         * @stability stable
         */
        resetFile(): void;
        /**
         * @stability stable
         */
        get fileInput(): AppmeshVirtualGatewaySpecListenerTlsCertificateFile | undefined;
        private _sds?;
        private __sdsOutput;
        /**
         * @stability stable
         */
        get sds(): AppmeshVirtualGatewaySpecListenerTlsCertificateSdsOutputReference;
        /**
         * @stability stable
         */
        putSds(value: AppmeshVirtualGatewaySpecListenerTlsCertificateSds | undefined): void;
        /**
         * @stability stable
         */
        resetSds(): void;
        /**
         * @stability stable
         */
        get sdsInput(): AppmeshVirtualGatewaySpecListenerTlsCertificateSds | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerTlsValidationSubjectAlternativeNamesMatch {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#exact AppmeshVirtualGateway#exact}.
         *
         * @stability stable
         */
        readonly exact: string[];
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerTlsValidationSubjectAlternativeNamesMatchOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _exact?;
        /**
         * @stability stable
         */
        get exact(): string[];
        /**
         * @stability stable
         */
        set exact(value: string[]);
        /**
         * @stability stable
         */
        get exactInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerTlsValidationSubjectAlternativeNames {
        /**
         * match block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#match AppmeshVirtualGateway#match}
         *
         * @stability stable
         */
        readonly match: AppmeshVirtualGatewaySpecListenerTlsValidationSubjectAlternativeNamesMatch;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerTlsValidationSubjectAlternativeNamesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _match?;
        private __matchOutput;
        /**
         * @stability stable
         */
        get match(): AppmeshVirtualGatewaySpecListenerTlsValidationSubjectAlternativeNamesMatchOutputReference;
        /**
         * @stability stable
         */
        putMatch(value: AppmeshVirtualGatewaySpecListenerTlsValidationSubjectAlternativeNamesMatch): void;
        /**
         * @stability stable
         */
        get matchInput(): AppmeshVirtualGatewaySpecListenerTlsValidationSubjectAlternativeNamesMatch | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerTlsValidationTrustFile {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#certificate_chain AppmeshVirtualGateway#certificate_chain}.
         *
         * @stability stable
         */
        readonly certificateChain: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerTlsValidationTrustFileOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificateChain?;
        /**
         * @stability stable
         */
        get certificateChain(): string;
        /**
         * @stability stable
         */
        set certificateChain(value: string);
        /**
         * @stability stable
         */
        get certificateChainInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerTlsValidationTrustSds {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#secret_name AppmeshVirtualGateway#secret_name}.
         *
         * @stability stable
         */
        readonly secretName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerTlsValidationTrustSdsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _secretName?;
        /**
         * @stability stable
         */
        get secretName(): string;
        /**
         * @stability stable
         */
        set secretName(value: string);
        /**
         * @stability stable
         */
        get secretNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerTlsValidationTrust {
        /**
         * file block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#file AppmeshVirtualGateway#file}
         *
         * @stability stable
         */
        readonly file?: AppmeshVirtualGatewaySpecListenerTlsValidationTrustFile;
        /**
         * sds block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#sds AppmeshVirtualGateway#sds}
         *
         * @stability stable
         */
        readonly sds?: AppmeshVirtualGatewaySpecListenerTlsValidationTrustSds;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerTlsValidationTrustOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _file?;
        private __fileOutput;
        /**
         * @stability stable
         */
        get file(): AppmeshVirtualGatewaySpecListenerTlsValidationTrustFileOutputReference;
        /**
         * @stability stable
         */
        putFile(value: AppmeshVirtualGatewaySpecListenerTlsValidationTrustFile | undefined): void;
        /**
         * @stability stable
         */
        resetFile(): void;
        /**
         * @stability stable
         */
        get fileInput(): AppmeshVirtualGatewaySpecListenerTlsValidationTrustFile | undefined;
        private _sds?;
        private __sdsOutput;
        /**
         * @stability stable
         */
        get sds(): AppmeshVirtualGatewaySpecListenerTlsValidationTrustSdsOutputReference;
        /**
         * @stability stable
         */
        putSds(value: AppmeshVirtualGatewaySpecListenerTlsValidationTrustSds | undefined): void;
        /**
         * @stability stable
         */
        resetSds(): void;
        /**
         * @stability stable
         */
        get sdsInput(): AppmeshVirtualGatewaySpecListenerTlsValidationTrustSds | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerTlsValidation {
        /**
         * subject_alternative_names block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#subject_alternative_names AppmeshVirtualGateway#subject_alternative_names}
         *
         * @stability stable
         */
        readonly subjectAlternativeNames?: AppmeshVirtualGatewaySpecListenerTlsValidationSubjectAlternativeNames;
        /**
         * trust block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#trust AppmeshVirtualGateway#trust}
         *
         * @stability stable
         */
        readonly trust: AppmeshVirtualGatewaySpecListenerTlsValidationTrust;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerTlsValidationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _subjectAlternativeNames?;
        private __subjectAlternativeNamesOutput;
        /**
         * @stability stable
         */
        get subjectAlternativeNames(): AppmeshVirtualGatewaySpecListenerTlsValidationSubjectAlternativeNamesOutputReference;
        /**
         * @stability stable
         */
        putSubjectAlternativeNames(value: AppmeshVirtualGatewaySpecListenerTlsValidationSubjectAlternativeNames | undefined): void;
        /**
         * @stability stable
         */
        resetSubjectAlternativeNames(): void;
        /**
         * @stability stable
         */
        get subjectAlternativeNamesInput(): AppmeshVirtualGatewaySpecListenerTlsValidationSubjectAlternativeNames | undefined;
        private _trust?;
        private __trustOutput;
        /**
         * @stability stable
         */
        get trust(): AppmeshVirtualGatewaySpecListenerTlsValidationTrustOutputReference;
        /**
         * @stability stable
         */
        putTrust(value: AppmeshVirtualGatewaySpecListenerTlsValidationTrust): void;
        /**
         * @stability stable
         */
        get trustInput(): AppmeshVirtualGatewaySpecListenerTlsValidationTrust | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListenerTls {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#mode AppmeshVirtualGateway#mode}.
         *
         * @stability stable
         */
        readonly mode: string;
        /**
         * certificate block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#certificate AppmeshVirtualGateway#certificate}
         *
         * @stability stable
         */
        readonly certificate: AppmeshVirtualGatewaySpecListenerTlsCertificate;
        /**
         * validation block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#validation AppmeshVirtualGateway#validation}
         *
         * @stability stable
         */
        readonly validation?: AppmeshVirtualGatewaySpecListenerTlsValidation;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerTlsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _mode?;
        /**
         * @stability stable
         */
        get mode(): string;
        /**
         * @stability stable
         */
        set mode(value: string);
        /**
         * @stability stable
         */
        get modeInput(): string | undefined;
        private _certificate?;
        private __certificateOutput;
        /**
         * @stability stable
         */
        get certificate(): AppmeshVirtualGatewaySpecListenerTlsCertificateOutputReference;
        /**
         * @stability stable
         */
        putCertificate(value: AppmeshVirtualGatewaySpecListenerTlsCertificate): void;
        /**
         * @stability stable
         */
        get certificateInput(): AppmeshVirtualGatewaySpecListenerTlsCertificate | undefined;
        private _validation?;
        private __validationOutput;
        /**
         * @stability stable
         */
        get validation(): AppmeshVirtualGatewaySpecListenerTlsValidationOutputReference;
        /**
         * @stability stable
         */
        putValidation(value: AppmeshVirtualGatewaySpecListenerTlsValidation | undefined): void;
        /**
         * @stability stable
         */
        resetValidation(): void;
        /**
         * @stability stable
         */
        get validationInput(): AppmeshVirtualGatewaySpecListenerTlsValidation | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecListener {
        /**
         * connection_pool block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#connection_pool AppmeshVirtualGateway#connection_pool}
         *
         * @stability stable
         */
        readonly connectionPool?: AppmeshVirtualGatewaySpecListenerConnectionPool;
        /**
         * health_check block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#health_check AppmeshVirtualGateway#health_check}
         *
         * @stability stable
         */
        readonly healthCheck?: AppmeshVirtualGatewaySpecListenerHealthCheck;
        /**
         * port_mapping block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#port_mapping AppmeshVirtualGateway#port_mapping}
         *
         * @stability stable
         */
        readonly portMapping: AppmeshVirtualGatewaySpecListenerPortMapping;
        /**
         * tls block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#tls AppmeshVirtualGateway#tls}
         *
         * @stability stable
         */
        readonly tls?: AppmeshVirtualGatewaySpecListenerTls;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecListenerOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _connectionPool?;
        private __connectionPoolOutput;
        /**
         * @stability stable
         */
        get connectionPool(): AppmeshVirtualGatewaySpecListenerConnectionPoolOutputReference;
        /**
         * @stability stable
         */
        putConnectionPool(value: AppmeshVirtualGatewaySpecListenerConnectionPool | undefined): void;
        /**
         * @stability stable
         */
        resetConnectionPool(): void;
        /**
         * @stability stable
         */
        get connectionPoolInput(): AppmeshVirtualGatewaySpecListenerConnectionPool | undefined;
        private _healthCheck?;
        private __healthCheckOutput;
        /**
         * @stability stable
         */
        get healthCheck(): AppmeshVirtualGatewaySpecListenerHealthCheckOutputReference;
        /**
         * @stability stable
         */
        putHealthCheck(value: AppmeshVirtualGatewaySpecListenerHealthCheck | undefined): void;
        /**
         * @stability stable
         */
        resetHealthCheck(): void;
        /**
         * @stability stable
         */
        get healthCheckInput(): AppmeshVirtualGatewaySpecListenerHealthCheck | undefined;
        private _portMapping?;
        private __portMappingOutput;
        /**
         * @stability stable
         */
        get portMapping(): AppmeshVirtualGatewaySpecListenerPortMappingOutputReference;
        /**
         * @stability stable
         */
        putPortMapping(value: AppmeshVirtualGatewaySpecListenerPortMapping): void;
        /**
         * @stability stable
         */
        get portMappingInput(): AppmeshVirtualGatewaySpecListenerPortMapping | undefined;
        private _tls?;
        private __tlsOutput;
        /**
         * @stability stable
         */
        get tls(): AppmeshVirtualGatewaySpecListenerTlsOutputReference;
        /**
         * @stability stable
         */
        putTls(value: AppmeshVirtualGatewaySpecListenerTls | undefined): void;
        /**
         * @stability stable
         */
        resetTls(): void;
        /**
         * @stability stable
         */
        get tlsInput(): AppmeshVirtualGatewaySpecListenerTls | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecLoggingAccessLogFile {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#path AppmeshVirtualGateway#path}.
         *
         * @stability stable
         */
        readonly path: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecLoggingAccessLogFileOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _path?;
        /**
         * @stability stable
         */
        get path(): string;
        /**
         * @stability stable
         */
        set path(value: string);
        /**
         * @stability stable
         */
        get pathInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecLoggingAccessLog {
        /**
         * file block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#file AppmeshVirtualGateway#file}
         *
         * @stability stable
         */
        readonly file?: AppmeshVirtualGatewaySpecLoggingAccessLogFile;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecLoggingAccessLogOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _file?;
        private __fileOutput;
        /**
         * @stability stable
         */
        get file(): AppmeshVirtualGatewaySpecLoggingAccessLogFileOutputReference;
        /**
         * @stability stable
         */
        putFile(value: AppmeshVirtualGatewaySpecLoggingAccessLogFile | undefined): void;
        /**
         * @stability stable
         */
        resetFile(): void;
        /**
         * @stability stable
         */
        get fileInput(): AppmeshVirtualGatewaySpecLoggingAccessLogFile | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpecLogging {
        /**
         * access_log block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#access_log AppmeshVirtualGateway#access_log}
         *
         * @stability stable
         */
        readonly accessLog?: AppmeshVirtualGatewaySpecLoggingAccessLog;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecLoggingOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _accessLog?;
        private __accessLogOutput;
        /**
         * @stability stable
         */
        get accessLog(): AppmeshVirtualGatewaySpecLoggingAccessLogOutputReference;
        /**
         * @stability stable
         */
        putAccessLog(value: AppmeshVirtualGatewaySpecLoggingAccessLog | undefined): void;
        /**
         * @stability stable
         */
        resetAccessLog(): void;
        /**
         * @stability stable
         */
        get accessLogInput(): AppmeshVirtualGatewaySpecLoggingAccessLog | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualGatewaySpec {
        /**
         * backend_defaults block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#backend_defaults AppmeshVirtualGateway#backend_defaults}
         *
         * @stability stable
         */
        readonly backendDefaults?: AppmeshVirtualGatewaySpecBackendDefaults;
        /**
         * listener block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#listener AppmeshVirtualGateway#listener}
         *
         * @stability stable
         */
        readonly listener: AppmeshVirtualGatewaySpecListener;
        /**
         * logging block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html#logging AppmeshVirtualGateway#logging}
         *
         * @stability stable
         */
        readonly logging?: AppmeshVirtualGatewaySpecLogging;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualGatewaySpecOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _backendDefaults?;
        private __backendDefaultsOutput;
        /**
         * @stability stable
         */
        get backendDefaults(): AppmeshVirtualGatewaySpecBackendDefaultsOutputReference;
        /**
         * @stability stable
         */
        putBackendDefaults(value: AppmeshVirtualGatewaySpecBackendDefaults | undefined): void;
        /**
         * @stability stable
         */
        resetBackendDefaults(): void;
        /**
         * @stability stable
         */
        get backendDefaultsInput(): AppmeshVirtualGatewaySpecBackendDefaults | undefined;
        private _listener?;
        private __listenerOutput;
        /**
         * @stability stable
         */
        get listener(): AppmeshVirtualGatewaySpecListenerOutputReference;
        /**
         * @stability stable
         */
        putListener(value: AppmeshVirtualGatewaySpecListener): void;
        /**
         * @stability stable
         */
        get listenerInput(): AppmeshVirtualGatewaySpecListener | undefined;
        private _logging?;
        private __loggingOutput;
        /**
         * @stability stable
         */
        get logging(): AppmeshVirtualGatewaySpecLoggingOutputReference;
        /**
         * @stability stable
         */
        putLogging(value: AppmeshVirtualGatewaySpecLogging | undefined): void;
        /**
         * @stability stable
         */
        resetLogging(): void;
        /**
         * @stability stable
         */
        get loggingInput(): AppmeshVirtualGatewaySpecLogging | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html aws_appmesh_virtual_gateway}.
     *
     * @stability stable
     */
    class AppmeshVirtualGateway extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_gateway.html aws_appmesh_virtual_gateway} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AppmeshVirtualGatewayConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdDate(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        private _meshName?;
        /**
         * @stability stable
         */
        get meshName(): string;
        /**
         * @stability stable
         */
        set meshName(value: string);
        /**
         * @stability stable
         */
        get meshNameInput(): string | undefined;
        private _meshOwner?;
        /**
         * @stability stable
         */
        get meshOwner(): string | undefined;
        /**
         * @stability stable
         */
        set meshOwner(value: string | undefined);
        /**
         * @stability stable
         */
        resetMeshOwner(): void;
        /**
         * @stability stable
         */
        get meshOwnerInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get resourceOwner(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _spec?;
        private __specOutput;
        /**
         * @stability stable
         */
        get spec(): AppmeshVirtualGatewaySpecOutputReference;
        /**
         * @stability stable
         */
        putSpec(value: AppmeshVirtualGatewaySpec): void;
        /**
         * @stability stable
         */
        get specInput(): AppmeshVirtualGatewaySpec | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#mesh_name AppmeshVirtualNode#mesh_name}.
         *
         * @stability stable
         */
        readonly meshName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#mesh_owner AppmeshVirtualNode#mesh_owner}.
         *
         * @stability stable
         */
        readonly meshOwner?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#name AppmeshVirtualNode#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#tags AppmeshVirtualNode#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#tags_all AppmeshVirtualNode#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * spec block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#spec AppmeshVirtualNode#spec}
         *
         * @stability stable
         */
        readonly spec: AppmeshVirtualNodeSpec;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFile {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#certificate_chain AppmeshVirtualNode#certificate_chain}.
         *
         * @stability stable
         */
        readonly certificateChain: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#private_key AppmeshVirtualNode#private_key}.
         *
         * @stability stable
         */
        readonly privateKey: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFileOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificateChain?;
        /**
         * @stability stable
         */
        get certificateChain(): string;
        /**
         * @stability stable
         */
        set certificateChain(value: string);
        /**
         * @stability stable
         */
        get certificateChainInput(): string | undefined;
        private _privateKey?;
        /**
         * @stability stable
         */
        get privateKey(): string;
        /**
         * @stability stable
         */
        set privateKey(value: string);
        /**
         * @stability stable
         */
        get privateKeyInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSds {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#secret_name AppmeshVirtualNode#secret_name}.
         *
         * @stability stable
         */
        readonly secretName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSdsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _secretName?;
        /**
         * @stability stable
         */
        get secretName(): string;
        /**
         * @stability stable
         */
        set secretName(value: string);
        /**
         * @stability stable
         */
        get secretNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificate {
        /**
         * file block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#file AppmeshVirtualNode#file}
         *
         * @stability stable
         */
        readonly file?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFile;
        /**
         * sds block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#sds AppmeshVirtualNode#sds}
         *
         * @stability stable
         */
        readonly sds?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSds;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _file?;
        private __fileOutput;
        /**
         * @stability stable
         */
        get file(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFileOutputReference;
        /**
         * @stability stable
         */
        putFile(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFile | undefined): void;
        /**
         * @stability stable
         */
        resetFile(): void;
        /**
         * @stability stable
         */
        get fileInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFile | undefined;
        private _sds?;
        private __sdsOutput;
        /**
         * @stability stable
         */
        get sds(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSdsOutputReference;
        /**
         * @stability stable
         */
        putSds(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSds | undefined): void;
        /**
         * @stability stable
         */
        resetSds(): void;
        /**
         * @stability stable
         */
        get sdsInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSds | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatch {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#exact AppmeshVirtualNode#exact}.
         *
         * @stability stable
         */
        readonly exact: string[];
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatchOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _exact?;
        /**
         * @stability stable
         */
        get exact(): string[];
        /**
         * @stability stable
         */
        set exact(value: string[]);
        /**
         * @stability stable
         */
        get exactInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNames {
        /**
         * match block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#match AppmeshVirtualNode#match}
         *
         * @stability stable
         */
        readonly match: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatch;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _match?;
        private __matchOutput;
        /**
         * @stability stable
         */
        get match(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatchOutputReference;
        /**
         * @stability stable
         */
        putMatch(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatch): void;
        /**
         * @stability stable
         */
        get matchInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatch | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcm {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#certificate_authority_arns AppmeshVirtualNode#certificate_authority_arns}.
         *
         * @stability stable
         */
        readonly certificateAuthorityArns: string[];
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcmOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificateAuthorityArns?;
        /**
         * @stability stable
         */
        get certificateAuthorityArns(): string[];
        /**
         * @stability stable
         */
        set certificateAuthorityArns(value: string[]);
        /**
         * @stability stable
         */
        get certificateAuthorityArnsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFile {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#certificate_chain AppmeshVirtualNode#certificate_chain}.
         *
         * @stability stable
         */
        readonly certificateChain: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFileOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificateChain?;
        /**
         * @stability stable
         */
        get certificateChain(): string;
        /**
         * @stability stable
         */
        set certificateChain(value: string);
        /**
         * @stability stable
         */
        get certificateChainInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSds {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#secret_name AppmeshVirtualNode#secret_name}.
         *
         * @stability stable
         */
        readonly secretName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSdsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _secretName?;
        /**
         * @stability stable
         */
        get secretName(): string;
        /**
         * @stability stable
         */
        set secretName(value: string);
        /**
         * @stability stable
         */
        get secretNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrust {
        /**
         * acm block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#acm AppmeshVirtualNode#acm}
         *
         * @stability stable
         */
        readonly acm?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcm;
        /**
         * file block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#file AppmeshVirtualNode#file}
         *
         * @stability stable
         */
        readonly file?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFile;
        /**
         * sds block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#sds AppmeshVirtualNode#sds}
         *
         * @stability stable
         */
        readonly sds?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSds;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _acm?;
        private __acmOutput;
        /**
         * @stability stable
         */
        get acm(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcmOutputReference;
        /**
         * @stability stable
         */
        putAcm(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcm | undefined): void;
        /**
         * @stability stable
         */
        resetAcm(): void;
        /**
         * @stability stable
         */
        get acmInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcm | undefined;
        private _file?;
        private __fileOutput;
        /**
         * @stability stable
         */
        get file(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFileOutputReference;
        /**
         * @stability stable
         */
        putFile(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFile | undefined): void;
        /**
         * @stability stable
         */
        resetFile(): void;
        /**
         * @stability stable
         */
        get fileInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFile | undefined;
        private _sds?;
        private __sdsOutput;
        /**
         * @stability stable
         */
        get sds(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSdsOutputReference;
        /**
         * @stability stable
         */
        putSds(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSds | undefined): void;
        /**
         * @stability stable
         */
        resetSds(): void;
        /**
         * @stability stable
         */
        get sdsInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSds | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidation {
        /**
         * subject_alternative_names block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#subject_alternative_names AppmeshVirtualNode#subject_alternative_names}
         *
         * @stability stable
         */
        readonly subjectAlternativeNames?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNames;
        /**
         * trust block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#trust AppmeshVirtualNode#trust}
         *
         * @stability stable
         */
        readonly trust: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrust;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _subjectAlternativeNames?;
        private __subjectAlternativeNamesOutput;
        /**
         * @stability stable
         */
        get subjectAlternativeNames(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesOutputReference;
        /**
         * @stability stable
         */
        putSubjectAlternativeNames(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNames | undefined): void;
        /**
         * @stability stable
         */
        resetSubjectAlternativeNames(): void;
        /**
         * @stability stable
         */
        get subjectAlternativeNamesInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNames | undefined;
        private _trust?;
        private __trustOutput;
        /**
         * @stability stable
         */
        get trust(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustOutputReference;
        /**
         * @stability stable
         */
        putTrust(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrust): void;
        /**
         * @stability stable
         */
        get trustInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrust | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTls {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#enforce AppmeshVirtualNode#enforce}.
         *
         * @stability stable
         */
        readonly enforce?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#ports AppmeshVirtualNode#ports}.
         *
         * @stability stable
         */
        readonly ports?: number[];
        /**
         * certificate block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#certificate AppmeshVirtualNode#certificate}
         *
         * @stability stable
         */
        readonly certificate?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificate;
        /**
         * validation block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#validation AppmeshVirtualNode#validation}
         *
         * @stability stable
         */
        readonly validation: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidation;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enforce?;
        /**
         * @stability stable
         */
        get enforce(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enforce(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnforce(): void;
        /**
         * @stability stable
         */
        get enforceInput(): boolean | cdktf.IResolvable | undefined;
        private _ports?;
        /**
         * @stability stable
         */
        get ports(): number[] | undefined;
        /**
         * @stability stable
         */
        set ports(value: number[] | undefined);
        /**
         * @stability stable
         */
        resetPorts(): void;
        /**
         * @stability stable
         */
        get portsInput(): number[] | undefined;
        private _certificate?;
        private __certificateOutput;
        /**
         * @stability stable
         */
        get certificate(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateOutputReference;
        /**
         * @stability stable
         */
        putCertificate(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificate | undefined): void;
        /**
         * @stability stable
         */
        resetCertificate(): void;
        /**
         * @stability stable
         */
        get certificateInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificate | undefined;
        private _validation?;
        private __validationOutput;
        /**
         * @stability stable
         */
        get validation(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationOutputReference;
        /**
         * @stability stable
         */
        putValidation(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidation): void;
        /**
         * @stability stable
         */
        get validationInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidation | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicy {
        /**
         * tls block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#tls AppmeshVirtualNode#tls}
         *
         * @stability stable
         */
        readonly tls?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTls;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _tls?;
        private __tlsOutput;
        /**
         * @stability stable
         */
        get tls(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsOutputReference;
        /**
         * @stability stable
         */
        putTls(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTls | undefined): void;
        /**
         * @stability stable
         */
        resetTls(): void;
        /**
         * @stability stable
         */
        get tlsInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTls | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendVirtualService {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#virtual_service_name AppmeshVirtualNode#virtual_service_name}.
         *
         * @stability stable
         */
        readonly virtualServiceName: string;
        /**
         * client_policy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#client_policy AppmeshVirtualNode#client_policy}
         *
         * @stability stable
         */
        readonly clientPolicy?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicy;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendVirtualServiceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _virtualServiceName?;
        /**
         * @stability stable
         */
        get virtualServiceName(): string;
        /**
         * @stability stable
         */
        set virtualServiceName(value: string);
        /**
         * @stability stable
         */
        get virtualServiceNameInput(): string | undefined;
        private _clientPolicy?;
        private __clientPolicyOutput;
        /**
         * @stability stable
         */
        get clientPolicy(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyOutputReference;
        /**
         * @stability stable
         */
        putClientPolicy(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicy | undefined): void;
        /**
         * @stability stable
         */
        resetClientPolicy(): void;
        /**
         * @stability stable
         */
        get clientPolicyInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicy | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackend {
        /**
         * virtual_service block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#virtual_service AppmeshVirtualNode#virtual_service}
         *
         * @stability stable
         */
        readonly virtualService: AppmeshVirtualNodeSpecBackendVirtualService;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFile {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#certificate_chain AppmeshVirtualNode#certificate_chain}.
         *
         * @stability stable
         */
        readonly certificateChain: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#private_key AppmeshVirtualNode#private_key}.
         *
         * @stability stable
         */
        readonly privateKey: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFileOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificateChain?;
        /**
         * @stability stable
         */
        get certificateChain(): string;
        /**
         * @stability stable
         */
        set certificateChain(value: string);
        /**
         * @stability stable
         */
        get certificateChainInput(): string | undefined;
        private _privateKey?;
        /**
         * @stability stable
         */
        get privateKey(): string;
        /**
         * @stability stable
         */
        set privateKey(value: string);
        /**
         * @stability stable
         */
        get privateKeyInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSds {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#secret_name AppmeshVirtualNode#secret_name}.
         *
         * @stability stable
         */
        readonly secretName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSdsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _secretName?;
        /**
         * @stability stable
         */
        get secretName(): string;
        /**
         * @stability stable
         */
        set secretName(value: string);
        /**
         * @stability stable
         */
        get secretNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificate {
        /**
         * file block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#file AppmeshVirtualNode#file}
         *
         * @stability stable
         */
        readonly file?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFile;
        /**
         * sds block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#sds AppmeshVirtualNode#sds}
         *
         * @stability stable
         */
        readonly sds?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSds;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _file?;
        private __fileOutput;
        /**
         * @stability stable
         */
        get file(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFileOutputReference;
        /**
         * @stability stable
         */
        putFile(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFile | undefined): void;
        /**
         * @stability stable
         */
        resetFile(): void;
        /**
         * @stability stable
         */
        get fileInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFile | undefined;
        private _sds?;
        private __sdsOutput;
        /**
         * @stability stable
         */
        get sds(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSdsOutputReference;
        /**
         * @stability stable
         */
        putSds(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSds | undefined): void;
        /**
         * @stability stable
         */
        resetSds(): void;
        /**
         * @stability stable
         */
        get sdsInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSds | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#exact AppmeshVirtualNode#exact}.
         *
         * @stability stable
         */
        readonly exact: string[];
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatchOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _exact?;
        /**
         * @stability stable
         */
        get exact(): string[];
        /**
         * @stability stable
         */
        set exact(value: string[]);
        /**
         * @stability stable
         */
        get exactInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames {
        /**
         * match block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#match AppmeshVirtualNode#match}
         *
         * @stability stable
         */
        readonly match: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _match?;
        private __matchOutput;
        /**
         * @stability stable
         */
        get match(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatchOutputReference;
        /**
         * @stability stable
         */
        putMatch(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch): void;
        /**
         * @stability stable
         */
        get matchInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcm {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#certificate_authority_arns AppmeshVirtualNode#certificate_authority_arns}.
         *
         * @stability stable
         */
        readonly certificateAuthorityArns: string[];
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcmOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificateAuthorityArns?;
        /**
         * @stability stable
         */
        get certificateAuthorityArns(): string[];
        /**
         * @stability stable
         */
        set certificateAuthorityArns(value: string[]);
        /**
         * @stability stable
         */
        get certificateAuthorityArnsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFile {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#certificate_chain AppmeshVirtualNode#certificate_chain}.
         *
         * @stability stable
         */
        readonly certificateChain: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFileOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificateChain?;
        /**
         * @stability stable
         */
        get certificateChain(): string;
        /**
         * @stability stable
         */
        set certificateChain(value: string);
        /**
         * @stability stable
         */
        get certificateChainInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSds {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#secret_name AppmeshVirtualNode#secret_name}.
         *
         * @stability stable
         */
        readonly secretName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSdsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _secretName?;
        /**
         * @stability stable
         */
        get secretName(): string;
        /**
         * @stability stable
         */
        set secretName(value: string);
        /**
         * @stability stable
         */
        get secretNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrust {
        /**
         * acm block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#acm AppmeshVirtualNode#acm}
         *
         * @stability stable
         */
        readonly acm?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcm;
        /**
         * file block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#file AppmeshVirtualNode#file}
         *
         * @stability stable
         */
        readonly file?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFile;
        /**
         * sds block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#sds AppmeshVirtualNode#sds}
         *
         * @stability stable
         */
        readonly sds?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSds;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _acm?;
        private __acmOutput;
        /**
         * @stability stable
         */
        get acm(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcmOutputReference;
        /**
         * @stability stable
         */
        putAcm(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcm | undefined): void;
        /**
         * @stability stable
         */
        resetAcm(): void;
        /**
         * @stability stable
         */
        get acmInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcm | undefined;
        private _file?;
        private __fileOutput;
        /**
         * @stability stable
         */
        get file(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFileOutputReference;
        /**
         * @stability stable
         */
        putFile(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFile | undefined): void;
        /**
         * @stability stable
         */
        resetFile(): void;
        /**
         * @stability stable
         */
        get fileInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFile | undefined;
        private _sds?;
        private __sdsOutput;
        /**
         * @stability stable
         */
        get sds(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSdsOutputReference;
        /**
         * @stability stable
         */
        putSds(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSds | undefined): void;
        /**
         * @stability stable
         */
        resetSds(): void;
        /**
         * @stability stable
         */
        get sdsInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSds | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidation {
        /**
         * subject_alternative_names block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#subject_alternative_names AppmeshVirtualNode#subject_alternative_names}
         *
         * @stability stable
         */
        readonly subjectAlternativeNames?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames;
        /**
         * trust block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#trust AppmeshVirtualNode#trust}
         *
         * @stability stable
         */
        readonly trust: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrust;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _subjectAlternativeNames?;
        private __subjectAlternativeNamesOutput;
        /**
         * @stability stable
         */
        get subjectAlternativeNames(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesOutputReference;
        /**
         * @stability stable
         */
        putSubjectAlternativeNames(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames | undefined): void;
        /**
         * @stability stable
         */
        resetSubjectAlternativeNames(): void;
        /**
         * @stability stable
         */
        get subjectAlternativeNamesInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames | undefined;
        private _trust?;
        private __trustOutput;
        /**
         * @stability stable
         */
        get trust(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustOutputReference;
        /**
         * @stability stable
         */
        putTrust(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrust): void;
        /**
         * @stability stable
         */
        get trustInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrust | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTls {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#enforce AppmeshVirtualNode#enforce}.
         *
         * @stability stable
         */
        readonly enforce?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#ports AppmeshVirtualNode#ports}.
         *
         * @stability stable
         */
        readonly ports?: number[];
        /**
         * certificate block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#certificate AppmeshVirtualNode#certificate}
         *
         * @stability stable
         */
        readonly certificate?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificate;
        /**
         * validation block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#validation AppmeshVirtualNode#validation}
         *
         * @stability stable
         */
        readonly validation: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidation;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enforce?;
        /**
         * @stability stable
         */
        get enforce(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enforce(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnforce(): void;
        /**
         * @stability stable
         */
        get enforceInput(): boolean | cdktf.IResolvable | undefined;
        private _ports?;
        /**
         * @stability stable
         */
        get ports(): number[] | undefined;
        /**
         * @stability stable
         */
        set ports(value: number[] | undefined);
        /**
         * @stability stable
         */
        resetPorts(): void;
        /**
         * @stability stable
         */
        get portsInput(): number[] | undefined;
        private _certificate?;
        private __certificateOutput;
        /**
         * @stability stable
         */
        get certificate(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateOutputReference;
        /**
         * @stability stable
         */
        putCertificate(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificate | undefined): void;
        /**
         * @stability stable
         */
        resetCertificate(): void;
        /**
         * @stability stable
         */
        get certificateInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificate | undefined;
        private _validation?;
        private __validationOutput;
        /**
         * @stability stable
         */
        get validation(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationOutputReference;
        /**
         * @stability stable
         */
        putValidation(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidation): void;
        /**
         * @stability stable
         */
        get validationInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidation | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicy {
        /**
         * tls block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#tls AppmeshVirtualNode#tls}
         *
         * @stability stable
         */
        readonly tls?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTls;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _tls?;
        private __tlsOutput;
        /**
         * @stability stable
         */
        get tls(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsOutputReference;
        /**
         * @stability stable
         */
        putTls(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTls | undefined): void;
        /**
         * @stability stable
         */
        resetTls(): void;
        /**
         * @stability stable
         */
        get tlsInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTls | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecBackendDefaults {
        /**
         * client_policy block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#client_policy AppmeshVirtualNode#client_policy}
         *
         * @stability stable
         */
        readonly clientPolicy?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicy;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecBackendDefaultsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _clientPolicy?;
        private __clientPolicyOutput;
        /**
         * @stability stable
         */
        get clientPolicy(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyOutputReference;
        /**
         * @stability stable
         */
        putClientPolicy(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicy | undefined): void;
        /**
         * @stability stable
         */
        resetClientPolicy(): void;
        /**
         * @stability stable
         */
        get clientPolicyInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicy | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerConnectionPoolGrpc {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#max_requests AppmeshVirtualNode#max_requests}.
         *
         * @stability stable
         */
        readonly maxRequests: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerConnectionPoolGrpcOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _maxRequests?;
        /**
         * @stability stable
         */
        get maxRequests(): number;
        /**
         * @stability stable
         */
        set maxRequests(value: number);
        /**
         * @stability stable
         */
        get maxRequestsInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerConnectionPoolHttp {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#max_connections AppmeshVirtualNode#max_connections}.
         *
         * @stability stable
         */
        readonly maxConnections: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#max_pending_requests AppmeshVirtualNode#max_pending_requests}.
         *
         * @stability stable
         */
        readonly maxPendingRequests?: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerConnectionPoolHttpOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _maxConnections?;
        /**
         * @stability stable
         */
        get maxConnections(): number;
        /**
         * @stability stable
         */
        set maxConnections(value: number);
        /**
         * @stability stable
         */
        get maxConnectionsInput(): number | undefined;
        private _maxPendingRequests?;
        /**
         * @stability stable
         */
        get maxPendingRequests(): number | undefined;
        /**
         * @stability stable
         */
        set maxPendingRequests(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaxPendingRequests(): void;
        /**
         * @stability stable
         */
        get maxPendingRequestsInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerConnectionPoolHttp2 {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#max_requests AppmeshVirtualNode#max_requests}.
         *
         * @stability stable
         */
        readonly maxRequests: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerConnectionPoolHttp2OutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _maxRequests?;
        /**
         * @stability stable
         */
        get maxRequests(): number;
        /**
         * @stability stable
         */
        set maxRequests(value: number);
        /**
         * @stability stable
         */
        get maxRequestsInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerConnectionPoolTcp {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#max_connections AppmeshVirtualNode#max_connections}.
         *
         * @stability stable
         */
        readonly maxConnections: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerConnectionPoolTcpOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _maxConnections?;
        /**
         * @stability stable
         */
        get maxConnections(): number;
        /**
         * @stability stable
         */
        set maxConnections(value: number);
        /**
         * @stability stable
         */
        get maxConnectionsInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerConnectionPool {
        /**
         * grpc block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#grpc AppmeshVirtualNode#grpc}
         *
         * @stability stable
         */
        readonly grpc?: AppmeshVirtualNodeSpecListenerConnectionPoolGrpc;
        /**
         * http block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#http AppmeshVirtualNode#http}
         *
         * @stability stable
         */
        readonly http?: AppmeshVirtualNodeSpecListenerConnectionPoolHttp;
        /**
         * http2 block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#http2 AppmeshVirtualNode#http2}
         *
         * @stability stable
         */
        readonly http2?: AppmeshVirtualNodeSpecListenerConnectionPoolHttp2;
        /**
         * tcp block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#tcp AppmeshVirtualNode#tcp}
         *
         * @stability stable
         */
        readonly tcp?: AppmeshVirtualNodeSpecListenerConnectionPoolTcp;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerConnectionPoolOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _grpc?;
        private __grpcOutput;
        /**
         * @stability stable
         */
        get grpc(): AppmeshVirtualNodeSpecListenerConnectionPoolGrpcOutputReference;
        /**
         * @stability stable
         */
        putGrpc(value: AppmeshVirtualNodeSpecListenerConnectionPoolGrpc | undefined): void;
        /**
         * @stability stable
         */
        resetGrpc(): void;
        /**
         * @stability stable
         */
        get grpcInput(): AppmeshVirtualNodeSpecListenerConnectionPoolGrpc | undefined;
        private _http?;
        private __httpOutput;
        /**
         * @stability stable
         */
        get http(): AppmeshVirtualNodeSpecListenerConnectionPoolHttpOutputReference;
        /**
         * @stability stable
         */
        putHttp(value: AppmeshVirtualNodeSpecListenerConnectionPoolHttp | undefined): void;
        /**
         * @stability stable
         */
        resetHttp(): void;
        /**
         * @stability stable
         */
        get httpInput(): AppmeshVirtualNodeSpecListenerConnectionPoolHttp | undefined;
        private _http2?;
        private __http2Output;
        /**
         * @stability stable
         */
        get http2(): AppmeshVirtualNodeSpecListenerConnectionPoolHttp2OutputReference;
        /**
         * @stability stable
         */
        putHttp2(value: AppmeshVirtualNodeSpecListenerConnectionPoolHttp2 | undefined): void;
        /**
         * @stability stable
         */
        resetHttp2(): void;
        /**
         * @stability stable
         */
        get http2Input(): AppmeshVirtualNodeSpecListenerConnectionPoolHttp2 | undefined;
        private _tcp?;
        private __tcpOutput;
        /**
         * @stability stable
         */
        get tcp(): AppmeshVirtualNodeSpecListenerConnectionPoolTcpOutputReference;
        /**
         * @stability stable
         */
        putTcp(value: AppmeshVirtualNodeSpecListenerConnectionPoolTcp | undefined): void;
        /**
         * @stability stable
         */
        resetTcp(): void;
        /**
         * @stability stable
         */
        get tcpInput(): AppmeshVirtualNodeSpecListenerConnectionPoolTcp | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerHealthCheck {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#healthy_threshold AppmeshVirtualNode#healthy_threshold}.
         *
         * @stability stable
         */
        readonly healthyThreshold: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#interval_millis AppmeshVirtualNode#interval_millis}.
         *
         * @stability stable
         */
        readonly intervalMillis: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#path AppmeshVirtualNode#path}.
         *
         * @stability stable
         */
        readonly path?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#port AppmeshVirtualNode#port}.
         *
         * @stability stable
         */
        readonly port?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#protocol AppmeshVirtualNode#protocol}.
         *
         * @stability stable
         */
        readonly protocol: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#timeout_millis AppmeshVirtualNode#timeout_millis}.
         *
         * @stability stable
         */
        readonly timeoutMillis: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#unhealthy_threshold AppmeshVirtualNode#unhealthy_threshold}.
         *
         * @stability stable
         */
        readonly unhealthyThreshold: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerHealthCheckOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _healthyThreshold?;
        /**
         * @stability stable
         */
        get healthyThreshold(): number;
        /**
         * @stability stable
         */
        set healthyThreshold(value: number);
        /**
         * @stability stable
         */
        get healthyThresholdInput(): number | undefined;
        private _intervalMillis?;
        /**
         * @stability stable
         */
        get intervalMillis(): number;
        /**
         * @stability stable
         */
        set intervalMillis(value: number);
        /**
         * @stability stable
         */
        get intervalMillisInput(): number | undefined;
        private _path?;
        /**
         * @stability stable
         */
        get path(): string | undefined;
        /**
         * @stability stable
         */
        set path(value: string | undefined);
        /**
         * @stability stable
         */
        resetPath(): void;
        /**
         * @stability stable
         */
        get pathInput(): string | undefined;
        private _port?;
        /**
         * @stability stable
         */
        get port(): number | undefined;
        /**
         * @stability stable
         */
        set port(value: number | undefined);
        /**
         * @stability stable
         */
        resetPort(): void;
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
        private _protocol?;
        /**
         * @stability stable
         */
        get protocol(): string;
        /**
         * @stability stable
         */
        set protocol(value: string);
        /**
         * @stability stable
         */
        get protocolInput(): string | undefined;
        private _timeoutMillis?;
        /**
         * @stability stable
         */
        get timeoutMillis(): number;
        /**
         * @stability stable
         */
        set timeoutMillis(value: number);
        /**
         * @stability stable
         */
        get timeoutMillisInput(): number | undefined;
        private _unhealthyThreshold?;
        /**
         * @stability stable
         */
        get unhealthyThreshold(): number;
        /**
         * @stability stable
         */
        set unhealthyThreshold(value: number);
        /**
         * @stability stable
         */
        get unhealthyThresholdInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDuration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#unit AppmeshVirtualNode#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#value AppmeshVirtualNode#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerOutlierDetectionInterval {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#unit AppmeshVirtualNode#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#value AppmeshVirtualNode#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerOutlierDetectionIntervalOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerOutlierDetection {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#max_ejection_percent AppmeshVirtualNode#max_ejection_percent}.
         *
         * @stability stable
         */
        readonly maxEjectionPercent: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#max_server_errors AppmeshVirtualNode#max_server_errors}.
         *
         * @stability stable
         */
        readonly maxServerErrors: number;
        /**
         * base_ejection_duration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#base_ejection_duration AppmeshVirtualNode#base_ejection_duration}
         *
         * @stability stable
         */
        readonly baseEjectionDuration: AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDuration;
        /**
         * interval block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#interval AppmeshVirtualNode#interval}
         *
         * @stability stable
         */
        readonly interval: AppmeshVirtualNodeSpecListenerOutlierDetectionInterval;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerOutlierDetectionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _maxEjectionPercent?;
        /**
         * @stability stable
         */
        get maxEjectionPercent(): number;
        /**
         * @stability stable
         */
        set maxEjectionPercent(value: number);
        /**
         * @stability stable
         */
        get maxEjectionPercentInput(): number | undefined;
        private _maxServerErrors?;
        /**
         * @stability stable
         */
        get maxServerErrors(): number;
        /**
         * @stability stable
         */
        set maxServerErrors(value: number);
        /**
         * @stability stable
         */
        get maxServerErrorsInput(): number | undefined;
        private _baseEjectionDuration?;
        private __baseEjectionDurationOutput;
        /**
         * @stability stable
         */
        get baseEjectionDuration(): AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDurationOutputReference;
        /**
         * @stability stable
         */
        putBaseEjectionDuration(value: AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDuration): void;
        /**
         * @stability stable
         */
        get baseEjectionDurationInput(): AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDuration | undefined;
        private _interval?;
        private __intervalOutput;
        /**
         * @stability stable
         */
        get interval(): AppmeshVirtualNodeSpecListenerOutlierDetectionIntervalOutputReference;
        /**
         * @stability stable
         */
        putInterval(value: AppmeshVirtualNodeSpecListenerOutlierDetectionInterval): void;
        /**
         * @stability stable
         */
        get intervalInput(): AppmeshVirtualNodeSpecListenerOutlierDetectionInterval | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerPortMapping {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#port AppmeshVirtualNode#port}.
         *
         * @stability stable
         */
        readonly port: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#protocol AppmeshVirtualNode#protocol}.
         *
         * @stability stable
         */
        readonly protocol: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerPortMappingOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _port?;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        set port(value: number);
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
        private _protocol?;
        /**
         * @stability stable
         */
        get protocol(): string;
        /**
         * @stability stable
         */
        set protocol(value: string);
        /**
         * @stability stable
         */
        get protocolInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTimeoutGrpcIdle {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#unit AppmeshVirtualNode#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#value AppmeshVirtualNode#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTimeoutGrpcIdleOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequest {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#unit AppmeshVirtualNode#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#value AppmeshVirtualNode#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequestOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTimeoutGrpc {
        /**
         * idle block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#idle AppmeshVirtualNode#idle}
         *
         * @stability stable
         */
        readonly idle?: AppmeshVirtualNodeSpecListenerTimeoutGrpcIdle;
        /**
         * per_request block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#per_request AppmeshVirtualNode#per_request}
         *
         * @stability stable
         */
        readonly perRequest?: AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequest;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTimeoutGrpcOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _idle?;
        private __idleOutput;
        /**
         * @stability stable
         */
        get idle(): AppmeshVirtualNodeSpecListenerTimeoutGrpcIdleOutputReference;
        /**
         * @stability stable
         */
        putIdle(value: AppmeshVirtualNodeSpecListenerTimeoutGrpcIdle | undefined): void;
        /**
         * @stability stable
         */
        resetIdle(): void;
        /**
         * @stability stable
         */
        get idleInput(): AppmeshVirtualNodeSpecListenerTimeoutGrpcIdle | undefined;
        private _perRequest?;
        private __perRequestOutput;
        /**
         * @stability stable
         */
        get perRequest(): AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequestOutputReference;
        /**
         * @stability stable
         */
        putPerRequest(value: AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequest | undefined): void;
        /**
         * @stability stable
         */
        resetPerRequest(): void;
        /**
         * @stability stable
         */
        get perRequestInput(): AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequest | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTimeoutHttpIdle {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#unit AppmeshVirtualNode#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#value AppmeshVirtualNode#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTimeoutHttpIdleOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequest {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#unit AppmeshVirtualNode#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#value AppmeshVirtualNode#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequestOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTimeoutHttp {
        /**
         * idle block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#idle AppmeshVirtualNode#idle}
         *
         * @stability stable
         */
        readonly idle?: AppmeshVirtualNodeSpecListenerTimeoutHttpIdle;
        /**
         * per_request block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#per_request AppmeshVirtualNode#per_request}
         *
         * @stability stable
         */
        readonly perRequest?: AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequest;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTimeoutHttpOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _idle?;
        private __idleOutput;
        /**
         * @stability stable
         */
        get idle(): AppmeshVirtualNodeSpecListenerTimeoutHttpIdleOutputReference;
        /**
         * @stability stable
         */
        putIdle(value: AppmeshVirtualNodeSpecListenerTimeoutHttpIdle | undefined): void;
        /**
         * @stability stable
         */
        resetIdle(): void;
        /**
         * @stability stable
         */
        get idleInput(): AppmeshVirtualNodeSpecListenerTimeoutHttpIdle | undefined;
        private _perRequest?;
        private __perRequestOutput;
        /**
         * @stability stable
         */
        get perRequest(): AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequestOutputReference;
        /**
         * @stability stable
         */
        putPerRequest(value: AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequest | undefined): void;
        /**
         * @stability stable
         */
        resetPerRequest(): void;
        /**
         * @stability stable
         */
        get perRequestInput(): AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequest | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTimeoutHttp2Idle {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#unit AppmeshVirtualNode#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#value AppmeshVirtualNode#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTimeoutHttp2IdleOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequest {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#unit AppmeshVirtualNode#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#value AppmeshVirtualNode#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequestOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTimeoutHttp2 {
        /**
         * idle block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#idle AppmeshVirtualNode#idle}
         *
         * @stability stable
         */
        readonly idle?: AppmeshVirtualNodeSpecListenerTimeoutHttp2Idle;
        /**
         * per_request block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#per_request AppmeshVirtualNode#per_request}
         *
         * @stability stable
         */
        readonly perRequest?: AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequest;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTimeoutHttp2OutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _idle?;
        private __idleOutput;
        /**
         * @stability stable
         */
        get idle(): AppmeshVirtualNodeSpecListenerTimeoutHttp2IdleOutputReference;
        /**
         * @stability stable
         */
        putIdle(value: AppmeshVirtualNodeSpecListenerTimeoutHttp2Idle | undefined): void;
        /**
         * @stability stable
         */
        resetIdle(): void;
        /**
         * @stability stable
         */
        get idleInput(): AppmeshVirtualNodeSpecListenerTimeoutHttp2Idle | undefined;
        private _perRequest?;
        private __perRequestOutput;
        /**
         * @stability stable
         */
        get perRequest(): AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequestOutputReference;
        /**
         * @stability stable
         */
        putPerRequest(value: AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequest | undefined): void;
        /**
         * @stability stable
         */
        resetPerRequest(): void;
        /**
         * @stability stable
         */
        get perRequestInput(): AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequest | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTimeoutTcpIdle {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#unit AppmeshVirtualNode#unit}.
         *
         * @stability stable
         */
        readonly unit: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#value AppmeshVirtualNode#value}.
         *
         * @stability stable
         */
        readonly value: number;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTimeoutTcpIdleOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _unit?;
        /**
         * @stability stable
         */
        get unit(): string;
        /**
         * @stability stable
         */
        set unit(value: string);
        /**
         * @stability stable
         */
        get unitInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): number;
        /**
         * @stability stable
         */
        set value(value: number);
        /**
         * @stability stable
         */
        get valueInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTimeoutTcp {
        /**
         * idle block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#idle AppmeshVirtualNode#idle}
         *
         * @stability stable
         */
        readonly idle?: AppmeshVirtualNodeSpecListenerTimeoutTcpIdle;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTimeoutTcpOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _idle?;
        private __idleOutput;
        /**
         * @stability stable
         */
        get idle(): AppmeshVirtualNodeSpecListenerTimeoutTcpIdleOutputReference;
        /**
         * @stability stable
         */
        putIdle(value: AppmeshVirtualNodeSpecListenerTimeoutTcpIdle | undefined): void;
        /**
         * @stability stable
         */
        resetIdle(): void;
        /**
         * @stability stable
         */
        get idleInput(): AppmeshVirtualNodeSpecListenerTimeoutTcpIdle | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTimeout {
        /**
         * grpc block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#grpc AppmeshVirtualNode#grpc}
         *
         * @stability stable
         */
        readonly grpc?: AppmeshVirtualNodeSpecListenerTimeoutGrpc;
        /**
         * http block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#http AppmeshVirtualNode#http}
         *
         * @stability stable
         */
        readonly http?: AppmeshVirtualNodeSpecListenerTimeoutHttp;
        /**
         * http2 block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#http2 AppmeshVirtualNode#http2}
         *
         * @stability stable
         */
        readonly http2?: AppmeshVirtualNodeSpecListenerTimeoutHttp2;
        /**
         * tcp block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#tcp AppmeshVirtualNode#tcp}
         *
         * @stability stable
         */
        readonly tcp?: AppmeshVirtualNodeSpecListenerTimeoutTcp;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTimeoutOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _grpc?;
        private __grpcOutput;
        /**
         * @stability stable
         */
        get grpc(): AppmeshVirtualNodeSpecListenerTimeoutGrpcOutputReference;
        /**
         * @stability stable
         */
        putGrpc(value: AppmeshVirtualNodeSpecListenerTimeoutGrpc | undefined): void;
        /**
         * @stability stable
         */
        resetGrpc(): void;
        /**
         * @stability stable
         */
        get grpcInput(): AppmeshVirtualNodeSpecListenerTimeoutGrpc | undefined;
        private _http?;
        private __httpOutput;
        /**
         * @stability stable
         */
        get http(): AppmeshVirtualNodeSpecListenerTimeoutHttpOutputReference;
        /**
         * @stability stable
         */
        putHttp(value: AppmeshVirtualNodeSpecListenerTimeoutHttp | undefined): void;
        /**
         * @stability stable
         */
        resetHttp(): void;
        /**
         * @stability stable
         */
        get httpInput(): AppmeshVirtualNodeSpecListenerTimeoutHttp | undefined;
        private _http2?;
        private __http2Output;
        /**
         * @stability stable
         */
        get http2(): AppmeshVirtualNodeSpecListenerTimeoutHttp2OutputReference;
        /**
         * @stability stable
         */
        putHttp2(value: AppmeshVirtualNodeSpecListenerTimeoutHttp2 | undefined): void;
        /**
         * @stability stable
         */
        resetHttp2(): void;
        /**
         * @stability stable
         */
        get http2Input(): AppmeshVirtualNodeSpecListenerTimeoutHttp2 | undefined;
        private _tcp?;
        private __tcpOutput;
        /**
         * @stability stable
         */
        get tcp(): AppmeshVirtualNodeSpecListenerTimeoutTcpOutputReference;
        /**
         * @stability stable
         */
        putTcp(value: AppmeshVirtualNodeSpecListenerTimeoutTcp | undefined): void;
        /**
         * @stability stable
         */
        resetTcp(): void;
        /**
         * @stability stable
         */
        get tcpInput(): AppmeshVirtualNodeSpecListenerTimeoutTcp | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTlsCertificateAcm {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#certificate_arn AppmeshVirtualNode#certificate_arn}.
         *
         * @stability stable
         */
        readonly certificateArn: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTlsCertificateAcmOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificateArn?;
        /**
         * @stability stable
         */
        get certificateArn(): string;
        /**
         * @stability stable
         */
        set certificateArn(value: string);
        /**
         * @stability stable
         */
        get certificateArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTlsCertificateFile {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#certificate_chain AppmeshVirtualNode#certificate_chain}.
         *
         * @stability stable
         */
        readonly certificateChain: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#private_key AppmeshVirtualNode#private_key}.
         *
         * @stability stable
         */
        readonly privateKey: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTlsCertificateFileOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificateChain?;
        /**
         * @stability stable
         */
        get certificateChain(): string;
        /**
         * @stability stable
         */
        set certificateChain(value: string);
        /**
         * @stability stable
         */
        get certificateChainInput(): string | undefined;
        private _privateKey?;
        /**
         * @stability stable
         */
        get privateKey(): string;
        /**
         * @stability stable
         */
        set privateKey(value: string);
        /**
         * @stability stable
         */
        get privateKeyInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTlsCertificateSds {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#secret_name AppmeshVirtualNode#secret_name}.
         *
         * @stability stable
         */
        readonly secretName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTlsCertificateSdsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _secretName?;
        /**
         * @stability stable
         */
        get secretName(): string;
        /**
         * @stability stable
         */
        set secretName(value: string);
        /**
         * @stability stable
         */
        get secretNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTlsCertificate {
        /**
         * acm block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#acm AppmeshVirtualNode#acm}
         *
         * @stability stable
         */
        readonly acm?: AppmeshVirtualNodeSpecListenerTlsCertificateAcm;
        /**
         * file block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#file AppmeshVirtualNode#file}
         *
         * @stability stable
         */
        readonly file?: AppmeshVirtualNodeSpecListenerTlsCertificateFile;
        /**
         * sds block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#sds AppmeshVirtualNode#sds}
         *
         * @stability stable
         */
        readonly sds?: AppmeshVirtualNodeSpecListenerTlsCertificateSds;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTlsCertificateOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _acm?;
        private __acmOutput;
        /**
         * @stability stable
         */
        get acm(): AppmeshVirtualNodeSpecListenerTlsCertificateAcmOutputReference;
        /**
         * @stability stable
         */
        putAcm(value: AppmeshVirtualNodeSpecListenerTlsCertificateAcm | undefined): void;
        /**
         * @stability stable
         */
        resetAcm(): void;
        /**
         * @stability stable
         */
        get acmInput(): AppmeshVirtualNodeSpecListenerTlsCertificateAcm | undefined;
        private _file?;
        private __fileOutput;
        /**
         * @stability stable
         */
        get file(): AppmeshVirtualNodeSpecListenerTlsCertificateFileOutputReference;
        /**
         * @stability stable
         */
        putFile(value: AppmeshVirtualNodeSpecListenerTlsCertificateFile | undefined): void;
        /**
         * @stability stable
         */
        resetFile(): void;
        /**
         * @stability stable
         */
        get fileInput(): AppmeshVirtualNodeSpecListenerTlsCertificateFile | undefined;
        private _sds?;
        private __sdsOutput;
        /**
         * @stability stable
         */
        get sds(): AppmeshVirtualNodeSpecListenerTlsCertificateSdsOutputReference;
        /**
         * @stability stable
         */
        putSds(value: AppmeshVirtualNodeSpecListenerTlsCertificateSds | undefined): void;
        /**
         * @stability stable
         */
        resetSds(): void;
        /**
         * @stability stable
         */
        get sdsInput(): AppmeshVirtualNodeSpecListenerTlsCertificateSds | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatch {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#exact AppmeshVirtualNode#exact}.
         *
         * @stability stable
         */
        readonly exact: string[];
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatchOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _exact?;
        /**
         * @stability stable
         */
        get exact(): string[];
        /**
         * @stability stable
         */
        set exact(value: string[]);
        /**
         * @stability stable
         */
        get exactInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNames {
        /**
         * match block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#match AppmeshVirtualNode#match}
         *
         * @stability stable
         */
        readonly match: AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatch;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _match?;
        private __matchOutput;
        /**
         * @stability stable
         */
        get match(): AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatchOutputReference;
        /**
         * @stability stable
         */
        putMatch(value: AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatch): void;
        /**
         * @stability stable
         */
        get matchInput(): AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatch | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTlsValidationTrustFile {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#certificate_chain AppmeshVirtualNode#certificate_chain}.
         *
         * @stability stable
         */
        readonly certificateChain: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTlsValidationTrustFileOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _certificateChain?;
        /**
         * @stability stable
         */
        get certificateChain(): string;
        /**
         * @stability stable
         */
        set certificateChain(value: string);
        /**
         * @stability stable
         */
        get certificateChainInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTlsValidationTrustSds {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#secret_name AppmeshVirtualNode#secret_name}.
         *
         * @stability stable
         */
        readonly secretName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTlsValidationTrustSdsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _secretName?;
        /**
         * @stability stable
         */
        get secretName(): string;
        /**
         * @stability stable
         */
        set secretName(value: string);
        /**
         * @stability stable
         */
        get secretNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTlsValidationTrust {
        /**
         * file block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#file AppmeshVirtualNode#file}
         *
         * @stability stable
         */
        readonly file?: AppmeshVirtualNodeSpecListenerTlsValidationTrustFile;
        /**
         * sds block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#sds AppmeshVirtualNode#sds}
         *
         * @stability stable
         */
        readonly sds?: AppmeshVirtualNodeSpecListenerTlsValidationTrustSds;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTlsValidationTrustOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _file?;
        private __fileOutput;
        /**
         * @stability stable
         */
        get file(): AppmeshVirtualNodeSpecListenerTlsValidationTrustFileOutputReference;
        /**
         * @stability stable
         */
        putFile(value: AppmeshVirtualNodeSpecListenerTlsValidationTrustFile | undefined): void;
        /**
         * @stability stable
         */
        resetFile(): void;
        /**
         * @stability stable
         */
        get fileInput(): AppmeshVirtualNodeSpecListenerTlsValidationTrustFile | undefined;
        private _sds?;
        private __sdsOutput;
        /**
         * @stability stable
         */
        get sds(): AppmeshVirtualNodeSpecListenerTlsValidationTrustSdsOutputReference;
        /**
         * @stability stable
         */
        putSds(value: AppmeshVirtualNodeSpecListenerTlsValidationTrustSds | undefined): void;
        /**
         * @stability stable
         */
        resetSds(): void;
        /**
         * @stability stable
         */
        get sdsInput(): AppmeshVirtualNodeSpecListenerTlsValidationTrustSds | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTlsValidation {
        /**
         * subject_alternative_names block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#subject_alternative_names AppmeshVirtualNode#subject_alternative_names}
         *
         * @stability stable
         */
        readonly subjectAlternativeNames?: AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNames;
        /**
         * trust block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#trust AppmeshVirtualNode#trust}
         *
         * @stability stable
         */
        readonly trust: AppmeshVirtualNodeSpecListenerTlsValidationTrust;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTlsValidationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _subjectAlternativeNames?;
        private __subjectAlternativeNamesOutput;
        /**
         * @stability stable
         */
        get subjectAlternativeNames(): AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesOutputReference;
        /**
         * @stability stable
         */
        putSubjectAlternativeNames(value: AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNames | undefined): void;
        /**
         * @stability stable
         */
        resetSubjectAlternativeNames(): void;
        /**
         * @stability stable
         */
        get subjectAlternativeNamesInput(): AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNames | undefined;
        private _trust?;
        private __trustOutput;
        /**
         * @stability stable
         */
        get trust(): AppmeshVirtualNodeSpecListenerTlsValidationTrustOutputReference;
        /**
         * @stability stable
         */
        putTrust(value: AppmeshVirtualNodeSpecListenerTlsValidationTrust): void;
        /**
         * @stability stable
         */
        get trustInput(): AppmeshVirtualNodeSpecListenerTlsValidationTrust | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListenerTls {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#mode AppmeshVirtualNode#mode}.
         *
         * @stability stable
         */
        readonly mode: string;
        /**
         * certificate block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#certificate AppmeshVirtualNode#certificate}
         *
         * @stability stable
         */
        readonly certificate: AppmeshVirtualNodeSpecListenerTlsCertificate;
        /**
         * validation block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#validation AppmeshVirtualNode#validation}
         *
         * @stability stable
         */
        readonly validation?: AppmeshVirtualNodeSpecListenerTlsValidation;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerTlsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _mode?;
        /**
         * @stability stable
         */
        get mode(): string;
        /**
         * @stability stable
         */
        set mode(value: string);
        /**
         * @stability stable
         */
        get modeInput(): string | undefined;
        private _certificate?;
        private __certificateOutput;
        /**
         * @stability stable
         */
        get certificate(): AppmeshVirtualNodeSpecListenerTlsCertificateOutputReference;
        /**
         * @stability stable
         */
        putCertificate(value: AppmeshVirtualNodeSpecListenerTlsCertificate): void;
        /**
         * @stability stable
         */
        get certificateInput(): AppmeshVirtualNodeSpecListenerTlsCertificate | undefined;
        private _validation?;
        private __validationOutput;
        /**
         * @stability stable
         */
        get validation(): AppmeshVirtualNodeSpecListenerTlsValidationOutputReference;
        /**
         * @stability stable
         */
        putValidation(value: AppmeshVirtualNodeSpecListenerTlsValidation | undefined): void;
        /**
         * @stability stable
         */
        resetValidation(): void;
        /**
         * @stability stable
         */
        get validationInput(): AppmeshVirtualNodeSpecListenerTlsValidation | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecListener {
        /**
         * connection_pool block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#connection_pool AppmeshVirtualNode#connection_pool}
         *
         * @stability stable
         */
        readonly connectionPool?: AppmeshVirtualNodeSpecListenerConnectionPool;
        /**
         * health_check block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#health_check AppmeshVirtualNode#health_check}
         *
         * @stability stable
         */
        readonly healthCheck?: AppmeshVirtualNodeSpecListenerHealthCheck;
        /**
         * outlier_detection block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#outlier_detection AppmeshVirtualNode#outlier_detection}
         *
         * @stability stable
         */
        readonly outlierDetection?: AppmeshVirtualNodeSpecListenerOutlierDetection;
        /**
         * port_mapping block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#port_mapping AppmeshVirtualNode#port_mapping}
         *
         * @stability stable
         */
        readonly portMapping: AppmeshVirtualNodeSpecListenerPortMapping;
        /**
         * timeout block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#timeout AppmeshVirtualNode#timeout}
         *
         * @stability stable
         */
        readonly timeout?: AppmeshVirtualNodeSpecListenerTimeout;
        /**
         * tls block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#tls AppmeshVirtualNode#tls}
         *
         * @stability stable
         */
        readonly tls?: AppmeshVirtualNodeSpecListenerTls;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecListenerOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _connectionPool?;
        private __connectionPoolOutput;
        /**
         * @stability stable
         */
        get connectionPool(): AppmeshVirtualNodeSpecListenerConnectionPoolOutputReference;
        /**
         * @stability stable
         */
        putConnectionPool(value: AppmeshVirtualNodeSpecListenerConnectionPool | undefined): void;
        /**
         * @stability stable
         */
        resetConnectionPool(): void;
        /**
         * @stability stable
         */
        get connectionPoolInput(): AppmeshVirtualNodeSpecListenerConnectionPool | undefined;
        private _healthCheck?;
        private __healthCheckOutput;
        /**
         * @stability stable
         */
        get healthCheck(): AppmeshVirtualNodeSpecListenerHealthCheckOutputReference;
        /**
         * @stability stable
         */
        putHealthCheck(value: AppmeshVirtualNodeSpecListenerHealthCheck | undefined): void;
        /**
         * @stability stable
         */
        resetHealthCheck(): void;
        /**
         * @stability stable
         */
        get healthCheckInput(): AppmeshVirtualNodeSpecListenerHealthCheck | undefined;
        private _outlierDetection?;
        private __outlierDetectionOutput;
        /**
         * @stability stable
         */
        get outlierDetection(): AppmeshVirtualNodeSpecListenerOutlierDetectionOutputReference;
        /**
         * @stability stable
         */
        putOutlierDetection(value: AppmeshVirtualNodeSpecListenerOutlierDetection | undefined): void;
        /**
         * @stability stable
         */
        resetOutlierDetection(): void;
        /**
         * @stability stable
         */
        get outlierDetectionInput(): AppmeshVirtualNodeSpecListenerOutlierDetection | undefined;
        private _portMapping?;
        private __portMappingOutput;
        /**
         * @stability stable
         */
        get portMapping(): AppmeshVirtualNodeSpecListenerPortMappingOutputReference;
        /**
         * @stability stable
         */
        putPortMapping(value: AppmeshVirtualNodeSpecListenerPortMapping): void;
        /**
         * @stability stable
         */
        get portMappingInput(): AppmeshVirtualNodeSpecListenerPortMapping | undefined;
        private _timeout?;
        private __timeoutOutput;
        /**
         * @stability stable
         */
        get timeout(): AppmeshVirtualNodeSpecListenerTimeoutOutputReference;
        /**
         * @stability stable
         */
        putTimeout(value: AppmeshVirtualNodeSpecListenerTimeout | undefined): void;
        /**
         * @stability stable
         */
        resetTimeout(): void;
        /**
         * @stability stable
         */
        get timeoutInput(): AppmeshVirtualNodeSpecListenerTimeout | undefined;
        private _tls?;
        private __tlsOutput;
        /**
         * @stability stable
         */
        get tls(): AppmeshVirtualNodeSpecListenerTlsOutputReference;
        /**
         * @stability stable
         */
        putTls(value: AppmeshVirtualNodeSpecListenerTls | undefined): void;
        /**
         * @stability stable
         */
        resetTls(): void;
        /**
         * @stability stable
         */
        get tlsInput(): AppmeshVirtualNodeSpecListenerTls | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecLoggingAccessLogFile {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#path AppmeshVirtualNode#path}.
         *
         * @stability stable
         */
        readonly path: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecLoggingAccessLogFileOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _path?;
        /**
         * @stability stable
         */
        get path(): string;
        /**
         * @stability stable
         */
        set path(value: string);
        /**
         * @stability stable
         */
        get pathInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecLoggingAccessLog {
        /**
         * file block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#file AppmeshVirtualNode#file}
         *
         * @stability stable
         */
        readonly file?: AppmeshVirtualNodeSpecLoggingAccessLogFile;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecLoggingAccessLogOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _file?;
        private __fileOutput;
        /**
         * @stability stable
         */
        get file(): AppmeshVirtualNodeSpecLoggingAccessLogFileOutputReference;
        /**
         * @stability stable
         */
        putFile(value: AppmeshVirtualNodeSpecLoggingAccessLogFile | undefined): void;
        /**
         * @stability stable
         */
        resetFile(): void;
        /**
         * @stability stable
         */
        get fileInput(): AppmeshVirtualNodeSpecLoggingAccessLogFile | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecLogging {
        /**
         * access_log block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#access_log AppmeshVirtualNode#access_log}
         *
         * @stability stable
         */
        readonly accessLog?: AppmeshVirtualNodeSpecLoggingAccessLog;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecLoggingOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _accessLog?;
        private __accessLogOutput;
        /**
         * @stability stable
         */
        get accessLog(): AppmeshVirtualNodeSpecLoggingAccessLogOutputReference;
        /**
         * @stability stable
         */
        putAccessLog(value: AppmeshVirtualNodeSpecLoggingAccessLog | undefined): void;
        /**
         * @stability stable
         */
        resetAccessLog(): void;
        /**
         * @stability stable
         */
        get accessLogInput(): AppmeshVirtualNodeSpecLoggingAccessLog | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMap {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#attributes AppmeshVirtualNode#attributes}.
         *
         * @stability stable
         */
        readonly attributes?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#namespace_name AppmeshVirtualNode#namespace_name}.
         *
         * @stability stable
         */
        readonly namespaceName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#service_name AppmeshVirtualNode#service_name}.
         *
         * @stability stable
         */
        readonly serviceName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMapOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _attributes?;
        /**
         * @stability stable
         */
        get attributes(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set attributes(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAttributes(): void;
        /**
         * @stability stable
         */
        get attributesInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _namespaceName?;
        /**
         * @stability stable
         */
        get namespaceName(): string;
        /**
         * @stability stable
         */
        set namespaceName(value: string);
        /**
         * @stability stable
         */
        get namespaceNameInput(): string | undefined;
        private _serviceName?;
        /**
         * @stability stable
         */
        get serviceName(): string;
        /**
         * @stability stable
         */
        set serviceName(value: string);
        /**
         * @stability stable
         */
        get serviceNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecServiceDiscoveryDns {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#hostname AppmeshVirtualNode#hostname}.
         *
         * @stability stable
         */
        readonly hostname: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecServiceDiscoveryDnsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _hostname?;
        /**
         * @stability stable
         */
        get hostname(): string;
        /**
         * @stability stable
         */
        set hostname(value: string);
        /**
         * @stability stable
         */
        get hostnameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpecServiceDiscovery {
        /**
         * aws_cloud_map block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#aws_cloud_map AppmeshVirtualNode#aws_cloud_map}
         *
         * @stability stable
         */
        readonly awsCloudMap?: AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMap;
        /**
         * dns block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#dns AppmeshVirtualNode#dns}
         *
         * @stability stable
         */
        readonly dns?: AppmeshVirtualNodeSpecServiceDiscoveryDns;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecServiceDiscoveryOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _awsCloudMap?;
        private __awsCloudMapOutput;
        /**
         * @stability stable
         */
        get awsCloudMap(): AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMapOutputReference;
        /**
         * @stability stable
         */
        putAwsCloudMap(value: AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMap | undefined): void;
        /**
         * @stability stable
         */
        resetAwsCloudMap(): void;
        /**
         * @stability stable
         */
        get awsCloudMapInput(): AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMap | undefined;
        private _dns?;
        private __dnsOutput;
        /**
         * @stability stable
         */
        get dns(): AppmeshVirtualNodeSpecServiceDiscoveryDnsOutputReference;
        /**
         * @stability stable
         */
        putDns(value: AppmeshVirtualNodeSpecServiceDiscoveryDns | undefined): void;
        /**
         * @stability stable
         */
        resetDns(): void;
        /**
         * @stability stable
         */
        get dnsInput(): AppmeshVirtualNodeSpecServiceDiscoveryDns | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualNodeSpec {
        /**
         * backend block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#backend AppmeshVirtualNode#backend}
         *
         * @stability stable
         */
        readonly backend?: AppmeshVirtualNodeSpecBackend[];
        /**
         * backend_defaults block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#backend_defaults AppmeshVirtualNode#backend_defaults}
         *
         * @stability stable
         */
        readonly backendDefaults?: AppmeshVirtualNodeSpecBackendDefaults;
        /**
         * listener block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#listener AppmeshVirtualNode#listener}
         *
         * @stability stable
         */
        readonly listener?: AppmeshVirtualNodeSpecListener;
        /**
         * logging block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#logging AppmeshVirtualNode#logging}
         *
         * @stability stable
         */
        readonly logging?: AppmeshVirtualNodeSpecLogging;
        /**
         * service_discovery block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html#service_discovery AppmeshVirtualNode#service_discovery}
         *
         * @stability stable
         */
        readonly serviceDiscovery?: AppmeshVirtualNodeSpecServiceDiscovery;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualNodeSpecOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _backend?;
        /**
         * @stability stable
         */
        get backend(): AppmeshVirtualNodeSpecBackend[] | undefined;
        /**
         * @stability stable
         */
        set backend(value: AppmeshVirtualNodeSpecBackend[] | undefined);
        /**
         * @stability stable
         */
        resetBackend(): void;
        /**
         * @stability stable
         */
        get backendInput(): AppmeshVirtualNodeSpecBackend[] | undefined;
        private _backendDefaults?;
        private __backendDefaultsOutput;
        /**
         * @stability stable
         */
        get backendDefaults(): AppmeshVirtualNodeSpecBackendDefaultsOutputReference;
        /**
         * @stability stable
         */
        putBackendDefaults(value: AppmeshVirtualNodeSpecBackendDefaults | undefined): void;
        /**
         * @stability stable
         */
        resetBackendDefaults(): void;
        /**
         * @stability stable
         */
        get backendDefaultsInput(): AppmeshVirtualNodeSpecBackendDefaults | undefined;
        private _listener?;
        private __listenerOutput;
        /**
         * @stability stable
         */
        get listener(): AppmeshVirtualNodeSpecListenerOutputReference;
        /**
         * @stability stable
         */
        putListener(value: AppmeshVirtualNodeSpecListener | undefined): void;
        /**
         * @stability stable
         */
        resetListener(): void;
        /**
         * @stability stable
         */
        get listenerInput(): AppmeshVirtualNodeSpecListener | undefined;
        private _logging?;
        private __loggingOutput;
        /**
         * @stability stable
         */
        get logging(): AppmeshVirtualNodeSpecLoggingOutputReference;
        /**
         * @stability stable
         */
        putLogging(value: AppmeshVirtualNodeSpecLogging | undefined): void;
        /**
         * @stability stable
         */
        resetLogging(): void;
        /**
         * @stability stable
         */
        get loggingInput(): AppmeshVirtualNodeSpecLogging | undefined;
        private _serviceDiscovery?;
        private __serviceDiscoveryOutput;
        /**
         * @stability stable
         */
        get serviceDiscovery(): AppmeshVirtualNodeSpecServiceDiscoveryOutputReference;
        /**
         * @stability stable
         */
        putServiceDiscovery(value: AppmeshVirtualNodeSpecServiceDiscovery | undefined): void;
        /**
         * @stability stable
         */
        resetServiceDiscovery(): void;
        /**
         * @stability stable
         */
        get serviceDiscoveryInput(): AppmeshVirtualNodeSpecServiceDiscovery | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html aws_appmesh_virtual_node}.
     *
     * @stability stable
     */
    class AppmeshVirtualNode extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node.html aws_appmesh_virtual_node} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AppmeshVirtualNodeConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdDate(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        private _meshName?;
        /**
         * @stability stable
         */
        get meshName(): string;
        /**
         * @stability stable
         */
        set meshName(value: string);
        /**
         * @stability stable
         */
        get meshNameInput(): string | undefined;
        private _meshOwner?;
        /**
         * @stability stable
         */
        get meshOwner(): string | undefined;
        /**
         * @stability stable
         */
        set meshOwner(value: string | undefined);
        /**
         * @stability stable
         */
        resetMeshOwner(): void;
        /**
         * @stability stable
         */
        get meshOwnerInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get resourceOwner(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _spec?;
        private __specOutput;
        /**
         * @stability stable
         */
        get spec(): AppmeshVirtualNodeSpecOutputReference;
        /**
         * @stability stable
         */
        putSpec(value: AppmeshVirtualNodeSpec): void;
        /**
         * @stability stable
         */
        get specInput(): AppmeshVirtualNodeSpec | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualRouterConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_router.html#mesh_name AppmeshVirtualRouter#mesh_name}.
         *
         * @stability stable
         */
        readonly meshName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_router.html#mesh_owner AppmeshVirtualRouter#mesh_owner}.
         *
         * @stability stable
         */
        readonly meshOwner?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_router.html#name AppmeshVirtualRouter#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_router.html#tags AppmeshVirtualRouter#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_router.html#tags_all AppmeshVirtualRouter#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * spec block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_router.html#spec AppmeshVirtualRouter#spec}
         *
         * @stability stable
         */
        readonly spec: AppmeshVirtualRouterSpec;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualRouterSpecListenerPortMapping {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_router.html#port AppmeshVirtualRouter#port}.
         *
         * @stability stable
         */
        readonly port: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_router.html#protocol AppmeshVirtualRouter#protocol}.
         *
         * @stability stable
         */
        readonly protocol: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualRouterSpecListenerPortMappingOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _port?;
        /**
         * @stability stable
         */
        get port(): number;
        /**
         * @stability stable
         */
        set port(value: number);
        /**
         * @stability stable
         */
        get portInput(): number | undefined;
        private _protocol?;
        /**
         * @stability stable
         */
        get protocol(): string;
        /**
         * @stability stable
         */
        set protocol(value: string);
        /**
         * @stability stable
         */
        get protocolInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualRouterSpecListener {
        /**
         * port_mapping block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_router.html#port_mapping AppmeshVirtualRouter#port_mapping}
         *
         * @stability stable
         */
        readonly portMapping: AppmeshVirtualRouterSpecListenerPortMapping;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualRouterSpecListenerOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _portMapping?;
        private __portMappingOutput;
        /**
         * @stability stable
         */
        get portMapping(): AppmeshVirtualRouterSpecListenerPortMappingOutputReference;
        /**
         * @stability stable
         */
        putPortMapping(value: AppmeshVirtualRouterSpecListenerPortMapping): void;
        /**
         * @stability stable
         */
        get portMappingInput(): AppmeshVirtualRouterSpecListenerPortMapping | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualRouterSpec {
        /**
         * listener block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_router.html#listener AppmeshVirtualRouter#listener}
         *
         * @stability stable
         */
        readonly listener: AppmeshVirtualRouterSpecListener;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualRouterSpecOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _listener?;
        private __listenerOutput;
        /**
         * @stability stable
         */
        get listener(): AppmeshVirtualRouterSpecListenerOutputReference;
        /**
         * @stability stable
         */
        putListener(value: AppmeshVirtualRouterSpecListener): void;
        /**
         * @stability stable
         */
        get listenerInput(): AppmeshVirtualRouterSpecListener | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_router.html aws_appmesh_virtual_router}.
     *
     * @stability stable
     */
    class AppmeshVirtualRouter extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_router.html aws_appmesh_virtual_router} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AppmeshVirtualRouterConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdDate(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        private _meshName?;
        /**
         * @stability stable
         */
        get meshName(): string;
        /**
         * @stability stable
         */
        set meshName(value: string);
        /**
         * @stability stable
         */
        get meshNameInput(): string | undefined;
        private _meshOwner?;
        /**
         * @stability stable
         */
        get meshOwner(): string | undefined;
        /**
         * @stability stable
         */
        set meshOwner(value: string | undefined);
        /**
         * @stability stable
         */
        resetMeshOwner(): void;
        /**
         * @stability stable
         */
        get meshOwnerInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get resourceOwner(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _spec?;
        private __specOutput;
        /**
         * @stability stable
         */
        get spec(): AppmeshVirtualRouterSpecOutputReference;
        /**
         * @stability stable
         */
        putSpec(value: AppmeshVirtualRouterSpec): void;
        /**
         * @stability stable
         */
        get specInput(): AppmeshVirtualRouterSpec | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualServiceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service.html#mesh_name AppmeshVirtualService#mesh_name}.
         *
         * @stability stable
         */
        readonly meshName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service.html#mesh_owner AppmeshVirtualService#mesh_owner}.
         *
         * @stability stable
         */
        readonly meshOwner?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service.html#name AppmeshVirtualService#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service.html#tags AppmeshVirtualService#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service.html#tags_all AppmeshVirtualService#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * spec block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service.html#spec AppmeshVirtualService#spec}
         *
         * @stability stable
         */
        readonly spec: AppmeshVirtualServiceSpec;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualServiceSpecProviderVirtualNode {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service.html#virtual_node_name AppmeshVirtualService#virtual_node_name}.
         *
         * @stability stable
         */
        readonly virtualNodeName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualServiceSpecProviderVirtualNodeOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _virtualNodeName?;
        /**
         * @stability stable
         */
        get virtualNodeName(): string;
        /**
         * @stability stable
         */
        set virtualNodeName(value: string);
        /**
         * @stability stable
         */
        get virtualNodeNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualServiceSpecProviderVirtualRouter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service.html#virtual_router_name AppmeshVirtualService#virtual_router_name}.
         *
         * @stability stable
         */
        readonly virtualRouterName: string;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualServiceSpecProviderVirtualRouterOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _virtualRouterName?;
        /**
         * @stability stable
         */
        get virtualRouterName(): string;
        /**
         * @stability stable
         */
        set virtualRouterName(value: string);
        /**
         * @stability stable
         */
        get virtualRouterNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualServiceSpecProvider {
        /**
         * virtual_node block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service.html#virtual_node AppmeshVirtualService#virtual_node}
         *
         * @stability stable
         */
        readonly virtualNode?: AppmeshVirtualServiceSpecProviderVirtualNode;
        /**
         * virtual_router block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service.html#virtual_router AppmeshVirtualService#virtual_router}
         *
         * @stability stable
         */
        readonly virtualRouter?: AppmeshVirtualServiceSpecProviderVirtualRouter;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualServiceSpecProviderOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _virtualNode?;
        private __virtualNodeOutput;
        /**
         * @stability stable
         */
        get virtualNode(): AppmeshVirtualServiceSpecProviderVirtualNodeOutputReference;
        /**
         * @stability stable
         */
        putVirtualNode(value: AppmeshVirtualServiceSpecProviderVirtualNode | undefined): void;
        /**
         * @stability stable
         */
        resetVirtualNode(): void;
        /**
         * @stability stable
         */
        get virtualNodeInput(): AppmeshVirtualServiceSpecProviderVirtualNode | undefined;
        private _virtualRouter?;
        private __virtualRouterOutput;
        /**
         * @stability stable
         */
        get virtualRouter(): AppmeshVirtualServiceSpecProviderVirtualRouterOutputReference;
        /**
         * @stability stable
         */
        putVirtualRouter(value: AppmeshVirtualServiceSpecProviderVirtualRouter | undefined): void;
        /**
         * @stability stable
         */
        resetVirtualRouter(): void;
        /**
         * @stability stable
         */
        get virtualRouterInput(): AppmeshVirtualServiceSpecProviderVirtualRouter | undefined;
    }
    /**
     * @stability stable
     */
    interface AppmeshVirtualServiceSpec {
        /**
         * provider block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service.html#provider AppmeshVirtualService#provider}
         *
         * @stability stable
         */
        readonly provider?: AppmeshVirtualServiceSpecProvider;
    }
    /**
     * @stability stable
     */
    class AppmeshVirtualServiceSpecOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _provider?;
        private __providerOutput;
        /**
         * @stability stable
         */
        get provider(): AppmeshVirtualServiceSpecProviderOutputReference;
        /**
         * @stability stable
         */
        putProvider(value: AppmeshVirtualServiceSpecProvider | undefined): void;
        /**
         * @stability stable
         */
        resetProvider(): void;
        /**
         * @stability stable
         */
        get providerInput(): AppmeshVirtualServiceSpecProvider | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service.html aws_appmesh_virtual_service}.
     *
     * @stability stable
     */
    class AppmeshVirtualService extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service.html aws_appmesh_virtual_service} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AppmeshVirtualServiceConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdDate(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        private _meshName?;
        /**
         * @stability stable
         */
        get meshName(): string;
        /**
         * @stability stable
         */
        set meshName(value: string);
        /**
         * @stability stable
         */
        get meshNameInput(): string | undefined;
        private _meshOwner?;
        /**
         * @stability stable
         */
        get meshOwner(): string | undefined;
        /**
         * @stability stable
         */
        set meshOwner(value: string | undefined);
        /**
         * @stability stable
         */
        resetMeshOwner(): void;
        /**
         * @stability stable
         */
        get meshOwnerInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get resourceOwner(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _spec?;
        private __specOutput;
        /**
         * @stability stable
         */
        get spec(): AppmeshVirtualServiceSpecOutputReference;
        /**
         * @stability stable
         */
        putSpec(value: AppmeshVirtualServiceSpec): void;
        /**
         * @stability stable
         */
        get specInput(): AppmeshVirtualServiceSpec | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsAppmeshMeshConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/appmesh_mesh.html#mesh_owner DataAwsAppmeshMesh#mesh_owner}.
         *
         * @stability stable
         */
        readonly meshOwner?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/appmesh_mesh.html#name DataAwsAppmeshMesh#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/appmesh_mesh.html#tags DataAwsAppmeshMesh#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class DataAwsAppmeshMeshSpecEgressFilter extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get type(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsAppmeshMeshSpec extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get egressFilter(): any;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/appmesh_mesh.html aws_appmesh_mesh}.
     *
     * @stability stable
     */
    class DataAwsAppmeshMesh extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/appmesh_mesh.html aws_appmesh_mesh} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsAppmeshMeshConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdDate(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        private _meshOwner?;
        /**
         * @stability stable
         */
        get meshOwner(): string | undefined;
        /**
         * @stability stable
         */
        set meshOwner(value: string | undefined);
        /**
         * @stability stable
         */
        resetMeshOwner(): void;
        /**
         * @stability stable
         */
        get meshOwnerInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get resourceOwner(): string;
        /**
         * @stability stable
         */
        spec(index: string): DataAwsAppmeshMeshSpec;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsAppmeshVirtualServiceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/appmesh_virtual_service.html#mesh_name DataAwsAppmeshVirtualService#mesh_name}.
         *
         * @stability stable
         */
        readonly meshName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/appmesh_virtual_service.html#mesh_owner DataAwsAppmeshVirtualService#mesh_owner}.
         *
         * @stability stable
         */
        readonly meshOwner?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/appmesh_virtual_service.html#name DataAwsAppmeshVirtualService#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/appmesh_virtual_service.html#tags DataAwsAppmeshVirtualService#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class DataAwsAppmeshVirtualServiceSpecProviderVirtualNode extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get virtualNodeName(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsAppmeshVirtualServiceSpecProviderVirtualRouter extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get virtualRouterName(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsAppmeshVirtualServiceSpecProvider extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get virtualNode(): any;
        /**
         * @stability stable
         */
        get virtualRouter(): any;
    }
    /**
     * @stability stable
     */
    class DataAwsAppmeshVirtualServiceSpec extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get provider(): any;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/appmesh_virtual_service.html aws_appmesh_virtual_service}.
     *
     * @stability stable
     */
    class DataAwsAppmeshVirtualService extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/appmesh_virtual_service.html aws_appmesh_virtual_service} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsAppmeshVirtualServiceConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createdDate(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdatedDate(): string;
        private _meshName?;
        /**
         * @stability stable
         */
        get meshName(): string;
        /**
         * @stability stable
         */
        set meshName(value: string);
        /**
         * @stability stable
         */
        get meshNameInput(): string | undefined;
        private _meshOwner?;
        /**
         * @stability stable
         */
        get meshOwner(): string | undefined;
        /**
         * @stability stable
         */
        set meshOwner(value: string | undefined);
        /**
         * @stability stable
         */
        resetMeshOwner(): void;
        /**
         * @stability stable
         */
        get meshOwnerInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get resourceOwner(): string;
        /**
         * @stability stable
         */
        spec(index: string): DataAwsAppmeshVirtualServiceSpec;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
