import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS EC2
*/
export declare namespace EC2 {
    /**
     * @stability stable
     */
    interface AmiConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#architecture Ami#architecture}.
         *
         * @stability stable
         */
        readonly architecture?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#description Ami#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#ena_support Ami#ena_support}.
         *
         * @stability stable
         */
        readonly enaSupport?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#image_location Ami#image_location}.
         *
         * @stability stable
         */
        readonly imageLocation?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#kernel_id Ami#kernel_id}.
         *
         * @stability stable
         */
        readonly kernelId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#name Ami#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#ramdisk_id Ami#ramdisk_id}.
         *
         * @stability stable
         */
        readonly ramdiskId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#root_device_name Ami#root_device_name}.
         *
         * @stability stable
         */
        readonly rootDeviceName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#sriov_net_support Ami#sriov_net_support}.
         *
         * @stability stable
         */
        readonly sriovNetSupport?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#tags Ami#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#tags_all Ami#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#virtualization_type Ami#virtualization_type}.
         *
         * @stability stable
         */
        readonly virtualizationType?: string;
        /**
         * ebs_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#ebs_block_device Ami#ebs_block_device}
         *
         * @stability stable
         */
        readonly ebsBlockDevice?: AmiEbsBlockDevice[];
        /**
         * ephemeral_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#ephemeral_block_device Ami#ephemeral_block_device}
         *
         * @stability stable
         */
        readonly ephemeralBlockDevice?: AmiEphemeralBlockDevice[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#timeouts Ami#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: AmiTimeouts;
    }
    /**
     * @stability stable
     */
    interface AmiEbsBlockDevice {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#delete_on_termination Ami#delete_on_termination}.
         *
         * @stability stable
         */
        readonly deleteOnTermination?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#device_name Ami#device_name}.
         *
         * @stability stable
         */
        readonly deviceName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#encrypted Ami#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#iops Ami#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#snapshot_id Ami#snapshot_id}.
         *
         * @stability stable
         */
        readonly snapshotId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#throughput Ami#throughput}.
         *
         * @stability stable
         */
        readonly throughput?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#volume_size Ami#volume_size}.
         *
         * @stability stable
         */
        readonly volumeSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#volume_type Ami#volume_type}.
         *
         * @stability stable
         */
        readonly volumeType?: string;
    }
    /**
     * @stability stable
     */
    interface AmiEphemeralBlockDevice {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#device_name Ami#device_name}.
         *
         * @stability stable
         */
        readonly deviceName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#virtual_name Ami#virtual_name}.
         *
         * @stability stable
         */
        readonly virtualName: string;
    }
    /**
     * @stability stable
     */
    interface AmiTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#create Ami#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#delete Ami#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami.html#update Ami#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class AmiTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ami.html aws_ami}.
     *
     * @stability stable
     */
    class Ami extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ami.html aws_ami} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AmiConfig);
        private _architecture?;
        /**
         * @stability stable
         */
        get architecture(): string | undefined;
        /**
         * @stability stable
         */
        set architecture(value: string | undefined);
        /**
         * @stability stable
         */
        resetArchitecture(): void;
        /**
         * @stability stable
         */
        get architectureInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _enaSupport?;
        /**
         * @stability stable
         */
        get enaSupport(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enaSupport(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnaSupport(): void;
        /**
         * @stability stable
         */
        get enaSupportInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get hypervisor(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _imageLocation?;
        /**
         * @stability stable
         */
        get imageLocation(): string | undefined;
        /**
         * @stability stable
         */
        set imageLocation(value: string | undefined);
        /**
         * @stability stable
         */
        resetImageLocation(): void;
        /**
         * @stability stable
         */
        get imageLocationInput(): string | undefined;
        /**
         * @stability stable
         */
        get imageOwnerAlias(): string;
        /**
         * @stability stable
         */
        get imageType(): string;
        private _kernelId?;
        /**
         * @stability stable
         */
        get kernelId(): string | undefined;
        /**
         * @stability stable
         */
        set kernelId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKernelId(): void;
        /**
         * @stability stable
         */
        get kernelIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get manageEbsSnapshots(): any;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get ownerId(): string;
        /**
         * @stability stable
         */
        get platform(): string;
        /**
         * @stability stable
         */
        get platformDetails(): string;
        /**
         * @stability stable
         */
        get public(): any;
        private _ramdiskId?;
        /**
         * @stability stable
         */
        get ramdiskId(): string | undefined;
        /**
         * @stability stable
         */
        set ramdiskId(value: string | undefined);
        /**
         * @stability stable
         */
        resetRamdiskId(): void;
        /**
         * @stability stable
         */
        get ramdiskIdInput(): string | undefined;
        private _rootDeviceName?;
        /**
         * @stability stable
         */
        get rootDeviceName(): string | undefined;
        /**
         * @stability stable
         */
        set rootDeviceName(value: string | undefined);
        /**
         * @stability stable
         */
        resetRootDeviceName(): void;
        /**
         * @stability stable
         */
        get rootDeviceNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get rootSnapshotId(): string;
        private _sriovNetSupport?;
        /**
         * @stability stable
         */
        get sriovNetSupport(): string | undefined;
        /**
         * @stability stable
         */
        set sriovNetSupport(value: string | undefined);
        /**
         * @stability stable
         */
        resetSriovNetSupport(): void;
        /**
         * @stability stable
         */
        get sriovNetSupportInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get usageOperation(): string;
        private _virtualizationType?;
        /**
         * @stability stable
         */
        get virtualizationType(): string | undefined;
        /**
         * @stability stable
         */
        set virtualizationType(value: string | undefined);
        /**
         * @stability stable
         */
        resetVirtualizationType(): void;
        /**
         * @stability stable
         */
        get virtualizationTypeInput(): string | undefined;
        private _ebsBlockDevice?;
        /**
         * @stability stable
         */
        get ebsBlockDevice(): AmiEbsBlockDevice[] | undefined;
        /**
         * @stability stable
         */
        set ebsBlockDevice(value: AmiEbsBlockDevice[] | undefined);
        /**
         * @stability stable
         */
        resetEbsBlockDevice(): void;
        /**
         * @stability stable
         */
        get ebsBlockDeviceInput(): AmiEbsBlockDevice[] | undefined;
        private _ephemeralBlockDevice?;
        /**
         * @stability stable
         */
        get ephemeralBlockDevice(): AmiEphemeralBlockDevice[] | undefined;
        /**
         * @stability stable
         */
        set ephemeralBlockDevice(value: AmiEphemeralBlockDevice[] | undefined);
        /**
         * @stability stable
         */
        resetEphemeralBlockDevice(): void;
        /**
         * @stability stable
         */
        get ephemeralBlockDeviceInput(): AmiEphemeralBlockDevice[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): AmiTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: AmiTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): AmiTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AmiCopyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#description AmiCopy#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#destination_outpost_arn AmiCopy#destination_outpost_arn}.
         *
         * @stability stable
         */
        readonly destinationOutpostArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#encrypted AmiCopy#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#kms_key_id AmiCopy#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#name AmiCopy#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#source_ami_id AmiCopy#source_ami_id}.
         *
         * @stability stable
         */
        readonly sourceAmiId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#source_ami_region AmiCopy#source_ami_region}.
         *
         * @stability stable
         */
        readonly sourceAmiRegion: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#tags AmiCopy#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#tags_all AmiCopy#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * ebs_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#ebs_block_device AmiCopy#ebs_block_device}
         *
         * @stability stable
         */
        readonly ebsBlockDevice?: AmiCopyEbsBlockDevice[];
        /**
         * ephemeral_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#ephemeral_block_device AmiCopy#ephemeral_block_device}
         *
         * @stability stable
         */
        readonly ephemeralBlockDevice?: AmiCopyEphemeralBlockDevice[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#timeouts AmiCopy#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: AmiCopyTimeouts;
    }
    /**
     * @stability stable
     */
    interface AmiCopyEbsBlockDevice {
    }
    /**
     * @stability stable
     */
    interface AmiCopyEphemeralBlockDevice {
    }
    /**
     * @stability stable
     */
    interface AmiCopyTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#create AmiCopy#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#delete AmiCopy#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html#update AmiCopy#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class AmiCopyTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html aws_ami_copy}.
     *
     * @stability stable
     */
    class AmiCopy extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ami_copy.html aws_ami_copy} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AmiCopyConfig);
        /**
         * @stability stable
         */
        get architecture(): string;
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _destinationOutpostArn?;
        /**
         * @stability stable
         */
        get destinationOutpostArn(): string | undefined;
        /**
         * @stability stable
         */
        set destinationOutpostArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetDestinationOutpostArn(): void;
        /**
         * @stability stable
         */
        get destinationOutpostArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get enaSupport(): any;
        private _encrypted?;
        /**
         * @stability stable
         */
        get encrypted(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set encrypted(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEncrypted(): void;
        /**
         * @stability stable
         */
        get encryptedInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get hypervisor(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get imageLocation(): string;
        /**
         * @stability stable
         */
        get imageOwnerAlias(): string;
        /**
         * @stability stable
         */
        get imageType(): string;
        /**
         * @stability stable
         */
        get kernelId(): string;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get manageEbsSnapshots(): any;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get ownerId(): string;
        /**
         * @stability stable
         */
        get platform(): string;
        /**
         * @stability stable
         */
        get platformDetails(): string;
        /**
         * @stability stable
         */
        get public(): any;
        /**
         * @stability stable
         */
        get ramdiskId(): string;
        /**
         * @stability stable
         */
        get rootDeviceName(): string;
        /**
         * @stability stable
         */
        get rootSnapshotId(): string;
        private _sourceAmiId?;
        /**
         * @stability stable
         */
        get sourceAmiId(): string;
        /**
         * @stability stable
         */
        set sourceAmiId(value: string);
        /**
         * @stability stable
         */
        get sourceAmiIdInput(): string | undefined;
        private _sourceAmiRegion?;
        /**
         * @stability stable
         */
        get sourceAmiRegion(): string;
        /**
         * @stability stable
         */
        set sourceAmiRegion(value: string);
        /**
         * @stability stable
         */
        get sourceAmiRegionInput(): string | undefined;
        /**
         * @stability stable
         */
        get sriovNetSupport(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get usageOperation(): string;
        /**
         * @stability stable
         */
        get virtualizationType(): string;
        private _ebsBlockDevice?;
        /**
         * @stability stable
         */
        get ebsBlockDevice(): AmiCopyEbsBlockDevice[] | undefined;
        /**
         * @stability stable
         */
        set ebsBlockDevice(value: AmiCopyEbsBlockDevice[] | undefined);
        /**
         * @stability stable
         */
        resetEbsBlockDevice(): void;
        /**
         * @stability stable
         */
        get ebsBlockDeviceInput(): AmiCopyEbsBlockDevice[] | undefined;
        private _ephemeralBlockDevice?;
        /**
         * @stability stable
         */
        get ephemeralBlockDevice(): AmiCopyEphemeralBlockDevice[] | undefined;
        /**
         * @stability stable
         */
        set ephemeralBlockDevice(value: AmiCopyEphemeralBlockDevice[] | undefined);
        /**
         * @stability stable
         */
        resetEphemeralBlockDevice(): void;
        /**
         * @stability stable
         */
        get ephemeralBlockDeviceInput(): AmiCopyEphemeralBlockDevice[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): AmiCopyTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: AmiCopyTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): AmiCopyTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AmiFromInstanceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_from_instance.html#description AmiFromInstance#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_from_instance.html#name AmiFromInstance#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_from_instance.html#snapshot_without_reboot AmiFromInstance#snapshot_without_reboot}.
         *
         * @stability stable
         */
        readonly snapshotWithoutReboot?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_from_instance.html#source_instance_id AmiFromInstance#source_instance_id}.
         *
         * @stability stable
         */
        readonly sourceInstanceId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_from_instance.html#tags AmiFromInstance#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_from_instance.html#tags_all AmiFromInstance#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * ebs_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_from_instance.html#ebs_block_device AmiFromInstance#ebs_block_device}
         *
         * @stability stable
         */
        readonly ebsBlockDevice?: AmiFromInstanceEbsBlockDevice[];
        /**
         * ephemeral_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_from_instance.html#ephemeral_block_device AmiFromInstance#ephemeral_block_device}
         *
         * @stability stable
         */
        readonly ephemeralBlockDevice?: AmiFromInstanceEphemeralBlockDevice[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_from_instance.html#timeouts AmiFromInstance#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: AmiFromInstanceTimeouts;
    }
    /**
     * @stability stable
     */
    interface AmiFromInstanceEbsBlockDevice {
    }
    /**
     * @stability stable
     */
    interface AmiFromInstanceEphemeralBlockDevice {
    }
    /**
     * @stability stable
     */
    interface AmiFromInstanceTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_from_instance.html#create AmiFromInstance#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_from_instance.html#delete AmiFromInstance#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_from_instance.html#update AmiFromInstance#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class AmiFromInstanceTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ami_from_instance.html aws_ami_from_instance}.
     *
     * @stability stable
     */
    class AmiFromInstance extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ami_from_instance.html aws_ami_from_instance} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AmiFromInstanceConfig);
        /**
         * @stability stable
         */
        get architecture(): string;
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get enaSupport(): any;
        /**
         * @stability stable
         */
        get hypervisor(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get imageLocation(): string;
        /**
         * @stability stable
         */
        get imageOwnerAlias(): string;
        /**
         * @stability stable
         */
        get imageType(): string;
        /**
         * @stability stable
         */
        get kernelId(): string;
        /**
         * @stability stable
         */
        get manageEbsSnapshots(): any;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get ownerId(): string;
        /**
         * @stability stable
         */
        get platform(): string;
        /**
         * @stability stable
         */
        get platformDetails(): string;
        /**
         * @stability stable
         */
        get public(): any;
        /**
         * @stability stable
         */
        get ramdiskId(): string;
        /**
         * @stability stable
         */
        get rootDeviceName(): string;
        /**
         * @stability stable
         */
        get rootSnapshotId(): string;
        private _snapshotWithoutReboot?;
        /**
         * @stability stable
         */
        get snapshotWithoutReboot(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set snapshotWithoutReboot(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetSnapshotWithoutReboot(): void;
        /**
         * @stability stable
         */
        get snapshotWithoutRebootInput(): boolean | cdktf.IResolvable | undefined;
        private _sourceInstanceId?;
        /**
         * @stability stable
         */
        get sourceInstanceId(): string;
        /**
         * @stability stable
         */
        set sourceInstanceId(value: string);
        /**
         * @stability stable
         */
        get sourceInstanceIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get sriovNetSupport(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get usageOperation(): string;
        /**
         * @stability stable
         */
        get virtualizationType(): string;
        private _ebsBlockDevice?;
        /**
         * @stability stable
         */
        get ebsBlockDevice(): AmiFromInstanceEbsBlockDevice[] | undefined;
        /**
         * @stability stable
         */
        set ebsBlockDevice(value: AmiFromInstanceEbsBlockDevice[] | undefined);
        /**
         * @stability stable
         */
        resetEbsBlockDevice(): void;
        /**
         * @stability stable
         */
        get ebsBlockDeviceInput(): AmiFromInstanceEbsBlockDevice[] | undefined;
        private _ephemeralBlockDevice?;
        /**
         * @stability stable
         */
        get ephemeralBlockDevice(): AmiFromInstanceEphemeralBlockDevice[] | undefined;
        /**
         * @stability stable
         */
        set ephemeralBlockDevice(value: AmiFromInstanceEphemeralBlockDevice[] | undefined);
        /**
         * @stability stable
         */
        resetEphemeralBlockDevice(): void;
        /**
         * @stability stable
         */
        get ephemeralBlockDeviceInput(): AmiFromInstanceEphemeralBlockDevice[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): AmiFromInstanceTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: AmiFromInstanceTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): AmiFromInstanceTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface AmiLaunchPermissionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_launch_permission.html#account_id AmiLaunchPermission#account_id}.
         *
         * @stability stable
         */
        readonly accountId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ami_launch_permission.html#image_id AmiLaunchPermission#image_id}.
         *
         * @stability stable
         */
        readonly imageId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ami_launch_permission.html aws_ami_launch_permission}.
     *
     * @stability stable
     */
    class AmiLaunchPermission extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ami_launch_permission.html aws_ami_launch_permission} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: AmiLaunchPermissionConfig);
        private _accountId?;
        /**
         * @stability stable
         */
        get accountId(): string;
        /**
         * @stability stable
         */
        set accountId(value: string);
        /**
         * @stability stable
         */
        get accountIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _imageId?;
        /**
         * @stability stable
         */
        get imageId(): string;
        /**
         * @stability stable
         */
        set imageId(value: string);
        /**
         * @stability stable
         */
        get imageIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface EbsDefaultKmsKeyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_default_kms_key.html#key_arn EbsDefaultKmsKey#key_arn}.
         *
         * @stability stable
         */
        readonly keyArn: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ebs_default_kms_key.html aws_ebs_default_kms_key}.
     *
     * @stability stable
     */
    class EbsDefaultKmsKey extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ebs_default_kms_key.html aws_ebs_default_kms_key} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: EbsDefaultKmsKeyConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _keyArn?;
        /**
         * @stability stable
         */
        get keyArn(): string;
        /**
         * @stability stable
         */
        set keyArn(value: string);
        /**
         * @stability stable
         */
        get keyArnInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface EbsEncryptionByDefaultConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_encryption_by_default.html#enabled EbsEncryptionByDefault#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ebs_encryption_by_default.html aws_ebs_encryption_by_default}.
     *
     * @stability stable
     */
    class EbsEncryptionByDefault extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ebs_encryption_by_default.html aws_ebs_encryption_by_default} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: EbsEncryptionByDefaultConfig);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface EbsSnapshotConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot.html#description EbsSnapshot#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot.html#tags EbsSnapshot#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot.html#tags_all EbsSnapshot#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot.html#volume_id EbsSnapshot#volume_id}.
         *
         * @stability stable
         */
        readonly volumeId: string;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot.html#timeouts EbsSnapshot#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: EbsSnapshotTimeouts;
    }
    /**
     * @stability stable
     */
    interface EbsSnapshotTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot.html#create EbsSnapshot#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot.html#delete EbsSnapshot#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
    }
    /**
     * @stability stable
     */
    class EbsSnapshotTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot.html aws_ebs_snapshot}.
     *
     * @stability stable
     */
    class EbsSnapshot extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot.html aws_ebs_snapshot} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: EbsSnapshotConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get dataEncryptionKeyId(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get encrypted(): any;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get kmsKeyId(): string;
        /**
         * @stability stable
         */
        get ownerAlias(): string;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _volumeId?;
        /**
         * @stability stable
         */
        get volumeId(): string;
        /**
         * @stability stable
         */
        set volumeId(value: string);
        /**
         * @stability stable
         */
        get volumeIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get volumeSize(): number;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): EbsSnapshotTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: EbsSnapshotTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): EbsSnapshotTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface EbsSnapshotCopyConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_copy.html#description EbsSnapshotCopy#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_copy.html#encrypted EbsSnapshotCopy#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_copy.html#kms_key_id EbsSnapshotCopy#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_copy.html#source_region EbsSnapshotCopy#source_region}.
         *
         * @stability stable
         */
        readonly sourceRegion: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_copy.html#source_snapshot_id EbsSnapshotCopy#source_snapshot_id}.
         *
         * @stability stable
         */
        readonly sourceSnapshotId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_copy.html#tags EbsSnapshotCopy#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_copy.html#tags_all EbsSnapshotCopy#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_copy.html aws_ebs_snapshot_copy}.
     *
     * @stability stable
     */
    class EbsSnapshotCopy extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_copy.html aws_ebs_snapshot_copy} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: EbsSnapshotCopyConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get dataEncryptionKeyId(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _encrypted?;
        /**
         * @stability stable
         */
        get encrypted(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set encrypted(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEncrypted(): void;
        /**
         * @stability stable
         */
        get encryptedInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get ownerAlias(): string;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _sourceRegion?;
        /**
         * @stability stable
         */
        get sourceRegion(): string;
        /**
         * @stability stable
         */
        set sourceRegion(value: string);
        /**
         * @stability stable
         */
        get sourceRegionInput(): string | undefined;
        private _sourceSnapshotId?;
        /**
         * @stability stable
         */
        get sourceSnapshotId(): string;
        /**
         * @stability stable
         */
        set sourceSnapshotId(value: string);
        /**
         * @stability stable
         */
        get sourceSnapshotIdInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get volumeId(): string;
        /**
         * @stability stable
         */
        get volumeSize(): number;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface EbsSnapshotImportConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#description EbsSnapshotImport#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#encrypted EbsSnapshotImport#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#kms_key_id EbsSnapshotImport#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#role_name EbsSnapshotImport#role_name}.
         *
         * @stability stable
         */
        readonly roleName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#tags EbsSnapshotImport#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#tags_all EbsSnapshotImport#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * client_data block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#client_data EbsSnapshotImport#client_data}
         *
         * @stability stable
         */
        readonly clientData?: EbsSnapshotImportClientData;
        /**
         * disk_container block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#disk_container EbsSnapshotImport#disk_container}
         *
         * @stability stable
         */
        readonly diskContainer: EbsSnapshotImportDiskContainer;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#timeouts EbsSnapshotImport#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: EbsSnapshotImportTimeouts;
    }
    /**
     * @stability stable
     */
    interface EbsSnapshotImportClientData {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#comment EbsSnapshotImport#comment}.
         *
         * @stability stable
         */
        readonly comment?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#upload_end EbsSnapshotImport#upload_end}.
         *
         * @stability stable
         */
        readonly uploadEnd?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#upload_size EbsSnapshotImport#upload_size}.
         *
         * @stability stable
         */
        readonly uploadSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#upload_start EbsSnapshotImport#upload_start}.
         *
         * @stability stable
         */
        readonly uploadStart?: string;
    }
    /**
     * @stability stable
     */
    class EbsSnapshotImportClientDataOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _comment?;
        /**
         * @stability stable
         */
        get comment(): string | undefined;
        /**
         * @stability stable
         */
        set comment(value: string | undefined);
        /**
         * @stability stable
         */
        resetComment(): void;
        /**
         * @stability stable
         */
        get commentInput(): string | undefined;
        private _uploadEnd?;
        /**
         * @stability stable
         */
        get uploadEnd(): string | undefined;
        /**
         * @stability stable
         */
        set uploadEnd(value: string | undefined);
        /**
         * @stability stable
         */
        resetUploadEnd(): void;
        /**
         * @stability stable
         */
        get uploadEndInput(): string | undefined;
        private _uploadSize?;
        /**
         * @stability stable
         */
        get uploadSize(): number | undefined;
        /**
         * @stability stable
         */
        set uploadSize(value: number | undefined);
        /**
         * @stability stable
         */
        resetUploadSize(): void;
        /**
         * @stability stable
         */
        get uploadSizeInput(): number | undefined;
        private _uploadStart?;
        /**
         * @stability stable
         */
        get uploadStart(): string | undefined;
        /**
         * @stability stable
         */
        set uploadStart(value: string | undefined);
        /**
         * @stability stable
         */
        resetUploadStart(): void;
        /**
         * @stability stable
         */
        get uploadStartInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface EbsSnapshotImportDiskContainerUserBucket {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#s3_bucket EbsSnapshotImport#s3_bucket}.
         *
         * @stability stable
         */
        readonly s3Bucket: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#s3_key EbsSnapshotImport#s3_key}.
         *
         * @stability stable
         */
        readonly s3Key: string;
    }
    /**
     * @stability stable
     */
    class EbsSnapshotImportDiskContainerUserBucketOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _s3Bucket?;
        /**
         * @stability stable
         */
        get s3Bucket(): string;
        /**
         * @stability stable
         */
        set s3Bucket(value: string);
        /**
         * @stability stable
         */
        get s3BucketInput(): string | undefined;
        private _s3Key?;
        /**
         * @stability stable
         */
        get s3Key(): string;
        /**
         * @stability stable
         */
        set s3Key(value: string);
        /**
         * @stability stable
         */
        get s3KeyInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface EbsSnapshotImportDiskContainer {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#description EbsSnapshotImport#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#format EbsSnapshotImport#format}.
         *
         * @stability stable
         */
        readonly format: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#url EbsSnapshotImport#url}.
         *
         * @stability stable
         */
        readonly url?: string;
        /**
         * user_bucket block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#user_bucket EbsSnapshotImport#user_bucket}
         *
         * @stability stable
         */
        readonly userBucket?: EbsSnapshotImportDiskContainerUserBucket;
    }
    /**
     * @stability stable
     */
    class EbsSnapshotImportDiskContainerOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _format?;
        /**
         * @stability stable
         */
        get format(): string;
        /**
         * @stability stable
         */
        set format(value: string);
        /**
         * @stability stable
         */
        get formatInput(): string | undefined;
        private _url?;
        /**
         * @stability stable
         */
        get url(): string | undefined;
        /**
         * @stability stable
         */
        set url(value: string | undefined);
        /**
         * @stability stable
         */
        resetUrl(): void;
        /**
         * @stability stable
         */
        get urlInput(): string | undefined;
        private _userBucket?;
        private __userBucketOutput;
        /**
         * @stability stable
         */
        get userBucket(): EbsSnapshotImportDiskContainerUserBucketOutputReference;
        /**
         * @stability stable
         */
        putUserBucket(value: EbsSnapshotImportDiskContainerUserBucket | undefined): void;
        /**
         * @stability stable
         */
        resetUserBucket(): void;
        /**
         * @stability stable
         */
        get userBucketInput(): EbsSnapshotImportDiskContainerUserBucket | undefined;
    }
    /**
     * @stability stable
     */
    interface EbsSnapshotImportTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#create EbsSnapshotImport#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html#delete EbsSnapshotImport#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
    }
    /**
     * @stability stable
     */
    class EbsSnapshotImportTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html aws_ebs_snapshot_import}.
     *
     * @stability stable
     */
    class EbsSnapshotImport extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import.html aws_ebs_snapshot_import} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: EbsSnapshotImportConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get dataEncryptionKeyId(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _encrypted?;
        /**
         * @stability stable
         */
        get encrypted(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set encrypted(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEncrypted(): void;
        /**
         * @stability stable
         */
        get encryptedInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get ownerAlias(): string;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _roleName?;
        /**
         * @stability stable
         */
        get roleName(): string | undefined;
        /**
         * @stability stable
         */
        set roleName(value: string | undefined);
        /**
         * @stability stable
         */
        resetRoleName(): void;
        /**
         * @stability stable
         */
        get roleNameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get volumeSize(): number;
        private _clientData?;
        private __clientDataOutput;
        /**
         * @stability stable
         */
        get clientData(): EbsSnapshotImportClientDataOutputReference;
        /**
         * @stability stable
         */
        putClientData(value: EbsSnapshotImportClientData | undefined): void;
        /**
         * @stability stable
         */
        resetClientData(): void;
        /**
         * @stability stable
         */
        get clientDataInput(): EbsSnapshotImportClientData | undefined;
        private _diskContainer?;
        private __diskContainerOutput;
        /**
         * @stability stable
         */
        get diskContainer(): EbsSnapshotImportDiskContainerOutputReference;
        /**
         * @stability stable
         */
        putDiskContainer(value: EbsSnapshotImportDiskContainer): void;
        /**
         * @stability stable
         */
        get diskContainerInput(): EbsSnapshotImportDiskContainer | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): EbsSnapshotImportTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: EbsSnapshotImportTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): EbsSnapshotImportTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface EbsVolumeConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_volume.html#availability_zone EbsVolume#availability_zone}.
         *
         * @stability stable
         */
        readonly availabilityZone: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_volume.html#encrypted EbsVolume#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_volume.html#iops EbsVolume#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_volume.html#kms_key_id EbsVolume#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_volume.html#multi_attach_enabled EbsVolume#multi_attach_enabled}.
         *
         * @stability stable
         */
        readonly multiAttachEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_volume.html#outpost_arn EbsVolume#outpost_arn}.
         *
         * @stability stable
         */
        readonly outpostArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_volume.html#size EbsVolume#size}.
         *
         * @stability stable
         */
        readonly size?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_volume.html#snapshot_id EbsVolume#snapshot_id}.
         *
         * @stability stable
         */
        readonly snapshotId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_volume.html#tags EbsVolume#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_volume.html#tags_all EbsVolume#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_volume.html#throughput EbsVolume#throughput}.
         *
         * @stability stable
         */
        readonly throughput?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_volume.html#type EbsVolume#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ebs_volume.html aws_ebs_volume}.
     *
     * @stability stable
     */
    class EbsVolume extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ebs_volume.html aws_ebs_volume} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: EbsVolumeConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _availabilityZone?;
        /**
         * @stability stable
         */
        get availabilityZone(): string;
        /**
         * @stability stable
         */
        set availabilityZone(value: string);
        /**
         * @stability stable
         */
        get availabilityZoneInput(): string | undefined;
        private _encrypted?;
        /**
         * @stability stable
         */
        get encrypted(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set encrypted(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEncrypted(): void;
        /**
         * @stability stable
         */
        get encryptedInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _iops?;
        /**
         * @stability stable
         */
        get iops(): number | undefined;
        /**
         * @stability stable
         */
        set iops(value: number | undefined);
        /**
         * @stability stable
         */
        resetIops(): void;
        /**
         * @stability stable
         */
        get iopsInput(): number | undefined;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        private _multiAttachEnabled?;
        /**
         * @stability stable
         */
        get multiAttachEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set multiAttachEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetMultiAttachEnabled(): void;
        /**
         * @stability stable
         */
        get multiAttachEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _outpostArn?;
        /**
         * @stability stable
         */
        get outpostArn(): string | undefined;
        /**
         * @stability stable
         */
        set outpostArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetOutpostArn(): void;
        /**
         * @stability stable
         */
        get outpostArnInput(): string | undefined;
        private _size?;
        /**
         * @stability stable
         */
        get size(): number | undefined;
        /**
         * @stability stable
         */
        set size(value: number | undefined);
        /**
         * @stability stable
         */
        resetSize(): void;
        /**
         * @stability stable
         */
        get sizeInput(): number | undefined;
        private _snapshotId?;
        /**
         * @stability stable
         */
        get snapshotId(): string | undefined;
        /**
         * @stability stable
         */
        set snapshotId(value: string | undefined);
        /**
         * @stability stable
         */
        resetSnapshotId(): void;
        /**
         * @stability stable
         */
        get snapshotIdInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _throughput?;
        /**
         * @stability stable
         */
        get throughput(): number | undefined;
        /**
         * @stability stable
         */
        set throughput(value: number | undefined);
        /**
         * @stability stable
         */
        resetThroughput(): void;
        /**
         * @stability stable
         */
        get throughputInput(): number | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string | undefined;
        /**
         * @stability stable
         */
        set type(value: string | undefined);
        /**
         * @stability stable
         */
        resetType(): void;
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2AvailabilityZoneGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_availability_zone_group.html#group_name Ec2AvailabilityZoneGroup#group_name}.
         *
         * @stability stable
         */
        readonly groupName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_availability_zone_group.html#opt_in_status Ec2AvailabilityZoneGroup#opt_in_status}.
         *
         * @stability stable
         */
        readonly optInStatus: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_availability_zone_group.html aws_ec2_availability_zone_group}.
     *
     * @stability stable
     */
    class Ec2AvailabilityZoneGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_availability_zone_group.html aws_ec2_availability_zone_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2AvailabilityZoneGroupConfig);
        private _groupName?;
        /**
         * @stability stable
         */
        get groupName(): string;
        /**
         * @stability stable
         */
        set groupName(value: string);
        /**
         * @stability stable
         */
        get groupNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _optInStatus?;
        /**
         * @stability stable
         */
        get optInStatus(): string;
        /**
         * @stability stable
         */
        set optInStatus(value: string);
        /**
         * @stability stable
         */
        get optInStatusInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2CapacityReservationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_capacity_reservation.html#availability_zone Ec2CapacityReservation#availability_zone}.
         *
         * @stability stable
         */
        readonly availabilityZone: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_capacity_reservation.html#ebs_optimized Ec2CapacityReservation#ebs_optimized}.
         *
         * @stability stable
         */
        readonly ebsOptimized?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_capacity_reservation.html#end_date Ec2CapacityReservation#end_date}.
         *
         * @stability stable
         */
        readonly endDate?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_capacity_reservation.html#end_date_type Ec2CapacityReservation#end_date_type}.
         *
         * @stability stable
         */
        readonly endDateType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_capacity_reservation.html#ephemeral_storage Ec2CapacityReservation#ephemeral_storage}.
         *
         * @stability stable
         */
        readonly ephemeralStorage?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_capacity_reservation.html#instance_count Ec2CapacityReservation#instance_count}.
         *
         * @stability stable
         */
        readonly instanceCount: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_capacity_reservation.html#instance_match_criteria Ec2CapacityReservation#instance_match_criteria}.
         *
         * @stability stable
         */
        readonly instanceMatchCriteria?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_capacity_reservation.html#instance_platform Ec2CapacityReservation#instance_platform}.
         *
         * @stability stable
         */
        readonly instancePlatform: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_capacity_reservation.html#instance_type Ec2CapacityReservation#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_capacity_reservation.html#outpost_arn Ec2CapacityReservation#outpost_arn}.
         *
         * @stability stable
         */
        readonly outpostArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_capacity_reservation.html#tags Ec2CapacityReservation#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_capacity_reservation.html#tags_all Ec2CapacityReservation#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_capacity_reservation.html#tenancy Ec2CapacityReservation#tenancy}.
         *
         * @stability stable
         */
        readonly tenancy?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_capacity_reservation.html aws_ec2_capacity_reservation}.
     *
     * @stability stable
     */
    class Ec2CapacityReservation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_capacity_reservation.html aws_ec2_capacity_reservation} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2CapacityReservationConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _availabilityZone?;
        /**
         * @stability stable
         */
        get availabilityZone(): string;
        /**
         * @stability stable
         */
        set availabilityZone(value: string);
        /**
         * @stability stable
         */
        get availabilityZoneInput(): string | undefined;
        private _ebsOptimized?;
        /**
         * @stability stable
         */
        get ebsOptimized(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set ebsOptimized(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEbsOptimized(): void;
        /**
         * @stability stable
         */
        get ebsOptimizedInput(): boolean | cdktf.IResolvable | undefined;
        private _endDate?;
        /**
         * @stability stable
         */
        get endDate(): string | undefined;
        /**
         * @stability stable
         */
        set endDate(value: string | undefined);
        /**
         * @stability stable
         */
        resetEndDate(): void;
        /**
         * @stability stable
         */
        get endDateInput(): string | undefined;
        private _endDateType?;
        /**
         * @stability stable
         */
        get endDateType(): string | undefined;
        /**
         * @stability stable
         */
        set endDateType(value: string | undefined);
        /**
         * @stability stable
         */
        resetEndDateType(): void;
        /**
         * @stability stable
         */
        get endDateTypeInput(): string | undefined;
        private _ephemeralStorage?;
        /**
         * @stability stable
         */
        get ephemeralStorage(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set ephemeralStorage(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEphemeralStorage(): void;
        /**
         * @stability stable
         */
        get ephemeralStorageInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceCount?;
        /**
         * @stability stable
         */
        get instanceCount(): number;
        /**
         * @stability stable
         */
        set instanceCount(value: number);
        /**
         * @stability stable
         */
        get instanceCountInput(): number | undefined;
        private _instanceMatchCriteria?;
        /**
         * @stability stable
         */
        get instanceMatchCriteria(): string | undefined;
        /**
         * @stability stable
         */
        set instanceMatchCriteria(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceMatchCriteria(): void;
        /**
         * @stability stable
         */
        get instanceMatchCriteriaInput(): string | undefined;
        private _instancePlatform?;
        /**
         * @stability stable
         */
        get instancePlatform(): string;
        /**
         * @stability stable
         */
        set instancePlatform(value: string);
        /**
         * @stability stable
         */
        get instancePlatformInput(): string | undefined;
        private _instanceType?;
        /**
         * @stability stable
         */
        get instanceType(): string;
        /**
         * @stability stable
         */
        set instanceType(value: string);
        /**
         * @stability stable
         */
        get instanceTypeInput(): string | undefined;
        private _outpostArn?;
        /**
         * @stability stable
         */
        get outpostArn(): string | undefined;
        /**
         * @stability stable
         */
        set outpostArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetOutpostArn(): void;
        /**
         * @stability stable
         */
        get outpostArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tenancy?;
        /**
         * @stability stable
         */
        get tenancy(): string | undefined;
        /**
         * @stability stable
         */
        set tenancy(value: string | undefined);
        /**
         * @stability stable
         */
        resetTenancy(): void;
        /**
         * @stability stable
         */
        get tenancyInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2CarrierGatewayConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_carrier_gateway.html#tags Ec2CarrierGateway#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_carrier_gateway.html#tags_all Ec2CarrierGateway#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_carrier_gateway.html#vpc_id Ec2CarrierGateway#vpc_id}.
         *
         * @stability stable
         */
        readonly vpcId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_carrier_gateway.html aws_ec2_carrier_gateway}.
     *
     * @stability stable
     */
    class Ec2CarrierGateway extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_carrier_gateway.html aws_ec2_carrier_gateway} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2CarrierGatewayConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _vpcId?;
        /**
         * @stability stable
         */
        get vpcId(): string;
        /**
         * @stability stable
         */
        set vpcId(value: string);
        /**
         * @stability stable
         */
        get vpcIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2ClientVpnAuthorizationRuleConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_authorization_rule.html#access_group_id Ec2ClientVpnAuthorizationRule#access_group_id}.
         *
         * @stability stable
         */
        readonly accessGroupId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_authorization_rule.html#authorize_all_groups Ec2ClientVpnAuthorizationRule#authorize_all_groups}.
         *
         * @stability stable
         */
        readonly authorizeAllGroups?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_authorization_rule.html#client_vpn_endpoint_id Ec2ClientVpnAuthorizationRule#client_vpn_endpoint_id}.
         *
         * @stability stable
         */
        readonly clientVpnEndpointId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_authorization_rule.html#description Ec2ClientVpnAuthorizationRule#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_authorization_rule.html#target_network_cidr Ec2ClientVpnAuthorizationRule#target_network_cidr}.
         *
         * @stability stable
         */
        readonly targetNetworkCidr: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_authorization_rule.html aws_ec2_client_vpn_authorization_rule}.
     *
     * @stability stable
     */
    class Ec2ClientVpnAuthorizationRule extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_authorization_rule.html aws_ec2_client_vpn_authorization_rule} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2ClientVpnAuthorizationRuleConfig);
        private _accessGroupId?;
        /**
         * @stability stable
         */
        get accessGroupId(): string | undefined;
        /**
         * @stability stable
         */
        set accessGroupId(value: string | undefined);
        /**
         * @stability stable
         */
        resetAccessGroupId(): void;
        /**
         * @stability stable
         */
        get accessGroupIdInput(): string | undefined;
        private _authorizeAllGroups?;
        /**
         * @stability stable
         */
        get authorizeAllGroups(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set authorizeAllGroups(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAuthorizeAllGroups(): void;
        /**
         * @stability stable
         */
        get authorizeAllGroupsInput(): boolean | cdktf.IResolvable | undefined;
        private _clientVpnEndpointId?;
        /**
         * @stability stable
         */
        get clientVpnEndpointId(): string;
        /**
         * @stability stable
         */
        set clientVpnEndpointId(value: string);
        /**
         * @stability stable
         */
        get clientVpnEndpointIdInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _targetNetworkCidr?;
        /**
         * @stability stable
         */
        get targetNetworkCidr(): string;
        /**
         * @stability stable
         */
        set targetNetworkCidr(value: string);
        /**
         * @stability stable
         */
        get targetNetworkCidrInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2ClientVpnEndpointConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#client_cidr_block Ec2ClientVpnEndpoint#client_cidr_block}.
         *
         * @stability stable
         */
        readonly clientCidrBlock: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#description Ec2ClientVpnEndpoint#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#dns_servers Ec2ClientVpnEndpoint#dns_servers}.
         *
         * @stability stable
         */
        readonly dnsServers?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#self_service_portal Ec2ClientVpnEndpoint#self_service_portal}.
         *
         * @stability stable
         */
        readonly selfServicePortal?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#server_certificate_arn Ec2ClientVpnEndpoint#server_certificate_arn}.
         *
         * @stability stable
         */
        readonly serverCertificateArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#split_tunnel Ec2ClientVpnEndpoint#split_tunnel}.
         *
         * @stability stable
         */
        readonly splitTunnel?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#tags Ec2ClientVpnEndpoint#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#tags_all Ec2ClientVpnEndpoint#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#transport_protocol Ec2ClientVpnEndpoint#transport_protocol}.
         *
         * @stability stable
         */
        readonly transportProtocol?: string;
        /**
         * authentication_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#authentication_options Ec2ClientVpnEndpoint#authentication_options}
         *
         * @stability stable
         */
        readonly authenticationOptions: Ec2ClientVpnEndpointAuthenticationOptions[];
        /**
         * connection_log_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#connection_log_options Ec2ClientVpnEndpoint#connection_log_options}
         *
         * @stability stable
         */
        readonly connectionLogOptions: Ec2ClientVpnEndpointConnectionLogOptions;
    }
    /**
     * @stability stable
     */
    interface Ec2ClientVpnEndpointAuthenticationOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#active_directory_id Ec2ClientVpnEndpoint#active_directory_id}.
         *
         * @stability stable
         */
        readonly activeDirectoryId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#root_certificate_chain_arn Ec2ClientVpnEndpoint#root_certificate_chain_arn}.
         *
         * @stability stable
         */
        readonly rootCertificateChainArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#saml_provider_arn Ec2ClientVpnEndpoint#saml_provider_arn}.
         *
         * @stability stable
         */
        readonly samlProviderArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#self_service_saml_provider_arn Ec2ClientVpnEndpoint#self_service_saml_provider_arn}.
         *
         * @stability stable
         */
        readonly selfServiceSamlProviderArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#type Ec2ClientVpnEndpoint#type}.
         *
         * @stability stable
         */
        readonly type: string;
    }
    /**
     * @stability stable
     */
    interface Ec2ClientVpnEndpointConnectionLogOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#cloudwatch_log_group Ec2ClientVpnEndpoint#cloudwatch_log_group}.
         *
         * @stability stable
         */
        readonly cloudwatchLogGroup?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#cloudwatch_log_stream Ec2ClientVpnEndpoint#cloudwatch_log_stream}.
         *
         * @stability stable
         */
        readonly cloudwatchLogStream?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html#enabled Ec2ClientVpnEndpoint#enabled}.
         *
         * @stability stable
         */
        readonly enabled: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class Ec2ClientVpnEndpointConnectionLogOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _cloudwatchLogGroup?;
        /**
         * @stability stable
         */
        get cloudwatchLogGroup(): string | undefined;
        /**
         * @stability stable
         */
        set cloudwatchLogGroup(value: string | undefined);
        /**
         * @stability stable
         */
        resetCloudwatchLogGroup(): void;
        /**
         * @stability stable
         */
        get cloudwatchLogGroupInput(): string | undefined;
        private _cloudwatchLogStream?;
        /**
         * @stability stable
         */
        get cloudwatchLogStream(): string | undefined;
        /**
         * @stability stable
         */
        set cloudwatchLogStream(value: string | undefined);
        /**
         * @stability stable
         */
        resetCloudwatchLogStream(): void;
        /**
         * @stability stable
         */
        get cloudwatchLogStreamInput(): string | undefined;
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html aws_ec2_client_vpn_endpoint}.
     *
     * @stability stable
     */
    class Ec2ClientVpnEndpoint extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_endpoint.html aws_ec2_client_vpn_endpoint} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2ClientVpnEndpointConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _clientCidrBlock?;
        /**
         * @stability stable
         */
        get clientCidrBlock(): string;
        /**
         * @stability stable
         */
        set clientCidrBlock(value: string);
        /**
         * @stability stable
         */
        get clientCidrBlockInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get dnsName(): string;
        private _dnsServers?;
        /**
         * @stability stable
         */
        get dnsServers(): string[] | undefined;
        /**
         * @stability stable
         */
        set dnsServers(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetDnsServers(): void;
        /**
         * @stability stable
         */
        get dnsServersInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _selfServicePortal?;
        /**
         * @stability stable
         */
        get selfServicePortal(): string | undefined;
        /**
         * @stability stable
         */
        set selfServicePortal(value: string | undefined);
        /**
         * @stability stable
         */
        resetSelfServicePortal(): void;
        /**
         * @stability stable
         */
        get selfServicePortalInput(): string | undefined;
        private _serverCertificateArn?;
        /**
         * @stability stable
         */
        get serverCertificateArn(): string;
        /**
         * @stability stable
         */
        set serverCertificateArn(value: string);
        /**
         * @stability stable
         */
        get serverCertificateArnInput(): string | undefined;
        private _splitTunnel?;
        /**
         * @stability stable
         */
        get splitTunnel(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set splitTunnel(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetSplitTunnel(): void;
        /**
         * @stability stable
         */
        get splitTunnelInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _transportProtocol?;
        /**
         * @stability stable
         */
        get transportProtocol(): string | undefined;
        /**
         * @stability stable
         */
        set transportProtocol(value: string | undefined);
        /**
         * @stability stable
         */
        resetTransportProtocol(): void;
        /**
         * @stability stable
         */
        get transportProtocolInput(): string | undefined;
        private _authenticationOptions?;
        /**
         * @stability stable
         */
        get authenticationOptions(): Ec2ClientVpnEndpointAuthenticationOptions[];
        /**
         * @stability stable
         */
        set authenticationOptions(value: Ec2ClientVpnEndpointAuthenticationOptions[]);
        /**
         * @stability stable
         */
        get authenticationOptionsInput(): Ec2ClientVpnEndpointAuthenticationOptions[] | undefined;
        private _connectionLogOptions?;
        private __connectionLogOptionsOutput;
        /**
         * @stability stable
         */
        get connectionLogOptions(): Ec2ClientVpnEndpointConnectionLogOptionsOutputReference;
        /**
         * @stability stable
         */
        putConnectionLogOptions(value: Ec2ClientVpnEndpointConnectionLogOptions): void;
        /**
         * @stability stable
         */
        get connectionLogOptionsInput(): Ec2ClientVpnEndpointConnectionLogOptions | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2ClientVpnNetworkAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_network_association.html#client_vpn_endpoint_id Ec2ClientVpnNetworkAssociation#client_vpn_endpoint_id}.
         *
         * @stability stable
         */
        readonly clientVpnEndpointId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_network_association.html#security_groups Ec2ClientVpnNetworkAssociation#security_groups}.
         *
         * @stability stable
         */
        readonly securityGroups?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_network_association.html#subnet_id Ec2ClientVpnNetworkAssociation#subnet_id}.
         *
         * @stability stable
         */
        readonly subnetId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_network_association.html aws_ec2_client_vpn_network_association}.
     *
     * @stability stable
     */
    class Ec2ClientVpnNetworkAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_network_association.html aws_ec2_client_vpn_network_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2ClientVpnNetworkAssociationConfig);
        /**
         * @stability stable
         */
        get associationId(): string;
        private _clientVpnEndpointId?;
        /**
         * @stability stable
         */
        get clientVpnEndpointId(): string;
        /**
         * @stability stable
         */
        set clientVpnEndpointId(value: string);
        /**
         * @stability stable
         */
        get clientVpnEndpointIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _securityGroups?;
        /**
         * @stability stable
         */
        get securityGroups(): string[] | undefined;
        /**
         * @stability stable
         */
        set securityGroups(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecurityGroups(): void;
        /**
         * @stability stable
         */
        get securityGroupsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        private _subnetId?;
        /**
         * @stability stable
         */
        get subnetId(): string;
        /**
         * @stability stable
         */
        set subnetId(value: string);
        /**
         * @stability stable
         */
        get subnetIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get vpcId(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2ClientVpnRouteConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_route.html#client_vpn_endpoint_id Ec2ClientVpnRoute#client_vpn_endpoint_id}.
         *
         * @stability stable
         */
        readonly clientVpnEndpointId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_route.html#description Ec2ClientVpnRoute#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_route.html#destination_cidr_block Ec2ClientVpnRoute#destination_cidr_block}.
         *
         * @stability stable
         */
        readonly destinationCidrBlock: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_route.html#target_vpc_subnet_id Ec2ClientVpnRoute#target_vpc_subnet_id}.
         *
         * @stability stable
         */
        readonly targetVpcSubnetId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_route.html aws_ec2_client_vpn_route}.
     *
     * @stability stable
     */
    class Ec2ClientVpnRoute extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_client_vpn_route.html aws_ec2_client_vpn_route} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2ClientVpnRouteConfig);
        private _clientVpnEndpointId?;
        /**
         * @stability stable
         */
        get clientVpnEndpointId(): string;
        /**
         * @stability stable
         */
        set clientVpnEndpointId(value: string);
        /**
         * @stability stable
         */
        get clientVpnEndpointIdInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _destinationCidrBlock?;
        /**
         * @stability stable
         */
        get destinationCidrBlock(): string;
        /**
         * @stability stable
         */
        set destinationCidrBlock(value: string);
        /**
         * @stability stable
         */
        get destinationCidrBlockInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get origin(): string;
        private _targetVpcSubnetId?;
        /**
         * @stability stable
         */
        get targetVpcSubnetId(): string;
        /**
         * @stability stable
         */
        set targetVpcSubnetId(value: string);
        /**
         * @stability stable
         */
        get targetVpcSubnetIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2FleetConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#excess_capacity_termination_policy Ec2Fleet#excess_capacity_termination_policy}.
         *
         * @stability stable
         */
        readonly excessCapacityTerminationPolicy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#replace_unhealthy_instances Ec2Fleet#replace_unhealthy_instances}.
         *
         * @stability stable
         */
        readonly replaceUnhealthyInstances?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#tags Ec2Fleet#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#tags_all Ec2Fleet#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#terminate_instances Ec2Fleet#terminate_instances}.
         *
         * @stability stable
         */
        readonly terminateInstances?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#terminate_instances_with_expiration Ec2Fleet#terminate_instances_with_expiration}.
         *
         * @stability stable
         */
        readonly terminateInstancesWithExpiration?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#type Ec2Fleet#type}.
         *
         * @stability stable
         */
        readonly type?: string;
        /**
         * launch_template_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#launch_template_config Ec2Fleet#launch_template_config}
         *
         * @stability stable
         */
        readonly launchTemplateConfig: Ec2FleetLaunchTemplateConfig;
        /**
         * on_demand_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#on_demand_options Ec2Fleet#on_demand_options}
         *
         * @stability stable
         */
        readonly onDemandOptions?: Ec2FleetOnDemandOptions;
        /**
         * spot_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#spot_options Ec2Fleet#spot_options}
         *
         * @stability stable
         */
        readonly spotOptions?: Ec2FleetSpotOptions;
        /**
         * target_capacity_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#target_capacity_specification Ec2Fleet#target_capacity_specification}
         *
         * @stability stable
         */
        readonly targetCapacitySpecification: Ec2FleetTargetCapacitySpecification;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#timeouts Ec2Fleet#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: Ec2FleetTimeouts;
    }
    /**
     * @stability stable
     */
    interface Ec2FleetLaunchTemplateConfigLaunchTemplateSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#launch_template_id Ec2Fleet#launch_template_id}.
         *
         * @stability stable
         */
        readonly launchTemplateId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#launch_template_name Ec2Fleet#launch_template_name}.
         *
         * @stability stable
         */
        readonly launchTemplateName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#version Ec2Fleet#version}.
         *
         * @stability stable
         */
        readonly version: string;
    }
    /**
     * @stability stable
     */
    class Ec2FleetLaunchTemplateConfigLaunchTemplateSpecificationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _launchTemplateId?;
        /**
         * @stability stable
         */
        get launchTemplateId(): string | undefined;
        /**
         * @stability stable
         */
        set launchTemplateId(value: string | undefined);
        /**
         * @stability stable
         */
        resetLaunchTemplateId(): void;
        /**
         * @stability stable
         */
        get launchTemplateIdInput(): string | undefined;
        private _launchTemplateName?;
        /**
         * @stability stable
         */
        get launchTemplateName(): string | undefined;
        /**
         * @stability stable
         */
        set launchTemplateName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLaunchTemplateName(): void;
        /**
         * @stability stable
         */
        get launchTemplateNameInput(): string | undefined;
        private _version?;
        /**
         * @stability stable
         */
        get version(): string;
        /**
         * @stability stable
         */
        set version(value: string);
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Ec2FleetLaunchTemplateConfigOverride {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#availability_zone Ec2Fleet#availability_zone}.
         *
         * @stability stable
         */
        readonly availabilityZone?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#instance_type Ec2Fleet#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#max_price Ec2Fleet#max_price}.
         *
         * @stability stable
         */
        readonly maxPrice?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#priority Ec2Fleet#priority}.
         *
         * @stability stable
         */
        readonly priority?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#subnet_id Ec2Fleet#subnet_id}.
         *
         * @stability stable
         */
        readonly subnetId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#weighted_capacity Ec2Fleet#weighted_capacity}.
         *
         * @stability stable
         */
        readonly weightedCapacity?: number;
    }
    /**
     * @stability stable
     */
    interface Ec2FleetLaunchTemplateConfig {
        /**
         * launch_template_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#launch_template_specification Ec2Fleet#launch_template_specification}
         *
         * @stability stable
         */
        readonly launchTemplateSpecification: Ec2FleetLaunchTemplateConfigLaunchTemplateSpecification;
        /**
         * override block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#override Ec2Fleet#override}
         *
         * @stability stable
         */
        readonly override?: Ec2FleetLaunchTemplateConfigOverride[];
    }
    /**
     * @stability stable
     */
    class Ec2FleetLaunchTemplateConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _launchTemplateSpecification?;
        private __launchTemplateSpecificationOutput;
        /**
         * @stability stable
         */
        get launchTemplateSpecification(): Ec2FleetLaunchTemplateConfigLaunchTemplateSpecificationOutputReference;
        /**
         * @stability stable
         */
        putLaunchTemplateSpecification(value: Ec2FleetLaunchTemplateConfigLaunchTemplateSpecification): void;
        /**
         * @stability stable
         */
        get launchTemplateSpecificationInput(): Ec2FleetLaunchTemplateConfigLaunchTemplateSpecification | undefined;
        private _override?;
        /**
         * @stability stable
         */
        get override(): Ec2FleetLaunchTemplateConfigOverride[] | undefined;
        /**
         * @stability stable
         */
        set override(value: Ec2FleetLaunchTemplateConfigOverride[] | undefined);
        /**
         * @stability stable
         */
        resetOverride(): void;
        /**
         * @stability stable
         */
        get overrideInput(): Ec2FleetLaunchTemplateConfigOverride[] | undefined;
    }
    /**
     * @stability stable
     */
    interface Ec2FleetOnDemandOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#allocation_strategy Ec2Fleet#allocation_strategy}.
         *
         * @stability stable
         */
        readonly allocationStrategy?: string;
    }
    /**
     * @stability stable
     */
    class Ec2FleetOnDemandOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _allocationStrategy?;
        /**
         * @stability stable
         */
        get allocationStrategy(): string | undefined;
        /**
         * @stability stable
         */
        set allocationStrategy(value: string | undefined);
        /**
         * @stability stable
         */
        resetAllocationStrategy(): void;
        /**
         * @stability stable
         */
        get allocationStrategyInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalance {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#replacement_strategy Ec2Fleet#replacement_strategy}.
         *
         * @stability stable
         */
        readonly replacementStrategy?: string;
    }
    /**
     * @stability stable
     */
    class Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalanceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _replacementStrategy?;
        /**
         * @stability stable
         */
        get replacementStrategy(): string | undefined;
        /**
         * @stability stable
         */
        set replacementStrategy(value: string | undefined);
        /**
         * @stability stable
         */
        resetReplacementStrategy(): void;
        /**
         * @stability stable
         */
        get replacementStrategyInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Ec2FleetSpotOptionsMaintenanceStrategies {
        /**
         * capacity_rebalance block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#capacity_rebalance Ec2Fleet#capacity_rebalance}
         *
         * @stability stable
         */
        readonly capacityRebalance?: Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalance;
    }
    /**
     * @stability stable
     */
    class Ec2FleetSpotOptionsMaintenanceStrategiesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _capacityRebalance?;
        private __capacityRebalanceOutput;
        /**
         * @stability stable
         */
        get capacityRebalance(): Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalanceOutputReference;
        /**
         * @stability stable
         */
        putCapacityRebalance(value: Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalance | undefined): void;
        /**
         * @stability stable
         */
        resetCapacityRebalance(): void;
        /**
         * @stability stable
         */
        get capacityRebalanceInput(): Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalance | undefined;
    }
    /**
     * @stability stable
     */
    interface Ec2FleetSpotOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#allocation_strategy Ec2Fleet#allocation_strategy}.
         *
         * @stability stable
         */
        readonly allocationStrategy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#instance_interruption_behavior Ec2Fleet#instance_interruption_behavior}.
         *
         * @stability stable
         */
        readonly instanceInterruptionBehavior?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#instance_pools_to_use_count Ec2Fleet#instance_pools_to_use_count}.
         *
         * @stability stable
         */
        readonly instancePoolsToUseCount?: number;
        /**
         * maintenance_strategies block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#maintenance_strategies Ec2Fleet#maintenance_strategies}
         *
         * @stability stable
         */
        readonly maintenanceStrategies?: Ec2FleetSpotOptionsMaintenanceStrategies;
    }
    /**
     * @stability stable
     */
    class Ec2FleetSpotOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _allocationStrategy?;
        /**
         * @stability stable
         */
        get allocationStrategy(): string | undefined;
        /**
         * @stability stable
         */
        set allocationStrategy(value: string | undefined);
        /**
         * @stability stable
         */
        resetAllocationStrategy(): void;
        /**
         * @stability stable
         */
        get allocationStrategyInput(): string | undefined;
        private _instanceInterruptionBehavior?;
        /**
         * @stability stable
         */
        get instanceInterruptionBehavior(): string | undefined;
        /**
         * @stability stable
         */
        set instanceInterruptionBehavior(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceInterruptionBehavior(): void;
        /**
         * @stability stable
         */
        get instanceInterruptionBehaviorInput(): string | undefined;
        private _instancePoolsToUseCount?;
        /**
         * @stability stable
         */
        get instancePoolsToUseCount(): number | undefined;
        /**
         * @stability stable
         */
        set instancePoolsToUseCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetInstancePoolsToUseCount(): void;
        /**
         * @stability stable
         */
        get instancePoolsToUseCountInput(): number | undefined;
        private _maintenanceStrategies?;
        private __maintenanceStrategiesOutput;
        /**
         * @stability stable
         */
        get maintenanceStrategies(): Ec2FleetSpotOptionsMaintenanceStrategiesOutputReference;
        /**
         * @stability stable
         */
        putMaintenanceStrategies(value: Ec2FleetSpotOptionsMaintenanceStrategies | undefined): void;
        /**
         * @stability stable
         */
        resetMaintenanceStrategies(): void;
        /**
         * @stability stable
         */
        get maintenanceStrategiesInput(): Ec2FleetSpotOptionsMaintenanceStrategies | undefined;
    }
    /**
     * @stability stable
     */
    interface Ec2FleetTargetCapacitySpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#default_target_capacity_type Ec2Fleet#default_target_capacity_type}.
         *
         * @stability stable
         */
        readonly defaultTargetCapacityType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#on_demand_target_capacity Ec2Fleet#on_demand_target_capacity}.
         *
         * @stability stable
         */
        readonly onDemandTargetCapacity?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#spot_target_capacity Ec2Fleet#spot_target_capacity}.
         *
         * @stability stable
         */
        readonly spotTargetCapacity?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#total_target_capacity Ec2Fleet#total_target_capacity}.
         *
         * @stability stable
         */
        readonly totalTargetCapacity: number;
    }
    /**
     * @stability stable
     */
    class Ec2FleetTargetCapacitySpecificationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _defaultTargetCapacityType?;
        /**
         * @stability stable
         */
        get defaultTargetCapacityType(): string;
        /**
         * @stability stable
         */
        set defaultTargetCapacityType(value: string);
        /**
         * @stability stable
         */
        get defaultTargetCapacityTypeInput(): string | undefined;
        private _onDemandTargetCapacity?;
        /**
         * @stability stable
         */
        get onDemandTargetCapacity(): number | undefined;
        /**
         * @stability stable
         */
        set onDemandTargetCapacity(value: number | undefined);
        /**
         * @stability stable
         */
        resetOnDemandTargetCapacity(): void;
        /**
         * @stability stable
         */
        get onDemandTargetCapacityInput(): number | undefined;
        private _spotTargetCapacity?;
        /**
         * @stability stable
         */
        get spotTargetCapacity(): number | undefined;
        /**
         * @stability stable
         */
        set spotTargetCapacity(value: number | undefined);
        /**
         * @stability stable
         */
        resetSpotTargetCapacity(): void;
        /**
         * @stability stable
         */
        get spotTargetCapacityInput(): number | undefined;
        private _totalTargetCapacity?;
        /**
         * @stability stable
         */
        get totalTargetCapacity(): number;
        /**
         * @stability stable
         */
        set totalTargetCapacity(value: number);
        /**
         * @stability stable
         */
        get totalTargetCapacityInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface Ec2FleetTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#create Ec2Fleet#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#delete Ec2Fleet#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#update Ec2Fleet#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class Ec2FleetTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html aws_ec2_fleet}.
     *
     * @stability stable
     */
    class Ec2Fleet extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html aws_ec2_fleet} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2FleetConfig);
        private _excessCapacityTerminationPolicy?;
        /**
         * @stability stable
         */
        get excessCapacityTerminationPolicy(): string | undefined;
        /**
         * @stability stable
         */
        set excessCapacityTerminationPolicy(value: string | undefined);
        /**
         * @stability stable
         */
        resetExcessCapacityTerminationPolicy(): void;
        /**
         * @stability stable
         */
        get excessCapacityTerminationPolicyInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _replaceUnhealthyInstances?;
        /**
         * @stability stable
         */
        get replaceUnhealthyInstances(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set replaceUnhealthyInstances(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetReplaceUnhealthyInstances(): void;
        /**
         * @stability stable
         */
        get replaceUnhealthyInstancesInput(): boolean | cdktf.IResolvable | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _terminateInstances?;
        /**
         * @stability stable
         */
        get terminateInstances(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set terminateInstances(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTerminateInstances(): void;
        /**
         * @stability stable
         */
        get terminateInstancesInput(): boolean | cdktf.IResolvable | undefined;
        private _terminateInstancesWithExpiration?;
        /**
         * @stability stable
         */
        get terminateInstancesWithExpiration(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set terminateInstancesWithExpiration(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTerminateInstancesWithExpiration(): void;
        /**
         * @stability stable
         */
        get terminateInstancesWithExpirationInput(): boolean | cdktf.IResolvable | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string | undefined;
        /**
         * @stability stable
         */
        set type(value: string | undefined);
        /**
         * @stability stable
         */
        resetType(): void;
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _launchTemplateConfig?;
        private __launchTemplateConfigOutput;
        /**
         * @stability stable
         */
        get launchTemplateConfig(): Ec2FleetLaunchTemplateConfigOutputReference;
        /**
         * @stability stable
         */
        putLaunchTemplateConfig(value: Ec2FleetLaunchTemplateConfig): void;
        /**
         * @stability stable
         */
        get launchTemplateConfigInput(): Ec2FleetLaunchTemplateConfig | undefined;
        private _onDemandOptions?;
        private __onDemandOptionsOutput;
        /**
         * @stability stable
         */
        get onDemandOptions(): Ec2FleetOnDemandOptionsOutputReference;
        /**
         * @stability stable
         */
        putOnDemandOptions(value: Ec2FleetOnDemandOptions | undefined): void;
        /**
         * @stability stable
         */
        resetOnDemandOptions(): void;
        /**
         * @stability stable
         */
        get onDemandOptionsInput(): Ec2FleetOnDemandOptions | undefined;
        private _spotOptions?;
        private __spotOptionsOutput;
        /**
         * @stability stable
         */
        get spotOptions(): Ec2FleetSpotOptionsOutputReference;
        /**
         * @stability stable
         */
        putSpotOptions(value: Ec2FleetSpotOptions | undefined): void;
        /**
         * @stability stable
         */
        resetSpotOptions(): void;
        /**
         * @stability stable
         */
        get spotOptionsInput(): Ec2FleetSpotOptions | undefined;
        private _targetCapacitySpecification?;
        private __targetCapacitySpecificationOutput;
        /**
         * @stability stable
         */
        get targetCapacitySpecification(): Ec2FleetTargetCapacitySpecificationOutputReference;
        /**
         * @stability stable
         */
        putTargetCapacitySpecification(value: Ec2FleetTargetCapacitySpecification): void;
        /**
         * @stability stable
         */
        get targetCapacitySpecificationInput(): Ec2FleetTargetCapacitySpecification | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): Ec2FleetTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: Ec2FleetTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): Ec2FleetTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2HostConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_host.html#auto_placement Ec2Host#auto_placement}.
         *
         * @stability stable
         */
        readonly autoPlacement?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_host.html#availability_zone Ec2Host#availability_zone}.
         *
         * @stability stable
         */
        readonly availabilityZone: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_host.html#host_recovery Ec2Host#host_recovery}.
         *
         * @stability stable
         */
        readonly hostRecovery?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_host.html#instance_family Ec2Host#instance_family}.
         *
         * @stability stable
         */
        readonly instanceFamily?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_host.html#instance_type Ec2Host#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_host.html#tags Ec2Host#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_host.html#tags_all Ec2Host#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_host.html aws_ec2_host}.
     *
     * @stability stable
     */
    class Ec2Host extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_host.html aws_ec2_host} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2HostConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoPlacement?;
        /**
         * @stability stable
         */
        get autoPlacement(): string | undefined;
        /**
         * @stability stable
         */
        set autoPlacement(value: string | undefined);
        /**
         * @stability stable
         */
        resetAutoPlacement(): void;
        /**
         * @stability stable
         */
        get autoPlacementInput(): string | undefined;
        private _availabilityZone?;
        /**
         * @stability stable
         */
        get availabilityZone(): string;
        /**
         * @stability stable
         */
        set availabilityZone(value: string);
        /**
         * @stability stable
         */
        get availabilityZoneInput(): string | undefined;
        private _hostRecovery?;
        /**
         * @stability stable
         */
        get hostRecovery(): string | undefined;
        /**
         * @stability stable
         */
        set hostRecovery(value: string | undefined);
        /**
         * @stability stable
         */
        resetHostRecovery(): void;
        /**
         * @stability stable
         */
        get hostRecoveryInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceFamily?;
        /**
         * @stability stable
         */
        get instanceFamily(): string | undefined;
        /**
         * @stability stable
         */
        set instanceFamily(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceFamily(): void;
        /**
         * @stability stable
         */
        get instanceFamilyInput(): string | undefined;
        private _instanceType?;
        /**
         * @stability stable
         */
        get instanceType(): string | undefined;
        /**
         * @stability stable
         */
        set instanceType(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceType(): void;
        /**
         * @stability stable
         */
        get instanceTypeInput(): string | undefined;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2LocalGatewayRouteConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_local_gateway_route.html#destination_cidr_block Ec2LocalGatewayRoute#destination_cidr_block}.
         *
         * @stability stable
         */
        readonly destinationCidrBlock: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_local_gateway_route.html#local_gateway_route_table_id Ec2LocalGatewayRoute#local_gateway_route_table_id}.
         *
         * @stability stable
         */
        readonly localGatewayRouteTableId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_local_gateway_route.html#local_gateway_virtual_interface_group_id Ec2LocalGatewayRoute#local_gateway_virtual_interface_group_id}.
         *
         * @stability stable
         */
        readonly localGatewayVirtualInterfaceGroupId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_local_gateway_route.html aws_ec2_local_gateway_route}.
     *
     * @stability stable
     */
    class Ec2LocalGatewayRoute extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_local_gateway_route.html aws_ec2_local_gateway_route} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2LocalGatewayRouteConfig);
        private _destinationCidrBlock?;
        /**
         * @stability stable
         */
        get destinationCidrBlock(): string;
        /**
         * @stability stable
         */
        set destinationCidrBlock(value: string);
        /**
         * @stability stable
         */
        get destinationCidrBlockInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _localGatewayRouteTableId?;
        /**
         * @stability stable
         */
        get localGatewayRouteTableId(): string;
        /**
         * @stability stable
         */
        set localGatewayRouteTableId(value: string);
        /**
         * @stability stable
         */
        get localGatewayRouteTableIdInput(): string | undefined;
        private _localGatewayVirtualInterfaceGroupId?;
        /**
         * @stability stable
         */
        get localGatewayVirtualInterfaceGroupId(): string;
        /**
         * @stability stable
         */
        set localGatewayVirtualInterfaceGroupId(value: string);
        /**
         * @stability stable
         */
        get localGatewayVirtualInterfaceGroupIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2LocalGatewayRouteTableVpcAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_local_gateway_route_table_vpc_association.html#local_gateway_route_table_id Ec2LocalGatewayRouteTableVpcAssociation#local_gateway_route_table_id}.
         *
         * @stability stable
         */
        readonly localGatewayRouteTableId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_local_gateway_route_table_vpc_association.html#tags Ec2LocalGatewayRouteTableVpcAssociation#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_local_gateway_route_table_vpc_association.html#tags_all Ec2LocalGatewayRouteTableVpcAssociation#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_local_gateway_route_table_vpc_association.html#vpc_id Ec2LocalGatewayRouteTableVpcAssociation#vpc_id}.
         *
         * @stability stable
         */
        readonly vpcId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_local_gateway_route_table_vpc_association.html aws_ec2_local_gateway_route_table_vpc_association}.
     *
     * @stability stable
     */
    class Ec2LocalGatewayRouteTableVpcAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_local_gateway_route_table_vpc_association.html aws_ec2_local_gateway_route_table_vpc_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2LocalGatewayRouteTableVpcAssociationConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get localGatewayId(): string;
        private _localGatewayRouteTableId?;
        /**
         * @stability stable
         */
        get localGatewayRouteTableId(): string;
        /**
         * @stability stable
         */
        set localGatewayRouteTableId(value: string);
        /**
         * @stability stable
         */
        get localGatewayRouteTableIdInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _vpcId?;
        /**
         * @stability stable
         */
        get vpcId(): string;
        /**
         * @stability stable
         */
        set vpcId(value: string);
        /**
         * @stability stable
         */
        get vpcIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2ManagedPrefixListConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_managed_prefix_list.html#address_family Ec2ManagedPrefixList#address_family}.
         *
         * @stability stable
         */
        readonly addressFamily: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_managed_prefix_list.html#max_entries Ec2ManagedPrefixList#max_entries}.
         *
         * @stability stable
         */
        readonly maxEntries: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_managed_prefix_list.html#name Ec2ManagedPrefixList#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_managed_prefix_list.html#tags Ec2ManagedPrefixList#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_managed_prefix_list.html#tags_all Ec2ManagedPrefixList#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * entry block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_managed_prefix_list.html#entry Ec2ManagedPrefixList#entry}
         *
         * @stability stable
         */
        readonly entry?: Ec2ManagedPrefixListEntry[];
    }
    /**
     * @stability stable
     */
    interface Ec2ManagedPrefixListEntry {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_managed_prefix_list.html#cidr Ec2ManagedPrefixList#cidr}.
         *
         * @stability stable
         */
        readonly cidr: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_managed_prefix_list.html#description Ec2ManagedPrefixList#description}.
         *
         * @stability stable
         */
        readonly description?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_managed_prefix_list.html aws_ec2_managed_prefix_list}.
     *
     * @stability stable
     */
    class Ec2ManagedPrefixList extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_managed_prefix_list.html aws_ec2_managed_prefix_list} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2ManagedPrefixListConfig);
        private _addressFamily?;
        /**
         * @stability stable
         */
        get addressFamily(): string;
        /**
         * @stability stable
         */
        set addressFamily(value: string);
        /**
         * @stability stable
         */
        get addressFamilyInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _maxEntries?;
        /**
         * @stability stable
         */
        get maxEntries(): number;
        /**
         * @stability stable
         */
        set maxEntries(value: number);
        /**
         * @stability stable
         */
        get maxEntriesInput(): number | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get version(): number;
        private _entry?;
        /**
         * @stability stable
         */
        get entry(): Ec2ManagedPrefixListEntry[] | undefined;
        /**
         * @stability stable
         */
        set entry(value: Ec2ManagedPrefixListEntry[] | undefined);
        /**
         * @stability stable
         */
        resetEntry(): void;
        /**
         * @stability stable
         */
        get entryInput(): Ec2ManagedPrefixListEntry[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2ManagedPrefixListEntryAConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_managed_prefix_list_entry.html#cidr Ec2ManagedPrefixListEntryA#cidr}.
         *
         * @stability stable
         */
        readonly cidr: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_managed_prefix_list_entry.html#description Ec2ManagedPrefixListEntryA#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_managed_prefix_list_entry.html#prefix_list_id Ec2ManagedPrefixListEntryA#prefix_list_id}.
         *
         * @stability stable
         */
        readonly prefixListId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_managed_prefix_list_entry.html aws_ec2_managed_prefix_list_entry}.
     *
     * @stability stable
     */
    class Ec2ManagedPrefixListEntryA extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_managed_prefix_list_entry.html aws_ec2_managed_prefix_list_entry} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2ManagedPrefixListEntryAConfig);
        private _cidr?;
        /**
         * @stability stable
         */
        get cidr(): string;
        /**
         * @stability stable
         */
        set cidr(value: string);
        /**
         * @stability stable
         */
        get cidrInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _prefixListId?;
        /**
         * @stability stable
         */
        get prefixListId(): string;
        /**
         * @stability stable
         */
        set prefixListId(value: string);
        /**
         * @stability stable
         */
        get prefixListIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2TagConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_tag.html#key Ec2Tag#key}.
         *
         * @stability stable
         */
        readonly key: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_tag.html#resource_id Ec2Tag#resource_id}.
         *
         * @stability stable
         */
        readonly resourceId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_tag.html#value Ec2Tag#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_tag.html aws_ec2_tag}.
     *
     * @stability stable
     */
    class Ec2Tag extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_tag.html aws_ec2_tag} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2TagConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _key?;
        /**
         * @stability stable
         */
        get key(): string;
        /**
         * @stability stable
         */
        set key(value: string);
        /**
         * @stability stable
         */
        get keyInput(): string | undefined;
        private _resourceId?;
        /**
         * @stability stable
         */
        get resourceId(): string;
        /**
         * @stability stable
         */
        set resourceId(value: string);
        /**
         * @stability stable
         */
        get resourceIdInput(): string | undefined;
        private _value?;
        /**
         * @stability stable
         */
        get value(): string;
        /**
         * @stability stable
         */
        set value(value: string);
        /**
         * @stability stable
         */
        get valueInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2TrafficMirrorFilterConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter.html#description Ec2TrafficMirrorFilter#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter.html#network_services Ec2TrafficMirrorFilter#network_services}.
         *
         * @stability stable
         */
        readonly networkServices?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter.html#tags Ec2TrafficMirrorFilter#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter.html#tags_all Ec2TrafficMirrorFilter#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter.html aws_ec2_traffic_mirror_filter}.
     *
     * @stability stable
     */
    class Ec2TrafficMirrorFilter extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter.html aws_ec2_traffic_mirror_filter} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: Ec2TrafficMirrorFilterConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _networkServices?;
        /**
         * @stability stable
         */
        get networkServices(): string[] | undefined;
        /**
         * @stability stable
         */
        set networkServices(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetNetworkServices(): void;
        /**
         * @stability stable
         */
        get networkServicesInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2TrafficMirrorFilterRuleConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter_rule.html#description Ec2TrafficMirrorFilterRule#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter_rule.html#destination_cidr_block Ec2TrafficMirrorFilterRule#destination_cidr_block}.
         *
         * @stability stable
         */
        readonly destinationCidrBlock: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter_rule.html#protocol Ec2TrafficMirrorFilterRule#protocol}.
         *
         * @stability stable
         */
        readonly protocol?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter_rule.html#rule_action Ec2TrafficMirrorFilterRule#rule_action}.
         *
         * @stability stable
         */
        readonly ruleAction: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter_rule.html#rule_number Ec2TrafficMirrorFilterRule#rule_number}.
         *
         * @stability stable
         */
        readonly ruleNumber: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter_rule.html#source_cidr_block Ec2TrafficMirrorFilterRule#source_cidr_block}.
         *
         * @stability stable
         */
        readonly sourceCidrBlock: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter_rule.html#traffic_direction Ec2TrafficMirrorFilterRule#traffic_direction}.
         *
         * @stability stable
         */
        readonly trafficDirection: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter_rule.html#traffic_mirror_filter_id Ec2TrafficMirrorFilterRule#traffic_mirror_filter_id}.
         *
         * @stability stable
         */
        readonly trafficMirrorFilterId: string;
        /**
         * destination_port_range block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter_rule.html#destination_port_range Ec2TrafficMirrorFilterRule#destination_port_range}
         *
         * @stability stable
         */
        readonly destinationPortRange?: Ec2TrafficMirrorFilterRuleDestinationPortRange;
        /**
         * source_port_range block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter_rule.html#source_port_range Ec2TrafficMirrorFilterRule#source_port_range}
         *
         * @stability stable
         */
        readonly sourcePortRange?: Ec2TrafficMirrorFilterRuleSourcePortRange;
    }
    /**
     * @stability stable
     */
    interface Ec2TrafficMirrorFilterRuleDestinationPortRange {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter_rule.html#from_port Ec2TrafficMirrorFilterRule#from_port}.
         *
         * @stability stable
         */
        readonly fromPort?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter_rule.html#to_port Ec2TrafficMirrorFilterRule#to_port}.
         *
         * @stability stable
         */
        readonly toPort?: number;
    }
    /**
     * @stability stable
     */
    class Ec2TrafficMirrorFilterRuleDestinationPortRangeOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _fromPort?;
        /**
         * @stability stable
         */
        get fromPort(): number | undefined;
        /**
         * @stability stable
         */
        set fromPort(value: number | undefined);
        /**
         * @stability stable
         */
        resetFromPort(): void;
        /**
         * @stability stable
         */
        get fromPortInput(): number | undefined;
        private _toPort?;
        /**
         * @stability stable
         */
        get toPort(): number | undefined;
        /**
         * @stability stable
         */
        set toPort(value: number | undefined);
        /**
         * @stability stable
         */
        resetToPort(): void;
        /**
         * @stability stable
         */
        get toPortInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface Ec2TrafficMirrorFilterRuleSourcePortRange {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter_rule.html#from_port Ec2TrafficMirrorFilterRule#from_port}.
         *
         * @stability stable
         */
        readonly fromPort?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter_rule.html#to_port Ec2TrafficMirrorFilterRule#to_port}.
         *
         * @stability stable
         */
        readonly toPort?: number;
    }
    /**
     * @stability stable
     */
    class Ec2TrafficMirrorFilterRuleSourcePortRangeOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _fromPort?;
        /**
         * @stability stable
         */
        get fromPort(): number | undefined;
        /**
         * @stability stable
         */
        set fromPort(value: number | undefined);
        /**
         * @stability stable
         */
        resetFromPort(): void;
        /**
         * @stability stable
         */
        get fromPortInput(): number | undefined;
        private _toPort?;
        /**
         * @stability stable
         */
        get toPort(): number | undefined;
        /**
         * @stability stable
         */
        set toPort(value: number | undefined);
        /**
         * @stability stable
         */
        resetToPort(): void;
        /**
         * @stability stable
         */
        get toPortInput(): number | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter_rule.html aws_ec2_traffic_mirror_filter_rule}.
     *
     * @stability stable
     */
    class Ec2TrafficMirrorFilterRule extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_filter_rule.html aws_ec2_traffic_mirror_filter_rule} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2TrafficMirrorFilterRuleConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _destinationCidrBlock?;
        /**
         * @stability stable
         */
        get destinationCidrBlock(): string;
        /**
         * @stability stable
         */
        set destinationCidrBlock(value: string);
        /**
         * @stability stable
         */
        get destinationCidrBlockInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _protocol?;
        /**
         * @stability stable
         */
        get protocol(): number | undefined;
        /**
         * @stability stable
         */
        set protocol(value: number | undefined);
        /**
         * @stability stable
         */
        resetProtocol(): void;
        /**
         * @stability stable
         */
        get protocolInput(): number | undefined;
        private _ruleAction?;
        /**
         * @stability stable
         */
        get ruleAction(): string;
        /**
         * @stability stable
         */
        set ruleAction(value: string);
        /**
         * @stability stable
         */
        get ruleActionInput(): string | undefined;
        private _ruleNumber?;
        /**
         * @stability stable
         */
        get ruleNumber(): number;
        /**
         * @stability stable
         */
        set ruleNumber(value: number);
        /**
         * @stability stable
         */
        get ruleNumberInput(): number | undefined;
        private _sourceCidrBlock?;
        /**
         * @stability stable
         */
        get sourceCidrBlock(): string;
        /**
         * @stability stable
         */
        set sourceCidrBlock(value: string);
        /**
         * @stability stable
         */
        get sourceCidrBlockInput(): string | undefined;
        private _trafficDirection?;
        /**
         * @stability stable
         */
        get trafficDirection(): string;
        /**
         * @stability stable
         */
        set trafficDirection(value: string);
        /**
         * @stability stable
         */
        get trafficDirectionInput(): string | undefined;
        private _trafficMirrorFilterId?;
        /**
         * @stability stable
         */
        get trafficMirrorFilterId(): string;
        /**
         * @stability stable
         */
        set trafficMirrorFilterId(value: string);
        /**
         * @stability stable
         */
        get trafficMirrorFilterIdInput(): string | undefined;
        private _destinationPortRange?;
        private __destinationPortRangeOutput;
        /**
         * @stability stable
         */
        get destinationPortRange(): Ec2TrafficMirrorFilterRuleDestinationPortRangeOutputReference;
        /**
         * @stability stable
         */
        putDestinationPortRange(value: Ec2TrafficMirrorFilterRuleDestinationPortRange | undefined): void;
        /**
         * @stability stable
         */
        resetDestinationPortRange(): void;
        /**
         * @stability stable
         */
        get destinationPortRangeInput(): Ec2TrafficMirrorFilterRuleDestinationPortRange | undefined;
        private _sourcePortRange?;
        private __sourcePortRangeOutput;
        /**
         * @stability stable
         */
        get sourcePortRange(): Ec2TrafficMirrorFilterRuleSourcePortRangeOutputReference;
        /**
         * @stability stable
         */
        putSourcePortRange(value: Ec2TrafficMirrorFilterRuleSourcePortRange | undefined): void;
        /**
         * @stability stable
         */
        resetSourcePortRange(): void;
        /**
         * @stability stable
         */
        get sourcePortRangeInput(): Ec2TrafficMirrorFilterRuleSourcePortRange | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2TrafficMirrorSessionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_session.html#description Ec2TrafficMirrorSession#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_session.html#network_interface_id Ec2TrafficMirrorSession#network_interface_id}.
         *
         * @stability stable
         */
        readonly networkInterfaceId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_session.html#packet_length Ec2TrafficMirrorSession#packet_length}.
         *
         * @stability stable
         */
        readonly packetLength?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_session.html#session_number Ec2TrafficMirrorSession#session_number}.
         *
         * @stability stable
         */
        readonly sessionNumber: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_session.html#tags Ec2TrafficMirrorSession#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_session.html#tags_all Ec2TrafficMirrorSession#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_session.html#traffic_mirror_filter_id Ec2TrafficMirrorSession#traffic_mirror_filter_id}.
         *
         * @stability stable
         */
        readonly trafficMirrorFilterId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_session.html#traffic_mirror_target_id Ec2TrafficMirrorSession#traffic_mirror_target_id}.
         *
         * @stability stable
         */
        readonly trafficMirrorTargetId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_session.html#virtual_network_id Ec2TrafficMirrorSession#virtual_network_id}.
         *
         * @stability stable
         */
        readonly virtualNetworkId?: number;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_session.html aws_ec2_traffic_mirror_session}.
     *
     * @stability stable
     */
    class Ec2TrafficMirrorSession extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_session.html aws_ec2_traffic_mirror_session} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2TrafficMirrorSessionConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _networkInterfaceId?;
        /**
         * @stability stable
         */
        get networkInterfaceId(): string;
        /**
         * @stability stable
         */
        set networkInterfaceId(value: string);
        /**
         * @stability stable
         */
        get networkInterfaceIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _packetLength?;
        /**
         * @stability stable
         */
        get packetLength(): number | undefined;
        /**
         * @stability stable
         */
        set packetLength(value: number | undefined);
        /**
         * @stability stable
         */
        resetPacketLength(): void;
        /**
         * @stability stable
         */
        get packetLengthInput(): number | undefined;
        private _sessionNumber?;
        /**
         * @stability stable
         */
        get sessionNumber(): number;
        /**
         * @stability stable
         */
        set sessionNumber(value: number);
        /**
         * @stability stable
         */
        get sessionNumberInput(): number | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _trafficMirrorFilterId?;
        /**
         * @stability stable
         */
        get trafficMirrorFilterId(): string;
        /**
         * @stability stable
         */
        set trafficMirrorFilterId(value: string);
        /**
         * @stability stable
         */
        get trafficMirrorFilterIdInput(): string | undefined;
        private _trafficMirrorTargetId?;
        /**
         * @stability stable
         */
        get trafficMirrorTargetId(): string;
        /**
         * @stability stable
         */
        set trafficMirrorTargetId(value: string);
        /**
         * @stability stable
         */
        get trafficMirrorTargetIdInput(): string | undefined;
        private _virtualNetworkId?;
        /**
         * @stability stable
         */
        get virtualNetworkId(): number | undefined;
        /**
         * @stability stable
         */
        set virtualNetworkId(value: number | undefined);
        /**
         * @stability stable
         */
        resetVirtualNetworkId(): void;
        /**
         * @stability stable
         */
        get virtualNetworkIdInput(): number | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2TrafficMirrorTargetConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_target.html#description Ec2TrafficMirrorTarget#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_target.html#network_interface_id Ec2TrafficMirrorTarget#network_interface_id}.
         *
         * @stability stable
         */
        readonly networkInterfaceId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_target.html#network_load_balancer_arn Ec2TrafficMirrorTarget#network_load_balancer_arn}.
         *
         * @stability stable
         */
        readonly networkLoadBalancerArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_target.html#tags Ec2TrafficMirrorTarget#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_target.html#tags_all Ec2TrafficMirrorTarget#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_target.html aws_ec2_traffic_mirror_target}.
     *
     * @stability stable
     */
    class Ec2TrafficMirrorTarget extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_traffic_mirror_target.html aws_ec2_traffic_mirror_target} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: Ec2TrafficMirrorTargetConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _networkInterfaceId?;
        /**
         * @stability stable
         */
        get networkInterfaceId(): string | undefined;
        /**
         * @stability stable
         */
        set networkInterfaceId(value: string | undefined);
        /**
         * @stability stable
         */
        resetNetworkInterfaceId(): void;
        /**
         * @stability stable
         */
        get networkInterfaceIdInput(): string | undefined;
        private _networkLoadBalancerArn?;
        /**
         * @stability stable
         */
        get networkLoadBalancerArn(): string | undefined;
        /**
         * @stability stable
         */
        set networkLoadBalancerArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetNetworkLoadBalancerArn(): void;
        /**
         * @stability stable
         */
        get networkLoadBalancerArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2TransitGatewayConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway.html#amazon_side_asn Ec2TransitGateway#amazon_side_asn}.
         *
         * @stability stable
         */
        readonly amazonSideAsn?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway.html#auto_accept_shared_attachments Ec2TransitGateway#auto_accept_shared_attachments}.
         *
         * @stability stable
         */
        readonly autoAcceptSharedAttachments?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway.html#default_route_table_association Ec2TransitGateway#default_route_table_association}.
         *
         * @stability stable
         */
        readonly defaultRouteTableAssociation?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway.html#default_route_table_propagation Ec2TransitGateway#default_route_table_propagation}.
         *
         * @stability stable
         */
        readonly defaultRouteTablePropagation?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway.html#description Ec2TransitGateway#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway.html#dns_support Ec2TransitGateway#dns_support}.
         *
         * @stability stable
         */
        readonly dnsSupport?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway.html#tags Ec2TransitGateway#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway.html#tags_all Ec2TransitGateway#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway.html#vpn_ecmp_support Ec2TransitGateway#vpn_ecmp_support}.
         *
         * @stability stable
         */
        readonly vpnEcmpSupport?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway.html aws_ec2_transit_gateway}.
     *
     * @stability stable
     */
    class Ec2TransitGateway extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway.html aws_ec2_transit_gateway} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: Ec2TransitGatewayConfig);
        private _amazonSideAsn?;
        /**
         * @stability stable
         */
        get amazonSideAsn(): number | undefined;
        /**
         * @stability stable
         */
        set amazonSideAsn(value: number | undefined);
        /**
         * @stability stable
         */
        resetAmazonSideAsn(): void;
        /**
         * @stability stable
         */
        get amazonSideAsnInput(): number | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get associationDefaultRouteTableId(): string;
        private _autoAcceptSharedAttachments?;
        /**
         * @stability stable
         */
        get autoAcceptSharedAttachments(): string | undefined;
        /**
         * @stability stable
         */
        set autoAcceptSharedAttachments(value: string | undefined);
        /**
         * @stability stable
         */
        resetAutoAcceptSharedAttachments(): void;
        /**
         * @stability stable
         */
        get autoAcceptSharedAttachmentsInput(): string | undefined;
        private _defaultRouteTableAssociation?;
        /**
         * @stability stable
         */
        get defaultRouteTableAssociation(): string | undefined;
        /**
         * @stability stable
         */
        set defaultRouteTableAssociation(value: string | undefined);
        /**
         * @stability stable
         */
        resetDefaultRouteTableAssociation(): void;
        /**
         * @stability stable
         */
        get defaultRouteTableAssociationInput(): string | undefined;
        private _defaultRouteTablePropagation?;
        /**
         * @stability stable
         */
        get defaultRouteTablePropagation(): string | undefined;
        /**
         * @stability stable
         */
        set defaultRouteTablePropagation(value: string | undefined);
        /**
         * @stability stable
         */
        resetDefaultRouteTablePropagation(): void;
        /**
         * @stability stable
         */
        get defaultRouteTablePropagationInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _dnsSupport?;
        /**
         * @stability stable
         */
        get dnsSupport(): string | undefined;
        /**
         * @stability stable
         */
        set dnsSupport(value: string | undefined);
        /**
         * @stability stable
         */
        resetDnsSupport(): void;
        /**
         * @stability stable
         */
        get dnsSupportInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ownerId(): string;
        /**
         * @stability stable
         */
        get propagationDefaultRouteTableId(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _vpnEcmpSupport?;
        /**
         * @stability stable
         */
        get vpnEcmpSupport(): string | undefined;
        /**
         * @stability stable
         */
        set vpnEcmpSupport(value: string | undefined);
        /**
         * @stability stable
         */
        resetVpnEcmpSupport(): void;
        /**
         * @stability stable
         */
        get vpnEcmpSupportInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2TransitGatewayPeeringAttachmentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_peering_attachment.html#peer_account_id Ec2TransitGatewayPeeringAttachment#peer_account_id}.
         *
         * @stability stable
         */
        readonly peerAccountId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_peering_attachment.html#peer_region Ec2TransitGatewayPeeringAttachment#peer_region}.
         *
         * @stability stable
         */
        readonly peerRegion: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_peering_attachment.html#peer_transit_gateway_id Ec2TransitGatewayPeeringAttachment#peer_transit_gateway_id}.
         *
         * @stability stable
         */
        readonly peerTransitGatewayId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_peering_attachment.html#tags Ec2TransitGatewayPeeringAttachment#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_peering_attachment.html#tags_all Ec2TransitGatewayPeeringAttachment#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_peering_attachment.html#transit_gateway_id Ec2TransitGatewayPeeringAttachment#transit_gateway_id}.
         *
         * @stability stable
         */
        readonly transitGatewayId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_peering_attachment.html aws_ec2_transit_gateway_peering_attachment}.
     *
     * @stability stable
     */
    class Ec2TransitGatewayPeeringAttachment extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_peering_attachment.html aws_ec2_transit_gateway_peering_attachment} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2TransitGatewayPeeringAttachmentConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _peerAccountId?;
        /**
         * @stability stable
         */
        get peerAccountId(): string | undefined;
        /**
         * @stability stable
         */
        set peerAccountId(value: string | undefined);
        /**
         * @stability stable
         */
        resetPeerAccountId(): void;
        /**
         * @stability stable
         */
        get peerAccountIdInput(): string | undefined;
        private _peerRegion?;
        /**
         * @stability stable
         */
        get peerRegion(): string;
        /**
         * @stability stable
         */
        set peerRegion(value: string);
        /**
         * @stability stable
         */
        get peerRegionInput(): string | undefined;
        private _peerTransitGatewayId?;
        /**
         * @stability stable
         */
        get peerTransitGatewayId(): string;
        /**
         * @stability stable
         */
        set peerTransitGatewayId(value: string);
        /**
         * @stability stable
         */
        get peerTransitGatewayIdInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _transitGatewayId?;
        /**
         * @stability stable
         */
        get transitGatewayId(): string;
        /**
         * @stability stable
         */
        set transitGatewayId(value: string);
        /**
         * @stability stable
         */
        get transitGatewayIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2TransitGatewayPeeringAttachmentAccepterConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_peering_attachment_accepter.html#tags Ec2TransitGatewayPeeringAttachmentAccepter#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_peering_attachment_accepter.html#tags_all Ec2TransitGatewayPeeringAttachmentAccepter#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_peering_attachment_accepter.html#transit_gateway_attachment_id Ec2TransitGatewayPeeringAttachmentAccepter#transit_gateway_attachment_id}.
         *
         * @stability stable
         */
        readonly transitGatewayAttachmentId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_peering_attachment_accepter.html aws_ec2_transit_gateway_peering_attachment_accepter}.
     *
     * @stability stable
     */
    class Ec2TransitGatewayPeeringAttachmentAccepter extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_peering_attachment_accepter.html aws_ec2_transit_gateway_peering_attachment_accepter} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2TransitGatewayPeeringAttachmentAccepterConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get peerAccountId(): string;
        /**
         * @stability stable
         */
        get peerRegion(): string;
        /**
         * @stability stable
         */
        get peerTransitGatewayId(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _transitGatewayAttachmentId?;
        /**
         * @stability stable
         */
        get transitGatewayAttachmentId(): string;
        /**
         * @stability stable
         */
        set transitGatewayAttachmentId(value: string);
        /**
         * @stability stable
         */
        get transitGatewayAttachmentIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get transitGatewayId(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2TransitGatewayPrefixListReferenceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_prefix_list_reference.html#blackhole Ec2TransitGatewayPrefixListReference#blackhole}.
         *
         * @stability stable
         */
        readonly blackhole?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_prefix_list_reference.html#prefix_list_id Ec2TransitGatewayPrefixListReference#prefix_list_id}.
         *
         * @stability stable
         */
        readonly prefixListId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_prefix_list_reference.html#transit_gateway_attachment_id Ec2TransitGatewayPrefixListReference#transit_gateway_attachment_id}.
         *
         * @stability stable
         */
        readonly transitGatewayAttachmentId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_prefix_list_reference.html#transit_gateway_route_table_id Ec2TransitGatewayPrefixListReference#transit_gateway_route_table_id}.
         *
         * @stability stable
         */
        readonly transitGatewayRouteTableId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_prefix_list_reference.html aws_ec2_transit_gateway_prefix_list_reference}.
     *
     * @stability stable
     */
    class Ec2TransitGatewayPrefixListReference extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_prefix_list_reference.html aws_ec2_transit_gateway_prefix_list_reference} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2TransitGatewayPrefixListReferenceConfig);
        private _blackhole?;
        /**
         * @stability stable
         */
        get blackhole(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set blackhole(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetBlackhole(): void;
        /**
         * @stability stable
         */
        get blackholeInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _prefixListId?;
        /**
         * @stability stable
         */
        get prefixListId(): string;
        /**
         * @stability stable
         */
        set prefixListId(value: string);
        /**
         * @stability stable
         */
        get prefixListIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get prefixListOwnerId(): string;
        private _transitGatewayAttachmentId?;
        /**
         * @stability stable
         */
        get transitGatewayAttachmentId(): string | undefined;
        /**
         * @stability stable
         */
        set transitGatewayAttachmentId(value: string | undefined);
        /**
         * @stability stable
         */
        resetTransitGatewayAttachmentId(): void;
        /**
         * @stability stable
         */
        get transitGatewayAttachmentIdInput(): string | undefined;
        private _transitGatewayRouteTableId?;
        /**
         * @stability stable
         */
        get transitGatewayRouteTableId(): string;
        /**
         * @stability stable
         */
        set transitGatewayRouteTableId(value: string);
        /**
         * @stability stable
         */
        get transitGatewayRouteTableIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2TransitGatewayRouteConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route.html#blackhole Ec2TransitGatewayRoute#blackhole}.
         *
         * @stability stable
         */
        readonly blackhole?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route.html#destination_cidr_block Ec2TransitGatewayRoute#destination_cidr_block}.
         *
         * @stability stable
         */
        readonly destinationCidrBlock: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route.html#transit_gateway_attachment_id Ec2TransitGatewayRoute#transit_gateway_attachment_id}.
         *
         * @stability stable
         */
        readonly transitGatewayAttachmentId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route.html#transit_gateway_route_table_id Ec2TransitGatewayRoute#transit_gateway_route_table_id}.
         *
         * @stability stable
         */
        readonly transitGatewayRouteTableId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route.html aws_ec2_transit_gateway_route}.
     *
     * @stability stable
     */
    class Ec2TransitGatewayRoute extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route.html aws_ec2_transit_gateway_route} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2TransitGatewayRouteConfig);
        private _blackhole?;
        /**
         * @stability stable
         */
        get blackhole(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set blackhole(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetBlackhole(): void;
        /**
         * @stability stable
         */
        get blackholeInput(): boolean | cdktf.IResolvable | undefined;
        private _destinationCidrBlock?;
        /**
         * @stability stable
         */
        get destinationCidrBlock(): string;
        /**
         * @stability stable
         */
        set destinationCidrBlock(value: string);
        /**
         * @stability stable
         */
        get destinationCidrBlockInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _transitGatewayAttachmentId?;
        /**
         * @stability stable
         */
        get transitGatewayAttachmentId(): string | undefined;
        /**
         * @stability stable
         */
        set transitGatewayAttachmentId(value: string | undefined);
        /**
         * @stability stable
         */
        resetTransitGatewayAttachmentId(): void;
        /**
         * @stability stable
         */
        get transitGatewayAttachmentIdInput(): string | undefined;
        private _transitGatewayRouteTableId?;
        /**
         * @stability stable
         */
        get transitGatewayRouteTableId(): string;
        /**
         * @stability stable
         */
        set transitGatewayRouteTableId(value: string);
        /**
         * @stability stable
         */
        get transitGatewayRouteTableIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2TransitGatewayRouteTableConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table.html#tags Ec2TransitGatewayRouteTable#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table.html#tags_all Ec2TransitGatewayRouteTable#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table.html#transit_gateway_id Ec2TransitGatewayRouteTable#transit_gateway_id}.
         *
         * @stability stable
         */
        readonly transitGatewayId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table.html aws_ec2_transit_gateway_route_table}.
     *
     * @stability stable
     */
    class Ec2TransitGatewayRouteTable extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table.html aws_ec2_transit_gateway_route_table} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2TransitGatewayRouteTableConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get defaultAssociationRouteTable(): any;
        /**
         * @stability stable
         */
        get defaultPropagationRouteTable(): any;
        /**
         * @stability stable
         */
        get id(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _transitGatewayId?;
        /**
         * @stability stable
         */
        get transitGatewayId(): string;
        /**
         * @stability stable
         */
        set transitGatewayId(value: string);
        /**
         * @stability stable
         */
        get transitGatewayIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2TransitGatewayRouteTableAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table_association.html#transit_gateway_attachment_id Ec2TransitGatewayRouteTableAssociation#transit_gateway_attachment_id}.
         *
         * @stability stable
         */
        readonly transitGatewayAttachmentId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table_association.html#transit_gateway_route_table_id Ec2TransitGatewayRouteTableAssociation#transit_gateway_route_table_id}.
         *
         * @stability stable
         */
        readonly transitGatewayRouteTableId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table_association.html aws_ec2_transit_gateway_route_table_association}.
     *
     * @stability stable
     */
    class Ec2TransitGatewayRouteTableAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table_association.html aws_ec2_transit_gateway_route_table_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2TransitGatewayRouteTableAssociationConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get resourceId(): string;
        /**
         * @stability stable
         */
        get resourceType(): string;
        private _transitGatewayAttachmentId?;
        /**
         * @stability stable
         */
        get transitGatewayAttachmentId(): string;
        /**
         * @stability stable
         */
        set transitGatewayAttachmentId(value: string);
        /**
         * @stability stable
         */
        get transitGatewayAttachmentIdInput(): string | undefined;
        private _transitGatewayRouteTableId?;
        /**
         * @stability stable
         */
        get transitGatewayRouteTableId(): string;
        /**
         * @stability stable
         */
        set transitGatewayRouteTableId(value: string);
        /**
         * @stability stable
         */
        get transitGatewayRouteTableIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2TransitGatewayRouteTablePropagationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table_propagation.html#transit_gateway_attachment_id Ec2TransitGatewayRouteTablePropagation#transit_gateway_attachment_id}.
         *
         * @stability stable
         */
        readonly transitGatewayAttachmentId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table_propagation.html#transit_gateway_route_table_id Ec2TransitGatewayRouteTablePropagation#transit_gateway_route_table_id}.
         *
         * @stability stable
         */
        readonly transitGatewayRouteTableId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table_propagation.html aws_ec2_transit_gateway_route_table_propagation}.
     *
     * @stability stable
     */
    class Ec2TransitGatewayRouteTablePropagation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_route_table_propagation.html aws_ec2_transit_gateway_route_table_propagation} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2TransitGatewayRouteTablePropagationConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get resourceId(): string;
        /**
         * @stability stable
         */
        get resourceType(): string;
        private _transitGatewayAttachmentId?;
        /**
         * @stability stable
         */
        get transitGatewayAttachmentId(): string;
        /**
         * @stability stable
         */
        set transitGatewayAttachmentId(value: string);
        /**
         * @stability stable
         */
        get transitGatewayAttachmentIdInput(): string | undefined;
        private _transitGatewayRouteTableId?;
        /**
         * @stability stable
         */
        get transitGatewayRouteTableId(): string;
        /**
         * @stability stable
         */
        set transitGatewayRouteTableId(value: string);
        /**
         * @stability stable
         */
        get transitGatewayRouteTableIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2TransitGatewayVpcAttachmentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment.html#appliance_mode_support Ec2TransitGatewayVpcAttachment#appliance_mode_support}.
         *
         * @stability stable
         */
        readonly applianceModeSupport?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment.html#dns_support Ec2TransitGatewayVpcAttachment#dns_support}.
         *
         * @stability stable
         */
        readonly dnsSupport?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment.html#ipv6_support Ec2TransitGatewayVpcAttachment#ipv6_support}.
         *
         * @stability stable
         */
        readonly ipv6Support?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment.html#subnet_ids Ec2TransitGatewayVpcAttachment#subnet_ids}.
         *
         * @stability stable
         */
        readonly subnetIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment.html#tags Ec2TransitGatewayVpcAttachment#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment.html#tags_all Ec2TransitGatewayVpcAttachment#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment.html#transit_gateway_default_route_table_association Ec2TransitGatewayVpcAttachment#transit_gateway_default_route_table_association}.
         *
         * @stability stable
         */
        readonly transitGatewayDefaultRouteTableAssociation?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment.html#transit_gateway_default_route_table_propagation Ec2TransitGatewayVpcAttachment#transit_gateway_default_route_table_propagation}.
         *
         * @stability stable
         */
        readonly transitGatewayDefaultRouteTablePropagation?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment.html#transit_gateway_id Ec2TransitGatewayVpcAttachment#transit_gateway_id}.
         *
         * @stability stable
         */
        readonly transitGatewayId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment.html#vpc_id Ec2TransitGatewayVpcAttachment#vpc_id}.
         *
         * @stability stable
         */
        readonly vpcId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment.html aws_ec2_transit_gateway_vpc_attachment}.
     *
     * @stability stable
     */
    class Ec2TransitGatewayVpcAttachment extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment.html aws_ec2_transit_gateway_vpc_attachment} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2TransitGatewayVpcAttachmentConfig);
        private _applianceModeSupport?;
        /**
         * @stability stable
         */
        get applianceModeSupport(): string | undefined;
        /**
         * @stability stable
         */
        set applianceModeSupport(value: string | undefined);
        /**
         * @stability stable
         */
        resetApplianceModeSupport(): void;
        /**
         * @stability stable
         */
        get applianceModeSupportInput(): string | undefined;
        private _dnsSupport?;
        /**
         * @stability stable
         */
        get dnsSupport(): string | undefined;
        /**
         * @stability stable
         */
        set dnsSupport(value: string | undefined);
        /**
         * @stability stable
         */
        resetDnsSupport(): void;
        /**
         * @stability stable
         */
        get dnsSupportInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _ipv6Support?;
        /**
         * @stability stable
         */
        get ipv6Support(): string | undefined;
        /**
         * @stability stable
         */
        set ipv6Support(value: string | undefined);
        /**
         * @stability stable
         */
        resetIpv6Support(): void;
        /**
         * @stability stable
         */
        get ipv6SupportInput(): string | undefined;
        private _subnetIds?;
        /**
         * @stability stable
         */
        get subnetIds(): string[];
        /**
         * @stability stable
         */
        set subnetIds(value: string[]);
        /**
         * @stability stable
         */
        get subnetIdsInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _transitGatewayDefaultRouteTableAssociation?;
        /**
         * @stability stable
         */
        get transitGatewayDefaultRouteTableAssociation(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set transitGatewayDefaultRouteTableAssociation(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTransitGatewayDefaultRouteTableAssociation(): void;
        /**
         * @stability stable
         */
        get transitGatewayDefaultRouteTableAssociationInput(): boolean | cdktf.IResolvable | undefined;
        private _transitGatewayDefaultRouteTablePropagation?;
        /**
         * @stability stable
         */
        get transitGatewayDefaultRouteTablePropagation(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set transitGatewayDefaultRouteTablePropagation(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTransitGatewayDefaultRouteTablePropagation(): void;
        /**
         * @stability stable
         */
        get transitGatewayDefaultRouteTablePropagationInput(): boolean | cdktf.IResolvable | undefined;
        private _transitGatewayId?;
        /**
         * @stability stable
         */
        get transitGatewayId(): string;
        /**
         * @stability stable
         */
        set transitGatewayId(value: string);
        /**
         * @stability stable
         */
        get transitGatewayIdInput(): string | undefined;
        private _vpcId?;
        /**
         * @stability stable
         */
        get vpcId(): string;
        /**
         * @stability stable
         */
        set vpcId(value: string);
        /**
         * @stability stable
         */
        get vpcIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get vpcOwnerId(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Ec2TransitGatewayVpcAttachmentAccepterConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment_accepter.html#tags Ec2TransitGatewayVpcAttachmentAccepter#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment_accepter.html#tags_all Ec2TransitGatewayVpcAttachmentAccepter#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment_accepter.html#transit_gateway_attachment_id Ec2TransitGatewayVpcAttachmentAccepter#transit_gateway_attachment_id}.
         *
         * @stability stable
         */
        readonly transitGatewayAttachmentId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment_accepter.html#transit_gateway_default_route_table_association Ec2TransitGatewayVpcAttachmentAccepter#transit_gateway_default_route_table_association}.
         *
         * @stability stable
         */
        readonly transitGatewayDefaultRouteTableAssociation?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment_accepter.html#transit_gateway_default_route_table_propagation Ec2TransitGatewayVpcAttachmentAccepter#transit_gateway_default_route_table_propagation}.
         *
         * @stability stable
         */
        readonly transitGatewayDefaultRouteTablePropagation?: boolean | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment_accepter.html aws_ec2_transit_gateway_vpc_attachment_accepter}.
     *
     * @stability stable
     */
    class Ec2TransitGatewayVpcAttachmentAccepter extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_transit_gateway_vpc_attachment_accepter.html aws_ec2_transit_gateway_vpc_attachment_accepter} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Ec2TransitGatewayVpcAttachmentAccepterConfig);
        /**
         * @stability stable
         */
        get applianceModeSupport(): string;
        /**
         * @stability stable
         */
        get dnsSupport(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ipv6Support(): string;
        /**
         * @stability stable
         */
        get subnetIds(): string[];
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _transitGatewayAttachmentId?;
        /**
         * @stability stable
         */
        get transitGatewayAttachmentId(): string;
        /**
         * @stability stable
         */
        set transitGatewayAttachmentId(value: string);
        /**
         * @stability stable
         */
        get transitGatewayAttachmentIdInput(): string | undefined;
        private _transitGatewayDefaultRouteTableAssociation?;
        /**
         * @stability stable
         */
        get transitGatewayDefaultRouteTableAssociation(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set transitGatewayDefaultRouteTableAssociation(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTransitGatewayDefaultRouteTableAssociation(): void;
        /**
         * @stability stable
         */
        get transitGatewayDefaultRouteTableAssociationInput(): boolean | cdktf.IResolvable | undefined;
        private _transitGatewayDefaultRouteTablePropagation?;
        /**
         * @stability stable
         */
        get transitGatewayDefaultRouteTablePropagation(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set transitGatewayDefaultRouteTablePropagation(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTransitGatewayDefaultRouteTablePropagation(): void;
        /**
         * @stability stable
         */
        get transitGatewayDefaultRouteTablePropagationInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get transitGatewayId(): string;
        /**
         * @stability stable
         */
        get vpcId(): string;
        /**
         * @stability stable
         */
        get vpcOwnerId(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface EipConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip.html#address Eip#address}.
         *
         * @stability stable
         */
        readonly address?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip.html#associate_with_private_ip Eip#associate_with_private_ip}.
         *
         * @stability stable
         */
        readonly associateWithPrivateIp?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip.html#customer_owned_ipv4_pool Eip#customer_owned_ipv4_pool}.
         *
         * @stability stable
         */
        readonly customerOwnedIpv4Pool?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip.html#instance Eip#instance}.
         *
         * @stability stable
         */
        readonly instance?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip.html#network_border_group Eip#network_border_group}.
         *
         * @stability stable
         */
        readonly networkBorderGroup?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip.html#network_interface Eip#network_interface}.
         *
         * @stability stable
         */
        readonly networkInterface?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip.html#public_ipv4_pool Eip#public_ipv4_pool}.
         *
         * @stability stable
         */
        readonly publicIpv4Pool?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip.html#tags Eip#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip.html#tags_all Eip#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip.html#vpc Eip#vpc}.
         *
         * @stability stable
         */
        readonly vpc?: boolean | cdktf.IResolvable;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip.html#timeouts Eip#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: EipTimeouts;
    }
    /**
     * @stability stable
     */
    interface EipTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip.html#delete Eip#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip.html#read Eip#read}.
         *
         * @stability stable
         */
        readonly read?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip.html#update Eip#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class EipTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _read?;
        /**
         * @stability stable
         */
        get read(): string | undefined;
        /**
         * @stability stable
         */
        set read(value: string | undefined);
        /**
         * @stability stable
         */
        resetRead(): void;
        /**
         * @stability stable
         */
        get readInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/eip.html aws_eip}.
     *
     * @stability stable
     */
    class Eip extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/eip.html aws_eip} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: EipConfig);
        private _address?;
        /**
         * @stability stable
         */
        get address(): string | undefined;
        /**
         * @stability stable
         */
        set address(value: string | undefined);
        /**
         * @stability stable
         */
        resetAddress(): void;
        /**
         * @stability stable
         */
        get addressInput(): string | undefined;
        /**
         * @stability stable
         */
        get allocationId(): string;
        private _associateWithPrivateIp?;
        /**
         * @stability stable
         */
        get associateWithPrivateIp(): string | undefined;
        /**
         * @stability stable
         */
        set associateWithPrivateIp(value: string | undefined);
        /**
         * @stability stable
         */
        resetAssociateWithPrivateIp(): void;
        /**
         * @stability stable
         */
        get associateWithPrivateIpInput(): string | undefined;
        /**
         * @stability stable
         */
        get associationId(): string;
        /**
         * @stability stable
         */
        get carrierIp(): string;
        /**
         * @stability stable
         */
        get customerOwnedIp(): string;
        private _customerOwnedIpv4Pool?;
        /**
         * @stability stable
         */
        get customerOwnedIpv4Pool(): string | undefined;
        /**
         * @stability stable
         */
        set customerOwnedIpv4Pool(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomerOwnedIpv4Pool(): void;
        /**
         * @stability stable
         */
        get customerOwnedIpv4PoolInput(): string | undefined;
        /**
         * @stability stable
         */
        get domain(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _instance?;
        /**
         * @stability stable
         */
        get instance(): string | undefined;
        /**
         * @stability stable
         */
        set instance(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstance(): void;
        /**
         * @stability stable
         */
        get instanceInput(): string | undefined;
        private _networkBorderGroup?;
        /**
         * @stability stable
         */
        get networkBorderGroup(): string | undefined;
        /**
         * @stability stable
         */
        set networkBorderGroup(value: string | undefined);
        /**
         * @stability stable
         */
        resetNetworkBorderGroup(): void;
        /**
         * @stability stable
         */
        get networkBorderGroupInput(): string | undefined;
        private _networkInterface?;
        /**
         * @stability stable
         */
        get networkInterface(): string | undefined;
        /**
         * @stability stable
         */
        set networkInterface(value: string | undefined);
        /**
         * @stability stable
         */
        resetNetworkInterface(): void;
        /**
         * @stability stable
         */
        get networkInterfaceInput(): string | undefined;
        /**
         * @stability stable
         */
        get privateDns(): string;
        /**
         * @stability stable
         */
        get privateIp(): string;
        /**
         * @stability stable
         */
        get publicDns(): string;
        /**
         * @stability stable
         */
        get publicIp(): string;
        private _publicIpv4Pool?;
        /**
         * @stability stable
         */
        get publicIpv4Pool(): string | undefined;
        /**
         * @stability stable
         */
        set publicIpv4Pool(value: string | undefined);
        /**
         * @stability stable
         */
        resetPublicIpv4Pool(): void;
        /**
         * @stability stable
         */
        get publicIpv4PoolInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _vpc?;
        /**
         * @stability stable
         */
        get vpc(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set vpc(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetVpc(): void;
        /**
         * @stability stable
         */
        get vpcInput(): boolean | cdktf.IResolvable | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): EipTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: EipTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): EipTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface EipAssociationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip_association.html#allocation_id EipAssociation#allocation_id}.
         *
         * @stability stable
         */
        readonly allocationId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip_association.html#allow_reassociation EipAssociation#allow_reassociation}.
         *
         * @stability stable
         */
        readonly allowReassociation?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip_association.html#instance_id EipAssociation#instance_id}.
         *
         * @stability stable
         */
        readonly instanceId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip_association.html#network_interface_id EipAssociation#network_interface_id}.
         *
         * @stability stable
         */
        readonly networkInterfaceId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip_association.html#private_ip_address EipAssociation#private_ip_address}.
         *
         * @stability stable
         */
        readonly privateIpAddress?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/eip_association.html#public_ip EipAssociation#public_ip}.
         *
         * @stability stable
         */
        readonly publicIp?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/eip_association.html aws_eip_association}.
     *
     * @stability stable
     */
    class EipAssociation extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/eip_association.html aws_eip_association} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: EipAssociationConfig);
        private _allocationId?;
        /**
         * @stability stable
         */
        get allocationId(): string | undefined;
        /**
         * @stability stable
         */
        set allocationId(value: string | undefined);
        /**
         * @stability stable
         */
        resetAllocationId(): void;
        /**
         * @stability stable
         */
        get allocationIdInput(): string | undefined;
        private _allowReassociation?;
        /**
         * @stability stable
         */
        get allowReassociation(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set allowReassociation(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAllowReassociation(): void;
        /**
         * @stability stable
         */
        get allowReassociationInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceId?;
        /**
         * @stability stable
         */
        get instanceId(): string | undefined;
        /**
         * @stability stable
         */
        set instanceId(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceId(): void;
        /**
         * @stability stable
         */
        get instanceIdInput(): string | undefined;
        private _networkInterfaceId?;
        /**
         * @stability stable
         */
        get networkInterfaceId(): string | undefined;
        /**
         * @stability stable
         */
        set networkInterfaceId(value: string | undefined);
        /**
         * @stability stable
         */
        resetNetworkInterfaceId(): void;
        /**
         * @stability stable
         */
        get networkInterfaceIdInput(): string | undefined;
        private _privateIpAddress?;
        /**
         * @stability stable
         */
        get privateIpAddress(): string | undefined;
        /**
         * @stability stable
         */
        set privateIpAddress(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrivateIpAddress(): void;
        /**
         * @stability stable
         */
        get privateIpAddressInput(): string | undefined;
        private _publicIp?;
        /**
         * @stability stable
         */
        get publicIp(): string | undefined;
        /**
         * @stability stable
         */
        set publicIp(value: string | undefined);
        /**
         * @stability stable
         */
        resetPublicIp(): void;
        /**
         * @stability stable
         */
        get publicIpInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface InstanceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#ami Instance#ami}.
         *
         * @stability stable
         */
        readonly ami?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#associate_public_ip_address Instance#associate_public_ip_address}.
         *
         * @stability stable
         */
        readonly associatePublicIpAddress?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#availability_zone Instance#availability_zone}.
         *
         * @stability stable
         */
        readonly availabilityZone?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#cpu_core_count Instance#cpu_core_count}.
         *
         * @stability stable
         */
        readonly cpuCoreCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#cpu_threads_per_core Instance#cpu_threads_per_core}.
         *
         * @stability stable
         */
        readonly cpuThreadsPerCore?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#disable_api_termination Instance#disable_api_termination}.
         *
         * @stability stable
         */
        readonly disableApiTermination?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#ebs_optimized Instance#ebs_optimized}.
         *
         * @stability stable
         */
        readonly ebsOptimized?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#get_password_data Instance#get_password_data}.
         *
         * @stability stable
         */
        readonly fetchPasswordData?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#hibernation Instance#hibernation}.
         *
         * @stability stable
         */
        readonly hibernation?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#host_id Instance#host_id}.
         *
         * @stability stable
         */
        readonly hostId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#iam_instance_profile Instance#iam_instance_profile}.
         *
         * @stability stable
         */
        readonly iamInstanceProfile?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#instance_initiated_shutdown_behavior Instance#instance_initiated_shutdown_behavior}.
         *
         * @stability stable
         */
        readonly instanceInitiatedShutdownBehavior?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#instance_type Instance#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#ipv6_address_count Instance#ipv6_address_count}.
         *
         * @stability stable
         */
        readonly ipv6AddressCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#ipv6_addresses Instance#ipv6_addresses}.
         *
         * @stability stable
         */
        readonly ipv6Addresses?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#key_name Instance#key_name}.
         *
         * @stability stable
         */
        readonly keyName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#monitoring Instance#monitoring}.
         *
         * @stability stable
         */
        readonly monitoring?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#placement_group Instance#placement_group}.
         *
         * @stability stable
         */
        readonly placementGroup?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#placement_partition_number Instance#placement_partition_number}.
         *
         * @stability stable
         */
        readonly placementPartitionNumber?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#private_ip Instance#private_ip}.
         *
         * @stability stable
         */
        readonly privateIp?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#secondary_private_ips Instance#secondary_private_ips}.
         *
         * @stability stable
         */
        readonly secondaryPrivateIps?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#security_groups Instance#security_groups}.
         *
         * @stability stable
         */
        readonly securityGroups?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#source_dest_check Instance#source_dest_check}.
         *
         * @stability stable
         */
        readonly sourceDestCheck?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#subnet_id Instance#subnet_id}.
         *
         * @stability stable
         */
        readonly subnetId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#tags Instance#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#tags_all Instance#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#tenancy Instance#tenancy}.
         *
         * @stability stable
         */
        readonly tenancy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#user_data Instance#user_data}.
         *
         * @stability stable
         */
        readonly userData?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#user_data_base64 Instance#user_data_base64}.
         *
         * @stability stable
         */
        readonly userDataBase64?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#volume_tags Instance#volume_tags}.
         *
         * @stability stable
         */
        readonly volumeTags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#vpc_security_group_ids Instance#vpc_security_group_ids}.
         *
         * @stability stable
         */
        readonly vpcSecurityGroupIds?: string[];
        /**
         * capacity_reservation_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#capacity_reservation_specification Instance#capacity_reservation_specification}
         *
         * @stability stable
         */
        readonly capacityReservationSpecification?: InstanceCapacityReservationSpecification;
        /**
         * credit_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#credit_specification Instance#credit_specification}
         *
         * @stability stable
         */
        readonly creditSpecification?: InstanceCreditSpecification;
        /**
         * ebs_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#ebs_block_device Instance#ebs_block_device}
         *
         * @stability stable
         */
        readonly ebsBlockDevice?: InstanceEbsBlockDevice[];
        /**
         * enclave_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#enclave_options Instance#enclave_options}
         *
         * @stability stable
         */
        readonly enclaveOptions?: InstanceEnclaveOptions;
        /**
         * ephemeral_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#ephemeral_block_device Instance#ephemeral_block_device}
         *
         * @stability stable
         */
        readonly ephemeralBlockDevice?: InstanceEphemeralBlockDevice[];
        /**
         * launch_template block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#launch_template Instance#launch_template}
         *
         * @stability stable
         */
        readonly launchTemplate?: InstanceLaunchTemplate;
        /**
         * metadata_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#metadata_options Instance#metadata_options}
         *
         * @stability stable
         */
        readonly metadataOptions?: InstanceMetadataOptions;
        /**
         * network_interface block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#network_interface Instance#network_interface}
         *
         * @stability stable
         */
        readonly networkInterface?: InstanceNetworkInterface[];
        /**
         * root_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#root_block_device Instance#root_block_device}
         *
         * @stability stable
         */
        readonly rootBlockDevice?: InstanceRootBlockDevice;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#timeouts Instance#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: InstanceTimeouts;
    }
    /**
     * @stability stable
     */
    interface InstanceCapacityReservationSpecificationCapacityReservationTarget {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#capacity_reservation_id Instance#capacity_reservation_id}.
         *
         * @stability stable
         */
        readonly capacityReservationId?: string;
    }
    /**
     * @stability stable
     */
    class InstanceCapacityReservationSpecificationCapacityReservationTargetOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _capacityReservationId?;
        /**
         * @stability stable
         */
        get capacityReservationId(): string | undefined;
        /**
         * @stability stable
         */
        set capacityReservationId(value: string | undefined);
        /**
         * @stability stable
         */
        resetCapacityReservationId(): void;
        /**
         * @stability stable
         */
        get capacityReservationIdInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface InstanceCapacityReservationSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#capacity_reservation_preference Instance#capacity_reservation_preference}.
         *
         * @stability stable
         */
        readonly capacityReservationPreference?: string;
        /**
         * capacity_reservation_target block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#capacity_reservation_target Instance#capacity_reservation_target}
         *
         * @stability stable
         */
        readonly capacityReservationTarget?: InstanceCapacityReservationSpecificationCapacityReservationTarget;
    }
    /**
     * @stability stable
     */
    class InstanceCapacityReservationSpecificationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _capacityReservationPreference?;
        /**
         * @stability stable
         */
        get capacityReservationPreference(): string | undefined;
        /**
         * @stability stable
         */
        set capacityReservationPreference(value: string | undefined);
        /**
         * @stability stable
         */
        resetCapacityReservationPreference(): void;
        /**
         * @stability stable
         */
        get capacityReservationPreferenceInput(): string | undefined;
        private _capacityReservationTarget?;
        private __capacityReservationTargetOutput;
        /**
         * @stability stable
         */
        get capacityReservationTarget(): InstanceCapacityReservationSpecificationCapacityReservationTargetOutputReference;
        /**
         * @stability stable
         */
        putCapacityReservationTarget(value: InstanceCapacityReservationSpecificationCapacityReservationTarget | undefined): void;
        /**
         * @stability stable
         */
        resetCapacityReservationTarget(): void;
        /**
         * @stability stable
         */
        get capacityReservationTargetInput(): InstanceCapacityReservationSpecificationCapacityReservationTarget | undefined;
    }
    /**
     * @stability stable
     */
    interface InstanceCreditSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#cpu_credits Instance#cpu_credits}.
         *
         * @stability stable
         */
        readonly cpuCredits?: string;
    }
    /**
     * @stability stable
     */
    class InstanceCreditSpecificationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _cpuCredits?;
        /**
         * @stability stable
         */
        get cpuCredits(): string | undefined;
        /**
         * @stability stable
         */
        set cpuCredits(value: string | undefined);
        /**
         * @stability stable
         */
        resetCpuCredits(): void;
        /**
         * @stability stable
         */
        get cpuCreditsInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface InstanceEbsBlockDevice {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#delete_on_termination Instance#delete_on_termination}.
         *
         * @stability stable
         */
        readonly deleteOnTermination?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#device_name Instance#device_name}.
         *
         * @stability stable
         */
        readonly deviceName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#encrypted Instance#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#iops Instance#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#kms_key_id Instance#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#snapshot_id Instance#snapshot_id}.
         *
         * @stability stable
         */
        readonly snapshotId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#tags Instance#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#throughput Instance#throughput}.
         *
         * @stability stable
         */
        readonly throughput?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#volume_size Instance#volume_size}.
         *
         * @stability stable
         */
        readonly volumeSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#volume_type Instance#volume_type}.
         *
         * @stability stable
         */
        readonly volumeType?: string;
    }
    /**
     * @stability stable
     */
    interface InstanceEnclaveOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#enabled Instance#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class InstanceEnclaveOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * @stability stable
     */
    interface InstanceEphemeralBlockDevice {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#device_name Instance#device_name}.
         *
         * @stability stable
         */
        readonly deviceName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#no_device Instance#no_device}.
         *
         * @stability stable
         */
        readonly noDevice?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#virtual_name Instance#virtual_name}.
         *
         * @stability stable
         */
        readonly virtualName?: string;
    }
    /**
     * @stability stable
     */
    interface InstanceLaunchTemplate {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#id Instance#id}.
         *
         * @stability stable
         */
        readonly id?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#name Instance#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#version Instance#version}.
         *
         * @stability stable
         */
        readonly version?: string;
    }
    /**
     * @stability stable
     */
    class InstanceLaunchTemplateOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _version?;
        /**
         * @stability stable
         */
        get version(): string | undefined;
        /**
         * @stability stable
         */
        set version(value: string | undefined);
        /**
         * @stability stable
         */
        resetVersion(): void;
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface InstanceMetadataOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#http_endpoint Instance#http_endpoint}.
         *
         * @stability stable
         */
        readonly httpEndpoint?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#http_put_response_hop_limit Instance#http_put_response_hop_limit}.
         *
         * @stability stable
         */
        readonly httpPutResponseHopLimit?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#http_tokens Instance#http_tokens}.
         *
         * @stability stable
         */
        readonly httpTokens?: string;
    }
    /**
     * @stability stable
     */
    class InstanceMetadataOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _httpEndpoint?;
        /**
         * @stability stable
         */
        get httpEndpoint(): string | undefined;
        /**
         * @stability stable
         */
        set httpEndpoint(value: string | undefined);
        /**
         * @stability stable
         */
        resetHttpEndpoint(): void;
        /**
         * @stability stable
         */
        get httpEndpointInput(): string | undefined;
        private _httpPutResponseHopLimit?;
        /**
         * @stability stable
         */
        get httpPutResponseHopLimit(): number | undefined;
        /**
         * @stability stable
         */
        set httpPutResponseHopLimit(value: number | undefined);
        /**
         * @stability stable
         */
        resetHttpPutResponseHopLimit(): void;
        /**
         * @stability stable
         */
        get httpPutResponseHopLimitInput(): number | undefined;
        private _httpTokens?;
        /**
         * @stability stable
         */
        get httpTokens(): string | undefined;
        /**
         * @stability stable
         */
        set httpTokens(value: string | undefined);
        /**
         * @stability stable
         */
        resetHttpTokens(): void;
        /**
         * @stability stable
         */
        get httpTokensInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface InstanceNetworkInterface {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#delete_on_termination Instance#delete_on_termination}.
         *
         * @stability stable
         */
        readonly deleteOnTermination?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#device_index Instance#device_index}.
         *
         * @stability stable
         */
        readonly deviceIndex: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#network_interface_id Instance#network_interface_id}.
         *
         * @stability stable
         */
        readonly networkInterfaceId: string;
    }
    /**
     * @stability stable
     */
    interface InstanceRootBlockDevice {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#delete_on_termination Instance#delete_on_termination}.
         *
         * @stability stable
         */
        readonly deleteOnTermination?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#encrypted Instance#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#iops Instance#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#kms_key_id Instance#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#tags Instance#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#throughput Instance#throughput}.
         *
         * @stability stable
         */
        readonly throughput?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#volume_size Instance#volume_size}.
         *
         * @stability stable
         */
        readonly volumeSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#volume_type Instance#volume_type}.
         *
         * @stability stable
         */
        readonly volumeType?: string;
    }
    /**
     * @stability stable
     */
    class InstanceRootBlockDeviceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _deleteOnTermination?;
        /**
         * @stability stable
         */
        get deleteOnTermination(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set deleteOnTermination(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDeleteOnTermination(): void;
        /**
         * @stability stable
         */
        get deleteOnTerminationInput(): boolean | cdktf.IResolvable | undefined;
        private _encrypted?;
        /**
         * @stability stable
         */
        get encrypted(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set encrypted(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEncrypted(): void;
        /**
         * @stability stable
         */
        get encryptedInput(): boolean | cdktf.IResolvable | undefined;
        private _iops?;
        /**
         * @stability stable
         */
        get iops(): number | undefined;
        /**
         * @stability stable
         */
        set iops(value: number | undefined);
        /**
         * @stability stable
         */
        resetIops(): void;
        /**
         * @stability stable
         */
        get iopsInput(): number | undefined;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _throughput?;
        /**
         * @stability stable
         */
        get throughput(): number | undefined;
        /**
         * @stability stable
         */
        set throughput(value: number | undefined);
        /**
         * @stability stable
         */
        resetThroughput(): void;
        /**
         * @stability stable
         */
        get throughputInput(): number | undefined;
        private _volumeSize?;
        /**
         * @stability stable
         */
        get volumeSize(): number | undefined;
        /**
         * @stability stable
         */
        set volumeSize(value: number | undefined);
        /**
         * @stability stable
         */
        resetVolumeSize(): void;
        /**
         * @stability stable
         */
        get volumeSizeInput(): number | undefined;
        private _volumeType?;
        /**
         * @stability stable
         */
        get volumeType(): string | undefined;
        /**
         * @stability stable
         */
        set volumeType(value: string | undefined);
        /**
         * @stability stable
         */
        resetVolumeType(): void;
        /**
         * @stability stable
         */
        get volumeTypeInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface InstanceTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#create Instance#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#delete Instance#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/instance.html#update Instance#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class InstanceTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/instance.html aws_instance}.
     *
     * @stability stable
     */
    class Instance extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/instance.html aws_instance} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: InstanceConfig);
        private _ami?;
        /**
         * @stability stable
         */
        get ami(): string | undefined;
        /**
         * @stability stable
         */
        set ami(value: string | undefined);
        /**
         * @stability stable
         */
        resetAmi(): void;
        /**
         * @stability stable
         */
        get amiInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _associatePublicIpAddress?;
        /**
         * @stability stable
         */
        get associatePublicIpAddress(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set associatePublicIpAddress(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAssociatePublicIpAddress(): void;
        /**
         * @stability stable
         */
        get associatePublicIpAddressInput(): boolean | cdktf.IResolvable | undefined;
        private _availabilityZone?;
        /**
         * @stability stable
         */
        get availabilityZone(): string | undefined;
        /**
         * @stability stable
         */
        set availabilityZone(value: string | undefined);
        /**
         * @stability stable
         */
        resetAvailabilityZone(): void;
        /**
         * @stability stable
         */
        get availabilityZoneInput(): string | undefined;
        private _cpuCoreCount?;
        /**
         * @stability stable
         */
        get cpuCoreCount(): number | undefined;
        /**
         * @stability stable
         */
        set cpuCoreCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetCpuCoreCount(): void;
        /**
         * @stability stable
         */
        get cpuCoreCountInput(): number | undefined;
        private _cpuThreadsPerCore?;
        /**
         * @stability stable
         */
        get cpuThreadsPerCore(): number | undefined;
        /**
         * @stability stable
         */
        set cpuThreadsPerCore(value: number | undefined);
        /**
         * @stability stable
         */
        resetCpuThreadsPerCore(): void;
        /**
         * @stability stable
         */
        get cpuThreadsPerCoreInput(): number | undefined;
        private _disableApiTermination?;
        /**
         * @stability stable
         */
        get disableApiTermination(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set disableApiTermination(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDisableApiTermination(): void;
        /**
         * @stability stable
         */
        get disableApiTerminationInput(): boolean | cdktf.IResolvable | undefined;
        private _ebsOptimized?;
        /**
         * @stability stable
         */
        get ebsOptimized(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set ebsOptimized(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEbsOptimized(): void;
        /**
         * @stability stable
         */
        get ebsOptimizedInput(): boolean | cdktf.IResolvable | undefined;
        private _getPasswordData?;
        /**
         * @stability stable
         */
        get fetchPasswordData(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set fetchPasswordData(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetFetchPasswordData(): void;
        /**
         * @stability stable
         */
        get fetchPasswordDataInput(): boolean | cdktf.IResolvable | undefined;
        private _hibernation?;
        /**
         * @stability stable
         */
        get hibernation(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set hibernation(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetHibernation(): void;
        /**
         * @stability stable
         */
        get hibernationInput(): boolean | cdktf.IResolvable | undefined;
        private _hostId?;
        /**
         * @stability stable
         */
        get hostId(): string | undefined;
        /**
         * @stability stable
         */
        set hostId(value: string | undefined);
        /**
         * @stability stable
         */
        resetHostId(): void;
        /**
         * @stability stable
         */
        get hostIdInput(): string | undefined;
        private _iamInstanceProfile?;
        /**
         * @stability stable
         */
        get iamInstanceProfile(): string | undefined;
        /**
         * @stability stable
         */
        set iamInstanceProfile(value: string | undefined);
        /**
         * @stability stable
         */
        resetIamInstanceProfile(): void;
        /**
         * @stability stable
         */
        get iamInstanceProfileInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceInitiatedShutdownBehavior?;
        /**
         * @stability stable
         */
        get instanceInitiatedShutdownBehavior(): string | undefined;
        /**
         * @stability stable
         */
        set instanceInitiatedShutdownBehavior(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceInitiatedShutdownBehavior(): void;
        /**
         * @stability stable
         */
        get instanceInitiatedShutdownBehaviorInput(): string | undefined;
        /**
         * @stability stable
         */
        get instanceState(): string;
        private _instanceType?;
        /**
         * @stability stable
         */
        get instanceType(): string | undefined;
        /**
         * @stability stable
         */
        set instanceType(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceType(): void;
        /**
         * @stability stable
         */
        get instanceTypeInput(): string | undefined;
        private _ipv6AddressCount?;
        /**
         * @stability stable
         */
        get ipv6AddressCount(): number | undefined;
        /**
         * @stability stable
         */
        set ipv6AddressCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetIpv6AddressCount(): void;
        /**
         * @stability stable
         */
        get ipv6AddressCountInput(): number | undefined;
        private _ipv6Addresses?;
        /**
         * @stability stable
         */
        get ipv6Addresses(): string[] | undefined;
        /**
         * @stability stable
         */
        set ipv6Addresses(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetIpv6Addresses(): void;
        /**
         * @stability stable
         */
        get ipv6AddressesInput(): string[] | undefined;
        private _keyName?;
        /**
         * @stability stable
         */
        get keyName(): string | undefined;
        /**
         * @stability stable
         */
        set keyName(value: string | undefined);
        /**
         * @stability stable
         */
        resetKeyName(): void;
        /**
         * @stability stable
         */
        get keyNameInput(): string | undefined;
        private _monitoring?;
        /**
         * @stability stable
         */
        get monitoring(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set monitoring(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetMonitoring(): void;
        /**
         * @stability stable
         */
        get monitoringInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get outpostArn(): string;
        /**
         * @stability stable
         */
        get passwordData(): string;
        private _placementGroup?;
        /**
         * @stability stable
         */
        get placementGroup(): string | undefined;
        /**
         * @stability stable
         */
        set placementGroup(value: string | undefined);
        /**
         * @stability stable
         */
        resetPlacementGroup(): void;
        /**
         * @stability stable
         */
        get placementGroupInput(): string | undefined;
        private _placementPartitionNumber?;
        /**
         * @stability stable
         */
        get placementPartitionNumber(): number | undefined;
        /**
         * @stability stable
         */
        set placementPartitionNumber(value: number | undefined);
        /**
         * @stability stable
         */
        resetPlacementPartitionNumber(): void;
        /**
         * @stability stable
         */
        get placementPartitionNumberInput(): number | undefined;
        /**
         * @stability stable
         */
        get primaryNetworkInterfaceId(): string;
        /**
         * @stability stable
         */
        get privateDns(): string;
        private _privateIp?;
        /**
         * @stability stable
         */
        get privateIp(): string | undefined;
        /**
         * @stability stable
         */
        set privateIp(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrivateIp(): void;
        /**
         * @stability stable
         */
        get privateIpInput(): string | undefined;
        /**
         * @stability stable
         */
        get publicDns(): string;
        /**
         * @stability stable
         */
        get publicIp(): string;
        private _secondaryPrivateIps?;
        /**
         * @stability stable
         */
        get secondaryPrivateIps(): string[] | undefined;
        /**
         * @stability stable
         */
        set secondaryPrivateIps(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecondaryPrivateIps(): void;
        /**
         * @stability stable
         */
        get secondaryPrivateIpsInput(): string[] | undefined;
        private _securityGroups?;
        /**
         * @stability stable
         */
        get securityGroups(): string[] | undefined;
        /**
         * @stability stable
         */
        set securityGroups(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecurityGroups(): void;
        /**
         * @stability stable
         */
        get securityGroupsInput(): string[] | undefined;
        private _sourceDestCheck?;
        /**
         * @stability stable
         */
        get sourceDestCheck(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set sourceDestCheck(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetSourceDestCheck(): void;
        /**
         * @stability stable
         */
        get sourceDestCheckInput(): boolean | cdktf.IResolvable | undefined;
        private _subnetId?;
        /**
         * @stability stable
         */
        get subnetId(): string | undefined;
        /**
         * @stability stable
         */
        set subnetId(value: string | undefined);
        /**
         * @stability stable
         */
        resetSubnetId(): void;
        /**
         * @stability stable
         */
        get subnetIdInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tenancy?;
        /**
         * @stability stable
         */
        get tenancy(): string | undefined;
        /**
         * @stability stable
         */
        set tenancy(value: string | undefined);
        /**
         * @stability stable
         */
        resetTenancy(): void;
        /**
         * @stability stable
         */
        get tenancyInput(): string | undefined;
        private _userData?;
        /**
         * @stability stable
         */
        get userData(): string | undefined;
        /**
         * @stability stable
         */
        set userData(value: string | undefined);
        /**
         * @stability stable
         */
        resetUserData(): void;
        /**
         * @stability stable
         */
        get userDataInput(): string | undefined;
        private _userDataBase64?;
        /**
         * @stability stable
         */
        get userDataBase64(): string | undefined;
        /**
         * @stability stable
         */
        set userDataBase64(value: string | undefined);
        /**
         * @stability stable
         */
        resetUserDataBase64(): void;
        /**
         * @stability stable
         */
        get userDataBase64Input(): string | undefined;
        private _volumeTags?;
        /**
         * @stability stable
         */
        get volumeTags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set volumeTags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetVolumeTags(): void;
        /**
         * @stability stable
         */
        get volumeTagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _vpcSecurityGroupIds?;
        /**
         * @stability stable
         */
        get vpcSecurityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set vpcSecurityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetVpcSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get vpcSecurityGroupIdsInput(): string[] | undefined;
        private _capacityReservationSpecification?;
        private __capacityReservationSpecificationOutput;
        /**
         * @stability stable
         */
        get capacityReservationSpecification(): InstanceCapacityReservationSpecificationOutputReference;
        /**
         * @stability stable
         */
        putCapacityReservationSpecification(value: InstanceCapacityReservationSpecification | undefined): void;
        /**
         * @stability stable
         */
        resetCapacityReservationSpecification(): void;
        /**
         * @stability stable
         */
        get capacityReservationSpecificationInput(): InstanceCapacityReservationSpecification | undefined;
        private _creditSpecification?;
        private __creditSpecificationOutput;
        /**
         * @stability stable
         */
        get creditSpecification(): InstanceCreditSpecificationOutputReference;
        /**
         * @stability stable
         */
        putCreditSpecification(value: InstanceCreditSpecification | undefined): void;
        /**
         * @stability stable
         */
        resetCreditSpecification(): void;
        /**
         * @stability stable
         */
        get creditSpecificationInput(): InstanceCreditSpecification | undefined;
        private _ebsBlockDevice?;
        /**
         * @stability stable
         */
        get ebsBlockDevice(): InstanceEbsBlockDevice[] | undefined;
        /**
         * @stability stable
         */
        set ebsBlockDevice(value: InstanceEbsBlockDevice[] | undefined);
        /**
         * @stability stable
         */
        resetEbsBlockDevice(): void;
        /**
         * @stability stable
         */
        get ebsBlockDeviceInput(): InstanceEbsBlockDevice[] | undefined;
        private _enclaveOptions?;
        private __enclaveOptionsOutput;
        /**
         * @stability stable
         */
        get enclaveOptions(): InstanceEnclaveOptionsOutputReference;
        /**
         * @stability stable
         */
        putEnclaveOptions(value: InstanceEnclaveOptions | undefined): void;
        /**
         * @stability stable
         */
        resetEnclaveOptions(): void;
        /**
         * @stability stable
         */
        get enclaveOptionsInput(): InstanceEnclaveOptions | undefined;
        private _ephemeralBlockDevice?;
        /**
         * @stability stable
         */
        get ephemeralBlockDevice(): InstanceEphemeralBlockDevice[] | undefined;
        /**
         * @stability stable
         */
        set ephemeralBlockDevice(value: InstanceEphemeralBlockDevice[] | undefined);
        /**
         * @stability stable
         */
        resetEphemeralBlockDevice(): void;
        /**
         * @stability stable
         */
        get ephemeralBlockDeviceInput(): InstanceEphemeralBlockDevice[] | undefined;
        private _launchTemplate?;
        private __launchTemplateOutput;
        /**
         * @stability stable
         */
        get launchTemplate(): InstanceLaunchTemplateOutputReference;
        /**
         * @stability stable
         */
        putLaunchTemplate(value: InstanceLaunchTemplate | undefined): void;
        /**
         * @stability stable
         */
        resetLaunchTemplate(): void;
        /**
         * @stability stable
         */
        get launchTemplateInput(): InstanceLaunchTemplate | undefined;
        private _metadataOptions?;
        private __metadataOptionsOutput;
        /**
         * @stability stable
         */
        get metadataOptions(): InstanceMetadataOptionsOutputReference;
        /**
         * @stability stable
         */
        putMetadataOptions(value: InstanceMetadataOptions | undefined): void;
        /**
         * @stability stable
         */
        resetMetadataOptions(): void;
        /**
         * @stability stable
         */
        get metadataOptionsInput(): InstanceMetadataOptions | undefined;
        private _networkInterface?;
        /**
         * @stability stable
         */
        get networkInterface(): InstanceNetworkInterface[] | undefined;
        /**
         * @stability stable
         */
        set networkInterface(value: InstanceNetworkInterface[] | undefined);
        /**
         * @stability stable
         */
        resetNetworkInterface(): void;
        /**
         * @stability stable
         */
        get networkInterfaceInput(): InstanceNetworkInterface[] | undefined;
        private _rootBlockDevice?;
        private __rootBlockDeviceOutput;
        /**
         * @stability stable
         */
        get rootBlockDevice(): InstanceRootBlockDeviceOutputReference;
        /**
         * @stability stable
         */
        putRootBlockDevice(value: InstanceRootBlockDevice | undefined): void;
        /**
         * @stability stable
         */
        resetRootBlockDevice(): void;
        /**
         * @stability stable
         */
        get rootBlockDeviceInput(): InstanceRootBlockDevice | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): InstanceTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: InstanceTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): InstanceTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface KeyPairConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/key_pair.html#key_name KeyPair#key_name}.
         *
         * @stability stable
         */
        readonly keyName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/key_pair.html#key_name_prefix KeyPair#key_name_prefix}.
         *
         * @stability stable
         */
        readonly keyNamePrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/key_pair.html#public_key KeyPair#public_key}.
         *
         * @stability stable
         */
        readonly publicKey: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/key_pair.html#tags KeyPair#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/key_pair.html#tags_all KeyPair#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/key_pair.html aws_key_pair}.
     *
     * @stability stable
     */
    class KeyPair extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/key_pair.html aws_key_pair} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: KeyPairConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get fingerprint(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _keyName?;
        /**
         * @stability stable
         */
        get keyName(): string | undefined;
        /**
         * @stability stable
         */
        set keyName(value: string | undefined);
        /**
         * @stability stable
         */
        resetKeyName(): void;
        /**
         * @stability stable
         */
        get keyNameInput(): string | undefined;
        private _keyNamePrefix?;
        /**
         * @stability stable
         */
        get keyNamePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set keyNamePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetKeyNamePrefix(): void;
        /**
         * @stability stable
         */
        get keyNamePrefixInput(): string | undefined;
        /**
         * @stability stable
         */
        get keyPairId(): string;
        private _publicKey?;
        /**
         * @stability stable
         */
        get publicKey(): string;
        /**
         * @stability stable
         */
        set publicKey(value: string);
        /**
         * @stability stable
         */
        get publicKeyInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#default_version LaunchTemplate#default_version}.
         *
         * @stability stable
         */
        readonly defaultVersion?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#description LaunchTemplate#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#disable_api_termination LaunchTemplate#disable_api_termination}.
         *
         * @stability stable
         */
        readonly disableApiTermination?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#ebs_optimized LaunchTemplate#ebs_optimized}.
         *
         * @stability stable
         */
        readonly ebsOptimized?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#image_id LaunchTemplate#image_id}.
         *
         * @stability stable
         */
        readonly imageId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#instance_initiated_shutdown_behavior LaunchTemplate#instance_initiated_shutdown_behavior}.
         *
         * @stability stable
         */
        readonly instanceInitiatedShutdownBehavior?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#instance_type LaunchTemplate#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#kernel_id LaunchTemplate#kernel_id}.
         *
         * @stability stable
         */
        readonly kernelId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#key_name LaunchTemplate#key_name}.
         *
         * @stability stable
         */
        readonly keyName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#name LaunchTemplate#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#name_prefix LaunchTemplate#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#ram_disk_id LaunchTemplate#ram_disk_id}.
         *
         * @stability stable
         */
        readonly ramDiskId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#security_group_names LaunchTemplate#security_group_names}.
         *
         * @stability stable
         */
        readonly securityGroupNames?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#tags LaunchTemplate#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#tags_all LaunchTemplate#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#update_default_version LaunchTemplate#update_default_version}.
         *
         * @stability stable
         */
        readonly updateDefaultVersion?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#user_data LaunchTemplate#user_data}.
         *
         * @stability stable
         */
        readonly userData?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#vpc_security_group_ids LaunchTemplate#vpc_security_group_ids}.
         *
         * @stability stable
         */
        readonly vpcSecurityGroupIds?: string[];
        /**
         * block_device_mappings block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#block_device_mappings LaunchTemplate#block_device_mappings}
         *
         * @stability stable
         */
        readonly blockDeviceMappings?: LaunchTemplateBlockDeviceMappings[];
        /**
         * capacity_reservation_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#capacity_reservation_specification LaunchTemplate#capacity_reservation_specification}
         *
         * @stability stable
         */
        readonly capacityReservationSpecification?: LaunchTemplateCapacityReservationSpecification;
        /**
         * cpu_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#cpu_options LaunchTemplate#cpu_options}
         *
         * @stability stable
         */
        readonly cpuOptions?: LaunchTemplateCpuOptions;
        /**
         * credit_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#credit_specification LaunchTemplate#credit_specification}
         *
         * @stability stable
         */
        readonly creditSpecification?: LaunchTemplateCreditSpecification;
        /**
         * elastic_gpu_specifications block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#elastic_gpu_specifications LaunchTemplate#elastic_gpu_specifications}
         *
         * @stability stable
         */
        readonly elasticGpuSpecifications?: LaunchTemplateElasticGpuSpecifications[];
        /**
         * elastic_inference_accelerator block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#elastic_inference_accelerator LaunchTemplate#elastic_inference_accelerator}
         *
         * @stability stable
         */
        readonly elasticInferenceAccelerator?: LaunchTemplateElasticInferenceAccelerator;
        /**
         * enclave_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#enclave_options LaunchTemplate#enclave_options}
         *
         * @stability stable
         */
        readonly enclaveOptions?: LaunchTemplateEnclaveOptions;
        /**
         * hibernation_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#hibernation_options LaunchTemplate#hibernation_options}
         *
         * @stability stable
         */
        readonly hibernationOptions?: LaunchTemplateHibernationOptions;
        /**
         * iam_instance_profile block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#iam_instance_profile LaunchTemplate#iam_instance_profile}
         *
         * @stability stable
         */
        readonly iamInstanceProfile?: LaunchTemplateIamInstanceProfile;
        /**
         * instance_market_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#instance_market_options LaunchTemplate#instance_market_options}
         *
         * @stability stable
         */
        readonly instanceMarketOptions?: LaunchTemplateInstanceMarketOptions;
        /**
         * license_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#license_specification LaunchTemplate#license_specification}
         *
         * @stability stable
         */
        readonly licenseSpecification?: LaunchTemplateLicenseSpecification[];
        /**
         * metadata_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#metadata_options LaunchTemplate#metadata_options}
         *
         * @stability stable
         */
        readonly metadataOptions?: LaunchTemplateMetadataOptions;
        /**
         * monitoring block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#monitoring LaunchTemplate#monitoring}
         *
         * @stability stable
         */
        readonly monitoring?: LaunchTemplateMonitoring;
        /**
         * network_interfaces block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#network_interfaces LaunchTemplate#network_interfaces}
         *
         * @stability stable
         */
        readonly networkInterfaces?: LaunchTemplateNetworkInterfaces[];
        /**
         * placement block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#placement LaunchTemplate#placement}
         *
         * @stability stable
         */
        readonly placement?: LaunchTemplatePlacement;
        /**
         * tag_specifications block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#tag_specifications LaunchTemplate#tag_specifications}
         *
         * @stability stable
         */
        readonly tagSpecifications?: LaunchTemplateTagSpecifications[];
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateBlockDeviceMappingsEbs {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#delete_on_termination LaunchTemplate#delete_on_termination}.
         *
         * @stability stable
         */
        readonly deleteOnTermination?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#encrypted LaunchTemplate#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#iops LaunchTemplate#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#kms_key_id LaunchTemplate#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#snapshot_id LaunchTemplate#snapshot_id}.
         *
         * @stability stable
         */
        readonly snapshotId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#throughput LaunchTemplate#throughput}.
         *
         * @stability stable
         */
        readonly throughput?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#volume_size LaunchTemplate#volume_size}.
         *
         * @stability stable
         */
        readonly volumeSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#volume_type LaunchTemplate#volume_type}.
         *
         * @stability stable
         */
        readonly volumeType?: string;
    }
    /**
     * @stability stable
     */
    class LaunchTemplateBlockDeviceMappingsEbsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _deleteOnTermination?;
        /**
         * @stability stable
         */
        get deleteOnTermination(): string | undefined;
        /**
         * @stability stable
         */
        set deleteOnTermination(value: string | undefined);
        /**
         * @stability stable
         */
        resetDeleteOnTermination(): void;
        /**
         * @stability stable
         */
        get deleteOnTerminationInput(): string | undefined;
        private _encrypted?;
        /**
         * @stability stable
         */
        get encrypted(): string | undefined;
        /**
         * @stability stable
         */
        set encrypted(value: string | undefined);
        /**
         * @stability stable
         */
        resetEncrypted(): void;
        /**
         * @stability stable
         */
        get encryptedInput(): string | undefined;
        private _iops?;
        /**
         * @stability stable
         */
        get iops(): number | undefined;
        /**
         * @stability stable
         */
        set iops(value: number | undefined);
        /**
         * @stability stable
         */
        resetIops(): void;
        /**
         * @stability stable
         */
        get iopsInput(): number | undefined;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        private _snapshotId?;
        /**
         * @stability stable
         */
        get snapshotId(): string | undefined;
        /**
         * @stability stable
         */
        set snapshotId(value: string | undefined);
        /**
         * @stability stable
         */
        resetSnapshotId(): void;
        /**
         * @stability stable
         */
        get snapshotIdInput(): string | undefined;
        private _throughput?;
        /**
         * @stability stable
         */
        get throughput(): number | undefined;
        /**
         * @stability stable
         */
        set throughput(value: number | undefined);
        /**
         * @stability stable
         */
        resetThroughput(): void;
        /**
         * @stability stable
         */
        get throughputInput(): number | undefined;
        private _volumeSize?;
        /**
         * @stability stable
         */
        get volumeSize(): number | undefined;
        /**
         * @stability stable
         */
        set volumeSize(value: number | undefined);
        /**
         * @stability stable
         */
        resetVolumeSize(): void;
        /**
         * @stability stable
         */
        get volumeSizeInput(): number | undefined;
        private _volumeType?;
        /**
         * @stability stable
         */
        get volumeType(): string | undefined;
        /**
         * @stability stable
         */
        set volumeType(value: string | undefined);
        /**
         * @stability stable
         */
        resetVolumeType(): void;
        /**
         * @stability stable
         */
        get volumeTypeInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateBlockDeviceMappings {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#device_name LaunchTemplate#device_name}.
         *
         * @stability stable
         */
        readonly deviceName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#no_device LaunchTemplate#no_device}.
         *
         * @stability stable
         */
        readonly noDevice?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#virtual_name LaunchTemplate#virtual_name}.
         *
         * @stability stable
         */
        readonly virtualName?: string;
        /**
         * ebs block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#ebs LaunchTemplate#ebs}
         *
         * @stability stable
         */
        readonly ebs?: LaunchTemplateBlockDeviceMappingsEbs;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateCapacityReservationSpecificationCapacityReservationTarget {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#capacity_reservation_id LaunchTemplate#capacity_reservation_id}.
         *
         * @stability stable
         */
        readonly capacityReservationId?: string;
    }
    /**
     * @stability stable
     */
    class LaunchTemplateCapacityReservationSpecificationCapacityReservationTargetOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _capacityReservationId?;
        /**
         * @stability stable
         */
        get capacityReservationId(): string | undefined;
        /**
         * @stability stable
         */
        set capacityReservationId(value: string | undefined);
        /**
         * @stability stable
         */
        resetCapacityReservationId(): void;
        /**
         * @stability stable
         */
        get capacityReservationIdInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateCapacityReservationSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#capacity_reservation_preference LaunchTemplate#capacity_reservation_preference}.
         *
         * @stability stable
         */
        readonly capacityReservationPreference?: string;
        /**
         * capacity_reservation_target block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#capacity_reservation_target LaunchTemplate#capacity_reservation_target}
         *
         * @stability stable
         */
        readonly capacityReservationTarget?: LaunchTemplateCapacityReservationSpecificationCapacityReservationTarget;
    }
    /**
     * @stability stable
     */
    class LaunchTemplateCapacityReservationSpecificationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _capacityReservationPreference?;
        /**
         * @stability stable
         */
        get capacityReservationPreference(): string | undefined;
        /**
         * @stability stable
         */
        set capacityReservationPreference(value: string | undefined);
        /**
         * @stability stable
         */
        resetCapacityReservationPreference(): void;
        /**
         * @stability stable
         */
        get capacityReservationPreferenceInput(): string | undefined;
        private _capacityReservationTarget?;
        private __capacityReservationTargetOutput;
        /**
         * @stability stable
         */
        get capacityReservationTarget(): LaunchTemplateCapacityReservationSpecificationCapacityReservationTargetOutputReference;
        /**
         * @stability stable
         */
        putCapacityReservationTarget(value: LaunchTemplateCapacityReservationSpecificationCapacityReservationTarget | undefined): void;
        /**
         * @stability stable
         */
        resetCapacityReservationTarget(): void;
        /**
         * @stability stable
         */
        get capacityReservationTargetInput(): LaunchTemplateCapacityReservationSpecificationCapacityReservationTarget | undefined;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateCpuOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#core_count LaunchTemplate#core_count}.
         *
         * @stability stable
         */
        readonly coreCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#threads_per_core LaunchTemplate#threads_per_core}.
         *
         * @stability stable
         */
        readonly threadsPerCore?: number;
    }
    /**
     * @stability stable
     */
    class LaunchTemplateCpuOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _coreCount?;
        /**
         * @stability stable
         */
        get coreCount(): number | undefined;
        /**
         * @stability stable
         */
        set coreCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetCoreCount(): void;
        /**
         * @stability stable
         */
        get coreCountInput(): number | undefined;
        private _threadsPerCore?;
        /**
         * @stability stable
         */
        get threadsPerCore(): number | undefined;
        /**
         * @stability stable
         */
        set threadsPerCore(value: number | undefined);
        /**
         * @stability stable
         */
        resetThreadsPerCore(): void;
        /**
         * @stability stable
         */
        get threadsPerCoreInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateCreditSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#cpu_credits LaunchTemplate#cpu_credits}.
         *
         * @stability stable
         */
        readonly cpuCredits?: string;
    }
    /**
     * @stability stable
     */
    class LaunchTemplateCreditSpecificationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _cpuCredits?;
        /**
         * @stability stable
         */
        get cpuCredits(): string | undefined;
        /**
         * @stability stable
         */
        set cpuCredits(value: string | undefined);
        /**
         * @stability stable
         */
        resetCpuCredits(): void;
        /**
         * @stability stable
         */
        get cpuCreditsInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateElasticGpuSpecifications {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#type LaunchTemplate#type}.
         *
         * @stability stable
         */
        readonly type: string;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateElasticInferenceAccelerator {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#type LaunchTemplate#type}.
         *
         * @stability stable
         */
        readonly type: string;
    }
    /**
     * @stability stable
     */
    class LaunchTemplateElasticInferenceAcceleratorOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateEnclaveOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#enabled LaunchTemplate#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class LaunchTemplateEnclaveOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateHibernationOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#configured LaunchTemplate#configured}.
         *
         * @stability stable
         */
        readonly configured: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class LaunchTemplateHibernationOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _configured?;
        /**
         * @stability stable
         */
        get configured(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set configured(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get configuredInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateIamInstanceProfile {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#arn LaunchTemplate#arn}.
         *
         * @stability stable
         */
        readonly arn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#name LaunchTemplate#name}.
         *
         * @stability stable
         */
        readonly name?: string;
    }
    /**
     * @stability stable
     */
    class LaunchTemplateIamInstanceProfileOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _arn?;
        /**
         * @stability stable
         */
        get arn(): string | undefined;
        /**
         * @stability stable
         */
        set arn(value: string | undefined);
        /**
         * @stability stable
         */
        resetArn(): void;
        /**
         * @stability stable
         */
        get arnInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateInstanceMarketOptionsSpotOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#block_duration_minutes LaunchTemplate#block_duration_minutes}.
         *
         * @stability stable
         */
        readonly blockDurationMinutes?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#instance_interruption_behavior LaunchTemplate#instance_interruption_behavior}.
         *
         * @stability stable
         */
        readonly instanceInterruptionBehavior?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#max_price LaunchTemplate#max_price}.
         *
         * @stability stable
         */
        readonly maxPrice?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#spot_instance_type LaunchTemplate#spot_instance_type}.
         *
         * @stability stable
         */
        readonly spotInstanceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#valid_until LaunchTemplate#valid_until}.
         *
         * @stability stable
         */
        readonly validUntil?: string;
    }
    /**
     * @stability stable
     */
    class LaunchTemplateInstanceMarketOptionsSpotOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _blockDurationMinutes?;
        /**
         * @stability stable
         */
        get blockDurationMinutes(): number | undefined;
        /**
         * @stability stable
         */
        set blockDurationMinutes(value: number | undefined);
        /**
         * @stability stable
         */
        resetBlockDurationMinutes(): void;
        /**
         * @stability stable
         */
        get blockDurationMinutesInput(): number | undefined;
        private _instanceInterruptionBehavior?;
        /**
         * @stability stable
         */
        get instanceInterruptionBehavior(): string | undefined;
        /**
         * @stability stable
         */
        set instanceInterruptionBehavior(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceInterruptionBehavior(): void;
        /**
         * @stability stable
         */
        get instanceInterruptionBehaviorInput(): string | undefined;
        private _maxPrice?;
        /**
         * @stability stable
         */
        get maxPrice(): string | undefined;
        /**
         * @stability stable
         */
        set maxPrice(value: string | undefined);
        /**
         * @stability stable
         */
        resetMaxPrice(): void;
        /**
         * @stability stable
         */
        get maxPriceInput(): string | undefined;
        private _spotInstanceType?;
        /**
         * @stability stable
         */
        get spotInstanceType(): string | undefined;
        /**
         * @stability stable
         */
        set spotInstanceType(value: string | undefined);
        /**
         * @stability stable
         */
        resetSpotInstanceType(): void;
        /**
         * @stability stable
         */
        get spotInstanceTypeInput(): string | undefined;
        private _validUntil?;
        /**
         * @stability stable
         */
        get validUntil(): string | undefined;
        /**
         * @stability stable
         */
        set validUntil(value: string | undefined);
        /**
         * @stability stable
         */
        resetValidUntil(): void;
        /**
         * @stability stable
         */
        get validUntilInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateInstanceMarketOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#market_type LaunchTemplate#market_type}.
         *
         * @stability stable
         */
        readonly marketType?: string;
        /**
         * spot_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#spot_options LaunchTemplate#spot_options}
         *
         * @stability stable
         */
        readonly spotOptions?: LaunchTemplateInstanceMarketOptionsSpotOptions;
    }
    /**
     * @stability stable
     */
    class LaunchTemplateInstanceMarketOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _marketType?;
        /**
         * @stability stable
         */
        get marketType(): string | undefined;
        /**
         * @stability stable
         */
        set marketType(value: string | undefined);
        /**
         * @stability stable
         */
        resetMarketType(): void;
        /**
         * @stability stable
         */
        get marketTypeInput(): string | undefined;
        private _spotOptions?;
        private __spotOptionsOutput;
        /**
         * @stability stable
         */
        get spotOptions(): LaunchTemplateInstanceMarketOptionsSpotOptionsOutputReference;
        /**
         * @stability stable
         */
        putSpotOptions(value: LaunchTemplateInstanceMarketOptionsSpotOptions | undefined): void;
        /**
         * @stability stable
         */
        resetSpotOptions(): void;
        /**
         * @stability stable
         */
        get spotOptionsInput(): LaunchTemplateInstanceMarketOptionsSpotOptions | undefined;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateLicenseSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#license_configuration_arn LaunchTemplate#license_configuration_arn}.
         *
         * @stability stable
         */
        readonly licenseConfigurationArn: string;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateMetadataOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#http_endpoint LaunchTemplate#http_endpoint}.
         *
         * @stability stable
         */
        readonly httpEndpoint?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#http_protocol_ipv6 LaunchTemplate#http_protocol_ipv6}.
         *
         * @stability stable
         */
        readonly httpProtocolIpv6?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#http_put_response_hop_limit LaunchTemplate#http_put_response_hop_limit}.
         *
         * @stability stable
         */
        readonly httpPutResponseHopLimit?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#http_tokens LaunchTemplate#http_tokens}.
         *
         * @stability stable
         */
        readonly httpTokens?: string;
    }
    /**
     * @stability stable
     */
    class LaunchTemplateMetadataOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _httpEndpoint?;
        /**
         * @stability stable
         */
        get httpEndpoint(): string | undefined;
        /**
         * @stability stable
         */
        set httpEndpoint(value: string | undefined);
        /**
         * @stability stable
         */
        resetHttpEndpoint(): void;
        /**
         * @stability stable
         */
        get httpEndpointInput(): string | undefined;
        private _httpProtocolIpv6?;
        /**
         * @stability stable
         */
        get httpProtocolIpv6(): string | undefined;
        /**
         * @stability stable
         */
        set httpProtocolIpv6(value: string | undefined);
        /**
         * @stability stable
         */
        resetHttpProtocolIpv6(): void;
        /**
         * @stability stable
         */
        get httpProtocolIpv6Input(): string | undefined;
        private _httpPutResponseHopLimit?;
        /**
         * @stability stable
         */
        get httpPutResponseHopLimit(): number | undefined;
        /**
         * @stability stable
         */
        set httpPutResponseHopLimit(value: number | undefined);
        /**
         * @stability stable
         */
        resetHttpPutResponseHopLimit(): void;
        /**
         * @stability stable
         */
        get httpPutResponseHopLimitInput(): number | undefined;
        private _httpTokens?;
        /**
         * @stability stable
         */
        get httpTokens(): string | undefined;
        /**
         * @stability stable
         */
        set httpTokens(value: string | undefined);
        /**
         * @stability stable
         */
        resetHttpTokens(): void;
        /**
         * @stability stable
         */
        get httpTokensInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateMonitoring {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#enabled LaunchTemplate#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class LaunchTemplateMonitoringOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateNetworkInterfaces {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#associate_carrier_ip_address LaunchTemplate#associate_carrier_ip_address}.
         *
         * @stability stable
         */
        readonly associateCarrierIpAddress?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#associate_public_ip_address LaunchTemplate#associate_public_ip_address}.
         *
         * @stability stable
         */
        readonly associatePublicIpAddress?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#delete_on_termination LaunchTemplate#delete_on_termination}.
         *
         * @stability stable
         */
        readonly deleteOnTermination?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#description LaunchTemplate#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#device_index LaunchTemplate#device_index}.
         *
         * @stability stable
         */
        readonly deviceIndex?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#interface_type LaunchTemplate#interface_type}.
         *
         * @stability stable
         */
        readonly interfaceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#ipv4_address_count LaunchTemplate#ipv4_address_count}.
         *
         * @stability stable
         */
        readonly ipv4AddressCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#ipv4_addresses LaunchTemplate#ipv4_addresses}.
         *
         * @stability stable
         */
        readonly ipv4Addresses?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#ipv6_address_count LaunchTemplate#ipv6_address_count}.
         *
         * @stability stable
         */
        readonly ipv6AddressCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#ipv6_addresses LaunchTemplate#ipv6_addresses}.
         *
         * @stability stable
         */
        readonly ipv6Addresses?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#network_interface_id LaunchTemplate#network_interface_id}.
         *
         * @stability stable
         */
        readonly networkInterfaceId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#private_ip_address LaunchTemplate#private_ip_address}.
         *
         * @stability stable
         */
        readonly privateIpAddress?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#security_groups LaunchTemplate#security_groups}.
         *
         * @stability stable
         */
        readonly securityGroups?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#subnet_id LaunchTemplate#subnet_id}.
         *
         * @stability stable
         */
        readonly subnetId?: string;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplatePlacement {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#affinity LaunchTemplate#affinity}.
         *
         * @stability stable
         */
        readonly affinity?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#availability_zone LaunchTemplate#availability_zone}.
         *
         * @stability stable
         */
        readonly availabilityZone?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#group_name LaunchTemplate#group_name}.
         *
         * @stability stable
         */
        readonly groupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#host_id LaunchTemplate#host_id}.
         *
         * @stability stable
         */
        readonly hostId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#host_resource_group_arn LaunchTemplate#host_resource_group_arn}.
         *
         * @stability stable
         */
        readonly hostResourceGroupArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#partition_number LaunchTemplate#partition_number}.
         *
         * @stability stable
         */
        readonly partitionNumber?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#spread_domain LaunchTemplate#spread_domain}.
         *
         * @stability stable
         */
        readonly spreadDomain?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#tenancy LaunchTemplate#tenancy}.
         *
         * @stability stable
         */
        readonly tenancy?: string;
    }
    /**
     * @stability stable
     */
    class LaunchTemplatePlacementOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _affinity?;
        /**
         * @stability stable
         */
        get affinity(): string | undefined;
        /**
         * @stability stable
         */
        set affinity(value: string | undefined);
        /**
         * @stability stable
         */
        resetAffinity(): void;
        /**
         * @stability stable
         */
        get affinityInput(): string | undefined;
        private _availabilityZone?;
        /**
         * @stability stable
         */
        get availabilityZone(): string | undefined;
        /**
         * @stability stable
         */
        set availabilityZone(value: string | undefined);
        /**
         * @stability stable
         */
        resetAvailabilityZone(): void;
        /**
         * @stability stable
         */
        get availabilityZoneInput(): string | undefined;
        private _groupName?;
        /**
         * @stability stable
         */
        get groupName(): string | undefined;
        /**
         * @stability stable
         */
        set groupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetGroupName(): void;
        /**
         * @stability stable
         */
        get groupNameInput(): string | undefined;
        private _hostId?;
        /**
         * @stability stable
         */
        get hostId(): string | undefined;
        /**
         * @stability stable
         */
        set hostId(value: string | undefined);
        /**
         * @stability stable
         */
        resetHostId(): void;
        /**
         * @stability stable
         */
        get hostIdInput(): string | undefined;
        private _hostResourceGroupArn?;
        /**
         * @stability stable
         */
        get hostResourceGroupArn(): string | undefined;
        /**
         * @stability stable
         */
        set hostResourceGroupArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetHostResourceGroupArn(): void;
        /**
         * @stability stable
         */
        get hostResourceGroupArnInput(): string | undefined;
        private _partitionNumber?;
        /**
         * @stability stable
         */
        get partitionNumber(): number | undefined;
        /**
         * @stability stable
         */
        set partitionNumber(value: number | undefined);
        /**
         * @stability stable
         */
        resetPartitionNumber(): void;
        /**
         * @stability stable
         */
        get partitionNumberInput(): number | undefined;
        private _spreadDomain?;
        /**
         * @stability stable
         */
        get spreadDomain(): string | undefined;
        /**
         * @stability stable
         */
        set spreadDomain(value: string | undefined);
        /**
         * @stability stable
         */
        resetSpreadDomain(): void;
        /**
         * @stability stable
         */
        get spreadDomainInput(): string | undefined;
        private _tenancy?;
        /**
         * @stability stable
         */
        get tenancy(): string | undefined;
        /**
         * @stability stable
         */
        set tenancy(value: string | undefined);
        /**
         * @stability stable
         */
        resetTenancy(): void;
        /**
         * @stability stable
         */
        get tenancyInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface LaunchTemplateTagSpecifications {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#resource_type LaunchTemplate#resource_type}.
         *
         * @stability stable
         */
        readonly resourceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#tags LaunchTemplate#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html aws_launch_template}.
     *
     * @stability stable
     */
    class LaunchTemplate extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html aws_launch_template} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: LaunchTemplateConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _defaultVersion?;
        /**
         * @stability stable
         */
        get defaultVersion(): number | undefined;
        /**
         * @stability stable
         */
        set defaultVersion(value: number | undefined);
        /**
         * @stability stable
         */
        resetDefaultVersion(): void;
        /**
         * @stability stable
         */
        get defaultVersionInput(): number | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _disableApiTermination?;
        /**
         * @stability stable
         */
        get disableApiTermination(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set disableApiTermination(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDisableApiTermination(): void;
        /**
         * @stability stable
         */
        get disableApiTerminationInput(): boolean | cdktf.IResolvable | undefined;
        private _ebsOptimized?;
        /**
         * @stability stable
         */
        get ebsOptimized(): string | undefined;
        /**
         * @stability stable
         */
        set ebsOptimized(value: string | undefined);
        /**
         * @stability stable
         */
        resetEbsOptimized(): void;
        /**
         * @stability stable
         */
        get ebsOptimizedInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _imageId?;
        /**
         * @stability stable
         */
        get imageId(): string | undefined;
        /**
         * @stability stable
         */
        set imageId(value: string | undefined);
        /**
         * @stability stable
         */
        resetImageId(): void;
        /**
         * @stability stable
         */
        get imageIdInput(): string | undefined;
        private _instanceInitiatedShutdownBehavior?;
        /**
         * @stability stable
         */
        get instanceInitiatedShutdownBehavior(): string | undefined;
        /**
         * @stability stable
         */
        set instanceInitiatedShutdownBehavior(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceInitiatedShutdownBehavior(): void;
        /**
         * @stability stable
         */
        get instanceInitiatedShutdownBehaviorInput(): string | undefined;
        private _instanceType?;
        /**
         * @stability stable
         */
        get instanceType(): string | undefined;
        /**
         * @stability stable
         */
        set instanceType(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceType(): void;
        /**
         * @stability stable
         */
        get instanceTypeInput(): string | undefined;
        private _kernelId?;
        /**
         * @stability stable
         */
        get kernelId(): string | undefined;
        /**
         * @stability stable
         */
        set kernelId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKernelId(): void;
        /**
         * @stability stable
         */
        get kernelIdInput(): string | undefined;
        private _keyName?;
        /**
         * @stability stable
         */
        get keyName(): string | undefined;
        /**
         * @stability stable
         */
        set keyName(value: string | undefined);
        /**
         * @stability stable
         */
        resetKeyName(): void;
        /**
         * @stability stable
         */
        get keyNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get latestVersion(): number;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string | undefined;
        /**
         * @stability stable
         */
        set namePrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetNamePrefix(): void;
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        private _ramDiskId?;
        /**
         * @stability stable
         */
        get ramDiskId(): string | undefined;
        /**
         * @stability stable
         */
        set ramDiskId(value: string | undefined);
        /**
         * @stability stable
         */
        resetRamDiskId(): void;
        /**
         * @stability stable
         */
        get ramDiskIdInput(): string | undefined;
        private _securityGroupNames?;
        /**
         * @stability stable
         */
        get securityGroupNames(): string[] | undefined;
        /**
         * @stability stable
         */
        set securityGroupNames(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecurityGroupNames(): void;
        /**
         * @stability stable
         */
        get securityGroupNamesInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _updateDefaultVersion?;
        /**
         * @stability stable
         */
        get updateDefaultVersion(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set updateDefaultVersion(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUpdateDefaultVersion(): void;
        /**
         * @stability stable
         */
        get updateDefaultVersionInput(): boolean | cdktf.IResolvable | undefined;
        private _userData?;
        /**
         * @stability stable
         */
        get userData(): string | undefined;
        /**
         * @stability stable
         */
        set userData(value: string | undefined);
        /**
         * @stability stable
         */
        resetUserData(): void;
        /**
         * @stability stable
         */
        get userDataInput(): string | undefined;
        private _vpcSecurityGroupIds?;
        /**
         * @stability stable
         */
        get vpcSecurityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set vpcSecurityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetVpcSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get vpcSecurityGroupIdsInput(): string[] | undefined;
        private _blockDeviceMappings?;
        /**
         * @stability stable
         */
        get blockDeviceMappings(): LaunchTemplateBlockDeviceMappings[] | undefined;
        /**
         * @stability stable
         */
        set blockDeviceMappings(value: LaunchTemplateBlockDeviceMappings[] | undefined);
        /**
         * @stability stable
         */
        resetBlockDeviceMappings(): void;
        /**
         * @stability stable
         */
        get blockDeviceMappingsInput(): LaunchTemplateBlockDeviceMappings[] | undefined;
        private _capacityReservationSpecification?;
        private __capacityReservationSpecificationOutput;
        /**
         * @stability stable
         */
        get capacityReservationSpecification(): LaunchTemplateCapacityReservationSpecificationOutputReference;
        /**
         * @stability stable
         */
        putCapacityReservationSpecification(value: LaunchTemplateCapacityReservationSpecification | undefined): void;
        /**
         * @stability stable
         */
        resetCapacityReservationSpecification(): void;
        /**
         * @stability stable
         */
        get capacityReservationSpecificationInput(): LaunchTemplateCapacityReservationSpecification | undefined;
        private _cpuOptions?;
        private __cpuOptionsOutput;
        /**
         * @stability stable
         */
        get cpuOptions(): LaunchTemplateCpuOptionsOutputReference;
        /**
         * @stability stable
         */
        putCpuOptions(value: LaunchTemplateCpuOptions | undefined): void;
        /**
         * @stability stable
         */
        resetCpuOptions(): void;
        /**
         * @stability stable
         */
        get cpuOptionsInput(): LaunchTemplateCpuOptions | undefined;
        private _creditSpecification?;
        private __creditSpecificationOutput;
        /**
         * @stability stable
         */
        get creditSpecification(): LaunchTemplateCreditSpecificationOutputReference;
        /**
         * @stability stable
         */
        putCreditSpecification(value: LaunchTemplateCreditSpecification | undefined): void;
        /**
         * @stability stable
         */
        resetCreditSpecification(): void;
        /**
         * @stability stable
         */
        get creditSpecificationInput(): LaunchTemplateCreditSpecification | undefined;
        private _elasticGpuSpecifications?;
        /**
         * @stability stable
         */
        get elasticGpuSpecifications(): LaunchTemplateElasticGpuSpecifications[] | undefined;
        /**
         * @stability stable
         */
        set elasticGpuSpecifications(value: LaunchTemplateElasticGpuSpecifications[] | undefined);
        /**
         * @stability stable
         */
        resetElasticGpuSpecifications(): void;
        /**
         * @stability stable
         */
        get elasticGpuSpecificationsInput(): LaunchTemplateElasticGpuSpecifications[] | undefined;
        private _elasticInferenceAccelerator?;
        private __elasticInferenceAcceleratorOutput;
        /**
         * @stability stable
         */
        get elasticInferenceAccelerator(): LaunchTemplateElasticInferenceAcceleratorOutputReference;
        /**
         * @stability stable
         */
        putElasticInferenceAccelerator(value: LaunchTemplateElasticInferenceAccelerator | undefined): void;
        /**
         * @stability stable
         */
        resetElasticInferenceAccelerator(): void;
        /**
         * @stability stable
         */
        get elasticInferenceAcceleratorInput(): LaunchTemplateElasticInferenceAccelerator | undefined;
        private _enclaveOptions?;
        private __enclaveOptionsOutput;
        /**
         * @stability stable
         */
        get enclaveOptions(): LaunchTemplateEnclaveOptionsOutputReference;
        /**
         * @stability stable
         */
        putEnclaveOptions(value: LaunchTemplateEnclaveOptions | undefined): void;
        /**
         * @stability stable
         */
        resetEnclaveOptions(): void;
        /**
         * @stability stable
         */
        get enclaveOptionsInput(): LaunchTemplateEnclaveOptions | undefined;
        private _hibernationOptions?;
        private __hibernationOptionsOutput;
        /**
         * @stability stable
         */
        get hibernationOptions(): LaunchTemplateHibernationOptionsOutputReference;
        /**
         * @stability stable
         */
        putHibernationOptions(value: LaunchTemplateHibernationOptions | undefined): void;
        /**
         * @stability stable
         */
        resetHibernationOptions(): void;
        /**
         * @stability stable
         */
        get hibernationOptionsInput(): LaunchTemplateHibernationOptions | undefined;
        private _iamInstanceProfile?;
        private __iamInstanceProfileOutput;
        /**
         * @stability stable
         */
        get iamInstanceProfile(): LaunchTemplateIamInstanceProfileOutputReference;
        /**
         * @stability stable
         */
        putIamInstanceProfile(value: LaunchTemplateIamInstanceProfile | undefined): void;
        /**
         * @stability stable
         */
        resetIamInstanceProfile(): void;
        /**
         * @stability stable
         */
        get iamInstanceProfileInput(): LaunchTemplateIamInstanceProfile | undefined;
        private _instanceMarketOptions?;
        private __instanceMarketOptionsOutput;
        /**
         * @stability stable
         */
        get instanceMarketOptions(): LaunchTemplateInstanceMarketOptionsOutputReference;
        /**
         * @stability stable
         */
        putInstanceMarketOptions(value: LaunchTemplateInstanceMarketOptions | undefined): void;
        /**
         * @stability stable
         */
        resetInstanceMarketOptions(): void;
        /**
         * @stability stable
         */
        get instanceMarketOptionsInput(): LaunchTemplateInstanceMarketOptions | undefined;
        private _licenseSpecification?;
        /**
         * @stability stable
         */
        get licenseSpecification(): LaunchTemplateLicenseSpecification[] | undefined;
        /**
         * @stability stable
         */
        set licenseSpecification(value: LaunchTemplateLicenseSpecification[] | undefined);
        /**
         * @stability stable
         */
        resetLicenseSpecification(): void;
        /**
         * @stability stable
         */
        get licenseSpecificationInput(): LaunchTemplateLicenseSpecification[] | undefined;
        private _metadataOptions?;
        private __metadataOptionsOutput;
        /**
         * @stability stable
         */
        get metadataOptions(): LaunchTemplateMetadataOptionsOutputReference;
        /**
         * @stability stable
         */
        putMetadataOptions(value: LaunchTemplateMetadataOptions | undefined): void;
        /**
         * @stability stable
         */
        resetMetadataOptions(): void;
        /**
         * @stability stable
         */
        get metadataOptionsInput(): LaunchTemplateMetadataOptions | undefined;
        private _monitoring?;
        private __monitoringOutput;
        /**
         * @stability stable
         */
        get monitoring(): LaunchTemplateMonitoringOutputReference;
        /**
         * @stability stable
         */
        putMonitoring(value: LaunchTemplateMonitoring | undefined): void;
        /**
         * @stability stable
         */
        resetMonitoring(): void;
        /**
         * @stability stable
         */
        get monitoringInput(): LaunchTemplateMonitoring | undefined;
        private _networkInterfaces?;
        /**
         * @stability stable
         */
        get networkInterfaces(): LaunchTemplateNetworkInterfaces[] | undefined;
        /**
         * @stability stable
         */
        set networkInterfaces(value: LaunchTemplateNetworkInterfaces[] | undefined);
        /**
         * @stability stable
         */
        resetNetworkInterfaces(): void;
        /**
         * @stability stable
         */
        get networkInterfacesInput(): LaunchTemplateNetworkInterfaces[] | undefined;
        private _placement?;
        private __placementOutput;
        /**
         * @stability stable
         */
        get placement(): LaunchTemplatePlacementOutputReference;
        /**
         * @stability stable
         */
        putPlacement(value: LaunchTemplatePlacement | undefined): void;
        /**
         * @stability stable
         */
        resetPlacement(): void;
        /**
         * @stability stable
         */
        get placementInput(): LaunchTemplatePlacement | undefined;
        private _tagSpecifications?;
        /**
         * @stability stable
         */
        get tagSpecifications(): LaunchTemplateTagSpecifications[] | undefined;
        /**
         * @stability stable
         */
        set tagSpecifications(value: LaunchTemplateTagSpecifications[] | undefined);
        /**
         * @stability stable
         */
        resetTagSpecifications(): void;
        /**
         * @stability stable
         */
        get tagSpecificationsInput(): LaunchTemplateTagSpecifications[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface PlacementGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/placement_group.html#name PlacementGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/placement_group.html#partition_count PlacementGroup#partition_count}.
         *
         * @stability stable
         */
        readonly partitionCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/placement_group.html#strategy PlacementGroup#strategy}.
         *
         * @stability stable
         */
        readonly strategy: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/placement_group.html#tags PlacementGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/placement_group.html#tags_all PlacementGroup#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/placement_group.html aws_placement_group}.
     *
     * @stability stable
     */
    class PlacementGroup extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/placement_group.html aws_placement_group} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: PlacementGroupConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _partitionCount?;
        /**
         * @stability stable
         */
        get partitionCount(): number | undefined;
        /**
         * @stability stable
         */
        set partitionCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetPartitionCount(): void;
        /**
         * @stability stable
         */
        get partitionCountInput(): number | undefined;
        /**
         * @stability stable
         */
        get placementGroupId(): string;
        private _strategy?;
        /**
         * @stability stable
         */
        get strategy(): string;
        /**
         * @stability stable
         */
        set strategy(value: string);
        /**
         * @stability stable
         */
        get strategyInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface SnapshotCreateVolumePermissionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/snapshot_create_volume_permission.html#account_id SnapshotCreateVolumePermission#account_id}.
         *
         * @stability stable
         */
        readonly accountId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/snapshot_create_volume_permission.html#snapshot_id SnapshotCreateVolumePermission#snapshot_id}.
         *
         * @stability stable
         */
        readonly snapshotId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/snapshot_create_volume_permission.html aws_snapshot_create_volume_permission}.
     *
     * @stability stable
     */
    class SnapshotCreateVolumePermission extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/snapshot_create_volume_permission.html aws_snapshot_create_volume_permission} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: SnapshotCreateVolumePermissionConfig);
        private _accountId?;
        /**
         * @stability stable
         */
        get accountId(): string;
        /**
         * @stability stable
         */
        set accountId(value: string);
        /**
         * @stability stable
         */
        get accountIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _snapshotId?;
        /**
         * @stability stable
         */
        get snapshotId(): string;
        /**
         * @stability stable
         */
        set snapshotId(value: string);
        /**
         * @stability stable
         */
        get snapshotIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface SpotDatafeedSubscriptionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_datafeed_subscription.html#bucket SpotDatafeedSubscription#bucket}.
         *
         * @stability stable
         */
        readonly bucket: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_datafeed_subscription.html#prefix SpotDatafeedSubscription#prefix}.
         *
         * @stability stable
         */
        readonly prefix?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/spot_datafeed_subscription.html aws_spot_datafeed_subscription}.
     *
     * @stability stable
     */
    class SpotDatafeedSubscription extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/spot_datafeed_subscription.html aws_spot_datafeed_subscription} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: SpotDatafeedSubscriptionConfig);
        private _bucket?;
        /**
         * @stability stable
         */
        get bucket(): string;
        /**
         * @stability stable
         */
        set bucket(value: string);
        /**
         * @stability stable
         */
        get bucketInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _prefix?;
        /**
         * @stability stable
         */
        get prefix(): string | undefined;
        /**
         * @stability stable
         */
        set prefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrefix(): void;
        /**
         * @stability stable
         */
        get prefixInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface SpotFleetRequestConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#allocation_strategy SpotFleetRequest#allocation_strategy}.
         *
         * @stability stable
         */
        readonly allocationStrategy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#excess_capacity_termination_policy SpotFleetRequest#excess_capacity_termination_policy}.
         *
         * @stability stable
         */
        readonly excessCapacityTerminationPolicy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#fleet_type SpotFleetRequest#fleet_type}.
         *
         * @stability stable
         */
        readonly fleetType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#iam_fleet_role SpotFleetRequest#iam_fleet_role}.
         *
         * @stability stable
         */
        readonly iamFleetRole: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#instance_interruption_behaviour SpotFleetRequest#instance_interruption_behaviour}.
         *
         * @stability stable
         */
        readonly instanceInterruptionBehaviour?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#instance_pools_to_use_count SpotFleetRequest#instance_pools_to_use_count}.
         *
         * @stability stable
         */
        readonly instancePoolsToUseCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#load_balancers SpotFleetRequest#load_balancers}.
         *
         * @stability stable
         */
        readonly loadBalancers?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#on_demand_allocation_strategy SpotFleetRequest#on_demand_allocation_strategy}.
         *
         * @stability stable
         */
        readonly onDemandAllocationStrategy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#on_demand_max_total_price SpotFleetRequest#on_demand_max_total_price}.
         *
         * @stability stable
         */
        readonly onDemandMaxTotalPrice?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#on_demand_target_capacity SpotFleetRequest#on_demand_target_capacity}.
         *
         * @stability stable
         */
        readonly onDemandTargetCapacity?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#replace_unhealthy_instances SpotFleetRequest#replace_unhealthy_instances}.
         *
         * @stability stable
         */
        readonly replaceUnhealthyInstances?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#spot_price SpotFleetRequest#spot_price}.
         *
         * @stability stable
         */
        readonly spotPrice?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#tags SpotFleetRequest#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#tags_all SpotFleetRequest#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#target_capacity SpotFleetRequest#target_capacity}.
         *
         * @stability stable
         */
        readonly targetCapacity: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#target_group_arns SpotFleetRequest#target_group_arns}.
         *
         * @stability stable
         */
        readonly targetGroupArns?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#terminate_instances_with_expiration SpotFleetRequest#terminate_instances_with_expiration}.
         *
         * @stability stable
         */
        readonly terminateInstancesWithExpiration?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#valid_from SpotFleetRequest#valid_from}.
         *
         * @stability stable
         */
        readonly validFrom?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#valid_until SpotFleetRequest#valid_until}.
         *
         * @stability stable
         */
        readonly validUntil?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#wait_for_fulfillment SpotFleetRequest#wait_for_fulfillment}.
         *
         * @stability stable
         */
        readonly waitForFulfillment?: boolean | cdktf.IResolvable;
        /**
         * launch_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#launch_specification SpotFleetRequest#launch_specification}
         *
         * @stability stable
         */
        readonly launchSpecification?: SpotFleetRequestLaunchSpecification[];
        /**
         * launch_template_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#launch_template_config SpotFleetRequest#launch_template_config}
         *
         * @stability stable
         */
        readonly launchTemplateConfig?: SpotFleetRequestLaunchTemplateConfig[];
        /**
         * spot_maintenance_strategies block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#spot_maintenance_strategies SpotFleetRequest#spot_maintenance_strategies}
         *
         * @stability stable
         */
        readonly spotMaintenanceStrategies?: SpotFleetRequestSpotMaintenanceStrategies;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#timeouts SpotFleetRequest#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: SpotFleetRequestTimeouts;
    }
    /**
     * @stability stable
     */
    interface SpotFleetRequestLaunchSpecificationEbsBlockDevice {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#delete_on_termination SpotFleetRequest#delete_on_termination}.
         *
         * @stability stable
         */
        readonly deleteOnTermination?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#device_name SpotFleetRequest#device_name}.
         *
         * @stability stable
         */
        readonly deviceName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#encrypted SpotFleetRequest#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#iops SpotFleetRequest#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#kms_key_id SpotFleetRequest#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#snapshot_id SpotFleetRequest#snapshot_id}.
         *
         * @stability stable
         */
        readonly snapshotId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#throughput SpotFleetRequest#throughput}.
         *
         * @stability stable
         */
        readonly throughput?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#volume_size SpotFleetRequest#volume_size}.
         *
         * @stability stable
         */
        readonly volumeSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#volume_type SpotFleetRequest#volume_type}.
         *
         * @stability stable
         */
        readonly volumeType?: string;
    }
    /**
     * @stability stable
     */
    interface SpotFleetRequestLaunchSpecificationEphemeralBlockDevice {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#device_name SpotFleetRequest#device_name}.
         *
         * @stability stable
         */
        readonly deviceName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#virtual_name SpotFleetRequest#virtual_name}.
         *
         * @stability stable
         */
        readonly virtualName: string;
    }
    /**
     * @stability stable
     */
    interface SpotFleetRequestLaunchSpecificationRootBlockDevice {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#delete_on_termination SpotFleetRequest#delete_on_termination}.
         *
         * @stability stable
         */
        readonly deleteOnTermination?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#encrypted SpotFleetRequest#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#iops SpotFleetRequest#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#kms_key_id SpotFleetRequest#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#throughput SpotFleetRequest#throughput}.
         *
         * @stability stable
         */
        readonly throughput?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#volume_size SpotFleetRequest#volume_size}.
         *
         * @stability stable
         */
        readonly volumeSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#volume_type SpotFleetRequest#volume_type}.
         *
         * @stability stable
         */
        readonly volumeType?: string;
    }
    /**
     * @stability stable
     */
    interface SpotFleetRequestLaunchSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#ami SpotFleetRequest#ami}.
         *
         * @stability stable
         */
        readonly ami: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#associate_public_ip_address SpotFleetRequest#associate_public_ip_address}.
         *
         * @stability stable
         */
        readonly associatePublicIpAddress?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#availability_zone SpotFleetRequest#availability_zone}.
         *
         * @stability stable
         */
        readonly availabilityZone?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#ebs_optimized SpotFleetRequest#ebs_optimized}.
         *
         * @stability stable
         */
        readonly ebsOptimized?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#iam_instance_profile SpotFleetRequest#iam_instance_profile}.
         *
         * @stability stable
         */
        readonly iamInstanceProfile?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#iam_instance_profile_arn SpotFleetRequest#iam_instance_profile_arn}.
         *
         * @stability stable
         */
        readonly iamInstanceProfileArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#instance_type SpotFleetRequest#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#key_name SpotFleetRequest#key_name}.
         *
         * @stability stable
         */
        readonly keyName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#monitoring SpotFleetRequest#monitoring}.
         *
         * @stability stable
         */
        readonly monitoring?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#placement_group SpotFleetRequest#placement_group}.
         *
         * @stability stable
         */
        readonly placementGroup?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#placement_tenancy SpotFleetRequest#placement_tenancy}.
         *
         * @stability stable
         */
        readonly placementTenancy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#spot_price SpotFleetRequest#spot_price}.
         *
         * @stability stable
         */
        readonly spotPrice?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#subnet_id SpotFleetRequest#subnet_id}.
         *
         * @stability stable
         */
        readonly subnetId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#tags SpotFleetRequest#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#user_data SpotFleetRequest#user_data}.
         *
         * @stability stable
         */
        readonly userData?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#vpc_security_group_ids SpotFleetRequest#vpc_security_group_ids}.
         *
         * @stability stable
         */
        readonly vpcSecurityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#weighted_capacity SpotFleetRequest#weighted_capacity}.
         *
         * @stability stable
         */
        readonly weightedCapacity?: string;
        /**
         * ebs_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#ebs_block_device SpotFleetRequest#ebs_block_device}
         *
         * @stability stable
         */
        readonly ebsBlockDevice?: SpotFleetRequestLaunchSpecificationEbsBlockDevice[];
        /**
         * ephemeral_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#ephemeral_block_device SpotFleetRequest#ephemeral_block_device}
         *
         * @stability stable
         */
        readonly ephemeralBlockDevice?: SpotFleetRequestLaunchSpecificationEphemeralBlockDevice[];
        /**
         * root_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#root_block_device SpotFleetRequest#root_block_device}
         *
         * @stability stable
         */
        readonly rootBlockDevice?: SpotFleetRequestLaunchSpecificationRootBlockDevice[];
    }
    /**
     * @stability stable
     */
    interface SpotFleetRequestLaunchTemplateConfigLaunchTemplateSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#id SpotFleetRequest#id}.
         *
         * @stability stable
         */
        readonly id?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#name SpotFleetRequest#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#version SpotFleetRequest#version}.
         *
         * @stability stable
         */
        readonly version?: string;
    }
    /**
     * @stability stable
     */
    class SpotFleetRequestLaunchTemplateConfigLaunchTemplateSpecificationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _id?;
        /**
         * @stability stable
         */
        get id(): string | undefined;
        /**
         * @stability stable
         */
        set id(value: string | undefined);
        /**
         * @stability stable
         */
        resetId(): void;
        /**
         * @stability stable
         */
        get idInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _version?;
        /**
         * @stability stable
         */
        get version(): string | undefined;
        /**
         * @stability stable
         */
        set version(value: string | undefined);
        /**
         * @stability stable
         */
        resetVersion(): void;
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface SpotFleetRequestLaunchTemplateConfigOverrides {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#availability_zone SpotFleetRequest#availability_zone}.
         *
         * @stability stable
         */
        readonly availabilityZone?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#instance_type SpotFleetRequest#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#priority SpotFleetRequest#priority}.
         *
         * @stability stable
         */
        readonly priority?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#spot_price SpotFleetRequest#spot_price}.
         *
         * @stability stable
         */
        readonly spotPrice?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#subnet_id SpotFleetRequest#subnet_id}.
         *
         * @stability stable
         */
        readonly subnetId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#weighted_capacity SpotFleetRequest#weighted_capacity}.
         *
         * @stability stable
         */
        readonly weightedCapacity?: number;
    }
    /**
     * @stability stable
     */
    interface SpotFleetRequestLaunchTemplateConfig {
        /**
         * launch_template_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#launch_template_specification SpotFleetRequest#launch_template_specification}
         *
         * @stability stable
         */
        readonly launchTemplateSpecification: SpotFleetRequestLaunchTemplateConfigLaunchTemplateSpecification;
        /**
         * overrides block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#overrides SpotFleetRequest#overrides}
         *
         * @stability stable
         */
        readonly overrides?: SpotFleetRequestLaunchTemplateConfigOverrides[];
    }
    /**
     * @stability stable
     */
    interface SpotFleetRequestSpotMaintenanceStrategiesCapacityRebalance {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#replacement_strategy SpotFleetRequest#replacement_strategy}.
         *
         * @stability stable
         */
        readonly replacementStrategy?: string;
    }
    /**
     * @stability stable
     */
    class SpotFleetRequestSpotMaintenanceStrategiesCapacityRebalanceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _replacementStrategy?;
        /**
         * @stability stable
         */
        get replacementStrategy(): string | undefined;
        /**
         * @stability stable
         */
        set replacementStrategy(value: string | undefined);
        /**
         * @stability stable
         */
        resetReplacementStrategy(): void;
        /**
         * @stability stable
         */
        get replacementStrategyInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface SpotFleetRequestSpotMaintenanceStrategies {
        /**
         * capacity_rebalance block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#capacity_rebalance SpotFleetRequest#capacity_rebalance}
         *
         * @stability stable
         */
        readonly capacityRebalance?: SpotFleetRequestSpotMaintenanceStrategiesCapacityRebalance;
    }
    /**
     * @stability stable
     */
    class SpotFleetRequestSpotMaintenanceStrategiesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _capacityRebalance?;
        private __capacityRebalanceOutput;
        /**
         * @stability stable
         */
        get capacityRebalance(): SpotFleetRequestSpotMaintenanceStrategiesCapacityRebalanceOutputReference;
        /**
         * @stability stable
         */
        putCapacityRebalance(value: SpotFleetRequestSpotMaintenanceStrategiesCapacityRebalance | undefined): void;
        /**
         * @stability stable
         */
        resetCapacityRebalance(): void;
        /**
         * @stability stable
         */
        get capacityRebalanceInput(): SpotFleetRequestSpotMaintenanceStrategiesCapacityRebalance | undefined;
    }
    /**
     * @stability stable
     */
    interface SpotFleetRequestTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#create SpotFleetRequest#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html#delete SpotFleetRequest#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
    }
    /**
     * @stability stable
     */
    class SpotFleetRequestTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html aws_spot_fleet_request}.
     *
     * @stability stable
     */
    class SpotFleetRequest extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/spot_fleet_request.html aws_spot_fleet_request} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: SpotFleetRequestConfig);
        private _allocationStrategy?;
        /**
         * @stability stable
         */
        get allocationStrategy(): string | undefined;
        /**
         * @stability stable
         */
        set allocationStrategy(value: string | undefined);
        /**
         * @stability stable
         */
        resetAllocationStrategy(): void;
        /**
         * @stability stable
         */
        get allocationStrategyInput(): string | undefined;
        /**
         * @stability stable
         */
        get clientToken(): string;
        private _excessCapacityTerminationPolicy?;
        /**
         * @stability stable
         */
        get excessCapacityTerminationPolicy(): string | undefined;
        /**
         * @stability stable
         */
        set excessCapacityTerminationPolicy(value: string | undefined);
        /**
         * @stability stable
         */
        resetExcessCapacityTerminationPolicy(): void;
        /**
         * @stability stable
         */
        get excessCapacityTerminationPolicyInput(): string | undefined;
        private _fleetType?;
        /**
         * @stability stable
         */
        get fleetType(): string | undefined;
        /**
         * @stability stable
         */
        set fleetType(value: string | undefined);
        /**
         * @stability stable
         */
        resetFleetType(): void;
        /**
         * @stability stable
         */
        get fleetTypeInput(): string | undefined;
        private _iamFleetRole?;
        /**
         * @stability stable
         */
        get iamFleetRole(): string;
        /**
         * @stability stable
         */
        set iamFleetRole(value: string);
        /**
         * @stability stable
         */
        get iamFleetRoleInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceInterruptionBehaviour?;
        /**
         * @stability stable
         */
        get instanceInterruptionBehaviour(): string | undefined;
        /**
         * @stability stable
         */
        set instanceInterruptionBehaviour(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceInterruptionBehaviour(): void;
        /**
         * @stability stable
         */
        get instanceInterruptionBehaviourInput(): string | undefined;
        private _instancePoolsToUseCount?;
        /**
         * @stability stable
         */
        get instancePoolsToUseCount(): number | undefined;
        /**
         * @stability stable
         */
        set instancePoolsToUseCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetInstancePoolsToUseCount(): void;
        /**
         * @stability stable
         */
        get instancePoolsToUseCountInput(): number | undefined;
        private _loadBalancers?;
        /**
         * @stability stable
         */
        get loadBalancers(): string[] | undefined;
        /**
         * @stability stable
         */
        set loadBalancers(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetLoadBalancers(): void;
        /**
         * @stability stable
         */
        get loadBalancersInput(): string[] | undefined;
        private _onDemandAllocationStrategy?;
        /**
         * @stability stable
         */
        get onDemandAllocationStrategy(): string | undefined;
        /**
         * @stability stable
         */
        set onDemandAllocationStrategy(value: string | undefined);
        /**
         * @stability stable
         */
        resetOnDemandAllocationStrategy(): void;
        /**
         * @stability stable
         */
        get onDemandAllocationStrategyInput(): string | undefined;
        private _onDemandMaxTotalPrice?;
        /**
         * @stability stable
         */
        get onDemandMaxTotalPrice(): string | undefined;
        /**
         * @stability stable
         */
        set onDemandMaxTotalPrice(value: string | undefined);
        /**
         * @stability stable
         */
        resetOnDemandMaxTotalPrice(): void;
        /**
         * @stability stable
         */
        get onDemandMaxTotalPriceInput(): string | undefined;
        private _onDemandTargetCapacity?;
        /**
         * @stability stable
         */
        get onDemandTargetCapacity(): number | undefined;
        /**
         * @stability stable
         */
        set onDemandTargetCapacity(value: number | undefined);
        /**
         * @stability stable
         */
        resetOnDemandTargetCapacity(): void;
        /**
         * @stability stable
         */
        get onDemandTargetCapacityInput(): number | undefined;
        private _replaceUnhealthyInstances?;
        /**
         * @stability stable
         */
        get replaceUnhealthyInstances(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set replaceUnhealthyInstances(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetReplaceUnhealthyInstances(): void;
        /**
         * @stability stable
         */
        get replaceUnhealthyInstancesInput(): boolean | cdktf.IResolvable | undefined;
        private _spotPrice?;
        /**
         * @stability stable
         */
        get spotPrice(): string | undefined;
        /**
         * @stability stable
         */
        set spotPrice(value: string | undefined);
        /**
         * @stability stable
         */
        resetSpotPrice(): void;
        /**
         * @stability stable
         */
        get spotPriceInput(): string | undefined;
        /**
         * @stability stable
         */
        get spotRequestState(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _targetCapacity?;
        /**
         * @stability stable
         */
        get targetCapacity(): number;
        /**
         * @stability stable
         */
        set targetCapacity(value: number);
        /**
         * @stability stable
         */
        get targetCapacityInput(): number | undefined;
        private _targetGroupArns?;
        /**
         * @stability stable
         */
        get targetGroupArns(): string[] | undefined;
        /**
         * @stability stable
         */
        set targetGroupArns(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetTargetGroupArns(): void;
        /**
         * @stability stable
         */
        get targetGroupArnsInput(): string[] | undefined;
        private _terminateInstancesWithExpiration?;
        /**
         * @stability stable
         */
        get terminateInstancesWithExpiration(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set terminateInstancesWithExpiration(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTerminateInstancesWithExpiration(): void;
        /**
         * @stability stable
         */
        get terminateInstancesWithExpirationInput(): boolean | cdktf.IResolvable | undefined;
        private _validFrom?;
        /**
         * @stability stable
         */
        get validFrom(): string | undefined;
        /**
         * @stability stable
         */
        set validFrom(value: string | undefined);
        /**
         * @stability stable
         */
        resetValidFrom(): void;
        /**
         * @stability stable
         */
        get validFromInput(): string | undefined;
        private _validUntil?;
        /**
         * @stability stable
         */
        get validUntil(): string | undefined;
        /**
         * @stability stable
         */
        set validUntil(value: string | undefined);
        /**
         * @stability stable
         */
        resetValidUntil(): void;
        /**
         * @stability stable
         */
        get validUntilInput(): string | undefined;
        private _waitForFulfillment?;
        /**
         * @stability stable
         */
        get waitForFulfillment(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set waitForFulfillment(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetWaitForFulfillment(): void;
        /**
         * @stability stable
         */
        get waitForFulfillmentInput(): boolean | cdktf.IResolvable | undefined;
        private _launchSpecification?;
        /**
         * @stability stable
         */
        get launchSpecification(): SpotFleetRequestLaunchSpecification[] | undefined;
        /**
         * @stability stable
         */
        set launchSpecification(value: SpotFleetRequestLaunchSpecification[] | undefined);
        /**
         * @stability stable
         */
        resetLaunchSpecification(): void;
        /**
         * @stability stable
         */
        get launchSpecificationInput(): SpotFleetRequestLaunchSpecification[] | undefined;
        private _launchTemplateConfig?;
        /**
         * @stability stable
         */
        get launchTemplateConfig(): SpotFleetRequestLaunchTemplateConfig[] | undefined;
        /**
         * @stability stable
         */
        set launchTemplateConfig(value: SpotFleetRequestLaunchTemplateConfig[] | undefined);
        /**
         * @stability stable
         */
        resetLaunchTemplateConfig(): void;
        /**
         * @stability stable
         */
        get launchTemplateConfigInput(): SpotFleetRequestLaunchTemplateConfig[] | undefined;
        private _spotMaintenanceStrategies?;
        private __spotMaintenanceStrategiesOutput;
        /**
         * @stability stable
         */
        get spotMaintenanceStrategies(): SpotFleetRequestSpotMaintenanceStrategiesOutputReference;
        /**
         * @stability stable
         */
        putSpotMaintenanceStrategies(value: SpotFleetRequestSpotMaintenanceStrategies | undefined): void;
        /**
         * @stability stable
         */
        resetSpotMaintenanceStrategies(): void;
        /**
         * @stability stable
         */
        get spotMaintenanceStrategiesInput(): SpotFleetRequestSpotMaintenanceStrategies | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): SpotFleetRequestTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: SpotFleetRequestTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): SpotFleetRequestTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface SpotInstanceRequestConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#ami SpotInstanceRequest#ami}.
         *
         * @stability stable
         */
        readonly ami?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#associate_public_ip_address SpotInstanceRequest#associate_public_ip_address}.
         *
         * @stability stable
         */
        readonly associatePublicIpAddress?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#availability_zone SpotInstanceRequest#availability_zone}.
         *
         * @stability stable
         */
        readonly availabilityZone?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#block_duration_minutes SpotInstanceRequest#block_duration_minutes}.
         *
         * @stability stable
         */
        readonly blockDurationMinutes?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#cpu_core_count SpotInstanceRequest#cpu_core_count}.
         *
         * @stability stable
         */
        readonly cpuCoreCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#cpu_threads_per_core SpotInstanceRequest#cpu_threads_per_core}.
         *
         * @stability stable
         */
        readonly cpuThreadsPerCore?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#disable_api_termination SpotInstanceRequest#disable_api_termination}.
         *
         * @stability stable
         */
        readonly disableApiTermination?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#ebs_optimized SpotInstanceRequest#ebs_optimized}.
         *
         * @stability stable
         */
        readonly ebsOptimized?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#get_password_data SpotInstanceRequest#get_password_data}.
         *
         * @stability stable
         */
        readonly fetchPasswordData?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#hibernation SpotInstanceRequest#hibernation}.
         *
         * @stability stable
         */
        readonly hibernation?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#host_id SpotInstanceRequest#host_id}.
         *
         * @stability stable
         */
        readonly hostId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#iam_instance_profile SpotInstanceRequest#iam_instance_profile}.
         *
         * @stability stable
         */
        readonly iamInstanceProfile?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#instance_initiated_shutdown_behavior SpotInstanceRequest#instance_initiated_shutdown_behavior}.
         *
         * @stability stable
         */
        readonly instanceInitiatedShutdownBehavior?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#instance_interruption_behavior SpotInstanceRequest#instance_interruption_behavior}.
         *
         * @stability stable
         */
        readonly instanceInterruptionBehavior?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#instance_interruption_behaviour SpotInstanceRequest#instance_interruption_behaviour}.
         *
         * @stability stable
         */
        readonly instanceInterruptionBehaviour?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#instance_type SpotInstanceRequest#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#ipv6_address_count SpotInstanceRequest#ipv6_address_count}.
         *
         * @stability stable
         */
        readonly ipv6AddressCount?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#ipv6_addresses SpotInstanceRequest#ipv6_addresses}.
         *
         * @stability stable
         */
        readonly ipv6Addresses?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#key_name SpotInstanceRequest#key_name}.
         *
         * @stability stable
         */
        readonly keyName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#launch_group SpotInstanceRequest#launch_group}.
         *
         * @stability stable
         */
        readonly launchGroup?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#monitoring SpotInstanceRequest#monitoring}.
         *
         * @stability stable
         */
        readonly monitoring?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#placement_group SpotInstanceRequest#placement_group}.
         *
         * @stability stable
         */
        readonly placementGroup?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#placement_partition_number SpotInstanceRequest#placement_partition_number}.
         *
         * @stability stable
         */
        readonly placementPartitionNumber?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#private_ip SpotInstanceRequest#private_ip}.
         *
         * @stability stable
         */
        readonly privateIp?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#secondary_private_ips SpotInstanceRequest#secondary_private_ips}.
         *
         * @stability stable
         */
        readonly secondaryPrivateIps?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#security_groups SpotInstanceRequest#security_groups}.
         *
         * @stability stable
         */
        readonly securityGroups?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#source_dest_check SpotInstanceRequest#source_dest_check}.
         *
         * @stability stable
         */
        readonly sourceDestCheck?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#spot_price SpotInstanceRequest#spot_price}.
         *
         * @stability stable
         */
        readonly spotPrice?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#spot_type SpotInstanceRequest#spot_type}.
         *
         * @stability stable
         */
        readonly spotType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#subnet_id SpotInstanceRequest#subnet_id}.
         *
         * @stability stable
         */
        readonly subnetId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#tags SpotInstanceRequest#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#tags_all SpotInstanceRequest#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#tenancy SpotInstanceRequest#tenancy}.
         *
         * @stability stable
         */
        readonly tenancy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#user_data SpotInstanceRequest#user_data}.
         *
         * @stability stable
         */
        readonly userData?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#user_data_base64 SpotInstanceRequest#user_data_base64}.
         *
         * @stability stable
         */
        readonly userDataBase64?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#valid_from SpotInstanceRequest#valid_from}.
         *
         * @stability stable
         */
        readonly validFrom?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#valid_until SpotInstanceRequest#valid_until}.
         *
         * @stability stable
         */
        readonly validUntil?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#volume_tags SpotInstanceRequest#volume_tags}.
         *
         * @stability stable
         */
        readonly volumeTags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#vpc_security_group_ids SpotInstanceRequest#vpc_security_group_ids}.
         *
         * @stability stable
         */
        readonly vpcSecurityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#wait_for_fulfillment SpotInstanceRequest#wait_for_fulfillment}.
         *
         * @stability stable
         */
        readonly waitForFulfillment?: boolean | cdktf.IResolvable;
        /**
         * capacity_reservation_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#capacity_reservation_specification SpotInstanceRequest#capacity_reservation_specification}
         *
         * @stability stable
         */
        readonly capacityReservationSpecification?: SpotInstanceRequestCapacityReservationSpecification;
        /**
         * credit_specification block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#credit_specification SpotInstanceRequest#credit_specification}
         *
         * @stability stable
         */
        readonly creditSpecification?: SpotInstanceRequestCreditSpecification;
        /**
         * ebs_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#ebs_block_device SpotInstanceRequest#ebs_block_device}
         *
         * @stability stable
         */
        readonly ebsBlockDevice?: SpotInstanceRequestEbsBlockDevice[];
        /**
         * enclave_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#enclave_options SpotInstanceRequest#enclave_options}
         *
         * @stability stable
         */
        readonly enclaveOptions?: SpotInstanceRequestEnclaveOptions;
        /**
         * ephemeral_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#ephemeral_block_device SpotInstanceRequest#ephemeral_block_device}
         *
         * @stability stable
         */
        readonly ephemeralBlockDevice?: SpotInstanceRequestEphemeralBlockDevice[];
        /**
         * launch_template block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#launch_template SpotInstanceRequest#launch_template}
         *
         * @stability stable
         */
        readonly launchTemplate?: SpotInstanceRequestLaunchTemplate;
        /**
         * metadata_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#metadata_options SpotInstanceRequest#metadata_options}
         *
         * @stability stable
         */
        readonly metadataOptions?: SpotInstanceRequestMetadataOptions;
        /**
         * network_interface block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#network_interface SpotInstanceRequest#network_interface}
         *
         * @stability stable
         */
        readonly networkInterface?: SpotInstanceRequestNetworkInterface[];
        /**
         * root_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#root_block_device SpotInstanceRequest#root_block_device}
         *
         * @stability stable
         */
        readonly rootBlockDevice?: SpotInstanceRequestRootBlockDevice;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#timeouts SpotInstanceRequest#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: SpotInstanceRequestTimeouts;
    }
    /**
     * @stability stable
     */
    interface SpotInstanceRequestCapacityReservationSpecificationCapacityReservationTarget {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#capacity_reservation_id SpotInstanceRequest#capacity_reservation_id}.
         *
         * @stability stable
         */
        readonly capacityReservationId?: string;
    }
    /**
     * @stability stable
     */
    class SpotInstanceRequestCapacityReservationSpecificationCapacityReservationTargetOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _capacityReservationId?;
        /**
         * @stability stable
         */
        get capacityReservationId(): string | undefined;
        /**
         * @stability stable
         */
        set capacityReservationId(value: string | undefined);
        /**
         * @stability stable
         */
        resetCapacityReservationId(): void;
        /**
         * @stability stable
         */
        get capacityReservationIdInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface SpotInstanceRequestCapacityReservationSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#capacity_reservation_preference SpotInstanceRequest#capacity_reservation_preference}.
         *
         * @stability stable
         */
        readonly capacityReservationPreference?: string;
        /**
         * capacity_reservation_target block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#capacity_reservation_target SpotInstanceRequest#capacity_reservation_target}
         *
         * @stability stable
         */
        readonly capacityReservationTarget?: SpotInstanceRequestCapacityReservationSpecificationCapacityReservationTarget;
    }
    /**
     * @stability stable
     */
    class SpotInstanceRequestCapacityReservationSpecificationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _capacityReservationPreference?;
        /**
         * @stability stable
         */
        get capacityReservationPreference(): string | undefined;
        /**
         * @stability stable
         */
        set capacityReservationPreference(value: string | undefined);
        /**
         * @stability stable
         */
        resetCapacityReservationPreference(): void;
        /**
         * @stability stable
         */
        get capacityReservationPreferenceInput(): string | undefined;
        private _capacityReservationTarget?;
        private __capacityReservationTargetOutput;
        /**
         * @stability stable
         */
        get capacityReservationTarget(): SpotInstanceRequestCapacityReservationSpecificationCapacityReservationTargetOutputReference;
        /**
         * @stability stable
         */
        putCapacityReservationTarget(value: SpotInstanceRequestCapacityReservationSpecificationCapacityReservationTarget | undefined): void;
        /**
         * @stability stable
         */
        resetCapacityReservationTarget(): void;
        /**
         * @stability stable
         */
        get capacityReservationTargetInput(): SpotInstanceRequestCapacityReservationSpecificationCapacityReservationTarget | undefined;
    }
    /**
     * @stability stable
     */
    interface SpotInstanceRequestCreditSpecification {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#cpu_credits SpotInstanceRequest#cpu_credits}.
         *
         * @stability stable
         */
        readonly cpuCredits?: string;
    }
    /**
     * @stability stable
     */
    class SpotInstanceRequestCreditSpecificationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _cpuCredits?;
        /**
         * @stability stable
         */
        get cpuCredits(): string | undefined;
        /**
         * @stability stable
         */
        set cpuCredits(value: string | undefined);
        /**
         * @stability stable
         */
        resetCpuCredits(): void;
        /**
         * @stability stable
         */
        get cpuCreditsInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface SpotInstanceRequestEbsBlockDevice {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#delete_on_termination SpotInstanceRequest#delete_on_termination}.
         *
         * @stability stable
         */
        readonly deleteOnTermination?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#device_name SpotInstanceRequest#device_name}.
         *
         * @stability stable
         */
        readonly deviceName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#encrypted SpotInstanceRequest#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#iops SpotInstanceRequest#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#kms_key_id SpotInstanceRequest#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#snapshot_id SpotInstanceRequest#snapshot_id}.
         *
         * @stability stable
         */
        readonly snapshotId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#tags SpotInstanceRequest#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#throughput SpotInstanceRequest#throughput}.
         *
         * @stability stable
         */
        readonly throughput?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#volume_size SpotInstanceRequest#volume_size}.
         *
         * @stability stable
         */
        readonly volumeSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#volume_type SpotInstanceRequest#volume_type}.
         *
         * @stability stable
         */
        readonly volumeType?: string;
    }
    /**
     * @stability stable
     */
    interface SpotInstanceRequestEnclaveOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#enabled SpotInstanceRequest#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class SpotInstanceRequestEnclaveOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * @stability stable
     */
    interface SpotInstanceRequestEphemeralBlockDevice {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#device_name SpotInstanceRequest#device_name}.
         *
         * @stability stable
         */
        readonly deviceName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#no_device SpotInstanceRequest#no_device}.
         *
         * @stability stable
         */
        readonly noDevice?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#virtual_name SpotInstanceRequest#virtual_name}.
         *
         * @stability stable
         */
        readonly virtualName?: string;
    }
    /**
     * @stability stable
     */
    interface SpotInstanceRequestLaunchTemplate {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#id SpotInstanceRequest#id}.
         *
         * @stability stable
         */
        readonly id?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#name SpotInstanceRequest#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#version SpotInstanceRequest#version}.
         *
         * @stability stable
         */
        readonly version?: string;
    }
    /**
     * @stability stable
     */
    class SpotInstanceRequestLaunchTemplateOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _version?;
        /**
         * @stability stable
         */
        get version(): string | undefined;
        /**
         * @stability stable
         */
        set version(value: string | undefined);
        /**
         * @stability stable
         */
        resetVersion(): void;
        /**
         * @stability stable
         */
        get versionInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface SpotInstanceRequestMetadataOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#http_endpoint SpotInstanceRequest#http_endpoint}.
         *
         * @stability stable
         */
        readonly httpEndpoint?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#http_put_response_hop_limit SpotInstanceRequest#http_put_response_hop_limit}.
         *
         * @stability stable
         */
        readonly httpPutResponseHopLimit?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#http_tokens SpotInstanceRequest#http_tokens}.
         *
         * @stability stable
         */
        readonly httpTokens?: string;
    }
    /**
     * @stability stable
     */
    class SpotInstanceRequestMetadataOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _httpEndpoint?;
        /**
         * @stability stable
         */
        get httpEndpoint(): string | undefined;
        /**
         * @stability stable
         */
        set httpEndpoint(value: string | undefined);
        /**
         * @stability stable
         */
        resetHttpEndpoint(): void;
        /**
         * @stability stable
         */
        get httpEndpointInput(): string | undefined;
        private _httpPutResponseHopLimit?;
        /**
         * @stability stable
         */
        get httpPutResponseHopLimit(): number | undefined;
        /**
         * @stability stable
         */
        set httpPutResponseHopLimit(value: number | undefined);
        /**
         * @stability stable
         */
        resetHttpPutResponseHopLimit(): void;
        /**
         * @stability stable
         */
        get httpPutResponseHopLimitInput(): number | undefined;
        private _httpTokens?;
        /**
         * @stability stable
         */
        get httpTokens(): string | undefined;
        /**
         * @stability stable
         */
        set httpTokens(value: string | undefined);
        /**
         * @stability stable
         */
        resetHttpTokens(): void;
        /**
         * @stability stable
         */
        get httpTokensInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface SpotInstanceRequestNetworkInterface {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#delete_on_termination SpotInstanceRequest#delete_on_termination}.
         *
         * @stability stable
         */
        readonly deleteOnTermination?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#device_index SpotInstanceRequest#device_index}.
         *
         * @stability stable
         */
        readonly deviceIndex: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#network_interface_id SpotInstanceRequest#network_interface_id}.
         *
         * @stability stable
         */
        readonly networkInterfaceId: string;
    }
    /**
     * @stability stable
     */
    interface SpotInstanceRequestRootBlockDevice {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#delete_on_termination SpotInstanceRequest#delete_on_termination}.
         *
         * @stability stable
         */
        readonly deleteOnTermination?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#encrypted SpotInstanceRequest#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#iops SpotInstanceRequest#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#kms_key_id SpotInstanceRequest#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#tags SpotInstanceRequest#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#throughput SpotInstanceRequest#throughput}.
         *
         * @stability stable
         */
        readonly throughput?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#volume_size SpotInstanceRequest#volume_size}.
         *
         * @stability stable
         */
        readonly volumeSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#volume_type SpotInstanceRequest#volume_type}.
         *
         * @stability stable
         */
        readonly volumeType?: string;
    }
    /**
     * @stability stable
     */
    class SpotInstanceRequestRootBlockDeviceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _deleteOnTermination?;
        /**
         * @stability stable
         */
        get deleteOnTermination(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set deleteOnTermination(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDeleteOnTermination(): void;
        /**
         * @stability stable
         */
        get deleteOnTerminationInput(): boolean | cdktf.IResolvable | undefined;
        private _encrypted?;
        /**
         * @stability stable
         */
        get encrypted(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set encrypted(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEncrypted(): void;
        /**
         * @stability stable
         */
        get encryptedInput(): boolean | cdktf.IResolvable | undefined;
        private _iops?;
        /**
         * @stability stable
         */
        get iops(): number | undefined;
        /**
         * @stability stable
         */
        set iops(value: number | undefined);
        /**
         * @stability stable
         */
        resetIops(): void;
        /**
         * @stability stable
         */
        get iopsInput(): number | undefined;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _throughput?;
        /**
         * @stability stable
         */
        get throughput(): number | undefined;
        /**
         * @stability stable
         */
        set throughput(value: number | undefined);
        /**
         * @stability stable
         */
        resetThroughput(): void;
        /**
         * @stability stable
         */
        get throughputInput(): number | undefined;
        private _volumeSize?;
        /**
         * @stability stable
         */
        get volumeSize(): number | undefined;
        /**
         * @stability stable
         */
        set volumeSize(value: number | undefined);
        /**
         * @stability stable
         */
        resetVolumeSize(): void;
        /**
         * @stability stable
         */
        get volumeSizeInput(): number | undefined;
        private _volumeType?;
        /**
         * @stability stable
         */
        get volumeType(): string | undefined;
        /**
         * @stability stable
         */
        set volumeType(value: string | undefined);
        /**
         * @stability stable
         */
        resetVolumeType(): void;
        /**
         * @stability stable
         */
        get volumeTypeInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface SpotInstanceRequestTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#create SpotInstanceRequest#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#delete SpotInstanceRequest#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
    }
    /**
     * @stability stable
     */
    class SpotInstanceRequestTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html aws_spot_instance_request}.
     *
     * @stability stable
     */
    class SpotInstanceRequest extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html aws_spot_instance_request} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: SpotInstanceRequestConfig);
        private _ami?;
        /**
         * @stability stable
         */
        get ami(): string | undefined;
        /**
         * @stability stable
         */
        set ami(value: string | undefined);
        /**
         * @stability stable
         */
        resetAmi(): void;
        /**
         * @stability stable
         */
        get amiInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _associatePublicIpAddress?;
        /**
         * @stability stable
         */
        get associatePublicIpAddress(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set associatePublicIpAddress(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAssociatePublicIpAddress(): void;
        /**
         * @stability stable
         */
        get associatePublicIpAddressInput(): boolean | cdktf.IResolvable | undefined;
        private _availabilityZone?;
        /**
         * @stability stable
         */
        get availabilityZone(): string | undefined;
        /**
         * @stability stable
         */
        set availabilityZone(value: string | undefined);
        /**
         * @stability stable
         */
        resetAvailabilityZone(): void;
        /**
         * @stability stable
         */
        get availabilityZoneInput(): string | undefined;
        private _blockDurationMinutes?;
        /**
         * @stability stable
         */
        get blockDurationMinutes(): number | undefined;
        /**
         * @stability stable
         */
        set blockDurationMinutes(value: number | undefined);
        /**
         * @stability stable
         */
        resetBlockDurationMinutes(): void;
        /**
         * @stability stable
         */
        get blockDurationMinutesInput(): number | undefined;
        private _cpuCoreCount?;
        /**
         * @stability stable
         */
        get cpuCoreCount(): number | undefined;
        /**
         * @stability stable
         */
        set cpuCoreCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetCpuCoreCount(): void;
        /**
         * @stability stable
         */
        get cpuCoreCountInput(): number | undefined;
        private _cpuThreadsPerCore?;
        /**
         * @stability stable
         */
        get cpuThreadsPerCore(): number | undefined;
        /**
         * @stability stable
         */
        set cpuThreadsPerCore(value: number | undefined);
        /**
         * @stability stable
         */
        resetCpuThreadsPerCore(): void;
        /**
         * @stability stable
         */
        get cpuThreadsPerCoreInput(): number | undefined;
        private _disableApiTermination?;
        /**
         * @stability stable
         */
        get disableApiTermination(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set disableApiTermination(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDisableApiTermination(): void;
        /**
         * @stability stable
         */
        get disableApiTerminationInput(): boolean | cdktf.IResolvable | undefined;
        private _ebsOptimized?;
        /**
         * @stability stable
         */
        get ebsOptimized(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set ebsOptimized(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEbsOptimized(): void;
        /**
         * @stability stable
         */
        get ebsOptimizedInput(): boolean | cdktf.IResolvable | undefined;
        private _getPasswordData?;
        /**
         * @stability stable
         */
        get fetchPasswordData(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set fetchPasswordData(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetFetchPasswordData(): void;
        /**
         * @stability stable
         */
        get fetchPasswordDataInput(): boolean | cdktf.IResolvable | undefined;
        private _hibernation?;
        /**
         * @stability stable
         */
        get hibernation(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set hibernation(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetHibernation(): void;
        /**
         * @stability stable
         */
        get hibernationInput(): boolean | cdktf.IResolvable | undefined;
        private _hostId?;
        /**
         * @stability stable
         */
        get hostId(): string | undefined;
        /**
         * @stability stable
         */
        set hostId(value: string | undefined);
        /**
         * @stability stable
         */
        resetHostId(): void;
        /**
         * @stability stable
         */
        get hostIdInput(): string | undefined;
        private _iamInstanceProfile?;
        /**
         * @stability stable
         */
        get iamInstanceProfile(): string | undefined;
        /**
         * @stability stable
         */
        set iamInstanceProfile(value: string | undefined);
        /**
         * @stability stable
         */
        resetIamInstanceProfile(): void;
        /**
         * @stability stable
         */
        get iamInstanceProfileInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceInitiatedShutdownBehavior?;
        /**
         * @stability stable
         */
        get instanceInitiatedShutdownBehavior(): string | undefined;
        /**
         * @stability stable
         */
        set instanceInitiatedShutdownBehavior(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceInitiatedShutdownBehavior(): void;
        /**
         * @stability stable
         */
        get instanceInitiatedShutdownBehaviorInput(): string | undefined;
        private _instanceInterruptionBehavior?;
        /**
         * @stability stable
         */
        get instanceInterruptionBehavior(): string | undefined;
        /**
         * @stability stable
         */
        set instanceInterruptionBehavior(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceInterruptionBehavior(): void;
        /**
         * @stability stable
         */
        get instanceInterruptionBehaviorInput(): string | undefined;
        private _instanceInterruptionBehaviour?;
        /**
         * @stability stable
         */
        get instanceInterruptionBehaviour(): string | undefined;
        /**
         * @stability stable
         */
        set instanceInterruptionBehaviour(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceInterruptionBehaviour(): void;
        /**
         * @stability stable
         */
        get instanceInterruptionBehaviourInput(): string | undefined;
        /**
         * @stability stable
         */
        get instanceState(): string;
        private _instanceType?;
        /**
         * @stability stable
         */
        get instanceType(): string | undefined;
        /**
         * @stability stable
         */
        set instanceType(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceType(): void;
        /**
         * @stability stable
         */
        get instanceTypeInput(): string | undefined;
        private _ipv6AddressCount?;
        /**
         * @stability stable
         */
        get ipv6AddressCount(): number | undefined;
        /**
         * @stability stable
         */
        set ipv6AddressCount(value: number | undefined);
        /**
         * @stability stable
         */
        resetIpv6AddressCount(): void;
        /**
         * @stability stable
         */
        get ipv6AddressCountInput(): number | undefined;
        private _ipv6Addresses?;
        /**
         * @stability stable
         */
        get ipv6Addresses(): string[] | undefined;
        /**
         * @stability stable
         */
        set ipv6Addresses(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetIpv6Addresses(): void;
        /**
         * @stability stable
         */
        get ipv6AddressesInput(): string[] | undefined;
        private _keyName?;
        /**
         * @stability stable
         */
        get keyName(): string | undefined;
        /**
         * @stability stable
         */
        set keyName(value: string | undefined);
        /**
         * @stability stable
         */
        resetKeyName(): void;
        /**
         * @stability stable
         */
        get keyNameInput(): string | undefined;
        private _launchGroup?;
        /**
         * @stability stable
         */
        get launchGroup(): string | undefined;
        /**
         * @stability stable
         */
        set launchGroup(value: string | undefined);
        /**
         * @stability stable
         */
        resetLaunchGroup(): void;
        /**
         * @stability stable
         */
        get launchGroupInput(): string | undefined;
        private _monitoring?;
        /**
         * @stability stable
         */
        get monitoring(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set monitoring(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetMonitoring(): void;
        /**
         * @stability stable
         */
        get monitoringInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get outpostArn(): string;
        /**
         * @stability stable
         */
        get passwordData(): string;
        private _placementGroup?;
        /**
         * @stability stable
         */
        get placementGroup(): string | undefined;
        /**
         * @stability stable
         */
        set placementGroup(value: string | undefined);
        /**
         * @stability stable
         */
        resetPlacementGroup(): void;
        /**
         * @stability stable
         */
        get placementGroupInput(): string | undefined;
        private _placementPartitionNumber?;
        /**
         * @stability stable
         */
        get placementPartitionNumber(): number | undefined;
        /**
         * @stability stable
         */
        set placementPartitionNumber(value: number | undefined);
        /**
         * @stability stable
         */
        resetPlacementPartitionNumber(): void;
        /**
         * @stability stable
         */
        get placementPartitionNumberInput(): number | undefined;
        /**
         * @stability stable
         */
        get primaryNetworkInterfaceId(): string;
        /**
         * @stability stable
         */
        get privateDns(): string;
        private _privateIp?;
        /**
         * @stability stable
         */
        get privateIp(): string | undefined;
        /**
         * @stability stable
         */
        set privateIp(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrivateIp(): void;
        /**
         * @stability stable
         */
        get privateIpInput(): string | undefined;
        /**
         * @stability stable
         */
        get publicDns(): string;
        /**
         * @stability stable
         */
        get publicIp(): string;
        private _secondaryPrivateIps?;
        /**
         * @stability stable
         */
        get secondaryPrivateIps(): string[] | undefined;
        /**
         * @stability stable
         */
        set secondaryPrivateIps(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecondaryPrivateIps(): void;
        /**
         * @stability stable
         */
        get secondaryPrivateIpsInput(): string[] | undefined;
        private _securityGroups?;
        /**
         * @stability stable
         */
        get securityGroups(): string[] | undefined;
        /**
         * @stability stable
         */
        set securityGroups(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecurityGroups(): void;
        /**
         * @stability stable
         */
        get securityGroupsInput(): string[] | undefined;
        private _sourceDestCheck?;
        /**
         * @stability stable
         */
        get sourceDestCheck(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set sourceDestCheck(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetSourceDestCheck(): void;
        /**
         * @stability stable
         */
        get sourceDestCheckInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get spotBidStatus(): string;
        /**
         * @stability stable
         */
        get spotInstanceId(): string;
        private _spotPrice?;
        /**
         * @stability stable
         */
        get spotPrice(): string | undefined;
        /**
         * @stability stable
         */
        set spotPrice(value: string | undefined);
        /**
         * @stability stable
         */
        resetSpotPrice(): void;
        /**
         * @stability stable
         */
        get spotPriceInput(): string | undefined;
        /**
         * @stability stable
         */
        get spotRequestState(): string;
        private _spotType?;
        /**
         * @stability stable
         */
        get spotType(): string | undefined;
        /**
         * @stability stable
         */
        set spotType(value: string | undefined);
        /**
         * @stability stable
         */
        resetSpotType(): void;
        /**
         * @stability stable
         */
        get spotTypeInput(): string | undefined;
        private _subnetId?;
        /**
         * @stability stable
         */
        get subnetId(): string | undefined;
        /**
         * @stability stable
         */
        set subnetId(value: string | undefined);
        /**
         * @stability stable
         */
        resetSubnetId(): void;
        /**
         * @stability stable
         */
        get subnetIdInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tenancy?;
        /**
         * @stability stable
         */
        get tenancy(): string | undefined;
        /**
         * @stability stable
         */
        set tenancy(value: string | undefined);
        /**
         * @stability stable
         */
        resetTenancy(): void;
        /**
         * @stability stable
         */
        get tenancyInput(): string | undefined;
        private _userData?;
        /**
         * @stability stable
         */
        get userData(): string | undefined;
        /**
         * @stability stable
         */
        set userData(value: string | undefined);
        /**
         * @stability stable
         */
        resetUserData(): void;
        /**
         * @stability stable
         */
        get userDataInput(): string | undefined;
        private _userDataBase64?;
        /**
         * @stability stable
         */
        get userDataBase64(): string | undefined;
        /**
         * @stability stable
         */
        set userDataBase64(value: string | undefined);
        /**
         * @stability stable
         */
        resetUserDataBase64(): void;
        /**
         * @stability stable
         */
        get userDataBase64Input(): string | undefined;
        private _validFrom?;
        /**
         * @stability stable
         */
        get validFrom(): string | undefined;
        /**
         * @stability stable
         */
        set validFrom(value: string | undefined);
        /**
         * @stability stable
         */
        resetValidFrom(): void;
        /**
         * @stability stable
         */
        get validFromInput(): string | undefined;
        private _validUntil?;
        /**
         * @stability stable
         */
        get validUntil(): string | undefined;
        /**
         * @stability stable
         */
        set validUntil(value: string | undefined);
        /**
         * @stability stable
         */
        resetValidUntil(): void;
        /**
         * @stability stable
         */
        get validUntilInput(): string | undefined;
        private _volumeTags?;
        /**
         * @stability stable
         */
        get volumeTags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set volumeTags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetVolumeTags(): void;
        /**
         * @stability stable
         */
        get volumeTagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _vpcSecurityGroupIds?;
        /**
         * @stability stable
         */
        get vpcSecurityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set vpcSecurityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetVpcSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get vpcSecurityGroupIdsInput(): string[] | undefined;
        private _waitForFulfillment?;
        /**
         * @stability stable
         */
        get waitForFulfillment(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set waitForFulfillment(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetWaitForFulfillment(): void;
        /**
         * @stability stable
         */
        get waitForFulfillmentInput(): boolean | cdktf.IResolvable | undefined;
        private _capacityReservationSpecification?;
        private __capacityReservationSpecificationOutput;
        /**
         * @stability stable
         */
        get capacityReservationSpecification(): SpotInstanceRequestCapacityReservationSpecificationOutputReference;
        /**
         * @stability stable
         */
        putCapacityReservationSpecification(value: SpotInstanceRequestCapacityReservationSpecification | undefined): void;
        /**
         * @stability stable
         */
        resetCapacityReservationSpecification(): void;
        /**
         * @stability stable
         */
        get capacityReservationSpecificationInput(): SpotInstanceRequestCapacityReservationSpecification | undefined;
        private _creditSpecification?;
        private __creditSpecificationOutput;
        /**
         * @stability stable
         */
        get creditSpecification(): SpotInstanceRequestCreditSpecificationOutputReference;
        /**
         * @stability stable
         */
        putCreditSpecification(value: SpotInstanceRequestCreditSpecification | undefined): void;
        /**
         * @stability stable
         */
        resetCreditSpecification(): void;
        /**
         * @stability stable
         */
        get creditSpecificationInput(): SpotInstanceRequestCreditSpecification | undefined;
        private _ebsBlockDevice?;
        /**
         * @stability stable
         */
        get ebsBlockDevice(): SpotInstanceRequestEbsBlockDevice[] | undefined;
        /**
         * @stability stable
         */
        set ebsBlockDevice(value: SpotInstanceRequestEbsBlockDevice[] | undefined);
        /**
         * @stability stable
         */
        resetEbsBlockDevice(): void;
        /**
         * @stability stable
         */
        get ebsBlockDeviceInput(): SpotInstanceRequestEbsBlockDevice[] | undefined;
        private _enclaveOptions?;
        private __enclaveOptionsOutput;
        /**
         * @stability stable
         */
        get enclaveOptions(): SpotInstanceRequestEnclaveOptionsOutputReference;
        /**
         * @stability stable
         */
        putEnclaveOptions(value: SpotInstanceRequestEnclaveOptions | undefined): void;
        /**
         * @stability stable
         */
        resetEnclaveOptions(): void;
        /**
         * @stability stable
         */
        get enclaveOptionsInput(): SpotInstanceRequestEnclaveOptions | undefined;
        private _ephemeralBlockDevice?;
        /**
         * @stability stable
         */
        get ephemeralBlockDevice(): SpotInstanceRequestEphemeralBlockDevice[] | undefined;
        /**
         * @stability stable
         */
        set ephemeralBlockDevice(value: SpotInstanceRequestEphemeralBlockDevice[] | undefined);
        /**
         * @stability stable
         */
        resetEphemeralBlockDevice(): void;
        /**
         * @stability stable
         */
        get ephemeralBlockDeviceInput(): SpotInstanceRequestEphemeralBlockDevice[] | undefined;
        private _launchTemplate?;
        private __launchTemplateOutput;
        /**
         * @stability stable
         */
        get launchTemplate(): SpotInstanceRequestLaunchTemplateOutputReference;
        /**
         * @stability stable
         */
        putLaunchTemplate(value: SpotInstanceRequestLaunchTemplate | undefined): void;
        /**
         * @stability stable
         */
        resetLaunchTemplate(): void;
        /**
         * @stability stable
         */
        get launchTemplateInput(): SpotInstanceRequestLaunchTemplate | undefined;
        private _metadataOptions?;
        private __metadataOptionsOutput;
        /**
         * @stability stable
         */
        get metadataOptions(): SpotInstanceRequestMetadataOptionsOutputReference;
        /**
         * @stability stable
         */
        putMetadataOptions(value: SpotInstanceRequestMetadataOptions | undefined): void;
        /**
         * @stability stable
         */
        resetMetadataOptions(): void;
        /**
         * @stability stable
         */
        get metadataOptionsInput(): SpotInstanceRequestMetadataOptions | undefined;
        private _networkInterface?;
        /**
         * @stability stable
         */
        get networkInterface(): SpotInstanceRequestNetworkInterface[] | undefined;
        /**
         * @stability stable
         */
        set networkInterface(value: SpotInstanceRequestNetworkInterface[] | undefined);
        /**
         * @stability stable
         */
        resetNetworkInterface(): void;
        /**
         * @stability stable
         */
        get networkInterfaceInput(): SpotInstanceRequestNetworkInterface[] | undefined;
        private _rootBlockDevice?;
        private __rootBlockDeviceOutput;
        /**
         * @stability stable
         */
        get rootBlockDevice(): SpotInstanceRequestRootBlockDeviceOutputReference;
        /**
         * @stability stable
         */
        putRootBlockDevice(value: SpotInstanceRequestRootBlockDevice | undefined): void;
        /**
         * @stability stable
         */
        resetRootBlockDevice(): void;
        /**
         * @stability stable
         */
        get rootBlockDeviceInput(): SpotInstanceRequestRootBlockDevice | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): SpotInstanceRequestTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: SpotInstanceRequestTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): SpotInstanceRequestTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface VolumeAttachmentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/volume_attachment.html#device_name VolumeAttachment#device_name}.
         *
         * @stability stable
         */
        readonly deviceName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/volume_attachment.html#force_detach VolumeAttachment#force_detach}.
         *
         * @stability stable
         */
        readonly forceDetach?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/volume_attachment.html#instance_id VolumeAttachment#instance_id}.
         *
         * @stability stable
         */
        readonly instanceId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/volume_attachment.html#skip_destroy VolumeAttachment#skip_destroy}.
         *
         * @stability stable
         */
        readonly skipDestroy?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/volume_attachment.html#stop_instance_before_detaching VolumeAttachment#stop_instance_before_detaching}.
         *
         * @stability stable
         */
        readonly stopInstanceBeforeDetaching?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/volume_attachment.html#volume_id VolumeAttachment#volume_id}.
         *
         * @stability stable
         */
        readonly volumeId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/volume_attachment.html aws_volume_attachment}.
     *
     * @stability stable
     */
    class VolumeAttachment extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/volume_attachment.html aws_volume_attachment} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: VolumeAttachmentConfig);
        private _deviceName?;
        /**
         * @stability stable
         */
        get deviceName(): string;
        /**
         * @stability stable
         */
        set deviceName(value: string);
        /**
         * @stability stable
         */
        get deviceNameInput(): string | undefined;
        private _forceDetach?;
        /**
         * @stability stable
         */
        get forceDetach(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set forceDetach(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetForceDetach(): void;
        /**
         * @stability stable
         */
        get forceDetachInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceId?;
        /**
         * @stability stable
         */
        get instanceId(): string;
        /**
         * @stability stable
         */
        set instanceId(value: string);
        /**
         * @stability stable
         */
        get instanceIdInput(): string | undefined;
        private _skipDestroy?;
        /**
         * @stability stable
         */
        get skipDestroy(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set skipDestroy(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetSkipDestroy(): void;
        /**
         * @stability stable
         */
        get skipDestroyInput(): boolean | cdktf.IResolvable | undefined;
        private _stopInstanceBeforeDetaching?;
        /**
         * @stability stable
         */
        get stopInstanceBeforeDetaching(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set stopInstanceBeforeDetaching(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetStopInstanceBeforeDetaching(): void;
        /**
         * @stability stable
         */
        get stopInstanceBeforeDetachingInput(): boolean | cdktf.IResolvable | undefined;
        private _volumeId?;
        /**
         * @stability stable
         */
        get volumeId(): string;
        /**
         * @stability stable
         */
        set volumeId(value: string);
        /**
         * @stability stable
         */
        get volumeIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsAmiConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami.html#executable_users DataAwsAmi#executable_users}.
         *
         * @stability stable
         */
        readonly executableUsers?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami.html#most_recent DataAwsAmi#most_recent}.
         *
         * @stability stable
         */
        readonly mostRecent?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami.html#name_regex DataAwsAmi#name_regex}.
         *
         * @stability stable
         */
        readonly nameRegex?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami.html#owners DataAwsAmi#owners}.
         *
         * @stability stable
         */
        readonly owners: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami.html#tags DataAwsAmi#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami.html#filter DataAwsAmi#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsAmiFilter[];
    }
    /**
     * @stability stable
     */
    class DataAwsAmiBlockDeviceMappings extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get deviceName(): string;
        /**
         * @stability stable
         */
        get ebs(): any;
        /**
         * @stability stable
         */
        get noDevice(): string;
        /**
         * @stability stable
         */
        get virtualName(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsAmiProductCodes extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get productCodeId(): string;
        /**
         * @stability stable
         */
        get productCodeType(): string;
    }
    /**
     * @stability stable
     */
    interface DataAwsAmiFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami.html#name DataAwsAmi#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami.html#values DataAwsAmi#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ami.html aws_ami}.
     *
     * @stability stable
     */
    class DataAwsAmi extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ami.html aws_ami} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsAmiConfig);
        /**
         * @stability stable
         */
        get architecture(): string;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        blockDeviceMappings(index: string): DataAwsAmiBlockDeviceMappings;
        /**
         * @stability stable
         */
        get creationDate(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get enaSupport(): any;
        private _executableUsers?;
        /**
         * @stability stable
         */
        get executableUsers(): string[] | undefined;
        /**
         * @stability stable
         */
        set executableUsers(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetExecutableUsers(): void;
        /**
         * @stability stable
         */
        get executableUsersInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get hypervisor(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get imageId(): string;
        /**
         * @stability stable
         */
        get imageLocation(): string;
        /**
         * @stability stable
         */
        get imageOwnerAlias(): string;
        /**
         * @stability stable
         */
        get imageType(): string;
        /**
         * @stability stable
         */
        get kernelId(): string;
        private _mostRecent?;
        /**
         * @stability stable
         */
        get mostRecent(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set mostRecent(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetMostRecent(): void;
        /**
         * @stability stable
         */
        get mostRecentInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get name(): string;
        private _nameRegex?;
        /**
         * @stability stable
         */
        get nameRegex(): string | undefined;
        /**
         * @stability stable
         */
        set nameRegex(value: string | undefined);
        /**
         * @stability stable
         */
        resetNameRegex(): void;
        /**
         * @stability stable
         */
        get nameRegexInput(): string | undefined;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _owners?;
        /**
         * @stability stable
         */
        get owners(): string[];
        /**
         * @stability stable
         */
        set owners(value: string[]);
        /**
         * @stability stable
         */
        get ownersInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get platform(): string;
        /**
         * @stability stable
         */
        get platformDetails(): string;
        /**
         * @stability stable
         */
        productCodes(index: string): DataAwsAmiProductCodes;
        /**
         * @stability stable
         */
        get public(): any;
        /**
         * @stability stable
         */
        get ramdiskId(): string;
        /**
         * @stability stable
         */
        get rootDeviceName(): string;
        /**
         * @stability stable
         */
        get rootDeviceType(): string;
        /**
         * @stability stable
         */
        get rootSnapshotId(): string;
        /**
         * @stability stable
         */
        get sriovNetSupport(): string;
        /**
         * @stability stable
         */
        get state(): string;
        /**
         * @stability stable
         */
        stateReason(key: string): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get usageOperation(): string;
        /**
         * @stability stable
         */
        get virtualizationType(): string;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsAmiFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsAmiFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsAmiFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsAmiIdsConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami_ids.html#executable_users DataAwsAmiIds#executable_users}.
         *
         * @stability stable
         */
        readonly executableUsers?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami_ids.html#name_regex DataAwsAmiIds#name_regex}.
         *
         * @stability stable
         */
        readonly nameRegex?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami_ids.html#owners DataAwsAmiIds#owners}.
         *
         * @stability stable
         */
        readonly owners: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami_ids.html#sort_ascending DataAwsAmiIds#sort_ascending}.
         *
         * @stability stable
         */
        readonly sortAscending?: boolean | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami_ids.html#filter DataAwsAmiIds#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsAmiIdsFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsAmiIdsFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami_ids.html#name DataAwsAmiIds#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami_ids.html#values DataAwsAmiIds#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ami_ids.html aws_ami_ids}.
     *
     * @stability stable
     */
    class DataAwsAmiIds extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ami_ids.html aws_ami_ids} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsAmiIdsConfig);
        private _executableUsers?;
        /**
         * @stability stable
         */
        get executableUsers(): string[] | undefined;
        /**
         * @stability stable
         */
        set executableUsers(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetExecutableUsers(): void;
        /**
         * @stability stable
         */
        get executableUsersInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ids(): string[];
        private _nameRegex?;
        /**
         * @stability stable
         */
        get nameRegex(): string | undefined;
        /**
         * @stability stable
         */
        set nameRegex(value: string | undefined);
        /**
         * @stability stable
         */
        resetNameRegex(): void;
        /**
         * @stability stable
         */
        get nameRegexInput(): string | undefined;
        private _owners?;
        /**
         * @stability stable
         */
        get owners(): string[];
        /**
         * @stability stable
         */
        set owners(value: string[]);
        /**
         * @stability stable
         */
        get ownersInput(): string[] | undefined;
        private _sortAscending?;
        /**
         * @stability stable
         */
        get sortAscending(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set sortAscending(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetSortAscending(): void;
        /**
         * @stability stable
         */
        get sortAscendingInput(): boolean | cdktf.IResolvable | undefined;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsAmiIdsFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsAmiIdsFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsAmiIdsFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEbsDefaultKmsKeyConfig extends cdktf.TerraformMetaArguments {
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ebs_default_kms_key.html aws_ebs_default_kms_key}.
     *
     * @stability stable
     */
    class DataAwsEbsDefaultKmsKey extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ebs_default_kms_key.html aws_ebs_default_kms_key} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEbsDefaultKmsKeyConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get keyArn(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEbsEncryptionByDefaultConfig extends cdktf.TerraformMetaArguments {
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ebs_encryption_by_default.html aws_ebs_encryption_by_default}.
     *
     * @stability stable
     */
    class DataAwsEbsEncryptionByDefault extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ebs_encryption_by_default.html aws_ebs_encryption_by_default} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEbsEncryptionByDefaultConfig);
        /**
         * @stability stable
         */
        get enabled(): any;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEbsSnapshotConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot.html#most_recent DataAwsEbsSnapshot#most_recent}.
         *
         * @stability stable
         */
        readonly mostRecent?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot.html#owners DataAwsEbsSnapshot#owners}.
         *
         * @stability stable
         */
        readonly owners?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot.html#restorable_by_user_ids DataAwsEbsSnapshot#restorable_by_user_ids}.
         *
         * @stability stable
         */
        readonly restorableByUserIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot.html#snapshot_ids DataAwsEbsSnapshot#snapshot_ids}.
         *
         * @stability stable
         */
        readonly snapshotIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot.html#tags DataAwsEbsSnapshot#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot.html#filter DataAwsEbsSnapshot#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEbsSnapshotFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEbsSnapshotFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot.html#name DataAwsEbsSnapshot#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot.html#values DataAwsEbsSnapshot#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot.html aws_ebs_snapshot}.
     *
     * @stability stable
     */
    class DataAwsEbsSnapshot extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot.html aws_ebs_snapshot} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEbsSnapshotConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get dataEncryptionKeyId(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get encrypted(): any;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get kmsKeyId(): string;
        private _mostRecent?;
        /**
         * @stability stable
         */
        get mostRecent(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set mostRecent(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetMostRecent(): void;
        /**
         * @stability stable
         */
        get mostRecentInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get ownerAlias(): string;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _owners?;
        /**
         * @stability stable
         */
        get owners(): string[] | undefined;
        /**
         * @stability stable
         */
        set owners(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetOwners(): void;
        /**
         * @stability stable
         */
        get ownersInput(): string[] | undefined;
        private _restorableByUserIds?;
        /**
         * @stability stable
         */
        get restorableByUserIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set restorableByUserIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetRestorableByUserIds(): void;
        /**
         * @stability stable
         */
        get restorableByUserIdsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get snapshotId(): string;
        private _snapshotIds?;
        /**
         * @stability stable
         */
        get snapshotIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set snapshotIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSnapshotIds(): void;
        /**
         * @stability stable
         */
        get snapshotIdsInput(): string[] | undefined;
        /**
         * @stability stable
         */
        get state(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get volumeId(): string;
        /**
         * @stability stable
         */
        get volumeSize(): number;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEbsSnapshotFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEbsSnapshotFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEbsSnapshotFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEbsSnapshotIdsConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot_ids.html#owners DataAwsEbsSnapshotIds#owners}.
         *
         * @stability stable
         */
        readonly owners?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot_ids.html#restorable_by_user_ids DataAwsEbsSnapshotIds#restorable_by_user_ids}.
         *
         * @stability stable
         */
        readonly restorableByUserIds?: string[];
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot_ids.html#filter DataAwsEbsSnapshotIds#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEbsSnapshotIdsFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEbsSnapshotIdsFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot_ids.html#name DataAwsEbsSnapshotIds#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot_ids.html#values DataAwsEbsSnapshotIds#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot_ids.html aws_ebs_snapshot_ids}.
     *
     * @stability stable
     */
    class DataAwsEbsSnapshotIds extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot_ids.html aws_ebs_snapshot_ids} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEbsSnapshotIdsConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ids(): string[];
        private _owners?;
        /**
         * @stability stable
         */
        get owners(): string[] | undefined;
        /**
         * @stability stable
         */
        set owners(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetOwners(): void;
        /**
         * @stability stable
         */
        get ownersInput(): string[] | undefined;
        private _restorableByUserIds?;
        /**
         * @stability stable
         */
        get restorableByUserIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set restorableByUserIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetRestorableByUserIds(): void;
        /**
         * @stability stable
         */
        get restorableByUserIdsInput(): string[] | undefined;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEbsSnapshotIdsFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEbsSnapshotIdsFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEbsSnapshotIdsFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEbsVolumeConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_volume.html#most_recent DataAwsEbsVolume#most_recent}.
         *
         * @stability stable
         */
        readonly mostRecent?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_volume.html#tags DataAwsEbsVolume#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_volume.html#filter DataAwsEbsVolume#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEbsVolumeFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEbsVolumeFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_volume.html#name DataAwsEbsVolume#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_volume.html#values DataAwsEbsVolume#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ebs_volume.html aws_ebs_volume}.
     *
     * @stability stable
     */
    class DataAwsEbsVolume extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ebs_volume.html aws_ebs_volume} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEbsVolumeConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get availabilityZone(): string;
        /**
         * @stability stable
         */
        get encrypted(): any;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get iops(): number;
        /**
         * @stability stable
         */
        get kmsKeyId(): string;
        private _mostRecent?;
        /**
         * @stability stable
         */
        get mostRecent(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set mostRecent(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetMostRecent(): void;
        /**
         * @stability stable
         */
        get mostRecentInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get multiAttachEnabled(): any;
        /**
         * @stability stable
         */
        get outpostArn(): string;
        /**
         * @stability stable
         */
        get size(): number;
        /**
         * @stability stable
         */
        get snapshotId(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get throughput(): number;
        /**
         * @stability stable
         */
        get volumeId(): string;
        /**
         * @stability stable
         */
        get volumeType(): string;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEbsVolumeFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEbsVolumeFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEbsVolumeFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEbsVolumesConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_volumes.html#tags DataAwsEbsVolumes#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_volumes.html#filter DataAwsEbsVolumes#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEbsVolumesFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEbsVolumesFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_volumes.html#name DataAwsEbsVolumes#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_volumes.html#values DataAwsEbsVolumes#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ebs_volumes.html aws_ebs_volumes}.
     *
     * @stability stable
     */
    class DataAwsEbsVolumes extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ebs_volumes.html aws_ebs_volumes} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEbsVolumesConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ids(): string[];
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEbsVolumesFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEbsVolumesFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEbsVolumesFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2CoipPoolConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_coip_pool.html#local_gateway_route_table_id DataAwsEc2CoipPool#local_gateway_route_table_id}.
         *
         * @stability stable
         */
        readonly localGatewayRouteTableId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_coip_pool.html#pool_id DataAwsEc2CoipPool#pool_id}.
         *
         * @stability stable
         */
        readonly poolId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_coip_pool.html#tags DataAwsEc2CoipPool#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_coip_pool.html#filter DataAwsEc2CoipPool#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2CoipPoolFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2CoipPoolFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_coip_pool.html#name DataAwsEc2CoipPool#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_coip_pool.html#values DataAwsEc2CoipPool#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_coip_pool.html aws_ec2_coip_pool}.
     *
     * @stability stable
     */
    class DataAwsEc2CoipPool extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_coip_pool.html aws_ec2_coip_pool} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2CoipPoolConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _localGatewayRouteTableId?;
        /**
         * @stability stable
         */
        get localGatewayRouteTableId(): string | undefined;
        /**
         * @stability stable
         */
        set localGatewayRouteTableId(value: string | undefined);
        /**
         * @stability stable
         */
        resetLocalGatewayRouteTableId(): void;
        /**
         * @stability stable
         */
        get localGatewayRouteTableIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get poolCidrs(): string[];
        private _poolId?;
        /**
         * @stability stable
         */
        get poolId(): string | undefined;
        /**
         * @stability stable
         */
        set poolId(value: string | undefined);
        /**
         * @stability stable
         */
        resetPoolId(): void;
        /**
         * @stability stable
         */
        get poolIdInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2CoipPoolFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2CoipPoolFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2CoipPoolFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2CoipPoolsConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_coip_pools.html#tags DataAwsEc2CoipPools#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_coip_pools.html#filter DataAwsEc2CoipPools#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2CoipPoolsFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2CoipPoolsFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_coip_pools.html#name DataAwsEc2CoipPools#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_coip_pools.html#values DataAwsEc2CoipPools#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_coip_pools.html aws_ec2_coip_pools}.
     *
     * @stability stable
     */
    class DataAwsEc2CoipPools extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_coip_pools.html aws_ec2_coip_pools} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2CoipPoolsConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get poolIds(): string[];
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2CoipPoolsFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2CoipPoolsFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2CoipPoolsFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2HostConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_host.html#host_id DataAwsEc2Host#host_id}.
         *
         * @stability stable
         */
        readonly hostId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_host.html#tags DataAwsEc2Host#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_host.html#filter DataAwsEc2Host#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2HostFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2HostFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_host.html#name DataAwsEc2Host#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_host.html#values DataAwsEc2Host#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_host.html aws_ec2_host}.
     *
     * @stability stable
     */
    class DataAwsEc2Host extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_host.html aws_ec2_host} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2HostConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get autoPlacement(): string;
        /**
         * @stability stable
         */
        get availabilityZone(): string;
        /**
         * @stability stable
         */
        get cores(): number;
        private _hostId?;
        /**
         * @stability stable
         */
        get hostId(): string | undefined;
        /**
         * @stability stable
         */
        set hostId(value: string | undefined);
        /**
         * @stability stable
         */
        resetHostId(): void;
        /**
         * @stability stable
         */
        get hostIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get hostRecovery(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get instanceFamily(): string;
        /**
         * @stability stable
         */
        get instanceType(): string;
        /**
         * @stability stable
         */
        get ownerId(): string;
        /**
         * @stability stable
         */
        get sockets(): number;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get totalVcpus(): number;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2HostFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2HostFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2HostFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2InstanceTypeConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type.html#default_cores DataAwsEc2InstanceType#default_cores}.
         *
         * @stability stable
         */
        readonly defaultCores?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type.html#default_threads_per_core DataAwsEc2InstanceType#default_threads_per_core}.
         *
         * @stability stable
         */
        readonly defaultThreadsPerCore?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type.html#hypervisor DataAwsEc2InstanceType#hypervisor}.
         *
         * @stability stable
         */
        readonly hypervisor?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type.html#instance_type DataAwsEc2InstanceType#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type.html#maximum_ipv6_addresses_per_interface DataAwsEc2InstanceType#maximum_ipv6_addresses_per_interface}.
         *
         * @stability stable
         */
        readonly maximumIpv6AddressesPerInterface?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type.html#total_fpga_memory DataAwsEc2InstanceType#total_fpga_memory}.
         *
         * @stability stable
         */
        readonly totalFpgaMemory?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type.html#total_gpu_memory DataAwsEc2InstanceType#total_gpu_memory}.
         *
         * @stability stable
         */
        readonly totalGpuMemory?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type.html#total_instance_storage DataAwsEc2InstanceType#total_instance_storage}.
         *
         * @stability stable
         */
        readonly totalInstanceStorage?: number;
        /**
         * fpgas block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type.html#fpgas DataAwsEc2InstanceType#fpgas}
         *
         * @stability stable
         */
        readonly fpgas?: DataAwsEc2InstanceTypeFpgas[];
        /**
         * gpus block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type.html#gpus DataAwsEc2InstanceType#gpus}
         *
         * @stability stable
         */
        readonly gpus?: DataAwsEc2InstanceTypeGpus[];
        /**
         * inference_accelerators block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type.html#inference_accelerators DataAwsEc2InstanceType#inference_accelerators}
         *
         * @stability stable
         */
        readonly inferenceAccelerators?: DataAwsEc2InstanceTypeInferenceAccelerators[];
        /**
         * instance_disks block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type.html#instance_disks DataAwsEc2InstanceType#instance_disks}
         *
         * @stability stable
         */
        readonly instanceDisks?: DataAwsEc2InstanceTypeInstanceDisks[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2InstanceTypeFpgas {
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2InstanceTypeGpus {
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2InstanceTypeInferenceAccelerators {
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2InstanceTypeInstanceDisks {
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type.html aws_ec2_instance_type}.
     *
     * @stability stable
     */
    class DataAwsEc2InstanceType extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type.html aws_ec2_instance_type} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsEc2InstanceTypeConfig);
        /**
         * @stability stable
         */
        get autoRecoverySupported(): any;
        /**
         * @stability stable
         */
        get bareMetal(): any;
        /**
         * @stability stable
         */
        get burstablePerformanceSupported(): any;
        /**
         * @stability stable
         */
        get currentGeneration(): any;
        /**
         * @stability stable
         */
        get dedicatedHostsSupported(): any;
        private _defaultCores?;
        /**
         * @stability stable
         */
        get defaultCores(): number | undefined;
        /**
         * @stability stable
         */
        set defaultCores(value: number | undefined);
        /**
         * @stability stable
         */
        resetDefaultCores(): void;
        /**
         * @stability stable
         */
        get defaultCoresInput(): number | undefined;
        private _defaultThreadsPerCore?;
        /**
         * @stability stable
         */
        get defaultThreadsPerCore(): number | undefined;
        /**
         * @stability stable
         */
        set defaultThreadsPerCore(value: number | undefined);
        /**
         * @stability stable
         */
        resetDefaultThreadsPerCore(): void;
        /**
         * @stability stable
         */
        get defaultThreadsPerCoreInput(): number | undefined;
        /**
         * @stability stable
         */
        get defaultVcpus(): number;
        /**
         * @stability stable
         */
        get ebsEncryptionSupport(): string;
        /**
         * @stability stable
         */
        get ebsNvmeSupport(): string;
        /**
         * @stability stable
         */
        get ebsOptimizedSupport(): string;
        /**
         * @stability stable
         */
        get ebsPerformanceBaselineBandwidth(): number;
        /**
         * @stability stable
         */
        get ebsPerformanceBaselineIops(): number;
        /**
         * @stability stable
         */
        get ebsPerformanceBaselineThroughput(): number;
        /**
         * @stability stable
         */
        get ebsPerformanceMaximumBandwidth(): number;
        /**
         * @stability stable
         */
        get ebsPerformanceMaximumIops(): number;
        /**
         * @stability stable
         */
        get ebsPerformanceMaximumThroughput(): number;
        /**
         * @stability stable
         */
        get efaSupported(): any;
        /**
         * @stability stable
         */
        get enaSupport(): string;
        /**
         * @stability stable
         */
        get freeTierEligible(): any;
        /**
         * @stability stable
         */
        get hibernationSupported(): any;
        private _hypervisor?;
        /**
         * @stability stable
         */
        get hypervisor(): string | undefined;
        /**
         * @stability stable
         */
        set hypervisor(value: string | undefined);
        /**
         * @stability stable
         */
        resetHypervisor(): void;
        /**
         * @stability stable
         */
        get hypervisorInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get instanceStorageSupported(): any;
        private _instanceType?;
        /**
         * @stability stable
         */
        get instanceType(): string;
        /**
         * @stability stable
         */
        set instanceType(value: string);
        /**
         * @stability stable
         */
        get instanceTypeInput(): string | undefined;
        /**
         * @stability stable
         */
        get ipv6Supported(): any;
        /**
         * @stability stable
         */
        get maximumIpv4AddressesPerInterface(): number;
        private _maximumIpv6AddressesPerInterface?;
        /**
         * @stability stable
         */
        get maximumIpv6AddressesPerInterface(): number | undefined;
        /**
         * @stability stable
         */
        set maximumIpv6AddressesPerInterface(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaximumIpv6AddressesPerInterface(): void;
        /**
         * @stability stable
         */
        get maximumIpv6AddressesPerInterfaceInput(): number | undefined;
        /**
         * @stability stable
         */
        get maximumNetworkInterfaces(): number;
        /**
         * @stability stable
         */
        get memorySize(): number;
        /**
         * @stability stable
         */
        get networkPerformance(): string;
        /**
         * @stability stable
         */
        get supportedArchitectures(): string[];
        /**
         * @stability stable
         */
        get supportedPlacementStrategies(): string[];
        /**
         * @stability stable
         */
        get supportedRootDeviceTypes(): string[];
        /**
         * @stability stable
         */
        get supportedUsagesClasses(): string[];
        /**
         * @stability stable
         */
        get supportedVirtualizationTypes(): string[];
        /**
         * @stability stable
         */
        get sustainedClockSpeed(): number;
        private _totalFpgaMemory?;
        /**
         * @stability stable
         */
        get totalFpgaMemory(): number | undefined;
        /**
         * @stability stable
         */
        set totalFpgaMemory(value: number | undefined);
        /**
         * @stability stable
         */
        resetTotalFpgaMemory(): void;
        /**
         * @stability stable
         */
        get totalFpgaMemoryInput(): number | undefined;
        private _totalGpuMemory?;
        /**
         * @stability stable
         */
        get totalGpuMemory(): number | undefined;
        /**
         * @stability stable
         */
        set totalGpuMemory(value: number | undefined);
        /**
         * @stability stable
         */
        resetTotalGpuMemory(): void;
        /**
         * @stability stable
         */
        get totalGpuMemoryInput(): number | undefined;
        private _totalInstanceStorage?;
        /**
         * @stability stable
         */
        get totalInstanceStorage(): number | undefined;
        /**
         * @stability stable
         */
        set totalInstanceStorage(value: number | undefined);
        /**
         * @stability stable
         */
        resetTotalInstanceStorage(): void;
        /**
         * @stability stable
         */
        get totalInstanceStorageInput(): number | undefined;
        /**
         * @stability stable
         */
        get validCores(): any;
        /**
         * @stability stable
         */
        get validThreadsPerCore(): any;
        private _fpgas?;
        /**
         * @stability stable
         */
        get fpgas(): DataAwsEc2InstanceTypeFpgas[] | undefined;
        /**
         * @stability stable
         */
        set fpgas(value: DataAwsEc2InstanceTypeFpgas[] | undefined);
        /**
         * @stability stable
         */
        resetFpgas(): void;
        /**
         * @stability stable
         */
        get fpgasInput(): DataAwsEc2InstanceTypeFpgas[] | undefined;
        private _gpus?;
        /**
         * @stability stable
         */
        get gpus(): DataAwsEc2InstanceTypeGpus[] | undefined;
        /**
         * @stability stable
         */
        set gpus(value: DataAwsEc2InstanceTypeGpus[] | undefined);
        /**
         * @stability stable
         */
        resetGpus(): void;
        /**
         * @stability stable
         */
        get gpusInput(): DataAwsEc2InstanceTypeGpus[] | undefined;
        private _inferenceAccelerators?;
        /**
         * @stability stable
         */
        get inferenceAccelerators(): DataAwsEc2InstanceTypeInferenceAccelerators[] | undefined;
        /**
         * @stability stable
         */
        set inferenceAccelerators(value: DataAwsEc2InstanceTypeInferenceAccelerators[] | undefined);
        /**
         * @stability stable
         */
        resetInferenceAccelerators(): void;
        /**
         * @stability stable
         */
        get inferenceAcceleratorsInput(): DataAwsEc2InstanceTypeInferenceAccelerators[] | undefined;
        private _instanceDisks?;
        /**
         * @stability stable
         */
        get instanceDisks(): DataAwsEc2InstanceTypeInstanceDisks[] | undefined;
        /**
         * @stability stable
         */
        set instanceDisks(value: DataAwsEc2InstanceTypeInstanceDisks[] | undefined);
        /**
         * @stability stable
         */
        resetInstanceDisks(): void;
        /**
         * @stability stable
         */
        get instanceDisksInput(): DataAwsEc2InstanceTypeInstanceDisks[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2InstanceTypeOfferingConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offering.html#location_type DataAwsEc2InstanceTypeOffering#location_type}.
         *
         * @stability stable
         */
        readonly locationType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offering.html#preferred_instance_types DataAwsEc2InstanceTypeOffering#preferred_instance_types}.
         *
         * @stability stable
         */
        readonly preferredInstanceTypes?: string[];
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offering.html#filter DataAwsEc2InstanceTypeOffering#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2InstanceTypeOfferingFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2InstanceTypeOfferingFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offering.html#name DataAwsEc2InstanceTypeOffering#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offering.html#values DataAwsEc2InstanceTypeOffering#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offering.html aws_ec2_instance_type_offering}.
     *
     * @stability stable
     */
    class DataAwsEc2InstanceTypeOffering extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offering.html aws_ec2_instance_type_offering} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2InstanceTypeOfferingConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get instanceType(): string;
        private _locationType?;
        /**
         * @stability stable
         */
        get locationType(): string | undefined;
        /**
         * @stability stable
         */
        set locationType(value: string | undefined);
        /**
         * @stability stable
         */
        resetLocationType(): void;
        /**
         * @stability stable
         */
        get locationTypeInput(): string | undefined;
        private _preferredInstanceTypes?;
        /**
         * @stability stable
         */
        get preferredInstanceTypes(): string[] | undefined;
        /**
         * @stability stable
         */
        set preferredInstanceTypes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetPreferredInstanceTypes(): void;
        /**
         * @stability stable
         */
        get preferredInstanceTypesInput(): string[] | undefined;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2InstanceTypeOfferingFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2InstanceTypeOfferingFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2InstanceTypeOfferingFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2InstanceTypeOfferingsConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offerings.html#location_type DataAwsEc2InstanceTypeOfferings#location_type}.
         *
         * @stability stable
         */
        readonly locationType?: string;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offerings.html#filter DataAwsEc2InstanceTypeOfferings#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2InstanceTypeOfferingsFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2InstanceTypeOfferingsFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offerings.html#name DataAwsEc2InstanceTypeOfferings#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offerings.html#values DataAwsEc2InstanceTypeOfferings#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offerings.html aws_ec2_instance_type_offerings}.
     *
     * @stability stable
     */
    class DataAwsEc2InstanceTypeOfferings extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_instance_type_offerings.html aws_ec2_instance_type_offerings} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2InstanceTypeOfferingsConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get instanceTypes(): string[];
        private _locationType?;
        /**
         * @stability stable
         */
        get locationType(): string | undefined;
        /**
         * @stability stable
         */
        set locationType(value: string | undefined);
        /**
         * @stability stable
         */
        resetLocationType(): void;
        /**
         * @stability stable
         */
        get locationTypeInput(): string | undefined;
        /**
         * @stability stable
         */
        get locationTypes(): string[];
        /**
         * @stability stable
         */
        get locations(): string[];
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2InstanceTypeOfferingsFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2InstanceTypeOfferingsFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2InstanceTypeOfferingsFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2LocalGatewayConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway.html#state DataAwsEc2LocalGateway#state}.
         *
         * @stability stable
         */
        readonly state?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway.html#tags DataAwsEc2LocalGateway#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway.html#filter DataAwsEc2LocalGateway#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2LocalGatewayFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2LocalGatewayFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway.html#name DataAwsEc2LocalGateway#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway.html#values DataAwsEc2LocalGateway#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway.html aws_ec2_local_gateway}.
     *
     * @stability stable
     */
    class DataAwsEc2LocalGateway extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway.html aws_ec2_local_gateway} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2LocalGatewayConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get outpostArn(): string;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _state?;
        /**
         * @stability stable
         */
        get state(): string | undefined;
        /**
         * @stability stable
         */
        set state(value: string | undefined);
        /**
         * @stability stable
         */
        resetState(): void;
        /**
         * @stability stable
         */
        get stateInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2LocalGatewayFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2LocalGatewayFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2LocalGatewayFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2LocalGatewayRouteTableConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_route_table.html#local_gateway_id DataAwsEc2LocalGatewayRouteTable#local_gateway_id}.
         *
         * @stability stable
         */
        readonly localGatewayId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_route_table.html#local_gateway_route_table_id DataAwsEc2LocalGatewayRouteTable#local_gateway_route_table_id}.
         *
         * @stability stable
         */
        readonly localGatewayRouteTableId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_route_table.html#outpost_arn DataAwsEc2LocalGatewayRouteTable#outpost_arn}.
         *
         * @stability stable
         */
        readonly outpostArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_route_table.html#state DataAwsEc2LocalGatewayRouteTable#state}.
         *
         * @stability stable
         */
        readonly state?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_route_table.html#tags DataAwsEc2LocalGatewayRouteTable#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_route_table.html#filter DataAwsEc2LocalGatewayRouteTable#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2LocalGatewayRouteTableFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2LocalGatewayRouteTableFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_route_table.html#name DataAwsEc2LocalGatewayRouteTable#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_route_table.html#values DataAwsEc2LocalGatewayRouteTable#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_route_table.html aws_ec2_local_gateway_route_table}.
     *
     * @stability stable
     */
    class DataAwsEc2LocalGatewayRouteTable extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_route_table.html aws_ec2_local_gateway_route_table} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2LocalGatewayRouteTableConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _localGatewayId?;
        /**
         * @stability stable
         */
        get localGatewayId(): string | undefined;
        /**
         * @stability stable
         */
        set localGatewayId(value: string | undefined);
        /**
         * @stability stable
         */
        resetLocalGatewayId(): void;
        /**
         * @stability stable
         */
        get localGatewayIdInput(): string | undefined;
        private _localGatewayRouteTableId?;
        /**
         * @stability stable
         */
        get localGatewayRouteTableId(): string | undefined;
        /**
         * @stability stable
         */
        set localGatewayRouteTableId(value: string | undefined);
        /**
         * @stability stable
         */
        resetLocalGatewayRouteTableId(): void;
        /**
         * @stability stable
         */
        get localGatewayRouteTableIdInput(): string | undefined;
        private _outpostArn?;
        /**
         * @stability stable
         */
        get outpostArn(): string | undefined;
        /**
         * @stability stable
         */
        set outpostArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetOutpostArn(): void;
        /**
         * @stability stable
         */
        get outpostArnInput(): string | undefined;
        private _state?;
        /**
         * @stability stable
         */
        get state(): string | undefined;
        /**
         * @stability stable
         */
        set state(value: string | undefined);
        /**
         * @stability stable
         */
        resetState(): void;
        /**
         * @stability stable
         */
        get stateInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2LocalGatewayRouteTableFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2LocalGatewayRouteTableFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2LocalGatewayRouteTableFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2LocalGatewayRouteTablesConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_route_tables.html#tags DataAwsEc2LocalGatewayRouteTables#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_route_tables.html#filter DataAwsEc2LocalGatewayRouteTables#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2LocalGatewayRouteTablesFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2LocalGatewayRouteTablesFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_route_tables.html#name DataAwsEc2LocalGatewayRouteTables#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_route_tables.html#values DataAwsEc2LocalGatewayRouteTables#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_route_tables.html aws_ec2_local_gateway_route_tables}.
     *
     * @stability stable
     */
    class DataAwsEc2LocalGatewayRouteTables extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_route_tables.html aws_ec2_local_gateway_route_tables} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2LocalGatewayRouteTablesConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ids(): string[];
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2LocalGatewayRouteTablesFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2LocalGatewayRouteTablesFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2LocalGatewayRouteTablesFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2LocalGatewayVirtualInterfaceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface.html#tags DataAwsEc2LocalGatewayVirtualInterface#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface.html#filter DataAwsEc2LocalGatewayVirtualInterface#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2LocalGatewayVirtualInterfaceFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2LocalGatewayVirtualInterfaceFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface.html#name DataAwsEc2LocalGatewayVirtualInterface#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface.html#values DataAwsEc2LocalGatewayVirtualInterface#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface.html aws_ec2_local_gateway_virtual_interface}.
     *
     * @stability stable
     */
    class DataAwsEc2LocalGatewayVirtualInterface extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface.html aws_ec2_local_gateway_virtual_interface} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2LocalGatewayVirtualInterfaceConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get localAddress(): string;
        /**
         * @stability stable
         */
        get localBgpAsn(): number;
        /**
         * @stability stable
         */
        get localGatewayId(): string;
        /**
         * @stability stable
         */
        get localGatewayVirtualInterfaceIds(): string[];
        /**
         * @stability stable
         */
        get peerAddress(): string;
        /**
         * @stability stable
         */
        get peerBgpAsn(): number;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get vlan(): number;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2LocalGatewayVirtualInterfaceFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2LocalGatewayVirtualInterfaceFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2LocalGatewayVirtualInterfaceFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2LocalGatewayVirtualInterfaceGroupConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface_group.html#local_gateway_id DataAwsEc2LocalGatewayVirtualInterfaceGroup#local_gateway_id}.
         *
         * @stability stable
         */
        readonly localGatewayId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface_group.html#tags DataAwsEc2LocalGatewayVirtualInterfaceGroup#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface_group.html#filter DataAwsEc2LocalGatewayVirtualInterfaceGroup#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2LocalGatewayVirtualInterfaceGroupFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2LocalGatewayVirtualInterfaceGroupFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface_group.html#name DataAwsEc2LocalGatewayVirtualInterfaceGroup#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface_group.html#values DataAwsEc2LocalGatewayVirtualInterfaceGroup#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface_group.html aws_ec2_local_gateway_virtual_interface_group}.
     *
     * @stability stable
     */
    class DataAwsEc2LocalGatewayVirtualInterfaceGroup extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface_group.html aws_ec2_local_gateway_virtual_interface_group} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2LocalGatewayVirtualInterfaceGroupConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _localGatewayId?;
        /**
         * @stability stable
         */
        get localGatewayId(): string | undefined;
        /**
         * @stability stable
         */
        set localGatewayId(value: string | undefined);
        /**
         * @stability stable
         */
        resetLocalGatewayId(): void;
        /**
         * @stability stable
         */
        get localGatewayIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get localGatewayVirtualInterfaceIds(): string[];
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2LocalGatewayVirtualInterfaceGroupFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2LocalGatewayVirtualInterfaceGroupFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2LocalGatewayVirtualInterfaceGroupFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2LocalGatewayVirtualInterfaceGroupsConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface_groups.html#tags DataAwsEc2LocalGatewayVirtualInterfaceGroups#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface_groups.html#filter DataAwsEc2LocalGatewayVirtualInterfaceGroups#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2LocalGatewayVirtualInterfaceGroupsFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2LocalGatewayVirtualInterfaceGroupsFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface_groups.html#name DataAwsEc2LocalGatewayVirtualInterfaceGroups#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface_groups.html#values DataAwsEc2LocalGatewayVirtualInterfaceGroups#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface_groups.html aws_ec2_local_gateway_virtual_interface_groups}.
     *
     * @stability stable
     */
    class DataAwsEc2LocalGatewayVirtualInterfaceGroups extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateway_virtual_interface_groups.html aws_ec2_local_gateway_virtual_interface_groups} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2LocalGatewayVirtualInterfaceGroupsConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ids(): string[];
        /**
         * @stability stable
         */
        get localGatewayVirtualInterfaceIds(): string[];
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2LocalGatewayVirtualInterfaceGroupsFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2LocalGatewayVirtualInterfaceGroupsFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2LocalGatewayVirtualInterfaceGroupsFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2LocalGatewaysConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateways.html#tags DataAwsEc2LocalGateways#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateways.html#filter DataAwsEc2LocalGateways#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2LocalGatewaysFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2LocalGatewaysFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateways.html#name DataAwsEc2LocalGateways#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateways.html#values DataAwsEc2LocalGateways#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateways.html aws_ec2_local_gateways}.
     *
     * @stability stable
     */
    class DataAwsEc2LocalGateways extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_local_gateways.html aws_ec2_local_gateways} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2LocalGatewaysConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ids(): string[];
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2LocalGatewaysFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2LocalGatewaysFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2LocalGatewaysFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2ManagedPrefixListConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_managed_prefix_list.html#name DataAwsEc2ManagedPrefixList#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_managed_prefix_list.html#tags DataAwsEc2ManagedPrefixList#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_managed_prefix_list.html#filter DataAwsEc2ManagedPrefixList#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2ManagedPrefixListFilter[];
    }
    /**
     * @stability stable
     */
    class DataAwsEc2ManagedPrefixListEntries extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get cidr(): string;
        /**
         * @stability stable
         */
        get description(): string;
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2ManagedPrefixListFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_managed_prefix_list.html#name DataAwsEc2ManagedPrefixList#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_managed_prefix_list.html#values DataAwsEc2ManagedPrefixList#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_managed_prefix_list.html aws_ec2_managed_prefix_list}.
     *
     * @stability stable
     */
    class DataAwsEc2ManagedPrefixList extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_managed_prefix_list.html aws_ec2_managed_prefix_list} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2ManagedPrefixListConfig);
        /**
         * @stability stable
         */
        get addressFamily(): string;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        entries(index: string): DataAwsEc2ManagedPrefixListEntries;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get maxEntries(): number;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get ownerId(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get version(): number;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2ManagedPrefixListFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2ManagedPrefixListFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2ManagedPrefixListFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2SpotPriceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_spot_price.html#availability_zone DataAwsEc2SpotPrice#availability_zone}.
         *
         * @stability stable
         */
        readonly availabilityZone?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_spot_price.html#instance_type DataAwsEc2SpotPrice#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType?: string;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_spot_price.html#filter DataAwsEc2SpotPrice#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2SpotPriceFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2SpotPriceFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_spot_price.html#name DataAwsEc2SpotPrice#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_spot_price.html#values DataAwsEc2SpotPrice#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_spot_price.html aws_ec2_spot_price}.
     *
     * @stability stable
     */
    class DataAwsEc2SpotPrice extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_spot_price.html aws_ec2_spot_price} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2SpotPriceConfig);
        private _availabilityZone?;
        /**
         * @stability stable
         */
        get availabilityZone(): string | undefined;
        /**
         * @stability stable
         */
        set availabilityZone(value: string | undefined);
        /**
         * @stability stable
         */
        resetAvailabilityZone(): void;
        /**
         * @stability stable
         */
        get availabilityZoneInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceType?;
        /**
         * @stability stable
         */
        get instanceType(): string | undefined;
        /**
         * @stability stable
         */
        set instanceType(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceType(): void;
        /**
         * @stability stable
         */
        get instanceTypeInput(): string | undefined;
        /**
         * @stability stable
         */
        get spotPrice(): string;
        /**
         * @stability stable
         */
        get spotPriceTimestamp(): string;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2SpotPriceFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2SpotPriceFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2SpotPriceFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2TransitGatewayConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway.html#tags DataAwsEc2TransitGateway#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway.html#filter DataAwsEc2TransitGateway#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2TransitGatewayFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2TransitGatewayFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway.html#name DataAwsEc2TransitGateway#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway.html#values DataAwsEc2TransitGateway#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway.html aws_ec2_transit_gateway}.
     *
     * @stability stable
     */
    class DataAwsEc2TransitGateway extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway.html aws_ec2_transit_gateway} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2TransitGatewayConfig);
        /**
         * @stability stable
         */
        get amazonSideAsn(): number;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get associationDefaultRouteTableId(): string;
        /**
         * @stability stable
         */
        get autoAcceptSharedAttachments(): string;
        /**
         * @stability stable
         */
        get defaultRouteTableAssociation(): string;
        /**
         * @stability stable
         */
        get defaultRouteTablePropagation(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get dnsSupport(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ownerId(): string;
        /**
         * @stability stable
         */
        get propagationDefaultRouteTableId(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get vpnEcmpSupport(): string;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2TransitGatewayFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2TransitGatewayFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2TransitGatewayFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2TransitGatewayDxGatewayAttachmentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_dx_gateway_attachment.html#dx_gateway_id DataAwsEc2TransitGatewayDxGatewayAttachment#dx_gateway_id}.
         *
         * @stability stable
         */
        readonly dxGatewayId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_dx_gateway_attachment.html#tags DataAwsEc2TransitGatewayDxGatewayAttachment#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_dx_gateway_attachment.html#transit_gateway_id DataAwsEc2TransitGatewayDxGatewayAttachment#transit_gateway_id}.
         *
         * @stability stable
         */
        readonly transitGatewayId?: string;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_dx_gateway_attachment.html#filter DataAwsEc2TransitGatewayDxGatewayAttachment#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2TransitGatewayDxGatewayAttachmentFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2TransitGatewayDxGatewayAttachmentFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_dx_gateway_attachment.html#name DataAwsEc2TransitGatewayDxGatewayAttachment#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_dx_gateway_attachment.html#values DataAwsEc2TransitGatewayDxGatewayAttachment#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_dx_gateway_attachment.html aws_ec2_transit_gateway_dx_gateway_attachment}.
     *
     * @stability stable
     */
    class DataAwsEc2TransitGatewayDxGatewayAttachment extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_dx_gateway_attachment.html aws_ec2_transit_gateway_dx_gateway_attachment} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2TransitGatewayDxGatewayAttachmentConfig);
        private _dxGatewayId?;
        /**
         * @stability stable
         */
        get dxGatewayId(): string | undefined;
        /**
         * @stability stable
         */
        set dxGatewayId(value: string | undefined);
        /**
         * @stability stable
         */
        resetDxGatewayId(): void;
        /**
         * @stability stable
         */
        get dxGatewayIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _transitGatewayId?;
        /**
         * @stability stable
         */
        get transitGatewayId(): string | undefined;
        /**
         * @stability stable
         */
        set transitGatewayId(value: string | undefined);
        /**
         * @stability stable
         */
        resetTransitGatewayId(): void;
        /**
         * @stability stable
         */
        get transitGatewayIdInput(): string | undefined;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2TransitGatewayDxGatewayAttachmentFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2TransitGatewayDxGatewayAttachmentFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2TransitGatewayDxGatewayAttachmentFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2TransitGatewayPeeringAttachmentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_peering_attachment.html#tags DataAwsEc2TransitGatewayPeeringAttachment#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_peering_attachment.html#filter DataAwsEc2TransitGatewayPeeringAttachment#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2TransitGatewayPeeringAttachmentFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2TransitGatewayPeeringAttachmentFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_peering_attachment.html#name DataAwsEc2TransitGatewayPeeringAttachment#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_peering_attachment.html#values DataAwsEc2TransitGatewayPeeringAttachment#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_peering_attachment.html aws_ec2_transit_gateway_peering_attachment}.
     *
     * @stability stable
     */
    class DataAwsEc2TransitGatewayPeeringAttachment extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_peering_attachment.html aws_ec2_transit_gateway_peering_attachment} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2TransitGatewayPeeringAttachmentConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get peerAccountId(): string;
        /**
         * @stability stable
         */
        get peerRegion(): string;
        /**
         * @stability stable
         */
        get peerTransitGatewayId(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get transitGatewayId(): string;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2TransitGatewayPeeringAttachmentFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2TransitGatewayPeeringAttachmentFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2TransitGatewayPeeringAttachmentFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2TransitGatewayRouteTableConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_route_table.html#tags DataAwsEc2TransitGatewayRouteTable#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_route_table.html#filter DataAwsEc2TransitGatewayRouteTable#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2TransitGatewayRouteTableFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2TransitGatewayRouteTableFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_route_table.html#name DataAwsEc2TransitGatewayRouteTable#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_route_table.html#values DataAwsEc2TransitGatewayRouteTable#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_route_table.html aws_ec2_transit_gateway_route_table}.
     *
     * @stability stable
     */
    class DataAwsEc2TransitGatewayRouteTable extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_route_table.html aws_ec2_transit_gateway_route_table} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2TransitGatewayRouteTableConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get defaultAssociationRouteTable(): any;
        /**
         * @stability stable
         */
        get defaultPropagationRouteTable(): any;
        /**
         * @stability stable
         */
        get id(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get transitGatewayId(): string;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2TransitGatewayRouteTableFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2TransitGatewayRouteTableFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2TransitGatewayRouteTableFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2TransitGatewayRouteTablesConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_route_tables.html#tags DataAwsEc2TransitGatewayRouteTables#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_route_tables.html#filter DataAwsEc2TransitGatewayRouteTables#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2TransitGatewayRouteTablesFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2TransitGatewayRouteTablesFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_route_tables.html#name DataAwsEc2TransitGatewayRouteTables#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_route_tables.html#values DataAwsEc2TransitGatewayRouteTables#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_route_tables.html aws_ec2_transit_gateway_route_tables}.
     *
     * @stability stable
     */
    class DataAwsEc2TransitGatewayRouteTables extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_route_tables.html aws_ec2_transit_gateway_route_tables} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2TransitGatewayRouteTablesConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ids(): string[];
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2TransitGatewayRouteTablesFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2TransitGatewayRouteTablesFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2TransitGatewayRouteTablesFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2TransitGatewayVpcAttachmentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_vpc_attachment.html#tags DataAwsEc2TransitGatewayVpcAttachment#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_vpc_attachment.html#filter DataAwsEc2TransitGatewayVpcAttachment#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2TransitGatewayVpcAttachmentFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2TransitGatewayVpcAttachmentFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_vpc_attachment.html#name DataAwsEc2TransitGatewayVpcAttachment#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_vpc_attachment.html#values DataAwsEc2TransitGatewayVpcAttachment#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_vpc_attachment.html aws_ec2_transit_gateway_vpc_attachment}.
     *
     * @stability stable
     */
    class DataAwsEc2TransitGatewayVpcAttachment extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_vpc_attachment.html aws_ec2_transit_gateway_vpc_attachment} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2TransitGatewayVpcAttachmentConfig);
        /**
         * @stability stable
         */
        get applianceModeSupport(): string;
        /**
         * @stability stable
         */
        get dnsSupport(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ipv6Support(): string;
        /**
         * @stability stable
         */
        get subnetIds(): string[];
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get transitGatewayId(): string;
        /**
         * @stability stable
         */
        get vpcId(): string;
        /**
         * @stability stable
         */
        get vpcOwnerId(): string;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2TransitGatewayVpcAttachmentFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2TransitGatewayVpcAttachmentFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2TransitGatewayVpcAttachmentFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2TransitGatewayVpnAttachmentConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_vpn_attachment.html#tags DataAwsEc2TransitGatewayVpnAttachment#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_vpn_attachment.html#transit_gateway_id DataAwsEc2TransitGatewayVpnAttachment#transit_gateway_id}.
         *
         * @stability stable
         */
        readonly transitGatewayId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_vpn_attachment.html#vpn_connection_id DataAwsEc2TransitGatewayVpnAttachment#vpn_connection_id}.
         *
         * @stability stable
         */
        readonly vpnConnectionId?: string;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_vpn_attachment.html#filter DataAwsEc2TransitGatewayVpnAttachment#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEc2TransitGatewayVpnAttachmentFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEc2TransitGatewayVpnAttachmentFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_vpn_attachment.html#name DataAwsEc2TransitGatewayVpnAttachment#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_vpn_attachment.html#values DataAwsEc2TransitGatewayVpnAttachment#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_vpn_attachment.html aws_ec2_transit_gateway_vpn_attachment}.
     *
     * @stability stable
     */
    class DataAwsEc2TransitGatewayVpnAttachment extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ec2_transit_gateway_vpn_attachment.html aws_ec2_transit_gateway_vpn_attachment} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEc2TransitGatewayVpnAttachmentConfig);
        /**
         * @stability stable
         */
        get id(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _transitGatewayId?;
        /**
         * @stability stable
         */
        get transitGatewayId(): string | undefined;
        /**
         * @stability stable
         */
        set transitGatewayId(value: string | undefined);
        /**
         * @stability stable
         */
        resetTransitGatewayId(): void;
        /**
         * @stability stable
         */
        get transitGatewayIdInput(): string | undefined;
        private _vpnConnectionId?;
        /**
         * @stability stable
         */
        get vpnConnectionId(): string | undefined;
        /**
         * @stability stable
         */
        set vpnConnectionId(value: string | undefined);
        /**
         * @stability stable
         */
        resetVpnConnectionId(): void;
        /**
         * @stability stable
         */
        get vpnConnectionIdInput(): string | undefined;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEc2TransitGatewayVpnAttachmentFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEc2TransitGatewayVpnAttachmentFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEc2TransitGatewayVpnAttachmentFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsEipConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/eip.html#public_ip DataAwsEip#public_ip}.
         *
         * @stability stable
         */
        readonly publicIp?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/eip.html#tags DataAwsEip#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/eip.html#filter DataAwsEip#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsEipFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsEipFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/eip.html#name DataAwsEip#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/eip.html#values DataAwsEip#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/eip.html aws_eip}.
     *
     * @stability stable
     */
    class DataAwsEip extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/eip.html aws_eip} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsEipConfig);
        /**
         * @stability stable
         */
        get associationId(): string;
        /**
         * @stability stable
         */
        get carrierIp(): string;
        /**
         * @stability stable
         */
        get customerOwnedIp(): string;
        /**
         * @stability stable
         */
        get customerOwnedIpv4Pool(): string;
        /**
         * @stability stable
         */
        get domain(): string;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get instanceId(): string;
        /**
         * @stability stable
         */
        get networkInterfaceId(): string;
        /**
         * @stability stable
         */
        get networkInterfaceOwnerId(): string;
        /**
         * @stability stable
         */
        get privateDns(): string;
        /**
         * @stability stable
         */
        get privateIp(): string;
        /**
         * @stability stable
         */
        get publicDns(): string;
        private _publicIp?;
        /**
         * @stability stable
         */
        get publicIp(): string | undefined;
        /**
         * @stability stable
         */
        set publicIp(value: string | undefined);
        /**
         * @stability stable
         */
        resetPublicIp(): void;
        /**
         * @stability stable
         */
        get publicIpInput(): string | undefined;
        /**
         * @stability stable
         */
        get publicIpv4Pool(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsEipFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsEipFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsEipFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsInstanceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instance.html#get_password_data DataAwsInstance#get_password_data}.
         *
         * @stability stable
         */
        readonly fetchPasswordData?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instance.html#get_user_data DataAwsInstance#get_user_data}.
         *
         * @stability stable
         */
        readonly fetchUserData?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instance.html#instance_id DataAwsInstance#instance_id}.
         *
         * @stability stable
         */
        readonly instanceId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instance.html#instance_tags DataAwsInstance#instance_tags}.
         *
         * @stability stable
         */
        readonly instanceTags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instance.html#tags DataAwsInstance#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instance.html#filter DataAwsInstance#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsInstanceFilter[];
    }
    /**
     * @stability stable
     */
    class DataAwsInstanceCreditSpecification extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get cpuCredits(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsInstanceEbsBlockDevice extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get deleteOnTermination(): any;
        /**
         * @stability stable
         */
        get deviceName(): string;
        /**
         * @stability stable
         */
        get encrypted(): any;
        /**
         * @stability stable
         */
        get iops(): number;
        /**
         * @stability stable
         */
        get kmsKeyId(): string;
        /**
         * @stability stable
         */
        get snapshotId(): string;
        /**
         * @stability stable
         */
        get tags(): any;
        /**
         * @stability stable
         */
        get throughput(): number;
        /**
         * @stability stable
         */
        get volumeId(): string;
        /**
         * @stability stable
         */
        get volumeSize(): number;
        /**
         * @stability stable
         */
        get volumeType(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsInstanceEnclaveOptions extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get enabled(): any;
    }
    /**
     * @stability stable
     */
    class DataAwsInstanceEphemeralBlockDevice extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get deviceName(): string;
        /**
         * @stability stable
         */
        get noDevice(): any;
        /**
         * @stability stable
         */
        get virtualName(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsInstanceMetadataOptions extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get httpEndpoint(): string;
        /**
         * @stability stable
         */
        get httpPutResponseHopLimit(): number;
        /**
         * @stability stable
         */
        get httpTokens(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsInstanceRootBlockDevice extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get deleteOnTermination(): any;
        /**
         * @stability stable
         */
        get deviceName(): string;
        /**
         * @stability stable
         */
        get encrypted(): any;
        /**
         * @stability stable
         */
        get iops(): number;
        /**
         * @stability stable
         */
        get kmsKeyId(): string;
        /**
         * @stability stable
         */
        get tags(): any;
        /**
         * @stability stable
         */
        get throughput(): number;
        /**
         * @stability stable
         */
        get volumeId(): string;
        /**
         * @stability stable
         */
        get volumeSize(): number;
        /**
         * @stability stable
         */
        get volumeType(): string;
    }
    /**
     * @stability stable
     */
    interface DataAwsInstanceFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instance.html#name DataAwsInstance#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instance.html#values DataAwsInstance#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/instance.html aws_instance}.
     *
     * @stability stable
     */
    class DataAwsInstance extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/instance.html aws_instance} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsInstanceConfig);
        /**
         * @stability stable
         */
        get ami(): string;
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get associatePublicIpAddress(): any;
        /**
         * @stability stable
         */
        get availabilityZone(): string;
        /**
         * @stability stable
         */
        creditSpecification(index: string): DataAwsInstanceCreditSpecification;
        /**
         * @stability stable
         */
        get disableApiTermination(): any;
        /**
         * @stability stable
         */
        ebsBlockDevice(index: string): DataAwsInstanceEbsBlockDevice;
        /**
         * @stability stable
         */
        get ebsOptimized(): any;
        /**
         * @stability stable
         */
        enclaveOptions(index: string): DataAwsInstanceEnclaveOptions;
        /**
         * @stability stable
         */
        ephemeralBlockDevice(index: string): DataAwsInstanceEphemeralBlockDevice;
        private _getPasswordData?;
        /**
         * @stability stable
         */
        get fetchPasswordData(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set fetchPasswordData(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetFetchPasswordData(): void;
        /**
         * @stability stable
         */
        get fetchPasswordDataInput(): boolean | cdktf.IResolvable | undefined;
        private _getUserData?;
        /**
         * @stability stable
         */
        get fetchUserData(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set fetchUserData(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetFetchUserData(): void;
        /**
         * @stability stable
         */
        get fetchUserDataInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get hostId(): string;
        /**
         * @stability stable
         */
        get iamInstanceProfile(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _instanceId?;
        /**
         * @stability stable
         */
        get instanceId(): string | undefined;
        /**
         * @stability stable
         */
        set instanceId(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceId(): void;
        /**
         * @stability stable
         */
        get instanceIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get instanceState(): string;
        private _instanceTags?;
        /**
         * @stability stable
         */
        get instanceTags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set instanceTags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetInstanceTags(): void;
        /**
         * @stability stable
         */
        get instanceTagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get instanceType(): string;
        /**
         * @stability stable
         */
        get ipv6Addresses(): string[];
        /**
         * @stability stable
         */
        get keyName(): string;
        /**
         * @stability stable
         */
        metadataOptions(index: string): DataAwsInstanceMetadataOptions;
        /**
         * @stability stable
         */
        get monitoring(): any;
        /**
         * @stability stable
         */
        get networkInterfaceId(): string;
        /**
         * @stability stable
         */
        get outpostArn(): string;
        /**
         * @stability stable
         */
        get passwordData(): string;
        /**
         * @stability stable
         */
        get placementGroup(): string;
        /**
         * @stability stable
         */
        get placementPartitionNumber(): number;
        /**
         * @stability stable
         */
        get privateDns(): string;
        /**
         * @stability stable
         */
        get privateIp(): string;
        /**
         * @stability stable
         */
        get publicDns(): string;
        /**
         * @stability stable
         */
        get publicIp(): string;
        /**
         * @stability stable
         */
        rootBlockDevice(index: string): DataAwsInstanceRootBlockDevice;
        /**
         * @stability stable
         */
        get secondaryPrivateIps(): string[];
        /**
         * @stability stable
         */
        get securityGroups(): string[];
        /**
         * @stability stable
         */
        get sourceDestCheck(): any;
        /**
         * @stability stable
         */
        get subnetId(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get tenancy(): string;
        /**
         * @stability stable
         */
        get userData(): string;
        /**
         * @stability stable
         */
        get userDataBase64(): string;
        /**
         * @stability stable
         */
        get vpcSecurityGroupIds(): string[];
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsInstanceFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsInstanceFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsInstanceFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsInstancesConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instances.html#instance_state_names DataAwsInstances#instance_state_names}.
         *
         * @stability stable
         */
        readonly instanceStateNames?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instances.html#instance_tags DataAwsInstances#instance_tags}.
         *
         * @stability stable
         */
        readonly instanceTags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instances.html#filter DataAwsInstances#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsInstancesFilter[];
    }
    /**
     * @stability stable
     */
    interface DataAwsInstancesFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instances.html#name DataAwsInstances#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instances.html#values DataAwsInstances#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/instances.html aws_instances}.
     *
     * @stability stable
     */
    class DataAwsInstances extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/instances.html aws_instances} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsInstancesConfig);
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get ids(): string[];
        private _instanceStateNames?;
        /**
         * @stability stable
         */
        get instanceStateNames(): string[] | undefined;
        /**
         * @stability stable
         */
        set instanceStateNames(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetInstanceStateNames(): void;
        /**
         * @stability stable
         */
        get instanceStateNamesInput(): string[] | undefined;
        private _instanceTags?;
        /**
         * @stability stable
         */
        get instanceTags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set instanceTags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetInstanceTags(): void;
        /**
         * @stability stable
         */
        get instanceTagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get privateIps(): string[];
        /**
         * @stability stable
         */
        get publicIps(): string[];
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsInstancesFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsInstancesFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsInstancesFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsLaunchTemplateConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/launch_template.html#name DataAwsLaunchTemplate#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/launch_template.html#tags DataAwsLaunchTemplate#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * filter block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/launch_template.html#filter DataAwsLaunchTemplate#filter}
         *
         * @stability stable
         */
        readonly filter?: DataAwsLaunchTemplateFilter[];
    }
    /**
     * @stability stable
     */
    class DataAwsLaunchTemplateBlockDeviceMappingsEbs extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get deleteOnTermination(): string;
        /**
         * @stability stable
         */
        get encrypted(): string;
        /**
         * @stability stable
         */
        get iops(): number;
        /**
         * @stability stable
         */
        get kmsKeyId(): string;
        /**
         * @stability stable
         */
        get snapshotId(): string;
        /**
         * @stability stable
         */
        get throughput(): number;
        /**
         * @stability stable
         */
        get volumeSize(): number;
        /**
         * @stability stable
         */
        get volumeType(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsLaunchTemplateBlockDeviceMappings extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get deviceName(): string;
        /**
         * @stability stable
         */
        get ebs(): any;
        /**
         * @stability stable
         */
        get noDevice(): string;
        /**
         * @stability stable
         */
        get virtualName(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsLaunchTemplateCreditSpecification extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get cpuCredits(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsLaunchTemplateElasticGpuSpecifications extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get type(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsLaunchTemplateEnclaveOptions extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get enabled(): any;
    }
    /**
     * @stability stable
     */
    class DataAwsLaunchTemplateHibernationOptions extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get configured(): any;
    }
    /**
     * @stability stable
     */
    class DataAwsLaunchTemplateIamInstanceProfile extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get name(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsLaunchTemplateInstanceMarketOptionsSpotOptions extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get blockDurationMinutes(): number;
        /**
         * @stability stable
         */
        get instanceInterruptionBehavior(): string;
        /**
         * @stability stable
         */
        get maxPrice(): string;
        /**
         * @stability stable
         */
        get spotInstanceType(): string;
        /**
         * @stability stable
         */
        get validUntil(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsLaunchTemplateInstanceMarketOptions extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get marketType(): string;
        /**
         * @stability stable
         */
        get spotOptions(): any;
    }
    /**
     * @stability stable
     */
    class DataAwsLaunchTemplateMetadataOptions extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get httpEndpoint(): string;
        /**
         * @stability stable
         */
        get httpProtocolIpv6(): string;
        /**
         * @stability stable
         */
        get httpPutResponseHopLimit(): number;
        /**
         * @stability stable
         */
        get httpTokens(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsLaunchTemplateMonitoring extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get enabled(): any;
    }
    /**
     * @stability stable
     */
    class DataAwsLaunchTemplateNetworkInterfaces extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get associateCarrierIpAddress(): string;
        /**
         * @stability stable
         */
        get associatePublicIpAddress(): string;
        /**
         * @stability stable
         */
        get deleteOnTermination(): string;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get deviceIndex(): number;
        /**
         * @stability stable
         */
        get interfaceType(): string;
        /**
         * @stability stable
         */
        get ipv4AddressCount(): number;
        /**
         * @stability stable
         */
        get ipv4Addresses(): string[];
        /**
         * @stability stable
         */
        get ipv6AddressCount(): number;
        /**
         * @stability stable
         */
        get ipv6Addresses(): string[];
        /**
         * @stability stable
         */
        get networkInterfaceId(): string;
        /**
         * @stability stable
         */
        get privateIpAddress(): string;
        /**
         * @stability stable
         */
        get securityGroups(): string[];
        /**
         * @stability stable
         */
        get subnetId(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsLaunchTemplatePlacement extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get affinity(): string;
        /**
         * @stability stable
         */
        get availabilityZone(): string;
        /**
         * @stability stable
         */
        get groupName(): string;
        /**
         * @stability stable
         */
        get hostId(): string;
        /**
         * @stability stable
         */
        get hostResourceGroupArn(): string;
        /**
         * @stability stable
         */
        get partitionNumber(): number;
        /**
         * @stability stable
         */
        get spreadDomain(): string;
        /**
         * @stability stable
         */
        get tenancy(): string;
    }
    /**
     * @stability stable
     */
    class DataAwsLaunchTemplateTagSpecifications extends cdktf.ComplexComputedList {
        /**
         * @stability stable
         */
        get resourceType(): string;
        /**
         * @stability stable
         */
        get tags(): any;
    }
    /**
     * @stability stable
     */
    interface DataAwsLaunchTemplateFilter {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/launch_template.html#name DataAwsLaunchTemplate#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/launch_template.html#values DataAwsLaunchTemplate#values}.
         *
         * @stability stable
         */
        readonly values: string[];
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/launch_template.html aws_launch_template}.
     *
     * @stability stable
     */
    class DataAwsLaunchTemplate extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/launch_template.html aws_launch_template} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config?: DataAwsLaunchTemplateConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        blockDeviceMappings(index: string): DataAwsLaunchTemplateBlockDeviceMappings;
        /**
         * @stability stable
         */
        creditSpecification(index: string): DataAwsLaunchTemplateCreditSpecification;
        /**
         * @stability stable
         */
        get defaultVersion(): number;
        /**
         * @stability stable
         */
        get description(): string;
        /**
         * @stability stable
         */
        get disableApiTermination(): any;
        /**
         * @stability stable
         */
        get ebsOptimized(): string;
        /**
         * @stability stable
         */
        elasticGpuSpecifications(index: string): DataAwsLaunchTemplateElasticGpuSpecifications;
        /**
         * @stability stable
         */
        enclaveOptions(index: string): DataAwsLaunchTemplateEnclaveOptions;
        /**
         * @stability stable
         */
        hibernationOptions(index: string): DataAwsLaunchTemplateHibernationOptions;
        /**
         * @stability stable
         */
        iamInstanceProfile(index: string): DataAwsLaunchTemplateIamInstanceProfile;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get imageId(): string;
        /**
         * @stability stable
         */
        get instanceInitiatedShutdownBehavior(): string;
        /**
         * @stability stable
         */
        instanceMarketOptions(index: string): DataAwsLaunchTemplateInstanceMarketOptions;
        /**
         * @stability stable
         */
        get instanceType(): string;
        /**
         * @stability stable
         */
        get kernelId(): string;
        /**
         * @stability stable
         */
        get keyName(): string;
        /**
         * @stability stable
         */
        get latestVersion(): number;
        /**
         * @stability stable
         */
        metadataOptions(index: string): DataAwsLaunchTemplateMetadataOptions;
        /**
         * @stability stable
         */
        monitoring(index: string): DataAwsLaunchTemplateMonitoring;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        networkInterfaces(index: string): DataAwsLaunchTemplateNetworkInterfaces;
        /**
         * @stability stable
         */
        placement(index: string): DataAwsLaunchTemplatePlacement;
        /**
         * @stability stable
         */
        get ramDiskId(): string;
        /**
         * @stability stable
         */
        get securityGroupNames(): string[];
        /**
         * @stability stable
         */
        tagSpecifications(index: string): DataAwsLaunchTemplateTagSpecifications;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get userData(): string;
        /**
         * @stability stable
         */
        get vpcSecurityGroupIds(): string[];
        private _filter?;
        /**
         * @stability stable
         */
        get filter(): DataAwsLaunchTemplateFilter[] | undefined;
        /**
         * @stability stable
         */
        set filter(value: DataAwsLaunchTemplateFilter[] | undefined);
        /**
         * @stability stable
         */
        resetFilter(): void;
        /**
         * @stability stable
         */
        get filterInput(): DataAwsLaunchTemplateFilter[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
