import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Kinesis
*/
export declare namespace Kinesis {
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#code KinesisAnalyticsApplication#code}.
         *
         * @stability stable
         */
        readonly code?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#description KinesisAnalyticsApplication#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#name KinesisAnalyticsApplication#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#start_application KinesisAnalyticsApplication#start_application}.
         *
         * @stability stable
         */
        readonly startApplication?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#tags KinesisAnalyticsApplication#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#tags_all KinesisAnalyticsApplication#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * cloudwatch_logging_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#cloudwatch_logging_options KinesisAnalyticsApplication#cloudwatch_logging_options}
         *
         * @stability stable
         */
        readonly cloudwatchLoggingOptions?: KinesisAnalyticsApplicationCloudwatchLoggingOptions;
        /**
         * inputs block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#inputs KinesisAnalyticsApplication#inputs}
         *
         * @stability stable
         */
        readonly inputs?: KinesisAnalyticsApplicationInputs;
        /**
         * outputs block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#outputs KinesisAnalyticsApplication#outputs}
         *
         * @stability stable
         */
        readonly outputs?: KinesisAnalyticsApplicationOutputs[];
        /**
         * reference_data_sources block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#reference_data_sources KinesisAnalyticsApplication#reference_data_sources}
         *
         * @stability stable
         */
        readonly referenceDataSources?: KinesisAnalyticsApplicationReferenceDataSources;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationCloudwatchLoggingOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#log_stream_arn KinesisAnalyticsApplication#log_stream_arn}.
         *
         * @stability stable
         */
        readonly logStreamArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#role_arn KinesisAnalyticsApplication#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationCloudwatchLoggingOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _logStreamArn?;
        /**
         * @stability stable
         */
        get logStreamArn(): string;
        /**
         * @stability stable
         */
        set logStreamArn(value: string);
        /**
         * @stability stable
         */
        get logStreamArnInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationInputsKinesisFirehose {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#resource_arn KinesisAnalyticsApplication#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#role_arn KinesisAnalyticsApplication#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationInputsKinesisFirehoseOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _resourceArn?;
        /**
         * @stability stable
         */
        get resourceArn(): string;
        /**
         * @stability stable
         */
        set resourceArn(value: string);
        /**
         * @stability stable
         */
        get resourceArnInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationInputsKinesisStream {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#resource_arn KinesisAnalyticsApplication#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#role_arn KinesisAnalyticsApplication#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationInputsKinesisStreamOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _resourceArn?;
        /**
         * @stability stable
         */
        get resourceArn(): string;
        /**
         * @stability stable
         */
        set resourceArn(value: string);
        /**
         * @stability stable
         */
        get resourceArnInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationInputsParallelism {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#count KinesisAnalyticsApplication#count}.
         *
         * @stability stable
         */
        readonly count?: number;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationInputsParallelismOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _count?;
        /**
         * @stability stable
         */
        get count(): number | undefined;
        /**
         * @stability stable
         */
        set count(value: number | undefined);
        /**
         * @stability stable
         */
        resetCount(): void;
        /**
         * @stability stable
         */
        get countInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationInputsProcessingConfigurationLambda {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#resource_arn KinesisAnalyticsApplication#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#role_arn KinesisAnalyticsApplication#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationInputsProcessingConfigurationLambdaOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _resourceArn?;
        /**
         * @stability stable
         */
        get resourceArn(): string;
        /**
         * @stability stable
         */
        set resourceArn(value: string);
        /**
         * @stability stable
         */
        get resourceArnInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationInputsProcessingConfiguration {
        /**
         * lambda block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#lambda KinesisAnalyticsApplication#lambda}
         *
         * @stability stable
         */
        readonly lambda: KinesisAnalyticsApplicationInputsProcessingConfigurationLambda;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationInputsProcessingConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _lambda?;
        private __lambdaOutput;
        /**
         * @stability stable
         */
        get lambda(): KinesisAnalyticsApplicationInputsProcessingConfigurationLambdaOutputReference;
        /**
         * @stability stable
         */
        putLambda(value: KinesisAnalyticsApplicationInputsProcessingConfigurationLambda): void;
        /**
         * @stability stable
         */
        get lambdaInput(): KinesisAnalyticsApplicationInputsProcessingConfigurationLambda | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationInputsSchemaRecordColumns {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#mapping KinesisAnalyticsApplication#mapping}.
         *
         * @stability stable
         */
        readonly mapping?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#name KinesisAnalyticsApplication#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#sql_type KinesisAnalyticsApplication#sql_type}.
         *
         * @stability stable
         */
        readonly sqlType: string;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParametersCsv {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#record_column_delimiter KinesisAnalyticsApplication#record_column_delimiter}.
         *
         * @stability stable
         */
        readonly recordColumnDelimiter: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#record_row_delimiter KinesisAnalyticsApplication#record_row_delimiter}.
         *
         * @stability stable
         */
        readonly recordRowDelimiter: string;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParametersCsvOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _recordColumnDelimiter?;
        /**
         * @stability stable
         */
        get recordColumnDelimiter(): string;
        /**
         * @stability stable
         */
        set recordColumnDelimiter(value: string);
        /**
         * @stability stable
         */
        get recordColumnDelimiterInput(): string | undefined;
        private _recordRowDelimiter?;
        /**
         * @stability stable
         */
        get recordRowDelimiter(): string;
        /**
         * @stability stable
         */
        set recordRowDelimiter(value: string);
        /**
         * @stability stable
         */
        get recordRowDelimiterInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParametersJson {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#record_row_path KinesisAnalyticsApplication#record_row_path}.
         *
         * @stability stable
         */
        readonly recordRowPath: string;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParametersJsonOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _recordRowPath?;
        /**
         * @stability stable
         */
        get recordRowPath(): string;
        /**
         * @stability stable
         */
        set recordRowPath(value: string);
        /**
         * @stability stable
         */
        get recordRowPathInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParameters {
        /**
         * csv block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#csv KinesisAnalyticsApplication#csv}
         *
         * @stability stable
         */
        readonly csv?: KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParametersCsv;
        /**
         * json block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#json KinesisAnalyticsApplication#json}
         *
         * @stability stable
         */
        readonly json?: KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParametersJson;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParametersOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _csv?;
        private __csvOutput;
        /**
         * @stability stable
         */
        get csv(): KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParametersCsvOutputReference;
        /**
         * @stability stable
         */
        putCsv(value: KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParametersCsv | undefined): void;
        /**
         * @stability stable
         */
        resetCsv(): void;
        /**
         * @stability stable
         */
        get csvInput(): KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParametersCsv | undefined;
        private _json?;
        private __jsonOutput;
        /**
         * @stability stable
         */
        get json(): KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParametersJsonOutputReference;
        /**
         * @stability stable
         */
        putJson(value: KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParametersJson | undefined): void;
        /**
         * @stability stable
         */
        resetJson(): void;
        /**
         * @stability stable
         */
        get jsonInput(): KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParametersJson | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationInputsSchemaRecordFormat {
        /**
         * mapping_parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#mapping_parameters KinesisAnalyticsApplication#mapping_parameters}
         *
         * @stability stable
         */
        readonly mappingParameters?: KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParameters;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationInputsSchemaRecordFormatOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _mappingParameters?;
        private __mappingParametersOutput;
        /**
         * @stability stable
         */
        get mappingParameters(): KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParametersOutputReference;
        /**
         * @stability stable
         */
        putMappingParameters(value: KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParameters | undefined): void;
        /**
         * @stability stable
         */
        resetMappingParameters(): void;
        /**
         * @stability stable
         */
        get mappingParametersInput(): KinesisAnalyticsApplicationInputsSchemaRecordFormatMappingParameters | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationInputsSchema {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#record_encoding KinesisAnalyticsApplication#record_encoding}.
         *
         * @stability stable
         */
        readonly recordEncoding?: string;
        /**
         * record_columns block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#record_columns KinesisAnalyticsApplication#record_columns}
         *
         * @stability stable
         */
        readonly recordColumns: KinesisAnalyticsApplicationInputsSchemaRecordColumns[];
        /**
         * record_format block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#record_format KinesisAnalyticsApplication#record_format}
         *
         * @stability stable
         */
        readonly recordFormat: KinesisAnalyticsApplicationInputsSchemaRecordFormat;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationInputsSchemaOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _recordEncoding?;
        /**
         * @stability stable
         */
        get recordEncoding(): string | undefined;
        /**
         * @stability stable
         */
        set recordEncoding(value: string | undefined);
        /**
         * @stability stable
         */
        resetRecordEncoding(): void;
        /**
         * @stability stable
         */
        get recordEncodingInput(): string | undefined;
        private _recordColumns?;
        /**
         * @stability stable
         */
        get recordColumns(): KinesisAnalyticsApplicationInputsSchemaRecordColumns[];
        /**
         * @stability stable
         */
        set recordColumns(value: KinesisAnalyticsApplicationInputsSchemaRecordColumns[]);
        /**
         * @stability stable
         */
        get recordColumnsInput(): KinesisAnalyticsApplicationInputsSchemaRecordColumns[] | undefined;
        private _recordFormat?;
        private __recordFormatOutput;
        /**
         * @stability stable
         */
        get recordFormat(): KinesisAnalyticsApplicationInputsSchemaRecordFormatOutputReference;
        /**
         * @stability stable
         */
        putRecordFormat(value: KinesisAnalyticsApplicationInputsSchemaRecordFormat): void;
        /**
         * @stability stable
         */
        get recordFormatInput(): KinesisAnalyticsApplicationInputsSchemaRecordFormat | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationInputsStartingPositionConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#starting_position KinesisAnalyticsApplication#starting_position}.
         *
         * @stability stable
         */
        readonly startingPosition?: string;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationInputs {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#name_prefix KinesisAnalyticsApplication#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix: string;
        /**
         * kinesis_firehose block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#kinesis_firehose KinesisAnalyticsApplication#kinesis_firehose}
         *
         * @stability stable
         */
        readonly kinesisFirehose?: KinesisAnalyticsApplicationInputsKinesisFirehose;
        /**
         * kinesis_stream block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#kinesis_stream KinesisAnalyticsApplication#kinesis_stream}
         *
         * @stability stable
         */
        readonly kinesisStream?: KinesisAnalyticsApplicationInputsKinesisStream;
        /**
         * parallelism block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#parallelism KinesisAnalyticsApplication#parallelism}
         *
         * @stability stable
         */
        readonly parallelism?: KinesisAnalyticsApplicationInputsParallelism;
        /**
         * processing_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#processing_configuration KinesisAnalyticsApplication#processing_configuration}
         *
         * @stability stable
         */
        readonly processingConfiguration?: KinesisAnalyticsApplicationInputsProcessingConfiguration;
        /**
         * schema block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#schema KinesisAnalyticsApplication#schema}
         *
         * @stability stable
         */
        readonly schema: KinesisAnalyticsApplicationInputsSchema;
        /**
         * starting_position_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#starting_position_configuration KinesisAnalyticsApplication#starting_position_configuration}
         *
         * @stability stable
         */
        readonly startingPositionConfiguration?: KinesisAnalyticsApplicationInputsStartingPositionConfiguration[];
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationInputsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string;
        /**
         * @stability stable
         */
        set namePrefix(value: string);
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        private _kinesisFirehose?;
        private __kinesisFirehoseOutput;
        /**
         * @stability stable
         */
        get kinesisFirehose(): KinesisAnalyticsApplicationInputsKinesisFirehoseOutputReference;
        /**
         * @stability stable
         */
        putKinesisFirehose(value: KinesisAnalyticsApplicationInputsKinesisFirehose | undefined): void;
        /**
         * @stability stable
         */
        resetKinesisFirehose(): void;
        /**
         * @stability stable
         */
        get kinesisFirehoseInput(): KinesisAnalyticsApplicationInputsKinesisFirehose | undefined;
        private _kinesisStream?;
        private __kinesisStreamOutput;
        /**
         * @stability stable
         */
        get kinesisStream(): KinesisAnalyticsApplicationInputsKinesisStreamOutputReference;
        /**
         * @stability stable
         */
        putKinesisStream(value: KinesisAnalyticsApplicationInputsKinesisStream | undefined): void;
        /**
         * @stability stable
         */
        resetKinesisStream(): void;
        /**
         * @stability stable
         */
        get kinesisStreamInput(): KinesisAnalyticsApplicationInputsKinesisStream | undefined;
        private _parallelism?;
        private __parallelismOutput;
        /**
         * @stability stable
         */
        get parallelism(): KinesisAnalyticsApplicationInputsParallelismOutputReference;
        /**
         * @stability stable
         */
        putParallelism(value: KinesisAnalyticsApplicationInputsParallelism | undefined): void;
        /**
         * @stability stable
         */
        resetParallelism(): void;
        /**
         * @stability stable
         */
        get parallelismInput(): KinesisAnalyticsApplicationInputsParallelism | undefined;
        private _processingConfiguration?;
        private __processingConfigurationOutput;
        /**
         * @stability stable
         */
        get processingConfiguration(): KinesisAnalyticsApplicationInputsProcessingConfigurationOutputReference;
        /**
         * @stability stable
         */
        putProcessingConfiguration(value: KinesisAnalyticsApplicationInputsProcessingConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetProcessingConfiguration(): void;
        /**
         * @stability stable
         */
        get processingConfigurationInput(): KinesisAnalyticsApplicationInputsProcessingConfiguration | undefined;
        private _schema?;
        private __schemaOutput;
        /**
         * @stability stable
         */
        get schema(): KinesisAnalyticsApplicationInputsSchemaOutputReference;
        /**
         * @stability stable
         */
        putSchema(value: KinesisAnalyticsApplicationInputsSchema): void;
        /**
         * @stability stable
         */
        get schemaInput(): KinesisAnalyticsApplicationInputsSchema | undefined;
        private _startingPositionConfiguration?;
        /**
         * @stability stable
         */
        get startingPositionConfiguration(): KinesisAnalyticsApplicationInputsStartingPositionConfiguration[] | undefined;
        /**
         * @stability stable
         */
        set startingPositionConfiguration(value: KinesisAnalyticsApplicationInputsStartingPositionConfiguration[] | undefined);
        /**
         * @stability stable
         */
        resetStartingPositionConfiguration(): void;
        /**
         * @stability stable
         */
        get startingPositionConfigurationInput(): KinesisAnalyticsApplicationInputsStartingPositionConfiguration[] | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationOutputsKinesisFirehose {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#resource_arn KinesisAnalyticsApplication#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#role_arn KinesisAnalyticsApplication#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationOutputsKinesisFirehoseOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _resourceArn?;
        /**
         * @stability stable
         */
        get resourceArn(): string;
        /**
         * @stability stable
         */
        set resourceArn(value: string);
        /**
         * @stability stable
         */
        get resourceArnInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationOutputsKinesisStream {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#resource_arn KinesisAnalyticsApplication#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#role_arn KinesisAnalyticsApplication#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationOutputsKinesisStreamOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _resourceArn?;
        /**
         * @stability stable
         */
        get resourceArn(): string;
        /**
         * @stability stable
         */
        set resourceArn(value: string);
        /**
         * @stability stable
         */
        get resourceArnInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationOutputsLambda {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#resource_arn KinesisAnalyticsApplication#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#role_arn KinesisAnalyticsApplication#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationOutputsLambdaOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _resourceArn?;
        /**
         * @stability stable
         */
        get resourceArn(): string;
        /**
         * @stability stable
         */
        set resourceArn(value: string);
        /**
         * @stability stable
         */
        get resourceArnInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationOutputsSchema {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#record_format_type KinesisAnalyticsApplication#record_format_type}.
         *
         * @stability stable
         */
        readonly recordFormatType: string;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationOutputsSchemaOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _recordFormatType?;
        /**
         * @stability stable
         */
        get recordFormatType(): string;
        /**
         * @stability stable
         */
        set recordFormatType(value: string);
        /**
         * @stability stable
         */
        get recordFormatTypeInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationOutputs {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#name KinesisAnalyticsApplication#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * kinesis_firehose block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#kinesis_firehose KinesisAnalyticsApplication#kinesis_firehose}
         *
         * @stability stable
         */
        readonly kinesisFirehose?: KinesisAnalyticsApplicationOutputsKinesisFirehose;
        /**
         * kinesis_stream block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#kinesis_stream KinesisAnalyticsApplication#kinesis_stream}
         *
         * @stability stable
         */
        readonly kinesisStream?: KinesisAnalyticsApplicationOutputsKinesisStream;
        /**
         * lambda block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#lambda KinesisAnalyticsApplication#lambda}
         *
         * @stability stable
         */
        readonly lambda?: KinesisAnalyticsApplicationOutputsLambda;
        /**
         * schema block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#schema KinesisAnalyticsApplication#schema}
         *
         * @stability stable
         */
        readonly schema: KinesisAnalyticsApplicationOutputsSchema;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationReferenceDataSourcesS3 {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#bucket_arn KinesisAnalyticsApplication#bucket_arn}.
         *
         * @stability stable
         */
        readonly bucketArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#file_key KinesisAnalyticsApplication#file_key}.
         *
         * @stability stable
         */
        readonly fileKey: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#role_arn KinesisAnalyticsApplication#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationReferenceDataSourcesS3OutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bucketArn?;
        /**
         * @stability stable
         */
        get bucketArn(): string;
        /**
         * @stability stable
         */
        set bucketArn(value: string);
        /**
         * @stability stable
         */
        get bucketArnInput(): string | undefined;
        private _fileKey?;
        /**
         * @stability stable
         */
        get fileKey(): string;
        /**
         * @stability stable
         */
        set fileKey(value: string);
        /**
         * @stability stable
         */
        get fileKeyInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordColumns {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#mapping KinesisAnalyticsApplication#mapping}.
         *
         * @stability stable
         */
        readonly mapping?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#name KinesisAnalyticsApplication#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#sql_type KinesisAnalyticsApplication#sql_type}.
         *
         * @stability stable
         */
        readonly sqlType: string;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParametersCsv {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#record_column_delimiter KinesisAnalyticsApplication#record_column_delimiter}.
         *
         * @stability stable
         */
        readonly recordColumnDelimiter: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#record_row_delimiter KinesisAnalyticsApplication#record_row_delimiter}.
         *
         * @stability stable
         */
        readonly recordRowDelimiter: string;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParametersCsvOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _recordColumnDelimiter?;
        /**
         * @stability stable
         */
        get recordColumnDelimiter(): string;
        /**
         * @stability stable
         */
        set recordColumnDelimiter(value: string);
        /**
         * @stability stable
         */
        get recordColumnDelimiterInput(): string | undefined;
        private _recordRowDelimiter?;
        /**
         * @stability stable
         */
        get recordRowDelimiter(): string;
        /**
         * @stability stable
         */
        set recordRowDelimiter(value: string);
        /**
         * @stability stable
         */
        get recordRowDelimiterInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParametersJson {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#record_row_path KinesisAnalyticsApplication#record_row_path}.
         *
         * @stability stable
         */
        readonly recordRowPath: string;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParametersJsonOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _recordRowPath?;
        /**
         * @stability stable
         */
        get recordRowPath(): string;
        /**
         * @stability stable
         */
        set recordRowPath(value: string);
        /**
         * @stability stable
         */
        get recordRowPathInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParameters {
        /**
         * csv block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#csv KinesisAnalyticsApplication#csv}
         *
         * @stability stable
         */
        readonly csv?: KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParametersCsv;
        /**
         * json block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#json KinesisAnalyticsApplication#json}
         *
         * @stability stable
         */
        readonly json?: KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParametersJson;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParametersOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _csv?;
        private __csvOutput;
        /**
         * @stability stable
         */
        get csv(): KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParametersCsvOutputReference;
        /**
         * @stability stable
         */
        putCsv(value: KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParametersCsv | undefined): void;
        /**
         * @stability stable
         */
        resetCsv(): void;
        /**
         * @stability stable
         */
        get csvInput(): KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParametersCsv | undefined;
        private _json?;
        private __jsonOutput;
        /**
         * @stability stable
         */
        get json(): KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParametersJsonOutputReference;
        /**
         * @stability stable
         */
        putJson(value: KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParametersJson | undefined): void;
        /**
         * @stability stable
         */
        resetJson(): void;
        /**
         * @stability stable
         */
        get jsonInput(): KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParametersJson | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormat {
        /**
         * mapping_parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#mapping_parameters KinesisAnalyticsApplication#mapping_parameters}
         *
         * @stability stable
         */
        readonly mappingParameters?: KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParameters;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _mappingParameters?;
        private __mappingParametersOutput;
        /**
         * @stability stable
         */
        get mappingParameters(): KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParametersOutputReference;
        /**
         * @stability stable
         */
        putMappingParameters(value: KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParameters | undefined): void;
        /**
         * @stability stable
         */
        resetMappingParameters(): void;
        /**
         * @stability stable
         */
        get mappingParametersInput(): KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatMappingParameters | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationReferenceDataSourcesSchema {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#record_encoding KinesisAnalyticsApplication#record_encoding}.
         *
         * @stability stable
         */
        readonly recordEncoding?: string;
        /**
         * record_columns block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#record_columns KinesisAnalyticsApplication#record_columns}
         *
         * @stability stable
         */
        readonly recordColumns: KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordColumns[];
        /**
         * record_format block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#record_format KinesisAnalyticsApplication#record_format}
         *
         * @stability stable
         */
        readonly recordFormat: KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormat;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationReferenceDataSourcesSchemaOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _recordEncoding?;
        /**
         * @stability stable
         */
        get recordEncoding(): string | undefined;
        /**
         * @stability stable
         */
        set recordEncoding(value: string | undefined);
        /**
         * @stability stable
         */
        resetRecordEncoding(): void;
        /**
         * @stability stable
         */
        get recordEncodingInput(): string | undefined;
        private _recordColumns?;
        /**
         * @stability stable
         */
        get recordColumns(): KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordColumns[];
        /**
         * @stability stable
         */
        set recordColumns(value: KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordColumns[]);
        /**
         * @stability stable
         */
        get recordColumnsInput(): KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordColumns[] | undefined;
        private _recordFormat?;
        private __recordFormatOutput;
        /**
         * @stability stable
         */
        get recordFormat(): KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormatOutputReference;
        /**
         * @stability stable
         */
        putRecordFormat(value: KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormat): void;
        /**
         * @stability stable
         */
        get recordFormatInput(): KinesisAnalyticsApplicationReferenceDataSourcesSchemaRecordFormat | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisAnalyticsApplicationReferenceDataSources {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#table_name KinesisAnalyticsApplication#table_name}.
         *
         * @stability stable
         */
        readonly tableName: string;
        /**
         * s3 block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#s3 KinesisAnalyticsApplication#s3}
         *
         * @stability stable
         */
        readonly s3: KinesisAnalyticsApplicationReferenceDataSourcesS3;
        /**
         * schema block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html#schema KinesisAnalyticsApplication#schema}
         *
         * @stability stable
         */
        readonly schema: KinesisAnalyticsApplicationReferenceDataSourcesSchema;
    }
    /**
     * @stability stable
     */
    class KinesisAnalyticsApplicationReferenceDataSourcesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _tableName?;
        /**
         * @stability stable
         */
        get tableName(): string;
        /**
         * @stability stable
         */
        set tableName(value: string);
        /**
         * @stability stable
         */
        get tableNameInput(): string | undefined;
        private _s3?;
        private __s3Output;
        /**
         * @stability stable
         */
        get s3(): KinesisAnalyticsApplicationReferenceDataSourcesS3OutputReference;
        /**
         * @stability stable
         */
        putS3(value: KinesisAnalyticsApplicationReferenceDataSourcesS3): void;
        /**
         * @stability stable
         */
        get s3Input(): KinesisAnalyticsApplicationReferenceDataSourcesS3 | undefined;
        private _schema?;
        private __schemaOutput;
        /**
         * @stability stable
         */
        get schema(): KinesisAnalyticsApplicationReferenceDataSourcesSchemaOutputReference;
        /**
         * @stability stable
         */
        putSchema(value: KinesisAnalyticsApplicationReferenceDataSourcesSchema): void;
        /**
         * @stability stable
         */
        get schemaInput(): KinesisAnalyticsApplicationReferenceDataSourcesSchema | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html aws_kinesis_analytics_application}.
     *
     * @stability stable
     */
    class KinesisAnalyticsApplication extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/kinesis_analytics_application.html aws_kinesis_analytics_application} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: KinesisAnalyticsApplicationConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _code?;
        /**
         * @stability stable
         */
        get code(): string | undefined;
        /**
         * @stability stable
         */
        set code(value: string | undefined);
        /**
         * @stability stable
         */
        resetCode(): void;
        /**
         * @stability stable
         */
        get codeInput(): string | undefined;
        /**
         * @stability stable
         */
        get createTimestamp(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdateTimestamp(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _startApplication?;
        /**
         * @stability stable
         */
        get startApplication(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set startApplication(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetStartApplication(): void;
        /**
         * @stability stable
         */
        get startApplicationInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get version(): number;
        private _cloudwatchLoggingOptions?;
        private __cloudwatchLoggingOptionsOutput;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptions(): KinesisAnalyticsApplicationCloudwatchLoggingOptionsOutputReference;
        /**
         * @stability stable
         */
        putCloudwatchLoggingOptions(value: KinesisAnalyticsApplicationCloudwatchLoggingOptions | undefined): void;
        /**
         * @stability stable
         */
        resetCloudwatchLoggingOptions(): void;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptionsInput(): KinesisAnalyticsApplicationCloudwatchLoggingOptions | undefined;
        private _inputs?;
        private __inputsOutput;
        /**
         * @stability stable
         */
        get inputs(): KinesisAnalyticsApplicationInputsOutputReference;
        /**
         * @stability stable
         */
        putInputs(value: KinesisAnalyticsApplicationInputs | undefined): void;
        /**
         * @stability stable
         */
        resetInputs(): void;
        /**
         * @stability stable
         */
        get inputsInput(): KinesisAnalyticsApplicationInputs | undefined;
        private _outputs?;
        /**
         * @stability stable
         */
        get outputs(): KinesisAnalyticsApplicationOutputs[] | undefined;
        /**
         * @stability stable
         */
        set outputs(value: KinesisAnalyticsApplicationOutputs[] | undefined);
        /**
         * @stability stable
         */
        resetOutputs(): void;
        /**
         * @stability stable
         */
        get outputsInput(): KinesisAnalyticsApplicationOutputs[] | undefined;
        private _referenceDataSources?;
        private __referenceDataSourcesOutput;
        /**
         * @stability stable
         */
        get referenceDataSources(): KinesisAnalyticsApplicationReferenceDataSourcesOutputReference;
        /**
         * @stability stable
         */
        putReferenceDataSources(value: KinesisAnalyticsApplicationReferenceDataSources | undefined): void;
        /**
         * @stability stable
         */
        resetReferenceDataSources(): void;
        /**
         * @stability stable
         */
        get referenceDataSourcesInput(): KinesisAnalyticsApplicationReferenceDataSources | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#destination KinesisFirehoseDeliveryStream#destination}.
         *
         * @stability stable
         */
        readonly destination: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#destination_id KinesisFirehoseDeliveryStream#destination_id}.
         *
         * @stability stable
         */
        readonly destinationId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#name KinesisFirehoseDeliveryStream#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#tags KinesisFirehoseDeliveryStream#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#tags_all KinesisFirehoseDeliveryStream#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#version_id KinesisFirehoseDeliveryStream#version_id}.
         *
         * @stability stable
         */
        readonly versionId?: string;
        /**
         * elasticsearch_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#elasticsearch_configuration KinesisFirehoseDeliveryStream#elasticsearch_configuration}
         *
         * @stability stable
         */
        readonly elasticsearchConfiguration?: KinesisFirehoseDeliveryStreamElasticsearchConfiguration;
        /**
         * extended_s3_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#extended_s3_configuration KinesisFirehoseDeliveryStream#extended_s3_configuration}
         *
         * @stability stable
         */
        readonly extendedS3Configuration?: KinesisFirehoseDeliveryStreamExtendedS3Configuration;
        /**
         * http_endpoint_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#http_endpoint_configuration KinesisFirehoseDeliveryStream#http_endpoint_configuration}
         *
         * @stability stable
         */
        readonly httpEndpointConfiguration?: KinesisFirehoseDeliveryStreamHttpEndpointConfiguration;
        /**
         * kinesis_source_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#kinesis_source_configuration KinesisFirehoseDeliveryStream#kinesis_source_configuration}
         *
         * @stability stable
         */
        readonly kinesisSourceConfiguration?: KinesisFirehoseDeliveryStreamKinesisSourceConfiguration;
        /**
         * redshift_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#redshift_configuration KinesisFirehoseDeliveryStream#redshift_configuration}
         *
         * @stability stable
         */
        readonly redshiftConfiguration?: KinesisFirehoseDeliveryStreamRedshiftConfiguration;
        /**
         * s3_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#s3_configuration KinesisFirehoseDeliveryStream#s3_configuration}
         *
         * @stability stable
         */
        readonly s3Configuration?: KinesisFirehoseDeliveryStreamS3Configuration;
        /**
         * server_side_encryption block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#server_side_encryption KinesisFirehoseDeliveryStream#server_side_encryption}
         *
         * @stability stable
         */
        readonly serverSideEncryption?: KinesisFirehoseDeliveryStreamServerSideEncryption;
        /**
         * splunk_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#splunk_configuration KinesisFirehoseDeliveryStream#splunk_configuration}
         *
         * @stability stable
         */
        readonly splunkConfiguration?: KinesisFirehoseDeliveryStreamSplunkConfiguration;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamElasticsearchConfigurationCloudwatchLoggingOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enabled KinesisFirehoseDeliveryStream#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#log_group_name KinesisFirehoseDeliveryStream#log_group_name}.
         *
         * @stability stable
         */
        readonly logGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#log_stream_name KinesisFirehoseDeliveryStream#log_stream_name}.
         *
         * @stability stable
         */
        readonly logStreamName?: string;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamElasticsearchConfigurationCloudwatchLoggingOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _logGroupName?;
        /**
         * @stability stable
         */
        get logGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set logGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogGroupName(): void;
        /**
         * @stability stable
         */
        get logGroupNameInput(): string | undefined;
        private _logStreamName?;
        /**
         * @stability stable
         */
        get logStreamName(): string | undefined;
        /**
         * @stability stable
         */
        set logStreamName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogStreamName(): void;
        /**
         * @stability stable
         */
        get logStreamNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfigurationProcessorsParameters {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#parameter_name KinesisFirehoseDeliveryStream#parameter_name}.
         *
         * @stability stable
         */
        readonly parameterName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#parameter_value KinesisFirehoseDeliveryStream#parameter_value}.
         *
         * @stability stable
         */
        readonly parameterValue: string;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfigurationProcessors {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#type KinesisFirehoseDeliveryStream#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#parameters KinesisFirehoseDeliveryStream#parameters}
         *
         * @stability stable
         */
        readonly parameters?: KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfigurationProcessorsParameters[];
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enabled KinesisFirehoseDeliveryStream#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * processors block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#processors KinesisFirehoseDeliveryStream#processors}
         *
         * @stability stable
         */
        readonly processors?: KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfigurationProcessors[];
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _processors?;
        /**
         * @stability stable
         */
        get processors(): KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfigurationProcessors[] | undefined;
        /**
         * @stability stable
         */
        set processors(value: KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfigurationProcessors[] | undefined);
        /**
         * @stability stable
         */
        resetProcessors(): void;
        /**
         * @stability stable
         */
        get processorsInput(): KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfigurationProcessors[] | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamElasticsearchConfigurationVpcConfig {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#role_arn KinesisFirehoseDeliveryStream#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#security_group_ids KinesisFirehoseDeliveryStream#security_group_ids}.
         *
         * @stability stable
         */
        readonly securityGroupIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#subnet_ids KinesisFirehoseDeliveryStream#subnet_ids}.
         *
         * @stability stable
         */
        readonly subnetIds: string[];
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamElasticsearchConfigurationVpcConfigOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        private _securityGroupIds?;
        /**
         * @stability stable
         */
        get securityGroupIds(): string[];
        /**
         * @stability stable
         */
        set securityGroupIds(value: string[]);
        /**
         * @stability stable
         */
        get securityGroupIdsInput(): string[] | undefined;
        private _subnetIds?;
        /**
         * @stability stable
         */
        get subnetIds(): string[];
        /**
         * @stability stable
         */
        set subnetIds(value: string[]);
        /**
         * @stability stable
         */
        get subnetIdsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamElasticsearchConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#buffering_interval KinesisFirehoseDeliveryStream#buffering_interval}.
         *
         * @stability stable
         */
        readonly bufferingInterval?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#buffering_size KinesisFirehoseDeliveryStream#buffering_size}.
         *
         * @stability stable
         */
        readonly bufferingSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#cluster_endpoint KinesisFirehoseDeliveryStream#cluster_endpoint}.
         *
         * @stability stable
         */
        readonly clusterEndpoint?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#domain_arn KinesisFirehoseDeliveryStream#domain_arn}.
         *
         * @stability stable
         */
        readonly domainArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#index_name KinesisFirehoseDeliveryStream#index_name}.
         *
         * @stability stable
         */
        readonly indexName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#index_rotation_period KinesisFirehoseDeliveryStream#index_rotation_period}.
         *
         * @stability stable
         */
        readonly indexRotationPeriod?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#retry_duration KinesisFirehoseDeliveryStream#retry_duration}.
         *
         * @stability stable
         */
        readonly retryDuration?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#role_arn KinesisFirehoseDeliveryStream#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#s3_backup_mode KinesisFirehoseDeliveryStream#s3_backup_mode}.
         *
         * @stability stable
         */
        readonly s3BackupMode?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#type_name KinesisFirehoseDeliveryStream#type_name}.
         *
         * @stability stable
         */
        readonly typeName?: string;
        /**
         * cloudwatch_logging_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#cloudwatch_logging_options KinesisFirehoseDeliveryStream#cloudwatch_logging_options}
         *
         * @stability stable
         */
        readonly cloudwatchLoggingOptions?: KinesisFirehoseDeliveryStreamElasticsearchConfigurationCloudwatchLoggingOptions;
        /**
         * processing_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#processing_configuration KinesisFirehoseDeliveryStream#processing_configuration}
         *
         * @stability stable
         */
        readonly processingConfiguration?: KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfiguration;
        /**
         * vpc_config block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#vpc_config KinesisFirehoseDeliveryStream#vpc_config}
         *
         * @stability stable
         */
        readonly vpcConfig?: KinesisFirehoseDeliveryStreamElasticsearchConfigurationVpcConfig;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamElasticsearchConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bufferingInterval?;
        /**
         * @stability stable
         */
        get bufferingInterval(): number | undefined;
        /**
         * @stability stable
         */
        set bufferingInterval(value: number | undefined);
        /**
         * @stability stable
         */
        resetBufferingInterval(): void;
        /**
         * @stability stable
         */
        get bufferingIntervalInput(): number | undefined;
        private _bufferingSize?;
        /**
         * @stability stable
         */
        get bufferingSize(): number | undefined;
        /**
         * @stability stable
         */
        set bufferingSize(value: number | undefined);
        /**
         * @stability stable
         */
        resetBufferingSize(): void;
        /**
         * @stability stable
         */
        get bufferingSizeInput(): number | undefined;
        private _clusterEndpoint?;
        /**
         * @stability stable
         */
        get clusterEndpoint(): string | undefined;
        /**
         * @stability stable
         */
        set clusterEndpoint(value: string | undefined);
        /**
         * @stability stable
         */
        resetClusterEndpoint(): void;
        /**
         * @stability stable
         */
        get clusterEndpointInput(): string | undefined;
        private _domainArn?;
        /**
         * @stability stable
         */
        get domainArn(): string | undefined;
        /**
         * @stability stable
         */
        set domainArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetDomainArn(): void;
        /**
         * @stability stable
         */
        get domainArnInput(): string | undefined;
        private _indexName?;
        /**
         * @stability stable
         */
        get indexName(): string;
        /**
         * @stability stable
         */
        set indexName(value: string);
        /**
         * @stability stable
         */
        get indexNameInput(): string | undefined;
        private _indexRotationPeriod?;
        /**
         * @stability stable
         */
        get indexRotationPeriod(): string | undefined;
        /**
         * @stability stable
         */
        set indexRotationPeriod(value: string | undefined);
        /**
         * @stability stable
         */
        resetIndexRotationPeriod(): void;
        /**
         * @stability stable
         */
        get indexRotationPeriodInput(): string | undefined;
        private _retryDuration?;
        /**
         * @stability stable
         */
        get retryDuration(): number | undefined;
        /**
         * @stability stable
         */
        set retryDuration(value: number | undefined);
        /**
         * @stability stable
         */
        resetRetryDuration(): void;
        /**
         * @stability stable
         */
        get retryDurationInput(): number | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        private _s3BackupMode?;
        /**
         * @stability stable
         */
        get s3BackupMode(): string | undefined;
        /**
         * @stability stable
         */
        set s3BackupMode(value: string | undefined);
        /**
         * @stability stable
         */
        resetS3BackupMode(): void;
        /**
         * @stability stable
         */
        get s3BackupModeInput(): string | undefined;
        private _typeName?;
        /**
         * @stability stable
         */
        get typeName(): string | undefined;
        /**
         * @stability stable
         */
        set typeName(value: string | undefined);
        /**
         * @stability stable
         */
        resetTypeName(): void;
        /**
         * @stability stable
         */
        get typeNameInput(): string | undefined;
        private _cloudwatchLoggingOptions?;
        private __cloudwatchLoggingOptionsOutput;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptions(): KinesisFirehoseDeliveryStreamElasticsearchConfigurationCloudwatchLoggingOptionsOutputReference;
        /**
         * @stability stable
         */
        putCloudwatchLoggingOptions(value: KinesisFirehoseDeliveryStreamElasticsearchConfigurationCloudwatchLoggingOptions | undefined): void;
        /**
         * @stability stable
         */
        resetCloudwatchLoggingOptions(): void;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptionsInput(): KinesisFirehoseDeliveryStreamElasticsearchConfigurationCloudwatchLoggingOptions | undefined;
        private _processingConfiguration?;
        private __processingConfigurationOutput;
        /**
         * @stability stable
         */
        get processingConfiguration(): KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfigurationOutputReference;
        /**
         * @stability stable
         */
        putProcessingConfiguration(value: KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetProcessingConfiguration(): void;
        /**
         * @stability stable
         */
        get processingConfigurationInput(): KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfiguration | undefined;
        private _vpcConfig?;
        private __vpcConfigOutput;
        /**
         * @stability stable
         */
        get vpcConfig(): KinesisFirehoseDeliveryStreamElasticsearchConfigurationVpcConfigOutputReference;
        /**
         * @stability stable
         */
        putVpcConfig(value: KinesisFirehoseDeliveryStreamElasticsearchConfigurationVpcConfig | undefined): void;
        /**
         * @stability stable
         */
        resetVpcConfig(): void;
        /**
         * @stability stable
         */
        get vpcConfigInput(): KinesisFirehoseDeliveryStreamElasticsearchConfigurationVpcConfig | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationCloudwatchLoggingOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enabled KinesisFirehoseDeliveryStream#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#log_group_name KinesisFirehoseDeliveryStream#log_group_name}.
         *
         * @stability stable
         */
        readonly logGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#log_stream_name KinesisFirehoseDeliveryStream#log_stream_name}.
         *
         * @stability stable
         */
        readonly logStreamName?: string;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamExtendedS3ConfigurationCloudwatchLoggingOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _logGroupName?;
        /**
         * @stability stable
         */
        get logGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set logGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogGroupName(): void;
        /**
         * @stability stable
         */
        get logGroupNameInput(): string | undefined;
        private _logStreamName?;
        /**
         * @stability stable
         */
        get logStreamName(): string | undefined;
        /**
         * @stability stable
         */
        set logStreamName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogStreamName(): void;
        /**
         * @stability stable
         */
        get logStreamNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerHiveJsonSerDe {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#timestamp_formats KinesisFirehoseDeliveryStream#timestamp_formats}.
         *
         * @stability stable
         */
        readonly timestampFormats?: string[];
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerHiveJsonSerDeOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _timestampFormats?;
        /**
         * @stability stable
         */
        get timestampFormats(): string[] | undefined;
        /**
         * @stability stable
         */
        set timestampFormats(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetTimestampFormats(): void;
        /**
         * @stability stable
         */
        get timestampFormatsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerOpenXJsonSerDe {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#case_insensitive KinesisFirehoseDeliveryStream#case_insensitive}.
         *
         * @stability stable
         */
        readonly caseInsensitive?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#column_to_json_key_mappings KinesisFirehoseDeliveryStream#column_to_json_key_mappings}.
         *
         * @stability stable
         */
        readonly columnToJsonKeyMappings?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#convert_dots_in_json_keys_to_underscores KinesisFirehoseDeliveryStream#convert_dots_in_json_keys_to_underscores}.
         *
         * @stability stable
         */
        readonly convertDotsInJsonKeysToUnderscores?: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerOpenXJsonSerDeOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _caseInsensitive?;
        /**
         * @stability stable
         */
        get caseInsensitive(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set caseInsensitive(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetCaseInsensitive(): void;
        /**
         * @stability stable
         */
        get caseInsensitiveInput(): boolean | cdktf.IResolvable | undefined;
        private _columnToJsonKeyMappings?;
        /**
         * @stability stable
         */
        get columnToJsonKeyMappings(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set columnToJsonKeyMappings(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetColumnToJsonKeyMappings(): void;
        /**
         * @stability stable
         */
        get columnToJsonKeyMappingsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _convertDotsInJsonKeysToUnderscores?;
        /**
         * @stability stable
         */
        get convertDotsInJsonKeysToUnderscores(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set convertDotsInJsonKeysToUnderscores(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetConvertDotsInJsonKeysToUnderscores(): void;
        /**
         * @stability stable
         */
        get convertDotsInJsonKeysToUnderscoresInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializer {
        /**
         * hive_json_ser_de block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#hive_json_ser_de KinesisFirehoseDeliveryStream#hive_json_ser_de}
         *
         * @stability stable
         */
        readonly hiveJsonSerDe?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerHiveJsonSerDe;
        /**
         * open_x_json_ser_de block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#open_x_json_ser_de KinesisFirehoseDeliveryStream#open_x_json_ser_de}
         *
         * @stability stable
         */
        readonly openXJsonSerDe?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerOpenXJsonSerDe;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _hiveJsonSerDe?;
        private __hiveJsonSerDeOutput;
        /**
         * @stability stable
         */
        get hiveJsonSerDe(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerHiveJsonSerDeOutputReference;
        /**
         * @stability stable
         */
        putHiveJsonSerDe(value: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerHiveJsonSerDe | undefined): void;
        /**
         * @stability stable
         */
        resetHiveJsonSerDe(): void;
        /**
         * @stability stable
         */
        get hiveJsonSerDeInput(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerHiveJsonSerDe | undefined;
        private _openXJsonSerDe?;
        private __openXJsonSerDeOutput;
        /**
         * @stability stable
         */
        get openXJsonSerDe(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerOpenXJsonSerDeOutputReference;
        /**
         * @stability stable
         */
        putOpenXJsonSerDe(value: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerOpenXJsonSerDe | undefined): void;
        /**
         * @stability stable
         */
        resetOpenXJsonSerDe(): void;
        /**
         * @stability stable
         */
        get openXJsonSerDeInput(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerOpenXJsonSerDe | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfiguration {
        /**
         * deserializer block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#deserializer KinesisFirehoseDeliveryStream#deserializer}
         *
         * @stability stable
         */
        readonly deserializer: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializer;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _deserializer?;
        private __deserializerOutput;
        /**
         * @stability stable
         */
        get deserializer(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerOutputReference;
        /**
         * @stability stable
         */
        putDeserializer(value: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializer): void;
        /**
         * @stability stable
         */
        get deserializerInput(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializer | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerOrcSerDe {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#block_size_bytes KinesisFirehoseDeliveryStream#block_size_bytes}.
         *
         * @stability stable
         */
        readonly blockSizeBytes?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#bloom_filter_columns KinesisFirehoseDeliveryStream#bloom_filter_columns}.
         *
         * @stability stable
         */
        readonly bloomFilterColumns?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#bloom_filter_false_positive_probability KinesisFirehoseDeliveryStream#bloom_filter_false_positive_probability}.
         *
         * @stability stable
         */
        readonly bloomFilterFalsePositiveProbability?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#compression KinesisFirehoseDeliveryStream#compression}.
         *
         * @stability stable
         */
        readonly compression?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#dictionary_key_threshold KinesisFirehoseDeliveryStream#dictionary_key_threshold}.
         *
         * @stability stable
         */
        readonly dictionaryKeyThreshold?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enable_padding KinesisFirehoseDeliveryStream#enable_padding}.
         *
         * @stability stable
         */
        readonly enablePadding?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#format_version KinesisFirehoseDeliveryStream#format_version}.
         *
         * @stability stable
         */
        readonly formatVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#padding_tolerance KinesisFirehoseDeliveryStream#padding_tolerance}.
         *
         * @stability stable
         */
        readonly paddingTolerance?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#row_index_stride KinesisFirehoseDeliveryStream#row_index_stride}.
         *
         * @stability stable
         */
        readonly rowIndexStride?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#stripe_size_bytes KinesisFirehoseDeliveryStream#stripe_size_bytes}.
         *
         * @stability stable
         */
        readonly stripeSizeBytes?: number;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerOrcSerDeOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _blockSizeBytes?;
        /**
         * @stability stable
         */
        get blockSizeBytes(): number | undefined;
        /**
         * @stability stable
         */
        set blockSizeBytes(value: number | undefined);
        /**
         * @stability stable
         */
        resetBlockSizeBytes(): void;
        /**
         * @stability stable
         */
        get blockSizeBytesInput(): number | undefined;
        private _bloomFilterColumns?;
        /**
         * @stability stable
         */
        get bloomFilterColumns(): string[] | undefined;
        /**
         * @stability stable
         */
        set bloomFilterColumns(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetBloomFilterColumns(): void;
        /**
         * @stability stable
         */
        get bloomFilterColumnsInput(): string[] | undefined;
        private _bloomFilterFalsePositiveProbability?;
        /**
         * @stability stable
         */
        get bloomFilterFalsePositiveProbability(): number | undefined;
        /**
         * @stability stable
         */
        set bloomFilterFalsePositiveProbability(value: number | undefined);
        /**
         * @stability stable
         */
        resetBloomFilterFalsePositiveProbability(): void;
        /**
         * @stability stable
         */
        get bloomFilterFalsePositiveProbabilityInput(): number | undefined;
        private _compression?;
        /**
         * @stability stable
         */
        get compression(): string | undefined;
        /**
         * @stability stable
         */
        set compression(value: string | undefined);
        /**
         * @stability stable
         */
        resetCompression(): void;
        /**
         * @stability stable
         */
        get compressionInput(): string | undefined;
        private _dictionaryKeyThreshold?;
        /**
         * @stability stable
         */
        get dictionaryKeyThreshold(): number | undefined;
        /**
         * @stability stable
         */
        set dictionaryKeyThreshold(value: number | undefined);
        /**
         * @stability stable
         */
        resetDictionaryKeyThreshold(): void;
        /**
         * @stability stable
         */
        get dictionaryKeyThresholdInput(): number | undefined;
        private _enablePadding?;
        /**
         * @stability stable
         */
        get enablePadding(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enablePadding(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnablePadding(): void;
        /**
         * @stability stable
         */
        get enablePaddingInput(): boolean | cdktf.IResolvable | undefined;
        private _formatVersion?;
        /**
         * @stability stable
         */
        get formatVersion(): string | undefined;
        /**
         * @stability stable
         */
        set formatVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetFormatVersion(): void;
        /**
         * @stability stable
         */
        get formatVersionInput(): string | undefined;
        private _paddingTolerance?;
        /**
         * @stability stable
         */
        get paddingTolerance(): number | undefined;
        /**
         * @stability stable
         */
        set paddingTolerance(value: number | undefined);
        /**
         * @stability stable
         */
        resetPaddingTolerance(): void;
        /**
         * @stability stable
         */
        get paddingToleranceInput(): number | undefined;
        private _rowIndexStride?;
        /**
         * @stability stable
         */
        get rowIndexStride(): number | undefined;
        /**
         * @stability stable
         */
        set rowIndexStride(value: number | undefined);
        /**
         * @stability stable
         */
        resetRowIndexStride(): void;
        /**
         * @stability stable
         */
        get rowIndexStrideInput(): number | undefined;
        private _stripeSizeBytes?;
        /**
         * @stability stable
         */
        get stripeSizeBytes(): number | undefined;
        /**
         * @stability stable
         */
        set stripeSizeBytes(value: number | undefined);
        /**
         * @stability stable
         */
        resetStripeSizeBytes(): void;
        /**
         * @stability stable
         */
        get stripeSizeBytesInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerParquetSerDe {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#block_size_bytes KinesisFirehoseDeliveryStream#block_size_bytes}.
         *
         * @stability stable
         */
        readonly blockSizeBytes?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#compression KinesisFirehoseDeliveryStream#compression}.
         *
         * @stability stable
         */
        readonly compression?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enable_dictionary_compression KinesisFirehoseDeliveryStream#enable_dictionary_compression}.
         *
         * @stability stable
         */
        readonly enableDictionaryCompression?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#max_padding_bytes KinesisFirehoseDeliveryStream#max_padding_bytes}.
         *
         * @stability stable
         */
        readonly maxPaddingBytes?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#page_size_bytes KinesisFirehoseDeliveryStream#page_size_bytes}.
         *
         * @stability stable
         */
        readonly pageSizeBytes?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#writer_version KinesisFirehoseDeliveryStream#writer_version}.
         *
         * @stability stable
         */
        readonly writerVersion?: string;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerParquetSerDeOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _blockSizeBytes?;
        /**
         * @stability stable
         */
        get blockSizeBytes(): number | undefined;
        /**
         * @stability stable
         */
        set blockSizeBytes(value: number | undefined);
        /**
         * @stability stable
         */
        resetBlockSizeBytes(): void;
        /**
         * @stability stable
         */
        get blockSizeBytesInput(): number | undefined;
        private _compression?;
        /**
         * @stability stable
         */
        get compression(): string | undefined;
        /**
         * @stability stable
         */
        set compression(value: string | undefined);
        /**
         * @stability stable
         */
        resetCompression(): void;
        /**
         * @stability stable
         */
        get compressionInput(): string | undefined;
        private _enableDictionaryCompression?;
        /**
         * @stability stable
         */
        get enableDictionaryCompression(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableDictionaryCompression(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableDictionaryCompression(): void;
        /**
         * @stability stable
         */
        get enableDictionaryCompressionInput(): boolean | cdktf.IResolvable | undefined;
        private _maxPaddingBytes?;
        /**
         * @stability stable
         */
        get maxPaddingBytes(): number | undefined;
        /**
         * @stability stable
         */
        set maxPaddingBytes(value: number | undefined);
        /**
         * @stability stable
         */
        resetMaxPaddingBytes(): void;
        /**
         * @stability stable
         */
        get maxPaddingBytesInput(): number | undefined;
        private _pageSizeBytes?;
        /**
         * @stability stable
         */
        get pageSizeBytes(): number | undefined;
        /**
         * @stability stable
         */
        set pageSizeBytes(value: number | undefined);
        /**
         * @stability stable
         */
        resetPageSizeBytes(): void;
        /**
         * @stability stable
         */
        get pageSizeBytesInput(): number | undefined;
        private _writerVersion?;
        /**
         * @stability stable
         */
        get writerVersion(): string | undefined;
        /**
         * @stability stable
         */
        set writerVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetWriterVersion(): void;
        /**
         * @stability stable
         */
        get writerVersionInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializer {
        /**
         * orc_ser_de block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#orc_ser_de KinesisFirehoseDeliveryStream#orc_ser_de}
         *
         * @stability stable
         */
        readonly orcSerDe?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerOrcSerDe;
        /**
         * parquet_ser_de block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#parquet_ser_de KinesisFirehoseDeliveryStream#parquet_ser_de}
         *
         * @stability stable
         */
        readonly parquetSerDe?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerParquetSerDe;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _orcSerDe?;
        private __orcSerDeOutput;
        /**
         * @stability stable
         */
        get orcSerDe(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerOrcSerDeOutputReference;
        /**
         * @stability stable
         */
        putOrcSerDe(value: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerOrcSerDe | undefined): void;
        /**
         * @stability stable
         */
        resetOrcSerDe(): void;
        /**
         * @stability stable
         */
        get orcSerDeInput(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerOrcSerDe | undefined;
        private _parquetSerDe?;
        private __parquetSerDeOutput;
        /**
         * @stability stable
         */
        get parquetSerDe(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerParquetSerDeOutputReference;
        /**
         * @stability stable
         */
        putParquetSerDe(value: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerParquetSerDe | undefined): void;
        /**
         * @stability stable
         */
        resetParquetSerDe(): void;
        /**
         * @stability stable
         */
        get parquetSerDeInput(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerParquetSerDe | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfiguration {
        /**
         * serializer block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#serializer KinesisFirehoseDeliveryStream#serializer}
         *
         * @stability stable
         */
        readonly serializer: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializer;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _serializer?;
        private __serializerOutput;
        /**
         * @stability stable
         */
        get serializer(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerOutputReference;
        /**
         * @stability stable
         */
        putSerializer(value: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializer): void;
        /**
         * @stability stable
         */
        get serializerInput(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializer | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationSchemaConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#catalog_id KinesisFirehoseDeliveryStream#catalog_id}.
         *
         * @stability stable
         */
        readonly catalogId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#database_name KinesisFirehoseDeliveryStream#database_name}.
         *
         * @stability stable
         */
        readonly databaseName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#region KinesisFirehoseDeliveryStream#region}.
         *
         * @stability stable
         */
        readonly region?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#role_arn KinesisFirehoseDeliveryStream#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#table_name KinesisFirehoseDeliveryStream#table_name}.
         *
         * @stability stable
         */
        readonly tableName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#version_id KinesisFirehoseDeliveryStream#version_id}.
         *
         * @stability stable
         */
        readonly versionId?: string;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationSchemaConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _catalogId?;
        /**
         * @stability stable
         */
        get catalogId(): string | undefined;
        /**
         * @stability stable
         */
        set catalogId(value: string | undefined);
        /**
         * @stability stable
         */
        resetCatalogId(): void;
        /**
         * @stability stable
         */
        get catalogIdInput(): string | undefined;
        private _databaseName?;
        /**
         * @stability stable
         */
        get databaseName(): string;
        /**
         * @stability stable
         */
        set databaseName(value: string);
        /**
         * @stability stable
         */
        get databaseNameInput(): string | undefined;
        private _region?;
        /**
         * @stability stable
         */
        get region(): string | undefined;
        /**
         * @stability stable
         */
        set region(value: string | undefined);
        /**
         * @stability stable
         */
        resetRegion(): void;
        /**
         * @stability stable
         */
        get regionInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        private _tableName?;
        /**
         * @stability stable
         */
        get tableName(): string;
        /**
         * @stability stable
         */
        set tableName(value: string);
        /**
         * @stability stable
         */
        get tableNameInput(): string | undefined;
        private _versionId?;
        /**
         * @stability stable
         */
        get versionId(): string | undefined;
        /**
         * @stability stable
         */
        set versionId(value: string | undefined);
        /**
         * @stability stable
         */
        resetVersionId(): void;
        /**
         * @stability stable
         */
        get versionIdInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enabled KinesisFirehoseDeliveryStream#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * input_format_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#input_format_configuration KinesisFirehoseDeliveryStream#input_format_configuration}
         *
         * @stability stable
         */
        readonly inputFormatConfiguration: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfiguration;
        /**
         * output_format_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#output_format_configuration KinesisFirehoseDeliveryStream#output_format_configuration}
         *
         * @stability stable
         */
        readonly outputFormatConfiguration: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfiguration;
        /**
         * schema_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#schema_configuration KinesisFirehoseDeliveryStream#schema_configuration}
         *
         * @stability stable
         */
        readonly schemaConfiguration: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationSchemaConfiguration;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _inputFormatConfiguration?;
        private __inputFormatConfigurationOutput;
        /**
         * @stability stable
         */
        get inputFormatConfiguration(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationOutputReference;
        /**
         * @stability stable
         */
        putInputFormatConfiguration(value: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfiguration): void;
        /**
         * @stability stable
         */
        get inputFormatConfigurationInput(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfiguration | undefined;
        private _outputFormatConfiguration?;
        private __outputFormatConfigurationOutput;
        /**
         * @stability stable
         */
        get outputFormatConfiguration(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationOutputReference;
        /**
         * @stability stable
         */
        putOutputFormatConfiguration(value: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfiguration): void;
        /**
         * @stability stable
         */
        get outputFormatConfigurationInput(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfiguration | undefined;
        private _schemaConfiguration?;
        private __schemaConfigurationOutput;
        /**
         * @stability stable
         */
        get schemaConfiguration(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationSchemaConfigurationOutputReference;
        /**
         * @stability stable
         */
        putSchemaConfiguration(value: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationSchemaConfiguration): void;
        /**
         * @stability stable
         */
        get schemaConfigurationInput(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationSchemaConfiguration | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfigurationProcessorsParameters {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#parameter_name KinesisFirehoseDeliveryStream#parameter_name}.
         *
         * @stability stable
         */
        readonly parameterName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#parameter_value KinesisFirehoseDeliveryStream#parameter_value}.
         *
         * @stability stable
         */
        readonly parameterValue: string;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfigurationProcessors {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#type KinesisFirehoseDeliveryStream#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#parameters KinesisFirehoseDeliveryStream#parameters}
         *
         * @stability stable
         */
        readonly parameters?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfigurationProcessorsParameters[];
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enabled KinesisFirehoseDeliveryStream#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * processors block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#processors KinesisFirehoseDeliveryStream#processors}
         *
         * @stability stable
         */
        readonly processors?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfigurationProcessors[];
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _processors?;
        /**
         * @stability stable
         */
        get processors(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfigurationProcessors[] | undefined;
        /**
         * @stability stable
         */
        set processors(value: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfigurationProcessors[] | undefined);
        /**
         * @stability stable
         */
        resetProcessors(): void;
        /**
         * @stability stable
         */
        get processorsInput(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfigurationProcessors[] | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationS3BackupConfigurationCloudwatchLoggingOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enabled KinesisFirehoseDeliveryStream#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#log_group_name KinesisFirehoseDeliveryStream#log_group_name}.
         *
         * @stability stable
         */
        readonly logGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#log_stream_name KinesisFirehoseDeliveryStream#log_stream_name}.
         *
         * @stability stable
         */
        readonly logStreamName?: string;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamExtendedS3ConfigurationS3BackupConfigurationCloudwatchLoggingOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _logGroupName?;
        /**
         * @stability stable
         */
        get logGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set logGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogGroupName(): void;
        /**
         * @stability stable
         */
        get logGroupNameInput(): string | undefined;
        private _logStreamName?;
        /**
         * @stability stable
         */
        get logStreamName(): string | undefined;
        /**
         * @stability stable
         */
        set logStreamName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogStreamName(): void;
        /**
         * @stability stable
         */
        get logStreamNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationS3BackupConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#bucket_arn KinesisFirehoseDeliveryStream#bucket_arn}.
         *
         * @stability stable
         */
        readonly bucketArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#buffer_interval KinesisFirehoseDeliveryStream#buffer_interval}.
         *
         * @stability stable
         */
        readonly bufferInterval?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#buffer_size KinesisFirehoseDeliveryStream#buffer_size}.
         *
         * @stability stable
         */
        readonly bufferSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#compression_format KinesisFirehoseDeliveryStream#compression_format}.
         *
         * @stability stable
         */
        readonly compressionFormat?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#kms_key_arn KinesisFirehoseDeliveryStream#kms_key_arn}.
         *
         * @stability stable
         */
        readonly kmsKeyArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#prefix KinesisFirehoseDeliveryStream#prefix}.
         *
         * @stability stable
         */
        readonly prefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#role_arn KinesisFirehoseDeliveryStream#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
        /**
         * cloudwatch_logging_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#cloudwatch_logging_options KinesisFirehoseDeliveryStream#cloudwatch_logging_options}
         *
         * @stability stable
         */
        readonly cloudwatchLoggingOptions?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationS3BackupConfigurationCloudwatchLoggingOptions;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamExtendedS3ConfigurationS3BackupConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bucketArn?;
        /**
         * @stability stable
         */
        get bucketArn(): string;
        /**
         * @stability stable
         */
        set bucketArn(value: string);
        /**
         * @stability stable
         */
        get bucketArnInput(): string | undefined;
        private _bufferInterval?;
        /**
         * @stability stable
         */
        get bufferInterval(): number | undefined;
        /**
         * @stability stable
         */
        set bufferInterval(value: number | undefined);
        /**
         * @stability stable
         */
        resetBufferInterval(): void;
        /**
         * @stability stable
         */
        get bufferIntervalInput(): number | undefined;
        private _bufferSize?;
        /**
         * @stability stable
         */
        get bufferSize(): number | undefined;
        /**
         * @stability stable
         */
        set bufferSize(value: number | undefined);
        /**
         * @stability stable
         */
        resetBufferSize(): void;
        /**
         * @stability stable
         */
        get bufferSizeInput(): number | undefined;
        private _compressionFormat?;
        /**
         * @stability stable
         */
        get compressionFormat(): string | undefined;
        /**
         * @stability stable
         */
        set compressionFormat(value: string | undefined);
        /**
         * @stability stable
         */
        resetCompressionFormat(): void;
        /**
         * @stability stable
         */
        get compressionFormatInput(): string | undefined;
        private _kmsKeyArn?;
        /**
         * @stability stable
         */
        get kmsKeyArn(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyArn(): void;
        /**
         * @stability stable
         */
        get kmsKeyArnInput(): string | undefined;
        private _prefix?;
        /**
         * @stability stable
         */
        get prefix(): string | undefined;
        /**
         * @stability stable
         */
        set prefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrefix(): void;
        /**
         * @stability stable
         */
        get prefixInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        private _cloudwatchLoggingOptions?;
        private __cloudwatchLoggingOptionsOutput;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptions(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationS3BackupConfigurationCloudwatchLoggingOptionsOutputReference;
        /**
         * @stability stable
         */
        putCloudwatchLoggingOptions(value: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationS3BackupConfigurationCloudwatchLoggingOptions | undefined): void;
        /**
         * @stability stable
         */
        resetCloudwatchLoggingOptions(): void;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptionsInput(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationS3BackupConfigurationCloudwatchLoggingOptions | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamExtendedS3Configuration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#bucket_arn KinesisFirehoseDeliveryStream#bucket_arn}.
         *
         * @stability stable
         */
        readonly bucketArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#buffer_interval KinesisFirehoseDeliveryStream#buffer_interval}.
         *
         * @stability stable
         */
        readonly bufferInterval?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#buffer_size KinesisFirehoseDeliveryStream#buffer_size}.
         *
         * @stability stable
         */
        readonly bufferSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#compression_format KinesisFirehoseDeliveryStream#compression_format}.
         *
         * @stability stable
         */
        readonly compressionFormat?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#error_output_prefix KinesisFirehoseDeliveryStream#error_output_prefix}.
         *
         * @stability stable
         */
        readonly errorOutputPrefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#kms_key_arn KinesisFirehoseDeliveryStream#kms_key_arn}.
         *
         * @stability stable
         */
        readonly kmsKeyArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#prefix KinesisFirehoseDeliveryStream#prefix}.
         *
         * @stability stable
         */
        readonly prefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#role_arn KinesisFirehoseDeliveryStream#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#s3_backup_mode KinesisFirehoseDeliveryStream#s3_backup_mode}.
         *
         * @stability stable
         */
        readonly s3BackupMode?: string;
        /**
         * cloudwatch_logging_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#cloudwatch_logging_options KinesisFirehoseDeliveryStream#cloudwatch_logging_options}
         *
         * @stability stable
         */
        readonly cloudwatchLoggingOptions?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationCloudwatchLoggingOptions;
        /**
         * data_format_conversion_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#data_format_conversion_configuration KinesisFirehoseDeliveryStream#data_format_conversion_configuration}
         *
         * @stability stable
         */
        readonly dataFormatConversionConfiguration?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfiguration;
        /**
         * processing_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#processing_configuration KinesisFirehoseDeliveryStream#processing_configuration}
         *
         * @stability stable
         */
        readonly processingConfiguration?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfiguration;
        /**
         * s3_backup_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#s3_backup_configuration KinesisFirehoseDeliveryStream#s3_backup_configuration}
         *
         * @stability stable
         */
        readonly s3BackupConfiguration?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationS3BackupConfiguration;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamExtendedS3ConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bucketArn?;
        /**
         * @stability stable
         */
        get bucketArn(): string;
        /**
         * @stability stable
         */
        set bucketArn(value: string);
        /**
         * @stability stable
         */
        get bucketArnInput(): string | undefined;
        private _bufferInterval?;
        /**
         * @stability stable
         */
        get bufferInterval(): number | undefined;
        /**
         * @stability stable
         */
        set bufferInterval(value: number | undefined);
        /**
         * @stability stable
         */
        resetBufferInterval(): void;
        /**
         * @stability stable
         */
        get bufferIntervalInput(): number | undefined;
        private _bufferSize?;
        /**
         * @stability stable
         */
        get bufferSize(): number | undefined;
        /**
         * @stability stable
         */
        set bufferSize(value: number | undefined);
        /**
         * @stability stable
         */
        resetBufferSize(): void;
        /**
         * @stability stable
         */
        get bufferSizeInput(): number | undefined;
        private _compressionFormat?;
        /**
         * @stability stable
         */
        get compressionFormat(): string | undefined;
        /**
         * @stability stable
         */
        set compressionFormat(value: string | undefined);
        /**
         * @stability stable
         */
        resetCompressionFormat(): void;
        /**
         * @stability stable
         */
        get compressionFormatInput(): string | undefined;
        private _errorOutputPrefix?;
        /**
         * @stability stable
         */
        get errorOutputPrefix(): string | undefined;
        /**
         * @stability stable
         */
        set errorOutputPrefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetErrorOutputPrefix(): void;
        /**
         * @stability stable
         */
        get errorOutputPrefixInput(): string | undefined;
        private _kmsKeyArn?;
        /**
         * @stability stable
         */
        get kmsKeyArn(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyArn(): void;
        /**
         * @stability stable
         */
        get kmsKeyArnInput(): string | undefined;
        private _prefix?;
        /**
         * @stability stable
         */
        get prefix(): string | undefined;
        /**
         * @stability stable
         */
        set prefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrefix(): void;
        /**
         * @stability stable
         */
        get prefixInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        private _s3BackupMode?;
        /**
         * @stability stable
         */
        get s3BackupMode(): string | undefined;
        /**
         * @stability stable
         */
        set s3BackupMode(value: string | undefined);
        /**
         * @stability stable
         */
        resetS3BackupMode(): void;
        /**
         * @stability stable
         */
        get s3BackupModeInput(): string | undefined;
        private _cloudwatchLoggingOptions?;
        private __cloudwatchLoggingOptionsOutput;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptions(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationCloudwatchLoggingOptionsOutputReference;
        /**
         * @stability stable
         */
        putCloudwatchLoggingOptions(value: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationCloudwatchLoggingOptions | undefined): void;
        /**
         * @stability stable
         */
        resetCloudwatchLoggingOptions(): void;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptionsInput(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationCloudwatchLoggingOptions | undefined;
        private _dataFormatConversionConfiguration?;
        private __dataFormatConversionConfigurationOutput;
        /**
         * @stability stable
         */
        get dataFormatConversionConfiguration(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputReference;
        /**
         * @stability stable
         */
        putDataFormatConversionConfiguration(value: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetDataFormatConversionConfiguration(): void;
        /**
         * @stability stable
         */
        get dataFormatConversionConfigurationInput(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfiguration | undefined;
        private _processingConfiguration?;
        private __processingConfigurationOutput;
        /**
         * @stability stable
         */
        get processingConfiguration(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfigurationOutputReference;
        /**
         * @stability stable
         */
        putProcessingConfiguration(value: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetProcessingConfiguration(): void;
        /**
         * @stability stable
         */
        get processingConfigurationInput(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfiguration | undefined;
        private _s3BackupConfiguration?;
        private __s3BackupConfigurationOutput;
        /**
         * @stability stable
         */
        get s3BackupConfiguration(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationS3BackupConfigurationOutputReference;
        /**
         * @stability stable
         */
        putS3BackupConfiguration(value: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationS3BackupConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetS3BackupConfiguration(): void;
        /**
         * @stability stable
         */
        get s3BackupConfigurationInput(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationS3BackupConfiguration | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamHttpEndpointConfigurationCloudwatchLoggingOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enabled KinesisFirehoseDeliveryStream#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#log_group_name KinesisFirehoseDeliveryStream#log_group_name}.
         *
         * @stability stable
         */
        readonly logGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#log_stream_name KinesisFirehoseDeliveryStream#log_stream_name}.
         *
         * @stability stable
         */
        readonly logStreamName?: string;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamHttpEndpointConfigurationCloudwatchLoggingOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _logGroupName?;
        /**
         * @stability stable
         */
        get logGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set logGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogGroupName(): void;
        /**
         * @stability stable
         */
        get logGroupNameInput(): string | undefined;
        private _logStreamName?;
        /**
         * @stability stable
         */
        get logStreamName(): string | undefined;
        /**
         * @stability stable
         */
        set logStreamName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogStreamName(): void;
        /**
         * @stability stable
         */
        get logStreamNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfigurationProcessorsParameters {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#parameter_name KinesisFirehoseDeliveryStream#parameter_name}.
         *
         * @stability stable
         */
        readonly parameterName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#parameter_value KinesisFirehoseDeliveryStream#parameter_value}.
         *
         * @stability stable
         */
        readonly parameterValue: string;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfigurationProcessors {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#type KinesisFirehoseDeliveryStream#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#parameters KinesisFirehoseDeliveryStream#parameters}
         *
         * @stability stable
         */
        readonly parameters?: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfigurationProcessorsParameters[];
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enabled KinesisFirehoseDeliveryStream#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * processors block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#processors KinesisFirehoseDeliveryStream#processors}
         *
         * @stability stable
         */
        readonly processors?: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfigurationProcessors[];
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _processors?;
        /**
         * @stability stable
         */
        get processors(): KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfigurationProcessors[] | undefined;
        /**
         * @stability stable
         */
        set processors(value: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfigurationProcessors[] | undefined);
        /**
         * @stability stable
         */
        resetProcessors(): void;
        /**
         * @stability stable
         */
        get processorsInput(): KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfigurationProcessors[] | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamHttpEndpointConfigurationRequestConfigurationCommonAttributes {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#name KinesisFirehoseDeliveryStream#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#value KinesisFirehoseDeliveryStream#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamHttpEndpointConfigurationRequestConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#content_encoding KinesisFirehoseDeliveryStream#content_encoding}.
         *
         * @stability stable
         */
        readonly contentEncoding?: string;
        /**
         * common_attributes block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#common_attributes KinesisFirehoseDeliveryStream#common_attributes}
         *
         * @stability stable
         */
        readonly commonAttributes?: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationRequestConfigurationCommonAttributes[];
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamHttpEndpointConfigurationRequestConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _contentEncoding?;
        /**
         * @stability stable
         */
        get contentEncoding(): string | undefined;
        /**
         * @stability stable
         */
        set contentEncoding(value: string | undefined);
        /**
         * @stability stable
         */
        resetContentEncoding(): void;
        /**
         * @stability stable
         */
        get contentEncodingInput(): string | undefined;
        private _commonAttributes?;
        /**
         * @stability stable
         */
        get commonAttributes(): KinesisFirehoseDeliveryStreamHttpEndpointConfigurationRequestConfigurationCommonAttributes[] | undefined;
        /**
         * @stability stable
         */
        set commonAttributes(value: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationRequestConfigurationCommonAttributes[] | undefined);
        /**
         * @stability stable
         */
        resetCommonAttributes(): void;
        /**
         * @stability stable
         */
        get commonAttributesInput(): KinesisFirehoseDeliveryStreamHttpEndpointConfigurationRequestConfigurationCommonAttributes[] | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamHttpEndpointConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#access_key KinesisFirehoseDeliveryStream#access_key}.
         *
         * @stability stable
         */
        readonly accessKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#buffering_interval KinesisFirehoseDeliveryStream#buffering_interval}.
         *
         * @stability stable
         */
        readonly bufferingInterval?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#buffering_size KinesisFirehoseDeliveryStream#buffering_size}.
         *
         * @stability stable
         */
        readonly bufferingSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#name KinesisFirehoseDeliveryStream#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#retry_duration KinesisFirehoseDeliveryStream#retry_duration}.
         *
         * @stability stable
         */
        readonly retryDuration?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#role_arn KinesisFirehoseDeliveryStream#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#s3_backup_mode KinesisFirehoseDeliveryStream#s3_backup_mode}.
         *
         * @stability stable
         */
        readonly s3BackupMode?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#url KinesisFirehoseDeliveryStream#url}.
         *
         * @stability stable
         */
        readonly url: string;
        /**
         * cloudwatch_logging_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#cloudwatch_logging_options KinesisFirehoseDeliveryStream#cloudwatch_logging_options}
         *
         * @stability stable
         */
        readonly cloudwatchLoggingOptions?: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationCloudwatchLoggingOptions;
        /**
         * processing_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#processing_configuration KinesisFirehoseDeliveryStream#processing_configuration}
         *
         * @stability stable
         */
        readonly processingConfiguration?: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfiguration;
        /**
         * request_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#request_configuration KinesisFirehoseDeliveryStream#request_configuration}
         *
         * @stability stable
         */
        readonly requestConfiguration?: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationRequestConfiguration;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamHttpEndpointConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _accessKey?;
        /**
         * @stability stable
         */
        get accessKey(): string | undefined;
        /**
         * @stability stable
         */
        set accessKey(value: string | undefined);
        /**
         * @stability stable
         */
        resetAccessKey(): void;
        /**
         * @stability stable
         */
        get accessKeyInput(): string | undefined;
        private _bufferingInterval?;
        /**
         * @stability stable
         */
        get bufferingInterval(): number | undefined;
        /**
         * @stability stable
         */
        set bufferingInterval(value: number | undefined);
        /**
         * @stability stable
         */
        resetBufferingInterval(): void;
        /**
         * @stability stable
         */
        get bufferingIntervalInput(): number | undefined;
        private _bufferingSize?;
        /**
         * @stability stable
         */
        get bufferingSize(): number | undefined;
        /**
         * @stability stable
         */
        set bufferingSize(value: number | undefined);
        /**
         * @stability stable
         */
        resetBufferingSize(): void;
        /**
         * @stability stable
         */
        get bufferingSizeInput(): number | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _retryDuration?;
        /**
         * @stability stable
         */
        get retryDuration(): number | undefined;
        /**
         * @stability stable
         */
        set retryDuration(value: number | undefined);
        /**
         * @stability stable
         */
        resetRetryDuration(): void;
        /**
         * @stability stable
         */
        get retryDurationInput(): number | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string | undefined;
        /**
         * @stability stable
         */
        set roleArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetRoleArn(): void;
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        private _s3BackupMode?;
        /**
         * @stability stable
         */
        get s3BackupMode(): string | undefined;
        /**
         * @stability stable
         */
        set s3BackupMode(value: string | undefined);
        /**
         * @stability stable
         */
        resetS3BackupMode(): void;
        /**
         * @stability stable
         */
        get s3BackupModeInput(): string | undefined;
        private _url?;
        /**
         * @stability stable
         */
        get url(): string;
        /**
         * @stability stable
         */
        set url(value: string);
        /**
         * @stability stable
         */
        get urlInput(): string | undefined;
        private _cloudwatchLoggingOptions?;
        private __cloudwatchLoggingOptionsOutput;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptions(): KinesisFirehoseDeliveryStreamHttpEndpointConfigurationCloudwatchLoggingOptionsOutputReference;
        /**
         * @stability stable
         */
        putCloudwatchLoggingOptions(value: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationCloudwatchLoggingOptions | undefined): void;
        /**
         * @stability stable
         */
        resetCloudwatchLoggingOptions(): void;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptionsInput(): KinesisFirehoseDeliveryStreamHttpEndpointConfigurationCloudwatchLoggingOptions | undefined;
        private _processingConfiguration?;
        private __processingConfigurationOutput;
        /**
         * @stability stable
         */
        get processingConfiguration(): KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfigurationOutputReference;
        /**
         * @stability stable
         */
        putProcessingConfiguration(value: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetProcessingConfiguration(): void;
        /**
         * @stability stable
         */
        get processingConfigurationInput(): KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfiguration | undefined;
        private _requestConfiguration?;
        private __requestConfigurationOutput;
        /**
         * @stability stable
         */
        get requestConfiguration(): KinesisFirehoseDeliveryStreamHttpEndpointConfigurationRequestConfigurationOutputReference;
        /**
         * @stability stable
         */
        putRequestConfiguration(value: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationRequestConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetRequestConfiguration(): void;
        /**
         * @stability stable
         */
        get requestConfigurationInput(): KinesisFirehoseDeliveryStreamHttpEndpointConfigurationRequestConfiguration | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamKinesisSourceConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#kinesis_stream_arn KinesisFirehoseDeliveryStream#kinesis_stream_arn}.
         *
         * @stability stable
         */
        readonly kinesisStreamArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#role_arn KinesisFirehoseDeliveryStream#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamKinesisSourceConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _kinesisStreamArn?;
        /**
         * @stability stable
         */
        get kinesisStreamArn(): string;
        /**
         * @stability stable
         */
        set kinesisStreamArn(value: string);
        /**
         * @stability stable
         */
        get kinesisStreamArnInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamRedshiftConfigurationCloudwatchLoggingOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enabled KinesisFirehoseDeliveryStream#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#log_group_name KinesisFirehoseDeliveryStream#log_group_name}.
         *
         * @stability stable
         */
        readonly logGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#log_stream_name KinesisFirehoseDeliveryStream#log_stream_name}.
         *
         * @stability stable
         */
        readonly logStreamName?: string;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamRedshiftConfigurationCloudwatchLoggingOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _logGroupName?;
        /**
         * @stability stable
         */
        get logGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set logGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogGroupName(): void;
        /**
         * @stability stable
         */
        get logGroupNameInput(): string | undefined;
        private _logStreamName?;
        /**
         * @stability stable
         */
        get logStreamName(): string | undefined;
        /**
         * @stability stable
         */
        set logStreamName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogStreamName(): void;
        /**
         * @stability stable
         */
        get logStreamNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfigurationProcessorsParameters {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#parameter_name KinesisFirehoseDeliveryStream#parameter_name}.
         *
         * @stability stable
         */
        readonly parameterName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#parameter_value KinesisFirehoseDeliveryStream#parameter_value}.
         *
         * @stability stable
         */
        readonly parameterValue: string;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfigurationProcessors {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#type KinesisFirehoseDeliveryStream#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#parameters KinesisFirehoseDeliveryStream#parameters}
         *
         * @stability stable
         */
        readonly parameters?: KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfigurationProcessorsParameters[];
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enabled KinesisFirehoseDeliveryStream#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * processors block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#processors KinesisFirehoseDeliveryStream#processors}
         *
         * @stability stable
         */
        readonly processors?: KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfigurationProcessors[];
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _processors?;
        /**
         * @stability stable
         */
        get processors(): KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfigurationProcessors[] | undefined;
        /**
         * @stability stable
         */
        set processors(value: KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfigurationProcessors[] | undefined);
        /**
         * @stability stable
         */
        resetProcessors(): void;
        /**
         * @stability stable
         */
        get processorsInput(): KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfigurationProcessors[] | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamRedshiftConfigurationS3BackupConfigurationCloudwatchLoggingOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enabled KinesisFirehoseDeliveryStream#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#log_group_name KinesisFirehoseDeliveryStream#log_group_name}.
         *
         * @stability stable
         */
        readonly logGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#log_stream_name KinesisFirehoseDeliveryStream#log_stream_name}.
         *
         * @stability stable
         */
        readonly logStreamName?: string;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamRedshiftConfigurationS3BackupConfigurationCloudwatchLoggingOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _logGroupName?;
        /**
         * @stability stable
         */
        get logGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set logGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogGroupName(): void;
        /**
         * @stability stable
         */
        get logGroupNameInput(): string | undefined;
        private _logStreamName?;
        /**
         * @stability stable
         */
        get logStreamName(): string | undefined;
        /**
         * @stability stable
         */
        set logStreamName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogStreamName(): void;
        /**
         * @stability stable
         */
        get logStreamNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamRedshiftConfigurationS3BackupConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#bucket_arn KinesisFirehoseDeliveryStream#bucket_arn}.
         *
         * @stability stable
         */
        readonly bucketArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#buffer_interval KinesisFirehoseDeliveryStream#buffer_interval}.
         *
         * @stability stable
         */
        readonly bufferInterval?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#buffer_size KinesisFirehoseDeliveryStream#buffer_size}.
         *
         * @stability stable
         */
        readonly bufferSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#compression_format KinesisFirehoseDeliveryStream#compression_format}.
         *
         * @stability stable
         */
        readonly compressionFormat?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#kms_key_arn KinesisFirehoseDeliveryStream#kms_key_arn}.
         *
         * @stability stable
         */
        readonly kmsKeyArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#prefix KinesisFirehoseDeliveryStream#prefix}.
         *
         * @stability stable
         */
        readonly prefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#role_arn KinesisFirehoseDeliveryStream#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
        /**
         * cloudwatch_logging_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#cloudwatch_logging_options KinesisFirehoseDeliveryStream#cloudwatch_logging_options}
         *
         * @stability stable
         */
        readonly cloudwatchLoggingOptions?: KinesisFirehoseDeliveryStreamRedshiftConfigurationS3BackupConfigurationCloudwatchLoggingOptions;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamRedshiftConfigurationS3BackupConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bucketArn?;
        /**
         * @stability stable
         */
        get bucketArn(): string;
        /**
         * @stability stable
         */
        set bucketArn(value: string);
        /**
         * @stability stable
         */
        get bucketArnInput(): string | undefined;
        private _bufferInterval?;
        /**
         * @stability stable
         */
        get bufferInterval(): number | undefined;
        /**
         * @stability stable
         */
        set bufferInterval(value: number | undefined);
        /**
         * @stability stable
         */
        resetBufferInterval(): void;
        /**
         * @stability stable
         */
        get bufferIntervalInput(): number | undefined;
        private _bufferSize?;
        /**
         * @stability stable
         */
        get bufferSize(): number | undefined;
        /**
         * @stability stable
         */
        set bufferSize(value: number | undefined);
        /**
         * @stability stable
         */
        resetBufferSize(): void;
        /**
         * @stability stable
         */
        get bufferSizeInput(): number | undefined;
        private _compressionFormat?;
        /**
         * @stability stable
         */
        get compressionFormat(): string | undefined;
        /**
         * @stability stable
         */
        set compressionFormat(value: string | undefined);
        /**
         * @stability stable
         */
        resetCompressionFormat(): void;
        /**
         * @stability stable
         */
        get compressionFormatInput(): string | undefined;
        private _kmsKeyArn?;
        /**
         * @stability stable
         */
        get kmsKeyArn(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyArn(): void;
        /**
         * @stability stable
         */
        get kmsKeyArnInput(): string | undefined;
        private _prefix?;
        /**
         * @stability stable
         */
        get prefix(): string | undefined;
        /**
         * @stability stable
         */
        set prefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrefix(): void;
        /**
         * @stability stable
         */
        get prefixInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        private _cloudwatchLoggingOptions?;
        private __cloudwatchLoggingOptionsOutput;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptions(): KinesisFirehoseDeliveryStreamRedshiftConfigurationS3BackupConfigurationCloudwatchLoggingOptionsOutputReference;
        /**
         * @stability stable
         */
        putCloudwatchLoggingOptions(value: KinesisFirehoseDeliveryStreamRedshiftConfigurationS3BackupConfigurationCloudwatchLoggingOptions | undefined): void;
        /**
         * @stability stable
         */
        resetCloudwatchLoggingOptions(): void;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptionsInput(): KinesisFirehoseDeliveryStreamRedshiftConfigurationS3BackupConfigurationCloudwatchLoggingOptions | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamRedshiftConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#cluster_jdbcurl KinesisFirehoseDeliveryStream#cluster_jdbcurl}.
         *
         * @stability stable
         */
        readonly clusterJdbcurl: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#copy_options KinesisFirehoseDeliveryStream#copy_options}.
         *
         * @stability stable
         */
        readonly copyOptions?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#data_table_columns KinesisFirehoseDeliveryStream#data_table_columns}.
         *
         * @stability stable
         */
        readonly dataTableColumns?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#data_table_name KinesisFirehoseDeliveryStream#data_table_name}.
         *
         * @stability stable
         */
        readonly dataTableName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#password KinesisFirehoseDeliveryStream#password}.
         *
         * @stability stable
         */
        readonly password: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#retry_duration KinesisFirehoseDeliveryStream#retry_duration}.
         *
         * @stability stable
         */
        readonly retryDuration?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#role_arn KinesisFirehoseDeliveryStream#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#s3_backup_mode KinesisFirehoseDeliveryStream#s3_backup_mode}.
         *
         * @stability stable
         */
        readonly s3BackupMode?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#username KinesisFirehoseDeliveryStream#username}.
         *
         * @stability stable
         */
        readonly username: string;
        /**
         * cloudwatch_logging_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#cloudwatch_logging_options KinesisFirehoseDeliveryStream#cloudwatch_logging_options}
         *
         * @stability stable
         */
        readonly cloudwatchLoggingOptions?: KinesisFirehoseDeliveryStreamRedshiftConfigurationCloudwatchLoggingOptions;
        /**
         * processing_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#processing_configuration KinesisFirehoseDeliveryStream#processing_configuration}
         *
         * @stability stable
         */
        readonly processingConfiguration?: KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfiguration;
        /**
         * s3_backup_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#s3_backup_configuration KinesisFirehoseDeliveryStream#s3_backup_configuration}
         *
         * @stability stable
         */
        readonly s3BackupConfiguration?: KinesisFirehoseDeliveryStreamRedshiftConfigurationS3BackupConfiguration;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamRedshiftConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _clusterJdbcurl?;
        /**
         * @stability stable
         */
        get clusterJdbcurl(): string;
        /**
         * @stability stable
         */
        set clusterJdbcurl(value: string);
        /**
         * @stability stable
         */
        get clusterJdbcurlInput(): string | undefined;
        private _copyOptions?;
        /**
         * @stability stable
         */
        get copyOptions(): string | undefined;
        /**
         * @stability stable
         */
        set copyOptions(value: string | undefined);
        /**
         * @stability stable
         */
        resetCopyOptions(): void;
        /**
         * @stability stable
         */
        get copyOptionsInput(): string | undefined;
        private _dataTableColumns?;
        /**
         * @stability stable
         */
        get dataTableColumns(): string | undefined;
        /**
         * @stability stable
         */
        set dataTableColumns(value: string | undefined);
        /**
         * @stability stable
         */
        resetDataTableColumns(): void;
        /**
         * @stability stable
         */
        get dataTableColumnsInput(): string | undefined;
        private _dataTableName?;
        /**
         * @stability stable
         */
        get dataTableName(): string;
        /**
         * @stability stable
         */
        set dataTableName(value: string);
        /**
         * @stability stable
         */
        get dataTableNameInput(): string | undefined;
        private _password?;
        /**
         * @stability stable
         */
        get password(): string;
        /**
         * @stability stable
         */
        set password(value: string);
        /**
         * @stability stable
         */
        get passwordInput(): string | undefined;
        private _retryDuration?;
        /**
         * @stability stable
         */
        get retryDuration(): number | undefined;
        /**
         * @stability stable
         */
        set retryDuration(value: number | undefined);
        /**
         * @stability stable
         */
        resetRetryDuration(): void;
        /**
         * @stability stable
         */
        get retryDurationInput(): number | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        private _s3BackupMode?;
        /**
         * @stability stable
         */
        get s3BackupMode(): string | undefined;
        /**
         * @stability stable
         */
        set s3BackupMode(value: string | undefined);
        /**
         * @stability stable
         */
        resetS3BackupMode(): void;
        /**
         * @stability stable
         */
        get s3BackupModeInput(): string | undefined;
        private _username?;
        /**
         * @stability stable
         */
        get username(): string;
        /**
         * @stability stable
         */
        set username(value: string);
        /**
         * @stability stable
         */
        get usernameInput(): string | undefined;
        private _cloudwatchLoggingOptions?;
        private __cloudwatchLoggingOptionsOutput;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptions(): KinesisFirehoseDeliveryStreamRedshiftConfigurationCloudwatchLoggingOptionsOutputReference;
        /**
         * @stability stable
         */
        putCloudwatchLoggingOptions(value: KinesisFirehoseDeliveryStreamRedshiftConfigurationCloudwatchLoggingOptions | undefined): void;
        /**
         * @stability stable
         */
        resetCloudwatchLoggingOptions(): void;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptionsInput(): KinesisFirehoseDeliveryStreamRedshiftConfigurationCloudwatchLoggingOptions | undefined;
        private _processingConfiguration?;
        private __processingConfigurationOutput;
        /**
         * @stability stable
         */
        get processingConfiguration(): KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfigurationOutputReference;
        /**
         * @stability stable
         */
        putProcessingConfiguration(value: KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetProcessingConfiguration(): void;
        /**
         * @stability stable
         */
        get processingConfigurationInput(): KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfiguration | undefined;
        private _s3BackupConfiguration?;
        private __s3BackupConfigurationOutput;
        /**
         * @stability stable
         */
        get s3BackupConfiguration(): KinesisFirehoseDeliveryStreamRedshiftConfigurationS3BackupConfigurationOutputReference;
        /**
         * @stability stable
         */
        putS3BackupConfiguration(value: KinesisFirehoseDeliveryStreamRedshiftConfigurationS3BackupConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetS3BackupConfiguration(): void;
        /**
         * @stability stable
         */
        get s3BackupConfigurationInput(): KinesisFirehoseDeliveryStreamRedshiftConfigurationS3BackupConfiguration | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamS3ConfigurationCloudwatchLoggingOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enabled KinesisFirehoseDeliveryStream#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#log_group_name KinesisFirehoseDeliveryStream#log_group_name}.
         *
         * @stability stable
         */
        readonly logGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#log_stream_name KinesisFirehoseDeliveryStream#log_stream_name}.
         *
         * @stability stable
         */
        readonly logStreamName?: string;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamS3ConfigurationCloudwatchLoggingOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _logGroupName?;
        /**
         * @stability stable
         */
        get logGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set logGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogGroupName(): void;
        /**
         * @stability stable
         */
        get logGroupNameInput(): string | undefined;
        private _logStreamName?;
        /**
         * @stability stable
         */
        get logStreamName(): string | undefined;
        /**
         * @stability stable
         */
        set logStreamName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogStreamName(): void;
        /**
         * @stability stable
         */
        get logStreamNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamS3Configuration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#bucket_arn KinesisFirehoseDeliveryStream#bucket_arn}.
         *
         * @stability stable
         */
        readonly bucketArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#buffer_interval KinesisFirehoseDeliveryStream#buffer_interval}.
         *
         * @stability stable
         */
        readonly bufferInterval?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#buffer_size KinesisFirehoseDeliveryStream#buffer_size}.
         *
         * @stability stable
         */
        readonly bufferSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#compression_format KinesisFirehoseDeliveryStream#compression_format}.
         *
         * @stability stable
         */
        readonly compressionFormat?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#kms_key_arn KinesisFirehoseDeliveryStream#kms_key_arn}.
         *
         * @stability stable
         */
        readonly kmsKeyArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#prefix KinesisFirehoseDeliveryStream#prefix}.
         *
         * @stability stable
         */
        readonly prefix?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#role_arn KinesisFirehoseDeliveryStream#role_arn}.
         *
         * @stability stable
         */
        readonly roleArn: string;
        /**
         * cloudwatch_logging_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#cloudwatch_logging_options KinesisFirehoseDeliveryStream#cloudwatch_logging_options}
         *
         * @stability stable
         */
        readonly cloudwatchLoggingOptions?: KinesisFirehoseDeliveryStreamS3ConfigurationCloudwatchLoggingOptions;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamS3ConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bucketArn?;
        /**
         * @stability stable
         */
        get bucketArn(): string;
        /**
         * @stability stable
         */
        set bucketArn(value: string);
        /**
         * @stability stable
         */
        get bucketArnInput(): string | undefined;
        private _bufferInterval?;
        /**
         * @stability stable
         */
        get bufferInterval(): number | undefined;
        /**
         * @stability stable
         */
        set bufferInterval(value: number | undefined);
        /**
         * @stability stable
         */
        resetBufferInterval(): void;
        /**
         * @stability stable
         */
        get bufferIntervalInput(): number | undefined;
        private _bufferSize?;
        /**
         * @stability stable
         */
        get bufferSize(): number | undefined;
        /**
         * @stability stable
         */
        set bufferSize(value: number | undefined);
        /**
         * @stability stable
         */
        resetBufferSize(): void;
        /**
         * @stability stable
         */
        get bufferSizeInput(): number | undefined;
        private _compressionFormat?;
        /**
         * @stability stable
         */
        get compressionFormat(): string | undefined;
        /**
         * @stability stable
         */
        set compressionFormat(value: string | undefined);
        /**
         * @stability stable
         */
        resetCompressionFormat(): void;
        /**
         * @stability stable
         */
        get compressionFormatInput(): string | undefined;
        private _kmsKeyArn?;
        /**
         * @stability stable
         */
        get kmsKeyArn(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyArn(): void;
        /**
         * @stability stable
         */
        get kmsKeyArnInput(): string | undefined;
        private _prefix?;
        /**
         * @stability stable
         */
        get prefix(): string | undefined;
        /**
         * @stability stable
         */
        set prefix(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrefix(): void;
        /**
         * @stability stable
         */
        get prefixInput(): string | undefined;
        private _roleArn?;
        /**
         * @stability stable
         */
        get roleArn(): string;
        /**
         * @stability stable
         */
        set roleArn(value: string);
        /**
         * @stability stable
         */
        get roleArnInput(): string | undefined;
        private _cloudwatchLoggingOptions?;
        private __cloudwatchLoggingOptionsOutput;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptions(): KinesisFirehoseDeliveryStreamS3ConfigurationCloudwatchLoggingOptionsOutputReference;
        /**
         * @stability stable
         */
        putCloudwatchLoggingOptions(value: KinesisFirehoseDeliveryStreamS3ConfigurationCloudwatchLoggingOptions | undefined): void;
        /**
         * @stability stable
         */
        resetCloudwatchLoggingOptions(): void;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptionsInput(): KinesisFirehoseDeliveryStreamS3ConfigurationCloudwatchLoggingOptions | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamServerSideEncryption {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enabled KinesisFirehoseDeliveryStream#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#key_arn KinesisFirehoseDeliveryStream#key_arn}.
         *
         * @stability stable
         */
        readonly keyArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#key_type KinesisFirehoseDeliveryStream#key_type}.
         *
         * @stability stable
         */
        readonly keyType?: string;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamServerSideEncryptionOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _keyArn?;
        /**
         * @stability stable
         */
        get keyArn(): string | undefined;
        /**
         * @stability stable
         */
        set keyArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetKeyArn(): void;
        /**
         * @stability stable
         */
        get keyArnInput(): string | undefined;
        private _keyType?;
        /**
         * @stability stable
         */
        get keyType(): string | undefined;
        /**
         * @stability stable
         */
        set keyType(value: string | undefined);
        /**
         * @stability stable
         */
        resetKeyType(): void;
        /**
         * @stability stable
         */
        get keyTypeInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamSplunkConfigurationCloudwatchLoggingOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enabled KinesisFirehoseDeliveryStream#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#log_group_name KinesisFirehoseDeliveryStream#log_group_name}.
         *
         * @stability stable
         */
        readonly logGroupName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#log_stream_name KinesisFirehoseDeliveryStream#log_stream_name}.
         *
         * @stability stable
         */
        readonly logStreamName?: string;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamSplunkConfigurationCloudwatchLoggingOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _logGroupName?;
        /**
         * @stability stable
         */
        get logGroupName(): string | undefined;
        /**
         * @stability stable
         */
        set logGroupName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogGroupName(): void;
        /**
         * @stability stable
         */
        get logGroupNameInput(): string | undefined;
        private _logStreamName?;
        /**
         * @stability stable
         */
        get logStreamName(): string | undefined;
        /**
         * @stability stable
         */
        set logStreamName(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogStreamName(): void;
        /**
         * @stability stable
         */
        get logStreamNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfigurationProcessorsParameters {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#parameter_name KinesisFirehoseDeliveryStream#parameter_name}.
         *
         * @stability stable
         */
        readonly parameterName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#parameter_value KinesisFirehoseDeliveryStream#parameter_value}.
         *
         * @stability stable
         */
        readonly parameterValue: string;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfigurationProcessors {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#type KinesisFirehoseDeliveryStream#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#parameters KinesisFirehoseDeliveryStream#parameters}
         *
         * @stability stable
         */
        readonly parameters?: KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfigurationProcessorsParameters[];
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#enabled KinesisFirehoseDeliveryStream#enabled}.
         *
         * @stability stable
         */
        readonly enabled?: boolean | cdktf.IResolvable;
        /**
         * processors block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#processors KinesisFirehoseDeliveryStream#processors}
         *
         * @stability stable
         */
        readonly processors?: KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfigurationProcessors[];
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _enabled?;
        /**
         * @stability stable
         */
        get enabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnabled(): void;
        /**
         * @stability stable
         */
        get enabledInput(): boolean | cdktf.IResolvable | undefined;
        private _processors?;
        /**
         * @stability stable
         */
        get processors(): KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfigurationProcessors[] | undefined;
        /**
         * @stability stable
         */
        set processors(value: KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfigurationProcessors[] | undefined);
        /**
         * @stability stable
         */
        resetProcessors(): void;
        /**
         * @stability stable
         */
        get processorsInput(): KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfigurationProcessors[] | undefined;
    }
    /**
     * @stability stable
     */
    interface KinesisFirehoseDeliveryStreamSplunkConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#hec_acknowledgment_timeout KinesisFirehoseDeliveryStream#hec_acknowledgment_timeout}.
         *
         * @stability stable
         */
        readonly hecAcknowledgmentTimeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#hec_endpoint KinesisFirehoseDeliveryStream#hec_endpoint}.
         *
         * @stability stable
         */
        readonly hecEndpoint: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#hec_endpoint_type KinesisFirehoseDeliveryStream#hec_endpoint_type}.
         *
         * @stability stable
         */
        readonly hecEndpointType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#hec_token KinesisFirehoseDeliveryStream#hec_token}.
         *
         * @stability stable
         */
        readonly hecToken: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#retry_duration KinesisFirehoseDeliveryStream#retry_duration}.
         *
         * @stability stable
         */
        readonly retryDuration?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#s3_backup_mode KinesisFirehoseDeliveryStream#s3_backup_mode}.
         *
         * @stability stable
         */
        readonly s3BackupMode?: string;
        /**
         * cloudwatch_logging_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#cloudwatch_logging_options KinesisFirehoseDeliveryStream#cloudwatch_logging_options}
         *
         * @stability stable
         */
        readonly cloudwatchLoggingOptions?: KinesisFirehoseDeliveryStreamSplunkConfigurationCloudwatchLoggingOptions;
        /**
         * processing_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html#processing_configuration KinesisFirehoseDeliveryStream#processing_configuration}
         *
         * @stability stable
         */
        readonly processingConfiguration?: KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfiguration;
    }
    /**
     * @stability stable
     */
    class KinesisFirehoseDeliveryStreamSplunkConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _hecAcknowledgmentTimeout?;
        /**
         * @stability stable
         */
        get hecAcknowledgmentTimeout(): number | undefined;
        /**
         * @stability stable
         */
        set hecAcknowledgmentTimeout(value: number | undefined);
        /**
         * @stability stable
         */
        resetHecAcknowledgmentTimeout(): void;
        /**
         * @stability stable
         */
        get hecAcknowledgmentTimeoutInput(): number | undefined;
        private _hecEndpoint?;
        /**
         * @stability stable
         */
        get hecEndpoint(): string;
        /**
         * @stability stable
         */
        set hecEndpoint(value: string);
        /**
         * @stability stable
         */
        get hecEndpointInput(): string | undefined;
        private _hecEndpointType?;
        /**
         * @stability stable
         */
        get hecEndpointType(): string | undefined;
        /**
         * @stability stable
         */
        set hecEndpointType(value: string | undefined);
        /**
         * @stability stable
         */
        resetHecEndpointType(): void;
        /**
         * @stability stable
         */
        get hecEndpointTypeInput(): string | undefined;
        private _hecToken?;
        /**
         * @stability stable
         */
        get hecToken(): string;
        /**
         * @stability stable
         */
        set hecToken(value: string);
        /**
         * @stability stable
         */
        get hecTokenInput(): string | undefined;
        private _retryDuration?;
        /**
         * @stability stable
         */
        get retryDuration(): number | undefined;
        /**
         * @stability stable
         */
        set retryDuration(value: number | undefined);
        /**
         * @stability stable
         */
        resetRetryDuration(): void;
        /**
         * @stability stable
         */
        get retryDurationInput(): number | undefined;
        private _s3BackupMode?;
        /**
         * @stability stable
         */
        get s3BackupMode(): string | undefined;
        /**
         * @stability stable
         */
        set s3BackupMode(value: string | undefined);
        /**
         * @stability stable
         */
        resetS3BackupMode(): void;
        /**
         * @stability stable
         */
        get s3BackupModeInput(): string | undefined;
        private _cloudwatchLoggingOptions?;
        private __cloudwatchLoggingOptionsOutput;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptions(): KinesisFirehoseDeliveryStreamSplunkConfigurationCloudwatchLoggingOptionsOutputReference;
        /**
         * @stability stable
         */
        putCloudwatchLoggingOptions(value: KinesisFirehoseDeliveryStreamSplunkConfigurationCloudwatchLoggingOptions | undefined): void;
        /**
         * @stability stable
         */
        resetCloudwatchLoggingOptions(): void;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptionsInput(): KinesisFirehoseDeliveryStreamSplunkConfigurationCloudwatchLoggingOptions | undefined;
        private _processingConfiguration?;
        private __processingConfigurationOutput;
        /**
         * @stability stable
         */
        get processingConfiguration(): KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfigurationOutputReference;
        /**
         * @stability stable
         */
        putProcessingConfiguration(value: KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetProcessingConfiguration(): void;
        /**
         * @stability stable
         */
        get processingConfigurationInput(): KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfiguration | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html aws_kinesis_firehose_delivery_stream}.
     *
     * @stability stable
     */
    class KinesisFirehoseDeliveryStream extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/kinesis_firehose_delivery_stream.html aws_kinesis_firehose_delivery_stream} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: KinesisFirehoseDeliveryStreamConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _destination?;
        /**
         * @stability stable
         */
        get destination(): string;
        /**
         * @stability stable
         */
        set destination(value: string);
        /**
         * @stability stable
         */
        get destinationInput(): string | undefined;
        private _destinationId?;
        /**
         * @stability stable
         */
        get destinationId(): string | undefined;
        /**
         * @stability stable
         */
        set destinationId(value: string | undefined);
        /**
         * @stability stable
         */
        resetDestinationId(): void;
        /**
         * @stability stable
         */
        get destinationIdInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _versionId?;
        /**
         * @stability stable
         */
        get versionId(): string | undefined;
        /**
         * @stability stable
         */
        set versionId(value: string | undefined);
        /**
         * @stability stable
         */
        resetVersionId(): void;
        /**
         * @stability stable
         */
        get versionIdInput(): string | undefined;
        private _elasticsearchConfiguration?;
        private __elasticsearchConfigurationOutput;
        /**
         * @stability stable
         */
        get elasticsearchConfiguration(): KinesisFirehoseDeliveryStreamElasticsearchConfigurationOutputReference;
        /**
         * @stability stable
         */
        putElasticsearchConfiguration(value: KinesisFirehoseDeliveryStreamElasticsearchConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetElasticsearchConfiguration(): void;
        /**
         * @stability stable
         */
        get elasticsearchConfigurationInput(): KinesisFirehoseDeliveryStreamElasticsearchConfiguration | undefined;
        private _extendedS3Configuration?;
        private __extendedS3ConfigurationOutput;
        /**
         * @stability stable
         */
        get extendedS3Configuration(): KinesisFirehoseDeliveryStreamExtendedS3ConfigurationOutputReference;
        /**
         * @stability stable
         */
        putExtendedS3Configuration(value: KinesisFirehoseDeliveryStreamExtendedS3Configuration | undefined): void;
        /**
         * @stability stable
         */
        resetExtendedS3Configuration(): void;
        /**
         * @stability stable
         */
        get extendedS3ConfigurationInput(): KinesisFirehoseDeliveryStreamExtendedS3Configuration | undefined;
        private _httpEndpointConfiguration?;
        private __httpEndpointConfigurationOutput;
        /**
         * @stability stable
         */
        get httpEndpointConfiguration(): KinesisFirehoseDeliveryStreamHttpEndpointConfigurationOutputReference;
        /**
         * @stability stable
         */
        putHttpEndpointConfiguration(value: KinesisFirehoseDeliveryStreamHttpEndpointConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetHttpEndpointConfiguration(): void;
        /**
         * @stability stable
         */
        get httpEndpointConfigurationInput(): KinesisFirehoseDeliveryStreamHttpEndpointConfiguration | undefined;
        private _kinesisSourceConfiguration?;
        private __kinesisSourceConfigurationOutput;
        /**
         * @stability stable
         */
        get kinesisSourceConfiguration(): KinesisFirehoseDeliveryStreamKinesisSourceConfigurationOutputReference;
        /**
         * @stability stable
         */
        putKinesisSourceConfiguration(value: KinesisFirehoseDeliveryStreamKinesisSourceConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetKinesisSourceConfiguration(): void;
        /**
         * @stability stable
         */
        get kinesisSourceConfigurationInput(): KinesisFirehoseDeliveryStreamKinesisSourceConfiguration | undefined;
        private _redshiftConfiguration?;
        private __redshiftConfigurationOutput;
        /**
         * @stability stable
         */
        get redshiftConfiguration(): KinesisFirehoseDeliveryStreamRedshiftConfigurationOutputReference;
        /**
         * @stability stable
         */
        putRedshiftConfiguration(value: KinesisFirehoseDeliveryStreamRedshiftConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetRedshiftConfiguration(): void;
        /**
         * @stability stable
         */
        get redshiftConfigurationInput(): KinesisFirehoseDeliveryStreamRedshiftConfiguration | undefined;
        private _s3Configuration?;
        private __s3ConfigurationOutput;
        /**
         * @stability stable
         */
        get s3Configuration(): KinesisFirehoseDeliveryStreamS3ConfigurationOutputReference;
        /**
         * @stability stable
         */
        putS3Configuration(value: KinesisFirehoseDeliveryStreamS3Configuration | undefined): void;
        /**
         * @stability stable
         */
        resetS3Configuration(): void;
        /**
         * @stability stable
         */
        get s3ConfigurationInput(): KinesisFirehoseDeliveryStreamS3Configuration | undefined;
        private _serverSideEncryption?;
        private __serverSideEncryptionOutput;
        /**
         * @stability stable
         */
        get serverSideEncryption(): KinesisFirehoseDeliveryStreamServerSideEncryptionOutputReference;
        /**
         * @stability stable
         */
        putServerSideEncryption(value: KinesisFirehoseDeliveryStreamServerSideEncryption | undefined): void;
        /**
         * @stability stable
         */
        resetServerSideEncryption(): void;
        /**
         * @stability stable
         */
        get serverSideEncryptionInput(): KinesisFirehoseDeliveryStreamServerSideEncryption | undefined;
        private _splunkConfiguration?;
        private __splunkConfigurationOutput;
        /**
         * @stability stable
         */
        get splunkConfiguration(): KinesisFirehoseDeliveryStreamSplunkConfigurationOutputReference;
        /**
         * @stability stable
         */
        putSplunkConfiguration(value: KinesisFirehoseDeliveryStreamSplunkConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetSplunkConfiguration(): void;
        /**
         * @stability stable
         */
        get splunkConfigurationInput(): KinesisFirehoseDeliveryStreamSplunkConfiguration | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface KinesisStreamConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream.html#encryption_type KinesisStream#encryption_type}.
         *
         * @stability stable
         */
        readonly encryptionType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream.html#enforce_consumer_deletion KinesisStream#enforce_consumer_deletion}.
         *
         * @stability stable
         */
        readonly enforceConsumerDeletion?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream.html#kms_key_id KinesisStream#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream.html#name KinesisStream#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream.html#retention_period KinesisStream#retention_period}.
         *
         * @stability stable
         */
        readonly retentionPeriod?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream.html#shard_count KinesisStream#shard_count}.
         *
         * @stability stable
         */
        readonly shardCount: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream.html#shard_level_metrics KinesisStream#shard_level_metrics}.
         *
         * @stability stable
         */
        readonly shardLevelMetrics?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream.html#tags KinesisStream#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream.html#tags_all KinesisStream#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream.html#timeouts KinesisStream#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: KinesisStreamTimeouts;
    }
    /**
     * @stability stable
     */
    interface KinesisStreamTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream.html#create KinesisStream#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream.html#delete KinesisStream#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream.html#update KinesisStream#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class KinesisStreamTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream.html aws_kinesis_stream}.
     *
     * @stability stable
     */
    class KinesisStream extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream.html aws_kinesis_stream} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: KinesisStreamConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _encryptionType?;
        /**
         * @stability stable
         */
        get encryptionType(): string | undefined;
        /**
         * @stability stable
         */
        set encryptionType(value: string | undefined);
        /**
         * @stability stable
         */
        resetEncryptionType(): void;
        /**
         * @stability stable
         */
        get encryptionTypeInput(): string | undefined;
        private _enforceConsumerDeletion?;
        /**
         * @stability stable
         */
        get enforceConsumerDeletion(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enforceConsumerDeletion(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnforceConsumerDeletion(): void;
        /**
         * @stability stable
         */
        get enforceConsumerDeletionInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _retentionPeriod?;
        /**
         * @stability stable
         */
        get retentionPeriod(): number | undefined;
        /**
         * @stability stable
         */
        set retentionPeriod(value: number | undefined);
        /**
         * @stability stable
         */
        resetRetentionPeriod(): void;
        /**
         * @stability stable
         */
        get retentionPeriodInput(): number | undefined;
        private _shardCount?;
        /**
         * @stability stable
         */
        get shardCount(): number;
        /**
         * @stability stable
         */
        set shardCount(value: number);
        /**
         * @stability stable
         */
        get shardCountInput(): number | undefined;
        private _shardLevelMetrics?;
        /**
         * @stability stable
         */
        get shardLevelMetrics(): string[] | undefined;
        /**
         * @stability stable
         */
        set shardLevelMetrics(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetShardLevelMetrics(): void;
        /**
         * @stability stable
         */
        get shardLevelMetricsInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): KinesisStreamTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: KinesisStreamTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): KinesisStreamTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface KinesisStreamConsumerConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream_consumer.html#name KinesisStreamConsumer#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream_consumer.html#stream_arn KinesisStreamConsumer#stream_arn}.
         *
         * @stability stable
         */
        readonly streamArn: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream_consumer.html aws_kinesis_stream_consumer}.
     *
     * @stability stable
     */
    class KinesisStreamConsumer extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/kinesis_stream_consumer.html aws_kinesis_stream_consumer} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: KinesisStreamConsumerConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get creationTimestamp(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _streamArn?;
        /**
         * @stability stable
         */
        get streamArn(): string;
        /**
         * @stability stable
         */
        set streamArn(value: string);
        /**
         * @stability stable
         */
        get streamArnInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface KinesisVideoStreamConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_video_stream.html#data_retention_in_hours KinesisVideoStream#data_retention_in_hours}.
         *
         * @stability stable
         */
        readonly dataRetentionInHours?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_video_stream.html#device_name KinesisVideoStream#device_name}.
         *
         * @stability stable
         */
        readonly deviceName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_video_stream.html#kms_key_id KinesisVideoStream#kms_key_id}.
         *
         * @stability stable
         */
        readonly kmsKeyId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_video_stream.html#media_type KinesisVideoStream#media_type}.
         *
         * @stability stable
         */
        readonly mediaType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_video_stream.html#name KinesisVideoStream#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_video_stream.html#tags KinesisVideoStream#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_video_stream.html#tags_all KinesisVideoStream#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_video_stream.html#timeouts KinesisVideoStream#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: KinesisVideoStreamTimeouts;
    }
    /**
     * @stability stable
     */
    interface KinesisVideoStreamTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_video_stream.html#create KinesisVideoStream#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_video_stream.html#delete KinesisVideoStream#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesis_video_stream.html#update KinesisVideoStream#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class KinesisVideoStreamTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/kinesis_video_stream.html aws_kinesis_video_stream}.
     *
     * @stability stable
     */
    class KinesisVideoStream extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/kinesis_video_stream.html aws_kinesis_video_stream} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: KinesisVideoStreamConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get creationTime(): string;
        private _dataRetentionInHours?;
        /**
         * @stability stable
         */
        get dataRetentionInHours(): number | undefined;
        /**
         * @stability stable
         */
        set dataRetentionInHours(value: number | undefined);
        /**
         * @stability stable
         */
        resetDataRetentionInHours(): void;
        /**
         * @stability stable
         */
        get dataRetentionInHoursInput(): number | undefined;
        private _deviceName?;
        /**
         * @stability stable
         */
        get deviceName(): string | undefined;
        /**
         * @stability stable
         */
        set deviceName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDeviceName(): void;
        /**
         * @stability stable
         */
        get deviceNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _kmsKeyId?;
        /**
         * @stability stable
         */
        get kmsKeyId(): string | undefined;
        /**
         * @stability stable
         */
        set kmsKeyId(value: string | undefined);
        /**
         * @stability stable
         */
        resetKmsKeyId(): void;
        /**
         * @stability stable
         */
        get kmsKeyIdInput(): string | undefined;
        private _mediaType?;
        /**
         * @stability stable
         */
        get mediaType(): string | undefined;
        /**
         * @stability stable
         */
        set mediaType(value: string | undefined);
        /**
         * @stability stable
         */
        resetMediaType(): void;
        /**
         * @stability stable
         */
        get mediaTypeInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get version(): string;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): KinesisVideoStreamTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: KinesisVideoStreamTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): KinesisVideoStreamTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#description Kinesisanalyticsv2Application#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#force_stop Kinesisanalyticsv2Application#force_stop}.
         *
         * @stability stable
         */
        readonly forceStop?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#name Kinesisanalyticsv2Application#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#runtime_environment Kinesisanalyticsv2Application#runtime_environment}.
         *
         * @stability stable
         */
        readonly runtimeEnvironment: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#service_execution_role Kinesisanalyticsv2Application#service_execution_role}.
         *
         * @stability stable
         */
        readonly serviceExecutionRole: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#start_application Kinesisanalyticsv2Application#start_application}.
         *
         * @stability stable
         */
        readonly startApplication?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#tags Kinesisanalyticsv2Application#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#tags_all Kinesisanalyticsv2Application#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * application_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#application_configuration Kinesisanalyticsv2Application#application_configuration}
         *
         * @stability stable
         */
        readonly applicationConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfiguration;
        /**
         * cloudwatch_logging_options block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#cloudwatch_logging_options Kinesisanalyticsv2Application#cloudwatch_logging_options}
         *
         * @stability stable
         */
        readonly cloudwatchLoggingOptions?: Kinesisanalyticsv2ApplicationCloudwatchLoggingOptions;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationCodeContentS3ContentLocation {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#bucket_arn Kinesisanalyticsv2Application#bucket_arn}.
         *
         * @stability stable
         */
        readonly bucketArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#file_key Kinesisanalyticsv2Application#file_key}.
         *
         * @stability stable
         */
        readonly fileKey: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#object_version Kinesisanalyticsv2Application#object_version}.
         *
         * @stability stable
         */
        readonly objectVersion?: string;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationCodeContentS3ContentLocationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bucketArn?;
        /**
         * @stability stable
         */
        get bucketArn(): string;
        /**
         * @stability stable
         */
        set bucketArn(value: string);
        /**
         * @stability stable
         */
        get bucketArnInput(): string | undefined;
        private _fileKey?;
        /**
         * @stability stable
         */
        get fileKey(): string;
        /**
         * @stability stable
         */
        set fileKey(value: string);
        /**
         * @stability stable
         */
        get fileKeyInput(): string | undefined;
        private _objectVersion?;
        /**
         * @stability stable
         */
        get objectVersion(): string | undefined;
        /**
         * @stability stable
         */
        set objectVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetObjectVersion(): void;
        /**
         * @stability stable
         */
        get objectVersionInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationCodeContent {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#text_content Kinesisanalyticsv2Application#text_content}.
         *
         * @stability stable
         */
        readonly textContent?: string;
        /**
         * s3_content_location block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#s3_content_location Kinesisanalyticsv2Application#s3_content_location}
         *
         * @stability stable
         */
        readonly s3ContentLocation?: Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationCodeContentS3ContentLocation;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationCodeContentOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _textContent?;
        /**
         * @stability stable
         */
        get textContent(): string | undefined;
        /**
         * @stability stable
         */
        set textContent(value: string | undefined);
        /**
         * @stability stable
         */
        resetTextContent(): void;
        /**
         * @stability stable
         */
        get textContentInput(): string | undefined;
        private _s3ContentLocation?;
        private __s3ContentLocationOutput;
        /**
         * @stability stable
         */
        get s3ContentLocation(): Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationCodeContentS3ContentLocationOutputReference;
        /**
         * @stability stable
         */
        putS3ContentLocation(value: Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationCodeContentS3ContentLocation | undefined): void;
        /**
         * @stability stable
         */
        resetS3ContentLocation(): void;
        /**
         * @stability stable
         */
        get s3ContentLocationInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationCodeContentS3ContentLocation | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#code_content_type Kinesisanalyticsv2Application#code_content_type}.
         *
         * @stability stable
         */
        readonly codeContentType: string;
        /**
         * code_content block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#code_content Kinesisanalyticsv2Application#code_content}
         *
         * @stability stable
         */
        readonly codeContent?: Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationCodeContent;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _codeContentType?;
        /**
         * @stability stable
         */
        get codeContentType(): string;
        /**
         * @stability stable
         */
        set codeContentType(value: string);
        /**
         * @stability stable
         */
        get codeContentTypeInput(): string | undefined;
        private _codeContent?;
        private __codeContentOutput;
        /**
         * @stability stable
         */
        get codeContent(): Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationCodeContentOutputReference;
        /**
         * @stability stable
         */
        putCodeContent(value: Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationCodeContent | undefined): void;
        /**
         * @stability stable
         */
        resetCodeContent(): void;
        /**
         * @stability stable
         */
        get codeContentInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationCodeContent | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationSnapshotConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#snapshots_enabled Kinesisanalyticsv2Application#snapshots_enabled}.
         *
         * @stability stable
         */
        readonly snapshotsEnabled: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationSnapshotConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _snapshotsEnabled?;
        /**
         * @stability stable
         */
        get snapshotsEnabled(): boolean | cdktf.IResolvable;
        /**
         * @stability stable
         */
        set snapshotsEnabled(value: boolean | cdktf.IResolvable);
        /**
         * @stability stable
         */
        get snapshotsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationEnvironmentPropertiesPropertyGroup {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#property_group_id Kinesisanalyticsv2Application#property_group_id}.
         *
         * @stability stable
         */
        readonly propertyGroupId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#property_map Kinesisanalyticsv2Application#property_map}.
         *
         * @stability stable
         */
        readonly propertyMap: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationEnvironmentProperties {
        /**
         * property_group block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#property_group Kinesisanalyticsv2Application#property_group}
         *
         * @stability stable
         */
        readonly propertyGroup: Kinesisanalyticsv2ApplicationApplicationConfigurationEnvironmentPropertiesPropertyGroup[];
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationEnvironmentPropertiesOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _propertyGroup?;
        /**
         * @stability stable
         */
        get propertyGroup(): Kinesisanalyticsv2ApplicationApplicationConfigurationEnvironmentPropertiesPropertyGroup[];
        /**
         * @stability stable
         */
        set propertyGroup(value: Kinesisanalyticsv2ApplicationApplicationConfigurationEnvironmentPropertiesPropertyGroup[]);
        /**
         * @stability stable
         */
        get propertyGroupInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationEnvironmentPropertiesPropertyGroup[] | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationCheckpointConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#checkpoint_interval Kinesisanalyticsv2Application#checkpoint_interval}.
         *
         * @stability stable
         */
        readonly checkpointInterval?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#checkpointing_enabled Kinesisanalyticsv2Application#checkpointing_enabled}.
         *
         * @stability stable
         */
        readonly checkpointingEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#configuration_type Kinesisanalyticsv2Application#configuration_type}.
         *
         * @stability stable
         */
        readonly configurationType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#min_pause_between_checkpoints Kinesisanalyticsv2Application#min_pause_between_checkpoints}.
         *
         * @stability stable
         */
        readonly minPauseBetweenCheckpoints?: number;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationCheckpointConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _checkpointInterval?;
        /**
         * @stability stable
         */
        get checkpointInterval(): number | undefined;
        /**
         * @stability stable
         */
        set checkpointInterval(value: number | undefined);
        /**
         * @stability stable
         */
        resetCheckpointInterval(): void;
        /**
         * @stability stable
         */
        get checkpointIntervalInput(): number | undefined;
        private _checkpointingEnabled?;
        /**
         * @stability stable
         */
        get checkpointingEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set checkpointingEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetCheckpointingEnabled(): void;
        /**
         * @stability stable
         */
        get checkpointingEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _configurationType?;
        /**
         * @stability stable
         */
        get configurationType(): string;
        /**
         * @stability stable
         */
        set configurationType(value: string);
        /**
         * @stability stable
         */
        get configurationTypeInput(): string | undefined;
        private _minPauseBetweenCheckpoints?;
        /**
         * @stability stable
         */
        get minPauseBetweenCheckpoints(): number | undefined;
        /**
         * @stability stable
         */
        set minPauseBetweenCheckpoints(value: number | undefined);
        /**
         * @stability stable
         */
        resetMinPauseBetweenCheckpoints(): void;
        /**
         * @stability stable
         */
        get minPauseBetweenCheckpointsInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationMonitoringConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#configuration_type Kinesisanalyticsv2Application#configuration_type}.
         *
         * @stability stable
         */
        readonly configurationType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#log_level Kinesisanalyticsv2Application#log_level}.
         *
         * @stability stable
         */
        readonly logLevel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#metrics_level Kinesisanalyticsv2Application#metrics_level}.
         *
         * @stability stable
         */
        readonly metricsLevel?: string;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationMonitoringConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _configurationType?;
        /**
         * @stability stable
         */
        get configurationType(): string;
        /**
         * @stability stable
         */
        set configurationType(value: string);
        /**
         * @stability stable
         */
        get configurationTypeInput(): string | undefined;
        private _logLevel?;
        /**
         * @stability stable
         */
        get logLevel(): string | undefined;
        /**
         * @stability stable
         */
        set logLevel(value: string | undefined);
        /**
         * @stability stable
         */
        resetLogLevel(): void;
        /**
         * @stability stable
         */
        get logLevelInput(): string | undefined;
        private _metricsLevel?;
        /**
         * @stability stable
         */
        get metricsLevel(): string | undefined;
        /**
         * @stability stable
         */
        set metricsLevel(value: string | undefined);
        /**
         * @stability stable
         */
        resetMetricsLevel(): void;
        /**
         * @stability stable
         */
        get metricsLevelInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationParallelismConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#auto_scaling_enabled Kinesisanalyticsv2Application#auto_scaling_enabled}.
         *
         * @stability stable
         */
        readonly autoScalingEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#configuration_type Kinesisanalyticsv2Application#configuration_type}.
         *
         * @stability stable
         */
        readonly configurationType: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#parallelism Kinesisanalyticsv2Application#parallelism}.
         *
         * @stability stable
         */
        readonly parallelism?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#parallelism_per_kpu Kinesisanalyticsv2Application#parallelism_per_kpu}.
         *
         * @stability stable
         */
        readonly parallelismPerKpu?: number;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationParallelismConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _autoScalingEnabled?;
        /**
         * @stability stable
         */
        get autoScalingEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoScalingEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoScalingEnabled(): void;
        /**
         * @stability stable
         */
        get autoScalingEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _configurationType?;
        /**
         * @stability stable
         */
        get configurationType(): string;
        /**
         * @stability stable
         */
        set configurationType(value: string);
        /**
         * @stability stable
         */
        get configurationTypeInput(): string | undefined;
        private _parallelism?;
        /**
         * @stability stable
         */
        get parallelism(): number | undefined;
        /**
         * @stability stable
         */
        set parallelism(value: number | undefined);
        /**
         * @stability stable
         */
        resetParallelism(): void;
        /**
         * @stability stable
         */
        get parallelismInput(): number | undefined;
        private _parallelismPerKpu?;
        /**
         * @stability stable
         */
        get parallelismPerKpu(): number | undefined;
        /**
         * @stability stable
         */
        set parallelismPerKpu(value: number | undefined);
        /**
         * @stability stable
         */
        resetParallelismPerKpu(): void;
        /**
         * @stability stable
         */
        get parallelismPerKpuInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfiguration {
        /**
         * checkpoint_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#checkpoint_configuration Kinesisanalyticsv2Application#checkpoint_configuration}
         *
         * @stability stable
         */
        readonly checkpointConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationCheckpointConfiguration;
        /**
         * monitoring_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#monitoring_configuration Kinesisanalyticsv2Application#monitoring_configuration}
         *
         * @stability stable
         */
        readonly monitoringConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationMonitoringConfiguration;
        /**
         * parallelism_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#parallelism_configuration Kinesisanalyticsv2Application#parallelism_configuration}
         *
         * @stability stable
         */
        readonly parallelismConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationParallelismConfiguration;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _checkpointConfiguration?;
        private __checkpointConfigurationOutput;
        /**
         * @stability stable
         */
        get checkpointConfiguration(): Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationCheckpointConfigurationOutputReference;
        /**
         * @stability stable
         */
        putCheckpointConfiguration(value: Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationCheckpointConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetCheckpointConfiguration(): void;
        /**
         * @stability stable
         */
        get checkpointConfigurationInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationCheckpointConfiguration | undefined;
        private _monitoringConfiguration?;
        private __monitoringConfigurationOutput;
        /**
         * @stability stable
         */
        get monitoringConfiguration(): Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationMonitoringConfigurationOutputReference;
        /**
         * @stability stable
         */
        putMonitoringConfiguration(value: Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationMonitoringConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetMonitoringConfiguration(): void;
        /**
         * @stability stable
         */
        get monitoringConfigurationInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationMonitoringConfiguration | undefined;
        private _parallelismConfiguration?;
        private __parallelismConfigurationOutput;
        /**
         * @stability stable
         */
        get parallelismConfiguration(): Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationParallelismConfigurationOutputReference;
        /**
         * @stability stable
         */
        putParallelismConfiguration(value: Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationParallelismConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetParallelismConfiguration(): void;
        /**
         * @stability stable
         */
        get parallelismConfigurationInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationParallelismConfiguration | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfigurationApplicationRestoreConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#application_restore_type Kinesisanalyticsv2Application#application_restore_type}.
         *
         * @stability stable
         */
        readonly applicationRestoreType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#snapshot_name Kinesisanalyticsv2Application#snapshot_name}.
         *
         * @stability stable
         */
        readonly snapshotName?: string;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfigurationApplicationRestoreConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _applicationRestoreType?;
        /**
         * @stability stable
         */
        get applicationRestoreType(): string | undefined;
        /**
         * @stability stable
         */
        set applicationRestoreType(value: string | undefined);
        /**
         * @stability stable
         */
        resetApplicationRestoreType(): void;
        /**
         * @stability stable
         */
        get applicationRestoreTypeInput(): string | undefined;
        private _snapshotName?;
        /**
         * @stability stable
         */
        get snapshotName(): string | undefined;
        /**
         * @stability stable
         */
        set snapshotName(value: string | undefined);
        /**
         * @stability stable
         */
        resetSnapshotName(): void;
        /**
         * @stability stable
         */
        get snapshotNameInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfigurationFlinkRunConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#allow_non_restored_state Kinesisanalyticsv2Application#allow_non_restored_state}.
         *
         * @stability stable
         */
        readonly allowNonRestoredState?: boolean | cdktf.IResolvable;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfigurationFlinkRunConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _allowNonRestoredState?;
        /**
         * @stability stable
         */
        get allowNonRestoredState(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set allowNonRestoredState(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAllowNonRestoredState(): void;
        /**
         * @stability stable
         */
        get allowNonRestoredStateInput(): boolean | cdktf.IResolvable | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfiguration {
        /**
         * application_restore_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#application_restore_configuration Kinesisanalyticsv2Application#application_restore_configuration}
         *
         * @stability stable
         */
        readonly applicationRestoreConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfigurationApplicationRestoreConfiguration;
        /**
         * flink_run_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#flink_run_configuration Kinesisanalyticsv2Application#flink_run_configuration}
         *
         * @stability stable
         */
        readonly flinkRunConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfigurationFlinkRunConfiguration;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _applicationRestoreConfiguration?;
        private __applicationRestoreConfigurationOutput;
        /**
         * @stability stable
         */
        get applicationRestoreConfiguration(): Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfigurationApplicationRestoreConfigurationOutputReference;
        /**
         * @stability stable
         */
        putApplicationRestoreConfiguration(value: Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfigurationApplicationRestoreConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetApplicationRestoreConfiguration(): void;
        /**
         * @stability stable
         */
        get applicationRestoreConfigurationInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfigurationApplicationRestoreConfiguration | undefined;
        private _flinkRunConfiguration?;
        private __flinkRunConfigurationOutput;
        /**
         * @stability stable
         */
        get flinkRunConfiguration(): Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfigurationFlinkRunConfigurationOutputReference;
        /**
         * @stability stable
         */
        putFlinkRunConfiguration(value: Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfigurationFlinkRunConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetFlinkRunConfiguration(): void;
        /**
         * @stability stable
         */
        get flinkRunConfigurationInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfigurationFlinkRunConfiguration | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputParallelism {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#count Kinesisanalyticsv2Application#count}.
         *
         * @stability stable
         */
        readonly count?: number;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputParallelismOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _count?;
        /**
         * @stability stable
         */
        get count(): number | undefined;
        /**
         * @stability stable
         */
        set count(value: number | undefined);
        /**
         * @stability stable
         */
        resetCount(): void;
        /**
         * @stability stable
         */
        get countInput(): number | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputProcessingConfigurationInputLambdaProcessor {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#resource_arn Kinesisanalyticsv2Application#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputProcessingConfigurationInputLambdaProcessorOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _resourceArn?;
        /**
         * @stability stable
         */
        get resourceArn(): string;
        /**
         * @stability stable
         */
        set resourceArn(value: string);
        /**
         * @stability stable
         */
        get resourceArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputProcessingConfiguration {
        /**
         * input_lambda_processor block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#input_lambda_processor Kinesisanalyticsv2Application#input_lambda_processor}
         *
         * @stability stable
         */
        readonly inputLambdaProcessor: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputProcessingConfigurationInputLambdaProcessor;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputProcessingConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _inputLambdaProcessor?;
        private __inputLambdaProcessorOutput;
        /**
         * @stability stable
         */
        get inputLambdaProcessor(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputProcessingConfigurationInputLambdaProcessorOutputReference;
        /**
         * @stability stable
         */
        putInputLambdaProcessor(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputProcessingConfigurationInputLambdaProcessor): void;
        /**
         * @stability stable
         */
        get inputLambdaProcessorInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputProcessingConfigurationInputLambdaProcessor | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordColumn {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#mapping Kinesisanalyticsv2Application#mapping}.
         *
         * @stability stable
         */
        readonly mapping?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#name Kinesisanalyticsv2Application#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#sql_type Kinesisanalyticsv2Application#sql_type}.
         *
         * @stability stable
         */
        readonly sqlType: string;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersCsvMappingParameters {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#record_column_delimiter Kinesisanalyticsv2Application#record_column_delimiter}.
         *
         * @stability stable
         */
        readonly recordColumnDelimiter: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#record_row_delimiter Kinesisanalyticsv2Application#record_row_delimiter}.
         *
         * @stability stable
         */
        readonly recordRowDelimiter: string;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersCsvMappingParametersOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _recordColumnDelimiter?;
        /**
         * @stability stable
         */
        get recordColumnDelimiter(): string;
        /**
         * @stability stable
         */
        set recordColumnDelimiter(value: string);
        /**
         * @stability stable
         */
        get recordColumnDelimiterInput(): string | undefined;
        private _recordRowDelimiter?;
        /**
         * @stability stable
         */
        get recordRowDelimiter(): string;
        /**
         * @stability stable
         */
        set recordRowDelimiter(value: string);
        /**
         * @stability stable
         */
        get recordRowDelimiterInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersJsonMappingParameters {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#record_row_path Kinesisanalyticsv2Application#record_row_path}.
         *
         * @stability stable
         */
        readonly recordRowPath: string;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersJsonMappingParametersOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _recordRowPath?;
        /**
         * @stability stable
         */
        get recordRowPath(): string;
        /**
         * @stability stable
         */
        set recordRowPath(value: string);
        /**
         * @stability stable
         */
        get recordRowPathInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParameters {
        /**
         * csv_mapping_parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#csv_mapping_parameters Kinesisanalyticsv2Application#csv_mapping_parameters}
         *
         * @stability stable
         */
        readonly csvMappingParameters?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersCsvMappingParameters;
        /**
         * json_mapping_parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#json_mapping_parameters Kinesisanalyticsv2Application#json_mapping_parameters}
         *
         * @stability stable
         */
        readonly jsonMappingParameters?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersJsonMappingParameters;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _csvMappingParameters?;
        private __csvMappingParametersOutput;
        /**
         * @stability stable
         */
        get csvMappingParameters(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersCsvMappingParametersOutputReference;
        /**
         * @stability stable
         */
        putCsvMappingParameters(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersCsvMappingParameters | undefined): void;
        /**
         * @stability stable
         */
        resetCsvMappingParameters(): void;
        /**
         * @stability stable
         */
        get csvMappingParametersInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersCsvMappingParameters | undefined;
        private _jsonMappingParameters?;
        private __jsonMappingParametersOutput;
        /**
         * @stability stable
         */
        get jsonMappingParameters(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersJsonMappingParametersOutputReference;
        /**
         * @stability stable
         */
        putJsonMappingParameters(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersJsonMappingParameters | undefined): void;
        /**
         * @stability stable
         */
        resetJsonMappingParameters(): void;
        /**
         * @stability stable
         */
        get jsonMappingParametersInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersJsonMappingParameters | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormat {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#record_format_type Kinesisanalyticsv2Application#record_format_type}.
         *
         * @stability stable
         */
        readonly recordFormatType: string;
        /**
         * mapping_parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#mapping_parameters Kinesisanalyticsv2Application#mapping_parameters}
         *
         * @stability stable
         */
        readonly mappingParameters: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParameters;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _recordFormatType?;
        /**
         * @stability stable
         */
        get recordFormatType(): string;
        /**
         * @stability stable
         */
        set recordFormatType(value: string);
        /**
         * @stability stable
         */
        get recordFormatTypeInput(): string | undefined;
        private _mappingParameters?;
        private __mappingParametersOutput;
        /**
         * @stability stable
         */
        get mappingParameters(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersOutputReference;
        /**
         * @stability stable
         */
        putMappingParameters(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParameters): void;
        /**
         * @stability stable
         */
        get mappingParametersInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParameters | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchema {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#record_encoding Kinesisanalyticsv2Application#record_encoding}.
         *
         * @stability stable
         */
        readonly recordEncoding?: string;
        /**
         * record_column block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#record_column Kinesisanalyticsv2Application#record_column}
         *
         * @stability stable
         */
        readonly recordColumn: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordColumn[];
        /**
         * record_format block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#record_format Kinesisanalyticsv2Application#record_format}
         *
         * @stability stable
         */
        readonly recordFormat: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormat;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _recordEncoding?;
        /**
         * @stability stable
         */
        get recordEncoding(): string | undefined;
        /**
         * @stability stable
         */
        set recordEncoding(value: string | undefined);
        /**
         * @stability stable
         */
        resetRecordEncoding(): void;
        /**
         * @stability stable
         */
        get recordEncodingInput(): string | undefined;
        private _recordColumn?;
        /**
         * @stability stable
         */
        get recordColumn(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordColumn[];
        /**
         * @stability stable
         */
        set recordColumn(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordColumn[]);
        /**
         * @stability stable
         */
        get recordColumnInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordColumn[] | undefined;
        private _recordFormat?;
        private __recordFormatOutput;
        /**
         * @stability stable
         */
        get recordFormat(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatOutputReference;
        /**
         * @stability stable
         */
        putRecordFormat(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormat): void;
        /**
         * @stability stable
         */
        get recordFormatInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormat | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputStartingPositionConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#input_starting_position Kinesisanalyticsv2Application#input_starting_position}.
         *
         * @stability stable
         */
        readonly inputStartingPosition?: string;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputKinesisFirehoseInput {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#resource_arn Kinesisanalyticsv2Application#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputKinesisFirehoseInputOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _resourceArn?;
        /**
         * @stability stable
         */
        get resourceArn(): string;
        /**
         * @stability stable
         */
        set resourceArn(value: string);
        /**
         * @stability stable
         */
        get resourceArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputKinesisStreamsInput {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#resource_arn Kinesisanalyticsv2Application#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputKinesisStreamsInputOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _resourceArn?;
        /**
         * @stability stable
         */
        get resourceArn(): string;
        /**
         * @stability stable
         */
        set resourceArn(value: string);
        /**
         * @stability stable
         */
        get resourceArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInput {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#name_prefix Kinesisanalyticsv2Application#name_prefix}.
         *
         * @stability stable
         */
        readonly namePrefix: string;
        /**
         * input_parallelism block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#input_parallelism Kinesisanalyticsv2Application#input_parallelism}
         *
         * @stability stable
         */
        readonly inputParallelism?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputParallelism;
        /**
         * input_processing_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#input_processing_configuration Kinesisanalyticsv2Application#input_processing_configuration}
         *
         * @stability stable
         */
        readonly inputProcessingConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputProcessingConfiguration;
        /**
         * input_schema block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#input_schema Kinesisanalyticsv2Application#input_schema}
         *
         * @stability stable
         */
        readonly inputSchema: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchema;
        /**
         * input_starting_position_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#input_starting_position_configuration Kinesisanalyticsv2Application#input_starting_position_configuration}
         *
         * @stability stable
         */
        readonly inputStartingPositionConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputStartingPositionConfiguration[];
        /**
         * kinesis_firehose_input block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#kinesis_firehose_input Kinesisanalyticsv2Application#kinesis_firehose_input}
         *
         * @stability stable
         */
        readonly kinesisFirehoseInput?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputKinesisFirehoseInput;
        /**
         * kinesis_streams_input block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#kinesis_streams_input Kinesisanalyticsv2Application#kinesis_streams_input}
         *
         * @stability stable
         */
        readonly kinesisStreamsInput?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputKinesisStreamsInput;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _namePrefix?;
        /**
         * @stability stable
         */
        get namePrefix(): string;
        /**
         * @stability stable
         */
        set namePrefix(value: string);
        /**
         * @stability stable
         */
        get namePrefixInput(): string | undefined;
        private _inputParallelism?;
        private __inputParallelismOutput;
        /**
         * @stability stable
         */
        get inputParallelism(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputParallelismOutputReference;
        /**
         * @stability stable
         */
        putInputParallelism(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputParallelism | undefined): void;
        /**
         * @stability stable
         */
        resetInputParallelism(): void;
        /**
         * @stability stable
         */
        get inputParallelismInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputParallelism | undefined;
        private _inputProcessingConfiguration?;
        private __inputProcessingConfigurationOutput;
        /**
         * @stability stable
         */
        get inputProcessingConfiguration(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputProcessingConfigurationOutputReference;
        /**
         * @stability stable
         */
        putInputProcessingConfiguration(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputProcessingConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetInputProcessingConfiguration(): void;
        /**
         * @stability stable
         */
        get inputProcessingConfigurationInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputProcessingConfiguration | undefined;
        private _inputSchema?;
        private __inputSchemaOutput;
        /**
         * @stability stable
         */
        get inputSchema(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaOutputReference;
        /**
         * @stability stable
         */
        putInputSchema(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchema): void;
        /**
         * @stability stable
         */
        get inputSchemaInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchema | undefined;
        private _inputStartingPositionConfiguration?;
        /**
         * @stability stable
         */
        get inputStartingPositionConfiguration(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputStartingPositionConfiguration[] | undefined;
        /**
         * @stability stable
         */
        set inputStartingPositionConfiguration(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputStartingPositionConfiguration[] | undefined);
        /**
         * @stability stable
         */
        resetInputStartingPositionConfiguration(): void;
        /**
         * @stability stable
         */
        get inputStartingPositionConfigurationInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputStartingPositionConfiguration[] | undefined;
        private _kinesisFirehoseInput?;
        private __kinesisFirehoseInputOutput;
        /**
         * @stability stable
         */
        get kinesisFirehoseInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputKinesisFirehoseInputOutputReference;
        /**
         * @stability stable
         */
        putKinesisFirehoseInput(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputKinesisFirehoseInput | undefined): void;
        /**
         * @stability stable
         */
        resetKinesisFirehoseInput(): void;
        /**
         * @stability stable
         */
        get kinesisFirehoseInputInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputKinesisFirehoseInput | undefined;
        private _kinesisStreamsInput?;
        private __kinesisStreamsInputOutput;
        /**
         * @stability stable
         */
        get kinesisStreamsInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputKinesisStreamsInputOutputReference;
        /**
         * @stability stable
         */
        putKinesisStreamsInput(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputKinesisStreamsInput | undefined): void;
        /**
         * @stability stable
         */
        resetKinesisStreamsInput(): void;
        /**
         * @stability stable
         */
        get kinesisStreamsInputInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputKinesisStreamsInput | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputDestinationSchema {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#record_format_type Kinesisanalyticsv2Application#record_format_type}.
         *
         * @stability stable
         */
        readonly recordFormatType: string;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputDestinationSchemaOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _recordFormatType?;
        /**
         * @stability stable
         */
        get recordFormatType(): string;
        /**
         * @stability stable
         */
        set recordFormatType(value: string);
        /**
         * @stability stable
         */
        get recordFormatTypeInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputKinesisFirehoseOutput {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#resource_arn Kinesisanalyticsv2Application#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputKinesisFirehoseOutputOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _resourceArn?;
        /**
         * @stability stable
         */
        get resourceArn(): string;
        /**
         * @stability stable
         */
        set resourceArn(value: string);
        /**
         * @stability stable
         */
        get resourceArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputKinesisStreamsOutput {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#resource_arn Kinesisanalyticsv2Application#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputKinesisStreamsOutputOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _resourceArn?;
        /**
         * @stability stable
         */
        get resourceArn(): string;
        /**
         * @stability stable
         */
        set resourceArn(value: string);
        /**
         * @stability stable
         */
        get resourceArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputLambdaOutput {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#resource_arn Kinesisanalyticsv2Application#resource_arn}.
         *
         * @stability stable
         */
        readonly resourceArn: string;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputLambdaOutputOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _resourceArn?;
        /**
         * @stability stable
         */
        get resourceArn(): string;
        /**
         * @stability stable
         */
        set resourceArn(value: string);
        /**
         * @stability stable
         */
        get resourceArnInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutput {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#name Kinesisanalyticsv2Application#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * destination_schema block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#destination_schema Kinesisanalyticsv2Application#destination_schema}
         *
         * @stability stable
         */
        readonly destinationSchema: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputDestinationSchema;
        /**
         * kinesis_firehose_output block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#kinesis_firehose_output Kinesisanalyticsv2Application#kinesis_firehose_output}
         *
         * @stability stable
         */
        readonly kinesisFirehoseOutput?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputKinesisFirehoseOutput;
        /**
         * kinesis_streams_output block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#kinesis_streams_output Kinesisanalyticsv2Application#kinesis_streams_output}
         *
         * @stability stable
         */
        readonly kinesisStreamsOutput?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputKinesisStreamsOutput;
        /**
         * lambda_output block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#lambda_output Kinesisanalyticsv2Application#lambda_output}
         *
         * @stability stable
         */
        readonly lambdaOutput?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputLambdaOutput;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordColumn {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#mapping Kinesisanalyticsv2Application#mapping}.
         *
         * @stability stable
         */
        readonly mapping?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#name Kinesisanalyticsv2Application#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#sql_type Kinesisanalyticsv2Application#sql_type}.
         *
         * @stability stable
         */
        readonly sqlType: string;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersCsvMappingParameters {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#record_column_delimiter Kinesisanalyticsv2Application#record_column_delimiter}.
         *
         * @stability stable
         */
        readonly recordColumnDelimiter: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#record_row_delimiter Kinesisanalyticsv2Application#record_row_delimiter}.
         *
         * @stability stable
         */
        readonly recordRowDelimiter: string;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersCsvMappingParametersOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _recordColumnDelimiter?;
        /**
         * @stability stable
         */
        get recordColumnDelimiter(): string;
        /**
         * @stability stable
         */
        set recordColumnDelimiter(value: string);
        /**
         * @stability stable
         */
        get recordColumnDelimiterInput(): string | undefined;
        private _recordRowDelimiter?;
        /**
         * @stability stable
         */
        get recordRowDelimiter(): string;
        /**
         * @stability stable
         */
        set recordRowDelimiter(value: string);
        /**
         * @stability stable
         */
        get recordRowDelimiterInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersJsonMappingParameters {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#record_row_path Kinesisanalyticsv2Application#record_row_path}.
         *
         * @stability stable
         */
        readonly recordRowPath: string;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersJsonMappingParametersOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _recordRowPath?;
        /**
         * @stability stable
         */
        get recordRowPath(): string;
        /**
         * @stability stable
         */
        set recordRowPath(value: string);
        /**
         * @stability stable
         */
        get recordRowPathInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParameters {
        /**
         * csv_mapping_parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#csv_mapping_parameters Kinesisanalyticsv2Application#csv_mapping_parameters}
         *
         * @stability stable
         */
        readonly csvMappingParameters?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersCsvMappingParameters;
        /**
         * json_mapping_parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#json_mapping_parameters Kinesisanalyticsv2Application#json_mapping_parameters}
         *
         * @stability stable
         */
        readonly jsonMappingParameters?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersJsonMappingParameters;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _csvMappingParameters?;
        private __csvMappingParametersOutput;
        /**
         * @stability stable
         */
        get csvMappingParameters(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersCsvMappingParametersOutputReference;
        /**
         * @stability stable
         */
        putCsvMappingParameters(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersCsvMappingParameters | undefined): void;
        /**
         * @stability stable
         */
        resetCsvMappingParameters(): void;
        /**
         * @stability stable
         */
        get csvMappingParametersInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersCsvMappingParameters | undefined;
        private _jsonMappingParameters?;
        private __jsonMappingParametersOutput;
        /**
         * @stability stable
         */
        get jsonMappingParameters(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersJsonMappingParametersOutputReference;
        /**
         * @stability stable
         */
        putJsonMappingParameters(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersJsonMappingParameters | undefined): void;
        /**
         * @stability stable
         */
        resetJsonMappingParameters(): void;
        /**
         * @stability stable
         */
        get jsonMappingParametersInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersJsonMappingParameters | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormat {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#record_format_type Kinesisanalyticsv2Application#record_format_type}.
         *
         * @stability stable
         */
        readonly recordFormatType: string;
        /**
         * mapping_parameters block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#mapping_parameters Kinesisanalyticsv2Application#mapping_parameters}
         *
         * @stability stable
         */
        readonly mappingParameters: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParameters;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _recordFormatType?;
        /**
         * @stability stable
         */
        get recordFormatType(): string;
        /**
         * @stability stable
         */
        set recordFormatType(value: string);
        /**
         * @stability stable
         */
        get recordFormatTypeInput(): string | undefined;
        private _mappingParameters?;
        private __mappingParametersOutput;
        /**
         * @stability stable
         */
        get mappingParameters(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersOutputReference;
        /**
         * @stability stable
         */
        putMappingParameters(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParameters): void;
        /**
         * @stability stable
         */
        get mappingParametersInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParameters | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchema {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#record_encoding Kinesisanalyticsv2Application#record_encoding}.
         *
         * @stability stable
         */
        readonly recordEncoding?: string;
        /**
         * record_column block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#record_column Kinesisanalyticsv2Application#record_column}
         *
         * @stability stable
         */
        readonly recordColumn: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordColumn[];
        /**
         * record_format block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#record_format Kinesisanalyticsv2Application#record_format}
         *
         * @stability stable
         */
        readonly recordFormat: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormat;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _recordEncoding?;
        /**
         * @stability stable
         */
        get recordEncoding(): string | undefined;
        /**
         * @stability stable
         */
        set recordEncoding(value: string | undefined);
        /**
         * @stability stable
         */
        resetRecordEncoding(): void;
        /**
         * @stability stable
         */
        get recordEncodingInput(): string | undefined;
        private _recordColumn?;
        /**
         * @stability stable
         */
        get recordColumn(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordColumn[];
        /**
         * @stability stable
         */
        set recordColumn(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordColumn[]);
        /**
         * @stability stable
         */
        get recordColumnInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordColumn[] | undefined;
        private _recordFormat?;
        private __recordFormatOutput;
        /**
         * @stability stable
         */
        get recordFormat(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatOutputReference;
        /**
         * @stability stable
         */
        putRecordFormat(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormat): void;
        /**
         * @stability stable
         */
        get recordFormatInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormat | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceS3ReferenceDataSource {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#bucket_arn Kinesisanalyticsv2Application#bucket_arn}.
         *
         * @stability stable
         */
        readonly bucketArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#file_key Kinesisanalyticsv2Application#file_key}.
         *
         * @stability stable
         */
        readonly fileKey: string;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceS3ReferenceDataSourceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _bucketArn?;
        /**
         * @stability stable
         */
        get bucketArn(): string;
        /**
         * @stability stable
         */
        set bucketArn(value: string);
        /**
         * @stability stable
         */
        get bucketArnInput(): string | undefined;
        private _fileKey?;
        /**
         * @stability stable
         */
        get fileKey(): string;
        /**
         * @stability stable
         */
        set fileKey(value: string);
        /**
         * @stability stable
         */
        get fileKeyInput(): string | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSource {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#table_name Kinesisanalyticsv2Application#table_name}.
         *
         * @stability stable
         */
        readonly tableName: string;
        /**
         * reference_schema block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#reference_schema Kinesisanalyticsv2Application#reference_schema}
         *
         * @stability stable
         */
        readonly referenceSchema: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchema;
        /**
         * s3_reference_data_source block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#s3_reference_data_source Kinesisanalyticsv2Application#s3_reference_data_source}
         *
         * @stability stable
         */
        readonly s3ReferenceDataSource: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceS3ReferenceDataSource;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _tableName?;
        /**
         * @stability stable
         */
        get tableName(): string;
        /**
         * @stability stable
         */
        set tableName(value: string);
        /**
         * @stability stable
         */
        get tableNameInput(): string | undefined;
        private _referenceSchema?;
        private __referenceSchemaOutput;
        /**
         * @stability stable
         */
        get referenceSchema(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaOutputReference;
        /**
         * @stability stable
         */
        putReferenceSchema(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchema): void;
        /**
         * @stability stable
         */
        get referenceSchemaInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchema | undefined;
        private _s3ReferenceDataSource?;
        private __s3ReferenceDataSourceOutput;
        /**
         * @stability stable
         */
        get s3ReferenceDataSource(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceS3ReferenceDataSourceOutputReference;
        /**
         * @stability stable
         */
        putS3ReferenceDataSource(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceS3ReferenceDataSource): void;
        /**
         * @stability stable
         */
        get s3ReferenceDataSourceInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceS3ReferenceDataSource | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfiguration {
        /**
         * input block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#input Kinesisanalyticsv2Application#input}
         *
         * @stability stable
         */
        readonly input?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInput;
        /**
         * output block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#output Kinesisanalyticsv2Application#output}
         *
         * @stability stable
         */
        readonly output?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutput[];
        /**
         * reference_data_source block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#reference_data_source Kinesisanalyticsv2Application#reference_data_source}
         *
         * @stability stable
         */
        readonly referenceDataSource?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSource;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _input?;
        private __inputOutput;
        /**
         * @stability stable
         */
        get input(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputOutputReference;
        /**
         * @stability stable
         */
        putInput(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInput | undefined): void;
        /**
         * @stability stable
         */
        resetInput(): void;
        /**
         * @stability stable
         */
        get inputInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInput | undefined;
        private _output?;
        /**
         * @stability stable
         */
        get output(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutput[] | undefined;
        /**
         * @stability stable
         */
        set output(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutput[] | undefined);
        /**
         * @stability stable
         */
        resetOutput(): void;
        /**
         * @stability stable
         */
        get outputInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutput[] | undefined;
        private _referenceDataSource?;
        private __referenceDataSourceOutput;
        /**
         * @stability stable
         */
        get referenceDataSource(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceOutputReference;
        /**
         * @stability stable
         */
        putReferenceDataSource(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSource | undefined): void;
        /**
         * @stability stable
         */
        resetReferenceDataSource(): void;
        /**
         * @stability stable
         */
        get referenceDataSourceInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSource | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfigurationVpcConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#security_group_ids Kinesisanalyticsv2Application#security_group_ids}.
         *
         * @stability stable
         */
        readonly securityGroupIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#subnet_ids Kinesisanalyticsv2Application#subnet_ids}.
         *
         * @stability stable
         */
        readonly subnetIds: string[];
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationVpcConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _securityGroupIds?;
        /**
         * @stability stable
         */
        get securityGroupIds(): string[];
        /**
         * @stability stable
         */
        set securityGroupIds(value: string[]);
        /**
         * @stability stable
         */
        get securityGroupIdsInput(): string[] | undefined;
        private _subnetIds?;
        /**
         * @stability stable
         */
        get subnetIds(): string[];
        /**
         * @stability stable
         */
        set subnetIds(value: string[]);
        /**
         * @stability stable
         */
        get subnetIdsInput(): string[] | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationApplicationConfiguration {
        /**
         * application_code_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#application_code_configuration Kinesisanalyticsv2Application#application_code_configuration}
         *
         * @stability stable
         */
        readonly applicationCodeConfiguration: Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfiguration;
        /**
         * application_snapshot_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#application_snapshot_configuration Kinesisanalyticsv2Application#application_snapshot_configuration}
         *
         * @stability stable
         */
        readonly applicationSnapshotConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationSnapshotConfiguration;
        /**
         * environment_properties block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#environment_properties Kinesisanalyticsv2Application#environment_properties}
         *
         * @stability stable
         */
        readonly environmentProperties?: Kinesisanalyticsv2ApplicationApplicationConfigurationEnvironmentProperties;
        /**
         * flink_application_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#flink_application_configuration Kinesisanalyticsv2Application#flink_application_configuration}
         *
         * @stability stable
         */
        readonly flinkApplicationConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfiguration;
        /**
         * run_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#run_configuration Kinesisanalyticsv2Application#run_configuration}
         *
         * @stability stable
         */
        readonly runConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfiguration;
        /**
         * sql_application_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#sql_application_configuration Kinesisanalyticsv2Application#sql_application_configuration}
         *
         * @stability stable
         */
        readonly sqlApplicationConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfiguration;
        /**
         * vpc_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#vpc_configuration Kinesisanalyticsv2Application#vpc_configuration}
         *
         * @stability stable
         */
        readonly vpcConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationVpcConfiguration;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationApplicationConfigurationOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _applicationCodeConfiguration?;
        private __applicationCodeConfigurationOutput;
        /**
         * @stability stable
         */
        get applicationCodeConfiguration(): Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationOutputReference;
        /**
         * @stability stable
         */
        putApplicationCodeConfiguration(value: Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfiguration): void;
        /**
         * @stability stable
         */
        get applicationCodeConfigurationInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfiguration | undefined;
        private _applicationSnapshotConfiguration?;
        private __applicationSnapshotConfigurationOutput;
        /**
         * @stability stable
         */
        get applicationSnapshotConfiguration(): Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationSnapshotConfigurationOutputReference;
        /**
         * @stability stable
         */
        putApplicationSnapshotConfiguration(value: Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationSnapshotConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetApplicationSnapshotConfiguration(): void;
        /**
         * @stability stable
         */
        get applicationSnapshotConfigurationInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationSnapshotConfiguration | undefined;
        private _environmentProperties?;
        private __environmentPropertiesOutput;
        /**
         * @stability stable
         */
        get environmentProperties(): Kinesisanalyticsv2ApplicationApplicationConfigurationEnvironmentPropertiesOutputReference;
        /**
         * @stability stable
         */
        putEnvironmentProperties(value: Kinesisanalyticsv2ApplicationApplicationConfigurationEnvironmentProperties | undefined): void;
        /**
         * @stability stable
         */
        resetEnvironmentProperties(): void;
        /**
         * @stability stable
         */
        get environmentPropertiesInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationEnvironmentProperties | undefined;
        private _flinkApplicationConfiguration?;
        private __flinkApplicationConfigurationOutput;
        /**
         * @stability stable
         */
        get flinkApplicationConfiguration(): Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationOutputReference;
        /**
         * @stability stable
         */
        putFlinkApplicationConfiguration(value: Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetFlinkApplicationConfiguration(): void;
        /**
         * @stability stable
         */
        get flinkApplicationConfigurationInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfiguration | undefined;
        private _runConfiguration?;
        private __runConfigurationOutput;
        /**
         * @stability stable
         */
        get runConfiguration(): Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfigurationOutputReference;
        /**
         * @stability stable
         */
        putRunConfiguration(value: Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetRunConfiguration(): void;
        /**
         * @stability stable
         */
        get runConfigurationInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationRunConfiguration | undefined;
        private _sqlApplicationConfiguration?;
        private __sqlApplicationConfigurationOutput;
        /**
         * @stability stable
         */
        get sqlApplicationConfiguration(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputReference;
        /**
         * @stability stable
         */
        putSqlApplicationConfiguration(value: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetSqlApplicationConfiguration(): void;
        /**
         * @stability stable
         */
        get sqlApplicationConfigurationInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfiguration | undefined;
        private _vpcConfiguration?;
        private __vpcConfigurationOutput;
        /**
         * @stability stable
         */
        get vpcConfiguration(): Kinesisanalyticsv2ApplicationApplicationConfigurationVpcConfigurationOutputReference;
        /**
         * @stability stable
         */
        putVpcConfiguration(value: Kinesisanalyticsv2ApplicationApplicationConfigurationVpcConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetVpcConfiguration(): void;
        /**
         * @stability stable
         */
        get vpcConfigurationInput(): Kinesisanalyticsv2ApplicationApplicationConfigurationVpcConfiguration | undefined;
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationCloudwatchLoggingOptions {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html#log_stream_arn Kinesisanalyticsv2Application#log_stream_arn}.
         *
         * @stability stable
         */
        readonly logStreamArn: string;
    }
    /**
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationCloudwatchLoggingOptionsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _logStreamArn?;
        /**
         * @stability stable
         */
        get logStreamArn(): string;
        /**
         * @stability stable
         */
        set logStreamArn(value: string);
        /**
         * @stability stable
         */
        get logStreamArnInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html aws_kinesisanalyticsv2_application}.
     *
     * @stability stable
     */
    class Kinesisanalyticsv2Application extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application.html aws_kinesisanalyticsv2_application} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Kinesisanalyticsv2ApplicationConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get createTimestamp(): string;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _forceStop?;
        /**
         * @stability stable
         */
        get forceStop(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set forceStop(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetForceStop(): void;
        /**
         * @stability stable
         */
        get forceStopInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get lastUpdateTimestamp(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _runtimeEnvironment?;
        /**
         * @stability stable
         */
        get runtimeEnvironment(): string;
        /**
         * @stability stable
         */
        set runtimeEnvironment(value: string);
        /**
         * @stability stable
         */
        get runtimeEnvironmentInput(): string | undefined;
        private _serviceExecutionRole?;
        /**
         * @stability stable
         */
        get serviceExecutionRole(): string;
        /**
         * @stability stable
         */
        set serviceExecutionRole(value: string);
        /**
         * @stability stable
         */
        get serviceExecutionRoleInput(): string | undefined;
        private _startApplication?;
        /**
         * @stability stable
         */
        get startApplication(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set startApplication(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetStartApplication(): void;
        /**
         * @stability stable
         */
        get startApplicationInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        get versionId(): number;
        private _applicationConfiguration?;
        private __applicationConfigurationOutput;
        /**
         * @stability stable
         */
        get applicationConfiguration(): Kinesisanalyticsv2ApplicationApplicationConfigurationOutputReference;
        /**
         * @stability stable
         */
        putApplicationConfiguration(value: Kinesisanalyticsv2ApplicationApplicationConfiguration | undefined): void;
        /**
         * @stability stable
         */
        resetApplicationConfiguration(): void;
        /**
         * @stability stable
         */
        get applicationConfigurationInput(): Kinesisanalyticsv2ApplicationApplicationConfiguration | undefined;
        private _cloudwatchLoggingOptions?;
        private __cloudwatchLoggingOptionsOutput;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptions(): Kinesisanalyticsv2ApplicationCloudwatchLoggingOptionsOutputReference;
        /**
         * @stability stable
         */
        putCloudwatchLoggingOptions(value: Kinesisanalyticsv2ApplicationCloudwatchLoggingOptions | undefined): void;
        /**
         * @stability stable
         */
        resetCloudwatchLoggingOptions(): void;
        /**
         * @stability stable
         */
        get cloudwatchLoggingOptionsInput(): Kinesisanalyticsv2ApplicationCloudwatchLoggingOptions | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface Kinesisanalyticsv2ApplicationSnapshotConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application_snapshot.html#application_name Kinesisanalyticsv2ApplicationSnapshot#application_name}.
         *
         * @stability stable
         */
        readonly applicationName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application_snapshot.html#snapshot_name Kinesisanalyticsv2ApplicationSnapshot#snapshot_name}.
         *
         * @stability stable
         */
        readonly snapshotName: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application_snapshot.html aws_kinesisanalyticsv2_application_snapshot}.
     *
     * @stability stable
     */
    class Kinesisanalyticsv2ApplicationSnapshot extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/kinesisanalyticsv2_application_snapshot.html aws_kinesisanalyticsv2_application_snapshot} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: Kinesisanalyticsv2ApplicationSnapshotConfig);
        private _applicationName?;
        /**
         * @stability stable
         */
        get applicationName(): string;
        /**
         * @stability stable
         */
        set applicationName(value: string);
        /**
         * @stability stable
         */
        get applicationNameInput(): string | undefined;
        /**
         * @stability stable
         */
        get applicationVersionId(): number;
        /**
         * @stability stable
         */
        get id(): string;
        /**
         * @stability stable
         */
        get snapshotCreationTimestamp(): string;
        private _snapshotName?;
        /**
         * @stability stable
         */
        get snapshotName(): string;
        /**
         * @stability stable
         */
        set snapshotName(value: string);
        /**
         * @stability stable
         */
        get snapshotNameInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsKinesisFirehoseDeliveryStreamConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kinesis_firehose_delivery_stream.html#name DataAwsKinesisFirehoseDeliveryStream#name}.
         *
         * @stability stable
         */
        readonly name: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/kinesis_firehose_delivery_stream.html aws_kinesis_firehose_delivery_stream}.
     *
     * @stability stable
     */
    class DataAwsKinesisFirehoseDeliveryStream extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/kinesis_firehose_delivery_stream.html aws_kinesis_firehose_delivery_stream} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsKinesisFirehoseDeliveryStreamConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsKinesisStreamConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kinesis_stream.html#name DataAwsKinesisStream#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kinesis_stream.html#tags DataAwsKinesisStream#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/kinesis_stream.html aws_kinesis_stream}.
     *
     * @stability stable
     */
    class DataAwsKinesisStream extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/kinesis_stream.html aws_kinesis_stream} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsKinesisStreamConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get closedShards(): string[];
        /**
         * @stability stable
         */
        get creationTimestamp(): number;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get openShards(): string[];
        /**
         * @stability stable
         */
        get retentionPeriod(): number;
        /**
         * @stability stable
         */
        get shardLevelMetrics(): string[];
        /**
         * @stability stable
         */
        get status(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface DataAwsKinesisStreamConsumerConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kinesis_stream_consumer.html#name DataAwsKinesisStreamConsumer#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kinesis_stream_consumer.html#stream_arn DataAwsKinesisStreamConsumer#stream_arn}.
         *
         * @stability stable
         */
        readonly streamArn: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/d/kinesis_stream_consumer.html aws_kinesis_stream_consumer}.
     *
     * @stability stable
     */
    class DataAwsKinesisStreamConsumer extends cdktf.TerraformDataSource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/d/kinesis_stream_consumer.html aws_kinesis_stream_consumer} Data Source.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: DataAwsKinesisStreamConsumerConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        /**
         * @stability stable
         */
        get creationTimestamp(): string;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        /**
         * @stability stable
         */
        get status(): string;
        private _streamArn?;
        /**
         * @stability stable
         */
        get streamArn(): string;
        /**
         * @stability stable
         */
        set streamArn(value: string);
        /**
         * @stability stable
         */
        get streamArnInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
