import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS OpsWorks
*/
export declare namespace OpsWorks {
    /**
     * @stability stable
     */
    interface OpsworksApplicationConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#auto_bundle_on_deploy OpsworksApplication#auto_bundle_on_deploy}.
         *
         * @stability stable
         */
        readonly autoBundleOnDeploy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#aws_flow_ruby_settings OpsworksApplication#aws_flow_ruby_settings}.
         *
         * @stability stable
         */
        readonly awsFlowRubySettings?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#data_source_arn OpsworksApplication#data_source_arn}.
         *
         * @stability stable
         */
        readonly dataSourceArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#data_source_database_name OpsworksApplication#data_source_database_name}.
         *
         * @stability stable
         */
        readonly dataSourceDatabaseName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#data_source_type OpsworksApplication#data_source_type}.
         *
         * @stability stable
         */
        readonly dataSourceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#description OpsworksApplication#description}.
         *
         * @stability stable
         */
        readonly description?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#document_root OpsworksApplication#document_root}.
         *
         * @stability stable
         */
        readonly documentRoot?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#domains OpsworksApplication#domains}.
         *
         * @stability stable
         */
        readonly domains?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#enable_ssl OpsworksApplication#enable_ssl}.
         *
         * @stability stable
         */
        readonly enableSsl?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#name OpsworksApplication#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#rails_env OpsworksApplication#rails_env}.
         *
         * @stability stable
         */
        readonly railsEnv?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#short_name OpsworksApplication#short_name}.
         *
         * @stability stable
         */
        readonly shortName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#stack_id OpsworksApplication#stack_id}.
         *
         * @stability stable
         */
        readonly stackId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#type OpsworksApplication#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * app_source block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#app_source OpsworksApplication#app_source}
         *
         * @stability stable
         */
        readonly appSource?: OpsworksApplicationAppSource[];
        /**
         * environment block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#environment OpsworksApplication#environment}
         *
         * @stability stable
         */
        readonly environment?: OpsworksApplicationEnvironment[];
        /**
         * ssl_configuration block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#ssl_configuration OpsworksApplication#ssl_configuration}
         *
         * @stability stable
         */
        readonly sslConfiguration?: OpsworksApplicationSslConfiguration[];
    }
    /**
     * @stability stable
     */
    interface OpsworksApplicationAppSource {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#password OpsworksApplication#password}.
         *
         * @stability stable
         */
        readonly password?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#revision OpsworksApplication#revision}.
         *
         * @stability stable
         */
        readonly revision?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#ssh_key OpsworksApplication#ssh_key}.
         *
         * @stability stable
         */
        readonly sshKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#type OpsworksApplication#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#url OpsworksApplication#url}.
         *
         * @stability stable
         */
        readonly url?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#username OpsworksApplication#username}.
         *
         * @stability stable
         */
        readonly username?: string;
    }
    /**
     * @stability stable
     */
    interface OpsworksApplicationEnvironment {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#key OpsworksApplication#key}.
         *
         * @stability stable
         */
        readonly key: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#secure OpsworksApplication#secure}.
         *
         * @stability stable
         */
        readonly secure?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#value OpsworksApplication#value}.
         *
         * @stability stable
         */
        readonly value: string;
    }
    /**
     * @stability stable
     */
    interface OpsworksApplicationSslConfiguration {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#certificate OpsworksApplication#certificate}.
         *
         * @stability stable
         */
        readonly certificate: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#chain OpsworksApplication#chain}.
         *
         * @stability stable
         */
        readonly chain?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html#private_key OpsworksApplication#private_key}.
         *
         * @stability stable
         */
        readonly privateKey: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html aws_opsworks_application}.
     *
     * @stability stable
     */
    class OpsworksApplication extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application.html aws_opsworks_application} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: OpsworksApplicationConfig);
        private _autoBundleOnDeploy?;
        /**
         * @stability stable
         */
        get autoBundleOnDeploy(): string | undefined;
        /**
         * @stability stable
         */
        set autoBundleOnDeploy(value: string | undefined);
        /**
         * @stability stable
         */
        resetAutoBundleOnDeploy(): void;
        /**
         * @stability stable
         */
        get autoBundleOnDeployInput(): string | undefined;
        private _awsFlowRubySettings?;
        /**
         * @stability stable
         */
        get awsFlowRubySettings(): string | undefined;
        /**
         * @stability stable
         */
        set awsFlowRubySettings(value: string | undefined);
        /**
         * @stability stable
         */
        resetAwsFlowRubySettings(): void;
        /**
         * @stability stable
         */
        get awsFlowRubySettingsInput(): string | undefined;
        private _dataSourceArn?;
        /**
         * @stability stable
         */
        get dataSourceArn(): string | undefined;
        /**
         * @stability stable
         */
        set dataSourceArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetDataSourceArn(): void;
        /**
         * @stability stable
         */
        get dataSourceArnInput(): string | undefined;
        private _dataSourceDatabaseName?;
        /**
         * @stability stable
         */
        get dataSourceDatabaseName(): string | undefined;
        /**
         * @stability stable
         */
        set dataSourceDatabaseName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDataSourceDatabaseName(): void;
        /**
         * @stability stable
         */
        get dataSourceDatabaseNameInput(): string | undefined;
        private _dataSourceType?;
        /**
         * @stability stable
         */
        get dataSourceType(): string | undefined;
        /**
         * @stability stable
         */
        set dataSourceType(value: string | undefined);
        /**
         * @stability stable
         */
        resetDataSourceType(): void;
        /**
         * @stability stable
         */
        get dataSourceTypeInput(): string | undefined;
        private _description?;
        /**
         * @stability stable
         */
        get description(): string | undefined;
        /**
         * @stability stable
         */
        set description(value: string | undefined);
        /**
         * @stability stable
         */
        resetDescription(): void;
        /**
         * @stability stable
         */
        get descriptionInput(): string | undefined;
        private _documentRoot?;
        /**
         * @stability stable
         */
        get documentRoot(): string | undefined;
        /**
         * @stability stable
         */
        set documentRoot(value: string | undefined);
        /**
         * @stability stable
         */
        resetDocumentRoot(): void;
        /**
         * @stability stable
         */
        get documentRootInput(): string | undefined;
        private _domains?;
        /**
         * @stability stable
         */
        get domains(): string[] | undefined;
        /**
         * @stability stable
         */
        set domains(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetDomains(): void;
        /**
         * @stability stable
         */
        get domainsInput(): string[] | undefined;
        private _enableSsl?;
        /**
         * @stability stable
         */
        get enableSsl(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set enableSsl(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEnableSsl(): void;
        /**
         * @stability stable
         */
        get enableSslInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _railsEnv?;
        /**
         * @stability stable
         */
        get railsEnv(): string | undefined;
        /**
         * @stability stable
         */
        set railsEnv(value: string | undefined);
        /**
         * @stability stable
         */
        resetRailsEnv(): void;
        /**
         * @stability stable
         */
        get railsEnvInput(): string | undefined;
        private _shortName?;
        /**
         * @stability stable
         */
        get shortName(): string | undefined;
        /**
         * @stability stable
         */
        set shortName(value: string | undefined);
        /**
         * @stability stable
         */
        resetShortName(): void;
        /**
         * @stability stable
         */
        get shortNameInput(): string | undefined;
        private _stackId?;
        /**
         * @stability stable
         */
        get stackId(): string;
        /**
         * @stability stable
         */
        set stackId(value: string);
        /**
         * @stability stable
         */
        get stackIdInput(): string | undefined;
        private _type?;
        /**
         * @stability stable
         */
        get type(): string;
        /**
         * @stability stable
         */
        set type(value: string);
        /**
         * @stability stable
         */
        get typeInput(): string | undefined;
        private _appSource?;
        /**
         * @stability stable
         */
        get appSource(): OpsworksApplicationAppSource[] | undefined;
        /**
         * @stability stable
         */
        set appSource(value: OpsworksApplicationAppSource[] | undefined);
        /**
         * @stability stable
         */
        resetAppSource(): void;
        /**
         * @stability stable
         */
        get appSourceInput(): OpsworksApplicationAppSource[] | undefined;
        private _environment?;
        /**
         * @stability stable
         */
        get environment(): OpsworksApplicationEnvironment[] | undefined;
        /**
         * @stability stable
         */
        set environment(value: OpsworksApplicationEnvironment[] | undefined);
        /**
         * @stability stable
         */
        resetEnvironment(): void;
        /**
         * @stability stable
         */
        get environmentInput(): OpsworksApplicationEnvironment[] | undefined;
        private _sslConfiguration?;
        /**
         * @stability stable
         */
        get sslConfiguration(): OpsworksApplicationSslConfiguration[] | undefined;
        /**
         * @stability stable
         */
        set sslConfiguration(value: OpsworksApplicationSslConfiguration[] | undefined);
        /**
         * @stability stable
         */
        resetSslConfiguration(): void;
        /**
         * @stability stable
         */
        get sslConfigurationInput(): OpsworksApplicationSslConfiguration[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface OpsworksCustomLayerConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#auto_assign_elastic_ips OpsworksCustomLayer#auto_assign_elastic_ips}.
         *
         * @stability stable
         */
        readonly autoAssignElasticIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#auto_assign_public_ips OpsworksCustomLayer#auto_assign_public_ips}.
         *
         * @stability stable
         */
        readonly autoAssignPublicIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#auto_healing OpsworksCustomLayer#auto_healing}.
         *
         * @stability stable
         */
        readonly autoHealing?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#custom_configure_recipes OpsworksCustomLayer#custom_configure_recipes}.
         *
         * @stability stable
         */
        readonly customConfigureRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#custom_deploy_recipes OpsworksCustomLayer#custom_deploy_recipes}.
         *
         * @stability stable
         */
        readonly customDeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#custom_instance_profile_arn OpsworksCustomLayer#custom_instance_profile_arn}.
         *
         * @stability stable
         */
        readonly customInstanceProfileArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#custom_json OpsworksCustomLayer#custom_json}.
         *
         * @stability stable
         */
        readonly customJson?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#custom_security_group_ids OpsworksCustomLayer#custom_security_group_ids}.
         *
         * @stability stable
         */
        readonly customSecurityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#custom_setup_recipes OpsworksCustomLayer#custom_setup_recipes}.
         *
         * @stability stable
         */
        readonly customSetupRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#custom_shutdown_recipes OpsworksCustomLayer#custom_shutdown_recipes}.
         *
         * @stability stable
         */
        readonly customShutdownRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#custom_undeploy_recipes OpsworksCustomLayer#custom_undeploy_recipes}.
         *
         * @stability stable
         */
        readonly customUndeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#drain_elb_on_shutdown OpsworksCustomLayer#drain_elb_on_shutdown}.
         *
         * @stability stable
         */
        readonly drainElbOnShutdown?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#elastic_load_balancer OpsworksCustomLayer#elastic_load_balancer}.
         *
         * @stability stable
         */
        readonly elasticLoadBalancer?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#install_updates_on_boot OpsworksCustomLayer#install_updates_on_boot}.
         *
         * @stability stable
         */
        readonly installUpdatesOnBoot?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#instance_shutdown_timeout OpsworksCustomLayer#instance_shutdown_timeout}.
         *
         * @stability stable
         */
        readonly instanceShutdownTimeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#name OpsworksCustomLayer#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#short_name OpsworksCustomLayer#short_name}.
         *
         * @stability stable
         */
        readonly shortName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#stack_id OpsworksCustomLayer#stack_id}.
         *
         * @stability stable
         */
        readonly stackId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#system_packages OpsworksCustomLayer#system_packages}.
         *
         * @stability stable
         */
        readonly systemPackages?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#tags OpsworksCustomLayer#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#tags_all OpsworksCustomLayer#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#use_ebs_optimized_instances OpsworksCustomLayer#use_ebs_optimized_instances}.
         *
         * @stability stable
         */
        readonly useEbsOptimizedInstances?: boolean | cdktf.IResolvable;
        /**
         * ebs_volume block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#ebs_volume OpsworksCustomLayer#ebs_volume}
         *
         * @stability stable
         */
        readonly ebsVolume?: OpsworksCustomLayerEbsVolume[];
    }
    /**
     * @stability stable
     */
    interface OpsworksCustomLayerEbsVolume {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#encrypted OpsworksCustomLayer#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#iops OpsworksCustomLayer#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#mount_point OpsworksCustomLayer#mount_point}.
         *
         * @stability stable
         */
        readonly mountPoint: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#number_of_disks OpsworksCustomLayer#number_of_disks}.
         *
         * @stability stable
         */
        readonly numberOfDisks: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#raid_level OpsworksCustomLayer#raid_level}.
         *
         * @stability stable
         */
        readonly raidLevel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#size OpsworksCustomLayer#size}.
         *
         * @stability stable
         */
        readonly size: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html#type OpsworksCustomLayer#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html aws_opsworks_custom_layer}.
     *
     * @stability stable
     */
    class OpsworksCustomLayer extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_custom_layer.html aws_opsworks_custom_layer} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: OpsworksCustomLayerConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoAssignElasticIps?;
        /**
         * @stability stable
         */
        get autoAssignElasticIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignElasticIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignElasticIps(): void;
        /**
         * @stability stable
         */
        get autoAssignElasticIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoAssignPublicIps?;
        /**
         * @stability stable
         */
        get autoAssignPublicIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignPublicIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignPublicIps(): void;
        /**
         * @stability stable
         */
        get autoAssignPublicIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoHealing?;
        /**
         * @stability stable
         */
        get autoHealing(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoHealing(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoHealing(): void;
        /**
         * @stability stable
         */
        get autoHealingInput(): boolean | cdktf.IResolvable | undefined;
        private _customConfigureRecipes?;
        /**
         * @stability stable
         */
        get customConfigureRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customConfigureRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomConfigureRecipes(): void;
        /**
         * @stability stable
         */
        get customConfigureRecipesInput(): string[] | undefined;
        private _customDeployRecipes?;
        /**
         * @stability stable
         */
        get customDeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customDeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomDeployRecipes(): void;
        /**
         * @stability stable
         */
        get customDeployRecipesInput(): string[] | undefined;
        private _customInstanceProfileArn?;
        /**
         * @stability stable
         */
        get customInstanceProfileArn(): string | undefined;
        /**
         * @stability stable
         */
        set customInstanceProfileArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomInstanceProfileArn(): void;
        /**
         * @stability stable
         */
        get customInstanceProfileArnInput(): string | undefined;
        private _customJson?;
        /**
         * @stability stable
         */
        get customJson(): string | undefined;
        /**
         * @stability stable
         */
        set customJson(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomJson(): void;
        /**
         * @stability stable
         */
        get customJsonInput(): string | undefined;
        private _customSecurityGroupIds?;
        /**
         * @stability stable
         */
        get customSecurityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSecurityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get customSecurityGroupIdsInput(): string[] | undefined;
        private _customSetupRecipes?;
        /**
         * @stability stable
         */
        get customSetupRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSetupRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSetupRecipes(): void;
        /**
         * @stability stable
         */
        get customSetupRecipesInput(): string[] | undefined;
        private _customShutdownRecipes?;
        /**
         * @stability stable
         */
        get customShutdownRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customShutdownRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomShutdownRecipes(): void;
        /**
         * @stability stable
         */
        get customShutdownRecipesInput(): string[] | undefined;
        private _customUndeployRecipes?;
        /**
         * @stability stable
         */
        get customUndeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customUndeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomUndeployRecipes(): void;
        /**
         * @stability stable
         */
        get customUndeployRecipesInput(): string[] | undefined;
        private _drainElbOnShutdown?;
        /**
         * @stability stable
         */
        get drainElbOnShutdown(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set drainElbOnShutdown(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDrainElbOnShutdown(): void;
        /**
         * @stability stable
         */
        get drainElbOnShutdownInput(): boolean | cdktf.IResolvable | undefined;
        private _elasticLoadBalancer?;
        /**
         * @stability stable
         */
        get elasticLoadBalancer(): string | undefined;
        /**
         * @stability stable
         */
        set elasticLoadBalancer(value: string | undefined);
        /**
         * @stability stable
         */
        resetElasticLoadBalancer(): void;
        /**
         * @stability stable
         */
        get elasticLoadBalancerInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _installUpdatesOnBoot?;
        /**
         * @stability stable
         */
        get installUpdatesOnBoot(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set installUpdatesOnBoot(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetInstallUpdatesOnBoot(): void;
        /**
         * @stability stable
         */
        get installUpdatesOnBootInput(): boolean | cdktf.IResolvable | undefined;
        private _instanceShutdownTimeout?;
        /**
         * @stability stable
         */
        get instanceShutdownTimeout(): number | undefined;
        /**
         * @stability stable
         */
        set instanceShutdownTimeout(value: number | undefined);
        /**
         * @stability stable
         */
        resetInstanceShutdownTimeout(): void;
        /**
         * @stability stable
         */
        get instanceShutdownTimeoutInput(): number | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _shortName?;
        /**
         * @stability stable
         */
        get shortName(): string;
        /**
         * @stability stable
         */
        set shortName(value: string);
        /**
         * @stability stable
         */
        get shortNameInput(): string | undefined;
        private _stackId?;
        /**
         * @stability stable
         */
        get stackId(): string;
        /**
         * @stability stable
         */
        set stackId(value: string);
        /**
         * @stability stable
         */
        get stackIdInput(): string | undefined;
        private _systemPackages?;
        /**
         * @stability stable
         */
        get systemPackages(): string[] | undefined;
        /**
         * @stability stable
         */
        set systemPackages(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSystemPackages(): void;
        /**
         * @stability stable
         */
        get systemPackagesInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _useEbsOptimizedInstances?;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstances(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set useEbsOptimizedInstances(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUseEbsOptimizedInstances(): void;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstancesInput(): boolean | cdktf.IResolvable | undefined;
        private _ebsVolume?;
        /**
         * @stability stable
         */
        get ebsVolume(): OpsworksCustomLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        set ebsVolume(value: OpsworksCustomLayerEbsVolume[] | undefined);
        /**
         * @stability stable
         */
        resetEbsVolume(): void;
        /**
         * @stability stable
         */
        get ebsVolumeInput(): OpsworksCustomLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface OpsworksGangliaLayerConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#auto_assign_elastic_ips OpsworksGangliaLayer#auto_assign_elastic_ips}.
         *
         * @stability stable
         */
        readonly autoAssignElasticIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#auto_assign_public_ips OpsworksGangliaLayer#auto_assign_public_ips}.
         *
         * @stability stable
         */
        readonly autoAssignPublicIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#auto_healing OpsworksGangliaLayer#auto_healing}.
         *
         * @stability stable
         */
        readonly autoHealing?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#custom_configure_recipes OpsworksGangliaLayer#custom_configure_recipes}.
         *
         * @stability stable
         */
        readonly customConfigureRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#custom_deploy_recipes OpsworksGangliaLayer#custom_deploy_recipes}.
         *
         * @stability stable
         */
        readonly customDeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#custom_instance_profile_arn OpsworksGangliaLayer#custom_instance_profile_arn}.
         *
         * @stability stable
         */
        readonly customInstanceProfileArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#custom_json OpsworksGangliaLayer#custom_json}.
         *
         * @stability stable
         */
        readonly customJson?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#custom_security_group_ids OpsworksGangliaLayer#custom_security_group_ids}.
         *
         * @stability stable
         */
        readonly customSecurityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#custom_setup_recipes OpsworksGangliaLayer#custom_setup_recipes}.
         *
         * @stability stable
         */
        readonly customSetupRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#custom_shutdown_recipes OpsworksGangliaLayer#custom_shutdown_recipes}.
         *
         * @stability stable
         */
        readonly customShutdownRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#custom_undeploy_recipes OpsworksGangliaLayer#custom_undeploy_recipes}.
         *
         * @stability stable
         */
        readonly customUndeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#drain_elb_on_shutdown OpsworksGangliaLayer#drain_elb_on_shutdown}.
         *
         * @stability stable
         */
        readonly drainElbOnShutdown?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#elastic_load_balancer OpsworksGangliaLayer#elastic_load_balancer}.
         *
         * @stability stable
         */
        readonly elasticLoadBalancer?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#install_updates_on_boot OpsworksGangliaLayer#install_updates_on_boot}.
         *
         * @stability stable
         */
        readonly installUpdatesOnBoot?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#instance_shutdown_timeout OpsworksGangliaLayer#instance_shutdown_timeout}.
         *
         * @stability stable
         */
        readonly instanceShutdownTimeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#name OpsworksGangliaLayer#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#password OpsworksGangliaLayer#password}.
         *
         * @stability stable
         */
        readonly password: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#stack_id OpsworksGangliaLayer#stack_id}.
         *
         * @stability stable
         */
        readonly stackId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#system_packages OpsworksGangliaLayer#system_packages}.
         *
         * @stability stable
         */
        readonly systemPackages?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#tags OpsworksGangliaLayer#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#tags_all OpsworksGangliaLayer#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#url OpsworksGangliaLayer#url}.
         *
         * @stability stable
         */
        readonly url?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#use_ebs_optimized_instances OpsworksGangliaLayer#use_ebs_optimized_instances}.
         *
         * @stability stable
         */
        readonly useEbsOptimizedInstances?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#username OpsworksGangliaLayer#username}.
         *
         * @stability stable
         */
        readonly username?: string;
        /**
         * ebs_volume block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#ebs_volume OpsworksGangliaLayer#ebs_volume}
         *
         * @stability stable
         */
        readonly ebsVolume?: OpsworksGangliaLayerEbsVolume[];
    }
    /**
     * @stability stable
     */
    interface OpsworksGangliaLayerEbsVolume {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#encrypted OpsworksGangliaLayer#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#iops OpsworksGangliaLayer#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#mount_point OpsworksGangliaLayer#mount_point}.
         *
         * @stability stable
         */
        readonly mountPoint: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#number_of_disks OpsworksGangliaLayer#number_of_disks}.
         *
         * @stability stable
         */
        readonly numberOfDisks: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#raid_level OpsworksGangliaLayer#raid_level}.
         *
         * @stability stable
         */
        readonly raidLevel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#size OpsworksGangliaLayer#size}.
         *
         * @stability stable
         */
        readonly size: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html#type OpsworksGangliaLayer#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html aws_opsworks_ganglia_layer}.
     *
     * @stability stable
     */
    class OpsworksGangliaLayer extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_ganglia_layer.html aws_opsworks_ganglia_layer} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: OpsworksGangliaLayerConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoAssignElasticIps?;
        /**
         * @stability stable
         */
        get autoAssignElasticIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignElasticIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignElasticIps(): void;
        /**
         * @stability stable
         */
        get autoAssignElasticIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoAssignPublicIps?;
        /**
         * @stability stable
         */
        get autoAssignPublicIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignPublicIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignPublicIps(): void;
        /**
         * @stability stable
         */
        get autoAssignPublicIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoHealing?;
        /**
         * @stability stable
         */
        get autoHealing(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoHealing(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoHealing(): void;
        /**
         * @stability stable
         */
        get autoHealingInput(): boolean | cdktf.IResolvable | undefined;
        private _customConfigureRecipes?;
        /**
         * @stability stable
         */
        get customConfigureRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customConfigureRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomConfigureRecipes(): void;
        /**
         * @stability stable
         */
        get customConfigureRecipesInput(): string[] | undefined;
        private _customDeployRecipes?;
        /**
         * @stability stable
         */
        get customDeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customDeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomDeployRecipes(): void;
        /**
         * @stability stable
         */
        get customDeployRecipesInput(): string[] | undefined;
        private _customInstanceProfileArn?;
        /**
         * @stability stable
         */
        get customInstanceProfileArn(): string | undefined;
        /**
         * @stability stable
         */
        set customInstanceProfileArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomInstanceProfileArn(): void;
        /**
         * @stability stable
         */
        get customInstanceProfileArnInput(): string | undefined;
        private _customJson?;
        /**
         * @stability stable
         */
        get customJson(): string | undefined;
        /**
         * @stability stable
         */
        set customJson(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomJson(): void;
        /**
         * @stability stable
         */
        get customJsonInput(): string | undefined;
        private _customSecurityGroupIds?;
        /**
         * @stability stable
         */
        get customSecurityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSecurityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get customSecurityGroupIdsInput(): string[] | undefined;
        private _customSetupRecipes?;
        /**
         * @stability stable
         */
        get customSetupRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSetupRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSetupRecipes(): void;
        /**
         * @stability stable
         */
        get customSetupRecipesInput(): string[] | undefined;
        private _customShutdownRecipes?;
        /**
         * @stability stable
         */
        get customShutdownRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customShutdownRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomShutdownRecipes(): void;
        /**
         * @stability stable
         */
        get customShutdownRecipesInput(): string[] | undefined;
        private _customUndeployRecipes?;
        /**
         * @stability stable
         */
        get customUndeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customUndeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomUndeployRecipes(): void;
        /**
         * @stability stable
         */
        get customUndeployRecipesInput(): string[] | undefined;
        private _drainElbOnShutdown?;
        /**
         * @stability stable
         */
        get drainElbOnShutdown(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set drainElbOnShutdown(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDrainElbOnShutdown(): void;
        /**
         * @stability stable
         */
        get drainElbOnShutdownInput(): boolean | cdktf.IResolvable | undefined;
        private _elasticLoadBalancer?;
        /**
         * @stability stable
         */
        get elasticLoadBalancer(): string | undefined;
        /**
         * @stability stable
         */
        set elasticLoadBalancer(value: string | undefined);
        /**
         * @stability stable
         */
        resetElasticLoadBalancer(): void;
        /**
         * @stability stable
         */
        get elasticLoadBalancerInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _installUpdatesOnBoot?;
        /**
         * @stability stable
         */
        get installUpdatesOnBoot(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set installUpdatesOnBoot(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetInstallUpdatesOnBoot(): void;
        /**
         * @stability stable
         */
        get installUpdatesOnBootInput(): boolean | cdktf.IResolvable | undefined;
        private _instanceShutdownTimeout?;
        /**
         * @stability stable
         */
        get instanceShutdownTimeout(): number | undefined;
        /**
         * @stability stable
         */
        set instanceShutdownTimeout(value: number | undefined);
        /**
         * @stability stable
         */
        resetInstanceShutdownTimeout(): void;
        /**
         * @stability stable
         */
        get instanceShutdownTimeoutInput(): number | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _password?;
        /**
         * @stability stable
         */
        get password(): string;
        /**
         * @stability stable
         */
        set password(value: string);
        /**
         * @stability stable
         */
        get passwordInput(): string | undefined;
        private _stackId?;
        /**
         * @stability stable
         */
        get stackId(): string;
        /**
         * @stability stable
         */
        set stackId(value: string);
        /**
         * @stability stable
         */
        get stackIdInput(): string | undefined;
        private _systemPackages?;
        /**
         * @stability stable
         */
        get systemPackages(): string[] | undefined;
        /**
         * @stability stable
         */
        set systemPackages(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSystemPackages(): void;
        /**
         * @stability stable
         */
        get systemPackagesInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _url?;
        /**
         * @stability stable
         */
        get url(): string | undefined;
        /**
         * @stability stable
         */
        set url(value: string | undefined);
        /**
         * @stability stable
         */
        resetUrl(): void;
        /**
         * @stability stable
         */
        get urlInput(): string | undefined;
        private _useEbsOptimizedInstances?;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstances(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set useEbsOptimizedInstances(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUseEbsOptimizedInstances(): void;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstancesInput(): boolean | cdktf.IResolvable | undefined;
        private _username?;
        /**
         * @stability stable
         */
        get username(): string | undefined;
        /**
         * @stability stable
         */
        set username(value: string | undefined);
        /**
         * @stability stable
         */
        resetUsername(): void;
        /**
         * @stability stable
         */
        get usernameInput(): string | undefined;
        private _ebsVolume?;
        /**
         * @stability stable
         */
        get ebsVolume(): OpsworksGangliaLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        set ebsVolume(value: OpsworksGangliaLayerEbsVolume[] | undefined);
        /**
         * @stability stable
         */
        resetEbsVolume(): void;
        /**
         * @stability stable
         */
        get ebsVolumeInput(): OpsworksGangliaLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface OpsworksHaproxyLayerConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#auto_assign_elastic_ips OpsworksHaproxyLayer#auto_assign_elastic_ips}.
         *
         * @stability stable
         */
        readonly autoAssignElasticIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#auto_assign_public_ips OpsworksHaproxyLayer#auto_assign_public_ips}.
         *
         * @stability stable
         */
        readonly autoAssignPublicIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#auto_healing OpsworksHaproxyLayer#auto_healing}.
         *
         * @stability stable
         */
        readonly autoHealing?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#custom_configure_recipes OpsworksHaproxyLayer#custom_configure_recipes}.
         *
         * @stability stable
         */
        readonly customConfigureRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#custom_deploy_recipes OpsworksHaproxyLayer#custom_deploy_recipes}.
         *
         * @stability stable
         */
        readonly customDeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#custom_instance_profile_arn OpsworksHaproxyLayer#custom_instance_profile_arn}.
         *
         * @stability stable
         */
        readonly customInstanceProfileArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#custom_json OpsworksHaproxyLayer#custom_json}.
         *
         * @stability stable
         */
        readonly customJson?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#custom_security_group_ids OpsworksHaproxyLayer#custom_security_group_ids}.
         *
         * @stability stable
         */
        readonly customSecurityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#custom_setup_recipes OpsworksHaproxyLayer#custom_setup_recipes}.
         *
         * @stability stable
         */
        readonly customSetupRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#custom_shutdown_recipes OpsworksHaproxyLayer#custom_shutdown_recipes}.
         *
         * @stability stable
         */
        readonly customShutdownRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#custom_undeploy_recipes OpsworksHaproxyLayer#custom_undeploy_recipes}.
         *
         * @stability stable
         */
        readonly customUndeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#drain_elb_on_shutdown OpsworksHaproxyLayer#drain_elb_on_shutdown}.
         *
         * @stability stable
         */
        readonly drainElbOnShutdown?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#elastic_load_balancer OpsworksHaproxyLayer#elastic_load_balancer}.
         *
         * @stability stable
         */
        readonly elasticLoadBalancer?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#healthcheck_method OpsworksHaproxyLayer#healthcheck_method}.
         *
         * @stability stable
         */
        readonly healthcheckMethod?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#healthcheck_url OpsworksHaproxyLayer#healthcheck_url}.
         *
         * @stability stable
         */
        readonly healthcheckUrl?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#install_updates_on_boot OpsworksHaproxyLayer#install_updates_on_boot}.
         *
         * @stability stable
         */
        readonly installUpdatesOnBoot?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#instance_shutdown_timeout OpsworksHaproxyLayer#instance_shutdown_timeout}.
         *
         * @stability stable
         */
        readonly instanceShutdownTimeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#name OpsworksHaproxyLayer#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#stack_id OpsworksHaproxyLayer#stack_id}.
         *
         * @stability stable
         */
        readonly stackId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#stats_enabled OpsworksHaproxyLayer#stats_enabled}.
         *
         * @stability stable
         */
        readonly statsEnabled?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#stats_password OpsworksHaproxyLayer#stats_password}.
         *
         * @stability stable
         */
        readonly statsPassword: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#stats_url OpsworksHaproxyLayer#stats_url}.
         *
         * @stability stable
         */
        readonly statsUrl?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#stats_user OpsworksHaproxyLayer#stats_user}.
         *
         * @stability stable
         */
        readonly statsUser?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#system_packages OpsworksHaproxyLayer#system_packages}.
         *
         * @stability stable
         */
        readonly systemPackages?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#tags OpsworksHaproxyLayer#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#tags_all OpsworksHaproxyLayer#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#use_ebs_optimized_instances OpsworksHaproxyLayer#use_ebs_optimized_instances}.
         *
         * @stability stable
         */
        readonly useEbsOptimizedInstances?: boolean | cdktf.IResolvable;
        /**
         * ebs_volume block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#ebs_volume OpsworksHaproxyLayer#ebs_volume}
         *
         * @stability stable
         */
        readonly ebsVolume?: OpsworksHaproxyLayerEbsVolume[];
    }
    /**
     * @stability stable
     */
    interface OpsworksHaproxyLayerEbsVolume {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#encrypted OpsworksHaproxyLayer#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#iops OpsworksHaproxyLayer#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#mount_point OpsworksHaproxyLayer#mount_point}.
         *
         * @stability stable
         */
        readonly mountPoint: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#number_of_disks OpsworksHaproxyLayer#number_of_disks}.
         *
         * @stability stable
         */
        readonly numberOfDisks: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#raid_level OpsworksHaproxyLayer#raid_level}.
         *
         * @stability stable
         */
        readonly raidLevel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#size OpsworksHaproxyLayer#size}.
         *
         * @stability stable
         */
        readonly size: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html#type OpsworksHaproxyLayer#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html aws_opsworks_haproxy_layer}.
     *
     * @stability stable
     */
    class OpsworksHaproxyLayer extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer.html aws_opsworks_haproxy_layer} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: OpsworksHaproxyLayerConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoAssignElasticIps?;
        /**
         * @stability stable
         */
        get autoAssignElasticIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignElasticIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignElasticIps(): void;
        /**
         * @stability stable
         */
        get autoAssignElasticIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoAssignPublicIps?;
        /**
         * @stability stable
         */
        get autoAssignPublicIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignPublicIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignPublicIps(): void;
        /**
         * @stability stable
         */
        get autoAssignPublicIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoHealing?;
        /**
         * @stability stable
         */
        get autoHealing(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoHealing(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoHealing(): void;
        /**
         * @stability stable
         */
        get autoHealingInput(): boolean | cdktf.IResolvable | undefined;
        private _customConfigureRecipes?;
        /**
         * @stability stable
         */
        get customConfigureRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customConfigureRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomConfigureRecipes(): void;
        /**
         * @stability stable
         */
        get customConfigureRecipesInput(): string[] | undefined;
        private _customDeployRecipes?;
        /**
         * @stability stable
         */
        get customDeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customDeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomDeployRecipes(): void;
        /**
         * @stability stable
         */
        get customDeployRecipesInput(): string[] | undefined;
        private _customInstanceProfileArn?;
        /**
         * @stability stable
         */
        get customInstanceProfileArn(): string | undefined;
        /**
         * @stability stable
         */
        set customInstanceProfileArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomInstanceProfileArn(): void;
        /**
         * @stability stable
         */
        get customInstanceProfileArnInput(): string | undefined;
        private _customJson?;
        /**
         * @stability stable
         */
        get customJson(): string | undefined;
        /**
         * @stability stable
         */
        set customJson(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomJson(): void;
        /**
         * @stability stable
         */
        get customJsonInput(): string | undefined;
        private _customSecurityGroupIds?;
        /**
         * @stability stable
         */
        get customSecurityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSecurityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get customSecurityGroupIdsInput(): string[] | undefined;
        private _customSetupRecipes?;
        /**
         * @stability stable
         */
        get customSetupRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSetupRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSetupRecipes(): void;
        /**
         * @stability stable
         */
        get customSetupRecipesInput(): string[] | undefined;
        private _customShutdownRecipes?;
        /**
         * @stability stable
         */
        get customShutdownRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customShutdownRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomShutdownRecipes(): void;
        /**
         * @stability stable
         */
        get customShutdownRecipesInput(): string[] | undefined;
        private _customUndeployRecipes?;
        /**
         * @stability stable
         */
        get customUndeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customUndeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomUndeployRecipes(): void;
        /**
         * @stability stable
         */
        get customUndeployRecipesInput(): string[] | undefined;
        private _drainElbOnShutdown?;
        /**
         * @stability stable
         */
        get drainElbOnShutdown(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set drainElbOnShutdown(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDrainElbOnShutdown(): void;
        /**
         * @stability stable
         */
        get drainElbOnShutdownInput(): boolean | cdktf.IResolvable | undefined;
        private _elasticLoadBalancer?;
        /**
         * @stability stable
         */
        get elasticLoadBalancer(): string | undefined;
        /**
         * @stability stable
         */
        set elasticLoadBalancer(value: string | undefined);
        /**
         * @stability stable
         */
        resetElasticLoadBalancer(): void;
        /**
         * @stability stable
         */
        get elasticLoadBalancerInput(): string | undefined;
        private _healthcheckMethod?;
        /**
         * @stability stable
         */
        get healthcheckMethod(): string | undefined;
        /**
         * @stability stable
         */
        set healthcheckMethod(value: string | undefined);
        /**
         * @stability stable
         */
        resetHealthcheckMethod(): void;
        /**
         * @stability stable
         */
        get healthcheckMethodInput(): string | undefined;
        private _healthcheckUrl?;
        /**
         * @stability stable
         */
        get healthcheckUrl(): string | undefined;
        /**
         * @stability stable
         */
        set healthcheckUrl(value: string | undefined);
        /**
         * @stability stable
         */
        resetHealthcheckUrl(): void;
        /**
         * @stability stable
         */
        get healthcheckUrlInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _installUpdatesOnBoot?;
        /**
         * @stability stable
         */
        get installUpdatesOnBoot(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set installUpdatesOnBoot(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetInstallUpdatesOnBoot(): void;
        /**
         * @stability stable
         */
        get installUpdatesOnBootInput(): boolean | cdktf.IResolvable | undefined;
        private _instanceShutdownTimeout?;
        /**
         * @stability stable
         */
        get instanceShutdownTimeout(): number | undefined;
        /**
         * @stability stable
         */
        set instanceShutdownTimeout(value: number | undefined);
        /**
         * @stability stable
         */
        resetInstanceShutdownTimeout(): void;
        /**
         * @stability stable
         */
        get instanceShutdownTimeoutInput(): number | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _stackId?;
        /**
         * @stability stable
         */
        get stackId(): string;
        /**
         * @stability stable
         */
        set stackId(value: string);
        /**
         * @stability stable
         */
        get stackIdInput(): string | undefined;
        private _statsEnabled?;
        /**
         * @stability stable
         */
        get statsEnabled(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set statsEnabled(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetStatsEnabled(): void;
        /**
         * @stability stable
         */
        get statsEnabledInput(): boolean | cdktf.IResolvable | undefined;
        private _statsPassword?;
        /**
         * @stability stable
         */
        get statsPassword(): string;
        /**
         * @stability stable
         */
        set statsPassword(value: string);
        /**
         * @stability stable
         */
        get statsPasswordInput(): string | undefined;
        private _statsUrl?;
        /**
         * @stability stable
         */
        get statsUrl(): string | undefined;
        /**
         * @stability stable
         */
        set statsUrl(value: string | undefined);
        /**
         * @stability stable
         */
        resetStatsUrl(): void;
        /**
         * @stability stable
         */
        get statsUrlInput(): string | undefined;
        private _statsUser?;
        /**
         * @stability stable
         */
        get statsUser(): string | undefined;
        /**
         * @stability stable
         */
        set statsUser(value: string | undefined);
        /**
         * @stability stable
         */
        resetStatsUser(): void;
        /**
         * @stability stable
         */
        get statsUserInput(): string | undefined;
        private _systemPackages?;
        /**
         * @stability stable
         */
        get systemPackages(): string[] | undefined;
        /**
         * @stability stable
         */
        set systemPackages(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSystemPackages(): void;
        /**
         * @stability stable
         */
        get systemPackagesInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _useEbsOptimizedInstances?;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstances(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set useEbsOptimizedInstances(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUseEbsOptimizedInstances(): void;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstancesInput(): boolean | cdktf.IResolvable | undefined;
        private _ebsVolume?;
        /**
         * @stability stable
         */
        get ebsVolume(): OpsworksHaproxyLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        set ebsVolume(value: OpsworksHaproxyLayerEbsVolume[] | undefined);
        /**
         * @stability stable
         */
        resetEbsVolume(): void;
        /**
         * @stability stable
         */
        get ebsVolumeInput(): OpsworksHaproxyLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface OpsworksInstanceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#agent_version OpsworksInstance#agent_version}.
         *
         * @stability stable
         */
        readonly agentVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#ami_id OpsworksInstance#ami_id}.
         *
         * @stability stable
         */
        readonly amiId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#architecture OpsworksInstance#architecture}.
         *
         * @stability stable
         */
        readonly architecture?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#auto_scaling_type OpsworksInstance#auto_scaling_type}.
         *
         * @stability stable
         */
        readonly autoScalingType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#availability_zone OpsworksInstance#availability_zone}.
         *
         * @stability stable
         */
        readonly availabilityZone?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#created_at OpsworksInstance#created_at}.
         *
         * @stability stable
         */
        readonly createdAt?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#delete_ebs OpsworksInstance#delete_ebs}.
         *
         * @stability stable
         */
        readonly deleteEbs?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#delete_eip OpsworksInstance#delete_eip}.
         *
         * @stability stable
         */
        readonly deleteEip?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#ebs_optimized OpsworksInstance#ebs_optimized}.
         *
         * @stability stable
         */
        readonly ebsOptimized?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#ecs_cluster_arn OpsworksInstance#ecs_cluster_arn}.
         *
         * @stability stable
         */
        readonly ecsClusterArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#elastic_ip OpsworksInstance#elastic_ip}.
         *
         * @stability stable
         */
        readonly elasticIp?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#hostname OpsworksInstance#hostname}.
         *
         * @stability stable
         */
        readonly hostname?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#infrastructure_class OpsworksInstance#infrastructure_class}.
         *
         * @stability stable
         */
        readonly infrastructureClass?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#install_updates_on_boot OpsworksInstance#install_updates_on_boot}.
         *
         * @stability stable
         */
        readonly installUpdatesOnBoot?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#instance_profile_arn OpsworksInstance#instance_profile_arn}.
         *
         * @stability stable
         */
        readonly instanceProfileArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#instance_type OpsworksInstance#instance_type}.
         *
         * @stability stable
         */
        readonly instanceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#last_service_error_id OpsworksInstance#last_service_error_id}.
         *
         * @stability stable
         */
        readonly lastServiceErrorId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#layer_ids OpsworksInstance#layer_ids}.
         *
         * @stability stable
         */
        readonly layerIds: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#os OpsworksInstance#os}.
         *
         * @stability stable
         */
        readonly os?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#platform OpsworksInstance#platform}.
         *
         * @stability stable
         */
        readonly platform?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#private_dns OpsworksInstance#private_dns}.
         *
         * @stability stable
         */
        readonly privateDns?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#private_ip OpsworksInstance#private_ip}.
         *
         * @stability stable
         */
        readonly privateIp?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#public_dns OpsworksInstance#public_dns}.
         *
         * @stability stable
         */
        readonly publicDns?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#public_ip OpsworksInstance#public_ip}.
         *
         * @stability stable
         */
        readonly publicIp?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#registered_by OpsworksInstance#registered_by}.
         *
         * @stability stable
         */
        readonly registeredBy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#reported_agent_version OpsworksInstance#reported_agent_version}.
         *
         * @stability stable
         */
        readonly reportedAgentVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#reported_os_family OpsworksInstance#reported_os_family}.
         *
         * @stability stable
         */
        readonly reportedOsFamily?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#reported_os_name OpsworksInstance#reported_os_name}.
         *
         * @stability stable
         */
        readonly reportedOsName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#reported_os_version OpsworksInstance#reported_os_version}.
         *
         * @stability stable
         */
        readonly reportedOsVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#root_device_type OpsworksInstance#root_device_type}.
         *
         * @stability stable
         */
        readonly rootDeviceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#root_device_volume_id OpsworksInstance#root_device_volume_id}.
         *
         * @stability stable
         */
        readonly rootDeviceVolumeId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#security_group_ids OpsworksInstance#security_group_ids}.
         *
         * @stability stable
         */
        readonly securityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#ssh_host_dsa_key_fingerprint OpsworksInstance#ssh_host_dsa_key_fingerprint}.
         *
         * @stability stable
         */
        readonly sshHostDsaKeyFingerprint?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#ssh_host_rsa_key_fingerprint OpsworksInstance#ssh_host_rsa_key_fingerprint}.
         *
         * @stability stable
         */
        readonly sshHostRsaKeyFingerprint?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#ssh_key_name OpsworksInstance#ssh_key_name}.
         *
         * @stability stable
         */
        readonly sshKeyName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#stack_id OpsworksInstance#stack_id}.
         *
         * @stability stable
         */
        readonly stackId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#state OpsworksInstance#state}.
         *
         * @stability stable
         */
        readonly state?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#status OpsworksInstance#status}.
         *
         * @stability stable
         */
        readonly status?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#subnet_id OpsworksInstance#subnet_id}.
         *
         * @stability stable
         */
        readonly subnetId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#tenancy OpsworksInstance#tenancy}.
         *
         * @stability stable
         */
        readonly tenancy?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#virtualization_type OpsworksInstance#virtualization_type}.
         *
         * @stability stable
         */
        readonly virtualizationType?: string;
        /**
         * ebs_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#ebs_block_device OpsworksInstance#ebs_block_device}
         *
         * @stability stable
         */
        readonly ebsBlockDevice?: OpsworksInstanceEbsBlockDevice[];
        /**
         * ephemeral_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#ephemeral_block_device OpsworksInstance#ephemeral_block_device}
         *
         * @stability stable
         */
        readonly ephemeralBlockDevice?: OpsworksInstanceEphemeralBlockDevice[];
        /**
         * root_block_device block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#root_block_device OpsworksInstance#root_block_device}
         *
         * @stability stable
         */
        readonly rootBlockDevice?: OpsworksInstanceRootBlockDevice[];
        /**
         * timeouts block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#timeouts OpsworksInstance#timeouts}
         *
         * @stability stable
         */
        readonly timeouts?: OpsworksInstanceTimeouts;
    }
    /**
     * @stability stable
     */
    interface OpsworksInstanceEbsBlockDevice {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#delete_on_termination OpsworksInstance#delete_on_termination}.
         *
         * @stability stable
         */
        readonly deleteOnTermination?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#device_name OpsworksInstance#device_name}.
         *
         * @stability stable
         */
        readonly deviceName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#iops OpsworksInstance#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#snapshot_id OpsworksInstance#snapshot_id}.
         *
         * @stability stable
         */
        readonly snapshotId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#volume_size OpsworksInstance#volume_size}.
         *
         * @stability stable
         */
        readonly volumeSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#volume_type OpsworksInstance#volume_type}.
         *
         * @stability stable
         */
        readonly volumeType?: string;
    }
    /**
     * @stability stable
     */
    interface OpsworksInstanceEphemeralBlockDevice {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#device_name OpsworksInstance#device_name}.
         *
         * @stability stable
         */
        readonly deviceName: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#virtual_name OpsworksInstance#virtual_name}.
         *
         * @stability stable
         */
        readonly virtualName: string;
    }
    /**
     * @stability stable
     */
    interface OpsworksInstanceRootBlockDevice {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#delete_on_termination OpsworksInstance#delete_on_termination}.
         *
         * @stability stable
         */
        readonly deleteOnTermination?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#iops OpsworksInstance#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#volume_size OpsworksInstance#volume_size}.
         *
         * @stability stable
         */
        readonly volumeSize?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#volume_type OpsworksInstance#volume_type}.
         *
         * @stability stable
         */
        readonly volumeType?: string;
    }
    /**
     * @stability stable
     */
    interface OpsworksInstanceTimeouts {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#create OpsworksInstance#create}.
         *
         * @stability stable
         */
        readonly create?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#delete OpsworksInstance#delete}.
         *
         * @stability stable
         */
        readonly delete?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html#update OpsworksInstance#update}.
         *
         * @stability stable
         */
        readonly update?: string;
    }
    /**
     * @stability stable
     */
    class OpsworksInstanceTimeoutsOutputReference extends cdktf.ComplexObject {
        /**
         * @param terraformResource The parent resource.
         * @param terraformAttribute The attribute on the parent resource this class is referencing.
         * @param isSingleItem True if this is a block, false if it's a list.
         * @stability stable
         */
        constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
        private _create?;
        /**
         * @stability stable
         */
        get create(): string | undefined;
        /**
         * @stability stable
         */
        set create(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreate(): void;
        /**
         * @stability stable
         */
        get createInput(): string | undefined;
        private _delete?;
        /**
         * @stability stable
         */
        get delete(): string | undefined;
        /**
         * @stability stable
         */
        set delete(value: string | undefined);
        /**
         * @stability stable
         */
        resetDelete(): void;
        /**
         * @stability stable
         */
        get deleteInput(): string | undefined;
        private _update?;
        /**
         * @stability stable
         */
        get update(): string | undefined;
        /**
         * @stability stable
         */
        set update(value: string | undefined);
        /**
         * @stability stable
         */
        resetUpdate(): void;
        /**
         * @stability stable
         */
        get updateInput(): string | undefined;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html aws_opsworks_instance}.
     *
     * @stability stable
     */
    class OpsworksInstance extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_instance.html aws_opsworks_instance} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: OpsworksInstanceConfig);
        private _agentVersion?;
        /**
         * @stability stable
         */
        get agentVersion(): string | undefined;
        /**
         * @stability stable
         */
        set agentVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetAgentVersion(): void;
        /**
         * @stability stable
         */
        get agentVersionInput(): string | undefined;
        private _amiId?;
        /**
         * @stability stable
         */
        get amiId(): string | undefined;
        /**
         * @stability stable
         */
        set amiId(value: string | undefined);
        /**
         * @stability stable
         */
        resetAmiId(): void;
        /**
         * @stability stable
         */
        get amiIdInput(): string | undefined;
        private _architecture?;
        /**
         * @stability stable
         */
        get architecture(): string | undefined;
        /**
         * @stability stable
         */
        set architecture(value: string | undefined);
        /**
         * @stability stable
         */
        resetArchitecture(): void;
        /**
         * @stability stable
         */
        get architectureInput(): string | undefined;
        private _autoScalingType?;
        /**
         * @stability stable
         */
        get autoScalingType(): string | undefined;
        /**
         * @stability stable
         */
        set autoScalingType(value: string | undefined);
        /**
         * @stability stable
         */
        resetAutoScalingType(): void;
        /**
         * @stability stable
         */
        get autoScalingTypeInput(): string | undefined;
        private _availabilityZone?;
        /**
         * @stability stable
         */
        get availabilityZone(): string | undefined;
        /**
         * @stability stable
         */
        set availabilityZone(value: string | undefined);
        /**
         * @stability stable
         */
        resetAvailabilityZone(): void;
        /**
         * @stability stable
         */
        get availabilityZoneInput(): string | undefined;
        private _createdAt?;
        /**
         * @stability stable
         */
        get createdAt(): string | undefined;
        /**
         * @stability stable
         */
        set createdAt(value: string | undefined);
        /**
         * @stability stable
         */
        resetCreatedAt(): void;
        /**
         * @stability stable
         */
        get createdAtInput(): string | undefined;
        private _deleteEbs?;
        /**
         * @stability stable
         */
        get deleteEbs(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set deleteEbs(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDeleteEbs(): void;
        /**
         * @stability stable
         */
        get deleteEbsInput(): boolean | cdktf.IResolvable | undefined;
        private _deleteEip?;
        /**
         * @stability stable
         */
        get deleteEip(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set deleteEip(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDeleteEip(): void;
        /**
         * @stability stable
         */
        get deleteEipInput(): boolean | cdktf.IResolvable | undefined;
        private _ebsOptimized?;
        /**
         * @stability stable
         */
        get ebsOptimized(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set ebsOptimized(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetEbsOptimized(): void;
        /**
         * @stability stable
         */
        get ebsOptimizedInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get ec2InstanceId(): string;
        private _ecsClusterArn?;
        /**
         * @stability stable
         */
        get ecsClusterArn(): string | undefined;
        /**
         * @stability stable
         */
        set ecsClusterArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetEcsClusterArn(): void;
        /**
         * @stability stable
         */
        get ecsClusterArnInput(): string | undefined;
        private _elasticIp?;
        /**
         * @stability stable
         */
        get elasticIp(): string | undefined;
        /**
         * @stability stable
         */
        set elasticIp(value: string | undefined);
        /**
         * @stability stable
         */
        resetElasticIp(): void;
        /**
         * @stability stable
         */
        get elasticIpInput(): string | undefined;
        private _hostname?;
        /**
         * @stability stable
         */
        get hostname(): string | undefined;
        /**
         * @stability stable
         */
        set hostname(value: string | undefined);
        /**
         * @stability stable
         */
        resetHostname(): void;
        /**
         * @stability stable
         */
        get hostnameInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _infrastructureClass?;
        /**
         * @stability stable
         */
        get infrastructureClass(): string | undefined;
        /**
         * @stability stable
         */
        set infrastructureClass(value: string | undefined);
        /**
         * @stability stable
         */
        resetInfrastructureClass(): void;
        /**
         * @stability stable
         */
        get infrastructureClassInput(): string | undefined;
        private _installUpdatesOnBoot?;
        /**
         * @stability stable
         */
        get installUpdatesOnBoot(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set installUpdatesOnBoot(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetInstallUpdatesOnBoot(): void;
        /**
         * @stability stable
         */
        get installUpdatesOnBootInput(): boolean | cdktf.IResolvable | undefined;
        private _instanceProfileArn?;
        /**
         * @stability stable
         */
        get instanceProfileArn(): string | undefined;
        /**
         * @stability stable
         */
        set instanceProfileArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceProfileArn(): void;
        /**
         * @stability stable
         */
        get instanceProfileArnInput(): string | undefined;
        private _instanceType?;
        /**
         * @stability stable
         */
        get instanceType(): string | undefined;
        /**
         * @stability stable
         */
        set instanceType(value: string | undefined);
        /**
         * @stability stable
         */
        resetInstanceType(): void;
        /**
         * @stability stable
         */
        get instanceTypeInput(): string | undefined;
        private _lastServiceErrorId?;
        /**
         * @stability stable
         */
        get lastServiceErrorId(): string | undefined;
        /**
         * @stability stable
         */
        set lastServiceErrorId(value: string | undefined);
        /**
         * @stability stable
         */
        resetLastServiceErrorId(): void;
        /**
         * @stability stable
         */
        get lastServiceErrorIdInput(): string | undefined;
        private _layerIds?;
        /**
         * @stability stable
         */
        get layerIds(): string[];
        /**
         * @stability stable
         */
        set layerIds(value: string[]);
        /**
         * @stability stable
         */
        get layerIdsInput(): string[] | undefined;
        private _os?;
        /**
         * @stability stable
         */
        get os(): string | undefined;
        /**
         * @stability stable
         */
        set os(value: string | undefined);
        /**
         * @stability stable
         */
        resetOs(): void;
        /**
         * @stability stable
         */
        get osInput(): string | undefined;
        private _platform?;
        /**
         * @stability stable
         */
        get platform(): string | undefined;
        /**
         * @stability stable
         */
        set platform(value: string | undefined);
        /**
         * @stability stable
         */
        resetPlatform(): void;
        /**
         * @stability stable
         */
        get platformInput(): string | undefined;
        private _privateDns?;
        /**
         * @stability stable
         */
        get privateDns(): string | undefined;
        /**
         * @stability stable
         */
        set privateDns(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrivateDns(): void;
        /**
         * @stability stable
         */
        get privateDnsInput(): string | undefined;
        private _privateIp?;
        /**
         * @stability stable
         */
        get privateIp(): string | undefined;
        /**
         * @stability stable
         */
        set privateIp(value: string | undefined);
        /**
         * @stability stable
         */
        resetPrivateIp(): void;
        /**
         * @stability stable
         */
        get privateIpInput(): string | undefined;
        private _publicDns?;
        /**
         * @stability stable
         */
        get publicDns(): string | undefined;
        /**
         * @stability stable
         */
        set publicDns(value: string | undefined);
        /**
         * @stability stable
         */
        resetPublicDns(): void;
        /**
         * @stability stable
         */
        get publicDnsInput(): string | undefined;
        private _publicIp?;
        /**
         * @stability stable
         */
        get publicIp(): string | undefined;
        /**
         * @stability stable
         */
        set publicIp(value: string | undefined);
        /**
         * @stability stable
         */
        resetPublicIp(): void;
        /**
         * @stability stable
         */
        get publicIpInput(): string | undefined;
        private _registeredBy?;
        /**
         * @stability stable
         */
        get registeredBy(): string | undefined;
        /**
         * @stability stable
         */
        set registeredBy(value: string | undefined);
        /**
         * @stability stable
         */
        resetRegisteredBy(): void;
        /**
         * @stability stable
         */
        get registeredByInput(): string | undefined;
        private _reportedAgentVersion?;
        /**
         * @stability stable
         */
        get reportedAgentVersion(): string | undefined;
        /**
         * @stability stable
         */
        set reportedAgentVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetReportedAgentVersion(): void;
        /**
         * @stability stable
         */
        get reportedAgentVersionInput(): string | undefined;
        private _reportedOsFamily?;
        /**
         * @stability stable
         */
        get reportedOsFamily(): string | undefined;
        /**
         * @stability stable
         */
        set reportedOsFamily(value: string | undefined);
        /**
         * @stability stable
         */
        resetReportedOsFamily(): void;
        /**
         * @stability stable
         */
        get reportedOsFamilyInput(): string | undefined;
        private _reportedOsName?;
        /**
         * @stability stable
         */
        get reportedOsName(): string | undefined;
        /**
         * @stability stable
         */
        set reportedOsName(value: string | undefined);
        /**
         * @stability stable
         */
        resetReportedOsName(): void;
        /**
         * @stability stable
         */
        get reportedOsNameInput(): string | undefined;
        private _reportedOsVersion?;
        /**
         * @stability stable
         */
        get reportedOsVersion(): string | undefined;
        /**
         * @stability stable
         */
        set reportedOsVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetReportedOsVersion(): void;
        /**
         * @stability stable
         */
        get reportedOsVersionInput(): string | undefined;
        private _rootDeviceType?;
        /**
         * @stability stable
         */
        get rootDeviceType(): string | undefined;
        /**
         * @stability stable
         */
        set rootDeviceType(value: string | undefined);
        /**
         * @stability stable
         */
        resetRootDeviceType(): void;
        /**
         * @stability stable
         */
        get rootDeviceTypeInput(): string | undefined;
        private _rootDeviceVolumeId?;
        /**
         * @stability stable
         */
        get rootDeviceVolumeId(): string | undefined;
        /**
         * @stability stable
         */
        set rootDeviceVolumeId(value: string | undefined);
        /**
         * @stability stable
         */
        resetRootDeviceVolumeId(): void;
        /**
         * @stability stable
         */
        get rootDeviceVolumeIdInput(): string | undefined;
        private _securityGroupIds?;
        /**
         * @stability stable
         */
        get securityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set securityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get securityGroupIdsInput(): string[] | undefined;
        private _sshHostDsaKeyFingerprint?;
        /**
         * @stability stable
         */
        get sshHostDsaKeyFingerprint(): string | undefined;
        /**
         * @stability stable
         */
        set sshHostDsaKeyFingerprint(value: string | undefined);
        /**
         * @stability stable
         */
        resetSshHostDsaKeyFingerprint(): void;
        /**
         * @stability stable
         */
        get sshHostDsaKeyFingerprintInput(): string | undefined;
        private _sshHostRsaKeyFingerprint?;
        /**
         * @stability stable
         */
        get sshHostRsaKeyFingerprint(): string | undefined;
        /**
         * @stability stable
         */
        set sshHostRsaKeyFingerprint(value: string | undefined);
        /**
         * @stability stable
         */
        resetSshHostRsaKeyFingerprint(): void;
        /**
         * @stability stable
         */
        get sshHostRsaKeyFingerprintInput(): string | undefined;
        private _sshKeyName?;
        /**
         * @stability stable
         */
        get sshKeyName(): string | undefined;
        /**
         * @stability stable
         */
        set sshKeyName(value: string | undefined);
        /**
         * @stability stable
         */
        resetSshKeyName(): void;
        /**
         * @stability stable
         */
        get sshKeyNameInput(): string | undefined;
        private _stackId?;
        /**
         * @stability stable
         */
        get stackId(): string;
        /**
         * @stability stable
         */
        set stackId(value: string);
        /**
         * @stability stable
         */
        get stackIdInput(): string | undefined;
        private _state?;
        /**
         * @stability stable
         */
        get state(): string | undefined;
        /**
         * @stability stable
         */
        set state(value: string | undefined);
        /**
         * @stability stable
         */
        resetState(): void;
        /**
         * @stability stable
         */
        get stateInput(): string | undefined;
        private _status?;
        /**
         * @stability stable
         */
        get status(): string | undefined;
        /**
         * @stability stable
         */
        set status(value: string | undefined);
        /**
         * @stability stable
         */
        resetStatus(): void;
        /**
         * @stability stable
         */
        get statusInput(): string | undefined;
        private _subnetId?;
        /**
         * @stability stable
         */
        get subnetId(): string | undefined;
        /**
         * @stability stable
         */
        set subnetId(value: string | undefined);
        /**
         * @stability stable
         */
        resetSubnetId(): void;
        /**
         * @stability stable
         */
        get subnetIdInput(): string | undefined;
        private _tenancy?;
        /**
         * @stability stable
         */
        get tenancy(): string | undefined;
        /**
         * @stability stable
         */
        set tenancy(value: string | undefined);
        /**
         * @stability stable
         */
        resetTenancy(): void;
        /**
         * @stability stable
         */
        get tenancyInput(): string | undefined;
        private _virtualizationType?;
        /**
         * @stability stable
         */
        get virtualizationType(): string | undefined;
        /**
         * @stability stable
         */
        set virtualizationType(value: string | undefined);
        /**
         * @stability stable
         */
        resetVirtualizationType(): void;
        /**
         * @stability stable
         */
        get virtualizationTypeInput(): string | undefined;
        private _ebsBlockDevice?;
        /**
         * @stability stable
         */
        get ebsBlockDevice(): OpsworksInstanceEbsBlockDevice[] | undefined;
        /**
         * @stability stable
         */
        set ebsBlockDevice(value: OpsworksInstanceEbsBlockDevice[] | undefined);
        /**
         * @stability stable
         */
        resetEbsBlockDevice(): void;
        /**
         * @stability stable
         */
        get ebsBlockDeviceInput(): OpsworksInstanceEbsBlockDevice[] | undefined;
        private _ephemeralBlockDevice?;
        /**
         * @stability stable
         */
        get ephemeralBlockDevice(): OpsworksInstanceEphemeralBlockDevice[] | undefined;
        /**
         * @stability stable
         */
        set ephemeralBlockDevice(value: OpsworksInstanceEphemeralBlockDevice[] | undefined);
        /**
         * @stability stable
         */
        resetEphemeralBlockDevice(): void;
        /**
         * @stability stable
         */
        get ephemeralBlockDeviceInput(): OpsworksInstanceEphemeralBlockDevice[] | undefined;
        private _rootBlockDevice?;
        /**
         * @stability stable
         */
        get rootBlockDevice(): OpsworksInstanceRootBlockDevice[] | undefined;
        /**
         * @stability stable
         */
        set rootBlockDevice(value: OpsworksInstanceRootBlockDevice[] | undefined);
        /**
         * @stability stable
         */
        resetRootBlockDevice(): void;
        /**
         * @stability stable
         */
        get rootBlockDeviceInput(): OpsworksInstanceRootBlockDevice[] | undefined;
        private _timeouts?;
        private __timeoutsOutput;
        /**
         * @stability stable
         */
        get timeouts(): OpsworksInstanceTimeoutsOutputReference;
        /**
         * @stability stable
         */
        putTimeouts(value: OpsworksInstanceTimeouts | undefined): void;
        /**
         * @stability stable
         */
        resetTimeouts(): void;
        /**
         * @stability stable
         */
        get timeoutsInput(): OpsworksInstanceTimeouts | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface OpsworksJavaAppLayerConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#app_server OpsworksJavaAppLayer#app_server}.
         *
         * @stability stable
         */
        readonly appServer?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#app_server_version OpsworksJavaAppLayer#app_server_version}.
         *
         * @stability stable
         */
        readonly appServerVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#auto_assign_elastic_ips OpsworksJavaAppLayer#auto_assign_elastic_ips}.
         *
         * @stability stable
         */
        readonly autoAssignElasticIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#auto_assign_public_ips OpsworksJavaAppLayer#auto_assign_public_ips}.
         *
         * @stability stable
         */
        readonly autoAssignPublicIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#auto_healing OpsworksJavaAppLayer#auto_healing}.
         *
         * @stability stable
         */
        readonly autoHealing?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#custom_configure_recipes OpsworksJavaAppLayer#custom_configure_recipes}.
         *
         * @stability stable
         */
        readonly customConfigureRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#custom_deploy_recipes OpsworksJavaAppLayer#custom_deploy_recipes}.
         *
         * @stability stable
         */
        readonly customDeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#custom_instance_profile_arn OpsworksJavaAppLayer#custom_instance_profile_arn}.
         *
         * @stability stable
         */
        readonly customInstanceProfileArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#custom_json OpsworksJavaAppLayer#custom_json}.
         *
         * @stability stable
         */
        readonly customJson?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#custom_security_group_ids OpsworksJavaAppLayer#custom_security_group_ids}.
         *
         * @stability stable
         */
        readonly customSecurityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#custom_setup_recipes OpsworksJavaAppLayer#custom_setup_recipes}.
         *
         * @stability stable
         */
        readonly customSetupRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#custom_shutdown_recipes OpsworksJavaAppLayer#custom_shutdown_recipes}.
         *
         * @stability stable
         */
        readonly customShutdownRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#custom_undeploy_recipes OpsworksJavaAppLayer#custom_undeploy_recipes}.
         *
         * @stability stable
         */
        readonly customUndeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#drain_elb_on_shutdown OpsworksJavaAppLayer#drain_elb_on_shutdown}.
         *
         * @stability stable
         */
        readonly drainElbOnShutdown?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#elastic_load_balancer OpsworksJavaAppLayer#elastic_load_balancer}.
         *
         * @stability stable
         */
        readonly elasticLoadBalancer?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#install_updates_on_boot OpsworksJavaAppLayer#install_updates_on_boot}.
         *
         * @stability stable
         */
        readonly installUpdatesOnBoot?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#instance_shutdown_timeout OpsworksJavaAppLayer#instance_shutdown_timeout}.
         *
         * @stability stable
         */
        readonly instanceShutdownTimeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#jvm_options OpsworksJavaAppLayer#jvm_options}.
         *
         * @stability stable
         */
        readonly jvmOptions?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#jvm_type OpsworksJavaAppLayer#jvm_type}.
         *
         * @stability stable
         */
        readonly jvmType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#jvm_version OpsworksJavaAppLayer#jvm_version}.
         *
         * @stability stable
         */
        readonly jvmVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#name OpsworksJavaAppLayer#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#stack_id OpsworksJavaAppLayer#stack_id}.
         *
         * @stability stable
         */
        readonly stackId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#system_packages OpsworksJavaAppLayer#system_packages}.
         *
         * @stability stable
         */
        readonly systemPackages?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#tags OpsworksJavaAppLayer#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#tags_all OpsworksJavaAppLayer#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#use_ebs_optimized_instances OpsworksJavaAppLayer#use_ebs_optimized_instances}.
         *
         * @stability stable
         */
        readonly useEbsOptimizedInstances?: boolean | cdktf.IResolvable;
        /**
         * ebs_volume block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#ebs_volume OpsworksJavaAppLayer#ebs_volume}
         *
         * @stability stable
         */
        readonly ebsVolume?: OpsworksJavaAppLayerEbsVolume[];
    }
    /**
     * @stability stable
     */
    interface OpsworksJavaAppLayerEbsVolume {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#encrypted OpsworksJavaAppLayer#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#iops OpsworksJavaAppLayer#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#mount_point OpsworksJavaAppLayer#mount_point}.
         *
         * @stability stable
         */
        readonly mountPoint: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#number_of_disks OpsworksJavaAppLayer#number_of_disks}.
         *
         * @stability stable
         */
        readonly numberOfDisks: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#raid_level OpsworksJavaAppLayer#raid_level}.
         *
         * @stability stable
         */
        readonly raidLevel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#size OpsworksJavaAppLayer#size}.
         *
         * @stability stable
         */
        readonly size: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html#type OpsworksJavaAppLayer#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html aws_opsworks_java_app_layer}.
     *
     * @stability stable
     */
    class OpsworksJavaAppLayer extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_java_app_layer.html aws_opsworks_java_app_layer} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: OpsworksJavaAppLayerConfig);
        private _appServer?;
        /**
         * @stability stable
         */
        get appServer(): string | undefined;
        /**
         * @stability stable
         */
        set appServer(value: string | undefined);
        /**
         * @stability stable
         */
        resetAppServer(): void;
        /**
         * @stability stable
         */
        get appServerInput(): string | undefined;
        private _appServerVersion?;
        /**
         * @stability stable
         */
        get appServerVersion(): string | undefined;
        /**
         * @stability stable
         */
        set appServerVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetAppServerVersion(): void;
        /**
         * @stability stable
         */
        get appServerVersionInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoAssignElasticIps?;
        /**
         * @stability stable
         */
        get autoAssignElasticIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignElasticIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignElasticIps(): void;
        /**
         * @stability stable
         */
        get autoAssignElasticIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoAssignPublicIps?;
        /**
         * @stability stable
         */
        get autoAssignPublicIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignPublicIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignPublicIps(): void;
        /**
         * @stability stable
         */
        get autoAssignPublicIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoHealing?;
        /**
         * @stability stable
         */
        get autoHealing(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoHealing(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoHealing(): void;
        /**
         * @stability stable
         */
        get autoHealingInput(): boolean | cdktf.IResolvable | undefined;
        private _customConfigureRecipes?;
        /**
         * @stability stable
         */
        get customConfigureRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customConfigureRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomConfigureRecipes(): void;
        /**
         * @stability stable
         */
        get customConfigureRecipesInput(): string[] | undefined;
        private _customDeployRecipes?;
        /**
         * @stability stable
         */
        get customDeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customDeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomDeployRecipes(): void;
        /**
         * @stability stable
         */
        get customDeployRecipesInput(): string[] | undefined;
        private _customInstanceProfileArn?;
        /**
         * @stability stable
         */
        get customInstanceProfileArn(): string | undefined;
        /**
         * @stability stable
         */
        set customInstanceProfileArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomInstanceProfileArn(): void;
        /**
         * @stability stable
         */
        get customInstanceProfileArnInput(): string | undefined;
        private _customJson?;
        /**
         * @stability stable
         */
        get customJson(): string | undefined;
        /**
         * @stability stable
         */
        set customJson(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomJson(): void;
        /**
         * @stability stable
         */
        get customJsonInput(): string | undefined;
        private _customSecurityGroupIds?;
        /**
         * @stability stable
         */
        get customSecurityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSecurityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get customSecurityGroupIdsInput(): string[] | undefined;
        private _customSetupRecipes?;
        /**
         * @stability stable
         */
        get customSetupRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSetupRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSetupRecipes(): void;
        /**
         * @stability stable
         */
        get customSetupRecipesInput(): string[] | undefined;
        private _customShutdownRecipes?;
        /**
         * @stability stable
         */
        get customShutdownRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customShutdownRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomShutdownRecipes(): void;
        /**
         * @stability stable
         */
        get customShutdownRecipesInput(): string[] | undefined;
        private _customUndeployRecipes?;
        /**
         * @stability stable
         */
        get customUndeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customUndeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomUndeployRecipes(): void;
        /**
         * @stability stable
         */
        get customUndeployRecipesInput(): string[] | undefined;
        private _drainElbOnShutdown?;
        /**
         * @stability stable
         */
        get drainElbOnShutdown(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set drainElbOnShutdown(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDrainElbOnShutdown(): void;
        /**
         * @stability stable
         */
        get drainElbOnShutdownInput(): boolean | cdktf.IResolvable | undefined;
        private _elasticLoadBalancer?;
        /**
         * @stability stable
         */
        get elasticLoadBalancer(): string | undefined;
        /**
         * @stability stable
         */
        set elasticLoadBalancer(value: string | undefined);
        /**
         * @stability stable
         */
        resetElasticLoadBalancer(): void;
        /**
         * @stability stable
         */
        get elasticLoadBalancerInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _installUpdatesOnBoot?;
        /**
         * @stability stable
         */
        get installUpdatesOnBoot(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set installUpdatesOnBoot(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetInstallUpdatesOnBoot(): void;
        /**
         * @stability stable
         */
        get installUpdatesOnBootInput(): boolean | cdktf.IResolvable | undefined;
        private _instanceShutdownTimeout?;
        /**
         * @stability stable
         */
        get instanceShutdownTimeout(): number | undefined;
        /**
         * @stability stable
         */
        set instanceShutdownTimeout(value: number | undefined);
        /**
         * @stability stable
         */
        resetInstanceShutdownTimeout(): void;
        /**
         * @stability stable
         */
        get instanceShutdownTimeoutInput(): number | undefined;
        private _jvmOptions?;
        /**
         * @stability stable
         */
        get jvmOptions(): string | undefined;
        /**
         * @stability stable
         */
        set jvmOptions(value: string | undefined);
        /**
         * @stability stable
         */
        resetJvmOptions(): void;
        /**
         * @stability stable
         */
        get jvmOptionsInput(): string | undefined;
        private _jvmType?;
        /**
         * @stability stable
         */
        get jvmType(): string | undefined;
        /**
         * @stability stable
         */
        set jvmType(value: string | undefined);
        /**
         * @stability stable
         */
        resetJvmType(): void;
        /**
         * @stability stable
         */
        get jvmTypeInput(): string | undefined;
        private _jvmVersion?;
        /**
         * @stability stable
         */
        get jvmVersion(): string | undefined;
        /**
         * @stability stable
         */
        set jvmVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetJvmVersion(): void;
        /**
         * @stability stable
         */
        get jvmVersionInput(): string | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _stackId?;
        /**
         * @stability stable
         */
        get stackId(): string;
        /**
         * @stability stable
         */
        set stackId(value: string);
        /**
         * @stability stable
         */
        get stackIdInput(): string | undefined;
        private _systemPackages?;
        /**
         * @stability stable
         */
        get systemPackages(): string[] | undefined;
        /**
         * @stability stable
         */
        set systemPackages(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSystemPackages(): void;
        /**
         * @stability stable
         */
        get systemPackagesInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _useEbsOptimizedInstances?;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstances(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set useEbsOptimizedInstances(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUseEbsOptimizedInstances(): void;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstancesInput(): boolean | cdktf.IResolvable | undefined;
        private _ebsVolume?;
        /**
         * @stability stable
         */
        get ebsVolume(): OpsworksJavaAppLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        set ebsVolume(value: OpsworksJavaAppLayerEbsVolume[] | undefined);
        /**
         * @stability stable
         */
        resetEbsVolume(): void;
        /**
         * @stability stable
         */
        get ebsVolumeInput(): OpsworksJavaAppLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface OpsworksMemcachedLayerConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#allocated_memory OpsworksMemcachedLayer#allocated_memory}.
         *
         * @stability stable
         */
        readonly allocatedMemory?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#auto_assign_elastic_ips OpsworksMemcachedLayer#auto_assign_elastic_ips}.
         *
         * @stability stable
         */
        readonly autoAssignElasticIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#auto_assign_public_ips OpsworksMemcachedLayer#auto_assign_public_ips}.
         *
         * @stability stable
         */
        readonly autoAssignPublicIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#auto_healing OpsworksMemcachedLayer#auto_healing}.
         *
         * @stability stable
         */
        readonly autoHealing?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#custom_configure_recipes OpsworksMemcachedLayer#custom_configure_recipes}.
         *
         * @stability stable
         */
        readonly customConfigureRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#custom_deploy_recipes OpsworksMemcachedLayer#custom_deploy_recipes}.
         *
         * @stability stable
         */
        readonly customDeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#custom_instance_profile_arn OpsworksMemcachedLayer#custom_instance_profile_arn}.
         *
         * @stability stable
         */
        readonly customInstanceProfileArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#custom_json OpsworksMemcachedLayer#custom_json}.
         *
         * @stability stable
         */
        readonly customJson?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#custom_security_group_ids OpsworksMemcachedLayer#custom_security_group_ids}.
         *
         * @stability stable
         */
        readonly customSecurityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#custom_setup_recipes OpsworksMemcachedLayer#custom_setup_recipes}.
         *
         * @stability stable
         */
        readonly customSetupRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#custom_shutdown_recipes OpsworksMemcachedLayer#custom_shutdown_recipes}.
         *
         * @stability stable
         */
        readonly customShutdownRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#custom_undeploy_recipes OpsworksMemcachedLayer#custom_undeploy_recipes}.
         *
         * @stability stable
         */
        readonly customUndeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#drain_elb_on_shutdown OpsworksMemcachedLayer#drain_elb_on_shutdown}.
         *
         * @stability stable
         */
        readonly drainElbOnShutdown?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#elastic_load_balancer OpsworksMemcachedLayer#elastic_load_balancer}.
         *
         * @stability stable
         */
        readonly elasticLoadBalancer?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#install_updates_on_boot OpsworksMemcachedLayer#install_updates_on_boot}.
         *
         * @stability stable
         */
        readonly installUpdatesOnBoot?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#instance_shutdown_timeout OpsworksMemcachedLayer#instance_shutdown_timeout}.
         *
         * @stability stable
         */
        readonly instanceShutdownTimeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#name OpsworksMemcachedLayer#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#stack_id OpsworksMemcachedLayer#stack_id}.
         *
         * @stability stable
         */
        readonly stackId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#system_packages OpsworksMemcachedLayer#system_packages}.
         *
         * @stability stable
         */
        readonly systemPackages?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#tags OpsworksMemcachedLayer#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#tags_all OpsworksMemcachedLayer#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#use_ebs_optimized_instances OpsworksMemcachedLayer#use_ebs_optimized_instances}.
         *
         * @stability stable
         */
        readonly useEbsOptimizedInstances?: boolean | cdktf.IResolvable;
        /**
         * ebs_volume block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#ebs_volume OpsworksMemcachedLayer#ebs_volume}
         *
         * @stability stable
         */
        readonly ebsVolume?: OpsworksMemcachedLayerEbsVolume[];
    }
    /**
     * @stability stable
     */
    interface OpsworksMemcachedLayerEbsVolume {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#encrypted OpsworksMemcachedLayer#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#iops OpsworksMemcachedLayer#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#mount_point OpsworksMemcachedLayer#mount_point}.
         *
         * @stability stable
         */
        readonly mountPoint: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#number_of_disks OpsworksMemcachedLayer#number_of_disks}.
         *
         * @stability stable
         */
        readonly numberOfDisks: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#raid_level OpsworksMemcachedLayer#raid_level}.
         *
         * @stability stable
         */
        readonly raidLevel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#size OpsworksMemcachedLayer#size}.
         *
         * @stability stable
         */
        readonly size: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html#type OpsworksMemcachedLayer#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html aws_opsworks_memcached_layer}.
     *
     * @stability stable
     */
    class OpsworksMemcachedLayer extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_memcached_layer.html aws_opsworks_memcached_layer} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: OpsworksMemcachedLayerConfig);
        private _allocatedMemory?;
        /**
         * @stability stable
         */
        get allocatedMemory(): number | undefined;
        /**
         * @stability stable
         */
        set allocatedMemory(value: number | undefined);
        /**
         * @stability stable
         */
        resetAllocatedMemory(): void;
        /**
         * @stability stable
         */
        get allocatedMemoryInput(): number | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoAssignElasticIps?;
        /**
         * @stability stable
         */
        get autoAssignElasticIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignElasticIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignElasticIps(): void;
        /**
         * @stability stable
         */
        get autoAssignElasticIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoAssignPublicIps?;
        /**
         * @stability stable
         */
        get autoAssignPublicIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignPublicIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignPublicIps(): void;
        /**
         * @stability stable
         */
        get autoAssignPublicIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoHealing?;
        /**
         * @stability stable
         */
        get autoHealing(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoHealing(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoHealing(): void;
        /**
         * @stability stable
         */
        get autoHealingInput(): boolean | cdktf.IResolvable | undefined;
        private _customConfigureRecipes?;
        /**
         * @stability stable
         */
        get customConfigureRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customConfigureRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomConfigureRecipes(): void;
        /**
         * @stability stable
         */
        get customConfigureRecipesInput(): string[] | undefined;
        private _customDeployRecipes?;
        /**
         * @stability stable
         */
        get customDeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customDeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomDeployRecipes(): void;
        /**
         * @stability stable
         */
        get customDeployRecipesInput(): string[] | undefined;
        private _customInstanceProfileArn?;
        /**
         * @stability stable
         */
        get customInstanceProfileArn(): string | undefined;
        /**
         * @stability stable
         */
        set customInstanceProfileArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomInstanceProfileArn(): void;
        /**
         * @stability stable
         */
        get customInstanceProfileArnInput(): string | undefined;
        private _customJson?;
        /**
         * @stability stable
         */
        get customJson(): string | undefined;
        /**
         * @stability stable
         */
        set customJson(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomJson(): void;
        /**
         * @stability stable
         */
        get customJsonInput(): string | undefined;
        private _customSecurityGroupIds?;
        /**
         * @stability stable
         */
        get customSecurityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSecurityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get customSecurityGroupIdsInput(): string[] | undefined;
        private _customSetupRecipes?;
        /**
         * @stability stable
         */
        get customSetupRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSetupRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSetupRecipes(): void;
        /**
         * @stability stable
         */
        get customSetupRecipesInput(): string[] | undefined;
        private _customShutdownRecipes?;
        /**
         * @stability stable
         */
        get customShutdownRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customShutdownRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomShutdownRecipes(): void;
        /**
         * @stability stable
         */
        get customShutdownRecipesInput(): string[] | undefined;
        private _customUndeployRecipes?;
        /**
         * @stability stable
         */
        get customUndeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customUndeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomUndeployRecipes(): void;
        /**
         * @stability stable
         */
        get customUndeployRecipesInput(): string[] | undefined;
        private _drainElbOnShutdown?;
        /**
         * @stability stable
         */
        get drainElbOnShutdown(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set drainElbOnShutdown(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDrainElbOnShutdown(): void;
        /**
         * @stability stable
         */
        get drainElbOnShutdownInput(): boolean | cdktf.IResolvable | undefined;
        private _elasticLoadBalancer?;
        /**
         * @stability stable
         */
        get elasticLoadBalancer(): string | undefined;
        /**
         * @stability stable
         */
        set elasticLoadBalancer(value: string | undefined);
        /**
         * @stability stable
         */
        resetElasticLoadBalancer(): void;
        /**
         * @stability stable
         */
        get elasticLoadBalancerInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _installUpdatesOnBoot?;
        /**
         * @stability stable
         */
        get installUpdatesOnBoot(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set installUpdatesOnBoot(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetInstallUpdatesOnBoot(): void;
        /**
         * @stability stable
         */
        get installUpdatesOnBootInput(): boolean | cdktf.IResolvable | undefined;
        private _instanceShutdownTimeout?;
        /**
         * @stability stable
         */
        get instanceShutdownTimeout(): number | undefined;
        /**
         * @stability stable
         */
        set instanceShutdownTimeout(value: number | undefined);
        /**
         * @stability stable
         */
        resetInstanceShutdownTimeout(): void;
        /**
         * @stability stable
         */
        get instanceShutdownTimeoutInput(): number | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _stackId?;
        /**
         * @stability stable
         */
        get stackId(): string;
        /**
         * @stability stable
         */
        set stackId(value: string);
        /**
         * @stability stable
         */
        get stackIdInput(): string | undefined;
        private _systemPackages?;
        /**
         * @stability stable
         */
        get systemPackages(): string[] | undefined;
        /**
         * @stability stable
         */
        set systemPackages(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSystemPackages(): void;
        /**
         * @stability stable
         */
        get systemPackagesInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _useEbsOptimizedInstances?;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstances(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set useEbsOptimizedInstances(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUseEbsOptimizedInstances(): void;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstancesInput(): boolean | cdktf.IResolvable | undefined;
        private _ebsVolume?;
        /**
         * @stability stable
         */
        get ebsVolume(): OpsworksMemcachedLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        set ebsVolume(value: OpsworksMemcachedLayerEbsVolume[] | undefined);
        /**
         * @stability stable
         */
        resetEbsVolume(): void;
        /**
         * @stability stable
         */
        get ebsVolumeInput(): OpsworksMemcachedLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface OpsworksMysqlLayerConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#auto_assign_elastic_ips OpsworksMysqlLayer#auto_assign_elastic_ips}.
         *
         * @stability stable
         */
        readonly autoAssignElasticIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#auto_assign_public_ips OpsworksMysqlLayer#auto_assign_public_ips}.
         *
         * @stability stable
         */
        readonly autoAssignPublicIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#auto_healing OpsworksMysqlLayer#auto_healing}.
         *
         * @stability stable
         */
        readonly autoHealing?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#custom_configure_recipes OpsworksMysqlLayer#custom_configure_recipes}.
         *
         * @stability stable
         */
        readonly customConfigureRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#custom_deploy_recipes OpsworksMysqlLayer#custom_deploy_recipes}.
         *
         * @stability stable
         */
        readonly customDeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#custom_instance_profile_arn OpsworksMysqlLayer#custom_instance_profile_arn}.
         *
         * @stability stable
         */
        readonly customInstanceProfileArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#custom_json OpsworksMysqlLayer#custom_json}.
         *
         * @stability stable
         */
        readonly customJson?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#custom_security_group_ids OpsworksMysqlLayer#custom_security_group_ids}.
         *
         * @stability stable
         */
        readonly customSecurityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#custom_setup_recipes OpsworksMysqlLayer#custom_setup_recipes}.
         *
         * @stability stable
         */
        readonly customSetupRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#custom_shutdown_recipes OpsworksMysqlLayer#custom_shutdown_recipes}.
         *
         * @stability stable
         */
        readonly customShutdownRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#custom_undeploy_recipes OpsworksMysqlLayer#custom_undeploy_recipes}.
         *
         * @stability stable
         */
        readonly customUndeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#drain_elb_on_shutdown OpsworksMysqlLayer#drain_elb_on_shutdown}.
         *
         * @stability stable
         */
        readonly drainElbOnShutdown?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#elastic_load_balancer OpsworksMysqlLayer#elastic_load_balancer}.
         *
         * @stability stable
         */
        readonly elasticLoadBalancer?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#install_updates_on_boot OpsworksMysqlLayer#install_updates_on_boot}.
         *
         * @stability stable
         */
        readonly installUpdatesOnBoot?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#instance_shutdown_timeout OpsworksMysqlLayer#instance_shutdown_timeout}.
         *
         * @stability stable
         */
        readonly instanceShutdownTimeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#name OpsworksMysqlLayer#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#root_password OpsworksMysqlLayer#root_password}.
         *
         * @stability stable
         */
        readonly rootPassword?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#root_password_on_all_instances OpsworksMysqlLayer#root_password_on_all_instances}.
         *
         * @stability stable
         */
        readonly rootPasswordOnAllInstances?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#stack_id OpsworksMysqlLayer#stack_id}.
         *
         * @stability stable
         */
        readonly stackId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#system_packages OpsworksMysqlLayer#system_packages}.
         *
         * @stability stable
         */
        readonly systemPackages?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#tags OpsworksMysqlLayer#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#tags_all OpsworksMysqlLayer#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#use_ebs_optimized_instances OpsworksMysqlLayer#use_ebs_optimized_instances}.
         *
         * @stability stable
         */
        readonly useEbsOptimizedInstances?: boolean | cdktf.IResolvable;
        /**
         * ebs_volume block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#ebs_volume OpsworksMysqlLayer#ebs_volume}
         *
         * @stability stable
         */
        readonly ebsVolume?: OpsworksMysqlLayerEbsVolume[];
    }
    /**
     * @stability stable
     */
    interface OpsworksMysqlLayerEbsVolume {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#encrypted OpsworksMysqlLayer#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#iops OpsworksMysqlLayer#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#mount_point OpsworksMysqlLayer#mount_point}.
         *
         * @stability stable
         */
        readonly mountPoint: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#number_of_disks OpsworksMysqlLayer#number_of_disks}.
         *
         * @stability stable
         */
        readonly numberOfDisks: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#raid_level OpsworksMysqlLayer#raid_level}.
         *
         * @stability stable
         */
        readonly raidLevel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#size OpsworksMysqlLayer#size}.
         *
         * @stability stable
         */
        readonly size: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html#type OpsworksMysqlLayer#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html aws_opsworks_mysql_layer}.
     *
     * @stability stable
     */
    class OpsworksMysqlLayer extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer.html aws_opsworks_mysql_layer} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: OpsworksMysqlLayerConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoAssignElasticIps?;
        /**
         * @stability stable
         */
        get autoAssignElasticIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignElasticIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignElasticIps(): void;
        /**
         * @stability stable
         */
        get autoAssignElasticIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoAssignPublicIps?;
        /**
         * @stability stable
         */
        get autoAssignPublicIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignPublicIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignPublicIps(): void;
        /**
         * @stability stable
         */
        get autoAssignPublicIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoHealing?;
        /**
         * @stability stable
         */
        get autoHealing(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoHealing(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoHealing(): void;
        /**
         * @stability stable
         */
        get autoHealingInput(): boolean | cdktf.IResolvable | undefined;
        private _customConfigureRecipes?;
        /**
         * @stability stable
         */
        get customConfigureRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customConfigureRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomConfigureRecipes(): void;
        /**
         * @stability stable
         */
        get customConfigureRecipesInput(): string[] | undefined;
        private _customDeployRecipes?;
        /**
         * @stability stable
         */
        get customDeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customDeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomDeployRecipes(): void;
        /**
         * @stability stable
         */
        get customDeployRecipesInput(): string[] | undefined;
        private _customInstanceProfileArn?;
        /**
         * @stability stable
         */
        get customInstanceProfileArn(): string | undefined;
        /**
         * @stability stable
         */
        set customInstanceProfileArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomInstanceProfileArn(): void;
        /**
         * @stability stable
         */
        get customInstanceProfileArnInput(): string | undefined;
        private _customJson?;
        /**
         * @stability stable
         */
        get customJson(): string | undefined;
        /**
         * @stability stable
         */
        set customJson(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomJson(): void;
        /**
         * @stability stable
         */
        get customJsonInput(): string | undefined;
        private _customSecurityGroupIds?;
        /**
         * @stability stable
         */
        get customSecurityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSecurityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get customSecurityGroupIdsInput(): string[] | undefined;
        private _customSetupRecipes?;
        /**
         * @stability stable
         */
        get customSetupRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSetupRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSetupRecipes(): void;
        /**
         * @stability stable
         */
        get customSetupRecipesInput(): string[] | undefined;
        private _customShutdownRecipes?;
        /**
         * @stability stable
         */
        get customShutdownRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customShutdownRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomShutdownRecipes(): void;
        /**
         * @stability stable
         */
        get customShutdownRecipesInput(): string[] | undefined;
        private _customUndeployRecipes?;
        /**
         * @stability stable
         */
        get customUndeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customUndeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomUndeployRecipes(): void;
        /**
         * @stability stable
         */
        get customUndeployRecipesInput(): string[] | undefined;
        private _drainElbOnShutdown?;
        /**
         * @stability stable
         */
        get drainElbOnShutdown(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set drainElbOnShutdown(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDrainElbOnShutdown(): void;
        /**
         * @stability stable
         */
        get drainElbOnShutdownInput(): boolean | cdktf.IResolvable | undefined;
        private _elasticLoadBalancer?;
        /**
         * @stability stable
         */
        get elasticLoadBalancer(): string | undefined;
        /**
         * @stability stable
         */
        set elasticLoadBalancer(value: string | undefined);
        /**
         * @stability stable
         */
        resetElasticLoadBalancer(): void;
        /**
         * @stability stable
         */
        get elasticLoadBalancerInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _installUpdatesOnBoot?;
        /**
         * @stability stable
         */
        get installUpdatesOnBoot(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set installUpdatesOnBoot(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetInstallUpdatesOnBoot(): void;
        /**
         * @stability stable
         */
        get installUpdatesOnBootInput(): boolean | cdktf.IResolvable | undefined;
        private _instanceShutdownTimeout?;
        /**
         * @stability stable
         */
        get instanceShutdownTimeout(): number | undefined;
        /**
         * @stability stable
         */
        set instanceShutdownTimeout(value: number | undefined);
        /**
         * @stability stable
         */
        resetInstanceShutdownTimeout(): void;
        /**
         * @stability stable
         */
        get instanceShutdownTimeoutInput(): number | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _rootPassword?;
        /**
         * @stability stable
         */
        get rootPassword(): string | undefined;
        /**
         * @stability stable
         */
        set rootPassword(value: string | undefined);
        /**
         * @stability stable
         */
        resetRootPassword(): void;
        /**
         * @stability stable
         */
        get rootPasswordInput(): string | undefined;
        private _rootPasswordOnAllInstances?;
        /**
         * @stability stable
         */
        get rootPasswordOnAllInstances(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set rootPasswordOnAllInstances(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetRootPasswordOnAllInstances(): void;
        /**
         * @stability stable
         */
        get rootPasswordOnAllInstancesInput(): boolean | cdktf.IResolvable | undefined;
        private _stackId?;
        /**
         * @stability stable
         */
        get stackId(): string;
        /**
         * @stability stable
         */
        set stackId(value: string);
        /**
         * @stability stable
         */
        get stackIdInput(): string | undefined;
        private _systemPackages?;
        /**
         * @stability stable
         */
        get systemPackages(): string[] | undefined;
        /**
         * @stability stable
         */
        set systemPackages(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSystemPackages(): void;
        /**
         * @stability stable
         */
        get systemPackagesInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _useEbsOptimizedInstances?;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstances(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set useEbsOptimizedInstances(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUseEbsOptimizedInstances(): void;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstancesInput(): boolean | cdktf.IResolvable | undefined;
        private _ebsVolume?;
        /**
         * @stability stable
         */
        get ebsVolume(): OpsworksMysqlLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        set ebsVolume(value: OpsworksMysqlLayerEbsVolume[] | undefined);
        /**
         * @stability stable
         */
        resetEbsVolume(): void;
        /**
         * @stability stable
         */
        get ebsVolumeInput(): OpsworksMysqlLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface OpsworksNodejsAppLayerConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#auto_assign_elastic_ips OpsworksNodejsAppLayer#auto_assign_elastic_ips}.
         *
         * @stability stable
         */
        readonly autoAssignElasticIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#auto_assign_public_ips OpsworksNodejsAppLayer#auto_assign_public_ips}.
         *
         * @stability stable
         */
        readonly autoAssignPublicIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#auto_healing OpsworksNodejsAppLayer#auto_healing}.
         *
         * @stability stable
         */
        readonly autoHealing?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#custom_configure_recipes OpsworksNodejsAppLayer#custom_configure_recipes}.
         *
         * @stability stable
         */
        readonly customConfigureRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#custom_deploy_recipes OpsworksNodejsAppLayer#custom_deploy_recipes}.
         *
         * @stability stable
         */
        readonly customDeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#custom_instance_profile_arn OpsworksNodejsAppLayer#custom_instance_profile_arn}.
         *
         * @stability stable
         */
        readonly customInstanceProfileArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#custom_json OpsworksNodejsAppLayer#custom_json}.
         *
         * @stability stable
         */
        readonly customJson?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#custom_security_group_ids OpsworksNodejsAppLayer#custom_security_group_ids}.
         *
         * @stability stable
         */
        readonly customSecurityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#custom_setup_recipes OpsworksNodejsAppLayer#custom_setup_recipes}.
         *
         * @stability stable
         */
        readonly customSetupRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#custom_shutdown_recipes OpsworksNodejsAppLayer#custom_shutdown_recipes}.
         *
         * @stability stable
         */
        readonly customShutdownRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#custom_undeploy_recipes OpsworksNodejsAppLayer#custom_undeploy_recipes}.
         *
         * @stability stable
         */
        readonly customUndeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#drain_elb_on_shutdown OpsworksNodejsAppLayer#drain_elb_on_shutdown}.
         *
         * @stability stable
         */
        readonly drainElbOnShutdown?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#elastic_load_balancer OpsworksNodejsAppLayer#elastic_load_balancer}.
         *
         * @stability stable
         */
        readonly elasticLoadBalancer?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#install_updates_on_boot OpsworksNodejsAppLayer#install_updates_on_boot}.
         *
         * @stability stable
         */
        readonly installUpdatesOnBoot?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#instance_shutdown_timeout OpsworksNodejsAppLayer#instance_shutdown_timeout}.
         *
         * @stability stable
         */
        readonly instanceShutdownTimeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#name OpsworksNodejsAppLayer#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#nodejs_version OpsworksNodejsAppLayer#nodejs_version}.
         *
         * @stability stable
         */
        readonly nodejsVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#stack_id OpsworksNodejsAppLayer#stack_id}.
         *
         * @stability stable
         */
        readonly stackId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#system_packages OpsworksNodejsAppLayer#system_packages}.
         *
         * @stability stable
         */
        readonly systemPackages?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#tags OpsworksNodejsAppLayer#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#tags_all OpsworksNodejsAppLayer#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#use_ebs_optimized_instances OpsworksNodejsAppLayer#use_ebs_optimized_instances}.
         *
         * @stability stable
         */
        readonly useEbsOptimizedInstances?: boolean | cdktf.IResolvable;
        /**
         * ebs_volume block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#ebs_volume OpsworksNodejsAppLayer#ebs_volume}
         *
         * @stability stable
         */
        readonly ebsVolume?: OpsworksNodejsAppLayerEbsVolume[];
    }
    /**
     * @stability stable
     */
    interface OpsworksNodejsAppLayerEbsVolume {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#encrypted OpsworksNodejsAppLayer#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#iops OpsworksNodejsAppLayer#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#mount_point OpsworksNodejsAppLayer#mount_point}.
         *
         * @stability stable
         */
        readonly mountPoint: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#number_of_disks OpsworksNodejsAppLayer#number_of_disks}.
         *
         * @stability stable
         */
        readonly numberOfDisks: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#raid_level OpsworksNodejsAppLayer#raid_level}.
         *
         * @stability stable
         */
        readonly raidLevel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#size OpsworksNodejsAppLayer#size}.
         *
         * @stability stable
         */
        readonly size: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html#type OpsworksNodejsAppLayer#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html aws_opsworks_nodejs_app_layer}.
     *
     * @stability stable
     */
    class OpsworksNodejsAppLayer extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_nodejs_app_layer.html aws_opsworks_nodejs_app_layer} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: OpsworksNodejsAppLayerConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoAssignElasticIps?;
        /**
         * @stability stable
         */
        get autoAssignElasticIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignElasticIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignElasticIps(): void;
        /**
         * @stability stable
         */
        get autoAssignElasticIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoAssignPublicIps?;
        /**
         * @stability stable
         */
        get autoAssignPublicIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignPublicIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignPublicIps(): void;
        /**
         * @stability stable
         */
        get autoAssignPublicIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoHealing?;
        /**
         * @stability stable
         */
        get autoHealing(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoHealing(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoHealing(): void;
        /**
         * @stability stable
         */
        get autoHealingInput(): boolean | cdktf.IResolvable | undefined;
        private _customConfigureRecipes?;
        /**
         * @stability stable
         */
        get customConfigureRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customConfigureRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomConfigureRecipes(): void;
        /**
         * @stability stable
         */
        get customConfigureRecipesInput(): string[] | undefined;
        private _customDeployRecipes?;
        /**
         * @stability stable
         */
        get customDeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customDeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomDeployRecipes(): void;
        /**
         * @stability stable
         */
        get customDeployRecipesInput(): string[] | undefined;
        private _customInstanceProfileArn?;
        /**
         * @stability stable
         */
        get customInstanceProfileArn(): string | undefined;
        /**
         * @stability stable
         */
        set customInstanceProfileArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomInstanceProfileArn(): void;
        /**
         * @stability stable
         */
        get customInstanceProfileArnInput(): string | undefined;
        private _customJson?;
        /**
         * @stability stable
         */
        get customJson(): string | undefined;
        /**
         * @stability stable
         */
        set customJson(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomJson(): void;
        /**
         * @stability stable
         */
        get customJsonInput(): string | undefined;
        private _customSecurityGroupIds?;
        /**
         * @stability stable
         */
        get customSecurityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSecurityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get customSecurityGroupIdsInput(): string[] | undefined;
        private _customSetupRecipes?;
        /**
         * @stability stable
         */
        get customSetupRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSetupRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSetupRecipes(): void;
        /**
         * @stability stable
         */
        get customSetupRecipesInput(): string[] | undefined;
        private _customShutdownRecipes?;
        /**
         * @stability stable
         */
        get customShutdownRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customShutdownRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomShutdownRecipes(): void;
        /**
         * @stability stable
         */
        get customShutdownRecipesInput(): string[] | undefined;
        private _customUndeployRecipes?;
        /**
         * @stability stable
         */
        get customUndeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customUndeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomUndeployRecipes(): void;
        /**
         * @stability stable
         */
        get customUndeployRecipesInput(): string[] | undefined;
        private _drainElbOnShutdown?;
        /**
         * @stability stable
         */
        get drainElbOnShutdown(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set drainElbOnShutdown(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDrainElbOnShutdown(): void;
        /**
         * @stability stable
         */
        get drainElbOnShutdownInput(): boolean | cdktf.IResolvable | undefined;
        private _elasticLoadBalancer?;
        /**
         * @stability stable
         */
        get elasticLoadBalancer(): string | undefined;
        /**
         * @stability stable
         */
        set elasticLoadBalancer(value: string | undefined);
        /**
         * @stability stable
         */
        resetElasticLoadBalancer(): void;
        /**
         * @stability stable
         */
        get elasticLoadBalancerInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _installUpdatesOnBoot?;
        /**
         * @stability stable
         */
        get installUpdatesOnBoot(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set installUpdatesOnBoot(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetInstallUpdatesOnBoot(): void;
        /**
         * @stability stable
         */
        get installUpdatesOnBootInput(): boolean | cdktf.IResolvable | undefined;
        private _instanceShutdownTimeout?;
        /**
         * @stability stable
         */
        get instanceShutdownTimeout(): number | undefined;
        /**
         * @stability stable
         */
        set instanceShutdownTimeout(value: number | undefined);
        /**
         * @stability stable
         */
        resetInstanceShutdownTimeout(): void;
        /**
         * @stability stable
         */
        get instanceShutdownTimeoutInput(): number | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _nodejsVersion?;
        /**
         * @stability stable
         */
        get nodejsVersion(): string | undefined;
        /**
         * @stability stable
         */
        set nodejsVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetNodejsVersion(): void;
        /**
         * @stability stable
         */
        get nodejsVersionInput(): string | undefined;
        private _stackId?;
        /**
         * @stability stable
         */
        get stackId(): string;
        /**
         * @stability stable
         */
        set stackId(value: string);
        /**
         * @stability stable
         */
        get stackIdInput(): string | undefined;
        private _systemPackages?;
        /**
         * @stability stable
         */
        get systemPackages(): string[] | undefined;
        /**
         * @stability stable
         */
        set systemPackages(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSystemPackages(): void;
        /**
         * @stability stable
         */
        get systemPackagesInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _useEbsOptimizedInstances?;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstances(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set useEbsOptimizedInstances(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUseEbsOptimizedInstances(): void;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstancesInput(): boolean | cdktf.IResolvable | undefined;
        private _ebsVolume?;
        /**
         * @stability stable
         */
        get ebsVolume(): OpsworksNodejsAppLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        set ebsVolume(value: OpsworksNodejsAppLayerEbsVolume[] | undefined);
        /**
         * @stability stable
         */
        resetEbsVolume(): void;
        /**
         * @stability stable
         */
        get ebsVolumeInput(): OpsworksNodejsAppLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface OpsworksPermissionConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_permission.html#allow_ssh OpsworksPermission#allow_ssh}.
         *
         * @stability stable
         */
        readonly allowSsh?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_permission.html#allow_sudo OpsworksPermission#allow_sudo}.
         *
         * @stability stable
         */
        readonly allowSudo?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_permission.html#level OpsworksPermission#level}.
         *
         * @stability stable
         */
        readonly level?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_permission.html#stack_id OpsworksPermission#stack_id}.
         *
         * @stability stable
         */
        readonly stackId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_permission.html#user_arn OpsworksPermission#user_arn}.
         *
         * @stability stable
         */
        readonly userArn: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_permission.html aws_opsworks_permission}.
     *
     * @stability stable
     */
    class OpsworksPermission extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_permission.html aws_opsworks_permission} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: OpsworksPermissionConfig);
        private _allowSsh?;
        /**
         * @stability stable
         */
        get allowSsh(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set allowSsh(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAllowSsh(): void;
        /**
         * @stability stable
         */
        get allowSshInput(): boolean | cdktf.IResolvable | undefined;
        private _allowSudo?;
        /**
         * @stability stable
         */
        get allowSudo(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set allowSudo(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAllowSudo(): void;
        /**
         * @stability stable
         */
        get allowSudoInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _level?;
        /**
         * @stability stable
         */
        get level(): string | undefined;
        /**
         * @stability stable
         */
        set level(value: string | undefined);
        /**
         * @stability stable
         */
        resetLevel(): void;
        /**
         * @stability stable
         */
        get levelInput(): string | undefined;
        private _stackId?;
        /**
         * @stability stable
         */
        get stackId(): string | undefined;
        /**
         * @stability stable
         */
        set stackId(value: string | undefined);
        /**
         * @stability stable
         */
        resetStackId(): void;
        /**
         * @stability stable
         */
        get stackIdInput(): string | undefined;
        private _userArn?;
        /**
         * @stability stable
         */
        get userArn(): string;
        /**
         * @stability stable
         */
        set userArn(value: string);
        /**
         * @stability stable
         */
        get userArnInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface OpsworksPhpAppLayerConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#auto_assign_elastic_ips OpsworksPhpAppLayer#auto_assign_elastic_ips}.
         *
         * @stability stable
         */
        readonly autoAssignElasticIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#auto_assign_public_ips OpsworksPhpAppLayer#auto_assign_public_ips}.
         *
         * @stability stable
         */
        readonly autoAssignPublicIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#auto_healing OpsworksPhpAppLayer#auto_healing}.
         *
         * @stability stable
         */
        readonly autoHealing?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#custom_configure_recipes OpsworksPhpAppLayer#custom_configure_recipes}.
         *
         * @stability stable
         */
        readonly customConfigureRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#custom_deploy_recipes OpsworksPhpAppLayer#custom_deploy_recipes}.
         *
         * @stability stable
         */
        readonly customDeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#custom_instance_profile_arn OpsworksPhpAppLayer#custom_instance_profile_arn}.
         *
         * @stability stable
         */
        readonly customInstanceProfileArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#custom_json OpsworksPhpAppLayer#custom_json}.
         *
         * @stability stable
         */
        readonly customJson?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#custom_security_group_ids OpsworksPhpAppLayer#custom_security_group_ids}.
         *
         * @stability stable
         */
        readonly customSecurityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#custom_setup_recipes OpsworksPhpAppLayer#custom_setup_recipes}.
         *
         * @stability stable
         */
        readonly customSetupRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#custom_shutdown_recipes OpsworksPhpAppLayer#custom_shutdown_recipes}.
         *
         * @stability stable
         */
        readonly customShutdownRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#custom_undeploy_recipes OpsworksPhpAppLayer#custom_undeploy_recipes}.
         *
         * @stability stable
         */
        readonly customUndeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#drain_elb_on_shutdown OpsworksPhpAppLayer#drain_elb_on_shutdown}.
         *
         * @stability stable
         */
        readonly drainElbOnShutdown?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#elastic_load_balancer OpsworksPhpAppLayer#elastic_load_balancer}.
         *
         * @stability stable
         */
        readonly elasticLoadBalancer?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#install_updates_on_boot OpsworksPhpAppLayer#install_updates_on_boot}.
         *
         * @stability stable
         */
        readonly installUpdatesOnBoot?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#instance_shutdown_timeout OpsworksPhpAppLayer#instance_shutdown_timeout}.
         *
         * @stability stable
         */
        readonly instanceShutdownTimeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#name OpsworksPhpAppLayer#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#stack_id OpsworksPhpAppLayer#stack_id}.
         *
         * @stability stable
         */
        readonly stackId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#system_packages OpsworksPhpAppLayer#system_packages}.
         *
         * @stability stable
         */
        readonly systemPackages?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#tags OpsworksPhpAppLayer#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#tags_all OpsworksPhpAppLayer#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#use_ebs_optimized_instances OpsworksPhpAppLayer#use_ebs_optimized_instances}.
         *
         * @stability stable
         */
        readonly useEbsOptimizedInstances?: boolean | cdktf.IResolvable;
        /**
         * ebs_volume block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#ebs_volume OpsworksPhpAppLayer#ebs_volume}
         *
         * @stability stable
         */
        readonly ebsVolume?: OpsworksPhpAppLayerEbsVolume[];
    }
    /**
     * @stability stable
     */
    interface OpsworksPhpAppLayerEbsVolume {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#encrypted OpsworksPhpAppLayer#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#iops OpsworksPhpAppLayer#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#mount_point OpsworksPhpAppLayer#mount_point}.
         *
         * @stability stable
         */
        readonly mountPoint: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#number_of_disks OpsworksPhpAppLayer#number_of_disks}.
         *
         * @stability stable
         */
        readonly numberOfDisks: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#raid_level OpsworksPhpAppLayer#raid_level}.
         *
         * @stability stable
         */
        readonly raidLevel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#size OpsworksPhpAppLayer#size}.
         *
         * @stability stable
         */
        readonly size: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html#type OpsworksPhpAppLayer#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html aws_opsworks_php_app_layer}.
     *
     * @stability stable
     */
    class OpsworksPhpAppLayer extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer.html aws_opsworks_php_app_layer} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: OpsworksPhpAppLayerConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoAssignElasticIps?;
        /**
         * @stability stable
         */
        get autoAssignElasticIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignElasticIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignElasticIps(): void;
        /**
         * @stability stable
         */
        get autoAssignElasticIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoAssignPublicIps?;
        /**
         * @stability stable
         */
        get autoAssignPublicIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignPublicIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignPublicIps(): void;
        /**
         * @stability stable
         */
        get autoAssignPublicIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoHealing?;
        /**
         * @stability stable
         */
        get autoHealing(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoHealing(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoHealing(): void;
        /**
         * @stability stable
         */
        get autoHealingInput(): boolean | cdktf.IResolvable | undefined;
        private _customConfigureRecipes?;
        /**
         * @stability stable
         */
        get customConfigureRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customConfigureRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomConfigureRecipes(): void;
        /**
         * @stability stable
         */
        get customConfigureRecipesInput(): string[] | undefined;
        private _customDeployRecipes?;
        /**
         * @stability stable
         */
        get customDeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customDeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomDeployRecipes(): void;
        /**
         * @stability stable
         */
        get customDeployRecipesInput(): string[] | undefined;
        private _customInstanceProfileArn?;
        /**
         * @stability stable
         */
        get customInstanceProfileArn(): string | undefined;
        /**
         * @stability stable
         */
        set customInstanceProfileArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomInstanceProfileArn(): void;
        /**
         * @stability stable
         */
        get customInstanceProfileArnInput(): string | undefined;
        private _customJson?;
        /**
         * @stability stable
         */
        get customJson(): string | undefined;
        /**
         * @stability stable
         */
        set customJson(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomJson(): void;
        /**
         * @stability stable
         */
        get customJsonInput(): string | undefined;
        private _customSecurityGroupIds?;
        /**
         * @stability stable
         */
        get customSecurityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSecurityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get customSecurityGroupIdsInput(): string[] | undefined;
        private _customSetupRecipes?;
        /**
         * @stability stable
         */
        get customSetupRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSetupRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSetupRecipes(): void;
        /**
         * @stability stable
         */
        get customSetupRecipesInput(): string[] | undefined;
        private _customShutdownRecipes?;
        /**
         * @stability stable
         */
        get customShutdownRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customShutdownRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomShutdownRecipes(): void;
        /**
         * @stability stable
         */
        get customShutdownRecipesInput(): string[] | undefined;
        private _customUndeployRecipes?;
        /**
         * @stability stable
         */
        get customUndeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customUndeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomUndeployRecipes(): void;
        /**
         * @stability stable
         */
        get customUndeployRecipesInput(): string[] | undefined;
        private _drainElbOnShutdown?;
        /**
         * @stability stable
         */
        get drainElbOnShutdown(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set drainElbOnShutdown(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDrainElbOnShutdown(): void;
        /**
         * @stability stable
         */
        get drainElbOnShutdownInput(): boolean | cdktf.IResolvable | undefined;
        private _elasticLoadBalancer?;
        /**
         * @stability stable
         */
        get elasticLoadBalancer(): string | undefined;
        /**
         * @stability stable
         */
        set elasticLoadBalancer(value: string | undefined);
        /**
         * @stability stable
         */
        resetElasticLoadBalancer(): void;
        /**
         * @stability stable
         */
        get elasticLoadBalancerInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _installUpdatesOnBoot?;
        /**
         * @stability stable
         */
        get installUpdatesOnBoot(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set installUpdatesOnBoot(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetInstallUpdatesOnBoot(): void;
        /**
         * @stability stable
         */
        get installUpdatesOnBootInput(): boolean | cdktf.IResolvable | undefined;
        private _instanceShutdownTimeout?;
        /**
         * @stability stable
         */
        get instanceShutdownTimeout(): number | undefined;
        /**
         * @stability stable
         */
        set instanceShutdownTimeout(value: number | undefined);
        /**
         * @stability stable
         */
        resetInstanceShutdownTimeout(): void;
        /**
         * @stability stable
         */
        get instanceShutdownTimeoutInput(): number | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _stackId?;
        /**
         * @stability stable
         */
        get stackId(): string;
        /**
         * @stability stable
         */
        set stackId(value: string);
        /**
         * @stability stable
         */
        get stackIdInput(): string | undefined;
        private _systemPackages?;
        /**
         * @stability stable
         */
        get systemPackages(): string[] | undefined;
        /**
         * @stability stable
         */
        set systemPackages(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSystemPackages(): void;
        /**
         * @stability stable
         */
        get systemPackagesInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _useEbsOptimizedInstances?;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstances(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set useEbsOptimizedInstances(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUseEbsOptimizedInstances(): void;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstancesInput(): boolean | cdktf.IResolvable | undefined;
        private _ebsVolume?;
        /**
         * @stability stable
         */
        get ebsVolume(): OpsworksPhpAppLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        set ebsVolume(value: OpsworksPhpAppLayerEbsVolume[] | undefined);
        /**
         * @stability stable
         */
        resetEbsVolume(): void;
        /**
         * @stability stable
         */
        get ebsVolumeInput(): OpsworksPhpAppLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface OpsworksRailsAppLayerConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#app_server OpsworksRailsAppLayer#app_server}.
         *
         * @stability stable
         */
        readonly appServer?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#auto_assign_elastic_ips OpsworksRailsAppLayer#auto_assign_elastic_ips}.
         *
         * @stability stable
         */
        readonly autoAssignElasticIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#auto_assign_public_ips OpsworksRailsAppLayer#auto_assign_public_ips}.
         *
         * @stability stable
         */
        readonly autoAssignPublicIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#auto_healing OpsworksRailsAppLayer#auto_healing}.
         *
         * @stability stable
         */
        readonly autoHealing?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#bundler_version OpsworksRailsAppLayer#bundler_version}.
         *
         * @stability stable
         */
        readonly bundlerVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#custom_configure_recipes OpsworksRailsAppLayer#custom_configure_recipes}.
         *
         * @stability stable
         */
        readonly customConfigureRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#custom_deploy_recipes OpsworksRailsAppLayer#custom_deploy_recipes}.
         *
         * @stability stable
         */
        readonly customDeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#custom_instance_profile_arn OpsworksRailsAppLayer#custom_instance_profile_arn}.
         *
         * @stability stable
         */
        readonly customInstanceProfileArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#custom_json OpsworksRailsAppLayer#custom_json}.
         *
         * @stability stable
         */
        readonly customJson?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#custom_security_group_ids OpsworksRailsAppLayer#custom_security_group_ids}.
         *
         * @stability stable
         */
        readonly customSecurityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#custom_setup_recipes OpsworksRailsAppLayer#custom_setup_recipes}.
         *
         * @stability stable
         */
        readonly customSetupRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#custom_shutdown_recipes OpsworksRailsAppLayer#custom_shutdown_recipes}.
         *
         * @stability stable
         */
        readonly customShutdownRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#custom_undeploy_recipes OpsworksRailsAppLayer#custom_undeploy_recipes}.
         *
         * @stability stable
         */
        readonly customUndeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#drain_elb_on_shutdown OpsworksRailsAppLayer#drain_elb_on_shutdown}.
         *
         * @stability stable
         */
        readonly drainElbOnShutdown?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#elastic_load_balancer OpsworksRailsAppLayer#elastic_load_balancer}.
         *
         * @stability stable
         */
        readonly elasticLoadBalancer?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#install_updates_on_boot OpsworksRailsAppLayer#install_updates_on_boot}.
         *
         * @stability stable
         */
        readonly installUpdatesOnBoot?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#instance_shutdown_timeout OpsworksRailsAppLayer#instance_shutdown_timeout}.
         *
         * @stability stable
         */
        readonly instanceShutdownTimeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#manage_bundler OpsworksRailsAppLayer#manage_bundler}.
         *
         * @stability stable
         */
        readonly manageBundler?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#name OpsworksRailsAppLayer#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#passenger_version OpsworksRailsAppLayer#passenger_version}.
         *
         * @stability stable
         */
        readonly passengerVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#ruby_version OpsworksRailsAppLayer#ruby_version}.
         *
         * @stability stable
         */
        readonly rubyVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#rubygems_version OpsworksRailsAppLayer#rubygems_version}.
         *
         * @stability stable
         */
        readonly rubygemsVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#stack_id OpsworksRailsAppLayer#stack_id}.
         *
         * @stability stable
         */
        readonly stackId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#system_packages OpsworksRailsAppLayer#system_packages}.
         *
         * @stability stable
         */
        readonly systemPackages?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#tags OpsworksRailsAppLayer#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#tags_all OpsworksRailsAppLayer#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#use_ebs_optimized_instances OpsworksRailsAppLayer#use_ebs_optimized_instances}.
         *
         * @stability stable
         */
        readonly useEbsOptimizedInstances?: boolean | cdktf.IResolvable;
        /**
         * ebs_volume block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#ebs_volume OpsworksRailsAppLayer#ebs_volume}
         *
         * @stability stable
         */
        readonly ebsVolume?: OpsworksRailsAppLayerEbsVolume[];
    }
    /**
     * @stability stable
     */
    interface OpsworksRailsAppLayerEbsVolume {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#encrypted OpsworksRailsAppLayer#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#iops OpsworksRailsAppLayer#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#mount_point OpsworksRailsAppLayer#mount_point}.
         *
         * @stability stable
         */
        readonly mountPoint: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#number_of_disks OpsworksRailsAppLayer#number_of_disks}.
         *
         * @stability stable
         */
        readonly numberOfDisks: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#raid_level OpsworksRailsAppLayer#raid_level}.
         *
         * @stability stable
         */
        readonly raidLevel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#size OpsworksRailsAppLayer#size}.
         *
         * @stability stable
         */
        readonly size: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html#type OpsworksRailsAppLayer#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html aws_opsworks_rails_app_layer}.
     *
     * @stability stable
     */
    class OpsworksRailsAppLayer extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rails_app_layer.html aws_opsworks_rails_app_layer} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: OpsworksRailsAppLayerConfig);
        private _appServer?;
        /**
         * @stability stable
         */
        get appServer(): string | undefined;
        /**
         * @stability stable
         */
        set appServer(value: string | undefined);
        /**
         * @stability stable
         */
        resetAppServer(): void;
        /**
         * @stability stable
         */
        get appServerInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoAssignElasticIps?;
        /**
         * @stability stable
         */
        get autoAssignElasticIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignElasticIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignElasticIps(): void;
        /**
         * @stability stable
         */
        get autoAssignElasticIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoAssignPublicIps?;
        /**
         * @stability stable
         */
        get autoAssignPublicIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignPublicIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignPublicIps(): void;
        /**
         * @stability stable
         */
        get autoAssignPublicIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoHealing?;
        /**
         * @stability stable
         */
        get autoHealing(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoHealing(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoHealing(): void;
        /**
         * @stability stable
         */
        get autoHealingInput(): boolean | cdktf.IResolvable | undefined;
        private _bundlerVersion?;
        /**
         * @stability stable
         */
        get bundlerVersion(): string | undefined;
        /**
         * @stability stable
         */
        set bundlerVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetBundlerVersion(): void;
        /**
         * @stability stable
         */
        get bundlerVersionInput(): string | undefined;
        private _customConfigureRecipes?;
        /**
         * @stability stable
         */
        get customConfigureRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customConfigureRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomConfigureRecipes(): void;
        /**
         * @stability stable
         */
        get customConfigureRecipesInput(): string[] | undefined;
        private _customDeployRecipes?;
        /**
         * @stability stable
         */
        get customDeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customDeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomDeployRecipes(): void;
        /**
         * @stability stable
         */
        get customDeployRecipesInput(): string[] | undefined;
        private _customInstanceProfileArn?;
        /**
         * @stability stable
         */
        get customInstanceProfileArn(): string | undefined;
        /**
         * @stability stable
         */
        set customInstanceProfileArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomInstanceProfileArn(): void;
        /**
         * @stability stable
         */
        get customInstanceProfileArnInput(): string | undefined;
        private _customJson?;
        /**
         * @stability stable
         */
        get customJson(): string | undefined;
        /**
         * @stability stable
         */
        set customJson(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomJson(): void;
        /**
         * @stability stable
         */
        get customJsonInput(): string | undefined;
        private _customSecurityGroupIds?;
        /**
         * @stability stable
         */
        get customSecurityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSecurityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get customSecurityGroupIdsInput(): string[] | undefined;
        private _customSetupRecipes?;
        /**
         * @stability stable
         */
        get customSetupRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSetupRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSetupRecipes(): void;
        /**
         * @stability stable
         */
        get customSetupRecipesInput(): string[] | undefined;
        private _customShutdownRecipes?;
        /**
         * @stability stable
         */
        get customShutdownRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customShutdownRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomShutdownRecipes(): void;
        /**
         * @stability stable
         */
        get customShutdownRecipesInput(): string[] | undefined;
        private _customUndeployRecipes?;
        /**
         * @stability stable
         */
        get customUndeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customUndeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomUndeployRecipes(): void;
        /**
         * @stability stable
         */
        get customUndeployRecipesInput(): string[] | undefined;
        private _drainElbOnShutdown?;
        /**
         * @stability stable
         */
        get drainElbOnShutdown(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set drainElbOnShutdown(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDrainElbOnShutdown(): void;
        /**
         * @stability stable
         */
        get drainElbOnShutdownInput(): boolean | cdktf.IResolvable | undefined;
        private _elasticLoadBalancer?;
        /**
         * @stability stable
         */
        get elasticLoadBalancer(): string | undefined;
        /**
         * @stability stable
         */
        set elasticLoadBalancer(value: string | undefined);
        /**
         * @stability stable
         */
        resetElasticLoadBalancer(): void;
        /**
         * @stability stable
         */
        get elasticLoadBalancerInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _installUpdatesOnBoot?;
        /**
         * @stability stable
         */
        get installUpdatesOnBoot(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set installUpdatesOnBoot(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetInstallUpdatesOnBoot(): void;
        /**
         * @stability stable
         */
        get installUpdatesOnBootInput(): boolean | cdktf.IResolvable | undefined;
        private _instanceShutdownTimeout?;
        /**
         * @stability stable
         */
        get instanceShutdownTimeout(): number | undefined;
        /**
         * @stability stable
         */
        set instanceShutdownTimeout(value: number | undefined);
        /**
         * @stability stable
         */
        resetInstanceShutdownTimeout(): void;
        /**
         * @stability stable
         */
        get instanceShutdownTimeoutInput(): number | undefined;
        private _manageBundler?;
        /**
         * @stability stable
         */
        get manageBundler(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set manageBundler(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetManageBundler(): void;
        /**
         * @stability stable
         */
        get manageBundlerInput(): boolean | cdktf.IResolvable | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _passengerVersion?;
        /**
         * @stability stable
         */
        get passengerVersion(): string | undefined;
        /**
         * @stability stable
         */
        set passengerVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetPassengerVersion(): void;
        /**
         * @stability stable
         */
        get passengerVersionInput(): string | undefined;
        private _rubyVersion?;
        /**
         * @stability stable
         */
        get rubyVersion(): string | undefined;
        /**
         * @stability stable
         */
        set rubyVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetRubyVersion(): void;
        /**
         * @stability stable
         */
        get rubyVersionInput(): string | undefined;
        private _rubygemsVersion?;
        /**
         * @stability stable
         */
        get rubygemsVersion(): string | undefined;
        /**
         * @stability stable
         */
        set rubygemsVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetRubygemsVersion(): void;
        /**
         * @stability stable
         */
        get rubygemsVersionInput(): string | undefined;
        private _stackId?;
        /**
         * @stability stable
         */
        get stackId(): string;
        /**
         * @stability stable
         */
        set stackId(value: string);
        /**
         * @stability stable
         */
        get stackIdInput(): string | undefined;
        private _systemPackages?;
        /**
         * @stability stable
         */
        get systemPackages(): string[] | undefined;
        /**
         * @stability stable
         */
        set systemPackages(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSystemPackages(): void;
        /**
         * @stability stable
         */
        get systemPackagesInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _useEbsOptimizedInstances?;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstances(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set useEbsOptimizedInstances(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUseEbsOptimizedInstances(): void;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstancesInput(): boolean | cdktf.IResolvable | undefined;
        private _ebsVolume?;
        /**
         * @stability stable
         */
        get ebsVolume(): OpsworksRailsAppLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        set ebsVolume(value: OpsworksRailsAppLayerEbsVolume[] | undefined);
        /**
         * @stability stable
         */
        resetEbsVolume(): void;
        /**
         * @stability stable
         */
        get ebsVolumeInput(): OpsworksRailsAppLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface OpsworksRdsDbInstanceConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rds_db_instance.html#db_password OpsworksRdsDbInstance#db_password}.
         *
         * @stability stable
         */
        readonly dbPassword: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rds_db_instance.html#db_user OpsworksRdsDbInstance#db_user}.
         *
         * @stability stable
         */
        readonly dbUser: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rds_db_instance.html#rds_db_instance_arn OpsworksRdsDbInstance#rds_db_instance_arn}.
         *
         * @stability stable
         */
        readonly rdsDbInstanceArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rds_db_instance.html#stack_id OpsworksRdsDbInstance#stack_id}.
         *
         * @stability stable
         */
        readonly stackId: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rds_db_instance.html aws_opsworks_rds_db_instance}.
     *
     * @stability stable
     */
    class OpsworksRdsDbInstance extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rds_db_instance.html aws_opsworks_rds_db_instance} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: OpsworksRdsDbInstanceConfig);
        private _dbPassword?;
        /**
         * @stability stable
         */
        get dbPassword(): string;
        /**
         * @stability stable
         */
        set dbPassword(value: string);
        /**
         * @stability stable
         */
        get dbPasswordInput(): string | undefined;
        private _dbUser?;
        /**
         * @stability stable
         */
        get dbUser(): string;
        /**
         * @stability stable
         */
        set dbUser(value: string);
        /**
         * @stability stable
         */
        get dbUserInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _rdsDbInstanceArn?;
        /**
         * @stability stable
         */
        get rdsDbInstanceArn(): string;
        /**
         * @stability stable
         */
        set rdsDbInstanceArn(value: string);
        /**
         * @stability stable
         */
        get rdsDbInstanceArnInput(): string | undefined;
        private _stackId?;
        /**
         * @stability stable
         */
        get stackId(): string;
        /**
         * @stability stable
         */
        set stackId(value: string);
        /**
         * @stability stable
         */
        get stackIdInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface OpsworksStackConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#agent_version OpsworksStack#agent_version}.
         *
         * @stability stable
         */
        readonly agentVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#berkshelf_version OpsworksStack#berkshelf_version}.
         *
         * @stability stable
         */
        readonly berkshelfVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#color OpsworksStack#color}.
         *
         * @stability stable
         */
        readonly color?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#configuration_manager_name OpsworksStack#configuration_manager_name}.
         *
         * @stability stable
         */
        readonly configurationManagerName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#configuration_manager_version OpsworksStack#configuration_manager_version}.
         *
         * @stability stable
         */
        readonly configurationManagerVersion?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#custom_json OpsworksStack#custom_json}.
         *
         * @stability stable
         */
        readonly customJson?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#default_availability_zone OpsworksStack#default_availability_zone}.
         *
         * @stability stable
         */
        readonly defaultAvailabilityZone?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#default_instance_profile_arn OpsworksStack#default_instance_profile_arn}.
         *
         * @stability stable
         */
        readonly defaultInstanceProfileArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#default_os OpsworksStack#default_os}.
         *
         * @stability stable
         */
        readonly defaultOs?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#default_root_device_type OpsworksStack#default_root_device_type}.
         *
         * @stability stable
         */
        readonly defaultRootDeviceType?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#default_ssh_key_name OpsworksStack#default_ssh_key_name}.
         *
         * @stability stable
         */
        readonly defaultSshKeyName?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#default_subnet_id OpsworksStack#default_subnet_id}.
         *
         * @stability stable
         */
        readonly defaultSubnetId?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#hostname_theme OpsworksStack#hostname_theme}.
         *
         * @stability stable
         */
        readonly hostnameTheme?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#manage_berkshelf OpsworksStack#manage_berkshelf}.
         *
         * @stability stable
         */
        readonly manageBerkshelf?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#name OpsworksStack#name}.
         *
         * @stability stable
         */
        readonly name: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#region OpsworksStack#region}.
         *
         * @stability stable
         */
        readonly region: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#service_role_arn OpsworksStack#service_role_arn}.
         *
         * @stability stable
         */
        readonly serviceRoleArn: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#tags OpsworksStack#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#tags_all OpsworksStack#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#use_custom_cookbooks OpsworksStack#use_custom_cookbooks}.
         *
         * @stability stable
         */
        readonly useCustomCookbooks?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#use_opsworks_security_groups OpsworksStack#use_opsworks_security_groups}.
         *
         * @stability stable
         */
        readonly useOpsworksSecurityGroups?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#vpc_id OpsworksStack#vpc_id}.
         *
         * @stability stable
         */
        readonly vpcId?: string;
        /**
         * custom_cookbooks_source block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#custom_cookbooks_source OpsworksStack#custom_cookbooks_source}
         *
         * @stability stable
         */
        readonly customCookbooksSource?: OpsworksStackCustomCookbooksSource[];
    }
    /**
     * @stability stable
     */
    interface OpsworksStackCustomCookbooksSource {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#password OpsworksStack#password}.
         *
         * @stability stable
         */
        readonly password?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#revision OpsworksStack#revision}.
         *
         * @stability stable
         */
        readonly revision?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#ssh_key OpsworksStack#ssh_key}.
         *
         * @stability stable
         */
        readonly sshKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#type OpsworksStack#type}.
         *
         * @stability stable
         */
        readonly type: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#url OpsworksStack#url}.
         *
         * @stability stable
         */
        readonly url: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html#username OpsworksStack#username}.
         *
         * @stability stable
         */
        readonly username?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html aws_opsworks_stack}.
     *
     * @stability stable
     */
    class OpsworksStack extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack.html aws_opsworks_stack} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: OpsworksStackConfig);
        private _agentVersion?;
        /**
         * @stability stable
         */
        get agentVersion(): string | undefined;
        /**
         * @stability stable
         */
        set agentVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetAgentVersion(): void;
        /**
         * @stability stable
         */
        get agentVersionInput(): string | undefined;
        /**
         * @stability stable
         */
        get arn(): string;
        private _berkshelfVersion?;
        /**
         * @stability stable
         */
        get berkshelfVersion(): string | undefined;
        /**
         * @stability stable
         */
        set berkshelfVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetBerkshelfVersion(): void;
        /**
         * @stability stable
         */
        get berkshelfVersionInput(): string | undefined;
        private _color?;
        /**
         * @stability stable
         */
        get color(): string | undefined;
        /**
         * @stability stable
         */
        set color(value: string | undefined);
        /**
         * @stability stable
         */
        resetColor(): void;
        /**
         * @stability stable
         */
        get colorInput(): string | undefined;
        private _configurationManagerName?;
        /**
         * @stability stable
         */
        get configurationManagerName(): string | undefined;
        /**
         * @stability stable
         */
        set configurationManagerName(value: string | undefined);
        /**
         * @stability stable
         */
        resetConfigurationManagerName(): void;
        /**
         * @stability stable
         */
        get configurationManagerNameInput(): string | undefined;
        private _configurationManagerVersion?;
        /**
         * @stability stable
         */
        get configurationManagerVersion(): string | undefined;
        /**
         * @stability stable
         */
        set configurationManagerVersion(value: string | undefined);
        /**
         * @stability stable
         */
        resetConfigurationManagerVersion(): void;
        /**
         * @stability stable
         */
        get configurationManagerVersionInput(): string | undefined;
        private _customJson?;
        /**
         * @stability stable
         */
        get customJson(): string | undefined;
        /**
         * @stability stable
         */
        set customJson(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomJson(): void;
        /**
         * @stability stable
         */
        get customJsonInput(): string | undefined;
        private _defaultAvailabilityZone?;
        /**
         * @stability stable
         */
        get defaultAvailabilityZone(): string | undefined;
        /**
         * @stability stable
         */
        set defaultAvailabilityZone(value: string | undefined);
        /**
         * @stability stable
         */
        resetDefaultAvailabilityZone(): void;
        /**
         * @stability stable
         */
        get defaultAvailabilityZoneInput(): string | undefined;
        private _defaultInstanceProfileArn?;
        /**
         * @stability stable
         */
        get defaultInstanceProfileArn(): string;
        /**
         * @stability stable
         */
        set defaultInstanceProfileArn(value: string);
        /**
         * @stability stable
         */
        get defaultInstanceProfileArnInput(): string | undefined;
        private _defaultOs?;
        /**
         * @stability stable
         */
        get defaultOs(): string | undefined;
        /**
         * @stability stable
         */
        set defaultOs(value: string | undefined);
        /**
         * @stability stable
         */
        resetDefaultOs(): void;
        /**
         * @stability stable
         */
        get defaultOsInput(): string | undefined;
        private _defaultRootDeviceType?;
        /**
         * @stability stable
         */
        get defaultRootDeviceType(): string | undefined;
        /**
         * @stability stable
         */
        set defaultRootDeviceType(value: string | undefined);
        /**
         * @stability stable
         */
        resetDefaultRootDeviceType(): void;
        /**
         * @stability stable
         */
        get defaultRootDeviceTypeInput(): string | undefined;
        private _defaultSshKeyName?;
        /**
         * @stability stable
         */
        get defaultSshKeyName(): string | undefined;
        /**
         * @stability stable
         */
        set defaultSshKeyName(value: string | undefined);
        /**
         * @stability stable
         */
        resetDefaultSshKeyName(): void;
        /**
         * @stability stable
         */
        get defaultSshKeyNameInput(): string | undefined;
        private _defaultSubnetId?;
        /**
         * @stability stable
         */
        get defaultSubnetId(): string | undefined;
        /**
         * @stability stable
         */
        set defaultSubnetId(value: string | undefined);
        /**
         * @stability stable
         */
        resetDefaultSubnetId(): void;
        /**
         * @stability stable
         */
        get defaultSubnetIdInput(): string | undefined;
        private _hostnameTheme?;
        /**
         * @stability stable
         */
        get hostnameTheme(): string | undefined;
        /**
         * @stability stable
         */
        set hostnameTheme(value: string | undefined);
        /**
         * @stability stable
         */
        resetHostnameTheme(): void;
        /**
         * @stability stable
         */
        get hostnameThemeInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _manageBerkshelf?;
        /**
         * @stability stable
         */
        get manageBerkshelf(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set manageBerkshelf(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetManageBerkshelf(): void;
        /**
         * @stability stable
         */
        get manageBerkshelfInput(): boolean | cdktf.IResolvable | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string;
        /**
         * @stability stable
         */
        set name(value: string);
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _region?;
        /**
         * @stability stable
         */
        get region(): string;
        /**
         * @stability stable
         */
        set region(value: string);
        /**
         * @stability stable
         */
        get regionInput(): string | undefined;
        private _serviceRoleArn?;
        /**
         * @stability stable
         */
        get serviceRoleArn(): string;
        /**
         * @stability stable
         */
        set serviceRoleArn(value: string);
        /**
         * @stability stable
         */
        get serviceRoleArnInput(): string | undefined;
        /**
         * @stability stable
         */
        get stackEndpoint(): string;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _useCustomCookbooks?;
        /**
         * @stability stable
         */
        get useCustomCookbooks(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set useCustomCookbooks(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUseCustomCookbooks(): void;
        /**
         * @stability stable
         */
        get useCustomCookbooksInput(): boolean | cdktf.IResolvable | undefined;
        private _useOpsworksSecurityGroups?;
        /**
         * @stability stable
         */
        get useOpsworksSecurityGroups(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set useOpsworksSecurityGroups(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUseOpsworksSecurityGroups(): void;
        /**
         * @stability stable
         */
        get useOpsworksSecurityGroupsInput(): boolean | cdktf.IResolvable | undefined;
        private _vpcId?;
        /**
         * @stability stable
         */
        get vpcId(): string | undefined;
        /**
         * @stability stable
         */
        set vpcId(value: string | undefined);
        /**
         * @stability stable
         */
        resetVpcId(): void;
        /**
         * @stability stable
         */
        get vpcIdInput(): string | undefined;
        private _customCookbooksSource?;
        /**
         * @stability stable
         */
        get customCookbooksSource(): OpsworksStackCustomCookbooksSource[] | undefined;
        /**
         * @stability stable
         */
        set customCookbooksSource(value: OpsworksStackCustomCookbooksSource[] | undefined);
        /**
         * @stability stable
         */
        resetCustomCookbooksSource(): void;
        /**
         * @stability stable
         */
        get customCookbooksSourceInput(): OpsworksStackCustomCookbooksSource[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface OpsworksStaticWebLayerConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#auto_assign_elastic_ips OpsworksStaticWebLayer#auto_assign_elastic_ips}.
         *
         * @stability stable
         */
        readonly autoAssignElasticIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#auto_assign_public_ips OpsworksStaticWebLayer#auto_assign_public_ips}.
         *
         * @stability stable
         */
        readonly autoAssignPublicIps?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#auto_healing OpsworksStaticWebLayer#auto_healing}.
         *
         * @stability stable
         */
        readonly autoHealing?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#custom_configure_recipes OpsworksStaticWebLayer#custom_configure_recipes}.
         *
         * @stability stable
         */
        readonly customConfigureRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#custom_deploy_recipes OpsworksStaticWebLayer#custom_deploy_recipes}.
         *
         * @stability stable
         */
        readonly customDeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#custom_instance_profile_arn OpsworksStaticWebLayer#custom_instance_profile_arn}.
         *
         * @stability stable
         */
        readonly customInstanceProfileArn?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#custom_json OpsworksStaticWebLayer#custom_json}.
         *
         * @stability stable
         */
        readonly customJson?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#custom_security_group_ids OpsworksStaticWebLayer#custom_security_group_ids}.
         *
         * @stability stable
         */
        readonly customSecurityGroupIds?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#custom_setup_recipes OpsworksStaticWebLayer#custom_setup_recipes}.
         *
         * @stability stable
         */
        readonly customSetupRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#custom_shutdown_recipes OpsworksStaticWebLayer#custom_shutdown_recipes}.
         *
         * @stability stable
         */
        readonly customShutdownRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#custom_undeploy_recipes OpsworksStaticWebLayer#custom_undeploy_recipes}.
         *
         * @stability stable
         */
        readonly customUndeployRecipes?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#drain_elb_on_shutdown OpsworksStaticWebLayer#drain_elb_on_shutdown}.
         *
         * @stability stable
         */
        readonly drainElbOnShutdown?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#elastic_load_balancer OpsworksStaticWebLayer#elastic_load_balancer}.
         *
         * @stability stable
         */
        readonly elasticLoadBalancer?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#install_updates_on_boot OpsworksStaticWebLayer#install_updates_on_boot}.
         *
         * @stability stable
         */
        readonly installUpdatesOnBoot?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#instance_shutdown_timeout OpsworksStaticWebLayer#instance_shutdown_timeout}.
         *
         * @stability stable
         */
        readonly instanceShutdownTimeout?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#name OpsworksStaticWebLayer#name}.
         *
         * @stability stable
         */
        readonly name?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#stack_id OpsworksStaticWebLayer#stack_id}.
         *
         * @stability stable
         */
        readonly stackId: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#system_packages OpsworksStaticWebLayer#system_packages}.
         *
         * @stability stable
         */
        readonly systemPackages?: string[];
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#tags OpsworksStaticWebLayer#tags}.
         *
         * @stability stable
         */
        readonly tags?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#tags_all OpsworksStaticWebLayer#tags_all}.
         *
         * @stability stable
         */
        readonly tagsAll?: {
            [key: string]: string;
        } | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#use_ebs_optimized_instances OpsworksStaticWebLayer#use_ebs_optimized_instances}.
         *
         * @stability stable
         */
        readonly useEbsOptimizedInstances?: boolean | cdktf.IResolvable;
        /**
         * ebs_volume block.
         *
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#ebs_volume OpsworksStaticWebLayer#ebs_volume}
         *
         * @stability stable
         */
        readonly ebsVolume?: OpsworksStaticWebLayerEbsVolume[];
    }
    /**
     * @stability stable
     */
    interface OpsworksStaticWebLayerEbsVolume {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#encrypted OpsworksStaticWebLayer#encrypted}.
         *
         * @stability stable
         */
        readonly encrypted?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#iops OpsworksStaticWebLayer#iops}.
         *
         * @stability stable
         */
        readonly iops?: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#mount_point OpsworksStaticWebLayer#mount_point}.
         *
         * @stability stable
         */
        readonly mountPoint: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#number_of_disks OpsworksStaticWebLayer#number_of_disks}.
         *
         * @stability stable
         */
        readonly numberOfDisks: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#raid_level OpsworksStaticWebLayer#raid_level}.
         *
         * @stability stable
         */
        readonly raidLevel?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#size OpsworksStaticWebLayer#size}.
         *
         * @stability stable
         */
        readonly size: number;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html#type OpsworksStaticWebLayer#type}.
         *
         * @stability stable
         */
        readonly type?: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html aws_opsworks_static_web_layer}.
     *
     * @stability stable
     */
    class OpsworksStaticWebLayer extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_static_web_layer.html aws_opsworks_static_web_layer} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: OpsworksStaticWebLayerConfig);
        /**
         * @stability stable
         */
        get arn(): string;
        private _autoAssignElasticIps?;
        /**
         * @stability stable
         */
        get autoAssignElasticIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignElasticIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignElasticIps(): void;
        /**
         * @stability stable
         */
        get autoAssignElasticIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoAssignPublicIps?;
        /**
         * @stability stable
         */
        get autoAssignPublicIps(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoAssignPublicIps(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoAssignPublicIps(): void;
        /**
         * @stability stable
         */
        get autoAssignPublicIpsInput(): boolean | cdktf.IResolvable | undefined;
        private _autoHealing?;
        /**
         * @stability stable
         */
        get autoHealing(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set autoHealing(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAutoHealing(): void;
        /**
         * @stability stable
         */
        get autoHealingInput(): boolean | cdktf.IResolvable | undefined;
        private _customConfigureRecipes?;
        /**
         * @stability stable
         */
        get customConfigureRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customConfigureRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomConfigureRecipes(): void;
        /**
         * @stability stable
         */
        get customConfigureRecipesInput(): string[] | undefined;
        private _customDeployRecipes?;
        /**
         * @stability stable
         */
        get customDeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customDeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomDeployRecipes(): void;
        /**
         * @stability stable
         */
        get customDeployRecipesInput(): string[] | undefined;
        private _customInstanceProfileArn?;
        /**
         * @stability stable
         */
        get customInstanceProfileArn(): string | undefined;
        /**
         * @stability stable
         */
        set customInstanceProfileArn(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomInstanceProfileArn(): void;
        /**
         * @stability stable
         */
        get customInstanceProfileArnInput(): string | undefined;
        private _customJson?;
        /**
         * @stability stable
         */
        get customJson(): string | undefined;
        /**
         * @stability stable
         */
        set customJson(value: string | undefined);
        /**
         * @stability stable
         */
        resetCustomJson(): void;
        /**
         * @stability stable
         */
        get customJsonInput(): string | undefined;
        private _customSecurityGroupIds?;
        /**
         * @stability stable
         */
        get customSecurityGroupIds(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSecurityGroupIds(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSecurityGroupIds(): void;
        /**
         * @stability stable
         */
        get customSecurityGroupIdsInput(): string[] | undefined;
        private _customSetupRecipes?;
        /**
         * @stability stable
         */
        get customSetupRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customSetupRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomSetupRecipes(): void;
        /**
         * @stability stable
         */
        get customSetupRecipesInput(): string[] | undefined;
        private _customShutdownRecipes?;
        /**
         * @stability stable
         */
        get customShutdownRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customShutdownRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomShutdownRecipes(): void;
        /**
         * @stability stable
         */
        get customShutdownRecipesInput(): string[] | undefined;
        private _customUndeployRecipes?;
        /**
         * @stability stable
         */
        get customUndeployRecipes(): string[] | undefined;
        /**
         * @stability stable
         */
        set customUndeployRecipes(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetCustomUndeployRecipes(): void;
        /**
         * @stability stable
         */
        get customUndeployRecipesInput(): string[] | undefined;
        private _drainElbOnShutdown?;
        /**
         * @stability stable
         */
        get drainElbOnShutdown(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set drainElbOnShutdown(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetDrainElbOnShutdown(): void;
        /**
         * @stability stable
         */
        get drainElbOnShutdownInput(): boolean | cdktf.IResolvable | undefined;
        private _elasticLoadBalancer?;
        /**
         * @stability stable
         */
        get elasticLoadBalancer(): string | undefined;
        /**
         * @stability stable
         */
        set elasticLoadBalancer(value: string | undefined);
        /**
         * @stability stable
         */
        resetElasticLoadBalancer(): void;
        /**
         * @stability stable
         */
        get elasticLoadBalancerInput(): string | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _installUpdatesOnBoot?;
        /**
         * @stability stable
         */
        get installUpdatesOnBoot(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set installUpdatesOnBoot(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetInstallUpdatesOnBoot(): void;
        /**
         * @stability stable
         */
        get installUpdatesOnBootInput(): boolean | cdktf.IResolvable | undefined;
        private _instanceShutdownTimeout?;
        /**
         * @stability stable
         */
        get instanceShutdownTimeout(): number | undefined;
        /**
         * @stability stable
         */
        set instanceShutdownTimeout(value: number | undefined);
        /**
         * @stability stable
         */
        resetInstanceShutdownTimeout(): void;
        /**
         * @stability stable
         */
        get instanceShutdownTimeoutInput(): number | undefined;
        private _name?;
        /**
         * @stability stable
         */
        get name(): string | undefined;
        /**
         * @stability stable
         */
        set name(value: string | undefined);
        /**
         * @stability stable
         */
        resetName(): void;
        /**
         * @stability stable
         */
        get nameInput(): string | undefined;
        private _stackId?;
        /**
         * @stability stable
         */
        get stackId(): string;
        /**
         * @stability stable
         */
        set stackId(value: string);
        /**
         * @stability stable
         */
        get stackIdInput(): string | undefined;
        private _systemPackages?;
        /**
         * @stability stable
         */
        get systemPackages(): string[] | undefined;
        /**
         * @stability stable
         */
        set systemPackages(value: string[] | undefined);
        /**
         * @stability stable
         */
        resetSystemPackages(): void;
        /**
         * @stability stable
         */
        get systemPackagesInput(): string[] | undefined;
        private _tags?;
        /**
         * @stability stable
         */
        get tags(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tags(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTags(): void;
        /**
         * @stability stable
         */
        get tagsInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _tagsAll?;
        /**
         * @stability stable
         */
        get tagsAll(): {
            [key: string]: string;
        } | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set tagsAll(value: {
            [key: string]: string;
        } | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetTagsAll(): void;
        /**
         * @stability stable
         */
        get tagsAllInput(): cdktf.IResolvable | {
            [key: string]: string;
        } | undefined;
        private _useEbsOptimizedInstances?;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstances(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set useEbsOptimizedInstances(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetUseEbsOptimizedInstances(): void;
        /**
         * @stability stable
         */
        get useEbsOptimizedInstancesInput(): boolean | cdktf.IResolvable | undefined;
        private _ebsVolume?;
        /**
         * @stability stable
         */
        get ebsVolume(): OpsworksStaticWebLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        set ebsVolume(value: OpsworksStaticWebLayerEbsVolume[] | undefined);
        /**
         * @stability stable
         */
        resetEbsVolume(): void;
        /**
         * @stability stable
         */
        get ebsVolumeInput(): OpsworksStaticWebLayerEbsVolume[] | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
    /**
     * @stability stable
     */
    interface OpsworksUserProfileConfig extends cdktf.TerraformMetaArguments {
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_user_profile.html#allow_self_management OpsworksUserProfile#allow_self_management}.
         *
         * @stability stable
         */
        readonly allowSelfManagement?: boolean | cdktf.IResolvable;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_user_profile.html#ssh_public_key OpsworksUserProfile#ssh_public_key}.
         *
         * @stability stable
         */
        readonly sshPublicKey?: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_user_profile.html#ssh_username OpsworksUserProfile#ssh_username}.
         *
         * @stability stable
         */
        readonly sshUsername: string;
        /**
         * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_user_profile.html#user_arn OpsworksUserProfile#user_arn}.
         *
         * @stability stable
         */
        readonly userArn: string;
    }
    /**
     * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_user_profile.html aws_opsworks_user_profile}.
     *
     * @stability stable
     */
    class OpsworksUserProfile extends cdktf.TerraformResource {
        /**
         * @stability stable
         */
        static readonly tfResourceType: string;
        /**
         * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_user_profile.html aws_opsworks_user_profile} Resource.
         *
         * @param scope The scope in which to define this construct.
         * @param id The scoped construct ID.
         * @stability stable
         */
        constructor(scope: Construct, id: string, config: OpsworksUserProfileConfig);
        private _allowSelfManagement?;
        /**
         * @stability stable
         */
        get allowSelfManagement(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        set allowSelfManagement(value: boolean | cdktf.IResolvable | undefined);
        /**
         * @stability stable
         */
        resetAllowSelfManagement(): void;
        /**
         * @stability stable
         */
        get allowSelfManagementInput(): boolean | cdktf.IResolvable | undefined;
        /**
         * @stability stable
         */
        get id(): string;
        private _sshPublicKey?;
        /**
         * @stability stable
         */
        get sshPublicKey(): string | undefined;
        /**
         * @stability stable
         */
        set sshPublicKey(value: string | undefined);
        /**
         * @stability stable
         */
        resetSshPublicKey(): void;
        /**
         * @stability stable
         */
        get sshPublicKeyInput(): string | undefined;
        private _sshUsername?;
        /**
         * @stability stable
         */
        get sshUsername(): string;
        /**
         * @stability stable
         */
        set sshUsername(value: string);
        /**
         * @stability stable
         */
        get sshUsernameInput(): string | undefined;
        private _userArn?;
        /**
         * @stability stable
         */
        get userArn(): string;
        /**
         * @stability stable
         */
        set userArn(value: string);
        /**
         * @stability stable
         */
        get userArnInput(): string | undefined;
        /**
         * @stability stable
         */
        protected synthesizeAttributes(): {
            [name: string]: any;
        };
    }
}
